"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","fs","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/base/common/iterator","vs/platform/request/common/request","vs/base/common/json","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/themables","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","vs/server/node/server.main"],Ee=function(ue){for(var e=[],s=0,C=ue.length;s<C;s++)e[s]=ye[ue[s]];return e};define(ye[97],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class s{static get(){const D=new Map,k=new Map,I=new Map,S=new Map;function w(m,u){m.has(u.detail)||m.set(u.detail,-u.timestamp)}function g(m,u){const a=m.get(u.detail);a&&(a>=0||m.set(u.detail,a+u.timestamp))}let y=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(y=ue.getStats().slice(0).sort((m,u)=>m.timestamp-u.timestamp));for(const m of y)switch(m.type){case 10:w(D,m);break;case 11:case 12:g(D,m);break;case 21:w(k,m);break;case 22:g(k,m);break;case 33:w(I,m);break;case 34:g(I,m);break;case 31:w(S,m);break;case 32:g(S,m);break}let v=0;I.forEach(m=>v+=m);function b(m){const u=[];return m.forEach((a,f)=>u.push([f,a])),u}return{amdLoad:b(D),amdInvoke:b(k),nodeRequire:b(I),nodeEval:b(S),nodeRequireTotal:v}}static toMarkdownTable(D,k){let I="";const S=[];return D.forEach((w,g)=>{S[g]=w.length}),k.forEach(w=>{w.forEach((g,y)=>{typeof g>"u"&&(g=w[y]="-");const v=g.toString().length;S[y]=Math.max(v,S[y])})}),D.forEach((w,g)=>{I+=`| ${w+" ".repeat(S[g]-w.toString().length)} `}),I+=`|
`,D.forEach((w,g)=>{I+=`| ${"-".repeat(S[g])} `}),I+=`|
`,k.forEach(w=>{w.forEach((g,y)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(S[y]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=s}),define(ye[145],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=s,e.$gb=C,e.$hb=D,e.$ib=k,e.$jb=I,e.$kb=S,e.$lb=w,e.$nb=y,e.$ob=v,e.$pb=b,e.$qb=m,e.$rb=u;function s(a,f){const c=C(a,f);if(c!==-1)return a[c]}function C(a,f,c=a.length-1){for(let d=c;d>=0;d--){const $=a[d];if(f($))return d}return-1}function D(a,f){const c=k(a,f);return c===-1?void 0:a[c]}function k(a,f,c=0,d=a.length){let $=c,E=d;for(;$<E;){const h=Math.floor(($+E)/2);f(a[h])?$=h+1:E=h}return $-1}function I(a,f){const c=S(a,f);return c===a.length?void 0:a[c]}function S(a,f,c=0,d=a.length){let $=c,E=d;for(;$<E;){const h=Math.floor(($+E)/2);f(a[h])?E=h:$=h+1}return $}function w(a,f,c=0,d=a.length){const $=S(a,f,c,d);return $===a.length?-1:$}class g{constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(g.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!f(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const c=k(this.e,f,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=g,g.assertInvariants=!1;function y(a,f){if(a.length===0)return;let c=a[0];for(let d=1;d<a.length;d++){const $=a[d];f($,c)>0&&(c=$)}return c}function v(a,f){if(a.length===0)return;let c=a[0];for(let d=1;d<a.length;d++){const $=a[d];f($,c)>=0&&(c=$)}return c}function b(a,f){return y(a,(c,d)=>-f(c,d))}function m(a,f){if(a.length===0)return-1;let c=0;for(let d=1;d<a.length;d++){const $=a[d];f($,a[c])>0&&(c=d)}return c}function u(a,f){for(const c of a){const d=f(c);if(d!==void 0)return d}}}),define(ye[146],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=s,e.$F=C,e.$G=D,e.$H=k;function s(I,S){const w=Object.create(null);for(const g of I){const y=S(g);let v=w[y];v||(v=w[y]=[]),v.push(g)}return w}function C(I,S){const w=[],g=[];for(const y of I)S.has(y)||w.push(y);for(const y of S)I.has(y)||g.push(y);return{removed:w,added:g}}function D(I,S){const w=[],g=[];for(const[y,v]of I)S.has(y)||w.push(v);for(const[y,v]of S)I.has(y)||g.push(v);return{removed:w,added:g}}function k(I,S){const w=new Set;for(const g of S)I.has(g)&&w.add(g);return w}}),define(ye[74],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=C,e.$2h=D,e.$3h=k;function s(I){return(S,w,g)=>{let y=null,v=null;if(typeof g.value=="function"?(y="value",v=g.value):typeof g.get=="function"&&(y="get",v=g.get),!v)throw new Error("not supported");g[y]=I(v,w)}}function C(I,S,w){let g=null,y=null;if(typeof w.value=="function"?(g="value",y=w.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(g="get",y=w.get),!y)throw new Error("not supported");const v=`$memoize$${S}`;w[g]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,b)}),this[v]}}function D(I,S,w){return s((g,y)=>{const v=`$debounce$${y}`,b=`$debounce$result$${y}`;return function(...m){this[b]||(this[b]=w?w():void 0),clearTimeout(this[v]),S&&(this[b]=S(this[b],...m),m=[this[b]]),this[v]=setTimeout(()=>{g.apply(this,m),this[b]=w?w():void 0},I)}})}function k(I,S,w){return s((g,y)=>{const v=`$throttle$timer$${y}`,b=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,u=`$throttle$pending$${y}`;return function(...a){if(this[b]||(this[b]=w?w():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),S&&(this[b]=S(this[b],...a)),this[u])return;const f=this[m]+I;f<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[b]]),this[b]=w?w():void 0):(this[u]=!0,this[v]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),g.apply(this,[this[b]]),this[b]=w?w():void 0},f-Date.now()))}})}}),define(ye[11],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=D,e.$1=k,e.$2=I,e.$3=S,e.$4=g,e.$6=v,e.$7=b,e.$8=m,e.$0=a;class s{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=s,e.$X=new s;function C(h){e.$X.setUnexpectedErrorHandler(h)}function D(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function k(h){g(h)||e.$X.onUnexpectedError(h)}function I(h){g(h)||e.$X.onUnexpectedExternalError(h)}function S(h){if(h instanceof Error){const{name:t,message:o}=h,r=h.stacktrace||h.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:$.isErrorNoTelemetry(h)}}return h}const w="Canceled";function g(h){return h instanceof y?!0:h instanceof Error&&h.name===w&&h.message===w}class y extends Error{constructor(){super(w),this.name=this.message}}e.$5=y;function v(){const h=new Error(w);return h.name=h.message,h}function b(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function m(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class u extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=u;function a(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const o=new $;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=$;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(ye[18],Ee([1,0,11,145]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=D,e.$tb=k,e.$ub=I,e.$vb=S,e.$wb=w,e.$xb=g,e.$yb=y,e.$zb=v,e.$Ab=b,e.$Bb=m,e.$Cb=u,e.$Db=a,e.$Eb=f,e.top=c,e.$Gb=d,e.$Hb=E,e.$Ib=h,e.$Jb=t,e.$Kb=o,e.$Lb=r,e.$Mb=i,e.$Nb=n,e.$Ob=l,e.$Pb=p,e.$Qb=P,e.$Rb=j,e.$Sb=O,e.$Tb=R,e.$Ub=A,e.$Vb=B,e.$Wb=G,e.$Xb=se,e.$Yb=ce,e.$Zb=ee,e.$1b=K,e.$2b=q,e.$3b=X,e.$4b=_,e.$5b=M,e.$6b=Q,e.$7b=we,e.$8b=ie,e.$$b=N;function D(x,J=0){return x[x.length-(1+J)]}function k(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function I(x,J,H=(L,U)=>L===U){if(x===J)return!0;if(!x||!J||x.length!==J.length)return!1;for(let L=0,U=x.length;L<U;L++)if(!H(x[L],J[L]))return!1;return!0}function S(x,J){const H=x.length-1;J<H&&(x[J]=x[H]),x.pop()}function w(x,J,H){return g(x.length,L=>H(x[L],J))}function g(x,J){let H=0,L=x-1;for(;H<=L;){const U=(H+L)/2|0,oe=J(U);if(oe<0)H=U+1;else if(oe>0)L=U-1;else return U}return-(H+1)}function y(x,J,H){if(x=x|0,x>=J.length)throw new TypeError("invalid index");const L=J[Math.floor(J.length*Math.random())],U=[],oe=[],le=[];for(const de of J){const te=H(de,L);te<0?U.push(de):te>0?oe.push(de):le.push(de)}return x<U.length?y(x,U,H):x<U.length+le.length?le[0]:y(x-(U.length+le.length),oe,H)}function v(x,J){const H=[];let L;for(const U of x.slice(0).sort(J))!L||J(L[0],U)!==0?(L=[U],H.push(L)):L.push(U);return H}function*b(x,J){let H,L;for(const U of x)L!==void 0&&J(L,U)?H.push(U):(H&&(yield H),H=[U]),L=U;H&&(yield H)}function m(x,J){for(let H=0;H<=x.length;H++)J(H===0?void 0:x[H-1],H===x.length?void 0:x[H])}function u(x,J){for(let H=0;H<x.length;H++)J(H===0?void 0:x[H-1],x[H],H+1===x.length?void 0:x[H+1])}function a(x,J,H){const L=[];function U(de,te,me){if(te===0&&me.length===0)return;const pe=L[L.length-1];pe&&pe.start+pe.deleteCount===de?(pe.deleteCount+=te,pe.toInsert.push(...me)):L.push({start:de,deleteCount:te,toInsert:me})}let oe=0,le=0;for(;;){if(oe===x.length){U(oe,0,J.slice(le));break}if(le===J.length){U(oe,x.length-oe,[]);break}const de=x[oe],te=J[le],me=H(de,te);me===0?(oe+=1,le+=1):me<0?(U(oe,1,[]),oe+=1):me>0&&(U(oe,0,[te]),le+=1)}return L}function f(x,J,H){const L=a(x,J,H),U=[],oe=[];for(const le of L)U.push(...x.slice(le.start,le.start+le.deleteCount)),oe.push(...le.toInsert);return{removed:U,added:oe}}function c(x,J,H){if(H===0)return[];const L=x.slice(0,H).sort(J);return $(x,J,L,H,x.length),L}function d(x,J,H,L,U){return H===0?Promise.resolve([]):new Promise((oe,le)=>{(async()=>{const de=x.length,te=x.slice(0,H).sort(J);for(let me=H,pe=Math.min(H+L,de);me<de;me=pe,pe=Math.min(pe+L,de)){if(me>H&&await new Promise(Ce=>setTimeout(Ce)),U&&U.isCancellationRequested)throw new s.$5;$(x,J,te,me,pe)}return te})().then(oe,le)})}function $(x,J,H,L,U){for(const oe=H.length;L<U;L++){const le=x[L];if(J(le,H[oe-1])<0){H.pop();const de=(0,C.$kb)(H,te=>J(le,te)<0);H.splice(de,0,le)}}}function E(x){return x.filter(J=>!!J)}function h(x){let J=0;for(let H=0;H<x.length;H++)x[H]&&(x[J]=x[H],J+=1);x.length=J}function t(x,J,H){x.splice(H,0,x.splice(J,1)[0])}function o(x){return!Array.isArray(x)||x.length===0}function r(x){return Array.isArray(x)&&x.length>0}function i(x,J=H=>H){const H=new Set;return x.filter(L=>{const U=J(L);return H.has(U)?!1:(H.add(U),!0)})}function n(x){const J=new Set;return H=>{const L=x(H);return J.has(L)?!1:(J.add(L),!0)}}function l(x,J){return x.length>0?x[0]:J}function p(x,J){return x.length>0?x[x.length-1]:J}function P(x,J,H=(L,U)=>L===U){let L=0;for(let U=0,oe=Math.min(x.length,J.length);U<oe&&H(x[U],J[U]);U++)L++;return L}function j(x){return[].concat(...x)}function O(x,J){let H=typeof J=="number"?x:0;typeof J=="number"?H=x:(H=0,J=x);const L=[];if(H<=J)for(let U=H;U<J;U++)L.push(U);else for(let U=H;U>J;U--)L.push(U);return L}function R(x,J,H){return x.reduce((L,U)=>(L[J(U)]=H?H(U):U,L),Object.create(null))}function A(x,J){return x.push(J),()=>B(x,J)}function B(x,J){const H=x.indexOf(J);if(H>-1)return x.splice(H,1),J}function G(x,J,H){const L=x.slice(0,J),U=x.slice(J);return L.concat(H,U)}function se(x,J){let H;if(typeof J=="number"){let L=J;H=()=>{const U=Math.sin(L++)*179426549;return U-Math.floor(U)}}else H=Math.random;for(let L=x.length-1;L>0;L-=1){const U=Math.floor(H()*(L+1)),oe=x[L];x[L]=x[U],x[U]=oe}}function ce(x,J){const H=x.indexOf(J);H>-1&&(x.splice(H,1),x.unshift(J))}function ee(x,J){const H=x.indexOf(J);H>-1&&(x.splice(H,1),x.push(J))}function K(x,J){for(const H of J)x.push(H)}function q(x,J){return Array.isArray(x)?x.map(J):J(x)}function X(x){return Array.isArray(x)?x:[x]}function _(x){return x[Math.floor(Math.random()*x.length)]}function M(x,J,H){const L=ae(x,J),U=x.length,oe=H.length;x.length=U+oe;for(let le=U-1;le>=L;le--)x[le+oe]=x[le];for(let le=0;le<oe;le++)x[le+L]=H[le]}function Q(x,J,H,L){const U=ae(x,J);let oe=x.splice(U,H);return oe===void 0&&(oe=[]),M(x,U,L),oe}function ae(x,J){return J<0?Math.max(J+x.length,0):Math.min(J,x.length)}var ne;(function(x){function J(oe){return oe<0}x.isLessThan=J;function H(oe){return oe<=0}x.isLessThanOrEqual=H;function L(oe){return oe>0}x.isGreaterThan=L;function U(oe){return oe===0}x.isNeitherLessOrGreaterThan=U,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function we(x,J){return(H,L)=>J(x(H),x(L))}function ie(...x){return(J,H)=>{for(const L of x){const U=L(J,H);if(!ne.isNeitherLessOrGreaterThan(U))return U}return ne.neitherLessOrGreaterThan}}const Y=(x,J)=>x-J;e.$9b=Y;const V=(x,J)=>(0,e.$9b)(x?1:0,J?1:0);e.$0b=V;function N(x){return(J,H)=>-x(J,H)}class z{constructor(J){this.g=J,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(J){let H=this.c;for(;H<this.g.length&&J(this.g[H]);)H++;const L=H===this.c?null:this.g.slice(this.c,H);return this.c=H,L}takeFromEndWhile(J){let H=this.d;for(;H>=0&&J(this.g[H]);)H--;const L=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,L}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const J=this.g[this.c];return this.c++,J}removeLast(){const J=this.g[this.d];return this.d--,J}takeCount(J){const H=this.g.slice(this.c,this.c+J);return this.c+=J,H}}e.$_b=z;class Z{constructor(J){this.iterate=J}forEach(J){this.iterate(H=>(J(H),!0))}toArray(){const J=[];return this.iterate(H=>(J.push(H),!0)),J}filter(J){return new Z(H=>this.iterate(L=>J(L)?H(L):!0))}map(J){return new Z(H=>this.iterate(L=>H(J(L))))}some(J){let H=!1;return this.iterate(L=>(H=J(L),!H)),H}findFirst(J){let H;return this.iterate(L=>J(L)?(H=L,!1):!0),H}findLast(J){let H;return this.iterate(L=>(J(L)&&(H=L),!0)),H}findLastMaxBy(J){let H,L=!0;return this.iterate(U=>((L||ne.isGreaterThan(J(U,H)))&&(L=!1,H=U),!0)),H}}e.$ac=Z,Z.empty=new Z(x=>{});class he{constructor(J){this.c=J}static createSortPermutation(J,H){const L=Array.from(J.keys()).sort((U,oe)=>H(J[U],J[oe]));return new he(L)}apply(J){return J.map((H,L)=>J[this.c[L]])}inverse(){const J=this.c.slice();for(let H=0;H<this.c.length;H++)J[this.c[H]]=H;return new he(J)}}e.$bc=he}),define(ye[98],Ee([1,0,11]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$fd=D,e.$gd=k,e.$hd=I,e.$id=S,e.$jd=w;function C(g,y){if(!g)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function D(g,y="Unreachable"){throw new Error(y)}function k(g){if(!g)throw new s.$cb("Assertion Failed")}function I(g){g||(0,s.$1)(new s.$cb("Soft Assertion Failed"))}function S(g){if(!g()){debugger;g(),(0,s.$1)(new s.$cb("Assertion Failed"))}}function w(g,y){let v=0;for(;v<g.length-1;){const b=g[v],m=g[v+1];if(!y(b,m))return!1;v++}return!0}}),define(ye[147],Ee([1,0,18]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=D,e.$9c=k,e.$0c=I,e.$$c=S,e.$_c=w,e.$ad=g;const C=(m,u)=>m===u;e.$7c=C;function D(m=e.$7c){return(u,a)=>s.$ub(u,a,m)}function k(){return(m,u)=>JSON.stringify(m)===JSON.stringify(u)}function I(){return(m,u)=>m.equals(u)}function S(m,u,a){return!m||!u?m===u:a(m,u)}function w(m,u){if(m===u)return!0;if(Array.isArray(m)&&Array.isArray(u)){if(m.length!==u.length)return!1;for(let a=0;a<m.length;a++)if(!w(m[a],u[a]))return!1;return!0}if(m&&typeof m=="object"&&u&&typeof u=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(u)===Object.prototype){const a=m,f=u,c=Object.keys(a),d=Object.keys(f),$=new Set(d);if(c.length!==d.length)return!1;for(const E of c)if(!$.has(E)||!w(a[E],f[E]))return!1;return!0}return!1}function g(m){return JSON.stringify(b(m))}let y=0;const v=new WeakMap;function b(m){if(Array.isArray(m))return m.map(b);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const u=m,a=Object.create(null);for(const f of Object.keys(u).sort())a[f]=b(u[f]);return a}else{let u=v.get(m);return u===void 0&&(u=y++,v.set(m,u)),u+"----2b76a038c20c4bcc"}return m}}),define(ye[75],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=s;function s(C,D){const k=this;let I=!1,S;return function(){if(I)return S;if(I=!0,D)try{S=C.apply(k,arguments)}finally{D()}else S=C.apply(k,arguments);return S}}}),define(ye[41],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(C){function D(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=D;const k=Object.freeze([]);function I(){return k}C.empty=I;function*S(t){yield t}C.single=S;function w(t){return D(t)?t:S(t)}C.wrap=w;function g(t){return t||k}C.from=g;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}C.reverse=y;function v(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=v;function b(t){return t[Symbol.iterator]().next().value}C.first=b;function m(t,o){for(const r of t)if(o(r))return!0;return!1}C.some=m;function u(t,o){for(const r of t)if(o(r))return r}C.find=u;function*a(t,o){for(const r of t)o(r)&&(yield r)}C.filter=a;function*f(t,o){let r=0;for(const i of t)yield o(i,r++)}C.map=f;function*c(...t){for(const o of t)yield*o}C.concat=c;function d(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}C.reduce=d;function*$(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}C.slice=$;function E(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const l=i.next();if(l.done)return[r,C.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}C.consume=E;async function h(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}C.asyncToArray=h})(s||(e.Iterable=s={}))}),define(ye[43],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$In=I,e.$Jn=v,e.$Kn=b,e.$Ln=m,e.$Mn=u,e.$Nn=a,e.$On=f,e.$Pn=c,e.$Qn=d,e.$Rn=$,e.$Sn=E,e.$Tn=h;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function I(t,o=!1){let r=0;const i=t.length;let n="",l=0,p=16,P=0;function j(ce){let ee=0,K=0;for(;ee<ce;){const q=t.charCodeAt(r);if(q>=48&&q<=57)K=K*16+q-48;else if(q>=65&&q<=70)K=K*16+q-65+10;else if(q>=97&&q<=102)K=K*16+q-97+10;else break;r++,ee++}return ee<ce&&(K=-1),K}function O(ce){r=ce,n="",l=0,p=16,P=0}function R(){const ce=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return P=3,t.substring(ce,r);let ee=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;ee=r}else P=3;return t.substring(ce,ee)}function A(){let ce="",ee=r;for(;;){if(r>=i){ce+=t.substring(ee,r),P=2;break}const K=t.charCodeAt(r);if(K===34){ce+=t.substring(ee,r),r++;break}if(K===92){if(ce+=t.substring(ee,r),r++,r>=i){P=2;break}switch(t.charCodeAt(r++)){case 34:ce+='"';break;case 92:ce+="\\";break;case 47:ce+="/";break;case 98:ce+="\b";break;case 102:ce+="\f";break;case 110:ce+=`
`;break;case 114:ce+="\r";break;case 116:ce+="	";break;case 117:{const X=j(4);X>=0?ce+=String.fromCharCode(X):P=4;break}default:P=5}ee=r;continue}if(K>=0&&K<=31)if(w(K)){ce+=t.substring(ee,r),P=2;break}else P=6;r++}return ce}function B(){if(n="",P=0,l=r,r>=i)return l=i,p=17;let ce=t.charCodeAt(r);if(S(ce)){do r++,n+=String.fromCharCode(ce),ce=t.charCodeAt(r);while(S(ce));return p=15}if(w(ce))return r++,n+=String.fromCharCode(ce),ce===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),p=14;switch(ce){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,n=A(),p=10;case 47:{const ee=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!w(t.charCodeAt(r));)r++;return n=t.substring(ee,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const K=i-1;let q=!1;for(;r<K;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,q=!0;break}r++}return q||(r++,P=1),n=t.substring(ee,r),p=13}return n+=String.fromCharCode(ce),r++,p=16}case 45:if(n+=String.fromCharCode(ce),r++,r===i||!g(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),p=11;default:for(;r<i&&G(ce);)r++,ce=t.charCodeAt(r);if(l!==r){switch(n=t.substring(l,r),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(ce),r++,p=16}}function G(ce){if(S(ce)||w(ce))return!1;switch(ce){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ce;do ce=B();while(ce>=12&&ce<=15);return ce}return{setPosition:O,getPosition:()=>r,scan:o?se:B,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>P}}function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function v(t,o){const r=[],i=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(j,O,R,A){l.value=j,l.offset=O,l.length=R,l.type=A,l.colonOffset=void 0,n=l}try{$(t,{onObjectBegin:(j,O)=>{if(o<=j)throw i;n=void 0,p=o>j,r.push("")},onObjectProperty:(j,O,R)=>{if(o<O||(P(j,O,R,"property"),r[r.length-1]=j,o<=O+R))throw i},onObjectEnd:(j,O)=>{if(o<=j)throw i;n=void 0,r.pop()},onArrayBegin:(j,O)=>{if(o<=j)throw i;n=void 0,r.push(0)},onArrayEnd:(j,O)=>{if(o<=j)throw i;n=void 0,r.pop()},onLiteralValue:(j,O,R)=>{if(o<O||(P(j,O,R,h(j)),o<=O+R))throw i},onSeparator:(j,O,R)=>{if(o<=O)throw i;if(j===":"&&n&&n.type==="property")n.colonOffset=O,p=!1,n=void 0;else if(j===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(p=!0,r[r.length-1]=""),n=void 0}}})}catch(j){if(j!==i)throw j}return{path:r,previousNode:n,isAtPropertyKey:p,matches:j=>{let O=0;for(let R=0;O<j.length&&R<r.length;R++)if(j[O]===r[R]||j[O]==="*")O++;else if(j[O]!=="**")return!1;return O===j.length}}}function b(t,o=[],r=k.DEFAULT){let i=null,n=[];const l=[];function p(j){Array.isArray(n)?n.push(j):i!==null&&(n[i]=j)}return $(t,{onObjectBegin:()=>{const j={};p(j),l.push(n),n=j,i=null},onObjectProperty:j=>{i=j},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const j=[];p(j),l.push(n),n=j,i=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:p,onError:(j,O,R)=>{o.push({error:j,offset:O,length:R})}},r),n[0]}function m(t,o=[],r=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(j){i.type==="property"&&(i.length=j-i.offset,i=i.parent)}function l(j){return i.children.push(j),j}$(t,{onObjectBegin:j=>{i=l({type:"object",offset:j,length:-1,parent:i,children:[]})},onObjectProperty:(j,O,R)=>{i=l({type:"property",offset:O,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:j,offset:O,length:R,parent:i})},onObjectEnd:(j,O)=>{i.length=j+O-i.offset,i=i.parent,n(j+O)},onArrayBegin:(j,O)=>{i=l({type:"array",offset:j,length:-1,parent:i,children:[]})},onArrayEnd:(j,O)=>{i.length=j+O-i.offset,i=i.parent,n(j+O)},onLiteralValue:(j,O,R)=>{l({type:h(j),offset:O,length:R,parent:i,value:j}),n(O+R)},onSeparator:(j,O,R)=>{i.type==="property"&&(j===":"?i.colonOffset=O:j===","&&n(O))},onError:(j,O,R)=>{o.push({error:j,offset:O,length:R})}},r);const P=i.children[0];return P&&delete P.parent,P}function u(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=f(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}function d(t,o,r=!1){if(c(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const l=d(i[n],o,r);if(l)return l}return t}}function $(t,o,r=k.DEFAULT){const i=I(t,!1);function n(we){return we?()=>we(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(we){return we?ie=>we(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=n(o.onObjectBegin),P=l(o.onObjectProperty),j=n(o.onObjectEnd),O=n(o.onArrayBegin),R=n(o.onArrayEnd),A=l(o.onLiteralValue),B=l(o.onSeparator),G=n(o.onComment),se=l(o.onError),ce=r&&r.disallowComments,ee=r&&r.allowTrailingComma;function K(){for(;;){const we=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ce||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(we){case 12:case 13:ce?q(10):G();break;case 16:q(1);break;case 15:case 14:break;default:return we}}}function q(we,ie=[],Y=[]){if(se(we),ie.length+Y.length>0){let V=i.getToken();for(;V!==17;){if(ie.indexOf(V)!==-1){K();break}else if(Y.indexOf(V)!==-1)break;V=K()}}}function X(we){const ie=i.getTokenValue();return we?A(ie):P(ie),K(),!0}function _(){switch(i.getToken()){case 11:{let we=0;try{we=JSON.parse(i.getTokenValue()),typeof we!="number"&&(q(2),we=0)}catch{q(2)}A(we);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return K(),!0}function M(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(B(":"),K(),ne()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Q(){p(),K();let we=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(we||q(4,[],[]),B(","),K(),i.getToken()===2&&ee)break}else we&&q(6,[],[]);M()||q(4,[],[2,5]),we=!0}return j(),i.getToken()!==2?q(7,[2],[]):K(),!0}function ae(){O(),K();let we=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(we||q(4,[],[]),B(","),K(),i.getToken()===4&&ee)break}else we&&q(6,[],[]);ne()||q(4,[],[4,5]),we=!0}return R(),i.getToken()!==4?q(8,[4],[]):K(),!0}function ne(){switch(i.getToken()){case 3:return ae();case 1:return Q();case 10:return X(!0);default:return _()}}return K(),i.getToken()===17?r.allowEmptyContent?!0:(q(4,[],[]),!1):ne()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}function E(t,o){const r=I(t),i=[];let n,l=0,p;do switch(p=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:l!==p&&i.push(t.substring(l,p)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(n!==17);return i.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[148],Ee([1,0,43]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=C,e.$Vn=D,e.$Wn=S,e.$Xn=w;function C(g,y,v){let b,m,u,a,f;if(y){for(a=y.offset,f=a+y.length,u=a;u>0&&!w(g,u-1);)u--;let p=f;for(;p<g.length&&!w(g,p);)p++;m=g.substring(u,p),b=I(m,v)}else m=g,b=0,u=0,a=0,f=g.length;const c=S(v,g);let d=!1,$=0,E;v.insertSpaces?E=k(" ",v.tabSize||4):E="	";const h=(0,s.$In)(m,!1);let t=!1;function o(){return c+k(E,b+$)}function r(){let p=h.scan();for(d=!1;p===15||p===14;)d=d||p===14,p=h.scan();return t=p===16||h.getTokenError()!==0,p}const i=[];function n(p,P,j){!t&&P<f&&j>a&&g.substring(P,j)!==p&&i.push({offset:P,length:j-P,content:p})}let l=r();if(l!==17){const p=h.getTokenOffset()+u,P=k(E,b);n(P,u,p)}for(;l!==17;){let p=h.getTokenOffset()+h.getTokenLength()+u,P=r(),j="";for(;!d&&(P===12||P===13);){const R=h.getTokenOffset()+u;n(" ",p,R),p=h.getTokenOffset()+h.getTokenLength()+u,j=P===12?o():"",P=r()}if(P===2)l!==1&&($--,j=o());else if(P===4)l!==3&&($--,j=o());else{switch(l){case 3:case 1:$++,j=o();break;case 5:case 12:j=o();break;case 13:d?j=o():j=" ";break;case 6:j=" ";break;case 10:if(P===6){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?j=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}d&&(P===12||P===13)&&(j=o())}const O=h.getTokenOffset()+u;n(j,p,O),l=P}return i}function D(g,y){const v=JSON.stringify(g,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?v.replace(/\r\n|\r|\n/g,y.eol):v}function k(g,y){let v="";for(let b=0;b<y;b++)v+=g;return v}function I(g,y){let v=0,b=0;const m=y.tabSize||4;for(;v<g.length;){const u=g.charAt(v);if(u===" ")b++;else if(u==="	")b+=m;else break;v++}return Math.floor(b/m)}function S(g,y){for(let v=0;v<y.length;v++){const b=y.charAt(v);if(b==="\r")return v+1<y.length&&y.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return g&&g.eol||`
`}function w(g,y){return`\r
`.indexOf(g.charAt(y))!==-1}}),define(ye[149],Ee([1,0,43,148]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=D,e.$Zn=k,e.$1n=I,e.$2n=S,e.$3n=w;function D(g,y,v){return k(g,y,void 0,v)}function k(g,y,v,b,m){const u=y.slice(),a=[],f=(0,s.$Ln)(g,a);let c,d;for(;u.length>0&&(d=u.pop(),c=(0,s.$Mn)(f,u),c===void 0&&v!==void 0);)typeof d=="string"?v={[d]:v}:v=[v];if(c)if(c.type==="object"&&typeof d=="string"&&Array.isArray(c.children)){const $=(0,s.$Mn)(c,[d]);if($!==void 0)if(v===void 0){if(!$.parent)throw new Error("Malformed AST");const E=c.children.indexOf($.parent);let h,t=$.parent.offset+$.parent.length;if(E>0){const o=c.children[E-1];h=o.offset+o.length}else h=c.offset+1,c.children.length>1&&(t=c.children[1].offset);return I(g,{offset:h,length:t-h,content:""},b)}else return I(g,{offset:$.offset,length:$.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const E=`${JSON.stringify(d)}: ${JSON.stringify(v)}`,h=m?m(c.children.map(o=>o.children[0].value)):c.children.length;let t;if(h>0){const o=c.children[h-1];t={offset:o.offset+o.length,length:0,content:","+E}}else c.children.length===0?t={offset:c.offset+1,length:0,content:E}:t={offset:c.offset+1,length:0,content:E+","};return I(g,t,b)}}else if(c.type==="array"&&typeof d=="number"&&Array.isArray(c.children))if(v!==void 0){const $=`${JSON.stringify(v)}`;let E;if(c.children.length===0||d===0)E={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const h=d===-1||d>c.children.length?c.children.length:d,t=c.children[h-1];E={offset:t.offset+t.length,length:0,content:","+$}}return I(g,E,b)}else{const $=d,E=c.children[$];let h;if(c.children.length===1)h={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const t=c.children[$-1],o=t.offset+t.length,r=c.offset+c.length;h={offset:o,length:r-2-o,content:""}}else h={offset:E.offset,length:c.children[$+1].offset-E.offset,content:""};return I(g,h,b)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${c.type}`);else return v===void 0?[]:I(g,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(v)},b)}function I(g,y,v){let b=S(g,y),m=y.offset,u=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,C.$Xn)(b,m-1);)m--;for(;u<b.length&&!(0,C.$Xn)(b,u);)u++}const a=(0,C.$Un)(b,{offset:m,length:u-m},v);for(let c=a.length-1;c>=0;c--){const d=a[c];b=S(b,d),m=Math.min(m,d.offset),u=Math.max(u,d.offset+d.length),u+=d.content.length-d.length}const f=g.length-(b.length-u)-m;return[{offset:m,length:f,content:b.substring(m,u)}]}function S(g,y){return g.substring(0,y.offset)+y.content+g.substring(y.offset+y.length)}function w(g,y){const v=y.slice(0).sort((m,u)=>{const a=m.offset-u.offset;return a===0?m.length-u.length:a});let b=g.length;for(let m=v.length-1;m>=0;m--){const u=v[m];if(u.offset+u.length<=b)g=S(g,u);else throw new Error("Overlapping edit");b=u.offset}return g}}),define(ye[60],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class s{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=s}),define(ye[99],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class s{constructor(k){this.element=k,this.next=s.Undefined,this.prev=s.Undefined}}s.Undefined=new s(void 0);class C{constructor(){this.a=s.Undefined,this.b=s.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===s.Undefined}clear(){let k=this.a;for(;k!==s.Undefined;){const I=k.next;k.prev=s.Undefined,k.next=s.Undefined,k=I}this.a=s.Undefined,this.b=s.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,I){const S=new s(k);if(this.a===s.Undefined)this.a=S,this.b=S;else if(I){const g=this.b;this.b=S,S.prev=g,g.next=S}else{const g=this.a;this.a=S,S.next=g,g.prev=S}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(S))}}shift(){if(this.a!==s.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==s.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==s.Undefined&&k.next!==s.Undefined){const I=k.prev;I.next=k.next,k.next.prev=I}else k.prev===s.Undefined&&k.next===s.Undefined?(this.a=s.Undefined,this.b=s.Undefined):k.next===s.Undefined?(this.b=this.b.prev,this.b.next=s.Undefined):k.prev===s.Undefined&&(this.a=this.a.next,this.a.prev=s.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==s.Undefined;)yield k.element,k=k.next}}e.$6c=C}),define(ye[24],Ee([1,0]),function(ue,e){"use strict";var s,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=k,e.$zc=I,e.$Ac=S,e.$Jc=E;function k(h,t,o){let r=h.get(t);return r===void 0&&(r=o,h.set(t,r)),r}function I(h){const t=[];return h.forEach((o,r)=>{t.push(`${r} => ${o}`)}),`Map(${h.size}) {${t.join(", ")}}`}function S(h){const t=[];return h.forEach(o=>{t.push(o)}),`Set(${h.size}) {${t.join(", ")}}`}class w{constructor(t,o){this.uri=t,this.value=o}}function g(h){return Array.isArray(h)}class y{constructor(t,o){if(this[s]="ResourceMap",t instanceof y)this.d=new Map(t.d),this.e=o??y.c;else if(g(t)){this.d=new Map,this.e=o??y.c;for(const[r,i]of t)this.set(r,i)}else this.d=new Map,this.e=t??y.c}set(t,o){return this.d.set(this.e(t),new w(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[r,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=y,y.c=h=>h.toString();class v{constructor(t,o){this[C]="ResourceSet",!t||typeof t=="function"?this.c=new y(t):(this.c=new y(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((r,i)=>t.call(o,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=v;var b;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class m{constructor(){this[D]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=0){const r=this.c.get(t);if(r)return o!==0&&this.m(r,o),r.value}set(t,o,r=0){let i=this.c.get(t);if(i)i.value=o,r!==0&&this.m(i,r);else{switch(i={key:t,value:o,next:void 0,previous:void 0},r){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const r=this.g;let i=this.d;for(;i;){if(o?t.bind(o)(i.value,i.key,this):t(i.value,i.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,o=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.key,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,o=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.value,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,o=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:[r.key,r.value],done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,r=this.size;for(;o&&r>t;)this.c.delete(o.key),o=o.next,r--;this.d=o,this.f=r,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,r=this.size;for(;o&&r>t;)this.c.delete(o.key),o=o.previous,r--;this.e=o,this.f=r,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,r=t.previous;if(!o||!r)throw new Error("Invalid list");o.previous=r,r.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.d)return;const r=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(r.previous=i,i.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===2){if(t===this.e)return;const r=t.next,i=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=i,i.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,r)=>{t.push([r,o])}),t}fromJSON(t){this.clear();for(const[o,r]of t)this.set(o,r)}}e.$Dc=m;class u extends m{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends u{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Ec=a;class f extends u{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Fc=f;class c{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Gc=c;class d{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,r]of t)this.set(o,r)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((r,i)=>{t.call(o,r,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=d;class ${constructor(){this.c=new Map}add(t,o){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(o)}delete(t,o){const r=this.c.get(t);r&&(r.delete(o),r.size===0&&this.c.delete(t))}forEach(t,o){const r=this.c.get(t);r&&r.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Ic=$;function E(h,t){if(h===t)return!0;if(h.size!==t.size)return!1;for(const[o,r]of h)if(!t.has(o)||t.get(o)!==r)return!1;for(const[o]of t)if(!h.has(o))return!1;return!0}}),define(ye[2],Ee([1,0,18,146,24,75,41]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=y,e.$Mc=v,e.$Nc=b,e.$Oc=a,e.$Pc=f,e.$Qc=c,e.$Rc=d,e.$Sc=$,e.$Tc=E,e.$4c=j;const S=!1;let w=null;class g{constructor(){this.b=new Map}c(A){let B=this.b.get(A);return B||(B={parent:null,source:null,isSingleton:!1,value:A,idx:g.a++},this.b.set(A,B)),B}trackDisposable(A){const B=this.c(A);B.source||(B.source=new Error().stack)}setParent(A,B){const G=this.c(A);G.parent=B}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,B){const G=B.get(A);if(G)return G;const se=A.parent?this.f(this.c(A.parent),B):A;return B.set(A,se),se}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,A).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(A=10,B){let G;if(B)G=B;else{const q=new Map,X=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,q).isSingleton);if(X.length===0)return;const _=new Set(X.map(M=>M.value));if(G=X.filter(M=>!(M.parent&&_.has(M.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function se(q){function X(M,Q){for(;M.length>0&&Q.some(ae=>typeof ae=="string"?ae===M[0]:M[0].match(ae));)M.shift()}const _=q.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return X(_,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),_.reverse()}const ce=new D.$Ic;for(const q of G){const X=se(q);for(let _=0;_<=X.length;_++)ce.add(X.slice(0,_).join(`
`),q)}G.sort((0,s.$7b)(q=>q.idx,s.$9b));let ee="",K=0;for(const q of G.slice(0,A)){K++;const X=se(q),_=[];for(let M=0;M<X.length;M++){let Q=X[M];Q=`(shared with ${ce.get(X.slice(0,M+1).join(`
`)).size}/${G.length} leaks) at ${Q}`;const ne=ce.get(X.slice(0,M).join(`
`)),we=(0,C.$E)([...ne].map(ie=>se(ie)[M]),ie=>ie);delete we[X[M]];for(const[ie,Y]of Object.entries(we))_.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${ie}`);_.unshift(Q)}ee+=`


==================== Leaking disposable ${K}/${G.length}: ${q.value.constructor.name} ====================
${_.join(`
`)}
============================================================

`}return G.length>A&&(ee+=`


... and ${G.length-A} more leaking disposables

`),{leaks:G,details:ee}}}e.$Kc=g,g.a=0;function y(R){w=R}if(S){const R="__is_disposable_tracked__";y(new class{trackDisposable(A){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[R]||console.log(B)},3e3)}setParent(A,B){if(A&&A!==t.None)try{A[R]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[R]=!0}catch{}}markAsSingleton(A){}})}function v(R){return w?.trackDisposable(R),R}function b(R){w?.markAsDisposed(R)}function m(R,A){w?.setParent(R,A)}function u(R,A){if(w)for(const B of R)w.setParent(B,A)}function a(R){return w?.markAsSingleton(R),R}function f(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function c(R){if(I.Iterable.is(R)){const A=[];for(const B of R)if(B)try{B.dispose()}catch(G){A.push(G)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function d(R){for(const A of R)f(A)&&A.dispose();return[]}function $(...R){const A=E(()=>c(R));return u(R,A),A}function E(R){const A=v({dispose:(0,k.$db)(()=>{b(A),R()})});return A}class h{constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return m(A,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),m(A,null))}}e.$Uc=h,h.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new h,v(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Vc=t,t.None=Object.freeze({dispose(){}});class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&m(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&m(A,null),A}}e.$Wc=o;class r{constructor(A){this.a=new o,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class i{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(A){let B=A;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,b(this))},this}}e.$Zc=n;class l{constructor(){this.a=new Map}acquire(A,...B){let G=this.a.get(A);G||(G={counter:0,object:this.b(A,...B)},this.a.set(A,G));const{object:se}=G,ce=(0,k.$db)(()=>{--G.counter===0&&(this.c(A,G.object),this.a.delete(A))});return G.counter++,{object:se,dispose:ce}}}e.$1c=l;class p{constructor(A){this.a=A}async acquire(A,...B){const G=this.a.acquire(A,...B);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(se){throw G.dispose(),se}}}e.$2c=p;class P{constructor(A){this.object=A}dispose(){}}e.$3c=P;function j(R){const A=new h;try{R(A)}finally{A.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,B,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(A)?.dispose(),this.a.set(A,B)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=O}),function(ue,e){typeof define=="function"&&define.amd?define(ye[150],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(x,J){for(var H=0;H<J.length;H++){var L=J[H];L.enumerable=L.enumerable||!1,L.configurable=!0,"value"in L&&(L.writable=!0),Object.defineProperty(x,L.key,L)}}function s(x,J,H){return J&&e(x.prototype,J),H&&e(x,H),Object.defineProperty(x,"prototype",{writable:!1}),x}function C(x,J){if(x){if(typeof x=="string")return D(x,J);var H=Object.prototype.toString.call(x).slice(8,-1);if(H==="Object"&&x.constructor&&(H=x.constructor.name),H==="Map"||H==="Set")return Array.from(x);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return D(x,J)}}function D(x,J){(J==null||J>x.length)&&(J=x.length);for(var H=0,L=new Array(J);H<J;H++)L[H]=x[H];return L}function k(x,J){var H=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if(H)return(H=H.call(x)).next.bind(H);if(Array.isArray(x)||(H=C(x))||J&&x&&typeof x.length=="number"){H&&(x=H);var L=0;return function(){return L>=x.length?{done:!0}:{done:!1,value:x[L++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=I();function S(x){ue.defaults=x}var w=/[&<>"']/,g=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(J){return b[J]};function u(x,J){if(J){if(w.test(x))return x.replace(g,m)}else if(y.test(x))return x.replace(v,m);return x}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(x){return x.replace(a,function(J,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var c=/(^|[^\[])\^/g;function d(x,J){x=typeof x=="string"?x:x.source,J=J||"";var H={replace:function(U,oe){return oe=oe.source||oe,oe=oe.replace(c,"$1"),x=x.replace(U,oe),H},getRegex:function(){return new RegExp(x,J)}};return H}var $=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(x,J,H){if(x){var L;try{L=decodeURIComponent(f(H)).replace($,"").toLowerCase()}catch{return null}if(L.indexOf("javascript:")===0||L.indexOf("vbscript:")===0||L.indexOf("data:")===0)return null}J&&!E.test(H)&&(H=n(J,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var t={},o=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(x,J){t[" "+x]||(o.test(x)?t[" "+x]=x+"/":t[" "+x]=j(x,"/",!0)),x=t[" "+x];var H=x.indexOf(":")===-1;return J.substring(0,2)==="//"?H?J:x.replace(r,"$1")+J:J.charAt(0)==="/"?H?J:x.replace(i,"$1")+J:x+J}var l={exec:function(){}};function p(x){for(var J=1,H,L;J<arguments.length;J++){H=arguments[J];for(L in H)Object.prototype.hasOwnProperty.call(H,L)&&(x[L]=H[L])}return x}function P(x,J){var H=x.replace(/\|/g,function(oe,le,de){for(var te=!1,me=le;--me>=0&&de[me]==="\\";)te=!te;return te?"|":" |"}),L=H.split(/ \|/),U=0;if(L[0].trim()||L.shift(),L.length>0&&!L[L.length-1].trim()&&L.pop(),L.length>J)L.splice(J);else for(;L.length<J;)L.push("");for(;U<L.length;U++)L[U]=L[U].trim().replace(/\\\|/g,"|");return L}function j(x,J,H){var L=x.length;if(L===0)return"";for(var U=0;U<L;){var oe=x.charAt(L-U-1);if(oe===J&&!H)U++;else if(oe!==J&&H)U++;else break}return x.slice(0,L-U)}function O(x,J){if(x.indexOf(J[1])===-1)return-1;for(var H=x.length,L=0,U=0;U<H;U++)if(x[U]==="\\")U++;else if(x[U]===J[0])L++;else if(x[U]===J[1]&&(L--,L<0))return U;return-1}function R(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(x,J){if(J<1)return"";for(var H="";J>1;)J&1&&(H+=x),J>>=1,x+=x;return H+x}function B(x,J,H,L){var U=J.href,oe=J.title?u(J.title):null,le=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){L.state.inLink=!0;var de={type:"link",raw:H,href:U,title:oe,text:le,tokens:L.inlineTokens(le)};return L.state.inLink=!1,de}return{type:"image",raw:H,href:U,title:oe,text:u(le)}}function G(x,J){var H=x.match(/^(\s+)(?:```)/);if(H===null)return J;var L=H[1];return J.split(`
`).map(function(U){var oe=U.match(/^\s+/);if(oe===null)return U;var le=oe[0];return le.length>=L.length?U.slice(L.length):U}).join(`
`)}var se=function(){function x(H){this.options=H||ue.defaults}var J=x.prototype;return J.space=function(L){var U=this.rules.block.newline.exec(L);if(U&&U[0].length>0)return{type:"space",raw:U[0]}},J.code=function(L){var U=this.rules.block.code.exec(L);if(U){var oe=U[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:U[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:j(oe,`
`)}}},J.fences=function(L){var U=this.rules.block.fences.exec(L);if(U){var oe=U[0],le=G(oe,U[3]||"");return{type:"code",raw:oe,lang:U[2]?U[2].trim():U[2],text:le}}},J.heading=function(L){var U=this.rules.block.heading.exec(L);if(U){var oe=U[2].trim();if(/#$/.test(oe)){var le=j(oe,"#");(this.options.pedantic||!le||/ $/.test(le))&&(oe=le.trim())}return{type:"heading",raw:U[0],depth:U[1].length,text:oe,tokens:this.lexer.inline(oe)}}},J.hr=function(L){var U=this.rules.block.hr.exec(L);if(U)return{type:"hr",raw:U[0]}},J.blockquote=function(L){var U=this.rules.block.blockquote.exec(L);if(U){var oe=U[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:U[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},J.list=function(L){var U=this.rules.block.list.exec(L);if(U){var oe,le,de,te,me,pe,Ce,je,ge,Se,De,Te,Le=U[1].trim(),Ue=Le.length>1,Qe={type:"list",raw:"",ordered:Ue,start:Ue?+Le.slice(0,-1):"",loose:!1,items:[]};Le=Ue?"\\d{1,9}\\"+Le.slice(-1):"\\"+Le,this.options.pedantic&&(Le=Ue?Le:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+Le+")((?:[	 ][^\\n]*)?(?:\\n|$))");L&&(Te=!1,!(!(U=Ge.exec(L))||this.rules.block.hr.test(L)));){if(oe=U[0],L=L.substring(oe.length),je=U[2].split(`
`,1)[0],ge=L.split(`
`,1)[0],this.options.pedantic?(te=2,De=je.trimLeft()):(te=U[2].search(/[^ ]/),te=te>4?1:te,De=je.slice(te),te+=U[1].length),pe=!1,!je&&/^ *$/.test(ge)&&(oe+=ge+`
`,L=L.substring(ge.length+1),Te=!0),!Te)for(var Je=new RegExp("^ {0,"+Math.min(3,te-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ye=new RegExp("^ {0,"+Math.min(3,te-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,te-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,te-1)+"}#");L&&(Se=L.split(`
`,1)[0],je=Se,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(je)||_e.test(je)||Je.test(je)||Ye.test(L)));){if(je.search(/[^ ]/)>=te||!je.trim())De+=`
`+je.slice(te);else if(!pe)De+=`
`+je;else break;!pe&&!je.trim()&&(pe=!0),oe+=Se+`
`,L=L.substring(Se.length+1)}Qe.loose||(Ce?Qe.loose=!0:/\n *\n *$/.test(oe)&&(Ce=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(De),le&&(de=le[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:oe,task:!!le,checked:de,loose:!1,text:De}),Qe.raw+=oe}Qe.items[Qe.items.length-1].raw=oe.trimRight(),Qe.items[Qe.items.length-1].text=De.trimRight(),Qe.raw=Qe.raw.trimRight();var Ze=Qe.items.length;for(me=0;me<Ze;me++){this.lexer.state.top=!1,Qe.items[me].tokens=this.lexer.blockTokens(Qe.items[me].text,[]);var $e=Qe.items[me].tokens.filter(function(Ae){return Ae.type==="space"}),Ie=$e.every(function(Ae){for(var Re=Ae.raw.split(""),Me=0,Ve=k(Re),He;!(He=Ve()).done;){var st=He.value;if(st===`
`&&(Me+=1),Me>1)return!0}return!1});!Qe.loose&&$e.length&&Ie&&(Qe.loose=!0,Qe.items[me].loose=!0)}return Qe}},J.html=function(L){var U=this.rules.block.html.exec(L);if(U){var oe={type:"html",raw:U[0],pre:!this.options.sanitizer&&(U[1]==="pre"||U[1]==="script"||U[1]==="style"),text:U[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(U[0]):u(U[0]);oe.type="paragraph",oe.text=le,oe.tokens=this.lexer.inline(le)}return oe}},J.def=function(L){var U=this.rules.block.def.exec(L);if(U){U[3]&&(U[3]=U[3].substring(1,U[3].length-1));var oe=U[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:U[0],href:U[2],title:U[3]}}},J.table=function(L){var U=this.rules.block.table.exec(L);if(U){var oe={type:"table",header:P(U[1]).map(function(Ce){return{text:Ce}}),align:U[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:U[3]&&U[3].trim()?U[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=U[0];var le=oe.align.length,de,te,me,pe;for(de=0;de<le;de++)/^ *-+: *$/.test(oe.align[de])?oe.align[de]="right":/^ *:-+: *$/.test(oe.align[de])?oe.align[de]="center":/^ *:-+ *$/.test(oe.align[de])?oe.align[de]="left":oe.align[de]=null;for(le=oe.rows.length,de=0;de<le;de++)oe.rows[de]=P(oe.rows[de],oe.header.length).map(function(Ce){return{text:Ce}});for(le=oe.header.length,te=0;te<le;te++)oe.header[te].tokens=this.lexer.inline(oe.header[te].text);for(le=oe.rows.length,te=0;te<le;te++)for(pe=oe.rows[te],me=0;me<pe.length;me++)pe[me].tokens=this.lexer.inline(pe[me].text);return oe}}},J.lheading=function(L){var U=this.rules.block.lheading.exec(L);if(U)return{type:"heading",raw:U[0],depth:U[2].charAt(0)==="="?1:2,text:U[1],tokens:this.lexer.inline(U[1])}},J.paragraph=function(L){var U=this.rules.block.paragraph.exec(L);if(U){var oe=U[1].charAt(U[1].length-1)===`
`?U[1].slice(0,-1):U[1];return{type:"paragraph",raw:U[0],text:oe,tokens:this.lexer.inline(oe)}}},J.text=function(L){var U=this.rules.block.text.exec(L);if(U)return{type:"text",raw:U[0],text:U[0],tokens:this.lexer.inline(U[0])}},J.escape=function(L){var U=this.rules.inline.escape.exec(L);if(U)return{type:"escape",raw:U[0],text:u(U[1])}},J.tag=function(L){var U=this.rules.inline.tag.exec(L);if(U)return!this.lexer.state.inLink&&/^<a /i.test(U[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(U[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(U[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(U[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:U[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(U[0]):u(U[0]):U[0]}},J.link=function(L){var U=this.rules.inline.link.exec(L);if(U){var oe=U[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var le=j(oe.slice(0,-1),"\\");if((oe.length-le.length)%2===0)return}else{var de=O(U[2],"()");if(de>-1){var te=U[0].indexOf("!")===0?5:4,me=te+U[1].length+de;U[2]=U[2].substring(0,de),U[0]=U[0].substring(0,me).trim(),U[3]=""}}var pe=U[2],Ce="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(pe);je&&(pe=je[1],Ce=je[3])}else Ce=U[3]?U[3].slice(1,-1):"";return pe=pe.trim(),/^</.test(pe)&&(this.options.pedantic&&!/>$/.test(oe)?pe=pe.slice(1):pe=pe.slice(1,-1)),B(U,{href:pe&&pe.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},U[0],this.lexer)}},J.reflink=function(L,U){var oe;if((oe=this.rules.inline.reflink.exec(L))||(oe=this.rules.inline.nolink.exec(L))){var le=(oe[2]||oe[1]).replace(/\s+/g," ");if(le=U[le.toLowerCase()],!le||!le.href){var de=oe[0].charAt(0);return{type:"text",raw:de,text:de}}return B(oe,le,oe[0],this.lexer)}},J.emStrong=function(L,U,oe){oe===void 0&&(oe="");var le=this.rules.inline.emStrong.lDelim.exec(L);if(le&&!(le[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=le[1]||le[2]||"";if(!de||de&&(oe===""||this.rules.inline.punctuation.exec(oe))){var te=le[0].length-1,me,pe,Ce=te,je=0,ge=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,U=U.slice(-1*L.length+te);(le=ge.exec(U))!=null;)if(me=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!me){if(pe=me.length,le[3]||le[4]){Ce+=pe;continue}else if((le[5]||le[6])&&te%3&&!((te+pe)%3)){je+=pe;continue}if(Ce-=pe,!(Ce>0)){if(pe=Math.min(pe,pe+Ce+je),Math.min(te,pe)%2){var Se=L.slice(1,te+le.index+pe);return{type:"em",raw:L.slice(0,te+le.index+pe+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var De=L.slice(2,te+le.index+pe-1);return{type:"strong",raw:L.slice(0,te+le.index+pe+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},J.codespan=function(L){var U=this.rules.inline.code.exec(L);if(U){var oe=U[2].replace(/\n/g," "),le=/[^ ]/.test(oe),de=/^ /.test(oe)&&/ $/.test(oe);return le&&de&&(oe=oe.substring(1,oe.length-1)),oe=u(oe,!0),{type:"codespan",raw:U[0],text:oe}}},J.br=function(L){var U=this.rules.inline.br.exec(L);if(U)return{type:"br",raw:U[0]}},J.del=function(L){var U=this.rules.inline.del.exec(L);if(U)return{type:"del",raw:U[0],text:U[2],tokens:this.lexer.inlineTokens(U[2])}},J.autolink=function(L,U){var oe=this.rules.inline.autolink.exec(L);if(oe){var le,de;return oe[2]==="@"?(le=u(this.options.mangle?U(oe[1]):oe[1]),de="mailto:"+le):(le=u(oe[1]),de=le),{type:"link",raw:oe[0],text:le,href:de,tokens:[{type:"text",raw:le,text:le}]}}},J.url=function(L,U){var oe;if(oe=this.rules.inline.url.exec(L)){var le,de;if(oe[2]==="@")le=u(this.options.mangle?U(oe[0]):oe[0]),de="mailto:"+le;else{var te;do te=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(te!==oe[0]);le=u(oe[0]),oe[1]==="www."?de="http://"+le:de=le}return{type:"link",raw:oe[0],text:le,href:de,tokens:[{type:"text",raw:le,text:le}]}}},J.inlineText=function(L,U){var oe=this.rules.inline.text.exec(L);if(oe){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):u(oe[0]):oe[0]:le=u(this.options.smartypants?U(oe[0]):oe[0]),{type:"text",raw:oe[0],text:le}}},x}(),ce={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ce._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ce._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ce.def=d(ce.def).replace("label",ce._label).replace("title",ce._title).getRegex(),ce.bullet=/(?:[*+-]|\d{1,9}[.)])/,ce.listItemStart=d(/^( *)(bull) */).replace("bull",ce.bullet).getRegex(),ce.list=d(ce.list).replace(/bull/g,ce.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ce.def.source+")").getRegex(),ce._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ce._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ce.html=d(ce.html,"i").replace("comment",ce._comment).replace("tag",ce._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ce.paragraph=d(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.blockquote=d(ce.blockquote).replace("paragraph",ce.paragraph).getRegex(),ce.normal=p({},ce),ce.gfm=p({},ce.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ce.gfm.table=d(ce.gfm.table).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.gfm.paragraph=d(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ce.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.pedantic=p({},ce.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ce._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:d(ce.normal._paragraph).replace("hr",ce.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ce.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=d(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=d(ce._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=d(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=d(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=d(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=d(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=d(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=d(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=d(ee.reflink).replace("label",ee._label).replace("ref",ce._label).getRegex(),ee.nolink=d(ee.nolink).replace("ref",ce._label).getRegex(),ee.reflinkSearch=d(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=p({},ee),ee.pedantic=p({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=p({},ee.normal,{escape:d(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=d(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=p({},ee.gfm,{br:d(ee.br).replace("{2,}","*").getRegex(),text:d(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(x){var J="",H,L,U=x.length;for(H=0;H<U;H++)L=x.charCodeAt(H),Math.random()>.5&&(L="x"+L.toString(16)),J+="&#"+L+";";return J}var X=function(){function x(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||ue.defaults,this.options.tokenizer=this.options.tokenizer||new se,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var L={block:ce.normal,inline:ee.normal};this.options.pedantic?(L.block=ce.pedantic,L.inline=ee.pedantic):this.options.gfm&&(L.block=ce.gfm,this.options.breaks?L.inline=ee.breaks:L.inline=ee.gfm),this.tokenizer.rules=L}x.lex=function(L,U){var oe=new x(U);return oe.lex(L)},x.lexInline=function(L,U){var oe=new x(U);return oe.inlineTokens(L)};var J=x.prototype;return J.lex=function(L){L=L.replace(/\r\n|\r/g,`
`),this.blockTokens(L,this.tokens);for(var U;U=this.inlineQueue.shift();)this.inlineTokens(U.src,U.tokens);return this.tokens},J.blockTokens=function(L,U){var oe=this;U===void 0&&(U=[]),this.options.pedantic?L=L.replace(/\t/g,"    ").replace(/^ +$/gm,""):L=L.replace(/^( *)(\t+)/gm,function(Ce,je,ge){return je+"    ".repeat(ge.length)});for(var le,de,te,me;L;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(le=Ce.call({lexer:oe},L,U))?(L=L.substring(le.raw.length),U.push(le),!0):!1}))){if(le=this.tokenizer.space(L)){L=L.substring(le.raw.length),le.raw.length===1&&U.length>0?U[U.length-1].raw+=`
`:U.push(le);continue}if(le=this.tokenizer.code(L)){L=L.substring(le.raw.length),de=U[U.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+le.raw,de.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):U.push(le);continue}if(le=this.tokenizer.fences(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.heading(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.hr(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.blockquote(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.list(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.html(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.def(L)){L=L.substring(le.raw.length),de=U[U.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+le.raw,de.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.lheading(L)){L=L.substring(le.raw.length),U.push(le);continue}if(te=L,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,je=L.slice(1),ge=void 0;oe.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},je),typeof ge=="number"&&ge>=0&&(Ce=Math.min(Ce,ge))}),Ce<1/0&&Ce>=0&&(te=L.substring(0,Ce+1))}(),this.state.top&&(le=this.tokenizer.paragraph(te))){de=U[U.length-1],me&&de.type==="paragraph"?(de.raw+=`
`+le.raw,de.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):U.push(le),me=te.length!==L.length,L=L.substring(le.raw.length);continue}if(le=this.tokenizer.text(L)){L=L.substring(le.raw.length),de=U[U.length-1],de&&de.type==="text"?(de.raw+=`
`+le.raw,de.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):U.push(le);continue}if(L){var pe="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return this.state.top=!0,U},J.inline=function(L,U){return U===void 0&&(U=[]),this.inlineQueue.push({src:L,tokens:U}),U},J.inlineTokens=function(L,U){var oe=this;U===void 0&&(U=[]);var le,de,te,me=L,pe,Ce,je;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(pe=this.tokenizer.rules.inline.reflinkSearch.exec(me))!=null;)ge.includes(pe[0].slice(pe[0].lastIndexOf("[")+1,-1))&&(me=me.slice(0,pe.index)+"["+A("a",pe[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(pe=this.tokenizer.rules.inline.blockSkip.exec(me))!=null;)me=me.slice(0,pe.index)+"["+A("a",pe[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(pe=this.tokenizer.rules.inline.escapedEmSt.exec(me))!=null;)me=me.slice(0,pe.index)+"++"+me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;L;)if(Ce||(je=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(le=De.call({lexer:oe},L,U))?(L=L.substring(le.raw.length),U.push(le),!0):!1}))){if(le=this.tokenizer.escape(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.tag(L)){L=L.substring(le.raw.length),de=U[U.length-1],de&&le.type==="text"&&de.type==="text"?(de.raw+=le.raw,de.text+=le.text):U.push(le);continue}if(le=this.tokenizer.link(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.reflink(L,this.tokens.links)){L=L.substring(le.raw.length),de=U[U.length-1],de&&le.type==="text"&&de.type==="text"?(de.raw+=le.raw,de.text+=le.text):U.push(le);continue}if(le=this.tokenizer.emStrong(L,me,je)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.codespan(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.br(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.del(L)){L=L.substring(le.raw.length),U.push(le);continue}if(le=this.tokenizer.autolink(L,q)){L=L.substring(le.raw.length),U.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(L,q))){L=L.substring(le.raw.length),U.push(le);continue}if(te=L,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Te=L.slice(1),Le=void 0;oe.options.extensions.startInline.forEach(function(Ue){Le=Ue.call({lexer:this},Te),typeof Le=="number"&&Le>=0&&(De=Math.min(De,Le))}),De<1/0&&De>=0&&(te=L.substring(0,De+1))}(),le=this.tokenizer.inlineText(te,K)){L=L.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(je=le.raw.slice(-1)),Ce=!0,de=U[U.length-1],de&&de.type==="text"?(de.raw+=le.raw,de.text+=le.text):U.push(le);continue}if(L){var Se="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return U},s(x,null,[{key:"rules",get:function(){return{block:ce,inline:ee}}}]),x}(),_=function(){function x(H){this.options=H||ue.defaults}var J=x.prototype;return J.code=function(L,U,oe){var le=(U||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(L,le);de!=null&&de!==L&&(oe=!0,L=de)}return L=L.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+u(le,!0)+'">'+(oe?L:u(L,!0))+`</code></pre>
`:"<pre><code>"+(oe?L:u(L,!0))+`</code></pre>
`},J.blockquote=function(L){return`<blockquote>
`+L+`</blockquote>
`},J.html=function(L){return L},J.heading=function(L,U,oe,le){if(this.options.headerIds){var de=this.options.headerPrefix+le.slug(oe);return"<h"+U+' id="'+de+'">'+L+"</h"+U+`>
`}return"<h"+U+">"+L+"</h"+U+`>
`},J.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},J.list=function(L,U,oe){var le=U?"ol":"ul",de=U&&oe!==1?' start="'+oe+'"':"";return"<"+le+de+`>
`+L+"</"+le+`>
`},J.listitem=function(L){return"<li>"+L+`</li>
`},J.checkbox=function(L){return"<input "+(L?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},J.paragraph=function(L){return"<p>"+L+`</p>
`},J.table=function(L,U){return U&&(U="<tbody>"+U+"</tbody>"),`<table>
<thead>
`+L+`</thead>
`+U+`</table>
`},J.tablerow=function(L){return`<tr>
`+L+`</tr>
`},J.tablecell=function(L,U){var oe=U.header?"th":"td",le=U.align?"<"+oe+' align="'+U.align+'">':"<"+oe+">";return le+L+("</"+oe+`>
`)},J.strong=function(L){return"<strong>"+L+"</strong>"},J.em=function(L){return"<em>"+L+"</em>"},J.codespan=function(L){return"<code>"+L+"</code>"},J.br=function(){return this.options.xhtml?"<br/>":"<br>"},J.del=function(L){return"<del>"+L+"</del>"},J.link=function(L,U,oe){if(L=h(this.options.sanitize,this.options.baseUrl,L),L===null)return oe;var le='<a href="'+u(L)+'"';return U&&(le+=' title="'+U+'"'),le+=">"+oe+"</a>",le},J.image=function(L,U,oe){if(L=h(this.options.sanitize,this.options.baseUrl,L),L===null)return oe;var le='<img src="'+L+'" alt="'+oe+'"';return U&&(le+=' title="'+U+'"'),le+=this.options.xhtml?"/>":">",le},J.text=function(L){return L},x}(),M=function(){function x(){}var J=x.prototype;return J.strong=function(L){return L},J.em=function(L){return L},J.codespan=function(L){return L},J.del=function(L){return L},J.html=function(L){return L},J.text=function(L){return L},J.link=function(L,U,oe){return""+oe},J.image=function(L,U,oe){return""+oe},J.br=function(){return""},x}(),Q=function(){function x(){this.seen={}}var J=x.prototype;return J.serialize=function(L){return L.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},J.getNextSafeSlug=function(L,U){var oe=L,le=0;if(this.seen.hasOwnProperty(oe)){le=this.seen[L];do le++,oe=L+"-"+le;while(this.seen.hasOwnProperty(oe))}return U||(this.seen[L]=le,this.seen[oe]=0),oe},J.slug=function(L,U){U===void 0&&(U={});var oe=this.serialize(L);return this.getNextSafeSlug(oe,U.dryrun)},x}(),ae=function(){function x(H){this.options=H||ue.defaults,this.options.renderer=this.options.renderer||new _,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new Q}x.parse=function(L,U){var oe=new x(U);return oe.parse(L)},x.parseInline=function(L,U){var oe=new x(U);return oe.parseInline(L)};var J=x.prototype;return J.parse=function(L,U){U===void 0&&(U=!0);var oe="",le,de,te,me,pe,Ce,je,ge,Se,De,Te,Le,Ue,Qe,Ge,Je,Ye,nt,_e,Ze=L.length;for(le=0;le<Ze;le++){if(De=L[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(_e=this.options.extensions.renderers[De.type].call({parser:this},De),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){oe+=_e||"";continue}switch(De.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(De.tokens),De.depth,f(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ge="",je="",me=De.header.length,de=0;de<me;de++)je+=this.renderer.tablecell(this.parseInline(De.header[de].tokens),{header:!0,align:De.align[de]});for(ge+=this.renderer.tablerow(je),Se="",me=De.rows.length,de=0;de<me;de++){for(Ce=De.rows[de],je="",pe=Ce.length,te=0;te<pe;te++)je+=this.renderer.tablecell(this.parseInline(Ce[te].tokens),{header:!1,align:De.align[te]});Se+=this.renderer.tablerow(je)}oe+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(De.tokens),oe+=this.renderer.blockquote(Se);continue}case"list":{for(Te=De.ordered,Le=De.start,Ue=De.loose,me=De.items.length,Se="",de=0;de<me;de++)Ge=De.items[de],Je=Ge.checked,Ye=Ge.task,Qe="",Ge.task&&(nt=this.renderer.checkbox(Je),Ue?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=nt+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=nt+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:nt}):Qe+=nt),Qe+=this.parse(Ge.tokens,Ue),Se+=this.renderer.listitem(Qe,Ye,Je);oe+=this.renderer.list(Se,Te,Le);continue}case"html":{oe+=this.renderer.html(De.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Se=De.tokens?this.parseInline(De.tokens):De.text;le+1<Ze&&L[le+1].type==="text";)De=L[++le],Se+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);oe+=U?this.renderer.paragraph(Se):Se;continue}default:{var $e='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return oe},J.parseInline=function(L,U){U=U||this.renderer;var oe="",le,de,te,me=L.length;for(le=0;le<me;le++){if(de=L[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(te=this.options.extensions.renderers[de.type].call({parser:this},de),te!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){oe+=te||"";continue}switch(de.type){case"escape":{oe+=U.text(de.text);break}case"html":{oe+=U.html(de.text);break}case"link":{oe+=U.link(de.href,de.title,this.parseInline(de.tokens,U));break}case"image":{oe+=U.image(de.href,de.title,de.text);break}case"strong":{oe+=U.strong(this.parseInline(de.tokens,U));break}case"em":{oe+=U.em(this.parseInline(de.tokens,U));break}case"codespan":{oe+=U.codespan(de.text);break}case"br":{oe+=U.br();break}case"del":{oe+=U.del(this.parseInline(de.tokens,U));break}case"text":{oe+=U.text(de.text);break}default:{var pe='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return oe},x}();function ne(x,J,H){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof J=="function"&&(H=J,J=null),J=p({},ne.defaults,J||{}),R(J),H){var L=J.highlight,U;try{U=X.lex(x,J)}catch(me){return H(me)}var oe=function(pe){var Ce;if(!pe)try{J.walkTokens&&ne.walkTokens(U,J.walkTokens),Ce=ae.parse(U,J)}catch(je){pe=je}return J.highlight=L,pe?H(pe):H(null,Ce)};if(!L||L.length<3||(delete J.highlight,!U.length))return oe();var le=0;ne.walkTokens(U,function(me){me.type==="code"&&(le++,setTimeout(function(){L(me.text,me.lang,function(pe,Ce){if(pe)return oe(pe);Ce!=null&&Ce!==me.text&&(me.text=Ce,me.escaped=!0),le--,le===0&&oe()})},0))}),le===0&&oe();return}function de(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+u(me.message+"",!0)+"</pre>";throw me}try{var te=X.lex(x,J);if(J.walkTokens){if(J.async)return Promise.all(ne.walkTokens(te,J.walkTokens)).then(function(){return ae.parse(te,J)}).catch(de);ne.walkTokens(te,J.walkTokens)}return ae.parse(te,J)}catch(me){de(me)}}ne.options=ne.setOptions=function(x){return p(ne.defaults,x),S(ne.defaults),ne},ne.getDefaults=I,ne.defaults=ue.defaults,ne.use=function(){for(var x=arguments.length,J=new Array(x),H=0;H<x;H++)J[H]=arguments[H];var L=p.apply(void 0,[{}].concat(J)),U=ne.defaults.extensions||{renderers:{},childTokens:{}},oe;J.forEach(function(le){if(le.extensions&&(oe=!0,le.extensions.forEach(function(te){if(!te.name)throw new Error("extension name required");if(te.renderer){var me=U.renderers?U.renderers[te.name]:null;me?U.renderers[te.name]=function(){for(var pe=arguments.length,Ce=new Array(pe),je=0;je<pe;je++)Ce[je]=arguments[je];var ge=te.renderer.apply(this,Ce);return ge===!1&&(ge=me.apply(this,Ce)),ge}:U.renderers[te.name]=te.renderer}if(te.tokenizer){if(!te.level||te.level!=="block"&&te.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");U[te.level]?U[te.level].unshift(te.tokenizer):U[te.level]=[te.tokenizer],te.start&&(te.level==="block"?U.startBlock?U.startBlock.push(te.start):U.startBlock=[te.start]:te.level==="inline"&&(U.startInline?U.startInline.push(te.start):U.startInline=[te.start]))}te.childTokens&&(U.childTokens[te.name]=te.childTokens)})),le.renderer&&function(){var te=ne.defaults.renderer||new _,me=function(je){var ge=te[je];te[je]=function(){for(var Se=arguments.length,De=new Array(Se),Te=0;Te<Se;Te++)De[Te]=arguments[Te];var Le=le.renderer[je].apply(te,De);return Le===!1&&(Le=ge.apply(te,De)),Le}};for(var pe in le.renderer)me(pe);L.renderer=te}(),le.tokenizer&&function(){var te=ne.defaults.tokenizer||new se,me=function(je){var ge=te[je];te[je]=function(){for(var Se=arguments.length,De=new Array(Se),Te=0;Te<Se;Te++)De[Te]=arguments[Te];var Le=le.tokenizer[je].apply(te,De);return Le===!1&&(Le=ge.apply(te,De)),Le}};for(var pe in le.tokenizer)me(pe);L.tokenizer=te}(),le.walkTokens){var de=ne.defaults.walkTokens;L.walkTokens=function(te){var me=[];return me.push(le.walkTokens.call(this,te)),de&&(me=me.concat(de.call(this,te))),me}}oe&&(L.extensions=U),ne.setOptions(L)})},ne.walkTokens=function(x,J){for(var H=[],L=function(){var de=oe.value;switch(H=H.concat(J.call(ne,de)),de.type){case"table":{for(var te=k(de.header),me;!(me=te()).done;){var pe=me.value;H=H.concat(ne.walkTokens(pe.tokens,J))}for(var Ce=k(de.rows),je;!(je=Ce()).done;)for(var ge=je.value,Se=k(ge),De;!(De=Se()).done;){var Te=De.value;H=H.concat(ne.walkTokens(Te.tokens,J))}break}case"list":{H=H.concat(ne.walkTokens(de.items,J));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[de.type]?ne.defaults.extensions.childTokens[de.type].forEach(function(Le){H=H.concat(ne.walkTokens(de[Le],J))}):de.tokens&&(H=H.concat(ne.walkTokens(de.tokens,J)))}},U=k(x),oe;!(oe=U()).done;)L();return H},ne.parseInline=function(x,J){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");J=p({},ne.defaults,J||{}),R(J);try{var H=X.lexInline(x,J);return J.walkTokens&&ne.walkTokens(H,J.walkTokens),ae.parseInline(H,J)}catch(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+u(L.message+"",!0)+"</pre>";throw L}},ne.Parser=ae,ne.parser=ae.parse,ne.Renderer=_,ne.TextRenderer=M,ne.Lexer=X,ne.lexer=X.lex,ne.Tokenizer=se,ne.Slugger=Q,ne.parse=ne;var we=ne.options,ie=ne.setOptions,Y=ne.use,V=ne.walkTokens,N=ne.parseInline,z=ne,Z=ae.parse,he=X.lex;ue.Lexer=X,ue.Parser=ae,ue.Renderer=_,ue.Slugger=Q,ue.TextRenderer=M,ue.Tokenizer=se,ue.getDefaults=I,ue.lexer=he,ue.marked=ne,ue.options=we,ue.parse=z,ue.parseInline=N,ue.parser=Z,ue.setOptions=ie,ue.use=Y,ue.walkTokens=V,Object.defineProperty(ue,"__esModule",{value:!0})}),define(ye[151],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=s;function s(a){const f=k(a);if(f&&f.length>0)return new Uint32Array(f)}let C=0;const D=new Uint32Array(10);function k(a){if(C=0,I(a,v,4352),C>0||(I(a,b,4449),C>0)||(I(a,m,4520),C>0)||(I(a,u,12593),C))return D.subarray(0,C);if(a>=44032&&a<=55203){const f=a-44032,c=f%588,d=Math.floor(f/588),$=Math.floor(c/28),E=c%28-1;if(d<v.length?I(d,v,0):4352+d-12593<u.length&&I(4352+d,u,12593),$<b.length?I($,b,0):4449+$-12593<u.length&&I(4449+$-12593,u,12593),E>=0&&(E<m.length?I(E,m,0):4520+E-12593<u.length&&I(4520+E-12593,u,12593)),C>0)return D.subarray(0,C)}}function I(a,f,c){a>=c&&a<c+f.length&&S(f[a-c])}function S(a){a!==0&&(D[C++]=a&255,a>>8&&(D[C++]=a>>8&255),a>>16&&(D[C++]=a>>16&255))}var w;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(w||(w={}));var g;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(g||(g={}));var y;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(y||(y={}));const v=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),m=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),u=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ye[100],Ee([1,0,24]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=void 0,e.$cm=D,e.$dm=I;const C=new s.$Ec(1e4);function D(g){return w(g,"NFC",C)}const k=new s.$Ec(1e4);function I(g){return w(g,"NFD",k)}const S=/[^\u0000-\u0080]/;function w(g,y,v){if(!g)return g;const b=v.get(g);if(b)return b;let m;return S.test(g)?m=g.normalize(y):m=g,v.set(g,m),m}e.$em=function(){const g=/[\u0300-\u036f]/g;return function(y){return I(y).replace(g,"")}}()}),define(ye[152],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0,e.$Cm=s,e.rot=C;function s(S,w,g){return Math.min(Math.max(S,w),g)}function C(S,w){return(w+S%w)%w}class D{constructor(){this.a=0}getNext(){return this.a++}}e.$Em=D;class k{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Fm=k;class I{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const g=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Gm=I}),define(ye[153],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=k,e.$dd=b;class s{constructor(u,a,f){this.owner=u,this.debugNameSource=a,this.referenceFn=f}getDebugName(u){return k(u,this)}}e.$bd=s;const C=new Map,D=new WeakMap;function k(m,u){const a=D.get(m);if(a)return a;const f=I(m,u);if(f){let c=C.get(f)??0;c++,C.set(f,c);const d=c===1?f:`${f}#${c}`;return D.set(m,d),d}}function I(m,u){const a=D.get(m);if(a)return a;const f=u.owner?y(u.owner)+".":"";let c;const d=u.debugNameSource;if(d!==void 0)if(typeof d=="function"){if(c=d(),c!==void 0)return f+c}else return f+d;const $=u.referenceFn;if($!==void 0&&(c=b($),c!==void 0))return f+c;if(u.owner!==void 0){const E=S(u.owner,m);if(E!==void 0)return f+E}}function S(m,u){for(const a in m)if(m[a]===u)return a}const w=new Map,g=new WeakMap;function y(m){const u=g.get(m);if(u)return u;const a=v(m);let f=w.get(a)??0;f++,w.set(a,f);const c=f===1?a:`${a}#${f}`;return g.set(m,c),c}function v(m){const u=m.constructor;return u?u.name:"Object"}function b(m){const u=m.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(u);return(f?f[1]:void 0)?.trim()}}),define(ye[154],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=C,e.$Jd=D;let s;function C(a){s=a}function D(){return s}class k{constructor(){this.a=0,this.d=new WeakMap}b(f){return I([S(m("|  ",this.a)),f])}c(f){return f.hadValue?f.didChange?[S(" "),g(y(f.oldValue,70),{color:"red",strikeThrough:!0}),S(" "),g(y(f.newValue,60),{color:"green"})]:[S(" (unchanged)")]:[S(" "),g(y(f.newValue,60),{color:"green"}),S(" (initial)")]}handleObservableChanged(f,c){console.log(...this.b([w("observable value changed"),g(f.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(f){if(f.size!==0)return g(" (changed deps: "+[...f].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const c=f.handleChange;this.d.set(f,new Set),f.handleChange=(d,$)=>(this.d.get(f).add(d),c.apply(f,[d,$]))}handleDerivedRecomputed(f,c){const d=this.d.get(f);console.log(...this.b([w("derived recomputed"),g(f.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(d),{data:[{fn:f._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(f,c){console.log(...this.b([w("observable from event triggered"),g(f.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const c=f.handleChange;this.d.set(f,new Set),f.handleChange=(d,$)=>(this.d.get(f).add(d),c.apply(f,[d,$]))}handleAutorunTriggered(f){const c=this.d.get(f);console.log(...this.b([w("autorun"),g(f.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:f._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(f){this.a--}handleBeginTransaction(f){let c=f.getDebugName();c===void 0&&(c=""),console.log(...this.b([w("transaction"),g(c,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=k;function I(a){const f=new Array,c=[];let d="";function $(h){if("length"in h)for(const t of h)t&&$(t);else"text"in h?(d+=`%c${h.text}`,f.push(h.style),h.data&&c.push(...h.data)):"data"in h&&c.push(...h.data)}$(a);const E=[d,...f];return E.push(...c),E}function S(a){return g(a,{color:"black"})}function w(a){return g(u(`${a}: `,10),{color:"black",bold:!0})}function g(a,f={color:"black"}){function c($){return Object.entries($).reduce((E,[h,t])=>`${E}${h}:${t};`,"")}const d={color:f.color};return f.strikeThrough&&(d["text-decoration"]="line-through"),f.bold&&(d["font-weight"]="bold"),{text:a,style:c(d)}}function y(a,f){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=f?`"${a}"`:`"${a.substr(0,f-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?v(a,f):b(a,f);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function v(a,f){let c="[ ",d=!0;for(const $ of a){if(d||(c+=", "),c.length-5>f){c+="...";break}d=!1,c+=`${y($,f-c.length)}`}return c+=" ]",c}function b(a,f){let c="{ ",d=!0;for(const[$,E]of Object.entries(a)){if(d||(c+=", "),c.length-5>f){c+="...";break}d=!1,c+=`${$}: ${y(E,f-c.length)}`}return c+=" }",c}function m(a,f){let c="";for(let d=1;d<=f;d++)c+=a;return c}function u(a,f){for(;a.length<f;)a+=" ";return a}}),define(ye[155],Ee([1,0,147,153,154]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=I,e.$Sd=w,e.$Td=y,e.$Wd=m,e.$Xd=a,e.$Yd=f,e.$Zd=c,e.$2d=$,e.$3d=E,e.$5d=t;let k;function I(r){k=r}let S;function w(r){S=r}let g;function y(r){g=r}class v{get TChange(){return null}reportChanges(){this.get()}read(i){return i?i.readObservable(this):this.get()}map(i,n){const l=n===void 0?void 0:i,p=n===void 0?i:n;return g({owner:l,debugName:()=>{const P=(0,C.$dd)(p);if(P!==void 0)return P;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(p.toString());if(O)return`${this.debugName}.${O[2]}`;if(!l)return`${this.debugName} (mapped)`},debugReferenceFn:p},P=>p(this.read(P),P))}recomputeInitiallyAndOnChange(i,n){return i.add(k(this,n)),this}keepObserved(i){return i.add(S(this)),this}get a(){return this.get()}}e.$Ud=v;class b extends v{constructor(){super(...arguments),this.b=new Set}addObserver(i){const n=this.b.size;this.b.add(i),n===0&&this.c()}removeObserver(i){this.b.delete(i)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=b;function m(r,i){const n=new d(r,i);try{r(n)}finally{n.finish()}}let u;function a(r){if(u)r(u);else{const i=new d(r,void 0);u=i;try{r(i)}finally{i.finish(),u=void 0}}}async function f(r,i){const n=new d(r,i);try{await r(n)}finally{n.finish()}}function c(r,i,n){r?i(r):m(i,n)}class d{constructor(i,n){this._fn=i,this.b=n,this.a=[],(0,D.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$dd)(this._fn)}updateObserver(i,n){this.a.push({observer:i,observable:n}),i.beginUpdate(n)}finish(){const i=this.a;for(let n=0;n<i.length;n++){const{observer:l,observable:p}=i[n];l.endUpdate(p)}this.a=null,(0,D.$Jd)()?.handleEndTransaction()}}e.$1d=d;function $(r,i){let n;return typeof r=="string"?n=new C.$bd(void 0,r,void 0):n=new C.$bd(r,void 0,void 0),new h(n,i,s.$7c)}function E(r,i){return new h(new C.$bd(r.owner,r.debugName,void 0),i,r.equalsFn??s.$7c)}class h extends b{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(i,n,l){super(),this.e=i,this.g=l,this.d=n}get(){return this.d}set(i,n,l){if(this.g(this.d,i))return;let p;n||(n=p=new d(()=>{},()=>`Setting ${this.debugName}`));try{const P=this.d;this.h(i),(0,D.$Jd)()?.handleObservableChanged(this,{oldValue:P,newValue:i,change:l,didChange:!0,hadValue:!0});for(const j of this.b)n.updateObserver(j,this),j.handleChange(this,l)}finally{p&&p.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(i){this.d=i}}e.$4d=h;function t(r,i){let n;return typeof r=="string"?n=new C.$bd(void 0,r,void 0):n=new C.$bd(r,void 0,void 0),new o(n,i,s.$7c)}class o extends h{h(i){this.d!==i&&(this.d&&this.d.dispose(),this.d=i)}dispose(){this.d?.dispose()}}e.$6d=o}),function(){function ue(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function I(w){k.push(w,Date.now())}function S(){const w=[];for(let g=0;g<k.length;g+=2)w.push({name:k[g],startTime:k[g+1]});return w}return{mark:I,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))k.push({name:I.name,startTime:Math.round(D+I.startTime)});return k}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function s(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=s(C))}(),define(ye[3],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=p,e.$D=P,e.$a="en";let s=!1,C=!1,D=!1,k=!1,I=!1,S=!1,w=!1,g=!1,y=!1,v=!1,b,m=e.$a,u=e.$a,a,f;const c=globalThis;let d;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?d=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const $=typeof d?.versions?.electron=="string",E=$&&d?.type==="renderer";if(typeof d=="object"){s=d.platform==="win32",C=d.platform==="darwin",D=d.platform==="linux",k=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,w=$,y=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$a,m=e.$a;const j=d.env.VSCODE_NLS_CONFIG;if(j)try{const O=JSON.parse(j),R=O.availableLanguages["*"];b=O.locale,u=O.osLocale,m=R||e.$a,a=O._translationsConfigFile}catch{}I=!0}else if(typeof navigator=="object"&&!E){f=navigator.userAgent,s=f.indexOf("Windows")>=0,C=f.indexOf("Macintosh")>=0,g=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=f.indexOf("Linux")>=0,v=f?.indexOf("Mobi")>=0,S=!0,b=e.$a,m=b,u=navigator.language;const j=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),O=j&&j.getAttribute("data-settings");if(O)try{const R=JSON.parse(O),A=R.availableLanguages["*"];b=R.locale,u=R.osLocale,m=A||e.$a,a=R._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var h;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(j){switch(j){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let o=0;C?o=1:s?o=3:D&&(o=2),e.$c=s,e.$d=C,e.$e=D,e.$f=k,e.$g=I,e.$h=w,e.$i=S,e.$j=S&&typeof c.importScripts=="function",e.$k=e.$j?c.origin:void 0,e.$l=g,e.$m=v,e.$n=y,e.$o=o,e.$p=f,e.$q=m;var r;(function(j){function O(){return e.$q}j.value=O;function R(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}j.isDefaultVariant=R;function A(){return e.$q==="en"}j.isDefault=A})(r||(e.Language=r={})),e.$r=b,e.$s=u,e.$t=a,e.$u=typeof c.postMessage=="function"&&!c.importScripts,e.$v=(()=>{if(e.$u){const j=[];c.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let A=0,B=j.length;A<B;A++){const G=j[A];if(G.id===R.data.vscodeScheduleAsyncWork){j.splice(A,1),G.callback();return}}});let O=0;return R=>{const A=++O;j.push({id:A,callback:R}),c.postMessage({vscodeScheduleAsyncWork:A},"*")}}return j=>setTimeout(j)})();var i;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=C||g?2:s?1:3;let n=!0,l=!1;function p(){if(!l){l=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,n=new Uint16Array(j.buffer)[0]===513}return n}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function P(j){return parseFloat(j)>=20}}),define(ye[156],Ee([1,0,41]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=void 0;const C=Symbol("unset");class D{constructor(){this.a=new I,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||s.Iterable.empty()}insert(w,g,y){this.d(w,v=>v._value=g,y)}mutate(w,g){this.d(w,y=>y._value=g(y._value===C?void 0:y._value))}delete(w){const g=this.c(w);if(!g)return;let y=g.length-1;const v=g[y].node._value;if(v!==C){for(this.b--,g[y].node._value=C;y>0;y--){const{node:b,part:m}=g[y];if(b.children?.size||b._value!==C)break;g[y-1].node.children.delete(m)}return v}}*deleteRecursive(w){const g=this.c(w);if(!g)return;const y=g[g.length-1].node;for(let v=g.length-1;v>0;v--){const b=g[v-1];if(b.node.children.delete(g[v].part),b.node.children.size>0||b.node._value!==C)break}for(const v of k(y))v._value!==C&&(this.b--,yield v._value)}find(w){let g=this.a;for(const y of w){const v=g.children?.get(y);if(!v)return;g=v}return g._value===C?void 0:g._value}hasKeyOrParent(w){let g=this.a;for(const y of w){const v=g.children?.get(y);if(!v)return!1;if(v._value!==C)return!0;g=v}return!1}hasKeyOrChildren(w){let g=this.a;for(const y of w){const v=g.children?.get(y);if(!v)return!1;g=v}return!0}hasKey(w){let g=this.a;for(const y of w){const v=g.children?.get(y);if(!v)return!1;g=v}return g._value!==C}c(w){const g=[{part:"",node:this.a}];let y=0;for(const v of w){const b=g[y].node.children?.get(v);if(!b)return;g.push({part:v,node:b}),y++}return g}d(w,g,y){let v=this.a;for(const u of w){if(v.children)if(v.children.has(u))v=v.children.get(u);else{const a=new I;v.children.set(u,a),v=a}else{const a=new I;v.children=new Map([[u,a]]),v=a}y?.(v)}const b=v._value===C?0:1;g(v);const m=v._value===C?0:1;this.b+=m-b}*values(){for(const{_value:w}of k(this.a))w!==C&&(yield w)}}e.$mP=D;function*k(S){const w=[S];for(;w.length>0;){const g=w.pop();if(yield g,g.children)for(const y of g.children.values())w.push(y)}}class I{constructor(){this._value=C}get value(){return this._value===C?void 0:this._value}set value(w){this._value=w===void 0?C:w}}}),define(ye[31],Ee([1,0,3]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let C;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const k=D.process;C={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return s.$c?"win32":s.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$ec=C.platform,e.$fc=C.arch}),define(ye[7],Ee([1,0,31]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const C=65,D=97,k=90,I=122,S=46,w=47,g=92,y=58,v=63;class b extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const l=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${l} ${n} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,o){if(t===null||typeof t!="object")throw new b(o,"Object",t)}function u(t,o){if(typeof t!="string")throw new b(o,"string",t)}const a=s.$ec==="win32";function f(t){return t===w||t===g}function c(t){return t===w}function d(t){return t>=C&&t<=k||t>=D&&t<=I}function $(t,o,r,i){let n="",l=0,p=-1,P=0,j=0;for(let O=0;O<=t.length;++O){if(O<t.length)j=t.charCodeAt(O);else{if(i(j))break;j=w}if(i(j)){if(!(p===O-1||P===1))if(P===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const R=n.lastIndexOf(r);R===-1?(n="",l=0):(n=n.slice(0,R),l=n.length-1-n.lastIndexOf(r)),p=O,P=0;continue}else if(n.length!==0){n="",l=0,p=O,P=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",l=2)}else n.length>0?n+=`${r}${t.slice(p+1,O)}`:n=t.slice(p+1,O),l=O-p-1;p=O,P=0}else j===S&&P!==-1?++P:P=-1}return n}function E(t,o){m(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let l;if(n>=0){if(l=t[n],u(l,"path"),l.length===0)continue}else o.length===0?l=s.cwd():(l=s.env[`=${o}`]||s.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===g)&&(l=`${o}\\`));const p=l.length;let P=0,j="",O=!1;const R=l.charCodeAt(0);if(p===1)f(R)&&(P=1,O=!0);else if(f(R))if(O=!0,f(l.charCodeAt(1))){let A=2,B=A;for(;A<p&&!f(l.charCodeAt(A));)A++;if(A<p&&A!==B){const G=l.slice(B,A);for(B=A;A<p&&f(l.charCodeAt(A));)A++;if(A<p&&A!==B){for(B=A;A<p&&!f(l.charCodeAt(A));)A++;(A===p||A!==B)&&(j=`\\\\${G}\\${l.slice(B,A)}`,P=A)}}}else P=1;else d(R)&&l.charCodeAt(1)===y&&(j=l.slice(0,2),P=2,p>2&&f(l.charCodeAt(2))&&(O=!0,P=3));if(j.length>0)if(o.length>0){if(j.toLowerCase()!==o.toLowerCase())continue}else o=j;if(i){if(o.length>0)break}else if(r=`${l.slice(P)}\\${r}`,i=O,O&&o.length>0)break}return r=$(r,!i,"\\",f),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){u(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const l=t.charCodeAt(0);if(o===1)return c(l)?"\\":t;if(f(l))if(n=!0,f(t.charCodeAt(1))){let P=2,j=P;for(;P<o&&!f(t.charCodeAt(P));)P++;if(P<o&&P!==j){const O=t.slice(j,P);for(j=P;P<o&&f(t.charCodeAt(P));)P++;if(P<o&&P!==j){for(j=P;P<o&&!f(t.charCodeAt(P));)P++;if(P===o)return`\\\\${O}\\${t.slice(j)}\\`;P!==j&&(i=`\\\\${O}\\${t.slice(j,P)}`,r=P)}}}else r=1;else d(l)&&t.charCodeAt(1)===y&&(i=t.slice(0,2),r=2,o>2&&f(t.charCodeAt(2))&&(n=!0,r=3));let p=r<o?$(t.slice(r),!n,"\\",f):"";return p.length===0&&!n&&(p="."),p.length>0&&f(t.charCodeAt(o-1))&&(p+="\\"),i===void 0?n?`\\${p}`:p:n?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){u(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return f(r)||o>2&&d(r)&&t.charCodeAt(1)===y&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let l=0;l<t.length;++l){const p=t[l];u(p,"path"),p.length>0&&(o===void 0?o=r=p:o+=`\\${p}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&f(r.charCodeAt(0))){++n;const l=r.length;l>1&&f(r.charCodeAt(1))&&(++n,l>2&&(f(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&f(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$gc.normalize(o)},relative(t,o){if(u(t,"from"),u(o,"to"),t===o)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===g;)n++;let l=t.length;for(;l-1>n&&t.charCodeAt(l-1)===g;)l--;const p=l-n;let P=0;for(;P<o.length&&o.charCodeAt(P)===g;)P++;let j=o.length;for(;j-1>P&&o.charCodeAt(j-1)===g;)j--;const O=j-P,R=p<O?p:O;let A=-1,B=0;for(;B<R;B++){const se=t.charCodeAt(n+B);if(se!==o.charCodeAt(P+B))break;se===g&&(A=B)}if(B!==R){if(A===-1)return i}else{if(O>R){if(o.charCodeAt(P+B)===g)return i.slice(P+B+1);if(B===2)return i.slice(P+B)}p>R&&(t.charCodeAt(n+B)===g?A=B:B===2&&(A=3)),A===-1&&(A=0)}let G="";for(B=n+A+1;B<=l;++B)(B===l||t.charCodeAt(B)===g)&&(G+=G.length===0?"..":"\\..");return P+=A,G.length>0?`${G}${i.slice(P,j)}`:(i.charCodeAt(P)===g&&++P,i.slice(P,j))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const r=o.charCodeAt(2);if(r!==v&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return t},dirname(t){u(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return f(n)?t:".";if(f(n)){if(r=i=1,f(t.charCodeAt(1))){let P=2,j=P;for(;P<o&&!f(t.charCodeAt(P));)P++;if(P<o&&P!==j){for(j=P;P<o&&f(t.charCodeAt(P));)P++;if(P<o&&P!==j){for(j=P;P<o&&!f(t.charCodeAt(P));)P++;if(P===o)return t;P!==j&&(r=i=P+1)}}}}else d(n)&&t.charCodeAt(1)===y&&(r=o>2&&f(t.charCodeAt(2))?3:2,i=r);let l=-1,p=!0;for(let P=o-1;P>=i;--P)if(f(t.charCodeAt(P))){if(!p){l=P;break}}else p=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,o){o!==void 0&&u(o,"ext"),u(t,"path");let r=0,i=-1,n=!0,l;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,P=-1;for(l=t.length-1;l>=r;--l){const j=t.charCodeAt(l);if(f(j)){if(!n){r=l+1;break}}else P===-1&&(n=!1,P=l+1),p>=0&&(j===o.charCodeAt(p)?--p===-1&&(i=l):(p=-1,i=P))}return r===i?i=P:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(f(t.charCodeAt(l))){if(!n){r=l+1;break}}else i===-1&&(n=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){u(t,"path");let o=0,r=-1,i=0,n=-1,l=!0,p=0;t.length>=2&&t.charCodeAt(1)===y&&d(t.charCodeAt(0))&&(o=i=2);for(let P=t.length-1;P>=o;--P){const j=t.charCodeAt(P);if(f(j)){if(!l){i=P+1;break}continue}n===-1&&(l=!1,n=P+1),j===S?r===-1?r=P:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||n===-1||p===0||p===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){u(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return f(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(f(n)){if(i=1,f(t.charCodeAt(1))){let A=2,B=A;for(;A<r&&!f(t.charCodeAt(A));)A++;if(A<r&&A!==B){for(B=A;A<r&&f(t.charCodeAt(A));)A++;if(A<r&&A!==B){for(B=A;A<r&&!f(t.charCodeAt(A));)A++;A===r?i=A:A!==B&&(i=A+1)}}}}else if(d(n)&&t.charCodeAt(1)===y){if(r<=2)return o.root=o.dir=t,o;if(i=2,f(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let l=-1,p=i,P=-1,j=!0,O=t.length-1,R=0;for(;O>=i;--O){if(n=t.charCodeAt(O),f(n)){if(!j){p=O+1;break}continue}P===-1&&(j=!1,P=O+1),n===S?l===-1?l=O:R!==1&&(R=1):l!==-1&&(R=-1)}return P!==-1&&(l===-1||R===0||R===1&&l===P-1&&l===p+1?o.base=o.name=t.slice(p,P):(o.name=t.slice(p,l),o.base=t.slice(p,P),o.ext=t.slice(l,P))),p>0&&p!==i?o.dir=t.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(a){const t=/\\/g;return()=>{const o=s.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>s.cwd()})();e.$hc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:h();u(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===w)}return o=$(o,!r,"/",c),r?`/${o}`:o.length>0?o:"."},normalize(t){if(u(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===w,r=t.charCodeAt(t.length-1)===w;return t=$(t,!o,"/",c),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return u(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];u(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(u(t,"from"),u(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,l=1,p=o.length-l,P=n<p?n:p;let j=-1,O=0;for(;O<P;O++){const A=t.charCodeAt(r+O);if(A!==o.charCodeAt(l+O))break;A===w&&(j=O)}if(O===P)if(p>P){if(o.charCodeAt(l+O)===w)return o.slice(l+O+1);if(O===0)return o.slice(l+O)}else n>P&&(t.charCodeAt(r+O)===w?j=O:O===0&&(j=0));let R="";for(O=r+j+1;O<=i;++O)(O===i||t.charCodeAt(O)===w)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(l+j)}`},toNamespacedPath(t){return t},dirname(t){if(u(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===w;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===w){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&u(o,"ext"),u(t,"path");let r=0,i=-1,n=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,P=-1;for(l=t.length-1;l>=0;--l){const j=t.charCodeAt(l);if(j===w){if(!n){r=l+1;break}}else P===-1&&(n=!1,P=l+1),p>=0&&(j===o.charCodeAt(p)?--p===-1&&(i=l):(p=-1,i=P))}return r===i?i=P:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===w){if(!n){r=l+1;break}}else i===-1&&(n=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){u(t,"path");let o=-1,r=0,i=-1,n=!0,l=0;for(let p=t.length-1;p>=0;--p){const P=t.charCodeAt(p);if(P===w){if(!n){r=p+1;break}continue}i===-1&&(n=!1,i=p+1),P===S?o===-1?o=p:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:E.bind(null,"/"),parse(t){u(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===w;let i;r?(o.root="/",i=1):i=0;let n=-1,l=0,p=-1,P=!0,j=t.length-1,O=0;for(;j>=i;--j){const R=t.charCodeAt(j);if(R===w){if(!P){l=j+1;break}continue}p===-1&&(P=!1,p=j+1),R===S?n===-1?n=j:O!==1&&(O=1):n!==-1&&(O=-1)}if(p!==-1){const R=l===0&&r?1:l;n===-1||O===0||O===1&&n===p-1&&n===l+1?o.base=o.name=t.slice(R,p):(o.name=t.slice(R,n),o.base=t.slice(R,p),o.ext=t.slice(n,p))}return l>0?o.dir=t.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ye[61],Ee([1,0,7]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Ss=k,e.$Ts=I,e.$Us=S,e.$Vs=g,e.$Rs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(y){const v=(0,s.$pc)(y),b=C[v.toLowerCase()];return b!==void 0?b:I(y)}function I(y){const v=(0,s.$pc)(y);return D[v.toLowerCase()]}function S(y){for(const v in D)if(D[v]===y)return v}const w=/^(.+)\/(.+?)(;.+)?$/;function g(y,v){const b=w.exec(y);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:v?void 0:y}}),define(ye[62],Ee([1,0,3]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$nm=k,e.$om=I;var C;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(C||(e.Source=C={}));var D;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function k(S,...w){const g=w.reduce((b,m)=>(b[m]=!0,b),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(S).filter(b=>!g[b]).forEach(b=>{for(let m=0;m<y.length;m++)if(b.search(y[m])!==-1){delete S[b];break}})}function I(S){S&&(delete S.DEBUG,s.$d&&delete S.DYLD_LIBRARY_PATH,s.$e&&delete S.LD_PRELOAD)}}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var C in s)(typeof exports=="object"?exports:ue)[C]=s[C]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function s(C){if(e[C])return e[C].exports;var D=e[C]={i:C,l:!1,exports:{}};return ue[C].call(D.exports,D,D.exports,s),D.l=!0,D.exports}return s.m=ue,s.c=e,s.d=function(C,D,k){s.o(C,D)||Object.defineProperty(C,D,{enumerable:!0,get:k})},s.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},s.t=function(C,D){if(1&D&&(C=s(C)),8&D||4&D&&typeof C=="object"&&C&&C.__esModule)return C;var k=Object.create(null);if(s.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:C}),2&D&&typeof C!="string")for(var I in C)s.d(k,I,function(S){return C[S]}.bind(null,I));return k},s.n=function(C){var D=C&&C.__esModule?function(){return C.default}:function(){return C};return s.d(D,"a",D),D},s.o=function(C,D){return Object.prototype.hasOwnProperty.call(C,D)},s.p="",s(s.s=0)}([function(ue,e,s){(function(C){var D;e=ue.exports=Y,D=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],w=e.src=[],g=0,y=g++;w[y]="0|[1-9]\\d*";var v=g++;w[v]="[0-9]+";var b=g++;w[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=g++;w[m]="("+w[y]+")\\.("+w[y]+")\\.("+w[y]+")";var u=g++;w[u]="("+w[v]+")\\.("+w[v]+")\\.("+w[v]+")";var a=g++;w[a]="(?:"+w[y]+"|"+w[b]+")";var f=g++;w[f]="(?:"+w[v]+"|"+w[b]+")";var c=g++;w[c]="(?:-("+w[a]+"(?:\\."+w[a]+")*))";var d=g++;w[d]="(?:-?("+w[f]+"(?:\\."+w[f]+")*))";var $=g++;w[$]="[0-9A-Za-z-]+";var E=g++;w[E]="(?:\\+("+w[$]+"(?:\\."+w[$]+")*))";var h=g++,t="v?"+w[m]+w[c]+"?"+w[E]+"?";w[h]="^"+t+"$";var o="[v=\\s]*"+w[u]+w[d]+"?"+w[E]+"?",r=g++;w[r]="^"+o+"$";var i=g++;w[i]="((?:<|>)?=?)";var n=g++;w[n]=w[v]+"|x|X|\\*";var l=g++;w[l]=w[y]+"|x|X|\\*";var p=g++;w[p]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[c]+")?"+w[E]+"?)?)?";var P=g++;w[P]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[d]+")?"+w[E]+"?)?)?";var j=g++;w[j]="^"+w[i]+"\\s*"+w[p]+"$";var O=g++;w[O]="^"+w[i]+"\\s*"+w[P]+"$";var R=g++;w[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=g++;w[A]="(?:~>?)";var B=g++;w[B]="(\\s*)"+w[A]+"\\s+",S[B]=new RegExp(w[B],"g");var G=g++;w[G]="^"+w[A]+w[p]+"$";var se=g++;w[se]="^"+w[A]+w[P]+"$";var ce=g++;w[ce]="(?:\\^)";var ee=g++;w[ee]="(\\s*)"+w[ce]+"\\s+",S[ee]=new RegExp(w[ee],"g");var K=g++;w[K]="^"+w[ce]+w[p]+"$";var q=g++;w[q]="^"+w[ce]+w[P]+"$";var X=g++;w[X]="^"+w[i]+"\\s*("+o+")$|^$";var _=g++;w[_]="^"+w[i]+"\\s*("+t+")$|^$";var M=g++;w[M]="(\\s*)"+w[i]+"\\s*("+o+"|"+w[p]+")",S[M]=new RegExp(w[M],"g");var Q=g++;w[Q]="^\\s*("+w[p]+")\\s+-\\s+("+w[p]+")\\s*$";var ae=g++;w[ae]="^\\s*("+w[P]+")\\s+-\\s+("+w[P]+")\\s*$";var ne=g++;w[ne]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)D(we,w[we]),S[we]||(S[we]=new RegExp(w[we]));function ie(ge,Se){if(ge instanceof Y)return ge;if(typeof ge!="string"||ge.length>k||!(Se?S[r]:S[h]).test(ge))return null;try{return new Y(ge,Se)}catch{return null}}function Y(ge,Se){if(ge instanceof Y){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Y))return new Y(ge,Se);D("SemVer",ge,Se),this.loose=Se;var De=ge.trim().match(Se?S[r]:S[h]);if(!De)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+De[1],this.minor=+De[2],this.patch=+De[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");De[4]?this.prerelease=De[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var Le=+Te;if(Le>=0&&Le<I)return Le}return Te}):this.prerelease=[],this.build=De[5]?De[5].split("."):[],this.format()}e.parse=ie,e.valid=function(ge,Se){var De=ie(ge,Se);return De?De.version:null},e.clean=function(ge,Se){var De=ie(ge.trim().replace(/^[=v]+/,""),Se);return De?De.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ge){return D("SemVer.compare",this.version,this.loose,ge),ge instanceof Y||(ge=new Y(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},Y.prototype.compareMain=function(ge){return ge instanceof Y||(ge=new Y(ge,this.loose)),N(this.major,ge.major)||N(this.minor,ge.minor)||N(this.patch,ge.patch)},Y.prototype.comparePre=function(ge){if(ge instanceof Y||(ge=new Y(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var De=this.prerelease[Se],Te=ge.prerelease[Se];if(D("prerelease compare",Se,De,Te),De===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(De===void 0)return-1;if(De!==Te)return N(De,Te)}while(++Se)},Y.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var De=this.prerelease.length;--De>=0;)typeof this.prerelease[De]=="number"&&(this.prerelease[De]++,De=-2);De===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,De,Te){typeof De=="string"&&(Te=De,De=void 0);try{return new Y(ge,De).inc(Se,Te).version}catch{return null}},e.diff=function(ge,Se){if(x(ge,Se))return null;var De=ie(ge),Te=ie(Se);if(De.prerelease.length||Te.prerelease.length){for(var Le in De)if((Le==="major"||Le==="minor"||Le==="patch")&&De[Le]!==Te[Le])return"pre"+Le;return"prerelease"}for(var Le in De)if((Le==="major"||Le==="minor"||Le==="patch")&&De[Le]!==Te[Le])return Le},e.compareIdentifiers=N;var V=/^[0-9]+$/;function N(ge,Se){var De=V.test(ge),Te=V.test(Se);return De&&Te&&(ge=+ge,Se=+Se),De&&!Te?-1:Te&&!De?1:ge<Se?-1:ge>Se?1:0}function z(ge,Se,De){return new Y(ge,De).compare(new Y(Se,De))}function Z(ge,Se,De){return z(ge,Se,De)>0}function he(ge,Se,De){return z(ge,Se,De)<0}function x(ge,Se,De){return z(ge,Se,De)===0}function J(ge,Se,De){return z(ge,Se,De)!==0}function H(ge,Se,De){return z(ge,Se,De)>=0}function L(ge,Se,De){return z(ge,Se,De)<=0}function U(ge,Se,De,Te){var Le;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),Le=ge===De;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),Le=ge!==De;break;case"":case"=":case"==":Le=x(ge,De,Te);break;case"!=":Le=J(ge,De,Te);break;case">":Le=Z(ge,De,Te);break;case">=":Le=H(ge,De,Te);break;case"<":Le=he(ge,De,Te);break;case"<=":Le=L(ge,De,Te);break;default:throw new TypeError("Invalid operator: "+Se)}return Le}function oe(ge,Se){if(ge instanceof oe){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof oe))return new oe(ge,Se);D("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===le?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ge,Se){return N(Se,ge)},e.major=function(ge,Se){return new Y(ge,Se).major},e.minor=function(ge,Se){return new Y(ge,Se).minor},e.patch=function(ge,Se){return new Y(ge,Se).patch},e.compare=z,e.compareLoose=function(ge,Se){return z(ge,Se,!0)},e.rcompare=function(ge,Se,De){return z(Se,ge,De)},e.sort=function(ge,Se){return ge.sort(function(De,Te){return e.compare(De,Te,Se)})},e.rsort=function(ge,Se){return ge.sort(function(De,Te){return e.rcompare(De,Te,Se)})},e.gt=Z,e.lt=he,e.eq=x,e.neq=J,e.gte=H,e.lte=L,e.cmp=U,e.Comparator=oe;var le={};function de(ge,Se){if(ge instanceof de)return ge.loose===Se?ge:new de(ge.raw,Se);if(ge instanceof oe)return new de(ge.value,Se);if(!(this instanceof de))return new de(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(De){return this.parseRange(De.trim())},this).filter(function(De){return De.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function te(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function me(ge,Se,De,Te,Le,Ue,Qe,Ge,Je,Ye,nt,_e,Ze){return((Se=te(De)?"":te(Te)?">="+De+".0.0":te(Le)?">="+De+"."+Te+".0":">="+Se)+" "+(Ge=te(Je)?"":te(Ye)?"<"+(+Je+1)+".0.0":te(nt)?"<"+Je+"."+(+Ye+1)+".0":_e?"<="+Je+"."+Ye+"."+nt+"-"+_e:"<="+Ge)).trim()}function pe(ge,Se){for(var De=0;De<ge.length;De++)if(!ge[De].test(Se))return!1;if(Se.prerelease.length){for(De=0;De<ge.length;De++)if(D(ge[De].semver),ge[De].semver!==le&&ge[De].semver.prerelease.length>0){var Te=ge[De].semver;if(Te.major===Se.major&&Te.minor===Se.minor&&Te.patch===Se.patch)return!0}return!1}return!0}function Ce(ge,Se,De){try{Se=new de(Se,De)}catch{return!1}return Se.test(ge)}function je(ge,Se,De,Te){var Le,Ue,Qe,Ge,Je;switch(ge=new Y(ge,Te),Se=new de(Se,Te),De){case">":Le=Z,Ue=L,Qe=he,Ge=">",Je=">=";break;case"<":Le=he,Ue=H,Qe=Z,Ge="<",Je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(ge,Se,Te))return!1;for(var Ye=0;Ye<Se.set.length;++Ye){var nt=Se.set[Ye],_e=null,Ze=null;if(nt.forEach(function($e){$e.semver===le&&($e=new oe(">=0.0.0")),_e=_e||$e,Ze=Ze||$e,Le($e.semver,_e.semver,Te)?_e=$e:Qe($e.semver,Ze.semver,Te)&&(Ze=$e)}),_e.operator===Ge||_e.operator===Je||(!Ze.operator||Ze.operator===Ge)&&Ue(ge,Ze.semver)||Ze.operator===Je&&Qe(ge,Ze.semver))return!1}return!0}oe.prototype.parse=function(ge){var Se=this.loose?S[X]:S[_],De=ge.match(Se);if(!De)throw new TypeError("Invalid comparator: "+ge);this.operator=De[1],this.operator==="="&&(this.operator=""),De[2]?this.semver=new Y(De[2],this.loose):this.semver=le},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(ge){return D("Comparator.test",ge,this.loose),this.semver===le||(typeof ge=="string"&&(ge=new Y(ge,this.loose)),U(ge,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(ge,Se){if(!(ge instanceof oe))throw new TypeError("a Comparator is required");var De;if(this.operator==="")return De=new de(ge.value,Se),Ce(this.value,De,Se);if(ge.operator==="")return De=new de(this.value,Se),Ce(ge.semver,De,Se);var Te=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Le=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),Ue=this.semver.version===ge.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Ge=U(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Je=U(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Te||Le||Ue&&Qe||Ge||Je},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),D("range",ge,Se);var De=Se?S[ae]:S[Q];ge=ge.replace(De,me),D("hyphen replace",ge),ge=ge.replace(S[M],"$1$2$3"),D("comparator trim",ge,S[M]),ge=(ge=(ge=ge.replace(S[B],"$1~")).replace(S[ee],"$1^")).split(/\s+/).join(" ");var Te=Se?S[X]:S[_],Le=ge.split(" ").map(function(Ue){return function(Qe,Ge){return D("comp",Qe),Qe=function(Je,Ye){return Je.trim().split(/\s+/).map(function(nt){return function(_e,Ze){D("caret",_e,Ze);var $e=Ze?S[q]:S[K];return _e.replace($e,function(Ie,Ae,Re,Me,Ve){var He;return D("caret",_e,Ie,Ae,Re,Me,Ve),te(Ae)?He="":te(Re)?He=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":te(Me)?He=Ae==="0"?">="+Ae+"."+Re+".0 <"+Ae+"."+(+Re+1)+".0":">="+Ae+"."+Re+".0 <"+(+Ae+1)+".0.0":Ve?(D("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),He=Ae==="0"?Re==="0"?">="+Ae+"."+Re+"."+Me+Ve+" <"+Ae+"."+Re+"."+(+Me+1):">="+Ae+"."+Re+"."+Me+Ve+" <"+Ae+"."+(+Re+1)+".0":">="+Ae+"."+Re+"."+Me+Ve+" <"+(+Ae+1)+".0.0"):(D("no pr"),He=Ae==="0"?Re==="0"?">="+Ae+"."+Re+"."+Me+" <"+Ae+"."+Re+"."+(+Me+1):">="+Ae+"."+Re+"."+Me+" <"+Ae+"."+(+Re+1)+".0":">="+Ae+"."+Re+"."+Me+" <"+(+Ae+1)+".0.0"),D("caret return",He),He})}(nt,Ye)}).join(" ")}(Qe,Ge),D("caret",Qe),Qe=function(Je,Ye){return Je.trim().split(/\s+/).map(function(nt){return function(_e,Ze){var $e=Ze?S[se]:S[G];return _e.replace($e,function(Ie,Ae,Re,Me,Ve){var He;return D("tilde",_e,Ie,Ae,Re,Me,Ve),te(Ae)?He="":te(Re)?He=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":te(Me)?He=">="+Ae+"."+Re+".0 <"+Ae+"."+(+Re+1)+".0":Ve?(D("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),He=">="+Ae+"."+Re+"."+Me+Ve+" <"+Ae+"."+(+Re+1)+".0"):He=">="+Ae+"."+Re+"."+Me+" <"+Ae+"."+(+Re+1)+".0",D("tilde return",He),He})}(nt,Ye)}).join(" ")}(Qe,Ge),D("tildes",Qe),Qe=function(Je,Ye){return D("replaceXRanges",Je,Ye),Je.split(/\s+/).map(function(nt){return function(_e,Ze){_e=_e.trim();var $e=Ze?S[O]:S[j];return _e.replace($e,function(Ie,Ae,Re,Me,Ve,He){D("xRange",_e,Ie,Ae,Re,Me,Ve,He);var st=te(Re),rt=st||te(Me),xe=rt||te(Ve);return Ae==="="&&xe&&(Ae=""),st?Ie=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&xe?(rt&&(Me=0),xe&&(Ve=0),Ae===">"?(Ae=">=",rt?(Re=+Re+1,Me=0,Ve=0):xe&&(Me=+Me+1,Ve=0)):Ae==="<="&&(Ae="<",rt?Re=+Re+1:Me=+Me+1),Ie=Ae+Re+"."+Me+"."+Ve):rt?Ie=">="+Re+".0.0 <"+(+Re+1)+".0.0":xe&&(Ie=">="+Re+"."+Me+".0 <"+Re+"."+(+Me+1)+".0"),D("xRange return",Ie),Ie})}(nt,Ye)}).join(" ")}(Qe,Ge),D("xrange",Qe),Qe=function(Je,Ye){return D("replaceStars",Je,Ye),Je.trim().replace(S[ne],"")}(Qe,Ge),D("stars",Qe),Qe}(Ue,Se)}).join(" ").split(/\s+/);return this.loose&&(Le=Le.filter(function(Ue){return!!Ue.match(Te)})),Le=Le.map(function(Ue){return new oe(Ue,Se)})},de.prototype.intersects=function(ge,Se){if(!(ge instanceof de))throw new TypeError("a Range is required");return this.set.some(function(De){return De.every(function(Te){return ge.set.some(function(Le){return Le.every(function(Ue){return Te.intersects(Ue,Se)})})})})},e.toComparators=function(ge,Se){return new de(ge,Se).set.map(function(De){return De.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new Y(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(pe(this.set[Se],ge))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(ge,Se,De){var Te=null,Le=null;try{var Ue=new de(Se,De)}catch{return null}return ge.forEach(function(Qe){Ue.test(Qe)&&(Te&&Le.compare(Qe)!==-1||(Le=new Y(Te=Qe,De)))}),Te},e.minSatisfying=function(ge,Se,De){var Te=null,Le=null;try{var Ue=new de(Se,De)}catch{return null}return ge.forEach(function(Qe){Ue.test(Qe)&&(Te&&Le.compare(Qe)!==1||(Le=new Y(Te=Qe,De)))}),Te},e.validRange=function(ge,Se){try{return new de(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,De){return je(ge,Se,"<",De)},e.gtr=function(ge,Se,De){return je(ge,Se,">",De)},e.outside=je,e.prerelease=function(ge,Se){var De=ie(ge,Se);return De&&De.prerelease.length?De.prerelease:null},e.intersects=function(ge,Se,De){return ge=new de(ge,De),Se=new de(Se,De),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof Y)return ge;if(typeof ge!="string")return null;var Se=ge.match(S[R]);return Se==null?null:ie((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,s(1))},function(ue,e){var s,C,D=ue.exports={};function k(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function S(f){if(s===setTimeout)return setTimeout(f,0);if((s===k||!s)&&setTimeout)return s=setTimeout,setTimeout(f,0);try{return s(f,0)}catch{try{return s.call(null,f,0)}catch{return s.call(this,f,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:k}catch{s=k}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var w,g=[],y=!1,v=-1;function b(){y&&w&&(y=!1,w.length?g=w.concat(g):v=-1,g.length&&m())}function m(){if(!y){var f=S(b);y=!0;for(var c=g.length;c;){for(w=g,g=[];++v<c;)w&&w[v].run();v=-1,c=g.length}w=null,y=!1,function(d){if(C===clearTimeout)return clearTimeout(d);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(d);try{C(d)}catch{try{return C.call(null,d)}catch{return C.call(this,d)}}}(f)}}function u(f,c){this.fun=f,this.array=c}function a(){}D.nextTick=function(f){var c=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)c[d-1]=arguments[d];g.push(new u(f,c)),g.length!==1||y||S(m)},u.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=a,D.addListener=a,D.once=a,D.off=a,D.removeListener=a,D.removeAllListeners=a,D.emit=a,D.prependListener=a,D.prependOnceListener=a,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ye[157],Ee([1,0]),function(ue,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class C{constructor(S,w,g){this.level=S,this.key=w,this.value=g,this.forward=[]}}const D=void 0;class k{constructor(S,w=2**16){this.comparator=S,this[s]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new C(this.c,D,D)}get size(){return this.f}clear(){this.e=new C(this.c,D,D),this.f=0}has(S){return!!k.g(this,S,this.comparator)}get(S){return k.g(this,S,this.comparator)?.value}set(S,w){return k.h(this,S,w,this.comparator)&&(this.f+=1),this}delete(S){const w=k.k(this,S,this.comparator);return w&&(this.f-=1),w}forEach(S,w){let g=this.e.forward[0];for(;g;)S.call(w,g.value,g.key,this),g=g.forward[0]}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",w=this.e.forward[0];for(;w;)S+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return S}static g(S,w,g){let y=S.e;for(let v=S.d-1;v>=0;v--)for(;y.forward[v]&&g(y.forward[v].key,w)<0;)y=y.forward[v];if(y=y.forward[0],y&&g(y.key,w)===0)return y}static h(S,w,g,y){const v=[];let b=S.e;for(let m=S.d-1;m>=0;m--){for(;b.forward[m]&&y(b.forward[m].key,w)<0;)b=b.forward[m];v[m]=b}if(b=b.forward[0],b&&y(b.key,w)===0)return b.value=g,!1;{const m=k.j(S);if(m>S.d){for(let u=S.d;u<m;u++)v[u]=S.e;S.d=m}b=new C(m,w,g);for(let u=0;u<m;u++)b.forward[u]=v[u].forward[u],v[u].forward[u]=b;return!0}}static j(S,w=.5){let g=1;for(;Math.random()<w&&g<S.c;)g+=1;return g}static k(S,w,g){const y=[];let v=S.e;for(let b=S.d-1;b>=0;b--){for(;v.forward[b]&&g(v.forward[b].key,w)<0;)v=v.forward[b];y[b]=v}if(v=v.forward[0],!v||g(v.key,w)!==0)return!1;for(let b=0;b<S.d&&y[b].forward[b]===v;b++)y[b].forward[b]=v.forward[b];for(;S.d>0&&S.e.forward[S.d-1]===D;)S.d-=1;return!0}}e.$As=k}),define(ye[63],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(k){return new C(k)}constructor(k){this.c=s&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=C}),define(ye[6],Ee([1,0,11,75,2,99,63]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=m;const S=!1,w=!1,g=!1;var y;(function(B){B.None=()=>D.$Vc.None;function G(de){if(g){const{onDidAddListener:te}=de,me=a.create();let pe=0;de.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),te?.()}}}function se(de,te){return ne(de,()=>{},0,void 0,!0,void 0,te)}B.defer=se;function ce(de){return(te,me=null,pe)=>{let Ce=!1,je;return je=de(ge=>{if(!Ce)return je?je.dispose():Ce=!0,te.call(me,ge)},null,pe),Ce&&je.dispose(),je}}B.once=ce;function ee(de,te,me){return Q((pe,Ce=null,je)=>de(ge=>pe.call(Ce,te(ge)),null,je),me)}B.map=ee;function K(de,te,me){return Q((pe,Ce=null,je)=>de(ge=>{te(ge),pe.call(Ce,ge)},null,je),me)}B.forEach=K;function q(de,te,me){return Q((pe,Ce=null,je)=>de(ge=>te(ge)&&pe.call(Ce,ge),null,je),me)}B.filter=q;function X(de){return de}B.signal=X;function _(...de){return(te,me=null,pe)=>{const Ce=(0,D.$Sc)(...de.map(je=>je(ge=>te.call(me,ge))));return ae(Ce,pe)}}B.any=_;function M(de,te,me,pe){let Ce=me;return ee(de,je=>(Ce=te(Ce,je),Ce),pe)}B.reduce=M;function Q(de,te){let me;const pe={onWillAddFirstListener(){me=de(Ce.fire,Ce)},onDidRemoveLastListener(){me?.dispose()}};te||G(pe);const Ce=new h(pe);return te?.add(Ce),Ce.event}function ae(de,te){return te instanceof Array?te.push(de):te&&te.add(de),de}function ne(de,te,me=100,pe=!1,Ce=!1,je,ge){let Se,De,Te,Le=0,Ue;const Qe={leakWarningThreshold:je,onWillAddFirstListener(){Se=de(Je=>{Le++,De=te(De,Je),pe&&!Te&&(Ge.fire(De),De=void 0),Ue=()=>{const Ye=De;De=void 0,Te=void 0,(!pe||Le>1)&&Ge.fire(Ye),Le=0},typeof me=="number"?(clearTimeout(Te),Te=setTimeout(Ue,me)):Te===void 0&&(Te=0,queueMicrotask(Ue))})},onWillRemoveListener(){Ce&&Le>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,Se.dispose()}};ge||G(Qe);const Ge=new h(Qe);return ge?.add(Ge),Ge.event}B.debounce=ne;function we(de,te=0,me){return B.debounce(de,(pe,Ce)=>pe?(pe.push(Ce),pe):[Ce],te,void 0,!0,void 0,me)}B.accumulate=we;function ie(de,te=(pe,Ce)=>pe===Ce,me){let pe=!0,Ce;return q(de,je=>{const ge=pe||!te(je,Ce);return pe=!1,Ce=je,ge},me)}B.latch=ie;function Y(de,te,me){return[B.filter(de,te,me),B.filter(de,pe=>!te(pe),me)]}B.split=Y;function V(de,te=!1,me=[],pe){let Ce=me.slice(),je=de(De=>{Ce?Ce.push(De):Se.fire(De)});pe&&pe.add(je);const ge=()=>{Ce?.forEach(De=>Se.fire(De)),Ce=null},Se=new h({onWillAddFirstListener(){je||(je=de(De=>Se.fire(De)),pe&&pe.add(je))},onDidAddFirstListener(){Ce&&(te?setTimeout(ge):ge())},onDidRemoveLastListener(){je&&je.dispose(),je=null}});return pe&&pe.add(Se),Se.event}B.buffer=V;function N(de,te){return(pe,Ce,je)=>{const ge=te(new Z);return de(function(Se){const De=ge.evaluate(Se);De!==z&&pe.call(Ce,De)},void 0,je)}}B.chain=N;const z=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(me=>(te(me),me)),this}filter(te){return this.f.push(me=>te(me)?me:z),this}reduce(te,me){let pe=me;return this.f.push(Ce=>(pe=te(pe,Ce),pe)),this}latch(te=(me,pe)=>me===pe){let me=!0,pe;return this.f.push(Ce=>{const je=me||!te(Ce,pe);return me=!1,pe=Ce,je?Ce:z}),this}evaluate(te){for(const me of this.f)if(te=me(te),te===z)break;return te}}function he(de,te,me=pe=>pe){const pe=(...Se)=>ge.fire(me(...Se)),Ce=()=>de.on(te,pe),je=()=>de.removeListener(te,pe),ge=new h({onWillAddFirstListener:Ce,onDidRemoveLastListener:je});return ge.event}B.fromNodeEventEmitter=he;function x(de,te,me=pe=>pe){const pe=(...Se)=>ge.fire(me(...Se)),Ce=()=>de.addEventListener(te,pe),je=()=>de.removeEventListener(te,pe),ge=new h({onWillAddFirstListener:Ce,onDidRemoveLastListener:je});return ge.event}B.fromDOMEventEmitter=x;function J(de){return new Promise(te=>ce(de)(te))}B.toPromise=J;function H(de){const te=new h;return de.then(me=>{te.fire(me)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}B.fromPromise=H;function L(de,te,me){return te(me),de(pe=>te(pe))}B.runAndSubscribe=L;class U{constructor(te,me){this._observable=te,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};me||G(pe),this.emitter=new h(pe),me&&me.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,me){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(de,te){return new U(de,te).emitter.event}B.fromObservable=oe;function le(de){return(te,me,pe)=>{let Ce=0,je=!1;const ge={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(de.reportChanges(),je&&(je=!1,te.call(me)))},handlePossibleChange(){},handleChange(){je=!0}};de.addObserver(ge),de.reportChanges();const Se={dispose(){de.removeObserver(ge)}};return pe instanceof D.$Uc?pe.add(Se):Array.isArray(pe)&&pe.push(Se),Se}}B.fromObservableLight=le})(y||(e.Event=y={}));class v{constructor(G){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${G}_${v.f++}`,v.all.add(this)}start(G){this.g=new I.$ae,this.listenerCount=G}stop(){if(this.g){const G=this.g.elapsed();this.durations.push(G),this.elapsedOverall+=G,this.invocationCount+=1,this.g=void 0}}}e.$ce=v,v.all=new Set,v.f=0;let b=-1;function m(B){const G=b;return b=B,{dispose(){b=G}}}class u{constructor(G,se=Math.random().toString(18).slice(2,5)){this.threshold=G,this.name=se,this.g=0}dispose(){this.f?.clear()}check(G,se){const ce=this.threshold;if(ce<=0||se<ce)return;this.f||(this.f=new Map);const ee=this.f.get(G.value)||0;if(this.f.set(G.value,ee+1),this.g-=1,this.g<=0){this.g=ce*.5;let K,q=0;for(const[X,_]of this.f)(!K||q<_)&&(K=X,q=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${q}):`),console.warn(K)}return()=>{const K=this.f.get(G.value)||0;this.f.set(G.value,K-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(G){this.value=G}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class c{constructor(G){this.value=G,this.id=f++}}const d=2,$=(B,G)=>{if(B instanceof c)G(B);else for(let se=0;se<B.length;se++){const ce=B[se];ce&&G(ce)}},E=S?new FinalizationRegistry(B=>{typeof B=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(B))}):void 0;class h{constructor(G){this.w=0,this.f=G,this.g=b>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const G=this.t;queueMicrotask(()=>{$(G,se=>se.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(G,se,ce)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.$Vc.None;if(this.m)return D.$Vc.None;se&&(G=G.bind(se));const ee=new c(G);let K,q;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=a.create(),K=this.g.check(ee.stack,this.w+1)),w&&(ee.stack=q??a.create()),this.t?this.t instanceof c?(this.u??(this.u=new o),this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,D.$Tc)(()=>{E?.unregister(X),K?.(),this.x(ee)});if(ce instanceof D.$Uc?ce.add(X):Array.isArray(ce)&&ce.push(X),E){const _=new Error().stack.split(`
`).slice(2).join(`
`).trim();E.register(X,_,X)}return X}),this.q}x(G){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const se=this.t,ce=se.indexOf(G);if(ce===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,se[ce]=void 0;const ee=this.u.current===this;if(this.w*d<=se.length){let K=0;for(let q=0;q<se.length;q++)se[q]?se[K++]=se[q]:ee&&(this.u.end--,K<this.u.i&&this.u.i--);se.length=K}}y(G,se){if(!G)return;const ce=this.f?.onListenerError||s.$1;if(!ce){G.value(se);return}try{G.value(se)}catch(ee){ce(ee)}}z(G){const se=G.current.t;for(;G.i<G.end;)this.y(se[G.i++],G.value);G.reset()}fire(G){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,G);else{const se=this.u;se.enqueue(this,G,this.t.length),this.z(se)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=h;const t=()=>new o;e.$fe=t;class o{constructor(){this.i=-1,this.end=0}enqueue(G,se,ce){this.i=0,this.end=ce,this.current=G,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends h{async fireAsync(G,se,ce){if(this.t)for(this.h||(this.h=new k.$6c),$(this.t,ee=>this.h.push([ee.value,G]));this.h.size>0&&!se.isCancellationRequested;){const[ee,K]=this.h.shift(),q=[],X={...K,token:se,waitUntil:_=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");ce&&(_=ce(_,ee)),q.push(_)}};try{ee(X)}catch(_){(0,s.$1)(_);continue}Object.freeze(q),await Promise.allSettled(q).then(_=>{for(const M of _)M.status==="rejected"&&(0,s.$1)(M.reason)})}}}e.$ge=r;class i extends h{get isPaused(){return this.h!==0}constructor(G){super(G),this.h=0,this.s=new k.$6c,this.A=G?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const G=Array.from(this.s);this.s.clear(),super.fire(this.A(G))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(G){this.w&&(this.h!==0?this.s.push(G):super.fire(G))}}e.$he=i;class n extends i{constructor(G){super(G),this.k=G.delay??100}fire(G){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(G)}}e.$ie=n;class l extends h{constructor(G){super(G),this.h=[],this.k=G?.merge}fire(G){this.hasListeners()&&(this.h.push(G),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$je=l;class p{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(G){const se={event:G,listener:null};this.h.push(se),this.g&&this.m(se);const ce=()=>{this.g&&this.o(se);const ee=this.h.indexOf(se);this.h.splice(ee,1)};return(0,D.$Tc)((0,C.$db)(ce))}j(){this.g=!0,this.h.forEach(G=>this.m(G))}k(){this.g=!1,this.h.forEach(G=>this.o(G))}m(G){G.listener=G.event(se=>this.f.fire(se))}o(G){G.listener?.dispose(),G.listener=null}dispose(){this.f.dispose();for(const G of this.h)G.listener?.dispose();this.h=[]}}e.$ke=p;class P{constructor(G,se,ce,ee){this.f=new D.$Uc;const K=this.f.add(new p),q=this.f.add(new D.$5c);function X(_){q.set(_,K.add(ee(_)))}for(const _ of G)X(_);this.f.add(se(_=>{X(_)})),this.f.add(ce(_=>{q.deleteAndDispose(_)})),this.event=K.event}dispose(){this.f.dispose()}}e.$le=P;class j{constructor(){this.f=[]}wrapEvent(G){return(se,ce,ee)=>G(K=>{const q=this.f[this.f.length-1];q?q.push(()=>se.call(ce,K)):se.call(ce,K)},void 0,ee)}bufferEvents(G){const se=[];this.f.push(se);const ce=G();return this.f.pop(),se.forEach(ee=>ee()),ce}}e.$me=j;class O{constructor(){this.f=!1,this.g=y.None,this.h=D.$Vc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(G){this.g=G,this.f&&(this.h.dispose(),this.h=G(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=O;class R{static const(G){return new A(G)}constructor(G){this.g=G,this.f=new h,this.onDidChange=this.f.event}get value(){return this.g}set value(G){G!==this.g&&(this.g=G,this.f.fire(void 0))}}e.$oe=R;class A{constructor(G){this.value=G,this.onDidChange=y.None}}}),define(ye[20],Ee([1,0,6]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=S;const C=Object.freeze(function(w,g){const y=setTimeout(w.bind(g),0);return{dispose(){clearTimeout(y)}}});var D;(function(w){function g(y){return y===w.None||y===w.Cancelled||y instanceof k?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}w.isCancellationToken=g,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(D||(e.CancellationToken=D={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new s.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=D.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=D.None}}e.$pe=I;function S(w){const g=new I;return w.add({dispose(){g.cancel()}}),g.token}}),define(ye[158],Ee([1,0,20]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=D;class C{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new s.$pe,g=this.b(w.token);return this.a={promise:g,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$2e=C;function D(S){return S}class k{constructor(w,g){this.a=void 0,this.b=void 0,typeof w=="function"?(this.c=w,this.d=D):(this.c=g,this.d=w.getCacheKey)}get(w){const g=this.d(w);return this.b!==g&&(this.b=g,this.a=this.c(w)),this.a}}e.$4e=k;class I{get cachedValues(){return this.a}constructor(w,g){this.a=new Map,this.b=new Map,typeof w=="function"?(this.c=w,this.d=D):(this.c=g,this.d=w.getCacheKey)}get(w){const g=this.d(w);if(this.b.has(g))return this.b.get(g);const y=this.c(w);return this.a.set(w,y),this.b.set(g,y),y}}e.$5e=I}),define(ye[52],Ee([1,0,11,2]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=D,e.$se=k,e.$te=I,e.$ue=S,e.$ve=g,e.$we=y,e.$xe=v,e.$ye=b,e.$ze=m,e.$Ae=u,e.$Be=a,e.$Ce=f,e.$De=c,e.$Ee=d,e.$Fe=$;function D(E){const h=E;return h?typeof h.read=="function":!1}function k(E){const h=E;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function I(E){const h=E;return h?k(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function S(E,h){return new w(E,h)}class w{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,s.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let o;switch(h){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,h){const t=[];let o;for(;(o=E.read())!==null;)t.push(o);return h(t)}function y(E,h,t){const o=[];let r;for(;(r=E.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?h(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}function v(E,h){return new Promise((t,o)=>{const r=[];b(E,{onData:i=>{h&&r.push(i)},onError:i=>{h?o(i):t(void 0)},onEnd:()=>{t(h?h(r):void 0)}})})}function b(E,h,t){E.on("error",o=>{t?.isCancellationRequested||h.onError(o)}),E.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),E.on("data",o=>{t?.isCancellationRequested||h.onData(o)})}function m(E,h){return new Promise((t,o)=>{const r=new C.$Uc,i=[],n=P=>{if(i.push(P),i.length>h)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},l=P=>(r.dispose(),o(P)),p=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,C.$Tc)(()=>E.removeListener("error",l))),E.on("error",l),r.add((0,C.$Tc)(()=>E.removeListener("end",p))),E.on("end",p),r.add((0,C.$Tc)(()=>E.removeListener("data",n))),E.on("data",n)})}function u(E,h){const t=S(h);return t.end(E),t}function a(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}function f(E){let h=!1;return{read:()=>h?null:(h=!0,E)}}function c(E,h,t){const o=S(t);return b(E,{onData:r=>o.write(h.data(r)),onError:r=>o.error(h.error?h.error(r):r),onEnd:()=>o.end()}),o}function d(E,h,t){let o=!1;return{read:()=>{const r=h.read();return o?r:(o=!0,r!==null?t([E,r]):E)}}}function $(E,h,t){let o=!1;const r=S(t);return b(h,{onData:i=>o?r.write(i):(o=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}}),define(ye[15],Ee([1,0,60,52]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=g,e.$Ie=y,e.$Je=v,e.$Ke=b,e.$Le=m,e.$Me=u,e.$Ne=a,e.$Oe=f,e.$Pe=c,e.$Qe=d,e.$Re=$,e.$Se=E,e.$Te=h,e.$Ue=t,e.$Ve=o,e.$We=r,e.$Xe=i,e.$Ye=n,e.$Ze=l,e.$1e=j;const D=typeof Buffer<"u",k=new s.$V(()=>new Uint8Array(256));let I,S;class w{static alloc(R){return D?new w(Buffer.allocUnsafe(R)):new w(new Uint8Array(R))}static wrap(R){return D&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new w(R)}static fromString(R,A){return!(A?.dontUseNodeBuffer||!1)&&D?new w(Buffer.from(R)):(I||(I=new TextEncoder),new w(I.encode(R)))}static fromByteArray(R){const A=w.alloc(R.length);for(let B=0,G=R.length;B<G;B++)A.buffer[B]=R[B];return A}static concat(R,A){if(typeof A>"u"){A=0;for(let se=0,ce=R.length;se<ce;se++)A+=R[se].byteLength}const B=w.alloc(A);let G=0;for(let se=0,ce=R.length;se<ce;se++){const ee=R[se];B.set(ee,G),G+=ee.byteLength}return B}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=w.alloc(this.byteLength);return R.set(this),R}toString(){return D?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(R,A){return new w(this.buffer.subarray(R,A))}set(R,A){if(R instanceof w)this.buffer.set(R.buffer,A);else if(R instanceof Uint8Array)this.buffer.set(R,A);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),A);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return b(this.buffer,R)}writeUInt32BE(R,A){m(this.buffer,R,A)}readUInt32LE(R){return u(this.buffer,R)}writeUInt32LE(R,A){a(this.buffer,R,A)}readUInt8(R){return f(this.buffer,R)}writeUInt8(R,A){c(this.buffer,R,A)}indexOf(R,A=0){return g(this.buffer,R instanceof w?R.buffer:R,A)}}e.$Ge=w;function g(O,R,A=0){const B=R.byteLength,G=O.byteLength;if(B===0)return 0;if(B===1)return O.indexOf(R[0]);if(B>G-A)return-1;const se=k.value;se.fill(R.length);for(let q=0;q<R.length;q++)se[R[q]]=R.length-q-1;let ce=A+R.length-1,ee=ce,K=-1;for(;ce<G;)if(O[ce]===R[ee]){if(ee===0){K=ce;break}ce--,ee--}else ce+=Math.max(R.length-ee,se[O[ce]]),ee=R.length-1;return K}function y(O,R){return O[R+0]<<0>>>0|O[R+1]<<8>>>0}function v(O,R,A){O[A+0]=R&255,R=R>>>8,O[A+1]=R&255}function b(O,R){return O[R]*2**24+O[R+1]*2**16+O[R+2]*2**8+O[R+3]}function m(O,R,A){O[A+3]=R,R=R>>>8,O[A+2]=R,R=R>>>8,O[A+1]=R,R=R>>>8,O[A]=R}function u(O,R){return O[R+0]<<0>>>0|O[R+1]<<8>>>0|O[R+2]<<16>>>0|O[R+3]<<24>>>0}function a(O,R,A){O[A+0]=R&255,R=R>>>8,O[A+1]=R&255,R=R>>>8,O[A+2]=R&255,R=R>>>8,O[A+3]=R&255}function f(O,R){return O[R]}function c(O,R,A){O[A]=R}function d(O){return C.$ve(O,R=>w.concat(R))}function $(O){return C.$Ce(O)}function E(O){return C.$xe(O,R=>w.concat(R))}async function h(O){return O.ended?w.concat(O.buffer):w.concat([...O.buffer,await E(O.stream)])}function t(O){return C.$Ae(O,R=>w.concat(R))}function o(O){return C.$De(O,{data:R=>typeof R=="string"?w.fromString(R):w.wrap(R)},R=>w.concat(R))}function r(O){return C.$ue(R=>w.concat(R),O)}function i(O,R){return C.$Ee(O,R,A=>w.concat(A))}function n(O,R){return C.$Fe(O,R,A=>w.concat(A))}function l(O){let R=0,A=0,B=0;const G=new Uint8Array(Math.floor(O.length/4*3)),se=ee=>{switch(A){case 3:G[B++]=R|ee,A=0;break;case 2:G[B++]=R|ee>>>2,R=ee<<6,A=3;break;case 1:G[B++]=R|ee>>>4,R=ee<<4,A=2;break;default:R=ee<<2,A=1}};for(let ee=0;ee<O.length;ee++){const K=O.charCodeAt(ee);if(K>=65&&K<=90)se(K-65);else if(K>=97&&K<=122)se(K-97+26);else if(K>=48&&K<=57)se(K-48+52);else if(K===43||K===45)se(62);else if(K===47||K===95)se(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${O[ee]}`)}}const ce=B;for(;A>0;)se(0);return w.wrap(G).slice(0,ce)}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:O},R=!0,A=!1){const B=A?P:p;let G="";const se=O.byteLength%3;let ce=0;for(;ce<O.byteLength-se;ce+=3){const ee=O[ce+0],K=O[ce+1],q=O[ce+2];G+=B[ee>>>2],G+=B[(ee<<4|K>>>4)&63],G+=B[(K<<2|q>>>6)&63],G+=B[q&63]}if(se===1){const ee=O[ce+0];G+=B[ee>>>2],G+=B[ee<<4&63],R&&(G+="==")}else if(se===2){const ee=O[ce+0],K=O[ce+1];G+=B[ee>>>2],G+=B[(ee<<4|K>>>4)&63],G+=B[K<<2&63],R&&(G+="=")}return G}}),define(ye[17],Ee([1,0,158,60]),function(ue,e,s,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=k,e.$9e=S,e.$0e=g,e.$$e=y,e.$_e=v,e.$af=b,e.$bf=m,e.$cf=u,e.$df=a,e.$ef=f,e.$ff=c,e.$gf=d,e.$hf=$,e.$if=E,e.$jf=h,e.$kf=t,e.$lf=o,e.$mf=r,e.$nf=i,e.$of=n,e.$pf=l,e.$qf=p,e.$rf=P,e.$sf=j,e.$tf=O,e.$uf=R,e.$vf=A,e.$wf=B,e.$xf=G,e.$yf=se,e.$zf=ce,e.$Af=ee,e.$Bf=K,e.$Cf=q,e.$Df=X,e.$Ef=_,e.$Ff=M,e.$If=we,e.$Jf=ie,e.$Kf=Y,e.$Lf=V,e.$Mf=Z,e.$Nf=x,e.$Pf=J,e.$Qf=H,e.$Rf=L,e.$Sf=U,e.$Tf=le,e.$Uf=de,e.$Wf=te,e.$Xf=me,e.$Yf=pe,e.$Zf=Ce,e.$1f=je,e.$2f=ge,e.$3f=Se,e.$4f=De,e.$5f=Ge;function k($e){return!$e||typeof $e!="string"?!0:$e.trim().length===0}const I=/{(\d+)}/g;function S($e,...Ie){return Ie.length===0?$e:$e.replace(I,function(Ae,Re){const Me=parseInt(Re,10);return isNaN(Me)||Me<0||Me>=Ie.length?Ae:Ie[Me]})}const w=/{([^}]+)}/g;function g($e,Ie){return Object.keys(Ie).length===0?$e:$e.replace(w,(Ae,Re)=>Ie[Re]??Ae)}function y($e){return $e.replace(/[<>"'&]/g,Ie=>{switch(Ie){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ie})}function v($e){return $e.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}function b($e){return $e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m($e,Ie){let Ae=0;const Re=Ie.charCodeAt(0);for(let Me=$e.length-1;Me>=0;Me--)$e.charCodeAt(Me)===Re&&Ae++;return Ae}function u($e,Ie,Ae="\u2026"){return $e.length<=Ie?$e:`${$e.substr(0,Ie)}${Ae}`}function a($e,Ie,Ae="\u2026"){if($e.length<=Ie)return $e;const Re=Math.ceil(Ie/2)-Ae.length/2,Me=Math.floor(Ie/2)-Ae.length/2;return`${$e.substr(0,Re)}${Ae}${$e.substr($e.length-Me)}`}function f($e,Ie=" "){const Ae=c($e,Ie);return d(Ae,Ie)}function c($e,Ie){if(!$e||!Ie)return $e;const Ae=Ie.length;if(Ae===0||$e.length===0)return $e;let Re=0;for(;$e.indexOf(Ie,Re)===Re;)Re=Re+Ae;return $e.substring(Re)}function d($e,Ie){if(!$e||!Ie)return $e;const Ae=Ie.length,Re=$e.length;if(Ae===0||Re===0)return $e;let Me=Re,Ve=-1;for(;Ve=$e.lastIndexOf(Ie,Me-1),!(Ve===-1||Ve+Ae!==Me);){if(Ve===0)return"";Me=Ve}return $e.substring(0,Me)}function $($e){return $e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function E($e){return $e.replace(/\*/g,"")}function h($e,Ie,Ae={}){if(!$e)throw new Error("Cannot create regex from empty string");Ie||($e=b($e)),Ae.wholeWord&&(/\B/.test($e.charAt(0))||($e="\\b"+$e),/\B/.test($e.charAt($e.length-1))||($e=$e+"\\b"));let Re="";return Ae.global&&(Re+="g"),Ae.matchCase||(Re+="i"),Ae.multiline&&(Re+="m"),Ae.unicode&&(Re+="u"),new RegExp($e,Re)}function t($e){return $e.source==="^"||$e.source==="^$"||$e.source==="$"||$e.source==="^\\s*$"?!1:!!($e.exec("")&&$e.lastIndex===0)}function o($e){return $e.split(/\r\n|\r|\n/)}function r($e){const Ie=[],Ae=$e.split(/(\r\n|\r|\n)/);for(let Re=0;Re<Math.ceil(Ae.length/2);Re++)Ie.push(Ae[2*Re]+(Ae[2*Re+1]??""));return Ie}function i($e){for(let Ie=0,Ae=$e.length;Ie<Ae;Ie++){const Re=$e.charCodeAt(Ie);if(Re!==32&&Re!==9)return Ie}return-1}function n($e,Ie=0,Ae=$e.length){for(let Re=Ie;Re<Ae;Re++){const Me=$e.charCodeAt(Re);if(Me!==32&&Me!==9)return $e.substring(Ie,Re)}return $e.substring(Ie,Ae)}function l($e,Ie=$e.length-1){for(let Ae=Ie;Ae>=0;Ae--){const Re=$e.charCodeAt(Ae);if(Re!==32&&Re!==9)return Ae}return-1}function p($e,Ie,Ae){const Re=[];let Me=0;for(const Ve of $e.matchAll(Ie)){if(Re.push($e.slice(Me,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Me=Ve.index+Ve[0].length,Re.push(Ae(Ve[0],...Ve.slice(1),Ve.index,$e,Ve.groups))}return Re.push($e.slice(Me)),Promise.all(Re).then(Ve=>Ve.join(""))}function P($e,Ie){return $e<Ie?-1:$e>Ie?1:0}function j($e,Ie,Ae=0,Re=$e.length,Me=0,Ve=Ie.length){for(;Ae<Re&&Me<Ve;Ae++,Me++){const rt=$e.charCodeAt(Ae),xe=Ie.charCodeAt(Me);if(rt<xe)return-1;if(rt>xe)return 1}const He=Re-Ae,st=Ve-Me;return He<st?-1:He>st?1:0}function O($e,Ie){return R($e,Ie,0,$e.length,0,Ie.length)}function R($e,Ie,Ae=0,Re=$e.length,Me=0,Ve=Ie.length){for(;Ae<Re&&Me<Ve;Ae++,Me++){let rt=$e.charCodeAt(Ae),xe=Ie.charCodeAt(Me);if(rt===xe)continue;if(rt>=128||xe>=128)return j($e.toLowerCase(),Ie.toLowerCase(),Ae,Re,Me,Ve);B(rt)&&(rt-=32),B(xe)&&(xe-=32);const ct=rt-xe;if(ct!==0)return ct}const He=Re-Ae,st=Ve-Me;return He<st?-1:He>st?1:0}function A($e){return $e>=48&&$e<=57}function B($e){return $e>=97&&$e<=122}function G($e){return $e>=65&&$e<=90}function se($e,Ie){return $e.length===Ie.length&&R($e,Ie)===0}function ce($e,Ie){const Ae=Ie.length;return Ie.length>$e.length?!1:R($e,Ie,0,Ae)===0}function ee($e,Ie){const Ae=Math.min($e.length,Ie.length);let Re;for(Re=0;Re<Ae;Re++)if($e.charCodeAt(Re)!==Ie.charCodeAt(Re))return Re;return Ae}function K($e,Ie){const Ae=Math.min($e.length,Ie.length);let Re;const Me=$e.length-1,Ve=Ie.length-1;for(Re=0;Re<Ae;Re++)if($e.charCodeAt(Me-Re)!==Ie.charCodeAt(Ve-Re))return Re;return Ae}function q($e){return 55296<=$e&&$e<=56319}function X($e){return 56320<=$e&&$e<=57343}function _($e,Ie){return($e-55296<<10)+(Ie-56320)+65536}function M($e,Ie,Ae){const Re=$e.charCodeAt(Ae);if(q(Re)&&Ae+1<Ie){const Me=$e.charCodeAt(Ae+1);if(X(Me))return _(Re,Me)}return Re}function Q($e,Ie){const Ae=$e.charCodeAt(Ie-1);if(X(Ae)&&Ie>1){const Re=$e.charCodeAt(Ie-2);if(q(Re))return _(Re,Ae)}return Ae}class ae{get offset(){return this.e}constructor(Ie,Ae=0){this.c=Ie,this.d=Ie.length,this.e=Ae}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=Q(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=M(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.$Gf=ae;class ne{get offset(){return this.c.offset}constructor(Ie,Ae=0){this.c=new ae(Ie,Ae)}nextGraphemeLength(){const Ie=Ue.getInstance(),Ae=this.c,Re=Ae.offset;let Me=Ie.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const Ve=Ae.offset,He=Ie.getGraphemeBreakType(Ae.nextCodePoint());if(Te(Me,He)){Ae.setOffset(Ve);break}Me=He}return Ae.offset-Re}prevGraphemeLength(){const Ie=Ue.getInstance(),Ae=this.c,Re=Ae.offset;let Me=Ie.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const Ve=Ae.offset,He=Ie.getGraphemeBreakType(Ae.prevCodePoint());if(Te(He,Me)){Ae.setOffset(Ve);break}Me=He}return Re-Ae.offset}eol(){return this.c.eol()}}e.$Hf=ne;function we($e,Ie){return new ne($e,Ie).nextGraphemeLength()}function ie($e,Ie){return new ne($e,Ie).prevGraphemeLength()}function Y($e,Ie){Ie>0&&X($e.charCodeAt(Ie))&&Ie--;const Ae=Ie+we($e,Ie);return[Ae-ie($e,Ae),Ae]}function V($e){const Ie=new ne($e);let Ae=0;for(;!Ie.eol();)Ae++,Ie.nextGraphemeLength();return Ae}let N;function z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z($e){return N||(N=z()),N.test($e)}const he=/^[\t\n\r\x20-\x7E]*$/;function x($e){return he.test($e)}e.$Of=/[\u2028\u2029]/;function J($e){return e.$Of.test($e)}function H($e){return $e>=11904&&$e<=55215||$e>=63744&&$e<=64255||$e>=65281&&$e<=65374}function L($e){return $e>=127462&&$e<=127487||$e===8986||$e===8987||$e===9200||$e===9203||$e>=9728&&$e<=10175||$e===11088||$e===11093||$e>=127744&&$e<=128591||$e>=128640&&$e<=128764||$e>=128992&&$e<=129008||$e>=129280&&$e<=129535||$e>=129648&&$e<=129782}function U($e,Ie,Ae=""){const Re=$e.trimStart();if(Re.length<Ie)return Re;const Me=/\b/g;let Ve=0;for(;Me.test(Re)&&!(Re.length-Me.lastIndex<Ie);)Ve=Me.lastIndex,Me.lastIndex+=1;return Ve===0?Re:Ae+Re.substring(Ve).trimStart()}const oe=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le($e){let Ie=0;for(const Ae of $e.matchAll(oe))Ie!==Ae.index&&(yield{isCode:!1,str:$e.substring(Ie,Ae.index)}),yield{isCode:!0,str:Ae[0]},Ie=Ae.index+Ae[0].length;Ie!==$e.length&&(yield{isCode:!1,str:$e.substring(Ie)})}function de($e){return $e&&($e=$e.replace(oe,"")),$e}e.$Vf="\uFEFF";function te($e){return!!($e&&$e.length>0&&$e.charCodeAt(0)===65279)}function me($e){return te($e)?$e.substr(1):$e}function pe($e,Ie){if(!$e||!Ie||$e.length<Ie.length)return!1;const Ae=Ie.length,Re=$e.toLowerCase();let Me=0,Ve=-1;for(;Me<Ae;){const He=Re.indexOf(Ie[Me],Ve+1);if(He<0)return!1;Ve=He,Me++}return!0}function Ce($e,Ie=!1){return $e?(Ie&&($e=$e.replace(/\\./g,"")),$e.toLowerCase()!==$e):!1}function je($e){return $e.charAt(0).toUpperCase()+$e.slice(1)}function ge($e,Ie=1){if(Ie===0)return"";let Ae=-1;do Ae=$e.indexOf(`
`,Ae+1),Ie--;while(Ie>0&&Ae>=0);return Ae===-1?$e:($e[Ae-1]==="\r"&&Ae--,$e.substr(0,Ae))}function Se($e){return $e=$e%(2*26),$e<26?String.fromCharCode(97+$e):String.fromCharCode(65+$e-26)}function De($e){return Ue.getInstance().getGraphemeBreakType($e)}function Te($e,Ie){return $e===0?Ie!==5&&Ie!==7:$e===2&&Ie===3?!1:$e===4||$e===2||$e===3||Ie===4||Ie===2||Ie===3?!0:!($e===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||($e===11||$e===9)&&(Ie===9||Ie===10)||($e===12||$e===10)&&Ie===10||Ie===5||Ie===13||Ie===7||$e===1||$e===13&&Ie===14||$e===6&&Ie===6)}var Le;(function($e){$e[$e.Other=0]="Other",$e[$e.Prepend=1]="Prepend",$e[$e.CR=2]="CR",$e[$e.LF=3]="LF",$e[$e.Control=4]="Control",$e[$e.Extend=5]="Extend",$e[$e.Regional_Indicator=6]="Regional_Indicator",$e[$e.SpacingMark=7]="SpacingMark",$e[$e.L=8]="L",$e[$e.V=9]="V",$e[$e.T=10]="T",$e[$e.LV=11]="LV",$e[$e.LVT=12]="LVT",$e[$e.ZWJ=13]="ZWJ",$e[$e.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Qe()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ae=this.d,Re=Ae.length/3;let Me=1;for(;Me<=Re;)if(Ie<Ae[3*Me])Me=2*Me;else if(Ie>Ae[3*Me+1])Me=2*Me+1;else return Ae[3*Me+2];return 0}}Ue.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge($e,Ie){if($e===0)return 0;const Ae=Je($e,Ie);if(Ae!==void 0)return Ae;const Re=new ae(Ie,$e);return Re.prevCodePoint(),Re.offset}function Je($e,Ie){const Ae=new ae(Ie,$e);let Re=Ae.prevCodePoint();for(;Ye(Re)||Re===65039||Re===8419;){if(Ae.offset===0)return;Re=Ae.prevCodePoint()}if(!L(Re))return;let Me=Ae.offset;return Me>0&&Ae.prevCodePoint()===8205&&(Me=Ae.offset),Me}function Ye($e){return 127995<=$e&&$e<=127999}var nt;(function($e){$e[$e.zwj=8205]="zwj",$e[$e.emojiVariantSelector=65039]="emojiVariantSelector",$e[$e.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$6f="\xA0";class _e{static getInstance(Ie){return D.d.get(Array.from(Ie))}static getLocales(){return D.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=_e,D=_e,_e.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.d=new s.$4e({getCacheKey:JSON.stringify},$e=>{function Ie(xe){const ct=new Map;for(let at=0;at<xe.length;at+=2)ct.set(xe[at],xe[at+1]);return ct}function Ae(xe,ct){const at=new Map(xe);for(const[gt,lt]of ct)at.set(gt,lt);return at}function Re(xe,ct){if(!xe)return ct;const at=new Map;for(const[gt,lt]of xe)ct.has(gt)&&at.set(gt,lt);return at}const Me=D.c.value;let Ve=$e.filter(xe=>!xe.startsWith("_")&&xe in Me);Ve.length===0&&(Ve=["_default"]);let He;for(const xe of Ve){const ct=Ie(Me[xe]);He=Re(He,ct)}const st=Ie(Me._common),rt=Ae(st,He);return new D(rt)}),_e.e=new C.$V(()=>Object.keys(D.c.value).filter($e=>!$e.startsWith("_")));class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(Ie){return Ze.e().has(Ie)}static get codePoints(){return Ze.e()}}e.$8f=Ze,Ze.d=void 0}),define(ye[159],Ee([1,0,24,151,17]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=k,e.$zk=S,e.$Ak=w,e.$Bk=v,e.$Ck=l,e.$Dk=p,e.$Ek=B,e.$Fk=G,e.$Gk=se,e.$Hk=ce,e.$Ik=z,e.$Kk=J,e.$Lk=U,e.$Mk=oe;function k(...te){return function(me,pe){for(let Ce=0,je=te.length;Ce<je;Ce++){const ge=te[Ce](me,pe);if(ge)return ge}return null}}e.$xk=I.bind(void 0,!1),e.$yk=I.bind(void 0,!0);function I(te,me,pe){if(!pe||pe.length<me.length)return null;let Ce;return te?Ce=D.$zf(pe,me):Ce=pe.indexOf(me)===0,Ce?me.length>0?[{start:0,end:me.length}]:[]:null}function S(te,me){const pe=me.toLowerCase().indexOf(te.toLowerCase());return pe===-1?null:[{start:pe,end:pe+te.length}]}function w(te,me){return g(te.toLowerCase(),me.toLowerCase(),0,0)}function g(te,me,pe,Ce){if(pe===te.length)return[];if(Ce===me.length)return null;if(te[pe]===me[Ce]){let je=null;return(je=g(te,me,pe+1,Ce+1))?E({start:Ce,end:Ce+1},je):null}return g(te,me,pe,Ce+1)}function y(te){return 97<=te&&te<=122}function v(te){return 65<=te&&te<=90}function b(te){return 48<=te&&te<=57}function m(te){return te===32||te===9||te===10||te===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>u.add(te.charCodeAt(0)));function a(te){return m(te)||u.has(te)}function f(te,me){return te===me||a(te)&&a(me)}const c=new Map;function d(te){if(c.has(te))return c.get(te);let me;const pe=(0,C.$vk)(te);return pe&&(me=pe),c.set(te,me),me}function $(te){return y(te)||v(te)||b(te)}function E(te,me){return me.length===0?me=[te]:te.end===me[0].start?me[0].start=te.start:me.unshift(te),me}function h(te,me){for(let pe=me;pe<te.length;pe++){const Ce=te.charCodeAt(pe);if(v(Ce)||b(Ce)||pe>0&&!$(te.charCodeAt(pe-1)))return pe}return te.length}function t(te,me,pe,Ce){if(pe===te.length)return[];if(Ce===me.length)return null;if(te[pe]!==me[Ce].toLowerCase())return null;{let je=null,ge=Ce+1;for(je=t(te,me,pe+1,Ce+1);!je&&(ge=h(me,ge))<me.length;)je=t(te,me,pe+1,ge),ge++;return je===null?null:E({start:Ce,end:Ce+1},je)}}function o(te){let me=0,pe=0,Ce=0,je=0,ge=0;for(let Ue=0;Ue<te.length;Ue++)ge=te.charCodeAt(Ue),v(ge)&&me++,y(ge)&&pe++,$(ge)&&Ce++,b(ge)&&je++;const Se=me/te.length,De=pe/te.length,Te=Ce/te.length,Le=je/te.length;return{upperPercent:Se,lowerPercent:De,alphaPercent:Te,numericPercent:Le}}function r(te){const{upperPercent:me,lowerPercent:pe}=te;return pe===0&&me>.6}function i(te){const{upperPercent:me,lowerPercent:pe,alphaPercent:Ce,numericPercent:je}=te;return pe>.2&&me<.8&&Ce>.6&&je<.2}function n(te){let me=0,pe=0,Ce=0,je=0;for(let ge=0;ge<te.length;ge++)Ce=te.charCodeAt(ge),v(Ce)&&me++,y(Ce)&&pe++,m(Ce)&&je++;return(me===0||pe===0)&&je===0?te.length<=30:me<=5}function l(te,me){if(!me||(me=me.trim(),me.length===0)||!n(te))return null;me.length>60&&(me=me.substring(0,60));const pe=o(me);if(!i(pe)){if(!r(pe))return null;me=me.toLowerCase()}let Ce=null,je=0;for(te=te.toLowerCase();je<me.length&&(Ce=t(te,me,0,je))===null;)je=h(me,je+1);return Ce}function p(te,me,pe=!1){if(!me||me.length===0)return null;let Ce=null,je=0;for(te=te.toLowerCase(),me=me.toLowerCase();je<me.length&&(Ce=P(te,me,0,je,pe),Ce===null);)je=j(me,je+1);return Ce}function P(te,me,pe,Ce,je){let ge=0;if(pe===te.length)return[];if(Ce===me.length)return null;if(!f(te.charCodeAt(pe),me.charCodeAt(Ce))){const Te=d(te.charCodeAt(pe));if(!Te)return null;for(let Le=0;Le<Te.length;Le++)if(!f(Te[Le],me.charCodeAt(Ce+Le)))return null;ge+=Te.length-1}let Se=null,De=Ce+ge+1;if(Se=P(te,me,pe+1,De,je),!je)for(;!Se&&(De=j(me,De))<me.length;)Se=P(te,me,pe+1,De,je),De++;if(!Se)return null;if(te.charCodeAt(pe)!==me.charCodeAt(Ce)){const Te=d(te.charCodeAt(pe));if(!Te)return Se;for(let Le=0;Le<Te.length;Le++)if(Te[Le]!==me.charCodeAt(Ce+Le))return Se}return E({start:Ce,end:Ce+ge+1},Se)}function j(te,me){for(let pe=me;pe<te.length;pe++)if(a(te.charCodeAt(pe))||pe>0&&a(te.charCodeAt(pe-1)))return pe;return te.length}const O=k(e.$yk,l,S),R=k(e.$yk,l,w),A=new s.$Ec(1e4);function B(te,me,pe=!1){if(typeof te!="string"||typeof me!="string")return null;let Ce=A.get(te);Ce||(Ce=new RegExp(D.$hf(te),"i"),A.set(te,Ce));const je=Ce.exec(me);return je?[{start:je.index,end:je.index+je[0].length}]:pe?R(te,me):O(te,me)}function G(te,me){const pe=J(te,te.toLowerCase(),0,me,me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?ce(pe):null}function se(te,me,pe,Ce,je,ge){const Se=Math.min(13,te.length);for(;pe<Se;pe++){const De=J(te,me,pe,Ce,je,ge,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ge]}function ce(te){if(typeof te>"u")return[];const me=[],pe=te[1];for(let Ce=te.length-1;Ce>1;Ce--){const je=te[Ce]+pe,ge=me[me.length-1];ge&&ge.end===je?ge.end=je+1:me.push({start:je,end:je+1})}return me}const ee=128;function K(){const te=[],me=[];for(let pe=0;pe<=ee;pe++)me[pe]=0;for(let pe=0;pe<=ee;pe++)te.push(me.slice(0));return te}function q(te){const me=[];for(let pe=0;pe<=te;pe++)me[pe]=0;return me}const X=q(2*ee),_=q(2*ee),M=K(),Q=K(),ae=K(),ne=!1;function we(te,me,pe,Ce,je){function ge(De,Te,Le=" "){for(;De.length<Te;)De=Le+De;return De}let Se=` |   |${Ce.split("").map(De=>ge(De,3)).join("|")}
`;for(let De=0;De<=pe;De++)De===0?Se+=" |":Se+=`${me[De-1]}|`,Se+=te[De].slice(0,je+1).map(Te=>ge(Te.toString(),3)).join("|")+`
`;return Se}function ie(te,me,pe,Ce){te=te.substr(me),pe=pe.substr(Ce),console.log(we(Q,te,te.length,pe,pe.length)),console.log(we(ae,te,te.length,pe,pe.length)),console.log(we(M,te,te.length,pe,pe.length))}function Y(te,me){if(me<0||me>=te.length)return!1;const pe=te.codePointAt(me);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!D.$Rf(pe)}}function V(te,me){if(me<0||me>=te.length)return!1;switch(te.charCodeAt(me)){case 32:case 9:return!0;default:return!1}}function N(te,me,pe){return me[te]!==pe[te]}function z(te,me,pe,Ce,je,ge,Se=!1){for(;me<pe&&je<ge;)te[me]===Ce[je]&&(Se&&(X[me]=je),me+=1),je+=1;return me===pe}var Z;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var he;(function(te){te.Default=[-100,0];function me(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}te.isDefault=me})(he||(e.FuzzyScore=he={}));class x{constructor(me,pe){this.firstMatchCanBeWeak=me,this.boostFullMatch=pe}}e.$Jk=x,x.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function J(te,me,pe,Ce,je,ge,Se=x.default){const De=te.length>ee?ee:te.length,Te=Ce.length>ee?ee:Ce.length;if(pe>=De||ge>=Te||De-pe>Te-ge||!z(me,pe,De,je,ge,Te,!0))return;H(De,Te,pe,ge,me,je);let Le=1,Ue=1,Qe=pe,Ge=ge;const Je=[!1];for(Le=1,Qe=pe;Qe<De;Le++,Qe++){const $e=X[Qe],Ie=_[Qe],Ae=Qe+1<De?_[Qe+1]:Te;for(Ue=$e-ge+1,Ge=$e;Ge<Ae;Ue++,Ge++){let Re=Number.MIN_SAFE_INTEGER,Me=!1;Ge<=Ie&&(Re=L(te,me,Qe,pe,Ce,je,Ge,Te,ge,M[Le-1][Ue-1]===0,Je));let Ve=0;Re!==Number.MAX_SAFE_INTEGER&&(Me=!0,Ve=Re+Q[Le-1][Ue-1]);const He=Ge>$e,st=He?Q[Le][Ue-1]+(M[Le][Ue-1]>0?-5:0):0,rt=Ge>$e+1&&M[Le][Ue-1]>0,xe=rt?Q[Le][Ue-2]+(M[Le][Ue-2]>0?-5:0):0;if(rt&&(!He||xe>=st)&&(!Me||xe>=Ve))Q[Le][Ue]=xe,ae[Le][Ue]=3,M[Le][Ue]=0;else if(He&&(!Me||st>=Ve))Q[Le][Ue]=st,ae[Le][Ue]=2,M[Le][Ue]=0;else if(Me)Q[Le][Ue]=Ve,ae[Le][Ue]=1,M[Le][Ue]=M[Le-1][Ue-1]+1;else throw new Error("not possible")}}if(ne&&ie(te,pe,Ce,ge),!Je[0]&&!Se.firstMatchCanBeWeak)return;Le--,Ue--;const Ye=[Q[Le][Ue],ge];let nt=0,_e=0;for(;Le>=1;){let $e=Ue;do{const Ie=ae[Le][$e];if(Ie===3)$e=$e-2;else if(Ie===2)$e=$e-1;else break}while($e>=1);nt>1&&me[pe+Le-1]===je[ge+Ue-1]&&!N($e+ge-1,Ce,je)&&nt+1>M[Le][$e]&&($e=Ue),$e===Ue?nt++:nt=1,_e||(_e=$e),Le--,Ue=$e-1,Ye.push(Ue)}Te===De&&Se.boostFullMatch&&(Ye[0]+=2);const Ze=_e-De;return Ye[0]-=Ze,Ye}function H(te,me,pe,Ce,je,ge){let Se=te-1,De=me-1;for(;Se>=pe&&De>=Ce;)je[Se]===ge[De]&&(_[Se]=De,Se--),De--}function L(te,me,pe,Ce,je,ge,Se,De,Te,Le,Ue){if(me[pe]!==ge[Se])return Number.MIN_SAFE_INTEGER;let Qe=1,Ge=!1;return Se===pe-Ce?Qe=te[pe]===je[Se]?7:5:N(Se,je,ge)&&(Se===0||!N(Se-1,je,ge))?(Qe=te[pe]===je[Se]?7:5,Ge=!0):Y(ge,Se)&&(Se===0||!Y(ge,Se-1))?Qe=5:(Y(ge,Se-1)||V(ge,Se-1))&&(Qe=5,Ge=!0),Qe>1&&pe===Ce&&(Ue[0]=!0),Ge||(Ge=N(Se,je,ge)||Y(ge,Se-1)||V(ge,Se-1)),pe===Ce?Se>Te&&(Qe-=Ge?3:5):Le?Qe+=Ge?2:0:Qe+=Ge?0:1,Se+1===De&&(Qe-=Ge?3:5),Qe}function U(te,me,pe,Ce,je,ge,Se){return le(te,me,pe,Ce,je,ge,!0,Se)}function oe(te,me,pe,Ce,je,ge,Se){return le(te,me,pe,Ce,je,ge,!1,Se)}function le(te,me,pe,Ce,je,ge,Se,De){let Te=J(te,me,pe,Ce,je,ge,De);if(Te&&!Se)return Te;if(te.length>=3){const Le=Math.min(7,te.length-1);for(let Ue=pe+1;Ue<Le;Ue++){const Qe=de(te,Ue);if(Qe){const Ge=J(Qe,Qe.toLowerCase(),pe,Ce,je,ge,De);Ge&&(Ge[0]-=3,(!Te||Ge[0]>Te[0])&&(Te=Ge))}}}return Te}function de(te,me){if(me+1>=te.length)return;const pe=te[me],Ce=te[me+1];if(pe!==Ce)return te.slice(0,me)+Ce+pe+te.slice(me+2)}}),define(ye[64],Ee([1,0,17]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=C,e.$lj=D,e.$mj=k,e.$nj=S,e.$pj=a;function C(c){return D(c,0)}function D(c,d){switch(typeof c){case"object":return c===null?k(349,d):Array.isArray(c)?w(c,d):g(c,d);case"string":return S(c,d);case"boolean":return I(c,d);case"number":return k(c,d);case"undefined":return k(937,d);default:return k(617,d)}}function k(c,d){return(d<<5)-d+c|0}function I(c,d){return k(c?433:863,d)}function S(c,d){d=k(149417,d);for(let $=0,E=c.length;$<E;$++)d=k(c.charCodeAt($),d);return d}function w(c,d){return d=k(104579,d),c.reduce(($,E)=>D(E,$),d)}function g(c,d){return d=k(181387,d),Object.keys(c).sort().reduce(($,E)=>($=S(E,$),D(c[E],$)),d)}class y{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.$oj=y;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(c,d,$=32){const E=$-d,h=~((1<<E)-1);return(c<<d|(h&c)>>>E)>>>0}function m(c,d=0,$=c.byteLength,E=0){for(let h=0;h<$;h++)c[d+h]=E}function u(c,d,$="0"){for(;c.length<d;)c=$+c;return c}function a(c,d=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):u((c>>>0).toString(16),d/4)}class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const $=d.length;if($===0)return;const E=this.p;let h=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=d.charCodeAt(0),r=0);;){let i=o;if(s.$Cf(o))if(r+1<$){const n=d.charCodeAt(r+1);s.$Df(n)?(r++,i=s.$Ef(o,n)):i=65533}else{t=o;break}else s.$Df(o)&&(i=65533);if(h=this.w(E,h,i),r++,r<$)o=d.charCodeAt(r);else break}this.r=h,this.u=t}w(d,$,E){return E<128?d[$++]=E:E<2048?(d[$++]=192|(E&1984)>>>6,d[$++]=128|(E&63)>>>0):E<65536?(d[$++]=224|(E&61440)>>>12,d[$++]=128|(E&4032)>>>6,d[$++]=128|(E&63)>>>0):(d[$++]=240|(E&1835008)>>>18,d[$++]=128|(E&258048)>>>12,d[$++]=128|(E&4032)>>>6,d[$++]=128|(E&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,$=this.q;for(let p=0;p<64;p+=4)d.setUint32(p,$.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)d.setUint32(p,b(d.getUint32(p-12,!1)^d.getUint32(p-32,!1)^d.getUint32(p-56,!1)^d.getUint32(p-64,!1),1),!1);let E=this.h,h=this.l,t=this.m,o=this.n,r=this.o,i,n,l;for(let p=0;p<80;p++)p<20?(i=h&t|~h&o,n=1518500249):p<40?(i=h^t^o,n=1859775393):p<60?(i=h&t|h&o|t&o,n=2400959708):(i=h^t^o,n=3395469782),l=b(E,5)+i+r+n+d.getUint32(p*4,!1)&4294967295,r=o,o=t,t=b(h,30),h=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$qj=f,f.g=new DataView(new ArrayBuffer(320))}),define(ye[65],Ee([1,0,17]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(C||(C={})),function(D){const k="error",I="warning",S="warn",w="info",g="ignore";function y(b){return b?s.$yf(k,b)?D.Error:s.$yf(I,b)||s.$yf(S,b)?D.Warning:s.$yf(w,b)?D.Info:D.Ignore:D.Ignore}D.fromValue=y;function v(b){switch(b){case D.Error:return k;case D.Warning:return I;case D.Info:return w;default:return g}}D.toString=v}(C||(C={})),e.default=C}),define(ye[160],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ye[66],Ee([1,0,18,17]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class D{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const u=m.charCodeAt(0),a=this.b.charCodeAt(this.c);return u-a}value(){return this.b[this.c]}}e.$yi=D;class k{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,C.$sf)(m,this.b,0,m.length,this.c,this.d):(0,C.$uf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=k;class I{constructor(m=!0,u=!0){this.f=m,this.g=u}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let u=m.length-1;u>=0;u--,this.c--){const a=this.b.charCodeAt(u);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===47||this.f&&u===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,C.$sf)(m,this.b,0,m.length,this.d,this.e):(0,C.$uf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=I;var S;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(S||(S={}));class w{constructor(m,u){this.f=m,this.g=u,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,C.$tf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,C.$tf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,C.$rf)(m,this.c.query);if(this.d[this.e]===5)return(0,C.$rf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=w;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(y||(y={}));class v{static forUris(m=()=>!1,u=()=>!1){return new v(new w(m,u))}static forPaths(m=!1){return new v(new I(void 0,!m))}static forStrings(){return new v(new D)}static forConfigKeys(){return new v(new k)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,u){if(u){const a=u.slice(0);(0,s.$Xb)(a);for(const f of a)this.set(f,m)}else{const a=m.slice(0);(0,s.$Xb)(a);for(const f of a)this.set(f[0],f[1])}}set(m,u){const a=this.b.reset(m);let f;this.c||(this.c=new g,this.c.segment=a.value());const c=[];for(f=this.c;;){const $=a.cmp(f.segment);if($>0)f.left||(f.left=new g,f.left.segment=a.value()),c.push([-1,f]),f=f.left;else if($<0)f.right||(f.right=new g,f.right.segment=a.value()),c.push([1,f]),f=f.right;else if(a.hasNext())a.next(),f.mid||(f.mid=new g,f.mid.segment=a.value()),c.push([0,f]),f=f.mid;else break}const d=f.value;f.value=u,f.key=m;for(let $=c.length-1;$>=0;$--){const E=c[$][1];E.updateHeight();const h=E.balanceFactor();if(h<-1||h>1){const t=c[$][0],o=c[$+1][0];if(t===1&&o===1)c[$][1]=E.rotateLeft();else if(t===-1&&o===-1)c[$][1]=E.rotateRight();else if(t===1&&o===-1)E.right=c[$+1][1]=c[$+1][1].rotateRight(),c[$][1]=E.rotateLeft();else if(t===-1&&o===1)E.left=c[$+1][1]=c[$+1][1].rotateLeft(),c[$][1]=E.rotateRight();else throw new Error;if($>0)switch(c[$-1][0]){case-1:c[$-1][1].left=c[$][1];break;case 1:c[$-1][1].right=c[$][1];break;case 0:c[$-1][1].mid=c[$][1];break}else this.c=c[0][1]}}return d}get(m){return this.d(m)?.value}d(m){const u=this.b.reset(m);let a=this.c;for(;a;){const f=u.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(u.hasNext())u.next(),a=a.mid;else break}return a}has(m){const u=this.d(m);return!(u?.value===void 0&&u?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,u){const a=this.b.reset(m),f=[];let c=this.c;for(;c;){const d=a.cmp(c.segment);if(d>0)f.push([-1,c]),c=c.left;else if(d<0)f.push([1,c]),c=c.right;else if(a.hasNext())a.next(),f.push([0,c]),c=c.mid;else break}if(c){if(u?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const d=this.f(c.right);if(d.key){const{key:$,value:E,segment:h}=d;this.e(d.key,!1),c.key=$,c.value=E,c.segment=h}}else{const d=c.left??c.right;if(f.length>0){const[$,E]=f[f.length-1];switch($){case-1:E.left=d;break;case 0:E.mid=d;break;case 1:E.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const $=f[d][1];$.updateHeight();const E=$.balanceFactor();if(E>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),f[d][1]=$.rotateLeft()):E<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),f[d][1]=$.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const u=this.b.reset(m);let a=this.c,f;for(;a;){const c=u.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(u.hasNext())u.next(),f=a.value||f,a=a.mid;else break}return a&&a.value||f}findSuperstr(m){return this.g(m,!1)}g(m,u){const a=this.b.reset(m);let f=this.c;for(;f;){const c=a.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else return f.mid?this.h(f.mid):u?f.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[u,a]of this)m(a,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const u=[];return this.j(m,u),u[Symbol.iterator]()}j(m,u){m&&(m.left&&this.j(m.left,u),m.value&&u.push([m.key,m.value]),m.mid&&this.j(m.mid,u),m.right&&this.j(m.right,u))}_isBalanced(){const m=u=>{if(!u)return!0;const a=u.balanceFactor();return a<-1||a>1?!1:m(u.left)&&m(u.right)};return m(this.c)}}e.$Ci=v}),define(ye[10],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=s,e.$0f=C,e.$$f=D,e.$_f=k,e.$ag=I,e.$bg=S,e.$cg=w,e.$dg=g,e.$eg=y,e.$fg=v,e.$gg=b,e.$hg=m,e.$ig=u,e.$jg=f,e.$kg=c,e.$lg=d,e.$mg=$,e.$ng=E;function s(h){return typeof h=="string"}function C(h){return Array.isArray(h)&&h.every(t=>s(t))}function D(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function k(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}function I(h){return typeof h=="number"&&!isNaN(h)}function S(h){return!!h&&typeof h[Symbol.iterator]=="function"}function w(h){return h===!0||h===!1}function g(h){return typeof h>"u"}function y(h){return!v(h)}function v(h){return g(h)||h===null}function b(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(h){if(v(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function u(...h){const t=[];for(let o=0;o<h.length;o++){const r=h[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const a=Object.prototype.hasOwnProperty;function f(h){if(!D(h))return!1;for(const t in h)if(a.call(h,t))return!1;return!0}function c(h){return typeof h=="function"}function d(...h){return h.length>0&&h.every(c)}function $(h,t){const o=Math.min(h.length,t.length);for(let r=0;r<o;r++)E(h[r],t[r])}function E(h,t){if(s(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(h instanceof t)return}catch{}if(!v(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[101],Ee([1,0,10]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=D,e.$Rj=k;const C=Object.create(null);function D(I,S){if((0,s.$9f)(S)){const w=C[S];if(w===void 0)throw new Error(`${I} references an unknown codicon: ${S}`);S=w}return C[I]=S,{id:I}}function k(){return C}}),define(ye[161],Ee([1,0,101]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,s.$Qj)("add",6e4),plus:(0,s.$Qj)("plus",6e4),gistNew:(0,s.$Qj)("gist-new",6e4),repoCreate:(0,s.$Qj)("repo-create",6e4),lightbulb:(0,s.$Qj)("lightbulb",60001),lightBulb:(0,s.$Qj)("light-bulb",60001),repo:(0,s.$Qj)("repo",60002),repoDelete:(0,s.$Qj)("repo-delete",60002),gistFork:(0,s.$Qj)("gist-fork",60003),repoForked:(0,s.$Qj)("repo-forked",60003),gitPullRequest:(0,s.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,s.$Qj)("record-keys",60005),keyboard:(0,s.$Qj)("keyboard",60005),tag:(0,s.$Qj)("tag",60006),gitPullRequestLabel:(0,s.$Qj)("git-pull-request-label",60006),tagAdd:(0,s.$Qj)("tag-add",60006),tagRemove:(0,s.$Qj)("tag-remove",60006),person:(0,s.$Qj)("person",60007),personFollow:(0,s.$Qj)("person-follow",60007),personOutline:(0,s.$Qj)("person-outline",60007),personFilled:(0,s.$Qj)("person-filled",60007),gitBranch:(0,s.$Qj)("git-branch",60008),gitBranchCreate:(0,s.$Qj)("git-branch-create",60008),gitBranchDelete:(0,s.$Qj)("git-branch-delete",60008),sourceControl:(0,s.$Qj)("source-control",60008),mirror:(0,s.$Qj)("mirror",60009),mirrorPublic:(0,s.$Qj)("mirror-public",60009),star:(0,s.$Qj)("star",60010),starAdd:(0,s.$Qj)("star-add",60010),starDelete:(0,s.$Qj)("star-delete",60010),starEmpty:(0,s.$Qj)("star-empty",60010),comment:(0,s.$Qj)("comment",60011),commentAdd:(0,s.$Qj)("comment-add",60011),alert:(0,s.$Qj)("alert",60012),warning:(0,s.$Qj)("warning",60012),search:(0,s.$Qj)("search",60013),searchSave:(0,s.$Qj)("search-save",60013),logOut:(0,s.$Qj)("log-out",60014),signOut:(0,s.$Qj)("sign-out",60014),logIn:(0,s.$Qj)("log-in",60015),signIn:(0,s.$Qj)("sign-in",60015),eye:(0,s.$Qj)("eye",60016),eyeUnwatch:(0,s.$Qj)("eye-unwatch",60016),eyeWatch:(0,s.$Qj)("eye-watch",60016),circleFilled:(0,s.$Qj)("circle-filled",60017),primitiveDot:(0,s.$Qj)("primitive-dot",60017),closeDirty:(0,s.$Qj)("close-dirty",60017),debugBreakpoint:(0,s.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,s.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,s.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,s.$Qj)("primitive-square",60018),edit:(0,s.$Qj)("edit",60019),pencil:(0,s.$Qj)("pencil",60019),info:(0,s.$Qj)("info",60020),issueOpened:(0,s.$Qj)("issue-opened",60020),gistPrivate:(0,s.$Qj)("gist-private",60021),gitForkPrivate:(0,s.$Qj)("git-fork-private",60021),lock:(0,s.$Qj)("lock",60021),mirrorPrivate:(0,s.$Qj)("mirror-private",60021),close:(0,s.$Qj)("close",60022),removeClose:(0,s.$Qj)("remove-close",60022),x:(0,s.$Qj)("x",60022),repoSync:(0,s.$Qj)("repo-sync",60023),sync:(0,s.$Qj)("sync",60023),clone:(0,s.$Qj)("clone",60024),desktopDownload:(0,s.$Qj)("desktop-download",60024),beaker:(0,s.$Qj)("beaker",60025),microscope:(0,s.$Qj)("microscope",60025),vm:(0,s.$Qj)("vm",60026),deviceDesktop:(0,s.$Qj)("device-desktop",60026),file:(0,s.$Qj)("file",60027),fileText:(0,s.$Qj)("file-text",60027),more:(0,s.$Qj)("more",60028),ellipsis:(0,s.$Qj)("ellipsis",60028),kebabHorizontal:(0,s.$Qj)("kebab-horizontal",60028),mailReply:(0,s.$Qj)("mail-reply",60029),reply:(0,s.$Qj)("reply",60029),organization:(0,s.$Qj)("organization",60030),organizationFilled:(0,s.$Qj)("organization-filled",60030),organizationOutline:(0,s.$Qj)("organization-outline",60030),newFile:(0,s.$Qj)("new-file",60031),fileAdd:(0,s.$Qj)("file-add",60031),newFolder:(0,s.$Qj)("new-folder",60032),fileDirectoryCreate:(0,s.$Qj)("file-directory-create",60032),trash:(0,s.$Qj)("trash",60033),trashcan:(0,s.$Qj)("trashcan",60033),history:(0,s.$Qj)("history",60034),clock:(0,s.$Qj)("clock",60034),folder:(0,s.$Qj)("folder",60035),fileDirectory:(0,s.$Qj)("file-directory",60035),symbolFolder:(0,s.$Qj)("symbol-folder",60035),logoGithub:(0,s.$Qj)("logo-github",60036),markGithub:(0,s.$Qj)("mark-github",60036),github:(0,s.$Qj)("github",60036),terminal:(0,s.$Qj)("terminal",60037),console:(0,s.$Qj)("console",60037),repl:(0,s.$Qj)("repl",60037),zap:(0,s.$Qj)("zap",60038),symbolEvent:(0,s.$Qj)("symbol-event",60038),error:(0,s.$Qj)("error",60039),stop:(0,s.$Qj)("stop",60039),variable:(0,s.$Qj)("variable",60040),symbolVariable:(0,s.$Qj)("symbol-variable",60040),array:(0,s.$Qj)("array",60042),symbolArray:(0,s.$Qj)("symbol-array",60042),symbolModule:(0,s.$Qj)("symbol-module",60043),symbolPackage:(0,s.$Qj)("symbol-package",60043),symbolNamespace:(0,s.$Qj)("symbol-namespace",60043),symbolObject:(0,s.$Qj)("symbol-object",60043),symbolMethod:(0,s.$Qj)("symbol-method",60044),symbolFunction:(0,s.$Qj)("symbol-function",60044),symbolConstructor:(0,s.$Qj)("symbol-constructor",60044),symbolBoolean:(0,s.$Qj)("symbol-boolean",60047),symbolNull:(0,s.$Qj)("symbol-null",60047),symbolNumeric:(0,s.$Qj)("symbol-numeric",60048),symbolNumber:(0,s.$Qj)("symbol-number",60048),symbolStructure:(0,s.$Qj)("symbol-structure",60049),symbolStruct:(0,s.$Qj)("symbol-struct",60049),symbolParameter:(0,s.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,s.$Qj)("symbol-type-parameter",60050),symbolKey:(0,s.$Qj)("symbol-key",60051),symbolText:(0,s.$Qj)("symbol-text",60051),symbolReference:(0,s.$Qj)("symbol-reference",60052),goToFile:(0,s.$Qj)("go-to-file",60052),symbolEnum:(0,s.$Qj)("symbol-enum",60053),symbolValue:(0,s.$Qj)("symbol-value",60053),symbolRuler:(0,s.$Qj)("symbol-ruler",60054),symbolUnit:(0,s.$Qj)("symbol-unit",60054),activateBreakpoints:(0,s.$Qj)("activate-breakpoints",60055),archive:(0,s.$Qj)("archive",60056),arrowBoth:(0,s.$Qj)("arrow-both",60057),arrowDown:(0,s.$Qj)("arrow-down",60058),arrowLeft:(0,s.$Qj)("arrow-left",60059),arrowRight:(0,s.$Qj)("arrow-right",60060),arrowSmallDown:(0,s.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,s.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,s.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,s.$Qj)("arrow-small-up",60064),arrowUp:(0,s.$Qj)("arrow-up",60065),bell:(0,s.$Qj)("bell",60066),bold:(0,s.$Qj)("bold",60067),book:(0,s.$Qj)("book",60068),bookmark:(0,s.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.$Qj)("briefcase",60076),broadcast:(0,s.$Qj)("broadcast",60077),browser:(0,s.$Qj)("browser",60078),bug:(0,s.$Qj)("bug",60079),calendar:(0,s.$Qj)("calendar",60080),caseSensitive:(0,s.$Qj)("case-sensitive",60081),check:(0,s.$Qj)("check",60082),checklist:(0,s.$Qj)("checklist",60083),chevronDown:(0,s.$Qj)("chevron-down",60084),chevronLeft:(0,s.$Qj)("chevron-left",60085),chevronRight:(0,s.$Qj)("chevron-right",60086),chevronUp:(0,s.$Qj)("chevron-up",60087),chromeClose:(0,s.$Qj)("chrome-close",60088),chromeMaximize:(0,s.$Qj)("chrome-maximize",60089),chromeMinimize:(0,s.$Qj)("chrome-minimize",60090),chromeRestore:(0,s.$Qj)("chrome-restore",60091),circleOutline:(0,s.$Qj)("circle-outline",60092),circle:(0,s.$Qj)("circle",60092),debugBreakpointUnverified:(0,s.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,s.$Qj)("circle-slash",60093),circuitBoard:(0,s.$Qj)("circuit-board",60094),clearAll:(0,s.$Qj)("clear-all",60095),clippy:(0,s.$Qj)("clippy",60096),closeAll:(0,s.$Qj)("close-all",60097),cloudDownload:(0,s.$Qj)("cloud-download",60098),cloudUpload:(0,s.$Qj)("cloud-upload",60099),code:(0,s.$Qj)("code",60100),collapseAll:(0,s.$Qj)("collapse-all",60101),colorMode:(0,s.$Qj)("color-mode",60102),commentDiscussion:(0,s.$Qj)("comment-discussion",60103),creditCard:(0,s.$Qj)("credit-card",60105),dash:(0,s.$Qj)("dash",60108),dashboard:(0,s.$Qj)("dashboard",60109),database:(0,s.$Qj)("database",60110),debugContinue:(0,s.$Qj)("debug-continue",60111),debugDisconnect:(0,s.$Qj)("debug-disconnect",60112),debugPause:(0,s.$Qj)("debug-pause",60113),debugRestart:(0,s.$Qj)("debug-restart",60114),debugStart:(0,s.$Qj)("debug-start",60115),debugStepInto:(0,s.$Qj)("debug-step-into",60116),debugStepOut:(0,s.$Qj)("debug-step-out",60117),debugStepOver:(0,s.$Qj)("debug-step-over",60118),debugStop:(0,s.$Qj)("debug-stop",60119),debug:(0,s.$Qj)("debug",60120),deviceCameraVideo:(0,s.$Qj)("device-camera-video",60121),deviceCamera:(0,s.$Qj)("device-camera",60122),deviceMobile:(0,s.$Qj)("device-mobile",60123),diffAdded:(0,s.$Qj)("diff-added",60124),diffIgnored:(0,s.$Qj)("diff-ignored",60125),diffModified:(0,s.$Qj)("diff-modified",60126),diffRemoved:(0,s.$Qj)("diff-removed",60127),diffRenamed:(0,s.$Qj)("diff-renamed",60128),diff:(0,s.$Qj)("diff",60129),diffSidebyside:(0,s.$Qj)("diff-sidebyside",60129),discard:(0,s.$Qj)("discard",60130),editorLayout:(0,s.$Qj)("editor-layout",60131),emptyWindow:(0,s.$Qj)("empty-window",60132),exclude:(0,s.$Qj)("exclude",60133),extensions:(0,s.$Qj)("extensions",60134),eyeClosed:(0,s.$Qj)("eye-closed",60135),fileBinary:(0,s.$Qj)("file-binary",60136),fileCode:(0,s.$Qj)("file-code",60137),fileMedia:(0,s.$Qj)("file-media",60138),filePdf:(0,s.$Qj)("file-pdf",60139),fileSubmodule:(0,s.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,s.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,s.$Qj)("file-symlink-file",60142),fileZip:(0,s.$Qj)("file-zip",60143),files:(0,s.$Qj)("files",60144),filter:(0,s.$Qj)("filter",60145),flame:(0,s.$Qj)("flame",60146),foldDown:(0,s.$Qj)("fold-down",60147),foldUp:(0,s.$Qj)("fold-up",60148),fold:(0,s.$Qj)("fold",60149),folderActive:(0,s.$Qj)("folder-active",60150),folderOpened:(0,s.$Qj)("folder-opened",60151),gear:(0,s.$Qj)("gear",60152),gift:(0,s.$Qj)("gift",60153),gistSecret:(0,s.$Qj)("gist-secret",60154),gist:(0,s.$Qj)("gist",60155),gitCommit:(0,s.$Qj)("git-commit",60156),gitCompare:(0,s.$Qj)("git-compare",60157),compareChanges:(0,s.$Qj)("compare-changes",60157),gitMerge:(0,s.$Qj)("git-merge",60158),githubAction:(0,s.$Qj)("github-action",60159),githubAlt:(0,s.$Qj)("github-alt",60160),globe:(0,s.$Qj)("globe",60161),grabber:(0,s.$Qj)("grabber",60162),graph:(0,s.$Qj)("graph",60163),gripper:(0,s.$Qj)("gripper",60164),heart:(0,s.$Qj)("heart",60165),home:(0,s.$Qj)("home",60166),horizontalRule:(0,s.$Qj)("horizontal-rule",60167),hubot:(0,s.$Qj)("hubot",60168),inbox:(0,s.$Qj)("inbox",60169),issueReopened:(0,s.$Qj)("issue-reopened",60171),issues:(0,s.$Qj)("issues",60172),italic:(0,s.$Qj)("italic",60173),jersey:(0,s.$Qj)("jersey",60174),json:(0,s.$Qj)("json",60175),kebabVertical:(0,s.$Qj)("kebab-vertical",60176),key:(0,s.$Qj)("key",60177),law:(0,s.$Qj)("law",60178),lightbulbAutofix:(0,s.$Qj)("lightbulb-autofix",60179),linkExternal:(0,s.$Qj)("link-external",60180),link:(0,s.$Qj)("link",60181),listOrdered:(0,s.$Qj)("list-ordered",60182),listUnordered:(0,s.$Qj)("list-unordered",60183),liveShare:(0,s.$Qj)("live-share",60184),loading:(0,s.$Qj)("loading",60185),location:(0,s.$Qj)("location",60186),mailRead:(0,s.$Qj)("mail-read",60187),mail:(0,s.$Qj)("mail",60188),markdown:(0,s.$Qj)("markdown",60189),megaphone:(0,s.$Qj)("megaphone",60190),mention:(0,s.$Qj)("mention",60191),milestone:(0,s.$Qj)("milestone",60192),gitPullRequestMilestone:(0,s.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,s.$Qj)("mortar-board",60193),move:(0,s.$Qj)("move",60194),multipleWindows:(0,s.$Qj)("multiple-windows",60195),mute:(0,s.$Qj)("mute",60196),noNewline:(0,s.$Qj)("no-newline",60197),note:(0,s.$Qj)("note",60198),octoface:(0,s.$Qj)("octoface",60199),openPreview:(0,s.$Qj)("open-preview",60200),package:(0,s.$Qj)("package",60201),paintcan:(0,s.$Qj)("paintcan",60202),pin:(0,s.$Qj)("pin",60203),play:(0,s.$Qj)("play",60204),run:(0,s.$Qj)("run",60204),plug:(0,s.$Qj)("plug",60205),preserveCase:(0,s.$Qj)("preserve-case",60206),preview:(0,s.$Qj)("preview",60207),project:(0,s.$Qj)("project",60208),pulse:(0,s.$Qj)("pulse",60209),question:(0,s.$Qj)("question",60210),quote:(0,s.$Qj)("quote",60211),radioTower:(0,s.$Qj)("radio-tower",60212),reactions:(0,s.$Qj)("reactions",60213),references:(0,s.$Qj)("references",60214),refresh:(0,s.$Qj)("refresh",60215),regex:(0,s.$Qj)("regex",60216),remoteExplorer:(0,s.$Qj)("remote-explorer",60217),remote:(0,s.$Qj)("remote",60218),remove:(0,s.$Qj)("remove",60219),replaceAll:(0,s.$Qj)("replace-all",60220),replace:(0,s.$Qj)("replace",60221),repoClone:(0,s.$Qj)("repo-clone",60222),repoForcePush:(0,s.$Qj)("repo-force-push",60223),repoPull:(0,s.$Qj)("repo-pull",60224),repoPush:(0,s.$Qj)("repo-push",60225),report:(0,s.$Qj)("report",60226),requestChanges:(0,s.$Qj)("request-changes",60227),rocket:(0,s.$Qj)("rocket",60228),rootFolderOpened:(0,s.$Qj)("root-folder-opened",60229),rootFolder:(0,s.$Qj)("root-folder",60230),rss:(0,s.$Qj)("rss",60231),ruby:(0,s.$Qj)("ruby",60232),saveAll:(0,s.$Qj)("save-all",60233),saveAs:(0,s.$Qj)("save-as",60234),save:(0,s.$Qj)("save",60235),screenFull:(0,s.$Qj)("screen-full",60236),screenNormal:(0,s.$Qj)("screen-normal",60237),searchStop:(0,s.$Qj)("search-stop",60238),server:(0,s.$Qj)("server",60240),settingsGear:(0,s.$Qj)("settings-gear",60241),settings:(0,s.$Qj)("settings",60242),shield:(0,s.$Qj)("shield",60243),smiley:(0,s.$Qj)("smiley",60244),sortPrecedence:(0,s.$Qj)("sort-precedence",60245),splitHorizontal:(0,s.$Qj)("split-horizontal",60246),splitVertical:(0,s.$Qj)("split-vertical",60247),squirrel:(0,s.$Qj)("squirrel",60248),starFull:(0,s.$Qj)("star-full",60249),starHalf:(0,s.$Qj)("star-half",60250),symbolClass:(0,s.$Qj)("symbol-class",60251),symbolColor:(0,s.$Qj)("symbol-color",60252),symbolConstant:(0,s.$Qj)("symbol-constant",60253),symbolEnumMember:(0,s.$Qj)("symbol-enum-member",60254),symbolField:(0,s.$Qj)("symbol-field",60255),symbolFile:(0,s.$Qj)("symbol-file",60256),symbolInterface:(0,s.$Qj)("symbol-interface",60257),symbolKeyword:(0,s.$Qj)("symbol-keyword",60258),symbolMisc:(0,s.$Qj)("symbol-misc",60259),symbolOperator:(0,s.$Qj)("symbol-operator",60260),symbolProperty:(0,s.$Qj)("symbol-property",60261),wrench:(0,s.$Qj)("wrench",60261),wrenchSubaction:(0,s.$Qj)("wrench-subaction",60261),symbolSnippet:(0,s.$Qj)("symbol-snippet",60262),tasklist:(0,s.$Qj)("tasklist",60263),telescope:(0,s.$Qj)("telescope",60264),textSize:(0,s.$Qj)("text-size",60265),threeBars:(0,s.$Qj)("three-bars",60266),thumbsdown:(0,s.$Qj)("thumbsdown",60267),thumbsup:(0,s.$Qj)("thumbsup",60268),tools:(0,s.$Qj)("tools",60269),triangleDown:(0,s.$Qj)("triangle-down",60270),triangleLeft:(0,s.$Qj)("triangle-left",60271),triangleRight:(0,s.$Qj)("triangle-right",60272),triangleUp:(0,s.$Qj)("triangle-up",60273),twitter:(0,s.$Qj)("twitter",60274),unfold:(0,s.$Qj)("unfold",60275),unlock:(0,s.$Qj)("unlock",60276),unmute:(0,s.$Qj)("unmute",60277),unverified:(0,s.$Qj)("unverified",60278),verified:(0,s.$Qj)("verified",60279),versions:(0,s.$Qj)("versions",60280),vmActive:(0,s.$Qj)("vm-active",60281),vmOutline:(0,s.$Qj)("vm-outline",60282),vmRunning:(0,s.$Qj)("vm-running",60283),watch:(0,s.$Qj)("watch",60284),whitespace:(0,s.$Qj)("whitespace",60285),wholeWord:(0,s.$Qj)("whole-word",60286),window:(0,s.$Qj)("window",60287),wordWrap:(0,s.$Qj)("word-wrap",60288),zoomIn:(0,s.$Qj)("zoom-in",60289),zoomOut:(0,s.$Qj)("zoom-out",60290),listFilter:(0,s.$Qj)("list-filter",60291),listFlat:(0,s.$Qj)("list-flat",60292),listSelection:(0,s.$Qj)("list-selection",60293),selection:(0,s.$Qj)("selection",60293),listTree:(0,s.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,s.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,s.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,s.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,s.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,s.$Qj)("symbol-string",60301),debugReverseContinue:(0,s.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,s.$Qj)("debug-step-back",60303),debugRestartFrame:(0,s.$Qj)("debug-restart-frame",60304),debugAlt:(0,s.$Qj)("debug-alt",60305),callIncoming:(0,s.$Qj)("call-incoming",60306),callOutgoing:(0,s.$Qj)("call-outgoing",60307),menu:(0,s.$Qj)("menu",60308),expandAll:(0,s.$Qj)("expand-all",60309),feedback:(0,s.$Qj)("feedback",60310),gitPullRequestReviewer:(0,s.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,s.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,s.$Qj)("ungroup-by-ref-type",60312),account:(0,s.$Qj)("account",60313),gitPullRequestAssignee:(0,s.$Qj)("git-pull-request-assignee",60313),bellDot:(0,s.$Qj)("bell-dot",60314),debugConsole:(0,s.$Qj)("debug-console",60315),library:(0,s.$Qj)("library",60316),output:(0,s.$Qj)("output",60317),runAll:(0,s.$Qj)("run-all",60318),syncIgnored:(0,s.$Qj)("sync-ignored",60319),pinned:(0,s.$Qj)("pinned",60320),githubInverted:(0,s.$Qj)("github-inverted",60321),serverProcess:(0,s.$Qj)("server-process",60322),serverEnvironment:(0,s.$Qj)("server-environment",60323),pass:(0,s.$Qj)("pass",60324),issueClosed:(0,s.$Qj)("issue-closed",60324),stopCircle:(0,s.$Qj)("stop-circle",60325),playCircle:(0,s.$Qj)("play-circle",60326),record:(0,s.$Qj)("record",60327),debugAltSmall:(0,s.$Qj)("debug-alt-small",60328),vmConnect:(0,s.$Qj)("vm-connect",60329),cloud:(0,s.$Qj)("cloud",60330),merge:(0,s.$Qj)("merge",60331),export:(0,s.$Qj)("export",60332),graphLeft:(0,s.$Qj)("graph-left",60333),magnet:(0,s.$Qj)("magnet",60334),notebook:(0,s.$Qj)("notebook",60335),redo:(0,s.$Qj)("redo",60336),checkAll:(0,s.$Qj)("check-all",60337),pinnedDirty:(0,s.$Qj)("pinned-dirty",60338),passFilled:(0,s.$Qj)("pass-filled",60339),circleLargeFilled:(0,s.$Qj)("circle-large-filled",60340),circleLarge:(0,s.$Qj)("circle-large",60341),circleLargeOutline:(0,s.$Qj)("circle-large-outline",60341),combine:(0,s.$Qj)("combine",60342),gather:(0,s.$Qj)("gather",60342),table:(0,s.$Qj)("table",60343),variableGroup:(0,s.$Qj)("variable-group",60344),typeHierarchy:(0,s.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,s.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.$Qj)("git-pull-request-create",60348),runAbove:(0,s.$Qj)("run-above",60349),runBelow:(0,s.$Qj)("run-below",60350),notebookTemplate:(0,s.$Qj)("notebook-template",60351),debugRerun:(0,s.$Qj)("debug-rerun",60352),workspaceTrusted:(0,s.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,s.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,s.$Qj)("workspace-unknown",60355),terminalCmd:(0,s.$Qj)("terminal-cmd",60356),terminalDebian:(0,s.$Qj)("terminal-debian",60357),terminalLinux:(0,s.$Qj)("terminal-linux",60358),terminalPowershell:(0,s.$Qj)("terminal-powershell",60359),terminalTmux:(0,s.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,s.$Qj)("terminal-ubuntu",60361),terminalBash:(0,s.$Qj)("terminal-bash",60362),arrowSwap:(0,s.$Qj)("arrow-swap",60363),copy:(0,s.$Qj)("copy",60364),personAdd:(0,s.$Qj)("person-add",60365),filterFilled:(0,s.$Qj)("filter-filled",60366),wand:(0,s.$Qj)("wand",60367),debugLineByLine:(0,s.$Qj)("debug-line-by-line",60368),inspect:(0,s.$Qj)("inspect",60369),layers:(0,s.$Qj)("layers",60370),layersDot:(0,s.$Qj)("layers-dot",60371),layersActive:(0,s.$Qj)("layers-active",60372),compass:(0,s.$Qj)("compass",60373),compassDot:(0,s.$Qj)("compass-dot",60374),compassActive:(0,s.$Qj)("compass-active",60375),azure:(0,s.$Qj)("azure",60376),issueDraft:(0,s.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,s.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.$Qj)("git-pull-request-draft",60379),debugAll:(0,s.$Qj)("debug-all",60380),debugCoverage:(0,s.$Qj)("debug-coverage",60381),runErrors:(0,s.$Qj)("run-errors",60382),folderLibrary:(0,s.$Qj)("folder-library",60383),debugContinueSmall:(0,s.$Qj)("debug-continue-small",60384),beakerStop:(0,s.$Qj)("beaker-stop",60385),graphLine:(0,s.$Qj)("graph-line",60386),graphScatter:(0,s.$Qj)("graph-scatter",60387),pieChart:(0,s.$Qj)("pie-chart",60388),bracket:(0,s.$Qj)("bracket",60175),bracketDot:(0,s.$Qj)("bracket-dot",60389),bracketError:(0,s.$Qj)("bracket-error",60390),lockSmall:(0,s.$Qj)("lock-small",60391),azureDevops:(0,s.$Qj)("azure-devops",60392),verifiedFilled:(0,s.$Qj)("verified-filled",60393),newline:(0,s.$Qj)("newline",60394),layout:(0,s.$Qj)("layout",60395),layoutActivitybarLeft:(0,s.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,s.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,s.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,s.$Qj)("layout-panel-right",60401),layoutPanel:(0,s.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,s.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,s.$Qj)("layout-statusbar",60405),layoutMenubar:(0,s.$Qj)("layout-menubar",60406),layoutCentered:(0,s.$Qj)("layout-centered",60407),target:(0,s.$Qj)("target",60408),indent:(0,s.$Qj)("indent",60409),recordSmall:(0,s.$Qj)("record-small",60410),errorSmall:(0,s.$Qj)("error-small",60411),terminalDecorationError:(0,s.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,s.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,s.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,s.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,s.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.$Qj)("layout-sidebar-left-off",60418),blank:(0,s.$Qj)("blank",60419),heartFilled:(0,s.$Qj)("heart-filled",60420),map:(0,s.$Qj)("map",60421),mapHorizontal:(0,s.$Qj)("map-horizontal",60421),foldHorizontal:(0,s.$Qj)("fold-horizontal",60421),mapFilled:(0,s.$Qj)("map-filled",60422),mapHorizontalFilled:(0,s.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,s.$Qj)("circle-small",60423),bellSlash:(0,s.$Qj)("bell-slash",60424),bellSlashDot:(0,s.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,s.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.$Qj)("search-fuzzy",60429),commentDraft:(0,s.$Qj)("comment-draft",60430),send:(0,s.$Qj)("send",60431),sparkle:(0,s.$Qj)("sparkle",60432),insert:(0,s.$Qj)("insert",60433),mic:(0,s.$Qj)("mic",60434),thumbsdownFilled:(0,s.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,s.$Qj)("thumbsup-filled",60436),coffee:(0,s.$Qj)("coffee",60437),snake:(0,s.$Qj)("snake",60438),game:(0,s.$Qj)("game",60439),vr:(0,s.$Qj)("vr",60440),chip:(0,s.$Qj)("chip",60441),piano:(0,s.$Qj)("piano",60442),music:(0,s.$Qj)("music",60443),micFilled:(0,s.$Qj)("mic-filled",60444),repoFetch:(0,s.$Qj)("repo-fetch",60445),copilot:(0,s.$Qj)("copilot",60446),lightbulbSparkle:(0,s.$Qj)("lightbulb-sparkle",60447),robot:(0,s.$Qj)("robot",60448),sparkleFilled:(0,s.$Qj)("sparkle-filled",60449),diffSingle:(0,s.$Qj)("diff-single",60450),diffMultiple:(0,s.$Qj)("diff-multiple",60451),surroundWith:(0,s.$Qj)("surround-with",60452),share:(0,s.$Qj)("share",60453),gitStash:(0,s.$Qj)("git-stash",60454),gitStashApply:(0,s.$Qj)("git-stash-apply",60455),gitStashPop:(0,s.$Qj)("git-stash-pop",60456),vscode:(0,s.$Qj)("vscode",60457),vscodeInsiders:(0,s.$Qj)("vscode-insiders",60458),codeOss:(0,s.$Qj)("code-oss",60459),runCoverage:(0,s.$Qj)("run-coverage",60460),runAllCoverage:(0,s.$Qj)("run-all-coverage",60461),coverage:(0,s.$Qj)("coverage",60462),githubProject:(0,s.$Qj)("github-project",60463),mapVertical:(0,s.$Qj)("map-vertical",60464),foldVertical:(0,s.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,s.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,s.$Qj)("fold-vertical-filled",60465),goToSearch:(0,s.$Qj)("go-to-search",60466),percentage:(0,s.$Qj)("percentage",60467),sortPercentage:(0,s.$Qj)("sort-percentage",60467)}}),define(ye[53],Ee([1,0,101,161]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=D;function D(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,s.$Qj)("dialog-error","error"),dialogWarning:(0,s.$Qj)("dialog-warning","warning"),dialogInfo:(0,s.$Qj)("dialog-info","info"),dialogClose:(0,s.$Qj)("dialog-close","close"),treeItemExpanded:(0,s.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,s.$Qj)("tree-item-loading","loading"),menuSelection:(0,s.$Qj)("menu-selection","check"),menuSubmenu:(0,s.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,s.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,s.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.$Qj)("toolbar-more","more"),quickInputBack:(0,s.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,s.$Qj)("drop-down-button",60084),symbolCustomColor:(0,s.$Qj)("symbol-customcolor",60252),exportIcon:(0,s.$Qj)("export",60332),workspaceUnspecified:(0,s.$Qj)("workspace-unspecified",60355),newLine:(0,s.$Qj)("newline",60394),thumbsDownFilled:(0,s.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.$Qj)("thumbsup-filled",60436),gitFetch:(0,s.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...C.$Sj,...e.$Uj}}),define(ye[35],Ee([1,0,7,3,17,10]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=I,e.$pg=S,e.$qg=w,e.$rg=g,e.$sg=y,e.$tg=u,e.$ug=a,e.$vg=f,e.$wg=c,e.$xg=d,e.$yg=$,e.$zg=E,e.$Ag=h,e.$Bg=t,e.$Cg=o,e.$Dg=r,e.$Eg=l;function I(p){return p===47||p===92}function S(p){return p.replace(/[\\/]/g,s.$hc.sep)}function w(p){return p.indexOf("/")===-1&&(p=S(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function g(p,P=s.$hc.sep){if(!p)return"";const j=p.length,O=p.charCodeAt(0);if(I(O)){if(I(p.charCodeAt(1))&&!I(p.charCodeAt(2))){let A=3;const B=A;for(;A<j&&!I(p.charCodeAt(A));A++);if(B!==A&&!I(p.charCodeAt(A+1))){for(A+=1;A<j;A++)if(I(p.charCodeAt(A)))return p.slice(0,A+1).replace(/[\\/]/g,P)}}return P}else if(c(O)&&p.charCodeAt(1)===58)return I(p.charCodeAt(2))?p.slice(0,2)+P:p.slice(0,2);let R=p.indexOf("://");if(R!==-1){for(R+=3;R<j;R++)if(I(p.charCodeAt(R)))return p.slice(0,R+1)}return""}function y(p){if(!C.$c||!p||p.length<5)return!1;let P=p.charCodeAt(0);if(P!==92||(P=p.charCodeAt(1),P!==92))return!1;let j=2;const O=j;for(;j<p.length&&(P=p.charCodeAt(j),P!==92);j++);return!(O===j||(P=p.charCodeAt(j+1),isNaN(P)||P===92))}const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(p,P=C.$c){const j=P?v:b;return!(!p||p.length===0||/^\s+$/.test(p)||(j.lastIndex=0,j.test(p))||P&&m.test(p)||p==="."||p===".."||P&&p[p.length-1]==="."||P&&p.length!==p.trim().length||p.length>255)}function a(p,P,j){const O=p===P;return!j||O?O:!p||!P?!1:(0,D.$yf)(p,P)}function f(p,P,j,O=s.sep){if(p===P)return!0;if(!p||!P||P.length>p.length)return!1;if(j){if(!(0,D.$zf)(p,P))return!1;if(P.length===p.length)return!0;let A=P.length;return P.charAt(P.length-1)===O&&A--,p.charAt(A)===O}return P.charAt(P.length-1)!==O&&(P+=O),p.indexOf(P)===0}function c(p){return p>=65&&p<=90||p>=97&&p<=122}function d(p,P){return C.$c&&p.endsWith(":")&&(p+=s.sep),(0,s.$jc)(p)||(p=(0,s.$kc)(P,p)),p=(0,s.$ic)(p),$(p)}function $(p){return C.$c?(p=(0,D.$gf)(p,s.sep),p.endsWith(":")&&(p+=s.sep)):(p=(0,D.$gf)(p,s.sep),p||(p=s.sep)),p}function E(p){const P=(0,s.$ic)(p);return C.$c?p.length>3?!1:h(P)&&(p.length===2||P.charCodeAt(2)===92):P===s.$hc.sep}function h(p,P=C.$c){return P?c(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function t(p,P=C.$c){return h(p,P)?p[0]:void 0}function o(p,P,j){return P.length>p.length?-1:p===P?0:(j&&(p=p.toLowerCase(),P=P.toLowerCase()),p.indexOf(P))}function r(p){const P=p.split(":");let j,O,R;for(const A of P){const B=Number(A);(0,k.$ag)(B)?O===void 0?O=B:R===void 0&&(R=B):j=j?[j,A].join(":"):A}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:O!==void 0?O:void 0,column:R!==void 0?R:O!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(p,P,j=8){let O="";for(let A=0;A<j;A++){let B;A===0&&C.$c&&!P&&(j===3||j===4)?B=n:B=i,O+=B.charAt(Math.floor(Math.random()*B.length))}let R;return P?R=`${P}-${O}`:R=O,p?(0,s.$kc)(p,R):R}}),define(ye[21],Ee([1,0,10]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=C,e.$5n=D,e.$6n=I,e.$7n=w,e.$8n=g,e.$9n=y,e.$0n=v,e.$$n=b,e.$_n=m,e.$ao=u,e.$bo=a,e.$co=f;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const d=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,E])=>{d[$]=E&&typeof E=="object"?C(E):E}),d}function D(c){if(!c||typeof c!="object")return c;const d=[c];for(;d.length>0;){const $=d.shift();Object.freeze($);for(const E in $)if(k.call($,E)){const h=$[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,s.$_f)(h)&&d.push(h)}}return c}const k=Object.prototype.hasOwnProperty;function I(c,d){return S(c,d,new Set)}function S(c,d,$){if((0,s.$fg)(c))return c;const E=d(c);if(typeof E<"u")return E;if(Array.isArray(c)){const h=[];for(const t of c)h.push(S(t,d,$));return h}if((0,s.$$f)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const h={};for(const t in c)k.call(c,t)&&(h[t]=S(c[t],d,$));return $.delete(c),h}return c}function w(c,d,$=!0){return(0,s.$$f)(c)?((0,s.$$f)(d)&&Object.keys(d).forEach(E=>{E in c?$&&((0,s.$$f)(c[E])&&(0,s.$$f)(d[E])?w(c[E],d[E],$):c[E]=d[E]):c[E]=d[E]}),c):d}function g(c,d){if(c===d)return!0;if(c==null||d===null||d===void 0||typeof c!=typeof d||typeof c!="object"||Array.isArray(c)!==Array.isArray(d))return!1;let $,E;if(Array.isArray(c)){if(c.length!==d.length)return!1;for($=0;$<c.length;$++)if(!g(c[$],d[$]))return!1}else{const h=[];for(E in c)h.push(E);h.sort();const t=[];for(E in d)t.push(E);if(t.sort(),!g(h,t))return!1;for($=0;$<h.length;$++)if(!g(c[h[$]],d[h[$]]))return!1}return!0}function y(c){const d=new Set;return JSON.stringify(c,($,E)=>{if((0,s.$$f)(E)||Array.isArray(E)){if(d.has(E))return"[Circular]";d.add(E)}return typeof E=="bigint"?`[BigInt ${E.toString()}]`:E})}function v(c,d){const $=Object.create(null);return!c||!d||Object.keys(d).forEach(h=>{const t=c[h],o=d[h];g(t,o)||($[h]=o)}),$}function b(c,d){const $=d.toLowerCase(),E=Object.keys(c).find(h=>h.toLowerCase()===$);return E?c[E]:c[d]}function m(c,d){const $=Object.create(null);for(const[E,h]of Object.entries(c))d(E,h)&&($[E]=h);return $}function u(c){let d=[];for(;Object.prototype!==c;)d=d.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return d}function a(c){const d=[];for(const $ of u(c))typeof c[$]=="function"&&d.push($);return d}function f(c,d){const $=h=>function(){const t=Array.prototype.slice.call(arguments,0);return d(h,t)},E={};for(const h of c)E[h]=$(h);return E}}),define(ye[76],Ee([1,0,53]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=D;var C;(function(I){function S(w){return w&&typeof w=="object"&&typeof w.id=="string"}I.isThemeColor=S})(C||(e.ThemeColor=C={}));function D(I){return{id:I}}var k;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function w(d){const $=S.exec(d.id);if(!$)return w(s.$Vj.error);const[,E,h]=$,t=["codicon","codicon-"+E];return h&&t.push("codicon-modifier-"+h.substring(1)),t}I.asClassNameArray=w;function g(d){return w(d).join(" ")}I.asClassName=g;function y(d){return"."+w(d).join(".")}I.asCSSSelector=y;function v(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||C.isThemeColor(d.color))}I.isThemeIcon=v;const b=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function m(d){const $=b.exec(d);if(!$)return;const[,E]=$;return{id:E}}I.fromString=m;function u(d){return{id:d}}I.fromId=u;function a(d,$){let E=d.id;const h=E.lastIndexOf("~");return h!==-1&&(E=E.substring(0,h)),$&&(E=`${E}~${$}`),{id:E}}I.modify=a;function f(d){const $=d.id.lastIndexOf("~");if($!==-1)return d.id.substring($+1)}I.getModifier=f;function c(d,$){return d.id===$.id&&d.color?.id===$.color?.id}I.isEqual=c})(k||(e.ThemeIcon=k={}))}),define(ye[162],Ee([1,0,159,17,76]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=w,e.$Ok=y,e.$Pk=b,e.$Qk=m,e.$Rk=a,e.$Sk=f;const k="$(",I=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${I.source}`,"g");function w(c){return c.replace(S,(d,$)=>$?d:`\\${d}`)}const g=new RegExp(`\\\\${I.source}`,"g");function y(c){return c.replace(g,d=>`\\${d}`)}const v=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function b(c){return c.indexOf(k)===-1?c:c.replace(v,(d,$,E,h)=>E?d:$||h||"")}function m(c){return c?c.replace(/\$\((.*?)\)/g,(d,$)=>` ${$} `).trim():""}const u=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(c){u.lastIndex=0;let d="";const $=[];let E=0;for(;;){const h=u.lastIndex,t=u.exec(c),o=c.substring(h,t?.index);if(o.length>0){d+=o;for(let r=0;r<o.length;r++)$.push(E)}if(!t)break;E+=t[0].length}return{text:d,iconOffsets:$}}function f(c,d,$=!1){const{text:E,iconOffsets:h}=d;if(!h||h.length===0)return(0,s.$Ek)(c,E,$);const t=(0,C.$ff)(E," "),o=E.length-t.length,r=(0,s.$Ek)(c,t,$);if(r)for(const i of r){const n=h[i.start+o]+o;i.start+=n,i.end+=n}return r}}),define(ye[4],Ee([1,0,7,3]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=u,e.$xc=E;const D=/^\w[\w\d+.-]*$/,k=/^\//,I=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,n){return!i&&!n?"file":i}function g(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const y="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,p,P,j,O=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=w(n,O),this.authority=l||y,this.path=g(this.scheme,p||y),this.query=P||y,this.fragment=j||y,S(this,O))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:p,path:P,query:j,fragment:O}=n;return l===void 0?l=this.scheme:l===null&&(l=y),p===void 0?p=this.authority:p===null&&(p=y),P===void 0?P=this.path:P===null&&(P=y),j===void 0?j=this.query:j===null&&(j=y),O===void 0?O=this.fragment:O===null&&(O=y),l===this.scheme&&p===this.authority&&P===this.path&&j===this.query&&O===this.fragment?this:new f(l,p,P,j,O)}static parse(n,l=!1){const p=b.exec(n);return p?new f(p[2]||y,r(p[4]||y),r(p[5]||y),r(p[7]||y),r(p[9]||y),l):new f(y,y,y,y,y)}static file(n){let l=y;if(C.$c&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const p=n.indexOf(v,2);p===-1?(l=n.substring(2),n=v):(l=n.substring(2,p),n=n.substring(p)||v)}return new f("file",l,n,y,y)}static from(n,l){return new f(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return C.$c&&n.scheme==="file"?p=m.file(s.$gc.join(E(n,!0),...l)).path:p=s.$hc.join(n.path,...l),n.with({path:p})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const l=new f(n);return l._formatted=n.external??null,l._fsPath=n._sep===a?n.fsPath??null:null,l}}else return n}}e.URI=m;function u(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const a=C.$c?1:void 0;class f extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=a),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(i,n,l){let p,P=-1;for(let j=0;j<i.length;j++){const O=i.charCodeAt(j);if(O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57||O===45||O===46||O===95||O===126||n&&O===47||l&&O===91||l&&O===93||l&&O===58)P!==-1&&(p+=encodeURIComponent(i.substring(P,j)),P=-1),p!==void 0&&(p+=i.charAt(j));else{p===void 0&&(p=i.substr(0,j));const R=c[O];R!==void 0?(P!==-1&&(p+=encodeURIComponent(i.substring(P,j)),P=-1),p+=R):P===-1&&(P=j)}}return P!==-1&&(p+=encodeURIComponent(i.substring(P))),p!==void 0?p:i}function $(i){let n;for(let l=0;l<i.length;l++){const p=i.charCodeAt(l);p===35||p===63?(n===void 0&&(n=i.substr(0,l)),n+=c[p]):n!==void 0&&(n+=i[l])}return n!==void 0?n:i}function E(i,n){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,C.$c&&(l=l.replace(/\//g,"\\")),l}function h(i,n){const l=n?$:d;let p="",{scheme:P,authority:j,path:O,query:R,fragment:A}=i;if(P&&(p+=P,p+=":"),(j||P==="file")&&(p+=v,p+=v),j){let B=j.indexOf("@");if(B!==-1){const G=j.substr(0,B);j=j.substr(B+1),B=G.lastIndexOf(":"),B===-1?p+=l(G,!1,!1):(p+=l(G.substr(0,B),!1,!1),p+=":",p+=l(G.substr(B+1),!1,!0)),p+="@"}j=j.toLowerCase(),B=j.lastIndexOf(":"),B===-1?p+=l(j,!1,!0):(p+=l(j.substr(0,B),!1,!0),p+=j.substr(B))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const B=O.charCodeAt(1);B>=65&&B<=90&&(O=`/${String.fromCharCode(B+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const B=O.charCodeAt(0);B>=65&&B<=90&&(O=`${String.fromCharCode(B+32)}:${O.substr(2)}`)}p+=l(O,!0,!1)}return R&&(p+="?",p+=l(R,!1,!1)),A&&(p+="#",p+=n?A:d(A,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(ye[163],Ee([1,0,4]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=C,e.$Xq=D,e.$Yq=k,e.log=S;function C(g){const y=g;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function D(g){const y=[];let v;try{const b=JSON.parse(g.arguments),m=b[b.length-1];m&&m.__$stack&&(b.pop(),v=m.__$stack),y.push(...b)}catch{y.push("Unable to log remote console arguments",g.arguments)}return{args:y,stack:v}}function k(g){if(typeof g!="string")return k(D(g).stack);const y=g;if(y){const v=I(y),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:s.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function I(g){if(!g)return g;const y=g.indexOf(`
`);return y===-1?g:g.substring(0,y)}function S(g,y){const{args:v,stack:b}=D(g),m=typeof v[0]=="string"&&v.length===1;let u=I(b);u&&(u=`(${u.trim()})`);let a=[];if(typeof v[0]=="string"?u&&m?a=[`%c[${y}] %c${v[0]} %c${u}`,w("blue"),w(""),w("grey")]:a=[`%c[${y}] %c${v[0]}`,w("blue"),w(""),...v.slice(1)]:a=[`%c[${y}]%`,w("blue"),...v],u&&!m&&a.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,a)}function w(g){return`color: ${g}`}}),define(ye[54],Ee([1,0,15,4]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=D,e.$5h=k,e.$6h=S;function D(w){return JSON.stringify(w,I)}function k(w){let g=JSON.parse(w);return g=S(g),g}function I(w,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function S(w,g=0){if(!w||g>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return C.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 17:return new Date(w.source)}if(w instanceof s.$Ge||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let y=0;y<w.length;++y)w[y]=S(w[y],g+1);else for(const y in w)Object.hasOwnProperty.call(w,y)&&(w[y]=S(w[y],g+1))}return w}}),define(ye[13],Ee([1,0,11,3,17,4,7]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=w,e.$Gg=g,e.$Kg=v;var S;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.commentsInput="comment",u.codeSetting="code-setting"})(S||(e.Schemas=S={}));function w(u,a){return k.URI.isUri(u)?(0,D.$yf)(u.scheme,a):(0,D.$zf)(u,a+":")}function g(u,...a){return a.some(f=>w(u,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,f){this.f=v(a,f)}getServerRootPath(){return this.f}get g(){return I.$hc.join(this.f,S.vscodeRemoteResource)}set(a,f,c){this.a[a]=f,this.b[a]=c}setConnectionToken(a,f){this.c[a]=f}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(h){return s.$1(h),a}const f=a.authority;let c=this.a[f];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const d=this.b[f],$=this.c[f];let E=`path=${encodeURIComponent(a.path)}`;return typeof $=="string"&&(E+=`&${e.$Ig}=${encodeURIComponent($)}`),k.URI.from({scheme:C.$i?this.d:S.vscodeRemoteResource,authority:`${c}:${d}`,path:C.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:E})}}e.$Jg=new y;function v(u,a){return I.$hc.join(a??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class b{asBrowserUri(a){const f=this.b(a,ue);return this.uriToBrowserUri(f)}uriToBrowserUri(a){return a.scheme===S.vscodeRemote?e.$Jg.rewrite(a):a.scheme===S.file&&(C.$g||C.$k===`${S.vscodeFileResource}://${b.a}`)?a.with({scheme:S.vscodeFileResource,authority:a.authority||b.a,query:null,fragment:null}):a}asFileUri(a){const f=this.b(a,ue);return this.uriToFileUri(f)}uriToFileUri(a){return a.scheme===S.vscodeFileResource?a.with({scheme:S.file,authority:a.authority!==b.a?a.authority:null,query:null,fragment:null}):a}b(a,f){return k.URI.isUri(a)?a:k.URI.parse(f.toUrl(a))}}b.a=e.$Pg,e.$Qg=new b;var m;(function(u){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(a.get("3"));const f="vscode-coi";function c($){let E;typeof $=="string"?E=new URL($).searchParams:$ instanceof URL?E=$.searchParams:k.URI.isUri($)&&(E=new URL($.toString(!0)).searchParams);const h=E?.get(f);if(h)return a.get(h)}u.getHeadersFromQuery=c;function d($,E,h){if(!globalThis.crossOriginIsolated)return;const t=E&&h?"3":h?"2":"1";$ instanceof URLSearchParams?$.set(f,t):$[f]=t}u.addSearchParam=d})(m||(e.COI=m={}))}),define(ye[164],Ee([1,0,97,13,3,4]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=y;class I{constructor(b,m,u){this.id=b,this.dependencies=m,this.callback=u}}class S{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,m,u)=>{typeof b!="string"&&(u=m,m=b,b=null),(typeof m!="object"||!Array.isArray(m))&&(u=m,m=null),this.c.push(new I(b,m,u))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const m=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!m)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(b){return new Promise((m,u)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const f=()=>{a.removeEventListener("load",c),a.removeEventListener("error",d)},c=$=>{f(),m(this.c.pop())},d=$=>{f(),u($)};a.addEventListener("load",c),a.addEventListener("error",d),this.f&&(b=this.f.createScriptURL(b)),a.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(b){return new Promise((m,u)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),m(this.c.pop())}catch(a){u(a)}})}async j(b){try{const m=globalThis._VSCODE_NODE_MODULES.fs,u=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,f=k.URI.parse(b).fsPath,c=m.readFileSync(f).toString(),d=a.wrap(c.replace(/^#!.*/,""));return new u.Script(d).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}S.INSTANCE=new S;const w=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function y(v,b,m){if(s.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[v]&&(v=g[v]);const u=`${v}/${b}`;if(w.has(u))return w.get(u);let a;if(/^\w[\w\d+.-]*:\/\//.test(u))a=u;else{const $=`${m&&!D.$i?C.$Ng:C.$Mg}/${u}`;a=C.$Qg.asBrowserUri($).toString(!0)}const f=S.INSTANCE.load(a);return w.set(u,f),f}else return await new Promise((u,a)=>{ue([v],u,a)})}}),define(ye[19],Ee([1,0,35,13,7,3,17,4]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=w,e.$gh=y,e.$hh=b;function w(m){return(0,S.$xc)(m,!0)}class g{constructor(u){this.a=u}compare(u,a,f=!1){return u===a?0:(0,I.$rf)(this.getComparisonKey(u,f),this.getComparisonKey(a,f))}isEqual(u,a,f=!1){return u===a?!0:!u||!a?!1:this.getComparisonKey(u,f)===this.getComparisonKey(a,f)}getComparisonKey(u,a=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,a,f=!1){if(u.scheme===a.scheme){if(u.scheme===C.Schemas.file)return s.$vg(w(u),w(a),this.a(u))&&u.query===a.query&&(f||u.fragment===a.fragment);if((0,e.$ch)(u.authority,a.authority))return s.$vg(u.path,a.path,this.a(u),"/")&&u.query===a.query&&(f||u.fragment===a.fragment)}return!1}joinPath(u,...a){return S.URI.joinPath(u,...a)}basenameOrAuthority(u){return(0,e.$7g)(u)||u.authority}basename(u){return D.$hc.basename(u.path)}extname(u){return D.$hc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let a;return u.scheme===C.Schemas.file?a=S.URI.file(D.$nc(w(u))).path:(a=D.$hc.dirname(u.path),u.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),a="/")),u.with({path:a})}normalizePath(u){if(!u.path.length)return u;let a;return u.scheme===C.Schemas.file?a=S.URI.file(D.$ic(w(u))).path:a=D.$hc.normalize(u.path),u.with({path:a})}relativePath(u,a){if(u.scheme!==a.scheme||!(0,e.$ch)(u.authority,a.authority))return;if(u.scheme===C.Schemas.file){const d=D.$mc(w(u),w(a));return k.$c?s.$pg(d):d}let f=u.path||"/";const c=a.path||"/";if(this.a(u)){let d=0;for(const $=Math.min(f.length,c.length);d<$&&!(f.charCodeAt(d)!==c.charCodeAt(d)&&f.charAt(d).toLowerCase()!==c.charAt(d).toLowerCase());d++);f=c.substr(0,d)+f.substr(d)}return D.$hc.relative(f,c)}resolvePath(u,a){if(u.scheme===C.Schemas.file){const f=S.URI.file(D.$lc(w(u),a));return u.with({authority:f.authority,path:f.path})}return a=s.$qg(a),u.with({path:D.$hc.resolve(u.path,a)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,a){return u===a||u!==void 0&&a!==void 0&&(0,I.$yf)(u,a)}hasTrailingPathSeparator(u,a=D.sep){if(u.scheme===C.Schemas.file){const f=w(u);return f.length>s.$rg(f).length&&f[f.length-1]===a}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,a=D.sep){return(0,e.$dh)(u,a)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,a=D.sep){let f=!1;if(u.scheme===C.Schemas.file){const c=w(u);f=c!==void 0&&c.length===s.$rg(c).length&&c[c.length-1]===a}else{a="/";const c=u.path;f=c.length===1&&c.charCodeAt(c.length-1)===47}return!f&&!(0,e.$dh)(u,a)?u.with({path:u.path+"/"}):u}}e.$Yg=g,e.$Zg=new g(()=>!1),e.$1g=new g(m=>m.scheme===C.Schemas.file?!k.$e:!0),e.$2g=new g(m=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function y(m,u){const a=[];for(let f=0;f<m.length;f++){const c=u(m[f]);m.some((d,$)=>$===f?!1:(0,e.$4g)(c,u(d)))||a.push(m[f])}return a}var v;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(a){const f=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach($=>{const[E,h]=$.split(":");E&&h&&f.set(E,h)});const d=a.path.substring(0,a.path.indexOf(";"));return d&&f.set(m.META_DATA_MIME,d),f}m.parseMetaData=u})(v||(e.DataUri=v={}));function b(m,u,a){if(u){let f=m.path;return f&&f[0]!==D.$hc.sep&&(f=D.$hc.sep+f),m.with({scheme:a,authority:u,path:f})}return m.with({scheme:a})}}),define(ye[14],Ee([1,0,20,11,6,2,19,3,160,60]),function(ue,e,s,C,D,k,I,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=y,e.$jh=v,e.$kh=b,e.$lh=m,e.$mh=u,e.$nh=a,e.$oh=f,e.$ph=c,e.$xh=l,e.$yh=p,e.$zh=P,e.$Ah=j,e.$Bh=O,e.$Qh=Q,e.$Yh=x;function y(H){return!!H&&typeof H.then=="function"}function v(H){const L=new s.$pe,U=H(L.token),oe=new Promise((le,de)=>{const te=L.token.onCancellationRequested(()=>{te.dispose(),de(new C.$5)});Promise.resolve(U).then(me=>{te.dispose(),L.dispose(),le(me)},me=>{te.dispose(),L.dispose(),de(me)})});return new class{cancel(){L.cancel(),L.dispose()}then(le,de){return oe.then(le,de)}catch(le){return this.then(void 0,le)}finally(le){return oe.finally(le)}}}function b(H,L,U){return new Promise((oe,le)=>{const de=L.onCancellationRequested(()=>{de.dispose(),oe(U)});H.then(oe,le).finally(()=>de.dispose())})}function m(H,L){return new Promise((U,oe)=>{const le=L.onCancellationRequested(()=>{le.dispose(),oe(new C.$5)});H.then(U,oe).finally(()=>le.dispose())})}async function u(H){let L=-1;const U=H.map((oe,le)=>oe.then(de=>(L=le,de)));try{return await Promise.race(U)}finally{H.forEach((oe,le)=>{le!==L&&oe.cancel()})}}function a(H,L,U){let oe;const le=setTimeout(()=>{oe?.(void 0),U?.()},L);return Promise.race([H.finally(()=>clearTimeout(le)),new Promise(de=>oe=de)])}function f(H){return new Promise((L,U)=>{const oe=H();y(oe)?oe.then(L,U):L(oe)})}function c(){let H,L;return{promise:new Promise((oe,le)=>{H=oe,L=le}),resolve:H,reject:L}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=L,!this.b){const U=()=>{if(this.b=null,this.f)return;const oe=this.queue(this.d);return this.d=null,oe};this.b=new Promise(oe=>{this.a.then(U,U).then(oe)})}return new Promise((U,oe)=>{this.b.then(U,oe)})}return this.a=L(),new Promise((U,oe)=>{this.a.then(le=>{this.a=null,U(le)},le=>{this.a=null,oe(le)})})}dispose(){this.f=!0}}e.$qh=d;class ${constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$rh=$;class E{constructor(){this.a=new Map}queue(L,U){const le=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(L)===le&&this.a.delete(L)});return this.a.set(L,le),le}}e.$sh=E;const h=(H,L)=>{let U=!0;const oe=setTimeout(()=>{U=!1,L()},H);return{isTriggered:()=>U,dispose:()=>{clearTimeout(oe),U=!1}}},t=H=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,H())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class o{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,U=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((le,de)=>{this.d=le,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const oe=()=>{this.a=null,this.d?.(null)};return this.a=U===w.$be?t(oe):h(U,oe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=o;class r{constructor(L){this.a=new o(L),this.b=new d}trigger(L,U){return this.a.trigger(()=>this.b.queue(L),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class i{constructor(){this.a=!1,this.b=new Promise((L,U)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=i;class n extends i{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$wh=n;function l(H,L){return L?new Promise((U,oe)=>{const le=setTimeout(()=>{de.dispose(),U()},H),de=L.onCancellationRequested(()=>{clearTimeout(le),de.dispose(),oe(new C.$5)})}):v(U=>l(H,U))}function p(H,L=0,U){const oe=setTimeout(()=>{H(),U&&le.dispose()},L),le=(0,k.$Tc)(()=>{clearTimeout(oe),U?.deleteAndLeak(le)});return U?.add(le),le}function P(H){const L=[];let U=0;const oe=H.length;function le(){return U<oe?H[U++]():null}function de(te){te!=null&&L.push(te);const me=le();return me?me.then(de):Promise.resolve(L)}return Promise.resolve(null).then(de)}function j(H,L=oe=>!!oe,U=null){let oe=0;const le=H.length,de=()=>{if(oe>=le)return Promise.resolve(U);const te=H[oe++];return Promise.resolve(te()).then(pe=>L(pe)?Promise.resolve(pe):de())};return de()}function O(H,L=oe=>!!oe,U=null){if(H.length===0)return Promise.resolve(U);let oe=H.length;const le=()=>{oe=-1;for(const de of H)de.cancel?.()};return new Promise((de,te)=>{for(const me of H)me.then(pe=>{--oe>=0&&L(pe)?(le(),de(pe)):oe===0&&de(U)}).catch(pe=>{--oe>=0&&(le(),te(pe))})})}class R{constructor(L){this.a=0,this.b=!1,this.f=L,this.g=[],this.d=0,this.h=new D.$ee}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(L){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((U,oe)=>{this.g.push({factory:L,c:U,e:oe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const L=this.g.shift();this.d++;const U=L.factory();U.then(L.c,L.e),U.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=R;class A extends R{constructor(){super(1)}}e.$Dh=A;class B{constructor(){this.a=new ae,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$Eh=B;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new ie;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueSize(L,U=I.$Zg){const oe=U.getComparisonKey(L);return this.a.get(oe)?.size??0}queueFor(L,U,oe=I.$Zg){const le=oe.getComparisonKey(L);let de=this.a.get(le);if(!de){de=new A;const te=this.f++,me=D.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(te),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$5c),this.d.set(te,me),this.a.set(le,de)}return de.queue(U)}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=G;class se{constructor(L,U){this.a=-1,typeof L=="function"&&typeof U=="number"&&this.setIfNotSet(L,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},U)}setIfNotSet(L,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},U))}}e.$Gh=se;class ce{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(L,U,oe=globalThis){this.cancel();const le=oe.setInterval(()=>{L()},U);this.d=(0,k.$Tc)(()=>{oe.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=ce;class ee{constructor(L,U){this.b=-1,this.a=L,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=ee;class K{constructor(L,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=L,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=K;class q extends ee{constructor(L,U){super(L,U),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$Kh=q;class X extends k.$Vc{constructor(L,U){super(),this.g=L,this.h=U,this.a=[],this.b=this.B(new k.$Wc),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of L)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(H,L)=>{(0,S.$v)(()=>{if(U)return;const oe=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.$Nh=(H,L,U)=>{const oe=H.requestIdleCallback(L,typeof U=="number"?{timeout:U}:void 0);let le=!1;return{dispose(){le||(le=!0,H.cancelIdleCallback(oe))}}},e.$Mh=H=>(0,e.$Nh)(globalThis,H)}();class _{constructor(L,U){this.g=!1,this.d=()=>{try{this.j=U()}catch(oe){this.l=oe}finally{this.g=!0}},this.f=(0,e.$Nh)(L,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=_;class M extends _{constructor(L){super(globalThis,L)}}e.$Ph=M;async function Q(H,L,U){let oe;for(let le=0;le<U;le++)try{return await H()}catch(de){oe=de,await l(L)}throw oe}class ae{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,U,oe){return this.a={taskId:L,cancel:()=>oe?.(),promise:U},U.then(()=>this.d(L),()=>this.d(L)),U}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{const{promise:U,resolve:oe,reject:le}=c();this.b={run:L,promise:U,promiseResolve:oe,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=ae;class ne{constructor(L,U=()=>Date.now()){this.d=L,this.f=U,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Sh=ne;var we;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(we||(we={}));class ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,U)=>{this.a=L,this.b=U})}complete(L){return new Promise(U=>{this.a(L),this.d={outcome:0,value:L},U()})}error(L){return new Promise(U=>{this.b(L),this.d={outcome:1,value:L},U()})}cancel(){return this.error(new C.$5)}}e.$Th=ie;var Y;(function(H){async function L(oe){let le;const de=await Promise.all(oe.map(te=>te.then(me=>me,me=>{le||(le=me)})));if(typeof le<"u")throw le;return de}H.settled=L;function U(oe){return new Promise(async(le,de)=>{try{await oe(le,de)}catch(te){de(te)}})}H.withAsyncBody=U})(Y||(e.Promises=Y={}));class V{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(L){this.a=void 0,this.b=void 0,this.d=!1,this.promise=L.then(U=>(this.a=U,this.d=!0,U),U=>{throw this.b=U,this.d=!0,U})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=V;class N{constructor(L){this.b=L,this.a=new g.$V(()=>new V(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=N;var z;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(z||(z={}));class Z{static fromArray(L){return new Z(U=>{U.emitMany(L)})}static fromPromise(L){return new Z(async U=>{U.emitMany(await L)})}static fromPromises(L){return new Z(async U=>{await Promise.all(L.map(async oe=>U.emitOne(await oe)))})}static merge(L){return new Z(async U=>{await Promise.all(L.map(async oe=>{for await(const le of oe)U.emitOne(le)}))})}constructor(L,U){this.a=0,this.b=[],this.d=null,this.f=U,this.g=new D.$ee,queueMicrotask(async()=>{const oe={emitOne:le=>this.h(le),emitMany:le=>this.j(le),reject:le=>this.l(le)};try{await Promise.resolve(L(oe)),this.k()}catch(le){this.l(le)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(L,U){return new Z(async oe=>{for await(const le of L)oe.emitOne(U(le))})}map(L){return Z.map(this,L)}static filter(L,U){return new Z(async oe=>{for await(const le of L)U(le)&&oe.emitOne(le)})}filter(L){return Z.filter(this,L)}static coalesce(L){return Z.filter(L,U=>!!U)}coalesce(){return Z.coalesce(this)}static async toPromise(L){const U=[];for await(const oe of L)U.push(oe);return U}toPromise(){return Z.toPromise(this)}h(L){this.a===0&&(this.b.push(L),this.g.fire())}j(L){this.a===0&&(this.b=this.b.concat(L),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(L){this.a===0&&(this.a=2,this.d=L,this.g.fire())}}e.$Wh=Z,Z.EMPTY=Z.fromArray([]);class he extends Z{constructor(L,U){super(U),this.m=L}cancel(){this.m.cancel()}}e.$Xh=he;function x(H){const L=new s.$pe,U=H(L.token);return new he(L,async oe=>{const le=L.token.onCancellationRequested(()=>{le.dispose(),L.dispose(),oe.reject(new C.$5)});try{for await(const de of U){if(L.token.isCancellationRequested)return;oe.emitOne(de)}le.dispose(),L.dispose()}catch(de){le.dispose(),L.dispose(),oe.reject(de)}})}class J{constructor(L){this.a=new ie,this.b=new Z(le=>{if(U){le.reject(U);return}return oe&&le.emitMany(oe),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p},L);let U,oe;this.f=le=>{oe||(oe=[]),oe.push(le)},this.d=le=>{U||(U=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(L){this.d(L),this.a.complete()}emitOne(L){this.f(L)}}e.$Zh=J}),define(ye[77],Ee([1,0,18,14,35,24,7,3,17]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=g,e.$ok=u,e.$pk=A,e.$qk=B,e.$rk=G,e.$sk=se,e.$tk=ce,e.$uk=X;function g(){return Object.create(null)}e.$mk="**",e.$nk="/";const y="[/\\\\]",v="[^/\\\\]",b=/\//g;function m(_,M){switch(_){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}${M?`|${y}${v}+`:""})*?`}}function u(_,M){if(!_)return[];const Q=[];let ae=!1,ne=!1,we="";for(const ie of _){switch(ie){case M:if(!ae&&!ne){Q.push(we),we="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}we+=ie}return we&&Q.push(we),Q}function a(_){if(!_)return"";let M="";const Q=u(_,e.$nk);if(Q.every(ae=>ae===e.$mk))M=".*";else{let ae=!1;Q.forEach((ne,we)=>{if(ne===e.$mk){if(ae)return;M+=m(2,we===Q.length-1)}else{let ie=!1,Y="",V=!1,N="";for(const z of ne){if(z!=="}"&&ie){Y+=z;continue}if(V&&(z!=="]"||!N)){let Z;z==="-"?Z=z:(z==="^"||z==="!")&&!N?Z="^":z===e.$nk?Z="":Z=(0,w.$af)(z),N+=Z;continue}switch(z){case"{":ie=!0;continue;case"[":V=!0;continue;case"}":{const he=`(?:${u(Y,",").map(x=>a(x)).join("|")})`;M+=he,ie=!1,Y="";break}case"]":{M+="["+N+"]",V=!1,N="";break}case"?":M+=v;continue;case"*":M+=m(1);continue;default:M+=(0,w.$af)(z)}}we<Q.length-1&&(Q[we+1]!==e.$mk||we+2<Q.length)&&(M+=y)}ae=ne===e.$mk})}return M}const f=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.$Ec(1e4),o=function(){return!1},r=function(){return null};function i(_,M){if(!_)return r;let Q;typeof _!="string"?Q=_.pattern:Q=_,Q=Q.trim();const ae=`${Q}_${!!M.trimForExclusions}`;let ne=t.get(ae);if(ne)return n(ne,_);let we;return f.test(Q)?ne=p(Q.substr(4),Q):(we=c.exec(l(Q,M)))?ne=P(we[1],Q):(M.trimForExclusions?$:d).test(Q)?ne=j(Q,M):(we=E.exec(l(Q,M)))?ne=O(we[1].substr(1),Q,!0):(we=h.exec(l(Q,M)))?ne=O(we[1],Q,!1):ne=R(Q),t.set(ae,ne),n(ne,_)}function n(_,M){if(typeof M=="string")return _;const Q=function(ae,ne){return(0,D.$vg)(ae,M.base,!S.$e)?_((0,w.$ff)(ae.substr(M.base.length),I.sep),ne):null};return Q.allBasenames=_.allBasenames,Q.allPaths=_.allPaths,Q.basenames=_.basenames,Q.patterns=_.patterns,Q}function l(_,M){return M.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function p(_,M){return function(Q,ae){return typeof Q=="string"&&Q.endsWith(_)?M:null}}function P(_,M){const Q=`/${_}`,ae=`\\${_}`,ne=function(ie,Y){return typeof ie!="string"?null:Y?Y===_?M:null:ie===_||ie.endsWith(Q)||ie.endsWith(ae)?M:null},we=[_];return ne.basenames=we,ne.patterns=[M],ne.allBasenames=we,ne}function j(_,M){const Q=q(_.slice(1,-1).split(",").map(Y=>i(Y,M)).filter(Y=>Y!==r),_),ae=Q.length;if(!ae)return r;if(ae===1)return Q[0];const ne=function(Y,V){for(let N=0,z=Q.length;N<z;N++)if(Q[N](Y,V))return _;return null},we=Q.find(Y=>!!Y.allBasenames);we&&(ne.allBasenames=we.allBasenames);const ie=Q.reduce((Y,V)=>V.allPaths?Y.concat(V.allPaths):Y,[]);return ie.length&&(ne.allPaths=ie),ne}function O(_,M,Q){const ae=I.sep===I.$hc.sep,ne=ae?_:_.replace(b,I.sep),we=I.sep+ne,ie=I.$hc.sep+_;let Y;return Q?Y=function(V,N){return typeof V=="string"&&(V===ne||V.endsWith(we)||!ae&&(V===_||V.endsWith(ie)))?M:null}:Y=function(V,N){return typeof V=="string"&&(V===ne||!ae&&V===_)?M:null},Y.allPaths=[(Q?"*/":"./")+_],Y}function R(_){try{const M=new RegExp(`^${a(_)}$`);return function(Q){return M.lastIndex=0,typeof Q=="string"&&M.test(Q)?_:null}}catch{return r}}function A(_,M,Q){return!_||typeof M!="string"?!1:B(_)(M,void 0,Q)}function B(_,M={}){if(!_)return o;if(typeof _=="string"||G(_)){const Q=i(_,M);if(Q===r)return o;const ae=function(ne,we){return!!Q(ne,we)};return Q.allBasenames&&(ae.allBasenames=Q.allBasenames),Q.allPaths&&(ae.allPaths=Q.allPaths),ae}return ee(_,M)}function G(_){const M=_;return M?typeof M.base=="string"&&typeof M.pattern=="string":!1}function se(_){return _.allBasenames||[]}function ce(_){return _.allPaths||[]}function ee(_,M){const Q=q(Object.getOwnPropertyNames(_).map(Y=>K(Y,_[Y],M)).filter(Y=>Y!==r)),ae=Q.length;if(!ae)return r;if(!Q.some(Y=>!!Y.requiresSiblings)){if(ae===1)return Q[0];const Y=function(z,Z){let he;for(let x=0,J=Q.length;x<J;x++){const H=Q[x](z,Z);if(typeof H=="string")return H;(0,C.$ih)(H)&&(he||(he=[]),he.push(H))}return he?(async()=>{for(const x of he){const J=await x;if(typeof J=="string")return J}return null})():null},V=Q.find(z=>!!z.allBasenames);V&&(Y.allBasenames=V.allBasenames);const N=Q.reduce((z,Z)=>Z.allPaths?z.concat(Z.allPaths):z,[]);return N.length&&(Y.allPaths=N),Y}const ne=function(Y,V,N){let z,Z;for(let he=0,x=Q.length;he<x;he++){const J=Q[he];J.requiresSiblings&&N&&(V||(V=(0,I.$oc)(Y)),z||(z=V.substr(0,V.length-(0,I.$pc)(Y).length)));const H=J(Y,V,z,N);if(typeof H=="string")return H;(0,C.$ih)(H)&&(Z||(Z=[]),Z.push(H))}return Z?(async()=>{for(const he of Z){const x=await he;if(typeof x=="string")return x}return null})():null},we=Q.find(Y=>!!Y.allBasenames);we&&(ne.allBasenames=we.allBasenames);const ie=Q.reduce((Y,V)=>V.allPaths?Y.concat(V.allPaths):Y,[]);return ie.length&&(ne.allPaths=ie),ne}function K(_,M,Q){if(M===!1)return r;const ae=i(_,Q);if(ae===r)return r;if(typeof M=="boolean")return ae;if(M){const ne=M.when;if(typeof ne=="string"){const we=(ie,Y,V,N)=>{if(!N||!ae(ie,Y))return null;const z=ne.replace("$(basename)",()=>V),Z=N(z);return(0,C.$ih)(Z)?Z.then(he=>he?_:null):Z?_:null};return we.requiresSiblings=!0,we}}return ae}function q(_,M){const Q=_.filter(Y=>!!Y.basenames);if(Q.length<2)return _;const ae=Q.reduce((Y,V)=>{const N=V.basenames;return N?Y.concat(N):Y},[]);let ne;if(M){ne=[];for(let Y=0,V=ae.length;Y<V;Y++)ne.push(M)}else ne=Q.reduce((Y,V)=>{const N=V.patterns;return N?Y.concat(N):Y},[]);const we=function(Y,V){if(typeof Y!="string")return null;if(!V){let z;for(z=Y.length;z>0;z--){const Z=Y.charCodeAt(z-1);if(Z===47||Z===92)break}V=Y.substr(z)}const N=ae.indexOf(V);return N!==-1?ne[N]:null};we.basenames=ae,we.patterns=ne,we.allBasenames=ae;const ie=_.filter(Y=>!Y.basenames);return ie.push(we),ie}function X(_,M){return(0,s.$ub)(_,M,(Q,ae)=>typeof Q=="string"&&typeof ae=="string"?Q===ae:typeof Q!="string"&&typeof ae!="string"?Q.base===ae.base&&Q.pattern===ae.pattern:!1)}}),define(ye[102],Ee([1,0,11,162,19,17,4]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=g,e.$Vk=y,e.$Wk=v,e.$Xk=b,e.$Yk=m,e.$Zk=u,e.$1k=a,e.$2k=f;var S;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(S||(e.MarkdownStringTextNewlineStyle=S={}));class w{constructor(d="",$=!1){if(this.value=d,typeof this.value!="string")throw(0,s.$7)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(d,$=0){return this.value+=b(this.supportThemeIcons?(0,C.$Nk)(d):d).replace(/([ \t]+)/g,(E,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,$){return this.value+=`
${m($,d)}
`,this}appendLink(d,$,E){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(d),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(d,$){const E=new RegExp((0,k.$af)($),"g");return d.replace(E,(h,t)=>d.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Tk=w;function g(c){return y(c)?!c.value:Array.isArray(c)?c.every(g):!0}function y(c){return c instanceof w?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function v(c,d){return c===d?!0:!c||!d?!1:c.value===d.value&&c.isTrusted===d.isTrusted&&c.supportThemeIcons===d.supportThemeIcons&&c.supportHtml===d.supportHtml&&(c.baseUri===d.baseUri||!!c.baseUri&&!!d.baseUri&&(0,D.$3g)(I.URI.from(c.baseUri),I.URI.from(d.baseUri)))}function b(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(c,d){const $=c.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,E=$>=3?$+1:3;return[`${"`".repeat(E)}${d}`,c,`${"`".repeat(E)}`].join(`
`)}function u(c){return c.replace(/"/g,"&quot;")}function a(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(c){const d=[],$=c.split("|").map(h=>h.trim());c=$[0];const E=$[1];if(E){const h=/height=(\d+)/.exec(E),t=/width=(\d+)/.exec(E),o=h?h[1]:"",r=t?t[1]:"",i=isFinite(parseInt(r)),n=isFinite(parseInt(o));i&&d.push(`width="${r}"`),n&&d.push(`height="${o}"`)}return{href:c,dimensions:d}}}),define(ye[165],Ee([1,0,18,35,7,3,19,17]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=w,e.$Fw=y,e.$Gw=b,e.$Hw=m,e.$Iw=c,e.$Jw=$,e.$Kw=E,e.$Lw=h,e.$Mw=t,e.$Nw=o;function w(i,n){const{os:l,tildify:p,relative:P}=n;if(P){const R=g(i,P,l);if(typeof R=="string")return R}let j=i.fsPath;if(l===1&&!k.$c?j=j.replace(/\//g,"\\"):l!==1&&k.$c&&(j=j.replace(/\\/g,"/")),l!==1&&p?.userHome){const R=p.userHome.fsPath;let A;i.scheme!==p.userHome.scheme&&i.path[0]===D.$hc.sep&&i.path[1]!==D.$hc.sep?A=p.userHome.with({path:i.path}).fsPath:A=j,j=b(A,R,l)}return(l===1?D.$gc:D.$hc).normalize(y(j,l===1))}function g(i,n,l){const p=l===1?D.$gc:D.$hc,P=l===3?I.$Zg:I.$2g,j=n.getWorkspace(),O=(0,s.$Ob)(j.folders);if(!O)return;i.scheme!==O.uri.scheme&&i.path[0]===D.$hc.sep&&i.path[1]!==D.$hc.sep&&(i=O.uri.with({path:i.path}));const R=n.getWorkspaceFolder(i);if(!R)return;let A;if(P.isEqual(R.uri,i)?A="":A=P.relativePath(R.uri,i)??"",A&&(A=p.normalize(A)),j.folders.length>1&&!n.noPrefix){const B=R.name?R.name:P.basenameOrAuthority(R.uri);A=A?`${B} \u2022 ${A}`:B}return A}function y(i,n=k.$c){return(0,C.$Ag)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}let v=Object.create(null);function b(i,n,l=k.OS){if(l===1||!i||!n)return i;let p=v.original===n?v.normalized:void 0;p||(p=n,k.$c&&(p=(0,C.$pg)(p)),p=`${(0,S.$gf)(p,D.$hc.sep)}${D.$hc.sep}`,v={original:n,normalized:p});let P=i;return k.$c&&(P=(0,C.$pg)(P)),(l===3?P.startsWith(p):(0,S.$zf)(P,p))?`~/${P.substr(p.length)}`:i}function m(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}const u="\u2026",a="\\\\",f="~";function c(i,n=D.sep){const l=new Array(i.length);let p=!1;for(let P=0;P<i.length;P++){const j=i[P];if(j===""){l[P]=`.${n}`;continue}if(!j){l[P]=j;continue}p=!0;let O="",R=j;R.indexOf(a)===0?(O=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(n)===0?(O=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(f)===0&&(O=R.substr(0,R.indexOf(f)+f.length),R=R.substr(R.indexOf(f)+f.length));const A=R.split(n);for(let B=1;p&&B<=A.length;B++)for(let G=A.length-B;p&&G>=0;G--){p=!1;let se=A.slice(G,G+B).join(n);for(let ce=0;!p&&ce<i.length;ce++)if(ce!==P&&i[ce]&&i[ce].indexOf(se)>-1){const ee=G+B===A.length,K=G>0&&i[ce].indexOf(n)>-1?n+se:se,q=i[ce].endsWith(K);p=!ee||q}if(!p){let ce="";(A[0].endsWith(":")||O!=="")&&(G===1&&(G=0,B++,se=A[0]+n+se),G>0&&(ce=A[0]+n),ce=O+ce),G>0&&(ce=ce+u+n),ce=ce+se,G+B<A.length&&(ce=ce+n+u),l[P]=ce}}p&&(l[P]=j)}return l}var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function $(i,n=Object.create(null)){const l=[];let p=!1,P="";for(const j of i)if(j==="$"||p&&j==="{")P&&l.push({value:P,type:d.TEXT}),P="",p=!0;else if(j==="}"&&p){const O=n[P];if(typeof O=="string")O.length&&l.push({value:O,type:d.VARIABLE});else if(O){const R=l[l.length-1];(!R||R.type!==d.SEPARATOR)&&l.push({value:O.label,type:d.SEPARATOR})}P="",p=!1}else P+=j;return P&&!p&&l.push({value:P,type:d.TEXT}),l.filter((j,O)=>{if(j.type===d.SEPARATOR){const R=l[O-1],A=l[O+1];return[R,A].every(B=>B&&(B.type===d.VARIABLE||B.type===d.TEXT)&&B.value.length>0)}return!0}).map(j=>j.value).join("")}function E(i,n){return k.$d||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.$d?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function h(i,n){return k.$d||n?i.replace(/\(&&\w\)|&&/g,""):k.$c?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const l=r(i.substring(0,n)),p=i.substring(n);return{name:l.name+p,parentPath:l.parentPath}}}return r(i)}function r(i){const n=i.indexOf("/")!==-1?D.$hc:D.$gc,l=n.basename(i),p=n.dirname(i);return l.length?{name:l,parentPath:p}:{name:p,parentPath:""}}}),define(ye[55],Ee([1,0,15,4]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=void 0,e.$Bn=S,e.$Cn=g,e.$Dn=y;function D(v){return v.toJSON()}class k{constructor(b){this.a=b}transformIncoming(b){const m=this.a.transformIncoming(b);return m===b?b:D(C.URI.from(m))}transformOutgoing(b){const m=this.a.transformOutgoing(b);return m===b?b:D(C.URI.from(m))}transformOutgoingURI(b){const m=this.a.transformOutgoing(b);return m===b?b:C.URI.from(m)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$zn=k,e.$An=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function I(v,b,m){if(!v||m>200)return null;if(typeof v=="object"){if(v instanceof C.URI)return b.transformOutgoing(v);for(const u in v)if(Object.hasOwnProperty.call(v,u)){const a=I(v[u],b,m+1);a!==null&&(v[u]=a)}}return null}function S(v,b){const m=I(v,b,0);return m===null?v:m}function w(v,b,m,u){if(!v||u>200)return null;if(typeof v=="object"){if(v.$mid===1)return m?C.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof s.$Ge)return null;for(const a in v)if(Object.hasOwnProperty.call(v,a)){const f=w(v[a],b,m,u+1);f!==null&&(v[a]=f)}}return null}function g(v,b){const m=w(v,b,!1,0);return m===null?v:m}function y(v,b){const m=w(v,b,!0,0);return m===null?v:m}}),define(ye[22],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=C;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(D){return s.test(D)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(S){for(let w=0;w<S.length;w++)S[w]=Math.floor(Math.random()*256);return S};const k=new Uint8Array(16),I=[];for(let S=0;S<256;S++)I.push(S.toString(16).padStart(2,"0"));return function(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let w=0,g="";return g+=I[k[w++]],g+=I[k[w++]],g+=I[k[w++]],g+=I[k[w++]],g+="-",g+=I[k[w++]],g+=I[k[w++]],g+="-",g+=I[k[w++]],g+=I[k[w++]],g+="-",g+=I[k[w++]],g+=I[k[w++]],g+="-",g+=I[k[w++]],g+=I[k[w++]],g+=I[k[w++]],g+=I[k[w++]],g+=I[k[w++]],g+=I[k[w++]],g}}()}),define(ye[166],Ee([1,0,18,41,22]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.$Tt=void 0,e.$Rt=k,e.$St=I,e.$Ut=g;function k(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function I(v,b,m){const u={id:(0,D.$Sg)(),name:v,uri:b,data:m};return{asString:async()=>"",asFile:()=>u,value:void 0}}class S{constructor(){this.a=new Map}get size(){let b=0;for(const m of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const m=[...this.a.keys()];return C.Iterable.some(this,([u,a])=>a.asFile())&&m.push("files"),y(w(b),m)}get(b){return this.a.get(this.b(b))?.[0]}append(b,m){const u=this.a.get(b);u?u.push(m):this.a.set(this.b(b),[m])}replace(b,m){this.a.set(this.b(b),[m])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,m]of this.a)for(const u of m)yield[b,u]}b(b){return w(b)}}e.$Tt=S;function w(v){return v.toLowerCase()}function g(v,b){return y(w(v),b.map(w))}function y(v,b){if(v==="*/*")return b.length>0;if(b.includes(v))return!0;const m=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!m)return!1;const[u,a,f]=m;return f==="*"?b.some(c=>c.startsWith(a+"/")):!1}e.$Vt=Object.freeze({create:v=>(0,s.$Mb)(v.map(b=>b.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$Vt.split(v).filter(b=>!b.startsWith("#"))})}),function(){"use strict";function ue(e,s,C){function D(m){return new Promise(u=>s.exists(m,u))}function k(m){return new Promise((u,a)=>{const f=new Date;s.utimes(m,f,f,c=>c?a(c):u())})}function I(m){return new Promise((u,a)=>s.mkdir(m,{recursive:!0},f=>f&&f.code!=="EEXIST"?a(f):u(m)))}function S(m){return new Promise((u,a)=>s.rm(m,{recursive:!0,force:!0,maxRetries:3},f=>f?a(f):u()))}function w(m){return new Promise((u,a)=>s.readFile(m,"utf8",(f,c)=>f?a(f):u(c)))}function g(m,u){return new Promise((a,f)=>s.writeFile(m,u,"utf8",c=>c?f(c):a()))}async function y(m){const u=e.join(m,"languagepacks.json");try{return JSON.parse(await w(u))}catch{}}function v(m,u){try{for(;u;){if(m[u])return u;{const a=u.lastIndexOf("-");if(a>0)u=u.substring(0,a);else return}}}catch(a){console.error("Resolving language pack configuration failed.",a)}}function b(m,u,a,f,c){const d=function(E){return C.mark("code/didGenerateNls"),Promise.resolve({locale:E,osLocale:c,availableLanguages:{}})};if(C.mark("code/willGenerateNls"),f==="pseudo")return Promise.resolve({locale:f,osLocale:c,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:f,osLocale:c,availableLanguages:{}});if(f&&(f==="en"||f==="en-us"))return Promise.resolve({locale:f,osLocale:c,availableLanguages:{}});const $=f;try{return m?y(u).then(E=>{if(!E)return d($);const h=v(E,f);if(!h)return d($);f=h;const t=E[f];let o;return!t||typeof t.hash!="string"||!t.translations||typeof(o=t.translations.vscode)!="string"?d($):D(o).then(r=>{if(!r)return d($);const i=t.hash+"."+f,n=e.join(u,"clp",i),l=e.join(n,m),p=e.join(n,"tcf.json"),P=e.join(n,"corrupted.info"),j={locale:$,osLocale:c,availableLanguages:{"*":f},_languagePackId:i,_translationsConfigFile:p,_cacheRoot:n,_resolvedLanguagePackCoreLocation:l,_corruptedFile:P};return D(P).then(O=>{let R;return O?R=S(n):R=Promise.resolve(void 0),R.then(()=>D(l).then(A=>A?(k(l).catch(()=>{}),C.mark("code/didGenerateNls"),j):I(l).then(()=>Promise.all([w(a),w(o)])).then(B=>{const G=JSON.parse(B[0]),se=JSON.parse(B[1]).contents,ce=Object.keys(G.bundles),ee=[];for(const K of ce){const q=G.bundles[K],X=Object.create(null);for(const _ of q){const M=G.keys[_],Q=G.messages[_],ae=se[_];let ne;if(ae){ne=[];for(let we=0;we<M.length;we++){const ie=M[we],Y=typeof ie=="string"?ie:ie.key;let V=ae[Y];V===void 0&&(V=Q[we]),ne.push(V)}}else ne=Q;X[_]=ne}ee.push(g(e.join(l,K.replace(/\//g,"!")+".nls.json"),JSON.stringify(X)))}return ee.push(g(p,JSON.stringify(t.translations))),Promise.all(ee)}).then(()=>(C.mark("code/didGenerateNls"),j)).catch(B=>(console.error("Generating translation files failed.",B),d(f)))))})})}):d($)}catch(E){return console.error("Generating translation files failed.",E),d(f)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(ye[167],Ee([78,27,44]),function(e,s,C){return ue(e,s,C)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),s=require("fs"),C=require("../common/performance");module.exports=ue(e,s,C)}else throw new Error("Unknown context")}(),define(ye[168],Ee([1,0,28]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=k;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(I){const S=I.replace(/\-/g,":").toLowerCase();return!C.has(S)}function k(){const I=(0,s.networkInterfaces)();for(const S in I){const w=I[S];if(w){for(const{mac:g}of w)if(D(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ye[103],Ee([1,0,28,66,22,168,3]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0,e.$Gn=w,e.$Hn=v,e.$Fn=new class{c(b){return this.a||(this.a=C.$Ci.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,m=0;const u=(0,s.networkInterfaces)();for(const a in u){const f=u[a];if(f)for(const{mac:c,internal:d}of f)d||(m+=1,this.c(c.toUpperCase())&&(b+=1))}this.b=m>0?b/m:0}return this.b}};let S;async function w(b){return S||(S=(async()=>await g(b)||D.$Sg())()),S}async function g(b){try{const m=await new Promise((a,f)=>{ue(["crypto"],a,f)}),u=(0,k.$En)();return m.createHash("sha256").update(u,"utf8").digest("hex")}catch(m){b(m);return}}const y="Software\\Microsoft\\SQMClient";async function v(b){if(I.$c){const m=await new Promise((u,a)=>{ue(["@vscode/windows-registry"],u,a)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(u){return b(u),""}}return""}}),define(ye[169],Ee([1,0,27,310,311,3]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=I;async function I(S){if(k.$d||k.$c)return;let w;for(const g of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{w=await(0,C.open)(g,s.constants.R_OK);break}catch{}if(!w){S("Unable to retrieve release information from known identifier paths.");return}try{const g=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),y={id:"unknown"};for await(const v of(0,D.createInterface)({input:w.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const b=v.split("=")[0].toUpperCase().trim();if(g.has(b)){const m=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();b==="ID"||b==="DISTRIB_ID"?y.id=m:b==="ID_LIKE"?y.id_like=m:(b==="VERSION_ID"||b==="DISTRIB_RELEASE")&&(y.version_id=m)}}return y}catch(g){S(g)}}}),define(ye[23],Ee([1,0,27,28,312,14,35,100,7,3,19,4]),function(ue,e,s,C,D,k,I,S,w,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=$,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=P;var b;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function m(K,q=b.UNLINK,X){if((0,I.$zg)(K))throw new Error("rimraf - will refuse to recursively delete root");return q===b.UNLINK?a(K):u(K,X)}async function u(K,q=(0,I.$Eg)((0,C.tmpdir)())){try{try{await s.promises.rename(K,q)}catch(X){return X.code==="ENOENT"?void 0:a(K)}a(q).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function a(K){return(0,D.promisify)(s.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function f(K){if((0,I.$zg)(K))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function c(K,q){return E(await(q?d(K):(0,D.promisify)(s.readdir)(K)))}async function d(K){try{return await(0,D.promisify)(s.readdir)(K,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const q=[],X=await c(K);for(const _ of X){let M=!1,Q=!1,ae=!1;try{const ne=await e.Promises.lstat((0,w.$kc)(K,_));M=ne.isFile(),Q=ne.isDirectory(),ae=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}q.push({name:_,isFile:()=>M,isDirectory:()=>Q,isSymbolicLink:()=>ae})}return q}function $(K){return E(s.readdirSync(K))}function E(K){return K.map(q=>typeof q=="string"?g.$d?(0,S.$cm)(q):q:(q.name=g.$d?(0,S.$cm)(q.name):q.name,q))}async function h(K){const q=await c(K),X=[];for(const _ of q)await o.existsDirectory((0,w.$kc)(K,_))&&X.push(_);return X}function t(K,q=1e3){return new Promise(X=>{let _=!1;const M=setInterval(()=>{_||(_=!0,s.access(K,Q=>{_=!1,Q&&(clearInterval(M),X(void 0))}))},q)})}var o;(function(K){async function q(M){let Q;try{if(Q=await e.Promises.lstat(M),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ae){if(ae.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(g.$c&&ae.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ne}throw ae}}K.stat=q;async function X(M){try{const{stat:Q,symbolicLink:ae}=await K.stat(M);return Q.isFile()&&ae?.dangling!==!0}catch{}return!1}K.existsFile=X;async function _(M){try{const{stat:Q,symbolicLink:ae}=await K.stat(M);return Q.isDirectory()&&ae?.dangling!==!0}catch{}return!1}K.existsDirectory=_})(o||(e.SymlinkSupport=o={}));const r=new k.$Fh;function i(K,q,X){return r.queueFor(v.URI.file(K),()=>{const _=j(X);return new Promise((M,Q)=>p(K,q,_,ae=>ae?Q(ae):M()))},y.$1g)}let n=!0;function l(K){n=K}function p(K,q,X,_){if(!n)return s.writeFile(K,q,{mode:X.mode,flag:X.flag},_);s.open(K,X.flag,X.mode,(M,Q)=>{if(M)return _(M);s.writeFile(Q,q,ae=>{if(ae)return s.close(Q,()=>_(ae));s.fdatasync(Q,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),l(!1)),s.close(Q,we=>_(we))))})})}function P(K,q,X){const _=j(X);if(!n)return s.writeFileSync(K,q,{mode:_.mode,flag:_.flag});const M=s.openSync(K,_.flag,_.mode);try{s.writeFileSync(M,q);try{s.fdatasyncSync(M)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{s.closeSync(M)}}function j(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function O(K,q,X=6e4){if(K!==q)try{g.$c&&typeof X=="number"?await R(K,q,Date.now(),X):await(0,D.promisify)(s.rename)(K,q)}catch(_){if(K.toLowerCase()!==q.toLowerCase()&&_.code==="EXDEV"||K.endsWith("."))await A(K,q,{preserveSymlinks:!1}),await m(K,b.MOVE);else throw _}}async function R(K,q,X,_,M=0){try{return await(0,D.promisify)(s.rename)(K,q)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-X>=_)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${Q}`),Q;if(M===0){let ae=!1;try{const{stat:ne}=await o.stat(q);ne.isFile()||(ae=!0)}catch{}if(ae)throw Q}return await(0,k.$xh)(Math.min(100,M*10)),R(K,q,X,_,M+1)}}async function A(K,q,X){return G(K,q,{root:{source:K,target:q},options:X,handledSourcePaths:new Set})}const B=511;async function G(K,q,X){if(X.handledSourcePaths.has(K))return;X.handledSourcePaths.add(K);const{stat:_,symbolicLink:M}=await o.stat(K);if(M){if(X.options.preserveSymlinks)try{return await ee(K,q,X)}catch{}if(M.dangling)return}return _.isDirectory()?se(K,q,_.mode&B,X):ce(K,q,_.mode&B)}async function se(K,q,X,_){await e.Promises.mkdir(q,{recursive:!0,mode:X});const M=await c(K);for(const Q of M)await G((0,w.$kc)(K,Q),(0,w.$kc)(q,Q),_)}async function ce(K,q,X){await e.Promises.copyFile(K,q),await e.Promises.chmod(q,X)}async function ee(K,q,X){let _=await e.Promises.readlink(K);(0,I.$vg)(_,X.root.source,!g.$e)&&(_=(0,w.$kc)(X.root.target,_.substr(X.root.source.length+1))),await e.Promises.symlink(_,q)}e.Promises=new class{get access(){return(0,D.promisify)(s.access)}get stat(){return(0,D.promisify)(s.stat)}get lstat(){return(0,D.promisify)(s.lstat)}get utimes(){return(0,D.promisify)(s.utimes)}get read(){return(K,q,X,_,M)=>new Promise((Q,ae)=>{s.read(K,q,X,_,M,(ne,we,ie)=>ne?ae(ne):Q({bytesRead:we,buffer:ie}))})}get readFile(){return(0,D.promisify)(s.readFile)}get write(){return(K,q,X,_,M)=>new Promise((Q,ae)=>{s.write(K,q,X,_,M,(ne,we,ie)=>ne?ae(ne):Q({bytesWritten:we,buffer:ie}))})}get appendFile(){return(0,D.promisify)(s.appendFile)}get fdatasync(){return(0,D.promisify)(s.fdatasync)}get truncate(){return(0,D.promisify)(s.truncate)}get copyFile(){return(0,D.promisify)(s.copyFile)}get open(){return(0,D.promisify)(s.open)}get close(){return(0,D.promisify)(s.close)}get symlink(){return(0,D.promisify)(s.symlink)}get readlink(){return(0,D.promisify)(s.readlink)}get chmod(){return(0,D.promisify)(s.chmod)}get mkdir(){return(0,D.promisify)(s.mkdir)}get unlink(){return(0,D.promisify)(s.unlink)}get rmdir(){return(0,D.promisify)(s.rmdir)}get realpath(){return(0,D.promisify)(s.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return m}get rename(){return O}get copy(){return A}}}),define(ye[170],Ee([1,0,27,7,3,17,23]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=S,e.$6q=w,e.$7q=g,e.$8q=y;function S(b){if(D.$e)return b;const m=(0,C.$nc)(b);if(b===m)return b;const u=((0,C.$oc)(b)||b).toLowerCase();try{const f=(0,I.readdirSync)(m).filter(c=>c.toLowerCase()===u);if(f.length===1){const c=S(m);if(c)return(0,C.$kc)(c,f[0])}else if(f.length>1){const c=f.indexOf(u);if(c>=0){const d=S(m);if(d)return(0,C.$kc)(d,f[c])}}}catch{}return null}async function w(b,m){if(D.$e)return b;const u=(0,C.$nc)(b);if(b===u)return b;const a=((0,C.$oc)(b)||b).toLowerCase();try{if(m?.isCancellationRequested)return null;const c=(await I.Promises.readdir(u)).filter(d=>d.toLowerCase()===a);if(c.length===1){const d=await w(u,m);if(d)return(0,C.$kc)(d,c[0])}else if(c.length>1){const d=c.indexOf(a);if(d>=0){const $=await w(u,m);if($)return(0,C.$kc)($,c[d])}}}catch{}return null}async function g(b){try{return await I.Promises.realpath(b)}catch{const u=v(b);return await I.Promises.access(u,s.constants.R_OK),u}}function y(b){try{return s.realpathSync(b)}catch{const u=v(b);return s.accessSync(u,s.constants.R_OK),u}}function v(b){return(0,k.$gf)((0,C.$ic)(b),C.sep)}}),define(ye[171],Ee([1,0,79]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=C,e.$Wg=k;function C(S,w,g,y=1){let v=!1;return new Promise(b=>{const m=setTimeout(()=>{if(!v)return v=!0,b(0)},g);D(S,w,y,u=>{if(!v)return v=!0,clearTimeout(m),b(u)})})}function D(S,w,g,y){if(w===0)return y(0);const v=new s.Socket;v.once("connect",()=>(I(v),D(S+g,w-1,g,y))),v.once("data",()=>{}),v.once("error",b=>(I(v),b.code!=="ECONNREFUSED"?D(S+g,w-1,g,y):y(S))),v.connect(S,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(S,w,g,y="127.0.0.1"){let v=!1,b,m=1;const u=s.createServer({pauseOnConnect:!0});function a(f,c){v||(v=!0,u.removeAllListeners(),u.close(),b&&clearTimeout(b),c(f))}return new Promise(f=>{b=setTimeout(()=>{a(0,f)},g),u.on("listening",()=>{a(S,f)}),u.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&m<w?(S++,m++,u.listen(S,y)):a(0,f)}),u.on("close",()=>{a(0,f)}),u.listen(S,y)})}function I(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(w){console.error(w)}}}),define(ye[104],Ee([1,0,28,7,23]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=d,e.$mm=$;const k=/^\d+$/,I=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var w;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(w||(w={}));let g;switch(process.arch){case"ia32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(h,t,o){this.exePath=h,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:E=!1}={}){return E?g===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:E=!1,findPreview:h=!1}={}){const t=b({useAlternateBitness:E});if(!t)return null;const o=C.$kc(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const p of await D.Promises.readdir(o)){let P=-1;if(h){const O=p.indexOf("-");if(O<0)continue;const R=p.substring(0,O);if(!k.test(R)||p.substring(O+1)!=="preview")continue;P=parseInt(R,10)}else{if(!k.test(p))continue;P=parseInt(p,10)}if(P<=r)continue;const j=C.$kc(o,p,"pwsh.exe");await D.SymlinkSupport.existsFile(j)&&(i=j,r=P)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",l=h?" Preview":"";return new v(i,`PowerShell${l}${n}`,!0)}async function u({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const h=C.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const r of await D.Promises.readdir(h))if(t.test(r)){const i=C.$kc(h,r,"pwsh.exe");return new v(i,o)}return null}function a(){const E=C.$kc(s.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function f(){const E=C.$kc(process.env.windir,g===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*c(){let E=await m();E&&(yield E),E=await m({useAlternateBitness:!0}),E&&(yield E),E=await u(),E&&(yield E),E=a(),E&&(yield E),E=await m({findPreview:!0}),E&&(yield E),E=await u({findPreview:!0}),E&&(yield E),E=await m({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=f(),E&&(yield E)}async function*d(){for await(const E of c())await E.exists()&&(yield E)}async function $(){for await(const E of d())return E;return null}}),define(ye[105],Ee([1,0,7,3,31,62,10,23]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$pm=w,e.$qm=g,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function w(v=D.env){return v.comspec||"cmd.exe"}function g(v){let b=[],m=!1;const u=function(a){if(m){b.push(a);return}(!v.send(a,c=>{if(c&&console.error(c),m=!1,b.length>0){const d=b.slice(0);b=[],d.forEach($=>u($))}})||C.$c)&&(m=!0)};return{send:u}}var y;(function(v){async function b(m,u,a){if(s.$jc(m))return m;if(u===void 0&&(u=D.cwd()),s.$nc(m)!=="."||(a===void 0&&I.$9f(D.env.PATH)&&(a=D.env.PATH.split(s.$uc)),a===void 0||a.length===0))return s.$kc(u,m);async function c(d){if(await S.Promises.exists(d)){let $;try{$=await S.Promises.stat(d)}catch(E){E.message.startsWith("EACCES")&&($=await S.Promises.lstat(d))}return $?!$.isDirectory():!1}return!1}for(const d of a){let $;if(s.$jc(d)?$=s.$kc(d,m):$=s.$kc(u,d,m),await c($))return $;let E=$+".com";if(await c(E)||(E=$+".exe",await c(E)))return E}return s.$kc(u,m)}v.findExecutable=b})(y||(e.win32=y={}))}),define(ye[106],Ee([1,0,56,13]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=D;function D(I){return new Promise((S,w)=>{let g;const y=new Map;function v(m,u,a,f,c){const d=y.get(u);if(m===I||d){const $={name:b(a),cmd:a,pid:m,ppid:u,load:f,mem:c};y.set(m,$),m===I&&(g=$),d&&(d.children||(d.children=[]),d.children.push($),d.children.length>1&&(d.children=d.children.sort((E,h)=>E.pid-h.pid)))}}function b(m){const u=/--utility-sub-type=network/i,a=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(a.exec(m))return"electron-crash-reporter";if(f.exec(m))return"winpty-agent";if(c.exec(m))return"conpty-agent";let $=d.exec(m);if($&&$.length===2)return $[1]==="renderer"?"window":$[1]==="utility"?u.exec(m)?"utility-network-service":"utility-process":$[1]==="extensionHost"?"extension-host":$[1];const E=/[a-zA-Z-]+\.js/g;let h="";do $=E.exec(m),$&&(h+=$+" ");while($);return h&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${h})`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,a)=>{ue(["@vscode/windows-process-tree"],u,a)}).then(u=>{u.getProcessList(I,a=>{if(!a){w(new Error(`Root process ${I} not found`));return}u.getProcessCpuUsage(a,f=>{const c=new Map;f.forEach(d=>{const $=m(d.commandLine||"");c.set(d.pid,{name:b($),cmd:$,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),g=c.get(I),g?(c.forEach(d=>{const $=c.get(d.ppid);$&&($.children||($.children=[]),$.children.push(d))}),c.forEach(d=>{d.children&&(d.children=d.children.sort(($,E)=>$.pid-E.pid))}),S(g)):w(new Error(`Root process ${I} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[g];const a=[];for(;u.length;){const c=u.shift();c&&(a.push(c.pid),c.children&&(u=u.concat(c.children)))}let f=JSON.stringify(C.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+a.join(" "),(0,s.exec)(f,{},(c,d,$)=>{if(c||$)w(c||new Error($.toString()));else{const E=d.toString().split(`
`);for(let h=0;h<a.length;h++){const t=y.get(a[h]);t.load=parseFloat(E[h])}if(!g){w(new Error(`Root process ${I} not found`));return}S(g)}})};(0,s.exec)("which ps",{},(u,a,f)=>{if(u||f)if(process.platform!=="linux")w(u||new Error(f.toString()));else{const c=JSON.stringify(C.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,s.exec)(c,{},(d,$,E)=>{d||E?w(d||new Error(E.toString())):(k($,v),m())})}else{const c=a.toString().trim();(0,s.exec)(`${c} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,E,h)=>{$||h&&!h.includes("screen size is bogus")?w($||new Error(h.toString())):(k(E,v),process.platform==="linux"?m():g?S(g):w(new Error(`Root process ${I} not found`)))})}})}})}function k(I,S){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const y of g){const v=w.exec(y.trim());v&&v.length===6&&S(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ye[107],Ee([1,0,28,3,104,105]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=I;async function I(v,b){return v===1?C.$c?y():k.$pm(b):w(v,b)}let S=null;function w(v,b){if(C.$e&&v===2||C.$d&&v===3)return"/bin/bash";if(!S){let m;if(C.$c)m="/bin/bash";else{if(m=b.SHELL,!m)try{m=(0,s.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}S=m}return S}let g=null;async function y(){return g||(g=(await(0,D.$mm)()).exePath),g}}),function(){function ue(){function e(){return process.uncHostAllowlist}function s(w){const g=new Set;if(Array.isArray(w))for(const y of w)typeof y=="string"&&g.add(y);return Array.from(g)}function C(){const w=e();return w?Array.from(w):[]}function D(w){if(process.platform!=="win32")return;const g=e();if(g)if(typeof w=="string")g.add(w.toLowerCase());else for(const y of s(w))D(y)}function k(w){if(typeof w!="string")return;const g=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const v of g){if(w.indexOf(v)!==0)continue;const m=w.indexOf("\\",v.length);if(m===-1)continue;const u=w.substring(v.length,m);if(u){y=u;break}}return y}function I(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:D,getUNCHost:k,disableUNCAccessRestrictions:I,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Fe=this&&this.__decorate||function(ue,e,s,C){var D=arguments.length,k=D<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,s):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(ue,e,s,C);else for(var S=ue.length-1;S>=0;S--)(I=ue[S])&&(k=(D<3?I(k):D>3?I(e,s,k):I(e,s))||k);return D>3&&k&&Object.defineProperty(e,s,k),k};define(ye[45],Ee([1,0,18,14,15,20,74,11,6,2,54,17,10]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=l,e.$0h=p,e.$ci=B,e.$di=G;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m||(m={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(a||(a={}));function f(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(c||(c={}));function d(M){let Q=0;for(let ae=0;;ae+=7){const ne=M.read(1);if(Q|=(ne.buffer[0]&127)<<ae,!(ne.buffer[0]&128))return Q}}const $=r(0);function E(M,Q){if(Q===0){M.write($);return}let ae=0;for(let we=Q;we!==0;we=we>>>7)ae++;const ne=D.$Ge.alloc(ae);for(let we=0;Q!==0;we++)ne.buffer[we]=Q&127,Q=Q>>>7,Q>0&&(ne.buffer[we]|=128);M.write(ne)}class h{constructor(Q){this.b=Q,this.a=0}read(Q){const ae=this.b.slice(this.a,this.a+Q);return this.a+=ae.byteLength,ae}}e.$7h=h;class t{constructor(){this.a=[]}get buffer(){return D.$Ge.concat(this.a)}write(Q){this.a.push(Q)}}e.$8h=t;var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(o||(o={}));function r(M){const Q=D.$Ge.alloc(1);return Q.writeUInt8(M,0),Q}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function l(M,Q){if(typeof Q>"u")M.write(i.Undefined);else if(typeof Q=="string"){const ae=D.$Ge.fromString(Q);M.write(i.String),E(M,ae.byteLength),M.write(ae)}else if(n&&Buffer.isBuffer(Q)){const ae=D.$Ge.wrap(Q);M.write(i.Buffer),E(M,ae.byteLength),M.write(ae)}else if(Q instanceof D.$Ge)M.write(i.VSBuffer),E(M,Q.byteLength),M.write(Q);else if(Array.isArray(Q)){M.write(i.Array),E(M,Q.length);for(const ae of Q)l(M,ae)}else if(typeof Q=="number"&&(Q|0)===Q)M.write(i.Uint),E(M,Q);else{const ae=D.$Ge.fromString(JSON.stringify(Q));M.write(i.Object),E(M,ae.byteLength),M.write(ae)}}function p(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(d(M)).toString();case o.Buffer:return M.read(d(M)).buffer;case o.VSBuffer:return M.read(d(M));case o.Array:{const ae=d(M),ne=[];for(let we=0;we<ae;we++)ne.push(p(M));return ne}case o.Object:return JSON.parse(M.read(d(M)).toString());case o.Int:return d(M)}}class P{constructor(Q,ae,ne=null,we=1e3){this.h=Q,this.j=ae,this.k=ne,this.l=we,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(Q,ae){this.b.set(Q,ae),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const ae=this.o([Q.type]);this.k?.logOutgoing(ae,0,1,f(Q.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(ae,Q.id,1,f(Q.type),Q.data);return}}}o(Q,ae=void 0){const ne=new t;return l(ne,Q),l(ne,ae),this.p(ne.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const ae=new h(Q),ne=p(ae),we=p(ae),ie=ne[0];switch(ie){case 100:return this.k?.logIncoming(Q.byteLength,ne[1],1,`${u(ie)}: ${ne[2]}.${ne[3]}`,we),this.s({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:we});case 102:return this.k?.logIncoming(Q.byteLength,ne[1],1,`${u(ie)}: ${ne[2]}.${ne[3]}`,we),this.t({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:we});case 101:return this.k?.logIncoming(Q.byteLength,ne[1],1,`${u(ie)}`),this.u({type:ie,id:ne[1]});case 103:return this.k?.logIncoming(Q.byteLength,ne[1],1,`${u(ie)}`),this.u({type:ie,id:ne[1]})}}s(Q){const ae=this.b.get(Q.channelName);if(!ae){this.v(Q);return}const ne=new k.$pe;let we;try{we=ae.call(this.j,Q.name,Q.arg,ne.token)}catch(V){we=Promise.reject(V)}const ie=Q.id;we.then(V=>{this.m({id:ie,data:V,type:201})},V=>{V instanceof Error?this.m({id:ie,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.m({id:ie,data:V,type:203})}).finally(()=>{Y.dispose(),this.d.delete(Q.id)});const Y=(0,g.$Tc)(()=>ne.cancel());this.d.set(Q.id,Y)}t(Q){const ae=this.b.get(Q.channelName);if(!ae){this.v(Q);return}const ne=Q.id,ie=ae.listen(this.j,Q.name,Q.arg)(Y=>this.m({id:ne,data:Y,type:204}));this.d.set(Q.id,ie)}u(Q){const ae=this.d.get(Q.id);ae&&(ae.dispose(),this.d.delete(Q.id))}v(Q){let ae=this.g.get(Q.channelName);ae||(ae=[],this.g.set(Q.channelName,ae));const ne=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:Q,timeoutTimer:ne})}w(Q){const ae=this.g.get(Q);if(ae){for(const ne of ae)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}e.$$h=P;var j;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class O{constructor(Q,ae=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ae}getChannel(Q){const ae=this;return{call(ne,we,ie){return ae.a?Promise.reject(new S.$5):ae.m(Q,ne,we,ie)},listen(ne,we){return ae.a?w.Event.None:ae.o(Q,ne,we)}}}m(Q,ae,ne,we=k.CancellationToken.None){const ie=this.g++,V={id:ie,type:100,channelName:Q,name:ae,arg:ne};if(we.isCancellationRequested)return Promise.reject(new S.$5);let N;return new Promise((Z,he)=>{if(we.isCancellationRequested)return he(new S.$5);const x=()=>{const U=oe=>{switch(oe.type){case 201:this.f.delete(ie),Z(oe.data);break;case 202:{this.f.delete(ie);const le=new Error(oe.data.message);le.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,le.name=oe.data.name,he(le);break}case 203:this.f.delete(ie),he(oe.data);break}};this.f.set(ie,U),this.p(V)};let J=null;this.b===c.Idle?x():(J=(0,C.$jh)(U=>this.u()),J.then(()=>{J=null,x()}));const H=()=>{J?(J.cancel(),J=null):this.p({id:ie,type:101}),he(new S.$5)},L=we.onCancellationRequested(H);N=(0,g.$Sc)((0,g.$Tc)(H),L),this.d.add(N)}).finally(()=>{N.dispose(),this.d.delete(N)})}o(Q,ae,ne){const we=this.g++,Y={id:we,type:102,channelName:Q,name:ae,arg:ne};let V=null;const N=new w.$ee({onWillAddFirstListener:()=>{V=(0,C.$jh)(Z=>this.u()),V.then(()=>{V=null,this.d.add(N),this.p(Y)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(N),this.p({id:we,type:103}))}}),z=Z=>N.fire(Z.data);return this.f.set(we,z),N.event}p(Q){switch(Q.type){case 100:case 102:{const ae=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(ae,Q.id,0,`${u(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const ae=this.q([Q.type,Q.id]);this.j?.logOutgoing(ae,Q.id,0,u(Q.type));return}}}q(Q,ae=void 0){const ne=new t;return l(ne,Q),l(ne,ae),this.r(ne.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const ae=new h(Q),ne=p(ae),we=p(ae),ie=ne[0];switch(ie){case 200:return this.j?.logIncoming(Q.byteLength,0,0,f(ie)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ne[1],0,f(ie),we),this.t({type:ne[0],id:ne[1],data:we})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}e.$_h=O,Fe([I.$1h],O.prototype,"onDidInitializePromise",null);class R{get connections(){const Q=[];return this.f.forEach(ae=>Q.push(ae)),Q}constructor(Q,ae,ne){this.a=new Map,this.f=new Set,this.g=new w.$ee,this.onDidAddConnection=this.g.event,this.h=new w.$ee,this.onDidRemoveConnection=this.h.event,this.j=new g.$Uc,this.j.add(Q(({protocol:we,onDidClientDisconnect:ie})=>{const Y=w.Event.once(we.onMessage);this.j.add(Y(V=>{const N=new h(V),z=p(N),Z=new P(we,z,ae,ne),he=new O(we,ae);this.a.forEach((J,H)=>Z.registerChannel(H,J));const x={channelServer:Z,channelClient:he,ctx:z};this.f.add(x),this.g.fire(x),this.j.add(ie(()=>{Z.dispose(),he.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(Q,ae){const ne=this;return{call(we,ie,Y){let V;if((0,b.$kg)(ae)){const z=(0,s.$4b)(ne.connections.filter(ae));V=z?Promise.resolve(z):w.Event.toPromise(w.Event.filter(ne.onDidAddConnection,ae))}else V=ae.routeCall(ne,we,ie);const N=V.then(z=>z.channelClient.getChannel(Q));return B(N).call(we,ie,Y)},listen(we,ie){if((0,b.$kg)(ae))return ne.k(Q,ae,we,ie);const Y=ae.routeEvent(ne,we,ie).then(V=>V.channelClient.getChannel(Q));return B(Y).listen(we,ie)}}}k(Q,ae,ne,we){const ie=this;let Y;const V=new w.$ee({onWillAddFirstListener:()=>{Y=new g.$Uc;const N=new w.$ke,z=new Map,Z=x=>{const H=x.channelClient.getChannel(Q).listen(ne,we),L=N.add(H);z.set(x,L)},he=x=>{const J=z.get(x);J&&(J.dispose(),z.delete(x))};ie.connections.filter(ae).forEach(Z),w.Event.filter(ie.onDidAddConnection,ae)(Z,void 0,Y),ie.onDidRemoveConnection(he,void 0,Y),N.event(V.fire,V,Y),Y.add(N)},onDidRemoveLastListener:()=>{Y?.dispose(),Y=void 0}});return V.event}registerChannel(Q,ae){this.a.set(Q,ae);for(const ne of this.f)ne.channelServer.registerChannel(Q,ae)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=R;class A{constructor(Q,ae,ne=null){const we=new t;l(we,ae),Q.send(we.buffer),this.a=new O(Q,ne),this.d=new P(Q,ae,ne)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,ae){this.d.registerChannel(Q,ae)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=A;function B(M){return{call(Q,ae,ne){return M.then(we=>we.call(Q,ae,ne))},listen(Q,ae){const ne=new w.$ne;return M.then(we=>ne.input=we.listen(Q,ae)),ne.event}}}function G(M){let Q=!1;return{call(ae,ne,we){return Q?M.call(ae,ne,we):(0,C.$xh)(0).then(()=>Q=!0).then(()=>M.call(ae,ne,we))},listen(ae,ne){if(Q)return M.listen(ae,ne);const we=new w.$ne;return(0,C.$xh)(0).then(()=>Q=!0).then(()=>we.input=M.listen(ae,ne)),we.event}}}class se{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const ae of Q.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await w.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$ei=se;var ce;(function(M){function Q(ie,Y,V){const N=ie,z=V&&V.disableMarshalling,Z=new Map;for(const he in N)ne(he)&&Z.set(he,w.Event.buffer(N[he],!0,void 0,Y));return new class{listen(he,x,J){const H=Z.get(x);if(H)return H;const L=N[x];if(typeof L=="function"){if(we(x))return L.call(N,J);if(ne(x))return Z.set(x,w.Event.buffer(N[x],!0,void 0,Y)),Z.get(x)}throw new S.$bb(`Event not found: ${x}`)}call(he,x,J){const H=N[x];if(typeof H=="function"){if(!z&&Array.isArray(J))for(let U=0;U<J.length;U++)J[U]=(0,y.$6h)(J[U]);let L=H.apply(N,J);return L instanceof Promise||(L=Promise.resolve(L)),L}throw new S.$bb(`Method not found: ${x}`)}}}M.fromService=Q;function ae(ie,Y){const V=Y&&Y.disableMarshalling;return new Proxy({},{get(N,z){if(typeof z=="string")return Y?.properties?.has(z)?Y.properties.get(z):we(z)?function(Z){return ie.listen(z,Z)}:ne(z)?ie.listen(z):async function(...Z){let he;Y&&!(0,b.$fg)(Y.context)?he=[Y.context,...Z]:he=Z;const x=await ie.call(z,he);return V?x:(0,y.$6h)(x)};throw new S.$bb(`Property not found: ${String(z)}`)}})}M.toService=ae;function ne(ie){return ie[0]==="o"&&ie[1]==="n"&&v.$xf(ie.charCodeAt(2))}function we(ie){return/^onDynamic/.test(ie)&&v.$xf(ie.charCodeAt(9))}})(ce||(e.ProxyChannel=ce={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const Q=M.toString();if(Q!=="[object Object]")return Q}return M}function q(M){return Array.isArray(M)?M.map(K):K(M)}function X(M,Q,ae,ne,we,ie,Y){Y=q(Y);const V=ee[we],N=V[ne%V.length];let z=[`%c[${M}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(ie)?(z=z.concat(Y),z.push(")")):z.push(Y),console.log.apply(console,z)}class _{constructor(Q,ae){this.d=Q,this.f=ae,this.a=0,this.b=0}logOutgoing(Q,ae,ne,we,ie){this.b+=Q,X(this.d,this.b,Q,ae,ne,we,ie)}logIncoming(Q,ae,ne,we,ie){this.a+=Q,X(this.f,this.a,Q,ae,ne,we,ie)}}e.$fi=_}),define(ye[108],Ee([1,0,15,6,2,45]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let l=0;function p(j,O){if(!n.has(j)){const R=String(++l);n.set(j,R)}return n.get(j)}function P(j,O,R,A){if(!i.enableDiagnostics)return;const B=p(j,O);if(A instanceof s.$Ge||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const G=s.$Ge.alloc(A.byteLength);G.set(A),i.records.push({timestamp:Date.now(),id:B,label:O,type:R,buff:G})}else i.records.push({timestamp:Date.now(),id:B,label:O,type:R,data:A})}i.traceSocketEvent=P})(S||(e.SocketDiagnostics=S={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let g=null;function y(){return g||(g=s.$Ge.alloc(0)),g}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,l){if(n===0)return y();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const O=this.a[0];return l&&(this.a.shift(),this.b-=n),O}if(this.a[0].byteLength>n){const O=this.a[0].slice(0,n);return l&&(this.a[0]=this.a[0].slice(n),this.b-=n),O}const p=s.$Ge.alloc(n);let P=0,j=0;for(;n>0;){const O=this.a[j];if(O.byteLength>n){const R=O.slice(0,n);p.set(R,P),P+=n,l&&(this.a[j]=O.slice(n),this.b-=n),n-=n}else p.set(O,P),P+=O.byteLength,l?(this.a.shift(),this.b-=O.byteLength):j++,n-=O.byteLength}return p}}e.$gi=v;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function m(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var u;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(u||(e.ProtocolConstants=u={}));class a{constructor(n,l,p,P){this.type=n,this.id=l,this.ack=p,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends D.$Vc{constructor(n){super(),this.f=this.B(new C.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,P=this.g.id,j=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new a(p,P,j,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=s.$Ge.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(l,n.data)}g(n,l){const p=this.f===0;return this.d.push(n,l),this.f+=n.byteLength+l.byteLength,p}h(){const n=s.$Ge.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,l){this.g(n,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class d extends D.$Vc{constructor(n){super(),this.f=new C.$ee,this.onMessage=this.f.event,this.g=new C.$ee,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new c(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new a(1,0,0,n))}}e.$hi=d;class $ extends k.$bi{static fromSocket(n,l){return new $(new d(n),l)}get onDidDispose(){return this.b.onDidDispose}constructor(n,l,p=null){super(n,l,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$ii=$;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ji=E;class h{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,l=this.a;for(;l;)l=l.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let l=0,p=this.a;for(;p;)n[l++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const l=new h(n);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let l=0;l<o.a;l++)this.c[l]=n-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),l=(1+o.a)*1e3;let p=0;for(let P=0;P<o.a;P++)n-this.c[P]<=l&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new D.$Uc,this.o=n.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new a(5,0,0,y());this.p.write(n),this.p.flush()}sendPause(){const n=new a(7,0,0,y());this.p.write(n)}sendResume(){const n=new a(8,0,0,y());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,l){this.a=!0,this.r.dispose(),this.r=new D.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new a(3,0,this.h,y());this.p.write(n);const l=this.b.toArray();for(let p=0,P=l.length;p<P;p++)this.p.write(l[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const l=this.b.peek();if(l&&l.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new a(6,0,0,y())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let p=0,P=l.length;p<P;p++)this.p.write(l[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const l=++this.c;this.h=this.g;const p=new a(1,l,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const l=new a(2,0,0,n);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),l=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(l>=2e4&&p>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:p});return}const j=Math.max(2e4-l,2e4-p,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},j)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new a(3,0,this.h,y());this.p.write(n)}D(){this.h=this.g;const n=new a(9,0,this.h,y());this.p.write(n)}}e.$ki=r}),define(ye[109],Ee([1,0,56,14,15,20,163,11,6,2,21,105,62,45]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=void 0;class u extends m.$$h{constructor(c){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",d=>D.$Ge.wrap(Buffer.from(d,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$1q=u;class a{constructor(c,d){this.i=c,this.j=d,this.c=new Set,this.g=new Map,this.h=new w.$ee,this.onDidProcessExit=this.h.event;const $=d&&d.timeout?d.timeout:6e4;this.b=new C.$th($),this.d=null,this.f=null}getChannel(c){const d=this;return{call($,E,h){return d.k(c,$,E,h)},listen($,E){return d.l(c,$,E)}}}k(c,d,$,E=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const h=this.n(c),t=(0,C.$jh)(i=>h.call(d,$,i)),o=E.onCancellationRequested(()=>t.cancel()),r=(0,g.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,d,$){if(!this.b)return w.Event.None;this.b.cancel();let E;const h=new w.$ee({onWillAddFirstListener:()=>{E=this.n(c).listen(d,$)(h.fire,h),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,y.$4n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,b.$om)(d.env),this.d=(0,s.fork)(this.i,c,d);const $=new w.$ee,h=w.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,I.$Wq)(l)){(0,I.log)(l,`IPC Library: ${this.j.serverName}`);return}$.fire(D.$Ge.wrap(Buffer.from(l,"base64")))}),t=this.j.useQueue?(0,v.$qm)(this.d):this.d,o=l=>this.d&&this.d.connected&&t.send(l.buffer.toString("base64")),r=$.event,i={send:o,onMessage:r};this.f=new m.$_h(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,p)=>{process.removeListener("exit",n),h.dispose(),this.c.forEach(P=>(0,g.$Qc)(P)),this.c.clear(),l!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+p),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:p})})}return this.f}n(c){let d=this.g.get(c);return d||(d=this.m.getChannel(c),this.g.set(c,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$2q=a}),define(ye[172],Ee([1,0,14,6,2,54,10]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.StorageState=e.StorageHint=void 0,e.$Wp=w;var S;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function w(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}var g;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(g||(e.StorageState=g={}));class y extends D.$Vc{constructor(m,u=Object.create(null)){super(),this.r=m,this.s=u,this.b=this.B(new C.$he),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new s.$uh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((u,a)=>this.w(a,u)),m.deleted?.forEach(u=>this.w(u,void 0))}finally{this.b.resume()}}w(m,u){if(this.c===g.Closed)return;let a=!1;(0,I.$fg)(u)?a=this.f.delete(m):this.f.get(m)!==u&&(this.f.set(m,u),a=!0),a&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,u){const a=this.f.get(m);return(0,I.$fg)(a)?u:a}getBoolean(m,u){const a=this.get(m);return(0,I.$fg)(a)?u:a==="true"}getNumber(m,u){const a=this.get(m);return(0,I.$fg)(a)?u:parseInt(a,10)}getObject(m,u){const a=this.get(m);return(0,I.$fg)(a)?u:(0,k.$5h)(a)}async set(m,u,a=!1){if(this.c===g.Closed)return;if((0,I.$fg)(u))return this.delete(m,a);const f=(0,I.$$f)(u)||Array.isArray(u)?(0,k.$4h)(u):String(u);if(this.f.get(m)!==f)return this.f.set(m,f),this.j.set(m,f),this.h.delete(m),this.b.fire({key:m,external:a}),this.D()}async delete(m,u=!1){if(!(this.c===g.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:u}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Xp=y,y.a=100;class v{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((u,a)=>this.a.set(a,u)),m.delete?.forEach(u=>this.a.delete(u))}async optimize(){}async close(){}}e.$Yp=v}),define(ye[80],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class s{constructor(D,k){this.lineNumber=D,this.column=k}with(D=this.lineNumber,k=this.column){return D===this.lineNumber&&k===this.column?this:new s(D,k)}delta(D=0,k=0){return this.with(this.lineNumber+D,this.column+k)}equals(D){return s.equals(this,D)}static equals(D,k){return!D&&!k?!0:!!D&&!!k&&D.lineNumber===k.lineNumber&&D.column===k.column}isBefore(D){return s.isBefore(this,D)}static isBefore(D,k){return D.lineNumber<k.lineNumber?!0:k.lineNumber<D.lineNumber?!1:D.column<k.column}isBeforeOrEqual(D){return s.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,k){return D.lineNumber<k.lineNumber?!0:k.lineNumber<D.lineNumber?!1:D.column<=k.column}static compare(D,k){const I=D.lineNumber|0,S=k.lineNumber|0;if(I===S){const w=D.column|0,g=k.column|0;return w-g}return I-S}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new s(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ut=s}),define(ye[46],Ee([1,0,80]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class C{constructor(k,I,S,w){k>S||k===S&&I>w?(this.startLineNumber=S,this.startColumn=w,this.endLineNumber=k,this.endColumn=I):(this.startLineNumber=k,this.startColumn=I,this.endLineNumber=S,this.endColumn=w)}isEmpty(){return C.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return C.containsPosition(this,k)}static containsPosition(k,I){return!(I.lineNumber<k.startLineNumber||I.lineNumber>k.endLineNumber||I.lineNumber===k.startLineNumber&&I.column<k.startColumn||I.lineNumber===k.endLineNumber&&I.column>k.endColumn)}static strictContainsPosition(k,I){return!(I.lineNumber<k.startLineNumber||I.lineNumber>k.endLineNumber||I.lineNumber===k.startLineNumber&&I.column<=k.startColumn||I.lineNumber===k.endLineNumber&&I.column>=k.endColumn)}containsRange(k){return C.containsRange(this,k)}static containsRange(k,I){return!(I.startLineNumber<k.startLineNumber||I.endLineNumber<k.startLineNumber||I.startLineNumber>k.endLineNumber||I.endLineNumber>k.endLineNumber||I.startLineNumber===k.startLineNumber&&I.startColumn<k.startColumn||I.endLineNumber===k.endLineNumber&&I.endColumn>k.endColumn)}strictContainsRange(k){return C.strictContainsRange(this,k)}static strictContainsRange(k,I){return!(I.startLineNumber<k.startLineNumber||I.endLineNumber<k.startLineNumber||I.startLineNumber>k.endLineNumber||I.endLineNumber>k.endLineNumber||I.startLineNumber===k.startLineNumber&&I.startColumn<=k.startColumn||I.endLineNumber===k.endLineNumber&&I.endColumn>=k.endColumn)}plusRange(k){return C.plusRange(this,k)}static plusRange(k,I){let S,w,g,y;return I.startLineNumber<k.startLineNumber?(S=I.startLineNumber,w=I.startColumn):I.startLineNumber===k.startLineNumber?(S=I.startLineNumber,w=Math.min(I.startColumn,k.startColumn)):(S=k.startLineNumber,w=k.startColumn),I.endLineNumber>k.endLineNumber?(g=I.endLineNumber,y=I.endColumn):I.endLineNumber===k.endLineNumber?(g=I.endLineNumber,y=Math.max(I.endColumn,k.endColumn)):(g=k.endLineNumber,y=k.endColumn),new C(S,w,g,y)}intersectRanges(k){return C.intersectRanges(this,k)}static intersectRanges(k,I){let S=k.startLineNumber,w=k.startColumn,g=k.endLineNumber,y=k.endColumn;const v=I.startLineNumber,b=I.startColumn,m=I.endLineNumber,u=I.endColumn;return S<v?(S=v,w=b):S===v&&(w=Math.max(w,b)),g>m?(g=m,y=u):g===m&&(y=Math.min(y,u)),S>g||S===g&&w>y?null:new C(S,w,g,y)}equalsRange(k){return C.equalsRange(this,k)}static equalsRange(k,I){return!k&&!I?!0:!!k&&!!I&&k.startLineNumber===I.startLineNumber&&k.startColumn===I.startColumn&&k.endLineNumber===I.endLineNumber&&k.endColumn===I.endColumn}getEndPosition(){return C.getEndPosition(this)}static getEndPosition(k){return new s.$ut(k.endLineNumber,k.endColumn)}getStartPosition(){return C.getStartPosition(this)}static getStartPosition(k){return new s.$ut(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,I){return new C(this.startLineNumber,this.startColumn,k,I)}setStartPosition(k,I){return new C(k,I,this.endLineNumber,this.endColumn)}collapseToStart(){return C.collapseToStart(this)}static collapseToStart(k){return new C(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}collapseToEnd(){return C.collapseToEnd(this)}static collapseToEnd(k){return new C(k.endLineNumber,k.endColumn,k.endLineNumber,k.endColumn)}delta(k){return new C(this.startLineNumber+k,this.startColumn,this.endLineNumber+k,this.endColumn)}static fromPositions(k,I=k){return new C(k.lineNumber,k.column,I.lineNumber,I.column)}static lift(k){return k?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,I){return!(k.endLineNumber<I.startLineNumber||k.endLineNumber===I.startLineNumber&&k.endColumn<I.startColumn||I.endLineNumber<k.startLineNumber||I.endLineNumber===k.startLineNumber&&I.endColumn<k.startColumn)}static areIntersecting(k,I){return!(k.endLineNumber<I.startLineNumber||k.endLineNumber===I.startLineNumber&&k.endColumn<=I.startColumn||I.endLineNumber<k.startLineNumber||I.endLineNumber===k.startLineNumber&&I.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,I){if(k&&I){const g=k.startLineNumber|0,y=I.startLineNumber|0;if(g===y){const v=k.startColumn|0,b=I.startColumn|0;if(v===b){const m=k.endLineNumber|0,u=I.endLineNumber|0;if(m===u){const a=k.endColumn|0,f=I.endColumn|0;return a-f}return m-u}return v-b}return g-y}return(k?1:0)-(I?1:0)}static compareRangesUsingEnds(k,I){return k.endLineNumber===I.endLineNumber?k.endColumn===I.endColumn?k.startLineNumber===I.startLineNumber?k.startColumn-I.startColumn:k.startLineNumber-I.startLineNumber:k.endColumn-I.endColumn:k.endLineNumber-I.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}toJSON(){return this}}e.$vt=C}),define(ye[173],Ee([1,0,46]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0;class C{static insert(k,I){return{range:new s.$vt(k.lineNumber,k.column,k.lineNumber,k.column),text:I,forceMoveMarkers:!0}}static delete(k){return{range:k,text:null}}static replace(k,I){return{range:k,text:I}}static replaceMove(k,I){return{range:k,text:I,forceMoveMarkers:!0}}}e.$wt=C}),define(ye[174],Ee([1,0,6,2]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=void 0;class D{constructor(){this.a=new Map,this.b=new Map,this.c=new s.$ee,this.onDidChange=this.c.event,this.d=null}handleChange(S){this.c.fire({changedLanguages:S,changedColorMap:!1})}register(S,w){return this.a.set(S,w),this.handleChange([S]),(0,C.$Tc)(()=>{this.a.get(S)===w&&(this.a.delete(S),this.handleChange([S]))})}get(S){return this.a.get(S)||null}registerFactory(S,w){this.b.get(S)?.dispose();const g=new k(this,S,w);return this.b.set(S,g),(0,C.$Tc)(()=>{const y=this.b.get(S);!y||y!==g||(this.b.delete(S),y.dispose())})}async getOrCreate(S){const w=this.get(S);if(w)return w;const g=this.b.get(S);return!g||g.isResolved?null:(await g.resolve(),this.get(S))}isResolved(S){if(this.get(S))return!0;const g=this.b.get(S);return!!(!g||g.isResolved)}setColorMap(S){this.d=S,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$1t=D;class k extends C.$Vc{get isResolved(){return this.c}constructor(S,w,g){super(),this.f=S,this.g=w,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const S=await this.h.tokenizationSupport;this.c=!0,S&&!this.a&&this.B(this.f.register(this.g,S))}}}),define(ye[175],Ee([8,9]),function(ue,e){return ue.create("vs/base/common/actions",e)}),define(ye[176],Ee([1,0,6,2,175]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=y;class k extends C.$Vc{constructor(b,m="",u="",a=!0,f){super(),this.h=this.B(new s.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=m,this.u=u,this.w=a,this.C=f}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,m){this.C&&await this.C(b)}}e.$bj=k;class I extends C.$Vc{constructor(){super(...arguments),this.f=this.B(new s.$ee),this.onWillRun=this.f.event,this.m=this.B(new s.$ee),this.onDidRun=this.m.event}async run(b,m){if(!b.enabled)return;this.f.fire({action:b});let u;try{await this.u(b,m)}catch(a){u=a}this.m.fire({action:b,error:u})}async u(b,m){await b.run(m)}}e.$cj=I;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let m=[];for(const u of b)u.length&&(m.length?m=[...m,new S,...u]:m=u);return m}async run(){}}e.$dj=S,S.ID="vs.actions.separator";class w{get actions(){return this.a}constructor(b,m,u,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=m,this.class=a,this.a=u}async run(){}}e.$ej=w;class g extends k{constructor(){super(g.ID,D.localize(0,null),void 0,!1)}}e.$fj=g,g.ID="vs.actions.empty";function y(v){return{id:v.id,label:v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...b)=>v.run(...b),tooltip:v.label}}}),define(ye[177],Ee([8,9]),function(ue,e){return ue.create("vs/base/common/date",e)}),define(ye[178],Ee([1,0,177]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=g,e.$4m=y,e.$5m=v;const C=60,D=C*60,k=D*24,I=k*7,S=k*30,w=k*365;function g(b,m,u,a){typeof b!="number"&&(b=b.getTime());const f=Math.round((new Date().getTime()-b)/1e3);if(f<-30)return(0,s.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!a&&f<30)return(0,s.localize)(1,null);let c;return f<C?(c=f,m?c===1?u?(0,s.localize)(2,null,c):(0,s.localize)(3,null,c):u?(0,s.localize)(4,null,c):(0,s.localize)(5,null,c):c===1?u?(0,s.localize)(6,null,c):(0,s.localize)(7,null,c):u?(0,s.localize)(8,null,c):(0,s.localize)(9,null,c)):f<D?(c=Math.floor(f/C),m?c===1?u?(0,s.localize)(10,null,c):(0,s.localize)(11,null,c):u?(0,s.localize)(12,null,c):(0,s.localize)(13,null,c):c===1?u?(0,s.localize)(14,null,c):(0,s.localize)(15,null,c):u?(0,s.localize)(16,null,c):(0,s.localize)(17,null,c)):f<k?(c=Math.floor(f/D),m?c===1?u?(0,s.localize)(18,null,c):(0,s.localize)(19,null,c):u?(0,s.localize)(20,null,c):(0,s.localize)(21,null,c):c===1?u?(0,s.localize)(22,null,c):(0,s.localize)(23,null,c):u?(0,s.localize)(24,null,c):(0,s.localize)(25,null,c)):f<I?(c=Math.floor(f/k),m?c===1?(0,s.localize)(26,null,c):(0,s.localize)(27,null,c):c===1?(0,s.localize)(28,null,c):(0,s.localize)(29,null,c)):f<S?(c=Math.floor(f/I),m?c===1?u?(0,s.localize)(30,null,c):(0,s.localize)(31,null,c):u?(0,s.localize)(32,null,c):(0,s.localize)(33,null,c):c===1?u?(0,s.localize)(34,null,c):(0,s.localize)(35,null,c):u?(0,s.localize)(36,null,c):(0,s.localize)(37,null,c)):f<w?(c=Math.floor(f/S),m?c===1?u?(0,s.localize)(38,null,c):(0,s.localize)(39,null,c):u?(0,s.localize)(40,null,c):(0,s.localize)(41,null,c):c===1?u?(0,s.localize)(42,null,c):(0,s.localize)(43,null,c):u?(0,s.localize)(44,null,c):(0,s.localize)(45,null,c)):(c=Math.floor(f/w),m?c===1?u?(0,s.localize)(46,null,c):(0,s.localize)(47,null,c):u?(0,s.localize)(48,null,c):(0,s.localize)(49,null,c):c===1?u?(0,s.localize)(50,null,c):(0,s.localize)(51,null,c):u?(0,s.localize)(52,null,c):(0,s.localize)(53,null,c))}function y(b,m){const u=Math.abs(b/1e3);return u<1?m?(0,s.localize)(54,null,b):(0,s.localize)(55,null,b):u<C?m?(0,s.localize)(56,null,Math.round(b)/1e3):(0,s.localize)(57,null,Math.round(b)/1e3):u<D?m?(0,s.localize)(58,null,Math.round(b/(1e3*C))):(0,s.localize)(59,null,Math.round(b/(1e3*C))):u<k?m?(0,s.localize)(60,null,Math.round(b/(1e3*D))):(0,s.localize)(61,null,Math.round(b/(1e3*D))):(0,s.localize)(62,null,Math.round(b/(1e3*k)))}function v(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[179],Ee([8,9]),function(ue,e){return ue.create("vs/base/common/errorMessage",e)}),define(ye[39],Ee([1,0,18,10,179]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=w,e.$ij=g,e.$jj=y;function k(v,b){return b&&(v.stack||v.stacktrace)?D.localize(0,null,S(v),I(v.stack)||I(v.stacktrace)):S(v)}function I(v){return Array.isArray(v)?v.join(`
`):v}function S(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?D.localize(1,null,v.message):v.message||D.localize(2,null)}function w(v=null,b=!1){if(!v)return D.localize(3,null);if(Array.isArray(v)){const m=s.$Hb(v),u=w(m[0],b);return m.length>1?D.localize(4,null,u,m.length):u}if(C.$9f(v))return v;if(v.detail){const m=v.detail;if(m.error)return k(m.error,b);if(m.exception)return k(m.exception,b)}return v.stack?k(v,b):v.message?v.message:D.localize(5,null)}function g(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}function y(v,b){let m;return typeof v=="string"?m=new Error(v):m=v,m.actions=b,m}}),define(ye[180],Ee([8,9]),function(ue,e){return ue.create("vs/base/common/jsonErrorMessages",e)}),define(ye[181],Ee([1,0,180]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=C;function C(D){switch(D){case 1:return(0,s.localize)(0,null);case 2:return(0,s.localize)(1,null);case 3:return(0,s.localize)(2,null);case 4:return(0,s.localize)(3,null);case 5:return(0,s.localize)(4,null);case 6:return(0,s.localize)(5,null);case 7:return(0,s.localize)(6,null);case 8:return(0,s.localize)(7,null);case 9:return(0,s.localize)(8,null);default:return""}}}),define(ye[182],Ee([8,9]),function(ue,e){return ue.create("vs/base/node/zip",e)}),define(ye[81],Ee([1,0,27,14,7,10,23,182]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0,e.zip=f,e.$kq=c,e.$lq=$,e.$hq="end of central directory record signature not found";const w=new RegExp(e.$hq);class g extends Error{constructor(h,t){let o=t.message;switch(h){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=h,this.cause=t}}e.$iq=g;function y(E){const h=E.externalFileAttributes>>16||33188;return[448,56,7].map(t=>h&t).reduce((t,o)=>t+o,h&61440)}function v(E){if(E instanceof g)return E;let h;return w.test(E.message)&&(h="CorruptZip"),new g(h,E)}function b(E,h,t,o,r,i){const n=D.$nc(h),l=D.$kc(o,n);if(!l.startsWith(o))return Promise.reject(new Error(S.localize(0,null,h)));const p=D.$kc(o,h);let P;return i.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(I.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((j,O)=>{if(!i.isCancellationRequested)try{P=(0,s.createWriteStream)(p,{mode:t}),P.once("close",()=>j()),P.once("error",O),E.once("error",O),E.pipe(P)}catch(R){O(R)}}))}function m(E,h,t,o){let r=(0,C.$jh)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{r.cancel(),E.close()});return new Promise((l,p)=>{const P=new C.$rh,j=O=>{O.isCancellationRequested||(i++,E.readEntry())};E.once("error",p),E.once("close",()=>r.then(()=>{o.isCancellationRequested||E.entryCount===i?l():p(new g("Incomplete",new Error(S.localize(1,null,i,E.entryCount))))},p)),E.readEntry(),E.on("entry",O=>{if(o.isCancellationRequested)return;if(!t.sourcePathRegex.test(O.fileName)){j(o);return}const R=O.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(R)){const G=D.$kc(h,R);r=(0,C.$jh)(se=>I.Promises.mkdir(G,{recursive:!0}).then(()=>j(se)).then(void 0,p));return}const A=a(E,O),B=y(O);r=(0,C.$jh)(G=>P.queue(()=>A.then(se=>b(se,R,B,h,t,G).then(()=>j(G)))).then(null,p))})}).finally(()=>n.dispose())}async function u(E,h=!1){const{open:t}=await new Promise((o,r)=>{ue(["yauzl"],o,r)});return new Promise((o,r)=>{t(E,h?{lazyEntries:!0}:void 0,(i,n)=>{i?r(v(i)):o((0,k.$hg)(n))})})}function a(E,h){return new Promise((t,o)=>{E.openReadStream(h,(r,i)=>{r?o(v(r)):t((0,k.$hg)(i))})})}async function f(E,h){const{ZipFile:t}=await new Promise((o,r)=>{ue(["yazl"],o,r)});return new Promise((o,r)=>{const i=new t;h.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const n=(0,s.createWriteStream)(E);i.outputStream.pipe(n),i.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>o(E))})}function c(E,h,t={},o){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=u(E,!0);return t.overwrite&&(i=i.then(n=>I.Promises.rm(h).then(()=>n))),i.then(n=>m(n,h,{sourcePathRegex:r},o))}function d(E,h){return u(E).then(t=>new Promise((o,r)=>{t.on("entry",i=>{i.fileName===h&&a(t,i).then(n=>o(n),n=>r(n))}),t.once("close",()=>r(new Error(S.localize(2,null,h))))}))}function $(E,h){return d(E,h).then(t=>new Promise((o,r)=>{const i=[];t.once("error",r),t.on("data",n=>i.push(n)),t.on("end",()=>o(Buffer.concat(i)))}))}}),define(ye[183],Ee([8,9]),function(ue,e){return ue.create("vs/editor/common/languages",e)}),define(ye[184],Ee([1,0,53,4,173,46,174,183]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$gu=e.$fu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$eu=e.$du=e.SymbolKinds=e.SymbolTag=e.$bu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$_t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$$t=e.$0t=e.$9t=void 0,e.$au=r,e.$cu=n;class w{constructor(Q,ae,ne){this.offset=Q,this.type=ae,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$9t=w;class g{constructor(Q,ae){this.tokens=Q,this.endState=ae,this._tokenizationResultBrand=void 0}}e.$0t=g;class y{constructor(Q,ae){this.tokens=Q,this.endState=ae,this._encodedTokenizationResultBrand=void 0}}e.$$t=y;var v;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(v||(e.HoverVerbosityAction=v={}));var b;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(b||(e.CompletionItemKind=b={}));var m;(function(M){const Q=new Map;Q.set(0,s.$Vj.symbolMethod),Q.set(1,s.$Vj.symbolFunction),Q.set(2,s.$Vj.symbolConstructor),Q.set(3,s.$Vj.symbolField),Q.set(4,s.$Vj.symbolVariable),Q.set(5,s.$Vj.symbolClass),Q.set(6,s.$Vj.symbolStruct),Q.set(7,s.$Vj.symbolInterface),Q.set(8,s.$Vj.symbolModule),Q.set(9,s.$Vj.symbolProperty),Q.set(10,s.$Vj.symbolEvent),Q.set(11,s.$Vj.symbolOperator),Q.set(12,s.$Vj.symbolUnit),Q.set(13,s.$Vj.symbolValue),Q.set(15,s.$Vj.symbolEnum),Q.set(14,s.$Vj.symbolConstant),Q.set(15,s.$Vj.symbolEnum),Q.set(16,s.$Vj.symbolEnumMember),Q.set(17,s.$Vj.symbolKeyword),Q.set(27,s.$Vj.symbolSnippet),Q.set(18,s.$Vj.symbolText),Q.set(19,s.$Vj.symbolColor),Q.set(20,s.$Vj.symbolFile),Q.set(21,s.$Vj.symbolReference),Q.set(22,s.$Vj.symbolCustomColor),Q.set(23,s.$Vj.symbolFolder),Q.set(24,s.$Vj.symbolTypeParameter),Q.set(25,s.$Vj.account),Q.set(26,s.$Vj.issues);function ae(ie){let Y=Q.get(ie);return Y||(console.info("No codicon found for CompletionItemKind "+ie),Y=s.$Vj.symbolProperty),Y}M.toIcon=ae;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function we(ie,Y){let V=ne.get(ie);return typeof V>"u"&&!Y&&(V=9),V}M.fromString=we})(m||(e.CompletionItemKinds=m={}));var u;(function(M){M[M.Deprecated=1]="Deprecated"})(u||(e.CompletionItemTag=u={}));var a;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var f;(function(M){M[M.Word=0]="Word",M[M.Line=1]="Line",M[M.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var c;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var d;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class ${constructor(Q,ae,ne,we){this.range=Q,this.text=ae,this.completionKind=ne,this.isSnippetText=we}equals(Q){return k.$vt.lift(this.range).equalsRange(Q.range)&&this.text===Q.text&&this.completionKind===Q.completionKind&&this.isSnippetText===Q.isSnippetText}}e.$_t=$;var E;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(E||(e.CodeActionTriggerType=E={}));var h;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(h||(e.DocumentPasteTriggerKind=h={}));var t;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function r(M){return M&&C.URI.isUri(M.uri)&&k.$vt.isIRange(M.range)&&(k.$vt.isIRange(M.originSelectionRange)||k.$vt.isIRange(M.targetSelectionRange))}var i;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$bu={17:(0,S.localize)(0,null),16:(0,S.localize)(1,null),4:(0,S.localize)(2,null),13:(0,S.localize)(3,null),8:(0,S.localize)(4,null),9:(0,S.localize)(5,null),21:(0,S.localize)(6,null),23:(0,S.localize)(7,null),7:(0,S.localize)(8,null),0:(0,S.localize)(9,null),11:(0,S.localize)(10,null),10:(0,S.localize)(11,null),19:(0,S.localize)(12,null),5:(0,S.localize)(13,null),1:(0,S.localize)(14,null),2:(0,S.localize)(15,null),20:(0,S.localize)(16,null),15:(0,S.localize)(17,null),18:(0,S.localize)(18,null),24:(0,S.localize)(19,null),3:(0,S.localize)(20,null),6:(0,S.localize)(21,null),14:(0,S.localize)(22,null),22:(0,S.localize)(23,null),25:(0,S.localize)(24,null),12:(0,S.localize)(25,null)};function n(M,Q){return(0,S.localize)(26,null,M,e.$bu[Q])}var l;(function(M){M[M.Deprecated=1]="Deprecated"})(l||(e.SymbolTag=l={}));var p;(function(M){const Q=new Map;Q.set(0,s.$Vj.symbolFile),Q.set(1,s.$Vj.symbolModule),Q.set(2,s.$Vj.symbolNamespace),Q.set(3,s.$Vj.symbolPackage),Q.set(4,s.$Vj.symbolClass),Q.set(5,s.$Vj.symbolMethod),Q.set(6,s.$Vj.symbolProperty),Q.set(7,s.$Vj.symbolField),Q.set(8,s.$Vj.symbolConstructor),Q.set(9,s.$Vj.symbolEnum),Q.set(10,s.$Vj.symbolInterface),Q.set(11,s.$Vj.symbolFunction),Q.set(12,s.$Vj.symbolVariable),Q.set(13,s.$Vj.symbolConstant),Q.set(14,s.$Vj.symbolString),Q.set(15,s.$Vj.symbolNumber),Q.set(16,s.$Vj.symbolBoolean),Q.set(17,s.$Vj.symbolArray),Q.set(18,s.$Vj.symbolObject),Q.set(19,s.$Vj.symbolKey),Q.set(20,s.$Vj.symbolNull),Q.set(21,s.$Vj.symbolEnumMember),Q.set(22,s.$Vj.symbolStruct),Q.set(23,s.$Vj.symbolEvent),Q.set(24,s.$Vj.symbolOperator),Q.set(25,s.$Vj.symbolTypeParameter);function ae(ne){let we=Q.get(ne);return we||(console.info("No codicon found for SymbolKind "+ne),we=s.$Vj.symbolProperty),we}M.toIcon=ae})(p||(e.SymbolKinds=p={}));class P{static asEditOperation(Q){return D.$wt.replace(k.$vt.lift(Q.range),Q.text)}}e.$du=P;class j{static fromValue(Q){switch(Q){case"comment":return j.Comment;case"imports":return j.Imports;case"region":return j.Region}return new j(Q)}constructor(Q){this.value=Q}}e.$eu=j,j.Comment=new j("comment"),j.Imports=new j("imports"),j.Region=new j("region");var O;(function(M){M[M.AIGenerated=1]="AIGenerated"})(O||(e.NewSymbolNameTag=O={}));var R;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(R||(e.NewSymbolNameTriggerKind=R={}));var A;(function(M){function Q(ae){return!ae||typeof ae!="object"?!1:typeof ae.id=="string"&&typeof ae.title=="string"}M.is=Q})(A||(e.Command=A={}));var B;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(B||(e.CommentThreadCollapsibleState=B={}));var G;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(G||(e.CommentThreadState=G={}));var se;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(se||(e.CommentThreadApplicability=se={}));var ce;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(ce||(e.CommentMode=ce={}));var ee;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(ee||(e.CommentState=ee={}));var K;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(K||(e.InlayHintKind=K={}));class q{constructor(Q){this.b=Q,this.a=null}dispose(){this.a&&this.a.then(Q=>{Q&&Q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$fu=q,e.$gu=new I.$1t;var X;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(X||(e.ExternalUriOpenerPriority=X={}));var _;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(_||(e.InlineEditTriggerKind=_={}))}),define(ye[185],Ee([8,9]),function(ue,e){return ue.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[186],Ee([8,9]),function(ue,e){return ue.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[187],Ee([8,9]),function(ue,e){return ue.create("vs/platform/contextkey/common/scanner",e)}),define(ye[188],Ee([8,9]),function(ue,e){return ue.create("vs/platform/environment/node/argv",e)}),define(ye[189],Ee([8,9]),function(ue,e){return ue.create("vs/platform/environment/node/argvHelper",e)}),define(ye[190],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ye[191],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[192],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ye[193],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ye[194],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ye[195],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ye[196],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ye[197],Ee([8,9]),function(ue,e){return ue.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[198],Ee([8,9]),function(ue,e){return ue.create("vs/platform/files/common/fileService",e)}),define(ye[199],Ee([8,9]),function(ue,e){return ue.create("vs/platform/files/common/files",e)}),define(ye[200],Ee([8,9]),function(ue,e){return ue.create("vs/platform/files/common/io",e)}),define(ye[201],Ee([8,9]),function(ue,e){return ue.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[202],Ee([8,9]),function(ue,e){return ue.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ye[203],Ee([8,9]),function(ue,e){return ue.create("vs/platform/log/common/log",e)}),define(ye[204],Ee([8,9]),function(ue,e){return ue.create("vs/platform/markers/common/markers",e)}),define(ye[205],Ee([8,9]),function(ue,e){return ue.create("vs/platform/request/common/request",e)}),define(ye[206],Ee([8,9]),function(ue,e){return ue.create("vs/platform/shell/node/shellEnv",e)}),define(ye[207],Ee([8,9]),function(ue,e){return ue.create("vs/platform/telemetry/common/telemetryService",e)}),define(ye[208],Ee([8,9]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ye[209],Ee([8,9]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ye[210],Ee([8,9]),function(ue,e){return ue.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[211],Ee([8,9]),function(ue,e){return ue.create("vs/platform/workspace/common/workspace",e)}),define(ye[212],Ee([8,9]),function(ue,e){return ue.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(ye[213],Ee([8,9]),function(ue,e){return ue.create("vs/server/node/serverEnvironmentService",e)}),define(ye[214],Ee([8,9]),function(ue,e){return ue.create("vs/server/node/serverServices",e)}),define(ye[215],Ee([8,9]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[216],Ee([8,9]),function(ue,e){return ue.create("vs/workbench/common/editor",e)}),define(ye[217],Ee([8,9]),function(ue,e){return ue.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[218],Ee([8,9]),function(ue,e){return ue.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[219],Ee([8,9]),function(ue,e){return ue.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ye[220],Ee([1,0,11,187]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var D;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(D||(e.TokenType=D={}));function k(...g){switch(g.length){case 1:return(0,C.localize)(0,null,g[0]);case 2:return(0,C.localize)(1,null,g[0],g[1]);case 3:return(0,C.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,C.localize)(3,null),S=(0,C.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,s.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(k("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(k("&&"));break;case 124:this.h(124)?this.k(16):this.l(k("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const v=this.d,b=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:b};this.g.push({offset:v,lexeme:b,additionalInfo:y}),this.f.push(m)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const v=this.c.substring(this.d,this.e),b=w.b.get(v);b?this.k(b):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,v=!1,b=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(S);return}const u=this.c.charCodeAt(y);if(v)v=!1;else if(u===47&&!b){y++;break}else u===91?b=!0:u===92?v=!0:u===93&&(b=!1);y++}for(;y<this.c.length&&w.a.has(this.c.charCodeAt(y));)y++;this.e=y;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=w,w.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),w.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ye[221],Ee([1,0,6,2]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;class D{constructor(){this.a=new s.$ee,this.b=new s.$ee,this.c=new s.$ee,this.d=new s.$ee}call(S,w,g){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(S,w,g){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Jo=D,D.ChannelName="extensionhostdebugservice";class k extends C.$Vc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,w,g){this.b.call("attach",[S,w,g])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,w){this.b.call("terminate",[S,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,w){return this.b.call("openExtensionDevelopmentHostWindow",[S,w])}}e.$Ko=k}),define(ye[222],Ee([1,0,4]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=void 0;class C{constructor(I){this.a=I}listen(I,S,w){throw new Error("Invalid listen")}call(I,S,w){switch(S){case"download":return this.a.download(s.URI.revive(w[0]),s.URI.revive(w[1]))}throw new Error("Invalid call")}}e.$Mo=C;class D{constructor(I,S){this.a=I,this.b=S}async download(I,S){const w=this.b();w&&(I=w.transformOutgoingURI(I),S=w.transformOutgoingURI(S)),await this.a.call("download",[I,S])}}e.$No=D}),define(ye[223],Ee([1,0,178,74,13,7,31,19,4]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$8m=y,e.$9m=v,e.$6m=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,k.$nc)(D.$Qg.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,k.$kc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,S.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,s.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$kc)(this.userDataPath,"logs",m)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$0g)(w.URI.file((0,k.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=I.env.VSCODE_PORTABLE;return m?w.URI.file((0,k.$kc)(m,"argv.json")):(0,S.$0g)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,k.$lc)(m):(0,k.$ic)((0,k.$kc)(D.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?w.URI.file((0,k.$lc)(m)):w.URI.file((0,k.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,k.$lc)(m);const u=I.env.VSCODE_EXTENSIONS;if(u)return u;const a=I.env.VSCODE_PORTABLE;return a?(0,k.$kc)(a,"extensions"):(0,S.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(u=>/^[^:/?#]+?:\/\//.test(u)?w.URI.parse(u):w.URI.file((0,k.$ic)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?w.URI.parse(m):w.URI.file((0,k.$ic)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$6m.test(m))}get extensionLogLevel(){const m=[];for(const u of this.args.log||[]){const a=e.$6m.exec(u);a&&a[1]&&a[2]&&m.push([a[1],a[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,S.$0g)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=I.env.VSCODE_PORTABLE;return m?w.URI.file((0,k.$kc)(m,"policy.json")):(0,S.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,u,a){this.a=m,this.b=u,this.c=a,this.editSessionId=this.args.editSessionId}}e.$7m=g,Fe([C.$1h],g.prototype,"appRoot",null),Fe([C.$1h],g.prototype,"userHome",null),Fe([C.$1h],g.prototype,"userDataPath",null),Fe([C.$1h],g.prototype,"appSettingsHome",null),Fe([C.$1h],g.prototype,"tmpDir",null),Fe([C.$1h],g.prototype,"cacheHome",null),Fe([C.$1h],g.prototype,"stateResource",null),Fe([C.$1h],g.prototype,"userRoamingDataHome",null),Fe([C.$1h],g.prototype,"userDataSyncHome",null),Fe([C.$1h],g.prototype,"sync",null),Fe([C.$1h],g.prototype,"machineSettingsResource",null),Fe([C.$1h],g.prototype,"workspaceStorageHome",null),Fe([C.$1h],g.prototype,"localHistoryHome",null),Fe([C.$1h],g.prototype,"keyboardLayoutResource",null),Fe([C.$1h],g.prototype,"argvResource",null),Fe([C.$1h],g.prototype,"isExtensionDevelopment",null),Fe([C.$1h],g.prototype,"untitledWorkspacesHome",null),Fe([C.$1h],g.prototype,"builtinExtensionsPath",null),Fe([C.$1h],g.prototype,"extensionsPath",null),Fe([C.$1h],g.prototype,"extensionDevelopmentLocationURI",null),Fe([C.$1h],g.prototype,"extensionDevelopmentKind",null),Fe([C.$1h],g.prototype,"extensionTestsLocationURI",null),Fe([C.$1h],g.prototype,"debugExtensionHost",null),Fe([C.$1h],g.prototype,"logLevel",null),Fe([C.$1h],g.prototype,"extensionLogLevel",null),Fe([C.$1h],g.prototype,"serviceMachineIdResource",null),Fe([C.$1h],g.prototype,"disableTelemetry",null),Fe([C.$1h],g.prototype,"disableWorkspaceTrust",null),Fe([C.$1h],g.prototype,"useInMemorySecretStorage",null),Fe([C.$1h],g.prototype,"policyFile",null);function y(b,m){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,m,b.debugId,b.extensionEnvironment)}function v(b,m,u,a,f,c){const $=Number(m||b)||(a?null:u),E=$?!!m:!1;let h;if(c)try{h=JSON.parse(c)}catch{}return{port:$,break:E,debugId:f,env:h}}}),define(ye[67],Ee([1,0,313,3,188]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=void 0,e.$um=S,e.$vm=g,e.$wm=m,e.$xm=u;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.$sm=["tunnel","serve-web"],e.$tm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,D.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,D.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(a,f,c=I){const d=a.find(l=>l.length>0&&l[0]!=="-"),$={},E=["_"],h=[],t={};let o;for(const l in f){const p=f[l];p.type==="subcommand"?l===d&&(o=p):(p.alias&&($[l]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(l),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(h.push(l),p.deprecates&&h.push(...p.deprecates)),p.global&&(t[l]=p))}if(o&&d){const l=t;for(const O in o.options)l[O]=o.options[O];const p=a.filter(O=>O!==d),P=c.getSubcommandReporter?c.getSubcommandReporter(d):void 0,j=S(p,l,P);return{[d]:j,_:[]}}const r=s(a,{string:E,boolean:h,alias:$}),i={},n=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in f){const p=f[l];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let P=n[l];if(p.deprecates)for(const j of p.deprecates)n.hasOwnProperty(j)&&(P||(P=n[j],P&&c.onDeprecatedOption(j,p.deprecationMessage||(0,D.localize)(38,null,l))),delete n[j]);if(typeof P<"u"){if(p.type==="string[]"){if(Array.isArray(P)||(P=[P]),!p.allowEmptyValue){const j=P.filter(O=>O.length>0);j.length!==P.length&&(c.onEmptyValue(l),P=j.length>0?j:void 0)}}else p.type==="string"&&(Array.isArray(P)?(P=P.pop(),c.onMultipleValues(l,P)):!P&&!p.allowEmptyValue&&(c.onEmptyValue(l),P=void 0));i[l]=P,p.deprecationMessage&&c.onDeprecatedOption(l,p.deprecationMessage)}delete n[l]}for(const l in n)c.onUnknownOption(l);return i}function w(a,f){let c="";return f.args&&(Array.isArray(f.args)?c=` <${f.args.join("> <")}>`:c=` <${f.args}>`),f.alias?`-${f.alias} --${a}${c}`:`--${a}${c}`}function g(a,f){const c=[];for(const d in a){const $=a[d],E=w(d,$);c.push([E,$.description])}return y(c,f)}function y(a,f){const d=a.reduce((h,t)=>Math.max(h,t[0].length),12)+2+1;if(f-d<25)return a.reduce((h,t)=>h.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const $=f-d-1,E=[];for(const h of a){const t=h[0],o=b(h[1],$),r=v(d-t.length-2);E.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)E.push(v(d)+o[i])}return E}function v(a){return" ".repeat(a)}function b(a,f){const c=[];for(;a.length;){const d=a.length<f?a.length:a.lastIndexOf(" ",f),$=a.slice(0,d).trim();a=a.slice(d),c.push($)}return c}function m(a,f,c,d,$){const E=process.stdout.isTTY&&process.stdout.columns||80,h=$?.noInputFiles!==!0?`[${(0,D.localize)(39,null)}...]`:"",t=[`${a} ${c}`];t.push(""),t.push(`${(0,D.localize)(40,null)}: ${f} [${(0,D.localize)(41,null)}]${h}`),t.push(""),$?.noPipe!==!0&&(C.$c?t.push((0,D.localize)(42,null,f)):t.push((0,D.localize)(43,null,f)),t.push(""));const o={},r=[];for(const i in d){const n=d[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let l=o[n.cat];l||(o[n.cat]=l={}),l[i]=n}}for(const i in o){const n=i,l=o[n];l&&(t.push(k[n]),t.push(...g(l,E)),t.push(""))}return r.length&&(t.push((0,D.localize)(44,null)),t.push(...y(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}function u(a,f){return`${a||(0,D.localize)(45,null)}
${f||(0,D.localize)(46,null)}
${process.arch}`}}),define(ye[224],Ee([1,0,314,189,67]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=S,e.$zm=w,e.$Am=g,e.$Bm=y;function k(v,b){const m=($,E)=>{console.warn((0,C.localize)(0,null,$,E))},u=$=>{console.warn((0,C.localize)(1,null,$))},a=($,E)=>{console.warn((0,C.localize)(2,null,$,E))},f=$=>({onUnknownOption:E=>{D.$sm.includes($)||console.warn((0,C.localize)(3,null,E,$))},onMultipleValues:m,onEmptyValue:u,onDeprecatedOption:a,getSubcommandReporter:D.$sm.includes($)?f:void 0}),c={onUnknownOption:$=>{console.warn((0,C.localize)(4,null,$))},onMultipleValues:m,onEmptyValue:u,onDeprecatedOption:a,getSubcommandReporter:f},d=(0,D.$um)(v,D.$tm,b?c:void 0);return d.goto&&d._.forEach($=>s(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test($),(0,C.localize)(5,null))),d}function I(v){const b=v.findIndex(m=>!/^-/.test(m));if(b>-1)return[...v.slice(0,b),...v.slice(b+1)]}function S(v){let[,...b]=v;process.env.VSCODE_DEV&&(b=I(b)||[]);const m=!y(process.env);return k(b,m)}function w(v){let[,,...b]=v;return process.env.VSCODE_DEV&&(b=I(b)||[]),k(b,!0)}function g(v,...b){const m=v.indexOf("--");return m===-1?v.push(...b):v.splice(m,0,...b),v}function y(v){return v.VSCODE_CLI==="1"}}),function(){"use strict";function ue(e,s,C){function D(I,S){const w=k(I,S),g=[w];return e.isAbsolute(w)||g.unshift(C),e.resolve(...g)}function k(I,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,S);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(v,"AppData","Roaming")}break;case"darwin":g=e.join(s.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(s.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,S)}return{getUserDataPath:D}}if(typeof define=="function")define(ye[225],Ee([78,28,31]),function(e,s,C){return ue(e,s,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),s=require("os");module.exports=ue(e,s,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ye[110],Ee([1,0,28,223,225]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$$m=I,e.$_m=S;class k extends C.$7m{constructor(g,y){super(g,{homeDir:(0,s.homedir)(),tmpDir:(0,s.tmpdir)(),userDataDir:(0,D.getUserDataPath)(g,y.nameShort)},y)}}e.$0m=k;function I(w,g){return(0,C.$9m)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,g,w.extensionEnvironment)}function S(w,g){return(0,C.$9m)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,g,w.extensionEnvironment)}}),define(ye[226],Ee([1,0,10,193]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=D;function D(I,S,w,g){try{k(I,S,w,g)}catch(y){I.error(y?.message??y)}return S}function k(I,S,w,g){const y=(v,b,m)=>{const u=v[b];if((0,s.$9f)(u)){const a=u,f=a.length;if(f>1&&a[0]==="%"&&a[f-1]==="%"){const c=a.substr(1,f-2);let d=w[c];d===void 0&&g&&(d=g[c]);const $=typeof d=="string"?d:d?.message,E=g?.[c],h=typeof E=="string"?E:E?.message;if(!$){h||I.warn(`[${S.name}]: ${(0,C.localize)(0,null,c)}`);return}if(m&&(b==="title"||b==="category")&&h&&h!==$){const t={value:$,original:h};v[b]=t}else v[b]=$}}else if((0,s.$$f)(u))for(const a in u)u.hasOwnProperty(a)&&(a==="commands"?y(u,a,!0):y(u,a,m));else if(Array.isArray(u))for(let a=0;a<u.length;a++)y(u,a,m)};for(const v in S)S.hasOwnProperty(v)&&y(S,v)}}),define(ye[227],Ee([1,0,81,196]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=D;function D(k){return(0,s.$lq)(k,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}}),define(ye[82],Ee([1,0,19,65,197,57]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=w,e.$Ip=g,e.$Jp=y,e.$Kp=v,e.$Lp=b,e.$Mp=m,e.$Np=u;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function w(c){return c=c.trim(),c==="*"||I.test(c)}function g(c){if(!w(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=c.match(I);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function y(c){if(!c)return null;const d=c.majorBase,$=c.majorMustEqual,E=c.minorBase;let h=c.minorMustEqual;const t=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(d===0||(h=!1),o=!1);let r=0;if(c.preRelease){const i=S.exec(c.preRelease);if(i){const[,n,l,p]=i;r=Date.UTC(Number(n),Number(l)-1,Number(p))}}return{majorBase:d,majorMustEqual:$,minorBase:E,minorMustEqual:h,patchBase:t,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:r}}function v(c,d,$){let E;typeof c=="string"?E=y(g(c)):E=c;let h;d instanceof Date?h=d.getTime():typeof d=="string"&&(h=new Date(d).getTime());let t;if(typeof $=="string"?t=y(g($)):t=$,!E||!t)return!1;const o=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,l=t.minorBase,p=t.patchBase;const P=t.notBefore;let j=t.majorMustEqual,O=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>l?!0:r<l||h&&h<P?!1:i>=p:(o===1&&n===0&&(!j||!O||!R)&&(n=1,l=0,p=0,j=!0,O=!1,R=!1),o<n?!1:o>n?!j:r<l?!1:r>l?!O:i<p?!1:i>p?!R:!(h&&h<P))}function b(c,d,$,E,h){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([C.default.Error,D.localize(0,null)]),t;if(typeof E.name!="string")return t.push([C.default.Error,D.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([C.default.Error,D.localize(2,null,"version")]),t;if(!E.engines)return t.push([C.default.Error,D.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([C.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!f(E.extensionDependencies))return t.push([C.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!f(E.activationEvents))return t.push([C.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([C.default.Error,D.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([C.default.Warning,D.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([C.default.Error,D.localize(9,null,"main")]),t;{const i=(0,s.$0g)($,E.main);(0,s.$4g)(i,$)||t.push([C.default.Warning,D.localize(10,null,i.path,$.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([C.default.Error,D.localize(11,null,"browser")]),t;{const i=(0,s.$0g)($,E.browser);(0,s.$4g)(i,$)||t.push([C.default.Warning,D.localize(12,null,i.path,$.path)])}}if(!k.valid(E.version))return t.push([C.default.Error,D.localize(13,null)]),t;const o=[];if(!m(c,d,E,h,o))for(const i of o)t.push([C.default.Error,i]);return t}function m(c,d,$,E,h){return E||typeof $.main>"u"&&typeof $.browser>"u"?!0:a(c,d,$.engines.vscode,h)}function u(c,d,$){return c==="*"||a(d,$,c)}function a(c,d,$,E=[]){const h=y(g($));if(!h)return E.push(D.localize(14,null,$)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return E.push(D.localize(15,null,$)),!1}else if(!h.majorMustEqual)return E.push(D.localize(16,null,$)),!1;return v(c,d,h)?!0:(E.push(D.localize(17,null,c,$)),!1)}function f(c){if(!Array.isArray(c))return!1;for(let d=0,$=c.length;d<$;d++)if(typeof c[d]!="string")return!1;return!0}}),define(ye[228],Ee([1,0,15,22]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=D;async function D(k,I,S){let w=S&&S.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const y=(await I.readFile(k.serviceMachineIdResource)).value.toString();w=(0,C.$Rg)(y)?y:null}catch{w=null}if(!w){w=(0,C.$Sg)();try{await I.writeFile(k.serviceMachineIdResource,s.$Ge.fromString(w))}catch{}}return S?.store("storage.serviceMachineId",w,-1,1),w}}),define(ye[68],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class s{constructor(D,k=[],I=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=I}}e.$ti=s}),define(ye[111],Ee([1,0,68]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ys=k,e.$zs=I;const C=[];var D;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function k(S,w,g){w instanceof s.$ti||(w=new s.$ti(w,[],!!g)),C.push([S,w])}function I(){return C}}),define(ye[229],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;class s{constructor(k,I){this.key=k,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$br=s;class C{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const I of this.a.values())I.outgoing.size===0&&k.push(I);return k}insertEdge(k,I){const S=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(I);S.outgoing.set(w.key,w),w.incoming.set(S.key,S)}removeNode(k){const I=this.b(k);this.a.delete(I);for(const S of this.a.values())S.outgoing.delete(I),S.incoming.delete(I)}lookupOrInsertNode(k){const I=this.b(k);let S=this.a.get(I);return S||(S=new s(I,k),this.a.set(I,S)),S}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[I,S]of this.a)k.push(`${I}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,I]of this.a){const S=new Set([k]),w=this.c(I,S);if(w)return w}}c(k,I){for(const[S,w]of k.outgoing){if(I.has(S))return[...I,S].join(" -> ");I.add(S);const g=this.c(w,I);if(g)return g;I.delete(S)}}}e.$cr=C}),define(ye[5],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=D,e.$xi=k;var s;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function S(w){return w[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=S})(s||(e._util=s={})),e.$vi=D("instantiationService");function C(I,S,w){S[s.DI_TARGET]===S?S[s.DI_DEPENDENCIES].push({id:I,index:w}):(S[s.DI_DEPENDENCIES]=[{id:I,index:w}],S[s.DI_TARGET]=S)}function D(I){if(s.serviceIds.has(I))return s.serviceIds.get(I);const S=function(w,g,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(S,w,y)};return S.toString=()=>I,s.serviceIds.set(I,S),S}function k(I){return I}}),define(ye[25],Ee([1,0,10,4,5]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=k,e.$5i=I,e.$6i=w,e.$7i=g,e.$8i=y,e.$9i=v,e.$0i=b,e.$$i=u,e.$_i=a,e.$aj=f,e.$3i=(0,D.$wi)("configurationService");function k(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function w(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function g(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function y(c,d){const $=Object.create(null);for(const E in c)v($,E,c[E],d);return $}function v(c,d,$,E){const h=d.split("."),t=h.pop();let o=c;for(let r=0;r<h.length;r++){const i=h[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":if(n===null){E(`Ignoring ${d} as ${h.slice(0,r+1).join(".")} is null`);return}break;default:E(`Ignoring ${d} as ${h.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=$}catch{E(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(o)}`)}function b(c,d){const $=d.split(".");m(c,$)}function m(c,d){const $=d.shift();if(d.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const E=c[$];typeof E=="object"&&!Array.isArray(E)&&(m(E,d),Object.keys(E).length===0&&delete c[$])}}function u(c,d,$){function E(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const h=d.split("."),t=E(c,h);return typeof t>"u"?$:t}function a(c,d,$){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in c?s.$$f(c[E])&&s.$$f(d[E])?a(c[E],d[E],$):$&&(c[E]=d[E]):c[E]=d[E])})}function f(c){return c.replace(/[\[\]]/g,"")}}),define(ye[47],Ee([1,0,3,17,220,5,186,11]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=g,e.$vj=o,e.$wj=r,e.$Pj=we;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",s.$d),w.set("isLinux",s.$e),w.set("isWindows",s.$c),w.set("isWeb",s.$i),w.set("isMacNative",s.$d&&!s.$i),w.set("isEdge",s.$B),w.set("isFirefox",s.$z),w.set("isChrome",s.$y),w.set("isSafari",s.$A);function g(V,N){if(w.get(V)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(V,N)}const y=Object.prototype.hasOwnProperty;var v;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const b={regexParsingWithErrorRecovery:!0},m=(0,I.localize)(0,null),u=(0,I.localize)(1,null),a=(0,I.localize)(2,null),f=(0,I.localize)(3,null),c=(0,I.localize)(4,null),d=(0,I.localize)(5,null),$=(0,I.localize)(6,null),E=(0,I.localize)(7,null);class h{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=b){this.k=N,this.d=new D.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:u});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const Z=this.D(),he=Z.type===17?d:void 0;throw this.h.push({message:c,offset:Z.offset,lexeme:D.$rj.getLexeme(Z),additionalInfo:he}),h.c}return z}catch(z){if(z!==h.c)throw z;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const z=this.o();N.push(z)}return N.length===1?N[0]:t.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const z=this.s();N.push(z)}return N.length===1?N[0]:t.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,f),z?.negate()}case 17:return this.z(),A.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,f),z}case 17:{const z=N.lexeme;if(this.z(),this.y(9)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==10)throw this.B("REGEX",he);const x=he.lexeme,J=x.lastIndexOf("/"),H=J===x.length-1?void 0:this.w(x.substring(J+1));let L;try{L=new RegExp(x.substring(1,J),H)}catch{throw this.B("REGEX",he)}return K.create(z,L)}switch(he.type){case 10:case 19:{const x=[he.lexeme];this.z();let J=this.D(),H=0;for(let de=0;de<he.lexeme.length;de++)he.lexeme.charCodeAt(de)===40?H++:he.lexeme.charCodeAt(de)===41&&H--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===40?H++:he.lexeme.charCodeAt(de)===41&&H--}if(H<0)break;x.push(D.$rj.getLexeme(J)),this.z(),J=this.D()}const L=x.join(""),U=L.lastIndexOf("/"),oe=U===L.length-1?void 0:this.w(L.substring(U+1));let le;try{le=new RegExp(L.substring(1,U),oe)}catch{throw this.B("REGEX",he)}return t.regex(z,le)}case 18:{const x=he.lexeme;this.z();let J=null;if(!(0,C.$8e)(x)){const H=x.indexOf("/"),L=x.lastIndexOf("/");if(H!==L&&H>=0){const U=x.slice(H+1,L),oe=x[L+1]==="i"?"i":"";try{J=new RegExp(U,oe)}catch{throw this.B("REGEX",he)}}}if(J===null)throw this.B("REGEX",he);return K.create(z,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const he=this.u();return t.notIn(z,he)}switch(this.D().type){case 3:{this.z();const he=this.u();if(this.x().type===18)return t.equals(z,he);switch(he){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,he)}}case 4:{this.z();const he=this.u();if(this.x().type===18)return t.notEquals(z,he);switch(he){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,he)}}case 5:return this.z(),ce.create(z,this.u());case 6:return this.z(),ee.create(z,this.u());case 7:return this.z(),G.create(z,this.u());case 8:return this.z(),se.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:$,offset:N.offset,lexeme:"",additionalInfo:E}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,z){if(this.C(N))return this.z();throw this.B(z,this.D())}B(N,z,Z){const he=(0,I.localize)(8,null,N,D.$rj.getLexeme(z)),x=z.offset,J=D.$rj.getLexeme(z);return this.h.push({message:he,offset:x,lexeme:J,additionalInfo:Z}),h.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=h,h.c=new Error;class t{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(N){return p.create(N)}static equals(N,z){return P.create(N,z)}static notEquals(N,z){return R.create(N,z)}static regex(N,z){return K.create(N,z)}static in(N,z){return j.create(N,z)}static notIn(N,z){return O.create(N,z)}static not(N){return A.create(N)}static and(...N){return _.create(N,null,!0)}static or(...N){return M.create(N,null,!0)}static greater(N,z){return G.create(N,z)}static greaterEquals(N,z){return se.create(N,z)}static smaller(N,z){return ce.create(N,z)}static smallerEquals(N,z){return ee.create(N,z)}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$uj=t,t.c=new h({regexParsingWithErrorRecovery:!1});function o(V){const N=new h({regexParsingWithErrorRecovery:!1});return V.map(z=>(N.parse(z),N.lexingErrors.length>0?N.lexingErrors.map(Z=>({errorMessage:Z.additionalInfo?(0,I.localize)(9,null,Z.additionalInfo):(0,I.localize)(10,null),offset:Z.offset,length:Z.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(Z=>({errorMessage:Z.additionalInfo?`${Z.message}. ${Z.additionalInfo}`:Z.message,offset:Z.offset,length:Z.lexeme.length})):[]))}function r(V,N){const z=V?V.substituteConstants():void 0,Z=N?N.substituteConstants():void 0;return!z&&!Z?!0:!z||!Z?!1:z.equals(Z)}function i(V,N){return V.cmp(N)}class n{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return l.INSTANCE}}e.$xj=n,n.INSTANCE=new n;class l{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return n.INSTANCE}}e.$yj=l,l.INSTANCE=new l;class p{static create(N,z=null){const Z=w.get(N);return typeof Z=="boolean"?Z?l.INSTANCE:n.INSTANCE:new p(N,z)}constructor(N,z){this.key=N,this.c=z,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:ae(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=w.get(this.key);return typeof N=="boolean"?N?l.INSTANCE:n.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$zj=p;class P{static create(N,z,Z=null){if(typeof z=="boolean")return z?p.create(N,Z):A.create(N,Z);const he=w.get(N);return typeof he=="boolean"?z===(he?"true":"false")?l.INSTANCE:n.INSTANCE:new P(N,z,Z)}constructor(N,z,Z){this.c=N,this.d=z,this.f=Z,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=w.get(this.c);if(typeof N=="boolean"){const z=N?"true":"false";return this.d===z?l.INSTANCE:n.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Aj=P;class j{static create(N,z){return new j(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const z=N.getValue(this.f),Z=N.getValue(this.d);return Array.isArray(z)?z.includes(Z):typeof Z=="string"&&typeof z=="object"&&z!==null?y.call(z,Z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$Bj=j;class O{static create(N,z){return new O(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=11,this.c=j.create(N,z)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=O;class R{static create(N,z,Z=null){if(typeof z=="boolean")return z?A.create(N,Z):p.create(N,Z);const he=w.get(N);return typeof he=="boolean"?z===(he?"true":"false")?n.INSTANCE:l.INSTANCE:new R(N,z,Z)}constructor(N,z,Z){this.c=N,this.d=z,this.f=Z,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=w.get(this.c);if(typeof N=="boolean"){const z=N?"true":"false";return this.d===z?n.INSTANCE:l.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Dj=R;class A{static create(N,z=null){const Z=w.get(N);return typeof Z=="boolean"?Z?n.INSTANCE:l.INSTANCE:new A(N,z)}constructor(N,z){this.c=N,this.d=z,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:ae(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=w.get(this.c);return typeof N=="boolean"?N?n.INSTANCE:l.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Ej=A;function B(V,N){if(typeof V=="string"){const z=parseFloat(V);isNaN(z)||(V=z)}return typeof V=="string"||typeof V=="number"?N(V):n.INSTANCE}class G{static create(N,z,Z=null){return B(z,he=>new G(N,he,Z))}constructor(N,z,Z){this.c=N,this.d=z,this.f=Z,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Fj=G;class se{static create(N,z,Z=null){return B(z,he=>new se(N,he,Z))}constructor(N,z,Z){this.c=N,this.d=z,this.f=Z,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Gj=se;class ce{static create(N,z,Z=null){return B(z,he=>new ce(N,he,Z))}constructor(N,z,Z){this.c=N,this.d=z,this.f=Z,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Hj=ce;class ee{static create(N,z,Z=null){return B(z,he=>new ee(N,he,Z))}constructor(N,z,Z){this.c=N,this.d=z,this.f=Z,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Ij=ee;class K{static create(N,z){return new K(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const z=this.f?this.f.source:"",Z=N.f?N.f.source:"";return z<Z?-1:z>Z?1:0}equals(N){if(N.type===this.type){const z=this.f?this.f.source:"",Z=N.f?N.f.source:"";return this.d===N.d&&z===Z}return!1}substituteConstants(){return this}evaluate(N){const z=N.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$Jj=K;class q{static create(N){return new q(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new q(this.c.map(N))}negate(){return this.c}}e.$Kj=q;function X(V){let N=null;for(let z=0,Z=V.length;z<Z;z++){const he=V[z].substituteConstants();if(V[z]!==he&&N===null){N=[];for(let x=0;x<z;x++)N[x]=V[x]}N!==null&&(N[z]=he)}return N===null?V:N}class _{static create(N,z,Z){return _.d(N,z,Z)}constructor(N,z){this.expr=N,this.c=z,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let z=0,Z=this.expr.length;z<Z;z++){const he=i(this.expr[z],N.expr[z]);if(he!==0)return he}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let z=0,Z=this.expr.length;z<Z;z++)if(!this.expr[z].equals(N.expr[z]))return!1;return!0}return!1}substituteConstants(){const N=X(this.expr);return N===this.expr?this:_.create(N,this.c,!1)}evaluate(N){for(let z=0,Z=this.expr.length;z<Z;z++)if(!this.expr[z].evaluate(N))return!1;return!0}static d(N,z,Z){const he=[];let x=!1;for(const J of N)if(J){if(J.type===1){x=!0;continue}if(J.type===0)return n.INSTANCE;if(J.type===6){he.push(...J.expr);continue}he.push(J)}if(he.length===0&&x)return l.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(i);for(let J=1;J<he.length;J++)he[J-1].equals(he[J])&&(he.splice(J,1),J--);if(he.length===1)return he[0];for(;he.length>1;){const J=he[he.length-1];if(J.type!==9)break;he.pop();const H=he.pop(),L=he.length===0,U=M.create(J.expr.map(oe=>_.create([oe,H],null,Z)),null,L);U&&(he.push(U),he.sort(i))}if(he.length===1)return he[0];if(Z){for(let J=0;J<he.length;J++)for(let H=J+1;H<he.length;H++)if(he[J].negate().equals(he[H]))return n.INSTANCE;if(he.length===1)return he[0]}return new _(he,z)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const z of this.expr)N.push(...z.keys());return N}map(N){return new _(this.expr.map(z=>z.map(N)),null)}negate(){if(!this.c){const N=[];for(const z of this.expr)N.push(z.negate());this.c=M.create(N,this,!0)}return this.c}}e.$Lj=_;class M{static create(N,z,Z){return M.d(N,z,Z)}constructor(N,z){this.expr=N,this.c=z,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let z=0,Z=this.expr.length;z<Z;z++){const he=i(this.expr[z],N.expr[z]);if(he!==0)return he}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let z=0,Z=this.expr.length;z<Z;z++)if(!this.expr[z].equals(N.expr[z]))return!1;return!0}return!1}substituteConstants(){const N=X(this.expr);return N===this.expr?this:M.create(N,this.c,!1)}evaluate(N){for(let z=0,Z=this.expr.length;z<Z;z++)if(this.expr[z].evaluate(N))return!0;return!1}static d(N,z,Z){let he=[],x=!1;if(N){for(let J=0,H=N.length;J<H;J++){const L=N[J];if(L){if(L.type===0){x=!0;continue}if(L.type===1)return l.INSTANCE;if(L.type===9){he=he.concat(L.expr);continue}he.push(L)}}if(he.length===0&&x)return n.INSTANCE;he.sort(i)}if(he.length!==0){if(he.length===1)return he[0];for(let J=1;J<he.length;J++)he[J-1].equals(he[J])&&(he.splice(J,1),J--);if(he.length===1)return he[0];if(Z){for(let J=0;J<he.length;J++)for(let H=J+1;H<he.length;H++)if(he[J].negate().equals(he[H]))return l.INSTANCE;if(he.length===1)return he[0]}return new M(he,z)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const z of this.expr)N.push(...z.keys());return N}map(N){return new M(this.expr.map(z=>z.map(N)),null)}negate(){if(!this.c){const N=[];for(const z of this.expr)N.push(z.negate());for(;N.length>1;){const z=N.shift(),Z=N.shift(),he=[];for(const x of Y(z))for(const J of Y(Z))he.push(_.create([x,J],null,!1));N.unshift(M.create(he,null,!1))}this.c=M.create(N,this,!0)}return this.c}}e.$Mj=M;class Q extends p{static all(){return Q.d.values()}constructor(N,z,Z){super(N,null),this.f=z,typeof Z=="object"?Q.d.push({...Z,key:N}):Z!==!0&&Q.d.push({key:N,description:Z,type:z!=null?typeof z:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return P.create(this.key,N)}notEqualsTo(N){return R.create(this.key,N)}}e.$Nj=Q,Q.d=[],e.$Oj=(0,k.$wi)("contextKeyService");function ae(V,N){return V<N?-1:V>N?1:0}function ne(V,N,z,Z){return V<z?-1:V>z?1:N<Z?-1:N>Z?1:0}function we(V,N){if(V.type===0||N.type===1)return!0;if(V.type===9)return N.type===9?ie(V.expr,N.expr):!1;if(N.type===9){for(const z of N.expr)if(we(V,z))return!0;return!1}if(V.type===6){if(N.type===6)return ie(N.expr,V.expr);for(const z of V.expr)if(we(z,N))return!0;return!1}return V.equals(N)}function ie(V,N){let z=0,Z=0;for(;z<V.length&&Z<N.length;){const he=V[z].cmp(N[Z]);if(he<0)return!1;he===0&&z++,Z++}return z===V.length}function Y(V){return V.type===9?V.expr:[V]}}),define(ye[230],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$en=e.ID=void 0,e.$fn=C,e.ID="diagnosticsService",e.$en=(0,s.$wi)(e.ID);function C(k){return!!k.hostName&&!!k.errorMessage}class D{async getPerformanceInfo(I,S){return{}}async getSystemInfo(I,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,S){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$gn=D}),define(ye[83],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=void 0,e.$Lo=(0,s.$wi)("downloadService")}),define(ye[26],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,s.$wi)("environmentService"),e.$Ei=(0,s.$xi)(e.$Di)}),define(ye[32],Ee([1,0,191,5]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.ExtensionGalleryErrorCode=e.$8o=e.ExtensionManagementErrorCode=e.$7o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$1o=D,e.$2o=k,e.$3o=I,e.$4o=S,e.$5o=w,e.$6o=g,e.$Uo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vo=new RegExp(e.$Uo),e.$Wo="__web_extension",e.$Xo="skipWalkthrough",e.$Yo="extensionsSync",e.$Zo="dependecyOrPackExtensionInstall";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function k(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function I(d,$){switch(d){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function S(d,$){return $==="web"&&!d.includes("web")}function w(d,$,E){return S($,E)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===E}function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}var y;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var b;(function(d){d.Install="install",d.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var m;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$7o=(0,C.$wi)("extensionGalleryService");var u;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Cancelled="Cancelled",d.Unknown="Unknown",d.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));class a extends Error{constructor($,E){super($),this.code=E,this.name=E}}e.$8o=a;var f;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(f||(e.ExtensionGalleryErrorCode=f={}));class c extends Error{constructor($,E){super($),this.code=E,this.name=E}}e.$9o=c,e.$0o=(0,C.$wi)("extensionManagementService"),e.$$o="extensionsIdentifiers/disabled",e.$_o="extensionsIdentifiers/enabled",e.$ap=(0,C.$wi)("IGlobalExtensionEnablementService"),e.$bp=(0,C.$wi)("IExtensionTipsService"),e.$cp=(0,s.localize2)(0,"Extensions"),e.$dp=(0,s.localize2)(1,"Preferences")}),define(ye[231],Ee([1,0,6,2,21,4,55,32]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=void 0;function w(f,c){return f?k.URI.revive(c?c.transformIncoming(f):f):void 0}function g(f,c){return c?c.transformOutgoingURI(f):f}function y(f,c){c=c||I.$An;const d=f.manifest;return{...(0,I.$Dn)({...f,manifest:void 0},c),manifest:d}}function v(f,c){return f?.profileLocation?(0,I.$Dn)(f,c??I.$An):f}function b(f,c){return c?(0,D.$6n)(f,d=>d instanceof k.URI?c.transformOutgoingURI(d):void 0):f}class m{constructor(c,d){this.a=c,this.b=d,this.onInstallExtension=s.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=s.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=s.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=s.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=s.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,d){const $=this.b(c);switch(d){case"onInstallExtension":return s.Event.map(this.onInstallExtension,E=>({...E,profileLocation:E.profileLocation?g(E.profileLocation,$):E.profileLocation}));case"onDidInstallExtensions":return s.Event.map(this.onDidInstallExtensions,E=>E.map(h=>({...h,local:h.local?b(h.local,$):h.local,profileLocation:h.profileLocation?g(h.profileLocation,$):h.profileLocation})));case"onUninstallExtension":return s.Event.map(this.onUninstallExtension,E=>({...E,profileLocation:E.profileLocation?g(E.profileLocation,$):E.profileLocation}));case"onDidUninstallExtension":return s.Event.map(this.onDidUninstallExtension,E=>({...E,profileLocation:E.profileLocation?g(E.profileLocation,$):E.profileLocation}));case"onDidUpdateExtensionMetadata":return s.Event.map(this.onDidUpdateExtensionMetadata,E=>b(E,$))}throw new Error("Invalid listen")}async call(c,d,$){const E=this.b(c);switch(d){case"zip":{const h=y($[0],E),t=await this.a.zip(h);return g(t,E)}case"unzip":return this.a.unzip(w($[0],E));case"install":return this.a.install(w($[0],E),v($[1],E));case"installFromLocation":return this.a.installFromLocation(w($[0],E),w($[1],E));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile($[0],w($[1],E),w($[2],E));case"getManifest":return this.a.getManifest(w($[0],E));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall($[0]);case"installFromGallery":return this.a.installFromGallery($[0],v($[1],E));case"installGalleryExtensions":{const h=$[0];return this.a.installGalleryExtensions(h.map(({extension:t,options:o})=>({extension:t,options:v(o,E)??{}})))}case"uninstall":return this.a.uninstall(y($[0],E),v($[1],E));case"reinstallFromGallery":return this.a.reinstallFromGallery(y($[0],E));case"getInstalled":return(await this.a.getInstalled($[0],w($[1],E),$[2])).map(t=>b(t,E));case"toggleAppliationScope":{const h=await this.a.toggleAppliationScope(y($[0],E),w($[1],E));return b(h,E)}case"copyExtensions":return this.a.copyExtensions(w($[0],E),w($[1],E));case"updateMetadata":{const h=await this.a.updateMetadata(y($[0],E),$[1],w($[2],E));return b(h,E)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download($[0],$[1],$[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$eq=m;class u extends C.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new s.$ee),this.f=this.B(new s.$ee),this.g=this.B(new s.$ee),this.h=this.B(new s.$ee),this.j=this.B(new s.$ee),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?k.URI.revive(d.source):d.source,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map($=>({...$,local:$.local?y($.local,null):$.local,source:this.r($.source)?k.URI.revive($.source):$.source,profileLocation:k.URI.revive($.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(y(d,null))))}n(c,d){c.fire(d)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const d=await this.getTargetPlatform();return c.allTargetPlatforms.some($=>(0,S.$5o)($,c.allTargetPlatforms,d))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(d=>k.URI.revive(d)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,d){return Promise.resolve(this.m.call("install",[c,d])).then($=>y($,null))}installFromLocation(c,d){return Promise.resolve(this.m.call("installFromLocation",[c,d])).then($=>y($,null))}async installExtensionsFromProfile(c,d,$){return(await this.m.call("installExtensionsFromProfile",[c,d,$])).map(h=>y(h,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,d){return Promise.resolve(this.m.call("installFromGallery",[c,d])).then($=>y($,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map($=>({...$,local:$.local?y($.local,null):$.local,source:this.r($.source)?k.URI.revive($.source):$.source,profileLocation:k.URI.revive($.profileLocation)}))}uninstall(c,d){if(c.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[c,d]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(d=>y(d,null))}getInstalled(c=null,d,$){return Promise.resolve(this.m.call("getInstalled",[c,d,$])).then(E=>E.map(h=>y(h,null)))}updateMetadata(c,d,$){return Promise.resolve(this.m.call("updateMetadata",[c,d,$])).then(E=>y(E,null))}toggleAppliationScope(c,d){return this.m.call("toggleAppliationScope",[c,d]).then($=>y($,null))}copyExtensions(c,d){return this.m.call("copyExtensions",[c,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,d,$){const E=await this.m.call("download",[c,d,$]);return k.URI.revive(E)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$fq=u;class a{constructor(c){this.a=c}listen(c,d){throw new Error("Invalid listen")}call(c,d,$){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive($[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$gq=a}),define(ye[16],Ee([1,0,66,7,17,10,4,199,5,3,13,60]),function(ue,e,s,C,D,k,I,S,w,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=b,e.$5k=f,e.$6k=d,e.$7k=$,e.$8k=E,e.$9k=h,e.$0k=t,e.$$k=o,e.$_k=r,e.$al=i,e.$bl=n,e.$dl=P,e.$el=j,e.$fl=O,e.$gl=R,e.$hl=A,e.$kl=ee,e.$wl=Q,e.$xl=ae,e.$zl=we,e.$3k=(0,w.$wi)("fileService");function b(ie){return ie.create===!0}var m;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var u;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var a;(function(ie){ie[ie.UPDATED=2]="UPDATED",ie[ie.ADDED=4]="ADDED",ie[ie.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function f(ie){const Y=ie;return!!Y&&typeof Y.onDidChange=="function"}var c;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function d(ie){return!!(ie.capabilities&2)}function $(ie){return!!(ie.capabilities&8)}function E(ie){return!!(ie.capabilities&131072)}function h(ie){return!!(ie.capabilities&4)}function t(ie){return!!(ie.capabilities&16)}function o(ie){return d(ie)?!!(ie.capabilities&16384):!1}function r(ie){return d(ie)?!!(ie.capabilities&32768):!1}function i(ie){return!!(ie.capabilities&65536)}function n(ie){return!!(ie.capabilities&2048)}var l;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class p extends Error{static create(Y,V){const N=new p(Y.toString(),V);return O(N,V),N}constructor(Y,V){super(Y),this.code=V}}e.$cl=p;function P(ie,Y){return p.create(ie,Y)}function j(ie){return ie||P((0,S.localize)(0,null),l.Unknown)}function O(ie,Y){return ie.name=Y?`${Y} (FileSystemError)`:"FileSystemError",ie}function R(ie){if(!ie)return l.Unknown;if(ie instanceof p)return ie.code;const Y=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!Y)return l.Unknown;switch(Y[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function A(ie){if(ie instanceof K)return ie.fileOperationResult;switch(R(ie)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}var B;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(B||(e.FileOperation=B={}));class G{constructor(Y,V,N){this.resource=Y,this.operation=V,this.target=N}isOperation(Y){return this.operation===Y}}e.$il=G;var se;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(se||(e.FileChangeType=se={}));class ce{constructor(Y,V){this.c=V,this.b=void 0,this.d=new v.$V(()=>{const N=s.$Ci.forUris(()=>this.c);return N.fill(this.rawAdded.map(z=>[z,!0])),N}),this.f=new v.$V(()=>{const N=s.$Ci.forUris(()=>this.c);return N.fill(this.rawUpdated.map(z=>[z,!0])),N}),this.g=new v.$V(()=>{const N=s.$Ci.forUris(()=>this.c);return N.fill(this.rawDeleted.map(z=>[z,!0])),N}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const N of Y){switch(N.type){case 1:this.rawAdded.push(N.resource);break;case 0:this.rawUpdated.push(N.resource);break;case 2:this.rawDeleted.push(N.resource);break}this.b!==ce.a&&(typeof N.cId=="number"?this.b===void 0?this.b=N.cId:this.b!==N.cId&&(this.b=ce.a):this.b!==void 0&&(this.b=ce.a))}}contains(Y,...V){return this.h(Y,{includeChildren:!1},...V)}affects(Y,...V){return this.h(Y,{includeChildren:!0},...V)}h(Y,V,...N){if(!Y)return!1;const z=N.length>0;return!!((!z||N.includes(1))&&(this.d.value.get(Y)||V.includeChildren&&this.d.value.findSuperstr(Y))||(!z||N.includes(0))&&(this.f.value.get(Y)||V.includeChildren&&this.f.value.findSuperstr(Y))||(!z||N.includes(2))&&(this.g.value.findSubstr(Y)||V.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}e.$jl=ce,ce.a=null;function ee(ie,Y,V){return!ie||!Y||ie===Y||Y.length>ie.length?!1:(Y.charAt(Y.length-1)!==C.sep&&(Y+=C.sep),V?(0,D.$zf)(ie,Y):ie.indexOf(Y)===0)}class K extends Error{constructor(Y,V,N){super(Y),this.fileOperationResult=V,this.options=N}}e.$ll=K;class q extends K{constructor(Y,V,N,z){super(Y,V,z),this.fileOperationResult=V,this.size=N}}e.$ml=q;class X extends K{constructor(Y,V,N){super(Y,2,N),this.stat=V}}e.$nl=X;var _;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(_||(e.FileOperationResult=_={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var M;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$vl="";function Q(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function ae(ie,Y){if(!Y.hasProvider(I.URI.from({scheme:ie.scheme})))return new Promise(V=>{const N=Y.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===ie.scheme&&z.added&&(N.dispose(),V())})})}class ne{static formatSize(Y){return(0,k.$ag)(Y)||(Y=0),Y<ne.KB?(0,S.localize)(1,null,Y.toFixed(0)):Y<ne.MB?(0,S.localize)(2,null,(Y/ne.KB).toFixed(2)):Y<ne.GB?(0,S.localize)(3,null,(Y/ne.MB).toFixed(2)):Y<ne.TB?(0,S.localize)(4,null,(Y/ne.GB).toFixed(2)):(0,S.localize)(5,null,(Y/ne.TB).toFixed(2))}}e.$yl=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;function we(ie){const Y=typeof ie=="string"||ie?.scheme===y.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===y.Schemas.file?1024*ne.MB:Y?10*ne.MB:g.$i?50*ne.MB:1024*ne.MB}}),define(ye[112],Ee([1,0,15,11,200,16]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=I;async function I(y,v,b,m,u,a){let f;try{await S(y,v,b,m,u,a)}catch(c){f=c}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f<"u"&&b.error(f),b.end()}}async function S(y,v,b,m,u,a){w(a);const f=await y.open(v,{create:!1});try{w(a);let c=0,d=0,$=u&&typeof u.length=="number"?u.length:void 0,E=s.$Ge.alloc(Math.min(u.bufferSize,typeof $=="number"?$:u.bufferSize)),h=u&&typeof u.position=="number"?u.position:0,t=0;do d=await y.read(f,h,E.buffer,t,E.byteLength-t),h+=d,t+=d,c+=d,typeof $=="number"&&($-=d),t===E.byteLength&&(await b.write(m(E)),E=s.$Ge.alloc(Math.min(u.bufferSize,typeof $=="number"?$:u.bufferSize)),t=0);while(d>0&&(typeof $!="number"||$>0)&&w(a)&&g(c,u));if(t>0){let o=t;typeof $=="number"&&(o=Math.min(t,$)),b.write(m(E.slice(0,o)))}}catch(c){throw(0,k.$el)(c)}finally{await y.close(f)}}function w(y){if(y.isCancellationRequested)throw(0,C.$6)();return!0}function g(y,v){if(typeof v?.limits?.size=="number"&&y>v.limits.size)throw(0,k.$dl)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[48],Ee([1,0,77,2,7,3,4,16]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=e.$Mq=void 0,e.$Kq=w,e.$Lq=g,e.$Pq=m,e.$Qq=u,e.$Rq=a,e.$Sq=f,e.$Tq=d,e.$Uq=$;function w(E){return typeof E.correlationId=="number"}function g(E){return E.recursive===!0}class y extends C.$Vc{constructor(h,t,o,r){super(),this.h=h,this.j=t,this.m=o,this.n=r,this.c=this.B(new C.$Wc),this.f=void 0,this.g=0}s(){const h=new C.$Uc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(t=>this.h(t))),h.add(this.b.onDidLogMessage(t=>this.j(t))),h.add(this.b.onDidError(t=>this.t(t)))}t(h){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Mq=y,y.a=5;class v extends y{constructor(h,t,o){super(h,t,o,{type:"node.js",restartOnError:!1})}}e.$Nq=v;class b extends y{constructor(h,t,o){super(h,t,o,{type:"universal",restartOnError:!0})}}e.$Oq=b;function m(E){return E.map(h=>({type:h.type,resource:I.URI.revive(h.resource),cId:h.cId}))}function u(E){const h=new c;for(const t of E)h.processEvent(t);return h.coalesce()}function a(E,h){return typeof h=="string"&&!h.startsWith(s.$mk)&&!(0,D.$jc)(h)?{base:E,pattern:h}:h}function f(E,h){const t=[];for(const o of h)t.push((0,s.$qk)(a(E,o)));return t}class c{constructor(){this.a=new Set,this.b=new Map}c(h){return k.$e?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const t=this.b.get(this.c(h));let o=!1;if(t){const r=t.type,i=h.type;t.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?o=!0:r===1&&i===2?(this.b.delete(this.c(h)),this.a.delete(t)):r===2&&i===1?t.type=0:r===1&&i===0||(t.type=i)}else o=!0;o&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],t=[];return Array.from(this.a).filter(o=>o.type!==2?(h.push(o),!1):!0).sort((o,r)=>o.resource.fsPath.length-r.resource.fsPath.length).filter(o=>t.some(r=>(0,S.$kl)(o.resource.fsPath,r,!k.$e))?!1:(t.push(o.resource.fsPath),!0)).concat(h)}}function d(E,h){if(typeof h=="number")switch(E.type){case 1:return(h&4)===0;case 2:return(h&8)===0;case 0:return(h&2)===0}return!1}function $(E){if(typeof E=="number"){const h=[];return E&4&&h.push("Added"),E&8&&h.push("Deleted"),E&2&&h.push("Updated"),h.length===0?"<all>":`[${h.join(", ")}]`}return"<none>"}}),define(ye[232],Ee([1,0,15,39,11,6,2,52,22,16,48]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=void 0,e.$DQ="localFilesystem";class v extends I.$Vc{constructor(m,u){super(),this.a=m,this.b=u,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$ee),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$ee),this.onDidWatchError=this.g.event,this.h=(0,w.$Sg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,u){const{buffer:a}=await this.a.call("readFile",[m,u]);return a}readFileStream(m,u,a){const f=(0,S.$ue)(d=>s.$Ge.concat(d.map($=>s.$Ge.wrap($))).buffer),c=new I.$Uc;return c.add(this.a.listen("readFileStream",[m,u])(d=>{if(d instanceof s.$Ge)f.write(d.buffer);else{if(d==="end")f.end();else{let $;if(d instanceof Error)$=d;else{const E=d;$=(0,g.$dl)(E.message??(0,C.$hj)(E),E.code??g.FileSystemProviderErrorCode.Unknown)}f.error($),f.end()}c.dispose()}})),c.add(a.onCancellationRequested(()=>{f.error((0,D.$6)()),f.end(),c.dispose()})),f}writeFile(m,u,a){return this.a.call("writeFile",[m,s.$Ge.wrap(u),a])}open(m,u){return this.a.call("open",[m,u])}close(m){return this.a.call("close",[m])}async read(m,u,a,f,c){const[d,$]=await this.a.call("read",[m,u,c]);return a.set(d.buffer.slice(0,$),f),$}write(m,u,a,f,c){return this.a.call("write",[m,u,s.$Ge.wrap(a),f,c])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,u){return this.a.call("delete",[m,u])}rename(m,u,a){return this.a.call("rename",[m,u,a])}copy(m,u,a){return this.a.call("copy",[m,u,a])}cloneFile(m,u){return this.a.call("cloneFile",[m,u])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const u=m;this.f.fire((0,y.$Pq)(u))}else{const u=m;this.g.fire(u)}}))}watch(m,u){const a=(0,w.$Sg)();return this.a.call("watch",[this.h,a,m,u]),(0,I.$Tc)(()=>this.a.call("unwatch",[this.h,a]))}}e.$EQ=v}),define(ye[233],Ee([1,0,27,2,48,6,4,14]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;class w extends C.$Vc{constructor(){super(),this.a=this.B(new k.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new C.$5c),this.m=new Set,this.n=5007,this.r=new S.$Th,this.P=!1,this.B(this.f(y=>this.s(y)))}s(y){this.t(y)&&this.w(y)}t(y){return(0,D.$Kq)(y)}async watch(y){this.r.isSettled||this.r.complete(),this.r=new S.$Th;try{this.h.clear(),this.g.clear();for(const v of y)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async w(y){if(this.j.has(y.correlationId))return;const v=new C.$Uc;this.j.set(y.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(y,v),this.u())}y(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.u()}z(y,v){this.C(y,v)?(this.N(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.D(y,v),this.m.add(y.correlationId))}C(y,v){const b=this.M?.subscribe(y.path,(m,u)=>{v.isDisposed||(m?this.z(y,v):u?.type===1&&this.F(y))});return b?(v.add(b),!0):!1}D(y,v){let b=!1;const m=(u,a)=>{if(v.isDisposed)return;const f=this.G(u),c=this.G(a),d=b;b=f,!f&&(c||d)&&this.F(y)};this.N(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,s.watchFile)(y.path,{persistent:!1,interval:this.n},m)}catch(u){this.O(`fs.watchFile() failed with error ${u} on path ${y.path} (correlationId: ${y.correlationId})`)}v.add((0,C.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,s.unwatchFile)(y.path,m)}catch(u){this.O(`fs.unwatchFile() failed with error ${u} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}F(y){this.N(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const v={resource:I.URI.file(y.path),type:1,cId:y.correlationId};this.a.fire([v]),this.H(v,y),this.y(y)}G(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(y,v){if(this.P){const b=` >> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.I(b,v)}}I(y,v){this.P&&this.N(`${y}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}J(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,D.$Uq)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.P=y}}e.$4q=w}),define(ye[234],Ee([1,0,27,14,20,35,2,100,7,3,19,4,170,23,48]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0,e.$0q=f;class a extends I.$Vc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(d,$,E,h,t,o){super(),this.s=d,this.t=$,this.u=E,this.w=h,this.y=t,this.z=o,this.c=this.B(new C.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new C.$Kh(r=>this.M(r),a.b)),this.g=(0,u.$Sq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,u.$Sq)(this.s.path,this.s.includes):void 0,this.j=(0,u.$Kq)(this.s)?this.s.filter:void 0,this.m=new D.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const d=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const $=await m.Promises.stat(d);if(this.m.token.isCancellationRequested)return;this.B(await this.G(d,$.isDirectory()))}catch(d){d.code!=="ENOENT"?this.O(d):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${d})`),this.D()}}D(){this.r=!0,this.w?.()}async F(d){let $=d.path;try{$=await m.Promises.realpath(d.path),d.path===$&&($=await(0,b.$6q)(d.path,this.m.token)??d.path),d.path!==$&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${$})`)}catch{}return $}async G(d,$){const E=new I.$Uc;return this.H(d,$,E)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(d,$,E)),E}H(d,$,E){if($)return!1;const h=v.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,r)=>{if(!E.isDisposed)if(o){const i=await this.G(d,$);E.isDisposed?i.dispose():E.add(i)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:r.type,cId:this.s.correlationId},!0)});return t?(E.add(t),!0):!1}async I(d,$,E){if(g.$d&&(0,k.$vg)(d,"/Volumes/",!0)){this.O(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new D.$pe(this.m.token);E.add((0,I.$Tc)(()=>h.dispose(!0)));const t=new I.$Uc;E.add(t);try{const o=v.URI.file(this.s.path),r=(0,w.$oc)(d),i=(0,s.watch)(d);t.add((0,I.$Tc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${d}'`);const n=new Set;if($)try{for(const p of await m.Promises.readdir(d))n.add(p)}catch(p){this.O(p)}if(h.token.isCancellationRequested)return;const l=new Map;t.add((0,I.$Tc)(()=>{for(const[,p]of l)p.dispose();l.clear()})),i.on("error",(p,P)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${d} for changes using fs.watch() (${p}, ${P})`),this.D())}),i.on("change",(p,P)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${p}"] ${P}`);let j="";if(P&&(j=P.toString(),g.$d&&(j=(0,S.$cm)(j))),!(!j||p!=="change"&&p!=="rename"))if($)if(p==="rename"){l.get(j)?.dispose();const O=setTimeout(async()=>{if(l.delete(j),j===r&&!await m.Promises.exists(d)){this.J(o);return}if(h.token.isCancellationRequested)return;const R=await this.N((0,w.$kc)(d,j));if(h.token.isCancellationRequested)return;let A;R?n.has(j)?A=0:(A=1,n.add(j)):(n.delete(j),A=2),this.L({resource:(0,y.$0g)(o,j),type:A,cId:this.s.correlationId})},a.a);l.set(j,(0,I.$Tc)(()=>clearTimeout(O)))}else{let O;n.has(j)?O=0:(O=1,n.add(j)),this.L({resource:(0,y.$0g)(o,j),type:O,cId:this.s.correlationId})}else if(p==="rename"||j!==r){const O=setTimeout(async()=>{const R=await m.Promises.exists(d);h.token.isCancellationRequested||(R?(this.L({resource:o,type:0,cId:this.s.correlationId},!0),t.add(await this.G(d,!1))):this.J(o))},a.a);t.clear(),t.add((0,I.$Tc)(()=>clearTimeout(O)))}else this.L({resource:o,type:0,cId:this.s.correlationId},!0)})}catch(o){h.token.isCancellationRequested||this.O(`Failed to watch ${d} for changes using fs.watch() (${o.toString()})`),this.D()}}J(d){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:d,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(d,$=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!$&&this.g.some(E=>E(d.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${d.resource.fsPath}`):!$&&this.h&&this.h.length>0&&!this.h.some(E=>E(d.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}M(d){const $=(0,u.$Qq)(d),E=[];for(const t of $){if((0,u.$Tq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}E.push(t)}if(E.length===0)return;if(this.z)for(const t of E)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(E)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${E.length}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(d){if(g.$e)return m.Promises.exists(d);try{const $=(0,w.$oc)(d);return(await m.Promises.readdir((0,w.$nc)(d))).some(h=>h===$)}catch($){return this.Q($),!1}}setVerboseLogging(d){this.z=d}O(d){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}P(d){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}Q(d){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}R(d){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${d}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$9q=a,a.a=100,a.b=75;async function f(c,d,$,E,h=512){const t=await m.Promises.open(c,"r"),o=Buffer.allocUnsafe(h),r=new D.$pe(E);let i,n=!1;const l={path:c,excludes:[],recursive:!1},p=new a(l,void 0,P=>{(async()=>{for(const{type:j}of P)if(j===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:O}=await m.Promises.read(t,o,0,h,null);if(!O||r.token.isCancellationRequested)break;d(o.slice(0,O))}}catch(O){i=new Error(O),r.dispose(!0)}finally{n=!1}}})()});return await p.ready,$(),new Promise((P,j)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await m.Promises.close(t)}catch(O){i=new Error(O)}i?j(i):P()})})}}),define(ye[235],Ee([1,0,6,77,233,3,234,35]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class w extends D.$4q{constructor(y){super(),this.M=y,this.onDidError=s.Event.None,this.watchers=new Set}async L(y){y=this.X(y);const v=[],b=new Set(Array.from(this.watchers));for(const m of y){const u=this.S(m);u&&(0,C.$uk)(u.request.excludes,m.excludes)&&(0,C.$uk)(u.request.includes,m.includes)?b.delete(u):v.push(m)}v.length&&this.N(`Request to start watching: ${v.map(m=>this.J(m)).join(",")}`),b.size&&this.N(`Request to stop watching: ${Array.from(b).map(m=>this.J(m.request)).join(",")}`);for(const m of b)this.W(m);for(const m of v)this.U(m)}S(y){for(const v of this.watchers)if(typeof y.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===y.correlationId)return v}else if((0,S.$ug)(v.request.path,y.path,!k.$e))return v}U(y){const v=new I.$9q(y,this.M,m=>this.a.fire(m),()=>this.c.fire(y),m=>this.b.fire(m),this.P),b={request:y,instance:v};this.watchers.add(b)}async stop(){await super.stop();for(const y of this.watchers)this.W(y)}W(y){this.N("stopping file watcher",y),this.watchers.delete(y),y.instance.dispose()}X(y){const v=new Map;for(const b of y){const m=k.$e?b.path:b.path.toLowerCase();let u=v.get(b.correlationId);u||(u=new Map,v.set(b.correlationId,u)),u.has(m)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(b)}`),u.set(m,b)}return Array.from(v.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(y){super.setVerboseLogging(y);for(const v of this.watchers)v.instance.setVerboseLogging(y)}N(y,v){this.P&&this.b.fire({type:"trace",message:this.$(y,v)})}O(y){this.b.fire({type:"warn",message:this.$(y)})}$(y,v){return v?`[File Watcher (node.js)] ${y} (${this.J(v.request)})`:`[File Watcher (node.js)] ${y}`}}e.$$q=w}),define(ye[236],Ee([1,0,48,235]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class D extends s.$Nq{constructor(I,S,w){super(I,S,w),this.s()}r(I){return I.add(new C.$$q(void 0))}}e.$_q=D}),define(ye[237],Ee([1,0,13,45,109,48]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class I extends k.$Oq{constructor(w,g,y){super(w,g,y),this.s()}r(w){const g=w.add(new D.$2q(s.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(g.onDidProcessExit(({code:y,signal:v})=>this.t(`terminated by itself with code ${y}, signal: ${v} (ETERM)`))),C.ProxyChannel.toService((0,C.$di)(g.getChannel("watcher")))}}e.$3q=I}),define(ye[84],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class s{constructor(...D){this.a=new Map;for(const[k,I]of D)this.set(k,I)}set(D,k){const I=this.a.get(D);return this.a.set(D,k),I}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$ui=s}),define(ye[113],Ee([1,0,14,11,2,68,229,5,84,99]),function(ue,e,s,C,D,k,I,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;const y=!1;class v extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class b{constructor(f=new w.$ui,c=!1,d,$=y){this.i=f,this.j=c,this.k=d,this.l=$,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(S.$vi,this),this._globalGraph=$?d?._globalGraph??new I.$cr(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,D.$Qc)(this.h),this.h.clear();for(const f of this.g)(0,D.$Pc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const c=new class extends b{dispose(){this.h.delete(c),super.dispose()}}(f,this.j,this,this.l);return this.h.add(c),c}invokeFunction(f,...c){this.m();const d=u.traceInvocation(this.l,f);let $=!1;try{return f({get:h=>{if($)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,d);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...c)}finally{$=!0,d.stop()}}createInstance(f,...c){this.m();let d,$;return f instanceof k.$ti?(d=u.traceCreation(this.l,f.ctor),$=this.o(f.ctor,f.staticArguments.concat(c),d)):(d=u.traceCreation(this.l,f),$=this.o(f,c,d)),d.stop(),$}o(f,c=[],d){const $=S._util.getServiceDependencies(f).sort((t,o)=>t.index-o.index),E=[];for(const t of $){const o=this.s(t.id,d);o||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(o)}const h=$.length>0?$[0].index:c.length;if(c.length!==h){console.trace(`[createInstance] First service dependency of ${f.name} at position ${h+1} conflicts with ${c.length} static arguments`);const t=h-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,h)}return Reflect.construct(f,c.concat(E))}q(f,c){if(this.i.get(f)instanceof k.$ti)this.i.set(f,c);else if(this.k)this.k.q(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const c=this.i.get(f);return!c&&this.k?this.k.r(f):c}s(f,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.r(f);return d instanceof k.$ti?this.u(f,d,c.branch(f,!0)):(c.branch(f,!1),d)}u(f,c,d){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,c,d)}finally{this.t.delete(f)}}v(f,c,d){const $=new I.$cr(t=>t.id.toString());let E=0;const h=[{id:f,desc:c,_trace:d}];for(;h.length;){const t=h.pop();if($.lookupOrInsertNode(t),E++>1e3)throw new v($);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const r=this.r(o.id);if(r||this.y(`[createInstance] ${f} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof k.$ti){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};$.insertEdge(t,i),h.push(i)}}}for(;;){const t=$.roots();if(t.length===0){if(!$.isEmpty())throw new v($);break}for(const{data:o}of t){if(this.r(o.id)instanceof k.$ti){const i=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,i)}$.removeNode(o)}}return this.r(f)}w(f,c,d=[],$,E){if(this.i.get(f)instanceof k.$ti)return this.x(f,c,d,$,E,this.g);if(this.k)return this.k.w(f,c,d,$,E);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(f,c,d=[],$,E,h){if($){const t=new b(void 0,this.j,this,this.l);t.c=String(f);const o=new Map,r=new s.$Ph(()=>{const i=t.o(c,d,E);for(const[n,l]of o){const p=i[n];if(typeof p=="function")for(const P of l)P.disposable=p.apply(i,P.listener)}return o.clear(),h.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let P=o.get(n);return P||(P=new g.$6c,o.set(n,P)),(O,R,A)=>{if(r.isInitialized)return r.value[n](O,R,A);{const B={listener:[O,R,A],disposable:void 0},G=P.push(B);return(0,D.$Tc)(()=>{G(),B.disposable?.dispose()})}}}if(n in i)return i[n];const l=r.value;let p=l[n];return typeof p!="function"||(p=p.bind(l),i[n]=p),p},set(i,n,l){return r.value[n]=l,!0},getPrototypeOf(i){return c.prototype}})}else{const t=this.o(c,d,E);return h.add(t),t}}y(f,c){if(c&&console.warn(f),this.j)throw new Error(f)}}e.$dr=b;var m;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(m||(m={}));class u{static traceInvocation(f,c){return f?new u(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u.c}static traceCreation(f,c){return f?new u(1,c.name):u.c}constructor(f,c){this.type=f,this.name=c,this.g=Date.now(),this.h=[]}branch(f,c){const d=new u(3,f.toString());return this.h.push([f,c,d]),d}stop(){const f=Date.now()-this.g;u.f+=f;let c=!1;function d(E,h){const t=[],o=new Array(E+1).join("	");for(const[r,i,n]of h.h)if(i&&n){c=!0,t.push(`${o}CREATES -> ${r}`);const l=d(E+1,n);l&&t.push(l)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${u.f.toFixed(2)}ms)`];(f>2||c)&&u.all.add($.join(`
`))}}e.$er=u,u.all=new Set,u.c=new class extends u{constructor(){super(0,null)}stop(){}branch(){return this}},u.f=0}),define(ye[238],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$0v=void 0,e.$0v=(0,s.$wi)("labelService");var C;(function(D){D[D.SHORT=0]="SHORT",D[D.MEDIUM=1]="MEDIUM",D[D.LONG=2]="LONG"})(C||(e.Verbosity=C={}))});var Ne=this&&this.__param||function(ue,e){return function(s,C){e(s,C,ue)}};define(ye[85],Ee([1,0,20,2,3,202,32,5]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=void 0,e.$Rr=w;function w(y){return y.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Sr=(0,S.$wi)("languagePackService");let g=class extends C.$Vc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new s.$pe;setTimeout(()=>v.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const u=b.firstPage.filter(a=>a.properties.localizedLanguages?.length&&a.tags.some(f=>f.startsWith("lp-"))).map(a=>{const f=a.properties.localizedLanguages?.[0],c=w(a);return{...this.f(c,f,a),extensionId:a.identifier.id,galleryExtension:a}});return u.push(this.f("en","English")),u}f(v,b,m){const u=b??v;let a;if(u!==v&&(a=`(${v})`),v.toLowerCase()===D.$q.toLowerCase()&&(a??(a=""),a+=(0,k.localize)(0,null)),m?.installCount){a??(a="");const f=m.installCount;let c;f>1e6?c=`${Math.floor(f/1e5)/10}M`:f>1e3?c=`${Math.floor(f/1e3)}K`:c=String(f),a+=` $(cloud-download) ${c}`}return{id:v,label:u,description:a}}};e.$Tr=g,e.$Tr=g=Fe([Ne(0,I.$7o)],g)}),define(ye[12],Ee([1,0,203,39,6,64,2,24,3,19,10,4,47,5]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=a,e.log=c,e.$ek=p,e.$fk=P,e.$gk=j,e.$hk=O,e.$3j=(0,m.$wi)("logService"),e.$4j=(0,m.$wi)("loggerService");function u(){return new Date().toISOString()}function a(R){return(0,y.$ag)(R)}var f;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function c(R,A,B){switch(A){case f.Trace:R.trace(B);break;case f.Debug:R.debug(B);break;case f.Info:R.info(B);break;case f.Warning:R.warn(B);break;case f.Error:R.error(B);break;case f.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function d(R,A=!1){let B="";for(let G=0;G<R.length;G++){let se=R[G];if(se instanceof Error&&(se=(0,C.$hj)(se,A)),typeof se=="object")try{se=JSON.stringify(se)}catch{}B+=(G>0?" ":"")+se}return B}class $ extends I.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new D.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==f.Off&&this.b<=A}}e.$8j=$;class E extends ${constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...B){this.f(f.Trace)&&this.g(f.Trace,d([A,...B],!0))}debug(A,...B){this.f(f.Debug)&&this.g(f.Debug,d([A,...B]))}info(A,...B){this.f(f.Info)&&this.g(f.Info,d([A,...B]))}warn(A,...B){this.f(f.Warning)&&this.g(f.Warning,d([A,...B]))}error(A,...B){if(this.f(f.Error))if(A instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=A.stack,this.g(f.Error,d(G))}else this.g(f.Error,d([A,...B]))}flush(){}}e.$9j=E;class h extends ${constructor(A=e.$6j){super(),this.setLevel(A),this.g=!w.$c}trace(A,...B){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,A,...B):console.log(`[main ${u()}]`,A,...B))}debug(A,...B){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,A,...B):console.log(`[main ${u()}]`,A,...B))}info(A,...B){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,A,...B):console.log(`[main ${u()}]`,A,...B))}warn(A,...B){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,A,...B):console.warn(`[main ${u()}]`,A,...B))}error(A,...B){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,A,...B):console.error(`[main ${u()}]`,A,...B))}flush(){}}e.$0j=h;class t extends ${constructor(A=e.$6j,B=!0){super(),this.g=B,this.setLevel(A)}trace(A,...B){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...B):console.log(A,...B))}debug(A,...B){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...B):console.log(A,...B))}info(A,...B){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...B):console.log(A,...B))}warn(A,...B){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...B):console.log(A,...B))}error(A,...B){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...B):console.error(A,...B))}flush(){}}e.$$j=t;class o extends ${constructor(A,B=e.$6j){super(),this.g=A,this.setLevel(B)}trace(A,...B){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(A),...B])}debug(A,...B){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(A),...B])}info(A,...B){this.f(f.Info)&&this.g.log(f.Info,[this.h(A),...B])}warn(A,...B){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(A),...B])}error(A,...B){this.f(f.Error)&&this.g.log(f.Error,[this.h(A),...B])}h(A){return typeof A=="string"?A:(0,C.$hj)(A,this.f(f.Trace))}flush(){}}e.$_j=o;class r extends ${constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const B of this.g)B.setLevel(A);super.setLevel(A)}trace(A,...B){for(const G of this.g)G.trace(A,...B)}debug(A,...B){for(const G of this.g)G.debug(A,...B)}info(A,...B){for(const G of this.g)G.info(A,...B)}warn(A,...B){for(const G of this.g)G.warn(A,...B)}error(A,...B){for(const G of this.g)G.error(A,...B)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose();super.dispose()}}e.$ak=r;class i extends I.$Vc{constructor(A,B,G){if(super(),this.h=A,this.j=B,this.b=new S.$Bc,this.c=this.B(new D.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$ee),this.onDidChangeVisibility=this.g.event,G)for(const se of G)this.b.set(se.resource,{logger:void 0,info:se})}m(A){return(0,y.$9f)(A)?[...this.b.values()].find(B=>B.info.id===A):this.b.get(A)}getLogger(A){return this.m(A)?.logger}createLogger(A,B){const G=this.n(A),se=(0,y.$9f)(A)?A:B?.id??(0,k.$kj)(G.toString()).toString(16);let ce=this.b.get(G)?.logger;const ee=B?.logLevel==="always"?f.Trace:B?.logLevel;ce||(ce=this.s(G,ee??this.getLogLevel(G)??this.h,{...B,id:se}));const K={logger:ce,info:{resource:G,id:se,logLevel:ee,name:B?.name,hidden:B?.hidden,extensionId:B?.extensionId,when:B?.when}};return this.registerLogger(K.info),this.b.set(G,K),ce}n(A){return(0,y.$9f)(A)?(0,g.$0g)(this.j,`${A}.log`):A}setLogLevel(A,B){if(v.URI.isUri(A)){const G=A,se=B,ce=this.b.get(G);ce&&se!==ce.info.logLevel&&(ce.info.logLevel=se===this.h?void 0:se,ce.logger?.setLevel(se),this.b.set(ce.info.resource,ce),this.f.fire([G,se]))}else{this.h=A;for(const[G,se]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&se.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,B){const G=this.m(A);G&&B!==!G.info.hidden&&(G.info.hidden=!B,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,B]))}getLogLevel(A){let B;return A&&(B=this.b.get(A)?.info.logLevel),B??this.h}registerLogger(A){const B=this.b.get(A.resource);B?B.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const B=this.b.get(A);B&&(B.logger&&B.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[B.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=i;class n{constructor(){this.onDidChangeLogLevel=new D.$ee().event}setLevel(A){}getLevel(){return f.Info}trace(A,...B){}debug(A,...B){}info(A,...B){}warn(A,...B){}error(A,...B){}critical(A,...B){}dispose(){}flush(){}}e.$ck=n;class l extends n{}e.$dk=l;function p(R){if(R.verbose)return f.Trace;if(typeof R.logLevel=="string"){const A=O(R.logLevel.toLowerCase());if(A!==void 0)return A}return e.$6j}function P(R){switch(R){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function j(R){switch(R){case f.Trace:return{original:"Trace",value:s.localize(0,null)};case f.Debug:return{original:"Debug",value:s.localize(1,null)};case f.Info:return{original:"Info",value:s.localize(2,null)};case f.Warning:return{original:"Warning",value:s.localize(3,null)};case f.Error:return{original:"Error",value:s.localize(4,null)};case f.Off:return{original:"Off",value:s.localize(5,null)}}}function O(R){switch(R){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new b.$Nj("logLevel",P(f.Info))}),define(ye[239],Ee([1,0,18,14,11,6,35,2,7,48,12]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class v extends S.$Vc{constructor(m,u){super(),this.a=m,this.b=u,this.c=this.B(new k.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$uh(0)),this.w=[],this.y=this.B(new C.$uh(0))}watch(m,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(m,u):this.z(m,u)}n(m,u){const a={path:this.J(m),excludes:u.excludes,includes:u.includes,recursive:u.recursive,filter:u.filter,correlationId:u.correlationId},f=(0,s.$Ub)(this.j,a);return this.r(),(0,S.$Tc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,D.$1)(m))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,g.$Pq)(u)),u=>this.G(u),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const u of this.j)(0,g.$Lq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const u of this.j)(0,g.$Lq)(u)&&m.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,u){const a={path:this.J(m),excludes:u.excludes,includes:u.includes,recursive:!1,filter:u.filter,correlationId:u.correlationId},f=(0,s.$Ub)(this.w,a);return this.C(),(0,S.$Tc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,D.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,g.$Pq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,w.$ic)(m.fsPath)}J(m){const u=this.I(m);return(0,I.$yg)(u)}}e.$Vq=v}),define(ye[114],Ee([1,0,18,14,15,20,6,64,41,2,66,13,44,19,52,198,16,112,12,11]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;let h=E=class extends g.$Vc{constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$ee),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$ee),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$ee),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$ee),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$ee),this.Y=this.B(new I.$ee),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$ee),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$Fh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`);const i=new g.$Uc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const l=new f.$jl(n,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,g.$Tc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,g.$Qc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await C.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,m.$bh)(o))throw new f.$ll((0,a.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new $.$bb;throw i.message=(0,a.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,f.$9k)(r)||(0,f.$6k)(r)||(0,f.$0k)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,f.$9k)(r)||(0,f.$6k)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,f.$gl)(i)===f.FileSystemProviderErrorCode.FileNotFound?new f.$ll((0,a.localize)(2,null,this.sb(o)),1):(0,f.$el)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),l=r?.resolveTo,p=r?.resolveSingleChildDescendants,P=r?.resolveMetadata,j=await i.stat(o);let O;return this.t(i,o,j,void 0,!!P,(R,A)=>(O||(O=y.$Ci.forUris(()=>!n),O.set(o,!0),l&&O.fill(!0,l)),O.get(R.resource)||O.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&p?A===1:!1))}async t(o,r,i,n,l,p){const{providerExtUri:P}=this.R(o),j={resource:r,name:P.basename(r),isFile:(i.type&f.FileType.File)!==0,isDirectory:(i.type&f.FileType.Directory)!==0,isSymbolicLink:(i.type&f.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&f.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&f.FilePermission.Locked),etag:(0,f.$wl)({mtime:i.mtime,size:i.size}),children:void 0};if(j.isDirectory&&p(j,n)){try{const O=await o.readdir(r),R=await C.Promises.settled(O.map(async([A,B])=>{try{const G=P.joinPath(r,A),se=l?await o.stat(G):{type:B};return await this.t(o,G,se,O.length,l,p)}catch(G){return this.b.trace(G),null}}));j.children=(0,s.$Hb)(R)}catch(O){this.b.trace(O),j.children=[]}return j}return j}async resolveAll(o){return C.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new f.$ll((0,a.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=D.$Ge.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new f.$il(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(n);let p=i;if((0,f.$_k)(n)&&!p?.atomic){const P=n.enforceAtomicWriteFile?.(o);P&&(p={...i,atomic:P})}try{await this.w(n,o,p)||await this.U(n,l.dirname(o));let j;if((0,f.$6k)(n)&&!(r instanceof D.$Ge))if((0,u.$se)(r)){const O=await(0,u.$ze)(r,3);O.ended?j=D.$Ge.concat(O.buffer):j=O}else j=(0,u.$we)(r,O=>D.$Ge.concat(O),3);else j=r;!(0,f.$9k)(n)||(0,f.$6k)(n)&&j instanceof D.$Ge||(0,f.$6k)(n)&&(0,f.$_k)(n)&&p?.atomic?await this.hb(n,o,p,j):await this.db(n,o,p,j instanceof D.$Ge?(0,D.$Re)(j):j),this.r.fire(new f.$il(o,4))}catch(P){throw new f.$ll((0,a.localize)(4,null,this.sb(o),(0,f.$el)(P).toString()),(0,f.$hl)(P),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,a.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,a.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,a.localize)(7,null,this.sb(r)));if(n)throw new Error((0,a.localize)(8,null,this.sb(r)))}let p;try{p=await o.stat(r)}catch{return}if(p.type&f.FileType.Directory)throw new f.$ll((0,a.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,p),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==f.$vl&&typeof p.mtime=="number"&&typeof p.size=="number"&&i.mtime<p.mtime&&i.etag!==(0,f.$wl)({mtime:i.mtime,size:p.size}))throw new f.$ll((0,a.localize)(10,null),3,i);return p}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((l,p)=>{this.cb.queueFor(r,async()=>{try{const P=await this.C(o,r,i,n);l(P)}catch(P){p(P)}},this.R(o).providerExtUri)})}async C(o,r,i,n){const l=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...l,value:await(0,D.$Se)(l.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const l=new k.$pe(n);let p=i;(0,f.$$k)(o)&&o.enforceAtomicReadFile?.(r)&&(p={...i,atomic:!0});const P=this.J(r,p).then(O=>O,O=>{throw l.dispose(!0),O});let j;try{return typeof p?.etag=="string"&&p.etag!==f.$vl&&await P,p?.atomic&&(0,f.$$k)(o)||!((0,f.$9k)(o)||(0,f.$0k)(o))||(0,f.$6k)(o)&&p?.preferUnbuffered?j=this.I(o,r,p):(0,f.$0k)(o)?j=this.G(o,r,l.token,p):j=this.H(o,r,l.token,p),j.on("end",()=>l.dispose()),j.on("error",()=>l.dispose()),{...await P,value:j}}catch(O){throw j&&await(0,u.$xe)(j),this.F(O,r,p)}}F(o,r,i){const n=(0,a.localize)(11,null,this.sb(r),(0,f.$el)(o).toString());return o instanceof f.$nl?new f.$nl(n,o.stat,i):o instanceof f.$ml?new f.$ml(n,o.fileOperationResult,o.size,o.options):new f.$ll(n,(0,f.$hl)(o),i)}G(o,r,i,n=Object.create(null)){const l=o.readFileStream(r,n,i);return(0,u.$De)(l,{data:p=>p instanceof D.$Ge?p:D.$Ge.wrap(p),error:p=>this.F(p,r,n)},p=>D.$Ge.concat(p))}H(o,r,i,n=Object.create(null)){const l=(0,D.$We)();return(0,c.$Iq)(o,r,l,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,r,n)},i),l}I(o,r,i){const n=(0,u.$ue)(l=>D.$Ge.concat(l));return(async()=>{try{let l;i?.atomic&&(0,f.$$k)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(r,l.byteLength,i),n.end(D.$Ge.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new f.$ll((0,a.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==f.$vl&&r.etag===i.etag)throw new f.$nl((0,a.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new f.$ml((0,a.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const l=i==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(r),r);await this.Q(l,o,p,r,i,n)}catch(l){return l}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),p=await this.N(n,o,l,r,"move",!!i),P=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new f.$il(o,p==="move"?2:3,P)),P}async copy(o,r,i){const n=await this.m(o),l=this.qb(await this.n(r),r),p=await this.N(n,o,l,r,"copy",!!i),P=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new f.$il(o,p==="copy"?3:2,P)),P}async N(o,r,i,n,l,p){if(r.toString()===n.toString())return l;const{exists:P,isSameResourceWithDifferentPathCase:j}=await this.Q(o,r,i,n,l,p);if(P&&!j&&p&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),l==="copy"){if(o===i&&(0,f.$7k)(o))await o.copy(r,n,{overwrite:p});else{const O=await this.resolve(r);O.isDirectory?await this.P(o,O,i,n):await this.O(o,r,i,n)}return l}else return o===i?(await o.rename(r,n,{overwrite:p}),l):(await this.N(o,r,i,n,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,f.$9k)(o)&&(0,f.$9k)(i))return this.jb(o,r,i,n);if((0,f.$9k)(o)&&(0,f.$6k)(i))return this.pb(o,r,i,n);if((0,f.$6k)(o)&&(0,f.$9k)(i))return this.nb(o,r,i,n);if((0,f.$6k)(o)&&(0,f.$6k)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await C.Promises.settled(r.children.map(async l=>{const p=this.R(i).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),i,p):this.O(o,l.resource,i,p)}))}async Q(o,r,i,n,l,p){let P=!1;if(o===i){const{providerExtUri:O,isPathCaseSensitive:R}=this.R(o);if(R||(P=O.isEqual(r,n)),P&&l==="copy")throw new Error((0,a.localize)(15,null,this.sb(r),this.sb(n)));if(!P&&O.isEqualOrParent(n,r))throw new Error((0,a.localize)(16,null,this.sb(r),this.sb(n)))}const j=await this.exists(n);if(j&&!P){if(!p)throw new f.$ll((0,a.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:O}=this.R(o);if(O.isEqualOrParent(r,n))throw new Error((0,a.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:j,isSameResourceWithDifferentPathCase:P}}R(o){const r=this.S(o);return{providerExtUri:r?m.$Zg:m.$2g,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new f.$il(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&f.FileType.Directory))throw new Error((0,a.localize)(19,null,this.sb(r)));break}catch(l){if((0,f.$gl)(l)!==f.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(n.basename(r)),r=n.dirname(r)}for(let l=i.length-1;l>=0;l--){r=n.joinPath(r,i[l]);try{await o.mkdir(r)}catch(p){if((0,f.$gl)(p)!==f.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,a.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,a.localize)(21,null,this.sb(o)));if(n&&l)throw new Error((0,a.localize)(22,null,this.sb(o)));let p;try{p=await i.stat(o)}catch{}if(p)this.rb(o,p);else throw new f.$ll((0,a.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const j=await this.resolve(o);if(j.isDirectory&&Array.isArray(j.children)&&j.children.length>0)throw new Error((0,a.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,f.$al)(i)&&!n?.atomic){const j=i.enforceAtomicDelete?.(o);j&&(n={...r,atomic:j})}const l=!!n?.useTrash,p=!!n?.recursive,P=n?.atomic??!1;await i.delete(o,{recursive:p,useTrash:l,atomic:P}),this.r.fire(new f.$il(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,r)))return i===n&&(0,f.$8k)(i)?i.cloneFile(o,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,f.$7k)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,r),this.R(i).providerExtUri))}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new g.$Uc;let n=!1,l=()=>{n=!0};i.add((0,g.$Tc)(()=>l())),(async()=>{try{const P=await this.bb(o,r);n?(0,g.$Qc)(P):l=()=>(0,g.$Qc)(P)}catch(P){this.b.error(P)}})();const p=r.correlationId;if(typeof p=="number"){const P=i.add(new I.$ee);return i.add(this.X.event(O=>{O.correlates(p)&&P.fire(O)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,S.$kj)([this.R(i).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(n);return l||(l={count:0,disposable:i.watch(o,r)},this.$.set(n,l)),l.count+=1,(0,g.$Tc)(()=>{l&&(l.count--,l.count===0&&((0,g.$Qc)(l.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Qc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,async()=>{const l=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,u.$se)(n)||(0,u.$te)(n)?await this.eb(o,l,n):await this.fb(o,l,n)}catch(p){throw(0,f.$el)(p)}finally{await o.close(l)}},this.R(o).providerExtUri)}async eb(o,r,i){let n=0,l;if((0,u.$te)(i)){if(i.buffer.length>0){const p=D.$Ge.concat(i.buffer);await this.gb(o,r,p,p.byteLength,n,0),n+=p.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((p,P)=>{(0,u.$ye)(l,{onData:async j=>{l.pause();try{await this.gb(o,r,j,j.byteLength,n,0)}catch(O){return P(O)}n+=j.byteLength,setTimeout(()=>l.resume())},onError:j=>P(j),onEnd:()=>p()})})}async fb(o,r,i){let n=0,l;for(;(l=i.read())!==null;)await this.gb(o,r,l,l.byteLength,n,0),n+=l.byteLength}async gb(o,r,i,n,l,p){let P=0;for(;P<n;){const j=await o.write(r,l+P,i.buffer,p+P,n-P);P+=j}}async hb(o,r,i,n){return this.cb.queueFor(r,()=>this.ib(o,r,i,n),this.R(o).providerExtUri)}async ib(o,r,i,n){let l;n instanceof D.$Ge?l=n:(0,u.$se)(n)?l=await(0,D.$Se)(n):(0,u.$te)(n)?l=await(0,D.$Te)(n):l=(0,D.$Qe)(n),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,()=>this.kb(o,r,i,n),this.R(i).providerExtUri)}async kb(o,r,i,n){let l,p;try{l=await o.open(r,{create:!1}),p=await i.open(n,{create:!0,unlock:!1});const P=D.$Ge.alloc(this.a);let j=0,O=0,R=0;do R=await o.read(l,j,P.buffer,O,P.byteLength-O),await this.gb(i,p,P,R,j,O),j+=R,O+=R,O===P.byteLength&&(O=0);while(R>0)}catch(P){throw(0,f.$el)(P)}finally{await C.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof p=="number"?i.close(p):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,()=>this.mb(o,r,i,n),this.R(i).providerExtUri)}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,()=>this.ob(o,r,i,n),this.R(i).providerExtUri)}async ob(o,r,i,n){const l=await i.open(n,{create:!0,unlock:!1});try{const p=await o.readFile(r);await this.gb(i,l,D.$Ge.wrap(p),p.byteLength,0,0)}catch(p){throw(0,f.$el)(p)}finally{await i.close(l)}}async pb(o,r,i,n){const l=await(0,D.$Se)(this.H(o,r,k.CancellationToken.None));await this.hb(i,n,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new f.$ll((0,a.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&f.FilePermission.Readonly)throw new f.$ll((0,a.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$Jq=h,h.ab=0,e.$Jq=h=E=Fe([Ne(0,d.$3j)],h)}),define(ye[69],Ee([1,0,27,315,14,24,15,6,35,2,7,3,19,52,23,201,16,112,239,39,237,236]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0,(()=>{try{(0,C.gracefulify)(s)}catch(o){console.error(`Error enabling graceful-fs: ${(0,$.$hj)(o)}`)}})();class t extends d.$Vq{constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.P=new k.$Bc(n=>b.$1g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,v.$e&&(this.M|=1024)),this.M}async stat(r){try{const{stat:i,symbolicLink:n}=await u.SymlinkSupport.stat(this.I(r));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:f.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await u.Promises.readdir(this.I(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async l=>{try{let p;l.isSymbolicLink()?p=(await this.stat((0,b.$0g)(r,l.name))).type:p=this.O(l),n.push([l.name,p])}catch(p){this.a.trace(p)}})),n}catch(i){throw this.hb(i)}}O(r,i){let n;return i?.dangling?n=f.FileType.Unknown:r.isFile()?n=f.FileType.File:r.isDirectory()?n=f.FileType.Directory:n=f.FileType.Unknown,i&&(n|=f.FileType.SymbolicLink),n}async Q(r){const i=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const l=new D.$vh;return this.P.set(r,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(r)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),n=await this.Q(r));const l=this.I(r);return await u.Promises.readFile(l)}catch(l){throw this.hb(l)}finally{n?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,i,n){const l=(0,m.$ue)(p=>I.$Ge.concat(p.map(P=>I.$Ge.wrap(P))).buffer);return(0,c.$Iq)(this,r,l,p=>p.buffer,{...i,bufferSize:256*1024},n),l}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(r)?this.U(r,(0,b.$0g)((0,b.$9g)(r),`${(0,b.$7g)(r)}${n.atomic.postfix}`),i,n):this.W(r,i,n)}async S(r){try{const i=this.I(r),{symbolicLink:n}=await u.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(r,i,n,l){const p=new g.$Uc;try{p.add(await this.Q(r)),p.add(await this.Q(i)),await this.W(i,n,l,!0);try{await this.rename(i,r,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{p.dispose()}}async W(r,i,n,l){let p;try{const P=this.I(r);if(!n.create||!n.overwrite){if(await u.Promises.exists(P)){if(!n.overwrite)throw(0,f.$dl)((0,a.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,f.$dl)((0,a.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:n.unlock},l),await this.write(p,0,i,0,i.byteLength)}catch(P){throw await this.ib(r,P)}finally{typeof p=="number"&&await this.close(p)}}static configureFlushOnWrite(r){t.$=r}async open(r,i,n){const l=this.I(r);let p;(0,f.$4k)(i)&&!n&&(p=await this.Q(r));let P;try{if((0,f.$4k)(i)&&i.unlock)try{const{stat:O}=await u.SymlinkSupport.stat(l);O.mode&128||await u.Promises.chmod(l,O.mode|128)}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}let j;if((0,f.$4k)(i)){if(v.$c)try{await u.Promises.truncate(l,0),j="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}j||(j="w")}else j="r";P=await u.Promises.open(l,j)}catch(j){throw p?.dispose(),(0,f.$4k)(i)?await this.ib(r,j):this.hb(j)}if(this.X.set(P,0),(0,f.$4k)(i)&&this.Z.set(P,r),p){const j=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${l})`),this.Y.set(P,p),j&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${l})`),j.dispose())}return P}async close(r){const i=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await u.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await u.Promises.close(r)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(r)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,l,p){const P=this.ab(r,i);let j=null;try{j=(await u.Promises.read(r,n,l,p,P)).bytesRead}catch(O){throw this.hb(O)}finally{this.bb(r,P,j)}return j}ab(r,i){return i===this.X.get(r)?null:i}bb(r,i,n){const l=this.X.get(r);typeof l=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(r,l+n):this.X.delete(r)))}async write(r,i,n,l,p){return(0,D.$Qh)(()=>this.cb(r,i,n,l,p),100,3)}async cb(r,i,n,l,p){const P=this.ab(r,i);let j=null;try{j=(await u.Promises.write(r,n,l,p,P)).bytesWritten}catch(O){throw await this.ib(this.Z.get(r),O)}finally{this.bb(r,P,j)}return j}async mkdir(r){try{await u.Promises.mkdir(this.I(r))}catch(i){throw this.hb(i)}}async delete(r,i){try{const n=this.I(r);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,y.$kc)((0,y.$nc)(n),`${(0,y.$oc)(n)}${i.atomic.postfix}`)),await u.Promises.rm(n,u.RimRafMode.MOVE,l)}else try{await u.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let p=!1;try{const{stat:P,symbolicLink:j}=await u.SymlinkSupport.stat(n);p=P.isDirectory()&&!j}catch{}if(p)await u.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.hb(n)}}async rename(r,i,n){const l=this.I(r),p=this.I(i);if(l!==p)try{await this.db(r,i,"move",n.overwrite),await u.Promises.rename(l,p)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,a.localize)(2,null,(0,y.$oc)(l),(0,y.$oc)((0,y.$nc)(p)),P.toString()))),this.hb(P)}}async copy(r,i,n){const l=this.I(r),p=this.I(i);if(l!==p)try{await this.db(r,i,"copy",n.overwrite),await u.Promises.copy(l,p,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,a.localize)(3,null,(0,y.$oc)(l),(0,y.$oc)((0,y.$nc)(p)),P.toString()))),this.hb(P)}}async db(r,i,n,l){const p=this.I(r),P=this.I(i);let j=!1;if(!!(this.capabilities&1024)||(j=(0,w.$ug)(p,P,!0)),j){if(n==="copy")throw(0,f.$dl)((0,a.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.N(r);if(!R)throw(0,f.$dl)((0,a.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(i);if(A){if(!l)throw(0,f.$dl)((0,a.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);R.type&f.FileType.File&&A.type&f.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.eb(r,i,!1)}async eb(r,i,n){const l=this.I(r),p=this.I(i),P=!!(this.capabilities&1024);if((0,w.$ug)(l,p,!P))return;const j=new g.$Uc;try{j.add(await this.Q(r)),j.add(await this.Q(i)),n&&await u.Promises.mkdir((0,y.$nc)(p),{recursive:!0}),await u.Promises.copyFile(l,p)}catch(O){if(O.code==="ENOENT"&&!n)return this.eb(r,i,!0);throw this.hb(O)}finally{j.dispose()}}t(r,i,n){return new E.$3q(l=>r(l),l=>i(l),n)}F(r,i,n){return new h.$_q(l=>r(l),l=>i(l),n)}hb(r){if(r instanceof f.$cl)return r;let i=r,n;switch(r.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=f.FileSystemProviderErrorCode.Unknown;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.$dl)(i,n)}async ib(r,i){let n=this.hb(i);if(r&&n.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await u.SymlinkSupport.stat(this.I(r));l.mode&128||(n=(0,f.$dl)(i,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return n}}e.$ar=t,t.L=!1,t.$=!0}),define(ye[240],Ee([1,0,6,69,2,15,52,20]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=e.$Ks=void 0;class w extends D.$Vc{constructor(v,b){super(),this.a=v,this.b=b,this.F=new Map,this.G=new Map}call(v,b,m){const u=this.c(v);switch(b){case"stat":return this.g(u,m[0]);case"readdir":return this.h(u,m[0]);case"open":return this.r(u,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(u,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(u,m[0],m[1],m[2]);case"rename":return this.z(u,m[0],m[1],m[2]);case"copy":return this.C(u,m[0],m[1],m[2]);case"cloneFile":return this.D(u,m[0],m[1]);case"mkdir":return this.w(u,m[0]);case"delete":return this.y(u,m[0],m[1]);case"watch":return this.I(u,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,m){const u=this.c(v);switch(b){case"fileChange":return this.H(u,m[0]);case"readFileStream":return this.m(u,m[0],m[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const m=this.f(v,b,!0);return this.a.stat(m)}h(v,b){const m=this.f(v,b);return this.a.readdir(m)}async j(v,b,m){const u=this.f(v,b,!0);this.b.trace(`File action: readFile ${u.path}`);const a=await this.a.readFile(u,m);return k.$Ge.wrap(a)}m(v,b,m){const u=this.f(v,b,!0),a=new S.$pe,f=new s.$ee({onDidRemoveLastListener:()=>{a.cancel()}});this.b.trace(`File action: readFileStream ${u.path}`);const c=this.a.readFileStream(u,m,a.token);return(0,I.$ye)(c,{onData:d=>f.fire(k.$Ge.wrap(d)),onError:d=>f.fire(d),onEnd:()=>{f.fire("end"),f.dispose(),a.dispose()}}),f.event}n(v,b,m,u){const a=this.f(v,b);return this.b.trace(`File action: writeFile ${a.path}`),this.a.writeFile(a,m.buffer,u)}r(v,b,m){const u=this.f(v,b,!0);return this.a.open(u,m)}s(v){return this.a.close(v)}async t(v,b,m){const u=k.$Ge.alloc(m),f=await this.a.read(v,b,u.buffer,0,m);return[u,f]}u(v,b,m,u,a){return this.a.write(v,b,m.buffer,u,a)}w(v,b){const m=this.f(v,b);return this.a.mkdir(m)}y(v,b,m){const u=this.f(v,b);return this.a.delete(u,m)}z(v,b,m,u){const a=this.f(v,b),f=this.f(v,m);return this.a.rename(a,f,u)}C(v,b,m,u){const a=this.f(v,b),f=this.f(v,m);return this.a.copy(a,f,u)}D(v,b,m){const u=this.f(v,b),a=this.f(v,m);return this.a.cloneFile(u,a)}H(v,b){const m=new s.$ee({onWillAddFirstListener:()=>{this.F.set(b,this.L(v,m))},onDidRemoveLastListener:()=>{(0,D.$Qc)(this.F.get(b)),this.F.delete(b)}});return m.event}async I(v,b,m,u,a){const f=this.F.get(b);if(f){const c=this.f(v,u),d=f.watch(m,c,a);this.G.set(b+m,d)}}async J(v,b){const m=v+b,u=this.G.get(m);u&&((0,D.$Qc)(u),this.G.delete(m))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$Ks=w;class g extends D.$Vc{constructor(v,b,m,u){super(),this.c=v,this.f=m,this.g=u,this.a=new Map,this.b=this.B(new C.$ar(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(b)}h(v){const b=this.B(new s.$ee);this.B(b.event(m=>{v.fire(m.map(u=>({resource:this.c.transformOutgoingURI(u.resource),type:u.type,cId:u.cId})))})),this.B(this.b.onDidChangeFile(m=>b.fire(m))),this.B(this.b.onDidWatchError(m=>v.fire(m)))}j(v){}m(v){}watch(v,b,m){const u=this.m(this.g);return Array.isArray(u)&&(m.excludes=[...m.excludes,...u]),this.a.set(v,this.b.watch(b,m)),(0,D.$Tc)(()=>{(0,D.$Qc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$Ls=g}),define(ye[115],Ee([1,0,4,6,12,2]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.$as=void 0;class I extends D.$bk{constructor(v,b,m,u,a){super(b,m,u),this.r=v,this.t=a,this.B(a.listen("onDidChangeLogLevel",v)(f=>{(0,D.$5j)(f)?super.setLogLevel(f):super.setLogLevel(s.URI.revive(f[0]),f[1])})),this.B(a.listen("onDidChangeVisibility",v)(([f,c])=>super.setVisibility(s.URI.revive(f),c))),this.B(a.listen("onDidChangeLoggers",v)(({added:f,removed:c})=>{for(const d of f)super.registerLogger({...d,resource:s.URI.revive(d.resource)});for(const d of c)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new D.$_j({log:(v,b)=>{this.t.call("consoleLog",[v,b])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,b){super.setLogLevel(v,b),this.t.call("setLogLevel",[v,b])}setVisibility(v,b){super.setVisibility(v,b),this.t.call("setVisibility",[this.n(v),b])}s(v,b,m){return new S(this.t,v,b,m,this.r)}static setLogLevel(v,b,m){return v.call("setLogLevel",[b,m])}}e.$as=I;class S extends D.$9j{constructor(v,b,m,u,a){super(u?.logLevel==="always"),this.r=v,this.s=b,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[b,u,a]).then(()=>{this.u(this.n),this.m=!0})}g(v,b){const m=[[v,b]];this.m?this.u(m):this.n.push(...m)}u(v){this.r.call("log",[this.s,v])}}class w{constructor(v,b){this.a=v,this.b=b}listen(v,b){const m=this.b(v);switch(b){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,u=>({added:[...u.added].map(a=>this.c(a,m)),removed:[...u.removed].map(a=>this.c(a,m))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,u=>[m.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,u=>(0,D.$5j)(u)?u:[m.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${b}`)}async call(v,b,m){const u=this.b(v);switch(b){case"setLogLevel":return(0,D.$5j)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(s.URI.revive(u.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(a=>this.c(a,u)))}throw new Error(`Call not found: ${b}`)}c(v,b){return{...v,resource:b.transformOutgoingURI(v.resource)}}}e.$bs=w;class g extends k.$Vc{constructor(v,b){super(),b.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(m=>b.call("setLogLevel",[m]))),b.call("getRegisteredLoggers").then(m=>{for(const u of m)v.registerLogger({...u,resource:s.URI.revive(u.resource)})}),this.B(b.listen("onDidChangeVisibility")(([m,u])=>v.setVisibility(s.URI.revive(m),u))),this.B(b.listen("onDidChangeLoggers")(({added:m,removed:u})=>{for(const a of m)v.registerLogger({...a,resource:s.URI.revive(a.resource)});for(const a of u)v.deregisterLogger(a.resource)}))}}e.$cs=g}),define(ye[116],Ee([1,0,2,12]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WQ=void 0;class D extends s.$Vc{constructor(I,S=[]){super(),this.a=new C.$ak([I,...S]),this.B(I.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...S){this.a.trace(I,...S)}debug(I,...S){this.a.debug(I,...S)}info(I,...S){this.a.info(I,...S)}warn(I,...S){this.a.warn(I,...S)}error(I,...S){this.a.error(I,...S)}flush(){this.a.flush()}}e.$WQ=D}),define(ye[241],Ee([1,0,16,12]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LQ=void 0;var D;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(D||(D={}));async function k(g,y,v,b,m){try{const u=await new Promise((f,c)=>{ue(["@vscode/spdlog"],f,c)});u.setFlushOn(D.Trace);const a=await u.createAsyncRotatingLogger(g,y,v,b);return m?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(u){console.error(u)}return null}function I(g,y,v){switch(y){case C.LogLevel.Trace:g.trace(v);break;case C.LogLevel.Debug:g.debug(v);break;case C.LogLevel.Info:g.info(v);break;case C.LogLevel.Warning:g.warn(v);break;case C.LogLevel.Error:g.error(v);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(g,y){switch(y){case C.LogLevel.Trace:g.setLevel(D.Trace);break;case C.LogLevel.Debug:g.setLevel(D.Debug);break;case C.LogLevel.Info:g.setLevel(D.Info);break;case C.LogLevel.Warning:g.setLevel(D.Warning);break;case C.LogLevel.Error:g.setLevel(D.Error);break;case C.LogLevel.Off:g.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class w extends C.$9j{constructor(y,v,b,m,u){super(),this.m=[],this.setLevel(u),this.n=this.s(y,v,b,m),this.B(this.onDidChangeLogLevel(a=>{this.r&&S(this.r,a)}))}async s(y,v,b,m){const u=b?6:1,a=30/u*s.$yl.MB,f=await k(y,v,a,u,m);if(f){this.r=f,S(this.r,this.getLevel());for(const{level:c,message:d}of this.m)I(this.r,c,d);this.m=[]}}g(y,v){this.r?I(this.r,y,v):this.getLevel()<=y&&this.m.push({level:y,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$LQ=w}),define(ye[117],Ee([1,0,22,12,241]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=void 0;class k extends C.$bk{s(S,w,g){return new D.$LQ((0,s.$Sg)(),S.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,w)}}e.$MQ=k}),define(ye[242],Ee([1,0,65,204,5]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(k||(e.MarkerTag=k={}));var I;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(I||(e.MarkerSeverity=I={})),function(w){function g(u,a){return a-u}w.compare=g;const y=Object.create(null);y[w.Error]=(0,C.localize)(0,null),y[w.Warning]=(0,C.localize)(1,null),y[w.Info]=(0,C.localize)(2,null);function v(u){return y[u]||""}w.toString=v;function b(u){switch(u){case s.default.Error:return w.Error;case s.default.Warning:return w.Warning;case s.default.Info:return w.Info;case s.default.Ignore:return w.Hint}}w.fromSeverity=b;function m(u){switch(u){case w.Error:return s.default.Error;case w.Warning:return s.default.Warning;case w.Info:return s.default.Info;case w.Hint:return s.default.Ignore}}w.toSeverity=m}(I||(e.MarkerSeverity=I={}));var S;(function(w){const g="";function y(b){return v(b,!0)}w.makeKey=y;function v(b,m){const u=[g];return b.source?u.push(b.source.replace("\xA6","\\\xA6")):u.push(g),b.code?typeof b.code=="string"?u.push(b.code.replace("\xA6","\\\xA6")):u.push(b.code.value.replace("\xA6","\\\xA6")):u.push(g),b.severity!==void 0&&b.severity!==null?u.push(I.toString(b.severity)):u.push(g),b.message&&m?u.push(b.message.replace("\xA6","\\\xA6")):u.push(g),b.startLineNumber!==void 0&&b.startLineNumber!==null?u.push(b.startLineNumber.toString()):u.push(g),b.startColumn!==void 0&&b.startColumn!==null?u.push(b.startColumn.toString()):u.push(g),b.endLineNumber!==void 0&&b.endLineNumber!==null?u.push(b.endLineNumber.toString()):u.push(g),b.endColumn!==void 0&&b.endColumn!==null?u.push(b.endColumn.toString()):u.push(g),u.push(g),u.join("\xA6")}w.makeKeyOptionalMessage=v})(S||(e.IMarkerData=S={})),e.$8t=(0,D.$wi)("markerService")}),define(ye[70],Ee([1,0,6,41,2,5]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=void 0,e.$fo=(0,k.$wi)("policy");class I extends D.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new s.$ee),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const y=Object.keys(this.f).length;return this.f={...g,...this.f},y!==Object.keys(this.f).length&&await this.j(g),C.Iterable.reduce(this.g.entries(),(v,[b,m])=>({...v,[b]:m}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(g,[y,v])=>({...g,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.$go=I;class S{constructor(){this.onDidChange=s.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ho=S}),define(ye[58],Ee([1,0,31]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const k=D.context.configuration();if(k)C=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,s.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:k.version})}Object.assign(C,{extensionsGallery:s.env.EXTENSIONS_GALLERY?JSON.parse(s.env.EXTENSIONS_GALLERY):C.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:s.env.CS_TELEMETRY_URL||C.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else C={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.89.0",sha256:"2abd9c01f711c0d60d40b722b5bed0930701be173931f3c6251906f692858221",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.89.0",commit:"0f4791b816c184b612df3bdcfc4e1f9f1a13daca",date:"2024-05-07T19:36:19.411Z"},Object.keys(C).length===0&&Object.assign(C,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ye[29],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,s.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(ye[36],Ee([1,0,98,10]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0;class D{constructor(){this.a=new Map}add(I,S){s.ok(C.$9f(I)),s.ok(C.$$f(S)),s.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,S)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$do=new D}),define(ye[243],Ee([1,0,6,36]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=void 0,e.$eo={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class k{constructor(){this.b=new s.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,g){this.a[D(w)]=g,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const I=new k;C.$do.add(e.$eo.JSONContribution,I)}),define(ye[49],Ee([1,0,18,6,10,185,25,243,36]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.ConfigurationScope=e.$io=e.EditPresentationTypes=void 0,e.$to=a,e.$uo=f,e.$vo=c,e.$wo=$,e.$xo=E;var g;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$io={Configuration:"base.contributions.configuration"};var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po="vscode://schemas/settings/resourceLanguage",e.$qo="vscode://schemas/settings/configurationDefaults";const v=w.$do.as(S.$eo.JSONContribution);class b{constructor(){this.h=new Set,this.i=new C.$ee,this.onDidSchemaChange=this.i.event,this.j=new C.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$po,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const l in i)if(o.add(l),e.$so.test(l)){const p=this.a.get(l),P=p?.valuesSources??new Map;if(n)for(const A of Object.keys(i[l]))P.set(A,n);const j={...p?.value||{},...i[l]};this.a.set(l,{source:n,value:j,valuesSources:P});const O=(0,I.$aj)(l),R={type:"object",default:j,description:k.localize(1,null,O),$ref:e.$po,defaultDefaultValue:j,source:D.$9f(n)?void 0:n,defaultValueSource:n};r.push(...a(l)),this.d[l]=R,this.b.properties[l]=R}else{this.a.set(l,{value:i[l],source:n});const p=this.d[l];p&&(this.w(l,p),this.r(l,p))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const l=this.a.get(n),p=D.$9f(i)?i:i?.id,P=D.$9f(l?.source)?l?.source:l?.source?.id;if(p===P)if(o.add(n),this.a.delete(n),e.$so.test(n))delete this.d[n],delete this.b.properties[n];else{const j=this.d[n];j&&(this.w(n,j),this.r(n,j))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const l=this.d[n];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,l){n=D.$fg(t.scope)?n:t.scope;const p=t.properties;if(p)for(const j in p){const O=p[j];if(o&&$(j,O)){delete p[j];continue}if(O.source=r,O.defaultDefaultValue=p[j].default,this.w(j,O),e.$so.test(j)?O.scope=void 0:(O.scope=D.$fg(O.scope)?n:O.scope,O.restricted=D.$fg(O.restricted)?!!i?.includes(j):O.restricted),p[j].hasOwnProperty("included")&&!p[j].included){this.f[j]=p[j],delete p[j];continue}else this.d[j]=p[j],p[j].policy?.name&&this.e.set(p[j].policy.name,j);!p[j].deprecationMessage&&p[j].markdownDeprecationMessage&&(p[j].deprecationMessage=p[j].markdownDeprecationMessage),l.add(j)}const P=t.allOf;if(P)for(const j of P)this.p(j,o,r,i,n,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$jo.properties[t]=o,o.scope){case 1:e.$ko.properties[t]=o;break;case 2:e.$lo.properties[t]=o;break;case 6:e.$mo.properties[t]=o;break;case 3:e.$no.properties[t]=o;break;case 4:e.$oo.properties[t]=o;break;case 5:e.$oo.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$jo.properties[t],o.scope){case 1:delete e.$ko.properties[t];break;case 2:delete e.$lo.properties[t];break;case 6:delete e.$mo.properties[t];break;case 3:delete e.$no.properties[t];break;case 4:case 5:delete e.$oo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.$po};this.w(o,r),e.$jo.properties[o]=r,e.$ko.properties[o]=r,e.$lo.properties[o]=r,e.$mo.properties[o]=r,e.$no.properties[o]=r,e.$oo.properties[o]=r}}v(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.$po};e.$jo.patternProperties[e.$ro]=t,e.$ko.patternProperties[e.$ro]=t,e.$lo.patternProperties[e.$ro]=t,e.$mo.patternProperties[e.$ro]=t,e.$no.patternProperties[e.$ro]=t,e.$oo.patternProperties[e.$ro]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;D.$dg(i)&&(i=o.defaultDefaultValue,n=void 0),D.$dg(i)&&(i=c(o.type)),o.default=i,o.defaultValueSource=n}}const m="\\[([^\\]]+)\\]",u=new RegExp(m,"g");e.$ro=`^(${m})+$`,e.$so=new RegExp(e.$ro);function a(h){const t=[];if(e.$so.test(h)){let o=u.exec(h);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=u.exec(h)}}return(0,s.$Mb)(t)}function f(h){return h.reduce((t,o)=>`${t}[${o}]`,"")}function c(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new b;w.$do.add(e.$io.Configuration,d);function $(h,t){return h.trim()?e.$so.test(h)?k.localize(7,null,h):d.getConfigurationProperties()[h]!==void 0?k.localize(8,null,h):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,h,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}function E(){const h=[],t=d.getConfigurationProperties();for(const o of Object.keys(t))h.push([o,t[o].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(ye[118],Ee([1,0,18,6,43,2,24,21,10,4,25,49,36]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$Co=$;function m(o){return Object.isFrozen(o)?o:S.$5n(o)}class u{static createEmptyModel(r){return new u({},[],[],void 0,r)}constructor(r,i,n,l,p){this.b=r,this.c=i,this.d=n,this.raw=l,this.f=p,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof u)return i;const n=new a("",this.f);return n.parseRaw(i),n.configurationModel});this.g=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$$i)(this.contents,r):this.contents}inspect(r,i){const n=this;return{get value(){return m(n.rawConfiguration.getValue(r))},get override(){return i?m(n.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return m(i?n.rawConfiguration.override(i).getValue(r):n.rawConfiguration.getValue(r))},get overrides(){const l=[];for(const{contents:p,identifiers:P,keys:j}of n.rawConfiguration.overrides){const O=new u(p,j,[],void 0,n.f).getValue(r);O!==void 0&&l.push({identifiers:P,value:O})}return l.length?m(l):void 0}}}getOverrideValue(r,i){const n=this.j(i);return n?r?(0,y.$$i)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return s.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return s.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.h(r),this.a.set(r,i)),i}merge(...r){const i=S.$4n(this.contents),n=S.$4n(this.overrides),l=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const P of r)if(p.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const j of P.overrides){const[O]=n.filter(R=>s.$ub(R.identifiers,j.identifiers));O?(this.i(O.contents,j.contents),O.keys.push(...j.keys),O.keys=s.$Mb(O.keys)):n.push(S.$4n(j))}for(const j of P.keys)l.indexOf(j)===-1&&l.push(j)}return new u(i,l,n,p.every(P=>P instanceof u)?void 0:p,this.f)}h(r){const i=this.j(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const l of s.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[l];const P=i[l];P&&(typeof p=="object"&&typeof P=="object"?(p=S.$4n(p),this.i(p,P)):p=P),n[l]=p}return new u(n,this.keys,this.overrides,void 0,this.f)}i(r,i){for(const n of Object.keys(i)){if(n in r&&w.$$f(r[n])&&w.$$f(i[n])){this.i(r[n],i[n]);continue}r[n]=S.$4n(i[n])}}j(r){let i=null,n=null;const l=p=>{p&&(n?this.i(n,p):n=S.$4n(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?i=p.contents:p.identifiers.includes(r)&&l(p.contents);return l(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.k(r,i,!0)}setValue(r,i){this.k(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,y.$0i)(this.contents,r),v.$so.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>s.$ub(n.identifiers,(0,v.$to)(r))),1))}k(r,i,n){(0,y.$9i)(this.contents,r,i,l=>this.f.error(l)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$so.test(r)&&this.overrides.push({identifiers:(0,v.$to)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$8i)(this.contents[r],l=>this.f.error(l))})}}e.$yo=u;class a{constructor(r,i){this.f=r,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||u.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!w.$fg(r)){const n=this.h(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:l,overrides:p,restricted:P,hasExcludedProperties:j}=this.i(r,i);this.b=new u(n,l,p,j?[r]:void 0,this.g),this.c=P||[]}h(r){let i={},n=null,l=[];const p=[],P=[];function j(R){Array.isArray(l)?l.push(R):n!==null&&(l[n]=R)}const O={onObjectBegin:()=>{const R={};j(R),p.push(l),l=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const R=[];j(R),p.push(l),l=R,n=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:j,onError:(R,A,B)=>{P.push({error:R,offset:A,length:B})}};if(r)try{D.$Rn(r,O),i=l[0]||{}}catch(R){this.g.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}i(r,i){const n=b.$do.as(v.$io.Configuration).getConfigurationProperties(),l=this.j(r,n,!0,i);r=l.raw;const p=(0,y.$8i)(r,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`)),P=Object.keys(r),j=this.l(r,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:p,keys:P,overrides:j,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(r,i,n,l){let p=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const P={},j=[];for(const O in r)if(v.$so.test(O)&&n){const R=this.j(r[O],i,!1,l);P[O]=R.raw,p=p||R.hasExcludedProperties,j.push(...R.restricted)}else{const R=i[O],A=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&j.push(O),!l.exclude?.includes(O)&&(l.include?.includes(O)||(A===void 0||l.scopes===void 0||l.scopes.includes(A))&&!(l.skipRestricted&&R?.restricted))?P[O]=r[O]:p=!0}return{raw:P,restricted:j,hasExcludedProperties:p}}l(r,i){const n=[];for(const l of Object.keys(r))if(v.$so.test(l)){const p={};for(const P in r[l])p[P]=r[l][P];n.push({identifiers:(0,v.$to)(l),keys:Object.keys(p),contents:(0,y.$8i)(p,i)})}return n}}e.$zo=a;class f extends k.$Vc{constructor(r,i,n,l,p){super(),this.c=r,this.f=i,this.g=l,this.h=p,this.b=this.B(new C.$ee),this.onDidChange=this.b.event,this.a=new a(this.c.toString(),p),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&n.isEqual(P.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return u.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ao=f;class c{constructor(r,i,n,l,p,P,j,O,R,A,B,G,se){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=l,this.d=p,this.f=P,this.g=j,this.h=O,this.i=R,this.j=A,this.k=B,this.l=G,this.m=se}get value(){return m(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(r,i,n,l,p,P,j,O,R,A){this.j=r,this.l=i,this.m=n,this.n=l,this.p=p,this.q=P,this.r=j,this.s=O,this.t=R,this.u=A,this.h=null,this.i=new I.$Bc,this.v=null}getValue(r,i,n){return this.w(r,i,n).getValue(r)}updateValue(r,i,n={}){let l;n.resource?(l=this.t.get(n.resource),l||(l=u.createEmptyModel(this.u),this.t.set(n.resource,l))):l=this.s,i===void 0?l.removeValue(r):l.setValue(r,i),n.resource||(this.h=null)}inspect(r,i,n){const l=this.w(r,i,n),p=this.A(i.resource,n),P=i.resource?this.t.get(i.resource)||this.s:this.s,j=new Set;for(const O of l.overrides)for(const R of O.identifiers)l.getOverrideValue(r,R)!==void 0&&j.add(R);return new c(r,i,l.getValue(r),j.size?[...j]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.q:void 0,p||void 0,P)}keys(r){const i=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,i){this.r.set(r,i),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:l,updated:p,removed:P}=h(this.j,r);i=[...l,...p,...P]}for(const l of i)for(const p of(0,v.$to)(l)){const P=this.j.getKeysForOverrideIdentifier(p),j=r.getKeysForOverrideIdentifier(p),O=[...j.filter(R=>P.indexOf(R)===-1),...P.filter(R=>j.indexOf(R)===-1),...P.filter(R=>!S.$8n(this.j.override(p).getValue(R),r.override(p).getValue(R)))];n.push([p,O])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:l}=h(this.l,r),p=[...i,...n,...l];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:l,overrides:p}=h(this.applicationConfiguration,r),P=[...i,...n,...l];return P.length&&this.updateApplicationConfiguration(r),{keys:P,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:l,overrides:p}=h(this.localUserConfiguration,r),P=[...i,...n,...l];return P.length&&this.updateLocalUserConfiguration(r),{keys:P,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:l,overrides:p}=h(this.remoteUserConfiguration,r),P=[...i,...n,...l];return P.length&&this.updateRemoteUserConfiguration(r),{keys:P,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:l,overrides:p}=h(this.workspaceConfiguration,r),P=[...i,...n,...l];return P.length&&this.updateWorkspaceConfiguration(r),{keys:P,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:l,updated:p,removed:P,overrides:j}=h(n,i),O=[...l,...p,...P];return(O.length||!n)&&this.updateFolderConfiguration(r,i),{keys:O,overrides:j}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:l,removed:p,overrides:P}=h(i,void 0);return{keys:[...n,...l,...p],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,i,n){let l=this.x(i,n);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(l=l.merge(this.l)),l}x({resource:r},i){let n=this.y();if(i&&r){const l=i.getFolder(r);l&&(n=this.z(l.uri)||n);const p=this.t.get(r);p&&(n=n.merge(p))}return n}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let i=this.i.get(r);if(!i){const n=this.y(),l=this.r.get(r);l?(i=n.merge(l),this.i.set(r,i)):i=n}return i}A(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.r.get(n.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,i)=>{const{contents:n,overrides:l,keys:p}=this.r.get(i);return r.push([i,{contents:n,overrides:l,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.q.keys.forEach(i=>r.add(i)),this.r.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}D(r){const i=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.q.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.r.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r,i){const n=this.E(r.defaults,i),l=this.E(r.policy,i),p=this.E(r.application,i),P=this.E(r.user,i),j=this.E(r.workspace,i),O=r.folders.reduce((R,A)=>(R.set(g.URI.revive(A[0]),this.E(A[1],i)),R),new I.$Bc);return new d(n,l,p,P,u.createEmptyModel(i),j,O,u.createEmptyModel(i),new I.$Bc,i)}static E(r,i){return new u(r.contents,r.keys,r.overrides,void 0,i)}}e.$Bo=d;function $(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const l of o)l.keys.forEach(p=>r.add(p)),l.overrides.forEach(([p,P])=>{const j=(0,I.$yc)(i,p,new Set);P.forEach(O=>j.add(O))});const n=[];return i.forEach((l,p)=>n.push([p,[...l.values()]])),{keys:[...r.values()],overrides:n}}class E{constructor(r,i,n,l,p){this.change=r,this.f=i,this.g=n,this.h=l,this.i=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of r.keys)this.affectedKeys.add(P);for(const[,P]of r.overrides)for(const j of P)this.affectedKeys.add(j);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,i){const n=this.a+r,l=this.d.indexOf(n);if(l<0)return!1;const p=l+n.length;if(p>=this.d.length)return!1;const P=this.d.charCodeAt(p);if(P!==this.b&&P!==this.c)return!1;if(i){const j=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,O=this.g.getValue(r,i,this.h);return!S.$8n(j,O)}return!0}}e.$Do=E;function h(o,r){const{added:i,removed:n,updated:l}=t(r?.rawConfiguration,o?.rawConfiguration),p=[],P=o?.getAllOverrideIdentifiers()||[],j=r?.getAllOverrideIdentifiers()||[];if(r){const O=j.filter(R=>!P.includes(R));for(const R of O)p.push([R,r.getKeysForOverrideIdentifier(R)])}if(o){const O=P.filter(R=>!j.includes(R));for(const R of O)p.push([R,o.getKeysForOverrideIdentifier(R)])}if(r&&o){for(const O of P)if(j.includes(O)){const R=t({contents:o.getOverrideValue(void 0,O)||{},keys:o.getKeysForOverrideIdentifier(O)},{contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)});p.push([O,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:l,overrides:p}}function t(o,r){const i=o?r?o.keys.filter(p=>r.keys.indexOf(p)===-1):[...o.keys]:[],n=r?o?r.keys.filter(p=>o.keys.indexOf(p)===-1):[...r.keys]:[],l=[];if(o&&r){for(const p of r.keys)if(o.keys.indexOf(p)!==-1){const P=(0,y.$$i)(r.contents,p),j=(0,y.$$i)(o.contents,p);S.$8n(P,j)||l.push(p)}}return{added:i,removed:n,updated:l}}}),define(ye[244],Ee([1,0,18,6,2,21,10,118,49,12,70,36]),function(ue,e,s,C,D,k,I,S,w,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=void 0;class b extends D.$Vc{get configurationModel(){return this.b}constructor(f){super(),this.c=f,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=S.$yo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$do.as(w.$io.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:c})=>this.f(Array.from(f),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(f,c){this.j(f,v.$do.as(w.$io.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}g(){return{}}h(){this.b=S.$yo.createEmptyModel(this.c);const f=v.$do.as(w.$io.Configuration).getConfigurationProperties();this.j(Object.keys(f),f)}j(f,c){const d=this.g();for(const $ of f){const E=d[$],h=c[$];E!==void 0?this.b.addValue($,E):h?this.b.addValue($,h.default):this.b.removeValue($)}}}e.$Eo=b;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=S.$yo.createEmptyModel(new g.$dk)}async initialize(){return this.configurationModel}}e.$Fo=m;let u=class extends D.$Vc{get configurationModel(){return this.b}constructor(f,c,d){super(),this.c=f,this.f=c,this.g=d,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=S.$yo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.j(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.m(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const c={},d=[],$=v.$do.as(w.$io.Configuration).getConfigurationProperties();for(const E of f){const h=$[E];if(!h){d.push(E);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}d.push(E),c[h.policy.name]={type:h.type}}}return(0,I.$jg)(c)||await this.f.updatePolicyDefinitions(c),d}j(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const c=v.$do.as(w.$io.Configuration).getPolicyConfigurations(),d=(0,s.$Hb)(f.map($=>c.get($)));this.m(d,!0)}m(f,c){this.g.trace("PolicyConfiguration#update",f);const d=v.$do.as(w.$io.Configuration).getConfigurationProperties(),$=[],E=this.b.isEmpty();for(const h of f){const t=d[h]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(E?o!==void 0:!(0,k.$8n)(this.b.getValue(h),o))&&$.push([h,o])}else this.b.getValue(h)!==void 0&&$.push([h,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const h=this.b;this.b=S.$yo.createEmptyModel(this.g);for(const t of h.keys)this.b.setValue(t,h.getValue(t));for(const[t,o]of $)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);c&&this.a.fire(this.b)}}};e.$Go=u,e.$Go=u=Fe([Ne(1,y.$fo),Ne(2,g.$3j)],u)}),define(ye[119],Ee([1,0,18,14,15,6,43,149,2,24,21,3,19,25,118,49,244,70]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=void 0;class d extends w.$Vc{constructor(h,t,o,r){super(),this.m=h,this.n=r,this.h=this.B(new k.$ee),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Eo(r)),this.c=o instanceof c.$ho?new f.$Fo:this.B(new f.$Go(this.b,o,r)),this.f=this.B(new u.$Ao(this.m,{},b.$1g,t,r)),this.a=new u.$Bo(this.b.configurationModel,this.c.configurationModel,u.$yo.createEmptyModel(r),u.$yo.createEmptyModel(r),u.$yo.createEmptyModel(r),u.$yo.createEmptyModel(r),new g.$Bc,u.$yo.createEmptyModel(r),new g.$Bc,r),this.j=new $(h,t,this),this.g=this.B(new C.$Ih(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:n})=>this.s(i,n))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$Bo(h,t,u.$yo.createEmptyModel(this.n),o,u.$yo.createEmptyModel(this.n),u.$yo.createEmptyModel(this.n),new g.$Bc,u.$yo.createEmptyModel(this.n),new g.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,t){const o=typeof h=="string"?h:void 0,r=(0,m.$4i)(h)?h:(0,m.$4i)(t)?t:{};return this.a.getValue(o,r,void 0)}async updateValue(h,t,o,r,i){const n=(0,m.$5i)(o)?o:(0,m.$4i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,l=n?r:o;if(l!==void 0&&l!==3&&l!==2)throw new Error(`Unable to write ${h} to target ${l}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,s.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const p=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(p.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,y.$8n)(t,p.defaultValue)&&(t=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const j=n.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(R=>(0,s.$ub)([...R.identifiers].sort(),j));O&&(n.overrideIdentifiers=O.identifiers)}const P=n?.overrideIdentifiers?.length?[(0,a.$uo)(n.overrideIdentifiers),h]:[h];await this.j.write(P,t),await this.reloadConfiguration()}inspect(h,t={}){return this.a.inspect(h,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(o,t,2)}s(h,t){const o=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,t);this.u(r,o,7)}t(h){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(h);this.u(o,t,7)}u(h,t,o){const r=new u.$Do(h,{data:t},this.a,void 0,this.n);r.source=o,this.h.fire(r)}}e.$Ho=d;class ${constructor(h,t,o){this.b=h,this.c=t,this.d=o,this.a=new C.$Dh}write(h,t){return this.a.queue(()=>this.e(h,t))}async e(h,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)o="{}";else throw n}const r=[];if((0,I.$Kn)(o,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(o,h,t);o=(0,S.$3n)(o,i),await this.c.writeFile(this.b,D.$Ge.fromString(o))}f(h,t,o){const{tabSize:r,insertSpaces:i,eol:n}=this.h;if(!t.length){const l=JSON.stringify(o,null,i?" ".repeat(r):"	");return[{content:l,length:l.length,offset:0}]}return(0,S.$Zn)(h,t,o,{tabSize:r,insertSpaces:i,eol:n})}get h(){if(!this.g){let h=v.OS===3||v.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(h=t),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ye[120],Ee([1,0,11,5]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=g,e.$Hl=(0,C.$wi)("remoteAuthorityResolverService");var D;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class k{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=k;class I{constructor(v,b){this.host=v,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=I;var S;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class w extends s.$bb{static isNotAvailable(v){return v instanceof w&&v._code===S.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof w&&v._code===S.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof w&&v._code===S.NoResolverFound}static isInvalidAuthority(v){return v instanceof w&&v._code===S.InvalidAuthority}static isHandled(v){return v instanceof w&&v.isHandled}constructor(v,b=S.Unknown,m){super(v),this._message=v,this._code=b,this._detail=m,this.isHandled=b===S.NotAvailable&&m===!0,Object.setPrototypeOf(this,w.prototype)}}e.$Kl=w;function g(y){const v=y.indexOf("+");return v===-1?y:y.substring(0,v)}}),define(ye[245],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=e.$YQ=void 0,e.$YQ=(0,s.$wi)("IRemoteExtensionsScannerService"),e.$ZQ="remoteExtensionsScanner"}),define(ye[86],Ee([1,0,13]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=C,e.$Jm=D,e.$Km=k,e.$Lm=I;function C(w){return w.scheme===s.Schemas.vscodeRemote?w.authority:void 0}function D(w){if(!w)return;const g=w.indexOf("+");return g<0?w:w.substr(0,g)}function k(w){const{host:g,port:y}=S(w);if(typeof y>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:y}}function I(w,g){let{host:y,port:v}=S(w);return typeof v>"u"&&(v=g),{host:y,port:v}}function S(w){const g=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const y=w.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=w.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:w,port:void 0}}}),define(ye[40],Ee([1,0,17,5,86]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Um=e.$Tm=e.$Sm=e.TargetPlatform=e.ExtensionType=e.$Rm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0,e.$Qm=k,e.$Vm=v,e.$Wm=b,e.$Xm=m,e.$Ym=u,e.$Mm="extensions.user.cache",e.$Nm="extensions.builtin.cache",e.$Om="undefined_publisher",e.$Pm=["ui","workspace","web"];function k(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Rm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var I;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(I||(e.ExtensionType=I={}));var S;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class w{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,c){if(typeof f>"u"||f===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof f=="string"||typeof c=="string"){const d=typeof f=="string"?f:f.value,$=typeof c=="string"?c:c.value;return s.$yf(d,$)}return f._lower===c._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Sm=w;class g{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const c of f)this.add(c)}add(f){this.c.add(w.toKey(f))}delete(f){return this.c.delete(w.toKey(f))}has(f){return this.c.has(w.toKey(f))}}e.$Tm=g;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(w.toKey(f))}get(f){return this.c.get(w.toKey(f))}has(f){return this.c.has(w.toKey(f))}set(f,c){this.c.set(w.toKey(f),c)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Um=y;function v(a){return b(a)}function b(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function m(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function u(a,f){if(f){const c=`onResolveRemoteAuthority:${(0,D.$Jm)(f)}`;return!!a.activationEvents?.includes(c)}return!1}e.$Zm=(0,C.$wi)("IBuiltinExtensionsScannerService")}),define(ye[246],Ee([1,0,2,40,16]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class k extends s.$Vc{constructor(S,w,g,y,v){super(),this.a=S,this.b=w,this.c=g,this.f=v,this.B(y.onDidInstallExtensions(b=>this.g(b))),this.B(y.onDidUninstallExtension(b=>this.h(b)))}g(S){for(const w of S)w.local&&this.invalidate(w.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,S)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,C.$Mm))}catch(w){(0,D.$hl)(w)!==1&&this.f.error(w)}}}e.$Cq=k}),define(ye[42],Ee([1,0,15,11,2,205,49,5,12,36]),function(ue,e,s,C,D,k,I,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0,e.$Qp=b,e.$Rp=m,e.$Sp=u,e.$Tp=a,e.$Up=f,e.$Vp=c,e.$Op=(0,S.$wi)("requestService");class y{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class v extends D.$Vc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,k.localize)(0,null),when:w.$ik.isEqualTo((0,w.$fk)(w.LogLevel.Trace)).serialize()})}async c(h,t,o){const r=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,C.$0)(i)),i}}}e.$Pp=v;function b(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function m(E){return E.res.statusCode===204}async function u(E){return m(E)?null:(await(0,s.$Se)(E.stream)).toString()}async function a(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);return u(E)}async function f(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);if(m(E))return null;const t=(await(0,s.$Se)(E.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function c(E){$(E)}let d;function $(E){const h=g.$do.as(I.$io.Configuration),t=d;d={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(6,null),(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null)],default:"override",description:(0,k.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[d],remove:t?[t]:[]})}$(1)}),define(ye[247],Ee([1,0,20,13,16,42]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;let I=class{constructor(w,g){this.a=w,this.b=g}async download(w,g,y=s.CancellationToken.None){if(w.scheme===C.Schemas.file||w.scheme===C.Schemas.vscodeRemote){await this.b.copy(w,g);return}const v={type:"GET",url:w.toString(!0)},b=await this.a.request(v,y);if(b.res.statusCode===200)await this.b.writeFile(g,b.stream);else{const m=await(0,k.$Tp)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${m}`)}}};e.$dR=I,e.$dR=I=Fe([Ne(0,k.$Op),Ne(1,D.$3k)],I)}),define(ye[248],Ee([1,0,15,20]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=void 0;class D{constructor(S){this.a=S}listen(S,w){throw new Error("Invalid listen")}call(S,w,g,y=C.CancellationToken.None){switch(w){case"request":return this.a.request(g[0],y).then(async({res:v,stream:b})=>{const m=await(0,s.$Se)(b);return[{statusCode:v.statusCode,headers:v.headers},m]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Vr=D;class k{constructor(S){this.a=S}async request(S,w){const[g,y]=await this.a.call("request",[S],w);return{res:g,stream:(0,s.$Ue)(y)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Wr=k}),define(ye[249],Ee([1,0,87,10]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=k;function D(I,S){return I.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:I.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function k(I,S,w={}){const g=(0,s.parse)(I),y=w.proxyUrl||D(g,S);if(!y)return null;const v=(0,s.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,C.$cg)(w.strictSSL)?w.strictSSL:!0,keepAlive:!0};return g.protocol==="http:"?new(await new Promise((m,u)=>{ue(["http-proxy-agent"],m,u)})).HttpProxyAgent(y,b):new(await new Promise((m,u)=>{ue(["https-proxy-agent"],m,u)})).HttpsProxyAgent(y,b)}}),define(ye[88],Ee([1,0,56,7,206,20,39,11,3,22,107,224,14,152]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=a;let u;async function a(c,d,$,E){return $["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$c?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Bm)(E)&&!$["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Bm)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=b.Promises.withAsyncBody(async(h,t)=>{const o=new k.$pe;let r=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,m.$Cm)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,D.localize)(0,null)))},r);try{h(await f(d,o.token))}catch(l){!(0,S.$4)(l)&&!o.token.isCancellationRequested?t(new Error((0,D.localize)(1,null,(0,I.$hj)(l)))):h({})}finally{clearTimeout(n),o.dispose()}})),u)}async function f(c,d){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",E);const h=(0,g.$Sg)().replace(/-/g,"").substr(0,12),t=new RegExp(h+"({.*})"+h),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",o);const r=await(0,y.$rm)(w.OS,o);return c.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(d.isCancellationRequested)return n(new S.$5);const l=(0,C.$oc)(r);let p,P;const j="";/^pwsh(-preview)?$/.test(l)?(p=`& '${process.execPath}' ${j} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,P=["-Login","-Command"]):l==="nu"?(p=`^'${process.execPath}' ${j} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,P=["-i","-l","-c"]):l==="xonsh"?(p=`import os, json; print("${h}", json.dumps(dict(os.environ)), "${h}")`,P=["-i","-l","-c"]):(p=`'${process.execPath}' ${j} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,l==="tcsh"||l==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),p);const O=(0,s.spawn)(r,[...P,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(O.kill(),n(new S.$5))),O.on("error",B=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,I.$hj)(B)),n(B)});const R=[];O.stdout.on("data",B=>R.push(B));const A=[];O.stderr.on("data",B=>A.push(B)),O.on("close",(B,G)=>{const se=Buffer.concat(R).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const ce=Buffer.concat(A).toString("utf8");if(ce.trim()&&c.trace("getUnixShellEnvironment#stderr",ce),B||G)return n(new Error((0,D.localize)(2,null,B,G)));const ee=t.exec(se),K=ee?ee[1]:"{}";try{const q=JSON.parse(K);$?q.ELECTRON_RUN_AS_NODE=$:delete q.ELECTRON_RUN_AS_NODE,E?q.ELECTRON_NO_ATTACH_CONSOLE=E:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.VSCODE_RESOLVING_ENVIRONMENT,delete q.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){c.error("getUnixShellEnvironment#errorCaught",(0,I.$hj)(q)),n(q)}})})}}),define(ye[250],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=void 0,e.$NQ=(0,s.$wi)("stateReadService"),e.$OQ=(0,s.$wi)("stateService")}),define(ye[251],Ee([1,0,14,15,2,10,26,16,12]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RQ=e.$QQ=e.$PQ=e.SaveStrategy=void 0;var g;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(g||(e.SaveStrategy=g={}));class y extends D.$Vc{constructor(u,a,f,c){super(),this.h=u,this.j=a,this.m=f,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new s.$uh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==1&&this.m.error(u)}}getItem(u,a){const f=this.a[u];return(0,k.$fg)(f)?a:f}setItem(u,a){this.setItems([{key:u,data:a}])}setItems(u){let a=!1;for(const{key:f,data:c}of u)this.a[f]!==c&&((0,k.$fg)(c)?(0,k.$dg)(this.a[f])||(this.a[f]=void 0,a=!0):(this.a[f]=c,a=!0));a&&this.s()}removeItem(u){(0,k.$dg)(this.a[u])||(this.a[u]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.n.writeFile(this.h,C.$Ge.fromString(u),{atomic:{postfix:".vsctmp"}}),this.b=u}catch(a){this.m.error(a)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$PQ=y;let v=class extends D.$Vc{constructor(u,a,f,c){super(),this.a=this.B(new y(a.stateResource,u,f,c))}async init(){await this.a.init()}getItem(u,a){return this.a.getItem(u,a)}};e.$QQ=v,e.$QQ=v=Fe([Ne(1,I.$Di),Ne(2,w.$3j),Ne(3,S.$3k)],v);class b extends v{setItem(u,a){this.a.setItem(u,a)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.$RQ=b}),define(ye[121],Ee([1,0,3,31,22]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=I,e.$fp=S;function k(w){if(s.$o===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function I(w,g,y,v,b,m,u,a,f){const c=Object.create(null);c["common.machineId"]=m,c["common.sqmId"]=u,c.sessionID=(0,D.$Sg)()+Date.now(),c.commitHash=v,c.version=b,c["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,s.$b)(s.$o),c["common.nodePlatform"]=C.$ec,c["common.nodeArch"]=y,c["common.product"]=f||"desktop",a&&(c["common.msftInternal"]=a);let d=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),s.$f&&(c["common.snap"]="true");const E=k(g);return E&&(c["common.platformDetail"]=E),c}function S(w){const g=C.env.USERDNSDOMAIN;if(!g)return!1;const y=g.toLowerCase();return w.some(v=>y===v)}}),define(ye[252],Ee([1,0,18,11,2,21,16]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var S;(function(g){function y(v,b){return v.callstack<b.callstack?-1:v.callstack>b.callstack?1:0}g.compare=y})(S||(e.ErrorEvent=S={}));class w{constructor(y,v=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new D.$Uc,this.c=y,this.d=v;const b=C.$X.addListener(m=>this.j(m));this.h.add((0,D.$Tc)(b)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(y){if(!y||y.code||(y.detail&&y.detail.stack&&(y=y.detail),C.$bb.isErrorNoTelemetry(y)||y instanceof I.$ll||typeof y?.message=="string"&&y.message.includes("Unable to read file")))return;const v=Array.isArray(y.stack)?y.stack.join(`
`):y.stack,b=y.message?y.message:(0,k.$9n)(y);v&&this.k({msg:b,callstack:v})}k(y){const v=(0,s.$wb)(this.g,y,S.compare);v<0?(y.count=1,this.g.splice(~v,0,y)):(this.g[v].count||(this.g[v].count=0),this.g[v].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const y of this.g)this.c.publicLogError2("UnhandledError",y);this.g.length=0}}w.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=w}),define(ye[253],Ee([1,0,2]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class C extends s.$Vc{constructor(k,I){super(),this.a=k,this.b=I}async call(k,I,S){switch(I){case"updateTelemetryLevel":{const{telemetryLevel:w}=S;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:g}=S;return this.b?this.b.log(w,g):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${I} not found`)}listen(k,I,S){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Qs=C}),define(ye[30],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,s.$wi)("telemetryService"),e.$3l=(0,s.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var C;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(ye[254],Ee([1,0,28,14,43,13,7,3,4,103,23,106,230,16,29,30]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0,e.$Fs=c,e.$Gs=$,e.$Hs=E;const f=new Map;async function c(t,o){const r=`${t}::${o.join(":")}`,i=f.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,p=new Map,P=2e4;function j(R,A,B,G){const se=A.substring(R.length+1);return C.Promises.withAsyncBody(async ce=>{let ee;try{ee=await y.Promises.readdir(A,{withFileTypes:!0})}catch{ce();return}if(G.count>=P){G.count+=ee.length,G.maxReached=!0,ce();return}let K=ee.length;if(K===0){ce();return}let q=ee;G.count+ee.length>P&&(G.maxReached=!0,K=P-G.count,q=ee.slice(0,K)),G.count+=ee.length;for(const X of q)if(X.isDirectory()){if(B.includes(X.name)||await j(R,(0,I.$kc)(A,X.name),B,G),--K===0){ce();return}}else{const _=X.name.lastIndexOf(".");if(_>=0){const M=X.name.substring(_+1);M&&l.set(M,(l.get(M)??0)+1)}for(const M of n)M.relativePathPattern?.test(se)!==!1&&M.filePattern.test(X.name)&&p.set(M.tag,(p.get(M.tag)??0)+1);if(--K===0){ce();return}}})}const O=C.Promises.withAsyncBody(async R=>{const A={count:0,maxReached:!1};await j(t,t,o,A);const B=await E(t);R({configFiles:d(p),fileTypes:d(l),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:B})});return f.set(r,O),O}function d(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function $(){const t={os:`${s.type()} ${s.arch()} ${s.release()}`,memory:`${(s.totalmem()/m.$yl.GB).toFixed(2)}GB (${(s.freemem()/m.$yl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$Fn.value()*100)}%`},o=s.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function E(t){try{const o=new Map,r=(0,I.$kc)(t,".vscode","launch.json"),i=await y.Promises.readFile(r),n=[],l=(0,D.$Kn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,D.$Tn)(l)==="object"&&l.configurations)for(const p of l.configurations){const P=p.type;P&&(o.has(P)?o.set(P,o.get(P)+1):o.set(P,1))}return d(o)}catch{return[]}}let h=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${s.type()} ${s.arch()} ${s.release()}`);const i=s.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(s.totalmem()/m.$yl.GB).toFixed(2)}GB (${(s.freemem()/m.$yl.GB).toFixed(2)}GB free)`),S.$c||r.push(`Load (avg):       ${s.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(g.$Fn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$Es)(o.mainPID),this.k(o)]).then(async i=>{let[n,l]=i,p=this.m(o,n);return r.forEach(P=>{if((0,b.$fn)(P))p+=`
${P.errorMessage}`,l+=`
${P.errorMessage}`;else if(p+=`

Remote: ${P.hostName}`,P.processes&&(p+=`
${this.m(o,P.processes)}`),P.workspaceMetadata){l+=`
|  Remote: ${P.hostName}`;for(const j of Object.keys(P.workspaceMetadata)){const O=P.workspaceMetadata[j];let R=`${O.fileCount} files`;O.maxFilesReached&&(R=`more than ${R}`),l+=`|    Folder (${j}): ${R}`,l+=this.h(O)}}}),{processInfo:p,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:l,cpus:p}=$(),P={os:l,memory:i,cpus:p,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$c||(P.load=`${s.loadavg().map(j=>Math.round(j)).join(", ")}`),S.$e&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(o,r){const i=[];return(0,v.$Es)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(l=>{if((0,b.$fn)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(o,l.processes)),l.workspaceMetadata)for(const p of Object.keys(l.workspaceMetadata)){const P=l.workspaceMetadata[p];let j=`${P.fileCount} files`;P.maxFilesReached&&(j=`more than ${j}`),i.push(`Folder (${p}): ${j}`),i.push(this.h(P))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const l=(O,R)=>{const A=` ${O}(${R})`;n+A.length>60?(r.push(p),p="|                 ",n=p.length):n+=A.length,p+=A};let p="|      File types:";const P=10,j=o.fileTypes.length>P?P:o.fileTypes.length;for(let O=0;O<j;O++){const R=o.fileTypes[O];l(R.name,R.count)}if(r.push(p),o.configFiles.length>=0&&(p="|      Conf files:",n=0,o.configFiles.forEach(O=>{l(O.name,O.count)}),r.push(p)),o.launchConfigFiles.length>0){let O="|      Launch Configs:";o.launchConfigFiles.forEach(R=>{const A=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;O+=A}),r.push(O)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const p=w.URI.revive(l);if(p.scheme===k.Schemas.file){const P=p.fsPath;i.push(c(P,["node_modules",".git"]).then(j=>{let O=`${j.fileCount} files`;j.maxFilesReached&&(O=`more than ${O}`),r.push(`|    Folder (${(0,I.$oc)(P)}): ${O}`),r.push(this.h(j))}).catch(j=>{r.push(`|      Error: Unable to collect workspace stats for folder ${P} (${j.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:p})=>i.set(l,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,l){const p=l===0;let P;p?P=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?P=r.get(n.pid):P=`${"  ".repeat(l)} ${n.name}`;const j=process.platform==="win32"?n.mem:s.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(j/m.$yl.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(n.children)&&n.children.forEach(O=>this.n(o,r,i,O,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=w.URI.revive(i);if(n.scheme!==k.Schemas.file)continue;const l=n.fsPath;try{(await c(l,["node_modules",".git"])).fileTypes.forEach(P=>r.add(P.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=w.URI.revive(r);if(i.scheme!==k.Schemas.file)continue;const n=i.fsPath;try{const l=await c(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Is=h,e.$Is=h=Fe([Ne(0,a.$2l),Ne(1,u.$jk)],h)}),define(ye[89],Ee([1,0,11,5,12,30]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.ExtensionSignatureVerificationCode=e.$aq=void 0,e.$aq=(0,C.$wi)("IExtensionSignatureVerificationService");var I;(function(g){g.None="None",g.RequiredArgumentMissing="RequiredArgumentMissing",g.InvalidArgument="InvalidArgument",g.PackageIsUnreadable="PackageIsUnreadable",g.UnhandledException="UnhandledException",g.SignatureManifestIsMissing="SignatureManifestIsMissing",g.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",g.SignatureIsMissing="SignatureIsMissing",g.SignatureIsUnreadable="SignatureIsUnreadable",g.CertificateIsUnreadable="CertificateIsUnreadable",g.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",g.FileAlreadyExists="FileAlreadyExists",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",g.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",g.Success="Success",g.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",g.SignatureIsInvalid="SignatureIsInvalid",g.SignatureManifestIsInvalid="SignatureManifestIsInvalid",g.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",g.EntryIsMissing="EntryIsMissing",g.EntryIsTampered="EntryIsTampered",g.Untrusted="Untrusted",g.CertificateRevoked="CertificateRevoked",g.SignatureIsNotValid="SignatureIsNotValid",g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(I||(e.ExtensionSignatureVerificationCode=I={}));class S extends Error{constructor(y){super(y),this.code=y}}e.$bq=S;let w=class{constructor(y,v){this.b=y,this.c=v}d(){return this.a||(this.a=new Promise((y,v)=>ue(["@vscode/vsce-sign"],async b=>y(b),v))),this.a}async verify(y,v,b){let m;try{m=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,s.$0)(c)),this.b.info(`Extension signature verification is not done: ${y}`),!1}const u=new Date().getTime();let a;try{a=await m.verify(v,b,this.b.getLevel()===D.LogLevel.Trace)}catch(c){a={code:"UnknownError",didExecute:!1,output:(0,s.$0)(c)}}const f=new Date().getTime()-u;if(this.b.info(`Extension signature verification result for ${y}: ${a.code}. Duration: ${f}ms.`),this.b.trace(`Extension signature verification output for ${y}:
${a.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:y,code:a.code,duration:f,didExecute:a.didExecute}),a.code==="Success")return!0;throw new S(a.code)}};e.$cq=w,e.$cq=w=Fe([Ne(0,D.$3j),Ne(1,k.$2l)],w)}),define(ye[37],Ee([1,0,21,10,86,121,30]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$np=y,e.$op=v,e.$pp=b,e.$qp=m,e.$rp=a,e.$sp=c,e.$tp=d,e.$up=h;class S{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$gp=S;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$hp=w,e.$ip=new w;class g{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$jp=g,e.$kp="telemetry",e.$lp="extensionTelemetryLog",e.$mp={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function v(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function b(t){const o=t.getValue(I.$0l),r=t.getValue(I.$$l);if(t.getValue(I.$_l)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const o={},r={},i={};f(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const l=i[n];typeof l=="number"?r[n]=l:typeof l=="boolean"?r[n]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${l.length}`),o[n]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(o[n]=l)}return{properties:o,measurements:r}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const o=(0,D.$Jm)(t);return u.has(o)?o:"other"}function f(t,o,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const l=t[n],p=i?i+n:n;Array.isArray(l)?o[p]=(0,s.$9n)(l):l instanceof Date?o[p]=l.toISOString():(0,C.$$f)(l)?r<2?f(l,o,r+1,p+"."):o[p]=(0,s.$9n)(l):o[p]=l}}function c(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,k.$fp)(r)||i}function d(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function $(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const P of o)for(;;){const j=P.exec(t);if(!j)break;i.push([j.index,P.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const P=l.exec(t);if(!P)break;const j=i.some(([O,R])=>P.index<R&&O<l.lastIndex);!n.test(P[0])&&!j&&(r+=t.substring(p,P.index)+"<REDACTED: user-file-path>",p=l.lastIndex)}return p<t.length&&(r+=t.substr(p)),r}function E(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function h(t,o){return(0,s.$6n)(t,r=>{if(r instanceof S||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=$(i,o);for(const n of o)i=i.replace(n,"");return i=E(i),i}})}}),define(ye[38],Ee([1,0,17,32,40,3,4,11,31,37]),function(ue,e,s,C,D,k,I,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$wp=void 0,e.$vp=y,e.$xp=u,e.$yp=a,e.$zp=f,e.$Ap=c,e.$Bp=d,e.$Cp=$,e.$Dp=E,e.$Fp=h,e.$Gp=o;function y(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,s.$tf)(r.id,i.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const n=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,n,l)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$wp=b;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(r){const i=m.exec(r);return i&&i[1]?[f(i[1]),i[2]]:[f(r),void 0]}function a(r,i){return`${r}.${i}`}function f(r){return r.toLowerCase()}function c(r,i){return f(a(r??D.$Om,i))}function d(r,i){const n=[],l=p=>{for(const P of n)if(P.some(j=>y(i(j),i(p))))return P;return null};for(const p of r){const P=l(p);P?P.push(p):n.push([p])}return n}function $(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function E(r){return{id:new g.$gp(r.identifier.id),name:new g.$gp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Ep=new D.$Sm("pprice.better-merge");function h(r,i){const n=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const p=l.shift();if(p&&n.every(P=>!y(P.identifier,{id:p}))){const P=r.filter(j=>y(j.identifier,{id:p}));P.length===1&&(n.push(P[0]),l.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(r,i){if(!k.$e)return!1;let n;try{n=(await r.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,S.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),l=(0,C.$3o)(n?"alpine":k.$o,w.$fc);return i.debug("ComputeTargetPlatform:",l),l}}),define(ye[122],Ee([1,0,20,11,13,19,57,4,192,32,38,40]),function(ue,e,s,C,D,k,I,S,w,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;const b=a=>(0,w.localize)(0,null,a),m=(0,w.localize)(1,null,"ms-dotnettools.csharp");let u=class{constructor(f,c,d){this.a=f,this.b=c,this.d=d}get f(){}async listExtensions(f,c,d){let $=await this.b.getInstalled(1,d);const E=v.$Rm.map(t=>t.toLowerCase());if(c&&c!==""){if(E.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(t=>t.manifest.categories?t.manifest.categories.map(r=>r.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),E.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,w.localize)(2,null,this.f)),$=$.sort((t,o)=>t.identifier.id.localeCompare(o.identifier.id));let h;for(const t of $)h!==t.identifier.id&&(h=t.identifier.id,this.a.info(f?`${h}@${t.manifest.version}`:h))}async installExtensions(f,c,d,$){const E=[];try{f.length&&this.a.info(this.f?(0,w.localize)(3,null,this.f):(0,w.localize)(4,null));const h=[],t=[],o=(i,n,l)=>{t.push({id:i,version:n!=="prerelease"?n:void 0,installOptions:{...d,isBuiltin:l,installPreReleaseVersion:n==="prerelease"||d.installPreReleaseVersion}})};for(const i of f)if(i instanceof S.URI)h.push({vsix:i,installOptions:d});else{const[n,l]=(0,y.$xp)(i);o(n,l,!1)}for(const i of c)if(i instanceof S.URI)h.push({vsix:i,installOptions:{...d,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,l]=(0,y.$xp)(i);o(n,l,!0)}const r=await this.b.getInstalled(void 0,d.profileLocation);if(h.length&&await Promise.all(h.map(async({vsix:i,installOptions:n})=>{try{await this.h(i,n,$,r)}catch(l){this.a.error(l),E.push(i.toString())}})),t.length){const i=await this.g(t,r,$);E.push(...i)}}catch(h){throw this.a.error((0,w.localize)(5,null,(0,C.$0)(h))),h}if(E.length)throw new Error((0,w.localize)(6,null,E.join(", ")))}async updateExtensions(f){const c=await this.b.getInstalled(1,f),d=[];for(const t of c)t.identifier.uuid&&d.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,w.localize)(7,null,d.length));const $=await this.d.getExtensions(d,{compatible:!0},s.CancellationToken.None),E=[];for(const t of $)for(const o of c)(0,y.$vp)(o.identifier,t.identifier)&&(0,I.gt)(t.version,o.manifest.version)&&E.push({extension:t,options:{operation:3,installPreReleaseVersion:o.preRelease,profileLocation:f}});if(!E.length){this.a.info((0,w.localize)(8,null));return}this.a.info((0,w.localize)(9,null,E.map(t=>t.extension.identifier.id).join(", ")));const h=await this.b.installGalleryExtensions(E);for(const t of h)t.error?this.a.error((0,w.localize)(10,null,t.identifier.id,(0,C.$0)(t.error))):this.a.info((0,w.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(f,c,d){if(f=f.filter(({id:t,version:o})=>{const r=c.find(i=>(0,y.$vp)(i.identifier,{id:t}));if(r){if(!d&&(!o||o==="prerelease"&&r.preRelease))return this.a.info((0,w.localize)(12,null,t,r.manifest.version,t)),!1;if(o&&r.manifest.version===o)return this.a.info((0,w.localize)(13,null,`${t}@${o}`)),!1}return!0}),!f.length)return[];const $=[],E=[],h=await this.j(f);if(await Promise.all(f.map(async({id:t,version:o,installOptions:r})=>{const i=h.get(t.toLowerCase());if(!i){this.a.error(`${b(o?`${t}@${o}`:t)}
${m}`),$.push(t);return}try{const l=await this.d.getManifest(i,s.CancellationToken.None);if(l&&!this.k(l))return}catch(l){this.a.error(l.message||l.stack||l),$.push(t);return}const n=c.find(l=>(0,y.$vp)(l.identifier,i.identifier));if(n){if(i.version===n.manifest.version){this.a.info((0,w.localize)(14,null,o?`${t}@${o}`:t));return}this.a.info((0,w.localize)(15,null,t,i.version))}r.isBuiltin?this.a.info(o?(0,w.localize)(16,null,t,o):(0,w.localize)(17,null,t)):this.a.info(o?(0,w.localize)(18,null,t,o):(0,w.localize)(19,null,t)),E.push({extension:i,options:{...r,installGivenVersion:!!o}})})),E.length){const t=await this.b.installGalleryExtensions(E);for(const o of t)o.error?(this.a.error((0,w.localize)(20,null,o.identifier.id,(0,C.$0)(o.error))),$.push(o.identifier.id)):this.a.info((0,w.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return $}async h(f,c,d,$){const E=await this.b.getManifest(f);if(!E)throw new Error("Invalid vsix");if(await this.l(E,d,c.profileLocation,$))try{await this.b.install(f,c),this.a.info((0,w.localize)(22,null,(0,k.$7g)(f)))}catch(t){if((0,C.$4)(t))this.a.info((0,w.localize)(23,null,(0,k.$7g)(f)));else throw t}}async j(f){const c=new Map,d=f.some(h=>h.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),E=[];for(const h of f)g.$Vo.test(h.id)&&E.push({...h,preRelease:d});if(E.length){const h=await this.d.getExtensions(E,{targetPlatform:$},s.CancellationToken.None);for(const t of h)c.set(t.identifier.id.toLowerCase(),t)}return c}k(f){return!0}async l(f,c,d,$){if(!c){const E={id:(0,y.$Ap)(f.publisher,f.name)},h=$.find(t=>(0,y.$vp)(E,t.identifier)&&(0,I.gt)(t.manifest.version,f.version));if(h)return this.a.info((0,w.localize)(24,null,h.identifier.id,h.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,c,d){const $=async h=>{if(h instanceof S.URI){const t=await this.b.getManifest(h);return(0,y.$yp)(t.publisher,t.name)}return h},E=[];for(const h of f){const t=await $(h),r=(await this.b.getInstalled(void 0,d)).filter(i=>(0,y.$vp)(i.identifier,{id:t}));if(!r.length)throw new Error(`${this.m(t)}
${m}`);if(r.some(i=>i.type===0)){this.a.info((0,w.localize)(25,null,t));return}if(!c&&r.some(i=>i.isBuiltin)){this.a.info((0,w.localize)(26,null,t));return}this.a.info((0,w.localize)(27,null,t));for(const i of r)await this.b.uninstall(i,{profileLocation:d}),E.push(i);this.f?this.a.info((0,w.localize)(28,null,t,this.f)):this.a.info((0,w.localize)(29,null,t))}}async locateExtension(f){const c=await this.b.getInstalled();f.forEach(d=>{c.forEach($=>{if($.identifier.id===d&&$.location.scheme===D.Schemas.file){this.a.info($.location.fsPath);return}})})}m(f){return this.f?(0,w.localize)(30,null,f,this.f):(0,w.localize)(31,null,f)}};e.$dq=u,e.$dq=u=Fe([Ne(1,g.$0o),Ne(2,g.$7o)],u)}),define(ye[255],Ee([1,0,14,11,2,13,19,57,10,22,23,81,25,26,32,38,89,16,12]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let E=$=class extends D.$Vc{constructor(t,o,r,i,n,l){super(),this.h=o,this.j=r,this.m=i,this.n=n,this.r=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,o,r){await this.g;const i=(0,I.$0g)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,i,l=>this.j.download(t,l,o))}catch(l){throw new u.$8o(l.message,u.ExtensionManagementErrorCode.Download)}let n=!1;if(r&&this.t(t)){const l=await this.u(t);try{n=await this.n.verify(t.identifier.id,i.fsPath,l.fsPath)}catch(p){if(n=p.code,n==="PackageIsInvalidZip"||n==="SignatureArchiveIsInvalidZip"){try{await this.delete(i)}catch(j){this.r.error(j)}throw new u.$8o(v.$hq,u.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(l)}catch(p){this.r.error(p)}}}return{location:i,verificationStatus:n}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,w.$cg)(o)?o:!0}async u(t){await this.g;const o=(0,I.$0g)(this.extensionsDownloadDir,`${this.z(t)}${$.c}`);try{await this.w(t,o,r=>this.j.downloadSignatureArchive(t,r))}catch(r){throw new u.$8o(r.message,u.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(t,o,r){if(await this.h.exists(o))return;if(o.scheme!==k.Schemas.file){await r(o);return}const i=(0,I.$0g)(this.extensionsDownloadDir,`.${(0,g.$Sg)()}`);await this.h.exists(i)||await r(i);try{await y.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,C.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],r=[],i=[];for(const p of t.children)if(p.name.endsWith($.c))i.push(p.resource);else{const P=a.$wp.parse(p.name);P&&r.push([P,p])}const n=(0,a.$Bp)(r,([p])=>p),l=[];for(const p of n)p.sort((P,j)=>S.rcompare(P[0].version,j[0].version)),o.push(...p.slice(1).map(P=>P[1].resource)),l.push(p[0][1]);l.sort((p,P)=>p.mtime-P.mtime),o.push(...l.slice(0,Math.max(0,l.length-this.f)).map(p=>p.resource)),o.push(...i),await s.Promises.settled(o.map(p=>(this.r.trace("Deleting from cache",p.path),this.h.del(p))))}}catch(t){this.r.error(t)}}z(t){return this.f?a.$wp.create(t).toString().toLowerCase():(0,g.$Sg)()}};e.$zq=E,E.c=".sigzip",e.$zq=E=$=Fe([Ne(0,m.$Ei),Ne(1,c.$3k),Ne(2,u.$7o),Ne(3,b.$3i),Ne(4,f.$aq),Ne(5,d.$3j)],E)}),define(ye[256],Ee([1,0,6,2,24,38,40]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class S extends C.$Vc{constructor(g,y,v,b,m,u,a){super(),this.f=g,this.g=y,this.h=v,this.j=b,this.m=m,this.n=u,this.r=a,this.a=this.B(new s.$ee),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new C.$5c),this.s().then(null,f=>a.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(y=>(this.c.set(y.id,(0,C.$Sc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(g){for(const y of g.extensions)this.I(this.L(y.identifier,y.version),g.profileLocation)}async y(g){for(const y of g.extensions){const v=this.L(y.identifier,y.version);g.error?this.J(v,g.profileLocation):this.I(v,g.profileLocation)}}async z(g){for(const y of g.extensions)this.J(this.L(y.identifier,y.version),g.profileLocation)}async C(g){const y=[],v=[];for(const b of g.extensions){const m=this.L(b.identifier,b.version);g.error?this.I(m,g.profileLocation):(this.J(m,g.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),v.push(this.f.scanInstalledExtensionAtLocation(b.location).then(u=>{u?y.push(u):this.r.info("Extension not found at the location",b.location.toString())},u=>this.r.error(u)))))}try{await Promise.all(v),y.length&&await this.H(y)}catch(b){this.r.error(b)}}D(g){for(const y of this.h.profiles)g.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(g){const y=[],v=[],b=await this.j.scanProfileExtensions(g),m=new Set,u=new Set;for(const[a,f]of this.b)f.has(g)&&u.add(a);for(const a of b){const f=this.L(a.identifier,a.version);m.add(f),u.has(f)||(y.push(a.identifier),this.I(f,g))}for(const a of u)if(!m.has(a)){const f=this.M(a);f&&(v.push(f.identifier),this.J(a,g))}(y.length||v.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:g}:void 0,removed:v.length?{extensions:v,profileLocation:g}:void 0})}async G(g){const y=await this.j.scanProfileExtensions(g);for(const v of y)this.I(this.L(v.identifier,v.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,y){let v=this.b.get(g);v||this.b.set(g,v=new D.$Cc(b=>this.m.extUri.getComparisonKey(b))),v.add(y)}J(g,y){const v=this.b.get(g);v&&v.delete(y),v?.size||this.b.delete(g)}L(g,y){return`${I.$Sm.toKey(g.id)}@${y}`}M(g){const[y,v]=(0,k.$xp)(g);return v?{identifier:{id:y},version:v}:void 0}}e.$Dq=S}),define(ye[257],Ee([1,0,228,37]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=D;async function D(k,I,S,w,g,y,v){const b={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${I.nameShort})`};if((0,C.$np)(I,S)&&(0,C.$pp)(w)===3){const m=await(0,s.$8p)(S,g,y);b["X-Market-User-Id"]=m,b["VSCode-SessionId"]=v.machineId||m}return b}}),define(ye[123],Ee([1,0,90,18,14,2,13,7,23,26,32,38,12,85,4]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;let a=class extends m.$Tr{constructor($,E,h,t){super(h),this.h=$,this.j=t,this.g=this.B(new f(E,t)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri($,E){const t=(await this.g.getLanguagePacks())[E];if(!t){this.j.warn(`No language pack found for ${E}`);return}const o=t.translations[$];return o?u.URI.file(o):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),E=Object.keys($).map(h=>{const t=$[h];return{...this.f(h,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((h,t)=>h.label.localeCompare(t.label)),E}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const E=await this.g.getLanguagePacks();Object.keys(E).some(h=>E[h]&&E[h].extensions.some(t=>(0,v.$vp)(t.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(E);return!(0,C.$ub)(Object.keys($),Object.keys(h))}};e.$Ur=a,e.$Ur=a=Fe([Ne(0,y.$0o),Ne(1,g.$Ei),Ne(2,y.$7o),Ne(3,b.$3j)],a);let f=class extends k.$Vc{constructor($,E){super(),this.j=E,this.c={},this.f=(0,S.$kc)($.userDataPath,"languagepacks.json"),this.g=new D.$Dh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(E=>{Object.keys(E).forEach(h=>delete E[h]),this.m(E,...$)}).then(()=>this.c)}m($,...E){for(const h of E)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n($,h);Object.keys($).forEach(h=>this.r($[h]))}n($,E){const h=E.identifier,t=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of t)if(E.location.scheme===I.Schemas.file&&c(o)){let r=$[o.languageId];r||(r={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},$[o.languageId]=r);const i=r.extensions.filter(n=>(0,v.$vp)(n.extensionIdentifier,h))[0];i?i.version=E.manifest.version:r.extensions.push({extensionIdentifier:h,version:E.manifest.version});for(const n of o.translations)r.translations[n.id]=(0,S.$kc)(E.location.fsPath,n.path)}}r($){if($){const E=(0,s.createHash)("md5");for(const h of $.extensions)E.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);$.hash=E.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let E=null;return w.Promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(E=$(h),h)).then(h=>{for(const o of Object.keys(h))h[o]||delete h[o];this.c=h,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),w.Promises.writeFile(this.f,t)}).then(()=>E,h=>this.j.error(h))})}};f=Fe([Ne(0,g.$Ei),Ne(1,b.$3j)],f);function c(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const $ of d.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ye[258],Ee([1,0,164,11,21,37]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function w(y,v,b){const m=await(0,s.$8D)("@microsoft/1ds-core-js","dist/ms.core.js"),u=await(0,s.$8D)("@microsoft/1ds-post-js","dist/ms.post.js"),a=new m.AppInsightsCore,f=new u.PostChannel,c={instrumentationKey:y,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(b){c.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:b};c.extensionConfig[f.identifier]=d}return a.initialize(c,[]),a.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),a}class g{constructor(v,b,m,u,a){this.e=v,this.f=b,this.g=m,this.h=a,this.c=I,this.d=S,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(b=>{v(b)},b=>{(0,C.$1)(b),console.error(b)})}}log(v,b){if(!this.a)return;b=(0,D.$7n)(b,this.g),b=(0,k.$qp)(b);const m=this.f+"/"+v;try{this.i(u=>{u.pluginVersionString=b?.properties.version??"Unknown",u.track({name:m,baseData:{name:m,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$JQ=g}),define(ye[259],Ee([1,0,2,21,3,17,207,25,49,58,29,36,30,37]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;let u=class{constructor(c,d,$){this.k=d,this.l=$,this.d={},this.i=new s.$Uc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,k.$af)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$af)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(b.$0l)||E.affectsConfiguration(b.$_l)||E.affectsConfiguration(b.$$l))&&this.m()}))}setExperimentProperty(c,d){this.d[c]=d}m(){let c=(0,m.$pp)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const $=d.usage?3:d.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,d,$){this.g<d||($=(0,C.$7n)($,this.d),$=(0,m.$up)($,this.j),$=(0,C.$7n)($,this.c),this.b.forEach(E=>E.log(c,$)))}publicLog(c,d){this.n(c,3,d)}publicLog2(c,d){this.publicLog(c,d)}publicLogError(c,d){this.h&&this.n(c,2,d)}publicLogError2(c,d){this.publicLogError(c,d)}};e.$1r=u,u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$1r=u=Fe([Ne(1,S.$3i),Ne(2,y.$jk)],u);function a(){const f=(0,I.localize)(0,null,g.default.nameLong),c=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.$i?"":(0,I.localize)(3,null),$=(0,I.localize)(4,null),E=(0,I.localize)(5,null),h=(0,I.localize)(6,null),t=(0,I.localize)(7,null),o=`
|       | ${$} | ${E} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${f} ${c} ${d}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$do.as(w.$io.Configuration).registerConfiguration({id:b.$9l,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[b.$0l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:a(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$do.as(w.$io.Configuration).registerConfiguration({id:b.$9l,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[b.$_l]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${b.$0l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ye[260],Ee([1,0,25,5,29,30,259,37]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=e.$Os=e.$Ns=void 0;let w=class extends I.$1r{constructor(y,v,b,m){super(y,b,m),this.o=v}publicLog(y,v){if(!(this.o<3))return super.publicLog(y,v)}publicLog2(y,v){return this.publicLog(y,v)}publicLogError(y,v){return this.o<2?Promise.resolve(void 0):super.publicLogError(y,v)}publicLogError2(y,v){return this.publicLogError(y,v)}async updateInjectedTelemetryLevel(y){if(y===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,y):y,this.o===0&&this.dispose()}};e.$Ns=w,e.$Ns=w=Fe([Ne(2,s.$3i),Ne(3,D.$jk)],w),e.$Os=new class extends S.$hp{async updateInjectedTelemetryLevel(){}},e.$Ps=(0,C.$xi)(k.$2l)}),define(ye[261],Ee([1,0,15,20,262,258]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=void 0;async function I(y,v){const b=await v.request(y,C.CancellationToken.None),m=(await(0,s.$Se)(b.stream)).toString(),u=b.res.statusCode??200;return{headers:b.res.headers,statusCode:u,responseData:m}}async function S(y){const v={method:y.type,headers:y.headers};return new Promise((m,u)=>{const a=D.request(y.url??"",v,f=>{f.on("data",function(c){m({headers:f.headers,statusCode:f.statusCode??200,responseData:c.toString()})}),f.on("error",function(c){u(c)})});a.write(y.data,f=>{f&&u(f)}),a.end()})}async function w(y,v,b){const m=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),u={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:m};try{const a=y?await I(u,y):await S(u);b(a.statusCode,a.headers,a.responseData)}catch{b(0,{})}}class g extends k.$JQ{constructor(v,b,m,u,a){const f={sendPOST:(c,d)=>{w(v,c,d)}};super(b,m,u,a,f)}}e.$KQ=g}),define(ye[263],Ee([1,0,11,252]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class D extends C.default{i(){(0,s.setUnexpectedErrorHandler)(S=>console.error(S));const I=[];process.on("unhandledRejection",(S,w)=>{I.push(w),setTimeout(()=>{const g=I.indexOf(w);g>=0&&w.catch(y=>{I.splice(g,1),(0,s.$4)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y.stack&&console.warn(`stack trace: ${y.stack}`),S&&(0,s.$1)(S))})},1e3)}),process.on("rejectionHandled",S=>{const w=I.indexOf(S);w>=0&&I.splice(w,1)}),process.on("uncaughtException",S=>{(0,s.$Z)(S)||(0,s.$1)(S)})}}e.default=D}),define(ye[124],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var s;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(s||(e.EnvironmentVariableMutatorType=s={}))}),define(ye[125],Ee([1,0,3,124]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0;const D=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((v,b)=>{this.d(v,b);const m=v.map.entries();let u=m.next();for(;!u.done;){const a=u.value[1],f=u.value[0];let c=this.a.get(f);if(c||(c=[],this.a.set(f,c)),c.length>0&&c[0].type===C.EnvironmentVariableMutatorType.Replace){u=m.next();continue}const d={extensionIdentifier:b,value:a.value,type:a.type,scope:a.scope,variable:a.variable,options:a.options};d.scope||delete d.scope,c.unshift(d),u=m.next()}})}async applyToProcessEnvironment(y,v,b){let m;s.$c&&(m={},Object.keys(y).forEach(u=>m[u.toLowerCase()]=u));for(const[u,a]of this.getVariableMap(v)){const f=s.$c&&m[u.toLowerCase()]||u;for(const c of a){const d=b?await b(c.value):c.value;if(c.options?.applyAtProcessCreation??!0)switch(c.type){case C.EnvironmentVariableMutatorType.Append:y[f]=(y[f]||"")+d;break;case C.EnvironmentVariableMutatorType.Prepend:y[f]=d+(y[f]||"");break;case C.EnvironmentVariableMutatorType.Replace:y[f]=d;break}if(c.options?.applyAtShellIntegration??!1){const $=`VSCODE_ENV_${D.get(c.type)}`;y[$]=(y[$]?y[$]+":":"")+u+"="+this.c(d)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,v){const b=new Map,m=new Map,u=new Map;if(y.getVariableMap(v).forEach((a,f)=>{const c=this.getVariableMap(v).get(f),d=S(a,c);d&&b.set(f,d)}),this.getVariableMap(v).forEach((a,f)=>{const c=y.getVariableMap(v).get(f),d=S(a,c);d&&u.set(f,d)}),this.getVariableMap(v).forEach((a,f)=>{const c=y.getVariableMap(v).get(f),d=w(a,c);d&&m.set(f,d)}),!(b.size===0&&m.size===0&&u.size===0))return{added:b,changed:m,removed:u}}getVariableMap(y){const v=new Map;for(const b of this.a.values()){const m=b.filter(u=>I(u,y));m.length>0&&v.set(m[0].variable,m)}return v}getDescriptionMap(y){const v=new Map;for(const b of this.b.values()){const m=b.filter(u=>I(u,y,!0));for(const u of m)v.set(u.extensionIdentifier,u.description)}return v}d(y,v){if(!y.descriptionMap)return;const b=y.descriptionMap.entries();let m=b.next();for(;!m.done;){const u=m.value[1],a=m.value[0];let f=this.b.get(a);f||(f=[],this.b.set(a,f));const c={extensionIdentifier:v,scope:u.scope,description:u.description};c.scope||delete c.scope,f.push(c),m=b.next()}}}e.$ss=k;function I(g,y,v=!1){return g.scope?!!(g.scope.workspaceFolder&&y?.workspaceFolder&&g.scope.workspaceFolder.index===y.workspaceFolder.index):v?y===g.scope:!0}function S(g,y){if(!y)return g;const v=new Set;y.forEach(m=>v.add(m.extensionIdentifier));const b=[];return g.forEach(m=>{v.has(m.extensionIdentifier)||b.push(m)}),b.length===0?void 0:b}function w(g,y){if(!y)return;const v=new Map;y.forEach(m=>v.set(m.extensionIdentifier,m));const b=[];return g.forEach(m=>{const u=v.get(m.extensionIdentifier);u&&(m.type!==u.type||m.value!==u.value||m.scope?.workspaceFolder?.index!==u.scope?.workspaceFolder?.index)&&b.push(u)}),b.length===0?void 0:b}}),define(ye[91],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=s,e.$ns=C,e.$os=D,e.$ps=k,e.$qs=I,e.$rs=S;function s(w){return[...w.entries()]}function C(w){return w?[...w.entries()]:[]}function D(w){return new Map(w)}function k(w){return new Map(w??[])}function I(w){return Array.from(w.entries()).map(g=>[g[0],s(g[1].map),C(g[1].descriptionMap)])}function S(w){return new Map(w.map(g=>[g[0],{map:D(g[1]),descriptionMap:k(g[2])}]))}}),define(ye[264],Ee([1,0,14,20,6,2,12]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;let S=class extends k.$Vc{constructor(g,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.$ee),this.onCreateRequest=this.g.event,this.b=g===void 0?15e3:g,this.B((0,k.$Tc)(()=>{for(const v of this.f.values())(0,k.$Qc)(v)}))}createRequest(g){return new Promise((y,v)=>{const b=++this.a;this.c.set(b,y),this.g.fire({requestId:b,...g});const m=new C.$pe;(0,s.$xh)(this.b,m.token).then(()=>v(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,k.$Tc)(()=>m.cancel())])})}acceptReply(g,y){const v=this.c.get(g);v?(this.c.delete(g),(0,k.$Qc)(this.f.get(g)||[]),this.f.delete(g),v(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${g}`)}};e.$ds=S,e.$ds=S=Fe([Ne(1,I.$3j)],S)}),define(ye[92],Ee([1,0,5,47,36]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.$0r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$9r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$8r=void 0,e.$8r=new C.$Nj("terminalTabFocusMode",!1,!0);var k;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var I;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.MiddleClickBehavior="terminal.integrated.middleClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.EnableVisualBell="terminal.integrated.enableVisualBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",h.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",h.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",h.MouseWheelZoom="terminal.integrated.mouseWheelZoom",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var S;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh",h.Python="python"})(S||(e.PosixShellType=S={}));var w;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash",h.Python="python"})(w||(e.WindowsShellType=w={}));var g;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(g||(e.TitleEventSource=g={}));var y;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var v;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$9r=(0,s.$wi)("ptyService");var b;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var m;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var u;(function(h){h.TerminalView="view",h.Editor="editor"})(u||(e.TerminalLocationString=u={}));var a;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var f;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var c;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var d;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var $;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})($||(e.TerminalExitReason=$={})),e.$0r={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}D.$do.add(e.$0r.Backend,new E),e.$$r=(0,s.$wi)("localPtyService"),e.$_r=(0,s.$wi)("terminalLogService")}),define(ye[126],Ee([1,0,3]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=C,e.$mQ=D,e.$nQ=k,e.$oQ=I;function C(S){let w=S;w.includes("\\")&&(w=w.replace(/\\/g,"\\\\"));const g=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return w=w.replace(g,""),`'${w}'`}function D(S,w,g){if(!S)return"";if(!w)return S;w.match(/[\/\\]$/)&&(w=w.slice(0,w.length-1));const y=S.replace(/\\/g,"/").toLowerCase(),v=w.replace(/\\/g,"/").toLowerCase();return y.includes(v)?`~${g}${S.slice(w.length+1)}`:S}function k(S){return S.match(/^['"].*['"]$/)&&(S=S.substring(1,S.length-1)),s.OS===1&&S&&S[1]===":"?S[0].toUpperCase()+S.substring(1):S}function I(S){return!S.strictEnv}}),define(ye[265],Ee([1,0,53,4,209,76]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=I,e.$fs=g,e.$gs=y,e.$hs=v;function I(b,m){const u=[{name:null,description:(0,D.localize)(0,null)}];return u.push(...b.map(a=>({name:a.profileName,description:S(a)}))),m&&u.push(...m.map(a=>({name:a.title,description:w(a)}))),{values:u.map(a=>a.name),markdownDescriptions:u.map(a=>a.description)}}function S(b){let m=`$(${k.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:s.$Vj.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?m+=`
- args: "${b.args}"`:m+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(m+=`
- overrideName: ${b.overrideName}`),b.color&&(m+=`
- color: ${b.color}`),b.env&&(m+=`
- env: ${JSON.stringify(b.env)}`),m}function w(b){return`$(${k.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:s.$Vj.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function g(b,m){if(!b&&!m)return!0;if(typeof b=="string"&&typeof m=="string")return b===m;if(Array.isArray(b)&&Array.isArray(m)){if(b.length!==m.length)return!1;for(let u=0;u<b.length;u++)if(b[u]!==m[u])return!1;return!0}return!1}function y(b,m){if(!b&&!m)return!0;if(!b||!m)return!1;if(k.ThemeIcon.isThemeIcon(b)&&k.ThemeIcon.isThemeIcon(m))return b.id===m.id&&b.color===m.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof m=="object"&&"light"in m&&"dark"in m){const u=b,a=m;if((C.URI.isUri(u.light)||v(u.light))&&(C.URI.isUri(u.dark)||v(u.dark))&&(C.URI.isUri(a.light)||v(a.light))&&(C.URI.isUri(a.dark)||v(a.dark)))return u.light.path===a.light.path&&u.dark.path===a.dark.path}if(C.URI.isUri(b)&&C.URI.isUri(m)||v(b)||v(m)){const u=b,a=m;return u.path===a.path&&u.scheme===a.scheme}return!1}function v(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}}),define(ye[266],Ee([1,0,53,3,208,49,36,265]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=void 0,e.$ks=m,e.$ls=a,e.$is={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$js={type:"string",enum:Array.from((0,s.$Tj)(),f=>f.id),markdownEnumDescriptions:Array.from((0,s.$Tj)(),f=>`$(${f.id})`)};const w={args:{description:(0,D.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,D.localize)(1,null),type:"boolean"},icon:{description:(0,D.localize)(2,null),...e.$js},color:{description:(0,D.localize)(3,null),...e.$is},env:{markdownDescription:(0,D.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},g={type:"object",required:["path"],properties:{path:{description:(0,D.localize)(5,null),type:["string","array"],items:{type:"string"}},...w}},y={type:"object",required:["path"],properties:{path:{description:(0,D.localize)(6,null),type:["string"],items:{type:"string"}},...w}};function v(f){const c=f===2?"linux":f===1?"osx":"windows";return(0,D.localize)(7,null,(0,C.$b)(f),'```json\n"terminal.integrated.profile.'+c+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,D.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,D.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,D.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,D.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,D.localize)(12,null),enum:["PowerShell","Git Bash"]},...w}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,D.localize)(13,null),type:"string"},id:{description:(0,D.localize)(14,null),type:"string"},title:{description:(0,D.localize)(15,null),type:"string"},...w}},{type:"null"},g]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,D.localize)(16,null),type:"string"},id:{description:(0,D.localize)(17,null),type:"string"},title:{description:(0,D.localize)(18,null),type:"string"},...w}},{type:"null"},g]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,D.localize)(19,null),type:"string"},id:{description:(0,D.localize)(20,null),type:"string"},title:{description:(0,D.localize)(21,null),type:"string"},...w}},{type:"null"},g]}},"terminal.integrated.useWslProfiles":{description:(0,D.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,D.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,D.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,D.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,D.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){I.$do.as(k.$io.Configuration).registerConfiguration(b),a()}let u;function a(f,c){const d=I.$do.as(k.$io.Configuration);let $;f&&($=(0,S.$es)(f?.profiles,c));const E=u;u={id:"terminal",order:100,title:(0,D.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,D.localize)(28,null),type:["string","null"],default:null,enum:f?.os===3?$?.values:void 0,markdownEnumDescriptions:f?.os===3?$?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,D.localize)(29,null),type:["string","null"],default:null,enum:f?.os===2?$?.values:void 0,markdownEnumDescriptions:f?.os===2?$?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,D.localize)(30,null),type:["string","null"],default:null,enum:f?.os===1?$?.values:void 0,markdownEnumDescriptions:f?.os===1?$?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[u],remove:E?[E]:[]})}}),define(ye[267],Ee([1,0,2,13,109,26,110]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0;let S=class extends s.$Vc{constructor(g,y){super(),this.a=g,this.b=y}start(){const g={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:C.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},y=(0,I.$$m)(this.b.args,this.b.isBuilt);y&&(y.break&&y.port?g.debugBrk=y.port:!y.break&&y.port&&(g.debug=y.port));const v=new D.$2q(C.$Qg.asFileUri("bootstrap-fork").fsPath,g),b=new s.$Uc;return b.add(v),{client:v,store:b,onDidProcessExit:v.onDidProcessExit}}};e.$5Q=S,e.$5Q=S=Fe([Ne(1,k.$Di)],S)}),define(ye[268],Ee([1,0,28,13,21,7,3,31,17,10,23,124,91,125]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=u,e.$us=a,e.$vs=f;function u(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(s.release());let p=0;return l&&l.length===4&&(p=parseInt(l[3])),p}async function a(l,p,P,j=S.env,O=y.Promises.exists){if(k.$jc(l))return await O(l)?l:void 0;if(p===void 0&&(p=S.cwd()),k.$nc(l)!=="."){const G=k.$kc(p,l);return await O(G)?G:void 0}const A=(0,D.$$n)(j,"PATH");if(P===void 0&&(0,g.$9f)(A)&&(P=A.split(k.$uc)),P===void 0||P.length===0){const G=k.$kc(p,l);return await O(G)?G:void 0}for(const G of P){let se;if(k.$jc(G)?se=k.$kc(G,l):se=k.$kc(p,G,l),await O(se))return se;if(I.$c){let ce=se+".com";if(await O(ce)||(ce=se+".exe",await O(ce)))return ce}}const B=k.$kc(p,l);return await O(B)?B:void 0}function f(l,p,P,j,O){const R=I.$c&&(!p.windowsEnableConpty||u()<18309);if(!p.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||R)return;const A=l.args,B=S.$ec==="win32"?k.$oc(l.executable).toLowerCase():k.$oc(l.executable),G=k.$nc(C.$Qg.asFileUri("").fsPath);let se;const ce={VSCODE_INJECTION:"1"};if(p.shellIntegration.nonce&&(ce.VSCODE_NONCE=p.shellIntegration.nonce),I.$c){if(B==="pwsh.exe"||B==="powershell.exe")return!A||i(A)?se=$.get(d.WindowsPwsh):r(A)&&(se=$.get(d.WindowsPwshLogin)),se?(se=[...se],se[se.length-1]=(0,w.$9e)(se[se.length-1],G,""),p.shellIntegration.suggestEnabled&&(ce.VSCODE_SUGGEST="1"),{newArgs:se,envMixin:ce}):void 0;if(B==="bash.exe")return!A||A.length===0?se=$.get(d.Bash):n(A)&&(ce.VSCODE_SHELL_LOGIN="1",c(p,ce),se=$.get(d.Bash)),se?(se=[...se],se[se.length-1]=(0,w.$9e)(se[se.length-1],G),{newArgs:se,envMixin:ce}):void 0;j.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(B){case"bash":return!A||A.length===0?se=$.get(d.Bash):n(A)&&(ce.VSCODE_SHELL_LOGIN="1",c(p,ce),se=$.get(d.Bash)),se?(se=[...se],se[se.length-1]=(0,w.$9e)(se[se.length-1],G),{newArgs:se,envMixin:ce}):void 0;case"fish":{const ee=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",K=k.$kc(G,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ce.XDG_DATA_DIRS=`${ee}:${K}`,c(p,ce),{newArgs:void 0,envMixin:ce}}case"pwsh":return!A||i(A)?se=$.get(d.Pwsh):r(A)&&(se=$.get(d.PwshLogin)),se?(p.shellIntegration.suggestEnabled&&(ce.VSCODE_SUGGEST="1"),se=[...se],se[se.length-1]=(0,w.$9e)(se[se.length-1],G,""),{newArgs:se,envMixin:ce}):void 0;case"zsh":{if(!A||A.length===0?se=$.get(d.Zsh):n(A)?(se=$.get(d.ZshLogin),c(p,ce)):(A===$.get(d.Zsh)||A===$.get(d.ZshLogin))&&(se=A),!se)return;se=[...se],se[se.length-1]=(0,w.$9e)(se[se.length-1],G);let ee;try{ee=s.userInfo().username}catch{ee="unknown"}const K=k.$kc(s.tmpdir(),`${ee}-${O.applicationName}-zsh`);ce.ZDOTDIR=K;const q=P?.ZDOTDIR??s.homedir()??"~";ce.USER_ZDOTDIR=q;const X=[];return X.push({source:k.$kc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.$kc(K,".zshrc")}),X.push({source:k.$kc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.$kc(K,".zprofile")}),X.push({source:k.$kc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.$kc(K,".zshenv")}),X.push({source:k.$kc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.$kc(K,".zlogin")}),{newArgs:se,envMixin:ce,filesToCopy:X}}}j.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function c(l,p){if(I.$d&&l.environmentVariableCollections){const P=(0,b.$rs)(l.environmentVariableCollections),O=new m.$ss(P).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),R=[];if(O)for(const A of O)A.type===v.EnvironmentVariableMutatorType.Prepend&&R.push(A.value);R.length>0&&(p.VSCODE_PATH_PREFIX=R.join(""))}}var d;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(d||(d={}));const $=new Map;$.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),$.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),$.set(d.Zsh,["-i"]),$.set(d.ZshLogin,["-il"]),$.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],h=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function r(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(o.includes(l[0].toLowerCase())||o.includes(l[1].toLowerCase()))}function i(l){return typeof l=="string"?o.includes(l.toLowerCase()):l.length===0||l?.length===1&&o.includes(l[0].toLowerCase())}function n(l){return typeof l!="string"&&(l=l.filter(p=>!t.includes(p.toLowerCase()))),l==="string"&&h.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&h.includes(l[0].toLowerCase())}}),define(ye[269],Ee([1,0,56,53,7,3,10,23,104,268,78]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=u;var v;(function(l){l.UnixShellsPath="/etc/shells"})(v||(v={}));let b,m=!0;function u(l,p,P,j,O=process.env,R,A,B,G){return R=R||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},k.$c?a(P,R,O,A,j.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:j.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:j.getValue("terminal.integrated.defaultProfile.windows"),G,B):r(R,A,P,l&&typeof l=="object"?{...l}:j.getValue(k.$e?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:j.getValue(k.$e?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),G,B,O)}async function a(l,p,P,j,O,R,A,B,G){const se=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ce=`${process.env.windir}\\${se?"Sysnative":"System32"}`;let ee=!1;(0,g.$ts)()>=16299&&(ee=!0),await $(B);const K=new Map;if(l){K.set("PowerShell",{source:"PowerShell",icon:C.$Vj.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${ce}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Vj.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),K.set("Command Prompt",{path:`${ce}\\cmd.exe`,icon:C.$Vj.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Vj.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${ce}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}i(R,K);const q=await f(K.entries(),A,p,P,j,G);if(l&&O)try{const X=await t(`${ce}\\${ee?"wsl":"bash"}.exe`,A);for(const _ of X)(!R||!(_.profileName in R))&&q.push(_)}catch{m&&(j?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return q}async function f(l,p,P,j=process.env,O,R){const A=[];for(const[B,G]of l)A.push(c(B,G,p,P,j,O,R));return(await Promise.all(A)).filter(B=>!!B)}async function c(l,p,P,j,O=process.env,R,A){if(p===null)return;let B,G,se;if("source"in p&&!("path"in p)){const q=b?.get(p.source);if(!q)return;B=q.paths,G=p.args||q.args,p.icon?se=d(p.icon):q.icon&&(se=q.icon)}else B=Array.isArray(p.path)?p.path:[p.path],G=k.$c||Array.isArray(p.args)?p.args:void 0,se=d(p.icon);let ce;if(A){const q=B.map(_=>typeof _=="string"?_:_.path),X=await A(q);ce=new Array(B.length);for(let _=0;_<B.length;_++)typeof B[_]=="string"?ce[_]=X[_]:ce[_]={path:X[_],isUnsafe:!0}}else ce=B.slice();let ee;if(p.requiresPath){let q;if((0,I.$9f)(p.requiresPath)?q=p.requiresPath:(q=p.requiresPath.path,p.requiresPath.isUnsafe&&(ee=q)),!await j.existsFile(q))return}const K=await n(l,P,ce,j,O,G,p.env,p.overrideName,p.isAutoDetected,ee);if(!K){R?.debug("Terminal profile not validated",l,B);return}return K.isAutoDetected=p.isAutoDetected,K.icon=se,K.color=p.color,K}function d(l){return typeof l=="string"?{id:l}:l}async function $(l){if(b&&!l)return;const[p,P]=await Promise.all([E(),l||h()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:P,icon:C.$Vj.terminalPowershell})}async function E(){const l=new Set,p=await(0,g.$us)("git.exe");if(p){const O=(0,y.dirname)(p);l.add((0,y.resolve)(O,"../.."))}function P(O,R){R&&O.add(R)}P(l,process.env.ProgramW6432),P(l,process.env.ProgramFiles),P(l,process.env["ProgramFiles(X86)"]),P(l,`${process.env.LocalAppData}\\Program`);const j=[];for(const O of l)j.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return j.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),j.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),j}async function h(){const l=[];for await(const p of(0,w.$lm)())l.push(p.exePath);return l}async function t(l,p){const P=[],j=await new Promise((A,B)=>{s.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(G,se)=>{if(G)return B("Problem occurred when getting wsl distros");A(se)})});if(!j)return[];const O=new RegExp(/[\r?\n]/),R=j.split(O).filter(A=>A.trim().length>0&&A!=="");for(const A of R){if(A===""||A.startsWith("docker-desktop"))continue;const B=`${A} (WSL)`,G={profileName:B,path:l,args:["-d",`${A}`],isDefault:B===p,icon:o(A),isAutoDetected:!1};P.push(G)}return P}function o(l){return l.includes("Ubuntu")?C.$Vj.terminalUbuntu:l.includes("Debian")?C.$Vj.terminalDebian:C.$Vj.terminalLinux}async function r(l,p,P,j,O,R,A,B){const G=new Map;if(P&&await l.existsFile("/etc/shells")){const se=(await l.readFile("/etc/shells")).toString(),ce=(R||se.split(`
`)).map(K=>{const q=K.indexOf("#");return q===-1?K:K.substring(0,q)}).filter(K=>K.trim().length>0),ee=new Map;for(const K of ce){let q=(0,D.$oc)(K),X=ee.get(q)||0;X++,X>1&&(q=`${q} (${X})`),ee.set(q,X),G.set(q,{path:K,isAutoDetected:!0})}}return i(j,G),await f(G.entries(),O,l,B,p,A)}function i(l,p){if(l)for(const[P,j]of Object.entries(l))j===null||typeof j!="object"||!("path"in j)&&!("source"in j)?p.delete(P):(j.icon=j.icon||p.get(P)?.icon,p.set(P,j))}async function n(l,p,P,j,O,R,A,B,G,se){if(P.length===0)return Promise.resolve(void 0);const ce=P.shift();if(ce==="")return n(l,p,P,j,O,R,A,B,G);const ee=typeof ce!="string"&&ce.isUnsafe,K=typeof ce=="string"?ce:ce.path,q={profileName:l,path:K,args:R,env:A,overrideName:B,isAutoDetected:G,isDefault:l===p,isUnsafePath:ee,requiresUnsafePath:se};if((0,D.$oc)(K)===K){const _=O.PATH?O.PATH.split(D.$uc):void 0,M=await(0,g.$us)(K,void 0,_,void 0,j.existsFile);return M?(q.path=M,q.isFromPath=!0,q):n(l,p,P,j,O,R)}return await j.existsFile((0,D.$ic)(K))?q:n(l,p,P,j,O,R,A,B,G)}}),define(ye[270],Ee([1,0,6,2,3,45,25,12,115,88,264,92,266,269,107,63]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;var f;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=class extends C.$Vc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor($,E,h,t){super(),this.M=$,this.N=E,this.O=h,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new s.$ee),this.onPtyHostExit=this.u.event,this.w=this.B(new s.$ee),this.onPtyHostStart=this.w.event,this.y=this.B(new s.$ee),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new s.$ee),this.onPtyHostResponsive=this.z.event,this.C=this.B(new s.$ee),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new s.$ee),this.onProcessData=this.D.event,this.F=this.B(new s.$ee),this.onProcessReady=this.F.event,this.G=this.B(new s.$ee),this.onProcessReplay=this.G.event,this.H=this.B(new s.$ee),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new s.$ee),this.onDidRequestDetach=this.I.event,this.J=this.B(new s.$ee),this.onDidChangeProperty=this.J.event,this.L=this.B(new s.$ee),this.onProcessExit=this.L.event,(0,b.$ks)(),this.B(this.M),this.B((0,C.$Tc)(()=>this.W())),this.j=this.B(new y.$ds(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&s.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(D.$c)return process.env;try{return await(0,g.$Hm)(this.N,this.O,{_:[]},process.env)}catch($){return this.O.error("ptyHost was unable to resolve shell environment",$),{}}}U(){const $=this.M.start(),E=$.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(E.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B($.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=f.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=k.ProxyChannel.toService(E.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new w.$cs(this.P,E.getChannel(v.TerminalIpcChannels.Logger))),this.a=$,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[$,t]}async createProcess($,E,h,t,o,r,i,n,l,p,P){const j=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),O=await this.f.createProcess($,E,h,t,o,r,i,n,l,p,P);return clearTimeout(j),O}updateTitle($,E,h){return this.f.updateTitle($,E,h)}updateIcon($,E,h,t){return this.f.updateIcon($,E,h,t)}attachToProcess($){return this.f.attachToProcess($)}detachFromProcess($,E){return this.f.detachFromProcess($,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start($){return this.f.start($)}shutdown($,E){return this.f.shutdown($,E)}input($,E){return this.f.input($,E)}processBinary($,E){return this.f.processBinary($,E)}resize($,E,h){return this.f.resize($,E,h)}clearBuffer($){return this.f.clearBuffer($)}acknowledgeDataEvent($,E){return this.f.acknowledgeDataEvent($,E)}setUnicodeVersion($,E){return this.f.setUnicodeVersion($,E)}getInitialCwd($){return this.f.getInitialCwd($)}getCwd($){return this.f.getCwd($)}async getLatency(){const $=new a.$ae,E=await this.f.getLatency();return $.stop(),[{label:"ptyhostservice<->ptyhost",latency:$.elapsed()},...E]}orphanQuestionReply($){return this.f.orphanQuestionReply($)}installAutoReply($,E){return this.f.installAutoReply($,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply($){return this.f.uninstallAutoReply($)}getDefaultSystemShell($){return this.g?.getDefaultSystemShell($)??(0,u.$rm)($??D.OS,process.env)}async getProfiles($,E,h,t=!1){const o=await this.S();return(0,m.$ws)(E,h,t,this.N,o,void 0,this.O,this.bb.bind(this,$))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath($,E){return this.f.getWslPath($,E)}getRevivedPtyNewId($,E){return this.f.getRevivedPtyNewId($,E)}setTerminalLayoutInfo($){return this.f.setTerminalLayoutInfo($)}async getTerminalLayoutInfo($){return this.g?.getTerminalLayoutInfo($)}async requestDetachInstance($,E){return this.f.requestDetachInstance($,E)}async acceptDetachInstanceReply($,E){return this.f.acceptDetachInstanceReply($,E)}async freePortKillProcess($){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess($)}async serializeTerminalState($){return this.f.serializeTerminalState($)}async reviveTerminalProcesses($,E,h){return this.f.reviveTerminalProcesses($,E,h)}async refreshProperty($,E){return this.f.refreshProperty($,E)}async updateProperty($,E,h){return this.f.updateProperty($,E,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X($){this.ab(),this.s=setTimeout(()=>this.Y(),$?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb($,E){return this.j.createRequest({workspaceId:$,originalText:E})}async acceptPtyHostResolvedVariables($,E){this.j.acceptReply($,E)}};e.$xs=c,e.$xs=c=Fe([Ne(1,I.$3i),Ne(2,S.$3j),Ne(3,S.$4j)],c)}),define(ye[34],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,s.$wi)("IUriIdentityService")}),define(ye[127],Ee([1,0,34,111,16,19,157,6,2]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0;class g{constructor(b){this.uri=b,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let y=class{constructor(b){this.g=b,this.c=new w.$Uc,this.f=2**16;const m=new Map,u=a=>{let f=m.get(a.scheme);return f===void 0&&(f=b.hasProvider(a)&&!this.g.hasCapability(a,1024),m.set(a.scheme,f)),f};this.c.add(S.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(a=>{m.delete(a.scheme)})),this.extUri=new k.$Yg(u),this.d=new I.$As((a,f)=>this.extUri.compare(a,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,k.$$g)(b));const m=this.d.get(b);return m?m.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new g(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((u,a)=>u[1].time<a[1].time?1:u[1].time>a[1].time?-1:0);g._clock=0,this.d.clear();const m=this.f*.5;for(let u=0;u<m;u++)this.d.set(b[u][0],b[u][1].touch())}};e.$Bs=y,e.$Bs=y=Fe([Ne(0,D.$3k)],y),(0,C.$ys)(s.$Al,y,1)}),define(ye[93],Ee([1,0,211,7,66,19,4,5,13]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=g,e.$Hi=y,e.$Ki=v,e.$Li=b,e.$Mi=m,e.$Ni=a,e.$Oi=f,e.$Ri=$,e.$Wi=E,e.$Xi=h,e.$Zi=t,e.$1i=o,e.$2i=r,e.$Fi=(0,S.$wi)("contextService");function g(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.uri)}function y(i){return typeof i?.id=="string"&&!g(i)&&!b(i)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$oc)(i)}:n?e.$Ii:e.$Ji;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function b(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.configPath)}function m(i){const n=i;if(n?.uri)return{id:n.id,uri:I.URI.revive(n.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:I.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}var u;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(u||(e.WorkbenchState=u={}));function a(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function f(i){const n=i;return!!(n&&typeof n=="object"&&I.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class c{constructor(n,l,p,P,j){this.h=n,this.j=p,this.k=P,this.l=j,this.c=D.$Ci.forUris(this.l,()=>!0),this.folders=l}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=D.$Ci.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=c;class d{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.$0g)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=d;function $(i){return new d({uri:i,index:0,name:(0,k.$6g)(i)},{uri:i.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,s.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function E(i,n){return k.$1g.isEqualOrParent(i,n.untitledWorkspacesHome)}function h(i){let n;return I.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===w.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Yi}function o(i,n){return!E(i,n)&&!h(i)}function r(i){return(typeof i=="string"?(0,C.$pc)(i):(0,k.$8g)(i))===e.$Ti}}),define(ye[33],Ee([1,0,64,6,2,19,4,210,26,16,5,12,93,24,34,14,22,17,10]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=E,e.$Dl=h,e.$El=t;var $;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&I.URI.isUri(n.extensionsResource))}e.$Cl=(0,y.$wi)("IUserDataProfilesService");function h(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:I.URI.revive(i.location).with({scheme:n}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:I.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,l,p,P,j){return{id:i,name:n,location:l,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:j&&P?.useDefaultFlags?.globalState?j.globalStorageHome:(0,k.$0g)(l,"globalStorage"),settingsResource:j&&P?.useDefaultFlags?.settings?j.settingsResource:(0,k.$0g)(l,"settings.json"),keybindingsResource:j&&P?.useDefaultFlags?.keybindings?j.keybindingsResource:(0,k.$0g)(l,"keybindings.json"),tasksResource:j&&P?.useDefaultFlags?.tasks?j.tasksResource:(0,k.$0g)(l,"tasks.json"),snippetsHome:j&&P?.useDefaultFlags?.snippets?j.snippetsHome:(0,k.$0g)(l,"snippets"),extensionsResource:j&&P?.useDefaultFlags?.extensions?j.extensionsResource:(0,k.$0g)(l,"extensions.json"),cacheHome:(0,k.$0g)(p,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let o=class extends D.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,l,p,P){super(),this.t=n,this.u=l,this.w=p,this.y=P,this.f=!0,this.h=this.B(new C.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Bc,emptyWindows:new Map},this.profilesHome=(0,k.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),l=[n];if(this.f)try{for(const j of this.O()){if(!j.name||!(0,d.$9f)(j.name)||!j.location){this.y.warn("Skipping the invalid stored profile",j.location||j.name);continue}l.push(t((0,k.$7g)(j.location),j.name,j.location,this.g,{shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags},n))}}catch(j){this.y.error(j)}const p=new m.$Bc,P=new Map;if(l.length)try{const j=this.Q();if(j.workspaces)for(const[O,R]of Object.entries(j.workspaces)){const A=I.URI.parse(O),B=l.find(G=>G.id===R);B&&p.set(A,B)}if(j.emptyWindows)for(const[O,R]of Object.entries(j.emptyWindows)){const A=l.find(B=>B.id===R);A&&P.set(O,A)}}catch(j){this.y.error(j)}this.z={profiles:l,workspaces:p,emptyWindows:P}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",p=new RegExp(`${(0,c.$af)(l)}\\s(\\d+)`);let P=0;for(const O of this.profiles){const R=p.exec(O.name),A=R?parseInt(R[1]):0;P=A>P?A:P}const j=`${l} ${P+1}`;return this.createProfile((0,s.$kj)((0,f.$Sg)()).toString(16),j,{transient:!0},n)}async createNamedProfile(n,l,p){return this.createProfile((0,s.$kj)((0,f.$Sg)()).toString(16),n,l,p)}async createProfile(n,l,p,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const j=await this.F(n,l,p);return P&&await this.setProfileForWorkspace(P,j),j}async F(n,l,p){if(!(0,d.$9f)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(l);return P||(P=(async()=>{try{if(this.profiles.find(A=>A.name===l||A.id===n))throw new Error(`Profile with ${l} name already exists`);const O=t(n,l,(0,k.$0g)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(O.location);const R=[];return this.j.fire({profile:O,join(A){R.push(A)}}),await a.Promises.settled(R),this.I([O],[],[]),O}finally{this.r.delete(l)}})(),this.r.set(l,P)),P}async updateProfile(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(P=>P.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=t(p.id,l.name??p.name,p.location,this.g,{shortName:l.shortName??p.shortName,icon:l.icon===null?void 0:l.icon??p.icon,transient:l.transient??p.isTransient,useDefaultFlags:l.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(P=>P.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:l,join(P){p.push(P)}});try{await Promise.allSettled(p)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(P){(0,g.$hl)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(P=>P.id===l.id);if(!p)throw new Error(`Profile '${l.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.G(n);return I.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(n){return(0,b.$Gi)(n)?n.uri:(0,b.$Li)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location)))}I(n,l,p){const P=[...this.profiles,...n],j=[];this.s.profiles=[];for(let O of P)O.isDefault||l.some(R=>O.id===R.id)||(O=p.find(R=>O.id===R.id)??O,O.isTransient?this.s.profiles.push(O):j.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags}));this.P(j),this.z=void 0,this.J(n,l,p)}J(n,l,p){this.h.fire({added:n,removed:l,updated:p,all:this.profiles})}L(n,l,p){p=l?.isTransient?!0:p,p||this.L(n,void 0,!0);const P=this.G(n),j=p?this.s:this.C;I.URI.isUri(P)?(j.workspaces.delete(P),l&&j.workspaces.set(P,l)):(j.emptyWindows.delete(P),l&&j.emptyWindows.set(P,l)),p||this.M()}M(){const n={};for(const[p,P]of this.C.workspaces.entries())n[p.toString()]=P.id;const l={};for(const[p,P]of this.C.emptyWindows.entries())l[p.toString()]=P.id;this.R({workspaces:n,emptyWindows:l}),this.z=void 0}N(n){const l={},p=this.D();if(n.workspaces)for(const[j,O]of Object.entries(n.workspaces)){const R=I.URI.parse(O);l[j]=this.w.extUri.isEqual(R,p.location)?p.id:this.w.extUri.basename(R)}const P={};if(n.emptyWindows)for(const[j,O]of Object.entries(n.emptyWindows)){const R=I.URI.parse(O);P[j]=this.w.extUri.isEqual(R,p.location)?p.id:this.w.extUri.basename(R)}return{workspaces:l,emptyWindows:P}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Fl=o,o.b="userDataProfiles",o.c="profileAssociations",e.$Fl=o=Fe([Ne(0,w.$Di),Ne(1,g.$3k),Ne(2,u.$Al),Ne(3,v.$3j)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Gl=r}),define(ye[271],Ee([1,0,18,14,20,11,6,2,3,10,4,190,32,38,40,12,29,30,34,33]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$mq=void 0,e.$nq=h;let E=class extends S.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,n,l,p,P,j){super(),this.z=i,this.C=n,this.D=l,this.F=p,this.G=P,this.H=j,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$ee),this.s=this.B(new I.$ee),this.t=this.B(new I.$ee),this.u=this.B(new I.$ee),this.w=this.B(new I.$ee),this.y=[],this.B((0,S.$Tc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,b.$5o)(l,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const p=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:P})=>(0,m.$vp)(P,i.identifier));if(p?.local)return p?.local;throw p?.error?p.error:new b.$8o(`Unknown error while installing extension ${i.identifier.id}`,b.ExtensionManagementErrorCode.Unknown)}catch(l){throw h(l)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new b.$8o(v.localize(0,null),b.ExtensionManagementErrorCode.NotAllowed);const n=[],l=[];return await Promise.allSettled(i.map(async({extension:p,options:P})=>{try{const j=await this.N(p,!!P?.installGivenVersion,!!P?.installPreReleaseVersion,P.productVersion??{version:this.G.version,date:this.G.date});l.push({...j,options:P})}catch(j){n.push({identifier:p.identifier,operation:2,source:p,error:j})}})),l.length&&n.push(...await this.I(l)),n}async uninstall(i,n={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,n)}async toggleAppliationScope(i,n){if((0,u.$Vm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let l=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(l=await this.$(i,this.H.defaultProfile.extensionsResource,n));for(const p of this.H.profiles){const P=(await this.getInstalled(1,p.extensionsResource)).find(j=>(0,m.$vp)(j.identifier,i.identifier));P?this.w.fire(P):this.u.fire({identifier:i.identifier,profileLocation:p.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const n=new Map,l=new Map,p=[],P=(O,R)=>`${m.$wp.create(O).toString()}-${R.toString()}`,j=(O,R,A,B)=>{const G=this.Y(O,R,A),se=`${(0,m.$Ap)(O.publisher,O.name)}-${A.profileLocation.toString()}`;l.set(se,{task:G,root:B}),this.n.fire({identifier:G.identifier,source:R,profileLocation:A.profileLocation}),this.F.info("Installing extension:",G.identifier.id),y.URI.isUri(R)||this.j.set(P(R,A.profileLocation),{task:G,waitingTasks:[]})};try{for(const{manifest:O,extension:R,options:A}of i){const B=A.isApplicationScoped||A.isBuiltin||(0,u.$Vm)(O),G={...A,installOnlyNewlyAddedFromExtensionPack:A.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(R),isApplicationScoped:B,profileLocation:B?this.H.defaultProfile.extensionsResource:A.profileLocation??this.X(),productVersion:A.productVersion??{version:this.G.version,date:this.G.date}},se=y.URI.isUri(R)?void 0:this.j.get(P(R,G.profileLocation));se?(this.F.info("Extension is already requested to install",se.task.identifier.id),p.push(se.task.waitUntilTaskIsFinished())):j(O,R,G,void 0)}return await Promise.all([...l.values()].map(async({task:O})=>{if(O.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const R=await this.M(O.identifier,O.manifest,!!O.options.installOnlyNewlyAddedFromExtensionPack,!!O.options.installPreReleaseVersion,O.options.profileLocation,O.options.productVersion),A=await this.getInstalled(void 0,O.options.profileLocation,O.options.productVersion),B={...O.options,context:{...O.options.context,[b.$Zo]:!0}};for(const{gallery:G,manifest:se}of(0,s.$Mb)(R,({gallery:ce})=>ce.identifier.id)){if(l.has(`${G.identifier.id.toLowerCase()}-${B.profileLocation.toString()}`))continue;const ce=this.j.get(P(G,B.profileLocation));if(ce){if(this.J(O,ce.task)){const ee=ce.task.identifier;this.F.info("Waiting for already requested installing extension",ee.id,O.identifier.id),ce.waitingTasks.push(O),p.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,K=>K.some(q=>(0,m.$vp)(q.identifier,ee)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",ee.id,O.identifier.id),!K.find(X=>(0,m.$vp)(X.identifier,ee))?.local)throw new Error(`Extension ${ee.id} is not installed`)}))}}else A.some(({identifier:ee})=>(0,m.$vp)(ee,G.identifier))||j(se,G,B,O)}}catch(R){if(y.URI.isUri(O.source))(0,s.$Lb)(O.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",O.identifier.id,R.message),(0,s.$Lb)(O.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",O.identifier.id,R.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),R}})),await this.L([...l.entries()].map(async([O,{task:R}])=>{const A=new Date().getTime();try{const B=await R.run();if(await this.L(this.y.map(G=>G.postInstall(B,R.source,R.options,D.CancellationToken.None))),!y.URI.isUri(R.source)){const G=R.operation===3,se=G?void 0:(new Date().getTime()-R.source.lastUpdated)/1e3;if(t(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Dp)(R.source),verificationStatus:R.verificationStatus,duration:new Date().getTime()-A,durationSinceUpdate:se}),w.$i&&R.operation!==3)try{await this.z.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}n.set(O,{local:B,identifier:R.identifier,operation:R.operation,source:R.source,context:R.options.context,profileLocation:R.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){const G=h(B);throw y.URI.isUri(R.source)||t(this.C,R.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Dp)(R.source),error:G}),n.set(O,{error:G,identifier:R.identifier,operation:R.operation,source:R.source,context:R.options.context,profileLocation:R.profileLocation,applicationScoped:R.options.isApplicationScoped}),this.F.error("Error while installing the extension",R.identifier.id,(0,k.$0)(G)),G}})),p.length&&await this.L(p),[...n.values()]}catch(O){const R=(G,se,ce)=>{const ee=[];G.manifest.extensionDependencies?.length&&ee.push(...G.manifest.extensionDependencies),G.manifest.extensionPack?.length&&ee.push(...G.manifest.extensionPack);for(const K of ee){if(ce.includes(K.toLowerCase()))continue;ce.push(K.toLowerCase());const q=n.get(`${K.toLowerCase()}-${se.toString()}`);q?.local&&(ce=R(q.local,se,ce))}return ce},A=G=>({identifier:G.identifier,operation:2,source:G.source,context:G.options.context,profileLocation:G.profileLocation,error:O}),B=[];for(const[G,{task:se,root:ce}]of l){const ee=n.get(G);ee?ee.local&&ce&&!n.get(`${ce.identifier.id.toLowerCase()}-${se.profileLocation.toString()}`)?.local&&(B.push(this.Z(ee.local,{versionOnly:!0,profileLocation:se.profileLocation})),n.set(G,A(se))):(se.cancel(),n.set(G,A(se)))}for(const[G,{task:se}]of l){const ce=n.get(G);if(!ce?.local||se.options.donotIncludePackAndDependencies)continue;R(ce.local,se.profileLocation,[ce.local.identifier.id.toLowerCase()]).slice(1).some(K=>l.has(`${K.toLowerCase()}-${se.profileLocation.toString()}`)&&!n.get(`${K.toLowerCase()}-${se.profileLocation.toString()}`)?.local)&&(B.push(this.Z(ce.local,{versionOnly:!0,profileLocation:se.profileLocation})),n.set(G,A(se)))}throw B.length&&await Promise.allSettled(B.map(async G=>{try{await G.run(),this.F.info("Rollback: Uninstalled extension",G.extension.identifier.id)}catch(se){this.F.warn("Rollback: Error while uninstalling extension",G.extension.identifier.id,(0,k.$0)(se))}})),O}finally{for(const{task:O}of l.values())O.source&&!y.URI.isUri(O.source)&&this.j.delete(P(O.source,O.profileLocation));if(n.size){const O=[...n.values()];for(const R of O)R.local&&this.F.info("Extension installed successfully:",R.identifier.id);this.s.fire(O)}}}J(i,n){for(const[,{task:l,waitingTasks:p}]of this.j.entries())if(l===i&&(p.includes(n)||p.some(P=>this.J(P,n)))||l===n&&p[0]&&!this.J(i,p[0]))return!1;return!0}async L(i){const n=[],l=[],p=await Promise.allSettled(i);for(const P of p)P.status==="fulfilled"?n.push(P.value):l.push(P.reason);if(l.length){if(l.length===1)throw l[0];let P=new b.$8o("",b.ExtensionManagementErrorCode.Unknown);for(const j of l){const O=j instanceof b.$8o?j.code:b.ExtensionManagementErrorCode.Unknown;P=new b.$8o(j.message?`${j.message}, ${P.message}`:P.message,O!==b.ExtensionManagementErrorCode.Unknown&&O!==b.ExtensionManagementErrorCode.Internal?O:P.code)}throw P}return n}async M(i,n,l,p,P,j){if(!this.z.isEnabled())return[];const O=await this.getInstalled(void 0,P,j),R=[],A=[],B=async(G,se)=>{R.push(G);const ce=se.extensionDependencies||[],ee=[...ce];if(se.extensionPack){const K=l?O.find(q=>(0,m.$vp)(q.identifier,G)):void 0;for(const q of se.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(X=>(0,m.$vp)({id:X},{id:q}))||ee.every(X=>!(0,m.$vp)({id:X},{id:q}))&&ee.push(q)}if(ee.length){const K=ee.filter(q=>R.every(X=>!(0,m.$vp)(X,{id:q})));if(K.length){const q=await this.z.getExtensions(K.map(X=>({id:X,preRelease:p})),D.CancellationToken.None);for(const X of q){if(R.find(Q=>(0,m.$vp)(Q,X.identifier)))continue;const _=ce.some(Q=>(0,m.$vp)({id:Q},X.identifier));let M;try{M=await this.N(X,!1,p,j)}catch(Q){if(_)throw Q;this.F.info("Skipping the packed extension as it cannot be installed",X.identifier.id,(0,k.$0)(Q));continue}A.push({gallery:M.extension,manifest:M.manifest}),await B(M.extension.identifier,M.manifest)}}}};return await B(i,n),A}async N(i,n,l,p){let P;const j=await this.getExtensionsControlManifest();if(j.malicious.some(A=>(0,m.$vp)(i.identifier,A)))throw new b.$8o(v.localize(1,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);const O=j.deprecated[i.identifier.id.toLowerCase()];if(O?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${O.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:O.extension.id,preRelease:O.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:p},D.CancellationToken.None))[0],!P)throw new b.$8o(v.localize(2,null,i.identifier.id,O.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const A=await this.getTargetPlatform();throw new b.$8o(v.localize(3,null,i.identifier.id,this.G.nameLong,(0,b.$1o)(A)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.O(i,n,l,p),!P)throw!l&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],D.CancellationToken.None))[0]?new b.$8o(v.localize(4,null,i.displayName??i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$8o(v.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const R=await this.z.getManifest(P,D.CancellationToken.None);if(R===null)throw new b.$8o(`Missing manifest for extension ${P.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(R.version!==P.version)throw new b.$8o(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:R}}async O(i,n,l,p){const P=await this.getTargetPlatform();let j=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(j=(await this.z.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:P,compatible:!0,productVersion:p},D.CancellationToken.None))[0]||null),!j&&await this.z.isExtensionCompatible(i,l,P,p)&&(j=i),j||(n?j=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:P,compatible:!0,productVersion:p},D.CancellationToken.None))[0]||null:j=await this.z.getCompatibleExtension(i,l,P,p)),j}async P(i,n){const l={...n,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},p=B=>`${B.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,P=this.m.get(p(i.identifier));if(P)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),P.waitUntilTaskIsFinished();const j=B=>{const G=this.Z(B,l);return this.m.set(p(G.extension.identifier),G),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this.t.fire({identifier:B.identifier,profileLocation:l.profileLocation,applicationScoped:B.isApplicationScoped}),G},O=(B,G)=>{G?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,l.profileLocation.toString(),G.message):this.F.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,G.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$Cp)(B),error:G}),this.u.fire({identifier:B.identifier,error:G?.code,profileLocation:l.profileLocation,applicationScoped:B.isApplicationScoped})},R=[],A=[];try{R.push(j(i));const B=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const G=this.S(i,B);for(const se of G)this.m.has(p(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):R.push(j(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(R.map(G=>G.extension),B,i),await this.L(R.map(async G=>{try{if(await G.run(),await this.L(this.y.map(se=>se.postUninstall(G.extension,l,D.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}O(G.extension)}catch(se){const ce=h(se);throw O(G.extension,ce),ce}finally{A.push(G)}}))}catch(B){const G=h(B);for(const se of R){try{se.cancel()}catch{}A.includes(se)||O(se.extension,G)}throw G}finally{for(const B of R)this.m.delete(p(B.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}Q(i,n,l){for(const p of i){const P=this.U(p,n);if(P.length){const j=P.filter(O=>!i.some(R=>(0,m.$vp)(R.identifier,O.identifier)));if(j.length)throw new Error(this.R(p,j,l))}}}R(i,n,l){return l===i?n.length===1?v.localize(6,null,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?v.localize(7,null,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):v.localize(8,null,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?v.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?v.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):v.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(i,n,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const p=i.manifest.extensionPack?i.manifest.extensionPack:[];if(p.length){const P=n.filter(O=>!O.isBuiltin&&p.some(R=>(0,m.$vp)({id:R},O.identifier))),j=[];for(const O of P)j.push(...this.S(O,n,l));return[...P,...j]}return[]}U(i,n){return n.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(p=>(0,m.$vp)({id:p},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$mq=E,e.$mq=E=Fe([Ne(0,b.$7o),Ne(1,c.$2l),Ne(2,d.$Al),Ne(3,a.$3j),Ne(4,f.$jk),Ne(5,$.$Cl)],E);function h(r){if(r instanceof b.$8o)return r;if(r instanceof b.$9o){const n=new b.$8o(r.message,b.ExtensionManagementErrorCode.Gallery);return n.stack=r.stack,n}const i=new b.$8o(r.message,(0,k.$4)(r)?b.ExtensionManagementErrorCode.Cancelled:b.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function t(r,i,{extensionData:n,verificationStatus:l,duration:p,error:P,durationSinceUpdate:j}){let O,R;(0,g.$eg)(l)&&(l===!0?l="Verified":(l===!1||(O=b.ExtensionManagementErrorCode.Signature,R=l),l="Unverified")),P&&(O=P.code,P.code===b.ExtensionManagementErrorCode.Signature&&(R=P.message)),r.publicLog(i,{...n,verificationStatus:l,success:!P,duration:p,errorcode:O,errorcodeDetail:R,durationSinceUpdate:j})}class o{constructor(){this.d=new C.$vh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,C.$jh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,C.$jh)(i=>new Promise((n,l)=>{const p=i.onCancellationRequested(()=>{p.dispose(),l(new k.$5)})})),this.d.open()),this.g.cancel()}}e.$oq=o}),define(ye[50],Ee([1,0,14,15,2,6,24,4,32,38,16,5,12,33,34,10,11,30]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class $ extends Error{constructor(r,i){super(r),this.code=i}}e.$pq=$,e.$qq=(0,v.$wi)("IExtensionsProfileScannerService");let E=class extends D.$Vc{constructor(r,i,n,l,p,P){super(),this.j=r,this.m=i,this.n=n,this.r=l,this.s=p,this.t=P,this.b=this.B(new k.$ee),this.onAddExtensions=this.b.event,this.c=this.B(new k.$ee),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$ee),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$ee),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,n){const l=[],p=[];try{return await this.u(i,P=>{const j=[];if(n)j.push(...P);else for(const O of P)r.some(([R])=>(0,g.$vp)(R.identifier,O.identifier)&&R.manifest.version!==O.version)?l.push(O):j.push(O);for(const[O,R]of r){const A=j.findIndex(G=>(0,g.$vp)(G.identifier,O.identifier)&&G.version===O.manifest.version),B={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:R};A===-1?(p.push(B),j.push(B)):j.splice(A,1,B)}return p.length&&this.b.fire({extensions:p,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),j}),p.length&&this.c.fire({extensions:p,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),p}catch(P){throw p.length&&this.c.fire({extensions:p,error:P,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:P,profileLocation:i}),P}}async updateMetadata(r,i){const n=[];return await this.u(i,l=>{const p=[];for(const P of l){const j=r.find(([O])=>(0,g.$vp)(O.identifier,P.identifier)&&O.manifest.version===P.version);j&&(P.metadata={...P.metadata,...j[1]},n.push(P)),p.push(P)}return p}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,l=>{const p=[];for(const P of l)(0,g.$vp)(P.identifier,r.identifier)?n.push(P):p.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:i}),p}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(l){throw n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async u(r,i,n){return this.F(r).queue(async()=>{let l=[],p;try{const P=await this.m.readFile(r);p=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,y.$hl)(P)!==1)throw P;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new $((0,f.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let P=!1;for(const j of p){h(j)||this.w(r);let O;if((0,a.$9f)(j.relativeLocation)&&j.relativeLocation)O=this.z(j.relativeLocation);else if((0,a.$9f)(j.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${j.location}`);continue}else{O=S.URI.revive(j.location);const R=this.y(O);R&&(P=!0,j.relativeLocation=R)}(0,a.$dg)(j.metadata?.hasPreReleaseVersion)&&j.metadata?.preRelease&&(P=!0,j.metadata.hasPreReleaseVersion=!0),l.push({identifier:j.identifier,location:O,version:j.version,metadata:j.metadata})}P&&await this.m.writeFile(r,C.$Ge.fromString(JSON.stringify(p)))}if(i){l=i(l);const P=l.map(j=>({identifier:j.identifier,version:j.version,location:j.location.toJSON(),relativeLocation:this.y(j.location),metadata:j.metadata}));await this.m.writeFile(r,C.$Ge.fromString(JSON.stringify(P)))}return l})}w(r){const i=new $(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(p){if((0,y.$hl)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(P=>h(P))?l=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$Ge.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,y.$hl)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,y.$hl)(p)!==1&&this.t.error(p)}try{await this.m.del(i)}catch(p){(0,y.$hl)(p)!==1&&this.t.error(p)}return l})()),this.C}F(r){let i=this.h.get(r);return i||(i=new s.$Dh,this.h.set(r,i)),i}};e.$rq=E,e.$rq=E=Fe([Ne(1,y.$3k),Ne(2,m.$Cl),Ne(3,u.$Al),Ne(4,c.$2l),Ne(5,b.$3j)],E);function h(o){return(0,a.$$f)(o)&&(0,w.$6o)(o.identifier)&&(t(o.location)||(0,a.$9f)(o.location)&&o.location)&&((0,a.$dg)(o.relativeLocation)||(0,a.$9f)(o.relativeLocation))&&o.version&&(0,a.$9f)(o.version)}function t(o){return o?(0,a.$9f)(o.path)&&(0,a.$9f)(o.scheme):!1}}),define(ye[59],Ee([1,0,18,14,21,15,11,43,181,2,13,7,3,19,57,65,10,4,194,26,38,40,82,16,5,12,29,6,54,50,33,34,226]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o,r,i,n,l,p,P,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$wq=e.$vq=e.$uq=e.Translations=void 0,e.$xq=ee;var A;(function(q){function X(_,M){if(_===M)return!0;const Q=Object.keys(_),ae=new Set;for(const ne of Object.keys(M))ae.add(ne);if(Q.length!==ae.size)return!1;for(const ne of Q){if(_[ne]!==M[ne])return!1;ae.delete(ne)}return ae.size===0}q.equals=X})(A||(e.Translations=A={})),e.$uq=(0,r.$wi)("IExtensionsScannerService");let B=class extends g.$Vc{constructor(X,_,M,Q,ae,ne,we,ie,Y,V,N,z){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=_,this.r=M,this.s=Q,this.t=ae,this.u=ne,this.w=we,this.y=ie,this.z=Y,this.C=V,this.D=N,this.F=z,this.g=this.B(new l.$ee),this.onDidChangeCache=this.g.event,this.h=(0,m.$0g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ce,this.s,this.h)),this.m=this.B(this.F.createInstance(ce,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Gp)(this.w,this.y)),this.G}async scanAllExtensions(X,_,M){const[Q,ae]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(_)]),ne=M?await this.scanExtensionsUnderDevelopment(X,[...Q,...ae]):[];return this.L(Q,ae,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const _=[];_.push(this.M(!!X.useCache,X.language)),_.push(this.N(X.language,!!X.checkControlFile));const[M,Q]=await Promise.all(_);return this.J([...M,...Q],0,X,!1)}async scanUserExtensions(X){const _=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const M=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,Q=await this.P(_,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,M,X.productVersion??this.R()),ae=X.useCache&&!Q.devMode&&Q.excludeObsolete?this.m:this.n;let ne;try{ne=await ae.scanExtensions(Q)}catch(we){if(we instanceof P.$pq&&we.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ae.scanExtensions(Q);else throw we}return ne=await this.J(ne,1,X,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(X,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(Q=>Q.scheme===y.Schemas.file).map(async Q=>{const ae=await this.P(Q,!1,1,!0,X.language,!1,void 0,X.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ae)).map(we=>(we.type=_.find(ie=>(0,E.$vp)(ie.identifier,we.identifier))?.type??we.type,this.n.validate(we,ae)))}))).flat();return this.J(M,"development",X,!0)}return[]}async scanExistingExtension(X,_,M){const Q=await this.P(X,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),ae=await this.n.scanExtension(Q);return!ae||!M.includeInvalid&&!ae.isValid?null:ae}async scanOneOrMultipleExtensions(X,_,M){const Q=await this.P(X,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),ae=await this.n.scanOneOrMultipleExtensions(Q);return this.J(ae,_,M,!0)}async scanMultipleExtensions(X,_,M){const Q=[];return await Promise.all(X.map(async ae=>{const ne=await this.scanOneOrMultipleExtensions(ae,_,M);Q.push(...ne)})),this.J(Q,_,M,!0)}async scanMetadata(X){const _=(0,m.$0g)(X,"package.json"),M=(await this.w.readFile(_)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(X,_){const M=(0,m.$0g)(X,"package.json"),Q=(await this.w.readFile(M)).value.toString(),ae=JSON.parse(Q);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,ae.__metadata={...ae.__metadata,..._},await this.w.writeFile((0,m.$0g)(X,"package.json"),k.$Ge.fromString(JSON.stringify(ae,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof P.$pq&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Ge.fromString(JSON.stringify([])))}catch(_){(0,o.$hl)(_)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,_,M,Q){return M.includeAllVersions||(X=this.L(_===0?X:void 0,_===1?X:void 0,_==="development"?X:void 0,await this.getTargetPlatform(),Q)),M.includeInvalid||(X=X.filter(ae=>ae.isValid)),X.sort((ae,ne)=>{const we=v.$oc(ae.location.fsPath),ie=v.$oc(ne.location.fsPath);return we<ie?-1:we>ie?1:0})}L(X,_,M,Q,ae){const ne=(ie,Y,V)=>{if(ie.isValid&&!Y.isValid)return!1;if(ie.isValid===Y.isValid){if(ae&&u.gt(ie.manifest.version,Y.manifest.version))return this.y.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(u.eq(ie.manifest.version,Y.manifest.version)){if(ie.type===0)return this.y.debug(`Skipping extension ${Y.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===Q)return this.y.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${ie.location.path} with ${Y.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${Y.location.path}.`),!0},we=new h.$Um;return X?.forEach(ie=>{const Y=we.get(ie.identifier.id);(!Y||ne(Y,ie,!1))&&we.set(ie.identifier.id,ie)}),_?.forEach(ie=>{const Y=we.get(ie.identifier.id);if(!Y&&X&&ie.type===0){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!Y||ne(Y,ie,!1))&&we.set(ie.identifier.id,ie)}),M?.forEach(ie=>{const Y=we.get(ie.identifier.id);(!Y||ne(Y,ie,!0))&&we.set(ie.identifier.id,ie),we.set(ie.identifier.id,ie)}),[...we.values()]}async M(X,_){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,_,!0,void 0,this.R()),ae=await(X&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",ae.length),ae}async N(X,_){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const Q=_?await this.O():{},ae=[],ne=c.URI.file(v.$ic(v.$kc(y.$Qg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of M){const Y=Q[ie.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":ae.push((0,m.$0g)(ne,ie.name));break;default:ae.push(c.URI.file(Y));break}}const we=await Promise.all(ae.map(async ie=>this.n.scanExtension(await this.P(ie,!1,0,!0,X,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",we.length),(0,s.$Hb)(we)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,_,M,Q,ae,ne,we,ie){const Y=await this.f(ae??b.$q),V=await this.Q(X),N=_&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,z=N?await this.Q(N):void 0;return new G(X,V,N,z,_,we,M,Q,ne,ie.version,ie.date,this.C.commit,!this.z.isBuilt,ae,Y)}async Q(X){try{const _=await this.w.stat(X);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$vq=B,e.$vq=B=Fe([Ne(4,j.$Cl),Ne(5,P.$qq),Ne(6,o.$3k),Ne(7,i.$3j),Ne(8,$.$Di),Ne(9,n.$jk),Ne(10,O.$Al),Ne(11,r.$vi)],B);class G{constructor(X,_,M,Q,ae,ne,we,ie,Y,V,N,z,Z,he,x){this.location=X,this.mtime=_,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=Q,this.profile=ae,this.profileScanOptions=ne,this.type=we,this.excludeObsolete=ie,this.validate=Y,this.productVersion=V,this.productDate=N,this.productCommit=z,this.devMode=Z,this.language=he,this.translations=x}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,_){return(0,m.$3g)(X.location,_.location)&&X.mtime===_.mtime&&(0,m.$3g)(X.applicationExtensionslocation,_.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&X.profile===_.profile&&D.$8n(X.profileScanOptions,_.profileScanOptions)&&X.type===_.type&&X.excludeObsolete===_.excludeObsolete&&X.validate===_.validate&&X.productVersion===_.productVersion&&X.productDate===_.productDate&&X.productCommit===_.productCommit&&X.devMode===_.devMode&&X.language===_.language&&A.equals(X.translations,_.translations)}}e.$wq=G;let se=class extends g.$Vc{constructor(X,_,M,Q,ae){super(),this.f=X,this.g=_,this.h=M,this.j=Q,this.m=ae}async scanExtensions(X){const _=X.profile?await this.r(X):await this.n(X);let M={};if(X.excludeObsolete&&X.type===1)try{const Q=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(Q)}catch{}return(0,f.$jg)(M)?_:_.filter(Q=>!M[E.$wp.create(Q).toString()])}async n(X){const _=await this.j.resolve(X.location);if(!_.children?.length)return[];const M=await Promise.all(_.children.map(async Q=>{if(!Q.isDirectory||X.type===1&&(0,m.$7g)(Q.resource).indexOf(".")===0)return null;const ae=new G(Q.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(ae)}));return(0,s.$Hb)(M).sort((Q,ae)=>Q.location.path<ae.location.path?-1:1)}async r(X){let _=await this.s(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){_=_.filter(Q=>!Q.metadata?.isApplicationScoped);const M=await this.s(X.applicationExtensionslocation,Q=>!!Q.metadata?.isBuiltin||!!Q.metadata?.isApplicationScoped,X);_.push(...M)}return _}async s(X,_,M){const Q=await this.g.scanProfileExtensions(X,M.profileScanOptions);if(!Q.length)return[];const ae=await Promise.all(Q.map(async ne=>{if(_(ne)){const we=new G(ne.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(we,ne.metadata)}return null}));return(0,s.$Hb)(ae)}async scanOneOrMultipleExtensions(X){try{if(await this.j.exists((0,m.$0g)(X.location,"package.json"))){const _=await this.scanExtension(X);return _?[_]:[]}else return await this.scanExtensions(X)}catch(_){return this.m.error(`Error scanning extensions at ${X.location.path}:`,(0,I.$0)(_)),[]}}async scanExtension(X,_){try{let M=await this.scanExtensionManifest(X.location);if(M){M.publisher||(M.publisher=h.$Om),_=_??M.__metadata,delete M.__metadata;const Q=(0,E.$Ap)(M.publisher,M.name),ae=_?.id?{id:Q,uuid:_.id}:{id:Q},ne=_?.isSystem?0:X.type,we=ne===0||!!_?.isBuiltin;M=await this.t(X.location,M,G.createNlsConfiguration(X));const ie={type:ne,identifier:ae,manifest:M,location:X.location,isBuiltin:we,targetPlatform:_?.targetPlatform??"undefined",publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return X.validate?this.validate(ie,X):ie}}catch(M){X.type!==0&&this.m.error(M)}return null}validate(X,_){let M=!0;const Q=(0,t.$Lp)(_.productVersion,_.productDate,_.location,X.manifest,X.isBuiltin);for(const[ae,ne]of Q)ae===a.default.Error&&(M=!1,this.m.error(this.z(_.location,ne)));return X.isValid=M,X.validations=Q,X}async scanExtensionManifest(X){const _=(0,m.$0g)(X,"package.json");let M;try{M=(await this.j.readFile(_)).value.toString()}catch(ae){return(0,o.$hl)(ae)!==1&&this.m.error(this.z(X,(0,d.localize)(0,null,_.path,ae.message))),null}let Q;try{Q=JSON.parse(M)}catch{const ne=[];(0,S.$Kn)(M,ne);for(const we of ne)this.m.error(this.z(X,(0,d.localize)(1,null,_.path,we.offset,we.length,(0,w.$sq)(we.error))));return null}return(0,S.$Tn)(Q)!=="object"?(this.m.error(this.z(X,(0,d.localize)(2,null,_.path))),null):Q}async t(X,_,M){const Q=await this.u(X,_,M);if(Q)try{const ae=[],ne=await this.w(Q.default,ae);if(ae.length>0)return ae.forEach(ie=>{this.m.error(this.z(X,(0,d.localize)(3,null,Q.default?.path,(0,w.$sq)(ie.error))))}),_;if((0,S.$Tn)(Q)!=="object")return this.m.error(this.z(X,(0,d.localize)(4,null,Q.default?.path))),_;const we=Q.values||Object.create(null);return(0,R.$tq)(this.m,_,we,ne)}catch{}return _}async u(X,_,M){const Q=(0,m.$0g)(X,"package.nls.json"),ae=(Y,V)=>{V.forEach(N=>{this.m.error(this.z(X,(0,d.localize)(5,null,Y?.path,(0,w.$sq)(N.error))))})},ne=Y=>{this.m.error(this.z(X,(0,d.localize)(6,null,Y?.path)))},we=`${_.publisher}.${_.name}`,ie=M.translations[we];if(ie)try{const Y=c.URI.file(ie),V=(await this.j.readFile(Y)).value.toString(),N=[],z=(0,S.$Kn)(V,N);return N.length>0?(ae(Y,N),{values:void 0,default:Q}):(0,S.$Tn)(z)!=="object"?(ne(Y),{values:void 0,default:Q}):{values:z.contents?z.contents.package:void 0,default:Q}}catch{return{values:void 0,default:Q}}else{if(!await this.j.exists(Q))return;let V;try{V=await this.y(X,M)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const N=(await this.j.readFile(V.localized)).value.toString(),z=[],Z=(0,S.$Kn)(N,z);return z.length>0?(ae(V.localized,z),{values:void 0,default:V.original}):(0,S.$Tn)(Z)!=="object"?(ne(V.localized),{values:void 0,default:V.original}):{values:Z,default:V.original}}catch{return{values:void 0,default:V.original}}}}async w(X,_){if(X)try{const M=(await this.j.readFile(X)).value.toString();return(0,S.$Kn)(M,_)}catch{}}y(X,_){return new Promise((M,Q)=>{const ae=ne=>{const we=(0,m.$0g)(X,`package.nls.${ne}.json`);this.j.exists(we).then(ie=>{ie&&M({localized:we,original:(0,m.$0g)(X,"package.nls.json")});const Y=ne.lastIndexOf("-");Y===-1?M({localized:(0,m.$0g)(X,"package.nls.json"),original:null}):(ne=ne.substring(0,Y),ae(ne))})};if(_.devMode||_.pseudo||!_.language)return M({localized:(0,m.$0g)(X,"package.nls.json"),original:null});ae(_.language)})}z(X,_){return`[${X.path}]: ${_}`}};se=Fe([Ne(1,P.$qq),Ne(2,O.$Al),Ne(3,o.$3k),Ne(4,i.$3j)],se);let ce=class extends se{constructor(X,_,M,Q,ae,ne,we){super(_,Q,ae,ne,we),this.G=X,this.H=M,this.D=this.B(new C.$uh(3e3)),this.F=this.B(new l.$ee),this.onDidChangeCache=this.F.event}async scanExtensions(X){const _=this.M(X),M=await this.I(_);if(this.C=X,M&&M.input&&G.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",X.location.toString()),this.D.trigger(()=>this.L()),M.result.map(ae=>(ae.location=c.URI.revive(ae.location),ae));const Q=await super.scanExtensions(X);return await this.J(_,{input:X,result:Q}),Q}async I(X){try{const _=await this.j.readFile(X),M=JSON.parse(_.value.toString());return{result:M.result,input:(0,p.$6h)(M.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",X.path,(0,I.$0)(_))}return null}async J(X,_){try{await this.j.writeFile(X,k.$Ge.fromString(JSON.stringify(_)))}catch(M){this.m.debug("Error while writing the extension cache file:",X.path,(0,I.$0)(M))}}async L(){if(!this.C)return;const X=this.M(this.C),_=await this.I(X);if(!_)return;const M=_.result,Q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$8n(Q,M))try{this.m.info("Invalidating Cache",M,Q),await this.j.del(X),this.F.fire()}catch(ae){this.m.error(ae)}}M(X){const _=this.N(X);return this.h.extUri.joinPath(_.cacheHome,X.type===0?h.$Nm:h.$Mm)}N(X){return X.type===0?this.H.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(X.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ce=Fe([Ne(2,j.$Cl),Ne(3,P.$qq),Ne(4,O.$Al),Ne(5,o.$3k),Ne(6,i.$3j)],ce);function ee(q,X){const _=(0,E.$yp)(q.manifest.publisher,q.manifest.name);return{id:_,identifier:new h.$Sm(_),isBuiltin:q.type===0,isUserBuiltin:q.type===1&&q.isBuiltin,isUnderDevelopment:X,extensionLocation:q.location,uuid:q.identifier.uuid,targetPlatform:q.targetPlatform,publisherDisplayName:q.publisherDisplayName,...q.manifest}}class K extends B{constructor(X,_,M,Q,ae,ne,we,ie,Y,V,N,z){super(X,_,(0,m.$0g)(M,".vscode-oss-dev","extensions","control.json"),Q,ae,ne,we,ie,Y,V,N,z),this.S=(async()=>{if(b.$t)try{const Z=await this.w.readFile(c.URI.file(b.$t));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}f(X){return this.S}}e.$yq=K}),define(ye[272],Ee([1,0,56,14,39,6,2,13,7,23,12,33]),function(ue,e,s,C,D,k,I,S,w,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;let b=class extends I.$Vc{constructor(u,a){super(),this.b=u,this.f=a,this.a=new C.$Ch(5)}async postUninstall(u){const a=this.g(u,"uninstall");a&&(this.f.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(a.script,"uninstall",a.args,!0,u),this.f.info("Finished running post uninstall script",u.identifier.id,u.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",u.identifier.id,u.manifest.version),this.f.error(f)}}));try{await g.Promises.rm(this.m(u))}catch(f){this.f.error("Error while removing extension storage path",u.identifier.id),this.f.error(f)}}g(u,a){const f=`vscode:${a}`;if(u.location.scheme===S.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const c=u.manifest.scripts[f].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,w.$kc)(u.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(u,a,f,c,d){return new Promise(($,E)=>{const h=this.j(u,a,f,d);let t;const o=r=>{t&&(clearTimeout(t),t=null),r?E(r):$(void 0)};h.on("error",r=>{o((0,D.$hj)(r)||"Unknown")}),h.on("exit",(r,i)=>{o(r?`post-${a} process exited with code ${r}`:void 0)}),c&&(t=setTimeout(()=>{t=null,h.kill(),E("timed out")},5e3))})}j(u,a,f,c){const d={silent:!0,execArgv:void 0},$=(0,s.fork)(u,[`--type=extension-post-${a}`,...f],d);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const E=k.Event.fromNodeEventEmitter($.stdout,"data"),h=k.Event.fromNodeEventEmitter($.stderr,"data");this.B(E(r=>this.f.info(c.identifier.id,c.manifest.version,`post-${a}`,r))),this.B(h(r=>this.f.error(c.identifier.id,c.manifest.version,`post-${a}`,r)));const t=k.Event.any(k.Event.map(E,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(h,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(c.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),$}m(u){return(0,w.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};e.$Aq=b,e.$Aq=b=Fe([Ne(0,v.$Cl),Ne(1,y.$3j)],b)}),define(ye[128],Ee([1,0,14,15,20,39,11,6,64,2,24,13,7,19,57,10,4,22,23,81,195,83,26,271,32,38,50,59,255,272,227,246,256,82,16,5,12,29,30,34,33]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o,r,i,n,l,p,P,j,O,R,A,B,G,se,ce,ee,K,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=void 0,e.$Eq=(0,G.$xi)(r.$0o);const X=".vsctmp";let _=class extends o.$mq{constructor(Y,V,N,z,Z,he,x,J,H,L,U,oe){super(Y,V,U,N,L,oe),this.eb=Z,this.fb=he,this.gb=x,this.hb=H,this.db=new Map,this.qb=new y.$Cc;const le=this.B(J.createInstance(P.$Aq));this.ab=this.B(J.createInstance(M,te=>le.postUninstall(te))),this.bb=this.B(new O.$Cq(oe,H,U,this,this.F)),this.cb=this.B(J.createInstance(p.$zq));const de=this.B(new R.$Dq(this,this.eb,oe,he,U,H,N));this.B(de.onDidChangeExtensionsByAnotherSource(te=>this.pb(te))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Gp)(this.hb,this.F)),this.ib}async zip(Y){this.F.trace("ExtensionManagementService#zip",Y.identifier.id);const V=await this.ob(Y),N=await(0,$.zip)((0,m.$0g)(this.cb.extensionsDownloadDir,(0,c.$Sg)()).fsPath,V);return f.URI.file(N)}async unzip(Y){return this.F.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:V,cleanup:N}=await this.kb(Y),z=b.$lc(V.fsPath);try{return await(0,j.$Bq)(z)}finally{await N()}}getInstalled(Y,V=this.H.defaultProfile.extensionsResource,N={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(Y??null,V,N)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.ab.scanUserExtensionAtLocation(Y)}async install(Y,V={}){this.F.trace("ExtensionManagementService#install",Y.toString());const{location:N,cleanup:z}=await this.kb(Y);try{const Z=await(0,j.$Bq)(b.$lc(N.fsPath)),he=(0,i.$Ap)(Z.publisher,Z.name);if(Z.engines&&Z.engines.vscode&&!(0,A.$Np)(Z.engines.vscode,this.G.version,this.G.date))throw new Error(E.localize(0,null,he,this.G.version));const J=(await this.I([{manifest:Z,extension:N,options:V}])).find(({identifier:H})=>(0,i.$vp)(H,{id:he}));if(J?.local)return J.local;throw J?.error?J.error:(0,o.$nq)(new Error(`Unknown error while installing extension ${he}`))}finally{await z()}}async installFromLocation(Y,V){this.F.trace("ExtensionManagementService#installFromLocation",Y.toString());const N=await this.ab.scanUserExtensionAtLocation(Y);if(!N||!N.manifest.name||!N.manifest.version)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.tb([[N,{source:"resource"}]],V),this.F.info("Successfully installed extension",N.identifier.id,V.toString()),N}async installExtensionsFromProfile(Y,V,N){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Y,V.toString(),N.toString());const z=(await this.getInstalled(1,V)).filter(Z=>Y.some(he=>(0,i.$vp)(he,Z.identifier)));if(z.length){const Z=await Promise.all(z.map(he=>this.ab.scanMetadata(he,V)));await this.tb(z.map((he,x)=>[he,Z[x]]),N),this.F.info("Successfully installed extensions",z.map(he=>he.identifier.id),N.toString())}return z}async updateMetadata(Y,V,N=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),Y=await this.ab.updateMetadata(Y,V,N),this.bb.invalidate(N),this.w.fire(Y),Y}async reinstallFromGallery(Y){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.z.isEnabled())throw new Error(E.localize(1,null));const V=await this.getTargetPlatform(),[N]=await this.z.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:V,compatible:!0},D.CancellationToken.None);if(!N)throw new Error(E.localize(2,null));await this.ab.setUninstalled(Y);try{await this.ab.removeUninstalledExtension(Y)}catch(z){throw new Error(E.localize(3,null,(0,k.$hj)(z)))}return this.installFromGallery(N)}$(Y,V,N,z){return this.ab.copyExtension(Y,V,N,z)}copyExtensions(Y,V){return this.ab.copyExtensions(Y,V,{version:this.G.version,date:this.G.date})}markAsUninstalled(...Y){return this.ab.setUninstalled(...Y)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(Y){this.F.error(Y)}}async download(Y,V,N){const{location:z}=await this.cb.download(Y,V,!N);return z}async kb(Y){if(Y.scheme===v.Schemas.file)return{location:Y,async cleanup(){}};this.F.trace("Downloading extension from",Y.toString());const V=(0,m.$0g)(this.cb.extensionsDownloadDir,(0,c.$Sg)());return await this.gb.download(Y,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.hb.del(V)}catch(z){this.F.error(z)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(Y,V,N){if(f.URI.isUri(V))return new ne(Y,V,N,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const z=i.$wp.create(V).toString();let Z=this.db.get(z);return Z||(this.db.set(z,Z=new ae(Y,V,N,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),Z.waitUntilTaskIsFinished().finally(()=>this.db.delete(z))),Z}Z(Y,V){return new we(Y,V.profileLocation,this.fb)}async ob(Y){const V=async z=>{let Z=await d.Promises.readdir(z);Z=Z.map(J=>b.$kc(z,J));const he=await Promise.all(Z.map(J=>d.Promises.stat(J)));let x=Promise.resolve([]);return he.forEach((J,H)=>{const L=Z[H];J.isFile()&&(x=x.then(U=>[...U,L])),J.isDirectory()&&(x=x.then(U=>V(L).then(oe=>[...U,...oe])))}),x};return(await V(Y.location.fsPath)).map(z=>({path:`extension/${b.$mc(Y.location.fsPath,z)}`,localPath:z}))}async pb({added:Y,removed:V}){if(V){const N=Y&&this.D.extUri.isEqual(V.profileLocation,Y.profileLocation)?V.extensions.filter(z=>Y.extensions.every(Z=>!(0,i.$vp)(Z,z))):V.extensions;for(const z of N)this.F.info("Extensions removed from another source",z.id,V.profileLocation.toString()),this.u.fire({identifier:z,profileLocation:V.profileLocation})}if(Y){const z=(await this.getInstalled(1,Y.profileLocation)).filter(Z=>Y.extensions.some(he=>(0,i.$vp)(he,Z.identifier)));this.s.fire(z.map(Z=>(this.F.info("Extensions added from another source",Z.identifier.id,Y.profileLocation.toString()),{identifier:Z.identifier,local:Z,profileLocation:Y.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(V=>this.qb.add(V)));const Y=await this.hb.resolve(this.eb.userExtensionsLocation);for(const V of Y.children??[])V.isDirectory&&this.qb.add(V.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(V=>this.sb(V)))}async sb(Y){if(!Y.affects(this.eb.userExtensionsLocation,1))return;const V=[];for(const N of Y.rawAdded){if(this.qb.has(N)||!this.D.extUri.isEqual(this.D.extUri.dirname(N),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(N,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(N).startsWith(".")||!(await this.hb.stat(N)).isDirectory)continue;const z=await this.ab.scanUserExtensionAtLocation(N);z&&z.installedTimestamp===void 0&&(this.qb.add(N),V.push(z))}V.length&&(await this.tb(V.map(N=>[N,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(N=>N.identifier.id)))}async tb(Y,V){const N=Y.map(z=>z[0]);await this.ub(N),await this.fb.addExtensionsToProfile(Y,V),this.s.fire(N.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:V})))}async ub(Y){const V=await this.ab.getUninstalledExtensions();for(const N of Y){const z=i.$wp.create(N);V[z.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",z.id),await this.ab.setInstalled(z),this.F.info("Removed the extension from uninstalled list:",z.id))}}};e.$Fq=_,e.$Fq=_=Fe([Ne(0,r.$7o),Ne(1,ee.$2l),Ne(2,se.$3j),Ne(3,t.$Ei),Ne(4,l.$uq),Ne(5,n.$qq),Ne(6,h.$Lo),Ne(7,G.$vi),Ne(8,B.$3k),Ne(9,ce.$jk),Ne(10,K.$Al),Ne(11,q.$Cl)],_);let M=class extends g.$Vc{constructor(Y,V,N,z,Z,he){super(),this.j=Y,this.m=V,this.n=N,this.s=z,this.t=Z,this.u=he,this.h=this.B(new S.$ee),this.onExtract=this.h.event,this.c=(0,m.$0g)(this.n.userExtensionsLocation,".obsolete"),this.g=new s.$Dh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Y,V,N){const z={includeInvalid:!0,profileLocation:V,productVersion:N};let Z=[];return Y===null||Y===0?Z.push(...await this.n.scanAllExtensions({includeInvalid:!0},z,!1)):Y===1&&Z.push(...await this.n.scanUserExtensions(z)),Z=Y!==null?Z.filter(he=>he.type===Y):Z,Promise.all(Z.map(he=>this.F(he)))}async scanAllUserExtensions(Y){const V=await this.n.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(V.map(N=>this.F(N)))}async scanUserExtensionAtLocation(Y){try{const V=await this.n.scanExistingExtension(Y,1,{includeInvalid:!0});if(V)return await this.F(V)}catch(V){this.u.error(V)}return null}async extractUserExtension(Y,V,N,z,Z){const he=Y.toString(),x=f.URI.file(b.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Sg)()}`)),J=f.URI.file(b.$kc(this.n.userExtensionsLocation.fsPath,he));let H=await this.m.exists(J);if(H&&z){try{await this.y(Y.id,J,"removeExisting")}catch{throw new r.$8o(E.localize(4,null,J.fsPath,Y.id),r.ExtensionManagementErrorCode.Delete)}H=!1}if(H)await this.n.updateMetadata(J,N);else try{try{this.u.trace(`Started extracting the extension from ${V} to ${J.fsPath}`),await(0,$.$kq)(V,x.fsPath,{sourcePath:"extension",overwrite:!0},Z),this.u.info(`Extracted extension to ${J}:`,Y.id)}catch(L){let U=r.ExtensionManagementErrorCode.Extract;throw L instanceof $.$iq&&(L.type==="CorruptZip"?U=r.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(U=r.ExtensionManagementErrorCode.IncompleteZip)),new r.$8o(L.message,U)}await this.n.updateMetadata(x,N);try{this.u.trace(`Started renaming the extension from ${x.fsPath} to ${J.fsPath}`),await this.C(x.fsPath,J.fsPath),this.u.info("Renamed to",J.fsPath)}catch(L){if(L.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(L)}. Deleted from extracted location`,x),L}this.h.fire(J)}catch(L){try{await this.m.del(x,{recursive:!0})}catch{}throw L}return this.D(J,1)}async scanMetadata(Y,V){return V?(await this.w(Y,V))?.metadata:this.n.scanMetadata(Y.location)}async w(Y,V){return(await this.s.scanProfileExtensions(V)).find(z=>(0,i.$vp)(z.identifier,Y.identifier))}async updateMetadata(Y,V,N){return N?await this.s.updateMetadata([[Y,V]],N):await this.n.updateMetadata(Y.location,V),this.D(Y.location,Y.type,N)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Y){const V=Y.map(N=>i.$wp.create(N));await this.z(N=>V.forEach(z=>{N[z.toString()]=!0,this.u.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(Y){await this.z(V=>delete V[Y.toString()])}async removeExtension(Y,V){if(this.t.extUri.isEqualOrParent(Y.location,this.n.userExtensionsLocation))return this.y(Y.identifier.id,Y.location,V)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.z(V=>delete V[i.$wp.create(Y).toString()])}async copyExtension(Y,V,N,z){const Z=await this.w(Y,V),he=await this.w(Y,N);if(z={...Z?.metadata,...z},he)if(this.t.extUri.isEqual(he.location,Y.location))await this.s.updateMetadata([[Y,{...he.metadata,...z}]],N);else{const x=await this.D(he.location,Y.type,N);await this.s.removeExtensionFromProfile(x,N),await this.s.addExtensionsToProfile([[Y,{...he.metadata,...z}]],N)}else await this.s.addExtensionsToProfile([[Y,z]],N);return this.D(Y.location,Y.type,N)}async copyExtensions(Y,V,N){const z=await this.scanExtensions(1,Y,N),Z=await Promise.all(z.filter(he=>!he.isApplicationScoped).map(async he=>[he,await this.scanMetadata(he,Y)]));await this.s.addExtensionsToProfile(Z,V)}async y(Y,V,N){this.u.trace(`Deleting ${N} extension from disk`,Y,V.fsPath);const z=this.t.extUri.joinPath(this.t.extUri.dirname(V),`${this.t.extUri.basename(V)}.${(0,w.$kj)((0,c.$Sg)()).toString(16)}${X}`);await this.C(V.fsPath,z.fsPath),await this.m.del(z,{recursive:!0}),this.u.info(`Deleted ${N} extension from disk`,Y,V.fsPath)}async z(Y){return this.g.queue(async()=>{let V;try{V=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,B.$hl)(z)!==1)throw z}let N={};if(V)try{N=JSON.parse(V)}catch{}return Y&&(Y(N),Object.keys(N).length?await this.m.writeFile(this.c,C.$Ge.fromString(JSON.stringify(N))):await this.m.del(this.c)),N})}async C(Y,V){try{await d.Promises.rename(Y,V,2*60*1e3)}catch(N){throw new r.$8o(N.message||E.localize(5,null,Y,V),N.code||r.ExtensionManagementErrorCode.Rename)}}async D(Y,V,N){if(N){const Z=(await this.n.scanUserExtensions({profileLocation:N})).find(he=>this.t.extUri.isEqual(he.location,Y));if(Z)return this.F(Z)}else{const z=await this.n.scanExistingExtension(Y,V,{includeInvalid:!0});if(z)return this.F(z)}throw new Error(E.localize(6,null,Y.path))}async F(Y){const V=await this.m.resolve(Y.location);let N,z;return V.children&&(N=V.children.find(({name:Z})=>/^readme(\.txt|\.md|)$/i.test(Z))?.resource,z=V.children.find(({name:Z})=>/^changelog(\.txt|\.md|)$/i.test(Z))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:N,changelogUrl:z,publisherDisplayName:Y.metadata?.publisherDisplayName,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!Y.metadata?.hasPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned,isWorkspaceScoped:!1,source:Y.metadata?.source??(Y.identifier.uuid?"gallery":"vsix")}}async G(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Y));const V=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const Z of V)Y[i.$wp.create(Z).toString()]||N.add(Z.identifier.id.toLowerCase());try{const Z=(0,i.$Bp)(V,he=>he.identifier);await s.Promises.settled(Z.map(async he=>{const x=he.sort((J,H)=>u.rcompare(J.manifest.version,H.manifest.version))[0];N.has(x.identifier.id.toLowerCase())||await this.j(await this.F(x))}))}catch(Z){this.u.error(Z)}const z=V.filter(Z=>Z.metadata&&Y[i.$wp.create(Z).toString()]);await Promise.allSettled(z.map(Z=>this.removeUninstalledExtension(Z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Y;try{Y=await this.m.resolve(this.n.userExtensionsLocation)}catch(V){(0,B.$hl)(V)!==1&&this.u.error(V);return}if(Y?.children)try{await Promise.allSettled(Y.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(X))){this.u.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.m.del(V.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(N){(0,B.$hl)(N)!==1&&this.u.error(N)}}}))}catch{}}};e.$Gq=M,e.$Gq=M=Fe([Ne(1,B.$3k),Ne(2,l.$uq),Ne(3,n.$qq),Ne(4,K.$Al),Ne(5,se.$3j)],M);class Q extends o.$oq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,a.$dg)(this.options.operation)?this.l:this.options.operation}constructor(Y,V,N,z,Z,he,x,J,H,L){super(),this.manifest=Y,this.identifier=V,this.source=N,this.options=z,this.m=Z,this.n=he,this.o=x,this.p=J,this.q=H,this.s=L,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Y){const[V,N]=await this.x(Y);return this.j=V.isBuiltin||V.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[V,N]],this.j,!V.isValid),V}async u({zipPath:Y,key:V,metadata:N},z,Z){let he=await this.v(V);return he?he=await this.m.updateMetadata(he,N):(this.s.trace("Extracting extension...",V.id),he=await this.m.extractUserExtension(V,Y,N,z,Z),this.s.info("Extracting extension completed.",V.id)),he}async v(Y){return await this.w(Y)?(this.s.trace("Removing the extension from uninstalled list:",Y.id),await this.m.setInstalled(Y),this.s.info("Removed the extension from uninstalled list:",Y.id),(await this.m.scanAllUserExtensions(!0)).find(z=>i.$wp.create(z).equals(Y))):void 0}async w(Y){return!!(await this.m.getUninstalledExtensions())[Y.toString()]}}class ae extends Q{constructor(Y,V,N,z,Z,he,x,J,H,L,U){super(Y,V.identifier,V,N,Z,he,x,J,H,L),this.y=V,this.z=z,this.A=U}async x(Y){let V;try{V=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(Z){throw new r.$8o(Z,r.ExtensionManagementErrorCode.Scanning)}const N=V.find(Z=>(0,i.$vp)(Z.identifier,this.y.identifier));N&&(this.l=3);const z={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:N?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??N?.pinned,preRelease:(0,a.$cg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||N?.preRelease,source:"gallery"};if(N&&N.type!==0&&N.manifest.version===this.y.version)try{return[await this.m.updateMetadata(N,z),z]}catch(Z){throw new r.$8o((0,I.$0)(Z),r.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(z,Y)}catch(Z){if(Z instanceof r.$8o&&(Z.code===r.ExtensionManagementErrorCode.CorruptZip||Z.code===r.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const he=await this.C(z,Y);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),he}catch(he){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),he}}else throw Z}}async C(Y,V){const{location:N,verificationStatus:z}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=z,this.D(N.fsPath),[await this.u({zipPath:N.fsPath,key:i.$wp.create(this.y),metadata:Y},!1,V),Y]}catch(Z){try{await this.z.delete(N)}catch(he){this.s.warn("Error while deleting the downloaded file",N.toString(),(0,I.$0)(he))}throw Z}}async D(Y){try{await(0,j.$Bq)(Y)}catch(V){throw new r.$8o(V.message,r.ExtensionManagementErrorCode.Invalid)}}}e.$Hq=ae;class ne extends Q{constructor(Y,V,N,z,Z,he,x,J,H,L){super(Y,{id:(0,i.$Ap)(Y.publisher,Y.name)},V,N,Z,he,x,J,H,L),this.y=V,this.z=z}async h(Y){const V=await super.h(Y);return this.C(V,Y),V}async x(Y){const V=new i.$wp(this.identifier,this.manifest.version),z=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(x=>(0,i.$vp)(this.identifier,x.identifier)),Z={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:"vsix"};if(z)if(this.l=3,V.equals(new i.$wp(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&u.gt(z.manifest.version,this.manifest.version)&&await this.m.setUninstalled(z);else{const x=await this.v(V);if(x)try{await this.m.removeExtension(x,"existing")}catch{throw new Error(E.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:b.$lc(this.y.fsPath),key:V,metadata:Z},!0,Y),Z]}async C(Y,V){try{let[N]=await this.z.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],V);if(N||([N]=await this.z.getExtensions([{id:Y.identifier.id}],V)),N){const z={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,hasPreReleaseVersion:Y.hasPreReleaseVersion||N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Y,z,this.options.profileLocation)}}catch{}}}class we extends o.$oq{constructor(Y,V,N){super(),this.extension=Y,this.j=V,this.k=N}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ye[129],Ee([1,0,12,33,34,30,50,16,26,4]),function(ue,e,s,C,D,k,I,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VQ=void 0;let y=class extends I.$rq{constructor(b,m,u,a,f,c){super(g.URI.file(b.extensionsPath),m,u,a,f,c)}};e.$VQ=y,e.$VQ=y=Fe([Ne(0,w.$Ei),Ne(1,S.$3k),Ne(2,C.$Cl),Ne(3,D.$Al),Ne(4,k.$2l),Ne(5,s.$3j)],y)}),define(ye[130],Ee([1,0,14,6,2,44,10,172,5,33]),function(ue,e,s,C,D,k,I,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$4p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2p=e.$1p=e.$Zp=void 0,e.$3p=m,e.$5p=a,e.$7p=c,e.$Zp="__$__isNewStorageMarker",e.$1p="__$__targetStorageMarker",e.$2p=(0,w.$wi)("storageService");var y;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var v;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var b;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function m(d){const $=d.get(e.$1p);if($)try{return JSON.parse($)}catch{}return Object.create(null)}class u extends D.$Vc{constructor($={flushInterval:u.a}){super(),this.m=$,this.b=this.B(new C.$he),this.c=this.B(new C.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new s.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,E,h){return C.Event.filter(this.b.event,t=>t.scope===$&&(E===void 0||t.key===E),h)}n(){this.j.value=(0,s.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,E){const{key:h,external:t}=E;if(h===e.$1p){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:h,target:this.J($)[h],external:t})}w($){this.f.fire({reason:$})}get($,E,h){return this.P(E)?.get($,h)}getBoolean($,E,h){return this.P(E)?.getBoolean($,h)}getNumber($,E,h){return this.P(E)?.getNumber($,h)}getObject($,E,h){return this.P(E)?.getObject($,h)}storeAll($,E){this.y(()=>{for(const h of $)this.store(h.key,h.value,h.scope,h.target,E)})}store($,E,h,t,o=!1){if((0,I.$fg)(E)){this.remove($,h,o);return}this.y(()=>{this.z($,h,t),this.P(h)?.set($,E,o)})}remove($,E,h=!1){this.y(()=>{this.z($,E,void 0),this.P(E)?.delete($,h)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,E){const h=[],t=this.J($);for(const o of Object.keys(t))t[o]===E&&h.push(o);return h}z($,E,h,t=!1){const o=this.J(E);typeof h=="number"?o[$]!==h&&(o[$]=h,this.P(E)?.set(e.$1p,JSON.stringify(o),t)):typeof o[$]=="number"&&(delete o[$],this.P(E)?.set(e.$1p,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const E=this.P($);return E?m(E):Object.create(null)}isNew($){return this.getBoolean(e.$Zp,$)===!0}async flush($=y.NONE){this.f.fire({reason:$});const E=this.P(-1),h=this.P(0),t=this.P(1);switch($){case y.NONE:await s.Promises.settled([E?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await s.Promises.settled([E?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return c($,E,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,E){return this.w(y.NONE),(0,g.$Bl)($)?this.R($,E):this.S($,E)}M($,E){return!($.id===E.id||a(E)&&a($))}N($,E,h){this.y(()=>{const t=new Set;for(const[o,r]of $)t.add(o),E.get(o)!==r&&this.u(h,{key:o,external:!0});for(const[o]of E.items)t.has(o)||this.u(h,{key:o,external:!0})})}}e.$4p=u,u.a=60*1e3;function a(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class f extends u{constructor(){super(),this.U=this.B(new S.$Xp(new S.$Yp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Xp(new S.$Yp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Xp(new S.$Yp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$6p=f;async function c(d,$,E,h,t,o){const r=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,n=new Map;d.forEach((A,B)=>{i.set(B,A),n.set(B,r(A))});const l=new Map,p=new Map;$.forEach((A,B)=>{l.set(B,A),p.set(B,r(A))});const P=new Map,j=new Map;E.forEach((A,B)=>{P.set(B,A),j.set(B,r(A))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const O=[];if(i.forEach((A,B)=>{O.push({key:B,value:A})}),console.table(O),console.groupEnd(),console.log(n),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];l.forEach((B,G)=>{A.push({key:G,value:B})}),console.table(A),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const R=[];P.forEach((A,B)=>{R.push({key:B,value:A})}),console.table(R),console.groupEnd(),console.log(j)}}),define(ye[131],Ee([1,0,18,20,11,3,31,10,4,25,26,32,38,82,16,12,29,42,257,130,30,63]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0,e.$0p=ne;const t=k.$i?"web":(0,v.$3o)(k.$o,I.$fc),o="X-Market-Search-Activity-Id";var r;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function i(...z){return String(z.reduce((Z,he)=>Z|he,0))}var n;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},p={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},j={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class O{constructor(Z=j){this.d=Z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(Z,he=this.d.pageSize){return new O({...this.d,pageNumber:Z,pageSize:he})}withFilter(Z,...he){const x=[...this.d.criteria,...he.length?he.map(J=>({filterType:Z,value:J})):[{filterType:Z}]];return new O({...this.d,criteria:x})}withSortBy(Z){return new O({...this.d,sortBy:Z})}withSortOrder(Z){return new O({...this.d,sortOrder:Z})}withFlags(...Z){return new O({...this.d,flags:Z.reduce((he,x)=>he|x,0)})}withAssetTypes(...Z){return new O({...this.d,assetTypes:Z})}withSource(Z){return new O({...this.d,source:Z})}get raw(){const{criteria:Z,pageNumber:he,pageSize:x,sortBy:J,sortOrder:H,flags:L,assetTypes:U}=this.d;return{filters:[{criteria:Z,pageNumber:he,pageSize:x,sortBy:J,sortOrder:H}],assetTypes:U,flags:L}}get searchText(){const Z=this.d.criteria.filter(he=>he.filterType===n.SearchText)[0];return Z&&Z.value?Z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(Z=>String(Z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(z,Z){const he=(z||[]).filter(x=>x.statisticName===Z)[0];return he?he.value:0}function A(z){const Z="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(x=>x.assetType.indexOf(Z)===0).reduce((x,J)=>{const H=se(z,J.assetType);return H&&x.push([J.assetType.substring(Z.length),H]),x},[])}function B(z){if(z.properties){const Z=z.properties.filter(J=>J.key===l.Repository),he=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=Z.filter(J=>he.test(J.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return se(z,l.Repository)}function G(z){return{uri:`${z.fallbackAssetUri}/${l.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${l.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function se(z,Z){return z.files.filter(x=>x.assetType===Z)[0]?{uri:`${z.assetUri}/${Z}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${Z}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function ce(z,Z){const he=z.properties?z.properties.filter(J=>J.key===Z):[],x=he.length>0&&he[0].value;return x?x.split(",").map(J=>(0,b.$zp)(J)):[]}function ee(z){const Z=z.properties?z.properties.filter(he=>he.key===p.Engine):[];return Z.length>0&&Z[0].value||""}function K(z){const Z=z.properties?z.properties.filter(he=>he.key===p.PreRelease):[];return Z.length>0&&Z[0].value==="true"}function q(z){const Z=z.properties?z.properties.filter(x=>x.key===p.LocalizedLanguages):[],he=Z.length>0&&Z[0].value||"";return he?he.split(","):[]}function X(z){return z.properties?.find(Z=>Z.key===p.SponsorLink)?.value}function _(z){return z.properties?.find(Z=>Z.key===p.SupportLink)?.value}function M(z){return z.indexOf("preview")!==-1}function Q(z){return z.targetPlatform?(0,v.$2o)(z.targetPlatform):"undefined"}function ae(z){const Z=(0,s.$Mb)(z.versions.map(Q)),he=!!z.tags?.includes(v.$Wo),x=Z.indexOf("web");return he?x===-1&&Z.push("web"):x!==-1&&Z.splice(x,1),Z}function ne(z,Z){for(let he=0;he<z.length;he++){const x=z[he];if(x.version===z[he-1]?.version){let J=he;if(Q(x)===Z)for(;J>0&&z[J-1].version===x.version;)J--;J!==he&&(z.splice(he,1),z.splice(J,0,x))}}return z}function we(z,Z,he){z.telemetryData={index:Z,querySource:he,queryActivityId:z.queryContext?.[o]}}function ie(z,Z,he,x){const J=z.versions[0],H={manifest:se(Z,l.Manifest),readme:se(Z,l.Details),changelog:se(Z,l.Changelog),license:se(Z,l.License),repository:B(Z),download:G(Z),icon:se(Z,l.Icon),signature:se(Z,l.Signature),coreTranslations:A(Z)};return{identifier:{id:(0,b.$Ap)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:Z.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,publisherSponsorLink:X(J),description:z.shortDescription??"",installCount:R(z.statistics,"install"),rating:R(z.statistics,"averagerating"),ratingCount:R(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:he,assets:H,properties:{dependencies:ce(Z,p.Dependency),extensionPack:ce(Z,p.ExtensionPack),engine:ee(Z),localizedLanguages:q(Z),targetPlatform:Q(Z),isPreReleaseVersion:K(Z)},hasPreReleaseVersion:K(J),hasReleaseVersion:!0,preview:M(z.flags),isSigned:!!H.signature,queryContext:x,supportLink:_(J)}}let Y=class{constructor(Z,he,x,J,H,L,U,oe){this.k=he,this.l=x,this.n=J,this.o=H,this.q=L,this.u=U,this.w=oe;const le=U.extensionsGallery,de=le?.servicePPEUrl&&oe.getValue("_extensionsGallery.enablePPE");this.d=de?le.servicePPEUrl:le?.serviceUrl,this.g=de?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,d.$9p)(U.version,U,this.n,this.w,this.q,Z,this.o)}x(Z=""){return`${this.d}${Z}`}isEnabled(){return!!this.d}async getExtensions(Z,he,x){const J=C.CancellationToken.isCancellationToken(he)?{}:he,H=C.CancellationToken.isCancellationToken(he)?he:x,L=[],U=[],oe=[],le=[];let de=!0;for(const pe of Z){pe.uuid?U.push(pe.uuid):L.push(pe.id);const Ce=!!(pe.version||pe.preRelease);oe.push({id:pe.id,uuid:pe.uuid,includePreRelease:Ce}),pe.version&&le.push({id:pe.id,uuid:pe.uuid,version:pe.version}),de=de&&!!pe.hasPreRelease&&!Ce}if(!U.length&&!L.length)return[];let te=new O().withPage(1,Z.length);U.length&&(te=te.withFilter(n.ExtensionId,...U)),L.length&&(te=te.withFilter(n.ExtensionName,...L)),(J.queryAllVersions||de)&&(te=te.withFlags(te.flags,r.IncludeVersions)),J.source&&(te=te.withSource(J.source));const{extensions:me}=await this.z(te,{targetPlatform:J.targetPlatform??t,includePreRelease:oe,versions:le,compatible:!!J.compatible,productVersion:J.productVersion??{version:this.u.version,date:this.u.date}},H);return J.source&&me.forEach((pe,Ce)=>we(pe,Ce,J.source)),me}async getCompatibleExtension(Z,he,x,J={version:this.u.version,date:this.u.date}){if((0,v.$4o)(Z.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(Z,he,x))return Z;const H=new O().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,Z.identifier.uuid),{extensions:L}=await this.z(H,{targetPlatform:x,compatible:!0,includePreRelease:he,productVersion:J},C.CancellationToken.None);return L[0]||null}async isExtensionCompatible(Z,he,x,J={version:this.u.version,date:this.u.date}){if(!(0,v.$5o)(Z.properties.targetPlatform,Z.allTargetPlatforms,x)||!he&&Z.properties.isPreReleaseVersion)return!1;let H=Z.properties.engine;if(!H){const L=await this.getManifest(Z,C.CancellationToken.None);if(!L)throw new Error("Manifest was not found");H=L.engines.vscode}return(0,m.$Np)(H,J.version,J.date)}async y(Z,he,x,J,H,L,U={version:this.u.version,date:this.u.date}){if(!(0,v.$5o)(Q(he),H,L)||x!=="any"&&K(he)!==(x==="prerelease"))return!1;if(J)try{const oe=await this.E(Z,he);if(!(0,m.$Np)(oe,U.version,U.date))return!1}catch(oe){return this.l.error(`Error while getting the engine for the version ${he.version}.`,(0,D.$0)(oe)),!1}return!0}async query(Z,he){let x=Z.text||"";const J=Z.pageSize??50;let H=new O().withPage(1,J);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,te,me)=>(H=H.withFilter(n.Category,me||te),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,te,me)=>(H=H.withFilter(n.Tag,me||te),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),H=H.withFilter(n.SearchText,x)),H=H.withSortBy(0)):Z.ids?H=H.withFilter(n.ExtensionId,...Z.ids):Z.names?H=H.withFilter(n.ExtensionName,...Z.names):H=H.withSortBy(4),typeof Z.sortBy=="number"&&(H=H.withSortBy(Z.sortBy)),typeof Z.sortOrder=="number"&&(H=H.withSortOrder(Z.sortOrder)),Z.source&&(H=H.withSource(Z.source));const L=async(de,te)=>{const{extensions:me,total:pe}=await this.z(de,{targetPlatform:t,compatible:!1,includePreRelease:!!Z.includePreRelease,productVersion:Z.productVersion??{version:this.u.version,date:this.u.date}},te);return me.forEach((Ce,je)=>we(Ce,(de.pageNumber-1)*de.pageSize+je,Z.source)),{extensions:me,total:pe}},{extensions:U,total:oe}=await L(H,he),le=async(de,te)=>{if(te.isCancellationRequested)throw new D.$5;const{extensions:me}=await L(H.withPage(de+1),te);return me};return{firstPage:U,total:oe,pageSize:H.pageSize,getPage:le}}async z(Z,he,x){const J=Z.flags;Z.flags&r.IncludeLatestVersionOnly&&Z.flags&r.IncludeVersions&&(Z=Z.withFlags(Z.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(Z.flags&r.IncludeLatestVersionOnly)&&!(Z.flags&r.IncludeVersions)&&(Z=Z.withFlags(Z.flags,r.IncludeLatestVersionOnly)),he.versions?.length&&(Z=Z.withFlags(Z.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),Z=Z.withFlags(Z.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:H,total:L,context:U}=await this.B(Z,x);if(!(Z.flags&r.IncludeLatestVersionOnly)){const te=[];for(const me of H){const pe=await this.A(me,he,U);pe&&te.push(pe)}return{extensions:te,total:L}}const le=[],de=new Map;for(let te=0;te<H.length;te++){const me=H[te],pe={id:(0,b.$Ap)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},Ce=(0,S.$cg)(he.includePreRelease)?he.includePreRelease:!!he.includePreRelease.find(ge=>(0,b.$vp)(ge,pe))?.includePreRelease;if(he.compatible&&(0,v.$4o)(ae(me),he.targetPlatform))continue;const je=await this.A(me,he,U);!je||je.properties.isPreReleaseVersion&&(!Ce||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==he.targetPlatform&&je.hasPreReleaseVersion?de.set(me.extensionId,te):le.push([te,je])}if(de.size){const te=new h.$ae,me=new O().withFlags(J&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,de.size).withFilter(n.ExtensionId,...de.keys()),{extensions:pe}=await this.z(me,he,x);this.o.publicLog2("galleryService:additionalQuery",{duration:te.elapsed(),count:de.size});for(const Ce of pe){const je=de.get(Ce.identifier.uuid);le.push([je,Ce])}}return{extensions:le.sort((te,me)=>te[0]-me[0]).map(([,te])=>te),total:L}}async A(Z,he,x){const J={id:(0,b.$Ap)(Z.publisher.publisherName,Z.extensionName),uuid:Z.extensionId},H=he.versions?.find(le=>(0,b.$vp)(le,J))?.version,L=(0,S.$cg)(he.includePreRelease)?he.includePreRelease:!!he.includePreRelease.find(le=>(0,b.$vp)(le,J))?.includePreRelease,U=ae(Z),oe=ne(Z.versions,he.targetPlatform);if(he.compatible&&(0,v.$4o)(U,he.targetPlatform))return null;for(let le=0;le<oe.length;le++){const de=oe[le];if(!(H&&de.version!==H)){if(await this.y((0,b.$Ap)(Z.publisher.publisherName,Z.extensionName),de,L?"any":"release",he.compatible,U,he.targetPlatform,he.productVersion))return ie(Z,de,U,x);if(H&&de.version===H)return null}}return H||he.compatible?null:ie(Z,Z.versions[0],U)}async B(Z,he){if(!this.isEnabled())throw new Error("No extension gallery service configured.");Z=Z.withFlags(Z.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(r.Unpublished));const x=await this.j,J=JSON.stringify(Z.raw),H={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},L=new h.$ae;let U,oe,le=0;try{if(U=await this.k.request({type:"POST",url:this.g&&Z.criteria.some(te=>te.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:H},he),U.res.statusCode&&U.res.statusCode>=400&&U.res.statusCode<500)return{galleryExtensions:[],total:le};const de=await(0,c.$Up)(U);if(de){const te=de.results[0],me=te.extensions,pe=te.resultMetadata&&te.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return le=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:le,context:{[o]:U.res.headers.activityid}}}return{galleryExtensions:[],total:le}}catch(de){const te=(0,D.$4)(de)?v.ExtensionGalleryErrorCode.Cancelled:(0,D.$0)(de).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw oe=new v.$9o((0,D.$0)(de),te),oe}finally{this.o.publicLog2("galleryService:query",{...Z.telemetryData,requestBodySize:String(J.length),duration:L.elapsed(),success:!!U&&(0,c.$Qp)(U),responseBodySize:U?.res.headers["Content-Length"],statusCode:U?String(U.res.statusCode):void 0,errorCode:oe?.code,count:String(le)})}}async reportStatistic(Z,he,x,J){if(!this.isEnabled())return;const H=k.$i?this.x(`/itemName/${Z}.${he}/version/${x}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${Z}/extensions/${he}/${x}/stats?statType=${J}`),L=k.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",oe={...await this.j,Accept:L};try{await this.k.request({type:"POST",url:H,headers:oe},C.CancellationToken.None)}catch{}}async download(Z,he,x){this.l.trace("ExtensionGalleryService#download",Z.identifier.id);const J=(0,b.$Dp)(Z),H=new Date().getTime(),L=te=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:te}),U=x===2?"install":x===3?"update":"",oe=U?{uri:`${Z.assets.download.uri}${w.URI.parse(Z.assets.download.uri).query?"&":"?"}${U}=true`,fallbackUri:`${Z.assets.download.fallbackUri}${w.URI.parse(Z.assets.download.fallbackUri).query?"&":"?"}${U}=true`}:Z.assets.download,le=Z.queryContext?.[o]?{[o]:Z.queryContext[o]}:void 0,de=await this.D(Z.identifier.id,oe,l.VSIX,le?{headers:le}:void 0);await this.q.writeFile(he,de.stream),L(new Date().getTime()-H)}async downloadSignatureArchive(Z,he){if(!Z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",Z.identifier.id);const x=await this.D(Z.identifier.id,Z.assets.signature,l.Signature);await this.q.writeFile(he,x.stream)}async getReadme(Z,he){if(Z.assets.readme){const x=await this.D(Z.identifier.id,Z.assets.readme,l.Details,{},he);return await(0,c.$Tp)(x)||""}return""}async getManifest(Z,he){if(Z.assets.manifest){const x=await this.D(Z.identifier.id,Z.assets.manifest,l.Manifest,{},he),J=await(0,c.$Tp)(x);return J?JSON.parse(J):null}return null}async C(Z,he,x){const J=se(he,l.Manifest);if(!J)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},L=await this.D(Z,J,l.Manifest,{headers:H});return await(0,c.$Up)(L)}async getCoreTranslation(Z,he){const x=Z.assets.coreTranslations.filter(J=>J[0]===he.toUpperCase())[0];if(x){const J=await this.D(Z.identifier.id,x[1],x[0]),H=await(0,c.$Tp)(J);return H?JSON.parse(H):null}return null}async getChangelog(Z,he){if(Z.assets.changelog){const x=await this.D(Z.identifier.id,Z.assets.changelog,l.Changelog,{},he);return await(0,c.$Tp)(x)||""}return""}async getAllCompatibleVersions(Z,he,x){let J=new O().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);Z.identifier.uuid?J=J.withFilter(n.ExtensionId,Z.identifier.uuid):J=J.withFilter(n.ExtensionName,Z.identifier.id);const{galleryExtensions:H}=await this.B(J,C.CancellationToken.None);if(!H.length)return[];const L=ae(H[0]);if((0,v.$4o)(L,x))return[];const U=[];await Promise.all(H[0].versions.map(async de=>{try{await this.y(Z.identifier.id,de,he?"any":"release",!0,L,x)&&U.push(de)}catch{}}));const oe=[],le=new Set;for(const de of ne(U,x))le.has(de.version)||(le.add(de.version),oe.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:K(de)}));return oe}async D(Z,he,x,J={},H=C.CancellationToken.None){const L=await this.j,U={type:"GET"},oe={...L,...J.headers||{}};J={...J,...U,headers:oe};const le=he.uri,de=he.fallbackUri,te={...J,url:le};try{const me=await this.k.request(te,H);if(me.res.statusCode===200)return me;const pe=await(0,c.$Tp)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${pe}`)}catch(me){if((0,D.$4)(me))throw me;const pe=(0,D.$0)(me);this.o.publicLog2("galleryService:cdnFallback",{extension:Z,assetType:x,message:pe});const Ce={...J,url:de};return this.k.request(Ce,H)}}async E(Z,he){let x=ee(he);if(!x){this.o.publicLog2("galleryService:engineFallback",{extension:Z,version:he.version});const J=await this.C(Z,he,C.CancellationToken.None);if(!J)throw new Error("Manifest was not found");x=J.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const Z=await this.k.request({type:"GET",url:this.h},C.CancellationToken.None);if(Z.res.statusCode!==200)throw new Error("Could not get extensions report.");const he=await(0,c.$Up)(Z),x=[],J={},H=[];if(he){for(const L of he.malicious)x.push({id:L});if(he.migrateToPreRelease)for(const[L,U]of Object.entries(he.migrateToPreRelease))(!U.engine||(0,m.$Np)(U.engine,this.u.version,this.u.date))&&(J[L.toLowerCase()]={disallowInstall:!0,extension:{id:U.id,displayName:U.displayName,autoMigrate:{storage:!!U.migrateStorage},preRelease:!0}});if(he.deprecated)for(const[L,U]of Object.entries(he.deprecated))U&&(J[L.toLowerCase()]=(0,S.$cg)(U)?{}:U);if(he.search)for(const L of he.search)H.push(L)}return{malicious:x,deprecated:J,search:H}}};Y=Fe([Ne(1,c.$Op),Ne(2,a.$3j),Ne(3,y.$Di),Ne(4,E.$2l),Ne(5,u.$3k),Ne(6,f.$jk),Ne(7,g.$3i)],Y);let V=class extends Y{constructor(Z,he,x,J,H,L,U,oe){super(Z,he,x,J,H,L,U,oe)}};e.$$p=V,e.$$p=V=Fe([Ne(0,$.$2p),Ne(1,c.$Op),Ne(2,a.$3j),Ne(3,y.$Di),Ne(4,E.$2l),Ne(5,u.$3k),Ne(6,f.$jk),Ne(7,g.$3i)],V);let N=class extends Y{constructor(Z,he,x,J,H,L,U){super(void 0,Z,he,x,J,H,L,U)}};e.$_p=N,e.$_p=N=Fe([Ne(0,c.$Op),Ne(1,a.$3j),Ne(2,y.$Di),Ne(3,E.$2l),Ne(4,u.$3k),Ne(5,f.$jk),Ne(6,g.$3i)],N)}),define(ye[273],Ee([1,0,6,2,33,55]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=void 0;class I{constructor(g,y){this.a=g,this.b=y}listen(g,y){const v=this.b(g);switch(y){case"onDidChangeProfiles":return s.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(m=>(0,k.$Bn)({...m},v)),added:b.added.map(m=>(0,k.$Bn)({...m},v)),removed:b.removed.map(m=>(0,k.$Bn)({...m},v)),updated:b.updated.map(m=>(0,k.$Bn)({...m},v))}))}throw new Error(`Invalid listen ${y}`)}async call(g,y,v){const b=this.b(g);switch(y){case"createProfile":{const m=await this.a.createProfile(v[0],v[1],v[2]);return(0,k.$Bn)({...m},b)}case"updateProfile":{let m=(0,D.$Dl)((0,k.$Cn)(v[0],b),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,v[1]),(0,k.$Bn)({...m},b)}case"removeProfile":{const m=(0,D.$Dl)((0,k.$Cn)(v[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${y}`)}}e.$3Q=I;class S extends C.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,y,v){super(),this.profilesHome=y,this.f=v,this.a=[],this.b=this.B(new s.$ee),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(b=>(0,D.$Dl)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const m=b.added.map(f=>(0,D.$Dl)(f,this.profilesHome.scheme)),u=b.removed.map(f=>(0,D.$Dl)(f,this.profilesHome.scheme)),a=b.updated.map(f=>(0,D.$Dl)(f,this.profilesHome.scheme));this.a=b.all.map(f=>(0,D.$Dl)(f,this.profilesHome.scheme)),this.b.fire({added:m,removed:u,updated:a,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,y,v){const b=await this.f.call("createNamedProfile",[g,y,v]);return(0,D.$Dl)(b,this.profilesHome.scheme)}async createProfile(g,y,v,b){const m=await this.f.call("createProfile",[g,y,v,b]);return(0,D.$Dl)(m,this.profilesHome.scheme)}async createTransientProfile(g){const y=await this.f.call("createTransientProfile",[g]);return(0,D.$Dl)(y,this.profilesHome.scheme)}async setProfileForWorkspace(g,y){await this.f.call("setProfileForWorkspace",[g,y])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,y){const v=await this.f.call("updateProfile",[g,y]);return(0,D.$Dl)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$4Q=S}),define(ye[132],Ee([1,0,4,26,16,12,250,34,33,10,251]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";var v,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=e.$TQ=e.$SQ=void 0;let m=v=class extends w.$Fl{constructor(c,d,$,E,h){super($,E,d,h),this.U=c,this.W=$}O(){return this.U.getItem(v.b,[]).map(d=>({...d,location:(0,g.$9f)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):s.URI.revive(d.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(s.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$SQ=m,m.a="profileAssociationsMigration",e.$SQ=m=v=Fe([Ne(0,I.$NQ),Ne(1,S.$Al),Ne(2,C.$Ei),Ne(3,D.$3k),Ne(4,k.$3j)],m);let u=b=class extends m{constructor(c,d,$,E,h){super(c,d,$,E,h),this.$=c}P(c){c.length?this.$.setItem(b.b,c.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(b.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(b.c,c):this.$.removeItem(b.c)}Q(){const c="workspaceAndProfileInfo",d=this.$.getItem(c,void 0);if(d){this.$.removeItem(c);const E=d.reduce((h,{workspace:t,profile:o})=>(h[s.URI.revive(t).toString()]=s.URI.revive(o).toString(),h),{});this.$.setItem(b.c,{workspaces:E})}const $=super.Q();return this.$.getItem(b.a,!1)||(this.R($),this.$.setItem(b.a,!0)),$}};e.$TQ=u,e.$TQ=u=b=Fe([Ne(0,I.$OQ),Ne(1,S.$Al),Ne(2,C.$Ei),Ne(3,D.$3k),Ne(4,k.$3j)],u);let a=class extends u{constructor(c,d,$,E){super(new y.$RQ(0,d,E,$),c,d,$,E)}async init(){return await this.$.init(),super.init()}};e.$UQ=a,e.$UQ=a=Fe([Ne(0,S.$Al),Ne(1,C.$Ei),Ne(2,D.$3k),Ne(3,k.$3j)],a)}),define(ye[133],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$jn=(0,s.$wi)("extensionHostStatusService");class C{constructor(){this.a=new Map}setExitInfo(k,I){this.a.set(k,I)}getExitInfo(k){return this.a.get(k)||null}}e.$kn=C}),define(ye[274],Ee([1,0,6,14]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0;function D(I){let S=0,w=0,g=0;I>=1e3&&(g=Math.floor(I/1e3),I-=g*1e3),g>=60&&(w=Math.floor(g/60),g-=w*60),w>=60&&(S=Math.floor(w/60),w-=S*60);const y=S?`${S}h`:"",v=w?`${w}m`:"",b=g?`${g}s`:"",m=I?`${I}ms`:"";return`${y}${v}${b}${m}`}class k{constructor(S,w,g,y){this.i=S,this.j=w,this.a=new s.$ee,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=g,this.protocol=y,this.e=!1,this.f=new C.$Jh(()=>{this.k(`The reconnection grace time of ${D(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new C.$Jh(()=>{this.k(`The reconnection short grace time of ${D(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${D(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(S){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${S}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${D(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const S=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),S.end(),this.a.fire(void 0)}acceptReconnection(S,w,g){this.d=S,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,g),this.protocol.endAcceptReconnection()}}e.$sn=k}),define(ye[94],Ee([1,0,27,13,7,167,58]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.InternalNLSConfiguration=void 0,e.$am=y;const S=D.$kc(C.$Qg.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function g(u){return new Promise(a=>s.exists(u,a))}function y(u,a){return g(S).then(f=>{if(!f||!I.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const c=`${u}||${a}`;let d=w.get(c);return d||(d=k.getNLSConfiguration(I.default.commit,a,S,u,u).then($=>(v.is($)&&($._languagePackSupport=!0),$.locale!=="en"&&$.locale!=="en-us"&&Object.keys($.availableLanguages).length===0&&w.delete(c),$)),w.set(c,d)),d})}var v;(function(u){function a(f){const c=f;return c&&typeof c._languagePackId=="string"}u.is=a})(v||(e.InternalNLSConfiguration=v={}));const b=async u=>{try{const a=m(await s.promises.readFile(u,"utf8"));return JSON.parse(a).locale}catch(a){return a.code!=="ENOENT"&&console.warn(a),"en"}};e.$bm=b;const m=u=>{const a=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return u.replace(a,(f,c,d,$,E)=>{if($)return"";if(E){const h=E.length;return h>2&&E[h-1]===`
`?E[h-2]==="\r"?`\r
`:`
`:""}else return f})}}),define(ye[134],Ee([1,0,19,4,26,50,59,16,5,12,29,34,33,94]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=void 0;let u=class extends I.$vq{constructor(f,c,d,$,E,h,t,o){super(C.URI.file(E.builtinExtensionsPath),C.URI.file(E.extensionsPath),(0,s.$0g)(E.userHome,".vscode-oss-dev","extensions","control.json"),f.defaultProfile,f,c,d,$,E,h,t,o),this.S=E}async f(f){const c=await(0,m.$am)(f,this.S.userDataPath);if(m.InternalNLSConfiguration.is(c))try{const d=await this.w.readFile(C.URI.file(c._translationsConfigFile));return JSON.parse(d.value.toString())}catch{}return Object.create(null)}};e.$HQ=u,e.$HQ=u=Fe([Ne(0,b.$Cl),Ne(1,k.$qq),Ne(2,S.$3k),Ne(3,g.$3j),Ne(4,D.$Ei),Ne(5,y.$jk),Ne(6,v.$Al),Ne(7,w.$vi)],u)}),define(ye[275],Ee([1,0,276,27,7,22,13,23]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.ServerConnectionTokenType=void 0,e.$wn=m,e.$xn=u,e.$yn=a;const w=/^[0-9A-Za-z_-]+$/;var g;(function(f){f[f.None=0]="None",f[f.Optional=1]="Optional",f[f.Mandatory=2]="Mandatory"})(g||(e.ServerConnectionTokenType=g={}));class y{constructor(){this.type=0}validate(c){return!0}}e.$tn=y;class v{constructor(c){this.value=c,this.type=2}validate(c){return c===this.value}}e.$un=v;class b{constructor(c){this.message=c}}e.$vn=b;async function m(f,c){const d=f["without-connection-token"],$=f["connection-token"],E=f["connection-token-file"];if(d)return typeof $<"u"||typeof E<"u"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new y;if(typeof E<"u"){if(typeof $<"u")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let h;try{h=C.readFileSync(E).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${E}'.`)}return w.test(h)?new v(h):new b(`The connection token defined in '${E} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof $<"u"?w.test($)?new v($):new b(`The connection token '${$} does not adhere to the characters 0-9, a-z, A-Z or -.`):new v(await c())}async function u(f){return m(f,async()=>{if(!f["user-data-dir"])return(0,k.$Sg)();const d=D.$kc(f["user-data-dir"],"token");try{const h=(await S.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(w.test(h))return h}catch{}const $=(0,k.$Sg)();try{await S.Promises.writeFile(d,$,{mode:384})}catch{}return $})}function a(f,c,d){if(f.validate(d.query[I.$Ig]))return!0;const $=s.parse(c.headers.cookie||"");return f.validate($[I.$Hg])}}),define(ye[51],Ee([1,0,213,110,67,5,26,74]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:s.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:s.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:s.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:s.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:s.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:s.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:s.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:s.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:s.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:s.localize(9,null)},"user-data-dir":D.$tm["user-data-dir"],"enable-smoke-test-driver":D.$tm["enable-smoke-test-driver"],"disable-telemetry":D.$tm["disable-telemetry"],"disable-workspace-trust":D.$tm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:D.$tm.log,logsPath:D.$tm.logsPath,"force-disable-user-env":D.$tm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:s.localize(10,null)},"default-workspace":{type:"string",description:s.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":D.$tm["extensions-dir"],"extensions-download-dir":D.$tm["extensions-download-dir"],"builtin-extensions-dir":D.$tm["builtin-extensions-dir"],"install-extension":D.$tm["install-extension"],"install-builtin-extension":D.$tm["install-builtin-extension"],"update-extensions":D.$tm["update-extensions"],"uninstall-extension":D.$tm["uninstall-extension"],"list-extensions":D.$tm["list-extensions"],"locate-extension":D.$tm["locate-extension"],"show-versions":D.$tm["show-versions"],category:D.$tm.category,force:D.$tm.force,"do-not-sync":D.$tm["do-not-sync"],"pre-release":D.$tm["pre-release"],"start-server":{type:"boolean",cat:"e",description:s.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:D.$tm.help,version:D.$tm.version,"locate-shell-integration-path":D.$tm["locate-shell-integration-path"],compatibility:{type:"string"},_:D.$tm._},e.$bn=(0,k.$xi)(I.$Di);class w extends C.$0m{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$cn=w,Fe([S.$1h],w.prototype,"userRoamingDataHome",null)}),define(ye[277],Ee([1,0,316,262,278,28]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=void 0;class I extends s.AppInsightsCore{constructor(w,g,y){super(),this.a=w,this.b=g,this.c=y}track(w){const g=w.baseData||{};g.properties||(g.properties={}),g.measurements||(g.measurements={});try{const y=k.cpus();g.measurements.cores=y.length,g.properties["common.cpuModel"]=y[0].model}catch{}try{g.measurements.memoryFree=k.freemem(),g.measurements.memoryTotal=k.totalmem()}catch{}try{g.properties["common.shell"]=k.userInfo().shell,g.properties["common.release"]=k.release(),g.properties["common.arch"]=k.arch()}catch{}g.properties["common.remoteMachineId"]=this.b,g.properties["common.isContainer"]=this.c;try{const y=(/^http:/.test(this.a)?D:C).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});y.on("error",()=>{}),y.write(JSON.stringify(g)),y.end()}catch{}}}e.$IQ=I}),define(ye[279],Ee([1,0,27,23,78,87,276,90,35,61,3,12,51,7,13,22,29,42,20,4,15,10,94]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=e.CacheControl=void 0,e.$8Q=r,e.$9Q=n;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(A,B,G,se){B.writeHead(G,{"Content-Type":"text/plain"}),B.end(se)}var i;(function(A){A[A.NO_CACHING=0]="NO_CACHING",A[A.ETAG=1]="ETAG",A[A.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function n(A,B,G,se,ce,ee){try{const K=await C.Promises.stat(A);if(B===1){const q=`W/"${[K.ino,K.size,K.mtime.getTime()].join("-")}"`;if(se.headers["if-none-match"]===q)return ce.writeHead(304),void ce.end();ee.Etag=q}else B===2?ee["Cache-Control"]="public, max-age=31536000":B===0&&(ee["Cache-Control"]="no-store");ee["Content-Type"]=o[(0,m.$pc)(A)]||(0,g.$Ts)(A)||"text/plain",ce.writeHead(200,ee),(0,s.createReadStream)(A).pipe(ce)}catch(K){return K.code!=="ENOENT"?(G.error(K),console.error(K.toString())):console.error(`File not found: ${A}`),ce.writeHead(404,{"Content-Type":"text/plain"}),void ce.end("Not found")}}const l=(0,m.$nc)(u.$Qg.asFileUri("").fsPath);let p=class{constructor(B,G,se,ce,ee,K,q){this.f=B,this.g=G,this.serverRootPath=se,this.h=ce,this.i=ee,this.j=K,this.k=q,this.a=this.k.extensionsGallery?.resourceUrlTemplate?$.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${se}/static`,this.c=`${se}/callback`,this.d="/web-extension-resource"}async handle(B,G,se){try{const ce=se.pathname;return ce.startsWith(this.b)&&ce.charCodeAt(this.b.length)===47?this.l(B,G,se):ce===this.g?this.o(B,G,se):ce===this.c?this.q(G):ce.startsWith(this.d)&&ce.charCodeAt(this.d.length)===47?this.n(B,G,se):r(B,G,404,"Not found.")}catch(ce){return this.i.error(ce),console.error(ce.toString()),r(B,G,500,"Internal Server Error.")}}async l(B,G,se){const ce=Object.create(null),K=decodeURIComponent(se.pathname).substring(this.b.length+1),q=(0,m.$kc)(l,K);return(0,w.$vg)(q,l,!y.$e)?n(q,this.h.isBuilt?2:1,this.i,B,G,ce):r(B,G,400,"Bad request.")}m(B){const G=B.authority.indexOf(".");return G!==-1?B.authority.substring(G+1):void 0}async n(B,G,se){if(!this.a)return r(B,G,500,"No extension gallery service configured.");const ce=decodeURIComponent(se.pathname),ee=(0,m.$ic)(ce.substring(this.d.length+1)),K=$.URI.parse(ee).with({scheme:this.a.scheme,authority:ee.substring(0,ee.indexOf("/")),path:ee.substring(ee.indexOf("/")+1)});if(this.m(this.a)!==this.m(K))return r(B,G,403,"Request Forbidden");const q={},X=we=>{const ie=B.headers[we];ie&&((0,h.$9f)(ie)||ie[0])?q[we]=(0,h.$9f)(ie)?ie:ie[0]:we!==we.toLowerCase()&&X(we.toLowerCase())};X("X-Client-Name"),X("X-Client-Version"),X("X-Machine-Id"),X("X-Client-Commit");const _=await this.j.request({type:"GET",url:K.toString(!0),headers:q},d.CancellationToken.None),M=_.res.statusCode||500;if(M!==200){let we=null;try{we=await(0,c.$Tp)(_)}catch{}return r(B,G,M,we||`Request failed with status ${M}`)}const Q=Object.create(null),ae=we=>{const ie=_.res.headers[we];ie?Q[we]=ie:we!==we.toLowerCase()&&ae(we.toLowerCase())};ae("Cache-Control"),ae("Content-Type"),G.writeHead(200,Q);const ne=await(0,E.$Se)(_.stream);return void G.end(ne.buffer)}async o(B,G,se){const ce=se.query[u.$Ig];if(typeof ce=="string"){const H=Object.create(null);H["Set-Cookie"]=I.serialize(u.$Hg,ce,{sameSite:"lax",maxAge:60*60*24*7});const L=Object.create(null);for(const oe in se.query)oe!==u.$Ig&&(L[oe]=se.query[oe]);const U=k.format({pathname:se.pathname,query:L});return H.Location=U,G.writeHead(302,H),void G.end()}const ee=!this.h.isBuilt&&this.h.args["use-test-resolver"],K=ee?"test+test":"remote";if(!K)return r(B,G,400,"Bad request.");function q(H){return JSON.stringify(H).replace(/"/g,"&quot;")}let X;this.h.args["enable-smoke-test-driver"]&&(X=!1);const _=H=>H&&$.URI.file(D.resolve(H)).with({scheme:u.Schemas.vscodeRemote,authority:K}),M=u.$Qg.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,Q=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,a.$Sg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ae=(0,e.$_Q)((0,e.$bR)(B)),ne=(0,e.$aR)((0,e.$bR)(B)),we={codeServerVersion:this.k.codeServerVersion,rootEndpoint:ae,updateEndpoint:this.h.args["disable-update-check"]?void 0:ae+"/update/check",logoutEndpoint:this.h.args.auth&&this.h.args.auth!=="none"?ae+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??ae+"/proxy/{{port}}/",serviceWorker:{scope:ne+"/",path:ae+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.k.enableTelemetry,telemetryEndpoint:this.k.telemetryEndpoint,embedderIdentifier:"server-distro",extensionsGallery:this.k.extensionsGallery};if(!this.h.isBuilt)try{const H=JSON.parse((await C.Promises.readFile((0,m.$kc)(l,"product.overrides.json"))).toString());Object.assign(we,H)}catch{}const ie={remoteAuthority:K,serverBasePath:this.g,webviewEndpoint:ne+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.h.userDataPath,isEnabledFileDownloads:!this.h.args["disable-file-downloads"],isEnabledFileUploads:!this.h.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.h.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:X,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:_(this.h.args["default-folder"]),workspaceUri:_(this.h.args["default-workspace"]),productConfiguration:we,callbackRoute:this.c},Y=this.h.args.locale||await(0,t.$bm)(this.h.argvResource.fsPath),V=await(0,t.$am)(Y,this.h.userDataPath),N=this.k.extensionsGallery?.nlsBaseUrl,z={WORKBENCH_WEB_CONFIGURATION:q(ie),WORKBENCH_AUTH_SESSION:Q?q(Q):"",WORKBENCH_WEB_BASE_URL:ne+this.b,WORKBENCH_NLS_BASE_URL:ne+(N?`${N}${N.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""),BASE:ae,VS_BASE:ne,NLS_CONFIGURATION:q(V)};if(ee){const H=[];for(const L of["vscode-test-resolver","github-authentication"]){const U=JSON.parse((await C.Promises.readFile(u.$Qg.asFileUri(`${u.$Lg}/${L}/package.json`).fsPath)).toString());H.push({extensionPath:L,packageJSON:U})}z.WORKBENCH_BUILTIN_EXTENSIONS=q(H)}let Z;try{Z=(await C.Promises.readFile(M)).toString().replace(/\{\{([^}]+)\}\}/g,(L,U)=>z[U]??"undefined")}catch{return G.writeHead(404,{"Content-Type":"text/plain"}),void G.end("Not found")}const J={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(Z).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(J["Set-Cookie"]=I.serialize(u.$Hg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),G.writeHead(200,J),void G.end(Z)}p(B){const G=/<script>([\s\S]+?)<\/script>/img,se=[];let ce;for(;ce=G.exec(B);){const ee=S.createHash("sha256"),K=ce[1].replace(/\r\n/g,`
`),q=ee.update(Buffer.from(K)).digest().toString("base64");se.push(`'sha256-${q}'`)}return se}async q(B){const G=u.$Qg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,se=(await C.Promises.readFile(G)).toString(),ce=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(se).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return B.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ce}),void B.end(se)}};e.$0Q=p,e.$0Q=p=Fe([Ne(3,b.$bn),Ne(4,v.$3j),Ne(5,c.$Op),Ne(6,f.$jk)],p);const P=(A,B=!1)=>A.replace(/\/\/+/g,"/").replace(/\/+$/,B?"/":"");e.$$Q=P;const j=A=>{const B=(A.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$$Q)("./"+(B>1?"../".repeat(B-1):""))};e.$_Q=j;const O=A=>{const B=A.split("?",1)[0].split("/");return(0,e.$$Q)("./"+B[B.length-1])};e.$aR=O;const R=A=>A.originalUrl||A.url;e.$bR=R}),define(ye[280],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0,e.$NP=(0,s.$wi)("IExtHostInitDataService")}),define(ye[281],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$xP=(0,s.$wi)("IExtHostRpcService");class C{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.dispose=k.dispose.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.$yP=C}),define(ye[71],Ee([1,0,55]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=D;function C(k){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:k,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function D(k){return new s.$zn(C(k))}}),define(ye[282],Ee([1,0,3,44,4,71,55,106,254,7,19]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;class v{constructor(m,u,a,f){this.b=m,this.c=u,this.d=a,this.e=f}async call(m,u,a){switch(u){case"getEnvironmentData":{const f=a,c=(0,k.$Cs)(f.remoteAuthority);let d=await this.f(f.profile);return d=(0,I.$Bn)(d,c),d}case"getExtensionHostExitInfo":{const f=a;return this.e.getExitInfo(f.reconnectionToken)}case"getDiagnosticInfo":{const f=a,c={machineInfo:(0,w.$Gs)()},d=f.includeProcesses?(0,S.$Es)(process.pid):Promise.resolve();let $=[];const E={};if(f.folders){const h=(0,k.$Cs)("");$=f.folders.map(o=>D.URI.revive(h.transformIncoming(o))).filter(o=>o.scheme==="file").map(o=>(0,w.$Fs)(o.fsPath,["node_modules",".git"]).then(r=>{E[(0,g.$oc)(o.fsPath)]=r}))}return Promise.all([d,...$]).then(([h,t])=>(c.processes=h||void 0,c.workspaceMetadata=f.folders?E:void 0,c))}}throw new Error(`IPC Command ${u} not found`)}listen(m,u,a){throw new Error("Not supported")}async f(m){m&&!this.d.profiles.some(a=>a.id===m)&&await this.d.createProfile(m,m);let u=!1;if(process.platform==="linux"){const a=process.glibcVersion;u=(a?parseInt(a.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:D.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$0g)(this.c.logsHome,`exthost${v.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:s.OS,arch:process.arch,marks:C.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(a=>({...a}))},isUnsupportedGlibc:u}}}e.$Js=v,v.a=1}),define(ye[283],Ee([1,0,4,71,69,7,240]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0;class S extends I.$Ks{constructor(y,v){super(new D.$ar(y),y),this.N=v,this.M=new Map,this.B(this.a)}c(y){let v=this.M.get(y.remoteAuthority);return v||(v=(0,C.$Cs)(y.remoteAuthority),this.M.set(y.remoteAuthority,v)),v}f(y,v,b=!1){if(b&&v.path==="/vscode-resource"&&v.query){const m=JSON.parse(v.query).requestResourcePath;return s.URI.from({scheme:"file",path:m})}return s.URI.revive(y.transformIncoming(v))}L(y,v){return new w(y,v,this.b,this.N)}}e.$Ms=S;class w extends I.$Ls{constructor(y,v,b,m){super(y,v,b,m)}j(y){const v=y.args["file-watcher-polling"];if(v){const b=v.split(k.$uc),m=Number(b[0]);if(m>0)return{usePolling:b.length>1?b.slice(1):!0,pollingInterval:m}}}m(y){if(y.extensionsPath)return[k.$hc.join(y.extensionsPath,"**")]}}}),define(ye[95],Ee([1,0,216,10,4,2,5,36,16,13,39,176,65]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=a,e.$zF=f,e.$AF=c,e.$BF=d,e.$CF=$,e.$DF=E,e.$EF=h,e.$FF=t,e.$GF=o,e.$JF=P,e.$KF=O,e.$LF=R,e.$MF=A,e.$NF=B,e.$OF=G,e.$PF=se,e.$QF=_,e.$SF=ae,e.$TF=we,e.$UF=ie,e.$VF=Y,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var m;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var u;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(u||(e.EditorPaneSelectionCompareResult=u={}));function a(V){const N=V;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}function f(V){const N=V;return!!N&&typeof N.getScrollPosition=="function"&&typeof N.setScrollPosition=="function"&&!!N.onDidChangeScroll}function c(V,N,z){for(const Z of z.visibleEditorPanes)if(Z.group.id===N&&V.matches(Z.input))return Z.getViewState()}function d(V){if(P(V))return!1;const N=V;return D.URI.isUri(N?.resource)}function $(V){if(P(V))return!1;const N=V;return N?.original!==void 0&&N.modified!==void 0}function E(V){if(P(V))return!1;const N=V;return!N||N.resources&&!Array.isArray(N.resources)?!1:!!N.resources||!!N.multiDiffSource}function h(V){if(P(V)||$(V))return!1;const N=V;return N?.primary!==void 0&&N.secondary!==void 0}function t(V){if(P(V))return!1;const N=V;return N?N.resource===void 0||N.resource.scheme===g.Schemas.untitled||N.forceUntitled===!0:!1}function o(V){if(P(V))return!1;const N=V;return D.URI.isUri(N?.base?.resource)&&D.URI.isUri(N?.input1?.resource)&&D.URI.isUri(N?.input2?.resource)&&D.URI.isUri(N?.result?.resource)}var r;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var i;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class n{constructor(){this.a=new Map}registerSource(N,z){let Z=this.a.get(N);return Z||(Z={source:N,label:z},this.a.set(N,Z)),Z.source}getSourceLabel(N){return this.a.get(N)?.label??N}}e.$HF=new n;var l;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors",V[V.Scratchpad=512]="Scratchpad"})(l||(e.EditorInputCapabilities=l={}));class p extends k.$Vc{}e.$IF=p;function P(V){return V instanceof p}function j(V){const N=V;return D.URI.isUri(N?.preferredResource)}function O(V){const N=V;return P(N?.primary)&&P(N?.secondary)}function R(V){const N=V;return P(N?.modified)&&P(N?.original)}function A(V,N,z,Z,he){return Y(Z,[(0,v.$gj)({id:"workbench.action.openLargeFile",label:(0,s.localize)(2,null),run:()=>{const x={...z,limits:{size:Number.MAX_VALUE}};V.openEditor(N,x)}}),(0,v.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(3,null),run:()=>he.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}function B(V){return P(V?.editor)}function G(V){const N=V;return B(V)&&N?.group!==void 0}function se(V){const N=V;return typeof N?.groupId=="number"&&P(N.editor)}var ce;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(ce||(e.EditorCloseContext=ce={}));var ee;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LABEL=2]="GROUP_LABEL",V[V.GROUP_LOCKED=3]="GROUP_LOCKED",V[V.EDITOR_OPEN=4]="EDITOR_OPEN",V[V.EDITOR_CLOSE=5]="EDITOR_CLOSE",V[V.EDITOR_MOVE=6]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=8]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=10]="EDITOR_PIN",V[V.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",V[V.EDITOR_STICKY=12]="EDITOR_STICKY",V[V.EDITOR_DIRTY=13]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(ee||(e.GroupModelChangeKind=ee={}));var K;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(K||(e.SideBySideEditor=K={}));class q{getOriginalUri(N,z){if(!N)return;if(o(N))return e.$RF.getOriginalUri(N.result,z);if(z?.supportSideBySide){const{primary:he,secondary:x}=this.a(N);if(he&&x){if(z?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(he,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===K.ANY)return this.getOriginalUri(he,{filterByScheme:z.filterByScheme})??this.getOriginalUri(x,{filterByScheme:z.filterByScheme});N=z.supportSideBySide===K.PRIMARY?he:x}}if($(N)||E(N)||h(N)||o(N))return;const Z=j(N)?N.preferredResource:N.resource;return!Z||!z||!z.filterByScheme?Z:this.b(Z,z.filterByScheme)}a(N){return O(N)||h(N)?{primary:N.primary,secondary:N.secondary}:R(N)||$(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,z){if(!N)return;if(o(N))return e.$RF.getCanonicalUri(N.result,z);if(z?.supportSideBySide){const{primary:he,secondary:x}=this.a(N);if(he&&x){if(z?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(he,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===K.ANY)return this.getCanonicalUri(he,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(x,{filterByScheme:z.filterByScheme});N=z.supportSideBySide===K.PRIMARY?he:x}}if($(N)||E(N)||h(N)||o(N))return;const Z=N.resource;return!Z||!z||!z.filterByScheme?Z:this.b(Z,z.filterByScheme)}b(N,z){if(Array.isArray(z)){if(z.some(Z=>N.scheme===Z))return N}else if(z===N.scheme)return N}}var X;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.KEYBOARD=1]="KEYBOARD",V[V.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function _(V,N,z,Z){if(!V.isSticky(N))return!1;switch(Z.preventPinnedEditorClose){case"keyboardAndMouse":return z===X.MOUSE||z===X.KEYBOARD;case"mouse":return z===X.MOUSE;case"keyboard":return z===X.KEYBOARD}return!1}e.$RF=new q;var M;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(M||(e.CloseDirection=M={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(N){const z=this.a=N.get(I.$vi);for(const[Z,he]of this.c)this.e(Z,he,z);this.c.clear()}e(N,z,Z){const he=Z.createInstance(z);this.d.set(N,he)}registerFileEditorFactory(N){if(this.b)throw new Error("Can only register one file editor factory.");this.b=N}getFileEditorFactory(){return(0,C.$hg)(this.b)}registerEditorSerializer(N,z){if(this.c.has(N)||this.d.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.a?this.e(N,z,this.a):this.c.set(N,z),(0,k.$Tc)(()=>{this.c.delete(N),this.d.delete(N)})}getEditorSerializer(N){return this.d.get(typeof N=="string"?N:N.typeId)}}S.$do.add(e.$tF.EditorFactory,new Q);async function ae(V,N,z){return!V||!V.length?[]:await Promise.all(V.map(async Z=>{const he=D.URI.revive(Z.fileUri);if(!he){z.info("Cannot resolve the path because it is not valid.",Z);return}if(!await N.canHandleResource(he)){z.info("Cannot resolve the path because it cannot be handled",Z);return}let J=Z.exists,H=Z.type;if(typeof J!="boolean"||typeof H!="number")try{H=(await N.stat(he)).isDirectory?w.FileType.Directory:w.FileType.Unknown,J=!0}catch(U){z.error(U),J=!1}if(!J&&Z.openOnlyIfExists){z.info("Cannot resolve the path because it does not exist",Z);return}if(H===w.FileType.Directory){z.info("Cannot resolve the path because it is a directory",Z);return}const L={...Z.options,pinned:!0};return J?{resource:he,options:L}:{resource:he,options:L,forceUntitled:!0}}))}var ne;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function we(V){const N=V;if(!N)return!1;const z=N;if(z.modified)return we(z.modified);const Z=N;return!!(Z.contributionsState&&Z.viewState&&Array.isArray(Z.cursorState))}function ie(V){return(0,y.$ij)(V)}function Y(V,N,z){const Z=(0,y.$jj)(V,N);return Z.forceMessage=z?.forceMessage,Z.forceSeverity=z?.forceSeverity,Z.allowDialog=z?.allowDialog,Z}}),define(ye[284],Ee([1,0,217,47]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new C.$Nj("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(0,null)}),e.$9F=new C.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(1,null)}),e.$0F=new C.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(2,null)}),e.$$F=new C.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(3,null)}),e.$_F=new C.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4,null)}),e.$aG=new C.$Nj("chatResponse",!1,{type:"boolean",description:(0,s.localize)(5,null)}),e.$bG=new C.$Nj("chatRequest",!1,{type:"boolean",description:(0,s.localize)(6,null)}),e.$cG=new C.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(7,null)}),e.$dG=new C.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(8,null)}),e.$eG=new C.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(9,null)}),e.$fG=new C.$Nj("inChatInput",!1,{type:"boolean",description:(0,s.localize)(10,null)}),e.$gG=new C.$Nj("inChat",!1,{type:"boolean",description:(0,s.localize)(11,null)}),e.$hG=new C.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(12,null)}),e.$iG=new C.$Nj("chatCursorAtTop",!1),e.$jG=new C.$Nj("chatInputHasAgent",!1),e.$kG=new C.$Nj("chatLocation",void 0)}),define(ye[285],Ee([1,0,14,20,6,41,2,155,17,47,5,12,29,42,130,284]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var c;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(c||(e.ChatAgentLocation=c={})),function(h){function t(o){switch(o){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=t}(c||(e.ChatAgentLocation=c={})),e.$iH=(0,y.$wi)("chatAgentService");let d=class{constructor(t){this.f=t,this.b=[],this.d=new D.$ee,this.onDidChangeAgents=this.d.event,this.e=a.$hG.bindTo(this.f)}registerAgent(t,o){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const i=this,n=o.slashCommands;o={...o,get slashCommands(){return n.filter(p=>!p.when||i.f.contextMatchesRules(g.$uj.deserialize(p.when)))}};const l={data:o};return this.b.push(l),(0,I.$Tc)(()=>{this.b=this.b.filter(p=>p!==l),this.d.fire(void 0)})}registerAgentImplementation(t,o){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=o,this.d.fire(new $(r.data,o)),(0,I.$Tc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,o){const r={data:t,impl:o};return this.b.push(r),this.d.fire(new $(t,o)),(0,I.$Tc)(()=>{this.b=this.b.filter(i=>i!==r),this.d.fire(void 0)})}updateAgent(t,o){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...o},this.d.fire(new $(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(o=>!!o.isDefault&&o.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(o=>!!o.isDefault&&o.locations.includes(t))}getSecondaryAgent(){return k.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(o=>o.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new $(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(o=>o.name===t)}async invokeAgent(t,o,r,i,n){const l=this.g(t);if(!l?.impl)throw new Error(`No activated agent with id ${t}`);return await l.impl.invoke(o,r,i,n)}async getFollowups(t,o,r,i,n){const l=this.g(t);if(!l?.impl)throw new Error(`No activated agent with id ${t}`);return l.impl?.provideFollowups?l.impl.provideFollowups(o,r,i,n):[]}};e.$jH=d,d.AGENT_LEADER="@",e.$jH=d=Fe([Ne(0,g.$Oj)],d);class ${constructor(t,o){this.b=t,this.d=o}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,o,r,i){return this.d.invoke(t,o,r,i)}async provideFollowups(t,o,r,i){return this.d.provideFollowups?this.d.provideFollowups(t,o,r,i):[]}provideWelcomeMessage(t,o){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,o)}provideSampleQuestions(t,o){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,o)}}e.$kH=$,e.$lH=(0,y.$wi)("chatAgentNameService");let E=f=class{constructor(t,o,r,i){if(this.g=o,this.h=r,this.i=i,this.e=(0,S.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const n=i.get(f.b,-1);try{this.e.set(JSON.parse(n??"{}"),void 0)}catch{i.remove(f.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,s.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const o=await(0,m.$Up)(t);if(!o||o.version!==1)throw new Error("Unexpected chat participant registry response.");const r=o.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(f.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(i=>(0,w.$yf)(i,i.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=E,E.b="chat.participantNameRegistry",e.$mH=E=f=Fe([Ne(0,b.$jk),Ne(1,m.$Op),Ne(2,v.$3j),Ne(3,u.$2p)],E)}),define(ye[286],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0,e.$1P=(0,s.$wi)("environmentVariableService")}),define(ye[287],Ee([1,0,7,4,62,3,126,10]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=w,e.$rQ=y,e.$sQ=m,e.$tQ=u,e.$uQ=a,e.$vQ=c,e.$wQ=d,e.$xQ=$,e.$yQ=E;function w(h,t){if(t)if(k.$c)for(const o in t){let r=o;for(const n in h)if(o.toLowerCase()===n.toLowerCase()){r=n;break}const i=t[o];i!==void 0&&g(h,r,i)}else Object.keys(t).forEach(o=>{const r=t[o];r!==void 0&&g(h,o,r)})}function g(h,t,o){typeof o=="string"?h[t]=o:delete h[t]}function y(h,t,o,r){h.TERM_PROGRAM="vscode",t&&(h.TERM_PROGRAM_VERSION=t),m(h,r)&&(h.LANG=u(o)),h.COLORTERM="truecolor"}function v(h,t){if(t)for(const o of Object.keys(t)){const r=t[o];r!=null&&(h[o]=r)}}async function b(h,t){return await Promise.all(Object.entries(t).map(async([o,r])=>{if(typeof r=="string")try{t[o]=await h(r)}catch{t[o]=r}})),t}function m(h,t){if(t==="on")return!0;if(t==="auto"){const o=h.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}function u(h){const t=h?h.split("-"):[],o=t.length;if(o===0)return"en_US.UTF-8";if(o===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in r&&t.push(r[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}async function a(h,t,o,r,i,n){if(h.cwd){const p=typeof h.cwd=="object"?h.cwd.fsPath:h.cwd,P=await f(p,o);return(0,I.$nQ)(P||p)}let l;return!h.ignoreConfigurationCwd&&i&&(o&&(i=await f(i,o,n)),i&&(s.$jc(i)?l=i:r&&(l=s.$kc(r.fsPath,i)))),l||(l=r?r.fsPath:t||""),(0,I.$nQ)(l)}async function f(h,t,o){if(t)try{return await t(h)}catch(r){o?.error("Could not resolve terminal cwd",r);return}return h}function c(h,t,o){if(o)return r=>o.resolveWithEnvironment(t,h,r)}async function d(h,t,o,r,i,n){const l={};if(h.strictEnv)v(l,h.env);else{v(l,n);const p={...t};o&&(p&&await b(o,p),h.env&&await b(o,h.env)),k.$d&&(l.VSCODE_NODE_OPTIONS&&(l.NODE_OPTIONS=l.VSCODE_NODE_OPTIONS,delete l.VSCODE_NODE_OPTIONS),l.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(l.NODE_REPL_EXTERNAL_MODULE=l.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete l.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,D.$nm)(l,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),w(l,p),w(l,h.env),y(l,r,k.$q,i)}return l}async function $(h,t,o,r,i,n,l=k.$c){let p;if((0,S.$9f)(h)?p=h:(p=h.fsPath,l&&n!==1?p=p.replace(/\\/g,"/"):!l&&n===1&&(p=p.replace(/\//g,"\\"))),!t)return p;const P=p.includes(" "),j=p.includes("(")||p.includes(")"),O=s.$oc(t,".exe"),R=O==="pwsh"||o==="pwsh"||O==="powershell"||o==="powershell";if(R&&(P||p.includes("'")))return`& '${p.replace(/'/g,"''")}'`;if(j&&R)return`& '${p}'`;if(n===1){if(r!==void 0)return r==="gitbash"?(0,I.$lQ)(p.replace(/\\/g,"/")):r==="wsl"?i?.getWslPath(p,"win-to-unix")||p:P?`"${p}"`:p;const A=t.toLowerCase();return A.includes("wsl")||A.includes("bash.exe")&&!A.toLowerCase().includes("git")?i?.getWslPath(p,"win-to-unix")||p:P?`"${p}"`:p}return(0,I.$lQ)(p)}function E(h,t,o){const r=typeof h=="string"?C.URI.parse(h):h;let i=r?t.getWorkspaceFolder(r)??void 0:void 0;if(!i){const n=o.getLastActiveWorkspaceRoot();i=n?t.getWorkspaceFolder(n)??void 0:void 0}return i}}),define(ye[72],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(k){k.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var C;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class D{static fromExtHostTestItem(I,S,w=I.parent){if(I._isRoot)return new D([S]);const g=[I.id];for(let y=w;y&&y.id!==S;y=y.parent)g.push(y.id);return g.push(S),new D(g.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const S=I.indexOf("\0");return S===-1?I:I.slice(0,S)}static fromString(I){return new D(I.split("\0"))}static join(I,S){return new D([...I.path,S])}static joinToString(I,S){return I.toString()+"\0"+S}static parentId(I){const S=I.lastIndexOf("\0");return S===-1?void 0:I.slice(0,S)}static localId(I){const S=I.lastIndexOf("\0");return S===-1?I:I.slice(S+1)}static isChild(I,S){return S.startsWith(I)&&S[I.length]==="\0"}static compare(I,S){return I===S?0:D.isChild(I,S)?2:D.isChild(S,I)?3:1}constructor(I,S=I.length){if(this.path=I,this.d=S,I.length===0||S<1)throw new Error("cannot create test with empty path")}get rootId(){return new D(this.path,1)}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new D(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new D(this.path,I)}compare(I){if(typeof I=="string")return D.compare(this.toString(),I);for(let S=0;S<I.d&&S<this.d;S++)if(I.path[S]!==this.path[S])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.$VL=D}),define(ye[96],Ee([1,0,4,80,46,72]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$3L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2L=e.$1L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YL=e.$XL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$WL=e.TestResultState=void 0;var I;(function(ee){ee[ee.Unset=0]="Unset",ee[ee.Queued=1]="Queued",ee[ee.Running=2]="Running",ee[ee.Passed=3]="Passed",ee[ee.Failed=4]="Failed",ee[ee.Skipped=5]="Skipped",ee[ee.Errored=6]="Errored"})(I||(e.TestResultState=I={})),e.$WL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var S;(function(ee){ee[ee.Run=1]="Run",ee[ee.Debug=2]="Debug",ee[ee.Coverage=3]="Coverage"})(S||(e.ExtTestRunProfileKind=S={}));var w;(function(ee){ee[ee.Run=2]="Run",ee[ee.Debug=4]="Debug",ee[ee.Coverage=8]="Coverage",ee[ee.HasNonDefaultProfile=16]="HasNonDefaultProfile",ee[ee.HasConfigurable=32]="HasConfigurable",ee[ee.SupportsContinuousRun=64]="SupportsContinuousRun"})(w||(e.TestRunProfileBitset=w={})),e.$XL=[2,4,8,16,32,64];const g=ee=>"runId"in ee;e.$YL=g;var y;(function(ee){ee.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),ee.deserialize=(K,q)=>({range:D.$vt.lift(q.range),uri:K.asCanonicalUri(s.URI.revive(q.uri))})})(y||(e.IRichLocation=y={}));var v;(function(ee){ee[ee.Error=0]="Error",ee[ee.Output=1]="Output"})(v||(e.TestMessageType=v={}));var b;(function(ee){ee.serialize=K=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&y.serialize(K.location)}),ee.deserialize=(K,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&y.deserialize(K,q.location)})})(b||(e.ITestErrorMessage=b={}));const m=(ee,K)=>`${K?"s":"e"}${ee}`;e.$ZL=m;var u;(function(ee){ee.serialize=K=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&y.serialize(K.location)}),ee.deserialize=(K,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&y.deserialize(K,q.location)})})(u||(e.ITestOutputMessage=u={}));var a;(function(ee){ee.serialize=K=>K.type===0?b.serialize(K):u.serialize(K),ee.deserialize=(K,q)=>q.type===0?b.deserialize(K,q):u.deserialize(K,q)})(a||(e.ITestMessage=a={}));var f;(function(ee){ee.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),ee.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(a.serialize)}),ee.deserialize=(K,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(X=>a.deserialize(K,X))})})(f||(e.ITestTaskState=f={}));const c="\0",d=(ee,K)=>ee+c+K;e.$1L=d;const $=ee=>{const K=ee.indexOf(c);return{ctrlId:ee.slice(0,K),tagId:ee.slice(K+1)}};e.$2L=$;var E;(function(ee){ee.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),ee.deserialize=(K,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?K.asCanonicalUri(s.URI.revive(q.uri)):void 0,range:q.range?D.$vt.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(E||(e.ITestItem=E={}));var h;(function(ee){ee[ee.NotExpandable=0]="NotExpandable",ee[ee.Expandable=1]="Expandable",ee[ee.BusyExpanding=2]="BusyExpanding",ee[ee.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(ee){ee.serialize=K=>({expand:K.expand,item:E.serialize(K.item)}),ee.deserialize=(K,q)=>({controllerId:k.$VL.root(q.item.extId),expand:q.expand,item:E.deserialize(K,q.item)})})(t||(e.InternalTestItem=t={}));var o;(function(ee){ee.serialize=K=>{let q;return K.item&&(q={},K.item.label!==void 0&&(q.label=K.item.label),K.item.tags!==void 0&&(q.tags=K.item.tags),K.item.busy!==void 0&&(q.busy=K.item.busy),K.item.uri!==void 0&&(q.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(q.range=K.item.range?.toJSON()),K.item.description!==void 0&&(q.description=K.item.description),K.item.error!==void 0&&(q.error=K.item.error),K.item.sortText!==void 0&&(q.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:q}},ee.deserialize=K=>{let q;return K.item&&(q={},K.item.label!==void 0&&(q.label=K.item.label),K.item.tags!==void 0&&(q.tags=K.item.tags),K.item.busy!==void 0&&(q.busy=K.item.busy),K.item.range!==void 0&&(q.range=K.item.range?D.$vt.lift(K.item.range):null),K.item.description!==void 0&&(q.description=K.item.description),K.item.error!==void 0&&(q.error=K.item.error),K.item.sortText!==void 0&&(q.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:q}}})(o||(e.ITestItemUpdate=o={}));const r=(ee,K)=>{K.expand!==void 0&&(ee.expand=K.expand),K.item!==void 0&&(ee.item=ee.item?Object.assign(ee.item,K.item):K.item)};e.$3L=r;var i;(function(ee){ee.serializeWithoutMessages=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(f.serializeWithoutMessages)}),ee.serialize=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(f.serialize)}),ee.deserialize=(K,q)=>({...t.deserialize(K,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(X=>f.deserialize(K,X)),retired:!0})})(i||(e.TestResultItem=i={}));var n;(function(ee){ee.empty=()=>({covered:0,total:0}),ee.sum=(K,q)=>{K.covered+=q.covered,K.total+=q.total}})(n||(e.ICoverageCount=n={}));var l;(function(ee){ee.serialize=K=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:K.uri.toJSON()}),ee.deserialize=(K,q)=>({id:q.id,statement:q.statement,branch:q.branch,declaration:q.declaration,uri:K.asCanonicalUri(s.URI.revive(q.uri))})})(l||(e.IFileCoverage=l={}));function p(ee){return{...ee,location:ee.location?.toJSON()}}function P(ee){return ee.location=ee.location?C.$ut.isIPosition(ee.location)?C.$ut.lift(ee.location):D.$vt.lift(ee.location):void 0,ee}e.$4L=3;var j;(function(ee){ee[ee.Declaration=0]="Declaration",ee[ee.Statement=1]="Statement",ee[ee.Branch=2]="Branch"})(j||(e.DetailType=j={}));var O;(function(ee){ee.serialize=K=>K.type===0?A.serialize(K):B.serialize(K),ee.deserialize=K=>K.type===0?A.deserialize(K):B.deserialize(K)})(O||(e.CoverageDetails=O={}));var R;(function(ee){ee.serialize=p,ee.deserialize=P})(R||(e.IBranchCoverage=R={}));var A;(function(ee){ee.serialize=p,ee.deserialize=P})(A||(e.IDeclarationCoverage=A={}));var B;(function(ee){ee.serialize=K=>({...p(K),branches:K.branches?.map(R.serialize)}),ee.deserialize=K=>({...P(K),branches:K.branches?.map(R.deserialize)})})(B||(e.IStatementCoverage=B={}));var G;(function(ee){ee[ee.Add=0]="Add",ee[ee.Update=1]="Update",ee[ee.DocumentSynced=2]="DocumentSynced",ee[ee.Remove=3]="Remove",ee[ee.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",ee[ee.Retire=5]="Retire",ee[ee.AddTag=6]="AddTag",ee[ee.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var se;(function(ee){ee.deserialize=(K,q)=>q.op===0?{op:q.op,item:t.deserialize(K,q.item)}:q.op===1?{op:q.op,item:o.deserialize(q.item)}:q.op===2?{op:q.op,uri:K.asCanonicalUri(s.URI.revive(q.uri)),docv:q.docv}:q,ee.serialize=K=>K.op===0?{op:K.op,item:t.serialize(K.item)}:K.op===1?{op:K.op,item:o.serialize(K.item)}:K})(se||(e.TestsDiffOp=se={}));class ce{constructor(K){this.k=K,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(K){const q=this.v();for(const X of K)switch(X.op){case 0:this.l(t.deserialize(this.k,X.item),q);break;case 1:this.o(o.deserialize(X.item),q);break;case 3:this.p(X.itemId,q);break;case 5:this.q(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}q.complete?.()}l(K,q){const X=k.$VL.parentId(K.item.extId)?.toString();let _;if(!X)_=this.w(K),this.g.add(_),this.f.set(K.item.extId,_);else if(this.f.has(X)){const M=this.f.get(X);M.children.add(K.item.extId),_=this.w(K,M),this.f.set(K.item.extId,_)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return q.add?.(_),K.expand===2&&this.h++,_}o(K,q){const X=this.f.get(K.extId);if(X)return K.expand!==void 0&&(X.expand===2&&this.h--,K.expand===2&&this.h++),(0,e.$3L)(X,K),q.update?.(X),X}p(K,q){const X=this.f.get(K);if(!X)return;const _=k.$VL.parentId(X.item.extId)?.toString();_?this.f.get(_).children.delete(X.item.extId):this.g.delete(X);const M=[[K]];for(;M.length;)for(const Q of M.pop()){const ae=this.f.get(Q);ae&&(M.push(ae.children),this.f.delete(Q),q.remove?.(ae,ae!==X),ae.expand===2&&this.h--)}}q(K){}updatePendingRoots(K){this.j+=K}v(){return{}}}e.$5L=ce}),define(ye[135],Ee([1,0,14,6,2,98,96,72]),function(ue,e,s,C,D,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.TestItemEventOp=void 0;var w;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const g=(d,$)=>d===$,v=Object.entries({range:(d,$)=>d===$?!0:!d||!$?!1:d.equalsRange($),busy:g,label:g,description:g,error:g,sortText:g,tags:(d,$)=>!(d.length!==$.length||d.some(E=>!$.includes(E)))}),b=(d,$)=>{let E;for(const[h,t]of v)t(d[h],$[h])||(E?E[h]=$[h]:E={[h]:$[h]});return E};class m extends D.$Vc{get root(){return this.s.root}constructor($){super(),this.s=$,this.f=this.B(new s.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new C.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler($){this.h=$;for(const E of this.tree.values())this.J(E)}get resolveHandler(){return this.h}collectDiff(){const $=this.m;return this.m=[],$}pushDiff($){switch($.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===$.uri){E.docv=$.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===$.item.extId){(0,I.$3L)(E.item,$.item);return}if(E.op===0&&E.item.item.extId===$.item.extId){(0,I.$3L)(E.item,$.item);return}}break}}this.m.push($),this.f.isScheduled()||this.f.schedule()}expand($,E){const h=this.tree.get($);if(h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,E-1):t.wait().then(()=>this.L(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,E-1)):this.L(h,E-1)}}dispose(){for(const $ of this.tree.values())this.s.getApiFor($.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w($,E){switch(E.op){case 3:this.O(S.$VL.joinToString($.fullId,E.id));break;case 0:this.z(E.item,$);break;case 5:for(const h of E.ops)this.w($,h);break;case 1:this.C(E.new,E.old,$.fullId.toString());break;case 2:this.J($);break;case 4:this.pushDiff({op:1,item:{extId:$.fullId.toString(),item:E.update}});break;case 6:this.y($.actual.uri);break;default:(0,k.$fd)(E)}}y($){$&&this.pushDiff({op:2,uri:$,docv:this.s.getDocumentVersion($)})}z($,E){const h=S.$VL.fromExtHostTestItem($,this.root.id,E?.actual),t=this.s.getApiFor($);t.parent&&t.parent!==E?.actual&&this.s.getChildren(t.parent).delete($.id);let o=this.tree.get(h.toString());if(!o){o={fullId:h,actual:$,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},$.tags.forEach(this.D,this),this.tree.set(o.fullId.toString(),o),this.G($,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem($)}}),this.I($,o,E);return}if(o.actual===$){this.H($,o,E);return}if(o.actual.uri?.toString()!==$.uri?.toString())return this.O(h.toString()),this.z($,E);const r=this.s.getChildren(o.actual),i=o.actual,n=b(this.s.toITestItem(i),this.s.toITestItem($));this.s.getApiFor(i).listener=void 0,o.actual=$,o.resolveBarrier=void 0,o.expand=0,n&&(n.hasOwnProperty("tags")&&(this.C($.tags,i.tags,h.toString()),delete n.tags),this.w(o,{op:4,update:n})),this.I($,o,E);for(const[p,P]of r)this.s.getChildren($).get(P.id)||this.O(S.$VL.joinToString(h,P.id));const l=o.expandLevels;l!==void 0&&queueMicrotask(()=>{o.expand===1&&(o.expandLevels=void 0,this.expand(h.toString(),l))}),this.y(o.actual.uri)}C($,E,h){const t=new Set(E.map(o=>o.id));for(const o of $)t.delete(o.id)||this.D(o);this.pushDiff({op:1,item:{extId:h,item:{tags:$.map(o=>(0,I.$1L)(this.s.controllerId,o.id))}}}),t.forEach(this.F,this)}D($){const E=this.j.get($.id);E?E.refCount++:(this.j.set($.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.$1L)(this.s.controllerId,$.id)}}))}F($){const E=this.j.get($);E&&!--E.refCount&&(this.j.delete($),this.pushDiff({op:7,id:(0,I.$1L)(this.s.controllerId,$)}))}G($,E){this.s.getApiFor($).parent=E&&E.actual!==this.root?E.actual:void 0}H($,E,h){this.G($,h);const t=this.s.getApiFor($);t.parent=h?.actual,t.listener=o=>this.w(E,o),this.J(E)}I($,E,h){this.H($,E,h);for(const[t,o]of this.s.getChildren($))this.z(o,E)}J($){let E;this.h?$.resolveBarrier?E=$.resolveBarrier.isOpen()?3:2:E=$.actual.canResolveChildren?1:0:E=0,E!==$.expand&&($.expand=E,this.pushDiff({op:1,item:{extId:$.fullId.toString(),expand:E}}),E===1&&$.expandLevels!==void 0&&this.M($))}L($,E){if(E<0)return;const h=[];for(const[t,o]of this.s.getChildren($.actual)){const r=this.expand(S.$VL.joinToString($.fullId,o.id),E);(0,s.$ih)(r)&&h.push(r)}if(h.length)return Promise.all(h).then(()=>{})}M($){if($.resolveBarrier)return $.resolveBarrier;if(!this.h){const o=new s.$vh;return o.open(),o}$.expand=2,this.N($);const E=$.resolveBarrier=new s.$vh,h=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h($.actual===this.root?void 0:$.actual)}catch(o){h(o)}return(0,s.$ih)(t)?t.catch(h).then(()=>{E.open(),this.J($)}):(E.open(),this.J($)),$.resolveBarrier}N($){this.pushDiff({op:1,item:{extId:$.fullId.toString(),expand:$.expand}})}O($){const E=this.tree.get($);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:$});const h=[E];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.F(o.id);this.tree.delete(t.fullId.toString());for(const[o,r]of this.s.getChildren(t.actual))h.push(this.tree.get(S.$VL.joinToString(t.fullId,r.id)))}}}flushDiff(){const $=this.collectDiff();$.length&&this.g.fire($)}}e.$nP=m;class u extends Error{constructor($){super(`Attempted to insert a duplicate test item ID ${$}`)}}e.$oP=u;class a extends Error{constructor($){super(`TestItem with ID "${$}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pP=a;class f extends Error{constructor($,E,h){super(`TestItem with ID "${$}" is from controller "${E}" and cannot be added as a child of an item from controller "${h}".`)}}e.$qP=f;const c=(d,$,E)=>{let h=new Map;return{get size(){return h.size},forEach(t,o){for(const r of h.values())t.call(o,r,this)},[Symbol.iterator](){return h.entries()},replace(t){const o=new Map,r=new Set(h.keys()),i={op:5,ops:[]};for(const n of t){if(!(n instanceof E))throw new a(n.id);const l=$(n).controllerId;if(l!==d.controllerId)throw new f(n.id,l,d.controllerId);if(o.has(n.id))throw new u(n.id);o.set(n.id,n),r.delete(n.id),i.ops.push({op:0,item:n})}for(const n of r.keys())i.ops.push({op:3,id:n});d.listener?.(i),h=o},add(t){if(!(t instanceof E))throw new a(t.id);h.set(t.id,t),d.listener?.({op:0,item:t})},delete(t){h.delete(t)&&d.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$rP=c}),define(ye[136],Ee([1,0,135]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=void 0;const C=new WeakMap,D=(I,S)=>{const w={controllerId:S};return C.set(I,w),w};e.$sP=D;const k=I=>{const S=C.get(I);if(!S)throw new s.$pP(I?.id||"<unknown>");return S};e.$tP=k}),define(ye[288],Ee([1,0,25,5]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=void 0,e.$PE=".vscode",e.$QE="settings",e.$RE=`${e.$PE}/${e.$QE}.json`,e.$SE="vscode://schemas/settings/default",e.$TE="vscode://schemas/settings/user",e.$UE="vscode://schemas/settings/profile",e.$VE="vscode://schemas/settings/machine",e.$WE="vscode://schemas/settings/workspace",e.$XE="vscode://schemas/settings/folder",e.$YE="vscode://schemas/launch",e.$ZE="vscode://schemas/tasks",e.$1E=[1],e.$2E=[2,3,4,5,6],e.$3E=[3,4,5],e.$4E=[1,...e.$3E],e.$5E=[2,3,4,5,6],e.$6E=[3,4,5,6],e.$7E=[4,5,6],e.$8E="tasks",e.$9E="launch",e.$0E=Object.create(null),e.$0E[e.$8E]=`${e.$PE}/${e.$8E}.json`,e.$0E[e.$9E]=`${e.$PE}/${e.$9E}.json`,e.$$E=Object.create(null),e.$$E[e.$8E]=`${e.$8E}.json`,e.$_E=(0,C.$xi)(s.$3i),e.$aF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$bF="workbench.settings.applyToAllProfiles"}),define(ye[137],Ee([1,0,5]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.VariableKind=e.$jQ=void 0,e.$jQ=(0,s.$wi)("configurationResolverService");var C;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator",k.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class D extends Error{constructor(I,S){super(S),this.variable=I}}e.$kQ=D}),define(ye[289],Ee([1,0,7,31,10,21,3,165,218,137,17]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;class v{constructor(m,u,a,f){this.h=new Map,this.a=m,this.b=u,this.g=a,f&&(this.c=f.then(c=>this.i(c)))}i(m){if(I.$c){const u=Object.create(null);return Object.keys(m).forEach(a=>{u[a.toLowerCase()]=m[a]}),u}return m}resolveWithEnvironment(m,u,a){return this.l({env:this.i(m),userHome:void 0},u?u.uri:void 0,a)}async resolveAsync(m,u){const a={env:await this.c,userHome:await this.g};return this.l(a,m?m.uri:void 0,u)}async j(m,u,a,f){const c=k.$4n(u);I.$c&&c.windows?Object.keys(c.windows).forEach($=>c[$]=c.windows[$]):I.$d&&c.osx?Object.keys(c.osx).forEach($=>c[$]=c.osx[$]):I.$e&&c.linux&&Object.keys(c.linux).forEach($=>c[$]=c.linux[$]),delete c.windows,delete c.osx,delete c.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,m?m.uri:void 0,c,a,f)}async resolveAnyAsync(m,u,a){return this.j(m,u,a)}async resolveAnyMap(m,u,a){const f=new Map;return{newConfig:await this.j(m,u,a,f),resolvedVariables:f}}resolveWithInteractionReplace(m,u,a,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,u,a,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,u){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,u)}async l(m,u,a,f,c){if(D.$9f(a))return this.m(m,u,a,f,c);if(Array.isArray(a))return Promise.all(a.map(d=>this.l(m,u,d,f,c)));if(D.$$f(a)){const d=Object.create(null),$=await Promise.all(Object.keys(a).map(async E=>[await this.m(m,u,E,f,c),await this.l(m,u,a[E],f,c)]));for(const[E,h]of $)d[E]=h;return d}return a}m(m,u,a,f,c){return(0,y.$qf)(a,v.VARIABLE_REGEXP,async(d,$)=>{if($.includes(v.VARIABLE_LHS))return d;let E=await this.o(m,d,$,u,f);return c?.set($,E),E!==d&&D.$9f(E)&&E.match(v.VARIABLE_REGEXP)&&(E=await this.m(m,u,E,f,c)),E})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,u,a,f,c){let d;const $=a.split(":");$.length>1&&(a=$[0],d=$[1]);const E=o=>{const r=this.a.getFilePath();if(r)return(0,S.$Fw)(r);throw new g.$kQ(o,(0,w.localize)(0,null,u))},h=o=>{const r=E(o);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,S.$Fw)(i)}throw new g.$kQ(o,(0,w.localize)(1,null,u,s.$oc(r)))},t=o=>{if(d){const r=this.a.getFolderUri(d);if(r)return r;throw new g.$kQ(o,(0,w.localize)(2,null,u,d))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new g.$kQ(o,(0,w.localize)(3,null,u)):new g.$kQ(o,(0,w.localize)(4,null,u))};switch(a){case"env":if(d){if(m.env){const o=m.env[I.$c?d.toLowerCase():d];if(D.$9f(o))return o}return""}throw new g.$kQ(g.VariableKind.Env,(0,w.localize)(5,null,u));case"config":if(d){const o=this.a.getConfigurationValue(f,d);if(D.$fg(o))throw new g.$kQ(g.VariableKind.Config,(0,w.localize)(6,null,u,d));if(D.$$f(o))throw new g.$kQ(g.VariableKind.Config,(0,w.localize)(7,null,u,d));return o}throw new g.$kQ(g.VariableKind.Config,(0,w.localize)(8,null,u));case"command":return this.p(g.VariableKind.Command,u,d,c,"command");case"input":return this.p(g.VariableKind.Input,u,d,c,"input");case"extensionInstallFolder":if(d){const o=await this.a.getExtension(d);if(!o)throw new g.$kQ(g.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,u,d));return this.n(o.extensionLocation)}throw new g.$kQ(g.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,u));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,S.$Fw)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return f||d?(0,S.$Fw)(this.n(t(g.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,S.$Fw)(s.$oc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new g.$kQ(g.VariableKind.UserHome,(0,w.localize)(11,null,u))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new g.$kQ(g.VariableKind.LineNumber,(0,w.localize)(12,null,u))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new g.$kQ(g.VariableKind.SelectedText,(0,w.localize)(13,null,u))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return h(g.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.$oc(h(g.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||d?s.$mc(this.n(t(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const o=s.$nc(E(g.VariableKind.RelativeFileDirname));if(f||d){const r=s.$mc(this.n(t(g.VariableKind.RelativeFileDirname)),o);return r.length===0?".":r}return o}case"fileDirname":return s.$nc(E(g.VariableKind.FileDirname));case"fileExtname":return s.$pc(E(g.VariableKind.FileExtname));case"fileBasename":return s.$oc(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=s.$oc(E(g.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-s.$pc(o).length)}case"fileDirnameBasename":return s.$oc(s.$nc(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||u}case"execInstallFolder":{const o=this.a.getAppRoot();return o||u}case"pathSeparator":case"/":return s.sep;default:try{const o=d?`${a}:${d}`:a;return this.p(g.VariableKind.Unknown,u,o,c,void 0)}catch{return u}}}}p(m,u,a,f,c){if(a&&f){const d=c===void 0?f[a]:f[c+":"+a];if(typeof d=="string")return d;throw new g.$kQ(m,(0,w.localize)(14,null,u))}return u}}e.$zQ=v,v.VARIABLE_LHS="${",v.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[290],Ee([1,0,5,95]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=g,e.$1D=b,e.$2D=m,e.$YD=(0,s.$wi)("editorGroupsService");var D;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var k;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(k||(e.GroupOrientation=k={}));var I;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(I||(e.GroupLocation=I={}));var S;(function(u){u[u.MAXIMIZE=0]="MAXIMIZE",u[u.EXPAND=1]="EXPAND",u[u.EVEN=2]="EVEN"})(S||(e.GroupsArrangement=S={}));var w;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function g(u){const a=u;return(0,C.$JF)(a?.editor)&&(0,C.$JF)(a?.replacement)}var y;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y||(e.GroupsOrder=y={}));var v;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function b(u){const a=u;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function m(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ye[138],Ee([1,0,5,290]),function(ue,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=D,e.$3D=(0,s.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function D(k){const I=k;return typeof k=="number"||(0,C.$1D)(I)}}),define(ye[291],Ee([1,0,288,120,93,91,137,95,138,13,238,286,92]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=e.$BQ=void 0,e.$BQ="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(a,f,c,d,$,E,h,t,o,r){this.a=a,this.b=f,this.c=c,this.d=d,this.e=$,this.f=E,this.g=h,this.h=t,this.i=o,this.j=r}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(a,f,c,d,$,E,h,t){await this.c.whenRemoteConfigurationLoaded();const o=Object.create(null),r=c?this.d.getWorkspaceFolder(c)??void 0:void 0;let i;try{i=(await this.e.resolveAnyMap(r,{shellLaunchConfig:a,configuration:f})).resolvedVariables}catch(B){this.h.error(B)}if(i)for(const[B,G]of i.entries())(/^config:/.test(B)||B==="selectedText"||B==="lineNumber")&&(o[B]=G);const n=[];for(const[B,G]of this.f.collections.entries())n.push([B,(0,k.$ms)(G.map),(0,k.$ns)(G.descriptionMap)]);const l=await this.g.resolveAuthority(this.a),p=l.options&&l.options.extensionHostEnv,P=this.d.getWorkspace(),j=P.folders,O=c?this.d.getWorkspaceFolder(c):null,R=S.$RF.getOriginalUri(this.i.activeEditor,{supportSideBySide:S.SideBySideEditor.PRIMARY,filterByScheme:[g.Schemas.file,g.Schemas.vscodeUserData,g.Schemas.vscodeRemote]}),A={configuration:f,resolvedVariables:o,envVariableCollections:n,shellLaunchConfig:a,workspaceId:P.id,workspaceName:this.j.getWorkspaceLabel(P),workspaceFolders:j,activeWorkspaceFolder:O,activeFileResource:R,shouldPersistTerminal:$,options:d,cols:E,rows:h,unicodeVersion:t,resolverEnv:p};return await this.b.call("$createProcess",A)}requestDetachInstance(a,f){return this.b.call("$requestDetachInstance",[a,f])}acceptDetachInstanceReply(a,f){return this.b.call("$acceptDetachInstanceReply",[a,f])}attachToProcess(a){return this.b.call("$attachToProcess",[a])}detachFromProcess(a,f){return this.b.call("$detachFromProcess",[a,f])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(a,f){return this.b.call("$processBinary",[a,f])}start(a){return this.b.call("$start",[a])}input(a,f){return this.b.call("$input",[a,f])}acknowledgeDataEvent(a,f){return this.b.call("$acknowledgeDataEvent",[a,f])}setUnicodeVersion(a,f){return this.b.call("$setUnicodeVersion",[a,f])}shutdown(a,f){return this.b.call("$shutdown",[a,f])}resize(a,f,c){return this.b.call("$resize",[a,f,c])}clearBuffer(a){return this.b.call("$clearBuffer",[a])}getInitialCwd(a){return this.b.call("$getInitialCwd",[a])}getCwd(a){return this.b.call("$getCwd",[a])}orphanQuestionReply(a){return this.b.call("$orphanQuestionReply",[a])}sendCommandResult(a,f,c){return this.b.call("$sendCommandResult",[a,f,c])}freePortKillProcess(a){return this.b.call("$freePortKillProcess",[a])}installAutoReply(a,f){return this.b.call("$installAutoReply",[a,f])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(a){return this.b.call("$getDefaultSystemShell",[a])}getProfiles(a,f,c){return this.b.call("$getProfiles",[this.d.getWorkspace().id,a,f,c])}acceptPtyHostResolvedVariables(a,f){return this.b.call("$acceptPtyHostResolvedVariables",[a,f])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(a,f){return this.b.call("$getWslPath",[a,f])}setTerminalLayoutInfo(a){const c={workspaceId:this.d.getWorkspace().id,tabs:a?a.tabs:[]};return this.b.call("$setTerminalLayoutInfo",c)}updateTitle(a,f,c){return this.b.call("$updateTitle",[a,f,c])}updateIcon(a,f,c,d){return this.b.call("$updateIcon",[a,f,c,d])}refreshProperty(a,f){return this.b.call("$refreshProperty",[a,f])}updateProperty(a,f,c){return this.b.call("$updateProperty",[a,f,c])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",f)}reviveTerminalProcesses(a,f,c){return this.b.call("$reviveTerminalProcesses",[a,f,c])}getRevivedPtyNewId(a){return this.b.call("$getRevivedPtyNewId",[a])}serializeTerminalState(a){return this.b.call("$serializeTerminalState",[a])}};e.$CQ=m,e.$CQ=m=Fe([Ne(2,s.$_E),Ne(3,D.$Fi),Ne(4,I.$jQ),Ne(5,v.$1P),Ne(6,C.$Hl),Ne(7,b.$_r),Ne(8,w.$3D),Ne(9,y.$0v)],m)}),define(ye[292],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.ExtHostConnectionType=void 0,e.$on=S,e.$pn=w;var s;(function(y){y[y.IPC=1]="IPC",y[y.Socket=2]="Socket",y[y.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class C{constructor(v){this.pipeName=v,this.type=1}serialize(v){v[C.ENV_KEY]=this.pipeName}}e.$ln=C,C.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(v){v[D.ENV_KEY]="1"}}e.$mn=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class k{constructor(){this.type=3}serialize(v){v[k.ENV_KEY]="1"}}e.$nn=k,k.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(y){delete y[C.ENV_KEY],delete y[D.ENV_KEY],delete y[k.ENV_KEY]}function S(y,v){I(v),y.serialize(v)}function w(y){if(y[C.ENV_KEY])return g(y,new C(y[C.ENV_KEY]));if(y[D.ENV_KEY])return g(y,new D);if(y[k.ENV_KEY])return g(y,new k);throw new Error("No connection information defined in environment!")}function g(y,v){return I(y),v}}),define(ye[293],Ee([1,0,15]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$1m=I,e.$2m=S;var C;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(C||(e.UIKind=C={}));var D;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var k;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(k||(e.MessageType=k={}));function I(g){const y=s.$Ge.alloc(1);switch(g){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}function S(g,y){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}var w;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(ye[294],Ee([1,0,5,6,12,280,293,86,37,21,4,2,215]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=e.$PP=e.$OP=void 0,e.$QP=a;let m=class extends v.$Vc{constructor(c,d){super(),this.s=c,this.t=d,this.a=this.B(new C.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:w.$lp,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(d.onDidChangeLogLevel($=>{(0,D.$5j)($)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,d,$){const E=this.getTelemetryDetails(),h=new u(d,$,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(c,d,$){this.f=c,this.g=d,this.c=$??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const d=Object.create(null);switch(d["common.extname"]=`${c.publisher}.${c.name}`,d["common.extversion"]=c.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case I.UIKind.Web:d["common.uikind"]="web";break;case I.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,S.$Jm)((0,w.$rp)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const d=this.getTelemetryDetails();this.r.forEach(($,E)=>{const h=$.filter(t=>!t.isDisposed);h.length===0?this.r.delete(E):this.r.set(E,h)}),this.r.forEach($=>{for(const E of $)E.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,d){const E=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!E)return this.r.delete(c.value),!1;let h=!1;for(const t of E)t.ignoreUnhandledExtHostErrors||(t.logError(d),h=!0);return h}};e.$OP=m,e.$OP=m=Fe([Ne(0,k.$NP),Ne(1,D.$4j)],m);class u{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,d,$,E,h,t,o){this.g=$,this.h=E,this.i=h,this.j=t,this.a=new C.$ee,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(c,d){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let d="properties"in c?c.properties??{}:c;return d=(0,w.$up)(d,[]),this.c&&(d=(0,g.$7n)(d,this.c)),this.b||(d=(0,g.$7n)(d,this.j)),"properties"in c?c.properties=d:c=d,c}k(c,d){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(c,d),this.h.trace(c,d))}logUsage(c,d){this.d.isUsageEnabled&&this.k(c,d)}logError(c,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,d);else{const $={name:c.name,message:c.message,stack:c.stack,cause:c.cause},E=(0,w.$up)($,[]),h=new Error(E.message,{cause:E.cause});h.stack=E.stack,h.name=E.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(h,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const c=this,d={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$PP=u;function a(f){const c=Date.now()-new Date(f).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$RP=(0,s.$wi)("IExtHostTelemetry")}),define(ye[295],Ee([1,0,40,219,57]),function(ue,e,s,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=k;function k(I,S,w,g){const y=new s.$Um;return I.forEach(v=>{const b=y.get(v.identifier);b&&g.warn((0,C.localize)(0,null,b.extensionLocation.fsPath,v.extensionLocation.fsPath)),y.set(v.identifier,v)}),S.forEach(v=>{const b=y.get(v.identifier);if(b)if(b.isBuiltin){if(D.gte(b.version,v.version)){g.warn(`Skipping extension ${v.extensionLocation.path} in favour of the builtin extension ${b.extensionLocation.path}.`);return}v.isBuiltin=!0}else g.warn((0,C.localize)(1,null,b.extensionLocation.fsPath,v.extensionLocation.fsPath));else if(v.isBuiltin){g.warn(`Skipping obsolete builtin extension ${v.extensionLocation.path}`);return}y.set(v.identifier,v)}),w.forEach(v=>{g.info((0,C.localize)(2,null,v.extensionLocation.fsPath));const b=y.get(v.identifier);b&&b.isBuiltin&&(v.isBuiltin=!0),y.set(v.identifier,v)}),Array.from(y.values())}}),define(ye[296],Ee([1,0,7,3,31,4,44,55,47,59,295,13]),function(ue,e,s,C,D,k,I,S,w,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=e.$1Q=void 0;class b{constructor(a,f,c,d,$,E,h){this.c=a,this.d=c,this.f=d,this.g=$,this.h=E,this.i=h,this.a=Promise.resolve(),this.b=Promise.resolve();const t=f.args["install-builtin-extension"];if(t){$.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"]};I.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=a.installExtensions([],this.j(t),r,!!f.args.force).then(()=>{I.mark("code/server/didInstallBuiltinExtensions"),$.trace("Finished installing builtin extensions")},i=>{$.error(i)})}const o=f.args["install-extension"];o&&($.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>a.installExtensions(this.j(o),[],{isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"],isApplicationScoped:!0},!!f.args.force)).then(()=>{$.trace("Finished installing extensions")},r=>{$.error(r)}))}j(a){return a.map(f=>/\.vsix$/i.test(f)?k.URI.file((0,s.$jc)(f)?f:(0,s.$kc)((0,D.cwd)(),f)):f)}whenExtensionsReady(){return this.b}async scanExtensions(a,f,c,d){I.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${a}`),await this.a;const $=c?c.filter(h=>h.scheme===v.Schemas.file).map(h=>h.fsPath):void 0;f=f??this.d.defaultProfile.extensionsResource;const E=await this.k(f,a??C.$q,$,d);return this.g.trace("Scanned Extensions",E),this.r(E),I.mark("code/server/didScanExtensions"),E}async scanSingleExtension(a,f,c){await this.a;const d=a.scheme===v.Schemas.file?a.fsPath:null;if(!d)return null;const $=await this.o(d,f,c??C.$q);return $?(this.r([$]),$):null}async k(a,f,c,d){await this.q(f,d);const[$,E,h]=await Promise.all([this.m(f),this.n(a,f),this.l(f,c)]);return(0,y.$XQ)($,E,h,this.g)}async l(a,f){return f?(await Promise.all(f.map(c=>this.f.scanOneOrMultipleExtensions(k.URI.file((0,s.$lc)(c)),1,{language:a})))).flat().map(c=>(0,g.$xq)(c,!0)):[]}async m(a){return(await this.f.scanSystemExtensions({language:a,useCache:!0})).map(c=>(0,g.$xq)(c,!1))}async n(a,f){return(await this.f.scanUserExtensions({profileLocation:a,language:f,useCache:!0})).map(d=>(0,g.$xq)(d,!1))}async o(a,f,c){const d=k.URI.file((0,s.$lc)(a)),$=f?0:1,E=await this.f.scanExistingExtension(d,$,{language:c});return E?(0,g.$xq)(E,!1):null}async q(a,f){if(!(a===C.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===a)){this.g.trace(`Language Pack ${a} is already installed. Skipping language pack installation.`);return}}catch(c){this.g.error(c)}if(!f){this.g.trace(`No language pack id provided for language ${a}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${f} for language ${a} is not installed. It will be installed now.`);try{await this.c.installExtensions([f],[],{isMachineScoped:!0},!0)}catch(c){this.g.error(c)}}}r(a){const f=(t,o)=>t.replace(/file/g,"vscode-remote"),c=t=>{let o="";return o+=t.global?"g":"",o+=t.ignoreCase?"i":"",o+=t.multiline?"m":"",new RegExp(f(t.source,!0),o)},d=new class{mapDefined(t){return w.$zj.create(t)}mapNot(t){return w.$Ej.create(t)}mapEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?w.$Aj.create(t,f(o,!1)):w.$Aj.create(t,o)}mapNotEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?w.$Dj.create(t,f(o,!1)):w.$Dj.create(t,o)}mapGreater(t,o){return w.$Fj.create(t,o)}mapGreaterEquals(t,o){return w.$Gj.create(t,o)}mapSmaller(t,o){return w.$Hj.create(t,o)}mapSmallerEquals(t,o){return w.$Ij.create(t,o)}mapRegex(t,o){return t==="resourceScheme"&&o?w.$Jj.create(t,c(o)):w.$Jj.create(t,o)}mapIn(t,o){return w.$Bj.create(t,o)}mapNotIn(t,o){return w.$Cj.create(t,o)}},$=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const o=w.$uj.deserialize(t.when);if(!o)return;const r=o.map(d);t.when=r.serialize()},E=t=>{if(Array.isArray(t))for(const o of t)$(o);else $(t)},h=t=>{for(const o in t)E(t[o])};a.forEach(t=>{t.contributes&&(t.contributes.menus&&h(t.contributes.menus),t.contributes.keybindings&&E(t.contributes.keybindings),t.contributes.views&&h(t.contributes.views))})}}e.$1Q=b;class m{constructor(a,f){this.a=a,this.b=f}listen(a,f){throw new Error("Invalid listen")}async call(a,f,c){const d=this.b(a);switch(f){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const $=c[0],E=c[1]?k.URI.revive(d.transformIncoming(c[1])):void 0,h=Array.isArray(c[2])?c[2].map(r=>k.URI.revive(d.transformIncoming(r))):void 0,t=c[3];return(await this.a.scanExtensions($,E,h,t)).map(r=>(0,S.$Bn)(r,d))}case"scanSingleExtension":{const $=await this.a.scanSingleExtension(k.URI.revive(d.transformIncoming(c[0])),c[1],c[2]);return $?(0,S.$Bn)($,d):null}}throw new Error("Invalid call")}}e.$2Q=m}),define(ye[139],Ee([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$zw=void 0,e.$Aw=D,e.$Bw=k;class s{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++s.count}}e.$zw=s,s.count=0;const C=[];function D(S){const w=new s(S);return C[w.nid]=w,w}function k(S){return C[S].sid}class I{constructor(w){this.value=w}}e.$Cw=I}),define(ye[297],Ee([1,0,139]),function(ue,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var D;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(D||(e.TabInputKind=D={}));var k;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(k||(e.TabModelOperationKind=k={}));var I;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(I||(e.WebviewEditorCapabilities=I={}));var S;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(S||(e.WebviewMessageArrayBufferViewType=S={}));var w;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var g;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var y;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(y||(e.CandidatePortSource=y={}));class v{static mixin(f){return f._id=v.a++,f}}e.$9M=v,v.a=0;var b;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var m;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var u;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(u||(e.ExtHostTestingResource=u={})),e.$0M={MainThreadAuthentication:(0,s.$Aw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.$Aw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.$Aw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,s.$Aw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.$Aw)("MainThreadChatVariables"),MainThreadClipboard:(0,s.$Aw)("MainThreadClipboard"),MainThreadCommands:(0,s.$Aw)("MainThreadCommands"),MainThreadComments:(0,s.$Aw)("MainThreadComments"),MainThreadConfiguration:(0,s.$Aw)("MainThreadConfiguration"),MainThreadConsole:(0,s.$Aw)("MainThreadConsole"),MainThreadDebugService:(0,s.$Aw)("MainThreadDebugService"),MainThreadDecorations:(0,s.$Aw)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.$Aw)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.$Aw)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.$Aw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.$Aw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.$Aw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.$Aw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.$Aw)("MainThreadEditorTabs"),MainThreadErrors:(0,s.$Aw)("MainThreadErrors"),MainThreadTreeViews:(0,s.$Aw)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.$Aw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.$Aw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.$Aw)("MainThreadLanguages"),MainThreadLogger:(0,s.$Aw)("MainThreadLogger"),MainThreadMessageService:(0,s.$Aw)("MainThreadMessageService"),MainThreadOutputService:(0,s.$Aw)("MainThreadOutputService"),MainThreadProgress:(0,s.$Aw)("MainThreadProgress"),MainThreadQuickDiff:(0,s.$Aw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.$Aw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.$Aw)("MainThreadStatusBar"),MainThreadSecretState:(0,s.$Aw)("MainThreadSecretState"),MainThreadStorage:(0,s.$Aw)("MainThreadStorage"),MainThreadSpeech:(0,s.$Aw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.$Aw)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.$Aw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.$Aw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.$Aw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.$Aw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.$Aw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.$Aw)("MainThreadCustomEditors"),MainThreadUrls:(0,s.$Aw)("MainThreadUrls"),MainThreadUriOpeners:(0,s.$Aw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.$Aw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.$Aw)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.$Aw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.$Aw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.$Aw)("MainThreadExtensionService"),MainThreadSCM:(0,s.$Aw)("MainThreadSCM"),MainThreadSearch:(0,s.$Aw)("MainThreadSearch"),MainThreadShare:(0,s.$Aw)("MainThreadShare"),MainThreadTask:(0,s.$Aw)("MainThreadTask"),MainThreadWindow:(0,s.$Aw)("MainThreadWindow"),MainThreadLabelService:(0,s.$Aw)("MainThreadLabelService"),MainThreadNotebook:(0,s.$Aw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.$Aw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.$Aw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.$Aw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.$Aw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.$Aw)("MainThreadInteractive"),MainThreadInlineChat:(0,s.$Aw)("MainThreadInlineChatShape"),MainThreadTheming:(0,s.$Aw)("MainThreadTheming"),MainThreadTunnelService:(0,s.$Aw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.$Aw)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.$Aw)("MainThreadTimeline"),MainThreadTesting:(0,s.$Aw)("MainThreadTesting"),MainThreadLocalization:(0,s.$Aw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.$Aw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.$Aw)("MainThreadAiEmbeddingVector")},e.$$M={ExtHostCommands:(0,s.$Aw)("ExtHostCommands"),ExtHostConfiguration:(0,s.$Aw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.$Aw)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.$Aw)("ExtHostDebugService"),ExtHostDecorations:(0,s.$Aw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.$Aw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.$Aw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.$Aw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.$Aw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.$Aw)("ExtHostEditors"),ExtHostTreeViews:(0,s.$Aw)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.$Aw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.$Aw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.$Aw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.$Aw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.$Aw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.$Aw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.$Aw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.$Aw)("ExtHostStatusBar"),ExtHostShare:(0,s.$Aw)("ExtHostShare"),ExtHostExtensionService:(0,s.$Aw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.$Aw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.$Aw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.$Aw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.$Aw)("ExtHostSCM"),ExtHostSearch:(0,s.$Aw)("ExtHostSearch"),ExtHostTask:(0,s.$Aw)("ExtHostTask"),ExtHostWorkspace:(0,s.$Aw)("ExtHostWorkspace"),ExtHostWindow:(0,s.$Aw)("ExtHostWindow"),ExtHostWebviews:(0,s.$Aw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.$Aw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.$Aw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.$Aw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.$Aw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.$Aw)("ExtHostEditorTabs"),ExtHostProgress:(0,s.$Aw)("ExtHostProgress"),ExtHostComments:(0,s.$Aw)("ExtHostComments"),ExtHostSecretState:(0,s.$Aw)("ExtHostSecretState"),ExtHostStorage:(0,s.$Aw)("ExtHostStorage"),ExtHostUrls:(0,s.$Aw)("ExtHostUrls"),ExtHostUriOpeners:(0,s.$Aw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.$Aw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.$Aw)("ExtHostOutputService"),ExtHostLabelService:(0,s.$Aw)("ExtHostLabelService"),ExtHostNotebook:(0,s.$Aw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.$Aw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.$Aw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.$Aw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.$Aw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.$Aw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.$Aw)("ExtHostInteractive"),ExtHostInlineChat:(0,s.$Aw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,s.$Aw)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.$Aw)("ExtHostChatVariables"),ExtHostChatProvider:(0,s.$Aw)("ExtHostChatProvider"),ExtHostSpeech:(0,s.$Aw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,s.$Aw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.$Aw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.$Aw)("ExtHostTheming"),ExtHostTunnelService:(0,s.$Aw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.$Aw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.$Aw)("ExtHostAuthentication"),ExtHostTimeline:(0,s.$Aw)("ExtHostTimeline"),ExtHostTesting:(0,s.$Aw)("ExtHostTesting"),ExtHostTelemetry:(0,s.$Aw)("ExtHostTelemetry"),ExtHostLocalization:(0,s.$Aw)("ExtHostLocalization")}}),define(ye[298],Ee([1,0,15,24,13,111,5]),function(ue,e,s,C,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=y,e.$NK=v,e.$LK=(0,I.$wi)("notebookDocumentService");const S=["W","X","Y","Z","a","b","c","d","e","f"],w=new RegExp(`^[${S.join("")}]+`),g=7;function y(m){if(m.scheme!==D.Schemas.vscodeNotebookCell)return;const u=m.fragment.indexOf("s");if(u<0)return;const a=parseInt(m.fragment.substring(0,u).replace(w,""),g),f=(0,s.$Ze)(m.fragment.substring(u+1)).toString();if(!isNaN(a))return{handle:a,notebook:m.with({scheme:f,fragment:null})}}function v(m,u){const a=u.toString(g),c=`${a.length<S.length?S[a.length-1]:"z"}${a}s${(0,s.$1e)(s.$Ge.fromString(m.scheme),!0,!0)}`;return m.with({scheme:D.Schemas.vscodeNotebookCell,fragment:c})}class b{constructor(){this.a=new C.$Bc}getNotebook(u){if(u.scheme===D.Schemas.vscodeNotebookCell){const a=y(u);if(a){const f=this.a.get(a.notebook);if(f)return f}}return this.a.get(u)}addNotebookDocument(u){this.a.set(u.uri,u)}removeNotebookDocument(u){this.a.delete(u.uri)}}e.$OK=b,(0,k.$ys)(e.$LK,b,1)}),define(ye[140],Ee([1,0,15,77,41,61,13,7,3,47,298]),function(ue,e,s,C,D,k,I,S,w,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=o,e.$3K=i,e.$4K=n,e.$7K=P,e.$8K=O,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var v;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(v||(e.CellKind=v={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",k.$Rs.latex,k.$Rs.markdown,"image/png","image/jpeg",k.$Rs.text],e.$VK=[k.$Rs.latex,k.$Rs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",k.$Rs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var b;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var m;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var u;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(u||(e.NotebookExecutionState=u={}));var a;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var f;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var c;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var d;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var $;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})($||(e.CellEditType=$={}));var E;(function(q){q.scheme=I.Schemas.vscodeNotebookCell;function X(we,ie){return(0,y.$NK)(we,ie)}q.generate=X;function _(we){return(0,y.$MK)(we)}q.parse=_;function M(we,ie){return we.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${we.scheme!==I.Schemas.file?we.scheme:""}`})}q.generateCellOutputUri=M;function Q(we){if(we.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!ie)return;const Y=ie[1]&&ie[1]!==""?ie[1]:void 0,V=ie[2];return{outputId:Y,notebook:we.with({scheme:V||I.Schemas.file,fragment:null})}}q.parseCellOutputUri=Q;function ae(we,ie,Y){return q.generate(we,ie).with({scheme:Y})}q.generateCellPropertyUri=ae;function ne(we,ie){if(we.scheme===ie)return q.parse(we.with({scheme:q.scheme}))}q.parseCellPropertyUri=ne})(E||(e.CellUri=E={}));const h=q=>w.$c?q.replace(/\//g,"\\"):q;class t{constructor(X=[],_=e.$UK){this.e=_,this.d=[...new Set(X)].map(M=>({pattern:M,matches:C.$qk(h(M))}))}sort(X){const _=new Map(D.Iterable.map(X,Q=>[Q,h(Q)]));let M=[];for(const{matches:Q}of this.d)for(const[ae,ne]of _)if(Q(ne)){M.push(ae),_.delete(ae);break}return _.size&&(M=M.concat([..._.keys()].sort((Q,ae)=>this.e.indexOf(Q)-this.e.indexOf(ae)))),M}prioritize(X,_){const M=this.f(X);if(M===-1){this.d.unshift({pattern:X,matches:C.$qk(h(X))});return}const Q=new Set(_.map(ne=>this.f(ne,M)));Q.delete(-1);const ae=Array.from(Q).sort();this.d.splice(M+1,0,...ae.map(ne=>this.d[ne]));for(let ne=ae.length-1;ne>=0;ne--)this.d.splice(ae[ne],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,_=this.d.length){const M=h(X);for(let Q=0;Q<_;Q++)if(this.d[Q].matches(M))return Q;return-1}}e.$YK=t;function o(q,X,_,M=(Q,ae)=>Q===ae){const Q=[];function ae(ie,Y,V){if(Y===0&&V.length===0)return;const N=Q[Q.length-1];N&&N.start+N.deleteCount===ie?(N.deleteCount+=Y,N.toInsert.push(...V)):Q.push({start:ie,deleteCount:Y,toInsert:V})}let ne=0,we=0;for(;;){if(ne===q.length){ae(ne,0,X.slice(we));break}if(we===X.length){ae(ne,q.length-ne,[]);break}const ie=q[ne],Y=X[we];if(M(ie,Y)){ne+=1,we+=1;continue}_(Y)?(ae(ne,1,[]),ne+=1):(ae(ne,0,[Y]),we+=1)}return Q}e.$1K=new g.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new g.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(q){q.default="default",q.option="option"})(r||(e.NotebookEditorPriority=r={}));function i(q){const X=q;return!!((typeof X.include=="string"||C.$rk(X.include))&&(typeof X.exclude=="string"||C.$rk(X.exclude)))}function n(q,X,_){if(Array.isArray(q.viewType)&&q.viewType.indexOf(X)>=0||q.viewType===X)return!0;if(q.filenamePattern){const M=i(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,Q=i(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(C.$pk(M,(0,S.$oc)(_.fsPath).toLowerCase()))return!(Q&&C.$pk(Q,(0,S.$oc)(_.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var l;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class p{static create(X){return`${p.d}${X}`}static parse(X){if(X.startsWith(p.d))return X.substring(p.d.length)}}e.$6K=p,p.d="notebook/";function P(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const j=new TextDecoder;function O(q){const X=[];let _=!1;for(const ne of q)(X.length===0||_)&&(X.push(ne),_=!0);let M=B(X);const Q=s.$Ge.concat(X.map(ne=>s.$Ge.wrap(ne))),ae=K(Q);return M=M||ae.byteLength!==Q.byteLength,{data:ae,didCompression:M}}e.$9K="\x1B[A";const R=e.$9K.split("").map(q=>q.charCodeAt(0)),A=10;function B(q){let X=!1;return q.forEach((_,M)=>{if(M===0||_.length<e.$9K.length)return;const Q=q[M-1],ae=_.subarray(0,e.$9K.length);if(ae[0]===R[0]&&ae[1]===R[1]&&ae[2]===R[2]){const ne=Q.lastIndexOf(A);if(ne===-1)return;X=!0,q[M-1]=Q.subarray(0,ne),q[M]=_.subarray(e.$9K.length)}}),X}function G(q){let X=q;do q=X,X=q.replace(/[^\n]\x08/gm,"");while(X.length<q.length);return q}function se(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const X=q.match(/^(.*)\r+/m)[1];let _=q.match(/\r+(.*)$/m)[1];_=_+X.slice(_.length,X.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,_)}return q}const ce=8,ee=13;function K(q){return!q.buffer.includes(ce)&&!q.buffer.includes(ee)?q:s.$Ge.fromString(se(G(j.decode(q.buffer))))}});var Lt=this&&this.__classPrivateFieldSet||function(ue,e,s,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ue!==e||!D:!e.has(ue))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(ue,s):D?D.value=s:e.set(ue,s),s},tt=this&&this.__classPrivateFieldGet||function(ue,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ue!==e||!C:!e.has(ue))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ue):C?C.value:e.get(ue)};define(ye[141],Ee([1,0,18,11,102,24,61,17,10,4,22,40,16,120,140]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u){"use strict";var a,f,c,d,$,E,h,t,o,r,i,n,l,p,P,j,O,R,A,B,G,se,ce,ee,K;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$lP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$kP=e.$jP=e.$iP=e.$hP=e.ChatLocation=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$8O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$UO=e.$TO=e.$SO=e.$RO=e.$PO=e.$OO=e.$NO=e.$MO=e.TestRunProfileKind=e.TestResultState=e.$LO=e.$KO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$JO=e.NotebookVariablesRequestKind=e.$IO=e.$HO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$GO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.ColorThemeKind=e.$AO=e.$zO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$yO=e.$xO=e.DebugConsoleMode=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$rO=e.$qO=e.FileChangeType=e.$pO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$oO=e.$nO=e.$mO=e.$lO=e.InlineCompletionTriggerKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$$N=e.ConfigurationTarget=e.$0N=e.$9N=e.$8N=e.$7N=e.DocumentPasteTriggerKind=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ZN=e.ViewBadge=e.ProgressLocation=e.$YN=e.$XN=e.TaskScope=e.ShellQuoting=e.$WN=e.$VN=e.$UN=e.TaskPanelKind=e.TaskRevealKind=e.$TN=e.TerminalLocation=e.$SN=e.$RN=e.$QN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$PN=e.$ON=e.$NN=e.$MN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$GN=e.$FN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.LanguageStatusSeverity=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.CodeActionTriggerKind=e.$tN=e.$sN=e.SymbolTag=e.SymbolKind=e.$rN=e.$qN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.DiagnosticSeverity=e.DiagnosticTag=e.$kN=e.$jN=e.FileEditType=e.$iN=e.$hN=e.$gN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$LN=jt,e.$_N=ut,e.$QO=gi;function q(T){return Object.assign(T,{apply:function(...re){if(re.length===0)return Reflect.construct(T,[]);{const ve=re.length===1?[]:re[1];return Reflect.construct(T,ve,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(T,[]);{const[ve,...ze]=re;return Reflect.construct(T,ze,ve.constructor)}}})}var X;(function(T){T[T.Top=0]="Top",T[T.Bottom=1]="Bottom"})(X||(e.TerminalOutputAnchor=X={}));var _;(function(T){T[T.TerminalCommand=0]="TerminalCommand",T[T.Opener=1]="Opener",T[T.Command=3]="Command"})(_||(e.TerminalQuickFixType=_={}));let M=o=class{static from(...F){let re=F;return new o(function(){if(re){for(const ve of re)ve&&typeof ve.dispose=="function"&&ve.dispose();re=void 0}})}constructor(F){a.set(this,void 0),Lt(this,a,F,"f")}dispose(){typeof tt(this,a,"f")=="function"&&(tt(this,a,"f").call(this),Lt(this,a,void 0,"f"))}};e.$_M=M,a=new WeakMap,e.$_M=M=o=Fe([q],M);let Q=r=class{static Min(...F){if(F.length===0)throw new TypeError;let re=F[0];for(let ve=1;ve<F.length;ve++){const ze=F[ve];ze.isBefore(re)&&(re=ze)}return re}static Max(...F){if(F.length===0)throw new TypeError;let re=F[0];for(let ve=1;ve<F.length;ve++){const ze=F[ve];ze.isAfter(re)&&(re=ze)}return re}static isPosition(F){if(!F)return!1;if(F instanceof r)return!0;const{line:re,character:ve}=F;return typeof re=="number"&&typeof ve=="number"}static of(F){if(F instanceof r)return F;if(this.isPosition(F))return new r(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,re){if(F<0)throw(0,C.$7)("line must be non-negative");if(re<0)throw(0,C.$7)("character must be non-negative");this.c=F,this.e=re}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,re=0){if(F===null||re===null)throw(0,C.$7)();let ve;return typeof F>"u"?ve=0:typeof F=="number"?ve=F:(ve=typeof F.lineDelta=="number"?F.lineDelta:0,re=typeof F.characterDelta=="number"?F.characterDelta:0),ve===0&&re===0?this:new r(this.line+ve,this.character+re)}with(F,re=this.character){if(F===null||re===null)throw(0,C.$7)();let ve;return typeof F>"u"?ve=this.line:typeof F=="number"?ve=F:(ve=typeof F.line=="number"?F.line:this.line,re=typeof F.character=="number"?F.character:this.character),ve===this.line&&re===this.character?this:new r(ve,re)}toJSON(){return{line:this.line,character:this.character}}};e.$aN=Q,e.$aN=Q=r=Fe([q],Q);let ae=i=class{static isRange(F){return F instanceof i?!0:F?Q.isPosition(F.start)&&Q.isPosition(F.end):!1}static of(F){if(F instanceof i)return F;if(this.isRange(F))return new i(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,re,ve,ze){let We,Ke;if(typeof F=="number"&&typeof re=="number"&&typeof ve=="number"&&typeof ze=="number"?(We=new Q(F,re),Ke=new Q(ve,ze)):Q.isPosition(F)&&Q.isPosition(re)&&(We=Q.of(F),Ke=Q.of(re)),!We||!Ke)throw new Error("Invalid arguments");We.isBefore(Ke)?(this.c=We,this.e=Ke):(this.c=Ke,this.e=We)}contains(F){return i.isRange(F)?this.contains(F.start)&&this.contains(F.end):Q.isPosition(F)?!(Q.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const re=Q.Max(F.start,this.c),ve=Q.Min(F.end,this.e);if(!re.isAfter(ve))return new i(re,ve)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const re=Q.Min(F.start,this.c),ve=Q.Max(F.end,this.end);return new i(re,ve)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,re=this.end){if(F===null||re===null)throw(0,C.$7)();let ve;return F?Q.isPosition(F)?ve=F:(ve=F.start||this.start,re=F.end||this.end):ve=this.start,ve.isEqual(this.c)&&re.isEqual(this.end)?this:new i(ve,re)}toJSON(){return[this.start,this.end]}};e.$bN=ae,e.$bN=ae=i=Fe([q],ae);let ne=n=class extends ae{static isSelection(F){return F instanceof n?!0:F?ae.isRange(F)&&Q.isPosition(F.anchor)&&Q.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,re,ve,ze){let We,Ke;if(typeof F=="number"&&typeof re=="number"&&typeof ve=="number"&&typeof ze=="number"?(We=new Q(F,re),Ke=new Q(ve,ze)):Q.isPosition(F)&&Q.isPosition(re)&&(We=Q.of(F),Ke=Q.of(re)),!We||!Ke)throw new Error("Invalid arguments");super(We,Ke),this.f=We,this.g=Ke}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cN=ne,e.$cN=ne=n=Fe([q],ne);const we=T=>{if(typeof T!="string"||T.length===0||!/^[0-9A-Za-z_\-]+$/.test(T))throw(0,C.$7)("connectionToken")};class ie{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,re,ve){if(typeof F!="string"||F.length===0)throw(0,C.$7)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,C.$7)("port");typeof ve<"u"&&we(ve),this.host=F,this.port=Math.round(re),this.connectionToken=ve}}e.$dN=ie;class Y{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,re){this.makeConnection=F,this.connectionToken=re,typeof re<"u"&&we(re)}}e.$eN=Y;class V extends Error{static NotAvailable(F,re){return new V(F,m.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(F){return new V(F,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,re=m.RemoteAuthorityResolverErrorCode.Unknown,ve){super(F),this._message=F,this._code=re,this._detail=ve,Object.setPrototypeOf(this,V.prototype)}}e.$fN=V;var N;(function(T){T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(N||(e.EndOfLine=N={}));var z;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(z||(e.EnvironmentVariableMutatorType=z={}));let Z=l=class{static isTextEdit(F){return F instanceof l?!0:F?ae.isRange(F)&&typeof F.newText=="string":!1}static replace(F,re){return new l(F,re)}static insert(F,re){return l.replace(new ae(F,F),re)}static delete(F){return l.replace(F,"")}static setEndOfLine(F){const re=new l(new ae(new Q(0,0),new Q(0,0)),"");return re.newEol=F,re}get range(){return this.c}set range(F){if(F&&!ae.isRange(F))throw(0,C.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,C.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,C.$7)("newEol");this.f=F}constructor(F,re){this.c=F,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gN=Z,e.$gN=Z=l=Fe([q],Z);let he=p=class{static isNotebookCellEdit(F){return F instanceof p?!0:F?Zt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,re){return new p(F,re)}static insertCells(F,re){return new p(new Zt(F,F),re)}static deleteCells(F){return new p(F,[])}static updateCellMetadata(F,re){const ve=new p(new Zt(F,F),[]);return ve.newCellMetadata=re,ve}static updateNotebookMetadata(F){const re=new p(new Zt(0,0),[]);return re.newNotebookMetadata=F,re}constructor(F,re){this.range=F,this.newCells=re}};e.$hN=he,e.$hN=he=p=Fe([q],he);class x{static isSnippetTextEdit(F){return F instanceof x?!0:F?ae.isRange(F.range)&&L.isSnippetString(F.snippet):!1}static replace(F,re){return new x(F,re)}static insert(F,re){return x.replace(new ae(F,F),re)}constructor(F,re){this.range=F,this.snippet=re}}e.$iN=x;var J;(function(T){T[T.File=1]="File",T[T.Text=2]="Text",T[T.Cell=3]="Cell",T[T.CellReplace=5]="CellReplace",T[T.Snippet=6]="Snippet"})(J||(e.FileEditType=J={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,re,ve,ze){this.c.push({_type:1,from:F,to:re,options:ve,metadata:ze})}createFile(F,re,ve){this.c.push({_type:1,from:void 0,to:F,options:re,metadata:ve})}deleteFile(F,re,ve){this.c.push({_type:1,from:F,to:void 0,options:re,metadata:ve})}e(F,re,ve){this.c.push({_type:3,metadata:ve,uri:F,edit:{editType:5,metadata:re},notebookMetadata:re})}f(F,re,ve,ze){const We=re.start,Ke=re.end;(We!==Ke||ve.length>0)&&this.c.push({_type:5,uri:F,index:We,count:Ke-We,cells:ve,metadata:ze})}g(F,re,ve,ze){this.c.push({_type:3,metadata:ze,uri:F,edit:{editType:3,index:re,metadata:ve}})}replace(F,re,ve,ze){this.c.push({_type:2,uri:F,edit:new Z(re,ve),metadata:ze})}insert(F,re,ve,ze){this.replace(F,new ae(re,re),ve,ze)}delete(F,re,ve){this.replace(F,re,"",ve)}has(F){return this.c.some(re=>re._type===2&&re.uri.toString()===F.toString())}set(F,re){if(re)for(const ve of re){if(!ve)continue;let ze,We;Array.isArray(ve)?(ze=ve[0],We=ve[1]):ze=ve,he.isNotebookCellEdit(ze)?ze.newCellMetadata?this.g(F,ze.range.start,ze.newCellMetadata,We):ze.newNotebookMetadata?this.e(F,ze.newNotebookMetadata,We):this.f(F,ze.range,ze.newCells,We):x.isSnippetTextEdit(ze)?this.c.push({_type:6,uri:F,range:ze.range,edit:ze.snippet,metadata:We}):this.c.push({_type:2,uri:F,edit:ze,metadata:We})}else{for(let ve=0;ve<this.c.length;ve++){const ze=this.c[ve];switch(ze._type){case 2:case 6:case 3:case 5:ze.uri.toString()===F.toString()&&(this.c[ve]=void 0);break}}(0,s.$Ib)(this.c)}}get(F){const re=[];for(const ve of this.c)ve._type===2&&ve.uri.toString()===F.toString()&&re.push(ve.edit);return re}entries(){const F=new k.$Bc;for(const re of this.c)if(re._type===2){let ve=F.get(re.uri);ve||(ve=[re.uri,[]],F.set(re.uri,ve)),ve[1].push(re.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jN=H,e.$jN=H=Fe([q],H);let L=P=class{static isSnippetString(F){return F instanceof P?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=P.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,re=this.e++){if(typeof F=="function"){const ve=new P;ve.e=this.e,F(ve),this.e=ve.e,F=ve.value}else F=P.c(F);return this.value+="${",this.value+=re,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,re=this.e++){const ve=F.map(ze=>ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ve,this.value+="|}",this}appendVariable(F,re){if(typeof re=="function"){const ve=new P;ve.e=this.e,re(ve),this.e=ve.e,re=ve.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$kN=L,e.$kN=L=P=Fe([q],L);var U;(function(T){T[T.Unnecessary=1]="Unnecessary",T[T.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var oe;(function(T){T[T.Hint=3]="Hint",T[T.Information=2]="Information",T[T.Warning=1]="Warning",T[T.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let le=j=class{static isLocation(F){return F instanceof j?!0:F?ae.isRange(F.range)&&g.URI.isUri(F.uri):!1}constructor(F,re){if(this.uri=F,re)if(ae.isRange(re))this.range=ae.of(re);else if(Q.isPosition(re))this.range=new ae(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lN=le,e.$lN=le=j=Fe([q],le);let de=class{static is(F){return F?typeof F.message=="string"&&F.location&&ae.isRange(F.location.range)&&g.URI.isUri(F.location.uri):!1}constructor(F,re){this.location=F,this.message=re}static isEqual(F,re){return F===re?!0:!F||!re?!1:F.message===re.message&&F.location.range.isEqual(re.location.range)&&F.location.uri.toString()===re.location.uri.toString()}};e.$mN=de,e.$mN=de=Fe([q],de);let te=class{constructor(F,re,ve=oe.Error){if(!ae.isRange(F))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=F,this.message=re,this.severity=ve}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,re){return F===re?!0:!F||!re?!1:F.message===re.message&&F.severity===re.severity&&F.code===re.code&&F.severity===re.severity&&F.source===re.source&&F.range.isEqual(re.range)&&(0,s.$ub)(F.tags,re.tags)&&(0,s.$ub)(F.relatedInformation,re.relatedInformation,de.isEqual)}};e.$nN=te,e.$nN=te=Fe([q],te);let me=class{constructor(F,re){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=re}};e.$oN=me,e.$oN=me=Fe([q],me);let pe=class extends me{constructor(F,re,ve,ze){super(F,re),this.canIncreaseHover=ve,this.canDecreaseHover=ze}};e.$pN=pe,e.$pN=pe=Fe([q],pe);var Ce;(function(T){T[T.Increase=0]="Increase",T[T.Decrease=1]="Decrease"})(Ce||(e.HoverVerbosityAction=Ce={}));var je;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(je||(e.DocumentHighlightKind=je={}));let ge=class{constructor(F,re=je.Text){this.range=F,this.kind=re}toJSON(){return{range:this.range,kind:je[this.kind]}}};e.$qN=ge,e.$qN=ge=Fe([q],ge);let Se=class{constructor(F,re){this.uri=F,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$rN=Se,e.$rN=Se=Fe([q],Se);var De;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(De||(e.SymbolKind=De={}));var Te;(function(T){T[T.Deprecated=1]="Deprecated"})(Te||(e.SymbolTag=Te={}));let Le=O=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,re,ve,ze,We){this.name=F,this.kind=re,this.containerName=We,typeof ve=="string"&&(this.containerName=ve),ze instanceof le?this.location=ze:ve instanceof ae&&(this.location=new le(ze,ve)),O.validate(this)}toJSON(){return{name:this.name,kind:De[this.kind],location:this.location,containerName:this.containerName}}};e.$sN=Le,e.$sN=Le=O=Fe([q],Le);let Ue=R=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(R.validate)}constructor(F,re,ve,ze,We){this.name=F,this.detail=re,this.kind=ve,this.range=ze,this.selectionRange=We,this.children=[],R.validate(this)}};e.$tN=Ue,e.$tN=Ue=R=Fe([q],Ue);var Qe;(function(T){T[T.Invoke=1]="Invoke",T[T.Automatic=2]="Automatic"})(Qe||(e.CodeActionTriggerKind=Qe={}));let Ge=class{constructor(F,re){this.title=F,this.kind=re}};e.$uN=Ge,e.$uN=Ge=Fe([q],Ge);let Je=A=class{constructor(F){this.value=F}append(F){return new A(this.value?this.value+A.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+A.c)}};e.$vN=Je,Je.c=".",e.$vN=Je=A=Fe([q],Je),Je.Empty=new Je(""),Je.QuickFix=Je.Empty.append("quickfix"),Je.Refactor=Je.Empty.append("refactor"),Je.RefactorExtract=Je.Refactor.append("extract"),Je.RefactorInline=Je.Refactor.append("inline"),Je.RefactorMove=Je.Refactor.append("move"),Je.RefactorRewrite=Je.Refactor.append("rewrite"),Je.Source=Je.Empty.append("source"),Je.SourceOrganizeImports=Je.Source.append("organizeImports"),Je.SourceFixAll=Je.Source.append("fixAll"),Je.Notebook=Je.Empty.append("notebook");let Ye=class{constructor(F,re){if(this.range=F,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$wN=Ye,e.$wN=Ye=Fe([q],Ye);class nt{constructor(F,re,ve,ze,We,Ke){this.kind=F,this.name=re,this.detail=ve,this.uri=ze,this.range=We,this.selectionRange=Ke}}e.$xN=nt;class _e{constructor(F,re){this.fromRanges=re,this.from=F}}e.$yN=_e;class Ze{constructor(F,re){this.fromRanges=re,this.to=F}}e.$zN=Ze;var $e;(function(T){T[T.Information=0]="Information",T[T.Warning=1]="Warning",T[T.Error=2]="Error"})($e||(e.LanguageStatusSeverity=$e={}));let Ie=class{constructor(F,re){this.range=F,this.command=re}get isResolved(){return!!this.command}};e.$AN=Ie,e.$AN=Ie=Fe([q],Ie);let Ae=B=class{static isMarkdownString(F){return F instanceof B?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,re=!1){f.set(this,void 0),Lt(this,f,new D.$Tk(F,{supportThemeIcons:re}),"f")}get value(){return tt(this,f,"f").value}set value(F){tt(this,f,"f").value=F}get isTrusted(){return tt(this,f,"f").isTrusted}set isTrusted(F){tt(this,f,"f").isTrusted=F}get supportThemeIcons(){return tt(this,f,"f").supportThemeIcons}set supportThemeIcons(F){tt(this,f,"f").supportThemeIcons=F}get supportHtml(){return tt(this,f,"f").supportHtml}set supportHtml(F){tt(this,f,"f").supportHtml=F}get baseUri(){return tt(this,f,"f").baseUri}set baseUri(F){tt(this,f,"f").baseUri=F}appendText(F){return tt(this,f,"f").appendText(F),this}appendMarkdown(F){return tt(this,f,"f").appendMarkdown(F),this}appendCodeblock(F,re){return tt(this,f,"f").appendCodeblock(re??"",F),this}};e.$BN=Ae,f=new WeakMap,e.$BN=Ae=B=Fe([q],Ae);let Re=class{constructor(F,re){this.label=F,this.documentation=re}};e.$CN=Re,e.$CN=Re=Fe([q],Re);let Me=class{constructor(F,re){this.label=F,this.documentation=re,this.parameters=[]}};e.$DN=Me,e.$DN=Me=Fe([q],Me);let Ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$EN=Ve,e.$EN=Ve=Fe([q],Ve);var He;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(He||(e.SignatureHelpTriggerKind=He={}));var st;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(st||(e.InlayHintKind=st={}));let rt=class{constructor(F){this.value=F}};e.$FN=rt,e.$FN=rt=Fe([q],rt);let xe=class{constructor(F,re,ve){this.position=F,this.label=re,this.kind=ve}};e.$GN=xe,e.$GN=xe=Fe([q],xe);var ct;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var at;(function(T){T[T.Text=0]="Text",T[T.Method=1]="Method",T[T.Function=2]="Function",T[T.Constructor=3]="Constructor",T[T.Field=4]="Field",T[T.Variable=5]="Variable",T[T.Class=6]="Class",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Unit=10]="Unit",T[T.Value=11]="Value",T[T.Enum=12]="Enum",T[T.Keyword=13]="Keyword",T[T.Snippet=14]="Snippet",T[T.Color=15]="Color",T[T.File=16]="File",T[T.Reference=17]="Reference",T[T.Folder=18]="Folder",T[T.EnumMember=19]="EnumMember",T[T.Constant=20]="Constant",T[T.Struct=21]="Struct",T[T.Event=22]="Event",T[T.Operator=23]="Operator",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue"})(at||(e.CompletionItemKind=at={}));var gt;(function(T){T[T.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let lt=class{constructor(F,re){this.label=F,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$HN=lt,e.$HN=lt=Fe([q],lt);let $t=class{constructor(F=[],re=!1){this.items=F,this.isIncomplete=re}};e.$IN=$t,e.$IN=$t=Fe([q],$t);let yt=class{constructor(F,re,ve){this.insertText=F,this.range=re,this.command=ve}};e.$JN=yt,e.$JN=yt=Fe([q],yt);let St=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$KN=St,e.$KN=St=Fe([q],St);var Tt;(function(T){T[T.Unknown=0]="Unknown",T[T.Word=1]="Word",T[T.Line=2]="Line",T[T.Suggest=3]="Suggest"})(Tt||(e.PartialAcceptTriggerKind=Tt={}));var Mt;(function(T){T[T.Active=-1]="Active",T[T.Beside=-2]="Beside",T[T.One=1]="One",T[T.Two=2]="Two",T[T.Three=3]="Three",T[T.Four=4]="Four",T[T.Five=5]="Five",T[T.Six=6]="Six",T[T.Seven=7]="Seven",T[T.Eight=8]="Eight",T[T.Nine=9]="Nine"})(Mt||(e.ViewColumn=Mt={}));var Pt;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function jt(T,F){return`${v.$Sm.toKey(T)}.${F}`}var Bt;(function(T){T[T.Off=0]="Off",T[T.On=1]="On",T[T.Relative=2]="Relative",T[T.Interval=3]="Interval"})(Bt||(e.TextEditorLineNumbersStyle=Bt={}));var zt;(function(T){T[T.Manual=1]="Manual",T[T.AfterDelay=2]="AfterDelay",T[T.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var dt;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(dt||(e.TextEditorRevealType=dt={}));var It;(function(T){T[T.Keyboard=1]="Keyboard",T[T.Mouse=2]="Mouse",T[T.Command=3]="Command"})(It||(e.TextEditorSelectionChangeKind=It={}));var qt;(function(T){T[T.Undo=1]="Undo",T[T.Redo=2]="Redo"})(qt||(e.TextDocumentChangeReason=qt={}));var it;(function(T){T[T.OpenOpen=0]="OpenOpen",T[T.ClosedClosed=1]="ClosedClosed",T[T.OpenClosed=2]="OpenClosed",T[T.ClosedOpen=3]="ClosedOpen"})(it||(e.DecorationRangeBehavior=it={})),function(T){function F(re){switch(re){case"keyboard":return T.Keyboard;case"mouse":return T.Mouse;case"api":return T.Command}}T.fromValue=F}(It||(e.TextEditorSelectionChangeKind=It={}));var mt;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(mt||(e.SyntaxTokenType=mt={})),function(T){function F(re){switch(re){case T.Other:return"other";case T.Comment:return"comment";case T.String:return"string";case T.RegEx:return"regex"}return"other"}T.toString=F}(mt||(e.SyntaxTokenType=mt={}));let wt=class{constructor(F,re){if(re&&!g.URI.isUri(re))throw(0,C.$7)("target");if(!ae.isRange(F)||F.isEmpty)throw(0,C.$7)("range");this.range=F,this.target=re}};e.$MN=wt,e.$MN=wt=Fe([q],wt);let Ot=class{constructor(F,re,ve,ze){this.red=F,this.green=re,this.blue=ve,this.alpha=ze}};e.$NN=Ot,e.$NN=Ot=Fe([q],Ot);let Ct=class{constructor(F,re){if(re&&!(re instanceof Ot))throw(0,C.$7)("color");if(!ae.isRange(F)||F.isEmpty)throw(0,C.$7)("range");this.range=F,this.color=re}};e.$ON=Ct,e.$ON=Ct=Fe([q],Ct);let Qt=class{constructor(F){if(!F||typeof F!="string")throw(0,C.$7)("label");this.label=F}};e.$PN=Qt,e.$PN=Qt=Fe([q],Qt);var Vt;(function(T){T[T.RGB=0]="RGB",T[T.HEX=1]="HEX",T[T.HSL=2]="HSL"})(Vt||(e.ColorFormat=Vt={}));var Ut;(function(T){T[T.Error=0]="Error",T[T.Warning=1]="Warning",T[T.Information=2]="Information"})(Ut||(e.SourceControlInputBoxValidationType=Ut={}));var Xt;(function(T){T[T.Unknown=0]="Unknown",T[T.Shutdown=1]="Shutdown",T[T.Process=2]="Process",T[T.User=3]="User",T[T.Extension=4]="Extension"})(Xt||(e.TerminalExitReason=Xt={}));var Nt;(function(T){T[T.Low=0]="Low",T[T.Medium=1]="Medium",T[T.High=2]="High"})(Nt||(e.TerminalShellExecutionCommandLineConfidence=Nt={}));class Ht{constructor(F,re,ve){if(this.startIndex=F,this.length=re,this.tooltip=ve,typeof F!="number"||F<0)throw(0,C.$7)("startIndex");if(typeof re!="number"||re<1)throw(0,C.$7)("length");if(ve!==void 0&&typeof ve!="string")throw(0,C.$7)("tooltip")}}e.$QN=Ht;class Wt{constructor(F){this.uri=F}}e.$RN=Wt;class nn{constructor(F){this.terminalCommand=F}}e.$SN=nn;var rn;(function(T){T[T.Panel=1]="Panel",T[T.Editor=2]="Editor"})(rn||(e.TerminalLocation=rn={}));class ln{constructor(F){if(this.options=F,typeof F!="object")throw(0,C.$7)("options")}}e.$TN=ln;var Yt;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(Yt||(e.TaskRevealKind=Yt={}));var Kt;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(Kt||(e.TaskPanelKind=Kt={}));let Et=G=class{static from(F){switch(F){case"clean":return G.Clean;case"build":return G.Build;case"rebuild":return G.Rebuild;case"test":return G.Test;default:return}}constructor(F,re){if(this.label=re,typeof F!="string"||typeof re!="string")throw(0,C.$7)("name");this.c=F}get id(){return this.c}};e.$UN=Et,Et.Clean=new G("clean","Clean"),Et.Build=new G("build","Build"),Et.Rebuild=new G("rebuild","Rebuild"),Et.Test=new G("test","Test"),e.$UN=Et=G=Fe([q],Et);function _t(T){let F="";for(let re=0;re<T.length;re++)F+=T[re].replace(/,/g,",,")+",";return F}let Gt=class{constructor(F,re,ve){if(typeof F!="string")throw(0,C.$7)("process");this.e=[],this.c=F,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=ve):this.f=re)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,C.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const re of this.e)F.push(re);return _t(F)}};e.$VN=Gt,e.$VN=Gt=Fe([q],Gt);let Rt=class{constructor(F,re,ve){if(this.f=[],Array.isArray(re)){if(!F)throw(0,C.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,C.$7)("command");this.e=F,this.f=re,this.g=ve}else{if(typeof F!="string")throw(0,C.$7)("commandLine");this.c=F,this.g=re}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,C.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,C.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)F.push(typeof re=="string"?re:re.value);return _t(F)}};e.$WN=Rt,e.$WN=Rt=Fe([q],Rt);var un;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(un||(e.ShellQuoting=un={}));var en;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace"})(en||(e.TaskScope=en={}));class sn{constructor(F){this.c=F}computeId(){return"customExecution"+(0,y.$Sg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$XN=sn;let kt=se=class{constructor(F,re,ve,ze,We,Ke){this.k=!1,this.l=this.definition=F;let et;typeof re=="string"?(this.o=this.name=re,this.w=this.source=ve,this.execution=ze,et=We,this.k=!0):re===en.Global||re===en.Workspace?(this.target=re,this.o=this.name=ve,this.w=this.source=ze,this.execution=We,et=Ke):(this.target=re,this.o=this.name=ve,this.w=this.source=ze,this.execution=We,et=Ke),typeof et=="string"?(this.r=[et],this.t=!0):Array.isArray(et)?(this.r=et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Gt?this.l={type:se.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:se.f,id:this.q.computeId()}:this.q instanceof sn?this.l={type:se.c,id:this.q.computeId()}:this.l={type:se.g,id:(0,y.$Sg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,C.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,C.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const re=this.l.type;(se.g===re||se.e===re||se.f===re||se.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,C.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$YN=kt,kt.c="customExecution",kt.e="process",kt.f="shell",kt.g="$empty",e.$YN=kt=se=Fe([q],kt);var hn;(function(T){T[T.SourceControl=1]="SourceControl",T[T.Window=10]="Window",T[T.Notification=15]="Notification"})(hn||(e.ProgressLocation=hn={}));var on;(function(T){function F(re){const ve=re;return(0,w.$ag)(ve.value)?ve.tooltip&&!(0,w.$9f)(ve.tooltip)?(console.log("INVALID view badge, invalid tooltip",ve.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ve.value),!1)}T.isViewBadge=F})(on||(e.ViewBadge=on={}));let an=ce=class{static isTreeItem(F,re){const ve=F;if(ve.checkboxState!==void 0){const ze=(0,w.$ag)(ve.checkboxState)?ve.checkboxState:(0,w.$$f)(ve.checkboxState)&&(0,w.$ag)(ve.checkboxState.state)?ve.checkboxState.state:void 0,We=!(0,w.$ag)(ve.checkboxState)&&(0,w.$$f)(ve.checkboxState)?ve.checkboxState.tooltip:void 0;if(ze===void 0||ze!==tn.Checked&&ze!==tn.Unchecked||We!==void 0&&!(0,w.$9f)(We))return console.log("INVALID tree item, invalid checkboxState",ve.checkboxState),!1}if(F instanceof ce)return!0;if(ve.label!==void 0&&!(0,w.$9f)(ve.label)&&!ve.label?.label)return console.log("INVALID tree item, invalid label",ve.label),!1;if(ve.id!==void 0&&!(0,w.$9f)(ve.id))return console.log("INVALID tree item, invalid id",ve.id),!1;if(ve.iconPath!==void 0&&!(0,w.$9f)(ve.iconPath)&&!g.URI.isUri(ve.iconPath)&&(!ve.iconPath||!(0,w.$9f)(ve.iconPath.id))){const ze=ve.iconPath;if(!ze||!(0,w.$9f)(ze.light)&&!g.URI.isUri(ze.light)&&!(0,w.$9f)(ze.dark)&&!g.URI.isUri(ze.dark))return console.log("INVALID tree item, invalid iconPath",ve.iconPath),!1}return ve.description!==void 0&&!(0,w.$9f)(ve.description)&&typeof ve.description!="boolean"?(console.log("INVALID tree item, invalid description",ve.description),!1):ve.resourceUri!==void 0&&!g.URI.isUri(ve.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ve.resourceUri),!1):ve.tooltip!==void 0&&!(0,w.$9f)(ve.tooltip)&&!(ve.tooltip instanceof Ae)?(console.log("INVALID tree item, invalid tooltip",ve.tooltip),!1):ve.command!==void 0&&!ve.command.command?(console.log("INVALID tree item, invalid command",ve.command),!1):ve.collapsibleState!==void 0&&ve.collapsibleState<Jt.None&&ve.collapsibleState>Jt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ve.collapsibleState),!1):ve.contextValue!==void 0&&!(0,w.$9f)(ve.contextValue)?(console.log("INVALID tree item, invalid contextValue",ve.contextValue),!1):ve.accessibilityInformation!==void 0&&!ve.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ve.accessibilityInformation),!1):!0}constructor(F,re=Jt.None){this.collapsibleState=re,g.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$ZN=an,e.$ZN=an=ce=Fe([q],an);var Jt;(function(T){T[T.None=0]="None",T[T.Collapsed=1]="Collapsed",T[T.Expanded=2]="Expanded"})(Jt||(e.TreeItemCollapsibleState=Jt={}));var tn;(function(T){T[T.Unchecked=0]="Unchecked",T[T.Checked=1]="Checked"})(tn||(e.TreeItemCheckboxState=tn={}));let xt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$1N=xt,e.$1N=xt=Fe([q],xt);class fn extends xt{}e.$2N=fn;class be extends fn{constructor(F){super(""),c.set(this,void 0),Lt(this,c,F,"f")}asFile(){return tt(this,c,"f")}}e.$3N=be,c=new WeakMap;class Pe{constructor(F,re,ve,ze){this.name=F,this.uri=re,this._itemId=ve,this.c=ze}data(){return this.c()}}e.$4N=Pe;let fe=class{constructor(F){d.add(this),$.set(this,new Map);for(const[re,ve]of F??[]){const ze=tt(this,$,"f").get(tt(this,d,"m",E).call(this,re));ze?ze.push(ve):tt(this,$,"f").set(tt(this,d,"m",E).call(this,re),[ve])}}get(F){return tt(this,$,"f").get(tt(this,d,"m",E).call(this,F))?.[0]}set(F,re){tt(this,$,"f").set(tt(this,d,"m",E).call(this,F),[re])}forEach(F,re){for(const[ve,ze]of tt(this,$,"f"))for(const We of ze)F.call(re,We,ve,this)}*[($=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[F,re]of tt(this,$,"f"))for(const ve of re)yield[F,ve]}};e.$5N=fe,E=function(F){return F.toLowerCase()},e.$5N=fe=Fe([q],fe);let W=class{constructor(F,re,ve){this.insertText=F,this.title=re,this.kind=ve}};e.$6N=W,e.$6N=W=Fe([q],W);var ke;(function(T){T[T.Automatic=0]="Automatic",T[T.PasteAs=1]="PasteAs"})(ke||(e.DocumentPasteTriggerKind=ke={}));class Oe{constructor(F){this.value=F}append(...F){return new Oe((this.value?[this.value,...F]:F).join(Oe.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+Oe.c)}}e.$7N=Oe,Oe.c=".",Oe.Empty=new Oe("");class qe{constructor(F,re,ve){this.title=re,this.insertText=F,this.kind=ve}}e.$8N=qe;let Be=class{constructor(F,re){this.id=F,this.color=re}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$9N=Be,e.$9N=Be=Fe([q],Be),Be.File=new Be("file"),Be.Folder=new Be("folder");let Xe=class{constructor(F){this.id=F}};e.$0N=Xe,e.$0N=Xe=Fe([q],Xe);var ot;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.WorkspaceFolder=3]="WorkspaceFolder"})(ot||(e.ConfigurationTarget=ot={}));let pt=class{get base(){return this.c}set base(F){this.c=F,this.e=g.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,re){if(typeof F!="string"&&(!F||!g.URI.isUri(F)&&!g.URI.isUri(F.uri)))throw(0,C.$7)("base");if(typeof re!="string")throw(0,C.$7)("pattern");typeof F=="string"?this.baseUri=g.URI.file(F):g.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$N=pt,e.$$N=pt=Fe([q],pt);const bt=new WeakMap;function ut(T,F){bt.set(T,F)}let ht=class{constructor(F,re,ve,ze,We){this.enabled=typeof F=="boolean"?F:!0,typeof re=="string"&&(this.condition=re),typeof ve=="string"&&(this.hitCondition=ve),typeof ze=="string"&&(this.logMessage=ze),typeof We=="string"&&(this.mode=We)}get id(){return this.c||(this.c=bt.get(this)??(0,y.$Sg)()),this.c}};e.$aO=ht,e.$aO=ht=Fe([q],ht);let bn=class extends ht{constructor(F,re,ve,ze,We,Ke){if(super(re,ve,ze,We,Ke),F===null)throw(0,C.$7)("location");this.location=F}};e.$bO=bn,e.$bO=bn=Fe([q],bn);let vn=class extends ht{constructor(F,re,ve,ze,We,Ke){super(re,ve,ze,We,Ke),this.functionName=F}};e.$cO=vn,e.$cO=vn=Fe([q],vn);let yn=class extends ht{constructor(F,re,ve,ze,We,Ke,et,ft){if(super(ze,We,Ke,et,ft),!re)throw(0,C.$7)("dataId");this.label=F,this.dataId=re,this.canPersist=ve}};e.$dO=yn,e.$dO=yn=Fe([q],yn);let En=class{constructor(F,re,ve){this.command=F,this.args=re||[],this.options=ve}};e.$eO=En,e.$eO=En=Fe([q],En);let kn=class{constructor(F,re){this.port=F,this.host=re}};e.$fO=kn,e.$fO=kn=Fe([q],kn);let Dn=class{constructor(F){this.path=F}};e.$gO=Dn,e.$gO=Dn=Fe([q],Dn);let Sn=class{constructor(F){this.implementation=F}};e.$hO=Sn,e.$hO=Sn=Fe([q],Sn);class ji{constructor(F,re,ve){this.session=F,this.threadId=re,this.frameId=ve}}e.$iO=ji;class Oi{constructor(F,re){this.session=F,this.threadId=re}}e.$jO=Oi;let Pn=class{constructor(F,re){this.range=F,this.expression=re}};e.$kO=Pn,e.$kO=Pn=Fe([q],Pn);var Qn;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(Qn||(e.InlineCompletionTriggerKind=Qn={}));let In=class{constructor(F,re){this.range=F,this.text=re}};e.$lO=In,e.$lO=In=Fe([q],In);let Cn=class{constructor(F,re,ve=!0){this.range=F,this.variableName=re,this.caseSensitiveLookup=ve}};e.$mO=Cn,e.$mO=Cn=Fe([q],Cn);let An=class{constructor(F,re){this.range=F,this.expression=re}};e.$nO=An,e.$nO=An=Fe([q],An);let jn=class{constructor(F,re){this.frameId=F,this.stoppedLocation=re}};e.$oO=jn,e.$oO=jn=Fe([q],jn);var Vn;(function(T){T[T.AIGenerated=1]="AIGenerated"})(Vn||(e.NewSymbolNameTag=Vn={}));var Un;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(Un||(e.NewSymbolNameTriggerKind=Un={}));class Ni{constructor(F,re){this.newSymbolName=F,this.tags=re}}e.$pO=Ni;var Hn;(function(T){T[T.Changed=1]="Changed",T[T.Created=2]="Created",T[T.Deleted=3]="Deleted"})(Hn||(e.FileChangeType=Hn={}));let On=ee=class extends Error{static FileExists(F){return new ee(F,b.FileSystemProviderErrorCode.FileExists,ee.FileExists)}static FileNotFound(F){return new ee(F,b.FileSystemProviderErrorCode.FileNotFound,ee.FileNotFound)}static FileNotADirectory(F){return new ee(F,b.FileSystemProviderErrorCode.FileNotADirectory,ee.FileNotADirectory)}static FileIsADirectory(F){return new ee(F,b.FileSystemProviderErrorCode.FileIsADirectory,ee.FileIsADirectory)}static NoPermissions(F){return new ee(F,b.FileSystemProviderErrorCode.NoPermissions,ee.NoPermissions)}static Unavailable(F){return new ee(F,b.FileSystemProviderErrorCode.Unavailable,ee.Unavailable)}constructor(F,re=b.FileSystemProviderErrorCode.Unknown,ve){super(g.URI.isUri(F)?F.toString(!0):F),this.code=ve?.name??"Unknown",(0,b.$fl)(this,re),Object.setPrototypeOf(this,ee.prototype),typeof Error.captureStackTrace=="function"&&typeof ve=="function"&&Error.captureStackTrace(this,ve)}};e.$qO=On,e.$qO=On=ee=Fe([q],On);let Nn=class{constructor(F,re,ve){this.start=F,this.end=re,this.kind=ve}};e.$rO=Nn,e.$rO=Nn=Fe([q],Nn);var Wn;(function(T){T[T.Comment=1]="Comment",T[T.Imports=2]="Imports",T[T.Region=3]="Region"})(Wn||(e.FoldingRangeKind=Wn={}));var Gn;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(Gn||(e.CommentThreadCollapsibleState=Gn={}));var Jn;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(Jn||(e.CommentMode=Jn={}));var xn;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(xn||(e.CommentState=xn={}));var Zn;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(Zn||(e.CommentThreadState=Zn={}));var Xn;(function(T){T[T.Current=0]="Current",T[T.Outdated=1]="Outdated"})(Xn||(e.CommentThreadApplicability=Xn={}));class Ri{constructor(F,re=[]){this.tokenTypes=F,this.tokenModifiers=re}}e.$sO=Ri;function Fi(T){return typeof T>"u"||(0,w.$0f)(T)}class Rn{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let re=0,ve=F.tokenTypes.length;re<ve;re++)this.k.set(F.tokenTypes[re],re);for(let re=0,ve=F.tokenModifiers.length;re<ve;re++)this.l.set(F.tokenModifiers[re],re)}}push(F,re,ve,ze,We){if(typeof F=="number"&&typeof re=="number"&&typeof ve=="number"&&typeof ze=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.q(F,re,ve,ze,We);if(ae.isRange(F)&&typeof re=="string"&&Fi(ve))return this.o(F,re,ve);throw(0,C.$7)()}o(F,re,ve){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const ze=F.start.line,We=F.start.character,Ke=F.end.character-F.start.character,et=this.k.get(re);let ft=0;if(ve)for(const vt of ve){if(!this.l.has(vt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.l.get(vt);ft|=1<<Dt>>>0}this.q(ze,We,Ke,et,ft)}q(F,re,ve,ze,We){if(this.f&&(F<this.c||F===this.c&&re<this.e)){this.f=!1;const ft=this.g.length/5|0;let vt=0,Dt=0;for(let At=0;At<ft;At++){let Ft=this.g[5*At],dn=this.g[5*At+1];Ft===0?(Ft=vt,dn+=Dt):Ft+=vt,this.g[5*At]=Ft,this.g[5*At+1]=dn,vt=Ft,Dt=dn}}let Ke=F,et=re;this.f&&this.j>0&&(Ke-=this.c,Ke===0&&(et-=this.e)),this.g[this.j++]=Ke,this.g[this.j++]=et,this.g[this.j++]=ve,this.g[this.j++]=ze,this.g[this.j++]=We,this.c=F,this.e=re}static r(F){const re=[],ve=F.length/5|0;for(let et=0;et<ve;et++)re[et]=et;re.sort((et,ft)=>{const vt=F[5*et],Dt=F[5*ft];if(vt===Dt){const At=F[5*et+1],Ft=F[5*ft+1];return At-Ft}return vt-Dt});const ze=new Uint32Array(F.length);let We=0,Ke=0;for(let et=0;et<ve;et++){const ft=5*re[et],vt=F[ft+0],Dt=F[ft+1],At=F[ft+2],Ft=F[ft+3],dn=F[ft+4],Ai=vt-We,Er=Ai===0?Dt-Ke:Dt,mn=5*et;ze[mn+0]=Ai,ze[mn+1]=Er,ze[mn+2]=At,ze[mn+3]=Ft,ze[mn+4]=dn,We=vt,Ke=Dt}return ze}build(F){return this.f?new Fn(new Uint32Array(this.g),F):new Fn(Rn.r(this.g),F)}}e.$tO=Rn;class Fn{constructor(F,re){this.resultId=re,this.data=F}}e.$uO=Fn;class Li{constructor(F,re,ve){this.start=F,this.deleteCount=re,this.data=ve}}e.$vO=Li;class Ti{constructor(F,re){this.resultId=re,this.edits=F}}e.$wO=Ti;var Yn;(function(T){T[T.Separate=0]="Separate",T[T.MergeWithParent=1]="MergeWithParent"})(Yn||(e.DebugConsoleMode=Yn={}));class Mi{constructor(F){this.name=F}}e.$xO=Mi;let gn=class{constructor(){}};e.$yO=gn,gn.Back={iconPath:new Be("arrow-left")},e.$yO=gn=Fe([q],gn);var Kn;(function(T){T[T.Separator=-1]="Separator",T[T.Default=0]="Default"})(Kn||(e.QuickPickItemKind=Kn={}));var _n;(function(T){T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(_n||(e.InputBoxValidationSeverity=_n={}));var ei;(function(T){T[T.UI=1]="UI",T[T.Workspace=2]="Workspace"})(ei||(e.ExtensionKind=ei={}));class Bi{static validate(F){if(typeof F.badge=="string"){let re=(0,S.$If)(F.badge,0);if(re<F.badge.length&&(re+=(0,S.$If)(F.badge,re)),F.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Be.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,re,ve){this.badge=F,this.tooltip=re,this.color=ve}}e.$zO=Bi;let Ln=class{constructor(F){this.kind=F}};e.$AO=Ln,e.$AO=Ln=Fe([q],Ln);var ti;(function(T){T[T.Light=1]="Light",T[T.Dark=2]="Dark",T[T.HighContrast=3]="HighContrast",T[T.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class Zt{static isNotebookRange(F){return F instanceof Zt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,re){if(F<0)throw(0,C.$7)("start must be positive");if(re<0)throw(0,C.$7)("end must be positive");F<=re?(this.c=F,this.e=re):(this.c=re,this.e=F)}with(F){let re=this.c,ve=this.e;return F.start!==void 0&&(re=F.start),F.end!==void 0&&(ve=F.end),re===this.c&&ve===this.e?this:new Zt(re,ve)}}e.$BO=Zt;class $n{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(re=>$n.isNotebookCellData(re))}static isNotebookCellData(F){return!0}constructor(F,re,ve,ze,We,Ke,et){this.kind=F,this.value=re,this.languageId=ve,this.mime=ze,this.outputs=We??[],this.metadata=Ke,this.executionSummary=et,$n.validate(this)}}e.$CO=$n;class zi{constructor(F){this.cells=F}}e.$DO=zi;class ni{static isNotebookCellOutputItem(F){return F instanceof h?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const re={name:F.name,message:F.message,stack:F.stack};return h.json(re,"application/vnd.code.notebook.error")}static stdout(F){return h.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return h.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,re="application/octet-stream"){return new h(F,re)}static text(F,re=I.$Rs.text){const ve=tt(h,h,"f",t).encode(String(F));return new h(ve,re)}static json(F,re="text/x-json"){const ve=JSON.stringify(F,void 0,"	");return h.text(ve,re)}constructor(F,re){this.data=F,this.mime=re;const ve=(0,I.$Vs)(re,!0);if(!ve)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ve}}e.$EO=ni,h=ni,t={value:new TextEncoder};class pn{static isNotebookCellOutput(F){return F instanceof pn?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,re=!1){const ve=new Set,ze=new Set;for(let We=0;We<F.length;We++){const Ke=F[We],et=(0,I.$Vs)(Ke.mime);if(!ve.has(et)||(0,u.$7K)(et)){ve.add(et);continue}ze.add(We),re&&console.warn(`DUPLICATED mime type '${Ke.mime}' will be dropped`)}return ze.size===0?F:F.filter((We,Ke)=>!ze.has(Ke))}constructor(F,re,ve){this.items=pn.ensureUniqueMimeTypes(F,!0),typeof re=="string"?(this.id=re,this.metadata=ve):(this.id=(0,y.$Sg)(),this.metadata=re??ve)}}e.$FO=pn;var ii;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(ii||(e.NotebookCellKind=ii={}));var ri;(function(T){T[T.Idle=1]="Idle",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(ri||(e.NotebookCellExecutionState=ri={}));var si;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(si||(e.NotebookCellStatusBarAlignment=si={}));var oi;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(oi||(e.NotebookEditorRevealType=oi={}));class qi{constructor(F,re){this.text=F,this.alignment=re}}e.$GO=qi;var ai;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred"})(ai||(e.NotebookControllerAffinity=ai={}));var ci;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred",T[T.Hidden=-1]="Hidden"})(ci||(e.NotebookControllerAffinity2=ci={}));class Qi{constructor(F,re=[]){this.uri=F,this.provides=(0,s.$3b)(re)}}e.$HO=Qi;class Vi{constructor(F){this.label=F}}e.$IO=Vi;var li;(function(T){T[T.Named=1]="Named",T[T.Indexed=2]="Indexed"})(li||(e.NotebookVariablesRequestKind=li={}));let Tn=class{constructor(F,re){this.label=F,this.timestamp=re}};e.$JO=Tn,e.$JO=Tn=Fe([q],Tn);var ui;(function(T){T[T.Production=1]="Production",T[T.Development=2]="Development",T[T.Test=3]="Test"})(ui||(e.ExtensionMode=ui={}));var hi;(function(T){T[T.Node=1]="Node",T[T.Webworker=2]="Webworker"})(hi||(e.ExtensionRuntime=hi={}));var fi;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(fi||(e.StandardTokenType=fi={}));class Ui{constructor(F,re){this.ranges=F,this.wordPattern=re}}e.$KO=Ui;class Hi{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$LO=Hi;var di;(function(T){T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(di||(e.TestResultState=di={}));var mi;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(mi||(e.TestRunProfileKind=mi={}));let Mn=class{constructor(F=void 0,re=void 0,ve=void 0,ze=!1,We=!0){this.include=F,this.exclude=re,this.profile=ve,this.continuous=ze,this.preserveFocus=We}};e.$MO=Mn,e.$MO=Mn=Fe([q],Mn);let Bn=K=class{static diff(F,re,ve){const ze=new K(F);return ze.expectedOutput=re,ze.actualOutput=ve,ze}constructor(F){this.message=F}};e.$NO=Bn,e.$NO=Bn=K=Fe([q],Bn);let zn=class{constructor(F){this.id=F}};e.$OO=zn,e.$OO=zn=Fe([q],zn);class wn{constructor(F,re){this.covered=F,this.total=re,gi(this)}}e.$PO=wn;function gi(T){if(T){if(T.covered>T.total)throw new Error(`The total number of covered items (${T.covered}) cannot be greater than the total (${T.total})`);if(T.total<0)throw new Error(`The number of covered items (${T.total}) cannot be negative`)}}class qn{static fromDetails(F,re){const ve=new wn(0,0),ze=new wn(0,0),We=new wn(0,0);for(const et of re)if("branches"in et){ve.total+=1,ve.covered+=et.executed?1:0;for(const ft of et.branches)ze.total+=1,ze.covered+=ft.executed?1:0}else We.total+=1,We.covered+=et.executed?1:0;const Ke=new qn(F,ve,ze.total>0?ze:void 0,We.total>0?We:void 0);return Ke.detailedCoverage=re,Ke}constructor(F,re,ve,ze){this.uri=F,this.statementCoverage=re,this.branchCoverage=ve,this.declarationCoverage=ze}}e.$RO=qn;class Wi{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,re,ve=[]){this.executed=F,this.location=re,this.branches=ve}}e.$SO=Wi;class Gi{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,re,ve){this.executed=F,this.location=re,this.label=ve}}e.$TO=Gi;class Ji{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,re,ve){this.name=F,this.executed=re,this.location=ve}}e.$UO=Ji;var $i;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})($i||(e.ExternalUriOpenerPriority=$i={}));var pi;(function(T){T[T.Untrusted=0]="Untrusted",T[T.Trusted=1]="Trusted",T[T.Unspecified=2]="Unspecified"})(pi||(e.WorkspaceTrustState=pi={}));var wi;(function(T){T[T.Notify=1]="Notify",T[T.OpenBrowser=2]="OpenBrowser",T[T.OpenPreview=3]="OpenPreview",T[T.Silent=4]="Silent",T[T.Ignore=5]="Ignore",T[T.OpenBrowserOnce=6]="OpenBrowserOnce"})(wi||(e.PortAutoForwardAction=wi={}));class xi{constructor(F,re,ve,ze,We,Ke){this.kind=F,this.name=re,this.detail=ve,this.uri=ze,this.range=We,this.selectionRange=Ke}}e.$VO=xi;class Zi{constructor(F){this.uri=F}}e.$WO=Zi;class Xi{constructor(F,re){this.original=F,this.modified=re}}e.$XO=Xi;class Yi{constructor(F,re,ve,ze){this.base=F,this.input1=re,this.input2=ve,this.result=ze}}e.$YO=Yi;class Ki{constructor(F,re){this.uri=F,this.viewType=re}}e.$ZO=Ki;class _i{constructor(F){this.viewType=F}}e.$1O=_i;class er{constructor(F,re){this.uri=F,this.notebookType=re}}e.$2O=er;class tr{constructor(F,re,ve){this.original=F,this.modified=re,this.notebookType=ve}}e.$3O=tr;class nr{constructor(){}}e.$4O=nr;class ir{constructor(F,re){this.uri=F,this.inputBoxUri=re}}e.$5O=ir;class rr{constructor(){}}e.$6O=rr;class sr{constructor(F){this.textDiffs=F}}e.$7O=sr;var bi;(function(T){T[T.Down=0]="Down",T[T.Up=1]="Up"})(bi||(e.InteractiveSessionVoteDirection=bi={}));var vi;(function(T){T[T.Action=1]="Action",T[T.Toolbar=2]="Toolbar"})(vi||(e.ChatCopyKind=vi={}));var yi;(function(T){T[T.Short=1]="Short",T[T.Medium=2]="Medium",T[T.Full=3]="Full"})(yi||(e.ChatVariableLevel=yi={}));class or{constructor(F,re){this.label=F,this.values=re}}e.$8O=or;var Ei;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful",T[T.Undone=2]="Undone",T[T.Accepted=3]="Accepted",T[T.Bug=4]="Bug"})(Ei||(e.InteractiveEditorResponseFeedbackKind=Ei={}));var ki;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful"})(ki||(e.ChatResultFeedbackKind=ki={}));class ar{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ae(F):F}}e.$9O=ar;class cr{constructor(F,re){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ae(F):F,this.vulnerabilities=re}}e.$0O=cr;class lr{constructor(F,re){this.participant=F,this.command=re}}e.$$O=lr;class ur{constructor(F,re){this.value=F,this.baseUri=re}}e.$_O=ur;class hr{constructor(F,re){this.value=F,this.title=re}}e.$aP=hr;class fr{constructor(F){this.value=F}}e.$bP=fr;class dr{constructor(F){this.value=F}}e.$cP=dr;class mr{constructor(F,re){this.value=F,this.iconPath=re}}e.$dP=mr;class gr{constructor(F,re){this.uri=F,this.edits=Array.isArray(re)?re:[re]}}e.$eP=gr;class $r{constructor(F,re,ve,ze){this.prompt=F,this.command=re,this.variables=ve,this.participant=ze}}e.$fP=$r;class pr{constructor(F,re,ve,ze){this.response=F,this.result=re,this.participant=ve,this.command=ze}}e.$gP=pr;var Di;(function(T){T[T.Panel=1]="Panel",T[T.Terminal=2]="Terminal",T[T.Notebook=3]="Notebook",T[T.Editor=4]="Editor"})(Di||(e.ChatLocation=Di={}));class wr{constructor(F){this.content=F}}e.$hP=wr;class br{constructor(F,re){this.content=F,this.name=re}}e.$iP=br;class vr{constructor(F,re){this.content=F,this.name=re}}e.$jP=vr;class cn extends Error{static NotFound(F){return new cn(F,cn.NotFound.name)}static NoPermissions(F){return new cn(F,cn.NoPermissions.name)}constructor(F,re,ve){super(F,{cause:ve}),this.name="LanguageModelError",this.code=re??""}}e.$kP=cn;var Si;(function(T){T[T.SymbolInformation=1]="SymbolInformation",T[T.CommandInformation=2]="CommandInformation",T[T.SearchInformation=3]="SearchInformation",T[T.SettingInformation=4]="SettingInformation"})(Si||(e.RelatedInformationType=Si={}));var Pi;(function(T){T[T.Started=1]="Started",T[T.Recognizing=2]="Recognizing",T[T.Recognized=3]="Recognized",T[T.Stopped=4]="Stopped",T[T.Error=5]="Error"})(Pi||(e.SpeechToTextStatus=Pi={}));var Ii;(function(T){T[T.Recognized=1]="Recognized",T[T.Stopped=2]="Stopped"})(Ii||(e.KeywordRecognitionStatus=Ii={}));class yr{constructor(F,re){this.text=F,this.range=re}}e.$lP=yr;var Ci;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(Ci||(e.InlineEditTriggerKind=Ci={}))}),define(ye[142],Ee([1,0,18,15,166,75,102,24,150,54,61,21,156,19,10,4,46,184,242,136,95,285,140,72,96,138,141,76]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o,r,i,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$uP=q,e.$vP=_,e.$wP=M;var p;(function(be){function Pe(W){const{selectionStartLineNumber:ke,selectionStartColumn:Oe,positionLineNumber:qe,positionColumn:Be}=W,Xe=new n.$aN(ke-1,Oe-1),ot=new n.$aN(qe-1,Be-1);return new n.$cN(Xe,ot)}be.to=Pe;function fe(W){const{anchor:ke,active:Oe}=W;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}be.from=fe})(p||(e.Selection=p={}));var P;(function(be){function Pe(W){if(!W)return;const{start:ke,end:Oe}=W;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}be.from=Pe;function fe(W){if(!W)return;const{startLineNumber:ke,startColumn:Oe,endLineNumber:qe,endColumn:Be}=W;return new n.$bN(ke-1,Oe-1,qe-1,Be-1)}be.to=fe})(P||(e.Range=P={}));var j;(function(be){function Pe(W){return{uri:W.uri,range:P.from(W.range)}}be.from=Pe;function fe(W){return new n.$lN(a.URI.revive(W.uri),P.to(W.range))}be.to=fe})(j||(e.Location=j={}));var O;(function(be){function Pe(fe){switch(fe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}be.to=Pe})(O||(e.TokenType=O={}));var R;(function(be){function Pe(W){return new n.$aN(W.lineNumber-1,W.column-1)}be.to=Pe;function fe(W){return{lineNumber:W.line+1,column:W.character+1}}be.from=fe})(R||(e.Position=R={}));var A;(function(be){function Pe(ke,Oe,qe){return(0,s.$Hb)((0,s.$3b)(ke).map(Be=>fe(Be,Oe,qe)))}be.from=Pe;function fe(ke,Oe,qe){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:qe?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:W(ke.scheme,Oe),pattern:He.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:qe?.isBuiltin}}function W(ke,Oe){return Oe&&typeof ke=="string"?Oe.transformOutgoingScheme(ke):ke}})(A||(e.DocumentSelector=A={}));var B;(function(be){function Pe(W){switch(W){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}be.from=Pe;function fe(W){switch(W){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}be.to=fe})(B||(e.DiagnosticTag=B={}));var G;(function(be){function Pe(W){let ke;return W.code&&((0,u.$9f)(W.code)||(0,u.$ag)(W.code)?ke=String(W.code):ke={value:String(W.code.value),target:W.code.target}),{...P.from(W.range),message:W.message,source:W.source,code:ke,severity:ce.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(se.from),tags:Array.isArray(W.tags)?(0,s.$Hb)(W.tags.map(B.from)):void 0}}be.from=Pe;function fe(W){const ke=new n.$nN(P.to(W),W.message,ce.to(W.severity));return ke.source=W.source,ke.code=(0,u.$9f)(W.code)?W.code:W.code?.value,ke.relatedInformation=W.relatedInformation&&W.relatedInformation.map(se.to),ke.tags=W.tags&&(0,s.$Hb)(W.tags.map(B.to)),ke}be.to=fe})(G||(e.Diagnostic=G={}));var se;(function(be){function Pe(W){return{...P.from(W.location.range),message:W.message,resource:W.location.uri}}be.from=Pe;function fe(W){return new n.$mN(new n.$lN(W.resource,P.to(W)),W.message)}be.to=fe})(se||(e.DiagnosticRelatedInformation=se={}));var ce;(function(be){function Pe(W){switch(W){case n.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}be.from=Pe;function fe(W){switch(W){case d.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}be.to=fe})(ce||(e.DiagnosticSeverity=ce={}));var ee;(function(be){function Pe(W){return typeof W=="number"&&W>=n.ViewColumn.One?W-1:W===n.ViewColumn.Beside?i.$5D:i.$4D}be.from=Pe;function fe(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=fe})(ee||(e.ViewColumn=ee={}));function K(be){return typeof be.range<"u"}function q(be){return be.length===0?!0:!!K(be[0])}var X;(function(be){function Pe(Be){return Be.map(be.from)}be.fromMany=Pe;function fe(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function W(Be){let Xe;if(fe(Be)){const{language:ut,value:ht}=Be;Xe={value:"```"+ut+`
`+ht+"\n```\n"}}else n.$BN.isMarkdownString(Be)?Xe={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Xe={value:Be}:Xe={value:""};const ot=Object.create(null);Xe.uris=ot;const pt=ut=>{try{let ht=a.URI.parse(ut,!0);ht=ht.with({query:ke(ht.query,ot)}),ot[ut]=ht}catch{}return""},bt=new w.marked.Renderer;return bt.link=pt,bt.image=ut=>typeof ut=="string"?pt(I.$2k(ut).href):"",(0,w.marked)(Xe.value,{renderer:bt}),Xe}be.from=W;function ke(Be,Xe){if(!Be)return Be;let ot;try{ot=(0,g.$5h)(Be)}catch{}if(!ot)return Be;let pt=!1;return ot=(0,v.$6n)(ot,bt=>{if(a.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[ut]=bt,pt=!0,ut}else return}),pt?JSON.stringify(ot):Be}function Oe(Be){const Xe=new n.$BN(Be.value,Be.supportThemeIcons);return Xe.isTrusted=Be.isTrusted,Xe.supportHtml=Be.supportHtml,Xe.baseUri=Be.baseUri?a.URI.from(Be.baseUri):void 0,Xe}be.to=Oe;function qe(Be){if(Be)return typeof Be=="string"?Be:be.from(Be)}be.fromStrict=qe})(X||(e.MarkdownString=X={}));function _(be){return q(be)?be.map(Pe=>({range:P.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?X.fromMany(Pe.hoverMessage):Pe.hoverMessage?X.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):be.map(Pe=>({range:P.from(Pe)}))}function M(be){return typeof be>"u"?be:typeof be=="string"?a.URI.file(be):be}var Q;(function(be){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?M(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}be.from=Pe})(Q||(e.ThemableDecorationAttachmentRenderOptions=Q={}));var ae;(function(be){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?M(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Q.from(fe.before):void 0,after:fe.after?Q.from(fe.after):void 0}}be.from=Pe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var ne;(function(be){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Pe})(ne||(e.DecorationRangeBehavior=ne={}));var we;(function(be){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ne.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?M(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Q.from(fe.before):void 0,after:fe.after?Q.from(fe.after):void 0}}be.from=Pe})(we||(e.DecorationRenderOptions=we={}));var ie;(function(be){function Pe(W){return{text:W.newText,eol:W.newEol&&Ie.from(W.newEol),range:P.from(W.range)}}be.from=Pe;function fe(W){const ke=new n.$gN(P.to(W.range),W.text);return ke.newEol=typeof W.eol>"u"?void 0:Ie.to(W.eol),ke}be.to=fe})(ie||(e.TextEdit=ie={}));var Y;(function(be){function Pe(W,ke){const Oe={edits:[]};if(W instanceof n.$jN){const qe=new S.$Cc;for(const Be of W._allEntries())Be._type===1&&a.URI.isUri(Be.to)&&Be.from===void 0&&qe.add(Be.to);for(const Be of W._allEntries())if(Be._type===1){let Xe;Be.options?.contents&&(ArrayBuffer.isView(Be.options.contents)?Xe={type:"base64",value:(0,C.$1e)(C.$Ge.wrap(Be.options.contents))}:Xe={type:"dataTransferItem",id:Be.options.contents._itemId}),Oe.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contents:Xe},metadata:Be.metadata})}else Be._type===2?Oe.edits.push({resource:Be.uri,textEdit:ie.from(Be.edit),versionId:qe.has(Be.uri)?void 0:ke?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Oe.edits.push({resource:Be.uri,textEdit:{range:P.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:qe.has(Be.uri)?void 0:ke?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Oe.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Oe.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map($t.from)}})}return Oe}be.from=Pe;function fe(W){const ke=new n.$jN,Oe=new S.$Bc;for(const qe of W.edits)if(qe.textEdit){const Be=qe,Xe=a.URI.revive(Be.resource),ot=P.to(Be.textEdit.range),pt=Be.textEdit.text,bt=Be.textEdit.insertAsSnippet;let ut;bt?ut=n.$iN.replace(ot,new n.$kN(pt)):ut=n.$gN.replace(ot,pt);const ht=Oe.get(Xe);ht?ht.push(ut):Oe.set(Xe,[ut])}else ke.renameFile(a.URI.revive(qe.oldResource),a.URI.revive(qe.newResource),qe.options);for(const[qe,Be]of Oe)ke.set(qe,Be);return ke}be.to=fe})(Y||(e.WorkspaceEdit=Y={}));var V;(function(be){const Pe=Object.create(null);Pe[n.SymbolKind.File]=0,Pe[n.SymbolKind.Module]=1,Pe[n.SymbolKind.Namespace]=2,Pe[n.SymbolKind.Package]=3,Pe[n.SymbolKind.Class]=4,Pe[n.SymbolKind.Method]=5,Pe[n.SymbolKind.Property]=6,Pe[n.SymbolKind.Field]=7,Pe[n.SymbolKind.Constructor]=8,Pe[n.SymbolKind.Enum]=9,Pe[n.SymbolKind.Interface]=10,Pe[n.SymbolKind.Function]=11,Pe[n.SymbolKind.Variable]=12,Pe[n.SymbolKind.Constant]=13,Pe[n.SymbolKind.String]=14,Pe[n.SymbolKind.Number]=15,Pe[n.SymbolKind.Boolean]=16,Pe[n.SymbolKind.Array]=17,Pe[n.SymbolKind.Object]=18,Pe[n.SymbolKind.Key]=19,Pe[n.SymbolKind.Null]=20,Pe[n.SymbolKind.EnumMember]=21,Pe[n.SymbolKind.Struct]=22,Pe[n.SymbolKind.Event]=23,Pe[n.SymbolKind.Operator]=24,Pe[n.SymbolKind.TypeParameter]=25;function fe(ke){return typeof Pe[ke]=="number"?Pe[ke]:6}be.from=fe;function W(ke){for(const Oe in Pe)if(Pe[Oe]===ke)return Number(Oe);return n.SymbolKind.Property}be.to=W})(V||(e.SymbolKind=V={}));var N;(function(be){function Pe(W){switch(W){case n.SymbolTag.Deprecated:return 1}}be.from=Pe;function fe(W){switch(W){case 1:return n.SymbolTag.Deprecated}}be.to=fe})(N||(e.SymbolTag=N={}));var z;(function(be){function Pe(W){return{name:W.name,kind:V.from(W.kind),tags:W.tags&&W.tags.map(N.from),containerName:W.containerName,location:H.from(W.location)}}be.from=Pe;function fe(W){const ke=new n.$sN(W.name,V.to(W.kind),W.containerName,H.to(W.location));return ke.tags=W.tags&&W.tags.map(N.to),ke}be.to=fe})(z||(e.WorkspaceSymbol=z={}));var Z;(function(be){function Pe(W){const ke={name:W.name||"!!MISSING: name!!",detail:W.detail,range:P.from(W.range),selectionRange:P.from(W.selectionRange),kind:V.from(W.kind),tags:W.tags?.map(N.from)??[]};return W.children&&(ke.children=W.children.map(Pe)),ke}be.from=Pe;function fe(W){const ke=new n.$tN(W.name,W.detail,V.to(W.kind),P.to(W.range),P.to(W.selectionRange));return(0,s.$Lb)(W.tags)&&(ke.tags=W.tags.map(N.to)),W.children&&(ke.children=W.children.map(fe)),ke}be.to=fe})(Z||(e.DocumentSymbol=Z={}));var he;(function(be){function Pe(W){const ke=new n.$xN(V.to(W.kind),W.name,W.detail||"",a.URI.revive(W.uri),P.to(W.range),P.to(W.selectionRange));return ke._sessionId=W._sessionId,ke._itemId=W._itemId,ke}be.to=Pe;function fe(W,ke,Oe){if(ke=ke??W._sessionId,Oe=Oe??W._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,name:W.name,detail:W.detail,kind:V.from(W.kind),uri:W.uri,range:P.from(W.range),selectionRange:P.from(W.selectionRange),tags:W.tags?.map(N.from)}}be.from=fe})(he||(e.CallHierarchyItem=he={}));var x;(function(be){function Pe(fe){return new n.$yN(he.to(fe.from),fe.fromRanges.map(W=>P.to(W)))}be.to=Pe})(x||(e.CallHierarchyIncomingCall=x={}));var J;(function(be){function Pe(fe){return new n.$zN(he.to(fe.to),fe.fromRanges.map(W=>P.to(W)))}be.to=Pe})(J||(e.CallHierarchyOutgoingCall=J={}));var H;(function(be){function Pe(W){return{range:W.range&&P.from(W.range),uri:W.uri}}be.from=Pe;function fe(W){return new n.$lN(a.URI.revive(W.uri),P.to(W.range))}be.to=fe})(H||(e.location=H={}));var L;(function(be){function Pe(W){const ke=W,Oe=W;return{originSelectionRange:ke.originSelectionRange?P.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Oe.uri,range:P.from(ke.targetRange?ke.targetRange:Oe.range),targetSelectionRange:ke.targetSelectionRange?P.from(ke.targetSelectionRange):void 0}}be.from=Pe;function fe(W){return{targetUri:a.URI.revive(W.uri),targetRange:P.to(W.range),targetSelectionRange:W.targetSelectionRange?P.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?P.to(W.originSelectionRange):void 0}}be.to=fe})(L||(e.DefinitionLink=L={}));var U;(function(be){function Pe(W){return{range:P.from(W.range),contents:X.fromMany(W.contents),canIncreaseVerbosity:W.canIncreaseVerbosity,canDecreaseVerbosity:W.canDecreaseVerbosity}}be.from=Pe;function fe(W){const ke=W.contents.map(X.to),Oe=P.to(W.range),qe=W.canIncreaseVerbosity,Be=W.canDecreaseVerbosity;return new n.$pN(ke,Oe,qe,Be)}be.to=fe})(U||(e.Hover=U={}));var oe;(function(be){function Pe(W){return{range:P.from(W.range),expression:W.expression}}be.from=Pe;function fe(W){return new n.$kO(P.to(W.range),W.expression)}be.to=fe})(oe||(e.EvaluatableExpression=oe={}));var le;(function(be){function Pe(W){if(W instanceof n.$lO)return{type:"text",range:P.from(W.range),text:W.text};if(W instanceof n.$mO)return{type:"variable",range:P.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof n.$nO)return{type:"expression",range:P.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Pe;function fe(W){switch(W.type){case"text":return{range:P.to(W.range),text:W.text};case"variable":return{range:P.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:P.to(W.range),expression:W.expression}}}be.to=fe})(le||(e.InlineValue=le={}));var de;(function(be){function Pe(W){return{frameId:W.frameId,stoppedLocation:P.from(W.stoppedLocation)}}be.from=Pe;function fe(W){return new n.$oO(W.frameId,P.to(W.stoppedLocation))}be.to=fe})(de||(e.InlineValueContext=de={}));var te;(function(be){function Pe(W){return{range:P.from(W.range),kind:W.kind}}be.from=Pe;function fe(W){return new n.$qN(P.to(W.range),W.kind)}be.to=fe})(te||(e.DocumentHighlight=te={}));var me;(function(be){function Pe(W){return{uri:W.uri,highlights:W.highlights.map(te.from)}}be.from=Pe;function fe(W){return new n.$rN(a.URI.revive(W.uri),W.highlights.map(te.to))}be.to=fe})(me||(e.MultiDocumentHighlight=me={}));var pe;(function(be){function Pe(fe){switch(fe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}be.to=Pe})(pe||(e.CompletionTriggerKind=pe={}));var Ce;(function(be){function Pe(fe){return{triggerKind:pe.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}be.to=Pe})(Ce||(e.CompletionContext=Ce={}));var je;(function(be){function Pe(W){switch(W){case n.CompletionItemTag.Deprecated:return 1}}be.from=Pe;function fe(W){switch(W){case 1:return n.CompletionItemTag.Deprecated}}be.to=fe})(je||(e.CompletionItemTag=je={}));var ge;(function(be){const Pe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function fe(Oe){return Pe.get(Oe)??9}be.from=fe;const W=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function ke(Oe){return W.get(Oe)??n.CompletionItemKind.Property}be.to=ke})(ge||(e.CompletionItemKind=ge={}));var Se;(function(be){function Pe(fe,W){const ke=new n.$HN(fe.label);return ke.insertText=fe.insertText,ke.kind=ge.to(fe.kind),ke.tags=fe.tags?.map(je.to),ke.detail=fe.detail,ke.documentation=I.$Vk(fe.documentation)?X.to(fe.documentation):fe.documentation,ke.sortText=fe.sortText,ke.filterText=fe.filterText,ke.preselect=fe.preselect,ke.commitCharacters=fe.commitCharacters,f.$vt.isIRange(fe.range)?ke.range=P.to(fe.range):typeof fe.range=="object"&&(ke.range={inserting:P.to(fe.range.insert),replacing:P.to(fe.range.replace)}),ke.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?ke.insertText=new n.$kN(fe.insertText):(ke.insertText=fe.insertText,ke.textEdit=ke.range instanceof n.$bN?new n.$gN(ke.range,ke.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(ke.additionalTextEdits=fe.additionalTextEdits.map(Oe=>ie.to(Oe))),ke.command=W&&fe.command?W.fromInternal(fe.command):void 0,ke}be.to=Pe})(Se||(e.CompletionItem=Se={}));var De;(function(be){function Pe(W){if(typeof W.label!="string"&&!Array.isArray(W.label))throw new TypeError("Invalid label");return{label:W.label,documentation:X.fromStrict(W.documentation)}}be.from=Pe;function fe(W){return{label:W.label,documentation:I.$Vk(W.documentation)?X.to(W.documentation):W.documentation}}be.to=fe})(De||(e.ParameterInformation=De={}));var Te;(function(be){function Pe(W){return{label:W.label,documentation:X.fromStrict(W.documentation),parameters:Array.isArray(W.parameters)?W.parameters.map(De.from):[],activeParameter:W.activeParameter}}be.from=Pe;function fe(W){return{label:W.label,documentation:I.$Vk(W.documentation)?X.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(De.to):[],activeParameter:W.activeParameter}}be.to=fe})(Te||(e.SignatureInformation=Te={}));var Le;(function(be){function Pe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Te.from):[]}}be.from=Pe;function fe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Te.to):[]}}be.to=fe})(Le||(e.SignatureHelp=Le={}));var Ue;(function(be){function Pe(fe,W){const ke=new n.$GN(R.to(W.position),typeof W.label=="string"?W.label:W.label.map(Qe.to.bind(void 0,fe)),W.kind&&Ge.to(W.kind));return ke.textEdits=W.textEdits&&W.textEdits.map(ie.to),ke.tooltip=I.$Vk(W.tooltip)?X.to(W.tooltip):W.tooltip,ke.paddingLeft=W.paddingLeft,ke.paddingRight=W.paddingRight,ke}be.to=Pe})(Ue||(e.InlayHint=Ue={}));var Qe;(function(be){function Pe(fe,W){const ke=new n.$FN(W.label);return ke.tooltip=I.$Vk(W.tooltip)?X.to(W.tooltip):W.tooltip,c.Command.is(W.command)&&(ke.command=fe.fromInternal(W.command)),W.location&&(ke.location=H.to(W.location)),ke}be.to=Pe})(Qe||(e.InlayHintLabelPart=Qe={}));var Ge;(function(be){function Pe(W){return W}be.from=Pe;function fe(W){return W}be.to=fe})(Ge||(e.InlayHintKind=Ge={}));var Je;(function(be){function Pe(W){return{range:P.from(W.range),url:W.target,tooltip:W.tooltip}}be.from=Pe;function fe(W){let ke;if(W.url)try{ke=typeof W.url=="string"?a.URI.parse(W.url,!0):a.URI.revive(W.url)}catch{}return new n.$MN(P.to(W.range),ke)}be.to=fe})(Je||(e.DocumentLink=Je={}));var Ye;(function(be){function Pe(W){const ke=new n.$PN(W.label);return W.textEdit&&(ke.textEdit=ie.to(W.textEdit)),W.additionalTextEdits&&(ke.additionalTextEdits=W.additionalTextEdits.map(Oe=>ie.to(Oe))),ke}be.to=Pe;function fe(W){return{label:W.label,textEdit:W.textEdit?ie.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(ke=>ie.from(ke)):void 0}}be.from=fe})(Ye||(e.ColorPresentation=Ye={}));var nt;(function(be){function Pe(W){return new n.$NN(W[0],W[1],W[2],W[3])}be.to=Pe;function fe(W){return[W.red,W.green,W.blue,W.alpha]}be.from=fe})(nt||(e.Color=nt={}));var _e;(function(be){function Pe(W){return{range:P.from(W.range)}}be.from=Pe;function fe(W){return new n.$wN(P.to(W.range))}be.to=fe})(_e||(e.SelectionRange=_e={}));var Ze;(function(be){function Pe(fe){switch(fe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}be.to=Pe})(Ze||(e.TextDocumentSaveReason=Ze={}));var $e;(function(be){function Pe(W){switch(W){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Pe;function fe(W){switch(W){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}be.to=fe})($e||(e.TextEditorLineNumbersStyle=$e={}));var Ie;(function(be){function Pe(W){if(W===n.EndOfLine.CRLF)return 1;if(W===n.EndOfLine.LF)return 0}be.from=Pe;function fe(W){if(W===1)return n.EndOfLine.CRLF;if(W===0)return n.EndOfLine.LF}be.to=fe})(Ie||(e.EndOfLine=Ie={}));var Ae;(function(be){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Pe})(Ae||(e.ProgressLocation=Ae={}));var Re;(function(be){function Pe(W){const ke={start:W.start+1,end:W.end+1};return W.kind&&(ke.kind=Me.from(W.kind)),ke}be.from=Pe;function fe(W){const ke={start:W.start-1,end:W.end-1};return W.kind&&(ke.kind=Me.to(W.kind)),ke}be.to=fe})(Re||(e.FoldingRange=Re={}));var Me;(function(be){function Pe(W){if(W)switch(W){case n.FoldingRangeKind.Comment:return c.$eu.Comment;case n.FoldingRangeKind.Imports:return c.$eu.Imports;case n.FoldingRangeKind.Region:return c.$eu.Region}}be.from=Pe;function fe(W){if(W)switch(W.value){case c.$eu.Comment.value:return n.FoldingRangeKind.Comment;case c.$eu.Imports.value:return n.FoldingRangeKind.Imports;case c.$eu.Region.value:return n.FoldingRangeKind.Region}}be.to=fe})(Me||(e.FoldingRangeKind=Me={}));var Ve;(function(be){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?P.from(fe.selection):void 0,override:typeof fe.override=="boolean"?E.$uF.id:void 0}}be.from=Pe})(Ve||(e.TextEditorOpenOptions=Ve={}));var He;(function(be){function Pe(Oe){return Oe instanceof n.$$N?Oe.toJSON():typeof Oe=="string"?Oe:fe(Oe)||W(Oe)?new n.$$N(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}be.from=Pe;function fe(Oe){const qe=Oe;return qe?a.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function W(Oe){const qe=Oe;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function ke(Oe){return typeof Oe=="string"?Oe:new n.$$N(a.URI.revive(Oe.baseUri),Oe.pattern)}be.to=ke})(He||(e.GlobPattern=He={}));var st;(function(be){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const W=fe;return{language:W.language,scheme:W.scheme,pattern:He.from(W.pattern),exclusive:W.exclusive,notebookType:W.notebookType}}}else return}be.from=Pe})(st||(e.LanguageSelector=st={}));var rt;(function(be){function Pe(W){return!!W&&typeof W=="object"&&"documents"in W&&Array.isArray(W.documents)&&W.documents.every(ke=>Array.isArray(ke)&&ke.every(Oe=>Oe&&typeof Oe=="object"&&"uri"in Oe&&a.URI.isUri(Oe.uri)&&"version"in Oe&&typeof Oe.version=="number"&&"ranges"in Oe&&Array.isArray(Oe.ranges)&&Oe.ranges.every(qe=>qe instanceof n.$bN)))}be.is=Pe;function fe(W){return{documents:W.documents.map(ke=>ke.map(Oe=>({uri:a.URI.from(Oe.uri),version:Oe.version,ranges:Oe.ranges.map(qe=>P.from(qe))})))}}be.from=fe})(rt||(e.MappedEditsContext=rt={}));var xe;(function(be){function Pe(W){return{start:W.start,end:W.end}}be.from=Pe;function fe(W){return new n.$BO(W.start,W.end)}be.to=fe})(xe||(e.NotebookRange=xe={}));var ct;(function(be){function Pe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}be.to=Pe;function fe(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}be.from=fe})(ct||(e.NotebookCellExecutionSummary=ct={}));var at;(function(be){function Pe(fe){if(fe===t.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(fe===t.NotebookCellExecutionState.Pending)return;if(fe===t.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}be.to=Pe})(at||(e.NotebookCellExecutionState=at={}));var gt;(function(be){function Pe(W){switch(W){case n.NotebookCellKind.Markup:return t.CellKind.Markup;case n.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=Pe;function fe(W){switch(W){case t.CellKind.Markup:return n.NotebookCellKind.Markup;case t.CellKind.Code:default:return n.NotebookCellKind.Code}}be.to=fe})(gt||(e.NotebookCellKind=gt={}));var lt;(function(be){function Pe(W){const ke={metadata:W.metadata??Object.create(null),cells:[]};for(const Oe of W.cells)n.$CO.validate(Oe),ke.cells.push($t.from(Oe));return ke}be.from=Pe;function fe(W){const ke=new n.$DO(W.cells.map($t.to));return(0,u.$jg)(W.metadata)||(ke.metadata=W.metadata),ke}be.to=fe})(lt||(e.NotebookData=lt={}));var $t;(function(be){function Pe(W){return{cellKind:gt.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:ct.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(St.from):[]}}be.from=Pe;function fe(W){return new n.$CO(gt.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(St.to):void 0,W.metadata,W.internalMetadata?ct.to(W.internalMetadata):void 0)}be.to=fe})($t||(e.NotebookCellData=$t={}));var yt;(function(be){function Pe(W){return{mime:W.mime,valueBytes:C.$Ge.wrap(W.data)}}be.from=Pe;function fe(W){return new n.$EO(W.valueBytes.buffer,W.mime)}be.to=fe})(yt||(e.NotebookCellOutputItem=yt={}));var St;(function(be){function Pe(W){return{outputId:W.id,items:W.items.map(yt.from),metadata:W.metadata}}be.from=Pe;function fe(W){const ke=W.items.map(yt.to);return new n.$FO(ke,W.outputId,W.metadata)}be.to=fe})(St||(e.NotebookCellOutput=St={}));var Tt;(function(be){function Pe(ke){return W(ke)?{include:He.from(ke.include)??void 0,exclude:He.from(ke.exclude)??void 0}:He.from(ke)??void 0}be.from=Pe;function fe(ke){return W(ke)?{include:He.to(ke.include),exclude:He.to(ke.exclude)}:He.to(ke)}be.to=fe;function W(ke){const Oe=ke;return Oe?!(0,u.$fg)(Oe.include)&&!(0,u.$fg)(Oe.exclude):!1}})(Tt||(e.NotebookExclusiveDocumentPattern=Tt={}));var Mt;(function(be){function Pe(fe,W,ke){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Oe,ke),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}be.from=Pe})(Mt||(e.NotebookStatusBarItem=Mt={}));var Pt;(function(be){function Pe(fe,W,ke){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:W.toInternal(Oe,ke),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}be.from=Pe})(Pt||(e.NotebookKernelSourceAction=Pt={}));var jt;(function(be){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}be.from=Pe})(jt||(e.NotebookDocumentContentOptions=jt={}));var Bt;(function(be){function Pe(W){return{uri:W.uri,provides:W.provides}}be.from=Pe;function fe(W){return new n.$HO(a.URI.revive(W.uri),W.provides)}be.to=fe})(Bt||(e.NotebookRendererScript=Bt={}));var zt;(function(be){function Pe(W){return{message:X.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,contextValue:W.contextValue,location:W.location&&{range:P.from(W.location.range),uri:W.location.uri}}}be.from=Pe;function fe(W){const ke=new n.$NO(typeof W.message=="string"?W.message:X.to(W.message));return ke.actualOutput=W.actual,ke.expectedOutput=W.expected,ke.contextValue=W.contextValue,ke.location=W.location?H.to(W.location):void 0,ke}be.to=fe})(zt||(e.TestMessage=zt={}));var dt;(function(be){be.namespace=r.$1L,be.denamespace=r.$2L})(dt||(e.TestTag=dt={}));var It;(function(be){function Pe(W){const ke=(0,$.$tP)(W).controllerId;return{extId:o.$VL.fromExtHostTestItem(W,ke).toString(),label:W.label,uri:a.URI.revive(W.uri),busy:W.busy,tags:W.tags.map(Oe=>dt.namespace(ke,Oe.id)),range:f.$vt.lift(P.from(W.range)),description:W.description||null,sortText:W.sortText||null,error:W.error&&X.fromStrict(W.error)||null}}be.from=Pe;function fe(W){return{parent:void 0,error:void 0,id:o.$VL.fromString(W.extId).localId,label:W.label,uri:a.URI.revive(W.uri),tags:(W.tags||[]).map(ke=>{const{tagId:Oe}=dt.denamespace(ke);return new n.$OO(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:P.to(W.range||void 0),canResolveChildren:!1,busy:W.busy,description:W.description||void 0,sortText:W.sortText||void 0}}be.toPlain=fe})(It||(e.TestItem=It={})),function(be){function Pe(W){return{id:W.id}}be.from=Pe;function fe(W){return new n.$OO(W.id)}be.to=fe}(dt||(e.TestTag=dt={}));var qt;(function(be){const Pe=(W,ke)=>{const Oe=W.value;if(!Oe)return;const qe={...It.toPlain(Oe.item),parent:ke,taskStates:Oe.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Xe=>Xe.type===0).map(zt.to)})),children:[]};if(W.children)for(const Be of W.children.values()){const Xe=Pe(Be,qe);Xe&&qe.children.push(Xe)}return qe};function fe(W){const ke=new b.$mP;for(const Be of W.items)ke.insert(o.$VL.fromString(Be.item.extId).path,Be);const Oe=[ke.nodes],qe=[];for(;Oe.length;)for(const Be of Oe.pop())Be.value?qe.push(Be):Be.children&&Oe.push(Be.children.values());return{completedAt:W.completedAt,results:qe.map(Be=>Pe(Be)).filter(u.$eg)}}be.to=fe})(qt||(e.TestResults=qt={}));var it;(function(be){function Pe(Oe){return{covered:Oe.covered,total:Oe.total}}function fe(Oe){return"line"in Oe?R.from(Oe):P.from(Oe)}function W(Oe){if(typeof Oe.executed=="number"&&Oe.executed<0)throw new Error(`Invalid coverage count ${Oe.executed}`);return"branches"in Oe?{count:Oe.executed,location:fe(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(qe=>({count:qe.executed,location:qe.location&&fe(qe.location),label:qe.label})):void 0}:{type:0,name:Oe.name,count:Oe.executed,location:fe(Oe.location)}}be.fromDetails=W;function ke(Oe,qe){return n.$QO(qe.statementCoverage),n.$QO(qe.branchCoverage),n.$QO(qe.declarationCoverage),{id:Oe,uri:qe.uri,statement:Pe(qe.statementCoverage),branch:qe.branchCoverage&&Pe(qe.branchCoverage),declaration:qe.declarationCoverage&&Pe(qe.declarationCoverage)}}be.fromFile=ke})(it||(e.TestCoverage=it={}));var mt;(function(be){function Pe(fe){switch(fe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}be.to=Pe})(mt||(e.CodeActionTriggerKind=mt={}));var wt;(function(be){function Pe(W){const ke=new n.$VO(V.to(W.kind),W.name,W.detail||"",a.URI.revive(W.uri),P.to(W.range),P.to(W.selectionRange));return ke._sessionId=W._sessionId,ke._itemId=W._itemId,ke}be.to=Pe;function fe(W,ke,Oe){if(ke=ke??W._sessionId,Oe=Oe??W._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,kind:V.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:P.from(W.range),selectionRange:P.from(W.selectionRange),tags:W.tags?.map(N.from)}}be.from=fe})(wt||(e.TypeHierarchyItem=wt={}));var Ot;(function(be){function Pe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}be.from=Pe})(Ot||(e.ViewBadge=Ot={}));var Ct;(function(be){function Pe(Oe,qe,Be){const Xe=qe.fileData;return Xe?new n.$3N(new n.$4N(Xe.name,a.URI.revive(Xe.uri),Xe.id,(0,k.$db)(()=>Be(Xe.id)))):Oe===y.$Rs.uriList&&qe.uriListData?new n.$2N(ke(qe.uriListData)):new n.$2N(qe.asString)}be.to=Pe;async function fe(Oe,qe){const Be=await qe.asString();if(Oe===y.$Rs.uriList)return{asString:Be,fileData:void 0,uriListData:W(Be)};const Xe=qe.asFile();return{asString:Be,fileData:Xe?{name:Xe.name,uri:Xe.uri,id:Xe._itemId??Xe.id}:void 0}}be.from=fe;function W(Oe){return D.$Vt.split(Oe).map(qe=>{if(qe.startsWith("#"))return qe;try{return a.URI.parse(qe)}catch{}return qe})}function ke(Oe){return D.$Vt.create(Oe.map(qe=>typeof qe=="string"?qe:a.URI.revive(qe)))}})(Ct||(e.DataTransferItem=Ct={}));var Qt;(function(be){function Pe(W,ke){const Oe=W.items.map(([qe,Be])=>[qe,Ct.to(qe,Be,ke)]);return new n.$5N(Oe)}be.toDataTransfer=Pe;async function fe(W){const ke={items:[]},Oe=[];for(const[qe,Be]of W)Oe.push((async()=>{ke.items.push([qe,await Ct.from(qe,Be)])})());return await Promise.all(Oe),ke}be.from=fe})(Qt||(e.DataTransfer=Qt={}));var Vt;(function(be){function Pe(W,ke){return{kind:"reply",agentId:W.participant??ke?.agentId??"",subCommand:W.command??ke?.command,message:W.prompt,title:W.label}}be.from=Pe;function fe(W){return{prompt:W.message,label:W.title,participant:W.agentId,command:W.subCommand}}be.to=fe})(Vt||(e.ChatFollowup=Vt={}));var Ut;(function(be){function Pe(fe){return"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}be.from=Pe})(Ut||(e.ChatInlineFollowup=Ut={}));var Xt;(function(be){function Pe(W){switch(W.role){case 0:return new n.$hP(W.content);case 1:return new n.$iP(W.content);case 2:return new n.$jP(W.content)}}be.to=Pe;function fe(W){if(W instanceof n.$hP)return{role:0,content:W.content};if(W instanceof n.$iP)return{role:1,content:W.content};if(W instanceof n.$jP)return{role:2,content:W.content};throw new Error("Invalid LanguageModelMessage")}be.from=fe})(Xt||(e.LanguageModelMessage=Xt={}));var Nt;(function(be){function Pe(ke){const Oe={};for(const qe of Object.keys(ke))Oe[qe]=ke[qe].map(be.to);return Oe}be.objectTo=Pe;function fe(ke){return{level:Ht.to(ke.level),kind:ke.kind,value:(0,a.$wc)(ke.value)?a.URI.revive(ke.value):ke.value,description:ke.description}}be.to=fe;function W(ke){return{level:Ht.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}be.from=W})(Nt||(e.ChatVariable=Nt={}));var Ht;(function(be){function Pe(W){switch(W){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}be.to=Pe;function fe(W){switch(W){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}be.from=fe})(Ht||(e.ChatVariableLevel=Ht={}));var Wt;(function(be){function Pe(fe){switch(fe){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Pe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var nn;(function(be){function Pe(W){return{kind:"markdownContent",content:X.from(W.value)}}be.from=Pe;function fe(W){return new n.$9O(X.to(W.content))}be.to=fe})(nn||(e.ChatResponseMarkdownPart=nn={}));var rn;(function(be){function Pe(W){return{kind:"markdownVuln",content:X.from(W.value),vulnerabilities:W.vulnerabilities}}be.from=Pe;function fe(W){return new n.$0O(X.to(W.content),W.vulnerabilities)}be.to=fe})(rn||(e.ChatResponseMarkdownWithVulnerabilitiesPart=rn={}));var ln;(function(be){function Pe(W){return{kind:"agentDetection",agentId:W.participant,command:W.command}}be.from=Pe;function fe(W){return new n.$$O(W.agentId,W.command)}be.to=fe})(ln||(e.ChatResponseDetectedParticipantPart=ln={}));var Yt;(function(be){function Pe(W){const{value:ke,baseUri:Oe}=W;function qe(Be,Xe){return Be.map(ot=>{const pt=a.URI.joinPath(Xe,ot.name);return{label:ot.name,uri:pt,children:ot.children&&qe(ot.children,pt)}})}return{kind:"treeData",treeData:{label:(0,m.$7g)(Oe),uri:Oe,children:qe(ke,Oe)}}}be.from=Pe;function fe(W){const ke=(0,g.$6h)(W.treeData);function Oe(Xe){return Xe.map(ot=>({name:ot.label,children:ot.children&&Oe(ot.children)}))}const qe=ke.uri,Be=ke.children?Oe(ke.children):[];return new n.$_O(Be,qe)}be.to=fe})(Yt||(e.ChatResponseFilesPart=Yt={}));var Kt;(function(be){function Pe(W){return{kind:"inlineReference",name:W.title,inlineReference:a.URI.isUri(W.value)?W.value:j.from(W.value)}}be.from=Pe;function fe(W){const ke=(0,g.$6h)(W);return new n.$aP(a.URI.isUri(ke.inlineReference)?ke.inlineReference:j.to(ke.inlineReference),W.name)}be.to=fe})(Kt||(e.ChatResponseAnchorPart=Kt={}));var Et;(function(be){function Pe(W){return{kind:"progressMessage",content:X.from(W.value)}}be.from=Pe;function fe(W){return new n.$bP(W.content.value)}be.to=fe})(Et||(e.ChatResponseProgressPart=Et={}));var _t;(function(be){function Pe(W,ke,Oe){return{kind:"command",command:ke.toInternal(W.value,Oe)??{command:W.value.command,title:W.value.title}}}be.from=Pe;function fe(W,ke){return new n.$cP(ke.fromInternal(W.command)??{command:W.command.id,title:W.command.title})}be.to=fe})(_t||(e.ChatResponseCommandButtonPart=_t={}));var Gt;(function(be){function Pe(W){return{kind:"textEdit",uri:W.uri,edits:W.edits.map(ke=>ie.from(ke))}}be.from=Pe;function fe(W){return new n.$eP(a.URI.revive(W.uri),W.edits.map(ke=>ie.to(ke)))}be.to=fe})(Gt||(e.ChatResponseTextEditPart=Gt={}));var Rt;(function(be){function Pe(W){const ke=l.ThemeIcon.isThemeIcon(W.iconPath)?W.iconPath:void 0;return"variableName"in W.value?{kind:"reference",reference:{variableName:W.value.variableName,value:a.URI.isUri(W.value.value)||!W.value.value?W.value.value:j.from(W.value.value)},iconPath:ke}:{kind:"reference",reference:a.URI.isUri(W.value)?W.value:j.from(W.value),iconPath:ke}}be.from=Pe;function fe(W){const ke=(0,g.$6h)(W),Oe=qe=>a.URI.isUri(qe)?qe:j.to(qe);return new n.$dP("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Oe(ke.reference.value)}:Oe(ke.reference))}be.to=fe})(Rt||(e.ChatResponseReferencePart=Rt={}));var un;(function(be){function Pe(ke,Oe,qe){return ke instanceof n.$9O?nn.from(ke):ke instanceof n.$aP?Kt.from(ke):ke instanceof n.$dP?Rt.from(ke):ke instanceof n.$bP?Et.from(ke):ke instanceof n.$_O?Yt.from(ke):ke instanceof n.$cP?_t.from(ke,Oe,qe):ke instanceof n.$eP?Gt.from(ke):ke instanceof n.$0O?rn.from(ke):ke instanceof n.$$O?ln.from(ke):{kind:"markdownContent",content:X.from("")}}be.from=Pe;function fe(ke,Oe){switch(ke.kind){case"reference":return Rt.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return W(ke,Oe)}}be.to=fe;function W(ke,Oe){switch(ke.kind){case"markdownContent":return nn.to(ke);case"inlineReference":return Kt.to(ke);case"progressMessage":return;case"treeData":return Yt.to(ke);case"command":return _t.to(ke,Oe)}}be.toContent=W})(un||(e.ChatResponsePart=un={}));var en;(function(be){function Pe(fe){return{prompt:fe.message,command:fe.command,attempt:fe.attempt??0,enableCommandDetection:fe.enableCommandDetection??!0,variables:fe.variables.variables.map(kt.to),location:sn.to(fe.location)}}be.to=Pe})(en||(e.ChatAgentRequest=en={}));var sn;(function(be){function Pe(fe){switch(fe){case h.ChatAgentLocation.Notebook:return n.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return n.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return n.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return n.ChatLocation.Editor}}be.to=Pe})(sn||(e.ChatLocation=sn={}));var kt;(function(be){function Pe(fe){return{name:fe.name,range:fe.range&&[fe.range.start,fe.range.endExclusive],values:fe.values.map(Nt.to)}}be.to=Pe})(kt||(e.ChatAgentResolvedVariable=kt={}));var hn;(function(be){function Pe(fe,W,ke){return{label:fe.label,values:fe.values.map(Nt.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation,command:W.toInternal(fe.command,ke)}}be.from=Pe})(hn||(e.ChatAgentCompletionItem=hn={}));var on;(function(be){function Pe(fe){return{errorDetails:fe.errorDetails,metadata:fe.metadata}}be.to=Pe})(on||(e.ChatAgentResult=on={}));var an;(function(be){function Pe(fe,W,ke){if(W.action.kind==="vote")return;const Oe=on.to(fe);if(W.action.kind==="command"){const qe=W.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(qe)??{command:qe.id,title:qe.title}}},result:Oe}}else return W.action.kind==="followUp"?{action:{kind:"followUp",followup:Vt.to(W.action.followup)},result:Oe}:W.action.kind==="inlineChat"?{action:{kind:"editor",accepted:W.action.action==="accepted"},result:Oe}:{action:W.action,result:Oe}}be.to=Pe})(an||(e.ChatAgentUserActionEvent=an={}));var Jt;(function(be){function Pe(fe,W,ke){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:W.toInternal(fe,ke)}be.from=Pe})(Jt||(e.TerminalQuickFix=Jt={}));var tn;(function(be){function Pe(fe){return{kind:xt.to(fe.kind)}}be.to=Pe})(tn||(e.PartialAcceptInfo=tn={}));var xt;(function(be){function Pe(fe){switch(fe){case 0:return n.PartialAcceptTriggerKind.Word;case 1:return n.PartialAcceptTriggerKind.Line;case 2:return n.PartialAcceptTriggerKind.Suggest;default:return n.PartialAcceptTriggerKind.Unknown}}be.to=Pe})(xt||(e.PartialAcceptTriggerKind=xt={}));var fn;(function(be){function Pe(fe,W){return{id:W,label:fe.label,description:fe.description,canEdit:fe.canEdit,collapsibleState:fe.collapsibleState||0,contextValue:fe.contextValue}}be.from=Pe})(fn||(e.DebugTreeItem=fn={}))}),define(ye[299],Ee([1,0,46,136,72,135,96,142,4]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.$LP=e.$KP=e.$JP=void 0;const g=($,E,h,t)=>{let o=E;return{enumerable:!0,configurable:!1,get(){return o},set(r){if(!h(o,r)){const i=o;o=r,$.listener?.(t(r,i))}}}},y=($,E)=>$===E,v={range:($,E)=>$===E?!0:!$||!E?!1:$.isEqual(E),label:y,description:y,sortText:y,busy:y,error:y,canResolveChildren:y,tags:($,E)=>!($.length!==E.length||$.some(h=>!E.find(t=>h.id===t.id)))},b=$=>E=>({op:4,update:$(E)}),m=($,E)=>({range:(()=>{let h;const t=b(o=>({range:s.$vt.lift(S.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return h},set(o){$.listener?.({op:6}),v.range(h,o)||(h=o,$.listener?.(t(o)))}}})(),label:g($,E,v.label,b(h=>({label:h}))),description:g($,void 0,v.description,b(h=>({description:h}))),sortText:g($,void 0,v.sortText,b(h=>({sortText:h}))),canResolveChildren:g($,!1,v.canResolveChildren,h=>({op:2,state:h})),busy:g($,!1,v.busy,b(h=>({busy:h}))),error:g($,void 0,v.error,b(h=>({error:S.MarkdownString.fromStrict(h)||null}))),tags:g($,[],v.tags,(h,t)=>({op:1,new:h.map(S.TestTag.from),old:t.map(S.TestTag.from)}))}),u=$=>{const E=D.$VL.fromString($.extId),h=new f(E.controllerId,E.localId,$.label,w.URI.revive($.uri)||void 0);return h.range=S.Range.to($.range||void 0),h.description=$.description||void 0,h.sortText=$.sortText||void 0,h.tags=$.tags.map(t=>S.TestTag.to({id:(0,I.$2L)(t).tagId})),h},a=$=>{let E;for(const h of $.tests){const t=u(h.item);(0,C.$tP)(t).parent=E,E=t}return E};e.$JP=a;class f{constructor(E,h,t,o){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,C.$sP)(this,E);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof c?void 0:r.parent}},children:{value:(0,k.$rP)(r,C.$tP,f),enumerable:!0,writable:!1},...m(r,t)})}}e.$KP=f;class c extends f{constructor(E,h){super(E,E,h,void 0),this._isRoot=!0}}e.$LP=c;class d extends k.$nP{constructor(E,h,t){super({controllerId:E,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:C.$tP,getChildren:o=>o.children,root:new c(E,h),toITestItem:S.TestItem.from})}}e.$MP=d});var Lt=this&&this.__classPrivateFieldSet||function(ue,e,s,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ue!==e||!D:!e.has(ue))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(ue,s):D?D.value=s:e.set(ue,s),s},tt=this&&this.__classPrivateFieldGet||function(ue,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ue!==e||!C:!e.has(ue))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ue):C?C.value:e.get(ue)};define(ye[300],Ee([1,0,10,141,142,21,297,18,12,54,46,80,4,2,5,281,299,15,139,39,63,37,294,22]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o){"use strict";var r,i,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=void 0;let l=class{constructor(A,B,G){r.set(this,void 0),this.b=new Map,this.c=new Map,i.set(this,void 0),n.set(this,void 0),Lt(this,r,A.getProxy(I.$0M.MainThreadCommands),"f"),this.d=B,Lt(this,n,G,"f"),Lt(this,i,A.getProxy(I.$0M.MainThreadTelemetry),"f"),this.converter=new p(this,se=>{const ce=this.c.get(se);return ce?.result===j.Void?ce:void 0},B),this.f=[{processArgument(se){return(0,g.$6h)(se)}},{processArgument(se){return(0,k.$6n)(se,function(ce){if(y.$vt.isIRange(ce))return D.Range.to(ce);if(v.$ut.isIPosition(ce))return D.Position.to(ce);if(y.$vt.isIRange(ce.range)&&b.URI.isUri(ce.uri))return D.location.to(ce);if(ce instanceof c.$Ge)return ce.buffer.buffer;if(!Array.isArray(ce))return ce})}}]}registerArgumentProcessor(A){this.f.push(A)}registerApiCommand(A){const B=this.registerCommand(!1,A.id,async(...G)=>{const se=A.args.map((ee,K)=>{if(!ee.validate(G[K]))throw new Error(`Invalid argument '${ee.name}' when running '${A.id}', received: ${typeof G[K]=="object"?JSON.stringify(G[K],null,"	"):G[K]} `);return ee.convert(G[K])}),ce=await this.executeCommand(A.internalId,...se);return A.result.convert(ce,G,this.converter)},void 0,{description:A.description,args:A.args,returns:A.result.description});return this.c.set(A.id,A),new C.$_M(()=>{B.dispose(),this.c.delete(A.id)})}registerCommand(A,B,G,se,ce,ee){if(this.d.trace("ExtHostCommands#registerCommand",B),!B.trim().length)throw new Error("invalid id");if(this.b.has(B))throw new Error(`command '${B}' already exists`);return this.b.set(B,{callback:G,thisArg:se,metadata:ce,extension:ee}),A&&tt(this,r,"f").$registerCommand(B),new C.$_M(()=>{this.b.delete(B)&&A&&tt(this,r,"f").$unregisterCommand(B)})}executeCommand(A,...B){return this.d.trace("ExtHostCommands#executeCommand",A),this.g(A,B,!0)}async g(A,B,G){if(this.b.has(A))return tt(this,r,"f").$fireCommandActivationEvent(A),this.h(A,B,!1);{let se=!1;const ce=(0,k.$6n)(B,function(ee){if(ee instanceof C.$aN)return D.Position.from(ee);if(ee instanceof C.$bN)return D.Range.from(ee);if(ee instanceof C.$lN)return D.location.from(ee);if(C.$BO.isNotebookRange(ee))return D.NotebookRange.from(ee);if(ee instanceof ArrayBuffer)return se=!0,c.$Ge.wrap(new Uint8Array(ee));if(ee instanceof Uint8Array)return se=!0,c.$Ge.wrap(ee);if(ee instanceof c.$Ge)return se=!0,ee;if(!Array.isArray(ee))return ee});try{const ee=await tt(this,r,"f").$executeCommand(A,se?new d.$Cw(ce):ce,G);return(0,g.$6h)(ee)}catch(ee){if(ee instanceof Error&&ee.message==="$executeCommand:retry")return this.g(A,B,!1);throw ee}}}async h(A,B,G){const se=this.b.get(A);if(!se)throw new Error("Unknown command");const{callback:ce,thisArg:ee,metadata:K}=se;if(K?.args)for(let X=0;X<K.args.length;X++)try{(0,s.$ng)(B[X],K.args[X].constraint)}catch{throw new Error(`Running the contributed command: '${A}' failed. Illegal argument '${K.args[X].name}' - ${K.args[X].description}`)}const q=E.$ae.create();try{return await ce.apply(ee,B)}catch(X){if(A===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...B);_&&(A=_.command)}if(this.d.error(X,A,se.extension?.identifier),!G)throw X;if(se.extension?.identifier){const _=tt(this,n,"f").onExtensionError(se.extension.identifier,X);this.d.trace("forwarded error to extension?",_,se.extension?.identifier)}throw new class extends Error{constructor(){super((0,$.$hj)(X)),this.id=A,this.source=se.extension?.displayName??se.extension?.name}}}finally{this.j(se,A,q.elapsed())}}j(A,B,G){A.extension&&tt(this,i,"f").$publicLog2("Extension:ActionExecuted",{extensionId:A.extension.identifier.value,id:new h.$gp(B),duration:G})}$executeContributedCommand(A,...B){this.d.trace("ExtHostCommands#$executeContributedCommand",A);const G=this.b.get(A);return G?(B=B.map(se=>this.f.reduce((ce,ee)=>ee.processArgument(ce,G.extension?.identifier),se)),this.h(A,B,!0)):Promise.reject(new Error(`Contributed command '${A}' does not exist.`))}getCommands(A=!1){return this.d.trace("ExtHostCommands#getCommands",A),tt(this,r,"f").$getCommands().then(B=>(A&&(B=B.filter(G=>G[0]!=="_")),B))}$getContributedCommandMetadata(){const A=Object.create(null);for(const[B,G]of this.b){const{metadata:se}=G;se&&(A[B]=se)}return Promise.resolve(A)}};e.$SP=l,r=new WeakMap,i=new WeakMap,n=new WeakMap,e.$SP=l=Fe([Ne(0,a.$xP),Ne(1,w.$3j),Ne(2,t.$RP)],l),e.$TP=(0,u.$wi)("IExtHostCommands");class p{constructor(A,B,G){this.d=A,this.f=B,this.g=G,this.delegatingCommandId=`__vsc${(0,o.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(A,B){if(!A)return;const G={$ident:void 0,id:A.command,title:A.title,tooltip:A.tooltip};if(!A.command)return G;const se=this.f(A.command);if(se)G.id=se.internalId,G.arguments=se.args.map((ce,ee)=>ce.convert(A.arguments&&A.arguments[ee]));else if((0,S.$Lb)(A.arguments)){const ce=`${A.command} /${++this.c}`;this.b.set(ce,A),B.add((0,m.$Tc)(()=>{this.b.delete(ce),this.g.trace("CommandsConverter#DISPOSE",ce)})),G.$ident=ce,G.id=this.delegatingCommandId,G.arguments=[ce],this.g.trace("CommandsConverter#CREATE",A.command,ce)}return G}fromInternal(A){return typeof A.$ident=="string"?this.b.get(A.$ident):{command:A.id,title:A.title,arguments:A.arguments}}getActualCommand(...A){return this.b.get(A[0])}h(...A){const B=this.getActualCommand(...A);return this.g.trace("CommandsConverter#EXECUTE",A[0],B?B.command:"MISSING"),B?this.d.executeCommand(B.command,...B.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${A[0]}`)}}e.$UP=p;class P{static Arr(A){return new P(`${A.name}_array`,`Array of ${A.name}, ${A.description}`,B=>Array.isArray(B)&&B.every(G=>A.validate(G)),B=>B.map(G=>A.convert(G)))}constructor(A,B,G,se){this.name=A,this.description=B,this.validate=G,this.convert=se}optional(){return new P(this.name,`(optional) ${this.description}`,A=>A==null||this.validate(A),A=>A===void 0?void 0:A===null?null:this.convert(A))}with(A,B){return new P(A??this.name,B??this.description,this.validate,this.convert)}}e.$VP=P,P.Uri=new P("uri","Uri of a text document",R=>b.URI.isUri(R),R=>R),P.Position=new P("position","A position in a text document",R=>C.$aN.isPosition(R),D.Position.from),P.Range=new P("range","A range in a text document",R=>C.$bN.isRange(R),D.Range.from),P.Selection=new P("selection","A selection in a text document",R=>C.$cN.isSelection(R),D.Selection.from),P.Number=new P("number","",R=>typeof R=="number",R=>R),P.String=new P("string","",R=>typeof R=="string",R=>R),P.StringArray=P.Arr(P.String),P.CallHierarchyItem=new P("item","A call hierarchy item",R=>R instanceof C.$xN,D.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",R=>R instanceof C.$VO,D.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",R=>R instanceof f.$KP,D.TestItem.from);class j{constructor(A,B){this.description=A,this.convert=B}}e.$WP=j,j.Void=new j("no result",R=>R);class O{constructor(A,B,G,se,ce){this.id=A,this.internalId=B,this.description=G,this.args=se,this.result=ce}}e.$XP=O}),define(ye[301],Ee([1,0,11,2,13,232]),function(ue,e,s,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=e.$FQ=void 0,e.$FQ="remoteFilesystem";class I extends k.$EQ{static register(w,g,y){const v=w.getConnection();if(!v)return C.$Vc.None;const b=new C.$Uc,m=(async()=>{try{const u=await w.getRawEnvironment();u?g.registerProvider(D.Schemas.vscodeRemote,b.add(new I(u,v))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(u){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,s.$0)(u))}})();return b.add(g.onWillActivateFileSystemProvider(u=>{u.scheme===D.Schemas.vscodeRemote&&u.join(m)})),b}constructor(w,g){super(g.getChannel(e.$FQ),{pathCaseSensitive:w.os===3})}}e.$GQ=I}),define(ye[73],Ee([1,0,90,79,28,302,15,11,6,2,7,3,22,45,108]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=i,e.$ri=p,e.$si=P;class a{traceSocketEvent(O,R){u.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,O,R)}constructor(O,R=""){this.f=!0,this.debugLabel=R,this.socket=O,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,S.$1)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(O){const R=A=>{this.traceSocketEvent("read",A),O(I.$Ge.wrap(A))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(O){const R=A=>{O({type:0,hadError:A,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(O){const R=()=>{O()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(O){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",O),this.socket.write(O.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,S.$1)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,S.$1)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((O,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),O();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),O()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$li=a;var f;(function(j){j[j.MinHeaderByteSize=2]="MinHeaderByteSize",j[j.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var c;(function(j){j[j.PeekHeader=1]="PeekHeader",j[j.ReadHeader=2]="ReadHeader",j[j.ReadBody=3]="ReadBody",j[j.Fin=4]="Fin"})(c||(c={}));class d extends g.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(O,R){this.socket.traceSocketEvent(O,R)}constructor(O,R,A,B){super(),this.f=this.B(new w.$ee),this.g=this.B(new w.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=O,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:A?.byteLength||0,recordInflateBytes:B}),this.a=this.B(new $(this,R,A,B,this.f,(G,se)=>this.m(G,se))),this.B(this.a.onError(G=>{console.error(G),(0,S.$1)(G),this.g.fire({type:0,hadError:!0,error:G})})),this.b=new u.$gi,this.B(this.socket.onData(G=>this.n(G))),this.B(this.socket.onClose(async G=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(G)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(O){return this.f.event(O)}onClose(O){return this.g.event(O)}onEnd(O){return this.socket.onEnd(O)}write(O){let R=0;for(;R<O.byteLength;)this.a.writeMessage(O.slice(R,Math.min(R+262144,O.byteLength)),{compressed:!0,opcode:2}),R+=262144}m(O,{compressed:R,opcode:A}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",O);let B=2;O.byteLength<126?B+=0:O.byteLength<2**16?B+=2:B+=8;const G=I.$Ge.alloc(B),se=R?64:0,ce=A&15;if(G.writeUInt8(128|se|ce,0),O.byteLength<126)G.writeUInt8(O.byteLength,1);else if(O.byteLength<2**16){G.writeUInt8(126,1);let ee=1;G.writeUInt8(O.byteLength>>>8&255,++ee),G.writeUInt8(O.byteLength>>>0&255,++ee)}else{G.writeUInt8(127,1);let ee=1;G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(O.byteLength>>>24&255,++ee),G.writeUInt8(O.byteLength>>>16&255,++ee),G.writeUInt8(O.byteLength>>>8&255,++ee),G.writeUInt8(O.byteLength>>>0&255,++ee)}this.socket.write(I.$Ge.concat([G,O]))}end(){this.h=!0,this.socket.end()}n(O){if(O.byteLength!==0){for(this.b.acceptChunk(O);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),A=R.readUInt8(0),B=(A&128)>>>7,G=(A&64)>>>6,se=A&15,ce=R.readUInt8(1),ee=(ce&128)>>>7,K=ce&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=B,this.j.firstFrameOfMessage&&(this.j.compressed=!!G),this.j.firstFrameOfMessage=!!B,this.j.mask=0,this.j.opcode=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),A=R.readUInt8(1),B=(A&128)>>>7;let G=A&127,se=1;G===126?G=R.readUInt8(++se)*2**8+R.readUInt8(++se):G===127&&(G=R.readUInt8(++se)*0+R.readUInt8(++se)*0+R.readUInt8(++se)*0+R.readUInt8(++se)*0+R.readUInt8(++se)*2**24+R.readUInt8(++se)*2**16+R.readUInt8(++se)*2**8+R.readUInt8(++se));let ce=0;B&&(ce=R.readUInt8(++se)*2**24+R.readUInt8(++se)*2**16+R.readUInt8(++se)*2**8+R.readUInt8(++se)),this.j.state=3,this.j.readLen=G,this.j.mask=ce,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),t(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=d;class $ extends g.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$Ge.alloc(0)}constructor(O,R,A,B,G,se){super(),this.n=O,this.r=G,this.s=se,this.a=this.B(new w.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new w.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new E(this.n,B,A,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(ce=>this.a.fire(ce))),this.B(this.f.onError(ce=>this.a.fire(ce)))):(this.b=null,this.f=null)}writeMessage(O,R){this.g.push({data:O,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:O,options:R}=this.g.shift();if(this.f&&R.compressed){const A=await this.w(this.f,O);this.s(A,R)}else this.s(O,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(O,R){return new Promise((A,B)=>{O.write(R),O.flush(G=>A(G))})}acceptFrame(O,R,A){this.h.push({data:O,isCompressed:R,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const O=this.h.shift();if(this.b&&O.isCompressed){const R=await this.C(this.b,O.data,O.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(O.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(O,R,A){return new Promise((B,G)=>{O.write(R),A&&O.write(I.$Ge.fromByteArray([0,0,255,255])),O.flush(se=>B(se))})}}class E extends g.$Vc{get recordedInflateBytes(){return this.j?I.$Ge.concat(this.f):I.$Ge.alloc(0)}constructor(O,R,A,B){super(),this.h=O,this.j=R,this.a=this.B(new w.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(B),this.b.on("error",G=>{this.h.traceSocketEvent("zlibInflateError",{message:G?.message,code:G?.code}),this.a.fire(G)}),this.b.on("data",G=>{this.h.traceSocketEvent("zlibInflateData",G),this.g.push(I.$Ge.wrap(G))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(O){this.j&&this.f.push(O.clone()),this.h.traceSocketEvent("zlibInflateWrite",O),this.b.write(O.buffer)}flush(O){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=I.$Ge.concat(this.g);this.g.length=0,O(R)})}}class h extends g.$Vc{constructor(O,R){super(),this.g=O,this.a=this.B(new w.$ee),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(I.$Ge.wrap(A))})}write(O){this.g.traceSocketEvent("zlibDeflateWrite",O.buffer),this.b.write(O.buffer)}flush(O){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=I.$Ge.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),O(R)})}}function t(j,O){if(O===0)return;const R=j.byteLength>>>2;for(let ee=0;ee<R;ee++){const K=j.readUInt32BE(ee*4);j.writeUInt32BE(K^O,ee*4)}const A=R*4,B=j.byteLength-A,G=O>>>24&255,se=O>>>16&255,ce=O>>>8&255;B>=1&&j.writeUInt8(j.readUInt8(A)^G,A),B>=2&&j.writeUInt8(j.readUInt8(A+1)^se,A+1),B>=3&&j.writeUInt8(j.readUInt8(A+2)^ce,A+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const j=(0,b.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${j}-sock`;const O=process.platform!=="darwin"&&e.$ni?e.$ni:(0,D.tmpdir)(),R=(0,y.$kc)(O,`vscode-ipc-${j}.sock`);return n(R),R}function i(j,O,R){const B=(0,s.createHash)("sha256").update(j).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${R}-${O}-sock`;const G=R.substr(0,4),se=O.substr(0,6);let ce;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?ce=(0,y.$kc)(e.$ni,`vscode-${B}-${G}-${se}.sock`):ce=(0,y.$kc)(j,`${G}-${se}.sock`),n(ce),ce}function n(j){const O=o[v.$o];typeof O=="number"&&j.length>=O&&console.warn(`WARNING: IPC handle "${j}" is longer than ${O} chars, try a shorter --user-data-dir`)}class l extends m.$ai{static b(O){const R=w.Event.fromNodeEventEmitter(O,"connection");return w.Event.map(R,A=>({protocol:new u.$hi(new a(A,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(A,"close"))}))}constructor(O){super(l.b(O)),this.d=O}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=l;function p(j){return new Promise((O,R)=>{const A=(0,C.createServer)();A.on("error",R),A.listen(j,()=>{A.removeListener("error",R),O(new l(A))})})}function P(j,O){return new Promise((R,A)=>{const B=(0,C.createConnection)(j,()=>{B.removeListener("error",A),R(u.$ii.fromSocket(new a(B,`ipc-client${O}`),O))});B.once("error",A)})}}),define(ye[143],Ee([1,0,87,14,15,11,10,25,26,88,12,42,249,302]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0,e.$Zr=f;let u=class extends v.$Pp{constructor(d,$,E,h){super(h),this.m=d,this.n=$,this.r=E,this.s(),this.B(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,$){const{f:E,g:h}=this;let t;try{t=await(0,g.$Hm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$0)(i)))}const o={...process.env,...t},r=d.agent?d.agent:await(0,b.$Xr)(d.url||"",o,{proxyUrl:E,strictSSL:h});return d.agent=r,d.strictSSL=h,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>f(d,$))}async resolveProxy(d){}async loadCertificates(){return(await new Promise(($,E)=>{ue(["@vscode/proxy-agent"],$,E)})).loadSystemCertificates({log:this.r})}};e.$Yr=u,e.$Yr=u=Fe([Ne(0,S.$3i),Ne(1,w.$Ei),Ne(2,y.$3j),Ne(3,y.$4j)],u);async function a(c){return((0,s.parse)(c.url).protocol==="https:"?await new Promise((E,h)=>{ue(["https"],E,h)}):await new Promise((E,h)=>{ue(["http"],E,h)})).request}async function f(c,d){return C.Promises.withAsyncBody(async($,E)=>{const h=(0,s.parse)(c.url),t=c.getRawRequest?c.getRawRequest(c):await a(c),o={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,I.$cg)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(o.auth=c.user+":"+c.password);const r=t(o,i=>{const n=(0,I.$ag)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)f({...c,url:i.headers.location,followRedirects:n-1},d).then($,E);else{let l=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,m.createGunzip)())),$({res:i,stream:(0,D.$Ve)(l)})}});r.on("error",E),c.timeout&&r.setTimeout(c.timeout),c.isChromiumNetwork&&r.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&r.write(c.data),r.end(),d.onCancellationRequested(()=>{r.abort(),E(new k.$5)})})}}),define(ye[144],Ee([1,0,56,79,94,13,7,15,6,73,88,12,51,3,62,133,2,292,25]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$qn=$;async function $(i={},n,l,p,P,j){const O=await(0,D.$am)(l,p.userDataPath);let R={};if(n)try{R=await(0,y.$Hm)(j,P,p.args,process.env)}catch(ee){P.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ee)}const B={...process.env,...R,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(O,void 0,0),...i},G=p.isBuilt?(0,I.$kc)(p.appRoot,"bin"):(0,I.$kc)(p.appRoot,"resources","server","bin-dev"),se=(0,I.$kc)(G,"remote-cli");let ce=t(B,"PATH");return ce?ce=se+I.$uc+ce:ce=se,o(B,"PATH",ce),p.args["without-browser-env-var"]||(B.BROWSER=(0,I.$kc)(G,"helpers",m.$c?"browser.cmd":"browser.sh")),r(B),B}class E{constructor(n,l){this.socket=n,this.initialDataChunk=l}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let n,l,p;return this.socket instanceof g.$li?(n=!0,l=!1,p=S.$Ge.alloc(0)):(n=!1,l=this.socket.permessageDeflate,p=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:n,permessageDeflate:l,inflateBytes:p.buffer.toString("base64")}}}let h=class{constructor(n,l,p,P,j,O,R,A){this.i=n,this.j=j,this.l=O,this.m=R,this.n=A,this.b=new w.$ee,this.onClose=this.b.event,this.c=!m.$c||!this.j.args["socket-path"],this.d=!1,this.f=l,this.g=null,this.h=new E(p,P),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(n){this.l.info(`${this.o}${n}`)}q(n){this.l.error(`${this.o}${n}`)}async r(n,l){const p=new f.$Uc;p.add(l.socket),p.add((0,f.$Tc)(()=>{n.destroy()}));const P=()=>{p.dispose()};p.add(l.socket.onEnd(P)),p.add(l.socket.onClose(P)),p.add(w.Event.fromNodeEventEmitter(n,"end")(P)),p.add(w.Event.fromNodeEventEmitter(n,"close")(P)),p.add(w.Event.fromNodeEventEmitter(n,"error")(P)),p.add(l.socket.onData(j=>n.write(j.buffer))),p.add(w.Event.fromNodeEventEmitter(n,"data")(j=>{l.socket.write(S.$Ge.wrap(j))})),l.initialDataChunk.byteLength>0&&n.write(l.initialDataChunk.buffer)}async s(n,l){await l.socketDrain();const p=l.toIExtHostSocketMessage();let P;l.socket instanceof g.$li?P=l.socket.socket:P=l.socket.socket.socket,n.send(p,P)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const n={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(n)}acceptReconnection(n,l,p){this.f=n,this.p("The client has reconnected.");const P=new E(l,p);if(!this.g){this.h=P;return}this.s(this.g,P)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(n){try{let l=process.execArgv?process.execArgv.filter(se=>!/^--inspect(-brk)?=/.test(se)):[];n.port&&!process.pkg&&(l=[`--inspect${n.break?"-brk":""}=${n.port}`]);const p=await $(n.env,!0,n.language,this.j,this.l,this.n);(0,u.$om)(p);let P;if(this.c)(0,c.$on)(new c.$mn,p),P=null;else{const{namedPipeServer:se,pipeName:ce}=await this.u();(0,c.$on)(new c.$ln(ce),p),P=se}const j={env:p,execArgv:l,silent:!0};j.execArgv.unshift("--dns-result-order=ipv4first");const O=["--type=extensionHost","--transformURIs"],R=this.j.args["use-host-proxy"];O.push(`--useHostProxy=${R?"true":"false"}`),this.g=s.fork(k.$Qg.asFileUri("bootstrap-fork").fsPath,O,j);const A=this.g.pid;this.p(`<${A}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const B=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),G=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(B(se=>this.p(`<${A}> ${se}`)),G(se=>this.p(`<${A}><stderr> ${se}`)),this.g.on("error",se=>{this.q(`<${A}> Extension Host Process had an error`),this.l.error(se),this.t()}),this.g.on("exit",(se,ce)=>{this.m.setExitInfo(this.i,{code:se,signal:ce}),this.p(`<${A}> Extension Host Process exited with code: ${se}, signal: ${ce}.`),this.t()}),P)P.on("connection",se=>{P.close(),this.r(se,this.h)});else{const se=ce=>{ce.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",se),this.s(this.g,this.h),this.h=null)};this.g.on("message",se)}}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}u(){return new Promise((n,l)=>{const p=(0,g.$oi)(),P=C.createServer();P.on("error",l),P.listen(p,()=>{P?.removeListener("error",l),n({pipeName:p,namedPipeServer:P})})})}};e.$rn=h,e.$rn=h=Fe([Ne(4,b.$bn),Ne(5,v.$3j),Ne(6,a.$jn),Ne(7,d.$3i)],h);function t(i,n){const l=Object.keys(i).filter(P=>P.toLowerCase()===n.toLowerCase()),p=l.length>0?l[0]:n;return i[p]}function o(i,n,l){const p=Object.keys(i).filter(j=>j.toLowerCase()===n.toLowerCase()),P=p.length>0?p[0]:n;i[P]=l}function r(i){for(const n of Object.keys(i))i[n]===null&&delete i[n]}}),define(ye[303],Ee([1,0,84,12,68,119,25,42,143,37,30,32,131,128,89,113,58,2,114,69,13,16,29,51,122,85,123,11,4,7,31,247,83,34,127,67,3,59,134,33,50,70,132,129,116,117,212,304]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o,r,i,n,l,p,P,j,O,R,A,B,G,se,ce,ee,K,q,X,_,M,Q,ae,ne,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=V;class ie extends c.$Vc{constructor(z,Z){super(),this.a=z,this.b=Z,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const z=await this.f();await z.invokeFunction(async Z=>{const he=Z.get(I.$3i),x=Z.get(C.$3j);se.$c&&(he.getValue("security.restrictUNCAccess")===!1?(0,we.disableUNCAccessRestrictions)():(0,we.addUNCHostToAllowlist)(he.getValue("security.allowedUNCHosts")));try{await this.g(z.createInstance(r.$dq,new C.$$j(x.getLevel(),!1)))}catch(J){throw x.error(J),console.error((0,l.$0)(J)),J}})}async f(){const z=new s.$ui,Z={_serviceBrand:void 0,...f.default};z.set(t.$jk,Z);const he=new o.$cn(this.a,Z);z.set(o.$bn,he);const x=new ae.$MQ((0,C.$ek)(he),he.logsHome);z.set(C.$4j,x);const J=new Q.$WQ(this.B(x.createLogger("remoteCLI",{name:(0,ne.localize)(0,null)})));z.set(C.$3j,J),J.trace(`Remote configuration data at ${this.b}`),J.trace("process arguments:",this.a);const H=this.B(new d.$Jq(J));z.set(h.$3k,H),H.registerProvider(E.Schemas.file,this.B(new $.$ar(J)));const L=new B.$Bs(H);z.set(A.$Al,L);const U=this.B(new _.$UQ(L,he,H,J));z.set(K.$Cl,U);const oe=this.B(new k.$Ho(U.defaultProfile.settingsResource,H,new X.$ho,J));return z.set(I.$3i,oe),await Promise.all([oe.initialize(),U.init()]),z.set(S.$Op,new D.$ti(w.$Yr)),z.set(R.$Lo,new D.$ti(O.$dR)),z.set(y.$2l,g.$ip),z.set(v.$7o,new D.$ti(b.$_p)),z.set(q.$qq,new D.$ti(M.$VQ)),z.set(ce.$uq,new D.$ti(ee.$HQ)),z.set(u.$aq,new D.$ti(u.$cq)),z.set(m.$Eq,new D.$ti(m.$Fq)),z.set(i.$Sr,new D.$ti(n.$Ur)),new a.$dr(z)}async g(z){if(this.a["list-extensions"])return z.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const Z={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return z.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),Z,!!this.a.force)}else{if(this.a["uninstall-extension"])return z.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return z.updateExtensions();if(this.a["locate-extension"])return z.locateExtension(this.a["locate-extension"])}}h(z){return z.map(Z=>/\.vsix$/i.test(Z)?p.URI.file((0,P.$jc)(Z)?Z:(0,P.$kc)((0,j.cwd)(),Z)):Z)}}function Y(N){setTimeout(()=>process.exit(N),0)}async function V(N,z,Z){if(N.help){const x=f.default.serverApplicationName+(se.$c?".cmd":"");console.log((0,G.$wm)(f.default.nameLong,x,f.default.version,Z,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,G.$xm)(f.default.version,f.default.commit));return}const he=new ie(N,z);try{await he.run(),Y(0)}catch{Y(1)}finally{he.dispose()}}}),define(ye[305],Ee([1,0,73,278,27,300,4,12,93]),function(ue,e,s,C,D,k,I,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=void 0;class g{constructor(b,m,u){this.b=b,this.c=m,this.f=u,this.a=C.createServer((a,f)=>this.h(a,f)),this.g().catch(a=>(m.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,m){const u=(f,c)=>{m.writeHead(f,{"content-type":"application/json"}),m.end(JSON.stringify(c||null),d=>d&&this.c.error(d))},a=[];b.setEncoding("utf8"),b.on("data",f=>a.push(f)),b.on("end",async()=>{try{const f=JSON.parse(a.join(""));let c;switch(f.type){case"open":c=await this.i(f);break;case"openExternal":c=await this.j(f);break;case"status":c=await this.l(f);break;case"extensionManagement":c=await this.k(f);break;default:u(404,`Unknown message type: ${f.type}`);break}u(200,c)}catch(f){const c=f instanceof Error?f.message:JSON.stringify(f);u(500,c),this.c.error("Error while processing pipe request",f)}})}async i(b){const{fileURIs:m,folderURIs:u,forceNewWindow:a,diffMode:f,mergeMode:c,addMode:d,forceReuseWindow:$,gotoLineMode:E,waitMarkerFilePath:h,remoteAuthority:t}=b,o=[];if(Array.isArray(u))for(const l of u)try{o.push({folderUri:I.URI.parse(l)})}catch{}if(Array.isArray(m))for(const l of m)try{(0,w.$2i)(l)?o.push({workspaceUri:I.URI.parse(l)}):o.push({fileUri:I.URI.parse(l)})}catch{}const r=h?I.URI.file(h):void 0,n={forceNewWindow:a,diffMode:f,mergeMode:c,addMode:d,gotoLineMode:E,forceReuseWindow:$,preferNewWindow:!$&&!r&&!d,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,n)}async j(b){for(const m of b.uris){const u=I.URI.parse(m),a=u.scheme==="file"?u:m;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(b){const m=a=>a?.map(f=>/\.vsix$/i.test(f)?I.URI.parse(f):f),u={list:b.list,install:m(b.install),uninstall:m(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",u)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&D.existsSync(this.f)&&D.unlinkSync(this.f)}}e.$YP=g;let y=class extends g{constructor(b,m){super(b,m,(0,s.$oi)())}};e.$ZP=y,e.$ZP=y=Fe([Ne(0,k.$TP),Ne(1,S.$3j)],y)}),define(ye[306],Ee([1,0,28,6,21,2,7,3,4,73,71,305,125,91,287,289,144,14,126]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class $ extends a.$zQ{constructor(t,o,r,i,n){super({getFolderUri:l=>{const p=o.filter(P=>P.name===l);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(l,p)=>i[`config:${p}`],getExecPath:()=>t.VSCODE_EXEC_PATH,getAppRoot:()=>t.VSCODE_CWD,getFilePath:()=>{if(r)return I.$ic(r.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async l=>{const P=(await n.getInstalled()).find(j=>j.identifier.id===l);return P&&{extensionLocation:P.location}}},void 0,Promise.resolve(s.homedir()),Promise.resolve(t))}}class E extends k.$Vc{constructor(t,o,r,i,n,l){super(),this.g=t,this.h=o,this.j=r,this.m=i,this.n=n,this.r=l,this.a=0,this.b=new Map,this.c=this.B(new C.$ee),this.onExecuteCommand=this.c.event}async call(t,o,r){switch(o){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,r);case"$createProcess":{const i=(0,y.$Cs)(t.remoteAuthority);return this.s(i,r)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,r);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,r);case"$listProcesses":return this.j.listProcesses.apply(this.j,r);case"$getLatency":return this.j.getLatency.apply(this.j,r);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,r);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,r);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,r);case"$start":return this.j.start.apply(this.j,r);case"$input":return this.j.input.apply(this.j,r);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,r);case"$shutdown":return this.j.shutdown.apply(this.j,r);case"$resize":return this.j.resize.apply(this.j,r);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,r);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,r);case"$getCwd":return this.j.getCwd.apply(this.j,r);case"$processBinary":return this.j.processBinary.apply(this.j,r);case"$sendCommandResult":return this.u(r[0],r[1],r[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,r);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,r);case"$getDefaultSystemShell":return this.w.apply(this,r);case"$getProfiles":return this.y.apply(this,r);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(r[0],r[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,r);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,r);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,r);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,r);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,r);case"$updateTitle":return this.j.updateTitle.apply(this.j,r);case"$updateProperty":return this.j.updateProperty.apply(this.j,r);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,r);case"$requestDetachInstance":return this.j.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(r[0],r[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,r);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,r)}throw new Error(`IPC Command ${o} not found`)}listen(t,o,r){switch(o){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||C.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||C.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||C.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||C.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||C.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||C.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${o} not found`)}async s(t,o){const r={name:o.shellLaunchConfig.name,executable:o.shellLaunchConfig.executable,args:o.shellLaunchConfig.args,cwd:typeof o.shellLaunchConfig.cwd=="string"||typeof o.shellLaunchConfig.cwd>"u"?o.shellLaunchConfig.cwd:w.URI.revive(t.transformIncoming(o.shellLaunchConfig.cwd)),env:o.shellLaunchConfig.env,useShellEnvironment:o.shellLaunchConfig.useShellEnvironment,reconnectionProperties:o.shellLaunchConfig.reconnectionProperties,type:o.shellLaunchConfig.type,isFeatureTerminal:o.shellLaunchConfig.isFeatureTerminal},i=await(0,f.$qn)(o.resolverEnv,!!o.shellLaunchConfig.useShellEnvironment,S.$q,this.g,this.h,this.r);this.h.trace("baseEnv",i);const n=q=>({uri:w.URI.revive(t.transformIncoming(q.uri)),name:q.name,index:q.index,toResource:()=>{throw new Error("Not implemented")}}),l=o.workspaceFolders.map(n),p=o.activeWorkspaceFolder?n(o.activeWorkspaceFolder):void 0,P=o.activeFileResource?w.URI.revive(t.transformIncoming(o.activeFileResource)):void 0,j=new $(i,l,P,o.resolvedVariables,this.n),O=u.$vQ(p,process.env,j),R=await u.$uQ(r,s.homedir(),O,p?.uri,o.configuration["terminal.integrated.cwd"],this.h);r.cwd=R;const A=S.$c?"terminal.integrated.env.windows":S.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",B=o.configuration[A],G=await u.$wQ(r,B,O,this.m.version,o.configuration["terminal.integrated.detectLocale"],i);if((0,d.$oQ)(r)){const q=[];for(const[Q,ae,ne]of o.envVariableCollections)q.push([Q,{map:(0,m.$os)(ae),descriptionMap:(0,m.$ps)(ne)}]);const X=new Map(q),_=new b.$ss(X),M=p?p??void 0:void 0;await _.applyToProcessEnvironment(G,{workspaceFolder:M},O)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:R,cols:o.cols,rows:o.rows,env:G});const se=(0,g.$oi)();G.VSCODE_IPC_HOOK_CLI=se;const ce=await this.j.createProcess(r,R,o.cols,o.rows,o.unicodeVersion,G,i,o.options,o.shouldPersistTerminal,o.workspaceId,o.workspaceName),ee={executeCommand:(q,...X)=>this.t(ce,q,X,t)},K=new v.$YP(ee,this.h,se);return this.j.onProcessExit(q=>q.id===ce&&K.dispose()),{persistentTerminalId:ce,resolvedShellLaunchConfig:r}}t(t,o,r,i){const{resolve:n,reject:l,promise:p}=(0,c.$ph)(),P=++this.a;this.b.set(P,{resolve:n,reject:l,uriTransformer:i});const j=(0,D.$6n)(r,O=>{if(O&&O.$mid===1)return i.transformOutgoing(O);if(O&&O instanceof w.URI)return i.transformOutgoingURI(O)});return this.c.fire({reqId:P,persistentProcessId:t,commandId:o,commandArgs:j}),p}u(t,o,r){const i=this.b.get(t);if(!i)return;this.b.delete(t);const n=(0,D.$6n)(r,l=>{if(l&&l.$mid===1)return i.uriTransformer.transformIncoming(l)});o?i.reject(n):i.resolve(n)}w(t){return this.j.getDefaultSystemShell(t)}async y(t,o,r,i){return this.j.getProfiles(t,o,r,i)||[]}z(){return{...process.env}}C(t,o){return this.j.getWslPath(t,o)}D(){return this.j.reduceConnectionGraceTime()}}e.$AQ=E}),define(ye[307],Ee([1,0,28,6,2,13,7,103,23,45,25,119,221,83,222,26,131,32,89,122,231,128,16,114,69,68,113,84,85,123,12,58,29,42,248,143,121,30,37,263,92,270,34,127,282,283,253,260,306,71,51,291,301,133,59,134,50,33,277,70,261,117,132,129,116,115,214,296,245,273,267]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o,r,i,n,l,p,P,j,O,R,A,B,G,se,ce,ee,K,q,X,_,M,Q,ae,ne,we,ie,Y,V,N,z,Z,he,x,J,H,L,U,oe,le,de,te,me,pe,Ce,je,ge,Se,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=void 0,e.$6Q=Le;const Te="monacoworkbench";async function Le(Ze,$e,Ie,Ae){const Re=new l.$ui,Me=new Ge,Ve={_serviceBrand:void 0,...O.default};Re.set(R.$jk,Ve);const He=new V.$cn($e,Ve);Re.set(a.$Di,He),Re.set(a.$Ei,He);const st=new le.$MQ((0,j.$ek)(He),He.logsHome);Re.set(j.$4j,st),Me.registerChannel("logger",new pe.$bs(st,it=>Qe(it.remoteAuthority)));const rt=st.createLogger("remoteagent",{name:(0,Ce.localize)(0,null)}),xe=new me.$WQ(rt,[new Je((0,j.$ek)(He))]);Re.set(j.$3j,xe),setTimeout(()=>_e(He.logsHome.with({scheme:k.Schemas.file}).fsPath).then(null,it=>xe.error(it)),1e4),xe.onDidChangeLogLevel(it=>(0,j.log)(xe,it,`Log level changed to ${(0,j.$fk)(xe.getLevel())}`)),xe.trace(`Remote configuration data at ${Ie}`),xe.trace("process arguments:",He.args),Array.isArray(Ve.serverGreeting)&&xe.info(`

${Ve.serverGreeting.join(`
`)}

`),Me.registerChannel(b.$Jo.ChannelName,new b.$Jo);const ct=new g.$ei(it=>it.clientId==="renderer"),at=Ae.add(new o.$Jq(xe));Re.set(t.$3k,at),at.registerProvider(k.Schemas.file,Ae.add(new r.$ar(xe)));const gt=new M.$Bs(at);Re.set(_.$Al,gt);const lt=new v.$Ho(He.machineSettingsResource,at,new U.$ho,xe);Re.set(y.$3i,lt);const $t=new de.$UQ(gt,He,at,xe);Re.set(H.$Cl,$t),Me.registerChannel("userDataProfiles",new Se.$3Q($t,it=>Qe(it.remoteAuthority)));const[,,yt,St]=await Promise.all([lt.initialize(),$t.init(),(0,S.$Gn)(xe.error.bind(xe)),(0,S.$Hn)(xe.error.bind(xe))]),Tt=new Z.$kn;Re.set(Z.$jn,Tt);const Mt=new G.$Yr(lt,He,xe,st);Re.set(A.$Op,Mt);let Pt;try{await w.Promises.stat("/run/.containerenv"),Pt=!0}catch{}if(!Pt)try{Pt=(await w.Promises.readFile("/proc/self/cgroup","utf8")).includes("docker")}catch{}let jt=ee.$mp;const Bt=(0,ee.$sp)(Ve,lt);if((0,ee.$np)(Ve,He)){!(0,ee.$op)(Ve,He)&&Ve.telemetryEndpoint&&(jt=new oe.$KQ(Mt,Bt,Te,null,()=>new L.$IQ(Ve.telemetryEndpoint,yt,Pt)),Ae.add((0,D.$Tc)(()=>jt?.flush())));const it={appenders:[jt],commonProperties:(0,se.$ep)((0,s.release)(),(0,s.hostname)(),process.arch,Ve.commit,Ve.version+"-remote",yt,St,Bt,"remoteAgent"),piiPaths:(0,ee.$tp)(He)},mt=He.args["telemetry-level"];let wt=3;mt==="all"?wt=3:mt==="error"?wt=2:mt==="crash"?wt=1:mt!==void 0&&(wt=0),Re.set(we.$Ps,new i.$ti(we.$Ns,[it,wt]))}else Re.set(we.$Ps,we.$Os);Re.set(c.$7o,new i.$ti(f.$_p));const zt=Me.getChannel("download",ct);Re.set(m.$Lo,new u.$No(zt,()=>Qe("renderer"))),Re.set(J.$qq,new i.$ti(te.$VQ)),Re.set(he.$uq,new i.$ti(x.$HQ)),Re.set(d.$aq,new i.$ti(d.$cq)),Re.set(h.$Eq,new i.$ti(h.$Fq));const dt=new n.$dr(Re);Re.set(p.$Sr,dt.createInstance(P.$Ur));const It=dt.createInstance(De.$5Q,{graceTime:108e5,shortGraceTime:3e5,scrollback:lt.getValue("terminal.integrated.persistentSessionScrollback")??100}),qt=dt.createInstance(X.$xs,It);return Re.set(q.$9r,qt),dt.invokeFunction(it=>{const mt=it.get(h.$Eq),wt=it.get(he.$uq),Ot=it.get(c.$7o),Ct=it.get(p.$Sr),Qt=new Q.$Js(Ze,He,$t,Tt);Me.registerChannel("remoteextensionsenvironment",Qt);const Vt=new ne.$Qs(it.get(we.$Ps),jt);Me.registerChannel("telemetry",Vt),Me.registerChannel(N.$BQ,new ie.$AQ(He,xe,qt,Ve,mt,lt));const Ut=new je.$1Q(dt.createInstance($.$dq,xe),He,$t,wt,xe,Ot,Ct);Me.registerChannel(ge.$ZQ,new je.$2Q(Ut,Wt=>Qe(Wt.remoteAuthority)));const Xt=new ae.$Ms(xe,He);Me.registerChannel(z.$FQ,Xt),Me.registerChannel("request",new B.$Vr(it.get(A.$Op)));const Nt=new E.$eq(mt,Wt=>Qe(Wt.remoteAuthority));Me.registerChannel("extensions",Nt);const Ht=g.ProxyChannel.fromService(it.get(p.$Sr),Ae);return Me.registerChannel("languagePacks",Ht),Ut.whenExtensionsReady().then(()=>mt.cleanUp()),Ae.add(new K.default(it.get(ce.$2l))),{telemetryService:it.get(ce.$2l)}}),{socketServer:Me,instantiationService:dt}}const Ue=Object.create(null);function Qe(Ze){return Ue[Ze]||(Ue[Ze]=(0,Y.$Cs)(Ze)),Ue[Ze]}class Ge extends g.$ai{constructor(){const $e=new C.$ee;super($e.event),this.b=$e}acceptConnection($e,Ie){this.b.fire({protocol:$e,onDidClientDisconnect:Ie})}}e.$7Q=Ge;class Je extends j.$8j{constructor($e=j.$6j){super(),this.setLevel($e),this.g=!!process.stdout.isTTY}trace($e,...Ie){this.f(j.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ye()}]\x1B[0m`,$e,...Ie):console.log(`[${Ye()}]`,$e,...Ie))}debug($e,...Ie){this.f(j.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ye()}]\x1B[0m`,$e,...Ie):console.log(`[${Ye()}]`,$e,...Ie))}info($e,...Ie){this.f(j.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ye()}]\x1B[0m`,$e,...Ie):console.log(`[${Ye()}]`,$e,...Ie))}warn($e,...Ie){this.f(j.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ye()}]\x1B[0m`,$e,...Ie):console.warn(`[${Ye()}]`,$e,...Ie))}error($e,...Ie){this.f(j.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ye()}]\x1B[0m`,$e,...Ie):console.error(`[${Ye()}]`,$e,...Ie))}flush(){}}function Ye(){const Ze=new Date;return`${nt(Ze.getHours())}:${nt(Ze.getMinutes())}:${nt(Ze.getSeconds())}`}function nt(Ze){return Ze<10?`0${Ze}`:String(Ze)}async function _e(Ze){const $e=I.$oc(Ze),Ie=I.$nc(Ze),Me=(await w.Promises.readdir(Ie)).filter(He=>/^\d{8}T\d{6}$/.test(He)).sort().filter(He=>He!==$e),Ve=Me.slice(0,Math.max(0,Me.length-9));await Promise.all(Ve.map(He=>w.Promises.rm(I.$kc(Ie,He))))}}),define(ye[308],Ee([1,0,90,27,79,309,87,97,15,11,35,2,13,7,44,3,17,4,22,169,171,304,108,73,25,5,12,29,30,144,274,275,51,307,279]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b,m,u,a,f,c,d,$,E,h,t,o,r,i,n,l,p,P,j,O,R,A,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=ce;const G=5*60*1e3;let se=class extends v.$Vc{constructor(q,X,_,M,Q,ae,ne,we,ie){super(),this.n=q,this.r=X,this.s=_,this.t=ae,this.u=ne,this.w=we,this.y=ie,this.h=ee.create(this.u),this.j=(0,b.$Kg)(ne,Q),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=M?this.y.createInstance(B.$0Q,this.r,Q??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(q,X){if(q.method!=="GET")return(0,B.$8Q)(q,X,405,`Unsupported method ${q.method}`);if(!q.url)return(0,B.$8Q)(q,X,400,"Bad request.");const _=I.parse(q.url,!0);let M=_.pathname;if(!M)return(0,B.$8Q)(q,X,400,"Bad request.");if(M.startsWith(this.j)&&M.charCodeAt(this.j.length)===47&&(M=M.substring(this.j.length)),M==="/version")return X.writeHead(200,{"Content-Type":"text/plain"}),void X.end(this.u.commit||"");if(M==="/delay-shutdown")return this.N(),X.writeHead(200),void X.end("OK");if(!(0,O.$yn)(this.r,q,_))return(0,B.$8Q)(q,X,403,"Forbidden.");if(M==="/vscode-remote-resource"){const Q=_.query.path;if(typeof Q!="string")return(0,B.$8Q)(q,X,400,"Bad request.");let ae;try{ae=c.URI.from({scheme:b.Schemas.file,path:Q}).fsPath}catch{return(0,B.$8Q)(q,X,400,"Bad request.")}const ne=Object.create(null);this.t.isBuilt&&((0,y.$vg)(ae,this.t.builtinExtensionsPath,!a.$e)||(0,y.$vg)(ae,this.t.extensionsPath,!a.$e))&&(ne["Cache-Control"]="public, max-age=31536000"),ne.Vary="Origin";const we=q.headers.origin;return we&&this.h.matches(we)&&(ne["Access-Control-Allow-Origin"]=we),(0,B.$9Q)(ae,1,this.w,q,X,ne)}if(this.g){this.g.handle(q,X,_);return}return X.writeHead(404,{"Content-Type":"text/plain"}),void X.end("Not found")}handleUpgrade(q,X){let _=(0,d.$Sg)(),M=!1,Q=!1;if(q.url){const V=I.parse(q.url,!0).query;typeof V.reconnectionToken=="string"&&(_=V.reconnectionToken),V.reconnection==="true"&&(M=!0),V.skipWebSocketFrames==="true"&&(Q=!0)}if(q.headers.upgrade===void 0||q.headers.upgrade.toLowerCase()!=="websocket"){X.end("HTTP/1.1 400 Bad Request");return}const ae=q.headers["sec-websocket-key"],ne=s.createHash("sha1");ne.update(ae+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ie=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ne.digest("base64")}`];let Y=!1;if(!Q&&!this.t.args["disable-websocket-compression"]&&q.headers["sec-websocket-extensions"]){const V=Array.isArray(q.headers["sec-websocket-extensions"])?q.headers["sec-websocket-extensions"]:[q.headers["sec-websocket-extensions"]];for(const N of V)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(N)){if(/\b(permessage-deflate)\b/.test(N)){Y=!0,ie.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(N)){Y=!0,ie.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}X.write(ie.join(`\r
`)+`\r
\r
`),X.setTimeout(0),X.setNoDelay(!0),Q?this.D(new o.$li(X,`server-connection-${_}`),M,_):this.D(new o.$mi(new o.$li(X,`server-connection-${_}`),Y,null,!0),M,_)}handleServerError(q){this.w.error("Error occurred in server"),this.w.error(q)}z(q){let X;return q instanceof o.$li?X=q.socket:X=q.socket.socket,X.remoteAddress||"<unknown>"}async C(q,X,_){const M=X.getSocket();this.w.error(`${q} ${_}.`);const Q={type:"error",reason:_};X.sendControl(w.$Ge.fromString(JSON.stringify(Q))),X.dispose(),await M.drain(),M.dispose()}D(q,X,_){const M=this.z(q),Q=`[${M}][${_.substr(0,8)}]`,ae=new t.$ki({socket:q}),ne=this.s?new this.s.validator:null,we=this.s?new this.s.signer:null;let ie;(function(z){z[z.WaitingForAuth=0]="WaitingForAuth",z[z.WaitingForConnectionType=1]="WaitingForConnectionType",z[z.Done=2]="Done",z[z.Error=3]="Error"})(ie||(ie={}));let Y=0;const V=z=>{Y=3,N.dispose(),this.C(Q,ae,z)},N=ae.onControlMessage(z=>{if(Y===0){let Z;try{Z=JSON.parse(z.toString())}catch{return V("Malformed first message")}if(Z.type!=="auth")return V("Invalid first message");if(this.r.type===2&&!this.r.validate(Z.auth))return V("Unauthorized client refused: auth mismatch");let he=(0,d.$Sg)();if(we)try{he=we.sign(Z.data)}catch{}let x=(0,d.$Sg)();if(ne)try{x=ne.createNewMessage(x)}catch{}const J={type:"sign",data:x,signedData:he};ae.sendControl(w.$Ge.fromString(JSON.stringify(J))),Y=1}else if(Y===1){let Z;try{Z=JSON.parse(z.toString())}catch{return V("Malformed second message")}if(Z.type!=="connectionType")return V("Invalid second message");if(typeof Z.signedData!="string")return V("Invalid second message field type");const he=Z.commit,x=this.u.commit;if(he&&x&&he!==x)return V("Client refused: version mismatch");let J=!1;if(!ne)J=!0;else if(this.r.validate(Z.signedData))J=!0;else try{J=ne.validate(Z.signedData)==="ok"}catch{}if(!J){if(this.t.isBuilt)return V("Unauthorized client refused");this.w.error(`${Q} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const H in this.b)this.b[H].shortenReconnectionGraceTimeIfNecessary();for(const H in this.a)this.a[H].shortenReconnectionGraceTimeIfNecessary();Y=2,N.dispose(),this.F(M,Q,ae,q,X,_,Z)}})}async F(q,X,_,M,Q,ae,ne){const we=ne.desiredConnectionType===1?`${X}[ManagementConnection]`:ne.desiredConnectionType===2?`${X}[ExtensionHostConnection]`:X;if(ne.desiredConnectionType===1)if(Q){if(!this.b[ae])return this.f.has(ae)?this.C(we,_,"Unknown reconnection token (seen before)"):this.C(we,_,"Unknown reconnection token (never seen)");_.sendControl(w.$Ge.fromString(JSON.stringify({type:"ok"})));const ie=_.readEntireBuffer();_.dispose(),this.b[ae].acceptReconnection(q,M,ie)}else{if(this.b[ae])return this.C(we,_,"Duplicate reconnection token");_.sendControl(w.$Ge.fromString(JSON.stringify({type:"ok"})));const ie=new j.$sn(this.w,ae,q,_);this.n.acceptConnection(ie.protocol,ie.onClose),this.b[ae]=ie,this.f.add(ae),ie.onClose(()=>{delete this.b[ae]})}else if(ne.desiredConnectionType===2){const ie=ne.args||{language:"en"},Y=await this.I(ie);if(Y.port&&this.w.trace(`${we} - startParams debug port ${Y.port}`),this.w.trace(`${we} - startParams language: ${Y.language}`),this.w.trace(`${we} - startParams env: ${JSON.stringify(Y.env)}`),Q){if(!this.a[ae])return this.f.has(ae)?this.C(we,_,"Unknown reconnection token (seen before)"):this.C(we,_,"Unknown reconnection token (never seen)");_.sendPause(),_.sendControl(w.$Ge.fromString(JSON.stringify(Y.port?{debugPort:Y.port}:{})));const V=_.readEntireBuffer();_.dispose(),this.a[ae].acceptReconnection(q,M,V)}else{if(this.a[ae])return this.C(we,_,"Duplicate reconnection token");_.sendPause(),_.sendControl(w.$Ge.fromString(JSON.stringify(Y.port?{debugPort:Y.port}:{})));const V=_.readEntireBuffer();_.dispose();const N=this.y.createInstance(P.$rn,ae,q,M,V);this.a[ae]=N,this.f.add(ae),N.onClose(()=>{delete this.a[ae],this.J()}),N.start(Y)}}else if(ne.desiredConnectionType===3){const ie=ne.args;this.G(_,ie)}else return this.C(we,_,"Unknown initial data received")}async G(q,X){const _=q.getSocket().socket,M=q.readEntireBuffer();q.dispose(),_.pause();const Q=await this.H(X.host,X.port);M.byteLength>0&&Q.write(M.buffer),Q.on("end",()=>_.end()),Q.on("close",()=>_.end()),Q.on("error",()=>_.destroy()),_.on("end",()=>Q.end()),_.on("close",()=>Q.end()),_.on("error",()=>Q.destroy()),Q.pipe(_),_.pipe(Q)}H(q,X){return new Promise((_,M)=>{const Q=D.createConnection({host:q,port:X,autoSelectFamily:!0},()=>{Q.removeListener("error",M),Q.pause(),_(Q)});Q.once("error",M)})}I(q){return typeof q.port=="number"?(0,E.$Ug)(q.port,10,5e3).then(X=>(q.port=X,q)):(q.debugId=void 0,q.port=void 0,q.break=void 0,Promise.resolve(q))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(q=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!q?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},G))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};se=Fe([Ne(5,R.$bn),Ne(6,l.$jk),Ne(7,n.$3j),Ne(8,i.$vi)],se);async function ce(K,q,X){const _=await(0,O.$xn)(q);_ instanceof O.$vn&&(console.warn(_.message),process.exit(1));function M(H){(0,g.setUnexpectedErrorHandler)(L=>{(0,g.$Z)(L)&&L.stack&&/unexpectedErrorHandler/.test(L.stack)||H(L)})}const Q=[];M(H=>{Q.push(H),console.error(H)});let ae=!1;process.on("SIGPIPE",()=>{ae||(ae=!0,(0,g.$1)(new Error("Unexpected SIGPIPE")))});const ne=new v.$Uc,{socketServer:we,instantiationService:ie}=await(0,A.$6Q)(_,q,X,ne);ie.invokeFunction(H=>{const L=H.get(n.$3j);Q.forEach(U=>L.error(U)),Q.length=0,M(U=>L.error(U))}),ie.invokeFunction(H=>{const L=H.get(r.$3i);a.$c&&(L.getValue("security.restrictUNCAccess")===!1?(0,h.disableUNCAccessRestrictions)():(0,h.addUNCHostToAllowlist)(L.getValue("security.allowedUNCHosts")))}),ie.invokeFunction(H=>{const L=H.get(n.$3j);if(a.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const U=(0,m.$kc)(process.env.HOMEDRIVE,"node_modules"),oe=(0,m.$nc)((0,m.$kc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),le=(0,m.$kc)(oe,"node_modules");if(C.existsSync(U)||C.existsSync(le)){const de=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${U}
* ${le}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;L.warn(de),console.warn(de),process.exit(0)}}});const Y=ie.invokeFunction(H=>{const L=H.get(n.$3j);if(C.existsSync((0,m.$kc)(b.$Qg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(oe){L.error(oe)}return null});let V=q["server-base-path"];V&&!V.startsWith("/")&&(V=`/${V}`);const N=C.existsSync(b.$Qg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(N&&K&&typeof K!="string"){const H=_.type!==0?`?${b.$Ig}=${_.value}`:"";console.log(`Web UI available at http://localhost${K.port===80?"":`:${K.port}`}${V??""}${H}`)}const z=ie.createInstance(se,we,_,Y,N,V);u.mark("code/server/ready");const Z=k.performance.now(),he=global.vscodeServerStartTime,x=global.vscodeServerListenTime,J=global.vscodeServerCodeLoadedTime;if(ie.invokeFunction(async H=>{const L=H.get(p.$2l);if(L.publicLog2("serverStart",{startTime:he,startedTime:x,codeLoadedTime:J,readyTime:Z}),a.$e){const U=H.get(n.$3j),oe=await(0,$.$Tg)(U.error.bind(U));oe&&L.publicLog2("serverPlatformInfo",{platformId:oe.id,platformVersionId:oe.version_id,platformIdLike:oe.id_like})}}),q["print-startup-performance"]){const H=S.$U.get();let L="";L+=`

### Load AMD-module
`,L+=S.$U.toMarkdownTable(["Module","Duration"],H.amdLoad),L+=`

### Load commonjs-module
`,L+=S.$U.toMarkdownTable(["Module","Duration"],H.nodeRequire),L+=`

### Invoke AMD-module factory
`,L+=S.$U.toMarkdownTable(["Module","Duration"],H.amdInvoke),L+=`

### Invoke commonjs-module
`,L+=S.$U.toMarkdownTable(["Module","Duration"],H.nodeEval),L+=`Start-up time: ${x-he}
`,L+=`Code loading time: ${J-he}
`,L+=`Initialized time: ${Z-he}
`,L+=`
`,console.log(L)}return z}class ee{static create(q){const X=q.webEndpointUrlTemplate,_=q.commit,M=q.quality;if(!X||!_||!M)return new ee(null);const Q=(0,d.$Sg)(),ne=new URL(X.replace("{{uuid}}",Q).replace("{{commit}}",_).replace("{{quality}}",M)).origin,we=(0,f.$af)(ne).replace(Q,"[a-zA-Z0-9\\-]+");try{const ie=(0,f.$jf)(`^${we}$`,!0,{matchCase:!1});return new ee(ie)}catch{return new ee(null)}}constructor(q){this.a=q}matches(q){return this.a?this.a.test(q):!1}}}),define(ye[317],Ee([1,0,28,27,13,303,308,67,7,309,51,58,44]),function(ue,e,s,C,D,k,I,S,w,g,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=f,e.createServer=c,b.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=g.performance.now();const m={onMultipleValues:(d,$)=>{console.error(`Option '${d}' can only be defined once. Using value ${$}.`)},onEmptyValue:d=>{console.error(`Ignoring option '${d}': Value must not be empty.`)},onUnknownOption:d=>{console.error(`Ignoring option '${d}': not supported for server.`)},onDeprecatedOption:(d,$)=>{console.warn(`Option '${d}' is deprecated: ${$}`)}};function u(){return(0,S.$um)(process.argv.slice(2),y.$an,m)}function a(d){const $=d["server-data-dir"]||d["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.$kc)(s.homedir(),v.default.serverDataFolderName||".vscode-remote"),E=d["user-data-dir"]||(0,w.$kc)($,"data"),h=(0,w.$kc)(E,"User"),t=(0,w.$kc)(h,"globalStorage"),o=(0,w.$kc)(h,"History"),r=(0,w.$kc)(E,"Machine");d["user-data-dir"]=E;const i=(0,w.$nc)(D.$Qg.asFileUri("").fsPath),n=d["builtin-extensions-dir"]||(0,w.$kc)(i,"extensions");return d["builtin-extensions-dir"]=n,d["extensions-dir"]=d["extensions-dir"]||(0,w.$kc)($,"extensions"),[$,d["extensions-dir"],E,h,r,t,o].forEach(l=>{try{C.existsSync(l)||C.mkdirSync(l,{mode:448})}catch(p){console.error(p)}}),$}function f(d=u()){return(0,k.run)(d,a(d),y.$an)}function c(d,$=u()){return(0,I.$cR)(d,$,a($))}})}).call(this);

//# sourceMappingURL=server.main.js.map
