"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/themables","fs","child_process","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/model","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ie){for(var e=[],a=0,N=ie.length;a<N;a++)e[a]=ke[ie[a]];return e};define(ke[164],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class a{static get(){const A=new Map,R=new Map,L=new Map,$=new Map;function m(k,p){k.has(p.detail)||k.set(p.detail,-p.timestamp)}function E(k,p){const h=k.get(p.detail);h&&(h>=0||k.set(p.detail,h+p.timestamp))}let I=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(I=ie.getStats().slice(0).sort((k,p)=>k.timestamp-p.timestamp));for(const k of I)switch(k.type){case 10:m(A,k);break;case 11:case 12:E(A,k);break;case 21:m(R,k);break;case 22:E(R,k);break;case 33:m(L,k);break;case 34:E(L,k);break;case 31:m($,k);break;case 32:E($,k);break}let P=0;L.forEach(k=>P+=k);function b(k){const p=[];return k.forEach((h,g)=>p.push([g,h])),p}return{amdLoad:b(A),amdInvoke:b(R),nodeRequire:b(L),nodeEval:b($),nodeRequireTotal:P}}static toMarkdownTable(A,R){let L="";const $=[];return A.forEach((m,E)=>{$[E]=m.length}),R.forEach(m=>{m.forEach((E,I)=>{typeof E>"u"&&(E=m[I]="-");const P=E.toString().length;$[I]=Math.max(P,$[I])})}),A.forEach((m,E)=>{L+=`| ${m+" ".repeat($[E]-m.toString().length)} `}),L+=`|
`,A.forEach((m,E)=>{L+=`| ${"-".repeat($[E])} `}),L+=`|
`,R.forEach(m=>{m.forEach((E,I)=>{typeof E<"u"&&(L+=`| ${E+" ".repeat($[I]-E.toString().length)} `)}),L+=`|
`}),L}}e.$U=a}),define(ke[165],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=a,e.$gb=N,e.$hb=A,e.$ib=R,e.$jb=L,e.$kb=$,e.$lb=m,e.$nb=I,e.$ob=P,e.$pb=b,e.$qb=k,e.$rb=p;function a(h,g){const u=N(h,g);if(u!==-1)return h[u]}function N(h,g,u=h.length-1){for(let n=u;n>=0;n--){const i=h[n];if(g(i))return n}return-1}function A(h,g){const u=R(h,g);return u===-1?void 0:h[u]}function R(h,g,u=0,n=h.length){let i=u,d=n;for(;i<d;){const o=Math.floor((i+d)/2);g(h[o])?i=o+1:d=o}return i-1}function L(h,g){const u=$(h,g);return u===h.length?void 0:h[u]}function $(h,g,u=0,n=h.length){let i=u,d=n;for(;i<d;){const o=Math.floor((i+d)/2);g(h[o])?d=o:i=o+1}return i}function m(h,g,u=0,n=h.length){const i=$(h,g,u,n);return i===h.length?-1:i}class E{constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!g(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const u=R(this.e,g,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=E,E.assertInvariants=!1;function I(h,g){if(h.length===0)return;let u=h[0];for(let n=1;n<h.length;n++){const i=h[n];g(i,u)>0&&(u=i)}return u}function P(h,g){if(h.length===0)return;let u=h[0];for(let n=1;n<h.length;n++){const i=h[n];g(i,u)>=0&&(u=i)}return u}function b(h,g){return I(h,(u,n)=>-g(u,n))}function k(h,g){if(h.length===0)return-1;let u=0;for(let n=1;n<h.length;n++){const i=h[n];g(i,h[u])>0&&(u=n)}return u}function p(h,g){for(const u of h){const n=g(u);if(n!==void 0)return n}}}),define(ke[74],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=a,e.$F=N,e.$G=A,e.$H=R;function a(L,$){const m=Object.create(null);for(const E of L){const I=$(E);let P=m[I];P||(P=m[I]=[]),P.push(E)}return m}function N(L,$){const m=[],E=[];for(const I of L)$.has(I)||m.push(I);for(const I of $)L.has(I)||E.push(I);return{removed:m,added:E}}function A(L,$){const m=[],E=[];for(const[I,P]of L)$.has(I)||m.push(P);for(const[I,P]of $)L.has(I)||E.push(P);return{removed:m,added:E}}function R(L,$){const m=new Set;for(const E of $)L.has(E)&&m.add(E);return m}}),define(ke[56],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=N,e.$2h=A,e.$3h=R;function a(L){return($,m,E)=>{let I=null,P=null;if(typeof E.value=="function"?(I="value",P=E.value):typeof E.get=="function"&&(I="get",P=E.get),!P)throw new Error("not supported");E[I]=L(P,m)}}function N(L,$,m){let E=null,I=null;if(typeof m.value=="function"?(E="value",I=m.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",I=m.get),!I)throw new Error("not supported");const P=`$memoize$${$}`;m[E]=function(...b){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,b)}),this[P]}}function A(L,$,m){return a((E,I)=>{const P=`$debounce$${I}`,b=`$debounce$result$${I}`;return function(...k){this[b]||(this[b]=m?m():void 0),clearTimeout(this[P]),$&&(this[b]=$(this[b],...k),k=[this[b]]),this[P]=setTimeout(()=>{E.apply(this,k),this[b]=m?m():void 0},L)}})}function R(L,$,m){return a((E,I)=>{const P=`$throttle$timer$${I}`,b=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...h){if(this[b]||(this[b]=m?m():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),$&&(this[b]=$(this[b],...h)),this[p])return;const g=this[k]+L;g<=Date.now()?(this[k]=Date.now(),E.apply(this,[this[b]]),this[b]=m?m():void 0):(this[p]=!0,this[P]=setTimeout(()=>{this[p]=!1,this[k]=Date.now(),E.apply(this,[this[b]]),this[b]=m?m():void 0},g-Date.now()))}})}}),define(ke[13],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=A,e.$1=R,e.$2=L,e.$3=$,e.$4=E,e.$6=P,e.$7=b,e.$8=k,e.$0=h;class a{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=a,e.$X=new a;function N(o){e.$X.setUnexpectedErrorHandler(o)}function A(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(o){E(o)||e.$X.onUnexpectedError(o)}function L(o){E(o)||e.$X.onUnexpectedExternalError(o)}function $(o){if(o instanceof Error){const{name:t,message:l}=o,r=o.stacktrace||o.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const m="Canceled";function E(o){return o instanceof I?!0:o instanceof Error&&o.name===m&&o.message===m}class I extends Error{constructor(){super(m),this.name=this.message}}e.$5=I;function P(){const o=new Error(m);return o.name=o.message,o}function b(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function k(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class p extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=p;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const l=new i;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(ke[19],Se([1,0,13,165]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=A,e.$tb=R,e.$ub=L,e.$vb=$,e.$wb=m,e.$xb=E,e.$yb=I,e.$zb=P,e.$Ab=b,e.$Bb=k,e.$Cb=p,e.$Db=h,e.$Eb=g,e.top=u,e.$Gb=n,e.$Hb=d,e.$Ib=o,e.$Jb=t,e.$Kb=l,e.$Lb=r,e.$Mb=c,e.$Nb=s,e.$Ob=v,e.$Pb=f,e.$Qb=y,e.$Rb=w,e.$Sb=D,e.$Tb=S,e.$Ub=C,e.$Vb=j,e.$Wb=B,e.$Xb=z,e.$Yb=T,e.$Zb=M,e.$1b=F,e.$2b=O,e.$3b=q,e.$4b=Y,e.$5b=V,e.$6b=J,e.$7b=de,e.$8b=ce,e.$$b=U;function A(re,se=0){return re[re.length-(1+se)]}function R(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}function L(re,se,oe=(K,te)=>K===te){if(re===se)return!0;if(!re||!se||re.length!==se.length)return!1;for(let K=0,te=re.length;K<te;K++)if(!oe(re[K],se[K]))return!1;return!0}function $(re,se){const oe=re.length-1;se<oe&&(re[se]=re[oe]),re.pop()}function m(re,se,oe){return E(re.length,K=>oe(re[K],se))}function E(re,se){let oe=0,K=re-1;for(;oe<=K;){const te=(oe+K)/2|0,ge=se(te);if(ge<0)oe=te+1;else if(ge>0)K=te-1;else return te}return-(oe+1)}function I(re,se,oe){if(re=re|0,re>=se.length)throw new TypeError("invalid index");const K=se[Math.floor(se.length*Math.random())],te=[],ge=[],be=[];for(const Re of se){const pe=oe(Re,K);pe<0?te.push(Re):pe>0?ge.push(Re):be.push(Re)}return re<te.length?I(re,te,oe):re<te.length+be.length?be[0]:I(re-(te.length+be.length),ge,oe)}function P(re,se){const oe=[];let K;for(const te of re.slice(0).sort(se))!K||se(K[0],te)!==0?(K=[te],oe.push(K)):K.push(te);return oe}function*b(re,se){let oe,K;for(const te of re)K!==void 0&&se(K,te)?oe.push(te):(oe&&(yield oe),oe=[te]),K=te;oe&&(yield oe)}function k(re,se){for(let oe=0;oe<=re.length;oe++)se(oe===0?void 0:re[oe-1],oe===re.length?void 0:re[oe])}function p(re,se){for(let oe=0;oe<re.length;oe++)se(oe===0?void 0:re[oe-1],re[oe],oe+1===re.length?void 0:re[oe+1])}function h(re,se,oe){const K=[];function te(Re,pe,Pe){if(pe===0&&Pe.length===0)return;const Ie=K[K.length-1];Ie&&Ie.start+Ie.deleteCount===Re?(Ie.deleteCount+=pe,Ie.toInsert.push(...Pe)):K.push({start:Re,deleteCount:pe,toInsert:Pe})}let ge=0,be=0;for(;;){if(ge===re.length){te(ge,0,se.slice(be));break}if(be===se.length){te(ge,re.length-ge,[]);break}const Re=re[ge],pe=se[be],Pe=oe(Re,pe);Pe===0?(ge+=1,be+=1):Pe<0?(te(ge,1,[]),ge+=1):Pe>0&&(te(ge,0,[pe]),be+=1)}return K}function g(re,se,oe){const K=h(re,se,oe),te=[],ge=[];for(const be of K)te.push(...re.slice(be.start,be.start+be.deleteCount)),ge.push(...be.toInsert);return{removed:te,added:ge}}function u(re,se,oe){if(oe===0)return[];const K=re.slice(0,oe).sort(se);return i(re,se,K,oe,re.length),K}function n(re,se,oe,K,te){return oe===0?Promise.resolve([]):new Promise((ge,be)=>{(async()=>{const Re=re.length,pe=re.slice(0,oe).sort(se);for(let Pe=oe,Ie=Math.min(oe+K,Re);Pe<Re;Pe=Ie,Ie=Math.min(Ie+K,Re)){if(Pe>oe&&await new Promise(je=>setTimeout(je)),te&&te.isCancellationRequested)throw new a.$5;i(re,se,pe,Pe,Ie)}return pe})().then(ge,be)})}function i(re,se,oe,K,te){for(const ge=oe.length;K<te;K++){const be=re[K];if(se(be,oe[ge-1])<0){oe.pop();const Re=(0,N.$kb)(oe,pe=>se(be,pe)<0);oe.splice(Re,0,be)}}}function d(re){return re.filter(se=>!!se)}function o(re){let se=0;for(let oe=0;oe<re.length;oe++)re[oe]&&(re[se]=re[oe],se+=1);re.length=se}function t(re,se,oe){re.splice(oe,0,re.splice(se,1)[0])}function l(re){return!Array.isArray(re)||re.length===0}function r(re){return Array.isArray(re)&&re.length>0}function c(re,se=oe=>oe){const oe=new Set;return re.filter(K=>{const te=se(K);return oe.has(te)?!1:(oe.add(te),!0)})}function s(re){const se=new Set;return oe=>{const K=re(oe);return se.has(K)?!1:(se.add(K),!0)}}function v(re,se){return re.length>0?re[0]:se}function f(re,se){return re.length>0?re[re.length-1]:se}function y(re,se,oe=(K,te)=>K===te){let K=0;for(let te=0,ge=Math.min(re.length,se.length);te<ge&&oe(re[te],se[te]);te++)K++;return K}function w(re){return[].concat(...re)}function D(re,se){let oe=typeof se=="number"?re:0;typeof se=="number"?oe=re:(oe=0,se=re);const K=[];if(oe<=se)for(let te=oe;te<se;te++)K.push(te);else for(let te=oe;te>se;te--)K.push(te);return K}function S(re,se,oe){return re.reduce((K,te)=>(K[se(te)]=oe?oe(te):te,K),Object.create(null))}function C(re,se){return re.push(se),()=>j(re,se)}function j(re,se){const oe=re.indexOf(se);if(oe>-1)return re.splice(oe,1),se}function B(re,se,oe){const K=re.slice(0,se),te=re.slice(se);return K.concat(oe,te)}function z(re,se){let oe;if(typeof se=="number"){let K=se;oe=()=>{const te=Math.sin(K++)*179426549;return te-Math.floor(te)}}else oe=Math.random;for(let K=re.length-1;K>0;K-=1){const te=Math.floor(oe()*(K+1)),ge=re[K];re[K]=re[te],re[te]=ge}}function T(re,se){const oe=re.indexOf(se);oe>-1&&(re.splice(oe,1),re.unshift(se))}function M(re,se){const oe=re.indexOf(se);oe>-1&&(re.splice(oe,1),re.push(se))}function F(re,se){for(const oe of se)re.push(oe)}function O(re,se){return Array.isArray(re)?re.map(se):se(re)}function q(re){return Array.isArray(re)?re:[re]}function Y(re){return re[Math.floor(Math.random()*re.length)]}function V(re,se,oe){const K=x(re,se),te=re.length,ge=oe.length;re.length=te+ge;for(let be=te-1;be>=K;be--)re[be+ge]=re[be];for(let be=0;be<ge;be++)re[be+K]=oe[be]}function J(re,se,oe,K){const te=x(re,se);let ge=re.splice(te,oe);return ge===void 0&&(ge=[]),V(re,te,K),ge}function x(re,se){return se<0?Math.max(se+re.length,0):Math.min(se,re.length)}var ne;(function(re){function se(ge){return ge<0}re.isLessThan=se;function oe(ge){return ge<=0}re.isLessThanOrEqual=oe;function K(ge){return ge>0}re.isGreaterThan=K;function te(ge){return ge===0}re.isNeitherLessOrGreaterThan=te,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function de(re,se){return(oe,K)=>se(re(oe),re(K))}function ce(...re){return(se,oe)=>{for(const K of re){const te=K(se,oe);if(!ne.isNeitherLessOrGreaterThan(te))return te}return ne.neitherLessOrGreaterThan}}const ve=(re,se)=>re-se;e.$9b=ve;const _=(re,se)=>(0,e.$9b)(re?1:0,se?1:0);e.$0b=_;function U(re){return(se,oe)=>-re(se,oe)}class le{constructor(se){this.g=se,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(se){let oe=this.c;for(;oe<this.g.length&&se(this.g[oe]);)oe++;const K=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,K}takeFromEndWhile(se){let oe=this.d;for(;oe>=0&&se(this.g[oe]);)oe--;const K=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const se=this.g[this.c];return this.c++,se}removeLast(){const se=this.g[this.d];return this.d--,se}takeCount(se){const oe=this.g.slice(this.c,this.c+se);return this.c+=se,oe}}e.$_b=le;class De{constructor(se){this.iterate=se}forEach(se){this.iterate(oe=>(se(oe),!0))}toArray(){const se=[];return this.iterate(oe=>(se.push(oe),!0)),se}filter(se){return new De(oe=>this.iterate(K=>se(K)?oe(K):!0))}map(se){return new De(oe=>this.iterate(K=>oe(se(K))))}some(se){let oe=!1;return this.iterate(K=>(oe=se(K),!oe)),oe}findFirst(se){let oe;return this.iterate(K=>se(K)?(oe=K,!1):!0),oe}findLast(se){let oe;return this.iterate(K=>(se(K)&&(oe=K),!0)),oe}findLastMaxBy(se){let oe,K=!0;return this.iterate(te=>((K||ne.isGreaterThan(se(te,oe)))&&(K=!1,oe=te),!0)),oe}}e.$ac=De,De.empty=new De(re=>{});class $e{constructor(se){this.c=se}static createSortPermutation(se,oe){const K=Array.from(se.keys()).sort((te,ge)=>oe(se[te],se[ge]));return new $e(K)}apply(se){return se.map((oe,K)=>se[this.c[K]])}inverse(){const se=this.c.slice();for(let oe=0;oe<this.c.length;oe++)se[this.c[oe]]=oe;return new $e(se)}}e.$bc=$e}),define(ke[62],Se([1,0,13]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$fd=A,e.$gd=R,e.$hd=L,e.$id=$,e.$jd=m;function N(E,I){if(!E)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function A(E,I="Unreachable"){throw new Error(I)}function R(E){if(!E)throw new a.$cb("Assertion Failed")}function L(E){E||(0,a.$1)(new a.$cb("Soft Assertion Failed"))}function $(E){if(!E()){debugger;E(),(0,a.$1)(new a.$cb("Assertion Failed"))}}function m(E,I){let P=0;for(;P<E.length-1;){const b=E[P],k=E[P+1];if(!I(b,k))return!1;P++}return!0}}),define(ke[166],Se([1,0,19]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=A,e.$9c=R,e.$0c=L,e.$$c=$,e.$_c=m,e.$ad=E;const N=(k,p)=>k===p;e.$7c=N;function A(k=e.$7c){return(p,h)=>a.$ub(p,h,k)}function R(){return(k,p)=>JSON.stringify(k)===JSON.stringify(p)}function L(){return(k,p)=>k.equals(p)}function $(k,p,h){return!k||!p?k===p:h(k,p)}function m(k,p){if(k===p)return!0;if(Array.isArray(k)&&Array.isArray(p)){if(k.length!==p.length)return!1;for(let h=0;h<k.length;h++)if(!m(k[h],p[h]))return!1;return!0}if(k&&typeof k=="object"&&p&&typeof p=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf(p)===Object.prototype){const h=k,g=p,u=Object.keys(h),n=Object.keys(g),i=new Set(n);if(u.length!==n.length)return!1;for(const d of u)if(!i.has(d)||!m(h[d],g[d]))return!1;return!0}return!1}function E(k){return JSON.stringify(b(k))}let I=0;const P=new WeakMap;function b(k){if(Array.isArray(k))return k.map(b);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const p=k,h=Object.create(null);for(const g of Object.keys(p).sort())h[g]=b(p[g]);return h}else{let p=P.get(k);return p===void 0&&(p=I++,P.set(k,p)),p+"----2b76a038c20c4bcc"}return k}}),define(ke[75],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=a;function a(N,A){const R=this;let L=!1,$;return function(){if(L)return $;if(L=!0,A)try{$=N.apply(R,arguments)}finally{A()}else $=N.apply(R,arguments);return $}}}),define(ke[126],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0;class a{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$CP=a,e.$DP=new a("id#")}),define(ke[40],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(N){function A(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=A;const R=Object.freeze([]);function L(){return R}N.empty=L;function*$(t){yield t}N.single=$;function m(t){return A(t)?t:$(t)}N.wrap=m;function E(t){return t||R}N.from=E;function*I(t){for(let l=t.length-1;l>=0;l--)yield t[l]}N.reverse=I;function P(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=P;function b(t){return t[Symbol.iterator]().next().value}N.first=b;function k(t,l){for(const r of t)if(l(r))return!0;return!1}N.some=k;function p(t,l){for(const r of t)if(l(r))return r}N.find=p;function*h(t,l){for(const r of t)l(r)&&(yield r)}N.filter=h;function*g(t,l){let r=0;for(const c of t)yield l(c,r++)}N.map=g;function*u(...t){for(const l of t)yield*l}N.concat=u;function n(t,l,r){let c=r;for(const s of t)c=l(c,s);return c}N.reduce=n;function*i(t,l,r=t.length){for(l<0&&(l+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);l<r;l++)yield t[l]}N.slice=i;function d(t,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,t];const c=t[Symbol.iterator]();for(let s=0;s<l;s++){const v=c.next();if(v.done)return[r,N.empty()];r.push(v.value)}return[r,{[Symbol.iterator](){return c}}]}N.consume=d;async function o(t){const l=[];for await(const r of t)l.push(r);return Promise.resolve(l)}N.asyncToArray=o})(a||(e.Iterable=a={}))}),define(ke[167],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$In=L,e.$Jn=P,e.$Kn=b,e.$Ln=k,e.$Mn=p,e.$Nn=h,e.$On=g,e.$Pn=u,e.$Qn=n,e.$Rn=i,e.$Sn=d,e.$Tn=o;var a;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(a||(e.ScanError=a={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,l=!1){let r=0;const c=t.length;let s="",v=0,f=16,y=0;function w(T){let M=0,F=0;for(;M<T;){const O=t.charCodeAt(r);if(O>=48&&O<=57)F=F*16+O-48;else if(O>=65&&O<=70)F=F*16+O-65+10;else if(O>=97&&O<=102)F=F*16+O-97+10;else break;r++,M++}return M<T&&(F=-1),F}function D(T){r=T,s="",v=0,f=16,y=0}function S(){const T=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return y=3,t.substring(T,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;M=r}else y=3;return t.substring(T,M)}function C(){let T="",M=r;for(;;){if(r>=c){T+=t.substring(M,r),y=2;break}const F=t.charCodeAt(r);if(F===34){T+=t.substring(M,r),r++;break}if(F===92){if(T+=t.substring(M,r),r++,r>=c){y=2;break}switch(t.charCodeAt(r++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const q=w(4);q>=0?T+=String.fromCharCode(q):y=4;break}default:y=5}M=r;continue}if(F>=0&&F<=31)if(m(F)){T+=t.substring(M,r),y=2;break}else y=6;r++}return T}function j(){if(s="",y=0,v=r,r>=c)return v=c,f=17;let T=t.charCodeAt(r);if($(T)){do r++,s+=String.fromCharCode(T),T=t.charCodeAt(r);while($(T));return f=15}if(m(T))return r++,s+=String.fromCharCode(T),T===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),f=14;switch(T){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,s=C(),f=10;case 47:{const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!m(t.charCodeAt(r));)r++;return s=t.substring(M,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const F=c-1;let O=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,O=!0;break}r++}return O||(r++,y=1),s=t.substring(M,r),f=13}return s+=String.fromCharCode(T),r++,f=16}case 45:if(s+=String.fromCharCode(T),r++,r===c||!E(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=S(),f=11;default:for(;r<c&&B(T);)r++,T=t.charCodeAt(r);if(v!==r){switch(s=t.substring(v,r),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(T),r++,f=16}}function B(T){if($(T)||m(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let T;do T=j();while(T>=12&&T<=15);return T}return{setPosition:D,getPosition:()=>r,scan:l?z:j,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>y}}function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function P(t,l){const r=[],c=new Object;let s;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function y(w,D,S,C){v.value=w,v.offset=D,v.length=S,v.type=C,v.colonOffset=void 0,s=v}try{i(t,{onObjectBegin:(w,D)=>{if(l<=w)throw c;s=void 0,f=l>w,r.push("")},onObjectProperty:(w,D,S)=>{if(l<D||(y(w,D,S,"property"),r[r.length-1]=w,l<=D+S))throw c},onObjectEnd:(w,D)=>{if(l<=w)throw c;s=void 0,r.pop()},onArrayBegin:(w,D)=>{if(l<=w)throw c;s=void 0,r.push(0)},onArrayEnd:(w,D)=>{if(l<=w)throw c;s=void 0,r.pop()},onLiteralValue:(w,D,S)=>{if(l<D||(y(w,D,S,o(w)),l<=D+S))throw c},onSeparator:(w,D,S)=>{if(l<=D)throw c;if(w===":"&&s&&s.type==="property")s.colonOffset=D,f=!1,s=void 0;else if(w===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(f=!0,r[r.length-1]=""),s=void 0}}})}catch(w){if(w!==c)throw w}return{path:r,previousNode:s,isAtPropertyKey:f,matches:w=>{let D=0;for(let S=0;D<w.length&&S<r.length;S++)if(w[D]===r[S]||w[D]==="*")D++;else if(w[D]!=="**")return!1;return D===w.length}}}function b(t,l=[],r=R.DEFAULT){let c=null,s=[];const v=[];function f(w){Array.isArray(s)?s.push(w):c!==null&&(s[c]=w)}return i(t,{onObjectBegin:()=>{const w={};f(w),v.push(s),s=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{s=v.pop()},onArrayBegin:()=>{const w=[];f(w),v.push(s),s=w,c=null},onArrayEnd:()=>{s=v.pop()},onLiteralValue:f,onError:(w,D,S)=>{l.push({error:w,offset:D,length:S})}},r),s[0]}function k(t,l=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){c.type==="property"&&(c.length=w-c.offset,c=c.parent)}function v(w){return c.children.push(w),w}i(t,{onObjectBegin:w=>{c=v({type:"object",offset:w,length:-1,parent:c,children:[]})},onObjectProperty:(w,D,S)=>{c=v({type:"property",offset:D,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:w,offset:D,length:S,parent:c})},onObjectEnd:(w,D)=>{c.length=w+D-c.offset,c=c.parent,s(w+D)},onArrayBegin:(w,D)=>{c=v({type:"array",offset:w,length:-1,parent:c,children:[]})},onArrayEnd:(w,D)=>{c.length=w+D-c.offset,c=c.parent,s(w+D)},onLiteralValue:(w,D,S)=>{v({type:o(w),offset:D,length:S,parent:c,value:w}),s(D+S)},onSeparator:(w,D,S)=>{c.type==="property"&&(w===":"?c.colonOffset=D:w===","&&s(D))},onError:(w,D,S)=>{l.push({error:w,offset:D,length:S})}},r);const y=c.children[0];return y&&delete y.parent,y}function p(t,l){if(!t)return;let r=t;for(const c of l)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===c){r=v.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function h(t){if(!t.parent||!t.parent.children)return[];const l=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const l=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(l[r.children[0].value]=g(c))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function u(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}function n(t,l,r=!1){if(u(t,l,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=l;s++){const v=n(c[s],l,r);if(v)return v}return t}}function i(t,l,r=R.DEFAULT){const c=L(t,!1);function s(de){return de?()=>de(c.getTokenOffset(),c.getTokenLength()):()=>!0}function v(de){return de?ce=>de(ce,c.getTokenOffset(),c.getTokenLength()):()=>!0}const f=s(l.onObjectBegin),y=v(l.onObjectProperty),w=s(l.onObjectEnd),D=s(l.onArrayBegin),S=s(l.onArrayEnd),C=v(l.onLiteralValue),j=v(l.onSeparator),B=s(l.onComment),z=v(l.onError),T=r&&r.disallowComments,M=r&&r.allowTrailingComma;function F(){for(;;){const de=c.scan();switch(c.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:T||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(de){case 12:case 13:T?O(10):B();break;case 16:O(1);break;case 15:case 14:break;default:return de}}}function O(de,ce=[],ve=[]){if(z(de),ce.length+ve.length>0){let _=c.getToken();for(;_!==17;){if(ce.indexOf(_)!==-1){F();break}else if(ve.indexOf(_)!==-1)break;_=F()}}}function q(de){const ce=c.getTokenValue();return de?C(ce):y(ce),F(),!0}function Y(){switch(c.getToken()){case 11:{let de=0;try{de=JSON.parse(c.getTokenValue()),typeof de!="number"&&(O(2),de=0)}catch{O(2)}C(de);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return F(),!0}function V(){return c.getToken()!==10?(O(3,[],[2,5]),!1):(q(!1),c.getToken()===6?(j(":"),F(),ne()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function J(){f(),F();let de=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(de||O(4,[],[]),j(","),F(),c.getToken()===2&&M)break}else de&&O(6,[],[]);V()||O(4,[],[2,5]),de=!0}return w(),c.getToken()!==2?O(7,[2],[]):F(),!0}function x(){D(),F();let de=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(de||O(4,[],[]),j(","),F(),c.getToken()===4&&M)break}else de&&O(6,[],[]);ne()||O(4,[],[4,5]),de=!0}return S(),c.getToken()!==4?O(8,[4],[]):F(),!0}function ne(){switch(c.getToken()){case 3:return x();case 1:return J();case 10:return q(!0);default:return Y()}}return F(),c.getToken()===17?r.allowEmptyContent?!0:(O(4,[],[]),!1):ne()?(c.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}function d(t,l){const r=L(t),c=[];let s,v=0,f;do switch(f=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:v!==f&&c.push(t.substring(v,f)),l!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,l)),v=r.getPosition();break}while(s!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class a{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=a}),define(ke[76],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class N{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const L=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=L}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const $=new a(R);if(this.a===a.Undefined)this.a=$,this.b=$;else if(L){const E=this.b;this.b=$,$.prev=E,E.next=$}else{const E=this.a;this.a=$,$.next=E,E.prev=$}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e($))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.$6c=N}),define(ke[27],Se([1,0]),function(ie,e){"use strict";var a,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=L,e.$Ac=$,e.$Jc=d;function R(o,t,l){let r=o.get(t);return r===void 0&&(r=l,o.set(t,r)),r}function L(o){const t=[];return o.forEach((l,r)=>{t.push(`${r} => ${l}`)}),`Map(${o.size}) {${t.join(", ")}}`}function $(o){const t=[];return o.forEach(l=>{t.push(l)}),`Set(${o.size}) {${t.join(", ")}}`}class m{constructor(t,l){this.uri=t,this.value=l}}function E(o){return Array.isArray(o)}class I{constructor(t,l){if(this[a]="ResourceMap",t instanceof I)this.d=new Map(t.d),this.e=l??I.c;else if(E(t)){this.d=new Map,this.e=l??I.c;for(const[r,c]of t)this.set(r,c)}else this.d=new Map,this.e=t??I.c}set(t,l){return this.d.set(this.e(t),new m(t,l)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,l){typeof l<"u"&&(t=t.bind(l));for(const[r,c]of this.d)t(c.value,c.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=I,I.c=o=>o.toString();class P{constructor(t,l){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new I(t):(this.c=new I(l),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,l){this.c.forEach((r,c)=>t.call(l,c,c,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var b;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class k{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,l=0){const r=this.c.get(t);if(r)return l!==0&&this.m(r,l),r.value}set(t,l,r=0){let c=this.c.get(t);if(c)c.value=l,r!==0&&this.m(c,r);else{switch(c={key:t,value:l,next:void 0,previous:void 0},r){case 0:this.k(c);break;case 1:this.j(c);break;case 2:this.k(c);break;default:this.k(c);break}this.c.set(t,c),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this.c.get(t);if(l)return this.c.delete(t),this.l(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,l){const r=this.g;let c=this.d;for(;c;){if(l?t.bind(l)(c.value,c.key,this):t(c.value,c.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.key,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}values(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.value,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}entries(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:[r.key,r.value],done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.d,r=this.size;for(;l&&r>t;)this.c.delete(l.key),l=l.next,r--;this.d=l,this.f=r,l&&(l.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.e,r=this.size;for(;l&&r>t;)this.c.delete(l.key),l=l.previous,r--;this.e=l,this.f=r,l&&(l.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const l=t.next,r=t.previous;if(!l||!r)throw new Error("Invalid list");l.previous=r,r.next=l}t.next=void 0,t.previous=void 0,this.g++}m(t,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this.d)return;const r=t.next,c=t.previous;t===this.e?(c.next=void 0,this.e=c):(r.previous=c,c.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(l===2){if(t===this.e)return;const r=t.next,c=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=c,c.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((l,r)=>{t.push([r,l])}),t}fromJSON(t){this.clear();for(const[l,r]of t)this.set(l,r)}}e.$Dc=k;class p extends k{constructor(t,l=1){super(),this.n=t,this.o=Math.min(Math.max(0,l),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends p{constructor(t,l=1){super(t,l)}q(t){this.h(t)}set(t,l){return super.set(t,l),this.p(),this}}e.$Ec=h;class g extends p{constructor(t,l=1){super(t,l)}q(t){this.i(t)}set(t,l){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,l),this}}e.$Fc=g;class u{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let l=this.c.get(t)||0;return l===0?!1:(l--,l===0?this.c.delete(t):this.c.set(t,l),!0)}has(t){return this.c.has(t)}}e.$Gc=u;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[l,r]of t)this.set(l,r)}clear(){this.c.clear(),this.d.clear()}set(t,l){this.c.set(t,l),this.d.set(l,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const l=this.c.get(t);return l===void 0?!1:(this.c.delete(t),this.d.delete(l),!0)}forEach(t,l){this.c.forEach((r,c)=>{t.call(l,r,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=n;class i{constructor(){this.c=new Map}add(t,l){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(l)}delete(t,l){const r=this.c.get(t);r&&(r.delete(l),r.size===0&&this.c.delete(t))}forEach(t,l){const r=this.c.get(t);r&&r.forEach(l)}get(t){const l=this.c.get(t);return l||new Set}}e.$Ic=i;function d(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[l,r]of o)if(!t.has(l)||t.get(l)!==r)return!1;for(const[l]of t)if(!o.has(l))return!1;return!0}}),define(ke[3],Se([1,0,19,74,27,75,40]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=I,e.$Mc=P,e.$Nc=b,e.$Oc=h,e.$Pc=g,e.$Qc=u,e.$Rc=n,e.$Sc=i,e.$Tc=d,e.$4c=w;const $=!1;let m=null;class E{constructor(){this.b=new Map}c(C){let j=this.b.get(C);return j||(j={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,j)),j}trackDisposable(C){const j=this.c(C);j.source||(j.source=new Error().stack)}setParent(C,j){const B=this.c(C);B.parent=j}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,j){const B=j.get(C);if(B)return B;const z=C.parent?this.f(this.c(C.parent),j):C;return j.set(C,z),z}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,B])=>B.source!==null&&!this.f(B,C).isSingleton).flatMap(([B])=>B)}computeLeakingDisposables(C=10,j){let B;if(j)B=j;else{const O=new Map,q=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,O).isSingleton);if(q.length===0)return;const Y=new Set(q.map(V=>V.value));if(B=q.filter(V=>!(V.parent&&Y.has(V.parent))),B.length===0)throw new Error("There are cyclic diposable chains!")}if(!B)return;function z(O){function q(V,J){for(;V.length>0&&J.some(x=>typeof x=="string"?x===V[0]:V[0].match(x));)V.shift()}const Y=O.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return q(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const T=new A.$Ic;for(const O of B){const q=z(O);for(let Y=0;Y<=q.length;Y++)T.add(q.slice(0,Y).join(`
`),O)}B.sort((0,a.$7b)(O=>O.idx,a.$9b));let M="",F=0;for(const O of B.slice(0,C)){F++;const q=z(O),Y=[];for(let V=0;V<q.length;V++){let J=q[V];J=`(shared with ${T.get(q.slice(0,V+1).join(`
`)).size}/${B.length} leaks) at ${J}`;const ne=T.get(q.slice(0,V).join(`
`)),de=(0,N.$E)([...ne].map(ce=>z(ce)[V]),ce=>ce);delete de[q[V]];for(const[ce,ve]of Object.entries(de))Y.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${ce}`);Y.unshift(J)}M+=`


==================== Leaking disposable ${F}/${B.length}: ${O.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return B.length>C&&(M+=`


... and ${B.length-C} more leaking disposables

`),{leaks:B,details:M}}}e.$Kc=E,E.a=0;function I(S){m=S}if($){const S="__is_disposable_tracked__";I(new class{trackDisposable(C){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[S]||console.log(j)},3e3)}setParent(C,j){if(C&&C!==t.None)try{C[S]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[S]=!0}catch{}}markAsSingleton(C){}})}function P(S){return m?.trackDisposable(S),S}function b(S){m?.markAsDisposed(S)}function k(S,C){m?.setParent(S,C)}function p(S,C){if(m)for(const j of S)m.setParent(j,C)}function h(S){return m?.markAsSingleton(S),S}function g(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function u(S){if(L.Iterable.is(S)){const C=[];for(const j of S)if(j)try{j.dispose()}catch(B){C.push(B)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function n(S){for(const C of S)g(C)&&C.dispose();return[]}function i(...S){const C=d(()=>u(S));return p(S,C),C}function d(S){const C=P({dispose:(0,R.$db)(()=>{b(C),S()})});return C}class o{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return k(C,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),k(C,null))}}e.$Uc=o,o.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new o,P(this),k(this.q,this)}dispose(){b(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Vc=t,t.None=Object.freeze({dispose(){}});class l{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&k(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&k(C,null),C}}e.$Wc=l;class r{constructor(C){this.a=new l,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class c{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let j=C;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,b(this))},this}}e.$Zc=s;class v{constructor(){this.a=new Map}acquire(C,...j){let B=this.a.get(C);B||(B={counter:0,object:this.b(C,...j)},this.a.set(C,B));const{object:z}=B,T=(0,R.$db)(()=>{--B.counter===0&&(this.c(C,B.object),this.a.delete(C))});return B.counter++,{object:z,dispose:T}}}e.$1c=v;class f{constructor(C){this.a=C}async acquire(C,...j){const B=this.a.acquire(C,...j);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(z){throw B.dispose(),z}}}e.$2c=f;class y{constructor(C){this.object=C}dispose(){}}e.$3c=y;function w(S){const C=new o;try{S(C)}finally{C.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,j,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(C)?.dispose(),this.a.set(C,j)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=D}),function(ie,e){typeof define=="function"&&define.amd?define(ke[168],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(re,se){for(var oe=0;oe<se.length;oe++){var K=se[oe];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(re,K.key,K)}}function a(re,se,oe){return se&&e(re.prototype,se),oe&&e(re,oe),Object.defineProperty(re,"prototype",{writable:!1}),re}function N(re,se){if(re){if(typeof re=="string")return A(re,se);var oe=Object.prototype.toString.call(re).slice(8,-1);if(oe==="Object"&&re.constructor&&(oe=re.constructor.name),oe==="Map"||oe==="Set")return Array.from(re);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return A(re,se)}}function A(re,se){(se==null||se>re.length)&&(se=re.length);for(var oe=0,K=new Array(se);oe<se;oe++)K[oe]=re[oe];return K}function R(re,se){var oe=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(oe)return(oe=oe.call(re)).next.bind(oe);if(Array.isArray(re)||(oe=N(re))||se&&re&&typeof re.length=="number"){oe&&(re=oe);var K=0;return function(){return K>=re.length?{done:!0}:{done:!1,value:re[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=L();function $(re){ie.defaults=re}var m=/[&<>"']/,E=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(se){return b[se]};function p(re,se){if(se){if(m.test(re))return re.replace(E,k)}else if(I.test(re))return re.replace(P,k);return re}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(re){return re.replace(h,function(se,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var u=/(^|[^\[])\^/g;function n(re,se){re=typeof re=="string"?re:re.source,se=se||"";var oe={replace:function(te,ge){return ge=ge.source||ge,ge=ge.replace(u,"$1"),re=re.replace(te,ge),oe},getRegex:function(){return new RegExp(re,se)}};return oe}var i=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(re,se,oe){if(re){var K;try{K=decodeURIComponent(g(oe)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}se&&!d.test(oe)&&(oe=s(se,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(re,se){t[" "+re]||(l.test(re)?t[" "+re]=re+"/":t[" "+re]=w(re,"/",!0)),re=t[" "+re];var oe=re.indexOf(":")===-1;return se.substring(0,2)==="//"?oe?se:re.replace(r,"$1")+se:se.charAt(0)==="/"?oe?se:re.replace(c,"$1")+se:re+se}var v={exec:function(){}};function f(re){for(var se=1,oe,K;se<arguments.length;se++){oe=arguments[se];for(K in oe)Object.prototype.hasOwnProperty.call(oe,K)&&(re[K]=oe[K])}return re}function y(re,se){var oe=re.replace(/\|/g,function(ge,be,Re){for(var pe=!1,Pe=be;--Pe>=0&&Re[Pe]==="\\";)pe=!pe;return pe?"|":" |"}),K=oe.split(/ \|/),te=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>se)K.splice(se);else for(;K.length<se;)K.push("");for(;te<K.length;te++)K[te]=K[te].trim().replace(/\\\|/g,"|");return K}function w(re,se,oe){var K=re.length;if(K===0)return"";for(var te=0;te<K;){var ge=re.charAt(K-te-1);if(ge===se&&!oe)te++;else if(ge!==se&&oe)te++;else break}return re.slice(0,K-te)}function D(re,se){if(re.indexOf(se[1])===-1)return-1;for(var oe=re.length,K=0,te=0;te<oe;te++)if(re[te]==="\\")te++;else if(re[te]===se[0])K++;else if(re[te]===se[1]&&(K--,K<0))return te;return-1}function S(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(re,se){if(se<1)return"";for(var oe="";se>1;)se&1&&(oe+=re),se>>=1,re+=re;return oe+re}function j(re,se,oe,K){var te=se.href,ge=se.title?p(se.title):null,be=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){K.state.inLink=!0;var Re={type:"link",raw:oe,href:te,title:ge,text:be,tokens:K.inlineTokens(be)};return K.state.inLink=!1,Re}return{type:"image",raw:oe,href:te,title:ge,text:p(be)}}function B(re,se){var oe=re.match(/^(\s+)(?:```)/);if(oe===null)return se;var K=oe[1];return se.split(`
`).map(function(te){var ge=te.match(/^\s+/);if(ge===null)return te;var be=ge[0];return be.length>=K.length?te.slice(K.length):te}).join(`
`)}var z=function(){function re(oe){this.options=oe||ie.defaults}var se=re.prototype;return se.space=function(K){var te=this.rules.block.newline.exec(K);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},se.code=function(K){var te=this.rules.block.code.exec(K);if(te){var ge=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:w(ge,`
`)}}},se.fences=function(K){var te=this.rules.block.fences.exec(K);if(te){var ge=te[0],be=B(ge,te[3]||"");return{type:"code",raw:ge,lang:te[2]?te[2].trim():te[2],text:be}}},se.heading=function(K){var te=this.rules.block.heading.exec(K);if(te){var ge=te[2].trim();if(/#$/.test(ge)){var be=w(ge,"#");(this.options.pedantic||!be||/ $/.test(be))&&(ge=be.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:ge,tokens:this.lexer.inline(ge)}}},se.hr=function(K){var te=this.rules.block.hr.exec(K);if(te)return{type:"hr",raw:te[0]}},se.blockquote=function(K){var te=this.rules.block.blockquote.exec(K);if(te){var ge=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},se.list=function(K){var te=this.rules.block.list.exec(K);if(te){var ge,be,Re,pe,Pe,Ie,je,W,Q,X,Z,he,we=te[1].trim(),Te=we.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(he=!1,!(!(te=Xe.exec(K))||this.rules.block.hr.test(K)));){if(ge=te[0],K=K.substring(ge.length),W=te[2].split(`
`,1)[0],Q=K.split(`
`,1)[0],this.options.pedantic?(pe=2,Z=W.trimLeft()):(pe=te[2].search(/[^ ]/),pe=pe>4?1:pe,Z=W.slice(pe),pe+=te[1].length),Ie=!1,!W&&/^ *$/.test(Q)&&(ge+=Q+`
`,K=K.substring(Q.length+1),he=!0),!he)for(var et=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");K&&(X=K.split(`
`,1)[0],W=X,this.options.pedantic&&(W=W.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(W)||ot.test(W)||et.test(W)||rt.test(K)));){if(W.search(/[^ ]/)>=pe||!W.trim())Z+=`
`+W.slice(pe);else if(!Ie)Z+=`
`+W;else break;!Ie&&!W.trim()&&(Ie=!0),ge+=X+`
`,K=K.substring(X.length+1)}He.loose||(je?He.loose=!0:/\n *\n *$/.test(ge)&&(je=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Z),be&&(Re=be[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:ge,task:!!be,checked:Re,loose:!1,text:Z}),He.raw+=ge}He.items[He.items.length-1].raw=ge.trimRight(),He.items[He.items.length-1].text=Z.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(Pe=0;Pe<ct;Pe++){this.lexer.state.top=!1,He.items[Pe].tokens=this.lexer.blockTokens(He.items[Pe].text,[]);var Ne=He.items[Pe].tokens.filter(function(Ae){return Ae.type==="space"}),Ve=Ne.every(function(Ae){for(var Ge=Ae.raw.split(""),ae=0,ue=R(Ge),Ce;!(Ce=ue()).done;){var Ke=Ce.value;if(Ke===`
`&&(ae+=1),ae>1)return!0}return!1});!He.loose&&Ne.length&&Ve&&(He.loose=!0,He.items[Pe].loose=!0)}return He}},se.html=function(K){var te=this.rules.block.html.exec(K);if(te){var ge={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(te[0]):p(te[0]);ge.type="paragraph",ge.text=be,ge.tokens=this.lexer.inline(be)}return ge}},se.def=function(K){var te=this.rules.block.def.exec(K);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var ge=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:te[0],href:te[2],title:te[3]}}},se.table=function(K){var te=this.rules.block.table.exec(K);if(te){var ge={type:"table",header:y(te[1]).map(function(je){return{text:je}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=te[0];var be=ge.align.length,Re,pe,Pe,Ie;for(Re=0;Re<be;Re++)/^ *-+: *$/.test(ge.align[Re])?ge.align[Re]="right":/^ *:-+: *$/.test(ge.align[Re])?ge.align[Re]="center":/^ *:-+ *$/.test(ge.align[Re])?ge.align[Re]="left":ge.align[Re]=null;for(be=ge.rows.length,Re=0;Re<be;Re++)ge.rows[Re]=y(ge.rows[Re],ge.header.length).map(function(je){return{text:je}});for(be=ge.header.length,pe=0;pe<be;pe++)ge.header[pe].tokens=this.lexer.inline(ge.header[pe].text);for(be=ge.rows.length,pe=0;pe<be;pe++)for(Ie=ge.rows[pe],Pe=0;Pe<Ie.length;Pe++)Ie[Pe].tokens=this.lexer.inline(Ie[Pe].text);return ge}}},se.lheading=function(K){var te=this.rules.block.lheading.exec(K);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},se.paragraph=function(K){var te=this.rules.block.paragraph.exec(K);if(te){var ge=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:ge,tokens:this.lexer.inline(ge)}}},se.text=function(K){var te=this.rules.block.text.exec(K);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},se.escape=function(K){var te=this.rules.inline.escape.exec(K);if(te)return{type:"escape",raw:te[0],text:p(te[1])}},se.tag=function(K){var te=this.rules.inline.tag.exec(K);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):p(te[0]):te[0]}},se.link=function(K){var te=this.rules.inline.link.exec(K);if(te){var ge=te[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var be=w(ge.slice(0,-1),"\\");if((ge.length-be.length)%2===0)return}else{var Re=D(te[2],"()");if(Re>-1){var pe=te[0].indexOf("!")===0?5:4,Pe=pe+te[1].length+Re;te[2]=te[2].substring(0,Re),te[0]=te[0].substring(0,Pe).trim(),te[3]=""}}var Ie=te[2],je="";if(this.options.pedantic){var W=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);W&&(Ie=W[1],je=W[3])}else je=te[3]?te[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(ge)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),j(te,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},se.reflink=function(K,te){var ge;if((ge=this.rules.inline.reflink.exec(K))||(ge=this.rules.inline.nolink.exec(K))){var be=(ge[2]||ge[1]).replace(/\s+/g," ");if(be=te[be.toLowerCase()],!be||!be.href){var Re=ge[0].charAt(0);return{type:"text",raw:Re,text:Re}}return j(ge,be,ge[0],this.lexer)}},se.emStrong=function(K,te,ge){ge===void 0&&(ge="");var be=this.rules.inline.emStrong.lDelim.exec(K);if(be&&!(be[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=be[1]||be[2]||"";if(!Re||Re&&(ge===""||this.rules.inline.punctuation.exec(ge))){var pe=be[0].length-1,Pe,Ie,je=pe,W=0,Q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Q.lastIndex=0,te=te.slice(-1*K.length+pe);(be=Q.exec(te))!=null;)if(Pe=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Pe){if(Ie=Pe.length,be[3]||be[4]){je+=Ie;continue}else if((be[5]||be[6])&&pe%3&&!((pe+Ie)%3)){W+=Ie;continue}if(je-=Ie,!(je>0)){if(Ie=Math.min(Ie,Ie+je+W),Math.min(pe,Ie)%2){var X=K.slice(1,pe+be.index+Ie);return{type:"em",raw:K.slice(0,pe+be.index+Ie+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Z=K.slice(2,pe+be.index+Ie-1);return{type:"strong",raw:K.slice(0,pe+be.index+Ie+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},se.codespan=function(K){var te=this.rules.inline.code.exec(K);if(te){var ge=te[2].replace(/\n/g," "),be=/[^ ]/.test(ge),Re=/^ /.test(ge)&&/ $/.test(ge);return be&&Re&&(ge=ge.substring(1,ge.length-1)),ge=p(ge,!0),{type:"codespan",raw:te[0],text:ge}}},se.br=function(K){var te=this.rules.inline.br.exec(K);if(te)return{type:"br",raw:te[0]}},se.del=function(K){var te=this.rules.inline.del.exec(K);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},se.autolink=function(K,te){var ge=this.rules.inline.autolink.exec(K);if(ge){var be,Re;return ge[2]==="@"?(be=p(this.options.mangle?te(ge[1]):ge[1]),Re="mailto:"+be):(be=p(ge[1]),Re=be),{type:"link",raw:ge[0],text:be,href:Re,tokens:[{type:"text",raw:be,text:be}]}}},se.url=function(K,te){var ge;if(ge=this.rules.inline.url.exec(K)){var be,Re;if(ge[2]==="@")be=p(this.options.mangle?te(ge[0]):ge[0]),Re="mailto:"+be;else{var pe;do pe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(pe!==ge[0]);be=p(ge[0]),ge[1]==="www."?Re="http://"+be:Re=be}return{type:"link",raw:ge[0],text:be,href:Re,tokens:[{type:"text",raw:be,text:be}]}}},se.inlineText=function(K,te){var ge=this.rules.inline.text.exec(K);if(ge){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):p(ge[0]):ge[0]:be=p(this.options.smartypants?te(ge[0]):ge[0]),{type:"text",raw:ge[0],text:be}}},re}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=n(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=n(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=n(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=n(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=n(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=f({},T),T.gfm=f({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=n(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=f({},T.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=n(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=n(T._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=n(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=n(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=n(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=n(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=n(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=n(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=n(M.reflink).replace("label",M._label).replace("ref",T._label).getRegex(),M.nolink=n(M.nolink).replace("ref",T._label).getRegex(),M.reflinkSearch=n(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=f({},M),M.pedantic=f({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=f({},M.normal,{escape:n(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=n(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=f({},M.gfm,{br:n(M.br).replace("{2,}","*").getRegex(),text:n(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function O(re){var se="",oe,K,te=re.length;for(oe=0;oe<te;oe++)K=re.charCodeAt(oe),Math.random()>.5&&(K="x"+K.toString(16)),se+="&#"+K+";";return se}var q=function(){function re(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||ie.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:T.normal,inline:M.normal};this.options.pedantic?(K.block=T.pedantic,K.inline=M.pedantic):this.options.gfm&&(K.block=T.gfm,this.options.breaks?K.inline=M.breaks:K.inline=M.gfm),this.tokenizer.rules=K}re.lex=function(K,te){var ge=new re(te);return ge.lex(K)},re.lexInline=function(K,te){var ge=new re(te);return ge.inlineTokens(K)};var se=re.prototype;return se.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},se.blockTokens=function(K,te){var ge=this;te===void 0&&(te=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(je,W,Q){return W+"    ".repeat(Q.length)});for(var be,Re,pe,Pe;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(be=je.call({lexer:ge},K,te))?(K=K.substring(be.raw.length),te.push(be),!0):!1}))){if(be=this.tokenizer.space(K)){K=K.substring(be.raw.length),be.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(be);continue}if(be=this.tokenizer.code(K)){K=K.substring(be.raw.length),Re=te[te.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(be);continue}if(be=this.tokenizer.fences(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.heading(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.hr(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.blockquote(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.list(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.html(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.def(K)){K=K.substring(be.raw.length),Re=te[te.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.lheading(K)){K=K.substring(be.raw.length),te.push(be);continue}if(pe=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,W=K.slice(1),Q=void 0;ge.options.extensions.startBlock.forEach(function(X){Q=X.call({lexer:this},W),typeof Q=="number"&&Q>=0&&(je=Math.min(je,Q))}),je<1/0&&je>=0&&(pe=K.substring(0,je+1))}(),this.state.top&&(be=this.tokenizer.paragraph(pe))){Re=te[te.length-1],Pe&&Re.type==="paragraph"?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(be),Pe=pe.length!==K.length,K=K.substring(be.raw.length);continue}if(be=this.tokenizer.text(K)){K=K.substring(be.raw.length),Re=te[te.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(be);continue}if(K){var Ie="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,te},se.inline=function(K,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:K,tokens:te}),te},se.inlineTokens=function(K,te){var ge=this;te===void 0&&(te=[]);var be,Re,pe,Pe=K,Ie,je,W;if(this.tokens.links){var Q=Object.keys(this.tokens.links);if(Q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)Q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ie.index)+"["+C("a",Ie[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ie.index)+"["+C("a",Ie[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ie.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(je||(W=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(be=Z.call({lexer:ge},K,te))?(K=K.substring(be.raw.length),te.push(be),!0):!1}))){if(be=this.tokenizer.escape(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.tag(K)){K=K.substring(be.raw.length),Re=te[te.length-1],Re&&be.type==="text"&&Re.type==="text"?(Re.raw+=be.raw,Re.text+=be.text):te.push(be);continue}if(be=this.tokenizer.link(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(be.raw.length),Re=te[te.length-1],Re&&be.type==="text"&&Re.type==="text"?(Re.raw+=be.raw,Re.text+=be.text):te.push(be);continue}if(be=this.tokenizer.emStrong(K,Pe,W)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.codespan(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.br(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.del(K)){K=K.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.autolink(K,O)){K=K.substring(be.raw.length),te.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(K,O))){K=K.substring(be.raw.length),te.push(be);continue}if(pe=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,he=K.slice(1),we=void 0;ge.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},he),typeof we=="number"&&we>=0&&(Z=Math.min(Z,we))}),Z<1/0&&Z>=0&&(pe=K.substring(0,Z+1))}(),be=this.tokenizer.inlineText(pe,F)){K=K.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(W=be.raw.slice(-1)),je=!0,Re=te[te.length-1],Re&&Re.type==="text"?(Re.raw+=be.raw,Re.text+=be.text):te.push(be);continue}if(K){var X="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return te},a(re,null,[{key:"rules",get:function(){return{block:T,inline:M}}}]),re}(),Y=function(){function re(oe){this.options=oe||ie.defaults}var se=re.prototype;return se.code=function(K,te,ge){var be=(te||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(K,be);Re!=null&&Re!==K&&(ge=!0,K=Re)}return K=K.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+p(be,!0)+'">'+(ge?K:p(K,!0))+`</code></pre>
`:"<pre><code>"+(ge?K:p(K,!0))+`</code></pre>
`},se.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},se.html=function(K){return K},se.heading=function(K,te,ge,be){if(this.options.headerIds){var Re=this.options.headerPrefix+be.slug(ge);return"<h"+te+' id="'+Re+'">'+K+"</h"+te+`>
`}return"<h"+te+">"+K+"</h"+te+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(K,te,ge){var be=te?"ol":"ul",Re=te&&ge!==1?' start="'+ge+'"':"";return"<"+be+Re+`>
`+K+"</"+be+`>
`},se.listitem=function(K){return"<li>"+K+`</li>
`},se.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(K){return"<p>"+K+`</p>
`},se.table=function(K,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+te+`</table>
`},se.tablerow=function(K){return`<tr>
`+K+`</tr>
`},se.tablecell=function(K,te){var ge=te.header?"th":"td",be=te.align?"<"+ge+' align="'+te.align+'">':"<"+ge+">";return be+K+("</"+ge+`>
`)},se.strong=function(K){return"<strong>"+K+"</strong>"},se.em=function(K){return"<em>"+K+"</em>"},se.codespan=function(K){return"<code>"+K+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(K){return"<del>"+K+"</del>"},se.link=function(K,te,ge){if(K=o(this.options.sanitize,this.options.baseUrl,K),K===null)return ge;var be='<a href="'+p(K)+'"';return te&&(be+=' title="'+te+'"'),be+=">"+ge+"</a>",be},se.image=function(K,te,ge){if(K=o(this.options.sanitize,this.options.baseUrl,K),K===null)return ge;var be='<img src="'+K+'" alt="'+ge+'"';return te&&(be+=' title="'+te+'"'),be+=this.options.xhtml?"/>":">",be},se.text=function(K){return K},re}(),V=function(){function re(){}var se=re.prototype;return se.strong=function(K){return K},se.em=function(K){return K},se.codespan=function(K){return K},se.del=function(K){return K},se.html=function(K){return K},se.text=function(K){return K},se.link=function(K,te,ge){return""+ge},se.image=function(K,te,ge){return""+ge},se.br=function(){return""},re}(),J=function(){function re(){this.seen={}}var se=re.prototype;return se.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(K,te){var ge=K,be=0;if(this.seen.hasOwnProperty(ge)){be=this.seen[K];do be++,ge=K+"-"+be;while(this.seen.hasOwnProperty(ge))}return te||(this.seen[K]=be,this.seen[ge]=0),ge},se.slug=function(K,te){te===void 0&&(te={});var ge=this.serialize(K);return this.getNextSafeSlug(ge,te.dryrun)},re}(),x=function(){function re(oe){this.options=oe||ie.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new J}re.parse=function(K,te){var ge=new re(te);return ge.parse(K)},re.parseInline=function(K,te){var ge=new re(te);return ge.parseInline(K)};var se=re.prototype;return se.parse=function(K,te){te===void 0&&(te=!0);var ge="",be,Re,pe,Pe,Ie,je,W,Q,X,Z,he,we,Te,He,Xe,et,rt,at,ot,ct=K.length;for(be=0;be<ct;be++){if(Z=K[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(ot=this.options.extensions.renderers[Z.type].call({parser:this},Z),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){ge+=ot||"";continue}switch(Z.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,g(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(Q="",W="",Pe=Z.header.length,Re=0;Re<Pe;Re++)W+=this.renderer.tablecell(this.parseInline(Z.header[Re].tokens),{header:!0,align:Z.align[Re]});for(Q+=this.renderer.tablerow(W),X="",Pe=Z.rows.length,Re=0;Re<Pe;Re++){for(je=Z.rows[Re],W="",Ie=je.length,pe=0;pe<Ie;pe++)W+=this.renderer.tablecell(this.parseInline(je[pe].tokens),{header:!1,align:Z.align[pe]});X+=this.renderer.tablerow(W)}ge+=this.renderer.table(Q,X);continue}case"blockquote":{X=this.parse(Z.tokens),ge+=this.renderer.blockquote(X);continue}case"list":{for(he=Z.ordered,we=Z.start,Te=Z.loose,Pe=Z.items.length,X="",Re=0;Re<Pe;Re++)Xe=Z.items[Re],et=Xe.checked,rt=Xe.task,He="",Xe.task&&(at=this.renderer.checkbox(et),Te?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=at+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=at+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(Xe.tokens,Te),X+=this.renderer.listitem(He,rt,et);ge+=this.renderer.list(X,he,we);continue}case"html":{ge+=this.renderer.html(Z.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(X=Z.tokens?this.parseInline(Z.tokens):Z.text;be+1<ct&&K[be+1].type==="text";)Z=K[++be],X+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);ge+=te?this.renderer.paragraph(X):X;continue}default:{var Ne='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return ge},se.parseInline=function(K,te){te=te||this.renderer;var ge="",be,Re,pe,Pe=K.length;for(be=0;be<Pe;be++){if(Re=K[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(pe=this.options.extensions.renderers[Re.type].call({parser:this},Re),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){ge+=pe||"";continue}switch(Re.type){case"escape":{ge+=te.text(Re.text);break}case"html":{ge+=te.html(Re.text);break}case"link":{ge+=te.link(Re.href,Re.title,this.parseInline(Re.tokens,te));break}case"image":{ge+=te.image(Re.href,Re.title,Re.text);break}case"strong":{ge+=te.strong(this.parseInline(Re.tokens,te));break}case"em":{ge+=te.em(this.parseInline(Re.tokens,te));break}case"codespan":{ge+=te.codespan(Re.text);break}case"br":{ge+=te.br();break}case"del":{ge+=te.del(this.parseInline(Re.tokens,te));break}case"text":{ge+=te.text(Re.text);break}default:{var Ie='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return ge},re}();function ne(re,se,oe){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof se=="function"&&(oe=se,se=null),se=f({},ne.defaults,se||{}),S(se),oe){var K=se.highlight,te;try{te=q.lex(re,se)}catch(Pe){return oe(Pe)}var ge=function(Ie){var je;if(!Ie)try{se.walkTokens&&ne.walkTokens(te,se.walkTokens),je=x.parse(te,se)}catch(W){Ie=W}return se.highlight=K,Ie?oe(Ie):oe(null,je)};if(!K||K.length<3||(delete se.highlight,!te.length))return ge();var be=0;ne.walkTokens(te,function(Pe){Pe.type==="code"&&(be++,setTimeout(function(){K(Pe.text,Pe.lang,function(Ie,je){if(Ie)return ge(Ie);je!=null&&je!==Pe.text&&(Pe.text=je,Pe.escaped=!0),be--,be===0&&ge()})},0))}),be===0&&ge();return}function Re(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+p(Pe.message+"",!0)+"</pre>";throw Pe}try{var pe=q.lex(re,se);if(se.walkTokens){if(se.async)return Promise.all(ne.walkTokens(pe,se.walkTokens)).then(function(){return x.parse(pe,se)}).catch(Re);ne.walkTokens(pe,se.walkTokens)}return x.parse(pe,se)}catch(Pe){Re(Pe)}}ne.options=ne.setOptions=function(re){return f(ne.defaults,re),$(ne.defaults),ne},ne.getDefaults=L,ne.defaults=ie.defaults,ne.use=function(){for(var re=arguments.length,se=new Array(re),oe=0;oe<re;oe++)se[oe]=arguments[oe];var K=f.apply(void 0,[{}].concat(se)),te=ne.defaults.extensions||{renderers:{},childTokens:{}},ge;se.forEach(function(be){if(be.extensions&&(ge=!0,be.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Pe=te.renderers?te.renderers[pe.name]:null;Pe?te.renderers[pe.name]=function(){for(var Ie=arguments.length,je=new Array(Ie),W=0;W<Ie;W++)je[W]=arguments[W];var Q=pe.renderer.apply(this,je);return Q===!1&&(Q=Pe.apply(this,je)),Q}:te.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[pe.level]?te[pe.level].unshift(pe.tokenizer):te[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?te.startBlock?te.startBlock.push(pe.start):te.startBlock=[pe.start]:pe.level==="inline"&&(te.startInline?te.startInline.push(pe.start):te.startInline=[pe.start]))}pe.childTokens&&(te.childTokens[pe.name]=pe.childTokens)})),be.renderer&&function(){var pe=ne.defaults.renderer||new Y,Pe=function(W){var Q=pe[W];pe[W]=function(){for(var X=arguments.length,Z=new Array(X),he=0;he<X;he++)Z[he]=arguments[he];var we=be.renderer[W].apply(pe,Z);return we===!1&&(we=Q.apply(pe,Z)),we}};for(var Ie in be.renderer)Pe(Ie);K.renderer=pe}(),be.tokenizer&&function(){var pe=ne.defaults.tokenizer||new z,Pe=function(W){var Q=pe[W];pe[W]=function(){for(var X=arguments.length,Z=new Array(X),he=0;he<X;he++)Z[he]=arguments[he];var we=be.tokenizer[W].apply(pe,Z);return we===!1&&(we=Q.apply(pe,Z)),we}};for(var Ie in be.tokenizer)Pe(Ie);K.tokenizer=pe}(),be.walkTokens){var Re=ne.defaults.walkTokens;K.walkTokens=function(pe){var Pe=[];return Pe.push(be.walkTokens.call(this,pe)),Re&&(Pe=Pe.concat(Re.call(this,pe))),Pe}}ge&&(K.extensions=te),ne.setOptions(K)})},ne.walkTokens=function(re,se){for(var oe=[],K=function(){var Re=ge.value;switch(oe=oe.concat(se.call(ne,Re)),Re.type){case"table":{for(var pe=R(Re.header),Pe;!(Pe=pe()).done;){var Ie=Pe.value;oe=oe.concat(ne.walkTokens(Ie.tokens,se))}for(var je=R(Re.rows),W;!(W=je()).done;)for(var Q=W.value,X=R(Q),Z;!(Z=X()).done;){var he=Z.value;oe=oe.concat(ne.walkTokens(he.tokens,se))}break}case"list":{oe=oe.concat(ne.walkTokens(Re.items,se));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Re.type]?ne.defaults.extensions.childTokens[Re.type].forEach(function(we){oe=oe.concat(ne.walkTokens(Re[we],se))}):Re.tokens&&(oe=oe.concat(ne.walkTokens(Re.tokens,se)))}},te=R(re),ge;!(ge=te()).done;)K();return oe},ne.parseInline=function(re,se){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");se=f({},ne.defaults,se||{}),S(se);try{var oe=q.lexInline(re,se);return se.walkTokens&&ne.walkTokens(oe,se.walkTokens),x.parseInline(oe,se)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+p(K.message+"",!0)+"</pre>";throw K}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=Y,ne.TextRenderer=V,ne.Lexer=q,ne.lexer=q.lex,ne.Tokenizer=z,ne.Slugger=J,ne.parse=ne;var de=ne.options,ce=ne.setOptions,ve=ne.use,_=ne.walkTokens,U=ne.parseInline,le=ne,De=x.parse,$e=q.lex;ie.Lexer=q,ie.Parser=x,ie.Renderer=Y,ie.Slugger=J,ie.TextRenderer=V,ie.Tokenizer=z,ie.getDefaults=L,ie.lexer=$e,ie.marked=ne,ie.options=de,ie.parse=le,ie.parseInline=U,ie.parser=De,ie.setOptions=ce,ie.use=ve,ie.walkTokens=_,Object.defineProperty(ie,"__esModule",{value:!0})}),define(ke[169],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=a;function a(h){const g=R(h);if(g&&g.length>0)return new Uint32Array(g)}let N=0;const A=new Uint32Array(10);function R(h){if(N=0,L(h,P,4352),N>0||(L(h,b,4449),N>0)||(L(h,k,4520),N>0)||(L(h,p,12593),N))return A.subarray(0,N);if(h>=44032&&h<=55203){const g=h-44032,u=g%588,n=Math.floor(g/588),i=Math.floor(u/28),d=u%28-1;if(n<P.length?L(n,P,0):4352+n-12593<p.length&&L(4352+n,p,12593),i<b.length?L(i,b,0):4449+i-12593<p.length&&L(4449+i-12593,p,12593),d>=0&&(d<k.length?L(d,k,0):4520+d-12593<p.length&&L(4520+d-12593,p,12593)),N>0)return A.subarray(0,N)}}function L(h,g,u){h>=u&&h<u+g.length&&$(g[h-u])}function $(h){h!==0&&(A[N++]=h&255,h>>8&&(A[N++]=h>>8&255),h>>16&&(A[N++]=h>>16&255))}var m;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(E||(E={}));var I;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(I||(I={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),k=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],Se([1,0,27]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=void 0,e.$cm=A,e.$dm=L;const N=new a.$Ec(1e4);function A(E){return m(E,"NFC",N)}const R=new a.$Ec(1e4);function L(E){return m(E,"NFD",R)}const $=/[^\u0000-\u0080]/;function m(E,I,P){if(!E)return E;const b=P.get(E);if(b)return b;let k;return $.test(E)?k=E.normalize(I):k=E,P.set(E,k),k}e.$em=function(){const E=/[\u0300-\u036f]/g;return function(I){return L(I).replace(E,"")}}()}),define(ke[127],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0,e.$Cm=a,e.rot=N;function a($,m,E){return Math.min(Math.max($,m),E)}function N($,m){return(m+$%m)%m}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Em=A;class R{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Fm=R;class L{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Gm=L}),define(ke[170],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=b;class a{constructor(p,h,g){this.owner=p,this.debugNameSource=h,this.referenceFn=g}getDebugName(p){return R(p,this)}}e.$bd=a;const N=new Map,A=new WeakMap;function R(k,p){const h=A.get(k);if(h)return h;const g=L(k,p);if(g){let u=N.get(g)??0;u++,N.set(g,u);const n=u===1?g:`${g}#${u}`;return A.set(k,n),n}}function L(k,p){const h=A.get(k);if(h)return h;const g=p.owner?I(p.owner)+".":"";let u;const n=p.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(u=n(),u!==void 0)return g+u}else return g+n;const i=p.referenceFn;if(i!==void 0&&(u=b(i),u!==void 0))return g+u;if(p.owner!==void 0){const d=$(p.owner,k);if(d!==void 0)return g+d}}function $(k,p){for(const h in k)if(k[h]===p)return h}const m=new Map,E=new WeakMap;function I(k){const p=E.get(k);if(p)return p;const h=P(k);let g=m.get(h)??0;g++,m.set(h,g);const u=g===1?h:`${h}#${g}`;return E.set(k,u),u}function P(k){const p=k.constructor;return p?p.name:"Object"}function b(k){const p=k.toString(),g=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(p);return(g?g[1]:void 0)?.trim()}}),define(ke[171],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=N,e.$Jd=A;let a;function N(h){a=h}function A(){return a}class R{constructor(){this.a=0,this.d=new WeakMap}b(g){return L([$(k("|  ",this.a)),g])}c(g){return g.hadValue?g.didChange?[$(" "),E(I(g.oldValue,70),{color:"red",strikeThrough:!0}),$(" "),E(I(g.newValue,60),{color:"green"})]:[$(" (unchanged)")]:[$(" "),E(I(g.newValue,60),{color:"green"}),$(" (initial)")]}handleObservableChanged(g,u){console.log(...this.b([m("observable value changed"),E(g.debugName,{color:"BlueViolet"}),...this.c(u)]))}formatChanges(g){if(g.size!==0)return E(" (changed deps: "+[...g].map(u=>u.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(g){const u=g.handleChange;this.d.set(g,new Set),g.handleChange=(n,i)=>(this.d.get(g).add(n),u.apply(g,[n,i]))}handleDerivedRecomputed(g,u){const n=this.d.get(g);console.log(...this.b([m("derived recomputed"),E(g.debugName,{color:"BlueViolet"}),...this.c(u),this.formatChanges(n),{data:[{fn:g._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(g,u){console.log(...this.b([m("observable from event triggered"),E(g.debugName,{color:"BlueViolet"}),...this.c(u),{data:[{fn:g._getValue}]}]))}handleAutorunCreated(g){const u=g.handleChange;this.d.set(g,new Set),g.handleChange=(n,i)=>(this.d.get(g).add(n),u.apply(g,[n,i]))}handleAutorunTriggered(g){const u=this.d.get(g);console.log(...this.b([m("autorun"),E(g.debugName,{color:"BlueViolet"}),this.formatChanges(u),{data:[{fn:g._runFn}]}])),u.clear(),this.a++}handleAutorunFinished(g){this.a--}handleBeginTransaction(g){let u=g.getDebugName();u===void 0&&(u=""),console.log(...this.b([m("transaction"),E(u,{color:"BlueViolet"}),{data:[{fn:g._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=R;function L(h){const g=new Array,u=[];let n="";function i(o){if("length"in o)for(const t of o)t&&i(t);else"text"in o?(n+=`%c${o.text}`,g.push(o.style),o.data&&u.push(...o.data)):"data"in o&&u.push(...o.data)}i(h);const d=[n,...g];return d.push(...u),d}function $(h){return E(h,{color:"black"})}function m(h){return E(p(`${h}: `,10),{color:"black",bold:!0})}function E(h,g={color:"black"}){function u(i){return Object.entries(i).reduce((d,[o,t])=>`${d}${o}:${t};`,"")}const n={color:g.color};return g.strikeThrough&&(n["text-decoration"]="line-through"),g.bold&&(n["font-weight"]="bold"),{text:h,style:u(n)}}function I(h,g){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=g?`"${h}"`:`"${h.substr(0,g-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?P(h,g):b(h,g);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function P(h,g){let u="[ ",n=!0;for(const i of h){if(n||(u+=", "),u.length-5>g){u+="...";break}n=!1,u+=`${I(i,g-u.length)}`}return u+=" ]",u}function b(h,g){let u="{ ",n=!0;for(const[i,d]of Object.entries(h)){if(n||(u+=", "),u.length-5>g){u+="...";break}n=!1,u+=`${i}: ${I(d,g-u.length)}`}return u+=" }",u}function k(h,g){let u="";for(let n=1;n<=g;n++)u+=h;return u}function p(h,g){for(;h.length<g;)h+=" ";return h}}),define(ke[172],Se([1,0,166,170,171]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=L,e.$Sd=m,e.$Td=I,e.$Wd=k,e.$Xd=h,e.$Yd=g,e.$Zd=u,e.$2d=i,e.$3d=d,e.$5d=t;let R;function L(r){R=r}let $;function m(r){$=r}let E;function I(r){E=r}class P{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,s){const v=s===void 0?void 0:c,f=s===void 0?c:s;return E({owner:v,debugName:()=>{const y=(0,N.$dd)(f);if(y!==void 0)return y;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());if(D)return`${this.debugName}.${D[2]}`;if(!v)return`${this.debugName} (mapped)`},debugReferenceFn:f},y=>f(this.read(y),y))}recomputeInitiallyAndOnChange(c,s){return c.add(R(this,s)),this}keepObserved(c){return c.add($(this)),this}get a(){return this.get()}}e.$Ud=P;class b extends P{constructor(){super(...arguments),this.b=new Set}addObserver(c){const s=this.b.size;this.b.add(c),s===0&&this.c()}removeObserver(c){this.b.delete(c)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=b;function k(r,c){const s=new n(r,c);try{r(s)}finally{s.finish()}}let p;function h(r){if(p)r(p);else{const c=new n(r,void 0);p=c;try{r(c)}finally{c.finish(),p=void 0}}}async function g(r,c){const s=new n(r,c);try{await r(s)}finally{s.finish()}}function u(r,c,s){r?c(r):k(c,s)}class n{constructor(c,s){this._fn=c,this.b=s,this.a=[],(0,A.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,N.$dd)(this._fn)}updateObserver(c,s){this.a.push({observer:c,observable:s}),c.beginUpdate(s)}finish(){const c=this.a;for(let s=0;s<c.length;s++){const{observer:v,observable:f}=c[s];v.endUpdate(f)}this.a=null,(0,A.$Jd)()?.handleEndTransaction()}}e.$1d=n;function i(r,c){let s;return typeof r=="string"?s=new N.$bd(void 0,r,void 0):s=new N.$bd(r,void 0,void 0),new o(s,c,a.$7c)}function d(r,c){return new o(new N.$bd(r.owner,r.debugName,void 0),c,r.equalsFn??a.$7c)}class o extends b{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(c,s,v){super(),this.e=c,this.g=v,this.d=s}get(){return this.d}set(c,s,v){if(this.g(this.d,c))return;let f;s||(s=f=new n(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(c),(0,A.$Jd)()?.handleObservableChanged(this,{oldValue:y,newValue:c,change:v,didChange:!0,hadValue:!0});for(const w of this.b)s.updateObserver(w,this),w.handleChange(this,v)}finally{f&&f.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(c){this.d=c}}e.$4d=o;function t(r,c){let s;return typeof r=="string"?s=new N.$bd(void 0,r,void 0):s=new N.$bd(r,void 0,void 0),new l(s,c,a.$7c)}class l extends o{h(c){this.d!==c&&(this.d&&this.d.dispose(),this.d=c)}dispose(){this.d?.dispose()}}e.$6d=l}),function(){function ie(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function L(m){R.push(m,Date.now())}function $(){const m=[];for(let E=0;E<R.length;E+=2)m.push({name:R[E],startTime:R[E+1]});return m}return{mark:L,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(A+L.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=a(N))}(),define(ke[12],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=f,e.$D=y,e.$a="en";let a=!1,N=!1,A=!1,R=!1,L=!1,$=!1,m=!1,E=!1,I=!1,P=!1,b,k=e.$a,p=e.$a,h,g;const u=globalThis;let n;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?n=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const i=typeof n?.versions?.electron=="string",d=i&&n?.type==="renderer";if(typeof n=="object"){a=n.platform==="win32",N=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,m=i,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$a,k=e.$a;const w=n.env.VSCODE_NLS_CONFIG;if(w)try{const D=JSON.parse(w),S=D.availableLanguages["*"];b=D.locale,p=D.osLocale,k=S||e.$a,h=D._translationsConfigFile}catch{}L=!0}else if(typeof navigator=="object"&&!d){g=navigator.userAgent,a=g.indexOf("Windows")>=0,N=g.indexOf("Macintosh")>=0,E=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,P=g?.indexOf("Mobi")>=0,$=!0,b=e.$a,k=b,p=navigator.language;const w=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),D=w&&w.getAttribute("data-settings");if(D)try{const S=JSON.parse(D),C=S.availableLanguages["*"];b=S.locale,p=S.osLocale,k=C||e.$a,h=S._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var o;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(o||(e.Platform=o={}));function t(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let l=0;N?l=1:a?l=3:A&&(l=2),e.$c=a,e.$d=N,e.$e=A,e.$f=R,e.$g=L,e.$h=m,e.$i=$,e.$j=$&&typeof u.importScripts=="function",e.$k=e.$j?u.origin:void 0,e.$l=E,e.$m=P,e.$n=I,e.$o=l,e.$p=g,e.$q=k;var r;(function(w){function D(){return e.$q}w.value=D;function S(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}w.isDefaultVariant=S;function C(){return e.$q==="en"}w.isDefault=C})(r||(e.Language=r={})),e.$r=b,e.$s=p,e.$t=h,e.$u=typeof u.postMessage=="function"&&!u.importScripts,e.$v=(()=>{if(e.$u){const w=[];u.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let C=0,j=w.length;C<j;C++){const B=w[C];if(B.id===S.data.vscodeScheduleAsyncWork){w.splice(C,1),B.callback();return}}});let D=0;return S=>{const C=++D;w.push({id:C,callback:S}),u.postMessage({vscodeScheduleAsyncWork:C},"*")}}return w=>setTimeout(w)})();var c;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=N||E?2:a?1:3;let s=!0,v=!1;function f(){if(!v){v=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,s=new Uint16Array(w.buffer)[0]===513}return s}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function y(w){return parseFloat(w)>=20}}),define(ke[173],Se([1,0,40]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=void 0;const N=Symbol("unset");class A{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||a.Iterable.empty()}insert(m,E,I){this.d(m,P=>P._value=E,I)}mutate(m,E){this.d(m,I=>I._value=E(I._value===N?void 0:I._value))}delete(m){const E=this.c(m);if(!E)return;let I=E.length-1;const P=E[I].node._value;if(P!==N){for(this.b--,E[I].node._value=N;I>0;I--){const{node:b,part:k}=E[I];if(b.children?.size||b._value!==N)break;E[I-1].node.children.delete(k)}return P}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const I=E[E.length-1].node;for(let P=E.length-1;P>0;P--){const b=E[P-1];if(b.node.children.delete(E[P].part),b.node.children.size>0||b.node._value!==N)break}for(const P of R(I))P._value!==N&&(this.b--,yield P._value)}find(m){let E=this.a;for(const I of m){const P=E.children?.get(I);if(!P)return;E=P}return E._value===N?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const I of m){const P=E.children?.get(I);if(!P)return!1;if(P._value!==N)return!0;E=P}return!1}hasKeyOrChildren(m){let E=this.a;for(const I of m){const P=E.children?.get(I);if(!P)return!1;E=P}return!0}hasKey(m){let E=this.a;for(const I of m){const P=E.children?.get(I);if(!P)return!1;E=P}return E._value!==N}c(m){const E=[{part:"",node:this.a}];let I=0;for(const P of m){const b=E[I].node.children?.get(P);if(!b)return;E.push({part:P,node:b}),I++}return E}d(m,E,I){let P=this.a;for(const p of m){if(P.children)if(P.children.has(p))P=P.children.get(p);else{const h=new L;P.children.set(p,h),P=h}else{const h=new L;P.children=new Map([[p,h]]),P=h}I?.(P)}const b=P._value===N?0:1;E(P);const k=P._value===N?0:1;this.b+=k-b}*values(){for(const{_value:m}of R(this.a))m!==N&&(yield m)}}e.$mP=A;function*R($){const m=[$];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const I of E.children.values())m.push(I)}}class L{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(m){this._value=m===void 0?N:m}}}),define(ke[50],Se([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return a.$c?"win32":a.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Se([1,0,50]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,A=97,R=90,L=122,$=46,m=47,E=92,I=58,P=63;class b extends Error{constructor(l,r,c){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const v=l.indexOf(".")!==-1?"property":"argument";let f=`The "${l}" ${v} ${s} of type ${r}`;f+=`. Received type ${typeof c}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,l){if(t===null||typeof t!="object")throw new b(l,"Object",t)}function p(t,l){if(typeof t!="string")throw new b(l,"string",t)}const h=a.$ec==="win32";function g(t){return t===m||t===E}function u(t){return t===m}function n(t){return t>=N&&t<=R||t>=A&&t<=L}function i(t,l,r,c){let s="",v=0,f=-1,y=0,w=0;for(let D=0;D<=t.length;++D){if(D<t.length)w=t.charCodeAt(D);else{if(c(w))break;w=m}if(c(w)){if(!(f===D-1||y===1))if(y===2){if(s.length<2||v!==2||s.charCodeAt(s.length-1)!==$||s.charCodeAt(s.length-2)!==$){if(s.length>2){const S=s.lastIndexOf(r);S===-1?(s="",v=0):(s=s.slice(0,S),v=s.length-1-s.lastIndexOf(r)),f=D,y=0;continue}else if(s.length!==0){s="",v=0,f=D,y=0;continue}}l&&(s+=s.length>0?`${r}..`:"..",v=2)}else s.length>0?s+=`${r}${t.slice(f+1,D)}`:s=t.slice(f+1,D),v=D-f-1;f=D,y=0}else w===$&&y!==-1?++y:y=-1}return s}function d(t,l){k(l,"pathObject");const r=l.dir||l.root,c=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${c}`:`${r}${t}${c}`:c}e.$gc={resolve(...t){let l="",r="",c=!1;for(let s=t.length-1;s>=-1;s--){let v;if(s>=0){if(v=t[s],p(v,"path"),v.length===0)continue}else l.length===0?v=a.cwd():(v=a.env[`=${l}`]||a.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==l.toLowerCase()&&v.charCodeAt(2)===E)&&(v=`${l}\\`));const f=v.length;let y=0,w="",D=!1;const S=v.charCodeAt(0);if(f===1)g(S)&&(y=1,D=!0);else if(g(S))if(D=!0,g(v.charCodeAt(1))){let C=2,j=C;for(;C<f&&!g(v.charCodeAt(C));)C++;if(C<f&&C!==j){const B=v.slice(j,C);for(j=C;C<f&&g(v.charCodeAt(C));)C++;if(C<f&&C!==j){for(j=C;C<f&&!g(v.charCodeAt(C));)C++;(C===f||C!==j)&&(w=`\\\\${B}\\${v.slice(j,C)}`,y=C)}}}else y=1;else n(S)&&v.charCodeAt(1)===I&&(w=v.slice(0,2),y=2,f>2&&g(v.charCodeAt(2))&&(D=!0,y=3));if(w.length>0)if(l.length>0){if(w.toLowerCase()!==l.toLowerCase())continue}else l=w;if(c){if(l.length>0)break}else if(r=`${v.slice(y)}\\${r}`,c=D,D&&l.length>0)break}return r=i(r,!c,"\\",g),c?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){p(t,"path");const l=t.length;if(l===0)return".";let r=0,c,s=!1;const v=t.charCodeAt(0);if(l===1)return u(v)?"\\":t;if(g(v))if(s=!0,g(t.charCodeAt(1))){let y=2,w=y;for(;y<l&&!g(t.charCodeAt(y));)y++;if(y<l&&y!==w){const D=t.slice(w,y);for(w=y;y<l&&g(t.charCodeAt(y));)y++;if(y<l&&y!==w){for(w=y;y<l&&!g(t.charCodeAt(y));)y++;if(y===l)return`\\\\${D}\\${t.slice(w)}\\`;y!==w&&(c=`\\\\${D}\\${t.slice(w,y)}`,r=y)}}}else r=1;else n(v)&&t.charCodeAt(1)===I&&(c=t.slice(0,2),r=2,l>2&&g(t.charCodeAt(2))&&(s=!0,r=3));let f=r<l?i(t.slice(r),!s,"\\",g):"";return f.length===0&&!s&&(f="."),f.length>0&&g(t.charCodeAt(l-1))&&(f+="\\"),c===void 0?s?`\\${f}`:f:s?`${c}\\${f}`:`${c}${f}`},isAbsolute(t){p(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return g(r)||l>2&&n(r)&&t.charCodeAt(1)===I&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let v=0;v<t.length;++v){const f=t[v];p(f,"path"),f.length>0&&(l===void 0?l=r=f:l+=`\\${f}`)}if(l===void 0)return".";let c=!0,s=0;if(typeof r=="string"&&g(r.charCodeAt(0))){++s;const v=r.length;v>1&&g(r.charCodeAt(1))&&(++s,v>2&&(g(r.charCodeAt(2))?++s:c=!1))}if(c){for(;s<l.length&&g(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.$gc.normalize(l)},relative(t,l){if(p(t,"from"),p(l,"to"),t===l)return"";const r=e.$gc.resolve(t),c=e.$gc.resolve(l);if(r===c||(t=r.toLowerCase(),l=c.toLowerCase(),t===l))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===E;)s++;let v=t.length;for(;v-1>s&&t.charCodeAt(v-1)===E;)v--;const f=v-s;let y=0;for(;y<l.length&&l.charCodeAt(y)===E;)y++;let w=l.length;for(;w-1>y&&l.charCodeAt(w-1)===E;)w--;const D=w-y,S=f<D?f:D;let C=-1,j=0;for(;j<S;j++){const z=t.charCodeAt(s+j);if(z!==l.charCodeAt(y+j))break;z===E&&(C=j)}if(j!==S){if(C===-1)return c}else{if(D>S){if(l.charCodeAt(y+j)===E)return c.slice(y+j+1);if(j===2)return c.slice(y+j)}f>S&&(t.charCodeAt(s+j)===E?C=j:j===2&&(C=3)),C===-1&&(C=0)}let B="";for(j=s+C+1;j<=v;++j)(j===v||t.charCodeAt(j)===E)&&(B+=B.length===0?"..":"\\..");return y+=C,B.length>0?`${B}${c.slice(y,w)}`:(c.charCodeAt(y)===E&&++y,c.slice(y,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$gc.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const r=l.charCodeAt(2);if(r!==P&&r!==$)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(n(l.charCodeAt(0))&&l.charCodeAt(1)===I&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return t},dirname(t){p(t,"path");const l=t.length;if(l===0)return".";let r=-1,c=0;const s=t.charCodeAt(0);if(l===1)return g(s)?t:".";if(g(s)){if(r=c=1,g(t.charCodeAt(1))){let y=2,w=y;for(;y<l&&!g(t.charCodeAt(y));)y++;if(y<l&&y!==w){for(w=y;y<l&&g(t.charCodeAt(y));)y++;if(y<l&&y!==w){for(w=y;y<l&&!g(t.charCodeAt(y));)y++;if(y===l)return t;y!==w&&(r=c=y+1)}}}}else n(s)&&t.charCodeAt(1)===I&&(r=l>2&&g(t.charCodeAt(2))?3:2,c=r);let v=-1,f=!0;for(let y=l-1;y>=c;--y)if(g(t.charCodeAt(y))){if(!f){v=y;break}}else f=!1;if(v===-1){if(r===-1)return".";v=r}return t.slice(0,v)},basename(t,l){l!==void 0&&p(l,"ext"),p(t,"path");let r=0,c=-1,s=!0,v;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let f=l.length-1,y=-1;for(v=t.length-1;v>=r;--v){const w=t.charCodeAt(v);if(g(w)){if(!s){r=v+1;break}}else y===-1&&(s=!1,y=v+1),f>=0&&(w===l.charCodeAt(f)?--f===-1&&(c=v):(f=-1,c=y))}return r===c?c=y:c===-1&&(c=t.length),t.slice(r,c)}for(v=t.length-1;v>=r;--v)if(g(t.charCodeAt(v))){if(!s){r=v+1;break}}else c===-1&&(s=!1,c=v+1);return c===-1?"":t.slice(r,c)},extname(t){p(t,"path");let l=0,r=-1,c=0,s=-1,v=!0,f=0;t.length>=2&&t.charCodeAt(1)===I&&n(t.charCodeAt(0))&&(l=c=2);for(let y=t.length-1;y>=l;--y){const w=t.charCodeAt(y);if(g(w)){if(!v){c=y+1;break}continue}s===-1&&(v=!1,s=y+1),w===$?r===-1?r=y:f!==1&&(f=1):r!==-1&&(f=-1)}return r===-1||s===-1||f===0||f===1&&r===s-1&&r===c+1?"":t.slice(r,s)},format:d.bind(null,"\\"),parse(t){p(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let c=0,s=t.charCodeAt(0);if(r===1)return g(s)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(g(s)){if(c=1,g(t.charCodeAt(1))){let C=2,j=C;for(;C<r&&!g(t.charCodeAt(C));)C++;if(C<r&&C!==j){for(j=C;C<r&&g(t.charCodeAt(C));)C++;if(C<r&&C!==j){for(j=C;C<r&&!g(t.charCodeAt(C));)C++;C===r?c=C:C!==j&&(c=C+1)}}}}else if(n(s)&&t.charCodeAt(1)===I){if(r<=2)return l.root=l.dir=t,l;if(c=2,g(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;c=3}}c>0&&(l.root=t.slice(0,c));let v=-1,f=c,y=-1,w=!0,D=t.length-1,S=0;for(;D>=c;--D){if(s=t.charCodeAt(D),g(s)){if(!w){f=D+1;break}continue}y===-1&&(w=!1,y=D+1),s===$?v===-1?v=D:S!==1&&(S=1):v!==-1&&(S=-1)}return y!==-1&&(v===-1||S===0||S===1&&v===y-1&&v===f+1?l.base=l.name=t.slice(f,y):(l.name=t.slice(f,v),l.base=t.slice(f,y),l.ext=t.slice(v,y))),f>0&&f!==c?l.dir=t.slice(0,f-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(h){const t=/\\/g;return()=>{const l=a.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>a.cwd()})();e.$hc={resolve(...t){let l="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const s=c>=0?t[c]:o();p(s,"path"),s.length!==0&&(l=`${s}/${l}`,r=s.charCodeAt(0)===m)}return l=i(l,!r,"/",u),r?`/${l}`:l.length>0?l:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===m,r=t.charCodeAt(t.length-1)===m;return t=i(t,!l,"/",u),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const c=t[r];p(c,"path"),c.length>0&&(l===void 0?l=c:l+=`/${c}`)}return l===void 0?".":e.$hc.normalize(l)},relative(t,l){if(p(t,"from"),p(l,"to"),t===l||(t=e.$hc.resolve(t),l=e.$hc.resolve(l),t===l))return"";const r=1,c=t.length,s=c-r,v=1,f=l.length-v,y=s<f?s:f;let w=-1,D=0;for(;D<y;D++){const C=t.charCodeAt(r+D);if(C!==l.charCodeAt(v+D))break;C===m&&(w=D)}if(D===y)if(f>y){if(l.charCodeAt(v+D)===m)return l.slice(v+D+1);if(D===0)return l.slice(v+D)}else s>y&&(t.charCodeAt(r+D)===m?w=D:D===0&&(w=0));let S="";for(D=r+w+1;D<=c;++D)(D===c||t.charCodeAt(D)===m)&&(S+=S.length===0?"..":"/..");return`${S}${l.slice(v+w)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===m;let r=-1,c=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===m){if(!c){r=s;break}}else c=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&p(l,"ext"),p(t,"path");let r=0,c=-1,s=!0,v;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let f=l.length-1,y=-1;for(v=t.length-1;v>=0;--v){const w=t.charCodeAt(v);if(w===m){if(!s){r=v+1;break}}else y===-1&&(s=!1,y=v+1),f>=0&&(w===l.charCodeAt(f)?--f===-1&&(c=v):(f=-1,c=y))}return r===c?c=y:c===-1&&(c=t.length),t.slice(r,c)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===m){if(!s){r=v+1;break}}else c===-1&&(s=!1,c=v+1);return c===-1?"":t.slice(r,c)},extname(t){p(t,"path");let l=-1,r=0,c=-1,s=!0,v=0;for(let f=t.length-1;f>=0;--f){const y=t.charCodeAt(f);if(y===m){if(!s){r=f+1;break}continue}c===-1&&(s=!1,c=f+1),y===$?l===-1?l=f:v!==1&&(v=1):l!==-1&&(v=-1)}return l===-1||c===-1||v===0||v===1&&l===c-1&&l===r+1?"":t.slice(l,c)},format:d.bind(null,"/"),parse(t){p(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===m;let c;r?(l.root="/",c=1):c=0;let s=-1,v=0,f=-1,y=!0,w=t.length-1,D=0;for(;w>=c;--w){const S=t.charCodeAt(w);if(S===m){if(!y){v=w+1;break}continue}f===-1&&(y=!1,f=w+1),S===$?s===-1?s=w:D!==1&&(D=1):s!==-1&&(D=-1)}if(f!==-1){const S=v===0&&r?1:v;s===-1||D===0||D===1&&s===f-1&&s===v+1?l.base=l.name=t.slice(S,f):(l.name=t.slice(S,s),l.base=t.slice(S,f),l.ext=t.slice(s,f))}return v>0?l.dir=t.slice(0,v-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=h?e.$gc.normalize:e.$hc.normalize,e.$jc=h?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=h?e.$gc.join:e.$hc.join,e.$lc=h?e.$gc.resolve:e.$hc.resolve,e.$mc=h?e.$gc.relative:e.$hc.relative,e.$nc=h?e.$gc.dirname:e.$hc.dirname,e.$oc=h?e.$gc.basename:e.$hc.basename,e.$pc=h?e.$gc.extname:e.$hc.extname,e.$qc=h?e.$gc.format:e.$hc.format,e.$rc=h?e.$gc.parse:e.$hc.parse,e.$sc=h?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=h?e.$gc.sep:e.$hc.sep,e.$uc=h?e.$gc.delimiter:e.$hc.delimiter}),define(ke[128],Se([1,0,46,17]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=$,e.$ir=m,e.$jr=E,e.$kr=I,e.$lr=P,e.$mr=b,e.$nr=k,e.$or=p,e.$pr=h,e.$qr=g,e.$rr=s,e.$sr=v,e.$tr=f;const A=new a.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),R=new a.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new a.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(y,w,D=!1){const S=y||"",C=w||"",j=A.value.collator.compare(S,C);return A.value.collatorIsNumeric&&j===0&&S!==C?S<C?-1:1:j}function m(y,w){const D=R.value.collator;return y=y||"",w=w||"",d(D,y,w)}function E(y,w){const D=R.value.collator;return y=y||"",w=w||"",r(y,w)||d(D,y,w)}function I(y,w){const D=R.value.collator;return y=y||"",w=w||"",l(y,w)||d(D,y,w)}function P(y,w){return y=y||"",w=w||"",y===w?0:y<w?-1:1}function b(y,w){const[D,S]=n(y),[C,j]=n(w);let B=A.value.collator.compare(S,j);if(B===0){if(A.value.collatorIsNumeric&&S!==j)return S<j?-1:1;if(B=A.value.collator.compare(D,C),A.value.collatorIsNumeric&&B===0&&D!==C)return D<C?-1:1}return B}function k(y,w){y=y||"",w=w||"";const D=i(y),S=i(w),C=R.value.collator,j=L.value.collator;return d(j,D,S)||d(C,y,w)}function p(y,w){y=y||"",w=w||"";const D=i(y),S=i(w),C=R.value.collator,j=L.value.collator;return d(j,D,S)||r(y,w)||d(C,y,w)}function h(y,w){y=y||"",w=w||"";const D=i(y),S=i(w),C=R.value.collator,j=L.value.collator;return d(j,D,S)||l(y,w)||d(C,y,w)}function g(y,w){y=y||"",w=w||"";const D=i(y).toLowerCase(),S=i(w).toLowerCase();return D!==S?D<S?-1:1:y!==w?y<w?-1:1:0}const u=/^(.*?)(\.([^.]*))?$/;function n(y,w=!1){const D=y?u.exec(y):[];let S=[D&&D[1]||"",D&&D[3]||""];return w&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function i(y){const w=y?u.exec(y):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function d(y,w,D){const S=y.compare(w,D);return S!==0?S:w.length!==D.length?w.length<D.length?-1:1:0}function o(y){const w=y.charAt(0);return w.toLocaleUpperCase()!==w}function t(y){const w=y.charAt(0);return w.toLocaleLowerCase()!==w}function l(y,w){return o(y)&&t(w)?-1:t(y)&&o(w)?1:0}function r(y,w){return t(y)&&o(w)?-1:o(y)&&t(w)?1:0}function c(y,w,D=!1){return D||(y=y&&y.toLowerCase(),w=w&&w.toLowerCase()),y===w?0:y<w?-1:1}function s(y,w,D=!1){const S=y.split(N.sep),C=w.split(N.sep),j=S.length-1,B=C.length-1;let z,T;for(let M=0;;M++){if(z=j===M,T=B===M,z&&T)return $(S[M],C[M],D);if(z)return-1;if(T)return 1;const F=c(S[M],C[M],D);if(F!==0)return F}}function v(y,w,D){const S=y.toLowerCase(),C=w.toLowerCase(),j=f(y,w,D);if(j)return j;const B=S.endsWith(D),z=C.endsWith(D);if(B!==z)return B?-1:1;const T=$(S,C);return T!==0?T:S.localeCompare(C)}function f(y,w,D){const S=y.toLowerCase(),C=w.toLowerCase(),j=S.startsWith(D),B=C.startsWith(D);if(j!==B)return j?-1:1;if(j&&B){if(S.length<C.length)return-1;if(S.length>C.length)return 1}return 0}}),define(ke[98],Se([1,0,17]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Ss=R,e.$Ts=L,e.$Us=$,e.$Vs=E,e.$Rs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const P=(0,a.$pc)(I),b=N[P.toLowerCase()];return b!==void 0?b:L(I)}function L(I){const P=(0,a.$pc)(I);return A[P.toLowerCase()]}function $(I){for(const P in A)if(A[P]===I)return P}const m=/^(.+)\/(.+?)(;.+)?$/;function E(I,P){const b=m.exec(I);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:P?void 0:I}}),define(ke[99],Se([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$nm=R,e.$om=L;var N;(function($){$[$.stdout=0]="stdout",$[$.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function($){$[$.Success=0]="Success",$[$.Unknown=1]="Unknown",$[$.AccessDenied=2]="AccessDenied",$[$.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R($,...m){const E=m.reduce((b,k)=>(b[k]=!0,b),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys($).filter(b=>!E[b]).forEach(b=>{for(let k=0;k<I.length;k++)if(b.search(I[k])!==-1){delete $[b];break}})}function L($){$&&(delete $.DEBUG,a.$d&&delete $.DYLD_LIBRARY_PATH,a.$e&&delete $.LD_PRELOAD)}}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var N in a)(typeof exports=="object"?exports:ie)[N]=a[N]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function a(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return ie[N].call(A.exports,A,A.exports,a),A.l=!0,A.exports}return a.m=ie,a.c=e,a.d=function(N,A,R){a.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:R})},a.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},a.t=function(N,A){if(1&A&&(N=a(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var L in N)a.d(R,L,function($){return N[$]}.bind(null,L));return R},a.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return a.d(A,"a",A),A},a.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},a.p="",a(a.s=0)}([function(ie,e,a){(function(N){var A;e=ie.exports=ve,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],m=e.src=[],E=0,I=E++;m[I]="0|[1-9]\\d*";var P=E++;m[P]="[0-9]+";var b=E++;m[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=E++;m[k]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var p=E++;m[p]="("+m[P]+")\\.("+m[P]+")\\.("+m[P]+")";var h=E++;m[h]="(?:"+m[I]+"|"+m[b]+")";var g=E++;m[g]="(?:"+m[P]+"|"+m[b]+")";var u=E++;m[u]="(?:-("+m[h]+"(?:\\."+m[h]+")*))";var n=E++;m[n]="(?:-?("+m[g]+"(?:\\."+m[g]+")*))";var i=E++;m[i]="[0-9A-Za-z-]+";var d=E++;m[d]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var o=E++,t="v?"+m[k]+m[u]+"?"+m[d]+"?";m[o]="^"+t+"$";var l="[v=\\s]*"+m[p]+m[n]+"?"+m[d]+"?",r=E++;m[r]="^"+l+"$";var c=E++;m[c]="((?:<|>)?=?)";var s=E++;m[s]=m[P]+"|x|X|\\*";var v=E++;m[v]=m[I]+"|x|X|\\*";var f=E++;m[f]="[v=\\s]*("+m[v]+")(?:\\.("+m[v]+")(?:\\.("+m[v]+")(?:"+m[u]+")?"+m[d]+"?)?)?";var y=E++;m[y]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[n]+")?"+m[d]+"?)?)?";var w=E++;m[w]="^"+m[c]+"\\s*"+m[f]+"$";var D=E++;m[D]="^"+m[c]+"\\s*"+m[y]+"$";var S=E++;m[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;m[C]="(?:~>?)";var j=E++;m[j]="(\\s*)"+m[C]+"\\s+",$[j]=new RegExp(m[j],"g");var B=E++;m[B]="^"+m[C]+m[f]+"$";var z=E++;m[z]="^"+m[C]+m[y]+"$";var T=E++;m[T]="(?:\\^)";var M=E++;m[M]="(\\s*)"+m[T]+"\\s+",$[M]=new RegExp(m[M],"g");var F=E++;m[F]="^"+m[T]+m[f]+"$";var O=E++;m[O]="^"+m[T]+m[y]+"$";var q=E++;m[q]="^"+m[c]+"\\s*("+l+")$|^$";var Y=E++;m[Y]="^"+m[c]+"\\s*("+t+")$|^$";var V=E++;m[V]="(\\s*)"+m[c]+"\\s*("+l+"|"+m[f]+")",$[V]=new RegExp(m[V],"g");var J=E++;m[J]="^\\s*("+m[f]+")\\s+-\\s+("+m[f]+")\\s*$";var x=E++;m[x]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ne=E++;m[ne]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)A(de,m[de]),$[de]||($[de]=new RegExp(m[de]));function ce(Q,X){if(Q instanceof ve)return Q;if(typeof Q!="string"||Q.length>R||!(X?$[r]:$[o]).test(Q))return null;try{return new ve(Q,X)}catch{return null}}function ve(Q,X){if(Q instanceof ve){if(Q.loose===X)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ve))return new ve(Q,X);A("SemVer",Q,X),this.loose=X;var Z=Q.trim().match(X?$[r]:$[o]);if(!Z)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var we=+he;if(we>=0&&we<L)return we}return he}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Q,X){var Z=ce(Q,X);return Z?Z.version:null},e.clean=function(Q,X){var Z=ce(Q.trim().replace(/^[=v]+/,""),X);return Z?Z.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(Q){return A("SemVer.compare",this.version,this.loose,Q),Q instanceof ve||(Q=new ve(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ve.prototype.compareMain=function(Q){return Q instanceof ve||(Q=new ve(Q,this.loose)),U(this.major,Q.major)||U(this.minor,Q.minor)||U(this.patch,Q.patch)},ve.prototype.comparePre=function(Q){if(Q instanceof ve||(Q=new ve(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var X=0;do{var Z=this.prerelease[X],he=Q.prerelease[X];if(A("prerelease compare",X,Z,he),Z===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(Z===void 0)return-1;if(Z!==he)return U(Z,he)}while(++X)},ve.prototype.inc=function(Q,X){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,X,Z,he){typeof Z=="string"&&(he=Z,Z=void 0);try{return new ve(Q,Z).inc(X,he).version}catch{return null}},e.diff=function(Q,X){if(re(Q,X))return null;var Z=ce(Q),he=ce(X);if(Z.prerelease.length||he.prerelease.length){for(var we in Z)if((we==="major"||we==="minor"||we==="patch")&&Z[we]!==he[we])return"pre"+we;return"prerelease"}for(var we in Z)if((we==="major"||we==="minor"||we==="patch")&&Z[we]!==he[we])return we},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(Q,X){var Z=_.test(Q),he=_.test(X);return Z&&he&&(Q=+Q,X=+X),Z&&!he?-1:he&&!Z?1:Q<X?-1:Q>X?1:0}function le(Q,X,Z){return new ve(Q,Z).compare(new ve(X,Z))}function De(Q,X,Z){return le(Q,X,Z)>0}function $e(Q,X,Z){return le(Q,X,Z)<0}function re(Q,X,Z){return le(Q,X,Z)===0}function se(Q,X,Z){return le(Q,X,Z)!==0}function oe(Q,X,Z){return le(Q,X,Z)>=0}function K(Q,X,Z){return le(Q,X,Z)<=0}function te(Q,X,Z,he){var we;switch(X){case"===":typeof Q=="object"&&(Q=Q.version),typeof Z=="object"&&(Z=Z.version),we=Q===Z;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof Z=="object"&&(Z=Z.version),we=Q!==Z;break;case"":case"=":case"==":we=re(Q,Z,he);break;case"!=":we=se(Q,Z,he);break;case">":we=De(Q,Z,he);break;case">=":we=oe(Q,Z,he);break;case"<":we=$e(Q,Z,he);break;case"<=":we=K(Q,Z,he);break;default:throw new TypeError("Invalid operator: "+X)}return we}function ge(Q,X){if(Q instanceof ge){if(Q.loose===X)return Q;Q=Q.value}if(!(this instanceof ge))return new ge(Q,X);A("comparator",Q,X),this.loose=X,this.parse(Q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(Q,X){return U(X,Q)},e.major=function(Q,X){return new ve(Q,X).major},e.minor=function(Q,X){return new ve(Q,X).minor},e.patch=function(Q,X){return new ve(Q,X).patch},e.compare=le,e.compareLoose=function(Q,X){return le(Q,X,!0)},e.rcompare=function(Q,X,Z){return le(X,Q,Z)},e.sort=function(Q,X){return Q.sort(function(Z,he){return e.compare(Z,he,X)})},e.rsort=function(Q,X){return Q.sort(function(Z,he){return e.rcompare(Z,he,X)})},e.gt=De,e.lt=$e,e.eq=re,e.neq=se,e.gte=oe,e.lte=K,e.cmp=te,e.Comparator=ge;var be={};function Re(Q,X){if(Q instanceof Re)return Q.loose===X?Q:new Re(Q.raw,X);if(Q instanceof ge)return new Re(Q.value,X);if(!(this instanceof Re))return new Re(Q,X);if(this.loose=X,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function pe(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Pe(Q,X,Z,he,we,Te,He,Xe,et,rt,at,ot,ct){return((X=pe(Z)?"":pe(he)?">="+Z+".0.0":pe(we)?">="+Z+"."+he+".0":">="+X)+" "+(Xe=pe(et)?"":pe(rt)?"<"+(+et+1)+".0.0":pe(at)?"<"+et+"."+(+rt+1)+".0":ot?"<="+et+"."+rt+"."+at+"-"+ot:"<="+Xe)).trim()}function Ie(Q,X){for(var Z=0;Z<Q.length;Z++)if(!Q[Z].test(X))return!1;if(X.prerelease.length){for(Z=0;Z<Q.length;Z++)if(A(Q[Z].semver),Q[Z].semver!==be&&Q[Z].semver.prerelease.length>0){var he=Q[Z].semver;if(he.major===X.major&&he.minor===X.minor&&he.patch===X.patch)return!0}return!1}return!0}function je(Q,X,Z){try{X=new Re(X,Z)}catch{return!1}return X.test(Q)}function W(Q,X,Z,he){var we,Te,He,Xe,et;switch(Q=new ve(Q,he),X=new Re(X,he),Z){case">":we=De,Te=K,He=$e,Xe=">",et=">=";break;case"<":we=$e,Te=oe,He=De,Xe="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(Q,X,he))return!1;for(var rt=0;rt<X.set.length;++rt){var at=X.set[rt],ot=null,ct=null;if(at.forEach(function(Ne){Ne.semver===be&&(Ne=new ge(">=0.0.0")),ot=ot||Ne,ct=ct||Ne,we(Ne.semver,ot.semver,he)?ot=Ne:He(Ne.semver,ct.semver,he)&&(ct=Ne)}),ot.operator===Xe||ot.operator===et||(!ct.operator||ct.operator===Xe)&&Te(Q,ct.semver)||ct.operator===et&&He(Q,ct.semver))return!1}return!0}ge.prototype.parse=function(Q){var X=this.loose?$[q]:$[Y],Z=Q.match(X);if(!Z)throw new TypeError("Invalid comparator: "+Q);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new ve(Z[2],this.loose):this.semver=be},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(Q){return A("Comparator.test",Q,this.loose),this.semver===be||(typeof Q=="string"&&(Q=new ve(Q,this.loose)),te(Q,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(Q,X){if(!(Q instanceof ge))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Re(Q.value,X),je(this.value,Z,X);if(Q.operator==="")return Z=new Re(this.value,X),je(Q.semver,Z,X);var he=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Te=this.semver.version===Q.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Xe=te(this.semver,"<",Q.semver,X)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),et=te(this.semver,">",Q.semver,X)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return he||we||Te&&He||Xe||et},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(Q){var X=this.loose;Q=Q.trim(),A("range",Q,X);var Z=X?$[x]:$[J];Q=Q.replace(Z,Pe),A("hyphen replace",Q),Q=Q.replace($[V],"$1$2$3"),A("comparator trim",Q,$[V]),Q=(Q=(Q=Q.replace($[j],"$1~")).replace($[M],"$1^")).split(/\s+/).join(" ");var he=X?$[q]:$[Y],we=Q.split(" ").map(function(Te){return function(He,Xe){return A("comp",He),He=function(et,rt){return et.trim().split(/\s+/).map(function(at){return function(ot,ct){A("caret",ot,ct);var Ne=ct?$[O]:$[F];return ot.replace(Ne,function(Ve,Ae,Ge,ae,ue){var Ce;return A("caret",ot,Ve,Ae,Ge,ae,ue),pe(Ae)?Ce="":pe(Ge)?Ce=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":pe(ae)?Ce=Ae==="0"?">="+Ae+"."+Ge+".0 <"+Ae+"."+(+Ge+1)+".0":">="+Ae+"."+Ge+".0 <"+(+Ae+1)+".0.0":ue?(A("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ce=Ae==="0"?Ge==="0"?">="+Ae+"."+Ge+"."+ae+ue+" <"+Ae+"."+Ge+"."+(+ae+1):">="+Ae+"."+Ge+"."+ae+ue+" <"+Ae+"."+(+Ge+1)+".0":">="+Ae+"."+Ge+"."+ae+ue+" <"+(+Ae+1)+".0.0"):(A("no pr"),Ce=Ae==="0"?Ge==="0"?">="+Ae+"."+Ge+"."+ae+" <"+Ae+"."+Ge+"."+(+ae+1):">="+Ae+"."+Ge+"."+ae+" <"+Ae+"."+(+Ge+1)+".0":">="+Ae+"."+Ge+"."+ae+" <"+(+Ae+1)+".0.0"),A("caret return",Ce),Ce})}(at,rt)}).join(" ")}(He,Xe),A("caret",He),He=function(et,rt){return et.trim().split(/\s+/).map(function(at){return function(ot,ct){var Ne=ct?$[z]:$[B];return ot.replace(Ne,function(Ve,Ae,Ge,ae,ue){var Ce;return A("tilde",ot,Ve,Ae,Ge,ae,ue),pe(Ae)?Ce="":pe(Ge)?Ce=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":pe(ae)?Ce=">="+Ae+"."+Ge+".0 <"+Ae+"."+(+Ge+1)+".0":ue?(A("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ce=">="+Ae+"."+Ge+"."+ae+ue+" <"+Ae+"."+(+Ge+1)+".0"):Ce=">="+Ae+"."+Ge+"."+ae+" <"+Ae+"."+(+Ge+1)+".0",A("tilde return",Ce),Ce})}(at,rt)}).join(" ")}(He,Xe),A("tildes",He),He=function(et,rt){return A("replaceXRanges",et,rt),et.split(/\s+/).map(function(at){return function(ot,ct){ot=ot.trim();var Ne=ct?$[D]:$[w];return ot.replace(Ne,function(Ve,Ae,Ge,ae,ue,Ce){A("xRange",ot,Ve,Ae,Ge,ae,ue,Ce);var Ke=pe(Ge),Oe=Ke||pe(ae),nt=Oe||pe(ue);return Ae==="="&&nt&&(Ae=""),Ke?Ve=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&nt?(Oe&&(ae=0),nt&&(ue=0),Ae===">"?(Ae=">=",Oe?(Ge=+Ge+1,ae=0,ue=0):nt&&(ae=+ae+1,ue=0)):Ae==="<="&&(Ae="<",Oe?Ge=+Ge+1:ae=+ae+1),Ve=Ae+Ge+"."+ae+"."+ue):Oe?Ve=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":nt&&(Ve=">="+Ge+"."+ae+".0 <"+Ge+"."+(+ae+1)+".0"),A("xRange return",Ve),Ve})}(at,rt)}).join(" ")}(He,Xe),A("xrange",He),He=function(et,rt){return A("replaceStars",et,rt),et.trim().replace($[ne],"")}(He,Xe),A("stars",He),He}(Te,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(he)})),we=we.map(function(Te){return new ge(Te,X)})},Re.prototype.intersects=function(Q,X){if(!(Q instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(he){return Q.set.some(function(we){return we.every(function(Te){return he.intersects(Te,X)})})})})},e.toComparators=function(Q,X){return new Re(Q,X).set.map(function(Z){return Z.map(function(he){return he.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ve(Q,this.loose));for(var X=0;X<this.set.length;X++)if(Ie(this.set[X],Q))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(Q,X,Z){var he=null,we=null;try{var Te=new Re(X,Z)}catch{return null}return Q.forEach(function(He){Te.test(He)&&(he&&we.compare(He)!==-1||(we=new ve(he=He,Z)))}),he},e.minSatisfying=function(Q,X,Z){var he=null,we=null;try{var Te=new Re(X,Z)}catch{return null}return Q.forEach(function(He){Te.test(He)&&(he&&we.compare(He)!==1||(we=new ve(he=He,Z)))}),he},e.validRange=function(Q,X){try{return new Re(Q,X).range||"*"}catch{return null}},e.ltr=function(Q,X,Z){return W(Q,X,"<",Z)},e.gtr=function(Q,X,Z){return W(Q,X,">",Z)},e.outside=W,e.prerelease=function(Q,X){var Z=ce(Q,X);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(Q,X,Z){return Q=new Re(Q,Z),X=new Re(X,Z),Q.intersects(X)},e.coerce=function(Q){if(Q instanceof ve)return Q;if(typeof Q!="string")return null;var X=Q.match($[S]);return X==null?null:ce((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,a(1))},function(ie,e){var a,N,A=ie.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function $(g){if(a===setTimeout)return setTimeout(g,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(g,0);try{return a(g,0)}catch{try{return a.call(null,g,0)}catch{return a.call(this,g,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{N=typeof clearTimeout=="function"?clearTimeout:L}catch{N=L}})();var m,E=[],I=!1,P=-1;function b(){I&&m&&(I=!1,m.length?E=m.concat(E):P=-1,E.length&&k())}function k(){if(!I){var g=$(b);I=!0;for(var u=E.length;u;){for(m=E,E=[];++P<u;)m&&m[P].run();P=-1,u=E.length}m=null,I=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===L||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(g)}}function p(g,u){this.fun=g,this.array=u}function h(){}A.nextTick=function(g){var u=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)u[n-1]=arguments[n];E.push(new p(g,u)),E.length!==1||I||$(k)},p.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=h,A.addListener=h,A.once=h,A.off=h,A.removeListener=h,A.removeAllListeners=h,A.emit=h,A.prependListener=h,A.prependOnceListener=h,A.listeners=function(g){return[]},A.binding=function(g){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(g){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(ke[41],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=a&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=N}),define(ke[4],Se([1,0,13,75,3,76,41]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=k;const $=!1,m=!1,E=!1;var I;(function(j){j.None=()=>A.$Vc.None;function B(Re){if(E){const{onDidAddListener:pe}=Re,Pe=h.create();let Ie=0;Re.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),pe?.()}}}function z(Re,pe){return ne(Re,()=>{},0,void 0,!0,void 0,pe)}j.defer=z;function T(Re){return(pe,Pe=null,Ie)=>{let je=!1,W;return W=Re(Q=>{if(!je)return W?W.dispose():je=!0,pe.call(Pe,Q)},null,Ie),je&&W.dispose(),W}}j.once=T;function M(Re,pe,Pe){return J((Ie,je=null,W)=>Re(Q=>Ie.call(je,pe(Q)),null,W),Pe)}j.map=M;function F(Re,pe,Pe){return J((Ie,je=null,W)=>Re(Q=>{pe(Q),Ie.call(je,Q)},null,W),Pe)}j.forEach=F;function O(Re,pe,Pe){return J((Ie,je=null,W)=>Re(Q=>pe(Q)&&Ie.call(je,Q),null,W),Pe)}j.filter=O;function q(Re){return Re}j.signal=q;function Y(...Re){return(pe,Pe=null,Ie)=>{const je=(0,A.$Sc)(...Re.map(W=>W(Q=>pe.call(Pe,Q))));return x(je,Ie)}}j.any=Y;function V(Re,pe,Pe,Ie){let je=Pe;return M(Re,W=>(je=pe(je,W),je),Ie)}j.reduce=V;function J(Re,pe){let Pe;const Ie={onWillAddFirstListener(){Pe=Re(je.fire,je)},onDidRemoveLastListener(){Pe?.dispose()}};pe||B(Ie);const je=new o(Ie);return pe?.add(je),je.event}function x(Re,pe){return pe instanceof Array?pe.push(Re):pe&&pe.add(Re),Re}function ne(Re,pe,Pe=100,Ie=!1,je=!1,W,Q){let X,Z,he,we=0,Te;const He={leakWarningThreshold:W,onWillAddFirstListener(){X=Re(et=>{we++,Z=pe(Z,et),Ie&&!he&&(Xe.fire(Z),Z=void 0),Te=()=>{const rt=Z;Z=void 0,he=void 0,(!Ie||we>1)&&Xe.fire(rt),we=0},typeof Pe=="number"?(clearTimeout(he),he=setTimeout(Te,Pe)):he===void 0&&(he=0,queueMicrotask(Te))})},onWillRemoveListener(){je&&we>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,X.dispose()}};Q||B(He);const Xe=new o(He);return Q?.add(Xe),Xe.event}j.debounce=ne;function de(Re,pe=0,Pe){return j.debounce(Re,(Ie,je)=>Ie?(Ie.push(je),Ie):[je],pe,void 0,!0,void 0,Pe)}j.accumulate=de;function ce(Re,pe=(Ie,je)=>Ie===je,Pe){let Ie=!0,je;return O(Re,W=>{const Q=Ie||!pe(W,je);return Ie=!1,je=W,Q},Pe)}j.latch=ce;function ve(Re,pe,Pe){return[j.filter(Re,pe,Pe),j.filter(Re,Ie=>!pe(Ie),Pe)]}j.split=ve;function _(Re,pe=!1,Pe=[],Ie){let je=Pe.slice(),W=Re(Z=>{je?je.push(Z):X.fire(Z)});Ie&&Ie.add(W);const Q=()=>{je?.forEach(Z=>X.fire(Z)),je=null},X=new o({onWillAddFirstListener(){W||(W=Re(Z=>X.fire(Z)),Ie&&Ie.add(W))},onDidAddFirstListener(){je&&(pe?setTimeout(Q):Q())},onDidRemoveLastListener(){W&&W.dispose(),W=null}});return Ie&&Ie.add(X),X.event}j.buffer=_;function U(Re,pe){return(Ie,je,W)=>{const Q=pe(new De);return Re(function(X){const Z=Q.evaluate(X);Z!==le&&Ie.call(je,Z)},void 0,W)}}j.chain=U;const le=Symbol("HaltChainable");class De{constructor(){this.f=[]}map(pe){return this.f.push(pe),this}forEach(pe){return this.f.push(Pe=>(pe(Pe),Pe)),this}filter(pe){return this.f.push(Pe=>pe(Pe)?Pe:le),this}reduce(pe,Pe){let Ie=Pe;return this.f.push(je=>(Ie=pe(Ie,je),Ie)),this}latch(pe=(Pe,Ie)=>Pe===Ie){let Pe=!0,Ie;return this.f.push(je=>{const W=Pe||!pe(je,Ie);return Pe=!1,Ie=je,W?je:le}),this}evaluate(pe){for(const Pe of this.f)if(pe=Pe(pe),pe===le)break;return pe}}function $e(Re,pe,Pe=Ie=>Ie){const Ie=(...X)=>Q.fire(Pe(...X)),je=()=>Re.on(pe,Ie),W=()=>Re.removeListener(pe,Ie),Q=new o({onWillAddFirstListener:je,onDidRemoveLastListener:W});return Q.event}j.fromNodeEventEmitter=$e;function re(Re,pe,Pe=Ie=>Ie){const Ie=(...X)=>Q.fire(Pe(...X)),je=()=>Re.addEventListener(pe,Ie),W=()=>Re.removeEventListener(pe,Ie),Q=new o({onWillAddFirstListener:je,onDidRemoveLastListener:W});return Q.event}j.fromDOMEventEmitter=re;function se(Re){return new Promise(pe=>T(Re)(pe))}j.toPromise=se;function oe(Re){const pe=new o;return Re.then(Pe=>{pe.fire(Pe)},()=>{pe.fire(void 0)}).finally(()=>{pe.dispose()}),pe.event}j.fromPromise=oe;function K(Re,pe,Pe){return pe(Pe),Re(Ie=>pe(Ie))}j.runAndSubscribe=K;class te{constructor(pe,Pe){this._observable=pe,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{pe.addObserver(this)},onDidRemoveLastListener:()=>{pe.removeObserver(this)}};Pe||B(Ie),this.emitter=new o(Ie),Pe&&Pe.add(this.emitter)}beginUpdate(pe){this.f++}handlePossibleChange(pe){}handleChange(pe,Pe){this.g=!0}endUpdate(pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ge(Re,pe){return new te(Re,pe).emitter.event}j.fromObservable=ge;function be(Re){return(pe,Pe,Ie)=>{let je=0,W=!1;const Q={beginUpdate(){je++},endUpdate(){je--,je===0&&(Re.reportChanges(),W&&(W=!1,pe.call(Pe)))},handlePossibleChange(){},handleChange(){W=!0}};Re.addObserver(Q),Re.reportChanges();const X={dispose(){Re.removeObserver(Q)}};return Ie instanceof A.$Uc?Ie.add(X):Array.isArray(Ie)&&Ie.push(X),X}}j.fromObservableLight=be})(I||(e.Event=I={}));class P{constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${P.f++}`,P.all.add(this)}start(B){this.g=new L.$ae,this.listenerCount=B}stop(){if(this.g){const B=this.g.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this.g=void 0}}}e.$ce=P,P.all=new Set,P.f=0;let b=-1;function k(j){const B=b;return b=j,{dispose(){b=B}}}class p{constructor(B,z=Math.random().toString(18).slice(2,5)){this.threshold=B,this.name=z,this.g=0}dispose(){this.f?.clear()}check(B,z){const T=this.threshold;if(T<=0||z<T)return;this.f||(this.f=new Map);const M=this.f.get(B.value)||0;if(this.f.set(B.value,M+1),this.g-=1,this.g<=0){this.g=T*.5;let F,O=0;for(const[q,Y]of this.f)(!F||O<Y)&&(F=q,O=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${O}):`),console.warn(F)}return()=>{const F=this.f.get(B.value)||0;this.f.set(B.value,F-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class u{constructor(B){this.value=B,this.id=g++}}const n=2,i=(j,B)=>{if(j instanceof u)B(j);else for(let z=0;z<j.length;z++){const T=j[z];T&&B(T)}},d=$?new FinalizationRegistry(j=>{typeof j=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(j))}):void 0;class o{constructor(B){this.w=0,this.f=B,this.g=b>0||this.f?.leakWarningThreshold?new p(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const B=this.t;queueMicrotask(()=>{i(B,z=>z.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(B,z,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Vc.None;if(this.m)return A.$Vc.None;z&&(B=B.bind(z));const M=new u(B);let F,O;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=h.create(),F=this.g.check(M.stack,this.w+1)),m&&(M.stack=O??h.create()),this.t?this.t instanceof u?(this.u??(this.u=new l),this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,A.$Tc)(()=>{d?.unregister(q),F?.(),this.x(M)});if(T instanceof A.$Uc?T.add(q):Array.isArray(T)&&T.push(q),d){const Y=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(q,Y,q)}return q}),this.q}x(B){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const z=this.t,T=z.indexOf(B);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,z[T]=void 0;const M=this.u.current===this;if(this.w*n<=z.length){let F=0;for(let O=0;O<z.length;O++)z[O]?z[F++]=z[O]:M&&(this.u.end--,F<this.u.i&&this.u.i--);z.length=F}}y(B,z){if(!B)return;const T=this.f?.onListenerError||a.$1;if(!T){B.value(z);return}try{B.value(z)}catch(M){T(M)}}z(B){const z=B.current.t;for(;B.i<B.end;)this.y(z[B.i++],B.value);B.reset()}fire(B){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,B);else{const z=this.u;z.enqueue(this,B,this.t.length),this.z(z)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=o;const t=()=>new l;e.$fe=t;class l{constructor(){this.i=-1,this.end=0}enqueue(B,z,T){this.i=0,this.end=T,this.current=B,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends o{async fireAsync(B,z,T){if(this.t)for(this.h||(this.h=new R.$6c),i(this.t,M=>this.h.push([M.value,B]));this.h.size>0&&!z.isCancellationRequested;){const[M,F]=this.h.shift(),O=[],q={...F,token:z,waitUntil:Y=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");T&&(Y=T(Y,M)),O.push(Y)}};try{M(q)}catch(Y){(0,a.$1)(Y);continue}Object.freeze(O),await Promise.allSettled(O).then(Y=>{for(const V of Y)V.status==="rejected"&&(0,a.$1)(V.reason)})}}}e.$ge=r;class c extends o{get isPaused(){return this.h!==0}constructor(B){super(B),this.h=0,this.s=new R.$6c,this.A=B?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const B=Array.from(this.s);this.s.clear(),super.fire(this.A(B))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(B){this.w&&(this.h!==0?this.s.push(B):super.fire(B))}}e.$he=c;class s extends c{constructor(B){super(B),this.k=B.delay??100}fire(B){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(B)}}e.$ie=s;class v extends o{constructor(B){super(B),this.h=[],this.k=B?.merge}fire(B){this.hasListeners()&&(this.h.push(B),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$je=v;class f{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(B){const z={event:B,listener:null};this.h.push(z),this.g&&this.m(z);const T=()=>{this.g&&this.o(z);const M=this.h.indexOf(z);this.h.splice(M,1)};return(0,A.$Tc)((0,N.$db)(T))}j(){this.g=!0,this.h.forEach(B=>this.m(B))}k(){this.g=!1,this.h.forEach(B=>this.o(B))}m(B){B.listener=B.event(z=>this.f.fire(z))}o(B){B.listener?.dispose(),B.listener=null}dispose(){this.f.dispose();for(const B of this.h)B.listener?.dispose();this.h=[]}}e.$ke=f;class y{constructor(B,z,T,M){this.f=new A.$Uc;const F=this.f.add(new f),O=this.f.add(new A.$5c);function q(Y){O.set(Y,F.add(M(Y)))}for(const Y of B)q(Y);this.f.add(z(Y=>{q(Y)})),this.f.add(T(Y=>{O.deleteAndDispose(Y)})),this.event=F.event}dispose(){this.f.dispose()}}e.$le=y;class w{constructor(){this.f=[]}wrapEvent(B){return(z,T,M)=>B(F=>{const O=this.f[this.f.length-1];O?O.push(()=>z.call(T,F)):z.call(T,F)},void 0,M)}bufferEvents(B){const z=[];this.f.push(z);const T=B();return this.f.pop(),z.forEach(M=>M()),T}}e.$me=w;class D{constructor(){this.f=!1,this.g=I.None,this.h=A.$Vc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(B){this.g=B,this.f&&(this.h.dispose(),this.h=B(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=D;class S{static const(B){return new C(B)}constructor(B){this.g=B,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(B){B!==this.g&&(this.g=B,this.f.fire(void 0))}}e.$oe=S;class C{constructor(B){this.value=B,this.onDidChange=I.None}}}),define(ke[22],Se([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=$;const N=Object.freeze(function(m,E){const I=setTimeout(m.bind(E),0);return{dispose(){clearTimeout(I)}}});var A;(function(m){function E(I){return I===m.None||I===m.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}m.isCancellationToken=E,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new a.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$pe=L;function $(m){const E=new L;return m.add({dispose(){E.cancel()}}),E.token}}),define(ke[174],Se([1,0,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=A;class N{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new a.$pe,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$2e=N;function A($){return $}class R{constructor(m,E){this.a=void 0,this.b=void 0,typeof m=="function"?(this.c=m,this.d=A):(this.c=E,this.d=m.getCacheKey)}get(m){const E=this.d(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$4e=R;class L{get cachedValues(){return this.a}constructor(m,E){this.a=new Map,this.b=new Map,typeof m=="function"?(this.c=m,this.d=A):(this.c=E,this.d=m.getCacheKey)}get(m){const E=this.d(m);if(this.b.has(E))return this.b.get(E);const I=this.c(m);return this.a.set(m,I),this.b.set(E,I),I}}e.$5e=L}),define(ke[100],Se([1,0,13,3]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=A,e.$se=R,e.$te=L,e.$ue=$,e.$ve=E,e.$we=I,e.$xe=P,e.$ye=b,e.$ze=k,e.$Ae=p,e.$Be=h,e.$Ce=g,e.$De=u,e.$Ee=n,e.$Fe=i;function A(d){const o=d;return o?typeof o.read=="function":!1}function R(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function L(d){const o=d;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function $(d,o){return new m(d,o)}class m{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,a.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let l;switch(o){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(d,o){const t=[];let l;for(;(l=d.read())!==null;)t.push(l);return o(t)}function I(d,o,t){const l=[];let r;for(;(r=d.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?o(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return d.read()}}}function P(d,o){return new Promise((t,l)=>{const r=[];b(d,{onData:c=>{o&&r.push(c)},onError:c=>{o?l(c):t(void 0)},onEnd:()=>{t(o?o(r):void 0)}})})}function b(d,o,t){d.on("error",l=>{t?.isCancellationRequested||o.onError(l)}),d.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),d.on("data",l=>{t?.isCancellationRequested||o.onData(l)})}function k(d,o){return new Promise((t,l)=>{const r=new N.$Uc,c=[],s=y=>{if(c.push(y),c.length>o)return r.dispose(),d.pause(),t({stream:d,buffer:c,ended:!1})},v=y=>(r.dispose(),l(y)),f=()=>(r.dispose(),t({stream:d,buffer:c,ended:!0}));r.add((0,N.$Tc)(()=>d.removeListener("error",v))),d.on("error",v),r.add((0,N.$Tc)(()=>d.removeListener("end",f))),d.on("end",f),r.add((0,N.$Tc)(()=>d.removeListener("data",s))),d.on("data",s)})}function p(d,o){const t=$(o);return t.end(d),t}function h(){const d=$(()=>{throw new Error("not supported")});return d.end(),d}function g(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}function u(d,o,t){const l=$(t);return b(d,{onData:r=>l.write(o.data(r)),onError:r=>l.error(o.error?o.error(r):r),onEnd:()=>l.end()}),l}function n(d,o,t){let l=!1;return{read:()=>{const r=o.read();return l?r:(l=!0,r!==null?t([d,r]):d)}}}function i(d,o,t){let l=!1;const r=$(t);return b(o,{onData:c=>l?r.write(c):(l=!0,r.write(t([d,c]))),onError:c=>r.error(c),onEnd:()=>{l||(l=!0,r.write(d)),r.end()}}),r}}),define(ke[21],Se([1,0,46,100]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=E,e.$Ie=I,e.$Je=P,e.$Ke=b,e.$Le=k,e.$Me=p,e.$Ne=h,e.$Oe=g,e.$Pe=u,e.$Qe=n,e.$Re=i,e.$Se=d,e.$Te=o,e.$Ue=t,e.$Ve=l,e.$We=r,e.$Xe=c,e.$Ye=s,e.$Ze=v,e.$1e=w;const A=typeof Buffer<"u",R=new a.$V(()=>new Uint8Array(256));let L,$;class m{static alloc(S){return A?new m(Buffer.allocUnsafe(S)):new m(new Uint8Array(S))}static wrap(S){return A&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new m(S)}static fromString(S,C){return!(C?.dontUseNodeBuffer||!1)&&A?new m(Buffer.from(S)):(L||(L=new TextEncoder),new m(L.encode(S)))}static fromByteArray(S){const C=m.alloc(S.length);for(let j=0,B=S.length;j<B;j++)C.buffer[j]=S[j];return C}static concat(S,C){if(typeof C>"u"){C=0;for(let z=0,T=S.length;z<T;z++)C+=S[z].byteLength}const j=m.alloc(C);let B=0;for(let z=0,T=S.length;z<T;z++){const M=S[z];j.set(M,B),B+=M.byteLength}return j}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=m.alloc(this.byteLength);return S.set(this),S}toString(){return A?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(S,C){return new m(this.buffer.subarray(S,C))}set(S,C){if(S instanceof m)this.buffer.set(S.buffer,C);else if(S instanceof Uint8Array)this.buffer.set(S,C);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),C);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return b(this.buffer,S)}writeUInt32BE(S,C){k(this.buffer,S,C)}readUInt32LE(S){return p(this.buffer,S)}writeUInt32LE(S,C){h(this.buffer,S,C)}readUInt8(S){return g(this.buffer,S)}writeUInt8(S,C){u(this.buffer,S,C)}indexOf(S,C=0){return E(this.buffer,S instanceof m?S.buffer:S,C)}}e.$Ge=m;function E(D,S,C=0){const j=S.byteLength,B=D.byteLength;if(j===0)return 0;if(j===1)return D.indexOf(S[0]);if(j>B-C)return-1;const z=R.value;z.fill(S.length);for(let O=0;O<S.length;O++)z[S[O]]=S.length-O-1;let T=C+S.length-1,M=T,F=-1;for(;T<B;)if(D[T]===S[M]){if(M===0){F=T;break}T--,M--}else T+=Math.max(S.length-M,z[D[T]]),M=S.length-1;return F}function I(D,S){return D[S+0]<<0>>>0|D[S+1]<<8>>>0}function P(D,S,C){D[C+0]=S&255,S=S>>>8,D[C+1]=S&255}function b(D,S){return D[S]*2**24+D[S+1]*2**16+D[S+2]*2**8+D[S+3]}function k(D,S,C){D[C+3]=S,S=S>>>8,D[C+2]=S,S=S>>>8,D[C+1]=S,S=S>>>8,D[C]=S}function p(D,S){return D[S+0]<<0>>>0|D[S+1]<<8>>>0|D[S+2]<<16>>>0|D[S+3]<<24>>>0}function h(D,S,C){D[C+0]=S&255,S=S>>>8,D[C+1]=S&255,S=S>>>8,D[C+2]=S&255,S=S>>>8,D[C+3]=S&255}function g(D,S){return D[S]}function u(D,S,C){D[C]=S}function n(D){return N.$ve(D,S=>m.concat(S))}function i(D){return N.$Ce(D)}function d(D){return N.$xe(D,S=>m.concat(S))}async function o(D){return D.ended?m.concat(D.buffer):m.concat([...D.buffer,await d(D.stream)])}function t(D){return N.$Ae(D,S=>m.concat(S))}function l(D){return N.$De(D,{data:S=>typeof S=="string"?m.fromString(S):m.wrap(S)},S=>m.concat(S))}function r(D){return N.$ue(S=>m.concat(S),D)}function c(D,S){return N.$Ee(D,S,C=>m.concat(C))}function s(D,S){return N.$Fe(D,S,C=>m.concat(C))}function v(D){let S=0,C=0,j=0;const B=new Uint8Array(Math.floor(D.length/4*3)),z=M=>{switch(C){case 3:B[j++]=S|M,C=0;break;case 2:B[j++]=S|M>>>2,S=M<<6,C=3;break;case 1:B[j++]=S|M>>>4,S=M<<4,C=2;break;default:S=M<<2,C=1}};for(let M=0;M<D.length;M++){const F=D.charCodeAt(M);if(F>=65&&F<=90)z(F-65);else if(F>=97&&F<=122)z(F-97+26);else if(F>=48&&F<=57)z(F-48+52);else if(F===43||F===45)z(62);else if(F===47||F===95)z(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${D[M]}`)}}const T=j;for(;C>0;)z(0);return m.wrap(B).slice(0,T)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:D},S=!0,C=!1){const j=C?y:f;let B="";const z=D.byteLength%3;let T=0;for(;T<D.byteLength-z;T+=3){const M=D[T+0],F=D[T+1],O=D[T+2];B+=j[M>>>2],B+=j[(M<<4|F>>>4)&63],B+=j[(F<<2|O>>>6)&63],B+=j[O&63]}if(z===1){const M=D[T+0];B+=j[M>>>2],B+=j[M<<4&63],S&&(B+="==")}else if(z===2){const M=D[T+0],F=D[T+1];B+=j[M>>>2],B+=j[(M<<4|F>>>4)&63],B+=j[F<<2&63],S&&(B+="=")}return B}}),define(ke[14],Se([1,0,174,46]),function(ie,e,a,N){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=R,e.$9e=$,e.$0e=E,e.$$e=I,e.$_e=P,e.$af=b,e.$bf=k,e.$cf=p,e.$df=h,e.$ef=g,e.$ff=u,e.$gf=n,e.$hf=i,e.$if=d,e.$jf=o,e.$kf=t,e.$lf=l,e.$mf=r,e.$nf=c,e.$of=s,e.$pf=v,e.$qf=f,e.$rf=y,e.$sf=w,e.$tf=D,e.$uf=S,e.$vf=C,e.$wf=j,e.$xf=B,e.$yf=z,e.$zf=T,e.$Af=M,e.$Bf=F,e.$Cf=O,e.$Df=q,e.$Ef=Y,e.$Ff=V,e.$If=de,e.$Jf=ce,e.$Kf=ve,e.$Lf=_,e.$Mf=De,e.$Nf=re,e.$Pf=se,e.$Qf=oe,e.$Rf=K,e.$Sf=te,e.$Tf=be,e.$Uf=Re,e.$Wf=pe,e.$Xf=Pe,e.$Yf=Ie,e.$Zf=je,e.$1f=W,e.$2f=Q,e.$3f=X,e.$4f=Z,e.$5f=Xe;function R(Ne){return!Ne||typeof Ne!="string"?!0:Ne.trim().length===0}const L=/{(\d+)}/g;function $(Ne,...Ve){return Ve.length===0?Ne:Ne.replace(L,function(Ae,Ge){const ae=parseInt(Ge,10);return isNaN(ae)||ae<0||ae>=Ve.length?Ae:Ve[ae]})}const m=/{([^}]+)}/g;function E(Ne,Ve){return Object.keys(Ve).length===0?Ne:Ne.replace(m,(Ae,Ge)=>Ve[Ge]??Ae)}function I(Ne){return Ne.replace(/[<>"'&]/g,Ve=>{switch(Ve){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ve})}function P(Ne){return Ne.replace(/[<>&]/g,function(Ve){switch(Ve){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ve}})}function b(Ne){return Ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(Ne,Ve){let Ae=0;const Ge=Ve.charCodeAt(0);for(let ae=Ne.length-1;ae>=0;ae--)Ne.charCodeAt(ae)===Ge&&Ae++;return Ae}function p(Ne,Ve,Ae="\u2026"){return Ne.length<=Ve?Ne:`${Ne.substr(0,Ve)}${Ae}`}function h(Ne,Ve,Ae="\u2026"){if(Ne.length<=Ve)return Ne;const Ge=Math.ceil(Ve/2)-Ae.length/2,ae=Math.floor(Ve/2)-Ae.length/2;return`${Ne.substr(0,Ge)}${Ae}${Ne.substr(Ne.length-ae)}`}function g(Ne,Ve=" "){const Ae=u(Ne,Ve);return n(Ae,Ve)}function u(Ne,Ve){if(!Ne||!Ve)return Ne;const Ae=Ve.length;if(Ae===0||Ne.length===0)return Ne;let Ge=0;for(;Ne.indexOf(Ve,Ge)===Ge;)Ge=Ge+Ae;return Ne.substring(Ge)}function n(Ne,Ve){if(!Ne||!Ve)return Ne;const Ae=Ve.length,Ge=Ne.length;if(Ae===0||Ge===0)return Ne;let ae=Ge,ue=-1;for(;ue=Ne.lastIndexOf(Ve,ae-1),!(ue===-1||ue+Ae!==ae);){if(ue===0)return"";ae=ue}return Ne.substring(0,ae)}function i(Ne){return Ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(Ne){return Ne.replace(/\*/g,"")}function o(Ne,Ve,Ae={}){if(!Ne)throw new Error("Cannot create regex from empty string");Ve||(Ne=b(Ne)),Ae.wholeWord&&(/\B/.test(Ne.charAt(0))||(Ne="\\b"+Ne),/\B/.test(Ne.charAt(Ne.length-1))||(Ne=Ne+"\\b"));let Ge="";return Ae.global&&(Ge+="g"),Ae.matchCase||(Ge+="i"),Ae.multiline&&(Ge+="m"),Ae.unicode&&(Ge+="u"),new RegExp(Ne,Ge)}function t(Ne){return Ne.source==="^"||Ne.source==="^$"||Ne.source==="$"||Ne.source==="^\\s*$"?!1:!!(Ne.exec("")&&Ne.lastIndex===0)}function l(Ne){return Ne.split(/\r\n|\r|\n/)}function r(Ne){const Ve=[],Ae=Ne.split(/(\r\n|\r|\n)/);for(let Ge=0;Ge<Math.ceil(Ae.length/2);Ge++)Ve.push(Ae[2*Ge]+(Ae[2*Ge+1]??""));return Ve}function c(Ne){for(let Ve=0,Ae=Ne.length;Ve<Ae;Ve++){const Ge=Ne.charCodeAt(Ve);if(Ge!==32&&Ge!==9)return Ve}return-1}function s(Ne,Ve=0,Ae=Ne.length){for(let Ge=Ve;Ge<Ae;Ge++){const ae=Ne.charCodeAt(Ge);if(ae!==32&&ae!==9)return Ne.substring(Ve,Ge)}return Ne.substring(Ve,Ae)}function v(Ne,Ve=Ne.length-1){for(let Ae=Ve;Ae>=0;Ae--){const Ge=Ne.charCodeAt(Ae);if(Ge!==32&&Ge!==9)return Ae}return-1}function f(Ne,Ve,Ae){const Ge=[];let ae=0;for(const ue of Ne.matchAll(Ve)){if(Ge.push(Ne.slice(ae,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");ae=ue.index+ue[0].length,Ge.push(Ae(ue[0],...ue.slice(1),ue.index,Ne,ue.groups))}return Ge.push(Ne.slice(ae)),Promise.all(Ge).then(ue=>ue.join(""))}function y(Ne,Ve){return Ne<Ve?-1:Ne>Ve?1:0}function w(Ne,Ve,Ae=0,Ge=Ne.length,ae=0,ue=Ve.length){for(;Ae<Ge&&ae<ue;Ae++,ae++){const Oe=Ne.charCodeAt(Ae),nt=Ve.charCodeAt(ae);if(Oe<nt)return-1;if(Oe>nt)return 1}const Ce=Ge-Ae,Ke=ue-ae;return Ce<Ke?-1:Ce>Ke?1:0}function D(Ne,Ve){return S(Ne,Ve,0,Ne.length,0,Ve.length)}function S(Ne,Ve,Ae=0,Ge=Ne.length,ae=0,ue=Ve.length){for(;Ae<Ge&&ae<ue;Ae++,ae++){let Oe=Ne.charCodeAt(Ae),nt=Ve.charCodeAt(ae);if(Oe===nt)continue;if(Oe>=128||nt>=128)return w(Ne.toLowerCase(),Ve.toLowerCase(),Ae,Ge,ae,ue);j(Oe)&&(Oe-=32),j(nt)&&(nt-=32);const ht=Oe-nt;if(ht!==0)return ht}const Ce=Ge-Ae,Ke=ue-ae;return Ce<Ke?-1:Ce>Ke?1:0}function C(Ne){return Ne>=48&&Ne<=57}function j(Ne){return Ne>=97&&Ne<=122}function B(Ne){return Ne>=65&&Ne<=90}function z(Ne,Ve){return Ne.length===Ve.length&&S(Ne,Ve)===0}function T(Ne,Ve){const Ae=Ve.length;return Ve.length>Ne.length?!1:S(Ne,Ve,0,Ae)===0}function M(Ne,Ve){const Ae=Math.min(Ne.length,Ve.length);let Ge;for(Ge=0;Ge<Ae;Ge++)if(Ne.charCodeAt(Ge)!==Ve.charCodeAt(Ge))return Ge;return Ae}function F(Ne,Ve){const Ae=Math.min(Ne.length,Ve.length);let Ge;const ae=Ne.length-1,ue=Ve.length-1;for(Ge=0;Ge<Ae;Ge++)if(Ne.charCodeAt(ae-Ge)!==Ve.charCodeAt(ue-Ge))return Ge;return Ae}function O(Ne){return 55296<=Ne&&Ne<=56319}function q(Ne){return 56320<=Ne&&Ne<=57343}function Y(Ne,Ve){return(Ne-55296<<10)+(Ve-56320)+65536}function V(Ne,Ve,Ae){const Ge=Ne.charCodeAt(Ae);if(O(Ge)&&Ae+1<Ve){const ae=Ne.charCodeAt(Ae+1);if(q(ae))return Y(Ge,ae)}return Ge}function J(Ne,Ve){const Ae=Ne.charCodeAt(Ve-1);if(q(Ae)&&Ve>1){const Ge=Ne.charCodeAt(Ve-2);if(O(Ge))return Y(Ge,Ae)}return Ae}class x{get offset(){return this.e}constructor(Ve,Ae=0){this.c=Ve,this.d=Ve.length,this.e=Ae}setOffset(Ve){this.e=Ve}prevCodePoint(){const Ve=J(this.c,this.e);return this.e-=Ve>=65536?2:1,Ve}nextCodePoint(){const Ve=V(this.c,this.d,this.e);return this.e+=Ve>=65536?2:1,Ve}eol(){return this.e>=this.d}}e.$Gf=x;class ne{get offset(){return this.c.offset}constructor(Ve,Ae=0){this.c=new x(Ve,Ae)}nextGraphemeLength(){const Ve=Te.getInstance(),Ae=this.c,Ge=Ae.offset;let ae=Ve.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const ue=Ae.offset,Ce=Ve.getGraphemeBreakType(Ae.nextCodePoint());if(he(ae,Ce)){Ae.setOffset(ue);break}ae=Ce}return Ae.offset-Ge}prevGraphemeLength(){const Ve=Te.getInstance(),Ae=this.c,Ge=Ae.offset;let ae=Ve.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const ue=Ae.offset,Ce=Ve.getGraphemeBreakType(Ae.prevCodePoint());if(he(Ce,ae)){Ae.setOffset(ue);break}ae=Ce}return Ge-Ae.offset}eol(){return this.c.eol()}}e.$Hf=ne;function de(Ne,Ve){return new ne(Ne,Ve).nextGraphemeLength()}function ce(Ne,Ve){return new ne(Ne,Ve).prevGraphemeLength()}function ve(Ne,Ve){Ve>0&&q(Ne.charCodeAt(Ve))&&Ve--;const Ae=Ve+de(Ne,Ve);return[Ae-ce(Ne,Ae),Ae]}function _(Ne){const Ve=new ne(Ne);let Ae=0;for(;!Ve.eol();)Ae++,Ve.nextGraphemeLength();return Ae}let U;function le(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(Ne){return U||(U=le()),U.test(Ne)}const $e=/^[\t\n\r\x20-\x7E]*$/;function re(Ne){return $e.test(Ne)}e.$Of=/[\u2028\u2029]/;function se(Ne){return e.$Of.test(Ne)}function oe(Ne){return Ne>=11904&&Ne<=55215||Ne>=63744&&Ne<=64255||Ne>=65281&&Ne<=65374}function K(Ne){return Ne>=127462&&Ne<=127487||Ne===8986||Ne===8987||Ne===9200||Ne===9203||Ne>=9728&&Ne<=10175||Ne===11088||Ne===11093||Ne>=127744&&Ne<=128591||Ne>=128640&&Ne<=128764||Ne>=128992&&Ne<=129008||Ne>=129280&&Ne<=129535||Ne>=129648&&Ne<=129782}function te(Ne,Ve,Ae=""){const Ge=Ne.trimStart();if(Ge.length<Ve)return Ge;const ae=/\b/g;let ue=0;for(;ae.test(Ge)&&!(Ge.length-ae.lastIndex<Ve);)ue=ae.lastIndex,ae.lastIndex+=1;return ue===0?Ge:Ae+Ge.substring(ue).trimStart()}const ge=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(Ne){let Ve=0;for(const Ae of Ne.matchAll(ge))Ve!==Ae.index&&(yield{isCode:!1,str:Ne.substring(Ve,Ae.index)}),yield{isCode:!0,str:Ae[0]},Ve=Ae.index+Ae[0].length;Ve!==Ne.length&&(yield{isCode:!1,str:Ne.substring(Ve)})}function Re(Ne){return Ne&&(Ne=Ne.replace(ge,"")),Ne}e.$Vf="\uFEFF";function pe(Ne){return!!(Ne&&Ne.length>0&&Ne.charCodeAt(0)===65279)}function Pe(Ne){return pe(Ne)?Ne.substr(1):Ne}function Ie(Ne,Ve){if(!Ne||!Ve||Ne.length<Ve.length)return!1;const Ae=Ve.length,Ge=Ne.toLowerCase();let ae=0,ue=-1;for(;ae<Ae;){const Ce=Ge.indexOf(Ve[ae],ue+1);if(Ce<0)return!1;ue=Ce,ae++}return!0}function je(Ne,Ve=!1){return Ne?(Ve&&(Ne=Ne.replace(/\\./g,"")),Ne.toLowerCase()!==Ne):!1}function W(Ne){return Ne.charAt(0).toUpperCase()+Ne.slice(1)}function Q(Ne,Ve=1){if(Ve===0)return"";let Ae=-1;do Ae=Ne.indexOf(`
`,Ae+1),Ve--;while(Ve>0&&Ae>=0);return Ae===-1?Ne:(Ne[Ae-1]==="\r"&&Ae--,Ne.substr(0,Ae))}function X(Ne){return Ne=Ne%(2*26),Ne<26?String.fromCharCode(97+Ne):String.fromCharCode(65+Ne-26)}function Z(Ne){return Te.getInstance().getGraphemeBreakType(Ne)}function he(Ne,Ve){return Ne===0?Ve!==5&&Ve!==7:Ne===2&&Ve===3?!1:Ne===4||Ne===2||Ne===3||Ve===4||Ve===2||Ve===3?!0:!(Ne===8&&(Ve===8||Ve===9||Ve===11||Ve===12)||(Ne===11||Ne===9)&&(Ve===9||Ve===10)||(Ne===12||Ne===10)&&Ve===10||Ve===5||Ve===13||Ve===7||Ne===1||Ne===13&&Ve===14||Ne===6&&Ve===6)}var we;(function(Ne){Ne[Ne.Other=0]="Other",Ne[Ne.Prepend=1]="Prepend",Ne[Ne.CR=2]="CR",Ne[Ne.LF=3]="LF",Ne[Ne.Control=4]="Control",Ne[Ne.Extend=5]="Extend",Ne[Ne.Regional_Indicator=6]="Regional_Indicator",Ne[Ne.SpacingMark=7]="SpacingMark",Ne[Ne.L=8]="L",Ne[Ne.V=9]="V",Ne[Ne.T=10]="T",Ne[Ne.LV=11]="LV",Ne[Ne.LVT=12]="LVT",Ne[Ne.ZWJ=13]="ZWJ",Ne[Ne.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=He()}getGraphemeBreakType(Ve){if(Ve<32)return Ve===10?3:Ve===13?2:4;if(Ve<127)return 0;const Ae=this.d,Ge=Ae.length/3;let ae=1;for(;ae<=Ge;)if(Ve<Ae[3*ae])ae=2*ae;else if(Ve>Ae[3*ae+1])ae=2*ae+1;else return Ae[3*ae+2];return 0}}Te.c=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(Ne,Ve){if(Ne===0)return 0;const Ae=et(Ne,Ve);if(Ae!==void 0)return Ae;const Ge=new x(Ve,Ne);return Ge.prevCodePoint(),Ge.offset}function et(Ne,Ve){const Ae=new x(Ve,Ne);let Ge=Ae.prevCodePoint();for(;rt(Ge)||Ge===65039||Ge===8419;){if(Ae.offset===0)return;Ge=Ae.prevCodePoint()}if(!K(Ge))return;let ae=Ae.offset;return ae>0&&Ae.prevCodePoint()===8205&&(ae=Ae.offset),ae}function rt(Ne){return 127995<=Ne&&Ne<=127999}var at;(function(Ne){Ne[Ne.zwj=8205]="zwj",Ne[Ne.emojiVariantSelector=65039]="emojiVariantSelector",Ne[Ne.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$6f="\xA0";class ot{static getInstance(Ve){return A.d.get(Array.from(Ve))}static getLocales(){return A.e.value}constructor(Ve){this.f=Ve}isAmbiguous(Ve){return this.f.has(Ve)}getPrimaryConfusable(Ve){return this.f.get(Ve)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=ot,A=ot,ot.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ot.d=new a.$4e({getCacheKey:JSON.stringify},Ne=>{function Ve(nt){const ht=new Map;for(let yt=0;yt<nt.length;yt+=2)ht.set(nt[yt],nt[yt+1]);return ht}function Ae(nt,ht){const yt=new Map(nt);for(const[Nt,jt]of ht)yt.set(Nt,jt);return yt}function Ge(nt,ht){if(!nt)return ht;const yt=new Map;for(const[Nt,jt]of nt)ht.has(Nt)&&yt.set(Nt,jt);return yt}const ae=A.c.value;let ue=Ne.filter(nt=>!nt.startsWith("_")&&nt in ae);ue.length===0&&(ue=["_default"]);let Ce;for(const nt of ue){const ht=Ve(ae[nt]);Ce=Ge(Ce,ht)}const Ke=Ve(ae._common),Oe=Ae(Ke,Ce);return new A(Oe)}),ot.e=new N.$V(()=>Object.keys(A.c.value).filter(Ne=>!Ne.startsWith("_")));class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Ve){return ct.e().has(Ve)}static get codePoints(){return ct.e()}}e.$8f=ct,ct.d=void 0}),define(ke[129],Se([1,0,27,169,14]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=R,e.$zk=$,e.$Ak=m,e.$Bk=P,e.$Ck=v,e.$Dk=f,e.$Ek=j,e.$Fk=B,e.$Gk=z,e.$Hk=T,e.$Ik=le,e.$Kk=se,e.$Lk=te,e.$Mk=ge;function R(...pe){return function(Pe,Ie){for(let je=0,W=pe.length;je<W;je++){const Q=pe[je](Pe,Ie);if(Q)return Q}return null}}e.$xk=L.bind(void 0,!1),e.$yk=L.bind(void 0,!0);function L(pe,Pe,Ie){if(!Ie||Ie.length<Pe.length)return null;let je;return pe?je=A.$zf(Ie,Pe):je=Ie.indexOf(Pe)===0,je?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(pe,Pe){const Ie=Pe.toLowerCase().indexOf(pe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+pe.length}]}function m(pe,Pe){return E(pe.toLowerCase(),Pe.toLowerCase(),0,0)}function E(pe,Pe,Ie,je){if(Ie===pe.length)return[];if(je===Pe.length)return null;if(pe[Ie]===Pe[je]){let W=null;return(W=E(pe,Pe,Ie+1,je+1))?d({start:je,end:je+1},W):null}return E(pe,Pe,Ie,je+1)}function I(pe){return 97<=pe&&pe<=122}function P(pe){return 65<=pe&&pe<=90}function b(pe){return 48<=pe&&pe<=57}function k(pe){return pe===32||pe===9||pe===10||pe===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>p.add(pe.charCodeAt(0)));function h(pe){return k(pe)||p.has(pe)}function g(pe,Pe){return pe===Pe||h(pe)&&h(Pe)}const u=new Map;function n(pe){if(u.has(pe))return u.get(pe);let Pe;const Ie=(0,N.$vk)(pe);return Ie&&(Pe=Ie),u.set(pe,Pe),Pe}function i(pe){return I(pe)||P(pe)||b(pe)}function d(pe,Pe){return Pe.length===0?Pe=[pe]:pe.end===Pe[0].start?Pe[0].start=pe.start:Pe.unshift(pe),Pe}function o(pe,Pe){for(let Ie=Pe;Ie<pe.length;Ie++){const je=pe.charCodeAt(Ie);if(P(je)||b(je)||Ie>0&&!i(pe.charCodeAt(Ie-1)))return Ie}return pe.length}function t(pe,Pe,Ie,je){if(Ie===pe.length)return[];if(je===Pe.length)return null;if(pe[Ie]!==Pe[je].toLowerCase())return null;{let W=null,Q=je+1;for(W=t(pe,Pe,Ie+1,je+1);!W&&(Q=o(Pe,Q))<Pe.length;)W=t(pe,Pe,Ie+1,Q),Q++;return W===null?null:d({start:je,end:je+1},W)}}function l(pe){let Pe=0,Ie=0,je=0,W=0,Q=0;for(let Te=0;Te<pe.length;Te++)Q=pe.charCodeAt(Te),P(Q)&&Pe++,I(Q)&&Ie++,i(Q)&&je++,b(Q)&&W++;const X=Pe/pe.length,Z=Ie/pe.length,he=je/pe.length,we=W/pe.length;return{upperPercent:X,lowerPercent:Z,alphaPercent:he,numericPercent:we}}function r(pe){const{upperPercent:Pe,lowerPercent:Ie}=pe;return Ie===0&&Pe>.6}function c(pe){const{upperPercent:Pe,lowerPercent:Ie,alphaPercent:je,numericPercent:W}=pe;return Ie>.2&&Pe<.8&&je>.6&&W<.2}function s(pe){let Pe=0,Ie=0,je=0,W=0;for(let Q=0;Q<pe.length;Q++)je=pe.charCodeAt(Q),P(je)&&Pe++,I(je)&&Ie++,k(je)&&W++;return(Pe===0||Ie===0)&&W===0?pe.length<=30:Pe<=5}function v(pe,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!s(pe))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ie=l(Pe);if(!c(Ie)){if(!r(Ie))return null;Pe=Pe.toLowerCase()}let je=null,W=0;for(pe=pe.toLowerCase();W<Pe.length&&(je=t(pe,Pe,0,W))===null;)W=o(Pe,W+1);return je}function f(pe,Pe,Ie=!1){if(!Pe||Pe.length===0)return null;let je=null,W=0;for(pe=pe.toLowerCase(),Pe=Pe.toLowerCase();W<Pe.length&&(je=y(pe,Pe,0,W,Ie),je===null);)W=w(Pe,W+1);return je}function y(pe,Pe,Ie,je,W){let Q=0;if(Ie===pe.length)return[];if(je===Pe.length)return null;if(!g(pe.charCodeAt(Ie),Pe.charCodeAt(je))){const he=n(pe.charCodeAt(Ie));if(!he)return null;for(let we=0;we<he.length;we++)if(!g(he[we],Pe.charCodeAt(je+we)))return null;Q+=he.length-1}let X=null,Z=je+Q+1;if(X=y(pe,Pe,Ie+1,Z,W),!W)for(;!X&&(Z=w(Pe,Z))<Pe.length;)X=y(pe,Pe,Ie+1,Z,W),Z++;if(!X)return null;if(pe.charCodeAt(Ie)!==Pe.charCodeAt(je)){const he=n(pe.charCodeAt(Ie));if(!he)return X;for(let we=0;we<he.length;we++)if(he[we]!==Pe.charCodeAt(je+we))return X}return d({start:je,end:je+Q+1},X)}function w(pe,Pe){for(let Ie=Pe;Ie<pe.length;Ie++)if(h(pe.charCodeAt(Ie))||Ie>0&&h(pe.charCodeAt(Ie-1)))return Ie;return pe.length}const D=R(e.$yk,v,$),S=R(e.$yk,v,m),C=new a.$Ec(1e4);function j(pe,Pe,Ie=!1){if(typeof pe!="string"||typeof Pe!="string")return null;let je=C.get(pe);je||(je=new RegExp(A.$hf(pe),"i"),C.set(pe,je));const W=je.exec(Pe);return W?[{start:W.index,end:W.index+W[0].length}]:Ie?S(pe,Pe):D(pe,Pe)}function B(pe,Pe){const Ie=se(pe,pe.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?T(Ie):null}function z(pe,Pe,Ie,je,W,Q){const X=Math.min(13,pe.length);for(;Ie<X;Ie++){const Z=se(pe,Pe,Ie,je,W,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,Q]}function T(pe){if(typeof pe>"u")return[];const Pe=[],Ie=pe[1];for(let je=pe.length-1;je>1;je--){const W=pe[je]+Ie,Q=Pe[Pe.length-1];Q&&Q.end===W?Q.end=W+1:Pe.push({start:W,end:W+1})}return Pe}const M=128;function F(){const pe=[],Pe=[];for(let Ie=0;Ie<=M;Ie++)Pe[Ie]=0;for(let Ie=0;Ie<=M;Ie++)pe.push(Pe.slice(0));return pe}function O(pe){const Pe=[];for(let Ie=0;Ie<=pe;Ie++)Pe[Ie]=0;return Pe}const q=O(2*M),Y=O(2*M),V=F(),J=F(),x=F(),ne=!1;function de(pe,Pe,Ie,je,W){function Q(Z,he,we=" "){for(;Z.length<he;)Z=we+Z;return Z}let X=` |   |${je.split("").map(Z=>Q(Z,3)).join("|")}
`;for(let Z=0;Z<=Ie;Z++)Z===0?X+=" |":X+=`${Pe[Z-1]}|`,X+=pe[Z].slice(0,W+1).map(he=>Q(he.toString(),3)).join("|")+`
`;return X}function ce(pe,Pe,Ie,je){pe=pe.substr(Pe),Ie=Ie.substr(je),console.log(de(J,pe,pe.length,Ie,Ie.length)),console.log(de(x,pe,pe.length,Ie,Ie.length)),console.log(de(V,pe,pe.length,Ie,Ie.length))}function ve(pe,Pe){if(Pe<0||Pe>=pe.length)return!1;const Ie=pe.codePointAt(Pe);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$Rf(Ie)}}function _(pe,Pe){if(Pe<0||Pe>=pe.length)return!1;switch(pe.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(pe,Pe,Ie){return Pe[pe]!==Ie[pe]}function le(pe,Pe,Ie,je,W,Q,X=!1){for(;Pe<Ie&&W<Q;)pe[Pe]===je[W]&&(X&&(q[Pe]=W),Pe+=1),W+=1;return Pe===Ie}var De;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(De||(De={}));var $e;(function(pe){pe.Default=[-100,0];function Pe(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}pe.isDefault=Pe})($e||(e.FuzzyScore=$e={}));class re{constructor(Pe,Ie){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ie}}e.$Jk=re,re.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function se(pe,Pe,Ie,je,W,Q,X=re.default){const Z=pe.length>M?M:pe.length,he=je.length>M?M:je.length;if(Ie>=Z||Q>=he||Z-Ie>he-Q||!le(Pe,Ie,Z,W,Q,he,!0))return;oe(Z,he,Ie,Q,Pe,W);let we=1,Te=1,He=Ie,Xe=Q;const et=[!1];for(we=1,He=Ie;He<Z;we++,He++){const Ne=q[He],Ve=Y[He],Ae=He+1<Z?Y[He+1]:he;for(Te=Ne-Q+1,Xe=Ne;Xe<Ae;Te++,Xe++){let Ge=Number.MIN_SAFE_INTEGER,ae=!1;Xe<=Ve&&(Ge=K(pe,Pe,He,Ie,je,W,Xe,he,Q,V[we-1][Te-1]===0,et));let ue=0;Ge!==Number.MAX_SAFE_INTEGER&&(ae=!0,ue=Ge+J[we-1][Te-1]);const Ce=Xe>Ne,Ke=Ce?J[we][Te-1]+(V[we][Te-1]>0?-5:0):0,Oe=Xe>Ne+1&&V[we][Te-1]>0,nt=Oe?J[we][Te-2]+(V[we][Te-2]>0?-5:0):0;if(Oe&&(!Ce||nt>=Ke)&&(!ae||nt>=ue))J[we][Te]=nt,x[we][Te]=3,V[we][Te]=0;else if(Ce&&(!ae||Ke>=ue))J[we][Te]=Ke,x[we][Te]=2,V[we][Te]=0;else if(ae)J[we][Te]=ue,x[we][Te]=1,V[we][Te]=V[we-1][Te-1]+1;else throw new Error("not possible")}}if(ne&&ce(pe,Ie,je,Q),!et[0]&&!X.firstMatchCanBeWeak)return;we--,Te--;const rt=[J[we][Te],Q];let at=0,ot=0;for(;we>=1;){let Ne=Te;do{const Ve=x[we][Ne];if(Ve===3)Ne=Ne-2;else if(Ve===2)Ne=Ne-1;else break}while(Ne>=1);at>1&&Pe[Ie+we-1]===W[Q+Te-1]&&!U(Ne+Q-1,je,W)&&at+1>V[we][Ne]&&(Ne=Te),Ne===Te?at++:at=1,ot||(ot=Ne),we--,Te=Ne-1,rt.push(Te)}he===Z&&X.boostFullMatch&&(rt[0]+=2);const ct=ot-Z;return rt[0]-=ct,rt}function oe(pe,Pe,Ie,je,W,Q){let X=pe-1,Z=Pe-1;for(;X>=Ie&&Z>=je;)W[X]===Q[Z]&&(Y[X]=Z,X--),Z--}function K(pe,Pe,Ie,je,W,Q,X,Z,he,we,Te){if(Pe[Ie]!==Q[X])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return X===Ie-je?He=pe[Ie]===W[X]?7:5:U(X,W,Q)&&(X===0||!U(X-1,W,Q))?(He=pe[Ie]===W[X]?7:5,Xe=!0):ve(Q,X)&&(X===0||!ve(Q,X-1))?He=5:(ve(Q,X-1)||_(Q,X-1))&&(He=5,Xe=!0),He>1&&Ie===je&&(Te[0]=!0),Xe||(Xe=U(X,W,Q)||ve(Q,X-1)||_(Q,X-1)),Ie===je?X>he&&(He-=Xe?3:5):we?He+=Xe?2:0:He+=Xe?0:1,X+1===Z&&(He-=Xe?3:5),He}function te(pe,Pe,Ie,je,W,Q,X){return be(pe,Pe,Ie,je,W,Q,!0,X)}function ge(pe,Pe,Ie,je,W,Q,X){return be(pe,Pe,Ie,je,W,Q,!1,X)}function be(pe,Pe,Ie,je,W,Q,X,Z){let he=se(pe,Pe,Ie,je,W,Q,Z);if(he&&!X)return he;if(pe.length>=3){const we=Math.min(7,pe.length-1);for(let Te=Ie+1;Te<we;Te++){const He=Re(pe,Te);if(He){const Xe=se(He,He.toLowerCase(),Ie,je,W,Q,Z);Xe&&(Xe[0]-=3,(!he||Xe[0]>he[0])&&(he=Xe))}}}return he}function Re(pe,Pe){if(Pe+1>=pe.length)return;const Ie=pe[Pe],je=pe[Pe+1];if(Ie!==je)return pe.slice(0,Pe)+je+Ie+pe.slice(Pe+2)}}),define(ke[57],Se([1,0,14]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=N,e.$lj=A,e.$mj=R,e.$nj=$,e.$pj=h;function N(u){return A(u,0)}function A(u,n){switch(typeof u){case"object":return u===null?R(349,n):Array.isArray(u)?m(u,n):E(u,n);case"string":return $(u,n);case"boolean":return L(u,n);case"number":return R(u,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(u,n){return(n<<5)-n+u|0}function L(u,n){return R(u?433:863,n)}function $(u,n){n=R(149417,n);for(let i=0,d=u.length;i<d;i++)n=R(u.charCodeAt(i),n);return n}function m(u,n){return n=R(104579,n),u.reduce((i,d)=>A(d,i),n)}function E(u,n){return n=R(181387,n),Object.keys(u).sort().reduce((i,d)=>(i=$(d,i),A(u[d],i)),n)}class I{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=A(n,this.g),this.g}}e.$oj=I;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function b(u,n,i=32){const d=i-n,o=~((1<<d)-1);return(u<<n|(o&u)>>>d)>>>0}function k(u,n=0,i=u.byteLength,d=0){for(let o=0;o<i;o++)u[n+o]=d}function p(u,n,i="0"){for(;u.length<n;)u=i+u;return u}function h(u,n=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(i=>i.toString(16).padStart(2,"0")).join(""):p((u>>>0).toString(16),n/4)}class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const d=this.p;let o=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=n.charCodeAt(0),r=0);;){let c=l;if(a.$Cf(l))if(r+1<i){const s=n.charCodeAt(r+1);a.$Df(s)?(r++,c=a.$Ef(l,s)):c=65533}else{t=l;break}else a.$Df(l)&&(c=65533);if(o=this.w(d,o,c),r++,r<i)l=n.charCodeAt(r);else break}this.r=o,this.u=t}w(n,i,d){return d<128?n[i++]=d:d<2048?(n[i++]=192|(d&1984)>>>6,n[i++]=128|(d&63)>>>0):d<65536?(n[i++]=224|(d&61440)>>>12,n[i++]=128|(d&4032)>>>6,n[i++]=128|(d&63)>>>0):(n[i++]=240|(d&1835008)>>>18,n[i++]=128|(d&258048)>>>12,n[i++]=128|(d&4032)>>>6,n[i++]=128|(d&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=g.g,i=this.q;for(let f=0;f<64;f+=4)n.setUint32(f,i.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)n.setUint32(f,b(n.getUint32(f-12,!1)^n.getUint32(f-32,!1)^n.getUint32(f-56,!1)^n.getUint32(f-64,!1),1),!1);let d=this.h,o=this.l,t=this.m,l=this.n,r=this.o,c,s,v;for(let f=0;f<80;f++)f<20?(c=o&t|~o&l,s=1518500249):f<40?(c=o^t^l,s=1859775393):f<60?(c=o&t|o&l|t&l,s=2400959708):(c=o^t^l,s=3395469782),v=b(d,5)+c+r+s+n.getUint32(f*4,!1)&4294967295,r=l,l=t,t=b(o,30),o=d,d=v;this.h=this.h+d&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$qj=g,g.g=new DataView(new ArrayBuffer(320))}),define(ke[130],Se([1,0,128,129,57,17,12,14]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=I,e.$vr=g,e.$wr=r,e.$xr=D,e.$yr=T,e.$zr=F;const m=0,E=[m,[]];function I(O,q,Y,V){if(!O||!q)return E;const J=O.length,x=q.length;if(J<x)return E;const ne=O.toLowerCase();return P(q,Y,x,O,ne,J,V)}function P(O,q,Y,V,J,x,ne){const de=[],ce=[];for(let le=0;le<Y;le++){const De=le*x,$e=De-x,re=le>0,se=O[le],oe=q[le];for(let K=0;K<x;K++){const te=K>0,ge=De+K,be=ge-1,Re=$e+K-1,pe=te?de[be]:0,Pe=re&&te?de[Re]:0,Ie=re&&te?ce[Re]:0;let je;!Pe&&re?je=0:je=b(se,oe,V,J,K,Ie),je&&Pe+je>=pe&&(ne||re||J.startsWith(q,K))?(ce[ge]=Ie+1,de[ge]=Pe+je):(ce[ge]=m,de[ge]=pe)}}const ve=[];let _=Y-1,U=x-1;for(;_>=0&&U>=0;){const le=_*x+U;ce[le]===m||(ve.push(U),_--),U--}return[de[Y*x-1],ve.reverse()]}function b(O,q,Y,V,J,x){let ne=0;if(!k(q,V[J]))return ne;if(ne+=1,x>0&&(ne+=x*5),O===Y[J]&&(ne+=1),J===0)ne+=8;else{const de=p(Y.charCodeAt(J-1));de?ne+=de:(0,N.$Bk)(Y.charCodeAt(J))&&x===0&&(ne+=2)}return ne}function k(O,q){return O===q?!0:O==="/"||O==="\\"?q==="/"||q==="\\":!1}function p(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function g(O,q,Y=0,V=0){const J=q;return J.values&&J.values.length>1?u(O,J.values,Y,V):n(O,q,Y,V)}function u(O,q,Y,V){let J=0;const x=[];for(const ne of q){const[de,ce]=n(O,ne,Y,V);if(typeof de!="number")return h;J+=de,x.push(...ce)}return[J,y(x)]}function n(O,q,Y,V){const J=(0,N.$Kk)(q.original,q.originalLowercase,Y,O,O.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,N.$Hk)(J)]:h}const i=Object.freeze({score:0}),d=1<<18,o=1<<17,t=65536;function l(O,q,Y,V){const J=V.values?V.values:[V];return(0,A.$kj)({[V.normalized]:{values:J.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:O,description:q,allowNonContiguousMatches:Y}})}function r(O,q,Y,V,J){if(!O||!q.normalized)return i;const x=V.getItemLabel(O);if(!x)return i;const ne=V.getItemDescription(O),de=l(x,ne,Y,q),ce=J[de];if(ce)return ce;const ve=c(x,ne,V.getItemPath(O),q,Y);return J[de]=ve,ve}function c(O,q,Y,V,J){const x=!Y||!V.containsPathSeparator;return Y&&(L.$e?V.pathNormalized===Y:(0,$.$yf)(V.pathNormalized,Y))?{score:d,labelMatch:[{start:0,end:O.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:V.values&&V.values.length>1?s(O,q,Y,V.values,x,J):v(O,q,Y,V,x,J)}function s(O,q,Y,V,J,x){let ne=0;const de=[],ce=[];for(const ve of V){const{score:_,labelMatch:U,descriptionMatch:le}=v(O,q,Y,ve,J,x);if(_===m)return i;ne+=_,U&&de.push(...U),le&&ce.push(...le)}return{score:ne,labelMatch:y(de),descriptionMatch:y(ce)}}function v(O,q,Y,V,J,x){if(J||!q){const[ne,de]=I(O,V.normalized,V.normalizedLowercase,x&&!V.expectContiguousMatch);if(ne){const ce=(0,N.$yk)(V.normalized,O);let ve;if(ce){ve=o;const _=Math.round(V.normalized.length/O.length*100);ve+=_}else ve=t;return{score:ve+ne,labelMatch:ce||f(de)}}}if(q){let ne=q;Y&&(ne=`${q}${R.sep}`);const de=ne.length,ce=`${ne}${O}`,[ve,_]=I(ce,V.normalized,V.normalizedLowercase,x&&!V.expectContiguousMatch);if(ve){const U=f(_),le=[],De=[];return U.forEach($e=>{$e.start<de&&$e.end>de?(le.push({start:0,end:$e.end-de}),De.push({start:$e.start,end:de})):$e.start>=de?le.push({start:$e.start-de,end:$e.end-de}):De.push($e)}),{score:ve,labelMatch:le,descriptionMatch:De}}}return i}function f(O){const q=[];if(!O)return q;let Y;for(const V of O)Y&&Y.end===V?Y.end+=1:(Y={start:V,end:V+1},q.push(Y));return q}function y(O){const q=O.sort((J,x)=>J.start-x.start),Y=[];let V;for(const J of q)!V||!w(V,J)?(V=J,Y.push(J)):(V.start=Math.min(V.start,J.start),V.end=Math.max(V.end,J.end));return Y}function w(O,q){return!(O.end<q.start||q.end<O.start)}function D(O,q,Y,V,J,x){const ne=r(O,Y,V,J,x),de=r(q,Y,V,J,x),ce=ne.score,ve=de.score;if((ce===d||ve===d)&&ce!==ve)return ce===d?-1:1;if(ce>t||ve>t){if(ce!==ve)return ce>ve?-1:1;if(ce<o&&ve<o){const se=C(ne.labelMatch,de.labelMatch);if(se!==0)return se}const $e=J.getItemLabel(O)||"",re=J.getItemLabel(q)||"";if($e.length!==re.length)return $e.length-re.length}if(ce!==ve)return ce>ve?-1:1;const _=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,U=Array.isArray(de.labelMatch)&&de.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const le=S(O,ne,J),De=S(q,de,J);return le&&De&&le!==De?De>le?-1:1:j(O,q,Y,J)}function S(O,q,Y){let V=-1,J=-1;if(q.descriptionMatch&&q.descriptionMatch.length?V=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(V=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(J=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const x=Y.getItemDescription(O);x&&(J+=x.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(J=q.descriptionMatch[q.descriptionMatch.length-1].end);return J-V}function C(O,q){if(!O&&!q||(!O||!O.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!O||!O.length)return 1;const Y=O[0].start,J=O[O.length-1].end-Y,x=q[0].start,de=q[q.length-1].end-x;return J===de?0:de<J?1:-1}function j(O,q,Y,V){const J=V.getItemLabel(O)||"",x=V.getItemLabel(q)||"",ne=V.getItemDescription(O),de=V.getItemDescription(q),ce=J.length+(ne?ne.length:0),ve=x.length+(de?de.length:0);if(ce!==ve)return ce-ve;const _=V.getItemPath(O),U=V.getItemPath(q);return _&&U&&_.length!==U.length?_.length-U.length:J!==x?(0,a.$sr)(J,x,Y.normalized):ne&&de&&ne!==de?(0,a.$sr)(ne,de,Y.normalized):_&&U&&_!==U?(0,a.$sr)(_,U,Y.normalized):0}function B(O){return O.startsWith('"')&&O.endsWith('"')}const z=" ";function T(O){typeof O!="string"&&(O="");const q=O.toLowerCase(),{pathNormalized:Y,normalized:V,normalizedLowercase:J}=M(O),x=Y.indexOf(R.sep)>=0,ne=B(O);let de;const ce=O.split(z);if(ce.length>1)for(const ve of ce){const _=B(ve),{pathNormalized:U,normalized:le,normalizedLowercase:De}=M(ve);le&&(de||(de=[]),de.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:le,normalizedLowercase:De,expectContiguousMatch:_}))}return{original:O,originalLowercase:q,pathNormalized:Y,normalized:V,normalizedLowercase:J,values:de,containsPathSeparator:x,expectContiguousMatch:ne}}function M(O){let q;L.$c?q=O.replace(/\//g,R.sep):q=O.replace(/\\/g,R.sep);const Y=(0,$.$if)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:Y,normalizedLowercase:Y.toLowerCase()}}function F(O){return Array.isArray(O)?T(O.map(q=>q.original).join(z)):T(O.original)}}),define(ke[42],Se([1,0,14]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const R="error",L="warning",$="warn",m="info",E="ignore";function I(b){return b?a.$yf(R,b)?A.Error:a.$yf(L,b)||a.$yf($,b)?A.Warning:a.$yf(m,b)?A.Info:A.Ignore:A.Ignore}A.fromValue=I;function P(b){switch(b){case A.Error:return R;case A.Warning:return L;case A.Info:return m;default:return E}}A.toString=P}(N||(N={})),e.default=N}),define(ke[175],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ke[78],Se([1,0,19,14]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class A{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const p=k.charCodeAt(0),h=this.b.charCodeAt(this.c);return p-h}value(){return this.b[this.c]}}e.$yi=A;class R{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,N.$sf)(k,this.b,0,k.length,this.c,this.d):(0,N.$uf)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=R;class L{constructor(k=!0,p=!0){this.f=k,this.g=p}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let p=k.length-1;p>=0;p--,this.c--){const h=this.b.charCodeAt(p);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,N.$sf)(k,this.b,0,k.length,this.d,this.e):(0,N.$uf)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=L;var $;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})($||($={}));class m{constructor(k,p){this.f=k,this.g=p,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,N.$tf)(k,this.c.scheme);if(this.d[this.e]===2)return(0,N.$tf)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,N.$rf)(k,this.c.query);if(this.d[this.e]===5)return(0,N.$rf)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(I||(I={}));class P{static forUris(k=()=>!1,p=()=>!1){return new P(new m(k,p))}static forPaths(k=!1){return new P(new L(void 0,!k))}static forStrings(){return new P(new A)}static forConfigKeys(){return new P(new R)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,p){if(p){const h=p.slice(0);(0,a.$Xb)(h);for(const g of h)this.set(g,k)}else{const h=k.slice(0);(0,a.$Xb)(h);for(const g of h)this.set(g[0],g[1])}}set(k,p){const h=this.b.reset(k);let g;this.c||(this.c=new E,this.c.segment=h.value());const u=[];for(g=this.c;;){const i=h.cmp(g.segment);if(i>0)g.left||(g.left=new E,g.left.segment=h.value()),u.push([-1,g]),g=g.left;else if(i<0)g.right||(g.right=new E,g.right.segment=h.value()),u.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new E,g.mid.segment=h.value()),u.push([0,g]),g=g.mid;else break}const n=g.value;g.value=p,g.key=k;for(let i=u.length-1;i>=0;i--){const d=u[i][1];d.updateHeight();const o=d.balanceFactor();if(o<-1||o>1){const t=u[i][0],l=u[i+1][0];if(t===1&&l===1)u[i][1]=d.rotateLeft();else if(t===-1&&l===-1)u[i][1]=d.rotateRight();else if(t===1&&l===-1)d.right=u[i+1][1]=u[i+1][1].rotateRight(),u[i][1]=d.rotateLeft();else if(t===-1&&l===1)d.left=u[i+1][1]=u[i+1][1].rotateLeft(),u[i][1]=d.rotateRight();else throw new Error;if(i>0)switch(u[i-1][0]){case-1:u[i-1][1].left=u[i][1];break;case 1:u[i-1][1].right=u[i][1];break;case 0:u[i-1][1].mid=u[i][1];break}else this.c=u[0][1]}}return n}get(k){return this.d(k)?.value}d(k){const p=this.b.reset(k);let h=this.c;for(;h;){const g=p.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else break}return h}has(k){const p=this.d(k);return!(p?.value===void 0&&p?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,p){const h=this.b.reset(k),g=[];let u=this.c;for(;u;){const n=h.cmp(u.segment);if(n>0)g.push([-1,u]),u=u.left;else if(n<0)g.push([1,u]),u=u.right;else if(h.hasNext())h.next(),g.push([0,u]),u=u.mid;else break}if(u){if(p?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const n=this.f(u.right);if(n.key){const{key:i,value:d,segment:o}=n;this.e(n.key,!1),u.key=i,u.value=d,u.segment=o}}else{const n=u.left??u.right;if(g.length>0){const[i,d]=g[g.length-1];switch(i){case-1:d.left=n;break;case 0:d.mid=n;break;case 1:d.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const i=g[n][1];i.updateHeight();const d=i.balanceFactor();if(d>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),g[n][1]=i.rotateLeft()):d<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),g[n][1]=i.rotateRight()),n>0)switch(g[n-1][0]){case-1:g[n-1][1].left=g[n][1];break;case 1:g[n-1][1].right=g[n][1];break;case 0:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const p=this.b.reset(k);let h=this.c,g;for(;h;){const u=p.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(p.hasNext())p.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(k){return this.g(k,!1)}g(k,p){const h=this.b.reset(k);let g=this.c;for(;g;){const u=h.cmp(g.segment);if(u>0)g=g.left;else if(u<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else return g.mid?this.h(g.mid):p?g.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[p,h]of this)k(h,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const p=[];return this.j(k,p),p[Symbol.iterator]()}j(k,p){k&&(k.left&&this.j(k.left,p),k.value&&p.push([k.key,k.value]),k.mid&&this.j(k.mid,p),k.right&&this.j(k.right,p))}_isBalanced(){const k=p=>{if(!p)return!0;const h=p.balanceFactor();return h<-1||h>1?!1:k(p.left)&&k(p.right)};return k(this.c)}}e.$Ci=P}),define(ke[18],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=a,e.$0f=N,e.$$f=A,e.$_f=R,e.$ag=L,e.$bg=$,e.$cg=m,e.$dg=E,e.$eg=I,e.$fg=P,e.$gg=b,e.$hg=k,e.$ig=p,e.$jg=g,e.$kg=u,e.$lg=n,e.$mg=i,e.$ng=d;function a(o){return typeof o=="string"}function N(o){return Array.isArray(o)&&o.every(t=>a(t))}function A(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function L(o){return typeof o=="number"&&!isNaN(o)}function $(o){return!!o&&typeof o[Symbol.iterator]=="function"}function m(o){return o===!0||o===!1}function E(o){return typeof o>"u"}function I(o){return!P(o)}function P(o){return E(o)||o===null}function b(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function k(o){if(P(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function p(...o){const t=[];for(let l=0;l<o.length;l++){const r=o[l];if(P(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}const h=Object.prototype.hasOwnProperty;function g(o){if(!A(o))return!1;for(const t in o)if(h.call(o,t))return!1;return!0}function u(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(u)}function i(o,t){const l=Math.min(o.length,t.length);for(let r=0;r<l;r++)d(o[r],t[r])}function d(o,t){if(a(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(o instanceof t)return}catch{}if(!P(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[101],Se([1,0,18]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=A,e.$Rj=R;const N=Object.create(null);function A(L,$){if((0,a.$9f)($)){const m=N[$];if(m===void 0)throw new Error(`${L} references an unknown codicon: ${$}`);$=m}return N[L]=$,{id:L}}function R(){return N}}),define(ke[176],Se([1,0,101]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,a.$Qj)("add",6e4),plus:(0,a.$Qj)("plus",6e4),gistNew:(0,a.$Qj)("gist-new",6e4),repoCreate:(0,a.$Qj)("repo-create",6e4),lightbulb:(0,a.$Qj)("lightbulb",60001),lightBulb:(0,a.$Qj)("light-bulb",60001),repo:(0,a.$Qj)("repo",60002),repoDelete:(0,a.$Qj)("repo-delete",60002),gistFork:(0,a.$Qj)("gist-fork",60003),repoForked:(0,a.$Qj)("repo-forked",60003),gitPullRequest:(0,a.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,a.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,a.$Qj)("record-keys",60005),keyboard:(0,a.$Qj)("keyboard",60005),tag:(0,a.$Qj)("tag",60006),gitPullRequestLabel:(0,a.$Qj)("git-pull-request-label",60006),tagAdd:(0,a.$Qj)("tag-add",60006),tagRemove:(0,a.$Qj)("tag-remove",60006),person:(0,a.$Qj)("person",60007),personFollow:(0,a.$Qj)("person-follow",60007),personOutline:(0,a.$Qj)("person-outline",60007),personFilled:(0,a.$Qj)("person-filled",60007),gitBranch:(0,a.$Qj)("git-branch",60008),gitBranchCreate:(0,a.$Qj)("git-branch-create",60008),gitBranchDelete:(0,a.$Qj)("git-branch-delete",60008),sourceControl:(0,a.$Qj)("source-control",60008),mirror:(0,a.$Qj)("mirror",60009),mirrorPublic:(0,a.$Qj)("mirror-public",60009),star:(0,a.$Qj)("star",60010),starAdd:(0,a.$Qj)("star-add",60010),starDelete:(0,a.$Qj)("star-delete",60010),starEmpty:(0,a.$Qj)("star-empty",60010),comment:(0,a.$Qj)("comment",60011),commentAdd:(0,a.$Qj)("comment-add",60011),alert:(0,a.$Qj)("alert",60012),warning:(0,a.$Qj)("warning",60012),search:(0,a.$Qj)("search",60013),searchSave:(0,a.$Qj)("search-save",60013),logOut:(0,a.$Qj)("log-out",60014),signOut:(0,a.$Qj)("sign-out",60014),logIn:(0,a.$Qj)("log-in",60015),signIn:(0,a.$Qj)("sign-in",60015),eye:(0,a.$Qj)("eye",60016),eyeUnwatch:(0,a.$Qj)("eye-unwatch",60016),eyeWatch:(0,a.$Qj)("eye-watch",60016),circleFilled:(0,a.$Qj)("circle-filled",60017),primitiveDot:(0,a.$Qj)("primitive-dot",60017),closeDirty:(0,a.$Qj)("close-dirty",60017),debugBreakpoint:(0,a.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,a.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,a.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,a.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,a.$Qj)("primitive-square",60018),edit:(0,a.$Qj)("edit",60019),pencil:(0,a.$Qj)("pencil",60019),info:(0,a.$Qj)("info",60020),issueOpened:(0,a.$Qj)("issue-opened",60020),gistPrivate:(0,a.$Qj)("gist-private",60021),gitForkPrivate:(0,a.$Qj)("git-fork-private",60021),lock:(0,a.$Qj)("lock",60021),mirrorPrivate:(0,a.$Qj)("mirror-private",60021),close:(0,a.$Qj)("close",60022),removeClose:(0,a.$Qj)("remove-close",60022),x:(0,a.$Qj)("x",60022),repoSync:(0,a.$Qj)("repo-sync",60023),sync:(0,a.$Qj)("sync",60023),clone:(0,a.$Qj)("clone",60024),desktopDownload:(0,a.$Qj)("desktop-download",60024),beaker:(0,a.$Qj)("beaker",60025),microscope:(0,a.$Qj)("microscope",60025),vm:(0,a.$Qj)("vm",60026),deviceDesktop:(0,a.$Qj)("device-desktop",60026),file:(0,a.$Qj)("file",60027),fileText:(0,a.$Qj)("file-text",60027),more:(0,a.$Qj)("more",60028),ellipsis:(0,a.$Qj)("ellipsis",60028),kebabHorizontal:(0,a.$Qj)("kebab-horizontal",60028),mailReply:(0,a.$Qj)("mail-reply",60029),reply:(0,a.$Qj)("reply",60029),organization:(0,a.$Qj)("organization",60030),organizationFilled:(0,a.$Qj)("organization-filled",60030),organizationOutline:(0,a.$Qj)("organization-outline",60030),newFile:(0,a.$Qj)("new-file",60031),fileAdd:(0,a.$Qj)("file-add",60031),newFolder:(0,a.$Qj)("new-folder",60032),fileDirectoryCreate:(0,a.$Qj)("file-directory-create",60032),trash:(0,a.$Qj)("trash",60033),trashcan:(0,a.$Qj)("trashcan",60033),history:(0,a.$Qj)("history",60034),clock:(0,a.$Qj)("clock",60034),folder:(0,a.$Qj)("folder",60035),fileDirectory:(0,a.$Qj)("file-directory",60035),symbolFolder:(0,a.$Qj)("symbol-folder",60035),logoGithub:(0,a.$Qj)("logo-github",60036),markGithub:(0,a.$Qj)("mark-github",60036),github:(0,a.$Qj)("github",60036),terminal:(0,a.$Qj)("terminal",60037),console:(0,a.$Qj)("console",60037),repl:(0,a.$Qj)("repl",60037),zap:(0,a.$Qj)("zap",60038),symbolEvent:(0,a.$Qj)("symbol-event",60038),error:(0,a.$Qj)("error",60039),stop:(0,a.$Qj)("stop",60039),variable:(0,a.$Qj)("variable",60040),symbolVariable:(0,a.$Qj)("symbol-variable",60040),array:(0,a.$Qj)("array",60042),symbolArray:(0,a.$Qj)("symbol-array",60042),symbolModule:(0,a.$Qj)("symbol-module",60043),symbolPackage:(0,a.$Qj)("symbol-package",60043),symbolNamespace:(0,a.$Qj)("symbol-namespace",60043),symbolObject:(0,a.$Qj)("symbol-object",60043),symbolMethod:(0,a.$Qj)("symbol-method",60044),symbolFunction:(0,a.$Qj)("symbol-function",60044),symbolConstructor:(0,a.$Qj)("symbol-constructor",60044),symbolBoolean:(0,a.$Qj)("symbol-boolean",60047),symbolNull:(0,a.$Qj)("symbol-null",60047),symbolNumeric:(0,a.$Qj)("symbol-numeric",60048),symbolNumber:(0,a.$Qj)("symbol-number",60048),symbolStructure:(0,a.$Qj)("symbol-structure",60049),symbolStruct:(0,a.$Qj)("symbol-struct",60049),symbolParameter:(0,a.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,a.$Qj)("symbol-type-parameter",60050),symbolKey:(0,a.$Qj)("symbol-key",60051),symbolText:(0,a.$Qj)("symbol-text",60051),symbolReference:(0,a.$Qj)("symbol-reference",60052),goToFile:(0,a.$Qj)("go-to-file",60052),symbolEnum:(0,a.$Qj)("symbol-enum",60053),symbolValue:(0,a.$Qj)("symbol-value",60053),symbolRuler:(0,a.$Qj)("symbol-ruler",60054),symbolUnit:(0,a.$Qj)("symbol-unit",60054),activateBreakpoints:(0,a.$Qj)("activate-breakpoints",60055),archive:(0,a.$Qj)("archive",60056),arrowBoth:(0,a.$Qj)("arrow-both",60057),arrowDown:(0,a.$Qj)("arrow-down",60058),arrowLeft:(0,a.$Qj)("arrow-left",60059),arrowRight:(0,a.$Qj)("arrow-right",60060),arrowSmallDown:(0,a.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,a.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,a.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,a.$Qj)("arrow-small-up",60064),arrowUp:(0,a.$Qj)("arrow-up",60065),bell:(0,a.$Qj)("bell",60066),bold:(0,a.$Qj)("bold",60067),book:(0,a.$Qj)("book",60068),bookmark:(0,a.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,a.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,a.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,a.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,a.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,a.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,a.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,a.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,a.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,a.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,a.$Qj)("briefcase",60076),broadcast:(0,a.$Qj)("broadcast",60077),browser:(0,a.$Qj)("browser",60078),bug:(0,a.$Qj)("bug",60079),calendar:(0,a.$Qj)("calendar",60080),caseSensitive:(0,a.$Qj)("case-sensitive",60081),check:(0,a.$Qj)("check",60082),checklist:(0,a.$Qj)("checklist",60083),chevronDown:(0,a.$Qj)("chevron-down",60084),chevronLeft:(0,a.$Qj)("chevron-left",60085),chevronRight:(0,a.$Qj)("chevron-right",60086),chevronUp:(0,a.$Qj)("chevron-up",60087),chromeClose:(0,a.$Qj)("chrome-close",60088),chromeMaximize:(0,a.$Qj)("chrome-maximize",60089),chromeMinimize:(0,a.$Qj)("chrome-minimize",60090),chromeRestore:(0,a.$Qj)("chrome-restore",60091),circleOutline:(0,a.$Qj)("circle-outline",60092),circle:(0,a.$Qj)("circle",60092),debugBreakpointUnverified:(0,a.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,a.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,a.$Qj)("circle-slash",60093),circuitBoard:(0,a.$Qj)("circuit-board",60094),clearAll:(0,a.$Qj)("clear-all",60095),clippy:(0,a.$Qj)("clippy",60096),closeAll:(0,a.$Qj)("close-all",60097),cloudDownload:(0,a.$Qj)("cloud-download",60098),cloudUpload:(0,a.$Qj)("cloud-upload",60099),code:(0,a.$Qj)("code",60100),collapseAll:(0,a.$Qj)("collapse-all",60101),colorMode:(0,a.$Qj)("color-mode",60102),commentDiscussion:(0,a.$Qj)("comment-discussion",60103),creditCard:(0,a.$Qj)("credit-card",60105),dash:(0,a.$Qj)("dash",60108),dashboard:(0,a.$Qj)("dashboard",60109),database:(0,a.$Qj)("database",60110),debugContinue:(0,a.$Qj)("debug-continue",60111),debugDisconnect:(0,a.$Qj)("debug-disconnect",60112),debugPause:(0,a.$Qj)("debug-pause",60113),debugRestart:(0,a.$Qj)("debug-restart",60114),debugStart:(0,a.$Qj)("debug-start",60115),debugStepInto:(0,a.$Qj)("debug-step-into",60116),debugStepOut:(0,a.$Qj)("debug-step-out",60117),debugStepOver:(0,a.$Qj)("debug-step-over",60118),debugStop:(0,a.$Qj)("debug-stop",60119),debug:(0,a.$Qj)("debug",60120),deviceCameraVideo:(0,a.$Qj)("device-camera-video",60121),deviceCamera:(0,a.$Qj)("device-camera",60122),deviceMobile:(0,a.$Qj)("device-mobile",60123),diffAdded:(0,a.$Qj)("diff-added",60124),diffIgnored:(0,a.$Qj)("diff-ignored",60125),diffModified:(0,a.$Qj)("diff-modified",60126),diffRemoved:(0,a.$Qj)("diff-removed",60127),diffRenamed:(0,a.$Qj)("diff-renamed",60128),diff:(0,a.$Qj)("diff",60129),diffSidebyside:(0,a.$Qj)("diff-sidebyside",60129),discard:(0,a.$Qj)("discard",60130),editorLayout:(0,a.$Qj)("editor-layout",60131),emptyWindow:(0,a.$Qj)("empty-window",60132),exclude:(0,a.$Qj)("exclude",60133),extensions:(0,a.$Qj)("extensions",60134),eyeClosed:(0,a.$Qj)("eye-closed",60135),fileBinary:(0,a.$Qj)("file-binary",60136),fileCode:(0,a.$Qj)("file-code",60137),fileMedia:(0,a.$Qj)("file-media",60138),filePdf:(0,a.$Qj)("file-pdf",60139),fileSubmodule:(0,a.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,a.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,a.$Qj)("file-symlink-file",60142),fileZip:(0,a.$Qj)("file-zip",60143),files:(0,a.$Qj)("files",60144),filter:(0,a.$Qj)("filter",60145),flame:(0,a.$Qj)("flame",60146),foldDown:(0,a.$Qj)("fold-down",60147),foldUp:(0,a.$Qj)("fold-up",60148),fold:(0,a.$Qj)("fold",60149),folderActive:(0,a.$Qj)("folder-active",60150),folderOpened:(0,a.$Qj)("folder-opened",60151),gear:(0,a.$Qj)("gear",60152),gift:(0,a.$Qj)("gift",60153),gistSecret:(0,a.$Qj)("gist-secret",60154),gist:(0,a.$Qj)("gist",60155),gitCommit:(0,a.$Qj)("git-commit",60156),gitCompare:(0,a.$Qj)("git-compare",60157),compareChanges:(0,a.$Qj)("compare-changes",60157),gitMerge:(0,a.$Qj)("git-merge",60158),githubAction:(0,a.$Qj)("github-action",60159),githubAlt:(0,a.$Qj)("github-alt",60160),globe:(0,a.$Qj)("globe",60161),grabber:(0,a.$Qj)("grabber",60162),graph:(0,a.$Qj)("graph",60163),gripper:(0,a.$Qj)("gripper",60164),heart:(0,a.$Qj)("heart",60165),home:(0,a.$Qj)("home",60166),horizontalRule:(0,a.$Qj)("horizontal-rule",60167),hubot:(0,a.$Qj)("hubot",60168),inbox:(0,a.$Qj)("inbox",60169),issueReopened:(0,a.$Qj)("issue-reopened",60171),issues:(0,a.$Qj)("issues",60172),italic:(0,a.$Qj)("italic",60173),jersey:(0,a.$Qj)("jersey",60174),json:(0,a.$Qj)("json",60175),kebabVertical:(0,a.$Qj)("kebab-vertical",60176),key:(0,a.$Qj)("key",60177),law:(0,a.$Qj)("law",60178),lightbulbAutofix:(0,a.$Qj)("lightbulb-autofix",60179),linkExternal:(0,a.$Qj)("link-external",60180),link:(0,a.$Qj)("link",60181),listOrdered:(0,a.$Qj)("list-ordered",60182),listUnordered:(0,a.$Qj)("list-unordered",60183),liveShare:(0,a.$Qj)("live-share",60184),loading:(0,a.$Qj)("loading",60185),location:(0,a.$Qj)("location",60186),mailRead:(0,a.$Qj)("mail-read",60187),mail:(0,a.$Qj)("mail",60188),markdown:(0,a.$Qj)("markdown",60189),megaphone:(0,a.$Qj)("megaphone",60190),mention:(0,a.$Qj)("mention",60191),milestone:(0,a.$Qj)("milestone",60192),gitPullRequestMilestone:(0,a.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,a.$Qj)("mortar-board",60193),move:(0,a.$Qj)("move",60194),multipleWindows:(0,a.$Qj)("multiple-windows",60195),mute:(0,a.$Qj)("mute",60196),noNewline:(0,a.$Qj)("no-newline",60197),note:(0,a.$Qj)("note",60198),octoface:(0,a.$Qj)("octoface",60199),openPreview:(0,a.$Qj)("open-preview",60200),package:(0,a.$Qj)("package",60201),paintcan:(0,a.$Qj)("paintcan",60202),pin:(0,a.$Qj)("pin",60203),play:(0,a.$Qj)("play",60204),run:(0,a.$Qj)("run",60204),plug:(0,a.$Qj)("plug",60205),preserveCase:(0,a.$Qj)("preserve-case",60206),preview:(0,a.$Qj)("preview",60207),project:(0,a.$Qj)("project",60208),pulse:(0,a.$Qj)("pulse",60209),question:(0,a.$Qj)("question",60210),quote:(0,a.$Qj)("quote",60211),radioTower:(0,a.$Qj)("radio-tower",60212),reactions:(0,a.$Qj)("reactions",60213),references:(0,a.$Qj)("references",60214),refresh:(0,a.$Qj)("refresh",60215),regex:(0,a.$Qj)("regex",60216),remoteExplorer:(0,a.$Qj)("remote-explorer",60217),remote:(0,a.$Qj)("remote",60218),remove:(0,a.$Qj)("remove",60219),replaceAll:(0,a.$Qj)("replace-all",60220),replace:(0,a.$Qj)("replace",60221),repoClone:(0,a.$Qj)("repo-clone",60222),repoForcePush:(0,a.$Qj)("repo-force-push",60223),repoPull:(0,a.$Qj)("repo-pull",60224),repoPush:(0,a.$Qj)("repo-push",60225),report:(0,a.$Qj)("report",60226),requestChanges:(0,a.$Qj)("request-changes",60227),rocket:(0,a.$Qj)("rocket",60228),rootFolderOpened:(0,a.$Qj)("root-folder-opened",60229),rootFolder:(0,a.$Qj)("root-folder",60230),rss:(0,a.$Qj)("rss",60231),ruby:(0,a.$Qj)("ruby",60232),saveAll:(0,a.$Qj)("save-all",60233),saveAs:(0,a.$Qj)("save-as",60234),save:(0,a.$Qj)("save",60235),screenFull:(0,a.$Qj)("screen-full",60236),screenNormal:(0,a.$Qj)("screen-normal",60237),searchStop:(0,a.$Qj)("search-stop",60238),server:(0,a.$Qj)("server",60240),settingsGear:(0,a.$Qj)("settings-gear",60241),settings:(0,a.$Qj)("settings",60242),shield:(0,a.$Qj)("shield",60243),smiley:(0,a.$Qj)("smiley",60244),sortPrecedence:(0,a.$Qj)("sort-precedence",60245),splitHorizontal:(0,a.$Qj)("split-horizontal",60246),splitVertical:(0,a.$Qj)("split-vertical",60247),squirrel:(0,a.$Qj)("squirrel",60248),starFull:(0,a.$Qj)("star-full",60249),starHalf:(0,a.$Qj)("star-half",60250),symbolClass:(0,a.$Qj)("symbol-class",60251),symbolColor:(0,a.$Qj)("symbol-color",60252),symbolConstant:(0,a.$Qj)("symbol-constant",60253),symbolEnumMember:(0,a.$Qj)("symbol-enum-member",60254),symbolField:(0,a.$Qj)("symbol-field",60255),symbolFile:(0,a.$Qj)("symbol-file",60256),symbolInterface:(0,a.$Qj)("symbol-interface",60257),symbolKeyword:(0,a.$Qj)("symbol-keyword",60258),symbolMisc:(0,a.$Qj)("symbol-misc",60259),symbolOperator:(0,a.$Qj)("symbol-operator",60260),symbolProperty:(0,a.$Qj)("symbol-property",60261),wrench:(0,a.$Qj)("wrench",60261),wrenchSubaction:(0,a.$Qj)("wrench-subaction",60261),symbolSnippet:(0,a.$Qj)("symbol-snippet",60262),tasklist:(0,a.$Qj)("tasklist",60263),telescope:(0,a.$Qj)("telescope",60264),textSize:(0,a.$Qj)("text-size",60265),threeBars:(0,a.$Qj)("three-bars",60266),thumbsdown:(0,a.$Qj)("thumbsdown",60267),thumbsup:(0,a.$Qj)("thumbsup",60268),tools:(0,a.$Qj)("tools",60269),triangleDown:(0,a.$Qj)("triangle-down",60270),triangleLeft:(0,a.$Qj)("triangle-left",60271),triangleRight:(0,a.$Qj)("triangle-right",60272),triangleUp:(0,a.$Qj)("triangle-up",60273),twitter:(0,a.$Qj)("twitter",60274),unfold:(0,a.$Qj)("unfold",60275),unlock:(0,a.$Qj)("unlock",60276),unmute:(0,a.$Qj)("unmute",60277),unverified:(0,a.$Qj)("unverified",60278),verified:(0,a.$Qj)("verified",60279),versions:(0,a.$Qj)("versions",60280),vmActive:(0,a.$Qj)("vm-active",60281),vmOutline:(0,a.$Qj)("vm-outline",60282),vmRunning:(0,a.$Qj)("vm-running",60283),watch:(0,a.$Qj)("watch",60284),whitespace:(0,a.$Qj)("whitespace",60285),wholeWord:(0,a.$Qj)("whole-word",60286),window:(0,a.$Qj)("window",60287),wordWrap:(0,a.$Qj)("word-wrap",60288),zoomIn:(0,a.$Qj)("zoom-in",60289),zoomOut:(0,a.$Qj)("zoom-out",60290),listFilter:(0,a.$Qj)("list-filter",60291),listFlat:(0,a.$Qj)("list-flat",60292),listSelection:(0,a.$Qj)("list-selection",60293),selection:(0,a.$Qj)("selection",60293),listTree:(0,a.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,a.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,a.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,a.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,a.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,a.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,a.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,a.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,a.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,a.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,a.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,a.$Qj)("symbol-string",60301),debugReverseContinue:(0,a.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,a.$Qj)("debug-step-back",60303),debugRestartFrame:(0,a.$Qj)("debug-restart-frame",60304),debugAlt:(0,a.$Qj)("debug-alt",60305),callIncoming:(0,a.$Qj)("call-incoming",60306),callOutgoing:(0,a.$Qj)("call-outgoing",60307),menu:(0,a.$Qj)("menu",60308),expandAll:(0,a.$Qj)("expand-all",60309),feedback:(0,a.$Qj)("feedback",60310),gitPullRequestReviewer:(0,a.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,a.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,a.$Qj)("ungroup-by-ref-type",60312),account:(0,a.$Qj)("account",60313),gitPullRequestAssignee:(0,a.$Qj)("git-pull-request-assignee",60313),bellDot:(0,a.$Qj)("bell-dot",60314),debugConsole:(0,a.$Qj)("debug-console",60315),library:(0,a.$Qj)("library",60316),output:(0,a.$Qj)("output",60317),runAll:(0,a.$Qj)("run-all",60318),syncIgnored:(0,a.$Qj)("sync-ignored",60319),pinned:(0,a.$Qj)("pinned",60320),githubInverted:(0,a.$Qj)("github-inverted",60321),serverProcess:(0,a.$Qj)("server-process",60322),serverEnvironment:(0,a.$Qj)("server-environment",60323),pass:(0,a.$Qj)("pass",60324),issueClosed:(0,a.$Qj)("issue-closed",60324),stopCircle:(0,a.$Qj)("stop-circle",60325),playCircle:(0,a.$Qj)("play-circle",60326),record:(0,a.$Qj)("record",60327),debugAltSmall:(0,a.$Qj)("debug-alt-small",60328),vmConnect:(0,a.$Qj)("vm-connect",60329),cloud:(0,a.$Qj)("cloud",60330),merge:(0,a.$Qj)("merge",60331),export:(0,a.$Qj)("export",60332),graphLeft:(0,a.$Qj)("graph-left",60333),magnet:(0,a.$Qj)("magnet",60334),notebook:(0,a.$Qj)("notebook",60335),redo:(0,a.$Qj)("redo",60336),checkAll:(0,a.$Qj)("check-all",60337),pinnedDirty:(0,a.$Qj)("pinned-dirty",60338),passFilled:(0,a.$Qj)("pass-filled",60339),circleLargeFilled:(0,a.$Qj)("circle-large-filled",60340),circleLarge:(0,a.$Qj)("circle-large",60341),circleLargeOutline:(0,a.$Qj)("circle-large-outline",60341),combine:(0,a.$Qj)("combine",60342),gather:(0,a.$Qj)("gather",60342),table:(0,a.$Qj)("table",60343),variableGroup:(0,a.$Qj)("variable-group",60344),typeHierarchy:(0,a.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,a.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,a.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,a.$Qj)("git-pull-request-create",60348),runAbove:(0,a.$Qj)("run-above",60349),runBelow:(0,a.$Qj)("run-below",60350),notebookTemplate:(0,a.$Qj)("notebook-template",60351),debugRerun:(0,a.$Qj)("debug-rerun",60352),workspaceTrusted:(0,a.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,a.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,a.$Qj)("workspace-unknown",60355),terminalCmd:(0,a.$Qj)("terminal-cmd",60356),terminalDebian:(0,a.$Qj)("terminal-debian",60357),terminalLinux:(0,a.$Qj)("terminal-linux",60358),terminalPowershell:(0,a.$Qj)("terminal-powershell",60359),terminalTmux:(0,a.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,a.$Qj)("terminal-ubuntu",60361),terminalBash:(0,a.$Qj)("terminal-bash",60362),arrowSwap:(0,a.$Qj)("arrow-swap",60363),copy:(0,a.$Qj)("copy",60364),personAdd:(0,a.$Qj)("person-add",60365),filterFilled:(0,a.$Qj)("filter-filled",60366),wand:(0,a.$Qj)("wand",60367),debugLineByLine:(0,a.$Qj)("debug-line-by-line",60368),inspect:(0,a.$Qj)("inspect",60369),layers:(0,a.$Qj)("layers",60370),layersDot:(0,a.$Qj)("layers-dot",60371),layersActive:(0,a.$Qj)("layers-active",60372),compass:(0,a.$Qj)("compass",60373),compassDot:(0,a.$Qj)("compass-dot",60374),compassActive:(0,a.$Qj)("compass-active",60375),azure:(0,a.$Qj)("azure",60376),issueDraft:(0,a.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,a.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,a.$Qj)("git-pull-request-draft",60379),debugAll:(0,a.$Qj)("debug-all",60380),debugCoverage:(0,a.$Qj)("debug-coverage",60381),runErrors:(0,a.$Qj)("run-errors",60382),folderLibrary:(0,a.$Qj)("folder-library",60383),debugContinueSmall:(0,a.$Qj)("debug-continue-small",60384),beakerStop:(0,a.$Qj)("beaker-stop",60385),graphLine:(0,a.$Qj)("graph-line",60386),graphScatter:(0,a.$Qj)("graph-scatter",60387),pieChart:(0,a.$Qj)("pie-chart",60388),bracket:(0,a.$Qj)("bracket",60175),bracketDot:(0,a.$Qj)("bracket-dot",60389),bracketError:(0,a.$Qj)("bracket-error",60390),lockSmall:(0,a.$Qj)("lock-small",60391),azureDevops:(0,a.$Qj)("azure-devops",60392),verifiedFilled:(0,a.$Qj)("verified-filled",60393),newline:(0,a.$Qj)("newline",60394),layout:(0,a.$Qj)("layout",60395),layoutActivitybarLeft:(0,a.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,a.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,a.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,a.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,a.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,a.$Qj)("layout-panel-right",60401),layoutPanel:(0,a.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,a.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,a.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,a.$Qj)("layout-statusbar",60405),layoutMenubar:(0,a.$Qj)("layout-menubar",60406),layoutCentered:(0,a.$Qj)("layout-centered",60407),target:(0,a.$Qj)("target",60408),indent:(0,a.$Qj)("indent",60409),recordSmall:(0,a.$Qj)("record-small",60410),errorSmall:(0,a.$Qj)("error-small",60411),terminalDecorationError:(0,a.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,a.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,a.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,a.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,a.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,a.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,a.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,a.$Qj)("layout-sidebar-left-off",60418),blank:(0,a.$Qj)("blank",60419),heartFilled:(0,a.$Qj)("heart-filled",60420),map:(0,a.$Qj)("map",60421),mapHorizontal:(0,a.$Qj)("map-horizontal",60421),foldHorizontal:(0,a.$Qj)("fold-horizontal",60421),mapFilled:(0,a.$Qj)("map-filled",60422),mapHorizontalFilled:(0,a.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,a.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,a.$Qj)("circle-small",60423),bellSlash:(0,a.$Qj)("bell-slash",60424),bellSlashDot:(0,a.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,a.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,a.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,a.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,a.$Qj)("search-fuzzy",60429),commentDraft:(0,a.$Qj)("comment-draft",60430),send:(0,a.$Qj)("send",60431),sparkle:(0,a.$Qj)("sparkle",60432),insert:(0,a.$Qj)("insert",60433),mic:(0,a.$Qj)("mic",60434),thumbsdownFilled:(0,a.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,a.$Qj)("thumbsup-filled",60436),coffee:(0,a.$Qj)("coffee",60437),snake:(0,a.$Qj)("snake",60438),game:(0,a.$Qj)("game",60439),vr:(0,a.$Qj)("vr",60440),chip:(0,a.$Qj)("chip",60441),piano:(0,a.$Qj)("piano",60442),music:(0,a.$Qj)("music",60443),micFilled:(0,a.$Qj)("mic-filled",60444),repoFetch:(0,a.$Qj)("repo-fetch",60445),copilot:(0,a.$Qj)("copilot",60446),lightbulbSparkle:(0,a.$Qj)("lightbulb-sparkle",60447),robot:(0,a.$Qj)("robot",60448),sparkleFilled:(0,a.$Qj)("sparkle-filled",60449),diffSingle:(0,a.$Qj)("diff-single",60450),diffMultiple:(0,a.$Qj)("diff-multiple",60451),surroundWith:(0,a.$Qj)("surround-with",60452),share:(0,a.$Qj)("share",60453),gitStash:(0,a.$Qj)("git-stash",60454),gitStashApply:(0,a.$Qj)("git-stash-apply",60455),gitStashPop:(0,a.$Qj)("git-stash-pop",60456),vscode:(0,a.$Qj)("vscode",60457),vscodeInsiders:(0,a.$Qj)("vscode-insiders",60458),codeOss:(0,a.$Qj)("code-oss",60459),runCoverage:(0,a.$Qj)("run-coverage",60460),runAllCoverage:(0,a.$Qj)("run-all-coverage",60461),coverage:(0,a.$Qj)("coverage",60462),githubProject:(0,a.$Qj)("github-project",60463),mapVertical:(0,a.$Qj)("map-vertical",60464),foldVertical:(0,a.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,a.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,a.$Qj)("fold-vertical-filled",60465),goToSearch:(0,a.$Qj)("go-to-search",60466),percentage:(0,a.$Qj)("percentage",60467),sortPercentage:(0,a.$Qj)("sort-percentage",60467)}}),define(ke[79],Se([1,0,101,176]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=A;function A(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,a.$Qj)("dialog-error","error"),dialogWarning:(0,a.$Qj)("dialog-warning","warning"),dialogInfo:(0,a.$Qj)("dialog-info","info"),dialogClose:(0,a.$Qj)("dialog-close","close"),treeItemExpanded:(0,a.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,a.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,a.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,a.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,a.$Qj)("tree-item-loading","loading"),menuSelection:(0,a.$Qj)("menu-selection","check"),menuSubmenu:(0,a.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,a.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,a.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,a.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,a.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,a.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,a.$Qj)("toolbar-more","more"),quickInputBack:(0,a.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,a.$Qj)("drop-down-button",60084),symbolCustomColor:(0,a.$Qj)("symbol-customcolor",60252),exportIcon:(0,a.$Qj)("export",60332),workspaceUnspecified:(0,a.$Qj)("workspace-unspecified",60355),newLine:(0,a.$Qj)("newline",60394),thumbsDownFilled:(0,a.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,a.$Qj)("thumbsup-filled",60436),gitFetch:(0,a.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,a.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,a.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...N.$Sj,...e.$Uj}}),define(ke[30],Se([1,0,17,12,14,18]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=L,e.$pg=$,e.$qg=m,e.$rg=E,e.$sg=I,e.$tg=p,e.$ug=h,e.$vg=g,e.$wg=u,e.$xg=n,e.$yg=i,e.$zg=d,e.$Ag=o,e.$Bg=t,e.$Cg=l,e.$Dg=r,e.$Eg=v;function L(f){return f===47||f===92}function $(f){return f.replace(/[\\/]/g,a.$hc.sep)}function m(f){return f.indexOf("/")===-1&&(f=$(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function E(f,y=a.$hc.sep){if(!f)return"";const w=f.length,D=f.charCodeAt(0);if(L(D)){if(L(f.charCodeAt(1))&&!L(f.charCodeAt(2))){let C=3;const j=C;for(;C<w&&!L(f.charCodeAt(C));C++);if(j!==C&&!L(f.charCodeAt(C+1))){for(C+=1;C<w;C++)if(L(f.charCodeAt(C)))return f.slice(0,C+1).replace(/[\\/]/g,y)}}return y}else if(u(D)&&f.charCodeAt(1)===58)return L(f.charCodeAt(2))?f.slice(0,2)+y:f.slice(0,2);let S=f.indexOf("://");if(S!==-1){for(S+=3;S<w;S++)if(L(f.charCodeAt(S)))return f.slice(0,S+1)}return""}function I(f){if(!N.$c||!f||f.length<5)return!1;let y=f.charCodeAt(0);if(y!==92||(y=f.charCodeAt(1),y!==92))return!1;let w=2;const D=w;for(;w<f.length&&(y=f.charCodeAt(w),y!==92);w++);return!(D===w||(y=f.charCodeAt(w+1),isNaN(y)||y===92))}const P=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(f,y=N.$c){const w=y?P:b;return!(!f||f.length===0||/^\s+$/.test(f)||(w.lastIndex=0,w.test(f))||y&&k.test(f)||f==="."||f===".."||y&&f[f.length-1]==="."||y&&f.length!==f.trim().length||f.length>255)}function h(f,y,w){const D=f===y;return!w||D?D:!f||!y?!1:(0,A.$yf)(f,y)}function g(f,y,w,D=a.sep){if(f===y)return!0;if(!f||!y||y.length>f.length)return!1;if(w){if(!(0,A.$zf)(f,y))return!1;if(y.length===f.length)return!0;let C=y.length;return y.charAt(y.length-1)===D&&C--,f.charAt(C)===D}return y.charAt(y.length-1)!==D&&(y+=D),f.indexOf(y)===0}function u(f){return f>=65&&f<=90||f>=97&&f<=122}function n(f,y){return N.$c&&f.endsWith(":")&&(f+=a.sep),(0,a.$jc)(f)||(f=(0,a.$kc)(y,f)),f=(0,a.$ic)(f),i(f)}function i(f){return N.$c?(f=(0,A.$gf)(f,a.sep),f.endsWith(":")&&(f+=a.sep)):(f=(0,A.$gf)(f,a.sep),f||(f=a.sep)),f}function d(f){const y=(0,a.$ic)(f);return N.$c?f.length>3?!1:o(y)&&(f.length===2||y.charCodeAt(2)===92):y===a.$hc.sep}function o(f,y=N.$c){return y?u(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function t(f,y=N.$c){return o(f,y)?f[0]:void 0}function l(f,y,w){return y.length>f.length?-1:f===y?0:(w&&(f=f.toLowerCase(),y=y.toLowerCase()),f.indexOf(y))}function r(f){const y=f.split(":");let w,D,S;for(const C of y){const j=Number(C);(0,R.$ag)(j)?D===void 0?D=j:S===void 0&&(S=j):w=w?[w,C].join(":"):C}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:D!==void 0?D:void 0,column:S!==void 0?S:D!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(f,y,w=8){let D="";for(let C=0;C<w;C++){let j;C===0&&N.$c&&!y&&(w===3||w===4)?j=s:j=c,D+=j.charAt(Math.floor(Math.random()*j.length))}let S;return y?S=`${y}-${D}`:S=D,f?(0,a.$kc)(f,S):S}}),define(ke[24],Se([1,0,18]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=N,e.$5n=A,e.$6n=L,e.$7n=m,e.$8n=E,e.$9n=I,e.$0n=P,e.$$n=b,e.$_n=k,e.$ao=p,e.$bo=h,e.$co=g;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const n=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([i,d])=>{n[i]=d&&typeof d=="object"?N(d):d}),n}function A(u){if(!u||typeof u!="object")return u;const n=[u];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const d in i)if(R.call(i,d)){const o=i[d];typeof o=="object"&&!Object.isFrozen(o)&&!(0,a.$_f)(o)&&n.push(o)}}return u}const R=Object.prototype.hasOwnProperty;function L(u,n){return $(u,n,new Set)}function $(u,n,i){if((0,a.$fg)(u))return u;const d=n(u);if(typeof d<"u")return d;if(Array.isArray(u)){const o=[];for(const t of u)o.push($(t,n,i));return o}if((0,a.$$f)(u)){if(i.has(u))throw new Error("Cannot clone recursive data-structure");i.add(u);const o={};for(const t in u)R.call(u,t)&&(o[t]=$(u[t],n,i));return i.delete(u),o}return u}function m(u,n,i=!0){return(0,a.$$f)(u)?((0,a.$$f)(n)&&Object.keys(n).forEach(d=>{d in u?i&&((0,a.$$f)(u[d])&&(0,a.$$f)(n[d])?m(u[d],n[d],i):u[d]=n[d]):u[d]=n[d]}),u):n}function E(u,n){if(u===n)return!0;if(u==null||n===null||n===void 0||typeof u!=typeof n||typeof u!="object"||Array.isArray(u)!==Array.isArray(n))return!1;let i,d;if(Array.isArray(u)){if(u.length!==n.length)return!1;for(i=0;i<u.length;i++)if(!E(u[i],n[i]))return!1}else{const o=[];for(d in u)o.push(d);o.sort();const t=[];for(d in n)t.push(d);if(t.sort(),!E(o,t))return!1;for(i=0;i<o.length;i++)if(!E(u[o[i]],n[o[i]]))return!1}return!0}function I(u){const n=new Set;return JSON.stringify(u,(i,d)=>{if((0,a.$$f)(d)||Array.isArray(d)){if(n.has(d))return"[Circular]";n.add(d)}return typeof d=="bigint"?`[BigInt ${d.toString()}]`:d})}function P(u,n){const i=Object.create(null);return!u||!n||Object.keys(n).forEach(o=>{const t=u[o],l=n[o];E(t,l)||(i[o]=l)}),i}function b(u,n){const i=n.toLowerCase(),d=Object.keys(u).find(o=>o.toLowerCase()===i);return d?u[d]:u[n]}function k(u,n){const i=Object.create(null);for(const[d,o]of Object.entries(u))n(d,o)&&(i[d]=o);return i}function p(u){let n=[];for(;Object.prototype!==u;)n=n.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return n}function h(u){const n=[];for(const i of p(u))typeof u[i]=="function"&&n.push(i);return n}function g(u,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},d={};for(const o of u)d[o]=i(o);return d}}),define(ke[51],Se([1,0,79]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=A;var N;(function(L){function $(m){return m&&typeof m=="object"&&typeof m.id=="string"}L.isThemeColor=$})(N||(e.ThemeColor=N={}));function A(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function m(n){const i=$.exec(n.id);if(!i)return m(a.$Vj.error);const[,d,o]=i,t=["codicon","codicon-"+d];return o&&t.push("codicon-modifier-"+o.substring(1)),t}L.asClassNameArray=m;function E(n){return m(n).join(" ")}L.asClassName=E;function I(n){return"."+m(n).join(".")}L.asCSSSelector=I;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}L.isThemeIcon=P;const b=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function k(n){const i=b.exec(n);if(!i)return;const[,d]=i;return{id:d}}L.fromString=k;function p(n){return{id:n}}L.fromId=p;function h(n,i){let d=n.id;const o=d.lastIndexOf("~");return o!==-1&&(d=d.substring(0,o)),i&&(d=`${d}~${i}`),{id:d}}L.modify=h;function g(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}L.getModifier=g;function u(n,i){return n.id===i.id&&n.color?.id===i.color?.id}L.isEqual=u})(R||(e.ThemeIcon=R={}))}),define(ke[177],Se([1,0,129,14,51]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=m,e.$Ok=I,e.$Pk=b,e.$Qk=k,e.$Rk=h,e.$Sk=g;const R="$(",L=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${L.source}`,"g");function m(u){return u.replace($,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${L.source}`,"g");function I(u){return u.replace(E,n=>`\\${n}`)}const P=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function b(u){return u.indexOf(R)===-1?u:u.replace(P,(n,i,d,o)=>d?n:i||o||"")}function k(u){return u?u.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const p=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(u){p.lastIndex=0;let n="";const i=[];let d=0;for(;;){const o=p.lastIndex,t=p.exec(u),l=u.substring(o,t?.index);if(l.length>0){n+=l;for(let r=0;r<l.length;r++)i.push(d)}if(!t)break;d+=t[0].length}return{text:n,iconOffsets:i}}function g(u,n,i=!1){const{text:d,iconOffsets:o}=n;if(!o||o.length===0)return(0,a.$Ek)(u,d,i);const t=(0,N.$ff)(d," "),l=d.length-t.length,r=(0,a.$Ek)(u,t,i);if(r)for(const c of r){const s=o[c.start+l]+l;c.start+=s,c.end+=s}return r}}),define(ke[131],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$6e=N,e.$7e=A;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function N(R){return R<0?0:R>255?255:R|0}function A(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[2],Se([1,0,17,12]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=p,e.$xc=d;const A=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function $(c,s){if(!c.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!A.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(c,s){return!c&&!s?"file":c}function E(c,s){switch(c){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const I="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(s){return s instanceof k?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,v,f,y,w,D=!1){typeof s=="object"?(this.scheme=s.scheme||I,this.authority=s.authority||I,this.path=s.path||I,this.query=s.query||I,this.fragment=s.fragment||I):(this.scheme=m(s,D),this.authority=v||I,this.path=E(this.scheme,f||I),this.query=y||I,this.fragment=w||I,$(this,D))}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:v,authority:f,path:y,query:w,fragment:D}=s;return v===void 0?v=this.scheme:v===null&&(v=I),f===void 0?f=this.authority:f===null&&(f=I),y===void 0?y=this.path:y===null&&(y=I),w===void 0?w=this.query:w===null&&(w=I),D===void 0?D=this.fragment:D===null&&(D=I),v===this.scheme&&f===this.authority&&y===this.path&&w===this.query&&D===this.fragment?this:new g(v,f,y,w,D)}static parse(s,v=!1){const f=b.exec(s);return f?new g(f[2]||I,r(f[4]||I),r(f[5]||I),r(f[7]||I),r(f[9]||I),v):new g(I,I,I,I,I)}static file(s){let v=I;if(N.$c&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const f=s.indexOf(P,2);f===-1?(v=s.substring(2),s=P):(v=s.substring(2,f),s=s.substring(f)||P)}return new g("file",v,s,I,I)}static from(s,v){return new g(s.scheme,s.authority,s.path,s.query,s.fragment,v)}static joinPath(s,...v){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return N.$c&&s.scheme==="file"?f=k.file(a.$gc.join(d(s,!0),...v)).path:f=a.$hc.join(s.path,...v),s.with({path:f})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof k)return s;{const v=new g(s);return v._formatted=s.external??null,v._fsPath=s._sep===h?s.fsPath??null:null,v}}else return s}}e.URI=k;function p(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const h=N.$c?1:void 0;class g extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(c,s,v){let f,y=-1;for(let w=0;w<c.length;w++){const D=c.charCodeAt(w);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47||v&&D===91||v&&D===93||v&&D===58)y!==-1&&(f+=encodeURIComponent(c.substring(y,w)),y=-1),f!==void 0&&(f+=c.charAt(w));else{f===void 0&&(f=c.substr(0,w));const S=u[D];S!==void 0?(y!==-1&&(f+=encodeURIComponent(c.substring(y,w)),y=-1),f+=S):y===-1&&(y=w)}}return y!==-1&&(f+=encodeURIComponent(c.substring(y))),f!==void 0?f:c}function i(c){let s;for(let v=0;v<c.length;v++){const f=c.charCodeAt(v);f===35||f===63?(s===void 0&&(s=c.substr(0,v)),s+=u[f]):s!==void 0&&(s+=c[v])}return s!==void 0?s:c}function d(c,s){let v;return c.authority&&c.path.length>1&&c.scheme==="file"?v=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?s?v=c.path.substr(1):v=c.path[1].toLowerCase()+c.path.substr(2):v=c.path,N.$c&&(v=v.replace(/\//g,"\\")),v}function o(c,s){const v=s?i:n;let f="",{scheme:y,authority:w,path:D,query:S,fragment:C}=c;if(y&&(f+=y,f+=":"),(w||y==="file")&&(f+=P,f+=P),w){let j=w.indexOf("@");if(j!==-1){const B=w.substr(0,j);w=w.substr(j+1),j=B.lastIndexOf(":"),j===-1?f+=v(B,!1,!1):(f+=v(B.substr(0,j),!1,!1),f+=":",f+=v(B.substr(j+1),!1,!0)),f+="@"}w=w.toLowerCase(),j=w.lastIndexOf(":"),j===-1?f+=v(w,!1,!0):(f+=v(w.substr(0,j),!1,!0),f+=w.substr(j))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const j=D.charCodeAt(1);j>=65&&j<=90&&(D=`/${String.fromCharCode(j+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const j=D.charCodeAt(0);j>=65&&j<=90&&(D=`${String.fromCharCode(j+32)}:${D.substr(2)}`)}f+=v(D,!0,!1)}return S&&(f+="?",f+=v(S,!1,!1)),C&&(f+="#",f+=s?C:n(C,!1,!1)),f}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(l)?c.replace(l,s=>t(s)):c}}),define(ke[178],Se([1,0,2]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=N,e.$Xq=A,e.$Yq=R,e.log=$;function N(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function A(E){const I=[];let P;try{const b=JSON.parse(E.arguments),k=b[b.length-1];k&&k.__$stack&&(b.pop(),P=k.__$stack),I.push(...b)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:P}}function R(E){if(typeof E!="string")return R(A(E).stack);const I=E;if(I){const P=L(I),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(b&&b.length===4)return{uri:a.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function L(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function $(E,I){const{args:P,stack:b}=A(E),k=typeof P[0]=="string"&&P.length===1;let p=L(b);p&&(p=`(${p.trim()})`);let h=[];if(typeof P[0]=="string"?p&&k?h=[`%c[${I}] %c${P[0]} %c${p}`,m("blue"),m(""),m("grey")]:h=[`%c[${I}] %c${P[0]}`,m("blue"),m(""),...P.slice(1)]:h=[`%c[${I}]%`,m("blue"),...P],p&&!k&&h.push(p),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}function m(E){return`color: ${E}`}}),define(ke[58],Se([1,0,21,2]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=A,e.$5h=R,e.$6h=$;function A(m){return JSON.stringify(m,L)}function R(m){let E=JSON.parse(m);return E=$(E),E}function L(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function $(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return N.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof a.$Ge||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=$(m[I],E+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=$(m[I],E+1))}return m}}),define(ke[15],Se([1,0,13,12,14,2,17]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=m,e.$Gg=E,e.$Kg=P;var $;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting"})($||(e.Schemas=$={}));function m(p,h){return R.URI.isUri(p)?(0,A.$yf)(p.scheme,h):(0,A.$zf)(p,h+":")}function E(p,...h){return h.some(g=>m(p,g))}e.$Hg="vscode-tkn",e.$Ig="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,g){this.f=P(h,g)}getServerRootPath(){return this.f}get g(){return L.$hc.join(this.f,$.vscodeRemoteResource)}set(h,g,u){this.a[h]=g,this.b[h]=u}setConnectionToken(h,g){this.c[h]=g}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(o){return a.$1(o),h}const g=h.authority;let u=this.a[g];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const n=this.b[g],i=this.c[g];let d=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(d+=`&${e.$Ig}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$i?this.d:$.vscodeRemoteResource,authority:`${u}:${n}`,path:N.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:d})}}e.$Jg=new I;function P(p,h){return L.$hc.join(h??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class b{asBrowserUri(h){const g=this.b(h,ie);return this.uriToBrowserUri(g)}uriToBrowserUri(h){return h.scheme===$.vscodeRemote?e.$Jg.rewrite(h):h.scheme===$.file&&(N.$g||N.$k===`${$.vscodeFileResource}://${b.a}`)?h.with({scheme:$.vscodeFileResource,authority:h.authority||b.a,query:null,fragment:null}):h}asFileUri(h){const g=this.b(h,ie);return this.uriToFileUri(g)}uriToFileUri(h){return h.scheme===$.vscodeFileResource?h.with({scheme:$.file,authority:h.authority!==b.a?h.authority:null,query:null,fragment:null}):h}b(h,g){return R.URI.isUri(h)?h:R.URI.parse(g.toUrl(h))}}b.a=e.$Pg,e.$Qg=new b;var k;(function(p){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(h.get("3"));const g="vscode-coi";function u(i){let d;typeof i=="string"?d=new URL(i).searchParams:i instanceof URL?d=i.searchParams:R.URI.isUri(i)&&(d=new URL(i.toString(!0)).searchParams);const o=d?.get(g);if(o)return h.get(o)}p.getHeadersFromQuery=u;function n(i,d,o){if(!globalThis.crossOriginIsolated)return;const t=d&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(g,t):i[g]=t}p.addSearchParam=n})(k||(e.COI=k={}))}),define(ke[179],Se([1,0,164,15,12,2]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=I;class L{constructor(b,k,p){this.id=b,this.dependencies=k,this.callback=p}}class ${constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,k,p)=>{typeof b!="string"&&(p=k,k=b,b=null),(typeof k!="object"||!Array.isArray(k))&&(p=k,k=null),this.c.push(new L(b,k,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const k=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!k)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(b){return new Promise((k,p)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const g=()=>{h.removeEventListener("load",u),h.removeEventListener("error",n)},u=i=>{g(),k(this.c.pop())},n=i=>{g(),p(i)};h.addEventListener("load",u),h.addEventListener("error",n),this.f&&(b=this.f.createScriptURL(b)),h.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(b){return new Promise((k,p)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),k(this.c.pop())}catch(h){p(h)}})}async j(b){try{const k=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse(b).fsPath,u=k.readFileSync(g).toString(),n=h.wrap(u.replace(/^#!.*/,""));return new p.Script(n).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}$.INSTANCE=new $;const m=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function I(P,b,k){if(a.$T){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[P]&&(P=E[P]);const p=`${P}/${b}`;if(m.has(p))return m.get(p);let h;if(/^\w[\w\d+.-]*:\/\//.test(p))h=p;else{const i=`${k&&!A.$i?N.$Ng:N.$Mg}/${p}`;h=N.$Qg.asBrowserUri(i).toString(!0)}const g=$.INSTANCE.load(h);return m.set(p,g),g}else return await new Promise((p,h)=>{ie([P],p,h)})}}),define(ke[23],Se([1,0,30,15,17,12,14,2]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=m,e.$gh=I,e.$hh=b;function m(k){return(0,$.$xc)(k,!0)}class E{constructor(p){this.a=p}compare(p,h,g=!1){return p===h?0:(0,L.$rf)(this.getComparisonKey(p,g),this.getComparisonKey(h,g))}isEqual(p,h,g=!1){return p===h?!0:!p||!h?!1:this.getComparisonKey(p,g)===this.getComparisonKey(h,g)}getComparisonKey(p,h=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,h,g=!1){if(p.scheme===h.scheme){if(p.scheme===N.Schemas.file)return a.$vg(m(p),m(h),this.a(p))&&p.query===h.query&&(g||p.fragment===h.fragment);if((0,e.$ch)(p.authority,h.authority))return a.$vg(p.path,h.path,this.a(p),"/")&&p.query===h.query&&(g||p.fragment===h.fragment)}return!1}joinPath(p,...h){return $.URI.joinPath(p,...h)}basenameOrAuthority(p){return(0,e.$7g)(p)||p.authority}basename(p){return A.$hc.basename(p.path)}extname(p){return A.$hc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let h;return p.scheme===N.Schemas.file?h=$.URI.file(A.$nc(m(p))).path:(h=A.$hc.dirname(p.path),p.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),h="/")),p.with({path:h})}normalizePath(p){if(!p.path.length)return p;let h;return p.scheme===N.Schemas.file?h=$.URI.file(A.$ic(m(p))).path:h=A.$hc.normalize(p.path),p.with({path:h})}relativePath(p,h){if(p.scheme!==h.scheme||!(0,e.$ch)(p.authority,h.authority))return;if(p.scheme===N.Schemas.file){const n=A.$mc(m(p),m(h));return R.$c?a.$pg(n):n}let g=p.path||"/";const u=h.path||"/";if(this.a(p)){let n=0;for(const i=Math.min(g.length,u.length);n<i&&!(g.charCodeAt(n)!==u.charCodeAt(n)&&g.charAt(n).toLowerCase()!==u.charAt(n).toLowerCase());n++);g=u.substr(0,n)+g.substr(n)}return A.$hc.relative(g,u)}resolvePath(p,h){if(p.scheme===N.Schemas.file){const g=$.URI.file(A.$lc(m(p),h));return p.with({authority:g.authority,path:g.path})}return h=a.$qg(h),p.with({path:A.$hc.resolve(p.path,h)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,h){return p===h||p!==void 0&&h!==void 0&&(0,L.$yf)(p,h)}hasTrailingPathSeparator(p,h=A.sep){if(p.scheme===N.Schemas.file){const g=m(p);return g.length>a.$rg(g).length&&g[g.length-1]===h}else{const g=p.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,h=A.sep){return(0,e.$dh)(p,h)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,h=A.sep){let g=!1;if(p.scheme===N.Schemas.file){const u=m(p);g=u!==void 0&&u.length===a.$rg(u).length&&u[u.length-1]===h}else{h="/";const u=p.path;g=u.length===1&&u.charCodeAt(u.length-1)===47}return!g&&!(0,e.$dh)(p,h)?p.with({path:p.path+"/"}):p}}e.$Yg=E,e.$Zg=new E(()=>!1),e.$1g=new E(k=>k.scheme===N.Schemas.file?!R.$e:!0),e.$2g=new E(k=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function I(k,p){const h=[];for(let g=0;g<k.length;g++){const u=p(k[g]);k.some((n,i)=>i===g?!1:(0,e.$4g)(u,p(n)))||h.push(k[g])}return h}var P;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function p(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[d,o]=i.split(":");d&&o&&g.set(d,o)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&g.set(k.META_DATA_MIME,n),g}k.parseMetaData=p})(P||(e.DataUri=P={}));function b(k,p,h){if(p){let g=k.path;return g&&g[0]!==A.$hc.sep&&(g=A.$hc.sep+g),k.with({scheme:h,authority:p,path:g})}return k.with({scheme:h})}}),define(ke[7],Se([1,0,22,13,4,3,23,12,175,46]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=I,e.$jh=P,e.$kh=b,e.$lh=k,e.$mh=p,e.$nh=h,e.$oh=g,e.$ph=u,e.$xh=v,e.$yh=f,e.$zh=y,e.$Ah=w,e.$Bh=D,e.$Qh=J,e.$Yh=re;function I(oe){return!!oe&&typeof oe.then=="function"}function P(oe){const K=new a.$pe,te=oe(K.token),ge=new Promise((be,Re)=>{const pe=K.token.onCancellationRequested(()=>{pe.dispose(),Re(new N.$5)});Promise.resolve(te).then(Pe=>{pe.dispose(),K.dispose(),be(Pe)},Pe=>{pe.dispose(),K.dispose(),Re(Pe)})});return new class{cancel(){K.cancel(),K.dispose()}then(be,Re){return ge.then(be,Re)}catch(be){return this.then(void 0,be)}finally(be){return ge.finally(be)}}}function b(oe,K,te){return new Promise((ge,be)=>{const Re=K.onCancellationRequested(()=>{Re.dispose(),ge(te)});oe.then(ge,be).finally(()=>Re.dispose())})}function k(oe,K){return new Promise((te,ge)=>{const be=K.onCancellationRequested(()=>{be.dispose(),ge(new N.$5)});oe.then(te,ge).finally(()=>be.dispose())})}async function p(oe){let K=-1;const te=oe.map((ge,be)=>ge.then(Re=>(K=be,Re)));try{return await Promise.race(te)}finally{oe.forEach((ge,be)=>{be!==K&&ge.cancel()})}}function h(oe,K,te){let ge;const be=setTimeout(()=>{ge?.(void 0),te?.()},K);return Promise.race([oe.finally(()=>clearTimeout(be)),new Promise(Re=>ge=Re)])}function g(oe){return new Promise((K,te)=>{const ge=oe();I(ge)?ge.then(K,te):K(ge)})}function u(){let oe,K;return{promise:new Promise((ge,be)=>{oe=ge,K=be}),resolve:oe,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const te=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(te,te).then(ge)})}return new Promise((te,ge)=>{this.b.then(te,ge)})}return this.a=K(),new Promise((te,ge)=>{this.a.then(be=>{this.a=null,te(be)},be=>{this.a=null,ge(be)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$rh=i;class d{constructor(){this.a=new Map}queue(K,te){const be=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(K)===be&&this.a.delete(K)});return this.a.set(K,be),be}}e.$sh=d;const o=(oe,K)=>{let te=!0;const ge=setTimeout(()=>{te=!1,K()},oe);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ge),te=!1}}},t=oe=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,oe())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class l{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,te=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((be,Re)=>{this.d=be,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=te===m.$be?t(ge):o(te,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=l;class r{constructor(K){this.a=new l(K),this.b=new n}trigger(K,te){return this.a.trigger(()=>this.b.queue(K),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class c{constructor(){this.a=!1,this.b=new Promise((K,te)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=c;class s extends c{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$wh=s;function v(oe,K){return K?new Promise((te,ge)=>{const be=setTimeout(()=>{Re.dispose(),te()},oe),Re=K.onCancellationRequested(()=>{clearTimeout(be),Re.dispose(),ge(new N.$5)})}):P(te=>v(oe,te))}function f(oe,K=0,te){const ge=setTimeout(()=>{oe(),te&&be.dispose()},K),be=(0,R.$Tc)(()=>{clearTimeout(ge),te?.deleteAndLeak(be)});return te?.add(be),be}function y(oe){const K=[];let te=0;const ge=oe.length;function be(){return te<ge?oe[te++]():null}function Re(pe){pe!=null&&K.push(pe);const Pe=be();return Pe?Pe.then(Re):Promise.resolve(K)}return Promise.resolve(null).then(Re)}function w(oe,K=ge=>!!ge,te=null){let ge=0;const be=oe.length,Re=()=>{if(ge>=be)return Promise.resolve(te);const pe=oe[ge++];return Promise.resolve(pe()).then(Ie=>K(Ie)?Promise.resolve(Ie):Re())};return Re()}function D(oe,K=ge=>!!ge,te=null){if(oe.length===0)return Promise.resolve(te);let ge=oe.length;const be=()=>{ge=-1;for(const Re of oe)Re.cancel?.()};return new Promise((Re,pe)=>{for(const Pe of oe)Pe.then(Ie=>{--ge>=0&&K(Ie)?(be(),Re(Ie)):ge===0&&Re(te)}).catch(Ie=>{--ge>=0&&(be(),pe(Ie))})})}class S{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new A.$ee}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ge)=>{this.g.push({factory:K,c:te,e:ge}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const te=K.factory();te.then(K.c,K.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=S;class C extends S{constructor(){super(1)}}e.$Dh=C;class j{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Eh=j;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ce;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,te=L.$Zg){const ge=te.getComparisonKey(K);return this.a.get(ge)?.size??0}queueFor(K,te,ge=L.$Zg){const be=ge.getComparisonKey(K);let Re=this.a.get(be);if(!Re){Re=new C;const pe=this.f++,Pe=A.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(pe,Pe),this.a.set(be,Re)}return Re.queue(te)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=B;class z{constructor(K,te){this.a=-1,typeof K=="function"&&typeof te=="number"&&this.setIfNotSet(K,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},te)}setIfNotSet(K,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},te))}}e.$Gh=z;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,te,ge=globalThis){this.cancel();const be=ge.setInterval(()=>{K()},te);this.d=(0,R.$Tc)(()=>{ge.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=T;class M{constructor(K,te){this.b=-1,this.a=K,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=M;class F{constructor(K,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=K,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=F;class O extends M{constructor(K,te){super(K,te),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Kh=O;class q extends R.$Vc{constructor(K,te){super(),this.g=K,this.h=te,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of K)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(oe,K)=>{(0,$.$v)(()=>{if(te)return;const ge=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Nh=(oe,K,te)=>{const ge=oe.requestIdleCallback(K,typeof te=="number"?{timeout:te}:void 0);let be=!1;return{dispose(){be||(be=!0,oe.cancelIdleCallback(ge))}}},e.$Mh=oe=>(0,e.$Nh)(globalThis,oe)}();class Y{constructor(K,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ge){this.l=ge}finally{this.g=!0}},this.f=(0,e.$Nh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=Y;class V extends Y{constructor(K){super(globalThis,K)}}e.$Ph=V;async function J(oe,K,te){let ge;for(let be=0;be<te;be++)try{return await oe()}catch(Re){ge=Re,await v(K)}throw ge}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,te,ge){return this.a={taskId:K,cancel:()=>ge?.(),promise:te},te.then(()=>this.d(K),()=>this.d(K)),te}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:te,resolve:ge,reject:be}=u();this.b={run:K,promise:te,promiseResolve:ge,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=x;class ne{constructor(K,te=()=>Date.now()){this.d=K,this.f=te,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Sh=ne;var de;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(de||(de={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,te)=>{this.a=K,this.b=te})}complete(K){return new Promise(te=>{this.a(K),this.d={outcome:0,value:K},te()})}error(K){return new Promise(te=>{this.b(K),this.d={outcome:1,value:K},te()})}cancel(){return this.error(new N.$5)}}e.$Th=ce;var ve;(function(oe){async function K(ge){let be;const Re=await Promise.all(ge.map(pe=>pe.then(Pe=>Pe,Pe=>{be||(be=Pe)})));if(typeof be<"u")throw be;return Re}oe.settled=K;function te(ge){return new Promise(async(be,Re)=>{try{await ge(be,Re)}catch(pe){Re(pe)}})}oe.withAsyncBody=te})(ve||(e.Promises=ve={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=_;class U{constructor(K){this.b=K,this.a=new E.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=U;var le;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(le||(le={}));class De{static fromArray(K){return new De(te=>{te.emitMany(K)})}static fromPromise(K){return new De(async te=>{te.emitMany(await K)})}static fromPromises(K){return new De(async te=>{await Promise.all(K.map(async ge=>te.emitOne(await ge)))})}static merge(K){return new De(async te=>{await Promise.all(K.map(async ge=>{for await(const be of ge)te.emitOne(be)}))})}constructor(K,te){this.a=0,this.b=[],this.d=null,this.f=te,this.g=new A.$ee,queueMicrotask(async()=>{const ge={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(K(ge)),this.k()}catch(be){this.l(be)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,te){return new De(async ge=>{for await(const be of K)ge.emitOne(te(be))})}map(K){return De.map(this,K)}static filter(K,te){return new De(async ge=>{for await(const be of K)te(be)&&ge.emitOne(be)})}filter(K){return De.filter(this,K)}static coalesce(K){return De.filter(K,te=>!!te)}coalesce(){return De.coalesce(this)}static async toPromise(K){const te=[];for await(const ge of K)te.push(ge);return te}toPromise(){return De.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Wh=De,De.EMPTY=De.fromArray([]);class $e extends De{constructor(K,te){super(te),this.m=K}cancel(){this.m.cancel()}}e.$Xh=$e;function re(oe){const K=new a.$pe,te=oe(K.token);return new $e(K,async ge=>{const be=K.token.onCancellationRequested(()=>{be.dispose(),K.dispose(),ge.reject(new N.$5)});try{for await(const Re of te){if(K.token.isCancellationRequested)return;ge.emitOne(Re)}be.dispose(),K.dispose()}catch(Re){be.dispose(),K.dispose(),ge.reject(Re)}})}class se{constructor(K){this.a=new ce,this.b=new De(be=>{if(te){be.reject(te);return}return ge&&be.emitMany(ge),this.d=Re=>be.reject(Re),this.f=Re=>be.emitOne(Re),this.a.p},K);let te,ge;this.f=be=>{ge||(ge=[]),ge.push(be)},this.d=be=>{te||(te=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Zh=se}),define(ke[35],Se([1,0,19,7,30,27,17,12,14]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=E,e.$ok=p,e.$pk=C,e.$qk=j,e.$rk=B,e.$sk=z,e.$tk=T,e.$uk=q;function E(){return Object.create(null)}e.$mk="**",e.$nk="/";const I="[/\\\\]",P="[^/\\\\]",b=/\//g;function k(Y,V){switch(Y){case 0:return"";case 1:return`${P}*?`;default:return`(?:${I}|${P}+${I}${V?`|${I}${P}+`:""})*?`}}function p(Y,V){if(!Y)return[];const J=[];let x=!1,ne=!1,de="";for(const ce of Y){switch(ce){case V:if(!x&&!ne){J.push(de),de="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}de+=ce}return de&&J.push(de),J}function h(Y){if(!Y)return"";let V="";const J=p(Y,e.$nk);if(J.every(x=>x===e.$mk))V=".*";else{let x=!1;J.forEach((ne,de)=>{if(ne===e.$mk){if(x)return;V+=k(2,de===J.length-1)}else{let ce=!1,ve="",_=!1,U="";for(const le of ne){if(le!=="}"&&ce){ve+=le;continue}if(_&&(le!=="]"||!U)){let De;le==="-"?De=le:(le==="^"||le==="!")&&!U?De="^":le===e.$nk?De="":De=(0,m.$af)(le),U+=De;continue}switch(le){case"{":ce=!0;continue;case"[":_=!0;continue;case"}":{const $e=`(?:${p(ve,",").map(re=>h(re)).join("|")})`;V+=$e,ce=!1,ve="";break}case"]":{V+="["+U+"]",_=!1,U="";break}case"?":V+=P;continue;case"*":V+=k(1);continue;default:V+=(0,m.$af)(le)}}de<J.length-1&&(J[de+1]!==e.$mk||de+2<J.length)&&(V+=I)}x=ne===e.$mk})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),l=function(){return!1},r=function(){return null};function c(Y,V){if(!Y)return r;let J;typeof Y!="string"?J=Y.pattern:J=Y,J=J.trim();const x=`${J}_${!!V.trimForExclusions}`;let ne=t.get(x);if(ne)return s(ne,Y);let de;return g.test(J)?ne=f(J.substr(4),J):(de=u.exec(v(J,V)))?ne=y(de[1],J):(V.trimForExclusions?i:n).test(J)?ne=w(J,V):(de=d.exec(v(J,V)))?ne=D(de[1].substr(1),J,!0):(de=o.exec(v(J,V)))?ne=D(de[1],J,!1):ne=S(J),t.set(x,ne),s(ne,Y)}function s(Y,V){if(typeof V=="string")return Y;const J=function(x,ne){return(0,A.$vg)(x,V.base,!$.$e)?Y((0,m.$ff)(x.substr(V.base.length),L.sep),ne):null};return J.allBasenames=Y.allBasenames,J.allPaths=Y.allPaths,J.basenames=Y.basenames,J.patterns=Y.patterns,J}function v(Y,V){return V.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function f(Y,V){return function(J,x){return typeof J=="string"&&J.endsWith(Y)?V:null}}function y(Y,V){const J=`/${Y}`,x=`\\${Y}`,ne=function(ce,ve){return typeof ce!="string"?null:ve?ve===Y?V:null:ce===Y||ce.endsWith(J)||ce.endsWith(x)?V:null},de=[Y];return ne.basenames=de,ne.patterns=[V],ne.allBasenames=de,ne}function w(Y,V){const J=O(Y.slice(1,-1).split(",").map(ve=>c(ve,V)).filter(ve=>ve!==r),Y),x=J.length;if(!x)return r;if(x===1)return J[0];const ne=function(ve,_){for(let U=0,le=J.length;U<le;U++)if(J[U](ve,_))return Y;return null},de=J.find(ve=>!!ve.allBasenames);de&&(ne.allBasenames=de.allBasenames);const ce=J.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ce.length&&(ne.allPaths=ce),ne}function D(Y,V,J){const x=L.sep===L.$hc.sep,ne=x?Y:Y.replace(b,L.sep),de=L.sep+ne,ce=L.$hc.sep+Y;let ve;return J?ve=function(_,U){return typeof _=="string"&&(_===ne||_.endsWith(de)||!x&&(_===Y||_.endsWith(ce)))?V:null}:ve=function(_,U){return typeof _=="string"&&(_===ne||!x&&_===Y)?V:null},ve.allPaths=[(J?"*/":"./")+Y],ve}function S(Y){try{const V=new RegExp(`^${h(Y)}$`);return function(J){return V.lastIndex=0,typeof J=="string"&&V.test(J)?Y:null}}catch{return r}}function C(Y,V,J){return!Y||typeof V!="string"?!1:j(Y)(V,void 0,J)}function j(Y,V={}){if(!Y)return l;if(typeof Y=="string"||B(Y)){const J=c(Y,V);if(J===r)return l;const x=function(ne,de){return!!J(ne,de)};return J.allBasenames&&(x.allBasenames=J.allBasenames),J.allPaths&&(x.allPaths=J.allPaths),x}return M(Y,V)}function B(Y){const V=Y;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function z(Y){return Y.allBasenames||[]}function T(Y){return Y.allPaths||[]}function M(Y,V){const J=O(Object.getOwnPropertyNames(Y).map(ve=>F(ve,Y[ve],V)).filter(ve=>ve!==r)),x=J.length;if(!x)return r;if(!J.some(ve=>!!ve.requiresSiblings)){if(x===1)return J[0];const ve=function(le,De){let $e;for(let re=0,se=J.length;re<se;re++){const oe=J[re](le,De);if(typeof oe=="string")return oe;(0,N.$ih)(oe)&&($e||($e=[]),$e.push(oe))}return $e?(async()=>{for(const re of $e){const se=await re;if(typeof se=="string")return se}return null})():null},_=J.find(le=>!!le.allBasenames);_&&(ve.allBasenames=_.allBasenames);const U=J.reduce((le,De)=>De.allPaths?le.concat(De.allPaths):le,[]);return U.length&&(ve.allPaths=U),ve}const ne=function(ve,_,U){let le,De;for(let $e=0,re=J.length;$e<re;$e++){const se=J[$e];se.requiresSiblings&&U&&(_||(_=(0,L.$oc)(ve)),le||(le=_.substr(0,_.length-(0,L.$pc)(ve).length)));const oe=se(ve,_,le,U);if(typeof oe=="string")return oe;(0,N.$ih)(oe)&&(De||(De=[]),De.push(oe))}return De?(async()=>{for(const $e of De){const re=await $e;if(typeof re=="string")return re}return null})():null},de=J.find(ve=>!!ve.allBasenames);de&&(ne.allBasenames=de.allBasenames);const ce=J.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ce.length&&(ne.allPaths=ce),ne}function F(Y,V,J){if(V===!1)return r;const x=c(Y,J);if(x===r)return r;if(typeof V=="boolean")return x;if(V){const ne=V.when;if(typeof ne=="string"){const de=(ce,ve,_,U)=>{if(!U||!x(ce,ve))return null;const le=ne.replace("$(basename)",()=>_),De=U(le);return(0,N.$ih)(De)?De.then($e=>$e?Y:null):De?Y:null};return de.requiresSiblings=!0,de}}return x}function O(Y,V){const J=Y.filter(ve=>!!ve.basenames);if(J.length<2)return Y;const x=J.reduce((ve,_)=>{const U=_.basenames;return U?ve.concat(U):ve},[]);let ne;if(V){ne=[];for(let ve=0,_=x.length;ve<_;ve++)ne.push(V)}else ne=J.reduce((ve,_)=>{const U=_.patterns;return U?ve.concat(U):ve},[]);const de=function(ve,_){if(typeof ve!="string")return null;if(!_){let le;for(le=ve.length;le>0;le--){const De=ve.charCodeAt(le-1);if(De===47||De===92)break}_=ve.substr(le)}const U=x.indexOf(_);return U!==-1?ne[U]:null};de.basenames=x,de.patterns=ne,de.allBasenames=x;const ce=Y.filter(ve=>!ve.basenames);return ce.push(de),ce}function q(Y,V){return(0,a.$ub)(Y,V,(J,x)=>typeof J=="string"&&typeof x=="string"?J===x:typeof J!="string"&&typeof x!="string"?J.base===x.base&&J.pattern===x.pattern:!1)}}),define(ke[80],Se([1,0,13,177,23,14,2]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=E,e.$Vk=I,e.$Wk=P,e.$Xk=b,e.$Yk=k,e.$Zk=p,e.$1k=h,e.$2k=g;var $;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,a.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=b(this.supportThemeIcons?(0,N.$Nk)(n):n).replace(/([ \t]+)/g,(d,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${k(i,n)}
`,this}appendLink(n,i,d){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(n,i){const d=new RegExp((0,R.$af)(i),"g");return n.replace(d,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Tk=m;function E(u){return I(u)?!u.value:Array.isArray(u)?u.every(E):!0}function I(u){return u instanceof m?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}function P(u,n){return u===n?!0:!u||!n?!1:u.value===n.value&&u.isTrusted===n.isTrusted&&u.supportThemeIcons===n.supportThemeIcons&&u.supportHtml===n.supportHtml&&(u.baseUri===n.baseUri||!!u.baseUri&&!!n.baseUri&&(0,A.$3g)(L.URI.from(u.baseUri),L.URI.from(n.baseUri)))}function b(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(u,n){const i=u.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,d=i>=3?i+1:3;return[`${"`".repeat(d)}${n}`,u,`${"`".repeat(d)}`].join(`
`)}function p(u){return u.replace(/"/g,"&quot;")}function h(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(u){const n=[],i=u.split("|").map(o=>o.trim());u=i[0];const d=i[1];if(d){const o=/height=(\d+)/.exec(d),t=/width=(\d+)/.exec(d),l=o?o[1]:"",r=t?t[1]:"",c=isFinite(parseInt(r)),s=isFinite(parseInt(l));c&&n.push(`width="${r}"`),s&&n.push(`height="${l}"`)}return{href:u,dimensions:n}}}),define(ke[102],Se([1,0,19,30,17,12,23,14]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=m,e.$Fw=I,e.$Gw=b,e.$Hw=k,e.$Iw=u,e.$Jw=i,e.$Kw=d,e.$Lw=o,e.$Mw=t,e.$Nw=l;function m(c,s){const{os:v,tildify:f,relative:y}=s;if(y){const S=E(c,y,v);if(typeof S=="string")return S}let w=c.fsPath;if(v===1&&!R.$c?w=w.replace(/\//g,"\\"):v!==1&&R.$c&&(w=w.replace(/\\/g,"/")),v!==1&&f?.userHome){const S=f.userHome.fsPath;let C;c.scheme!==f.userHome.scheme&&c.path[0]===A.$hc.sep&&c.path[1]!==A.$hc.sep?C=f.userHome.with({path:c.path}).fsPath:C=w,w=b(C,S,v)}return(v===1?A.$gc:A.$hc).normalize(I(w,v===1))}function E(c,s,v){const f=v===1?A.$gc:A.$hc,y=v===3?L.$Zg:L.$2g,w=s.getWorkspace(),D=(0,a.$Ob)(w.folders);if(!D)return;c.scheme!==D.uri.scheme&&c.path[0]===A.$hc.sep&&c.path[1]!==A.$hc.sep&&(c=D.uri.with({path:c.path}));const S=s.getWorkspaceFolder(c);if(!S)return;let C;if(y.isEqual(S.uri,c)?C="":C=y.relativePath(S.uri,c)??"",C&&(C=f.normalize(C)),w.folders.length>1&&!s.noPrefix){const j=S.name?S.name:y.basenameOrAuthority(S.uri);C=C?`${j} \u2022 ${C}`:j}return C}function I(c,s=R.$c){return(0,N.$Ag)(c,s)?c.charAt(0).toUpperCase()+c.slice(1):c}let P=Object.create(null);function b(c,s,v=R.OS){if(v===1||!c||!s)return c;let f=P.original===s?P.normalized:void 0;f||(f=s,R.$c&&(f=(0,N.$pg)(f)),f=`${(0,$.$gf)(f,A.$hc.sep)}${A.$hc.sep}`,P={original:s,normalized:f});let y=c;return R.$c&&(y=(0,N.$pg)(y)),(v===3?y.startsWith(f):(0,$.$zf)(y,f))?`~/${y.substr(f.length)}`:c}function k(c,s){return c.replace(/^~($|\/|\\)/,`${s}$1`)}const p="\u2026",h="\\\\",g="~";function u(c,s=A.sep){const v=new Array(c.length);let f=!1;for(let y=0;y<c.length;y++){const w=c[y];if(w===""){v[y]=`.${s}`;continue}if(!w){v[y]=w;continue}f=!0;let D="",S=w;S.indexOf(h)===0?(D=S.substr(0,S.indexOf(h)+h.length),S=S.substr(S.indexOf(h)+h.length)):S.indexOf(s)===0?(D=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length)):S.indexOf(g)===0&&(D=S.substr(0,S.indexOf(g)+g.length),S=S.substr(S.indexOf(g)+g.length));const C=S.split(s);for(let j=1;f&&j<=C.length;j++)for(let B=C.length-j;f&&B>=0;B--){f=!1;let z=C.slice(B,B+j).join(s);for(let T=0;!f&&T<c.length;T++)if(T!==y&&c[T]&&c[T].indexOf(z)>-1){const M=B+j===C.length,F=B>0&&c[T].indexOf(s)>-1?s+z:z,O=c[T].endsWith(F);f=!M||O}if(!f){let T="";(C[0].endsWith(":")||D!=="")&&(B===1&&(B=0,j++,z=C[0]+s+z),B>0&&(T=C[0]+s),T=D+T),B>0&&(T=T+p+s),T=T+z,B+j<C.length&&(T=T+s+p),v[y]=T}}f&&(v[y]=w)}return v}var n;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(c,s=Object.create(null)){const v=[];let f=!1,y="";for(const w of c)if(w==="$"||f&&w==="{")y&&v.push({value:y,type:n.TEXT}),y="",f=!0;else if(w==="}"&&f){const D=s[y];if(typeof D=="string")D.length&&v.push({value:D,type:n.VARIABLE});else if(D){const S=v[v.length-1];(!S||S.type!==n.SEPARATOR)&&v.push({value:D.label,type:n.SEPARATOR})}y="",f=!1}else y+=w;return y&&!f&&v.push({value:y,type:n.TEXT}),v.filter((w,D)=>{if(w.type===n.SEPARATOR){const S=v[D-1],C=v[D+1];return[S,C].every(j=>j&&(j.type===n.VARIABLE||j.type===n.TEXT)&&j.value.length>0)}return!0}).map(w=>w.value).join("")}function d(c,s){return R.$d||s?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$d?"&":"&&"):c.replace(/&&|&/g,v=>v==="&"?"&&":"&")}function o(c,s){return R.$d||s?c.replace(/\(&&\w\)|&&/g,""):R.$c?c.replace(/&&|&/g,v=>v==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function l(c){if(c.endsWith("]")){const s=c.lastIndexOf(" [",c.length-2);if(s!==-1){const v=r(c.substring(0,s)),f=c.substring(s);return{name:v.name+f,parentPath:v.parentPath}}}return r(c)}function r(c){const s=c.indexOf("/")!==-1?A.$hc:A.$gc,v=s.basename(c),f=s.dirname(c);return v.length?{name:v,parentPath:f}:{name:f,parentPath:""}}}),define(ke[132],Se([1,0,21,2]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=void 0,e.$Bn=$,e.$Cn=E,e.$Dn=I;function A(P){return P.toJSON()}class R{constructor(b){this.a=b}transformIncoming(b){const k=this.a.transformIncoming(b);return k===b?b:A(N.URI.from(k))}transformOutgoing(b){const k=this.a.transformOutgoing(b);return k===b?b:A(N.URI.from(k))}transformOutgoingURI(b){const k=this.a.transformOutgoing(b);return k===b?b:N.URI.from(k)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$zn=R,e.$An=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function L(P,b,k){if(!P||k>200)return null;if(typeof P=="object"){if(P instanceof N.URI)return b.transformOutgoing(P);for(const p in P)if(Object.hasOwnProperty.call(P,p)){const h=L(P[p],b,k+1);h!==null&&(P[p]=h)}}return null}function $(P,b){const k=L(P,b,0);return k===null?P:k}function m(P,b,k,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return k?N.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);if(P instanceof a.$Ge)return null;for(const h in P)if(Object.hasOwnProperty.call(P,h)){const g=m(P[h],b,k,p+1);g!==null&&(P[h]=g)}}return null}function E(P,b){const k=m(P,b,!1,0);return k===null?P:k}function I(P,b){const k=m(P,b,!0,0);return k===null?P:k}}),define(ke[31],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=N;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return a.test(A)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function($){for(let m=0;m<$.length;m++)$[m]=Math.floor(Math.random()*256);return $};const R=new Uint8Array(16),L=[];for(let $=0;$<256;$++)L.push($.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,E="";return E+=L[R[m++]],E+=L[R[m++]],E+=L[R[m++]],E+=L[R[m++]],E+="-",E+=L[R[m++]],E+=L[R[m++]],E+="-",E+=L[R[m++]],E+=L[R[m++]],E+="-",E+=L[R[m++]],E+=L[R[m++]],E+="-",E+=L[R[m++]],E+=L[R[m++]],E+=L[R[m++]],E+=L[R[m++]],E+=L[R[m++]],E+=L[R[m++]],E}}()}),define(ke[180],Se([1,0,19,40,31]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.$Tt=void 0,e.$Rt=R,e.$St=L,e.$Ut=E;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function L(P,b,k){const p={id:(0,A.$Sg)(),name:P,uri:b,data:k};return{asString:async()=>"",asFile:()=>p,value:void 0}}class ${constructor(){this.a=new Map}get size(){let b=0;for(const k of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const k=[...this.a.keys()];return N.Iterable.some(this,([p,h])=>h.asFile())&&k.push("files"),I(m(b),k)}get(b){return this.a.get(this.b(b))?.[0]}append(b,k){const p=this.a.get(b);p?p.push(k):this.a.set(this.b(b),[k])}replace(b,k){this.a.set(this.b(b),[k])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,k]of this.a)for(const p of k)yield[b,p]}b(b){return m(b)}}e.$Tt=$;function m(P){return P.toLowerCase()}function E(P,b){return I(m(P),b.map(m))}function I(P,b){if(P==="*/*")return b.length>0;if(b.includes(P))return!0;const k=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[p,h,g]=k;return g==="*"?b.some(u=>u.startsWith(h+"/")):!1}e.$Vt=Object.freeze({create:P=>(0,a.$Mb)(P.map(b=>b.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Vt.split(P).filter(b=>!b.startsWith("#"))})}),define(ke[32],Se([1,0,52,63,399,7,30,77,17,12,23,2]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=v,e.writeFileSync=y;var b;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function k(F,O=b.UNLINK,q){if((0,L.$zg)(F))throw new Error("rimraf - will refuse to recursively delete root");return O===b.UNLINK?h(F):p(F,q)}async function p(F,O=(0,L.$Eg)((0,N.tmpdir)())){try{try{await a.promises.rename(F,O)}catch(q){return q.code==="ENOENT"?void 0:h(F)}h(O).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function h(F){return(0,A.promisify)(a.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,L.$zg)(F))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function u(F,O){return d(await(O?n(F):(0,A.promisify)(a.readdir)(F)))}async function n(F){try{return await(0,A.promisify)(a.readdir)(F,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const O=[],q=await u(F);for(const Y of q){let V=!1,J=!1,x=!1;try{const ne=await e.Promises.lstat((0,m.$kc)(F,Y));V=ne.isFile(),J=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}O.push({name:Y,isFile:()=>V,isDirectory:()=>J,isSymbolicLink:()=>x})}return O}function i(F){return d(a.readdirSync(F))}function d(F){return F.map(O=>typeof O=="string"?E.$d?(0,$.$cm)(O):O:(O.name=E.$d?(0,$.$cm)(O.name):O.name,O))}async function o(F){const O=await u(F),q=[];for(const Y of O)await l.existsDirectory((0,m.$kc)(F,Y))&&q.push(Y);return q}function t(F,O=1e3){return new Promise(q=>{let Y=!1;const V=setInterval(()=>{Y||(Y=!0,a.access(F,J=>{Y=!1,J&&(clearInterval(V),q(void 0))}))},O)})}var l;(function(F){async function O(V){let J;try{if(J=await e.Promises.lstat(V),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(E.$c&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ne}throw x}}F.stat=O;async function q(V){try{const{stat:J,symbolicLink:x}=await F.stat(V);return J.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=q;async function Y(V){try{const{stat:J,symbolicLink:x}=await F.stat(V);return J.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=Y})(l||(e.SymlinkSupport=l={}));const r=new R.$Fh;function c(F,O,q){return r.queueFor(P.URI.file(F),()=>{const Y=w(q);return new Promise((V,J)=>f(F,O,Y,x=>x?J(x):V()))},I.$1g)}let s=!0;function v(F){s=F}function f(F,O,q,Y){if(!s)return a.writeFile(F,O,{mode:q.mode,flag:q.flag},Y);a.open(F,q.flag,q.mode,(V,J)=>{if(V)return Y(V);a.writeFile(J,O,x=>{if(x)return a.close(J,()=>Y(x));a.fdatasync(J,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),v(!1)),a.close(J,de=>Y(de))))})})}function y(F,O,q){const Y=w(q);if(!s)return a.writeFileSync(F,O,{mode:Y.mode,flag:Y.flag});const V=a.openSync(F,Y.flag,Y.mode);try{a.writeFileSync(V,O);try{a.fdatasyncSync(V)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),v(!1)}}finally{a.closeSync(V)}}function w(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function D(F,O,q=6e4){if(F!==O)try{E.$c&&typeof q=="number"?await S(F,O,Date.now(),q):await(0,A.promisify)(a.rename)(F,O)}catch(Y){if(F.toLowerCase()!==O.toLowerCase()&&Y.code==="EXDEV"||F.endsWith("."))await C(F,O,{preserveSymlinks:!1}),await k(F,b.MOVE);else throw Y}}async function S(F,O,q,Y,V=0){try{return await(0,A.promisify)(a.rename)(F,O)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-q>=Y)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${J}`),J;if(V===0){let x=!1;try{const{stat:ne}=await l.stat(O);ne.isFile()||(x=!0)}catch{}if(x)throw J}return await(0,R.$xh)(Math.min(100,V*10)),S(F,O,q,Y,V+1)}}async function C(F,O,q){return B(F,O,{root:{source:F,target:O},options:q,handledSourcePaths:new Set})}const j=511;async function B(F,O,q){if(q.handledSourcePaths.has(F))return;q.handledSourcePaths.add(F);const{stat:Y,symbolicLink:V}=await l.stat(F);if(V){if(q.options.preserveSymlinks)try{return await M(F,O,q)}catch{}if(V.dangling)return}return Y.isDirectory()?z(F,O,Y.mode&j,q):T(F,O,Y.mode&j)}async function z(F,O,q,Y){await e.Promises.mkdir(O,{recursive:!0,mode:q});const V=await u(F);for(const J of V)await B((0,m.$kc)(F,J),(0,m.$kc)(O,J),Y)}async function T(F,O,q){await e.Promises.copyFile(F,O),await e.Promises.chmod(O,q)}async function M(F,O,q){let Y=await e.Promises.readlink(F);(0,L.$vg)(Y,q.root.source,!E.$e)&&(Y=(0,m.$kc)(q.root.target,Y.substr(q.root.source.length+1))),await e.Promises.symlink(Y,O)}e.Promises=new class{get access(){return(0,A.promisify)(a.access)}get stat(){return(0,A.promisify)(a.stat)}get lstat(){return(0,A.promisify)(a.lstat)}get utimes(){return(0,A.promisify)(a.utimes)}get read(){return(F,O,q,Y,V)=>new Promise((J,x)=>{a.read(F,O,q,Y,V,(ne,de,ce)=>ne?x(ne):J({bytesRead:de,buffer:ce}))})}get readFile(){return(0,A.promisify)(a.readFile)}get write(){return(F,O,q,Y,V)=>new Promise((J,x)=>{a.write(F,O,q,Y,V,(ne,de,ce)=>ne?x(ne):J({bytesWritten:de,buffer:ce}))})}get appendFile(){return(0,A.promisify)(a.appendFile)}get fdatasync(){return(0,A.promisify)(a.fdatasync)}get truncate(){return(0,A.promisify)(a.truncate)}get copyFile(){return(0,A.promisify)(a.copyFile)}get open(){return(0,A.promisify)(a.open)}get close(){return(0,A.promisify)(a.close)}get symlink(){return(0,A.promisify)(a.symlink)}get readlink(){return(0,A.promisify)(a.readlink)}get chmod(){return(0,A.promisify)(a.chmod)}get mkdir(){return(0,A.promisify)(a.mkdir)}get unlink(){return(0,A.promisify)(a.unlink)}get rmdir(){return(0,A.promisify)(a.rmdir)}get realpath(){return(0,A.promisify)(a.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return k}get rename(){return D}get copy(){return C}}}),define(ke[103],Se([1,0,52,17,12,14,32]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=$,e.$6q=m,e.$7q=E,e.$8q=I;function $(b){if(A.$e)return b;const k=(0,N.$nc)(b);if(b===k)return b;const p=((0,N.$oc)(b)||b).toLowerCase();try{const g=(0,L.readdirSync)(k).filter(u=>u.toLowerCase()===p);if(g.length===1){const u=$(k);if(u)return(0,N.$kc)(u,g[0])}else if(g.length>1){const u=g.indexOf(p);if(u>=0){const n=$(k);if(n)return(0,N.$kc)(n,g[u])}}}catch{}return null}async function m(b,k){if(A.$e)return b;const p=(0,N.$nc)(b);if(b===p)return b;const h=((0,N.$oc)(b)||b).toLowerCase();try{if(k?.isCancellationRequested)return null;const u=(await L.Promises.readdir(p)).filter(n=>n.toLowerCase()===h);if(u.length===1){const n=await m(p,k);if(n)return(0,N.$kc)(n,u[0])}else if(u.length>1){const n=u.indexOf(h);if(n>=0){const i=await m(p,k);if(i)return(0,N.$kc)(i,u[n])}}}catch{}return null}async function E(b){try{return await L.Promises.realpath(b)}catch{const p=P(b);return await L.Promises.access(p,a.constants.R_OK),p}}function I(b){try{return a.realpathSync(b)}catch{const p=P(b);return a.accessSync(p,a.constants.R_OK),p}}function P(b){return(0,R.$gf)((0,N.$ic)(b),N.sep)}}),define(ke[181],Se([1,0,64]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=N,e.$Wg=R;function N($,m,E,I=1){let P=!1;return new Promise(b=>{const k=setTimeout(()=>{if(!P)return P=!0,b(0)},E);A($,m,I,p=>{if(!P)return P=!0,clearTimeout(k),b(p)})})}function A($,m,E,I){if(m===0)return I(0);const P=new a.Socket;P.once("connect",()=>(L(P),A($+E,m-1,E,I))),P.once("data",()=>{}),P.once("error",b=>(L(P),b.code!=="ECONNREFUSED"?A($+E,m-1,E,I):I($))),P.connect($,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R($,m,E,I="127.0.0.1"){let P=!1,b,k=1;const p=a.createServer({pauseOnConnect:!0});function h(g,u){P||(P=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),u(g))}return new Promise(g=>{b=setTimeout(()=>{h(0,g)},E),p.on("listening",()=>{h($,g)}),p.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&k<m?($++,k++,p.listen($,I)):h(0,g)}),p.on("close",()=>{h(0,g)}),p.listen($,I)})}function L($){try{$.removeAllListeners("connect"),$.removeAllListeners("error"),$.end(),$.destroy(),$.unref()}catch(m){console.error(m)}}}),define(ke[104],Se([1,0,17,12,50,99,18,32]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$pm=m,e.$qm=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function m(P=A.env){return P.comspec||"cmd.exe"}function E(P){let b=[],k=!1;const p=function(h){if(k){b.push(h);return}(!P.send(h,u=>{if(u&&console.error(u),k=!1,b.length>0){const n=b.slice(0);b=[],n.forEach(i=>p(i))}})||N.$c)&&(k=!0)};return{send:p}}var I;(function(P){async function b(k,p,h){if(a.$jc(k))return k;if(p===void 0&&(p=A.cwd()),a.$nc(k)!=="."||(h===void 0&&L.$9f(A.env.PATH)&&(h=A.env.PATH.split(a.$uc)),h===void 0||h.length===0))return a.$kc(p,k);async function u(n){if(await $.Promises.exists(n)){let i;try{i=await $.Promises.stat(n)}catch(d){d.message.startsWith("EACCES")&&(i=await $.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(a.$jc(n)?i=a.$kc(n,k):i=a.$kc(p,n,k),await u(i))return i;let d=i+".com";if(await u(d)||(d=i+".exe",await u(d)))return d}return a.$kc(p,k)}P.findExecutable=b})(I||(e.win32=I={}))});var Je=this&&this.__decorate||function(ie,e,a,N){var A=arguments.length,R=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,a):N,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ie,e,a,N);else for(var $=ie.length-1;$>=0;$--)(L=ie[$])&&(R=(A<3?L(R):A>3?L(e,a,R):L(e,a))||R);return A>3&&R&&Object.defineProperty(e,a,R),R};define(ke[81],Se([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=v,e.$0h=f,e.$ci=j,e.$di=B;var k;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(k||(k={}));function p(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h||(h={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function n(V){let J=0;for(let x=0;;x+=7){const ne=V.read(1);if(J|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return J}}const i=r(0);function d(V,J){if(J===0){V.write(i);return}let x=0;for(let de=J;de!==0;de=de>>>7)x++;const ne=A.$Ge.alloc(x);for(let de=0;J!==0;de++)ne.buffer[de]=J&127,J=J>>>7,J>0&&(ne.buffer[de]|=128);V.write(ne)}class o{constructor(J){this.b=J,this.a=0}read(J){const x=this.b.slice(this.a,this.a+J);return this.a+=x.byteLength,x}}e.$7h=o;class t{constructor(){this.a=[]}get buffer(){return A.$Ge.concat(this.a)}write(J){this.a.push(J)}}e.$8h=t;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function r(V){const J=A.$Ge.alloc(1);return J.writeUInt8(V,0),J}const c={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},s=typeof Buffer<"u";function v(V,J){if(typeof J>"u")V.write(c.Undefined);else if(typeof J=="string"){const x=A.$Ge.fromString(J);V.write(c.String),d(V,x.byteLength),V.write(x)}else if(s&&Buffer.isBuffer(J)){const x=A.$Ge.wrap(J);V.write(c.Buffer),d(V,x.byteLength),V.write(x)}else if(J instanceof A.$Ge)V.write(c.VSBuffer),d(V,J.byteLength),V.write(J);else if(Array.isArray(J)){V.write(c.Array),d(V,J.length);for(const x of J)v(V,x)}else if(typeof J=="number"&&(J|0)===J)V.write(c.Uint),d(V,J);else{const x=A.$Ge.fromString(JSON.stringify(J));V.write(c.Object),d(V,x.byteLength),V.write(x)}}function f(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(n(V)).toString();case l.Buffer:return V.read(n(V)).buffer;case l.VSBuffer:return V.read(n(V));case l.Array:{const x=n(V),ne=[];for(let de=0;de<x;de++)ne.push(f(V));return ne}case l.Object:return JSON.parse(V.read(n(V)).toString());case l.Int:return n(V)}}class y{constructor(J,x,ne=null,de=1e3){this.h=J,this.j=x,this.k=ne,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(J,x){this.b.set(J,x),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const x=this.o([J.type]);this.k?.logOutgoing(x,0,1,g(J.type));return}case 201:case 202:case 204:case 203:{const x=this.o([J.type,J.id],J.data);this.k?.logOutgoing(x,J.id,1,g(J.type),J.data);return}}}o(J,x=void 0){const ne=new t;return v(ne,J),v(ne,x),this.p(ne.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const x=new o(J),ne=f(x),de=f(x),ce=ne[0];switch(ce){case 100:return this.k?.logIncoming(J.byteLength,ne[1],1,`${p(ce)}: ${ne[2]}.${ne[3]}`,de),this.s({type:ce,id:ne[1],channelName:ne[2],name:ne[3],arg:de});case 102:return this.k?.logIncoming(J.byteLength,ne[1],1,`${p(ce)}: ${ne[2]}.${ne[3]}`,de),this.t({type:ce,id:ne[1],channelName:ne[2],name:ne[3],arg:de});case 101:return this.k?.logIncoming(J.byteLength,ne[1],1,`${p(ce)}`),this.u({type:ce,id:ne[1]});case 103:return this.k?.logIncoming(J.byteLength,ne[1],1,`${p(ce)}`),this.u({type:ce,id:ne[1]})}}s(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ne=new R.$pe;let de;try{de=x.call(this.j,J.name,J.arg,ne.token)}catch(_){de=Promise.reject(_)}const ce=J.id;de.then(_=>{this.m({id:ce,data:_,type:201})},_=>{_ instanceof Error?this.m({id:ce,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:ce,data:_,type:203})}).finally(()=>{ve.dispose(),this.d.delete(J.id)});const ve=(0,E.$Tc)(()=>ne.cancel());this.d.set(J.id,ve)}t(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ne=J.id,ce=x.listen(this.j,J.name,J.arg)(ve=>this.m({id:ne,data:ve,type:204}));this.d.set(J.id,ce)}u(J){const x=this.d.get(J.id);x&&(x.dispose(),this.d.delete(J.id))}v(J){let x=this.g.get(J.channelName);x||(x=[],this.g.set(J.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:J,timeoutTimer:ne})}w(J){const x=this.g.get(J);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Qc)(this.d.values()),this.d.clear()}}e.$$h=y;var w;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class D{constructor(J,x=null){this.l=J,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(J){const x=this;return{call(ne,de,ce){return x.a?Promise.reject(new $.$5):x.m(J,ne,de,ce)},listen(ne,de){return x.a?m.Event.None:x.o(J,ne,de)}}}m(J,x,ne,de=R.CancellationToken.None){const ce=this.g++,_={id:ce,type:100,channelName:J,name:x,arg:ne};if(de.isCancellationRequested)return Promise.reject(new $.$5);let U;return new Promise((De,$e)=>{if(de.isCancellationRequested)return $e(new $.$5);const re=()=>{const te=ge=>{switch(ge.type){case 201:this.f.delete(ce),De(ge.data);break;case 202:{this.f.delete(ce);const be=new Error(ge.data.message);be.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,be.name=ge.data.name,$e(be);break}case 203:this.f.delete(ce),$e(ge.data);break}};this.f.set(ce,te),this.p(_)};let se=null;this.b===u.Idle?re():(se=(0,N.$jh)(te=>this.u()),se.then(()=>{se=null,re()}));const oe=()=>{se?(se.cancel(),se=null):this.p({id:ce,type:101}),$e(new $.$5)},K=de.onCancellationRequested(oe);U=(0,E.$Sc)((0,E.$Tc)(oe),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,x,ne){const de=this.g++,ve={id:de,type:102,channelName:J,name:x,arg:ne};let _=null;const U=new m.$ee({onWillAddFirstListener:()=>{_=(0,N.$jh)(De=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:de,type:103}))}}),le=De=>U.fire(De.data);return this.f.set(de,le),U.event}p(J){switch(J.type){case 100:case 102:{const x=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(x,J.id,0,`${p(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const x=this.q([J.type,J.id]);this.j?.logOutgoing(x,J.id,0,p(J.type));return}}}q(J,x=void 0){const ne=new t;return v(ne,J),v(ne,x),this.r(ne.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const x=new o(J),ne=f(x),de=f(x),ce=ne[0];switch(ce){case 200:return this.j?.logIncoming(J.byteLength,0,0,g(ce)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ne[1],0,g(ce),de),this.t({type:ne[0],id:ne[1],data:de})}}t(J){if(J.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Qc)(this.d.values()),this.d.clear()}}e.$_h=D,Je([L.$1h],D.prototype,"onDidInitializePromise",null);class S{get connections(){const J=[];return this.f.forEach(x=>J.push(x)),J}constructor(J,x,ne){this.a=new Map,this.f=new Set,this.g=new m.$ee,this.onDidAddConnection=this.g.event,this.h=new m.$ee,this.onDidRemoveConnection=this.h.event,this.j=new E.$Uc,this.j.add(J(({protocol:de,onDidClientDisconnect:ce})=>{const ve=m.Event.once(de.onMessage);this.j.add(ve(_=>{const U=new o(_),le=f(U),De=new y(de,le,x,ne),$e=new D(de,x);this.a.forEach((se,oe)=>De.registerChannel(oe,se));const re={channelServer:De,channelClient:$e,ctx:le};this.f.add(re),this.g.fire(re),this.j.add(ce(()=>{De.dispose(),$e.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(J,x){const ne=this;return{call(de,ce,ve){let _;if((0,b.$kg)(x)){const le=(0,a.$4b)(ne.connections.filter(x));_=le?Promise.resolve(le):m.Event.toPromise(m.Event.filter(ne.onDidAddConnection,x))}else _=x.routeCall(ne,de,ce);const U=_.then(le=>le.channelClient.getChannel(J));return j(U).call(de,ce,ve)},listen(de,ce){if((0,b.$kg)(x))return ne.k(J,x,de,ce);const ve=x.routeEvent(ne,de,ce).then(_=>_.channelClient.getChannel(J));return j(ve).listen(de,ce)}}}k(J,x,ne,de){const ce=this;let ve;const _=new m.$ee({onWillAddFirstListener:()=>{ve=new E.$Uc;const U=new m.$ke,le=new Map,De=re=>{const oe=re.channelClient.getChannel(J).listen(ne,de),K=U.add(oe);le.set(re,K)},$e=re=>{const se=le.get(re);se&&(se.dispose(),le.delete(re))};ce.connections.filter(x).forEach(De),m.Event.filter(ce.onDidAddConnection,x)(De,void 0,ve),ce.onDidRemoveConnection($e,void 0,ve),U.event(_.fire,_,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return _.event}registerChannel(J,x){this.a.set(J,x);for(const ne of this.f)ne.channelServer.registerChannel(J,x)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=S;class C{constructor(J,x,ne=null){const de=new t;v(de,x),J.send(de.buffer),this.a=new D(J,ne),this.d=new y(J,x,ne)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,x){this.d.registerChannel(J,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=C;function j(V){return{call(J,x,ne){return V.then(de=>de.call(J,x,ne))},listen(J,x){const ne=new m.$ne;return V.then(de=>ne.input=de.listen(J,x)),ne.event}}}function B(V){let J=!1;return{call(x,ne,de){return J?V.call(x,ne,de):(0,N.$xh)(0).then(()=>J=!0).then(()=>V.call(x,ne,de))},listen(x,ne){if(J)return V.listen(x,ne);const de=new m.$ne;return(0,N.$xh)(0).then(()=>J=!0).then(()=>de.input=V.listen(x,ne)),de.event}}}class z{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const x of J.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await m.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$ei=z;var T;(function(V){function J(ce,ve,_){const U=ce,le=_&&_.disableMarshalling,De=new Map;for(const $e in U)ne($e)&&De.set($e,m.Event.buffer(U[$e],!0,void 0,ve));return new class{listen($e,re,se){const oe=De.get(re);if(oe)return oe;const K=U[re];if(typeof K=="function"){if(de(re))return K.call(U,se);if(ne(re))return De.set(re,m.Event.buffer(U[re],!0,void 0,ve)),De.get(re)}throw new $.$bb(`Event not found: ${re}`)}call($e,re,se){const oe=U[re];if(typeof oe=="function"){if(!le&&Array.isArray(se))for(let te=0;te<se.length;te++)se[te]=(0,I.$6h)(se[te]);let K=oe.apply(U,se);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new $.$bb(`Method not found: ${re}`)}}}V.fromService=J;function x(ce,ve){const _=ve&&ve.disableMarshalling;return new Proxy({},{get(U,le){if(typeof le=="string")return ve?.properties?.has(le)?ve.properties.get(le):de(le)?function(De){return ce.listen(le,De)}:ne(le)?ce.listen(le):async function(...De){let $e;ve&&!(0,b.$fg)(ve.context)?$e=[ve.context,...De]:$e=De;const re=await ce.call(le,$e);return _?re:(0,I.$6h)(re)};throw new $.$bb(`Property not found: ${String(le)}`)}})}V.toService=x;function ne(ce){return ce[0]==="o"&&ce[1]==="n"&&P.$xf(ce.charCodeAt(2))}function de(ce){return/^onDynamic/.test(ce)&&P.$xf(ce.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const J=V.toString();if(J!=="[object Object]")return J}return V}function O(V){return Array.isArray(V)?V.map(F):F(V)}function q(V,J,x,ne,de,ce,ve){ve=O(ve);const _=M[de],U=_[ne%_.length];let le=[`%c[${V}]%c[${String(J).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ce)?(le=le.concat(ve),le.push(")")):le.push(ve),console.log.apply(console,le)}class Y{constructor(J,x){this.d=J,this.f=x,this.a=0,this.b=0}logOutgoing(J,x,ne,de,ce){this.b+=J,q(this.d,this.b,J,x,ne,de,ce)}logIncoming(J,x,ne,de,ce){this.a+=J,q(this.f,this.a,J,x,ne,de,ce)}}e.$fi=Y}),define(ke[82],Se([1,0,21,4,3,81]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var $;(function(c){c.enableDiagnostics=!1,c.records=[];const s=new WeakMap;let v=0;function f(w,D){if(!s.has(w)){const S=String(++v);s.set(w,S)}return s.get(w)}function y(w,D,S,C){if(!c.enableDiagnostics)return;const j=f(w,D);if(C instanceof a.$Ge||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const B=a.$Ge.alloc(C.byteLength);B.set(C),c.records.push({timestamp:Date.now(),id:j,label:D,type:S,buff:B})}else c.records.push({timestamp:Date.now(),id:j,label:D,type:S,data:C})}c.traceSocketEvent=y})($||(e.SocketDiagnostics=$={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let E=null;function I(){return E||(E=a.$Ge.alloc(0)),E}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,v){if(s===0)return I();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const D=this.a[0];return v&&(this.a.shift(),this.b-=s),D}if(this.a[0].byteLength>s){const D=this.a[0].slice(0,s);return v&&(this.a[0]=this.a[0].slice(s),this.b-=s),D}const f=a.$Ge.alloc(s);let y=0,w=0;for(;s>0;){const D=this.a[w];if(D.byteLength>s){const S=D.slice(0,s);f.set(S,y),y+=s,v&&(this.a[w]=D.slice(s),this.b-=s),s-=s}else f.set(D,y),y+=D.byteLength,v?(this.a.shift(),this.b-=D.byteLength):w++,s-=D.byteLength}return f}}e.$gi=P;var b;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(b||(b={}));function k(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var p;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class h{constructor(s,v,f,y){this.type=s,this.id=v,this.ack=f,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.$Vc{constructor(s){super(),this.f=this.B(new N.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new P,this.B(this.a.onData(v=>this.acceptChunk(v))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const v=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=v.readUInt32BE(9),this.g.messageType=v.readUInt8(0),this.g.id=v.readUInt32BE(1),this.g.ack=v.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,y=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",v),this.f.fire(new h(f,y,w,v)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const v=a.$Ge.alloc(13);v.writeUInt8(s.type,0),v.writeUInt32BE(s.id,1),v.writeUInt32BE(s.ack,5),v.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(v,s.data)}g(s,v){const f=this.f===0;return this.d.push(s,v),this.f+=s.byteLength+v.byteLength,f}h(){const s=a.$Ge.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,v){this.g(s,v)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class n extends A.$Vc{constructor(s){super(),this.f=new N.$ee,this.onMessage=this.f.event,this.g=new N.$ee,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(v=>{v.type===1&&this.f.fire(v.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new h(1,0,0,s))}}e.$hi=n;class i extends R.$bi{static fromSocket(s,v){return new i(new n(s),v)}get onDidDispose(){return this.b.onDidDispose}constructor(s,v,f=null){super(s,v,f),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$ii=i;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$ji=d;class o{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,v=this.a;for(;v;)v=v.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let v=0,f=this.a;for(;f;)s[v++]=f.data,f=f.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const v=new o(s);if(!this.a){this.a=v,this.b=v;return}this.b.next=v,this.b=v}}class l{static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const s=Date.now();for(let v=0;v<l.a;v++)this.c[v]=s-1e3*v;setInterval(()=>{for(let v=l.a;v>=1;v--)this.c[v]=this.c[v-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),v=(1+l.a)*1e3;let f=0;for(let y=0;y<l.a;y++)s-this.c[y]<=v&&f++;return 1-f/l.a}hasHighLoad(){return this.d()>=.5}}l.a=10,l.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??l.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Uc,this.o=s.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new h(5,0,0,I());this.p.write(s),this.p.flush()}sendPause(){const s=new h(7,0,0,I());this.p.write(s)}sendResume(){const s=new h(8,0,0,I());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,v){this.a=!0,this.r.dispose(),this.r=new A.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(v)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new h(3,0,this.h,I());this.p.write(s);const v=this.b.toArray();for(let f=0,y=v.length;f<y;f++)this.p.write(v[f]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const v=this.b.peek();if(v&&v.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const v=Date.now();v-this.m>1e4&&(this.m=v,this.p.write(new h(6,0,0,I())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const v=this.b.toArray();for(let f=0,y=v.length;f<y;f++)this.p.write(v[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const v=++this.c;this.h=this.g;const f=new h(1,v,this.h,s);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(s){const v=new h(2,0,0,s);this.p.write(v)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),v=Date.now()-s.writtenTime,f=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(v>=2e4&&f>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:v,timeSinceLastReceivedSomeData:f});return}const w=Math.max(2e4-v,2e4-f,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new h(3,0,this.h,I());this.p.write(s)}D(){this.h=this.g;const s=new h(9,0,this.h,I());this.p.write(s)}}e.$ki=r}),define(ke[182],Se([1,0,53,7,21,22,178,13,4,3,24,104,99,81]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=void 0;class p extends k.$$h{constructor(u){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",n=>A.$Ge.wrap(Buffer.from(n,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$1q=p;class h{constructor(u,n){this.i=u,this.j=n,this.c=new Set,this.g=new Map,this.h=new m.$ee,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$th(i),this.d=null,this.f=null}getChannel(u){const n=this;return{call(i,d,o){return n.k(u,i,d,o)},listen(i,d){return n.l(u,i,d)}}}k(u,n,i,d=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject($.$6());this.b.cancel();const o=this.n(u),t=(0,N.$jh)(c=>o.call(n,i,c)),l=d.onCancellationRequested(()=>t.cancel()),r=(0,E.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,n,i){if(!this.b)return m.Event.None;this.b.cancel();let d;const o=new m.$ee({onWillAddFirstListener:()=>{d=this.n(u).listen(n,i)(o.fire,o),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,I.$4n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,b.$om)(n.env),this.d=(0,a.fork)(this.i,u,n);const i=new m.$ee,o=m.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,L.$Wq)(v)){(0,L.log)(v,`IPC Library: ${this.j.serverName}`);return}i.fire(A.$Ge.wrap(Buffer.from(v,"base64")))}),t=this.j.useQueue?(0,P.$qm)(this.d):this.d,l=v=>this.d&&this.d.connected&&t.send(v.buffer.toString("base64")),r=i.event,c={send:l,onMessage:r};this.f=new k.$_h(c);const s=()=>this.o();process.once("exit",s),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,f)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(y=>(0,E.$Qc)(y)),this.c.clear(),v!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:f})})}return this.f}n(u){let n=this.g.get(u);return n||(n=this.m.getChannel(u),this.g.set(u,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$2q=h}),define(ke[183],Se([1,0,7,4,3,58,18]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.StorageState=e.StorageHint=void 0,e.$Wp=m;var $;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function m(b){const k=b;return k?.changed instanceof Map||k?.deleted instanceof Set}var E;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(E||(e.StorageState=E={}));class I extends A.$Vc{constructor(k,p=Object.create(null)){super(),this.r=k,this.s=p,this.b=this.B(new N.$he),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new a.$uh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((p,h)=>this.w(h,p)),k.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(k,p){if(this.c===E.Closed)return;let h=!1;(0,L.$fg)(p)?h=this.f.delete(k):this.f.get(k)!==p&&(this.f.set(k,p),h=!0),h&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,p){const h=this.f.get(k);return(0,L.$fg)(h)?p:h}getBoolean(k,p){const h=this.get(k);return(0,L.$fg)(h)?p:h==="true"}getNumber(k,p){const h=this.get(k);return(0,L.$fg)(h)?p:parseInt(h,10)}getObject(k,p){const h=this.get(k);return(0,L.$fg)(h)?p:(0,R.$5h)(h)}async set(k,p,h=!1){if(this.c===E.Closed)return;if((0,L.$fg)(p))return this.delete(k,h);const g=(0,L.$$f)(p)||Array.isArray(p)?(0,R.$4h)(p):String(p);if(this.f.get(k)!==g)return this.f.set(k,g),this.j.set(k,g),this.h.delete(k),this.b.fire({key:k,external:h}),this.D()}async delete(k,p=!1){if(!(this.c===E.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:p}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$Xp=I,I.a=100;class P{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((p,h)=>this.a.set(h,p)),k.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$Yp=P}),define(ke[133],Se([1,0,131]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$Jt=void 0;class N{constructor($){const m=(0,a.$6e)($);this.c=m,this.a=N.d(m),this.b=new Map}static d($){const m=new Uint8Array(256);return m.fill($),m}set($,m){const E=(0,a.$6e)(m);$>=0&&$<256?this.a[$]=E:this.b.set($,E)}get($){return $>=0&&$<256?this.a[$]:this.b.get($)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Jt=N;var A;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new N(0)}add($){this.a.set($,1)}has($){return this.a.get($)===1}clear(){return this.a.clear()}}e.$Kt=R}),define(ke[184],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$2t=N;var a;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(a||(e.StringEOL=a={}));function N(A){let R=0,L=0,$=0,m=0;for(let E=0,I=A.length;E<I;E++){const P=A.charCodeAt(E);P===13?(R===0&&(L=E),R++,E+1<I&&A.charCodeAt(E+1)===10?(m|=2,E++):m|=3,$=E+1):P===10&&(m|=1,R===0&&(L=E),R++,$=E+1)}return R===0&&(L=A.length),[R,L,A.length-$,m]}}),define(ke[54],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class a{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new a(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return a.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return a.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return a.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const L=A.lineNumber|0,$=R.lineNumber|0;if(L===$){const m=A.column|0,E=R.column|0;return m-E}return L-$}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new a(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ut=a}),define(ke[29],Se([1,0,54]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class N{constructor(R,L,$,m){R>$||R===$&&L>m?(this.startLineNumber=$,this.startColumn=m,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=$,this.endColumn=m)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,L){let $,m,E,I;return L.startLineNumber<R.startLineNumber?($=L.startLineNumber,m=L.startColumn):L.startLineNumber===R.startLineNumber?($=L.startLineNumber,m=Math.min(L.startColumn,R.startColumn)):($=R.startLineNumber,m=R.startColumn),L.endLineNumber>R.endLineNumber?(E=L.endLineNumber,I=L.endColumn):L.endLineNumber===R.endLineNumber?(E=L.endLineNumber,I=Math.max(L.endColumn,R.endColumn)):(E=R.endLineNumber,I=R.endColumn),new N($,m,E,I)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,L){let $=R.startLineNumber,m=R.startColumn,E=R.endLineNumber,I=R.endColumn;const P=L.startLineNumber,b=L.startColumn,k=L.endLineNumber,p=L.endColumn;return $<P?($=P,m=b):$===P&&(m=Math.max(m,b)),E>k?(E=k,I=p):E===k&&(I=Math.min(I,p)),$>E||$===E&&m>I?null:new N($,m,E,I)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new a.$ut(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new a.$ut(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new N(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new N(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new N(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const E=R.startLineNumber|0,I=L.startLineNumber|0;if(E===I){const P=R.startColumn|0,b=L.startColumn|0;if(P===b){const k=R.endLineNumber|0,p=L.endLineNumber|0;if(k===p){const h=R.endColumn|0,g=L.endColumn|0;return h-g}return k-p}return P-b}return E-I}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$vt=N}),define(ke[185],Se([1,0,29]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0;class N{static insert(R,L){return{range:new a.$vt(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$wt=N}),define(ke[186],Se([1,0,54,29]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.SelectionDirection=void 0;var A;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends N.$vt{constructor($,m,E,I){super($,m,E,I),this.selectionStartLineNumber=$,this.selectionStartColumn=m,this.positionLineNumber=E,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection($){return R.selectionsEqual(this,$)}static selectionsEqual($,m){return $.selectionStartLineNumber===m.selectionStartLineNumber&&$.selectionStartColumn===m.selectionStartColumn&&$.positionLineNumber===m.positionLineNumber&&$.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition($,m){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,$,m):new R($,m,this.startLineNumber,this.startColumn)}getPosition(){return new a.$ut(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.$ut(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition($,m){return this.getDirection()===0?new R($,m,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,$,m)}static fromPositions($,m=$){return new R($.lineNumber,$.column,m.lineNumber,m.column)}static fromRange($,m){return m===0?new R($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new R($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)}static liftSelection($){return new R($.selectionStartLineNumber,$.selectionStartColumn,$.positionLineNumber,$.positionColumn)}static selectionsArrEqual($,m){if($&&!m||!$&&m)return!1;if(!$&&!m)return!0;if($.length!==m.length)return!1;for(let E=0,I=$.length;E<I;E++)if(!this.selectionsEqual($[E],m[E]))return!1;return!0}static isISelection($){return $&&typeof $.selectionStartLineNumber=="number"&&typeof $.selectionStartColumn=="number"&&typeof $.positionLineNumber=="number"&&typeof $.positionColumn=="number"}static createWithDirection($,m,E,I,P){return P===0?new R($,m,E,I):new R(E,I,$,m)}}e.$xt=R}),define(ke[187],Se([1,0,14,12,21]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Et=I,e.$Ft=P;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let $;function m(){return $||($=new TextDecoder("UTF-16BE")),$}let E;function I(){return E||(E=N.$x()?L():m()),E}function P(p,h,g){const u=new Uint16Array(p.buffer,h,g);return g>0&&(u[0]===65279||u[0]===65534)?b(p,h,g):L().decode(u)}function b(p,h,g){const u=[];let n=0;for(let i=0;i<g;i++){const d=A.$Ie(p,h);h+=2,u[n++]=String.fromCharCode(d)}return u.join("")}class k{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return I().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const g=this.a-this.d;g<=1&&(g===0||a.$Cf(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const g=h.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=h;return}for(let u=0;u<g;u++)this.b[this.d++]=h.charCodeAt(u)}}e.$Gt=k}),define(ke[188],Se([1,0,21,187]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0,e.$It=L;function A(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,I,P,b){this.oldPosition=E,this.oldText=I,this.newPosition=P,this.newText=b}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,I,P){const b=I.length;a.$Le(E,b,P),P+=4;for(let k=0;k<b;k++)a.$Je(E,I.charCodeAt(k),P),P+=2;return P}static d(E,I){const P=a.$Ke(E,I);return I+=4,(0,N.$Ft)(E,I,P)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(E,I){return a.$Le(E,this.oldPosition,I),I+=4,a.$Le(E,this.newPosition,I),I+=4,I=R.c(E,this.oldText,I),I=R.c(E,this.newText,I),I}static read(E,I,P){const b=a.$Ke(E,I);I+=4;const k=a.$Ke(E,I);I+=4;const p=R.d(E,I);I+=R.a(p);const h=R.d(E,I);return I+=R.a(h),P.push(new R(b,p,k,h)),I}}e.$Ht=R;function L(m,E){return m===null||m.length===0?E:new $(m,E).compress()}class ${constructor(E,I){this.a=E,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,I=0,P=this.n(E),b=this.l(I);for(;E<this.f||I<this.h;){if(P===null){this.k(b),b=this.l(++I);continue}if(b===null){this.m(P),P=this.n(++E);continue}if(b.oldEnd<=P.newPosition){this.k(b),b=this.l(++I);continue}if(P.newEnd<=b.oldPosition){this.m(P),P=this.n(++E);continue}if(b.oldPosition<P.newPosition){const[u,n]=$.r(b,P.newPosition-b.oldPosition);this.k(u),b=n;continue}if(P.newPosition<b.oldPosition){const[u,n]=$.q(P,b.oldPosition-P.newPosition);this.m(u),P=n;continue}let h,g;if(b.oldEnd===P.newEnd)h=P,g=b,P=this.n(++E),b=this.l(++I);else if(b.oldEnd<P.newEnd){const[u,n]=$.q(P,b.oldLength);h=u,g=b,P=n,b=this.l(++I)}else{const[u,n]=$.r(b,P.newLength);h=P,g=u,P=this.n(++E),b=n}this.d[this.e++]=new R(h.oldPosition,h.oldText,g.newPosition,g.newText),this.g+=h.newLength-h.oldLength,this.j+=g.newLength-g.oldLength}const k=$.s(this.d);return $.t(k)}k(E){this.d[this.e++]=$.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=$.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,I){return new R(I.oldPosition-E,I.oldText,I.newPosition,I.newText)}static p(E,I){return new R(I.oldPosition,I.oldText,I.newPosition+E,I.newText)}static q(E,I){const P=E.newText.substr(0,I),b=E.newText.substr(I);return[new R(E.oldPosition,E.oldText,E.newPosition,P),new R(E.oldEnd,"",E.newPosition+I,b)]}static r(E,I){const P=E.oldText.substr(0,I),b=E.oldText.substr(I);return[new R(E.oldPosition,P,E.newPosition,E.newText),new R(E.oldPosition+I,b,E.newEnd,"")]}static s(E){if(E.length===0)return E;const I=[];let P=0,b=E[0];for(let k=1;k<E.length;k++){const p=E[k];b.oldEnd===p.oldPosition?b=new R(b.oldPosition,b.oldText+p.oldText,b.newPosition,b.newText+p.newText):(I[P++]=b,b=p)}return I[P++]=b,I}static t(E){if(E.length===0)return E;const I=[];let P=0;for(let b=0;b<E.length;b++){const k=E[b];k.oldText!==k.newText&&(I[P++]=k)}return I}}}),define(ke[189],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$5s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[190],Se([1,0,27,133]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.WordCharacterClass=void 0,e.$Mt=$;var A;(function(m){m[m.Regular=0]="Regular",m[m.Whitespace=1]="Whitespace",m[m.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class R extends N.$Jt{constructor(E,I){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=I,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,b=E.length;P<b;P++)this.set(E.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(E,I){let P=null;for(const b of this.h(E)){if(b.index>I)break;P=b}return P}findNextIntlWordAtOrAfterOffset(E,I){for(const P of this.h(E))if(!(P.index<I))return P;return null}h(E){return this.e?this.f===E?this.g:(this.f=E,this.g=this.j(this.e.segment(E)),this.g):[]}j(E){const I=[];for(const P of E)this.k(P)&&I.push(P);return I}k(E){return!!E.isWordLike}}e.$Lt=R;const L=new a.$Ec(10);function $(m,E){const I=`${m}/${E.join(",")}`;let P=L.get(I);return P||(P=new R(m,E),L.set(I,P)),P}}),define(ke[134],Se([1,0,40,3,76]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=void 0,e.$8s=L,e.$9s=m,e.$0s=E,e.$6s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$6s)P.indexOf(k)>=0||(b+="\\"+k);return b+="\\s]+)",new RegExp(b,"g")}e.$7s=R();function L(P){let b=e.$7s;if(P&&P instanceof RegExp)if(P.global)b=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),b=new RegExp(P.source,k)}return b.lastIndex=0,b}const $=new A.$6c;$.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(P){const b=$.unshift(P);return(0,N.$Tc)(b)}function E(P,b,k,p,h){if(b=L(b),h||(h=a.Iterable.first($)),k.length>h.maxLen){let d=P-h.maxLen/2;return d<0?d=0:p+=d,k=k.substring(d,P+h.maxLen/2),E(P,b,k,p,h)}const g=Date.now(),u=P-1-p;let n=-1,i=null;for(let d=1;!(Date.now()-g>=h.timeBudget);d++){const o=u-h.windowSize*d;b.lastIndex=Math.max(0,o);const t=I(b,k,u,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const d={word:i[0],startColumn:p+1+i.index,endColumn:p+1+i.index+i[0].length};return b.lastIndex=0,d}return null}function I(P,b,k,p){let h;for(;h=P.exec(b);){const g=h.index||0;if(g<=k&&P.lastIndex>=k)return h;if(p>0&&g>p)return null}return null}}),define(ke[191],Se([1,0,35,17]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yt=A,e.$Zt=R;function A(L,$,m,E,I,P){if(Array.isArray(L)){let b=0;for(const k of L){const p=A(k,$,m,E,I,P);if(p===10)return p;p>b&&(b=p)}return b}else{if(typeof L=="string")return E?L==="*"?5:L===m?10:0:0;if(L){const{language:b,pattern:k,scheme:p,hasAccessToAllModels:h,notebookType:g}=L;if(!E&&!h)return 0;g&&I&&($=I);let u=0;if(p)if(p===$.scheme)u=10;else if(p==="*")u=5;else return 0;if(b)if(b===m)u=10;else if(b==="*")u=Math.max(u,5);else return 0;if(g)if(g===P)u=10;else if(g==="*"&&P!==void 0)u=Math.max(u,5);else return 0;if(k){let n;if(typeof k=="string"?n=k:n={...k,base:(0,N.$ic)(k.base)},n===$.fsPath||(0,a.$pk)(n,$.fsPath))u=10;else return 0}return u}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(ke[192],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=e.$lu=e.IndentAction=void 0;var a;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(a||(e.IndentAction=a={}));class N{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let m=0,E=$.notIn.length;m<E;m++)switch($.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,m){if($.getTokenCount()===0)return!0;const E=$.findTokenIndexAtOffset(m-2),I=$.getStandardTokenType(E);return this.isOK(I)}g($,m){for(let E=$;E<=m;E++){const I=String.fromCharCode(E);if(!this.open.includes(I)&&!this.close.includes(I))return I}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$lu=N;class A{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of $)R(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),R(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),R(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),R(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&R(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$mu=A;function R(L,$,m){L.has($)?L.get($).push(m):L.set($,[m])}}),define(ke[193],Se([1,0,133]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y3=e.$x3=e.State=void 0,e.$z3=b;var N;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class A{constructor(p,h,g){const u=new Uint8Array(p*h);for(let n=0,i=p*h;n<i;n++)u[n]=g;this.a=u,this.rows=p,this.cols=h}get(p,h){return this.a[p*this.cols+h]}set(p,h,g){this.a[p*this.cols+h]=g}}class R{constructor(p){let h=0,g=0;for(let n=0,i=p.length;n<i;n++){const[d,o,t]=p[n];o>h&&(h=o),d>g&&(g=d),t>g&&(g=t)}h++,g++;const u=new A(g,h,0);for(let n=0,i=p.length;n<i;n++){const[d,o,t]=p[n];u.set(d,o,t)}this.a=u,this.b=h}nextState(p,h){return h<0||h>=this.b?0:this.a.get(p,h)}}e.$x3=R;let L=null;function $(){return L===null&&(L=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var m;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(m||(m={}));let E=null;function I(){if(E===null){E=new a.$Jt(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<k.length;h++)E.set(k.charCodeAt(h),1);const p=".,;:";for(let h=0;h<p.length;h++)E.set(p.charCodeAt(h),2)}return E}class P{static a(p,h,g,u,n){let i=n-1;do{const d=h.charCodeAt(i);if(p.get(d)!==2)break;i--}while(i>u);if(u>0){const d=h.charCodeAt(u-1),o=h.charCodeAt(i);(d===40&&o===41||d===91&&o===93||d===123&&o===125)&&i--}return{range:{startLineNumber:g,startColumn:u+1,endLineNumber:g,endColumn:i+2},url:h.substring(u,i+1)}}static computeLinks(p,h=$()){const g=I(),u=[];for(let n=1,i=p.getLineCount();n<=i;n++){const d=p.getLineContent(n),o=d.length;let t=0,l=0,r=0,c=1,s=!1,v=!1,f=!1,y=!1;for(;t<o;){let w=!1;const D=d.charCodeAt(t);if(c===13){let S;switch(D){case 40:s=!0,S=0;break;case 41:S=s?0:1;break;case 91:f=!0,v=!0,S=0;break;case 93:f=!1,S=v?0:1;break;case 123:y=!0,S=0;break;case 125:S=y?0:1;break;case 39:case 34:case 96:r===D?S=1:r===39||r===34||r===96?S=0:S=1;break;case 42:S=r===42?1:0;break;case 124:S=r===124?1:0;break;case 32:S=f?0:1;break;default:S=g.get(D)}S===1&&(u.push(P.a(g,d,n,l,t)),w=!0)}else if(c===12){let S;D===91?(v=!0,S=0):S=g.get(D),S===1?w=!0:c=13}else c=h.nextState(c,D),c===0&&(w=!0);w&&(c=1,s=!1,v=!1,y=!1,l=t+1,r=D),t++}c===13&&u.push(P.a(g,d,n,l,o))}return u}}e.$y3=P;function b(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:P.computeLinks(k)}}),define(ke[83],Se([1,0,24]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Gv=e.$Fv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Hv=p,e.$Lv=d;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var A;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var $;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})($||(e.InjectedTextCursorStops=$={}));var m;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var I;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,a.$8n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Fv=P;class b{constructor(t,l){this._findMatchBrand=void 0,this.range=t,this.matches=l}}e.$Gv=b;var k;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k||(e.TrackedRangeStickiness=k={}));function p(o){return o&&typeof o.read=="function"}var h;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var g;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class u{constructor(t,l,r,c,s,v){this.identifier=t,this.range=l,this.text=r,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=s,this._isTracked=v}}e.$Iv=u;class n{constructor(t,l,r){this.regex=t,this.wordSeparators=l,this.simpleSearch=r}}e.$Jv=n;class i{constructor(t,l,r){this.reverseEdits=t,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}e.$Kv=i;function d(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(ke[194],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.NodeColor=e.$GC=void 0,e.$IC=A,e.$JC=R,e.$KC=E,e.$LC=I,e.$MC=P,e.$NC=b,e.$OC=k,e.$PC=p;class a{constructor(g,u){this.piece=g,this.color=u,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$HC)return A(this.right);let g=this;for(;g.parent!==e.$HC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$HC?e.$HC:g.parent}prev(){if(this.left!==e.$HC)return R(this.left);let g=this;for(;g.parent!==e.$HC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$HC?e.$HC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$GC=a;var N;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$HC=new a(null,0),e.$HC.parent=e.$HC,e.$HC.left=e.$HC,e.$HC.right=e.$HC,e.$HC.color=0;function A(h){for(;h.left!==e.$HC;)h=h.left;return h}function R(h){for(;h.right!==e.$HC;)h=h.right;return h}function L(h){return h===e.$HC?0:h.size_left+h.piece.length+L(h.right)}function $(h){return h===e.$HC?0:h.lf_left+h.piece.lineFeedCnt+$(h.right)}function m(){e.$HC.parent=e.$HC}function E(h,g){const u=g.right;u.size_left+=g.size_left+(g.piece?g.piece.length:0),u.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=u.left,u.left!==e.$HC&&(u.left.parent=g),u.parent=g.parent,g.parent===e.$HC?h.root=u:g.parent.left===g?g.parent.left=u:g.parent.right=u,u.left=g,g.parent=u}function I(h,g){const u=g.left;g.left=u.right,u.right!==e.$HC&&(u.right.parent=g),u.parent=g.parent,g.size_left-=u.size_left+(u.piece?u.piece.length:0),g.lf_left-=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),g.parent===e.$HC?h.root=u:g===g.parent.right?g.parent.right=u:g.parent.left=u,u.right=g,g.parent=u}function P(h,g){let u,n;if(g.left===e.$HC?(n=g,u=n.right):g.right===e.$HC?(n=g,u=n.left):(n=A(g.right),u=n.right),n===h.root){h.root=u,u.color=0,g.detach(),m(),h.root.parent=e.$HC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=u:n.parent.right=u,n===g?(u.parent=n.parent,p(h,u)):(n.parent===g?u.parent=n:u.parent=n.parent,p(h,u),n.left=g.left,n.right=g.right,n.parent=g.parent,n.color=g.color,g===h.root?h.root=n:g===g.parent.left?g.parent.left=n:g.parent.right=n,n.left!==e.$HC&&(n.left.parent=n),n.right!==e.$HC&&(n.right.parent=n),n.size_left=g.size_left,n.lf_left=g.lf_left,p(h,n)),g.detach(),u.parent.left===u){const o=L(u),t=$(u);if(o!==u.parent.size_left||t!==u.parent.lf_left){const l=o-u.parent.size_left,r=t-u.parent.lf_left;u.parent.size_left=o,u.parent.lf_left=t,k(h,u.parent,l,r)}}if(p(h,u.parent),i){m();return}let d;for(;u!==h.root&&u.color===0;)u===u.parent.left?(d=u.parent.right,d.color===1&&(d.color=0,u.parent.color=1,E(h,u.parent),d=u.parent.right),d.left.color===0&&d.right.color===0?(d.color=1,u=u.parent):(d.right.color===0&&(d.left.color=0,d.color=1,I(h,d),d=u.parent.right),d.color=u.parent.color,u.parent.color=0,d.right.color=0,E(h,u.parent),u=h.root)):(d=u.parent.left,d.color===1&&(d.color=0,u.parent.color=1,I(h,u.parent),d=u.parent.left),d.left.color===0&&d.right.color===0?(d.color=1,u=u.parent):(d.left.color===0&&(d.right.color=0,d.color=1,E(h,d),d=u.parent.left),d.color=u.parent.color,u.parent.color=0,d.left.color=0,I(h,u.parent),u=h.root));u.color=0,m()}function b(h,g){for(p(h,g);g!==h.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const u=g.parent.parent.right;u.color===1?(g.parent.color=0,u.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,E(h,g)),g.parent.color=0,g.parent.parent.color=1,I(h,g.parent.parent))}else{const u=g.parent.parent.left;u.color===1?(g.parent.color=0,u.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,I(h,g)),g.parent.color=0,g.parent.parent.color=1,E(h,g.parent.parent))}h.root.color=0}function k(h,g,u,n){for(;g!==h.root&&g!==e.$HC;)g.parent.left===g&&(g.parent.size_left+=u,g.parent.lf_left+=n),g=g.parent}function p(h,g){let u=0,n=0;if(g!==h.root){for(;g!==h.root&&g===g.parent.right;)g=g.parent;if(g!==h.root)for(g=g.parent,u=L(g.left)-g.size_left,n=$(g.left)-g.lf_left,g.size_left+=u,g.lf_left+=n;g!==h.root&&(u!==0||n!==0);)g.parent.left===g&&(g.parent.size_left+=u,g.parent.lf_left+=n),g=g.parent}}}),define(ke[195],Se([1,0,19,131]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=void 0;class A{constructor(m){this.a=m,this.b=new Uint32Array(m.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(m,E){m=(0,N.$7e)(m);const I=this.a,P=this.b,b=E.length;return b===0?!1:(this.a=new Uint32Array(I.length+b),this.a.set(I.subarray(0,m),0),this.a.set(I.subarray(m),m+b),this.a.set(E,m),m-1<this.c[0]&&(this.c[0]=m-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(m,E){return m=(0,N.$7e)(m),E=(0,N.$7e)(E),this.a[m]===E?!1:(this.a[m]=E,m-1<this.c[0]&&(this.c[0]=m-1),!0)}removeValues(m,E){m=(0,N.$7e)(m),E=(0,N.$7e)(E);const I=this.a,P=this.b;if(m>=I.length)return!1;const b=I.length-m;return E>=b&&(E=b),E===0?!1:(this.a=new Uint32Array(I.length-E),this.a.set(I.subarray(0,m),0),this.a.set(I.subarray(m+E),m),this.b=new Uint32Array(this.a.length),m-1<this.c[0]&&(this.c[0]=m-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(m){return m<0?0:(m=(0,N.$7e)(m),this.d(m))}d(m){if(m<=this.c[0])return this.b[m];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),m>=this.a.length&&(m=this.a.length-1);for(let I=E;I<=m;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],m),this.b[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let E=0,I=this.a.length-1,P=0,b=0,k=0;for(;E<=I;)if(P=E+(I-E)/2|0,b=this.b[P],k=b-this.a[P],m<k)I=P-1;else if(m>=b)E=P+1;else break;return new L(P,m-k)}}e.$4v=A;class R{constructor(m){this.a=m,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(m){return this.g(),m===0?0:this.d[m-1]}getIndexOf(m){this.g();const E=this.e[m],I=E>0?this.d[E-1]:0;return new L(E,m-I)}removeValues(m,E){this.a.splice(m,E),this.f(m)}insertValues(m,E){this.a=(0,a.$Wb)(this.a,m,E),this.f(m)}f(m){this.b=!1,this.c=Math.min(this.c,m-1)}g(){if(!this.b){for(let m=this.c+1,E=this.a.length;m<E;m++){const I=this.a[m],P=m>0?this.d[m-1]:0;this.d[m]=P+I;for(let b=0;b<I;b++)this.e[P+b]=m}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(m,E){this.a[m]!==E&&(this.a[m]=E,this.f(m))}}e.$5v=R;class L{constructor(m,E){this.index=m,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=E}}e.$6v=L}),define(ke[196],Se([1,0,14,54,195]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=void 0;class R{constructor($,m,E,I){this.d=$,this.f=m,this.g=E,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents($){$.eol&&$.eol!==this.g&&(this.g=$.eol,this.j=null);const m=$.changes;for(const E of m)this.o(E.range),this.p(new N.$ut(E.range.startLineNumber,E.range.startColumn),E.text);this.h=$.versionId,this.k=null}l(){if(!this.j){const $=this.g.length,m=this.f.length,E=new Uint32Array(m);for(let I=0;I<m;I++)E[I]=this.f[I].length+$;this.j=new A.$4v(E)}}n($,m){this.f[$]=m,this.j&&this.j.setValue($,this.f[$].length+this.g.length)}o($){if($.startLineNumber===$.endLineNumber){if($.startColumn===$.endColumn)return;this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.startLineNumber-1].substring($.endColumn-1));return}this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.endLineNumber-1].substring($.endColumn-1)),this.f.splice($.startLineNumber,$.endLineNumber-$.startLineNumber),this.j&&this.j.removeValues($.startLineNumber,$.endLineNumber-$.startLineNumber)}p($,m){if(m.length===0)return;const E=(0,a.$lf)(m);if(E.length===1){this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+E[0]+this.f[$.lineNumber-1].substring($.column-1));return}E[E.length-1]+=this.f[$.lineNumber-1].substring($.column-1),this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+E[0]);const I=new Uint32Array(E.length-1);for(let P=1;P<E.length;P++)this.f.splice($.lineNumber+P-1,0,E[P]),I[P-1]=E[P].length+this.g.length;this.j&&this.j.insertValues($.lineNumber,I)}}e.$7v=R}),define(ke[105],Se([1,0,14,190,54,29,83]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.$TC=e.$QC=void 0,e.$RC=E,e.$SC=I,e.$UC=h;const $=999;class m{constructor(n,i,d,o){this.searchString=n,this.isRegex=i,this.matchCase=d,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=a.$jf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let d=!this.isRegex&&!n;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new L.$Jv(i,this.wordSeparators?(0,N.$Mt)(this.wordSeparators,[]):null,d?this.searchString:null)}}e.$QC=m;function E(u){if(!u||u.length===0)return!1;for(let n=0,i=u.length;n<i;n++){const d=u.charCodeAt(n);if(d===10)return!0;if(d===92){if(n++,n>=i)break;const o=u.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function I(u,n,i){if(!i)return new L.$Gv(u,null);const d=[];for(let o=0,t=n.length;o<t;o++)d[o]=n[o];return new L.$Gv(u,d)}class P{constructor(n){const i=[];let d=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[d++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let d=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;d<o;){const t=d+((o-d)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(d=t,o=t):d=t+1}return d+1}}class b{static findMatches(n,i,d,o,t){const l=i.parseSearchRequest();return l?l.regex.multiline?this.b(n,d,new g(l.wordSeparators,l.regex),o,t):this.c(n,d,l,o,t):[]}static a(n,i,d,o,t,l){let r,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),r=i+t+c):r=i+t;let s;if(o){const w=o.findLineFeedCountBeforeOffset(t+l.length)-c;s=r+l.length+w}else s=r+l.length;const v=n.getPositionAt(r),f=n.getPositionAt(s);return new R.$vt(v.lineNumber,v.column,f.lineNumber,f.column)}static b(n,i,d,o,t){const l=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),c=n.getEOL()===`\r
`?new P(r):null,s=[];let v=0,f;for(d.reset(0);f=d.next(r);)if(s[v++]=I(this.a(n,l,r,c,f.index,f[0]),f,o),v>=t)return s;return s}static c(n,i,d,o,t){const l=[];let r=0;if(i.startLineNumber===i.endLineNumber){const s=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(d,s,i.startLineNumber,i.startColumn-1,r,l,o,t),l}const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(d,c,i.startLineNumber,i.startColumn-1,r,l,o,t);for(let s=i.startLineNumber+1;s<i.endLineNumber&&r<t;s++)r=this.d(d,n.getLineContent(s),s,0,r,l,o,t);if(r<t){const s=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(d,s,i.endLineNumber,0,r,l,o,t)}return l}static d(n,i,d,o,t,l,r,c){const s=n.wordSeparators;if(!r&&n.simpleSearch){const y=n.simpleSearch,w=y.length,D=i.length;let S=-w;for(;(S=i.indexOf(y,S+w))!==-1;)if((!s||h(s,i,D,S,w))&&(l[t++]=new L.$Gv(new R.$vt(d,S+1+o,d,S+1+w+o),null),t>=c))return t;return t}const v=new g(n.wordSeparators,n.regex);let f;v.reset(0);do if(f=v.next(i),f&&(l[t++]=I(new R.$vt(d,f.index+1+o,d,f.index+1+f[0].length+o),f,r),t>=c))return t;while(f);return t}static findNextMatch(n,i,d,o){const t=i.parseSearchRequest();if(!t)return null;const l=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,d,l,o):this.f(n,d,l,o)}static e(n,i,d,o){const t=new A.$ut(i.lineNumber,1),l=n.getOffsetAt(t),r=n.getLineCount(),c=n.getValueInRange(new R.$vt(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),s=n.getEOL()===`\r
`?new P(c):null;d.reset(i.column-1);const v=d.next(c);return v?I(this.a(n,l,c,s,v.index,v[0]),v,o):i.lineNumber!==1||i.column!==1?this.e(n,new A.$ut(1,1),d,o):null}static f(n,i,d,o){const t=n.getLineCount(),l=i.lineNumber,r=n.getLineContent(l),c=this.g(d,r,l,i.column,o);if(c)return c;for(let s=1;s<=t;s++){const v=(l+s-1)%t,f=n.getLineContent(v+1),y=this.g(d,f,v+1,1,o);if(y)return y}return null}static g(n,i,d,o,t){n.reset(o-1);const l=n.next(i);return l?I(new R.$vt(d,l.index+1,d,l.index+1+l[0].length),l,t):null}static findPreviousMatch(n,i,d,o){const t=i.parseSearchRequest();if(!t)return null;const l=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,d,l,o):this.j(n,d,l,o)}static h(n,i,d,o){const t=this.b(n,new R.$vt(1,1,i.lineNumber,i.column),d,o,10*$);if(t.length>0)return t[t.length-1];const l=n.getLineCount();return i.lineNumber!==l||i.column!==n.getLineMaxColumn(l)?this.h(n,new A.$ut(l,n.getLineMaxColumn(l)),d,o):null}static j(n,i,d,o){const t=n.getLineCount(),l=i.lineNumber,r=n.getLineContent(l).substring(0,i.column-1),c=this.k(d,r,l,o);if(c)return c;for(let s=1;s<=t;s++){const v=(t+l-s-1)%t,f=n.getLineContent(v+1),y=this.k(d,f,v+1,o);if(y)return y}return null}static k(n,i,d,o){let t=null,l;for(n.reset(0);l=n.next(i);)t=I(new R.$vt(d,l.index+1,d,l.index+1+l[0].length),l,o);return t}}e.$TC=b;function k(u,n,i,d,o){if(d===0)return!0;const t=n.charCodeAt(d-1);if(u.get(t)!==0||t===13||t===10)return!0;if(o>0){const l=n.charCodeAt(d);if(u.get(l)!==0)return!0}return!1}function p(u,n,i,d,o){if(d+o===i)return!0;const t=n.charCodeAt(d+o);if(u.get(t)!==0||t===13||t===10)return!0;if(o>0){const l=n.charCodeAt(d+o-1);if(u.get(l)!==0)return!0}return!1}function h(u,n,i,d,o){return k(u,n,i,d,o)&&p(u,n,i,d,o)}class g{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let d;do{if(this.b+this.c===i||(d=this.a.exec(n),!d))return null;const o=d.index,t=d[0].length;if(o===this.b&&t===this.c){if(t===0){a.$Ff(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,o,t))return d}while(d);return null}}e.$VC=g}),define(ke[135],Se([1,0,54,29,83,194,105]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=void 0,e.$WC=I,e.$XC=P;const $=65535;function m(u){let n;return u[u.length-1]<65536?n=new Uint16Array(u.length):n=new Uint32Array(u.length),n.set(u,0),n}class E{constructor(n,i,d,o,t){this.lineStarts=n,this.cr=i,this.lf=d,this.crlf=o,this.isBasicASCII=t}}function I(u,n=!0){const i=[0];let d=1;for(let o=0,t=u.length;o<t;o++){const l=u.charCodeAt(o);l===13?o+1<t&&u.charCodeAt(o+1)===10?(i[d++]=o+2,o++):i[d++]=o+1:l===10&&(i[d++]=o+1)}return n?m(i):i}function P(u,n){u.length=0,u[0]=0;let i=1,d=0,o=0,t=0,l=!0;for(let c=0,s=n.length;c<s;c++){const v=n.charCodeAt(c);v===13?c+1<s&&n.charCodeAt(c+1)===10?(t++,u[i++]=c+2,c++):(d++,u[i++]=c+1):v===10?(o++,u[i++]=c+1):l&&v!==9&&(v<32||v>126)&&(l=!1)}const r=new E(m(u),d,o,t,l);return u.length=0,r}class b{constructor(n,i,d,o,t){this.bufferIndex=n,this.start=i,this.end=d,this.lineFeedCnt=o,this.length=t}}e.$YC=b;class k{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$ZC=k;class p{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$HC&&n.iterate(n.root,d=>(d!==R.$HC&&this.a.push(d.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const d=this.b[i];if(d.nodeStartOffset<=n&&d.nodeStartOffset+d.node.piece.length>=n)return d}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const d=this.b[i];if(d.nodeStartLineNumber&&d.nodeStartLineNumber<n&&d.nodeStartLineNumber+d.node.piece.lineFeedCnt>=n)return d}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const d=this.b;for(let o=0;o<d.length;o++){const t=d[o];if(t.node.parent===null||t.nodeStartOffset>=n){d[o]=null,i=!0;continue}}if(i){const o=[];for(const t of d)t!==null&&o.push(t);this.b=o}}}class g{constructor(n,i,d){this.create(n,i,d)}create(n,i,d){this.a=[new k("",[0])],this.g={line:0,column:0},this.root=R.$HC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=d;let o=null;for(let t=0,l=n.length;t<l;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=I(n[t].buffer));const r=new b(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,r)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=$,d=i-Math.floor(i/3),o=d*2;let t="",l=0;const r=[];if(this.iterate(this.root,c=>{const s=this.R(c),v=s.length;if(l<=d||l+v<o)return t+=s,l+=v,!0;const f=t.replace(/\r\n|\r|\n/g,n);return r.push(new k(f,I(f))),t=s,l=v,!0}),l>0){const c=t.replace(/\r\n|\r|\n/g,n);r.push(new k(c,I(c)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===R.$HC)return!0;const t=this.R(o),l=t.length,r=n.G(i),c=n.G(i+l),s=n.getValueInRange2(r,c);return i+=l,t===s})}getOffsetAt(n,i){let d=0,o=this.root;for(;o!==R.$HC;)if(o.left!==R.$HC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){d+=o.size_left;const t=this.B(o,n-o.lf_left-2);return d+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,d+=o.size_left+o.piece.length,o=o.right;return d}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,d=0;const o=n;for(;i!==R.$HC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(d+=i.lf_left+t.index,t.index===0){const l=this.getOffsetAt(d+1,1),r=o-l;return new a.$ut(d+1,r+1)}return new a.$ut(d+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,d+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$HC){const t=this.getOffsetAt(d+1,1),l=o-n-t;return new a.$ut(d+1,l+1)}else i=i.right;return new a.$ut(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const d=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(d,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,c=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);return c.substring(s+n.remainder,s+i.remainder)}let d=n.node;const o=this.a[d.piece.bufferIndex].buffer,t=this.u(d.piece.bufferIndex,d.piece.start);let l=o.substring(t+n.remainder,t+d.piece.length);for(d=d.next();d!==R.$HC;){const r=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);if(d===i.node){l+=r.substring(c,c+i.remainder);break}else l+=r.substr(c,d.piece.length);d=d.next()}return l}getLinesContent(){const n=[];let i=0,d="",o=!1;return this.iterate(this.root,t=>{if(t===R.$HC)return!0;const l=t.piece;let r=l.length;if(r===0)return!0;const c=this.a[l.bufferIndex].buffer,s=this.a[l.bufferIndex].lineStarts,v=l.start.line,f=l.end.line;let y=s[v]+l.start.column;if(o&&(c.charCodeAt(y)===10&&(y++,r--),n[i++]=d,d="",o=!1,r===0))return!0;if(v===f)return!this.f&&c.charCodeAt(y+r-1)===13?(o=!0,d+=c.substr(y,r-1)):d+=c.substr(y,r),!0;d+=this.f?c.substring(y,Math.max(y,s[v+1]-this.e)):c.substring(y,s[v+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=d;for(let w=v+1;w<f;w++)d=this.f?c.substring(s[w],s[w+1]-this.e):c.substring(s[w],s[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=d;return!this.f&&c.charCodeAt(s[f]+l.end.column-1)===13?(o=!0,l.end.column===0?i--:d=c.substr(s[f],l.end.column-1)):d=c.substr(s[f],l.end.column),!0}),o&&(n[i++]=d,d=""),n[i++]=d,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const d=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return d.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const d=this.H(n,i+1);return this.l(d)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,d,o,t,l,r,c,s,v,f){const y=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),D=this.u(n.piece.bufferIndex,t),S=this.u(n.piece.bufferIndex,l);let C;const j={line:0,column:0};let B,z;i._wordSeparators?(B=y.buffer.substring(D,S),z=T=>T+D,i.reset(0)):(B=y.buffer,z=T=>T,i.reset(D));do if(C=i.next(B),C){if(z(C.index)>=S)return v;this.s(n,z(C.index)-w,j);const T=this.t(n.piece.bufferIndex,t,j),M=j.line===t.line?j.column-t.column+o:j.column+1,F=M+C[0].length;if(f[v++]=(0,L.$SC)(new N.$vt(d+T,M,d+T,F),C,c),z(C.index)+C[0].length>=S||v>=s)return v}while(C);return v}findMatchesLineByLine(n,i,d,o){const t=[];let l=0;const r=new L.$VC(i.wordSeparators,i.regex);let c=this.H(n.startLineNumber,n.startColumn);if(c===null)return[];const s=this.H(n.endLineNumber,n.endColumn);if(s===null)return[];let v=this.s(c.node,c.remainder);const f=this.s(s.node,s.remainder);if(c.node===s.node)return this.findMatchesInNode(c.node,r,n.startLineNumber,n.startColumn,v,f,i,d,o,l,t),t;let y=n.startLineNumber,w=c.node;for(;w!==s.node;){const S=this.t(w.piece.bufferIndex,v,w.piece.end);if(S>=1){const j=this.a[w.piece.bufferIndex].lineStarts,B=this.u(w.piece.bufferIndex,w.piece.start),z=j[v.line+S],T=y===n.startLineNumber?n.startColumn:1;if(l=this.findMatchesInNode(w,r,y,T,v,this.s(w,z-B),i,d,o,l,t),l>=o)return t;y+=S}const C=y===n.startLineNumber?n.startColumn-1:0;if(y===n.endLineNumber){const j=this.getLineContent(y).substring(C,n.endColumn-1);return l=this.n(i,r,j,n.endLineNumber,C,l,t,d,o),t}if(l=this.n(i,r,this.getLineContent(y).substr(C),y,C,l,t,d,o),l>=o)return t;y++,c=this.H(y,1),w=c.node,v=this.s(c.node,c.remainder)}if(y===n.endLineNumber){const S=y===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(y).substring(S,n.endColumn-1);return l=this.n(i,r,C,n.endLineNumber,S,l,t,d,o),t}const D=y===n.startLineNumber?n.startColumn:1;return l=this.findMatchesInNode(s.node,r,y,D,v,f,i,d,o,l,t),t}n(n,i,d,o,t,l,r,c,s){const v=n.wordSeparators;if(!c&&n.simpleSearch){const y=n.simpleSearch,w=y.length,D=d.length;let S=-w;for(;(S=d.indexOf(y,S+w))!==-1;)if((!v||(0,L.$UC)(v,d,D,S,w))&&(r[l++]=new A.$Gv(new N.$vt(o,S+1+t,o,S+1+w+t),null),l>=s))return l;return l}let f;i.reset(0);do if(f=i.next(d),f&&(r[l++]=(0,L.$SC)(new N.$vt(o,f.index+1+t,o,f.index+1+f[0].length+t),f,c),l>=s))return l;while(f);return l}insert(n,i,d=!1){if(this.f=this.f&&d,this.j.lineNumber=0,this.j.value="",this.root!==R.$HC){const{node:o,remainder:t,nodeStartOffset:l}=this.G(n),r=o.piece,c=r.bufferIndex,s=this.s(o,t);if(o.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&l+r.length===n&&i.length<$){this.F(o,i),this.y();return}if(l===n)this.o(i,o),this.h.validate(n);else if(l+o.piece.length>n){const v=[];let f=new b(r.bufferIndex,s,r.end,this.t(r.bufferIndex,s,r.end),this.u(c,r.end)-this.u(c,s));if(this.K()&&this.M(i)&&this.I(o,t)===10){const S={line:f.start.line+1,column:0};f=new b(f.bufferIndex,S,f.end,this.t(f.bufferIndex,S,f.end),f.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const S=this.s(o,t-1);this.C(o,S),i="\r"+i,o.piece.length===0&&v.push(o)}else this.C(o,s);else this.C(o,s);const y=this.w(i);f.length>0&&this.S(o,f);let w=o;for(let D=0;D<y.length;D++)w=this.S(w,y[D]);this.v(v)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let l=1;l<o.length;l++)t=this.S(t,o[l])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$HC)return;const d=this.G(n),o=this.G(n+i),t=d.node,l=o.node;if(t===l){const y=this.s(t,d.remainder),w=this.s(t,o.remainder);if(d.nodeStartOffset===n){if(i===t.piece.length){const D=t.next();(0,R.$MC)(this,t),this.N(D),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(d.nodeStartOffset+t.piece.length===n+i){this.C(t,y),this.O(t),this.y();return}this.E(t,y,w),this.y();return}const r=[],c=this.s(t,d.remainder);this.C(t,c),this.h.validate(n),t.piece.length===0&&r.push(t);const s=this.s(l,o.remainder);this.D(l,s),l.piece.length===0&&r.push(l);const v=t.next();for(let y=v;y!==R.$HC&&y!==l;y=y.next())r.push(y);const f=t.piece.length===0?t.prev():t;this.v(r),this.O(f),this.y()}o(n,i){const d=[];if(this.K()&&this.M(n)&&this.L(i)){const l=i.piece,r={line:l.start.line+1,column:0},c=new b(l.bufferIndex,r,l.end,this.t(l.bufferIndex,r,l.end),l.length-1);i.piece=c,n+=`
`,(0,R.$OC)(this,i,-1,-1),i.piece.length===0&&d.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let l=o.length-2;l>=0;l--)t=this.T(t,o[l]);this.N(t),this.v(d)}q(n,i){this.Q(n,i)&&(n+=`
`);const d=this.w(n),o=this.S(i,d[0]);let t=o;for(let l=1;l<d.length;l++)t=this.S(t,d[l]);this.N(o)}s(n,i,d){const o=n.piece,t=n.piece.bufferIndex,l=this.a[t].lineStarts,c=l[o.start.line]+o.start.column+i;let s=o.start.line,v=o.end.line,f=0,y=0,w=0;for(;s<=v&&(f=s+(v-s)/2|0,w=l[f],f!==v);)if(y=l[f+1],c<w)v=f-1;else if(c>=y)s=f+1;else break;return d?(d.line=f,d.column=c-w,null):{line:f,column:c-w}}t(n,i,d){if(d.column===0)return d.line-i.line;const o=this.a[n].lineStarts;if(d.line===o.length-1)return d.line-i.line;const t=o[d.line+1],l=o[d.line]+d.column;if(t>l+1)return d.line-i.line;const r=l-1;return this.a[n].buffer.charCodeAt(r)===13?d.line-i.line+1:d.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$MC)(this,n[i])}w(n){if(n.length>$){const v=[];for(;n.length>$;){const y=n.charCodeAt($-1);let w;y===13||y>=55296&&y<=56319?(w=n.substring(0,$-1),n=n.substring($-1)):(w=n.substring(0,$),n=n.substring($));const D=I(w);v.push(new b(this.a.length,{line:0,column:0},{line:D.length-1,column:w.length-D[D.length-1]},D.length-1,w.length)),this.a.push(new k(w,D))}const f=I(n);return v.push(new b(this.a.length,{line:0,column:0},{line:f.length-1,column:n.length-f[f.length-1]},f.length-1,n.length)),this.a.push(new k(n,f)),v}let i=this.a[0].buffer.length;const d=I(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let v=0;v<d.length;v++)d[v]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(d.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let v=0;v<d.length;v++)d[v]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(d.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,l=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[l],c={line:l,column:r},s=new b(0,o,c,this.t(0,o,c),t-i);return this.g=c,[s]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let d=this.root,o="";const t=this.h.get2(n);if(t){d=t.node;const l=this.B(d,n-t.nodeStartLineNumber-1),r=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);if(t.nodeStartLineNumber+d.piece.lineFeedCnt===n)o=r.substring(c+l,c+d.piece.length);else{const s=this.B(d,n-t.nodeStartLineNumber);return r.substring(c+l,c+s-i)}}else{let l=0;const r=n;for(;d!==R.$HC;)if(d.left!==R.$HC&&d.lf_left>=n-1)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt>n-1){const c=this.B(d,n-d.lf_left-2),s=this.B(d,n-d.lf_left-1),v=this.a[d.piece.bufferIndex].buffer,f=this.u(d.piece.bufferIndex,d.piece.start);return l+=d.size_left,this.h.set({node:d,nodeStartOffset:l,nodeStartLineNumber:r-(n-1-d.lf_left)}),v.substring(f+c,f+s-i)}else if(d.lf_left+d.piece.lineFeedCnt===n-1){const c=this.B(d,n-d.lf_left-2),s=this.a[d.piece.bufferIndex].buffer,v=this.u(d.piece.bufferIndex,d.piece.start);o=s.substring(v+c,v+d.piece.length);break}else n-=d.lf_left+d.piece.lineFeedCnt,l+=d.size_left+d.piece.length,d=d.right}for(d=d.next();d!==R.$HC;){const l=this.a[d.piece.bufferIndex].buffer;if(d.piece.lineFeedCnt>0){const r=this.B(d,0),c=this.u(d.piece.bufferIndex,d.piece.start);return o+=l.substring(c,c+r-i),o}else{const r=this.u(d.piece.bufferIndex,d.piece.start);o+=l.substr(r,d.piece.length)}d=d.next()}return o}y(){let n=this.root,i=1,d=0;for(;n!==R.$HC;)i+=n.lf_left+n.piece.lineFeedCnt,d+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=d,this.h.validate(this.c)}A(n,i){const d=n.piece,o=this.s(n,i),t=o.line-d.start.line;if(this.u(d.bufferIndex,d.end)-this.u(d.bufferIndex,d.start)===i){const l=this.t(n.piece.bufferIndex,d.start,o);if(l!==t)return{index:l,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const d=n.piece,o=this.a[d.bufferIndex].lineStarts,t=d.start.line+i+1;return t>d.end.line?o[d.end.line]+d.end.column-o[d.start.line]-d.start.column:o[t]-o[d.start.line]-d.start.column}C(n,i){const d=n.piece,o=d.lineFeedCnt,t=this.u(d.bufferIndex,d.end),l=i,r=this.u(d.bufferIndex,l),c=this.t(d.bufferIndex,d.start,l),s=c-o,v=r-t,f=d.length+v;n.piece=new b(d.bufferIndex,d.start,l,c,f),(0,R.$OC)(this,n,v,s)}D(n,i){const d=n.piece,o=d.lineFeedCnt,t=this.u(d.bufferIndex,d.start),l=i,r=this.t(d.bufferIndex,l,d.end),c=this.u(d.bufferIndex,l),s=r-o,v=t-c,f=d.length+v;n.piece=new b(d.bufferIndex,l,d.end,r,f),(0,R.$OC)(this,n,v,s)}E(n,i,d){const o=n.piece,t=o.start,l=o.end,r=o.length,c=o.lineFeedCnt,s=i,v=this.t(o.bufferIndex,o.start,s),f=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new b(o.bufferIndex,o.start,s,v,f),(0,R.$OC)(this,n,f-r,v-c);const y=new b(o.bufferIndex,d,l,this.t(o.bufferIndex,d,l),this.u(o.bufferIndex,l)-this.u(o.bufferIndex,d)),w=this.S(n,y);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const d=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=I(i,!1);for(let w=0;w<t.length;w++)t[w]+=o;if(d){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const l=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[l],c={line:l,column:r},s=n.piece.length+i.length,v=n.piece.lineFeedCnt,f=this.t(0,n.piece.start,c),y=f-v;n.piece=new b(n.piece.bufferIndex,n.piece.start,c,f,s),this.g=c,(0,R.$OC)(this,n,i.length,y)}G(n){let i=this.root;const d=this.h.get(n);if(d)return{node:d.node,nodeStartOffset:d.nodeStartOffset,remainder:n-d.nodeStartOffset};let o=0;for(;i!==R.$HC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let d=this.root,o=0;for(;d!==R.$HC;)if(d.left!==R.$HC&&d.lf_left>=n-1)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt>n-1){const t=this.B(d,n-d.lf_left-2),l=this.B(d,n-d.lf_left-1);return o+=d.size_left,{node:d,remainder:Math.min(t+i-1,l),nodeStartOffset:o}}else if(d.lf_left+d.piece.lineFeedCnt===n-1){const t=this.B(d,n-d.lf_left-2);if(t+i-1<=d.piece.length)return{node:d,remainder:t+i-1,nodeStartOffset:o};i-=d.piece.length-t;break}else n-=d.lf_left+d.piece.lineFeedCnt,o+=d.size_left+d.piece.length,d=d.right;for(d=d.next();d!==R.$HC;){if(d.piece.lineFeedCnt>0){const t=this.B(d,0),l=this.J(d);return{node:d,remainder:Math.min(i-1,t),nodeStartOffset:l}}else if(d.piece.length>=i-1){const t=this.J(d);return{node:d,remainder:i-1,nodeStartOffset:t}}else i-=d.piece.length;d=d.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const d=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return d.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$HC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,d=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=d[o]+i.start.column;return o===d.length-1||d[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$HC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const d=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const l=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new b(n.piece.bufferIndex,n.piece.start,t,r,l),(0,R.$OC)(this,n,-1,-1),n.piece.length===0&&d.push(n);const c={line:i.piece.start.line+1,column:0},s=i.piece.length-1,v=this.t(i.piece.bufferIndex,c,i.piece.end);i.piece=new b(i.piece.bufferIndex,c,i.piece.end,v,s),(0,R.$OC)(this,i,-1,-1),i.piece.length===0&&d.push(i);const f=this.w(`\r
`);this.S(n,f[0]);for(let y=0;y<d.length;y++)(0,R.$MC)(this,d[y])}Q(n,i){if(this.K()&&this.M(n)){const d=i.next();if(this.L(d)){if(n+=`
`,d.piece.length===1)(0,R.$MC)(this,d);else{const o=d.piece,t={line:o.start.line+1,column:0},l=o.length-1,r=this.t(o.bufferIndex,t,o.end);d.piece=new b(o.bufferIndex,t,o.end,r,l),(0,R.$OC)(this,d,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$HC)return i(R.$HC);const d=this.iterate(n.left,i);return d&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$HC)return"";const i=this.a[n.piece.bufferIndex],d=n.piece,o=this.u(d.bufferIndex,d.start),t=this.u(d.bufferIndex,d.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],d=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(d,o)}S(n,i){const d=new R.$GC(i,1);if(d.left=R.$HC,d.right=R.$HC,d.parent=R.$HC,d.size_left=0,d.lf_left=0,this.root===R.$HC)this.root=d,d.color=0;else if(n.right===R.$HC)n.right=d,d.parent=n;else{const t=(0,R.$IC)(n.right);t.left=d,d.parent=t}return(0,R.$NC)(this,d),d}T(n,i){const d=new R.$GC(i,1);if(d.left=R.$HC,d.right=R.$HC,d.parent=R.$HC,d.size_left=0,d.lf_left=0,this.root===R.$HC)this.root=d,d.color=0;else if(n.left===R.$HC)n.left=d,d.parent=n;else{const o=(0,R.$JC)(n.left);o.right=d,d.parent=o}return(0,R.$NC)(this,d),d}U(n){let i="";return this.iterate(n,d=>(i+=this.R(d),!0)),i}}e.$1C=g}),define(ke[197],Se([1,0,4,14,29,83,135,184,188,3]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class I extends E.$Vc{constructor(b,k,p,h,g,u,n){super(),this.m=this.B(new a.$ee),this.onDidChangeContent=this.m.event,this.f=k,this.j=!u,this.g=h,this.h=g,this.c=new L.$1C(b,p,n)}equals(b){return!(b instanceof I)||this.f!==b.f||this.getEOL()!==b.getEOL()?!1:this.c.equal(b.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(b){return this.c.createSnapshot(b?this.f:"")}getOffsetAt(b,k){return this.c.getOffsetAt(b,k)}getPositionAt(b){return this.c.getPositionAt(b)}getRangeAt(b,k){const p=b+k,h=this.getPositionAt(b),g=this.getPositionAt(p);return new A.$vt(h.lineNumber,h.column,g.lineNumber,g.column)}getValueInRange(b,k=0){if(b.isEmpty())return"";const p=this.n(k);return this.c.getValueInRange(b,p)}getValueLengthInRange(b,k=0){if(b.isEmpty())return 0;if(b.startLineNumber===b.endLineNumber)return b.endColumn-b.startColumn;const p=this.getOffsetAt(b.startLineNumber,b.startColumn),h=this.getOffsetAt(b.endLineNumber,b.endColumn);let g=0;const u=this.n(k),n=this.getEOL();if(u.length!==n.length){const i=u.length-n.length,d=b.endLineNumber-b.startLineNumber;g=i*d}return h-p+g}getCharacterCountInRange(b,k=0){if(this.j){let p=0;const h=b.startLineNumber,g=b.endLineNumber;for(let u=h;u<=g;u++){const n=this.getLineContent(u),i=u===h?b.startColumn-1:0,d=u===g?b.endColumn-1:n.length;for(let o=i;o<d;o++)N.$Cf(n.charCodeAt(o))?(p=p+1,o=o+1):p=p+1}return p+=this.n(k).length*(g-h),p}return this.getValueLengthInRange(b,k)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(b){return this.c.getLineContent(b)}getLineCharCode(b,k){return this.c.getLineCharCode(b,k)}getCharCode(b){return this.c.getCharCode(b)}getLineLength(b){return this.c.getLineLength(b)}getLineMinColumn(b){return 1}getLineMaxColumn(b){return this.getLineLength(b)+1}getLineFirstNonWhitespaceColumn(b){const k=N.$nf(this.getLineContent(b));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(b){const k=N.$pf(this.getLineContent(b));return k===-1?0:k+2}n(b){switch(b){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(b){this.c.setEOL(b)}applyEdits(b,k,p){let h=this.g,g=this.h,u=this.j,n=!0,i=[];for(let s=0;s<b.length;s++){const v=b[s];n&&v._isTracked&&(n=!1);const f=v.range;if(v.text){let C=!0;u||(C=!N.$Nf(v.text),u=C),!h&&C&&(h=N.$Mf(v.text)),!g&&C&&(g=N.$Pf(v.text))}let y="",w=0,D=0,S=0;if(v.text){let C;[w,D,S,C]=(0,$.$2t)(v.text);const j=this.getEOL();C===0||C===(j===`\r
`?2:1)?y=v.text:y=v.text.replace(/\r\n|\r|\n/g,j)}i[s]={sortIndex:s,identifier:v.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:y,eolCount:w,firstLineLength:D,lastLineLength:S,forceMoveMarkers:!!v.forceMoveMarkers,isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}i.sort(I.u);let d=!1;for(let s=0,v=i.length-1;s<v;s++){const f=i[s].range.getEndPosition(),y=i[s+1].range.getStartPosition();if(y.isBeforeOrEqual(f)){if(y.isBefore(f))throw new Error("Overlapping ranges are not allowed!");d=!0}}n&&(i=this.s(i));const o=p||k?I._getInverseEditRanges(i):[],t=[];if(k)for(let s=0;s<i.length;s++){const v=i[s],f=o[s];if(v.isAutoWhitespaceEdit&&v.range.isEmpty())for(let y=f.startLineNumber;y<=f.endLineNumber;y++){let w="";y===f.startLineNumber&&(w=this.getLineContent(v.range.startLineNumber),N.$nf(w)!==-1)||t.push({lineNumber:y,oldContent:w})}}let l=null;if(p){let s=0;l=[];for(let v=0;v<i.length;v++){const f=i[v],y=o[v],w=this.getValueInRange(f.range),D=f.rangeOffset+s;s+=f.text.length-w.length,l[v]={sortIndex:f.sortIndex,identifier:f.identifier,range:y,text:w,textChange:new m.$Ht(f.rangeOffset,w,D,f.text)}}d||l.sort((v,f)=>v.sortIndex-f.sortIndex)}this.g=h,this.h=g,this.j=u;const r=this.t(i);let c=null;if(k&&t.length>0){t.sort((s,v)=>v.lineNumber-s.lineNumber),c=[];for(let s=0,v=t.length;s<v;s++){const f=t[s].lineNumber;if(s>0&&t[s-1].lineNumber===f)continue;const y=t[s].oldContent,w=this.getLineContent(f);w.length===0||w===y||N.$nf(w)!==-1||c.push(f)}}return this.m.fire(),new R.$Kv(l,r,c)}s(b){return b.length<1e3?b:[this._toSingleEditOperation(b)]}_toSingleEditOperation(b){let k=!1;const p=b[0].range,h=b[b.length-1].range,g=new A.$vt(p.startLineNumber,p.startColumn,h.endLineNumber,h.endColumn);let u=p.startLineNumber,n=p.startColumn;const i=[];for(let r=0,c=b.length;r<c;r++){const s=b[r],v=s.range;k=k||s.forceMoveMarkers,i.push(this.getValueInRange(new A.$vt(u,n,v.startLineNumber,v.startColumn))),s.text.length>0&&i.push(s.text),u=v.endLineNumber,n=v.endColumn}const d=i.join(""),[o,t,l]=(0,$.$2t)(d);return{sortIndex:0,identifier:b[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:d,eolCount:o,firstLineLength:t,lastLineLength:l,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(b){b.sort(I.w);const k=[];for(let p=0;p<b.length;p++){const h=b[p],g=h.range.startLineNumber,u=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(g===n&&u===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const d=new A.$vt(g,u,n,i);k.push({range:d,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return k}findMatchesLineByLine(b,k,p,h){return this.c.findMatchesLineByLine(b,k,p,h)}getPieceTree(){return this.c}static _getInverseEditRange(b,k){const p=b.startLineNumber,h=b.startColumn,[g,u,n]=(0,$.$2t)(k);let i;if(k.length>0){const d=g+1;d===1?i=new A.$vt(p,h,p,h+u):i=new A.$vt(p,h,p+d-1,n+1)}else i=new A.$vt(p,h,p,h);return i}static _getInverseEditRanges(b){const k=[];let p=0,h=0,g=null;for(let u=0,n=b.length;u<n;u++){const i=b[u];let d,o;g?g.range.endLineNumber===i.range.startLineNumber?(d=p,o=h+(i.range.startColumn-g.range.endColumn)):(d=p+(i.range.startLineNumber-g.range.endLineNumber),o=i.range.startColumn):(d=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const l=i.eolCount+1;l===1?t=new A.$vt(d,o,d,o+i.firstLineLength):t=new A.$vt(d,o,d+l-1,i.lastLineLength+1)}else t=new A.$vt(d,o,d,o);p=t.endLineNumber,h=t.endColumn,k.push(t),g=i}return k}static u(b,k){const p=A.$vt.compareRangesUsingEnds(b.range,k.range);return p===0?b.sortIndex-k.sortIndex:p}static w(b,k){const p=A.$vt.compareRangesUsingEnds(b.range,k.range);return p===0?k.sortIndex-b.sortIndex:-p}}e.$2C=I}),define(ke[198],Se([1,0,14,135,197]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=void 0;class R{constructor(m,E,I,P,b,k,p,h,g){this.a=m,this.b=E,this.c=I,this.d=P,this.e=b,this.f=k,this.g=p,this.h=h,this.j=g}k(m){const E=this.c+this.d+this.e,I=this.c+this.e;return E===0?m===1?`
`:`\r
`:I>E/2?`\r
`:`
`}create(m){const E=this.k(m),I=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let b=0,k=I.length;b<k;b++){const p=I[b].buffer.replace(/\r\n|\r|\n/g,E),h=(0,N.$WC)(p);I[b]=new N.$ZC(p,h)}const P=new A.$2C(I,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&a.$Wf(m)&&(this.b=a.$Vf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,N.$XC)(this.e,m);this.a.push(new N.$ZC(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=a.$Mf(m)),this.k||(this.k=a.$Pf(m)))}finish(m=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,N.$WC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$3C=L}),define(ke[136],Se([1,0,21,12]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcb=m,e.$ecb=I;var A;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(A||(A={}));function R(P){for(let b=0,k=P.length;b<k;b+=4){const p=P[b+0],h=P[b+1],g=P[b+2],u=P[b+3];P[b+0]=u,P[b+1]=g,P[b+2]=h,P[b+3]=p}}function L(P){const b=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return N.$x()||R(b),a.$Ge.wrap(b)}function $(P){const b=P.buffer;if(N.$x()||R(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const k=new Uint8Array(b.byteLength);return k.set(b),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function m(P){const b=new Uint32Array(E(P));let k=0;if(b[k++]=P.id,P.type==="full")b[k++]=1,b[k++]=P.data.length,b.set(P.data,k),k+=P.data.length;else{b[k++]=2,b[k++]=P.deltas.length;for(const p of P.deltas)b[k++]=p.start,b[k++]=p.deleteCount,p.data?(b[k++]=p.data.length,b.set(p.data,k),k+=p.data.length):b[k++]=0}return L(b)}function E(P){let b=0;if(b+=2,P.type==="full")b+=1+P.data.length;else{b+=1,b+=3*P.deltas.length;for(const k of P.deltas)k.data&&(b+=k.data.length)}return b}function I(P){const b=$(P);let k=0;const p=b[k++];if(b[k++]===1){const n=b[k++],i=b.subarray(k,k+n);return k+=n,{id:p,type:"full",data:i}}const g=b[k++],u=[];for(let n=0;n<g;n++){const i=b[k++],d=b[k++],o=b[k++];let t;o>0&&(t=b.subarray(k,k+o),k+=o),u[n]={start:i,deleteCount:d,data:t}}return{id:p,type:"delta",deltas:u}}}),define(ke[199],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;class a{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$w$=a;class N{constructor(R){this.identifier=R}}e.$x$=N}),define(ke[200],Se([1,0,4,3]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=void 0;class A{constructor(){this.a=new Map,this.b=new Map,this.c=new a.$ee,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,m){return this.a.set($,m),this.handleChange([$]),(0,N.$Tc)(()=>{this.a.get($)===m&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,m){this.b.get($)?.dispose();const E=new R(this,$,m);return this.b.set($,E),(0,N.$Tc)(()=>{const I=this.b.get($);!I||I!==E||(this.b.delete($),I.dispose())})}async getOrCreate($){const m=this.get($);if(m)return m;const E=this.b.get($);return!E||E.isResolved?null:(await E.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const E=this.b.get($);return!!(!E||E.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$1t=A;class R extends N.$Vc{get isResolved(){return this.c}constructor($,m,E){super(),this.f=$,this.g=m,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(ke[201],Se([9,10]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(ke[202],Se([1,0,4,3,201]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=I;class R extends N.$Vc{constructor(b,k="",p="",h=!0,g){super(),this.h=this.B(new a.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=k,this.u=p,this.w=h,this.C=g}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,k){this.C&&await this.C(b)}}e.$bj=R;class L extends N.$Vc{constructor(){super(...arguments),this.f=this.B(new a.$ee),this.onWillRun=this.f.event,this.m=this.B(new a.$ee),this.onDidRun=this.m.event}async run(b,k){if(!b.enabled)return;this.f.fire({action:b});let p;try{await this.u(b,k)}catch(h){p=h}this.m.fire({action:b,error:p})}async u(b,k){await b.run(k)}}e.$cj=L;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let k=[];for(const p of b)p.length&&(k.length?k=[...k,new $,...p]:k=p);return k}async run(){}}e.$dj=$,$.ID="vs.actions.separator";class m{get actions(){return this.a}constructor(b,k,p,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=k,this.class=h,this.a=p}async run(){}}e.$ej=m;class E extends R{constructor(){super(E.ID,A.localize(0,null),void 0,!1)}}e.$fj=E,E.ID="vs.actions.empty";function I(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...b)=>P.run(...b),tooltip:P.label}}}),define(ke[203],Se([9,10]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ke[204],Se([1,0,203]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=E,e.$4m=I,e.$5m=P;const N=60,A=N*60,R=A*24,L=R*7,$=R*30,m=R*365;function E(b,k,p,h){typeof b!="number"&&(b=b.getTime());const g=Math.round((new Date().getTime()-b)/1e3);if(g<-30)return(0,a.localize)(0,null,E(new Date().getTime()+g*1e3,!1));if(!h&&g<30)return(0,a.localize)(1,null);let u;return g<N?(u=g,k?u===1?p?(0,a.localize)(2,null,u):(0,a.localize)(3,null,u):p?(0,a.localize)(4,null,u):(0,a.localize)(5,null,u):u===1?p?(0,a.localize)(6,null,u):(0,a.localize)(7,null,u):p?(0,a.localize)(8,null,u):(0,a.localize)(9,null,u)):g<A?(u=Math.floor(g/N),k?u===1?p?(0,a.localize)(10,null,u):(0,a.localize)(11,null,u):p?(0,a.localize)(12,null,u):(0,a.localize)(13,null,u):u===1?p?(0,a.localize)(14,null,u):(0,a.localize)(15,null,u):p?(0,a.localize)(16,null,u):(0,a.localize)(17,null,u)):g<R?(u=Math.floor(g/A),k?u===1?p?(0,a.localize)(18,null,u):(0,a.localize)(19,null,u):p?(0,a.localize)(20,null,u):(0,a.localize)(21,null,u):u===1?p?(0,a.localize)(22,null,u):(0,a.localize)(23,null,u):p?(0,a.localize)(24,null,u):(0,a.localize)(25,null,u)):g<L?(u=Math.floor(g/R),k?u===1?(0,a.localize)(26,null,u):(0,a.localize)(27,null,u):u===1?(0,a.localize)(28,null,u):(0,a.localize)(29,null,u)):g<$?(u=Math.floor(g/L),k?u===1?p?(0,a.localize)(30,null,u):(0,a.localize)(31,null,u):p?(0,a.localize)(32,null,u):(0,a.localize)(33,null,u):u===1?p?(0,a.localize)(34,null,u):(0,a.localize)(35,null,u):p?(0,a.localize)(36,null,u):(0,a.localize)(37,null,u)):g<m?(u=Math.floor(g/$),k?u===1?p?(0,a.localize)(38,null,u):(0,a.localize)(39,null,u):p?(0,a.localize)(40,null,u):(0,a.localize)(41,null,u):u===1?p?(0,a.localize)(42,null,u):(0,a.localize)(43,null,u):p?(0,a.localize)(44,null,u):(0,a.localize)(45,null,u)):(u=Math.floor(g/m),k?u===1?p?(0,a.localize)(46,null,u):(0,a.localize)(47,null,u):p?(0,a.localize)(48,null,u):(0,a.localize)(49,null,u):u===1?p?(0,a.localize)(50,null,u):(0,a.localize)(51,null,u):p?(0,a.localize)(52,null,u):(0,a.localize)(53,null,u))}function I(b,k){const p=Math.abs(b/1e3);return p<1?k?(0,a.localize)(54,null,b):(0,a.localize)(55,null,b):p<N?k?(0,a.localize)(56,null,Math.round(b)/1e3):(0,a.localize)(57,null,Math.round(b)/1e3):p<A?k?(0,a.localize)(58,null,Math.round(b/(1e3*N))):(0,a.localize)(59,null,Math.round(b/(1e3*N))):p<R?k?(0,a.localize)(60,null,Math.round(b/(1e3*A))):(0,a.localize)(61,null,Math.round(b/(1e3*A))):(0,a.localize)(62,null,Math.round(b/(1e3*R)))}function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[205],Se([9,10]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ke[47],Se([1,0,19,18,205]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=m,e.$ij=E,e.$jj=I;function R(P,b){return b&&(P.stack||P.stacktrace)?A.localize(0,null,$(P),L(P.stack)||L(P.stacktrace)):$(P)}function L(P){return Array.isArray(P)?P.join(`
`):P}function $(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?A.localize(1,null,P.message):P.message||A.localize(2,null)}function m(P=null,b=!1){if(!P)return A.localize(3,null);if(Array.isArray(P)){const k=a.$Hb(P),p=m(k[0],b);return k.length>1?A.localize(4,null,p,k.length):p}if(N.$9f(P))return P;if(P.detail){const k=P.detail;if(k.error)return R(k.error,b);if(k.exception)return R(k.exception,b)}return P.stack?R(P,b):P.message?P.message:A.localize(5,null)}function E(P){const b=P;return b instanceof Error&&Array.isArray(b.actions)}function I(P,b){let k;return typeof P=="string"?k=new Error(P):k=P,k.actions=b,k}}),define(ke[206],Se([9,10]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(ke[137],Se([1,0,19,24,12,189,134,206]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=n,e.clampedFloat=d,e.stringSet=l,e.cursorStyleToString=S,e.filterValidationDecorations=be;var m;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=E;class I{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=I;class P{constructor(ue,Ce,Ke,Oe){this.id=ue,this.name=Ce,this.defaultValue=Ke,this.schema=Oe}applyUpdate(ue,Ce){return k(ue,Ce)}compute(ue,Ce,Ke){return Ke}}class b{constructor(ue,Ce){this.newValue=ue,this.didChange=Ce}}e.ApplyUpdateResult=b;function k(ae,ue){if(typeof ae!="object"||typeof ue!="object"||!ae||!ue)return new b(ue,ae!==ue);if(Array.isArray(ae)||Array.isArray(ue)){const Ke=Array.isArray(ae)&&Array.isArray(ue)&&a.$ub(ae,ue);return new b(ue,!Ke)}let Ce=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Oe=k(ae[Ke],ue[Ke]);Oe.didChange&&(ae[Ke]=Oe.newValue,Ce=!0)}return new b(ae,Ce)}class p{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ce){return k(ue,Ce)}validate(ue){return this.defaultValue}}class h{constructor(ue,Ce,Ke,Oe){this.id=ue,this.name=Ce,this.defaultValue=Ke,this.schema=Oe}applyUpdate(ue,Ce){return k(ue,Ce)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ce,Ke){return Ke}}function g(ae,ue){return typeof ae>"u"?ue:ae==="false"?!1:!!ae}class u extends h{constructor(ue,Ce,Ke,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Ke),super(ue,Ce,Ke,Oe)}validate(ue){return g(ue,this.defaultValue)}}function n(ae,ue,Ce,Ke){if(typeof ae>"u")return ue;let Oe=parseInt(ae,10);return isNaN(Oe)?ue:(Oe=Math.max(Ce,Oe),Oe=Math.min(Ke,Oe),Oe|0)}class i extends h{static clampedInt(ue,Ce,Ke,Oe){return n(ue,Ce,Ke,Oe)}constructor(ue,Ce,Ke,Oe,nt,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ke,ht.minimum=Oe,ht.maximum=nt),super(ue,Ce,Ke,ht),this.minimum=Oe,this.maximum=nt}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function d(ae,ue,Ce,Ke){if(typeof ae>"u")return ue;const Oe=o.float(ae,ue);return o.clamp(Oe,Ce,Ke)}class o extends h{static clamp(ue,Ce,Ke){return ue<Ce?Ce:ue>Ke?Ke:ue}static float(ue,Ce){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ce;const Ke=parseFloat(ue);return isNaN(Ke)?Ce:Ke}constructor(ue,Ce,Ke,Oe,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ke),super(ue,Ce,Ke,nt),this.validationFn=Oe}validate(ue){return this.validationFn(o.float(ue,this.defaultValue))}}class t extends h{static string(ue,Ce){return typeof ue!="string"?Ce:ue}constructor(ue,Ce,Ke,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Ke),super(ue,Ce,Ke,Oe)}validate(ue){return t.string(ue,this.defaultValue)}}function l(ae,ue,Ce,Ke){return typeof ae!="string"?ue:Ke&&ae in Ke?Ke[ae]:Ce.indexOf(ae)===-1?ue:ae}class r extends h{constructor(ue,Ce,Ke,Oe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Oe,nt.default=Ke),super(ue,Ce,Ke,nt),this.c=Oe}validate(ue){return l(ue,this.defaultValue,this.c)}}class c extends P{constructor(ue,Ce,Ke,Oe,nt,ht,yt=void 0){typeof yt<"u"&&(yt.type="string",yt.enum=nt,yt.default=Oe),super(ue,Ce,Ke,yt),this.c=nt,this.d=ht}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function s(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ce,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class f extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:$.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{insertSpace:g(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function w(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function S(ae){switch(ae){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(ae){switch(ae){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class j extends p{constructor(){super(142)}compute(ue,Ce,Ke){const Oe=["monaco-editor"];return Ce.get(39)&&Oe.push(Ce.get(39)),ue.extraEditorClassName&&Oe.push(ue.extraEditorClassName),Ce.get(74)==="default"?Oe.push("mouse-default"):Ce.get(74)==="copy"&&Oe.push("mouse-copy"),Ce.get(111)&&Oe.push("showUnused"),Ce.get(140)&&Oe.push("showDeprecated"),Oe.join(" ")}}class B extends u{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(ue,Ce,Ke){return Ke&&ue.emptySelectionClipboard}}class z extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:$.localize(16,null),included:A.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:$.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{cursorMoveOnType:g(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":l(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":l(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ce.loop,this.defaultValue.loop)}}}class T extends P{constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?T.OFF:ue==="true"?T.ON:ue:ue?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class M extends P{constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?M.OFF:ue==="true"?M.TRANSLATE:ue:ue?M.TRANSLATE:M.OFF}compute(ue,Ce,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class F extends p{constructor(){super(50)}compute(ue,Ce,Ke){return ue.fontInfo}}class O extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(ue){const Ce=o.float(ue,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ce,6,100)}compute(ue,Ce,Ke){return ue.fontInfo.fontSize}}class q extends P{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}q.c=["normal","bold","100","200","300","400","500","600","700","800","900"],q.d=1,q.e=1e3;class Y extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:$.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{multiple:l(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??l(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??l(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??l(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??l(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??l(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:$.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:g(Ce.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ce.above,this.defaultValue.above)}}}var J;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class x extends p{constructor(){super(145)}compute(ue,Ce,Ke){return x.computeLayout(Ce,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ce=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Oe=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Oe=Math.max(Oe,Ce-1));const nt=(Ke+ue.viewLineCount+Oe)/(ue.pixelRatio*ue.height),ht=Math.floor(ue.viewLineCount/nt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Oe,desiredRatio:nt,minimapLineCount:ht}}static c(ue,Ce){const Ke=ue.outerWidth,Oe=ue.outerHeight,nt=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const ht=Ce.stableMinimapLayoutInput,yt=ht&&ue.outerHeight===ht.outerHeight&&ue.lineHeight===ht.lineHeight&&ue.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ue.pixelRatio===ht.pixelRatio&&ue.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ue.paddingTop===ht.paddingTop&&ue.paddingBottom===ht.paddingBottom&&ue.minimap.enabled===ht.minimap.enabled&&ue.minimap.side===ht.minimap.side&&ue.minimap.size===ht.minimap.size&&ue.minimap.showSlider===ht.minimap.showSlider&&ue.minimap.renderCharacters===ht.minimap.renderCharacters&&ue.minimap.maxColumn===ht.minimap.maxColumn&&ue.minimap.scale===ht.minimap.scale&&ue.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ue.isViewportWrapping===ht.isViewportWrapping,Nt=ue.lineHeight,jt=ue.typicalHalfwidthCharacterWidth,_t=ue.scrollBeyondLastLine,Xt=ue.minimap.renderCharacters;let Pt=nt>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const en=ue.minimap.maxColumn,tn=ue.minimap.size,tt=ue.minimap.side,dn=ue.verticalScrollbarWidth,rn=ue.viewLineCount,mt=ue.remainingWidth,bt=ue.isViewportWrapping,Gt=Xt?2:3;let Zt=Math.floor(nt*Oe);const zt=Zt/nt;let $t=!1,Bt=!1,Ht=Gt*Pt,Ft=Pt/nt,xe=1;if(tn==="fill"||tn==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:sn,extraLinesBeyondLastLine:on,desiredRatio:an,minimapLineCount:Ot}=x.computeContainedMinimapLineCount({viewLineCount:rn,scrollBeyondLastLine:_t,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Oe,lineHeight:Nt,pixelRatio:nt});if(rn/Ot>1)$t=!0,Bt=!0,Pt=1,Ht=1,Ft=Pt/nt;else{let Mt=!1,It=Pt+1;if(tn==="fit"){const pt=Math.ceil((sn+rn+on)*Ht);bt&&yt&&mt<=Ce.stableFitRemainingWidth?(Mt=!0,It=Ce.stableFitMaxMinimapScale):Mt=pt>Zt}if(tn==="fill"||Mt){$t=!0;const pt=Pt;Ht=Math.min(Nt*nt,Math.max(1,Math.floor(1/an))),bt&&yt&&mt<=Ce.stableFitRemainingWidth&&(It=Ce.stableFitMaxMinimapScale),Pt=Math.min(It,Math.max(1,Math.floor(Ht/Gt))),Pt>pt&&(xe=Math.min(2,Pt/pt)),Ft=Pt/nt/xe,Zt=Math.ceil(Math.max(Qt,sn+rn+on)*Ht),bt?(Ce.stableMinimapLayoutInput=ue,Ce.stableFitRemainingWidth=mt,Ce.stableFitMaxMinimapScale=Pt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const un=Math.floor(en*Ft),Yt=Math.min(un,Math.max(0,Math.floor((mt-dn-2)*Ft/(jt+Ft)))+e.MINIMAP_GUTTER_WIDTH);let Jt=Math.floor(nt*Yt);const wt=Jt/nt;Jt=Math.floor(Jt*xe);const Wt=Xt?1:2,Ut=tt==="left"?0:Ke-Yt-dn;return{renderMinimap:Wt,minimapLeft:Ut,minimapWidth:Yt,minimapHeightIsEditorHeight:$t,minimapIsSampling:Bt,minimapScale:Pt,minimapLineHeight:Ht,minimapCanvasInnerWidth:Jt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:zt}}static computeLayout(ue,Ce){const Ke=Ce.outerWidth|0,Oe=Ce.outerHeight|0,nt=Ce.lineHeight|0,ht=Ce.lineNumbersDigitCount|0,yt=Ce.typicalHalfwidthCharacterWidth,Nt=Ce.maxDigitWidth,jt=Ce.pixelRatio,_t=Ce.viewLineCount,Xt=ue.get(137),Pt=Xt==="inherit"?ue.get(136):Xt,en=Pt==="inherit"?ue.get(132):Pt,tn=ue.get(135),tt=Ce.isDominatedByLongLines,dn=ue.get(57),rn=ue.get(68).renderType!==0,mt=ue.get(69),bt=ue.get(105),Gt=ue.get(84),Zt=ue.get(73),zt=ue.get(103),$t=zt.verticalScrollbarSize,Bt=zt.verticalHasArrows,Ht=zt.arrowSize,Ft=zt.horizontalScrollbarSize,xe=ue.get(43),un=ue.get(110)!=="never";let Yt=ue.get(66);xe&&un&&(Yt+=16);let Jt=0;if(rn){const cn=Math.max(ht,mt);Jt=Math.round(cn*Nt)}let wt=0;dn&&(wt=nt*Ce.glyphMarginDecorationLaneCount);let Wt=0,Ut=Wt+wt,Qt=Ut+Jt,sn=Qt+Yt;const on=Ke-wt-Jt-Yt;let an=!1,Ot=!1,Ct=-1;Pt==="inherit"&&tt?(an=!0,Ot=!0):en==="on"||en==="bounded"?Ot=!0:en==="wordWrapColumn"&&(Ct=tn);const Mt=x.c({outerWidth:Ke,outerHeight:Oe,lineHeight:nt,typicalHalfwidthCharacterWidth:yt,pixelRatio:jt,scrollBeyondLastLine:bt,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:Zt,verticalScrollbarWidth:$t,viewLineCount:_t,remainingWidth:on,isViewportWrapping:Ot},Ce.memory||new I);Mt.renderMinimap!==0&&Mt.minimapLeft===0&&(Wt+=Mt.minimapWidth,Ut+=Mt.minimapWidth,Qt+=Mt.minimapWidth,sn+=Mt.minimapWidth);const It=on-Mt.minimapWidth,pt=Math.max(1,Math.floor((It-$t-2)/yt)),At=Bt?Ht:0;return Ot&&(Ct=Math.max(1,pt),en==="bounded"&&(Ct=Math.min(Ct,tn))),{width:Ke,height:Oe,glyphMarginLeft:Wt,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Ut,lineNumbersWidth:Jt,decorationsLeft:Qt,decorationsWidth:Yt,contentLeft:sn,contentWidth:It,minimap:Mt,viewportColumn:pt,isWordWrapMinified:an,isViewportWrapping:Ot,wrappingColumn:Ct,verticalScrollbarWidth:$t,horizontalScrollbarHeight:Ft,overviewRuler:{top:At,width:$t,height:Oe-2*At,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(ue){return l(ue,"simple",["simple","advanced"])}compute(ue,Ce,Ke){return Ce.get(2)===2?"advanced":Ke}}var de;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(de||(e.ShowLightbulbIconMode=de={}));class ce extends P{constructor(){const ue={enabled:de.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[de.Off,de.OnCode,de.On],default:ue.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:l(ue.enabled,this.defaultValue.enabled,[de.Off,de.OnCode,de.On])}}}class ve extends P{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:$.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:$.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:l(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,A.$d?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,A.$d?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:$.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:l(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:g(Ce.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ce,Ke){return Ke<0?i.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class le extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>o.clamp(ue,0,150),{markdownDescription:$.localize(66,null)})}compute(ue,Ce,Ke){return ue.fontInfo.lineHeight}}class De extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:ue.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:$.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:$.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:$.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:$.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),autohide:g(Ce.autohide,this.defaultValue.autohide),size:l(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(Ce.side,this.defaultValue.side,["right","left"]),showSlider:l(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ce.scale,1,1,3),maxColumn:i.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function $e(ae){return ae==="ctrlCmd"?A.$d?"metaKey":"ctrlKey":"altKey"}class re extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{top:i.clampedInt(Ce.top,0,0,1e3),bottom:i.clampedInt(Ce.bottom,0,0,1e3)}}}class se extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:$.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:$.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),cycle:g(Ce.cycle,this.defaultValue.cycle)}}}class oe extends p{constructor(){super(143)}compute(ue,Ce,Ke){return ue.pixelRatio}}class K extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(85,null),$.localize(86,null),$.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ue.strings,description:$.localize(88,null)},comments:{anyOf:Ce,default:ue.comments,description:$.localize(89,null)},other:{anyOf:Ce,default:ue.other,description:$.localize(90,null)}},default:ue,markdownDescription:$.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const jt=ue?"on":"off";return{comments:jt,strings:jt,other:jt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ce,comments:Ke,strings:Oe}=ue,nt=["on","inline","off"];let ht,yt,Nt;return typeof Ce=="boolean"?ht=Ce?"on":"off":ht=l(Ce,this.defaultValue.other,nt),typeof Ke=="boolean"?yt=Ke?"on":"off":yt=l(Ke,this.defaultValue.comments,nt),typeof Oe=="boolean"?Nt=Oe?"on":"off":Nt=l(Oe,this.defaultValue.strings,nt),{other:ht,comments:yt,strings:Nt}}}var te;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class ge extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(92,null),$.localize(93,null),$.localize(94,null),$.localize(95,null)],default:"on",description:$.localize(96,null)})}validate(ue){let Ce=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ce=4,Ke=ue):ue==="interval"?Ce=3:ue==="relative"?Ce=2:ue==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ke}}}function be(ae){const ue=ae.get(98);return ue==="editable"?ae.get(91):ue!=="on"}class Re extends P{constructor(){const ue=[],Ce={type:"number",description:$.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:$.localize(98,null),format:"color-hex"}}}]},default:ue,description:$.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Ce=[];for(const Ke of ue)if(typeof Ke=="number")Ce.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Oe=Ke;Ce.push({column:i.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return Ce.sort((Ke,Oe)=>Ke.column-Oe.column),Ce}return this.defaultValue}}class pe extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(ae,ue){if(typeof ae!="string")return ue;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(100,null),$.localize(101,null),$.localize(102,null)],default:"auto",description:$.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(104,null),$.localize(105,null),$.localize(106,null)],default:"auto",description:$.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:$.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:$.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:$.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:$.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue,Ke=i.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=i.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ce.vertical,this.defaultValue.vertical),horizontal:Pe(Ce.horizontal,this.defaultValue.horizontal),useShadows:g(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Ce.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:i.clampedInt(Ce.verticalSliderSize,Oe,0,1e3),scrollByPage:g(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:$.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:$.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:$.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:$.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:$.localize(118,null)}})}applyUpdate(ue,Ce){let Ke=!1;Ce.allowedCharacters&&ue&&(N.$8n(ue.allowedCharacters,Ce.allowedCharacters)||(ue={...ue,allowedCharacters:Ce.allowedCharacters},Ke=!0)),Ce.allowedLocales&&ue&&(N.$8n(ue.allowedLocales,Ce.allowedLocales)||(ue={...ue,allowedLocales:Ce.allowedLocales},Ke=!0));const Oe=super.applyUpdate(ue,Ce);return Ke?new b(Oe.newValue,!0):Oe}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{nonBasicASCII:he(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ce){if(typeof ue!="object"||!ue)return Ce;const Ke={};for(const[Oe,nt]of Object.entries(ue))nt===!0&&(Ke[Oe]=!0);return Ke}}class W extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:$.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],description:$.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:$.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:$.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),mode:l(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:l(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class Q extends P{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:$.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(127,null),$.localize(128,null),$.localize(129,null)],description:$.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:$.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:$.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showToolbar:l(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends P{constructor(){const ue={enabled:R.$5s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$5s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:$.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(135,null),$.localize(136,null),$.localize(137,null)],default:ue.bracketPairs,description:$.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null)],default:ue.bracketPairsHorizontal,description:$.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:$.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:$.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:ue.highlightActiveIndentation,description:$.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{bracketPairs:he(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ue,Ce){const Ke=Ce.indexOf(ae);return Ke===-1?ue:Ce[Ke]}class we extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(149,null),$.localize(150,null)],default:ue.insertMode,description:$.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:$.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:$.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:$.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(155,null),$.localize(156,null),$.localize(157,null),$.localize(158,null)],default:ue.selectionMode,markdownDescription:$.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:$.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:$.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:$.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:$.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:$.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{insertMode:l(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:l(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ce.preview,this.defaultValue.preview),previewMode:l(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ce.showMethods,this.defaultValue.showMethods),showFunctions:g(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ce.showFields,this.defaultValue.showFields),showVariables:g(Ce.showVariables,this.defaultValue.showVariables),showClasses:g(Ce.showClasses,this.defaultValue.showClasses),showStructs:g(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ce.showModules,this.defaultValue.showModules),showProperties:g(Ce.showProperties,this.defaultValue.showProperties),showEvents:g(Ce.showEvents,this.defaultValue.showEvents),showOperators:g(Ce.showOperators,this.defaultValue.showOperators),showUnits:g(Ce.showUnits,this.defaultValue.showUnits),showValues:g(Ce.showValues,this.defaultValue.showValues),showConstants:g(Ce.showConstants,this.defaultValue.showConstants),showEnums:g(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ce.showKeywords,this.defaultValue.showKeywords),showWords:g(Ce.showWords,this.defaultValue.showWords),showColors:g(Ce.showColors,this.defaultValue.showColors),showFiles:g(Ce.showFiles,this.defaultValue.showFiles),showReferences:g(Ce.showReferences,this.defaultValue.showReferences),showFolders:g(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ce.showUsers,this.defaultValue.showUsers),showIssues:g(Ce.showIssues,this.defaultValue.showIssues)}}}class Te extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class He extends P{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:$.localize(199,null),type:"string"},{description:$.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Ce=[];for(const Ke of ue)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Ce.push(Ke)}catch{}return Ce}return this.defaultValue}}var Xe;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Xe||(e.WrappingIndent=Xe={}));class et extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(201,null),$.localize(202,null),$.localize(203,null),$.localize(204,null)],description:$.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ce,Ke){return Ce.get(2)===2?0:Ke}}class rt extends p{constructor(){super(146)}compute(ue,Ce,Ke){const Oe=Ce.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class at extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(208,null),$.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showDropSelector:l(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(212,null),$.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showPasteSelector:l(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$d?Ne:A.$e?Ve:ct,fontWeight:"normal",fontSize:A.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Ge;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ge||(e.EditorOption=Ge={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(214,null)})),acceptSuggestionOnEnter:Ae(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(215,null),""],markdownDescription:$.localize(216,null)})),accessibilitySupport:Ae(new v),accessibilityPageSize:Ae(new i(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(217,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",$.localize(218,null))),ariaRequired:Ae(new u(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new u(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(220,null),$.localize(221,null),""],description:$.localize(222,null)})),autoClosingComments:Ae(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),autoClosingDelete:Ae(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(226,null),""],description:$.localize(227,null)})),autoClosingOvertype:Ae(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(228,null),""],description:$.localize(229,null)})),autoClosingQuotes:Ae(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(230,null),$.localize(231,null),""],description:$.localize(232,null)})),autoIndent:Ae(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[$.localize(233,null),$.localize(234,null),$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),automaticLayout:Ae(new u(13,"automaticLayout",!1)),autoSurround:Ae(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null),""],description:$.localize(242,null)})),bracketPairColorization:Ae(new X),bracketPairGuides:Ae(new Z),stickyTabStops:Ae(new u(116,"stickyTabStops",!1,{description:$.localize(243,null)})),codeLens:Ae(new u(17,"codeLens",!0,{description:$.localize(244,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:$.localize(245,null)})),codeLensFontSize:Ae(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(246,null)})),colorDecorators:Ae(new u(20,"colorDecorators",!0,{description:$.localize(247,null)})),colorDecoratorActivatedOn:Ae(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(248,null),$.localize(249,null),$.localize(250,null)],description:$.localize(251,null)})),colorDecoratorsLimit:Ae(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(252,null)})),columnSelection:Ae(new u(22,"columnSelection",!1,{description:$.localize(253,null)})),comments:Ae(new f),contextmenu:Ae(new u(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new u(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(254,null)})),cursorBlinking:Ae(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:$.localize(255,null)})),cursorSmoothCaretAnimation:Ae(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(256,null),$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),cursorStyle:Ae(new c(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(260,null)})),cursorSurroundingLines:Ae(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(261,null)})),cursorSurroundingLinesStyle:Ae(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(262,null),$.localize(263,null)],markdownDescription:$.localize(264,null)})),cursorWidth:Ae(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(265,null)})),disableLayerHinting:Ae(new u(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new u(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new u(34,"domReadOnly",!1)),dragAndDrop:Ae(new u(35,"dragAndDrop",!0,{description:$.localize(266,null)})),emptySelectionClipboard:Ae(new B),dropIntoEditor:Ae(new at),stickyScroll:Ae(new ve),experimentalWhitespaceRendering:Ae(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(267,null),$.localize(268,null),$.localize(269,null)],description:$.localize(270,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:$.localize(271,null)})),find:Ae(new z),fixedOverflowWidgets:Ae(new u(42,"fixedOverflowWidgets",!1)),folding:Ae(new u(43,"folding",!0,{description:$.localize(272,null)})),foldingStrategy:Ae(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(273,null),$.localize(274,null)],description:$.localize(275,null)})),foldingHighlight:Ae(new u(45,"foldingHighlight",!0,{description:$.localize(276,null)})),foldingImportsByDefault:Ae(new u(46,"foldingImportsByDefault",!1,{description:$.localize(277,null)})),foldingMaximumRegions:Ae(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ae(new u(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(279,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(280,null)})),fontInfo:Ae(new F),fontLigatures2:Ae(new T),fontSize:Ae(new O),fontWeight:Ae(new q),fontVariations:Ae(new M),formatOnPaste:Ae(new u(55,"formatOnPaste",!1,{description:$.localize(281,null)})),formatOnType:Ae(new u(56,"formatOnType",!1,{description:$.localize(282,null)})),glyphMargin:Ae(new u(57,"glyphMargin",!0,{description:$.localize(283,null)})),gotoLocation:Ae(new Y),hideCursorInOverviewRuler:Ae(new u(59,"hideCursorInOverviewRuler",!1,{description:$.localize(284,null)})),hover:Ae(new V),inDiffEditor:Ae(new u(61,"inDiffEditor",!1)),letterSpacing:Ae(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:$.localize(285,null)})),lightbulb:Ae(new ce),lineDecorationsWidth:Ae(new U),lineHeight:Ae(new le),lineNumbers:Ae(new ge),lineNumbersMinChars:Ae(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new u(70,"linkedEditing",!1,{description:$.localize(286,null)})),links:Ae(new u(71,"links",!0,{description:$.localize(287,null)})),matchBrackets:Ae(new r(72,"matchBrackets","always",["always","near","never"],{description:$.localize(288,null)})),minimap:Ae(new De),mouseStyle:Ae(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:$.localize(289,null)})),mouseWheelZoom:Ae(new u(76,"mouseWheelZoom",!1,{markdownDescription:A.$d?$.localize(290,null):$.localize(291,null)})),multiCursorMergeOverlapping:Ae(new u(77,"multiCursorMergeOverlapping",!0,{description:$.localize(292,null)})),multiCursorModifier:Ae(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$e,{markdownEnumDescriptions:[$.localize(293,null),$.localize(294,null)],markdownDescription:$.localize(295,null)})),multiCursorPaste:Ae(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(296,null),$.localize(297,null)],markdownDescription:$.localize(298,null)})),multiCursorLimit:Ae(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(299,null)})),occurrencesHighlight:Ae(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(300,null),$.localize(301,null),$.localize(302,null)],markdownDescription:$.localize(303,null)})),overviewRulerBorder:Ae(new u(82,"overviewRulerBorder",!0,{description:$.localize(304,null)})),overviewRulerLanes:Ae(new i(83,"overviewRulerLanes",3,0,3)),padding:Ae(new re),pasteAs:Ae(new ot),parameterHints:Ae(new se),peekWidgetDefaultFocus:Ae(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(305,null),$.localize(306,null)],description:$.localize(307,null)})),definitionLinkOpensInPeek:Ae(new u(88,"definitionLinkOpensInPeek",!1,{description:$.localize(308,null)})),quickSuggestions:Ae(new K),quickSuggestionsDelay:Ae(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(309,null)})),readOnly:Ae(new u(91,"readOnly",!1)),readOnlyMessage:Ae(new pe),renameOnType:Ae(new u(93,"renameOnType",!1,{description:$.localize(310,null),markdownDeprecationMessage:$.localize(311,null)})),renderControlCharacters:Ae(new u(94,"renderControlCharacters",!0,{description:$.localize(312,null),restricted:!0})),renderFinalNewline:Ae(new r(95,"renderFinalNewline",A.$e?"dimmed":"on",["off","on","dimmed"],{description:$.localize(313,null)})),renderLineHighlight:Ae(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(314,null)],description:$.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ae(new u(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(316,null)})),renderValidationDecorations:Ae(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(317,null),$.localize(318,null),$.localize(319,null),""],description:$.localize(320,null)})),revealHorizontalRightPadding:Ae(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new u(101,"roundedSelection",!0,{description:$.localize(321,null)})),rulers:Ae(new Re),scrollbar:Ae(new Ie),scrollBeyondLastColumn:Ae(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(322,null)})),scrollBeyondLastLine:Ae(new u(105,"scrollBeyondLastLine",!0,{description:$.localize(323,null)})),scrollPredominantAxis:Ae(new u(106,"scrollPredominantAxis",!0,{description:$.localize(324,null)})),selectionClipboard:Ae(new u(107,"selectionClipboard",!0,{description:$.localize(325,null),included:A.$e})),selectionHighlight:Ae(new u(108,"selectionHighlight",!0,{description:$.localize(326,null)})),selectOnLineNumbers:Ae(new u(109,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),showUnused:Ae(new u(111,"showUnused",!0,{description:$.localize(331,null)})),showDeprecated:Ae(new u(140,"showDeprecated",!0,{description:$.localize(332,null)})),inlayHints:Ae(new _),snippetSuggestions:Ae(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(333,null),$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),smartSelect:Ae(new Te),smoothScrolling:Ae(new u(114,"smoothScrolling",!1,{description:$.localize(338,null)})),stopRenderingLineAfter:Ae(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new we),inlineSuggest:Ae(new W),inlineEdit:Ae(new Q),inlineCompletionsAccessibilityVerbose:Ae(new u(149,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(339,null)})),suggestFontSize:Ae(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new u(121,"suggestOnTriggerCharacters",!0,{description:$.localize(342,null)})),suggestSelection:Ae(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null)],description:$.localize(346,null)})),tabCompletion:Ae(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null)],description:$.localize(350,null)})),tabIndex:Ae(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new je),unusualLineTerminators:Ae(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(351,null),$.localize(352,null),$.localize(353,null)],description:$.localize(354,null)})),useShadowDOM:Ae(new u(127,"useShadowDOM",!0)),useTabStops:Ae(new u(128,"useTabStops",!0,{description:$.localize(355,null)})),wordBreak:Ae(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(356,null),$.localize(357,null)],description:$.localize(358,null)})),wordSegmenterLocales:Ae(new He),wordSeparators:Ae(new t(131,"wordSeparators",L.$6s,{description:$.localize(359,null)})),wordWrap:Ae(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(360,null),$.localize(361,null),$.localize(362,null),$.localize(363,null)],description:$.localize(364,null)})),wordWrapBreakAfterCharacters:Ae(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(365,null)})),wordWrapOverride1:Ae(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new j),defaultColorDecorators:Ae(new u(147,"defaultColorDecorators",!1,{markdownDescription:$.localize(366,null)})),pixelRatio:Ae(new oe),tabFocusMode:Ae(new u(144,"tabFocusMode",!1,{markdownDescription:$.localize(367,null)})),layoutInfo:Ae(new x),wrappingInfo:Ae(new rt),wrappingIndent:Ae(new et),wrappingStrategy:Ae(new ne)}}),define(ke[207],Se([9,10]),function(ie,e){return ie.create("vs/editor/common/languages",e)}),define(ke[84],Se([1,0,79,2,185,29,200,207]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$gu=e.$fu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$eu=e.$du=e.SymbolKinds=e.SymbolTag=e.$bu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$_t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$$t=e.$0t=e.$9t=void 0,e.$au=r,e.$cu=s;class m{constructor(J,x,ne){this.offset=J,this.type=x,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$9t=m;class E{constructor(J,x){this.tokens=J,this.endState=x,this._tokenizationResultBrand=void 0}}e.$0t=E;class I{constructor(J,x){this.tokens=J,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$$t=I;var P;(function(V){V[V.Increase=0]="Increase",V[V.Decrease=1]="Decrease"})(P||(e.HoverVerbosityAction=P={}));var b;(function(V){V[V.Method=0]="Method",V[V.Function=1]="Function",V[V.Constructor=2]="Constructor",V[V.Field=3]="Field",V[V.Variable=4]="Variable",V[V.Class=5]="Class",V[V.Struct=6]="Struct",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Event=10]="Event",V[V.Operator=11]="Operator",V[V.Unit=12]="Unit",V[V.Value=13]="Value",V[V.Constant=14]="Constant",V[V.Enum=15]="Enum",V[V.EnumMember=16]="EnumMember",V[V.Keyword=17]="Keyword",V[V.Text=18]="Text",V[V.Color=19]="Color",V[V.File=20]="File",V[V.Reference=21]="Reference",V[V.Customcolor=22]="Customcolor",V[V.Folder=23]="Folder",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue",V[V.Snippet=27]="Snippet"})(b||(e.CompletionItemKind=b={}));var k;(function(V){const J=new Map;J.set(0,a.$Vj.symbolMethod),J.set(1,a.$Vj.symbolFunction),J.set(2,a.$Vj.symbolConstructor),J.set(3,a.$Vj.symbolField),J.set(4,a.$Vj.symbolVariable),J.set(5,a.$Vj.symbolClass),J.set(6,a.$Vj.symbolStruct),J.set(7,a.$Vj.symbolInterface),J.set(8,a.$Vj.symbolModule),J.set(9,a.$Vj.symbolProperty),J.set(10,a.$Vj.symbolEvent),J.set(11,a.$Vj.symbolOperator),J.set(12,a.$Vj.symbolUnit),J.set(13,a.$Vj.symbolValue),J.set(15,a.$Vj.symbolEnum),J.set(14,a.$Vj.symbolConstant),J.set(15,a.$Vj.symbolEnum),J.set(16,a.$Vj.symbolEnumMember),J.set(17,a.$Vj.symbolKeyword),J.set(27,a.$Vj.symbolSnippet),J.set(18,a.$Vj.symbolText),J.set(19,a.$Vj.symbolColor),J.set(20,a.$Vj.symbolFile),J.set(21,a.$Vj.symbolReference),J.set(22,a.$Vj.symbolCustomColor),J.set(23,a.$Vj.symbolFolder),J.set(24,a.$Vj.symbolTypeParameter),J.set(25,a.$Vj.account),J.set(26,a.$Vj.issues);function x(ce){let ve=J.get(ce);return ve||(console.info("No codicon found for CompletionItemKind "+ce),ve=a.$Vj.symbolProperty),ve}V.toIcon=x;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function de(ce,ve){let _=ne.get(ce);return typeof _>"u"&&!ve&&(_=9),_}V.fromString=de})(k||(e.CompletionItemKinds=k={}));var p;(function(V){V[V.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var h;(function(V){V[V.None=0]="None",V[V.KeepWhitespace=1]="KeepWhitespace",V[V.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var g;(function(V){V[V.Word=0]="Word",V[V.Line=1]="Line",V[V.Suggest=2]="Suggest"})(g||(e.PartialAcceptTriggerKind=g={}));var u;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var n;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(J,x,ne,de){this.range=J,this.text=x,this.completionKind=ne,this.isSnippetText=de}equals(J){return R.$vt.lift(this.range).equalsRange(J.range)&&this.text===J.text&&this.completionKind===J.completionKind&&this.isSnippetText===J.isSnippetText}}e.$_t=i;var d;(function(V){V[V.Invoke=1]="Invoke",V[V.Auto=2]="Auto"})(d||(e.CodeActionTriggerType=d={}));var o;(function(V){V[V.Automatic=0]="Automatic",V[V.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var t;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var l;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(l||(e.DocumentHighlightKind=l={}));function r(V){return V&&N.URI.isUri(V.uri)&&R.$vt.isIRange(V.range)&&(R.$vt.isIRange(V.originSelectionRange)||R.$vt.isIRange(V.targetSelectionRange))}var c;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.$bu={17:(0,$.localize)(0,null),16:(0,$.localize)(1,null),4:(0,$.localize)(2,null),13:(0,$.localize)(3,null),8:(0,$.localize)(4,null),9:(0,$.localize)(5,null),21:(0,$.localize)(6,null),23:(0,$.localize)(7,null),7:(0,$.localize)(8,null),0:(0,$.localize)(9,null),11:(0,$.localize)(10,null),10:(0,$.localize)(11,null),19:(0,$.localize)(12,null),5:(0,$.localize)(13,null),1:(0,$.localize)(14,null),2:(0,$.localize)(15,null),20:(0,$.localize)(16,null),15:(0,$.localize)(17,null),18:(0,$.localize)(18,null),24:(0,$.localize)(19,null),3:(0,$.localize)(20,null),6:(0,$.localize)(21,null),14:(0,$.localize)(22,null),22:(0,$.localize)(23,null),25:(0,$.localize)(24,null),12:(0,$.localize)(25,null)};function s(V,J){return(0,$.localize)(26,null,V,e.$bu[J])}var v;(function(V){V[V.Deprecated=1]="Deprecated"})(v||(e.SymbolTag=v={}));var f;(function(V){const J=new Map;J.set(0,a.$Vj.symbolFile),J.set(1,a.$Vj.symbolModule),J.set(2,a.$Vj.symbolNamespace),J.set(3,a.$Vj.symbolPackage),J.set(4,a.$Vj.symbolClass),J.set(5,a.$Vj.symbolMethod),J.set(6,a.$Vj.symbolProperty),J.set(7,a.$Vj.symbolField),J.set(8,a.$Vj.symbolConstructor),J.set(9,a.$Vj.symbolEnum),J.set(10,a.$Vj.symbolInterface),J.set(11,a.$Vj.symbolFunction),J.set(12,a.$Vj.symbolVariable),J.set(13,a.$Vj.symbolConstant),J.set(14,a.$Vj.symbolString),J.set(15,a.$Vj.symbolNumber),J.set(16,a.$Vj.symbolBoolean),J.set(17,a.$Vj.symbolArray),J.set(18,a.$Vj.symbolObject),J.set(19,a.$Vj.symbolKey),J.set(20,a.$Vj.symbolNull),J.set(21,a.$Vj.symbolEnumMember),J.set(22,a.$Vj.symbolStruct),J.set(23,a.$Vj.symbolEvent),J.set(24,a.$Vj.symbolOperator),J.set(25,a.$Vj.symbolTypeParameter);function x(ne){let de=J.get(ne);return de||(console.info("No codicon found for SymbolKind "+ne),de=a.$Vj.symbolProperty),de}V.toIcon=x})(f||(e.SymbolKinds=f={}));class y{static asEditOperation(J){return A.$wt.replace(R.$vt.lift(J.range),J.text)}}e.$du=y;class w{static fromValue(J){switch(J){case"comment":return w.Comment;case"imports":return w.Imports;case"region":return w.Region}return new w(J)}constructor(J){this.value=J}}e.$eu=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var D;(function(V){V[V.AIGenerated=1]="AIGenerated"})(D||(e.NewSymbolNameTag=D={}));var S;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(S||(e.NewSymbolNameTriggerKind=S={}));var C;(function(V){function J(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}V.is=J})(C||(e.Command=C={}));var j;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(j||(e.CommentThreadCollapsibleState=j={}));var B;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(B||(e.CommentThreadState=B={}));var z;(function(V){V[V.Current=0]="Current",V[V.Outdated=1]="Outdated"})(z||(e.CommentThreadApplicability=z={}));var T;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(T||(e.CommentMode=T={}));var M;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(M||(e.CommentState=M={}));var F;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class O{constructor(J){this.b=J,this.a=null}dispose(){this.a&&this.a.then(J=>{J&&J.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$fu=O,e.$gu=new L.$1t;var q;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(q||(e.ExternalUriOpenerPriority=q={}));var Y;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Y||(e.InlineEditTriggerKind=Y={}))}),define(ke[208],Se([9,10]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[209],Se([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[210],Se([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ke[211],Se([9,10]),function(ie,e){return ie.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[212],Se([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[213],Se([9,10]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[214],Se([9,10]),function(ie,e){return ie.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[215],Se([9,10]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ke[216],Se([9,10]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ke[217],Se([9,10]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[218],Se([9,10]),function(ie,e){return ie.create("vs/platform/log/common/log",e)}),define(ke[219],Se([9,10]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(ke[220],Se([9,10]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ke[221],Se([9,10]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[222],Se([9,10]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[223],Se([9,10]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ke[224],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[225],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[226],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[227],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[228],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[229],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[230],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[231],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[232],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[233],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[234],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[235],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[236],Se([9,10]),function(ie,e){return ie.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[237],Se([9,10]),function(ie,e){return ie.create("vs/workbench/common/configuration",e)}),define(ke[238],Se([9,10]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(ke[239],Se([9,10]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(ke[240],Se([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[241],Se([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[242],Se([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[243],Se([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[244],Se([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[245],Se([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[246],Se([9,10]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[247],Se([9,10]),function(ie,e){return ie.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[248],Se([9,10]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[249],Se([9,10]),function(ie,e){return ie.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[250],Se([9,10]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[251],Se([1,0,13,210]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var A;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(A||(e.TokenType=A={}));function R(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const L=(0,N.localize)(3,null),$=(0,N.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,a.$8)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const P=this.d,b=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:b};this.g.push({offset:P,lexeme:b,additionalInfo:I}),this.f.push(k)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const P=this.c.substring(this.d,this.e),b=m.b.get(P);b?this.k(b):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,P=!1,b=!1;for(;;){if(I>=this.c.length){this.e=I,this.l($);return}const p=this.c.charCodeAt(I);if(P)P=!1;else if(p===47&&!b){I++;break}else p===91?b=!0:p===92?P=!0:p===93&&(b=!1);I++}for(;I<this.c.length&&m.a.has(this.c.charCodeAt(I));)I++;this.e=I;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=m,m.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0))),m.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ke[252],Se([1,0,23,42,213,400]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=m,e.$Ip=E,e.$Jp=I,e.$Kp=P,e.$Lp=b,e.$Mp=k,e.$Np=p;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function m(u){return u=u.trim(),u==="*"||L.test(u)}function E(u){if(!m(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=u.match(L);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function I(u){if(!u)return null;const n=u.majorBase,i=u.majorMustEqual,d=u.minorBase;let o=u.minorMustEqual;const t=u.patchBase;let l=u.patchMustEqual;u.hasCaret&&(n===0||(o=!1),l=!1);let r=0;if(u.preRelease){const c=$.exec(u.preRelease);if(c){const[,s,v,f]=c;r=Date.UTC(Number(s),Number(v)-1,Number(f))}}return{majorBase:n,majorMustEqual:i,minorBase:d,minorMustEqual:o,patchBase:t,patchMustEqual:l,isMinimum:u.hasGreaterEquals,notBefore:r}}function P(u,n,i){let d;typeof u=="string"?d=I(E(u)):d=u;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=I(E(i)):t=i,!d||!t)return!1;const l=d.majorBase,r=d.minorBase,c=d.patchBase;let s=t.majorBase,v=t.minorBase,f=t.patchBase;const y=t.notBefore;let w=t.majorMustEqual,D=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?l>s?!0:l<s?!1:r>v?!0:r<v||o&&o<y?!1:c>=f:(l===1&&s===0&&(!w||!D||!S)&&(s=1,v=0,f=0,w=!0,D=!1,S=!1),l<s?!1:l>s?!w:r<v?!1:r>v?!D:c<f?!1:c>f?!S:!(o&&o<y))}function b(u,n,i,d,o){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([N.default.Error,A.localize(0,null)]),t;if(typeof d.name!="string")return t.push([N.default.Error,A.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([N.default.Error,A.localize(2,null,"version")]),t;if(!d.engines)return t.push([N.default.Error,A.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([N.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!g(d.extensionDependencies))return t.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!g(d.activationEvents))return t.push([N.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([N.default.Error,A.localize(9,null,"main")]),t;{const c=(0,a.$0g)(i,d.main);(0,a.$4g)(c,i)||t.push([N.default.Warning,A.localize(10,null,c.path,i.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([N.default.Error,A.localize(11,null,"browser")]),t;{const c=(0,a.$0g)(i,d.browser);(0,a.$4g)(c,i)||t.push([N.default.Warning,A.localize(12,null,c.path,i.path)])}}if(!R.valid(d.version))return t.push([N.default.Error,A.localize(13,null)]),t;const l=[];if(!k(u,n,d,o,l))for(const c of l)t.push([N.default.Error,c]);return t}function k(u,n,i,d,o){return d||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(u,n,i.engines.vscode,o)}function p(u,n,i){return u==="*"||h(n,i,u)}function h(u,n,i,d=[]){const o=I(E(i));if(!o)return d.push(A.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return d.push(A.localize(15,null,i)),!1}else if(!o.majorMustEqual)return d.push(A.localize(16,null,i)),!1;return P(u,n,o)?!0:(d.push(A.localize(17,null,u,i)),!1)}function g(u){if(!Array.isArray(u))return!1;for(let n=0,i=u.length;n<i;n++)if(typeof u[n]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class a{constructor(A,R=[],L=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$ti=a}),define(ke[85],Se([1,0,106]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ys=R,e.$zs=L;const N=[];var A;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R($,m,E){m instanceof a.$ti||(m=new a.$ti(m,[],!!E)),N.push([$,m])}function L(){return N}}),define(ke[253],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;class a{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$br=a;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const $=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(L);$.outgoing.set(m.key,m),m.incoming.set($.key,$)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const $ of this.a.values())$.outgoing.delete(L),$.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let $=this.a.get(L);return $||($=new a(L,R),this.a.set(L,$)),$}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,$]of this.a)R.push(`${L}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const $=new Set([R]),m=this.c(L,$);if(m)return m}}c(R,L){for(const[$,m]of R.outgoing){if(L.has($))return[...L,$].join(" -> ");L.add($);const E=this.c(m,L);if(E)return E;L.delete($)}}}e.$cr=N}),define(ke[5],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=A,e.$xi=R;var a;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function $(m){return m[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=$})(a||(e._util=a={})),e.$vi=A("instantiationService");function N(L,$,m){$[a.DI_TARGET]===$?$[a.DI_DEPENDENCIES].push({id:L,index:m}):($[a.DI_DEPENDENCIES]=[{id:L,index:m}],$[a.DI_TARGET]=$)}function A(L){if(a.serviceIds.has(L))return a.serviceIds.get(L);const $=function(m,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N($,m,I)};return $.toString=()=>L,a.serviceIds.set(L,$),$}function R(L){return L}}),define(ke[55],Se([1,0,18,2,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=R,e.$5i=L,e.$6i=m,e.$7i=E,e.$8i=I,e.$9i=P,e.$0i=b,e.$$i=p,e.$_i=h,e.$aj=g,e.$3i=(0,A.$wi)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}var $;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function m(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function I(u,n){const i=Object.create(null);for(const d in u)P(i,d,u[d],n);return i}function P(u,n,i,d){const o=n.split("."),t=o.pop();let l=u;for(let r=0;r<o.length;r++){const c=o[r];let s=l[c];switch(typeof s){case"undefined":s=l[c]=Object.create(null);break;case"object":if(s===null){d(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is null`);return}break;default:d(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}l=s}if(typeof l=="object"&&l!==null)try{l[t]=i}catch{d(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(l)}`)}else d(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(l)}`)}function b(u,n){const i=n.split(".");k(u,i)}function k(u,n){const i=n.shift();if(n.length===0){delete u[i];return}if(Object.keys(u).indexOf(i)!==-1){const d=u[i];typeof d=="object"&&!Array.isArray(d)&&(k(d,n),Object.keys(d).length===0&&delete u[i])}}function p(u,n,i){function d(l,r){let c=l;for(const s of r){if(typeof c!="object"||c===null)return;c=c[s]}return c}const o=n.split("."),t=d(u,o);return typeof t>"u"?i:t}function h(u,n,i){Object.keys(n).forEach(d=>{d!=="__proto__"&&(d in u?a.$$f(u[d])&&a.$$f(n[d])?h(u[d],n[d],i):i&&(u[d]=n[d]):u[d]=n[d])})}function g(u){return u.replace(/[\[\]]/g,"")}}),define(ke[38],Se([1,0,12,14,251,5,209,13]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=E,e.$vj=l,e.$wj=r,e.$Pj=de;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",a.$d),m.set("isLinux",a.$e),m.set("isWindows",a.$c),m.set("isWeb",a.$i),m.set("isMacNative",a.$d&&!a.$i),m.set("isEdge",a.$B),m.set("isFirefox",a.$z),m.set("isChrome",a.$y),m.set("isSafari",a.$A);function E(_,U){if(m.get(_)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(_,U)}const I=Object.prototype.hasOwnProperty;var P;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const b={regexParsingWithErrorRecovery:!0},k=(0,L.localize)(0,null),p=(0,L.localize)(1,null),h=(0,L.localize)(2,null),g=(0,L.localize)(3,null),u=(0,L.localize)(4,null),n=(0,L.localize)(5,null),i=(0,L.localize)(6,null),d=(0,L.localize)(7,null);class o{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=b){this.k=U,this.d=new A.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const le=this.l();if(!this.E()){const De=this.D(),$e=De.type===17?n:void 0;throw this.h.push({message:u,offset:De.offset,lexeme:A.$rj.getLexeme(De),additionalInfo:$e}),o.c}return le}catch(le){if(le!==o.c)throw le;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const le=this.o();U.push(le)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const le=this.s();U.push(le)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const le=this.l();return this.A(1,g),le?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const le=this.l();return this.A(1,g),le}case 17:{const le=U.lexeme;if(this.z(),this.y(9)){const $e=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),$e.type!==10)throw this.B("REGEX",$e);const re=$e.lexeme,se=re.lastIndexOf("/"),oe=se===re.length-1?void 0:this.w(re.substring(se+1));let K;try{K=new RegExp(re.substring(1,se),oe)}catch{throw this.B("REGEX",$e)}return F.create(le,K)}switch($e.type){case 10:case 19:{const re=[$e.lexeme];this.z();let se=this.D(),oe=0;for(let Re=0;Re<$e.lexeme.length;Re++)$e.lexeme.charCodeAt(Re)===40?oe++:$e.lexeme.charCodeAt(Re)===41&&oe--;for(;!this.E()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Re=0;Re<se.lexeme.length;Re++)se.lexeme.charCodeAt(Re)===40?oe++:$e.lexeme.charCodeAt(Re)===41&&oe--}if(oe<0)break;re.push(A.$rj.getLexeme(se)),this.z(),se=this.D()}const K=re.join(""),te=K.lastIndexOf("/"),ge=te===K.length-1?void 0:this.w(K.substring(te+1));let be;try{be=new RegExp(K.substring(1,te),ge)}catch{throw this.B("REGEX",$e)}return t.regex(le,be)}case 18:{const re=$e.lexeme;this.z();let se=null;if(!(0,N.$8e)(re)){const oe=re.indexOf("/"),K=re.lastIndexOf("/");if(oe!==K&&oe>=0){const te=re.slice(oe+1,K),ge=re[K+1]==="i"?"i":"";try{se=new RegExp(te,ge)}catch{throw this.B("REGEX",$e)}}}if(se===null)throw this.B("REGEX",$e);return F.create(le,se)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const $e=this.u();return t.notIn(le,$e)}switch(this.D().type){case 3:{this.z();const $e=this.u();if(this.x().type===18)return t.equals(le,$e);switch($e){case"true":return t.has(le);case"false":return t.not(le);default:return t.equals(le,$e)}}case 4:{this.z();const $e=this.u();if(this.x().type===18)return t.notEquals(le,$e);switch($e){case"true":return t.not(le);case"false":return t.has(le);default:return t.notEquals(le,$e)}}case 5:return this.z(),T.create(le,this.u());case 6:return this.z(),M.create(le,this.u());case 7:return this.z(),B.create(le,this.u());case 8:return this.z(),z.create(le,this.u());case 13:return this.z(),t.in(le,this.u());default:return t.has(le)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:d}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,le){if(this.C(U))return this.z();throw this.B(le,this.D())}B(U,le,De){const $e=(0,L.localize)(8,null,U,A.$rj.getLexeme(le)),re=le.offset,se=A.$rj.getLexeme(le);return this.h.push({message:$e,offset:re,lexeme:se,additionalInfo:De}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=o,o.c=new Error;class t{static false(){return s.INSTANCE}static true(){return v.INSTANCE}static has(U){return f.create(U)}static equals(U,le){return y.create(U,le)}static notEquals(U,le){return S.create(U,le)}static regex(U,le){return F.create(U,le)}static in(U,le){return w.create(U,le)}static notIn(U,le){return D.create(U,le)}static not(U){return C.create(U)}static and(...U){return Y.create(U,null,!0)}static or(...U){return V.create(U,null,!0)}static greater(U,le){return B.create(U,le)}static greaterEquals(U,le){return z.create(U,le)}static smaller(U,le){return T.create(U,le)}static smallerEquals(U,le){return M.create(U,le)}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$uj=t,t.c=new o({regexParsingWithErrorRecovery:!1});function l(_){const U=new o({regexParsingWithErrorRecovery:!1});return _.map(le=>(U.parse(le),U.lexingErrors.length>0?U.lexingErrors.map(De=>({errorMessage:De.additionalInfo?(0,L.localize)(9,null,De.additionalInfo):(0,L.localize)(10,null),offset:De.offset,length:De.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(De=>({errorMessage:De.additionalInfo?`${De.message}. ${De.additionalInfo}`:De.message,offset:De.offset,length:De.lexeme.length})):[]))}function r(_,U){const le=_?_.substituteConstants():void 0,De=U?U.substituteConstants():void 0;return!le&&!De?!0:!le||!De?!1:le.equals(De)}function c(_,U){return _.cmp(U)}class s{constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return v.INSTANCE}}e.$xj=s,s.INSTANCE=new s;class v{constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return s.INSTANCE}}e.$yj=v,v.INSTANCE=new v;class f{static create(U,le=null){const De=m.get(U);return typeof De=="boolean"?De?v.INSTANCE:s.INSTANCE:new f(U,le)}constructor(U,le){this.key=U,this.c=le,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=m.get(this.key);return typeof U=="boolean"?U?v.INSTANCE:s.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$zj=f;class y{static create(U,le,De=null){if(typeof le=="boolean")return le?f.create(U,De):C.create(U,De);const $e=m.get(U);return typeof $e=="boolean"?le===($e?"true":"false")?v.INSTANCE:s.INSTANCE:new y(U,le,De)}constructor(U,le,De){this.c=U,this.d=le,this.f=De,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const le=U?"true":"false";return this.d===le?v.INSTANCE:s.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Aj=y;class w{static create(U,le){return new w(U,le)}constructor(U,le){this.d=U,this.f=le,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const le=U.getValue(this.f),De=U.getValue(this.d);return Array.isArray(le)?le.includes(De):typeof De=="string"&&typeof le=="object"&&le!==null?I.call(le,De):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Bj=w;class D{static create(U,le){return new D(U,le)}constructor(U,le){this.d=U,this.f=le,this.type=11,this.c=w.create(U,le)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=D;class S{static create(U,le,De=null){if(typeof le=="boolean")return le?C.create(U,De):f.create(U,De);const $e=m.get(U);return typeof $e=="boolean"?le===($e?"true":"false")?s.INSTANCE:v.INSTANCE:new S(U,le,De)}constructor(U,le,De){this.c=U,this.d=le,this.f=De,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const le=U?"true":"false";return this.d===le?s.INSTANCE:v.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Dj=S;class C{static create(U,le=null){const De=m.get(U);return typeof De=="boolean"?De?s.INSTANCE:v.INSTANCE:new C(U,le)}constructor(U,le){this.c=U,this.d=le,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=m.get(this.c);return typeof U=="boolean"?U?s.INSTANCE:v.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Ej=C;function j(_,U){if(typeof _=="string"){const le=parseFloat(_);isNaN(le)||(_=le)}return typeof _=="string"||typeof _=="number"?U(_):s.INSTANCE}class B{static create(U,le,De=null){return j(le,$e=>new B(U,$e,De))}constructor(U,le,De){this.c=U,this.d=le,this.f=De,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Fj=B;class z{static create(U,le,De=null){return j(le,$e=>new z(U,$e,De))}constructor(U,le,De){this.c=U,this.d=le,this.f=De,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Gj=z;class T{static create(U,le,De=null){return j(le,$e=>new T(U,$e,De))}constructor(U,le,De){this.c=U,this.d=le,this.f=De,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Hj=T;class M{static create(U,le,De=null){return j(le,$e=>new M(U,$e,De))}constructor(U,le,De){this.c=U,this.d=le,this.f=De,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ij=M;class F{static create(U,le){return new F(U,le)}constructor(U,le){this.d=U,this.f=le,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const le=this.f?this.f.source:"",De=U.f?U.f.source:"";return le<De?-1:le>De?1:0}equals(U){if(U.type===this.type){const le=this.f?this.f.source:"",De=U.f?U.f.source:"";return this.d===U.d&&le===De}return!1}substituteConstants(){return this}evaluate(U){const le=U.getValue(this.d);return this.f?this.f.test(le):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=O.create(this)),this.c}}e.$Jj=F;class O{static create(U){return new O(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new O(this.c.map(U))}negate(){return this.c}}e.$Kj=O;function q(_){let U=null;for(let le=0,De=_.length;le<De;le++){const $e=_[le].substituteConstants();if(_[le]!==$e&&U===null){U=[];for(let re=0;re<le;re++)U[re]=_[re]}U!==null&&(U[le]=$e)}return U===null?_:U}class Y{static create(U,le,De){return Y.d(U,le,De)}constructor(U,le){this.expr=U,this.c=le,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let le=0,De=this.expr.length;le<De;le++){const $e=c(this.expr[le],U.expr[le]);if($e!==0)return $e}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let le=0,De=this.expr.length;le<De;le++)if(!this.expr[le].equals(U.expr[le]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:Y.create(U,this.c,!1)}evaluate(U){for(let le=0,De=this.expr.length;le<De;le++)if(!this.expr[le].evaluate(U))return!1;return!0}static d(U,le,De){const $e=[];let re=!1;for(const se of U)if(se){if(se.type===1){re=!0;continue}if(se.type===0)return s.INSTANCE;if(se.type===6){$e.push(...se.expr);continue}$e.push(se)}if($e.length===0&&re)return v.INSTANCE;if($e.length!==0){if($e.length===1)return $e[0];$e.sort(c);for(let se=1;se<$e.length;se++)$e[se-1].equals($e[se])&&($e.splice(se,1),se--);if($e.length===1)return $e[0];for(;$e.length>1;){const se=$e[$e.length-1];if(se.type!==9)break;$e.pop();const oe=$e.pop(),K=$e.length===0,te=V.create(se.expr.map(ge=>Y.create([ge,oe],null,De)),null,K);te&&($e.push(te),$e.sort(c))}if($e.length===1)return $e[0];if(De){for(let se=0;se<$e.length;se++)for(let oe=se+1;oe<$e.length;oe++)if($e[se].negate().equals($e[oe]))return s.INSTANCE;if($e.length===1)return $e[0]}return new Y($e,le)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const le of this.expr)U.push(...le.keys());return U}map(U){return new Y(this.expr.map(le=>le.map(U)),null)}negate(){if(!this.c){const U=[];for(const le of this.expr)U.push(le.negate());this.c=V.create(U,this,!0)}return this.c}}e.$Lj=Y;class V{static create(U,le,De){return V.d(U,le,De)}constructor(U,le){this.expr=U,this.c=le,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let le=0,De=this.expr.length;le<De;le++){const $e=c(this.expr[le],U.expr[le]);if($e!==0)return $e}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let le=0,De=this.expr.length;le<De;le++)if(!this.expr[le].equals(U.expr[le]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:V.create(U,this.c,!1)}evaluate(U){for(let le=0,De=this.expr.length;le<De;le++)if(this.expr[le].evaluate(U))return!0;return!1}static d(U,le,De){let $e=[],re=!1;if(U){for(let se=0,oe=U.length;se<oe;se++){const K=U[se];if(K){if(K.type===0){re=!0;continue}if(K.type===1)return v.INSTANCE;if(K.type===9){$e=$e.concat(K.expr);continue}$e.push(K)}}if($e.length===0&&re)return s.INSTANCE;$e.sort(c)}if($e.length!==0){if($e.length===1)return $e[0];for(let se=1;se<$e.length;se++)$e[se-1].equals($e[se])&&($e.splice(se,1),se--);if($e.length===1)return $e[0];if(De){for(let se=0;se<$e.length;se++)for(let oe=se+1;oe<$e.length;oe++)if($e[se].negate().equals($e[oe]))return v.INSTANCE;if($e.length===1)return $e[0]}return new V($e,le)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const le of this.expr)U.push(...le.keys());return U}map(U){return new V(this.expr.map(le=>le.map(U)),null)}negate(){if(!this.c){const U=[];for(const le of this.expr)U.push(le.negate());for(;U.length>1;){const le=U.shift(),De=U.shift(),$e=[];for(const re of ve(le))for(const se of ve(De))$e.push(Y.create([re,se],null,!1));U.unshift(V.create($e,null,!1))}this.c=V.create(U,this,!0)}return this.c}}e.$Mj=V;class J extends f{static all(){return J.d.values()}constructor(U,le,De){super(U,null),this.f=le,typeof De=="object"?J.d.push({...De,key:U}):De!==!0&&J.d.push({key:U,description:De,type:le!=null?typeof le:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return y.create(this.key,U)}notEqualsTo(U){return S.create(this.key,U)}}e.$Nj=J,J.d=[],e.$Oj=(0,R.$wi)("contextKeyService");function x(_,U){return _<U?-1:_>U?1:0}function ne(_,U,le,De){return _<le?-1:_>le?1:U<De?-1:U>De?1:0}function de(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?ce(_.expr,U.expr):!1;if(U.type===9){for(const le of U.expr)if(de(_,le))return!0;return!1}if(_.type===6){if(U.type===6)return ce(U.expr,_.expr);for(const le of _.expr)if(de(le,U))return!0;return!1}return _.equals(U)}function ce(_,U){let le=0,De=0;for(;le<_.length&&De<U.length;){const $e=_[le].cmp(U[De]);if($e<0)return!1;$e===0&&le++,De++}return le===_.length}function ve(_){return _.type===9?_.expr:[_]}}),define(ke[254],Se([1,0,23,42,211,5,102,12,24]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Qw=e.$Pw=e.$Ow=void 0,e.$Rw=k,e.$Sw=p,e.$Ow=(0,R.$wi)("dialogService");var E;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(E||(E={}));class I{a(g){return this.d(g,E.Confirmation)}b(g){return this.d(g,E.Prompt)}c(g){return this.d(g,E.Input)}d(g,u){const n=[];switch(u){case E.Confirmation:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,A.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,A.localize)(1,null));break}case E.Prompt:{const i=g;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(d=>d.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,A.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,A.localize)(3,null))),n.length===0&&n.push((0,A.localize)(4,null));break}case E.Input:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,A.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,A.localize)(6,null));break}}return n}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===N.default.Info?"info":g===N.default.Error?"error":g===N.default.Warning?"warning":"none"}f(g,u,n){const i=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&i.push(g.cancelButton);let d=i[u]?.run({checkboxChecked:n});return d instanceof Promise||(d=Promise.resolve(d)),{result:d,checkboxChecked:n}}}e.$Pw=I,e.$Qw=(0,R.$wi)("fileDialogService");var P;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const b=10;function k(h){const g=[];return g.push(...h.slice(0,b).map(u=>typeof u=="string"?u:(0,a.$7g)(u))),h.length>b&&(h.length-b===1?g.push((0,A.localize)(7,null)):g.push((0,A.localize)(8,null,h.length-b))),g.push(""),g.join(`
`)}function p(h,g){const u=(0,m.$4n)(h);let n=(u.buttons??[]).map(t=>(0,L.$Lw)(t)),i=(h.buttons||[]).map((t,l)=>l),d=0,o=u.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if($.$e||$.$d){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const l=i[o];i.splice(o,1),i.splice(1,0,l),o=1}$.$e&&n.length>1&&(n=n.reverse(),i=i.reverse(),d=n.length-1,typeof t=="string"&&(o=d-1))}else if($.$c&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const l=i[o];i.splice(o,1),i.push(l),o=n.length-1}}return u.buttons=n,u.defaultId=d,u.cancelId=o,u.noLink=!0,u.title=u.title||g.nameLong,{options:u,buttonIndeces:i}}}),define(ke[138],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,a.$wi)("environmentService"),e.$Ei=(0,a.$xi)(e.$Di)}),define(ke[139],Se([1,0,212,5]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.ExtensionGalleryErrorCode=e.$8o=e.ExtensionManagementErrorCode=e.$7o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$1o=A,e.$2o=R,e.$3o=L,e.$4o=$,e.$5o=m,e.$6o=E,e.$Uo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vo=new RegExp(e.$Uo),e.$Wo="__web_extension",e.$Xo="skipWalkthrough",e.$Yo="extensionsSync",e.$Zo="dependecyOrPackExtensionInstall";function A(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function L(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function $(n,i){return i==="web"&&!n.includes("web")}function m(n,i,d){return $(i,d)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===d}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var I;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var P;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var b;(function(n){n.Install="install",n.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var k;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$7o=(0,N.$wi)("extensionGalleryService");var p;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));class h extends Error{constructor(i,d){super(i),this.code=d,this.name=d}}e.$8o=h;var g;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class u extends Error{constructor(i,d){super(i),this.code=d,this.name=d}}e.$9o=u,e.$0o=(0,N.$wi)("extensionManagementService"),e.$$o="extensionsIdentifiers/disabled",e.$_o="extensionsIdentifiers/enabled",e.$ap=(0,N.$wi)("IGlobalExtensionEnablementService"),e.$bp=(0,N.$wi)("IExtensionTipsService"),e.$cp=(0,a.localize2)(0,"Extensions"),e.$dp=(0,a.localize2)(1,"Preferences")}),define(ke[255],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0,e.$r7b=(0,a.$wi)("externalTerminal"),e.$s7b="Terminal.app"}),define(ke[256],Se([1,0,53,56,15,17,12,99,32,104,214,255]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=e.$Acc=void 0;const b=I.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends k{openTerminal(o,t){return this.spawnTerminal(a,o,E.$pm(),t)}spawnTerminal(o,t,l,r){const c=t.windowsExec||p.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=R.$oc(c,".exe").toLowerCase();if(s==="cmder")return o.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const v=["/c","start","/wait"];return c.indexOf(" ")>=0&&v.push('""'),v.push(c),s==="wt"&&v.push("-d ."),new Promise((f,y)=>{const w=u(process),D=o.spawn(l,v,{cwd:r,env:w,detached:!0});D.on("error",y),D.on("exit",()=>f())})}async runInTerminal(o,t,l,r,c){const s="windowsExec"in c&&c.windowsExec?c.windowsExec:p.getDefaultTerminalWindows(),v=await p.f();return new Promise((f,y)=>{const w=`"${t} - ${b}"`,D=`"${l.join('" "')}" & pause`,S=Object.assign({},u(process),r);Object.keys(S).filter(T=>S[T]===null).forEach(T=>delete S[T]);const C={cwd:t,env:S,windowsVerbatimArguments:!0};let j,B;R.$oc(s,".exe")==="wt"?(j=s,B=["-d",".",p.b,"/c",D]):v?(j=v,B=["-d",".",s,"/c",D]):(j=p.b,B=["/c","start",w,"/wait",s,"/c",`"${D}"`]),a.spawn(j,B,C).on("error",T=>{y(n(T))}),f(void 0)})}static getDefaultTerminalWindows(){if(!p.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p.d}static async f(){try{const o=await E.win32.findExecutable("wt");return await m.Promises.exists(o)?o:void 0}catch{return}}}e.$Acc=p,p.b="cmd.exe",Je([N.$1h],p,"f",null);class h extends k{openTerminal(o,t){return this.spawnTerminal(a,o,t)}runInTerminal(o,t,l,r,c){const s=c.osxExec||P.$s7b;return new Promise((v,f)=>{if(s===P.$s7b||s==="iTerm.app"){const y=s===P.$s7b?"TerminalHelper":"iTermHelper",D=[A.$Qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",o||b,"-w",t];for(const j of l)D.push("-a"),D.push(j);if(r){const j=Object.assign({},u(process),r);for(const B in j){const z=j[B];z===null?(D.push("-u"),D.push(B)):(D.push("-e"),D.push(`${B}=${z}`))}}let S="";const C=a.spawn(h.b,D);C.on("error",j=>{f(n(j))}),C.stderr.on("data",j=>{S+=j.toString()}),C.on("exit",j=>{if(j===0)v(void 0);else if(S){const B=S.split(`
`,1);f(new Error(B[0]))}else f(new Error(I.localize(1,null,y,j)))})}else f(new Error(I.localize(2,null,s)))})}spawnTerminal(o,t,l){const r=t.osxExec||P.$s7b;return new Promise((c,s)=>{const v=["-a",r];l&&v.push(l);const f=u(process),y=o.spawn("/usr/bin/open",v,{cwd:l,env:f});y.on("error",s),y.on("exit",()=>c())})}}e.$Bcc=h,h.b="/usr/bin/osascript";class g extends k{openTerminal(o,t){return this.spawnTerminal(a,o,t)}runInTerminal(o,t,l,r,c){const s=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((v,f)=>{const y=[];s.then(w=>{w.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const D=`${i(l)}; echo; read -p "${g.b}" -n1;`;y.push(`''${D}''`);const S=Object.assign({},u(process),r);Object.keys(S).filter(z=>S[z]===null).forEach(z=>delete S[z]);const C={cwd:t,env:S};let j="";const B=a.spawn(w,y,C);B.on("error",z=>{f(n(z))}),B.stderr.on("data",z=>{j+=z.toString()}),B.on("exit",z=>{if(z===0)v(void 0);else if(j){const T=j.split(`
`,1);f(new Error(T[0]))}else f(new Error(I.localize(4,null,w,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!L.$e)g.d=Promise.resolve("xterm");else{const o=await m.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(o,t,l){const r=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((c,s)=>{r.then(v=>{const f=u(process),y=o.spawn(v,[],{cwd:l,env:f});y.on("error",s),y.on("exit",()=>c())})})}}e.$Ccc=g,g.b=I.localize(3,null);function u(d){const o={...d.env};return(0,$.$nm)(o),o}function n(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(I.localize(5,null,d.path)):d}function i(d){let o="";for(const t of d)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[33],Se([1,0,78,17,14,18,2,215,5,12,15,46]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=b,e.$5k=g,e.$6k=n,e.$7k=i,e.$8k=d,e.$9k=o,e.$0k=t,e.$$k=l,e.$_k=r,e.$al=c,e.$bl=s,e.$dl=y,e.$el=w,e.$fl=D,e.$gl=S,e.$hl=C,e.$kl=M,e.$wl=J,e.$xl=x,e.$zl=de,e.$3k=(0,m.$wi)("fileService");function b(ce){return ce.create===!0}var k;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var p;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var h;(function(ce){ce[ce.UPDATED=2]="UPDATED",ce[ce.ADDED=4]="ADDED",ce[ce.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function g(ce){const ve=ce;return!!ve&&typeof ve.onDidChange=="function"}var u;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function n(ce){return!!(ce.capabilities&2)}function i(ce){return!!(ce.capabilities&8)}function d(ce){return!!(ce.capabilities&131072)}function o(ce){return!!(ce.capabilities&4)}function t(ce){return!!(ce.capabilities&16)}function l(ce){return n(ce)?!!(ce.capabilities&16384):!1}function r(ce){return n(ce)?!!(ce.capabilities&32768):!1}function c(ce){return!!(ce.capabilities&65536)}function s(ce){return!!(ce.capabilities&2048)}var v;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class f extends Error{static create(ve,_){const U=new f(ve.toString(),_);return D(U,_),U}constructor(ve,_){super(ve),this.code=_}}e.$cl=f;function y(ce,ve){return f.create(ce,ve)}function w(ce){return ce||y((0,$.localize)(0,null),v.Unknown)}function D(ce,ve){return ce.name=ve?`${ve} (FileSystemError)`:"FileSystemError",ce}function S(ce){if(!ce)return v.Unknown;if(ce instanceof f)return ce.code;const ve=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!ve)return v.Unknown;switch(ve[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function C(ce){if(ce instanceof F)return ce.fileOperationResult;switch(S(ce)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var j;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class B{constructor(ve,_,U){this.resource=ve,this.operation=_,this.target=U}isOperation(ve){return this.operation===ve}}e.$il=B;var z;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class T{constructor(ve,_){this.c=_,this.b=void 0,this.d=new P.$V(()=>{const U=a.$Ci.forUris(()=>this.c);return U.fill(this.rawAdded.map(le=>[le,!0])),U}),this.f=new P.$V(()=>{const U=a.$Ci.forUris(()=>this.c);return U.fill(this.rawUpdated.map(le=>[le,!0])),U}),this.g=new P.$V(()=>{const U=a.$Ci.forUris(()=>this.c);return U.fill(this.rawDeleted.map(le=>[le,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ve){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==T.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(ve,..._){return this.h(ve,{includeChildren:!1},..._)}affects(ve,..._){return this.h(ve,{includeChildren:!0},..._)}h(ve,_,...U){if(!ve)return!1;const le=U.length>0;return!!((!le||U.includes(1))&&(this.d.value.get(ve)||_.includeChildren&&this.d.value.findSuperstr(ve))||(!le||U.includes(0))&&(this.f.value.get(ve)||_.includeChildren&&this.f.value.findSuperstr(ve))||(!le||U.includes(2))&&(this.g.value.findSubstr(ve)||_.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$jl=T,T.a=null;function M(ce,ve,_){return!ce||!ve||ce===ve||ve.length>ce.length?!1:(ve.charAt(ve.length-1)!==N.sep&&(ve+=N.sep),_?(0,A.$zf)(ce,ve):ce.indexOf(ve)===0)}class F extends Error{constructor(ve,_,U){super(ve),this.fileOperationResult=_,this.options=U}}e.$ll=F;class O extends F{constructor(ve,_,U,le){super(ve,_,le),this.fileOperationResult=_,this.size=U}}e.$ml=O;class q extends F{constructor(ve,_,U){super(ve,2,U),this.stat=_}}e.$nl=q;var Y;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var V;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$vl="";function J(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}async function x(ce,ve){if(!ve.hasProvider(L.URI.from({scheme:ce.scheme})))return new Promise(_=>{const U=ve.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===ce.scheme&&le.added&&(U.dispose(),_())})})}class ne{static formatSize(ve){return(0,R.$ag)(ve)||(ve=0),ve<ne.KB?(0,$.localize)(1,null,ve.toFixed(0)):ve<ne.MB?(0,$.localize)(2,null,(ve/ne.KB).toFixed(2)):ve<ne.GB?(0,$.localize)(3,null,(ve/ne.MB).toFixed(2)):ve<ne.TB?(0,$.localize)(4,null,(ve/ne.GB).toFixed(2)):(0,$.localize)(5,null,(ve/ne.TB).toFixed(2))}}e.$yl=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;function de(ce){const ve=typeof ce=="string"||ce?.scheme===I.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===I.Schemas.file?1024*ne.MB:ve?10*ne.MB:E.$i?50*ne.MB:1024*ne.MB}}),define(ke[257],Se([1,0,21,13,216,33]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=L;async function L(I,P,b,k,p,h){let g;try{await $(I,P,b,k,p,h)}catch(u){g=u}finally{g&&p.errorTransformer&&(g=p.errorTransformer(g)),typeof g<"u"&&b.error(g),b.end()}}async function $(I,P,b,k,p,h){m(h);const g=await I.open(P,{create:!1});try{m(h);let u=0,n=0,i=p&&typeof p.length=="number"?p.length:void 0,d=a.$Ge.alloc(Math.min(p.bufferSize,typeof i=="number"?i:p.bufferSize)),o=p&&typeof p.position=="number"?p.position:0,t=0;do n=await I.read(g,o,d.buffer,t,d.byteLength-t),o+=n,t+=n,u+=n,typeof i=="number"&&(i-=n),t===d.byteLength&&(await b.write(k(d)),d=a.$Ge.alloc(Math.min(p.bufferSize,typeof i=="number"?i:p.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&m(h)&&E(u,p));if(t>0){let l=t;typeof i=="number"&&(l=Math.min(t,i)),b.write(k(d.slice(0,l)))}}catch(u){throw(0,R.$el)(u)}finally{await I.close(g)}}function m(I){if(I.isCancellationRequested)throw(0,N.$6)();return!0}function E(I,P){if(typeof P?.limits?.size=="number"&&I>P.limits.size)throw(0,R.$dl)((0,A.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Se([1,0,35,3,17,12,2,33]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=e.$Mq=void 0,e.$Kq=m,e.$Lq=E,e.$Pq=k,e.$Qq=p,e.$Rq=h,e.$Sq=g,e.$Tq=n,e.$Uq=i;function m(d){return typeof d.correlationId=="number"}function E(d){return d.recursive===!0}class I extends N.$Vc{constructor(o,t,l,r){super(),this.h=o,this.j=t,this.m=l,this.n=r,this.c=this.B(new N.$Wc),this.f=void 0,this.g=0}s(){const o=new N.$Uc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(t=>this.h(t))),o.add(this.b.onDidLogMessage(t=>this.j(t))),o.add(this.b.onDidError(t=>this.t(t)))}t(o){this.n.restartOnError?this.g<I.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Mq=I,I.a=5;class P extends I{constructor(o,t,l){super(o,t,l,{type:"node.js",restartOnError:!1})}}e.$Nq=P;class b extends I{constructor(o,t,l){super(o,t,l,{type:"universal",restartOnError:!0})}}e.$Oq=b;function k(d){return d.map(o=>({type:o.type,resource:L.URI.revive(o.resource),cId:o.cId}))}function p(d){const o=new u;for(const t of d)o.processEvent(t);return o.coalesce()}function h(d,o){return typeof o=="string"&&!o.startsWith(a.$mk)&&!(0,A.$jc)(o)?{base:d,pattern:o}:o}function g(d,o){const t=[];for(const l of o)t.push((0,a.$qk)(h(d,l)));return t}class u{constructor(){this.a=new Set,this.b=new Map}c(o){return R.$e?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.b.get(this.c(o));let l=!1;if(t){const r=t.type,c=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?l=!0:r===1&&c===2?(this.b.delete(this.c(o)),this.a.delete(t)):r===2&&c===1?t.type=0:r===1&&c===0||(t.type=c)}else l=!0;l&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],t=[];return Array.from(this.a).filter(l=>l.type!==2?(o.push(l),!1):!0).sort((l,r)=>l.resource.fsPath.length-r.resource.fsPath.length).filter(l=>t.some(r=>(0,$.$kl)(l.resource.fsPath,r,!R.$e))?!1:(t.push(l.resource.fsPath),!0)).concat(o)}}function n(d,o){if(typeof o=="number")switch(d.type){case 1:return(o&4)===0;case 2:return(o&8)===0;case 0:return(o&2)===0}return!1}function i(d){if(typeof d=="number"){const o=[];return d&4&&o.push("Added"),d&8&&o.push("Deleted"),d&2&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(ke[258],Se([1,0,52,3,65,4,2,7]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;class m extends N.$Vc{constructor(){super(),this.a=this.B(new R.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$5c),this.m=new Set,this.n=5007,this.r=new $.$Th,this.P=!1,this.B(this.f(I=>this.s(I)))}s(I){this.t(I)&&this.w(I)}t(I){return(0,A.$Kq)(I)}async watch(I){this.r.isSettled||this.r.complete(),this.r=new $.$Th;try{this.h.clear(),this.g.clear();for(const P of I)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(I=>!this.j.has(I.correlationId))])}isSuspended(I){return typeof I.correlationId!="number"?!1:this.m.has(I.correlationId)?"polling":this.j.has(I.correlationId)}async w(I){if(this.j.has(I.correlationId))return;const P=new N.$Uc;this.j.set(I.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(I,P),this.u())}y(I){this.j.deleteAndDispose(I.correlationId),this.m.delete(I.correlationId),this.u()}z(I,P){this.C(I,P)?(this.N(`reusing an existing recursive watcher to monitor ${I.path}`),this.m.delete(I.correlationId)):(this.D(I,P),this.m.add(I.correlationId))}C(I,P){const b=this.M?.subscribe(I.path,(k,p)=>{P.isDisposed||(k?this.z(I,P):p?.type===1&&this.F(I))});return b?(P.add(b),!0):!1}D(I,P){let b=!1;const k=(p,h)=>{if(P.isDisposed)return;const g=this.G(p),u=this.G(h),n=b;b=g,!g&&(u||n)&&this.F(I)};this.N(`starting fs.watchFile() on ${I.path} (correlationId: ${I.correlationId})`);try{(0,a.watchFile)(I.path,{persistent:!1,interval:this.n},k)}catch(p){this.O(`fs.watchFile() failed with error ${p} on path ${I.path} (correlationId: ${I.correlationId})`)}P.add((0,N.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${I.path} (correlationId: ${I.correlationId})`);try{(0,a.unwatchFile)(I.path,k)}catch(p){this.O(`fs.unwatchFile() failed with error ${p} on path ${I.path} (correlationId: ${I.correlationId})`)}}))}F(I){this.N(`detected ${I.path} exists again, resuming watcher (correlationId: ${I.correlationId})`);const P={resource:L.URI.file(I.path),type:1,cId:I.correlationId};this.a.fire([P]),this.H(P,I),this.y(I)}G(I){return I.ctimeMs===0&&I.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(I,P){if(this.P){const b=` >> normalized ${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`;this.I(b,P)}}I(I,P){this.P&&this.N(`${I}${typeof P.correlationId=="number"?` <${P.correlationId}> `:""}`)}J(I){return`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"}, filter: ${(0,A.$Uq)(I.filter)}, correlationId: ${typeof I.correlationId=="number"?I.correlationId:"<none>"})`}async setVerboseLogging(I){this.P=I}}e.$4q=m}),define(ke[259],Se([1,0,52,7,22,30,3,77,17,12,23,2,103,32,65]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0,e.$0q=g;class h extends L.$Vc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,d,o,t,l){super(),this.s=n,this.t=i,this.u=d,this.w=o,this.y=t,this.z=l,this.c=this.B(new N.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new N.$Kh(r=>this.M(r),h.b)),this.g=(0,p.$Sq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,p.$Sq)(this.s.path,this.s.includes):void 0,this.j=(0,p.$Kq)(this.s)?this.s.filter:void 0,this.m=new A.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await k.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await k.Promises.realpath(n.path),n.path===i&&(i=await(0,b.$6q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const d=new L.$Uc;return this.H(n,i,d)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,d)),d}H(n,i,d){if(i)return!1;const o=P.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(l,r)=>{if(!d.isDisposed)if(l){const c=await this.G(n,i);d.isDisposed?c.dispose():d.add(c)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:r.type,cId:this.s.correlationId},!0)});return t?(d.add(t),!0):!1}async I(n,i,d){if(E.$d&&(0,R.$vg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new A.$pe(this.m.token);d.add((0,L.$Tc)(()=>o.dispose(!0)));const t=new L.$Uc;d.add(t);try{const l=P.URI.file(this.s.path),r=(0,m.$oc)(n),c=(0,a.watch)(n);t.add((0,L.$Tc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${n}'`);const s=new Set;if(i)try{for(const f of await k.Promises.readdir(n))s.add(f)}catch(f){this.O(f)}if(o.token.isCancellationRequested)return;const v=new Map;t.add((0,L.$Tc)(()=>{for(const[,f]of v)f.dispose();v.clear()})),c.on("error",(f,y)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${f}, ${y})`),this.D())}),c.on("change",(f,y)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${f}"] ${y}`);let w="";if(y&&(w=y.toString(),E.$d&&(w=(0,$.$cm)(w))),!(!w||f!=="change"&&f!=="rename"))if(i)if(f==="rename"){v.get(w)?.dispose();const D=setTimeout(async()=>{if(v.delete(w),w===r&&!await k.Promises.exists(n)){this.J(l);return}if(o.token.isCancellationRequested)return;const S=await this.N((0,m.$kc)(n,w));if(o.token.isCancellationRequested)return;let C;S?s.has(w)?C=0:(C=1,s.add(w)):(s.delete(w),C=2),this.L({resource:(0,I.$0g)(l,w),type:C,cId:this.s.correlationId})},h.a);v.set(w,(0,L.$Tc)(()=>clearTimeout(D)))}else{let D;s.has(w)?D=0:(D=1,s.add(w)),this.L({resource:(0,I.$0g)(l,w),type:D,cId:this.s.correlationId})}else if(f==="rename"||w!==r){const D=setTimeout(async()=>{const S=await k.Promises.exists(n);o.token.isCancellationRequested||(S?(this.L({resource:l,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(l))},h.a);t.clear(),t.add((0,L.$Tc)(()=>clearTimeout(D)))}else this.L({resource:l,type:0,cId:this.s.correlationId},!0)})}catch(l){o.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${l.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(d=>d(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(d=>d(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,p.$Qq)(n),d=[];for(const t of i){if((0,p.$Tq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}d.push(t)}if(d.length===0)return;if(this.z)for(const t of d)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(E.$e)return k.Promises.exists(n);try{const i=(0,m.$oc)(n);return(await k.Promises.readdir((0,m.$nc)(n))).some(o=>o===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$9q=h,h.a=100,h.b=75;async function g(u,n,i,d,o=512){const t=await k.Promises.open(u,"r"),l=Buffer.allocUnsafe(o),r=new A.$pe(d);let c,s=!1;const v={path:u,excludes:[],recursive:!1},f=new h(v,void 0,y=>{(async()=>{for(const{type:w}of y)if(w===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:D}=await k.Promises.read(t,l,0,o,null);if(!D||r.token.isCancellationRequested)break;n(l.slice(0,D))}}catch(D){c=new Error(D),r.dispose(!0)}finally{s=!1}}})()});return await f.ready,i(),new Promise((y,w)=>{r.token.onCancellationRequested(async()=>{f.dispose();try{await k.Promises.close(t)}catch(D){c=new Error(D)}c?w(c):y()})})}}),define(ke[260],Se([1,0,4,35,258,12,259,30]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class m extends A.$4q{constructor(I){super(),this.M=I,this.onDidError=a.Event.None,this.watchers=new Set}async L(I){I=this.X(I);const P=[],b=new Set(Array.from(this.watchers));for(const k of I){const p=this.S(k);p&&(0,N.$uk)(p.request.excludes,k.excludes)&&(0,N.$uk)(p.request.includes,k.includes)?b.delete(p):P.push(k)}P.length&&this.N(`Request to start watching: ${P.map(k=>this.J(k)).join(",")}`),b.size&&this.N(`Request to stop watching: ${Array.from(b).map(k=>this.J(k.request)).join(",")}`);for(const k of b)this.W(k);for(const k of P)this.U(k)}S(I){for(const P of this.watchers)if(typeof I.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===I.correlationId)return P}else if((0,$.$ug)(P.request.path,I.path,!R.$e))return P}U(I){const P=new L.$9q(I,this.M,k=>this.a.fire(k),()=>this.c.fire(I),k=>this.b.fire(k),this.P),b={request:I,instance:P};this.watchers.add(b)}async stop(){await super.stop();for(const I of this.watchers)this.W(I)}W(I){this.N("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}X(I){const P=new Map;for(const b of I){const k=R.$e?b.path:b.path.toLowerCase();let p=P.get(b.correlationId);p||(p=new Map,P.set(b.correlationId,p)),p.has(k)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(b)}`),p.set(k,b)}return Array.from(P.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const P of this.watchers)P.instance.setVerboseLogging(I)}N(I,P){this.P&&this.b.fire({type:"trace",message:this.$(I,P)})}O(I){this.b.fire({type:"warn",message:this.$(I)})}$(I,P){return P?`[File Watcher (node.js)] ${I} (${this.J(P.request)})`:`[File Watcher (node.js)] ${I}`}}e.$$q=m}),define(ke[261],Se([1,0,65,260]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class A extends a.$Nq{constructor(L,$,m){super(L,$,m),this.s()}r(L){return L.add(new N.$$q(void 0))}}e.$_q=A}),define(ke[262],Se([1,0,15,81,182,65]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class L extends R.$Oq{constructor(m,E,I){super(m,E,I),this.s()}r(m){const E=m.add(new A.$2q(a.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(E.onDidProcessExit(({code:I,signal:P})=>this.t(`terminated by itself with code ${I}, signal: ${P} (ETERM)`))),N.ProxyChannel.toService((0,N.$di)(E.getChannel("watcher")))}}e.$3q=L}),define(ke[107],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class a{constructor(...A){this.a=new Map;for(const[R,L]of A)this.set(R,L)}set(A,R){const L=this.a.get(A);return this.a.set(A,R),L}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$ui=a}),define(ke[263],Se([1,0,7,13,3,106,253,5,107,76]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;const I=!1;class P extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class b{constructor(g=new m.$ui,u=!1,n,i=I){this.i=g,this.j=u,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set($.$vi,this),this._globalGraph=i?n?._globalGraph??new L.$cr(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,A.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const u=new class extends b{dispose(){this.h.delete(u),super.dispose()}}(g,this.j,this,this.l);return this.h.add(u),u}invokeFunction(g,...u){this.m();const n=p.traceInvocation(this.l,g);let i=!1;try{return g({get:o=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...u)}finally{i=!0,n.stop()}}createInstance(g,...u){this.m();let n,i;return g instanceof R.$ti?(n=p.traceCreation(this.l,g.ctor),i=this.o(g.ctor,g.staticArguments.concat(u),n)):(n=p.traceCreation(this.l,g),i=this.o(g,u,n)),n.stop(),i}o(g,u=[],n){const i=$._util.getServiceDependencies(g).sort((t,l)=>t.index-l.index),d=[];for(const t of i){const l=this.s(t.id,n);l||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(l)}const o=i.length>0?i[0].index:u.length;if(u.length!==o){console.trace(`[createInstance] First service dependency of ${g.name} at position ${o+1} conflicts with ${u.length} static arguments`);const t=o-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,o)}return Reflect.construct(g,u.concat(d))}q(g,u){if(this.i.get(g)instanceof R.$ti)this.i.set(g,u);else if(this.k)this.k.q(g,u);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const u=this.i.get(g);return!u&&this.k?this.k.r(g):u}s(g,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const n=this.r(g);return n instanceof R.$ti?this.u(g,n,u.branch(g,!0)):(u.branch(g,!1),n)}u(g,u,n){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,u,n)}finally{this.t.delete(g)}}v(g,u,n){const i=new L.$cr(t=>t.id.toString());let d=0;const o=[{id:g,desc:u,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),d++>1e3)throw new P(i);for(const l of $._util.getServiceDependencies(t.desc.ctor)){const r=this.r(l.id);if(r||this.y(`[createInstance] ${g} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof R.$ti){const c={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};i.insertEdge(t,c),o.push(c)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new P(i);break}for(const{data:l}of t){if(this.r(l.id)instanceof R.$ti){const c=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,c)}i.removeNode(l)}}return this.r(g)}w(g,u,n=[],i,d){if(this.i.get(g)instanceof R.$ti)return this.x(g,u,n,i,d,this.g);if(this.k)return this.k.w(g,u,n,i,d);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}x(g,u,n=[],i,d,o){if(i){const t=new b(void 0,this.j,this,this.l);t.c=String(g);const l=new Map,r=new a.$Ph(()=>{const c=t.o(u,n,d);for(const[s,v]of l){const f=c[s];if(typeof f=="function")for(const y of v)y.disposable=f.apply(c,y.listener)}return l.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let y=l.get(s);return y||(y=new E.$6c,l.set(s,y)),(D,S,C)=>{if(r.isInitialized)return r.value[s](D,S,C);{const j={listener:[D,S,C],disposable:void 0},B=y.push(j);return(0,A.$Tc)(()=>{B(),j.disposable?.dispose()})}}}if(s in c)return c[s];const v=r.value;let f=v[s];return typeof f!="function"||(f=f.bind(v),c[s]=f),f},set(c,s,v){return r.value[s]=v,!0},getPrototypeOf(c){return u.prototype}})}else{const t=this.o(u,n,d);return o.add(t),t}}y(g,u){if(u&&console.warn(g),this.j)throw new Error(g)}}e.$dr=b;var k;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(k||(k={}));class p{static traceInvocation(g,u){return g?new p(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(g,u){return g?new p(1,u.name):p.c}constructor(g,u){this.type=g,this.name=u,this.g=Date.now(),this.h=[]}branch(g,u){const n=new p(3,g.toString());return this.h.push([g,u,n]),n}stop(){const g=Date.now()-this.g;p.f+=g;let u=!1;function n(d,o){const t=[],l=new Array(d+1).join("	");for(const[r,c,s]of o.h)if(c&&s){u=!0,t.push(`${l}CREATES -> ${r}`);const v=n(d+1,s);v&&t.push(v)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(g>2||u)&&p.all.add(i.join(`
`))}}e.$er=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(ke[11],Se([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=h,e.log=u,e.$ek=f,e.$fk=y,e.$gk=w,e.$hk=D,e.$3j=(0,k.$wi)("logService"),e.$4j=(0,k.$wi)("loggerService");function p(){return new Date().toISOString()}function h(S){return(0,I.$ag)(S)}var g;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$6j=g.Info;function u(S,C,j){switch(C){case g.Trace:S.trace(j);break;case g.Debug:S.debug(j);break;case g.Info:S.info(j);break;case g.Warning:S.warn(j);break;case g.Error:S.error(j);break;case g.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(S,C=!1){let j="";for(let B=0;B<S.length;B++){let z=S[B];if(z instanceof Error&&(z=(0,N.$hj)(z,C)),typeof z=="object")try{z=JSON.stringify(z)}catch{}j+=(B>0?" ":"")+z}return j}class i extends L.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new A.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==g.Off&&this.b<=C}}e.$8j=i;class d extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...j){this.f(g.Trace)&&this.g(g.Trace,n([C,...j],!0))}debug(C,...j){this.f(g.Debug)&&this.g(g.Debug,n([C,...j]))}info(C,...j){this.f(g.Info)&&this.g(g.Info,n([C,...j]))}warn(C,...j){this.f(g.Warning)&&this.g(g.Warning,n([C,...j]))}error(C,...j){if(this.f(g.Error))if(C instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=C.stack,this.g(g.Error,n(B))}else this.g(g.Error,n([C,...j]))}flush(){}}e.$9j=d;class o extends i{constructor(C=e.$6j){super(),this.setLevel(C),this.g=!m.$c}trace(C,...j){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...j):console.log(`[main ${p()}]`,C,...j))}debug(C,...j){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...j):console.log(`[main ${p()}]`,C,...j))}info(C,...j){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...j):console.log(`[main ${p()}]`,C,...j))}warn(C,...j){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,C,...j):console.warn(`[main ${p()}]`,C,...j))}error(C,...j){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,C,...j):console.error(`[main ${p()}]`,C,...j))}flush(){}}e.$0j=o;class t extends i{constructor(C=e.$6j,j=!0){super(),this.g=j,this.setLevel(C)}trace(C,...j){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...j):console.log(C,...j))}debug(C,...j){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...j):console.log(C,...j))}info(C,...j){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...j):console.log(C,...j))}warn(C,...j){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...j):console.log(C,...j))}error(C,...j){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...j):console.error(C,...j))}flush(){}}e.$$j=t;class l extends i{constructor(C,j=e.$6j){super(),this.g=C,this.setLevel(j)}trace(C,...j){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(C),...j])}debug(C,...j){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(C),...j])}info(C,...j){this.f(g.Info)&&this.g.log(g.Info,[this.h(C),...j])}warn(C,...j){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(C),...j])}error(C,...j){this.f(g.Error)&&this.g.log(g.Error,[this.h(C),...j])}h(C){return typeof C=="string"?C:(0,N.$hj)(C,this.f(g.Trace))}flush(){}}e.$_j=l;class r extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const j of this.g)j.setLevel(C);super.setLevel(C)}trace(C,...j){for(const B of this.g)B.trace(C,...j)}debug(C,...j){for(const B of this.g)B.debug(C,...j)}info(C,...j){for(const B of this.g)B.info(C,...j)}warn(C,...j){for(const B of this.g)B.warn(C,...j)}error(C,...j){for(const B of this.g)B.error(C,...j)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ak=r;class c extends L.$Vc{constructor(C,j,B){if(super(),this.h=C,this.j=j,this.b=new $.$Bc,this.c=this.B(new A.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$ee),this.onDidChangeVisibility=this.g.event,B)for(const z of B)this.b.set(z.resource,{logger:void 0,info:z})}m(C){return(0,I.$9f)(C)?[...this.b.values()].find(j=>j.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,j){const B=this.n(C),z=(0,I.$9f)(C)?C:j?.id??(0,R.$kj)(B.toString()).toString(16);let T=this.b.get(B)?.logger;const M=j?.logLevel==="always"?g.Trace:j?.logLevel;T||(T=this.s(B,M??this.getLogLevel(B)??this.h,{...j,id:z}));const F={logger:T,info:{resource:B,id:z,logLevel:M,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(F.info),this.b.set(B,F),T}n(C){return(0,I.$9f)(C)?(0,E.$0g)(this.j,`${C}.log`):C}setLogLevel(C,j){if(P.URI.isUri(C)){const B=C,z=j,T=this.b.get(B);T&&z!==T.info.logLevel&&(T.info.logLevel=z===this.h?void 0:z,T.logger?.setLevel(z),this.b.set(T.info.resource,T),this.f.fire([B,z]))}else{this.h=C;for(const[B,z]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,j){const B=this.m(C);B&&j!==!B.info.hidden&&(B.info.hidden=!j,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,j]))}getLogLevel(C){let j;return C&&(j=this.b.get(C)?.info.logLevel),j??this.h}registerLogger(C){const j=this.b.get(C.resource);j?j.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const j=this.b.get(C);j&&(j.logger&&j.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=c;class s{constructor(){this.onDidChangeLogLevel=new A.$ee().event}setLevel(C){}getLevel(){return g.Info}trace(C,...j){}debug(C,...j){}info(C,...j){}warn(C,...j){}error(C,...j){}critical(C,...j){}dispose(){}flush(){}}e.$ck=s;class v extends s{}e.$dk=v;function f(S){if(S.verbose)return g.Trace;if(typeof S.logLevel=="string"){const C=D(S.logLevel.toLowerCase());if(C!==void 0)return C}return e.$6j}function y(S){switch(S){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function w(S){switch(S){case g.Trace:return{original:"Trace",value:a.localize(0,null)};case g.Debug:return{original:"Debug",value:a.localize(1,null)};case g.Info:return{original:"Info",value:a.localize(2,null)};case g.Warning:return{original:"Warning",value:a.localize(3,null)};case g.Error:return{original:"Error",value:a.localize(4,null)};case g.Off:return{original:"Off",value:a.localize(5,null)}}}function D(S){switch(S){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ik=new b.$Nj("logLevel",y(g.Info))}),define(ke[264],Se([1,0,19,7,13,4,30,3,17,65,11]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class P extends $.$Vc{constructor(k,p){super(),this.a=k,this.b=p,this.c=this.B(new R.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$uh(0)),this.w=[],this.y=this.B(new N.$uh(0))}watch(k,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(k,p):this.z(k,p)}n(k,p){const h={path:this.J(k),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},g=(0,a.$Ub)(this.j,h);return this.r(),(0,$.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,A.$1)(k))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,E.$Pq)(p)),p=>this.G(p),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const p of this.j)(0,E.$Lq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const p of this.j)(0,E.$Lq)(p)&&k.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,p){const h={path:this.J(k),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},g=(0,a.$Ub)(this.w,h);return this.C(),(0,$.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,A.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,E.$Pq)(k)),k=>this.G(k),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,m.$ic)(k.fsPath)}J(k){const p=this.I(k);return(0,L.$yg)(p)}}e.$Vq=P}),define(ke[265],Se([1,0,52,401,7,27,21,4,30,3,17,12,23,100,32,217,33,257,264,47,262,261]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0,(()=>{try{(0,N.gracefulify)(a)}catch(l){console.error(`Error enabling graceful-fs: ${(0,i.$hj)(l)}`)}})();class t extends n.$Vq{constructor(r,c){super(r,c),this.onDidChangeCapabilities=$.Event.None,this.P=new R.$Bc(s=>b.$1g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,P.$e&&(this.M|=1024)),this.M}async stat(r){try{const{stat:c,symbolicLink:s}=await p.SymlinkSupport.stat(this.I(r));return{type:this.O(c,s),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:g.FilePermission.Locked}}catch(c){throw this.hb(c)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const c=await p.Promises.readdir(this.I(r),{withFileTypes:!0}),s=[];return await Promise.all(c.map(async v=>{try{let f;v.isSymbolicLink()?f=(await this.stat((0,b.$0g)(r,v.name))).type:f=this.O(v),s.push([v.name,f])}catch(f){this.a.trace(f)}})),s}catch(c){throw this.hb(c)}}O(r,c){let s;return c?.dangling?s=g.FileType.Unknown:r.isFile()?s=g.FileType.File:r.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,c&&(s|=g.FileType.SymbolicLink),s}async Q(r){const c=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let s;for(;s=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await s.wait();const v=new A.$vh;return this.P.set(r,v),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,E.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.P.get(r)===v&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),v.open()})}async readFile(r,c){let s;try{c?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),s=await this.Q(r));const v=this.I(r);return await p.Promises.readFile(v)}catch(v){throw this.hb(v)}finally{s?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,c,s){const v=(0,k.$ue)(f=>L.$Ge.concat(f.map(y=>L.$Ge.wrap(y))).buffer);return(0,u.$Iq)(this,r,v,f=>f.buffer,{...c,bufferSize:256*1024},s),v}async writeFile(r,c,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(r)?this.U(r,(0,b.$0g)((0,b.$9g)(r),`${(0,b.$7g)(r)}${s.atomic.postfix}`),c,s):this.W(r,c,s)}async S(r){try{const c=this.I(r),{symbolicLink:s}=await p.SymlinkSupport.stat(c);if(s)return!1}catch{}return!0}async U(r,c,s,v){const f=new E.$Uc;try{f.add(await this.Q(r)),f.add(await this.Q(c)),await this.W(c,s,v,!0);try{await this.rename(c,r,{overwrite:!0})}catch(y){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{f.dispose()}}async W(r,c,s,v){let f;try{const y=this.I(r);if(!s.create||!s.overwrite){if(await p.Promises.exists(y)){if(!s.overwrite)throw(0,g.$dl)((0,h.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$dl)((0,h.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(r,{create:!0,unlock:s.unlock},v),await this.write(f,0,c,0,c.byteLength)}catch(y){throw await this.ib(r,y)}finally{typeof f=="number"&&await this.close(f)}}static configureFlushOnWrite(r){t.$=r}async open(r,c,s){const v=this.I(r);let f;(0,g.$4k)(c)&&!s&&(f=await this.Q(r));let y;try{if((0,g.$4k)(c)&&c.unlock)try{const{stat:D}=await p.SymlinkSupport.stat(v);D.mode&128||await p.Promises.chmod(v,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let w;if((0,g.$4k)(c)){if(P.$c)try{await p.Promises.truncate(v,0),w="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}w||(w="w")}else w="r";y=await p.Promises.open(v,w)}catch(w){throw f?.dispose(),(0,g.$4k)(c)?await this.ib(r,w):this.hb(w)}if(this.X.set(y,0),(0,g.$4k)(c)&&this.Z.set(y,r),f){const w=this.Y.get(y);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${v})`),this.Y.set(y,f),w&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${v})`),w.dispose())}return y}async close(r){const c=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await p.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(r)}catch(s){throw this.hb(s)}finally{c&&(this.Y.get(r)===c&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),c.dispose())}}async read(r,c,s,v,f){const y=this.ab(r,c);let w=null;try{w=(await p.Promises.read(r,s,v,f,y)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(r,y,w)}return w}ab(r,c){return c===this.X.get(r)?null:c}bb(r,c,s){const v=this.X.get(r);typeof v=="number"&&(typeof c=="number"||(typeof s=="number"?this.X.set(r,v+s):this.X.delete(r)))}async write(r,c,s,v,f){return(0,A.$Qh)(()=>this.cb(r,c,s,v,f),100,3)}async cb(r,c,s,v,f){const y=this.ab(r,c);let w=null;try{w=(await p.Promises.write(r,s,v,f,y)).bytesWritten}catch(D){throw await this.ib(this.Z.get(r),D)}finally{this.bb(r,y,w)}return w}async mkdir(r){try{await p.Promises.mkdir(this.I(r))}catch(c){throw this.hb(c)}}async delete(r,c){try{const s=this.I(r);if(c.recursive){let v;c?.atomic!==!1&&c.atomic.postfix&&(v=(0,I.$kc)((0,I.$nc)(s),`${(0,I.$oc)(s)}${c.atomic.postfix}`)),await p.Promises.rm(s,p.RimRafMode.MOVE,v)}else try{await p.Promises.unlink(s)}catch(v){if(v.code==="EPERM"||v.code==="EISDIR"){let f=!1;try{const{stat:y,symbolicLink:w}=await p.SymlinkSupport.stat(s);f=y.isDirectory()&&!w}catch{}if(f)await p.Promises.rmdir(s);else throw v}else throw v}}catch(s){throw this.hb(s)}}async rename(r,c,s){const v=this.I(r),f=this.I(c);if(v!==f)try{await this.db(r,c,"move",s.overwrite),await p.Promises.rename(v,f)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(2,null,(0,I.$oc)(v),(0,I.$oc)((0,I.$nc)(f)),y.toString()))),this.hb(y)}}async copy(r,c,s){const v=this.I(r),f=this.I(c);if(v!==f)try{await this.db(r,c,"copy",s.overwrite),await p.Promises.copy(v,f,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(3,null,(0,I.$oc)(v),(0,I.$oc)((0,I.$nc)(f)),y.toString()))),this.hb(y)}}async db(r,c,s,v){const f=this.I(r),y=this.I(c);let w=!1;if(!!(this.capabilities&1024)||(w=(0,m.$ug)(f,y,!0)),w){if(s==="copy")throw(0,g.$dl)((0,h.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const S=await this.N(r);if(!S)throw(0,g.$dl)((0,h.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(c);if(C){if(!v)throw(0,g.$dl)((0,h.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);S.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,c){return this.eb(r,c,!1)}async eb(r,c,s){const v=this.I(r),f=this.I(c),y=!!(this.capabilities&1024);if((0,m.$ug)(v,f,!y))return;const w=new E.$Uc;try{w.add(await this.Q(r)),w.add(await this.Q(c)),s&&await p.Promises.mkdir((0,I.$nc)(f),{recursive:!0}),await p.Promises.copyFile(v,f)}catch(D){if(D.code==="ENOENT"&&!s)return this.eb(r,c,!0);throw this.hb(D)}finally{w.dispose()}}t(r,c,s){return new d.$3q(v=>r(v),v=>c(v),s)}F(r,c,s){return new o.$_q(v=>r(v),v=>c(v),s)}hb(r){if(r instanceof g.$cl)return r;let c=r,s;switch(r.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$dl)(c,s)}async ib(r,c){let s=this.hb(c);if(r&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await p.SymlinkSupport.stat(this.I(r));v.mode&128||(s=(0,g.$dl)(c,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.a.trace(v)}return s}}e.$ar=t,t.L=!1,t.$=!0}),define(ke[266],Se([1,0,3,11]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WQ=void 0;class A extends a.$Vc{constructor(L,$=[]){super(),this.a=new N.$ak([L,...$]),this.B(L.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...$){this.a.trace(L,...$)}debug(L,...$){this.a.debug(L,...$)}info(L,...$){this.a.info(L,...$)}warn(L,...$){this.a.warn(L,...$)}error(L,...$){this.a.error(L,...$)}flush(){this.a.flush()}}e.$WQ=A}),define(ke[267],Se([1,0,33,11]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LQ=void 0;var A;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(A||(A={}));async function R(E,I,P,b,k){try{const p=await new Promise((g,u)=>{ie(["@vscode/spdlog"],g,u)});p.setFlushOn(A.Trace);const h=await p.createAsyncRotatingLogger(E,I,P,b);return k?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(p){console.error(p)}return null}function L(E,I,P){switch(I){case N.LogLevel.Trace:E.trace(P);break;case N.LogLevel.Debug:E.debug(P);break;case N.LogLevel.Info:E.info(P);break;case N.LogLevel.Warning:E.warn(P);break;case N.LogLevel.Error:E.error(P);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function $(E,I){switch(I){case N.LogLevel.Trace:E.setLevel(A.Trace);break;case N.LogLevel.Debug:E.setLevel(A.Debug);break;case N.LogLevel.Info:E.setLevel(A.Info);break;case N.LogLevel.Warning:E.setLevel(A.Warning);break;case N.LogLevel.Error:E.setLevel(A.Error);break;case N.LogLevel.Off:E.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class m extends N.$9j{constructor(I,P,b,k,p){super(),this.m=[],this.setLevel(p),this.n=this.s(I,P,b,k),this.B(this.onDidChangeLogLevel(h=>{this.r&&$(this.r,h)}))}async s(I,P,b,k){const p=b?6:1,h=30/p*a.$yl.MB,g=await R(I,P,h,p,k);if(g){this.r=g,$(this.r,this.getLevel());for(const{level:u,message:n}of this.m)L(this.r,u,n);this.m=[]}}g(I,P){this.r?L(this.r,I,P):this.getLevel()<=I&&this.m.push({level:I,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$LQ=m}),define(ke[140],Se([1,0,42,219,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(m){function E(p,h){return h-p}m.compare=E;const I=Object.create(null);I[m.Error]=(0,N.localize)(0,null),I[m.Warning]=(0,N.localize)(1,null),I[m.Info]=(0,N.localize)(2,null);function P(p){return I[p]||""}m.toString=P;function b(p){switch(p){case a.default.Error:return m.Error;case a.default.Warning:return m.Warning;case a.default.Info:return m.Info;case a.default.Ignore:return m.Hint}}m.fromSeverity=b;function k(p){switch(p){case m.Error:return a.default.Error;case m.Warning:return a.default.Warning;case m.Info:return a.default.Info;case m.Hint:return a.default.Ignore}}m.toSeverity=k}(L||(e.MarkerSeverity=L={}));var $;(function(m){const E="";function I(b){return P(b,!0)}m.makeKey=I;function P(b,k){const p=[E];return b.source?p.push(b.source.replace("\xA6","\\\xA6")):p.push(E),b.code?typeof b.code=="string"?p.push(b.code.replace("\xA6","\\\xA6")):p.push(b.code.value.replace("\xA6","\\\xA6")):p.push(E),b.severity!==void 0&&b.severity!==null?p.push(L.toString(b.severity)):p.push(E),b.message&&k?p.push(b.message.replace("\xA6","\\\xA6")):p.push(E),b.startLineNumber!==void 0&&b.startLineNumber!==null?p.push(b.startLineNumber.toString()):p.push(E),b.startColumn!==void 0&&b.startColumn!==null?p.push(b.startColumn.toString()):p.push(E),b.endLineNumber!==void 0&&b.endLineNumber!==null?p.push(b.endLineNumber.toString()):p.push(E),b.endColumn!==void 0&&b.endColumn!==null?p.push(b.endColumn.toString()):p.push(E),p.push(E),p.join("\xA6")}m.makeKeyOptionalMessage=P})($||(e.IMarkerData=$={})),e.$8t=(0,A.$wi)("markerService")}),define(ke[268],Se([1,0,4,42,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$$v=e.Severity=void 0,e.$_v=$,e.Severity=N.default,e.$$v=(0,A.$wi)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function $(P){if(P){const b=P;return typeof b.id=="string"&&typeof b.label=="string"}return!1}var m;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new I,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.$aw=E;class I{infinite(){}done(){}total(b){}worked(b){}}e.$bw=I}),define(ke[269],Se([1,0,50]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,a.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}Object.assign(N,{extensionsGallery:a.env.EXTENSIONS_GALLERY?JSON.parse(a.env.EXTENSIONS_GALLERY):N.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:a.env.CS_TELEMETRY_URL||N.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else N={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.89.0",sha256:"2abd9c01f711c0d60d40b722b5bed0930701be173931f3c6251906f692858221",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.89.0",commit:"0f4791b816c184b612df3bdcfc4e1f9f1a13daca",date:"2024-05-07T19:36:19.411Z"},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[108],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,a.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var Ue=this&&this.__param||function(ie,e){return function(a,N){e(a,N,ie)}};define(ke[109],Se([1,0,7,22,3,5]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.ProgressLocation=e.$cw=void 0,e.$cw=(0,R.$wi)("progressService");var L;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$dw=Object.freeze({total(){},worked(){},done(){}});class ${get value(){return this.a}constructor(b){this.b=b}report(b){this.a=b,this.b(this.a)}}e.$ew=$,$.None=Object.freeze({report(){}});class m{get value(){return this.a}constructor(b){this.e=b}report(b){this.b?this.b.push(b):this.b=[b],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const b=this.b.shift();this.a=b,await this.e(this.a)}}finally{this.c=!1;const b=this.d;this.d=void 0,b?.()}}drain(){return this.c?new Promise(b=>{const k=this.d;this.d=()=>{k?.(),b()}}):Promise.resolve()}}e.$fw=m;let E=class extends A.$Vc{constructor(b,k){super(),this.a=new a.$Th,k.withProgress(b,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,A.$Tc)(()=>this.a.complete()))}report(b){this.b?this.b.report(b):this.c=b}};e.$gw=E,e.$gw=E=Je([Ue(1,e.$cw)],E);class I extends A.$Vc{constructor(b){super(),this.g=b,this.a=0,this.b=this.B(new A.$Uc)}start(b){this.stop();const k=++this.a,p=new N.$pe;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},b),this.b.add((0,A.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Tc)(()=>p.cancel())),this.b.add((0,A.$Tc)(()=>this.c?this.c.done():void 0)),{id:k,token:p.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(b){this.a===b&&this.b.clear()}}e.$hw=I,e.$iw=(0,R.$wi)("editorProgressService")}),define(ke[36],Se([1,0,62,18]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0;class A{constructor(){this.a=new Map}add(L,$){a.ok(N.$9f(L)),a.ok(N.$$f($)),a.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,$)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$do=new A}),define(ke[110],Se([1,0,4,36]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=void 0,e.$eo={JSONContribution:"base.contributions.json"};function A($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class R{constructor(){this.b=new a.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[A(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;N.$do.add(e.$eo.JSONContribution,L)}),define(ke[66],Se([1,0,19,4,18,208,55,110,36]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.ConfigurationScope=e.$io=e.EditPresentationTypes=void 0,e.$to=h,e.$uo=g,e.$vo=u,e.$wo=i,e.$xo=d;var E;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$io={Configuration:"base.contributions.configuration"};var I;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po="vscode://schemas/settings/resourceLanguage",e.$qo="vscode://schemas/settings/configurationDefaults";const P=m.$do.as($.$eo.JSONContribution);class b{constructor(){this.h=new Set,this.i=new N.$ee,this.onDidSchemaChange=this.i.event,this.j=new N.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$po,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),P.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),P.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),P.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:c,source:s}of t)for(const v in c)if(l.add(v),e.$so.test(v)){const f=this.a.get(v),y=f?.valuesSources??new Map;if(s)for(const C of Object.keys(c[v]))y.set(C,s);const w={...f?.value||{},...c[v]};this.a.set(v,{source:s,value:w,valuesSources:y});const D=(0,L.$aj)(v),S={type:"object",default:w,description:R.localize(1,null,D),$ref:e.$po,defaultDefaultValue:w,source:A.$9f(s)?void 0:s,defaultValueSource:s};r.push(...h(v)),this.d[v]=S,this.b.properties[v]=S}else{this.a.set(v,{value:c[v],source:s});const f=this.d[v];f&&(this.w(v,f),this.r(v,f))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:c}of t)for(const s in r){const v=this.a.get(s),f=A.$9f(c)?c:c?.id,y=A.$9f(v?.source)?v?.source:v?.source?.id;if(f===y)if(l.add(s),this.a.delete(s),e.$so.test(s))delete this.d[s],delete this.b.properties[s];else{const w=this.d[s];w&&(this.w(s,w),this.r(s,w))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(c=>{this.p(c,l,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(t,l){const r=c=>{if(c.properties)for(const s in c.properties){l.add(s);const v=this.d[s];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[s],this.s(s,c.properties[s])}c.allOf?.forEach(s=>r(s))};for(const c of t){r(c);const s=this.c.indexOf(c);s!==-1&&this.c.splice(s,1)}}p(t,l=!0,r,c,s=3,v){s=A.$fg(t.scope)?s:t.scope;const f=t.properties;if(f)for(const w in f){const D=f[w];if(l&&i(w,D)){delete f[w];continue}if(D.source=r,D.defaultDefaultValue=f[w].default,this.w(w,D),e.$so.test(w)?D.scope=void 0:(D.scope=A.$fg(D.scope)?s:D.scope,D.restricted=A.$fg(D.restricted)?!!c?.includes(w):D.restricted),f[w].hasOwnProperty("included")&&!f[w].included){this.f[w]=f[w],delete f[w];continue}else this.d[w]=f[w],f[w].policy?.name&&this.e.set(f[w].policy.name,w);!f[w].deprecationMessage&&f[w].markdownDeprecationMessage&&(f[w].deprecationMessage=f[w].markdownDeprecationMessage),v.add(w)}const y=t.allOf;if(y)for(const w of y)this.p(w,l,r,c,s,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const c=r.properties;if(c)for(const v in c)this.r(v,c[v]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$jo.properties[t]=l,l.scope){case 1:e.$ko.properties[t]=l;break;case 2:e.$lo.properties[t]=l;break;case 6:e.$mo.properties[t]=l;break;case 3:e.$no.properties[t]=l;break;case 4:e.$oo.properties[t]=l;break;case 5:e.$oo.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$jo.properties[t],l.scope){case 1:delete e.$ko.properties[t];break;case 2:delete e.$lo.properties[t];break;case 6:delete e.$mo.properties[t];break;case 3:delete e.$no.properties[t];break;case 4:case 5:delete e.$oo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$po};this.w(l,r),e.$jo.properties[l]=r,e.$ko.properties[l]=r,e.$lo.properties[l]=r,e.$mo.properties[l]=r,e.$no.properties[l]=r,e.$oo.properties[l]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$po};e.$jo.patternProperties[e.$ro]=t,e.$ko.patternProperties[e.$ro]=t,e.$lo.patternProperties[e.$ro]=t,e.$mo.patternProperties[e.$ro]=t,e.$no.patternProperties[e.$ro]=t,e.$oo.patternProperties[e.$ro]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let c=r?.value,s=r?.source;A.$dg(c)&&(c=l.defaultDefaultValue,s=void 0),A.$dg(c)&&(c=u(l.type)),l.default=c,l.defaultValueSource=s}}const k="\\[([^\\]]+)\\]",p=new RegExp(k,"g");e.$ro=`^(${k})+$`,e.$so=new RegExp(e.$ro);function h(o){const t=[];if(e.$so.test(o)){let l=p.exec(o);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=p.exec(o)}}return(0,a.$Mb)(t)}function g(o){return o.reduce((t,l)=>`${t}[${l}]`,"")}function u(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new b;m.$do.add(e.$io.Configuration,n);function i(o,t){return o.trim()?e.$so.test(o)?R.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function d(){const o=[],t=n.getConfigurationProperties();for(const l of Object.keys(t))o.push([l,t[l].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[270],Se([1,0,19,4,167,3,27,24,18,2,55,66,36]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$Co=i;function k(l){return Object.isFrozen(l)?l:$.$5n(l)}class p{static createEmptyModel(r){return new p({},[],[],void 0,r)}constructor(r,c,s,v,f){this.b=r,this.c=c,this.d=s,this.raw=v,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof p)return c;const s=new h("",this.f);return s.parseRaw(c),s.configurationModel});this.g=r.reduce((c,s)=>s===c?s:c.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,I.$$i)(this.contents,r):this.contents}inspect(r,c){const s=this;return{get value(){return k(s.rawConfiguration.getValue(r))},get override(){return c?k(s.rawConfiguration.getOverrideValue(r,c)):void 0},get merged(){return k(c?s.rawConfiguration.override(c).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const v=[];for(const{contents:f,identifiers:y,keys:w}of s.rawConfiguration.overrides){const D=new p(f,w,[],void 0,s.f).getValue(r);D!==void 0&&v.push({identifiers:y,value:D})}return v.length?k(v):void 0}}}getOverrideValue(r,c){const s=this.j(c);return s?r?(0,I.$$i)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const s of this.overrides)s.identifiers.includes(r)&&c.push(...s.keys);return a.$Mb(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return a.$Mb(r)}override(r){let c=this.a.get(r);return c||(c=this.h(r),this.a.set(r,c)),c}merge(...r){const c=$.$4n(this.contents),s=$.$4n(this.overrides),v=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const y of r)if(f.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(c,y.contents);for(const w of y.overrides){const[D]=s.filter(S=>a.$ub(S.identifiers,w.identifiers));D?(this.i(D.contents,w.contents),D.keys.push(...w.keys),D.keys=a.$Mb(D.keys)):s.push($.$4n(w))}for(const w of y.keys)v.indexOf(w)===-1&&v.push(w)}return new p(c,v,s,f.every(y=>y instanceof p)?void 0:f,this.f)}h(r){const c=this.j(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const s={};for(const v of a.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let f=this.contents[v];const y=c[v];y&&(typeof f=="object"&&typeof y=="object"?(f=$.$4n(f),this.i(f,y)):f=y),s[v]=f}return new p(s,this.keys,this.overrides,void 0,this.f)}i(r,c){for(const s of Object.keys(c)){if(s in r&&m.$$f(r[s])&&m.$$f(c[s])){this.i(r[s],c[s]);continue}r[s]=$.$4n(c[s])}}j(r){let c=null,s=null;const v=f=>{f&&(s?this.i(s,f):s=$.$4n(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===r?c=f.contents:f.identifiers.includes(r)&&v(f.contents);return v(c),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.k(r,c,!0)}setValue(r,c){this.k(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,I.$0i)(this.contents,r),P.$so.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>a.$ub(s.identifiers,(0,P.$to)(r))),1))}k(r,c,s){(0,I.$9i)(this.contents,r,c,v=>this.f.error(v)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),P.$so.test(r)&&this.overrides.push({identifiers:(0,P.$to)(r),keys:Object.keys(this.contents[r]),contents:(0,I.$8i)(this.contents[r],v=>this.f.error(v))})}}e.$yo=p;class h{constructor(r,c){this.f=r,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!m.$fg(r)){const s=this.h(r);this.parseRaw(s,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:s,keys:v,overrides:f,restricted:y,hasExcludedProperties:w}=this.i(r,c);this.b=new p(s,v,f,w?[r]:void 0,this.g),this.c=y||[]}h(r){let c={},s=null,v=[];const f=[],y=[];function w(S){Array.isArray(v)?v.push(S):s!==null&&(v[s]=S)}const D={onObjectBegin:()=>{const S={};w(S),f.push(v),v=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{v=f.pop()},onArrayBegin:()=>{const S=[];w(S),f.push(v),v=S,s=null},onArrayEnd:()=>{v=f.pop()},onLiteralValue:w,onError:(S,C,j)=>{y.push({error:S,offset:C,length:j})}};if(r)try{A.$Rn(r,D),c=v[0]||{}}catch(S){this.g.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return c}i(r,c){const s=b.$do.as(P.$io.Configuration).getConfigurationProperties(),v=this.j(r,s,!0,c);r=v.raw;const f=(0,I.$8i)(r,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),y=Object.keys(r),w=this.l(r,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:f,keys:y,overrides:w,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}j(r,c,s,v){let f=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:f};const y={},w=[];for(const D in r)if(P.$so.test(D)&&s){const S=this.j(r[D],c,!1,v);y[D]=S.raw,f=f||S.hasExcludedProperties,w.push(...S.restricted)}else{const S=c[D],C=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&w.push(D),!v.exclude?.includes(D)&&(v.include?.includes(D)||(C===void 0||v.scopes===void 0||v.scopes.includes(C))&&!(v.skipRestricted&&S?.restricted))?y[D]=r[D]:f=!0}return{raw:y,restricted:w,hasExcludedProperties:f}}l(r,c){const s=[];for(const v of Object.keys(r))if(P.$so.test(v)){const f={};for(const y in r[v])f[y]=r[v][y];s.push({identifiers:(0,P.$to)(v),keys:Object.keys(f),contents:(0,I.$8i)(f,c)})}return s}}e.$zo=h;class g extends R.$Vc{constructor(r,c,s,v,f){super(),this.c=r,this.f=c,this.g=v,this.h=f,this.b=this.B(new N.$ee),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),f),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&s.isEqual(y.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ao=g;class u{constructor(r,c,s,v,f,y,w,D,S,C,j,B,z){this.a=r,this.b=c,this.c=s,this.overrideIdentifiers=v,this.d=f,this.f=y,this.g=w,this.h=D,this.i=S,this.j=C,this.k=j,this.l=B,this.m=z}get value(){return k(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,c,s,v,f,y,w,D,S,C){this.j=r,this.l=c,this.m=s,this.n=v,this.p=f,this.q=y,this.r=w,this.s=D,this.t=S,this.u=C,this.h=null,this.i=new L.$Bc,this.v=null}getValue(r,c,s){return this.w(r,c,s).getValue(r)}updateValue(r,c,s={}){let v;s.resource?(v=this.t.get(s.resource),v||(v=p.createEmptyModel(this.u),this.t.set(s.resource,v))):v=this.s,c===void 0?v.removeValue(r):v.setValue(r,c),s.resource||(this.h=null)}inspect(r,c,s){const v=this.w(r,c,s),f=this.A(c.resource,s),y=c.resource?this.t.get(c.resource)||this.s:this.s,w=new Set;for(const D of v.overrides)for(const S of D.identifiers)v.getOverrideValue(r,S)!==void 0&&w.add(S);return new u(r,c,v.getValue(r),w.size?[...w]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,f||void 0,y)}keys(r){const c=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,c){this.r.set(r,c),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const s=[];if(!c){const{added:v,updated:f,removed:y}=o(this.j,r);c=[...v,...f,...y]}for(const v of c)for(const f of(0,P.$to)(v)){const y=this.j.getKeysForOverrideIdentifier(f),w=r.getKeysForOverrideIdentifier(f),D=[...w.filter(S=>y.indexOf(S)===-1),...y.filter(S=>w.indexOf(S)===-1),...y.filter(S=>!$.$8n(this.j.override(f).getValue(S),r.override(f).getValue(S)))];s.push([f,D])}return this.updateDefaultConfiguration(r),{keys:c,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:s,removed:v}=o(this.l,r),f=[...c,...s,...v];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.applicationConfiguration,r),y=[...c,...s,...v];return y.length&&this.updateApplicationConfiguration(r),{keys:y,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.localUserConfiguration,r),y=[...c,...s,...v];return y.length&&this.updateLocalUserConfiguration(r),{keys:y,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.remoteUserConfiguration,r),y=[...c,...s,...v];return y.length&&this.updateRemoteUserConfiguration(r),{keys:y,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.workspaceConfiguration,r),y=[...c,...s,...v];return y.length&&this.updateWorkspaceConfiguration(r),{keys:y,overrides:f}}compareAndUpdateFolderConfiguration(r,c){const s=this.folderConfigurations.get(r),{added:v,updated:f,removed:y,overrides:w}=o(s,c),D=[...v,...f,...y];return(D.length||!s)&&this.updateFolderConfiguration(r,c),{keys:D,overrides:w}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:v,removed:f,overrides:y}=o(c,void 0);return{keys:[...s,...v,...f],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,c,s){let v=this.x(c,s);return c.overrideIdentifier&&(v=v.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(v=v.merge(this.l)),v}x({resource:r},c){let s=this.y();if(c&&r){const v=c.getFolder(r);v&&(s=this.z(v.uri)||s);const f=this.t.get(r);f&&(s=s.merge(f))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let c=this.i.get(r);if(!c){const s=this.y(),v=this.r.get(r);v?(c=s.merge(v),this.i.set(r,c)):c=s}return c}A(r,c){if(c&&r){const s=c.getFolder(r);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,c)=>{const{contents:s,overrides:v,keys:f}=this.r.get(c);return r.push([c,{contents:s,overrides:v,keys:f}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.q.keys.forEach(c=>r.add(c)),this.r.forEach(c=>c.keys.forEach(s=>r.add(s))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}D(r){const c=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.q.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(v=>c.add(v))),[...c.values()]}static parse(r,c){const s=this.E(r.defaults,c),v=this.E(r.policy,c),f=this.E(r.application,c),y=this.E(r.user,c),w=this.E(r.workspace,c),D=r.folders.reduce((S,C)=>(S.set(E.URI.revive(C[0]),this.E(C[1],c)),S),new L.$Bc);return new n(s,v,f,y,p.createEmptyModel(c),w,D,p.createEmptyModel(c),new L.$Bc,c)}static E(r,c){return new p(r.contents,r.keys,r.overrides,void 0,c)}}e.$Bo=n;function i(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,c=new Map;for(const v of l)v.keys.forEach(f=>r.add(f)),v.overrides.forEach(([f,y])=>{const w=(0,L.$yc)(c,f,new Set);y.forEach(D=>w.add(D))});const s=[];return c.forEach((v,f)=>s.push([f,[...v.values()]])),{keys:[...r.values()],overrides:s}}class d{constructor(r,c,s,v,f){this.change=r,this.f=c,this.g=s,this.h=v,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of r.keys)this.affectedKeys.add(y);for(const[,y]of r.overrides)for(const w of y)this.affectedKeys.add(w);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,c){const s=this.a+r,v=this.d.indexOf(s);if(v<0)return!1;const f=v+s.length;if(f>=this.d.length)return!1;const y=this.d.charCodeAt(f);if(y!==this.b&&y!==this.c)return!1;if(c){const w=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,D=this.g.getValue(r,c,this.h);return!$.$8n(w,D)}return!0}}e.$Do=d;function o(l,r){const{added:c,removed:s,updated:v}=t(r?.rawConfiguration,l?.rawConfiguration),f=[],y=l?.getAllOverrideIdentifiers()||[],w=r?.getAllOverrideIdentifiers()||[];if(r){const D=w.filter(S=>!y.includes(S));for(const S of D)f.push([S,r.getKeysForOverrideIdentifier(S)])}if(l){const D=y.filter(S=>!w.includes(S));for(const S of D)f.push([S,l.getKeysForOverrideIdentifier(S)])}if(r&&l){for(const D of y)if(w.includes(D)){const S=t({contents:l.getOverrideValue(void 0,D)||{},keys:l.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});f.push([D,[...S.added,...S.removed,...S.updated]])}}return{added:c,removed:s,updated:v,overrides:f}}function t(l,r){const c=l?r?l.keys.filter(f=>r.keys.indexOf(f)===-1):[...l.keys]:[],s=r?l?r.keys.filter(f=>l.keys.indexOf(f)===-1):[...r.keys]:[],v=[];if(l&&r){for(const f of r.keys)if(l.keys.indexOf(f)!==-1){const y=(0,I.$$i)(r.contents,f),w=(0,I.$$i)(l.contents,f);$.$8n(y,w)||v.push(f)}}return{added:c,removed:s,updated:v}}}),define(ke[271],Se([1,0,21,4,3,82]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Avb=e.$yvb=e.$xvb=void 0,e.$zvb=$;const L=(E,I,P)=>{const b=new Uint8Array(16);for(let h=0;h<16;h++)b[h]=Math.round(Math.random()*256);const k=(0,a.$1e)(a.$Ge.wrap(b));return[`GET ws://localhost${E}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$xvb=L,e.$yvb=a.$Ge.fromString(`\r
\r
`);async function $(E,I,P,b,k){E.write(a.$Ge.fromString((0,e.$xvb)(I,P,b)));const p=new A.$Uc;try{return await new Promise((h,g)=>{let u;p.add(E.onData(n=>{u?u=a.$Ge.concat([u,n],u.byteLength+n.byteLength):u=n;const i=u.indexOf(e.$yvb);if(i===-1)return;h(E),E.pauseData();const d=u.slice(i+e.$yvb.byteLength);d.byteLength&&k.onData.fire(d)})),p.add(E.onClose(n=>g(n??new Error("socket closed")))),p.add(E.onEnd(()=>g(new Error("socket ended"))))})}catch(h){throw E.dispose(),h}finally{p.dispose()}}class m extends A.$Vc{constructor(I,P){super(),this.g=I,this.a=this.B(new N.$he),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new N.$ee),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(b=>this.a.fire(b))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Avb=m}),define(ke[67],Se([1,0,13,5]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=E,e.$Hl=(0,N.$wi)("remoteAuthorityResolverService");var A;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=R;class L{constructor(P,b){this.host=P,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=L;var $;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class m extends a.$bb{static isNotAvailable(P){return P instanceof m&&P._code===$.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof m&&P._code===$.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof m&&P._code===$.NoResolverFound}static isInvalidAuthority(P){return P instanceof m&&P._code===$.InvalidAuthority}static isHandled(P){return P instanceof m&&P.isHandled}constructor(P,b=$.Unknown,k){super(P),this._message=P,this._code=b,this._detail=k,this.isHandled=b===$.NotAvailable&&k===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Kl=m;function E(I){const P=I.indexOf("+");return P===-1?I:I.substring(0,P)}}),define(ke[272],Se([1,0,7,21,22,13,4,3,15,59,41,31,82,67]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=y,e.$Rl=w,e.$Sl=S;const p=30*1e3;var h;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function g(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(_){const U=new A.$pe;return setTimeout(()=>U.cancel(),_),U.token}function n(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return A.CancellationToken.Cancelled;const le=new A.$pe;return _.onCancellationRequested(()=>le.cancel()),U.onCancellationRequested(()=>le.cancel()),le.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new $.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,a.$ph)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function d(_,U){const le=new i(U);return le.registerDisposable(_.onControlMessage(De=>{const $e=JSON.parse(De.toString()),re=J($e);re?le.reject(re):le.resolve($e)})),le.promise}function o(_,U,le,De,$e,re,se,oe){const K=new i(oe),te=I.$ae.create(!1);return _.info(`Creating a socket (${se})...`),E.mark(`code/willCreateSocket/${re}`),U.connect(le,De,$e,se).then(ge=>{K.didTimeout?(E.mark(`code/didCreateSocketError/${re}`),_.info(`Creating a socket (${se}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(E.mark(`code/didCreateSocketOK/${re}`),_.info(`Creating a socket (${se}) was successful after ${te.elapsed()} ms.`),K.resolve(ge))},ge=>{E.mark(`code/didCreateSocketError/${re}`),_.info(`Creating a socket (${se}) returned an error after ${te.elapsed()} ms.`),_.error(ge),K.reject(ge)}),K.promise}function t(_,U){const le=new i(U);return _.then(De=>{le.didTimeout||le.resolve(De)},De=>{le.didTimeout||le.reject(De)}),le.promise}async function l(_,U,le,De){const $e=ce(_,U);_.logService.trace(`${$e} 1/6. invoking socketFactory.connect().`);let re;try{re=await o(_.logService,_.remoteSocketFactoryService,_.connectTo,m.$Jg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,g(U),`renderer-${g(U)}-${_.reconnectionToken}`,De)}catch(ge){throw _.logService.error(`${$e} socketFactory.connect() failed or timed out. Error:`),_.logService.error(ge),ge}_.logService.trace(`${$e} 2/6. socketFactory.connect() was successful.`);let se,oe;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(re,null),se=_.reconnectionProtocol,oe=!1):(se=new b.$ki({socket:re}),oe=!0),_.logService.trace(`${$e} 3/6. sending AuthRequest control message.`);const K=await t(_.signService.createNewMessage((0,P.$Sg)()),De),te={type:"auth",auth:_.connectionToken||"00000000000000000000",data:K.data};se.sendControl(N.$Ge.fromString(JSON.stringify(te)));try{const ge=await d(se,n(De,u(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(_.logService.trace(`${$e} 4/6. received SignRequest control message.`),!await t(_.signService.validate(K,ge.signedData),De)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Re=await t(_.signService.sign(ge.data),De),pe={type:"connectionType",commit:_.commit,signedData:Re,desiredConnectionType:U};return le&&(pe.args=le),_.logService.trace(`${$e} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(N.$Ge.fromString(JSON.stringify(pe))),{protocol:se,ownsProtocol:oe}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(_.logService.error(`${$e} the handshake timed out. Error:`),_.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${$e} received error control message when negotiating connection. Error:`),_.logService.error(ge)),oe&&V(se),ge}}async function r(_,U,le,De){const $e=Date.now(),re=ce(_,U),{protocol:se,ownsProtocol:oe}=await l(_,U,le,De),K=new i(De);return K.registerDisposable(se.onControlMessage(te=>{const ge=JSON.parse(te.toString()),be=J(ge);be?(_.logService.error(`${re} received error control message when negotiating connection. Error:`),_.logService.error(be),oe&&V(se),K.reject(be)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${ve($e)}!`),K.resolve({protocol:se,firstMessage:ge}))})),K.promise}async function c(_,U){const{protocol:le}=await r(_,1,void 0,U);return{protocol:le}}async function s(_,U,le){const{protocol:De,firstMessage:$e}=await r(_,2,U,le),re=$e&&$e.debugPort;return{protocol:De,debugPort:re}}async function v(_,U,le){const De=Date.now(),$e=ce(_,3),{protocol:re}=await l(_,3,U,le);return _.logService.trace(`${$e} 6/6. handshake finished, connection is up and running after ${ve(De)}!`),re}async function f(_,U,le){const{connectTo:De,connectionToken:$e}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:De,connectionToken:$e,reconnectionToken:U,reconnectionProtocol:le,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function y(_,U,le){return D(_,async De=>{const{protocol:$e}=await c(De,A.CancellationToken.None);return new q(_,U,le,De.reconnectionToken,$e)})}async function w(_,U){return D(_,async le=>{const{protocol:De,debugPort:$e}=await s(le,U,A.CancellationToken.None);return new Y(_,U,le.reconnectionToken,De,$e)})}async function D(_,U){for(let De=1;;De++)try{const $e=(0,P.$Sg)(),re=await f(_,$e,null);return await U(re)}catch($e){if(De<5)_.logService.error(`[remote-connection][attempt ${De}] An error occurred in initial connection! Will retry... Error:`),_.logService.error($e);else throw _.logService.error(`[remote-connection][attempt ${De}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error($e),O.triggerPermanentFailure(0,0,k.$Kl.isHandled($e)),$e}}async function S(_,U,le){const De=await f(_,(0,P.$Sg)(),null);return await v(De,{host:U,port:le},A.CancellationToken.None)}function C(_){return(0,a.$jh)(U=>new Promise((le,De)=>{const $e=setTimeout(le,_*1e3);U.onCancellationRequested(()=>{clearTimeout($e),le()})}))}var j;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class B{constructor(U,le){this.reconnectionToken=U,this.millisSinceLastIncomingData=le,this.type=0}}e.$Tl=B;class z{constructor(U,le,De,$e){this.reconnectionToken=U,this.millisSinceLastIncomingData=le,this.durationSeconds=De,this.c=$e,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=z;class T{constructor(U,le,De){this.reconnectionToken=U,this.millisSinceLastIncomingData=le,this.attempt=De,this.type=2}}e.$Vl=T;class M{constructor(U,le,De){this.reconnectionToken=U,this.millisSinceLastIncomingData=le,this.attempt=De,this.type=4}}e.$Wl=M;class F{constructor(U,le,De,$e){this.reconnectionToken=U,this.millisSinceLastIncomingData=le,this.attempt=De,this.handled=$e,this.type=3}}e.$Xl=F;class O extends $.$Vc{static triggerPermanentFailure(U,le,De){this._permanentFailure=!0,this.f=U,this.g=le,this.h=De,this.j.forEach($e=>$e.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}get n(){return this.c||O._permanentFailure}constructor(U,le,De,$e,re){super(),this.t=U,this.u=le,this.reconnectionToken=De,this.protocol=$e,this.w=re,this.m=this.B(new L.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B($e.onSocketClose(se=>{const oe=de(this.t,this.reconnectionToken,!0);se?se.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${se.hadError}).`),se.error&&this.u.logService.error(se.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.u.logService.error(se.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B($e.onSocketTimeout(se=>{const oe=de(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.y()})),O.j.push(this),this.B((0,$.$Tc)(()=>{const se=O.j.indexOf(this);se>=0&&O.j.splice(se,1)})),this.n&&this.D(O.f,O.g,O.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=de(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const le=[0,5,5,10,10,10,10,10,30];let De=-1;do{De++;const $e=De<le.length?le[De]:le[le.length-1];try{if($e>0){const se=C($e);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$e,se)),this.u.logService.info(`${U} waiting for ${$e} seconds before reconnecting...`);try{await se}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),De+1)),this.u.logService.info(`${U} resolving connection...`);const re=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${re.connectTo}...`),await this.G(re,u(p)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),De+1));break}catch(re){if(re.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),De+1,!1);break}if(De>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),De+1,!1);break}if(k.$Kl.isTemporarilyNotAvailable(re)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if((re.code==="ETIMEDOUT"||re.code==="ENETUNREACH"||re.code==="ECONNREFUSED"||re.code==="ECONNRESET")&&re.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if((0,R.$4)(re)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if(re instanceof k.$Kl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),De+1,k.$Kl.isHandled(re));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),De+1,!1);break}}while(!this.n&&!this.s)}C(U,le,De){this.w?O.triggerPermanentFailure(U,le,De):this.D(U,le,De)}D(U,le,De){this.m.fire(new F(this.reconnectionToken,U,le,De)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=O,O._permanentFailure=!1,O.f=0,O.g=0,O.h=!1,O.j=[];class q extends O{constructor(U,le,De,$e,re){super(1,U,$e,re,!0),this.client=this.B(new b.$ii(re,{remoteAuthority:le,clientId:De},U.ipcLogger))}async G(U,le){await c(U,le)}}e.$Zl=q;class Y extends O{constructor(U,le,De,$e,re){super(2,U,De,$e,!1),this.H=le,this.debugPort=re}async G(U,le){await s(U,this.H,le)}}e.$1l=Y;function V(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function J(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(_,U){for(;_.length<U;)_+=" ";return _}function ne(_,U){return`[remote-connection][${x(g(_),13)}][${U.substr(0,5)}\u2026]`}function de(_,U,le){return`${ne(_,U)}[${le?"reconnect":"initial"}]`}function ce(_,U){return`${de(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function ve(_){return`${Date.now()-_} ms`}}),define(ke[86],Se([1,0,15]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=N,e.$Jm=A,e.$Km=R,e.$Lm=L;function N(m){return m.scheme===a.Schemas.vscodeRemote?m.authority:void 0}function A(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function R(m){const{host:E,port:I}=$(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:I}}function L(m,E){let{host:I,port:P}=$(m);return typeof P>"u"&&(P=E),{host:I,port:P}}function $(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const P=m.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:m,port:void 0}}}),define(ke[25],Se([1,0,14,5,86]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Um=e.$Tm=e.$Sm=e.TargetPlatform=e.ExtensionType=e.$Rm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0,e.$Qm=R,e.$Vm=P,e.$Wm=b,e.$Xm=k,e.$Ym=p,e.$Mm="extensions.user.cache",e.$Nm="extensions.builtin.cache",e.$Om="undefined_publisher",e.$Pm=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Rm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var $;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class m{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,u){if(typeof g>"u"||g===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof g=="string"||typeof u=="string"){const n=typeof g=="string"?g:g.value,i=typeof u=="string"?u:u.value;return a.$yf(n,i)}return g._lower===u._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Sm=m;class E{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const u of g)this.add(u)}add(g){this.c.add(m.toKey(g))}delete(g){return this.c.delete(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}}e.$Tm=E;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(m.toKey(g))}get(g){return this.c.get(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}set(g,u){this.c.set(m.toKey(g),u)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Um=I;function P(h){return b(h)}function b(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function k(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function p(h,g){if(g){const u=`onResolveRemoteAuthority:${(0,A.$Jm)(g)}`;return!!h.activationEvents?.includes(u)}return!1}e.$Zm=(0,N.$wi)("IBuiltinExtensionsScannerService")}),define(ke[141],Se([1,0,13,25]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(L,$){this.a.set(L,$)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const $=Object.create(null);for(const m of L){const E=this.readActivationEvents(m);E.length>0&&($[N.$Sm.toKey(m.identifier)]=E)}return $}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const $=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let m=0;m<$.length;m++)$[m]==="onUri"&&($[m]=`onUri:${N.$Sm.toKey(L.identifier)}`);if(!L.contributes)return $;for(const m in L.contributes){const E=this.a.get(m);if(!E)continue;const I=L.contributes[m],P=Array.isArray(I)?I:[I];try{E(P,$)}catch(b){(0,a.$1)(b)}}return $}}e.$tG=A,e.$uG=new A}),define(ke[273],Se([1,0,3,5]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,N.$wi)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(L,$){var m;return(m=this.a)[L]??(m[L]=[]),this.a[L].push($),(0,a.$Tc)(()=>{const E=this.a[L]?.indexOf($);typeof E=="number"&&E>=0&&this.a[L]?.splice(E,1)})}b(L){return(this.a[L.type]||[]).find(m=>m.supports(L))}connect(L,$,m,E){const I=this.b(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,$,m,E)}}e.$Nl=A}),define(ke[274],Se([1,0,21,13,3,220,66,5,11,36]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0,e.$Qp=b,e.$Rp=k,e.$Sp=p,e.$Tp=h,e.$Up=g,e.$Vp=u,e.$Op=(0,$.$wi)("requestService");class I{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.b[t];this.a=o}return this.a}}class P extends A.$Vc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,R.localize)(0,null),when:m.$ik.isEqualTo((0,m.$fk)(m.LogLevel.Trace)).serialize()})}async c(o,t,l){const r=`${o} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new I(t.headers??{}));try{const c=await l();return this.a.trace(`${r} - end`,t.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.a.error(`${r} - error`,t.type,(0,N.$0)(c)),c}}}e.$Pp=P;function b(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function k(d){return d.res.statusCode===204}async function p(d){return k(d)?null:(await(0,a.$Se)(d.stream)).toString()}async function h(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);return p(d)}async function g(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);if(k(d))return null;const t=(await(0,a.$Se)(d.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}function u(d){i(d)}let n;function i(d){const o=E.$do.as(L.$io.Configuration),t=n;n={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(ke[275],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=void 0;class a{constructor(){this.b=new Map}async createNewMessage(A){try{const R=await this.c();if(R){const L=String(a.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const L=this.b.get(A.id);if(!L)return!1;this.b.delete(A.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$T$b=a,a.a=1}),define(ke[111],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,a.$wi)(e.$Ol)}),define(ke[142],Se([1,0,275]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class N extends a.$T$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>ie(["vsda"],R,L))}}e.$Pdc=N}),define(ke[276],Se([1,0,12,50,31]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=L,e.$fp=$;function R(m){if(a.$o===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function L(m,E,I,P,b,k,p,h,g){const u=Object.create(null);u["common.machineId"]=k,u["common.sqmId"]=p,u.sessionID=(0,A.$Sg)()+Date.now(),u.commitHash=P,u.version=b,u["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,a.$b)(a.$o),u["common.nodePlatform"]=N.$ec,u["common.nodeArch"]=I,u["common.product"]=g||"desktop",h&&(u["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),a.$f&&(u["common.snap"]="true");const d=R(E);return d&&(u["common.platformDetail"]=d),u}function $(m){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const I=E.toLowerCase();return m.some(P=>I===P)}}),define(ke[277],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,a.$wi)("telemetryService"),e.$3l=(0,a.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(ke[87],Se([1,0,24,18,86,276,277]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$np=I,e.$op=P,e.$pp=b,e.$qp=k,e.$rp=h,e.$sp=u,e.$tp=n,e.$up=o;class ${constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$gp=$;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$hp=m,e.$ip=new m;class E{async publicLog(l,r,c){}async publicLogError(l,r,c){}}e.$jp=E,e.$kp="telemetry",e.$lp="extensionTelemetryLog",e.$mp={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!t.enableTelemetry)}function P(t,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function b(t){const l=t.getValue(L.$0l),r=t.getValue(L.$$l);if(t.getValue(L.$_l)===!1||r===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function k(t){const l={},r={},c={};g(t,c);for(let s in c){s=s.length>150?s.substr(s.length-149):s;const v=c[s];typeof v=="number"?r[s]=v:typeof v=="boolean"?r[s]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${v.length}`),l[s]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(l[s]=v)}return{properties:l,measurements:r}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const l=(0,A.$Jm)(t);return p.has(l)?l:"other"}function g(t,l,r=0,c){if(t)for(const s of Object.getOwnPropertyNames(t)){const v=t[s],f=c?c+s:s;Array.isArray(v)?l[f]=(0,a.$9n)(v):v instanceof Date?l[f]=v.toISOString():(0,N.$$f)(v)?r<2?g(v,l,r+1,f+"."):l[f]=(0,a.$9n)(v):l[f]=v}}function u(t,l){const r=t.msftInternalDomains||[],c=l.getValue("telemetry.internalTesting");return(0,R.$fp)(r)||c}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,l){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const c=[];for(const y of l)for(;;){const w=y.exec(t);if(!w)break;c.push([w.index,y.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const y=v.exec(t);if(!y)break;const w=c.some(([D,S])=>y.index<S&&D<v.lastIndex);!s.test(y[0])&&!w&&(r+=t.substring(f,y.index)+"<REDACTED: user-file-path>",f=v.lastIndex)}return f<t.length&&(r+=t.substr(f)),r}function d(t){if(!t)return t;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of l)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,l){return(0,a.$6n)(t,r=>{if(r instanceof $||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=i(c,l);for(const s of l)c=c.replace(s,"");return c=d(c),c}})}}),define(ke[278],Se([1,0,14,139,25,12,2,13,50,87]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$wp=void 0,e.$vp=I,e.$xp=p,e.$yp=h,e.$zp=g,e.$Ap=u,e.$Bp=n,e.$Cp=i,e.$Dp=d,e.$Fp=o,e.$Gp=l;function I(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,a.$tf)(r.id,c.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(c){const s=c.manifest?c.manifest.version:c.version,v=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new b(c.identifier,s,v)}static parse(c){const s=P.exec(c);return s&&s[1]&&s[2]?new b({id:s[1]},s[2],s[4]||void 0):null}constructor(c,s,v="undefined"){this.version=s,this.targetPlatform=v,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof b?I(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$wp=b;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const c=k.exec(r);return c&&c[1]?[g(c[1]),c[2]]:[g(r),void 0]}function h(r,c){return`${r}.${c}`}function g(r){return r.toLowerCase()}function u(r,c){return g(h(r??A.$Om,c))}function n(r,c){const s=[],v=f=>{for(const y of s)if(y.some(w=>I(c(w),c(f))))return y;return null};for(const f of r){const y=v(f);y?y.push(f):s.push([f])}return s}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function d(r){return{id:new E.$gp(r.identifier.id),name:new E.$gp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Ep=new A.$Sm("pprice.better-merge");function o(r,c){const s=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const f=v.shift();if(f&&s.every(y=>!I(y.identifier,{id:f}))){const y=r.filter(w=>I(w.identifier,{id:f}));y.length===1&&(s.push(y[0]),v.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,c){if(!R.$e)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){c.debug("Error while getting the os-release file.",(0,$.$0)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,c){const s=await t(r,c),v=(0,N.$3o)(s?"alpine":R.$o,m.$fc);return c.debug("ComputeTargetPlatform:",v),v}}),define(ke[279],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=a,e.$ns=N,e.$os=A,e.$ps=R,e.$qs=L,e.$rs=$;function a(m){return[...m.entries()]}function N(m){return m?[...m.entries()]:[]}function A(m){return new Map(m)}function R(m){return new Map(m??[])}function L(m){return Array.from(m.entries()).map(E=>[E[0],a(E[1].map),N(E[1].descriptionMap)])}function $(m){return new Map(m.map(E=>[E[0],{map:A(E[1]),descriptionMap:R(E[2])}]))}}),define(ke[280],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Svb=void 0;class a{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,L=5){const $=R(m=>{const E=typeof m=="string"?m:m.data;let I=this.a.get(A);if(I){I.data.push(E);return}const P=setTimeout(()=>this.flushBuffer(A),L);I={data:[E],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(A),$.dispose()}},this.a.set(A,I)});return $}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$Svb=a}),define(ke[281],Se([1,0,7,79,101,51,4,18,2,221,110,36]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nx=e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.IconFontDefinition=e.IconContribution=e.$fx=void 0,e.$gx=g,e.$hx=u,e.$fx={IconContribution:"base.contributions.icons"};var b;(function(o){function t(l,r){let c=l.defaults;for(;R.ThemeIcon.isThemeIcon(c);){const s=h.getIcon(c.id);if(!s)return;c=s.defaults}return c}o.getDefinition=t})(b||(e.IconContribution=b={}));var k;(function(o){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function l(r){const c=s=>(0,$.$9f)(s)?s:void 0;if(r&&Array.isArray(r.src)&&r.src.every(s=>(0,$.$9f)(s.format)&&(0,$.$9f)(s.location)))return{weight:c(r.weight),style:c(r.style),src:r.src.map(s=>({format:s.format,location:m.URI.parse(s.location)}))}}o.fromJSONObject=l})(k||(e.IconFontDefinition=k={}));class p{constructor(){this.a=new L.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,l,r,c){const s=this.b[t];if(s){if(r&&!s.description){s.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=r),this.a.fire()}return s}const v={id:t,description:r,defaults:l,deprecationMessage:c};this.b[t]=v;const f={$ref:"#/definitions/icons"};return c&&(f.deprecationMessage=c),r&&(f.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const l=this.e.enum.indexOf(t);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,l){const r=this.f[t];return r||(this.f[t]=l,this.a.fire(),l)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(s,v)=>s.id.localeCompare(v.id),l=s=>{for(;R.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(s=>this.b[s]);for(const s of c.filter(v=>!!v.description).sort(t))r.push(`|<i class="${l(s)}"></i>|${s.id}|${R.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const s of c.filter(v=>!R.ThemeIcon.isThemeIcon(v.defaults)).sort(t))r.push(`|<i class="${l(s)}"></i>|${s.id}|`);return r.join(`
`)}}const h=new p;P.$do.add(e.$fx.IconContribution,h);function g(o,t,l,r){return h.registerIcon(o,t,l,r)}function u(){return h}function n(){const o=(0,A.$Rj)();for(const t in o){const l="\\"+o[t].toString(16);h.registerIcon(t,{fontCharacter:l})}}n(),e.$ix="vscode://schemas/icons";const i=P.$do.as(I.$eo.JSONContribution);i.registerSchema(e.$ix,h.getIconSchema());const d=new a.$Ih(()=>i.notifySchemaChanged(e.$ix),200);h.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.$jx=g("widget-close",N.$Vj.close,(0,E.localize)(2,null)),e.$kx=g("goto-previous-location",N.$Vj.arrowUp,(0,E.localize)(3,null)),e.$lx=g("goto-next-location",N.$Vj.arrowDown,(0,E.localize)(4,null)),e.$mx=R.ThemeIcon.modify(N.$Vj.sync,"spin"),e.$nx=R.ThemeIcon.modify(N.$Vj.loading,"spin")}),define(ke[88],Se([1,0,4,2,55,5,11]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$tw=e.$qw=e.$ow=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$kw=e.$jw=void 0,e.$lw=E,e.$mw=P,e.$nw=b,e.$pw=k,e.$rw=p,e.$sw=h,e.$jw=(0,R.$wi)("tunnelService"),e.$kw=(0,R.$wi)("sharedTunnelsService");var $;(function(n){n.Http="http",n.Https="https"})($||(e.TunnelProtocol=$={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(n){return!!n.forwardPort}var I;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(I||(e.ProvidedOnAutoForward=I={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function b(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const d of i){const o=d.split("=")[1];if(/^https?:/.exec(o)){const t=P(N.URI.parse(o));if(t)return t}}}e.$ow=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(n){return e.$ow.indexOf(n)>=0}e.$qw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(n){return e.$qw.indexOf(n)>=0}function h(n,i,d,o){if(d===1)return!1;if(d===2&&p(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class g{constructor(i,d,o){this.remoteAddress=i,this.localAddress=d,this.b=o,this.a=new a.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$tw=g;let u=class{constructor(i,d){this.k=i,this.l=d,this.a=new a.$ee,this.onTunnelOpened=this.a.event,this.b=new a.$ee,this.onTunnelClosed=this.b.event,this.c=new a.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],d=Array.from(this.e.values());for(const o of d){const t=Array.from(o.values());for(const l of t){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:d}of i.values())await d.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,d,o,t,l){this.q(i,d,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:d,localAddress:o,privacy:t,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,d){(p(i)||k(i))&&(i=e.$ow[0]);const o=this.s(i,d);if(o)return++o.refcount,o.value}openTunnel(i,d,o,t,l,r=!1,c,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${o} on local port ${l}.`);const v=this.f??i;if(!v)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(v,d,o,t,l,r,c,s);return f?f.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,o),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(y);return(y.tunnelRemoteHost!==d||y.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&y.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const d=this.e.get(i.tunnelRemoteHost);if(d){const o=d.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,d,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${d}.`);const t=o.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(d),t}}async closeTunnel(i,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${d} `);const o=this.e.get(i);if(o&&o.has(d)){const t=o.get(d);t.refcount=0,await this.p(i,d,t)}}q(i,d,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(d,{refcount:1,value:o})}async r(i,d){const o=this.e.get(i);if(o){const t=o.get(d),l=t?await t.value:void 0;(!l||typeof l=="string")&&o.delete(d),o.size===0&&this.e.delete(i)}}s(i,d){const o=[i];k(i)?(o.push(...e.$ow),o.push(...e.$qw)):p(i)&&o.push(...e.$qw);const t=o.map(l=>this.e.get(l));for(const l of t){const r=l?.get(d);if(r)return r}}canTunnel(i){return!!P(i)}u(i,d,o,t,l,r,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${o} on local port ${t}.`);const s=o;this.j.add(s);const v=t===void 0?o:t,f={elevationRequired:l?this.isPortPrivileged(v):!1},y={remoteAddress:{host:d,port:o},localAddressPort:t,privacy:r,public:r?r!==m.Private:void 0,protocol:c},w=i.forwardPort(y,f);return w?(this.q(d,o,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),w}};e.$uw=u,e.$uw=u=Je([Ue(0,L.$3j),Ue(1,A.$3i)],u)}),define(ke[282],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,a.$wi)("IUriIdentityService")}),define(ke[283],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$vw=void 0,e.$vw=(0,a.$wi)("editSessionIdentityService");var N;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[284],Se([1,0,15]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=N,e.$HM=A,e.$IM=R,e.$JM=L,e.$KM=$;function N(m){return m.scheme!==a.Schemas.file&&m.scheme!==a.Schemas.vscodeRemote}function A(m){if(m.folders.length)return m.folders.every(E=>N(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&N(m.configuration))return m.configuration}function R(m){return A(m)?.scheme}function L(m){return A(m)?.authority}function $(m){return A(m)!==void 0}}),define(ke[43],Se([1,0,223,17,78,23,2,5,15]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=E,e.$Hi=I,e.$Ki=P,e.$Li=b,e.$Mi=k,e.$Ni=h,e.$Oi=g,e.$Ri=i,e.$Wi=d,e.$Xi=o,e.$Zi=t,e.$1i=l,e.$2i=r,e.$Fi=(0,$.$wi)("contextService");function E(c){const s=c;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}function I(c){return typeof c?.id=="string"&&!E(c)&&!b(c)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function P(c,s){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,N.$oc)(c)}:s?e.$Ii:e.$Ji;const v=c;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}function b(c){const s=c;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}function k(c){const s=c;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const v=c;if(v?.configPath)return{id:v.id,configPath:L.URI.revive(v.configPath)};if(c?.id)return{id:c.id}}var p;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function h(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(c){const s=c;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class u{constructor(s,v,f,y,w){this.h=s,this.j=f,this.k=y,this.l=w,this.c=A.$Ci.forUris(this.l,()=>!0),this.folders=v}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=A.$Ci.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=u;class n{constructor(s,v){this.raw=v,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.$0g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(c){return new n({uri:c,index:0,name:(0,R.$6g)(c)},{uri:c.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,a.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function d(c,s){return R.$1g.isEqualOrParent(c,s.untitledWorkspacesHome)}function o(c){let s;return L.URI.isUri(c)?s=c:s=c.configuration,s?.scheme===m.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Yi}function l(c,s){return!d(c,s)&&!o(c)}function r(c){return(typeof c=="string"?(0,N.$pc)(c):(0,R.$8g)(c))===e.$Ti}}),define(ke[285],Se([1,0,57,4,3,23,2,222,138,33,5,11,43,27,282,7,31,14,18]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=d,e.$Dl=o,e.$El=t;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function d(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}e.$Cl=(0,I.$wi)("IUserDataProfilesService");function o(c,s){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:L.URI.revive(c.location).with({scheme:s}),globalStorageHome:L.URI.revive(c.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(c.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(c.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(c.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(c.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(c.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(c.cacheHome).with({scheme:s}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,s,v,f,y,w){return{id:c,name:s,location:v,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:w&&y?.useDefaultFlags?.globalState?w.globalStorageHome:(0,R.$0g)(v,"globalStorage"),settingsResource:w&&y?.useDefaultFlags?.settings?w.settingsResource:(0,R.$0g)(v,"settings.json"),keybindingsResource:w&&y?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,R.$0g)(v,"keybindings.json"),tasksResource:w&&y?.useDefaultFlags?.tasks?w.tasksResource:(0,R.$0g)(v,"tasks.json"),snippetsHome:w&&y?.useDefaultFlags?.snippets?w.snippetsHome:(0,R.$0g)(v,"snippets"),extensionsResource:w&&y?.useDefaultFlags?.extensions?w.extensionsResource:(0,R.$0g)(v,"extensions.json"),cacheHome:(0,R.$0g)(f,c),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let l=class extends A.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,v,f,y){super(),this.t=s,this.u=v,this.w=f,this.y=y,this.f=!0,this.h=this.B(new N.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),v=[s];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$9f)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}v.push(t((0,R.$7g)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},s))}}catch(w){this.y.error(w)}const f=new k.$Bc,y=new Map;if(v.length)try{const w=this.Q();if(w.workspaces)for(const[D,S]of Object.entries(w.workspaces)){const C=L.URI.parse(D),j=v.find(B=>B.id===S);j&&f.set(C,j)}if(w.emptyWindows)for(const[D,S]of Object.entries(w.emptyWindows)){const C=v.find(j=>j.id===S);C&&y.set(D,C)}}catch(w){this.y.error(w)}this.z={profiles:v,workspaces:f,emptyWindows:y}}return this.z}D(){const s=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const v="Temp",f=new RegExp(`${(0,u.$af)(v)}\\s(\\d+)`);let y=0;for(const D of this.profiles){const S=f.exec(D.name),C=S?parseInt(S[1]):0;y=C>y?C:y}const w=`${v} ${y+1}`;return this.createProfile((0,a.$kj)((0,g.$Sg)()).toString(16),w,{transient:!0},s)}async createNamedProfile(s,v,f){return this.createProfile((0,a.$kj)((0,g.$Sg)()).toString(16),s,v,f)}async createProfile(s,v,f,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(s,v,f);return y&&await this.setProfileForWorkspace(y,w),w}async F(s,v,f){if(!(0,n.$9f)(v)||!v)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(v);return y||(y=(async()=>{try{if(this.profiles.find(C=>C.name===v||C.id===s))throw new Error(`Profile with ${v} name already exists`);const D=t(s,v,(0,R.$0g)(this.profilesHome,s),this.g,f,this.defaultProfile);await this.u.createFolder(D.location);const S=[];return this.j.fire({profile:D,join(C){S.push(C)}}),await h.Promises.settled(S),this.I([D],[],[]),D}finally{this.r.delete(v)}})(),this.r.set(v,y)),y}async updateProfile(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(y=>y.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=t(f.id,v.name??f.name,f.location,this.g,{shortName:v.shortName??f.shortName,icon:v.icon===null?void 0:v.icon??f.icon,transient:v.transient??f.isTransient,useDefaultFlags:v.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const v=this.profiles.find(y=>y.id===s.id);if(!v)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this.m.fire({profile:v,join(y){f.push(y)}});try{await Promise.allSettled(f)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])v.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])v.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[v],[]);try{await this.u.del(v.cacheHome,{recursive:!0})}catch(y){(0,E.$hl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(y=>y.id===v.id);if(!f)throw new Error(`Profile '${v.name}' does not exist`);this.L(s,f)}unsetWorkspace(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,v)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(v=>v.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,v.resource))).map(v=>this.u.del(v.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(v=>!this.H(v));await Promise.allSettled(s.map(v=>this.removeProfile(v)))}getProfileForWorkspace(s){const v=this.G(s);return L.URI.isUri(v)?this.s.workspaces.get(v)??this.C.workspaces.get(v):this.s.emptyWindows.get(v)??this.C.emptyWindows.get(v)}G(s){return(0,b.$Gi)(s)?s.uri:(0,b.$Li)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.s.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.C.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.C.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,s.location)))}I(s,v,f){const y=[...this.profiles,...s],w=[];this.s.profiles=[];for(let D of y)D.isDefault||v.some(S=>D.id===S.id)||(D=f.find(S=>D.id===S.id)??D,D.isTransient?this.s.profiles.push(D):w.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(w),this.z=void 0,this.J(s,v,f)}J(s,v,f){this.h.fire({added:s,removed:v,updated:f,all:this.profiles})}L(s,v,f){f=v?.isTransient?!0:f,f||this.L(s,void 0,!0);const y=this.G(s),w=f?this.s:this.C;L.URI.isUri(y)?(w.workspaces.delete(y),v&&w.workspaces.set(y,v)):(w.emptyWindows.delete(y),v&&w.emptyWindows.set(y,v)),f||this.M()}M(){const s={};for(const[f,y]of this.C.workspaces.entries())s[f.toString()]=y.id;const v={};for(const[f,y]of this.C.emptyWindows.entries())v[f.toString()]=y.id;this.R({workspaces:s,emptyWindows:v}),this.z=void 0}N(s){const v={},f=this.D();if(s.workspaces)for(const[w,D]of Object.entries(s.workspaces)){const S=L.URI.parse(D);v[w]=this.w.extUri.isEqual(S,f.location)?f.id:this.w.extUri.basename(S)}const y={};if(s.emptyWindows)for(const[w,D]of Object.entries(s.emptyWindows)){const S=L.URI.parse(D);y[w]=this.w.extUri.isEqual(S,f.location)?f.id:this.w.extUri.basename(S)}return{workspaces:v,emptyWindows:y}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Fl=l,l.b="userDataProfiles",l.c="profileAssociations",e.$Fl=l=Je([Ue(0,m.$Di),Ue(1,E.$3k),Ue(2,p.$Al),Ue(3,P.$3j)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Gl=r}),define(ke[143],Se([1,0,7,4,3,59,18,183,5,285]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$4p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2p=e.$1p=e.$Zp=void 0,e.$3p=k,e.$5p=h,e.$7p=u,e.$Zp="__$__isNewStorageMarker",e.$1p="__$__targetStorageMarker",e.$2p=(0,m.$wi)("storageService");var I;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var P;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var b;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function k(n){const i=n.get(e.$1p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class p extends A.$Vc{constructor(i={flushInterval:p.a}){super(),this.m=i,this.b=this.B(new N.$he),this.c=this.B(new N.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new a.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,d,o){return N.Event.filter(this.b.event,t=>t.scope===i&&(d===void 0||t.key===d),o)}n(){this.j.value=(0,a.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,d){const{key:o,external:t}=d;if(o===e.$1p){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,d,o){return this.P(d)?.get(i,o)}getBoolean(i,d,o){return this.P(d)?.getBoolean(i,o)}getNumber(i,d,o){return this.P(d)?.getNumber(i,o)}getObject(i,d,o){return this.P(d)?.getObject(i,o)}storeAll(i,d){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,d)})}store(i,d,o,t,l=!1){if((0,L.$fg)(d)){this.remove(i,o,l);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,d,l)})}remove(i,d,o=!1){this.y(()=>{this.z(i,d,void 0),this.P(d)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,d){const o=[],t=this.J(i);for(const l of Object.keys(t))t[l]===d&&o.push(l);return o}z(i,d,o,t=!1){const l=this.J(d);typeof o=="number"?l[i]!==o&&(l[i]=o,this.P(d)?.set(e.$1p,JSON.stringify(l),t)):typeof l[i]=="number"&&(delete l[i],this.P(d)?.set(e.$1p,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const d=this.P(i);return d?k(d):Object.create(null)}isNew(i){return this.getBoolean(e.$Zp,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const d=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case I.NONE:await a.Promises.settled([d?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await a.Promises.settled([d?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return u(i,d,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,d){return this.w(I.NONE),(0,E.$Bl)(i)?this.R(i,d):this.S(i,d)}M(i,d){return!(i.id===d.id||h(d)&&h(i))}N(i,d,o){this.y(()=>{const t=new Set;for(const[l,r]of i)t.add(l),d.get(l)!==r&&this.u(o,{key:l,external:!0});for(const[l]of d.items)t.has(l)||this.u(o,{key:l,external:!0})})}}e.$4p=p,p.a=60*1e3;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class g extends p{constructor(){super(),this.U=this.B(new $.$Xp(new $.$Yp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$Xp(new $.$Yp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$Xp(new $.$Yp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$6p=g;async function u(n,i,d,o,t,l){const r=C=>{try{return JSON.parse(C)}catch{return C}},c=new Map,s=new Map;n.forEach((C,j)=>{c.set(j,C),s.set(j,r(C))});const v=new Map,f=new Map;i.forEach((C,j)=>{v.set(j,C),f.set(j,r(C))});const y=new Map,w=new Map;d.forEach((C,j)=>{y.set(j,C),w.set(j,r(C))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const D=[];if(c.forEach((C,j)=>{D.push({key:j,value:C})}),console.table(D),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];v.forEach((j,B)=>{C.push({key:B,value:j})}),console.table(C),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${l})`);const S=[];y.forEach((C,j)=>{S.push({key:j,value:C})}),console.table(S),console.groupEnd(),console.log(w)}}),define(ke[112],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class a{constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){a.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$flc=a,a.a=!1}),define(ke[60],Se([1,0,15,23,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new N.$Yg($=>{const m=this.b.get($.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos($,m){m===null?this.b.delete($.scheme):this.b.set($.scheme,m)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$klc=R,e.$llc=(0,A.$wi)("IExtHostFileSystemInfo")}),define(ke[28],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0,e.$NP=(0,a.$wi)("IExtHostInitDataService")}),define(ke[286],Se([1,0,228,11,266,28]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;let L=class extends A.$WQ{constructor(m,E,I){const P=I.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",b=I.remote.isRemote?(0,a.localize)(0,null):m?(0,a.localize)(1,null):(0,a.localize)(2,null);super(E.createLogger(P,{name:b}))}};e.$rnc=L,e.$rnc=L=Je([Ue(1,N.$4j),Ue(2,R.$NP)],L)}),define(ke[287],Se([1,0,7]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;class N{constructor(L,$,m){this.h=new Map,this.a=L,this.b=$,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new a.$Ih(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of E.values())I.complete()}catch(I){for(const P of E.values())P.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,$){let m=this.f[L];return typeof m>"u"&&(m=$),m}update(L,$){this.f[L]=$;const m=this.h.get(L);if(m!==void 0)return m.p;const E=new a.$Th;return this.h.set(L,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$3lc=N;class A extends N{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,$){super(L.identifier.value,!0,$),this.j=L}}e.$4lc=A}),define(ke[288],Se([1,0,4,2]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class A{constructor(L){this.c=L,this.a=new a.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,$,m,E){const P=this.c.getNotebookDocument(N.URI.revive(L)).acceptModelChanged($.value,m,E);this.b.fire(P)}$acceptDirtyStateChanged(L,$){this.c.getNotebookDocument(N.URI.revive(L)).acceptDirty($)}$acceptModelSaved(L){const $=this.c.getNotebookDocument(N.URI.revive(L));this.a.fire($.apiNotebook)}}e.$Rmc=A}),define(ke[20],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$xP=(0,a.$wi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$yP=N});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[289],Se([1,0,25,4]),function(ie,e,a,N){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;class R{constructor($,m){A.set(this,void 0),this.b=new N.$ee,this.onDidChange=this.b.event,this.a=a.$Sm.toKey($.identifier),it(this,A,m,"f"),qe(this,A,"f").onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get($){return qe(this,A,"f").get(this.a,$)}store($,m){return qe(this,A,"f").store(this.a,$,m)}delete($){return qe(this,A,"f").delete(this.a,$)}}e.$amc=R,A=new WeakMap}),define(ke[68],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0,e.$Alc=(0,a.$wi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Blc=N}),define(ke[290],Se([1,0,21]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irb=A,e.$Jrb=L;class N{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function A($,m){if(m.serializeBuffersForPostMessage){const E=new N,P=JSON.stringify($,(k,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(p)};if(ArrayBuffer.isView(p)){const h=R(p);if(h)return{$$vscode_array_buffer_reference$$:!0,index:E.add(p.buffer),view:{type:h,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),b=E.buffers.map(k=>{const p=new Uint8Array(k);return a.$Ge.wrap(p)});return{message:P,buffers:b}}else return{message:JSON.stringify($),buffers:[]}}function R($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L($,m){const E=m.map(b=>{const k=new ArrayBuffer(b.byteLength);return new Uint8Array(k).set(b.buffer),k}),I=m.length?(b,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const p=k,{index:h}=p,g=E[h];if(p.view)switch(p.view.type){case 1:return new Int8Array(g,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return k}:void 0;return{message:JSON.parse($,I),arrayBuffers:E}}}),define(ke[291],Se([1,0,113,402,403,64,2,11,404]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=I;const E=!1;function I(i,d,o,t,l,r){const c=r.environment.useHostProxy,s=typeof c=="boolean"?c:!r.remote.isRemote,v={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:g.bind(void 0,t,l,d,{},r.remote.isRemote),getProxyURL:()=>d.getConfiguration("http").get("proxy"),getProxySupport:()=>d.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>b(d),addCertificatesV2:()=>k(d),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case $.LogLevel.Trace:return m.LogLevel.Trace;case $.LogLevel.Debug:return m.LogLevel.Debug;case $.LogLevel.Info:return m.LogLevel.Info;case $.LogLevel.Warning:return m.LogLevel.Warning;case $.LogLevel.Error:return m.LogLevel.Error;case $.LogLevel.Off:return m.LogLevel.Off;default:return D(w)}function D(S){return t.error("Unknown log level",S),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,loadAdditionalCertificates:async()=>{const w=[];if(r.remote.isRemote&&w.push((0,m.loadSystemCertificates)({log:t})),s){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const D=i.loadCertificates();D.then(S=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",S.length)),w.push(D)}return(await Promise.all(w)).flat()},env:process.env},f=(0,m.createProxyResolver)(v),y=P(v,f);return h(o,y)}function P(i,d){return{http:Object.assign(a,(0,m.createHttpPatch)(i,a,d)),https:Object.assign(N,(0,m.createHttpPatch)(i,N,d)),net:Object.assign(R,(0,m.createNetPatch)(i,R)),tls:Object.assign(A,(0,m.createTlsPatch)(i,A))}}function b(i){const d=i.getConfiguration("http");return!d.get("experimental.systemCertificatesV2",E)&&!!d.get("systemCertificates")}function k(i){const d=i.getConfiguration("http");return!!d.get("experimental.systemCertificatesV2",E)&&!!d.get("systemCertificates")}const p=new Map;function h(i,d){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,l=t._load;t._load=function(c,s,v){if(c==="net")return d.net;if(c==="tls")return d.tls;if(c!=="http"&&c!=="https")return l.apply(this,arguments);const f=o.findSubstr(L.URI.file(s.filename));let y=p.get(f);if(y||p.set(f,y={}),!y[c]){const w=d[c];y[c]={...w}}return y[c]}})}async function g(i,d,o,t,l,r,c,s){const v=t[r];c&&(t[r]=c),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${v}`);const f=c||v,y=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(n(d,y,l),y.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const w=await new Promise((B,z)=>{ie(["kerberos"],B,z)}),D=new URL(r),S=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${D.hostname}`:`HTTP@${D.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${S}`),"Negotiate "+await(await w.initializeClient(S)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let u=!1;function n(i,d,o){u||!d.length||(u=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:d.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[292],Se([1,0,132]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=A;function N(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function A(R){return new a.$zn(N(R))}}),define(ke[144],Se([1,0,238,18,2,3,5,36,33,15,47,202,42]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=h,e.$zF=g,e.$AF=u,e.$BF=n,e.$CF=i,e.$DF=d,e.$EF=o,e.$FF=t,e.$GF=l,e.$JF=y,e.$KF=D,e.$LF=S,e.$MF=C,e.$NF=j,e.$OF=B,e.$PF=z,e.$QF=Y,e.$SF=x,e.$TF=de,e.$UF=ce,e.$VF=ve,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var k;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var p;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function h(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function g(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function u(_,U,le){for(const De of le.visibleEditorPanes)if(De.group.id===U&&_.matches(De.input))return De.getViewState()}function n(_){if(y(_))return!1;const U=_;return A.URI.isUri(U?.resource)}function i(_){if(y(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function d(_){if(y(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function o(_){if(y(_)||i(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(y(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===E.Schemas.untitled||U.forceUntitled===!0:!1}function l(_){if(y(_))return!1;const U=_;return A.URI.isUri(U?.base?.resource)&&A.URI.isUri(U?.input1?.resource)&&A.URI.isUri(U?.input2?.resource)&&A.URI.isUri(U?.result?.resource)}var r;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var c;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class s{constructor(){this.a=new Map}registerSource(U,le){let De=this.a.get(U);return De||(De={source:U,label:le},this.a.set(U,De)),De.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$HF=new s;var v;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(v||(e.EditorInputCapabilities=v={}));class f extends R.$Vc{}e.$IF=f;function y(_){return _ instanceof f}function w(_){const U=_;return A.URI.isUri(U?.preferredResource)}function D(_){const U=_;return y(U?.primary)&&y(U?.secondary)}function S(_){const U=_;return y(U?.modified)&&y(U?.original)}function C(_,U,le,De,$e){return ve(De,[(0,P.$gj)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const re={...le,limits:{size:Number.MAX_VALUE}};_.openEditor(U,re)}}),(0,P.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>$e.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}function j(_){return y(_?.editor)}function B(_){const U=_;return j(_)&&U?.group!==void 0}function z(_){const U=_;return typeof U?.groupId=="number"&&y(U.editor)}var T;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var M;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var F;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class O{getOriginalUri(U,le){if(!U)return;if(l(U))return e.$RF.getOriginalUri(U.result,le);if(le?.supportSideBySide){const{primary:$e,secondary:re}=this.a(U);if($e&&re){if(le?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri($e,{filterByScheme:le.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===F.ANY)return this.getOriginalUri($e,{filterByScheme:le.filterByScheme})??this.getOriginalUri(re,{filterByScheme:le.filterByScheme});U=le.supportSideBySide===F.PRIMARY?$e:re}}if(i(U)||d(U)||o(U)||l(U))return;const De=w(U)?U.preferredResource:U.resource;return!De||!le||!le.filterByScheme?De:this.b(De,le.filterByScheme)}a(U){return D(U)||o(U)?{primary:U.primary,secondary:U.secondary}:S(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,le){if(!U)return;if(l(U))return e.$RF.getCanonicalUri(U.result,le);if(le?.supportSideBySide){const{primary:$e,secondary:re}=this.a(U);if($e&&re){if(le?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri($e,{filterByScheme:le.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===F.ANY)return this.getCanonicalUri($e,{filterByScheme:le.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:le.filterByScheme});U=le.supportSideBySide===F.PRIMARY?$e:re}}if(i(U)||d(U)||o(U)||l(U))return;const De=U.resource;return!De||!le||!le.filterByScheme?De:this.b(De,le.filterByScheme)}b(U,le){if(Array.isArray(le)){if(le.some(De=>U.scheme===De))return U}else if(le===U.scheme)return U}}var q;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(q||(e.EditorCloseMethod=q={}));function Y(_,U,le,De){if(!_.isSticky(U))return!1;switch(De.preventPinnedEditorClose){case"keyboardAndMouse":return le===q.MOUSE||le===q.KEYBOARD;case"mouse":return le===q.MOUSE;case"keyboard":return le===q.KEYBOARD}return!1}e.$RF=new O;var V;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class J{constructor(){this.c=new Map,this.d=new Map}start(U){const le=this.a=U.get(L.$vi);for(const[De,$e]of this.c)this.e(De,$e,le);this.c.clear()}e(U,le,De){const $e=De.createInstance(le);this.d.set(U,$e)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$hg)(this.b)}registerEditorSerializer(U,le){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,le,this.a):this.c.set(U,le),(0,R.$Tc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}$.$do.add(e.$tF.EditorFactory,new J);async function x(_,U,le){return!_||!_.length?[]:await Promise.all(_.map(async De=>{const $e=A.URI.revive(De.fileUri);if(!$e){le.info("Cannot resolve the path because it is not valid.",De);return}if(!await U.canHandleResource($e)){le.info("Cannot resolve the path because it cannot be handled",De);return}let se=De.exists,oe=De.type;if(typeof se!="boolean"||typeof oe!="number")try{oe=(await U.stat($e)).isDirectory?m.FileType.Directory:m.FileType.Unknown,se=!0}catch(te){le.error(te),se=!1}if(!se&&De.openOnlyIfExists){le.info("Cannot resolve the path because it does not exist",De);return}if(oe===m.FileType.Directory){le.info("Cannot resolve the path because it is a directory",De);return}const K={...De.options,pinned:!0};return se?{resource:$e,options:K}:{resource:$e,options:K,forceUntitled:!0}}))}var ne;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function de(_){const U=_;if(!U)return!1;const le=U;if(le.modified)return de(le.modified);const De=U;return!!(De.contributionsState&&De.viewState&&Array.isArray(De.cursorState))}function ce(_){return(0,I.$ij)(_)}function ve(_,U,le){const De=(0,I.$jj)(_,U);return De.forceMessage=le?.forceMessage,De.forceSeverity=le?.forceSeverity,De.allowDialog=le?.allowDialog,De}}),define(ke[293],Se([1,0,4,239,5,3,27,36,19,24,79,281]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=p,e.$WF="views",e.$XF=(0,N.localize)(0,null),e.$YF=(0,P.$gx)("default-view-icon",I.$Vj.window,(0,N.localize)(1,null));var b;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var k;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(k||(e.ViewContainerLocation=k={})),e.$ZF=[0,1,2];function p(l){switch(l){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class h extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new a.$ee),this.onDidRegister=this.c.event,this.f=this.B(new a.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,m.$Rb)([...this.g.values()])}registerViewContainer(r,c,s){const v=this.get(r.id);if(v)return v;const f=r;return f.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,L.$yc)(this.g,c,[]).push(f),s?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:c}),f}deregisterViewContainer(r){for(const c of this.g.keys()){const s=this.g.get(c),v=s?.indexOf(r);if(v!==-1){s?.splice(v,1),s.length===0&&this.g.delete(c),this.f.fire({viewContainer:r,viewContainerLocation:c});return}}}get(r){return this.all.filter(c=>c.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(s=>s?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(c=>this.getViewContainerLocation(c)===r)}}$.$do.add(b.ViewContainersRegistry,new h);var g;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(g||(e.ViewContentGroups=g={}));function u(l,r){const c=l.group??g.More,s=r.group??g.More;return c!==s?c.localeCompare(s):(l.order??5)-(r.order??5)}class n extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new a.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new a.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Ic}registerViews(r,c){this.registerViews2([{views:r,viewContainer:c}])}registerViews2(r){r.forEach(({views:c,viewContainer:s})=>this.r(c,s)),this.c.fire(r)}deregisterViews(r,c){const s=this.s(r,c);s.length&&this.f.fire({views:s,viewContainer:c})}moveViews(r,c){for(const s of this.m.keys())if(s!==c){const v=this.s(r,s);v.length&&(this.r(v,c),this.g.fire({views:v,from:s,to:c}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const c of this.j){const s=(this.m.get(c)||[]).filter(v=>v.id===r)[0];if(s)return s}return null}getViewContainer(r){for(const c of this.j)if((this.m.get(c)||[]).filter(v=>v.id===r)[0])return c;return null}registerViewWelcomeContent(r,c){return this.n.add(r,c),this.h.fire(r),(0,R.$Tc)(()=>{this.n.delete(r,c),this.h.fire(r)})}registerViewWelcomeContent2(r,c){const s=new Map;for(const[v,f]of c)this.n.add(r,f),s.set(v,(0,R.$Tc)(()=>{this.n.delete(r,f),this.h.fire(r)}));return this.h.fire(r),s}getViewWelcomeContent(r){const c=[];return this.n.forEach(r,s=>c.push(s)),c.sort(u)}r(r,c){let s=this.m.get(c);s||(s=[],this.m.set(c,s),this.j.push(c));for(const v of r){if(this.getView(v.id)!==null)throw new Error((0,N.localize)(2,null,v.id));s.push(v)}}s(r,c){const s=this.m.get(c);if(!s)return[];const v=[],f=[];for(const y of s)r.includes(y)?v.push(y):f.push(y);return v.length&&(f.length?this.m.set(c,f):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),v}}$.$do.add(b.ViewsRegistry,new n),e.$2F=(0,A.$wi)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var d;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(d||(e.TreeItemCollapsibleState=d={}));class o{constructor(r,c){this.c=!1,this.d=!1,(0,E.$7n)(this,r),this.d=!!c,this.resolve=async s=>{if(c&&!this.c){const v=await c(s);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=o;class t extends Error{constructor(r){super((0,N.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$4F=t}),define(ke[294],Se([1,0,240,38]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new N.$Nj("chatSessionResponseVote","",{type:"string",description:(0,a.localize)(0,null)}),e.$9F=new N.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,a.localize)(1,null)}),e.$0F=new N.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,a.localize)(2,null)}),e.$$F=new N.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,a.localize)(3,null)}),e.$_F=new N.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,a.localize)(4,null)}),e.$aG=new N.$Nj("chatResponse",!1,{type:"boolean",description:(0,a.localize)(5,null)}),e.$bG=new N.$Nj("chatRequest",!1,{type:"boolean",description:(0,a.localize)(6,null)}),e.$cG=new N.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,a.localize)(7,null)}),e.$dG=new N.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,a.localize)(8,null)}),e.$eG=new N.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,a.localize)(9,null)}),e.$fG=new N.$Nj("inChatInput",!1,{type:"boolean",description:(0,a.localize)(10,null)}),e.$gG=new N.$Nj("inChat",!1,{type:"boolean",description:(0,a.localize)(11,null)}),e.$hG=new N.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,a.localize)(12,null)}),e.$iG=new N.$Nj("chatCursorAtTop",!1),e.$jG=new N.$Nj("chatInputHasAgent",!1),e.$kG=new N.$Nj("chatLocation",void 0)}),define(ke[295],Se([1,0,7,22,4,40,3,172,14,38,5,11,108,274,143,294]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var u;(function(o){o.Panel="panel",o.Terminal="terminal",o.Notebook="notebook",o.Editor="editor"})(u||(e.ChatAgentLocation=u={})),function(o){function t(l){switch(l){case"panel":return o.Panel;case"terminal":return o.Terminal;case"notebook":return o.Notebook;case"editor":return o.Editor}return o.Panel}o.fromRaw=t}(u||(e.ChatAgentLocation=u={})),e.$iH=(0,I.$wi)("chatAgentService");let n=class{constructor(t){this.f=t,this.b=[],this.d=new A.$ee,this.onDidChangeAgents=this.d.event,this.e=h.$hG.bindTo(this.f)}registerAgent(t,l){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const c=this,s=l.slashCommands;l={...l,get slashCommands(){return s.filter(f=>!f.when||c.f.contextMatchesRules(E.$uj.deserialize(f.when)))}};const v={data:l};return this.b.push(v),(0,L.$Tc)(()=>{this.b=this.b.filter(f=>f!==v),this.d.fire(void 0)})}registerAgentImplementation(t,l){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=l,this.d.fire(new i(r.data,l)),(0,L.$Tc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,l){const r={data:t,impl:l};return this.b.push(r),this.d.fire(new i(t,l)),(0,L.$Tc)(()=>{this.b=this.b.filter(c=>c!==r),this.d.fire(void 0)})}updateAgent(t,l){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...l},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(l=>!!l.isDefault&&l.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(l=>!!l.isDefault&&l.locations.includes(t))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(l=>l.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(l=>l.name===t)}async invokeAgent(t,l,r,c,s){const v=this.g(t);if(!v?.impl)throw new Error(`No activated agent with id ${t}`);return await v.impl.invoke(l,r,c,s)}async getFollowups(t,l,r,c,s){const v=this.g(t);if(!v?.impl)throw new Error(`No activated agent with id ${t}`);return v.impl?.provideFollowups?v.impl.provideFollowups(l,r,c,s):[]}};e.$jH=n,n.AGENT_LEADER="@",e.$jH=n=Je([Ue(0,E.$Oj)],n);class i{constructor(t,l){this.b=t,this.d=l}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,l,r,c){return this.d.invoke(t,l,r,c)}async provideFollowups(t,l,r,c){return this.d.provideFollowups?this.d.provideFollowups(t,l,r,c):[]}provideWelcomeMessage(t,l){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,l)}provideSampleQuestions(t,l){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,l)}}e.$kH=i,e.$lH=(0,I.$wi)("chatAgentNameService");let d=g=class{constructor(t,l,r,c){if(this.g=l,this.h=r,this.i=c,this.e=(0,$.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const s=c.get(g.b,-1);try{this.e.set(JSON.parse(s??"{}"),void 0)}catch{c.remove(g.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,a.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},N.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const l=await(0,k.$Up)(t);if(!l||l.version!==1)throw new Error("Unexpected chat participant registry response.");const r=l.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(g.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(c=>(0,m.$yf)(c,c.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=d,d.b="chat.participantNameRegistry",e.$mH=d=g=Je([Ue(0,b.$jk),Ue(1,k.$Op),Ue(2,P.$3j),Ue(3,p.$2p)],d)}),define(ke[296],Se([1,0,2,29,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=R,e.$qG=L;function R(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof a.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$vt.isIRange)}function L(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(R)}var $;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$rG=(0,A.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(ke[145],Se([1,0,4,7,241]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new a.$ee,this.o=new a.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage($){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=$}onEvent($){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=$}onRequest($){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.u("response",$)}sendRequest($,m,E,I){const P={command:$};if(m&&Object.keys(m).length>0&&(P.arguments=m),this.u("request",P),typeof I=="number"){const b=setTimeout(()=>{clearTimeout(b);const k=this.f.get(P.seq);if(k){this.f.delete(P.seq);const p={type:"response",seq:0,request_seq:P.seq,success:!1,command:$,message:(0,A.localize)(0,null,I,$)};k(p)}},I)}return E&&this.f.set(P.seq,E),P.seq}acceptMessage($){this.k?this.k($):(this.m.push($),this.m.length===1&&this.s())}q($,m){return $.type!=="event"||m.type!=="event"}async s(){let $;for(;this.m.length;){if((!$||this.q(this.m[0],$))&&await(0,N.$xh)(0),$=this.m.shift(),!$)return;switch($.type){case"event":this.j?.($);break;case"request":this.g?.($);break;case"response":{const m=$,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u($,m){m.type=$,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((m,E)=>$.set(E,m)),await(0,N.$xh)(500),$.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Vrb=R}),define(ke[297],Se([1,0,2,242,38,5]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=m,e.$BJ=I,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new A.$Nj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$xI=new A.$Nj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$yI=new A.$Nj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$zI="debugUx",e.$AI=new A.$Nj(e.$zI,"default",{type:"string",description:N.localize(3,null)}),e.$BI=new A.$Nj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$CI=new A.$Nj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$DI=new A.$Nj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$EI=new A.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$FI=new A.$Nj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$GI=new A.$Nj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$HI=new A.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$II=new A.$Nj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$JI=new A.$Nj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$KI=new A.$Nj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$LI=new A.$Nj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$MI=new A.$Nj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$NI=new A.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$OI=new A.$Nj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$PI=new A.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$QI=new A.$Nj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$RI=new A.$Nj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$SI=new A.$Nj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$TI=new A.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$UI=new A.$Nj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$VI=new A.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$WI=new A.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$XI=new A.$Nj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$YI=new A.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$ZI=new A.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$1I=new A.$Nj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$2I=new A.$Nj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$3I=new A.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$4I=new A.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$5I=new A.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$6I=new A.$Nj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$7I=new A.$Nj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$8I=new A.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$9I=new A.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$0I=new A.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$$I=new A.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$_I=new A.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$aJ=new A.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$bJ=new A.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$cJ=new A.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$dJ=new A.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$eJ=new A.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$fJ=new A.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$gJ=new A.$Nj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$hJ=new A.$Nj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$iJ=new A.$Nj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$jJ=new A.$Nj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$kJ=new A.$Nj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$lJ=new A.$Nj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$mJ=new A.$Nj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$nJ=new A.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$oJ=new A.$Nj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$pJ=new A.$Nj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$qJ=new A.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$rJ=new A.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$sJ=new A.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$tJ=new A.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const L=i=>N.localize(61,null,i);e.$uJ=L,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var $;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})($||(e.State=$={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$AJ="vscode-debug-memory";function I(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var P;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var b;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var k;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$CJ=(0,R.$wi)("debugService");var p;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var h;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var g;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var u;(function(i){i.deserialize=d=>d,i.serialize=d=>d})(u||(e.IDebugVisualizationTreeItem=u={}));var n;(function(i){i.deserialize=d=>({id:d.id,name:d.name,iconPath:d.iconPath&&{light:a.URI.revive(d.iconPath.light),dark:a.URI.revive(d.iconPath.dark)},iconClass:d.iconClass,visualization:d.visualization}),i.serialize=d=>d})(n||(e.IDebugVisualization=n={}))}),define(ke[298],Se([1,0,14,2,17,24,15,29,22,19]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=P,e.$qH=b,e.$rH=k,e.$sH=p,e.$tH=h,e.$uH=g,e.$vH=u,e.$wH=i,e.$xH=t,e.$yH=l,e.$zH=c,e.$AH=v;const I=/{([^}]+)}/g;function P(y,w,D){return y.replace(I,function(S,C){return w&&C.length>0&&C[0]!=="_"?S:D&&D.hasOwnProperty(C)?D[C]:S})}function b(y){const w={};for(const D of Object.keys(y))D.startsWith("!")||(w[D]=y[D]);return w}function k(y){return y.configuration.request==="attach"&&!p(y)&&(!y.parentSession||k(y.parentSession))}function p(y){let w=y.configuration.type;if(w)return w==="vslsShare"&&(w=y.configuration.adapterProxy.configuration.type),(0,a.$yf)(w,"extensionhost")||(0,a.$yf)(w,"pwa-extensionhost")?y:y.parentSession?p(y.parentSession):void 0}function h(y){return y.type&&(y.label||y.program||y.runtime)}function g(y,w,D){let S,C=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=j.exec(y);){const z=B.index+1,T=z+B[0].length;if(z<=w&&T>=D){S=B[0],C=z;break}}if(S){const z=/\w+/g;let T=null;for(;(T=z.exec(S))&&!(T.index+1+C+T[0].length>=D););T&&(S=S.substring(0,z.lastIndex))}return S?{start:C,end:C+S.length-1}:{start:0,end:0}}async function u(y,w,D,S){if(y.evaluatableExpressionProvider.has(w)){const C=y.evaluatableExpressionProvider.ordered(w),j=(0,E.$Hb)(await Promise.all(C.map(async B=>{try{return await B.provideEvaluatableExpression(w,D,S??m.CancellationToken.None)}catch{return}})));if(j.length>0){let B=j[0].expression;const z=j[0].range;return B||(B=w.getLineContent(D.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:B}}}else{const C=w.getLineContent(D.lineNumber),{start:j,end:B}=g(C,D.column,D.column),z=C.substring(j-1,B);return{matchingExpression:z,range:new $.$vt(D.lineNumber,j,D.lineNumber,j+z.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(n))}function d(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return N.URI.parse(y.path);if((0,A.$jc)(y.path))return N.URI.file(y.path)}return y.path}function o(y){if(typeof y.path=="object"){const w=N.URI.revive(y.path);if(w)return w.scheme===L.Schemas.file?w.fsPath:w.toString()}return y.path}function t(y,w){const D=w?d:o,S=(0,R.$4n)(y);return r(S,(C,j)=>{C&&j&&(j.path=D(j))}),S}function l(y,w){const D=w?d:o,S=(0,R.$4n)(y);return r(S,(C,j)=>{!C&&j&&(j.path=D(j))}),S}function r(y,w){switch(y.type){case"event":{const D=y;switch(D.event){case"output":w(!1,D.body.source);break;case"loadedSource":w(!1,D.body.source);break;case"breakpoint":w(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=y;switch(D.command){case"setBreakpoints":w(!0,D.arguments.source);break;case"breakpointLocations":w(!0,D.arguments.source);break;case"source":w(!0,D.arguments.source);break;case"gotoTargets":w(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(S=>w(!1,S));break;default:break}break}case"response":{const D=y;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(S=>w(!1,S.source));break;case"loadedSources":D.body.sources.forEach(S=>w(!1,S));break;case"scopes":D.body.scopes.forEach(S=>w(!1,S.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(S=>w(!1,S.source));break;case"setBreakpoints":D.body.breakpoints.forEach(S=>w(!1,S.source));break;case"disassemble":D.body?.instructions.forEach(C=>w(!1,C.location));break;default:break}break}}}function c(y){return y.filter(w=>!w.presentation?.hidden).sort((w,D)=>w.presentation?D.presentation?w.presentation.group?D.presentation.group?w.presentation.group!==D.presentation.group?w.presentation.group.localeCompare(D.presentation.group):s(w.presentation.order,D.presentation.order):-1:D.presentation.group?1:s(w.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function s(y,w){return typeof y!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:y-w}async function v(y,w){const D=y.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(D!=="none"&&(await w.saveAll(),D==="allEditorsInActiveGroup")){const S=w.activeEditorPane;S&&S.input.resource?.scheme===L.Schemas.untitled&&await w.save({editor:S.input,groupId:S.group.id})}await y.reloadConfiguration()}const f=(y,w)=>!y||!w?y===w:y.name===w.name&&y.path===w.path&&y.sourceReference===w.sourceReference;e.$BH=f}),define(ke[299],Se([1,0,53,64,24,17,12,14,32,243,145]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$Anc=e.$znc=e.$ync=e.$xnc=void 0;class P extends I.$Vrb{constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(u,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,u.on("data",i=>this.v(i))}sendMessage(u){if(this.l){const n=JSON.stringify(u);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${P.a}${n}`,"utf8")}}v(u){for(this.p=Buffer.concat([this.p,u]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(P.a);if(n!==-1){const d=this.p.toString("utf8",0,n).split(P.b);for(const o of d){const t=o.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+P.a.length);continue}}break}}}e.$xnc=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.i=/: */;class b extends P{startSession(){return new Promise((u,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),u(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",d=>{i?this.n.fire(d):n(d)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$ync=b;class k extends b{constructor(u){super(),this.z=u}y(u){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",u)}}e.$znc=k;class p extends b{constructor(u){super(),this.z=u}y(u){return N.createConnection(this.z.path,u)}}e.$Anc=p;class h extends P{constructor(u,n){super(),this.y=u,this.z=n}async startSession(){const u=this.y.command,n=this.y.args,i=this.y.options||{};try{if(u)if(R.$jc(u)){if(!await m.Promises.exists(u))throw new Error(E.localize(0,null,u))}else u.indexOf("/")<0&&u.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let d=process.env;if(i.env&&Object.keys(i.env).length>0&&(d=A.$7n(A.$4n(process.env),i.env)),u==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:d,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const l=a.fork(n[0],n.slice(1),t);if(!l.pid)throw new Error(E.localize(2,null,n[0]));this.x=l}else throw new Error(E.localize(3,null));else{const o={env:d};i.cwd&&(o.cwd=i.cwd),this.x=a.spawn(u,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(d){this.n.fire(d)}}async stopSession(){return this.x?(await this.w(),L.$c?new Promise((u,n)=>{const i=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(d,o,t){if(d)return n(d)});i.on("exit",u),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(u,n){if(!u)return;const i=Object.create(null);u.runtime&&(u.runtime.indexOf("./")===0?i.runtime=R.$kc(n,u.runtime):i.runtime=u.runtime),u.runtimeArgs&&(i.runtimeArgs=u.runtimeArgs),u.program&&(R.$jc(u.program)?i.program=u.program:i.program=R.$kc(n,u.program)),u.args&&(i.args=u.args);const d=u;return d.win&&(i.win=h.A(d.win,n)),d.winx86&&(i.winx86=h.A(d.winx86,n)),d.windows&&(i.windows=h.A(d.windows,n)),d.osx&&(i.osx=h.A(d.osx,n)),d.linux&&(i.linux=h.A(d.linux,n)),i}static platformAdapterExecutable(u,n){let i=Object.create(null);n=n.toLowerCase();for(const c of u)if(c.contributes){const s=c.contributes.debuggers;s&&s.length>0&&s.filter(v=>typeof v.type=="string"&&$.$yf(v.type,n)).forEach(v=>{const f=h.A(v,c.extensionLocation.fsPath);i=A.$7n(i,f,c.isBuiltin)})}let d;L.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?d=i.winx86||i.win||i.windows:L.$c?d=i.win||i.windows:L.$d?d=i.osx:L.$e&&(d=i.linux),d=d||i;const o=d.program||i.program,t=d.args||i.args,l=d.runtime||i.runtime,r=d.runtimeArgs||i.runtimeArgs;if(l)return{type:"executable",command:l,args:(r||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$Bnc=h}),define(ke[300],Se([1,0,53,30,12]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=L,e.$Dnc=m;function R(E,I){return new Promise((P,b)=>{let k="";const p=a.spawn(E,I);p.pid&&p.stdout.on("data",h=>{k+=h.toString()}),p.on("error",h=>{b(h)}),p.on("close",h=>{P(k)})})}async function L(E){if(E)if(A.$c){const I=await new Promise((P,b)=>{ie(["@vscode/windows-process-tree"],P,b)});return new Promise(P=>{I.getProcessTree(E,b=>{P(!!b&&b.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(E)]).then(I=>{const P=I.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var $;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})($||($={}));function m(E,I,P,b,k){E=E.trim().toLowerCase();let p;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?p=1:E.indexOf("cmd.exe")>=0?p=0:E.indexOf("bash")>=0?p=2:A.$c?p=0:p=2;let h,g=" ";switch(p){case 1:if(h=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),b){const u=(0,N.$Bg)(b);u&&(g+=`${u}:; `),g+=`cd ${h(b)}; `}if(k)for(const u in k){const n=k[u];n===null?g+=`Remove-Item env:${u}; `:g+=`\${env:${u}}='${n}'; `}if(I.length>0){const u=I.shift(),n=P?u:h(u);g+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of I)g+=i==="<"||i===">"||P?i:h(i),g+=" "}break;case 0:if(h=u=>(u=u.replace(/\"/g,'""'),u=u.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>u.includes(n))||u.length===0?`"${u}"`:u),b){const u=(0,N.$Bg)(b);u&&(g+=`${u}: && `),g+=`cd ${h(b)} && `}if(k){g+='cmd /C "';for(const u in k){let n=k[u];n===null?g+=`set "${u}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),g+=`set "${u}=${n}" && `)}}for(const u of I)g+=u==="<"||u===">"||P?u:h(u),g+=" ";k&&(g+='"');break;case 2:{h=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const u=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(b&&(g+=`cd ${h(b)} ; `),k){g+="/usr/bin/env";for(const n in k){const i=k[n];i===null?g+=` -u ${u(n)}`:g+=` ${u(`${n}=${i}`)}`}g+=" "}for(const n of I)g+=n==="<"||n===">"||P?n:h(n),g+=" ";break}}return g}}),define(ke[301],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.CellExecutionUpdateType=void 0;var N;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$PK=(0,a.$wi)("INotebookExecutionService")}),define(ke[302],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njb=e.$mjb=e.ProxyKernelState=e.$ljb=void 0,e.$ljb=100;var N;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$mjb=(0,a.$wi)("INotebookKernelService"),e.$njb=(0,a.$wi)("INotebookKernelHistoryService")}),define(ke[303],Se([1,0,3,29,198,105]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oXb=void 0;class L extends a.$Vc{constructor(m,E,I){super(),this._source=m,this.b=E,this.c=I,this.a=void 0}f(m){const E=m.getLineCount();return new N.$vt(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new A.$3C;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:I,disposable:P}=E.create(1);this.b=I,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new A.$3C;E.acceptChunk(m);const I=E.finish(!0),{textBuffer:P,disposable:b}=I.create(1);return this.B(b),P})),this.a}findInInputs(m){const I=new R.$QC(m,!1,!1,null).parseSearchRequest();if(!I)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,I,!0,5e3)}findInOutputs(m){const I=new R.$QC(m,!1,!1,null).parseSearchRequest();return I?this.outputTextBuffers.map(P=>{const b=P.findMatchesLineByLine(this.f(P),I,!0,5e3);if(b.length!==0)return{textBuffer:P,matches:b}}).filter(P=>!!P):[]}}e.$oXb=L}),define(ke[69],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a||(e.TestIdPathParts=a={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class A{static fromExtHostTestItem(L,$,m=L.parent){if(L._isRoot)return new A([$]);const E=[L.id];for(let I=m;I&&I.id!==$;I=I.parent)E.push(I.id);return E.push($),new A(E.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const $=L.indexOf("\0");return $===-1?L:L.slice(0,$)}static fromString(L){return new A(L.split("\0"))}static join(L,$){return new A([...L.path,$])}static joinToString(L,$){return L.toString()+"\0"+$}static parentId(L){const $=L.lastIndexOf("\0");return $===-1?void 0:L.slice(0,$)}static localId(L){const $=L.lastIndexOf("\0");return $===-1?L:L.slice($+1)}static isChild(L,$){return $.startsWith(L)&&$[L.length]==="\0"}static compare(L,$){return L===$?0:A.isChild(L,$)?2:A.isChild($,L)?3:1}constructor(L,$=L.length){if(this.path=L,this.d=$,L.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new A(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new A(this.path,L)}compare(L){if(typeof L=="string")return A.compare(this.toString(),L);for(let $=0;$<L.d&&$<this.d;$++)if(L.path[$]!==this.path[$])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$VL=A}),define(ke[89],Se([1,0,2,54,29,69]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$3L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2L=e.$1L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YL=e.$XL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$WL=e.TestResultState=void 0;var L;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$WL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var $;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var m;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$XL=[2,4,8,16,32,64];const E=M=>"runId"in M;e.$YL=E;var I;(function(M){M.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),M.deserialize=(F,O)=>({range:A.$vt.lift(O.range),uri:F.asCanonicalUri(a.URI.revive(O.uri))})})(I||(e.IRichLocation=I={}));var P;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(P||(e.TestMessageType=P={}));var b;(function(M){M.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.serialize(F.location)}),M.deserialize=(F,O)=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&I.deserialize(F,O.location)})})(b||(e.ITestErrorMessage=b={}));const k=(M,F)=>`${F?"s":"e"}${M}`;e.$ZL=k;var p;(function(M){M.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&I.serialize(F.location)}),M.deserialize=(F,O)=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&I.deserialize(F,O.location)})})(p||(e.ITestOutputMessage=p={}));var h;(function(M){M.serialize=F=>F.type===0?b.serialize(F):p.serialize(F),M.deserialize=(F,O)=>O.type===0?b.deserialize(F,O):p.deserialize(F,O)})(h||(e.ITestMessage=h={}));var g;(function(M){M.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),M.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(h.serialize)}),M.deserialize=(F,O)=>({state:O.state,duration:O.duration,messages:O.messages.map(q=>h.deserialize(F,q))})})(g||(e.ITestTaskState=g={}));const u="\0",n=(M,F)=>M+u+F;e.$1L=n;const i=M=>{const F=M.indexOf(u);return{ctrlId:M.slice(0,F),tagId:M.slice(F+1)}};e.$2L=i;var d;(function(M){M.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),M.deserialize=(F,O)=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?F.asCanonicalUri(a.URI.revive(O.uri)):void 0,range:O.range?A.$vt.lift(O.range):null,description:O.description,error:O.error,sortText:O.sortText})})(d||(e.ITestItem=d={}));var o;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(M){M.serialize=F=>({expand:F.expand,item:d.serialize(F.item)}),M.deserialize=(F,O)=>({controllerId:R.$VL.root(O.item.extId),expand:O.expand,item:d.deserialize(F,O.item)})})(t||(e.InternalTestItem=t={}));var l;(function(M){M.serialize=F=>{let O;return F.item&&(O={},F.item.label!==void 0&&(O.label=F.item.label),F.item.tags!==void 0&&(O.tags=F.item.tags),F.item.busy!==void 0&&(O.busy=F.item.busy),F.item.uri!==void 0&&(O.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(O.range=F.item.range?.toJSON()),F.item.description!==void 0&&(O.description=F.item.description),F.item.error!==void 0&&(O.error=F.item.error),F.item.sortText!==void 0&&(O.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:O}},M.deserialize=F=>{let O;return F.item&&(O={},F.item.label!==void 0&&(O.label=F.item.label),F.item.tags!==void 0&&(O.tags=F.item.tags),F.item.busy!==void 0&&(O.busy=F.item.busy),F.item.range!==void 0&&(O.range=F.item.range?A.$vt.lift(F.item.range):null),F.item.description!==void 0&&(O.description=F.item.description),F.item.error!==void 0&&(O.error=F.item.error),F.item.sortText!==void 0&&(O.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:O}}})(l||(e.ITestItemUpdate=l={}));const r=(M,F)=>{F.expand!==void 0&&(M.expand=F.expand),F.item!==void 0&&(M.item=M.item?Object.assign(M.item,F.item):F.item)};e.$3L=r;var c;(function(M){M.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serializeWithoutMessages)}),M.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serialize)}),M.deserialize=(F,O)=>({...t.deserialize(F,O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(q=>g.deserialize(F,q)),retired:!0})})(c||(e.TestResultItem=c={}));var s;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(F,O)=>{F.covered+=O.covered,F.total+=O.total}})(s||(e.ICoverageCount=s={}));var v;(function(M){M.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,uri:F.uri.toJSON()}),M.deserialize=(F,O)=>({id:O.id,statement:O.statement,branch:O.branch,declaration:O.declaration,uri:F.asCanonicalUri(a.URI.revive(O.uri))})})(v||(e.IFileCoverage=v={}));function f(M){return{...M,location:M.location?.toJSON()}}function y(M){return M.location=M.location?N.$ut.isIPosition(M.location)?N.$ut.lift(M.location):A.$vt.lift(M.location):void 0,M}e.$4L=3;var w;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(w||(e.DetailType=w={}));var D;(function(M){M.serialize=F=>F.type===0?C.serialize(F):j.serialize(F),M.deserialize=F=>F.type===0?C.deserialize(F):j.deserialize(F)})(D||(e.CoverageDetails=D={}));var S;(function(M){M.serialize=f,M.deserialize=y})(S||(e.IBranchCoverage=S={}));var C;(function(M){M.serialize=f,M.deserialize=y})(C||(e.IDeclarationCoverage=C={}));var j;(function(M){M.serialize=F=>({...f(F),branches:F.branches?.map(S.serialize)}),M.deserialize=F=>({...y(F),branches:F.branches?.map(S.deserialize)})})(j||(e.IStatementCoverage=j={}));var B;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(B||(e.TestDiffOpType=B={}));var z;(function(M){M.deserialize=(F,O)=>O.op===0?{op:O.op,item:t.deserialize(F,O.item)}:O.op===1?{op:O.op,item:l.deserialize(O.item)}:O.op===2?{op:O.op,uri:F.asCanonicalUri(a.URI.revive(O.uri)),docv:O.docv}:O,M.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:l.serialize(F.item)}:F})(z||(e.TestsDiffOp=z={}));class T{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const O=this.v();for(const q of F)switch(q.op){case 0:this.l(t.deserialize(this.k,q.item),O);break;case 1:this.o(l.deserialize(q.item),O);break;case 3:this.p(q.itemId,O);break;case 5:this.q(q.itemId);break;case 4:this.updatePendingRoots(q.amount);break;case 6:this.c.set(q.tag.id,q.tag);break;case 7:this.c.delete(q.id);break}O.complete?.()}l(F,O){const q=R.$VL.parentId(F.item.extId)?.toString();let Y;if(!q)Y=this.w(F),this.g.add(Y),this.f.set(F.item.extId,Y);else if(this.f.has(q)){const V=this.f.get(q);V.children.add(F.item.extId),Y=this.w(F,V),this.f.set(F.item.extId,Y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return O.add?.(Y),F.expand===2&&this.h++,Y}o(F,O){const q=this.f.get(F.extId);if(q)return F.expand!==void 0&&(q.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$3L)(q,F),O.update?.(q),q}p(F,O){const q=this.f.get(F);if(!q)return;const Y=R.$VL.parentId(q.item.extId)?.toString();Y?this.f.get(Y).children.delete(q.item.extId):this.g.delete(q);const V=[[F]];for(;V.length;)for(const J of V.pop()){const x=this.f.get(J);x&&(V.push(x.children),this.f.delete(J),O.remove?.(x,x!==q),x.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$5L=T}),define(ke[114],Se([1,0,7,4,3,62,89,69]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(n,i)=>n===i,P=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(d=>!i.includes(d)))}),b=(n,i)=>{let d;for(const[o,t]of P)t(n[o],i[o])||(d?d[o]=i[o]:d={[o]:i[o]});return d};class k extends A.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new a.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new N.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const d of this.tree.values())this.J(d)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const d of this.m)if(d.op===2&&d.uri===i.uri){d.docv=i.docv;return}break}case 1:{const d=this.m[this.m.length-1];if(d){if(d.op===1&&d.item.extId===i.item.extId){(0,L.$3L)(d.item,i.item);return}if(d.op===0&&d.item.item.extId===i.item.extId){(0,L.$3L)(d.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,d){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||d>o.expandLevels)&&(o.expandLevels=d),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,d-1):t.wait().then(()=>this.L(o,d-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,d-1)):this.L(o,d-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,d){switch(d.op){case 3:this.O($.$VL.joinToString(i.fullId,d.id));break;case 0:this.z(d.item,i);break;case 5:for(const o of d.ops)this.w(i,o);break;case 1:this.C(d.new,d.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:d.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$fd)(d)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,d){const o=$.$VL.fromExtHostTestItem(i,this.root.id,d?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==d?.actual&&this.s.getChildren(t.parent).delete(i.id);let l=this.tree.get(o.toString());if(!l){l={fullId:o,actual:i,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,d),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,d);return}if(l.actual===i){this.H(i,l,d);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,d);const r=this.s.getChildren(l.actual),c=l.actual,s=b(this.s.toITestItem(c),this.s.toITestItem(i));this.s.getApiFor(c).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(i.tags,c.tags,o.toString()),delete s.tags),this.w(l,{op:4,update:s})),this.I(i,l,d);for(const[f,y]of r)this.s.getChildren(i).get(y.id)||this.O($.$VL.joinToString(o,y.id));const v=l.expandLevels;v!==void 0&&queueMicrotask(()=>{l.expand===1&&(l.expandLevels=void 0,this.expand(o.toString(),v))}),this.y(l.actual.uri)}C(i,d,o){const t=new Set(d.map(l=>l.id));for(const l of i)t.delete(l.id)||this.D(l);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(l=>(0,L.$1L)(this.s.controllerId,l.id))}}}),t.forEach(this.F,this)}D(i){const d=this.j.get(i.id);d?d.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$1L)(this.s.controllerId,i.id)}}))}F(i){const d=this.j.get(i);d&&!--d.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,L.$1L)(this.s.controllerId,i)}))}G(i,d){this.s.getApiFor(i).parent=d&&d.actual!==this.root?d.actual:void 0}H(i,d,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=l=>this.w(d,l),this.J(d)}I(i,d,o){this.H(i,d,o);for(const[t,l]of this.s.getChildren(i))this.z(l,d)}J(i){let d;this.h?i.resolveBarrier?d=i.resolveBarrier.isOpen()?3:2:d=i.actual.canResolveChildren?1:0:d=0,d!==i.expand&&(i.expand=d,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:d}}),d===1&&i.expandLevels!==void 0&&this.M(i))}L(i,d){if(d<0)return;const o=[];for(const[t,l]of this.s.getChildren(i.actual)){const r=this.expand($.$VL.joinToString(i.fullId,l.id),d);(0,a.$ih)(r)&&o.push(r)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new a.$vh;return l.open(),l}i.expand=2,this.N(i);const d=i.resolveBarrier=new a.$vh,o=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(l){o(l)}return(0,a.$ih)(t)?t.catch(o).then(()=>{d.open(),this.J(i)}):(d.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const d=this.tree.get(i);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[d];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const l of t.actual.tags)this.F(l.id);this.tree.delete(t.fullId.toString());for(const[l,r]of this.s.getChildren(t.actual))o.push(this.tree.get($.$VL.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$nP=k;class p extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$oP=p;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pP=h;class g extends Error{constructor(i,d,o){super(`TestItem with ID "${i}" is from controller "${d}" and cannot be added as a child of an item from controller "${o}".`)}}e.$qP=g;const u=(n,i,d)=>{let o=new Map;return{get size(){return o.size},forEach(t,l){for(const r of o.values())t.call(l,r,this)},[Symbol.iterator](){return o.entries()},replace(t){const l=new Map,r=new Set(o.keys()),c={op:5,ops:[]};for(const s of t){if(!(s instanceof d))throw new h(s.id);const v=i(s).controllerId;if(v!==n.controllerId)throw new g(s.id,v,n.controllerId);if(l.has(s.id))throw new p(s.id);l.set(s.id,s),r.delete(s.id),c.ops.push({op:0,item:s})}for(const s of r.keys())c.ops.push({op:3,id:s});n.listener?.(c),o=l},add(t){if(!(t instanceof d))throw new h(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$rP=u}),define(ke[146],Se([1,0,114]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=void 0;const N=new WeakMap,A=(L,$)=>{const m={controllerId:$};return N.set(L,m),m};e.$sP=A;const R=L=>{const $=N.get(L);if(!$)throw new a.$pP(L?.id||"<unknown>");return $};e.$tP=R}),define(ke[115],Se([1,0,15,2]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZAb=e.$YAb=e.$XAb=void 0,e.$1Ab=A,e.$2Ab=L,e.$XAb="vscode-cdn.net",e.$YAb=`vscode-resource.${e.$XAb}`,e.$ZAb=`'self' https://*.${e.$XAb}`;function A($,m){return $.scheme===a.Schemas.http||$.scheme===a.Schemas.https?$:(m&&m.authority&&m.isRemote&&$.scheme===a.Schemas.file&&($=N.URI.from({scheme:a.Schemas.vscodeRemote,authority:m.authority,path:$.path})),N.URI.from({scheme:a.Schemas.https,authority:`${$.scheme}+${R($.authority)}.${e.$YAb}`,path:$.path,fragment:$.fragment,query:$.query}))}function R($){return $.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function L($){return $.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[304],Se([1,0,4,3,115]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class R{constructor($,m,E){this.d=$,this.e=m,this.f=E,this.a=0,this.b=new N.$Uc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const I=m.getVisibleTextEditors();for(const P of this.c.values())I.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,m,E,I,P){let b;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===$){b=i;break}if(!b)throw new Error("not a visible editor");const k=this,p=this.a++,h=new a.$ee,g=new a.$ee,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,A.$1Ab)(i,k.f)}get cspSource(){return A.$ZAb}set options(i){this.b=i,k.d.$setOptions(p,i)}get options(){return this.b}set html(i){this.a=i,k.d.$setHtml(p,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return k.d.$postMessage(p,i)}},n=new class{constructor(){this.editor=$,this.line=m,this.height=E,this.webview=u,this.onDidDispose=g.event}dispose(){k.c.has(p)&&(k.c.delete(p),k.d.$disposeEditorInset(p),g.fire(),g.dispose(),h.dispose())}};return this.d.$createEditorInset(p,b.id,b.value.document.uri,m+1,E,I||{},P.identifier,P.extensionLocation),this.c.set(p,{editor:$,inset:n,onDidReceiveMessage:h}),n}$onDidDispose($){const m=this.c.get($);m&&m.inset.dispose()}$onDidReceiveMessage($,m){this.c.get($)?.onDidReceiveMessage.fire(m)}}e.$ylc=R}),define(ke[147],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=void 0,e.$_L="__",e.$aM=(0,a.$wi)("IAuthenticationService"),e.$bM=(0,a.$wi)("IAuthenticationExtensionsService")}),define(ke[305],Se([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.VariableKind=e.$jQ=void 0,e.$jQ=(0,a.$wi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class A extends Error{constructor(L,$){super($),this.variable=L}}e.$kQ=A}),define(ke[306],Se([1,0,17,50,18,24,12,102,246,305,14]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;class P{constructor(k,p,h,g){this.h=new Map,this.a=k,this.b=p,this.g=h,g&&(this.c=g.then(u=>this.i(u)))}i(k){if(L.$c){const p=Object.create(null);return Object.keys(k).forEach(h=>{p[h.toLowerCase()]=k[h]}),p}return k}resolveWithEnvironment(k,p,h){return this.l({env:this.i(k),userHome:void 0},p?p.uri:void 0,h)}async resolveAsync(k,p){const h={env:await this.c,userHome:await this.g};return this.l(h,k?k.uri:void 0,p)}async j(k,p,h,g){const u=R.$4n(p);L.$c&&u.windows?Object.keys(u.windows).forEach(i=>u[i]=u.windows[i]):L.$d&&u.osx?Object.keys(u.osx).forEach(i=>u[i]=u.osx[i]):L.$e&&u.linux&&Object.keys(u.linux).forEach(i=>u[i]=u.linux[i]),delete u.windows,delete u.osx,delete u.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,k?k.uri:void 0,u,h,g)}async resolveAnyAsync(k,p,h){return this.j(k,p,h)}async resolveAnyMap(k,p,h){const g=new Map;return{newConfig:await this.j(k,p,h,g),resolvedVariables:g}}resolveWithInteractionReplace(k,p,h,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,p,h,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,p){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,p)}async l(k,p,h,g,u){if(A.$9f(h))return this.m(k,p,h,g,u);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(k,p,n,g,u)));if(A.$$f(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async d=>[await this.m(k,p,d,g,u),await this.l(k,p,h[d],g,u)]));for(const[d,o]of i)n[d]=o;return n}return h}m(k,p,h,g,u){return(0,I.$qf)(h,P.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(P.VARIABLE_LHS))return n;let d=await this.o(k,n,i,p,g);return u?.set(i,d),d!==n&&A.$9f(d)&&d.match(P.VARIABLE_REGEXP)&&(d=await this.m(k,p,d,g,u)),d})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,p,h,g,u){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const d=l=>{const r=this.a.getFilePath();if(r)return(0,$.$Fw)(r);throw new E.$kQ(l,(0,m.localize)(0,null,p))},o=l=>{const r=d(l);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,$.$Fw)(c)}throw new E.$kQ(l,(0,m.localize)(1,null,p,a.$oc(r)))},t=l=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new E.$kQ(l,(0,m.localize)(2,null,p,n))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new E.$kQ(l,(0,m.localize)(3,null,p)):new E.$kQ(l,(0,m.localize)(4,null,p))};switch(h){case"env":if(n){if(k.env){const l=k.env[L.$c?n.toLowerCase():n];if(A.$9f(l))return l}return""}throw new E.$kQ(E.VariableKind.Env,(0,m.localize)(5,null,p));case"config":if(n){const l=this.a.getConfigurationValue(g,n);if(A.$fg(l))throw new E.$kQ(E.VariableKind.Config,(0,m.localize)(6,null,p,n));if(A.$$f(l))throw new E.$kQ(E.VariableKind.Config,(0,m.localize)(7,null,p,n));return l}throw new E.$kQ(E.VariableKind.Config,(0,m.localize)(8,null,p));case"command":return this.p(E.VariableKind.Command,p,n,u,"command");case"input":return this.p(E.VariableKind.Input,p,n,u,"input");case"extensionInstallFolder":if(n){const l=await this.a.getExtension(n);if(!l)throw new E.$kQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,p,n));return this.n(l.extensionLocation)}throw new E.$kQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,p));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,$.$Fw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return g||n?(0,$.$Fw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Fw)(a.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new E.$kQ(E.VariableKind.UserHome,(0,m.localize)(11,null,p))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new E.$kQ(E.VariableKind.LineNumber,(0,m.localize)(12,null,p))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new E.$kQ(E.VariableKind.SelectedText,(0,m.localize)(13,null,p))}case"file":return d(E.VariableKind.File);case"fileWorkspaceFolder":return o(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return a.$oc(o(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||n?a.$mc(this.n(t(E.VariableKind.RelativeFile)),d(E.VariableKind.RelativeFile)):d(E.VariableKind.RelativeFile);case"relativeFileDirname":{const l=a.$nc(d(E.VariableKind.RelativeFileDirname));if(g||n){const r=a.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return a.$nc(d(E.VariableKind.FileDirname));case"fileExtname":return a.$pc(d(E.VariableKind.FileExtname));case"fileBasename":return a.$oc(d(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=a.$oc(d(E.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-a.$pc(l).length)}case"fileDirnameBasename":return a.$oc(a.$nc(d(E.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||p}case"execInstallFolder":{const l=this.a.getAppRoot();return l||p}case"pathSeparator":case"/":return a.sep;default:try{const l=n?`${h}:${n}`:h;return this.p(E.VariableKind.Unknown,p,l,u,void 0)}catch{return p}}}}p(k,p,h,g,u){if(h&&g){const n=u===void 0?g[h]:g[u+":"+h];if(typeof n=="string")return n;throw new E.$kQ(k,(0,m.localize)(14,null,p))}return p}}e.$zQ=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ke[148],Se([1,0,5,144]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=E,e.$1D=b,e.$2D=k,e.$YD=(0,a.$wi)("editorGroupsService");var A;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var m;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(p){const h=p;return(0,N.$JF)(h?.editor)&&(0,N.$JF)(h?.replacement)}var I;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var P;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function b(p){const h=p;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function k(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[307],Se([1,0,5,148]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=A,e.$3D=(0,a.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function A(R){const L=R;return typeof R=="number"||(0,N.$1D)(L)}}),define(ke[149],Se([1,0,5,138]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=void 0,e.$uM=(0,a.$xi)(N.$Di)}),define(ke[150],Se([1,0,25,4,17,3,7]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=e.$T_b=void 0;class ${constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$T_b=$;class m{static isHostExtension(n,i,d){if(i.getExtensionDescription(n))return!1;const o=d.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$ee,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new a.$Um,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const d of i)this.h.has(d)||this.h.set(d,[]),this.h.get(d).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=g(this.e,i),this.e=this.e.concat(n);const d=m.l(this.e);return this.e=g(this.e,d.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new $(this.d,d)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,c){this.addNode(r),this.addNode(c),this.c.has(r)?this.c.get(r).push(c):this.c.set(r,[c])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,c){const s=i.getArcs(r);for(let v=0;v<s.length;v++)if(!c.has(s[v]))return!1;return!0}getNodes(){return this.e}},d=new a.$Um;for(const r of n)if(d.set(r.identifier,r),r.extensionDependencies)for(const c of r.extensionDependencies)i.addArc(a.$Sm.toKey(r.identifier),a.$Sm.toKey(c));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const t=i.getNodes().filter(r=>!o.has(r));let l;do{l=!1;for(let r=0;r<t.length;r++){const c=t[r];i.hasOnlyGoodArcs(c,o)&&(t.splice(r,1),r--,o.add(c),l=!0)}}while(l);return t.map(r=>d.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$U_b=m;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$V_b=E;class I{constructor(n){this.d=new k,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new P(this,i)}deltaExtensions(n,i,d){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,d)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$W_b=I;class P extends R.$Vc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$X_b=P;class b{constructor(n){this.name=n;const i=(0,L.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class k{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new b(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const d=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(d),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Tc)(o))}}var p;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(p||(p={}));function h(u,n){const i=u.isBuiltin?0:u.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==d)return i-d;const o=A.$hc.basename(u.extensionLocation.path),t=A.$hc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function g(u,n){const i=new a.$Tm(n);return u.filter(d=>!i.has(d.identifier))}}),define(ke[308],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.ExtHostConnectionType=void 0,e.$on=$,e.$pn=m;var a;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(a||(e.ExtHostConnectionType=a={}));class N{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[N.ENV_KEY]=this.pipeName}}e.$ln=N,N.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class A{constructor(){this.type=2}serialize(P){P[A.ENV_KEY]="1"}}e.$mn=A,A.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}e.$nn=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(I){delete I[N.ENV_KEY],delete I[A.ENV_KEY],delete I[R.ENV_KEY]}function $(I,P){L(P),I.serialize(P)}function m(I){if(I[N.ENV_KEY])return E(I,new N(I[N.ENV_KEY]));if(I[A.ENV_KEY])return E(I,new A);if(I[R.ENV_KEY])return E(I,new R);throw new Error("No connection information defined in environment!")}function E(I,P){return L(I),P}}),define(ke[116],Se([1,0,21]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$1m=L,e.$2m=$;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var A;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(E){const I=a.$Ge.alloc(1);switch(E){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}function $(E,I){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(ke[90],Se([1,0,5,4,11,28,116,86,87,24,2,3,231]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=e.$PP=e.$OP=void 0,e.$QP=h;let k=class extends P.$Vc{constructor(u,n){super(),this.s=u,this.t=n,this.a=this.B(new N.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=I.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$lp,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,A.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,n,i){const d=this.getTelemetryDetails(),o=new p(n,i,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}),t=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(u,n,i){this.f=u,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const n=Object.create(null);switch(n["common.extname"]=`${u.publisher}.${u.name}`,n["common.extversion"]=u.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:n["common.uikind"]="web";break;case L.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Jm)((0,m.$rp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const n=this.getTelemetryDetails();this.r.forEach((i,d)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(d):this.r.set(d,o)}),this.r.forEach(i=>{for(const d of i)d.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,n){const d=this.r.get(u.value)?.filter(t=>!t.isDisposed);if(!d)return this.r.delete(u.value),!1;let o=!1;for(const t of d)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$OP=k,e.$OP=k=Je([Ue(0,R.$NP),Ue(1,A.$4j)],k);class p{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,n,i,d,o,t,l){this.g=i,this.h=d,this.i=o,this.j=t,this.a=new N.$ee,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(u,n){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let n="properties"in u?u.properties??{}:u;return n=(0,m.$up)(n,[]),this.c&&(n=(0,E.$7n)(n,this.c)),this.b||(n=(0,E.$7n)(n,this.j)),"properties"in u?u.properties=n:u=n,u}k(u,n){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(u,n),this.h.trace(u,n))}logUsage(u,n){this.d.isUsageEnabled&&this.k(u,n)}logError(u,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,n);else{const i={name:u.name,message:u.message,stack:u.stack,cause:u.cause},d=(0,m.$up)(i,[]),o=new Error(d.message,{cause:d.cause});o.stack=d.stack,o.name=d.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const u=this,n={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$PP=p;function h(g){const u=Date.now()-new Date(g).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$RP=(0,a.$wi)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,278,141,25,5]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=b,e.$PG=k,e.$SG=u,e.$TG=n,e.$JG=Object.freeze({identifier:new L.$Sm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,$.$wi)("extensionService");class m{constructor(o){this.dependency=o}}e.$MG=m;var E;(function(d){d[d.EagerAutoStart=1]="EagerAutoStart",d[d.EagerManualStart=2]="EagerManualStart",d[d.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,l){this.c=o,this.d=t.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$uG.createActivationEventsMap(this.d)}}set(o,t,l){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const r=[],c=[],s=[],v=[],f=P(this.d),y=P(t),w=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.d){const z=y.get(B.identifier);if(!z){r.push(B.identifier),f.delete(B.identifier);continue}if(!w(B,z)){r.push(B.identifier),f.delete(B.identifier);continue}}for(const B of t){const z=f.get(B.identifier);if(!z){c.push(B);continue}if(!w(z,B)){r.push(z.identifier),f.delete(z.identifier);continue}}const D=new L.$Tm(this.e),S=new L.$Tm(l);for(const B of this.e)S.has(B)||s.push(B);for(const B of l)D.has(B)||v.push(B);const C=R.$uG.createActivationEventsMap(c),j={versionId:o,toRemove:r,toAdd:c,addActivationEvents:C,myToRemove:s,myToAdd:v};return this.delta(j),j}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:l,myToRemove:r,myToAdd:c}=o,s=new L.$Tm(t),v=new L.$Tm(r);for(let f=0;f<this.d.length;f++)s.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)v.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of l)this.d.push(f);for(const f of c)this.e.push(f);return this.f=null,o}containsExtension(o){for(const t of this.e)if(L.$Sm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const l=R.$uG.readActivationEvents(t);for(const r of l)o.add(r)}return o}}e.$NG=I;function P(d){const o=new L.$Um;for(const t of d)o.set(t.identifier,t);return o}function b(d,o){return!0}function k(d,o){if(!b(d,o))throw new Error(`Extension '${d.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${d.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${d.identifier.value}`)}class p{constructor(o,t,l,r){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=l,this.activationReason=r}}e.$QG=p;class h{constructor(o,t){this.description=o,this.value=t}}e.$RG=h;var g;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function u(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,A.$Ap)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation,targetPlatform:d.targetPlatform,validations:[],isValid:!0}}function n(d,o){return{identifier:new L.$Sm((0,A.$yp)(d.manifest.publisher,d.manifest.name)),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!o,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid,targetPlatform:d.targetPlatform,publisherDisplayName:d.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.onWillStop=a.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(ke[309],Se([1,0,13,150,25,26,11,7]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=e.$Xlc=e.$Wlc=e.$Vlc=e.$Ulc=void 0;class m{constructor(u,n,i,d){this.startup=u,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=d}}e.$Ulc=m,m.NONE=new m(!1,-1,-1,-1);class E{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,n){return u===-1||n===-1?-1:n-u}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Vlc=E;class I{constructor(u,n,i,d,o,t){this.activationFailed=u,this.activationFailedError=n,this.activationTimes=i,this.module=d,this.exports=o,this.subscriptions=t}}e.$Wlc=I;class P extends I{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xlc=P;class b extends I{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ylc=b;class k extends I{constructor(u){super(!0,u,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(u,n,i,d){this.g=d,this.a=u,this.b=n,this.c=i,this.d=new A.$Um,this.f=Object.create(null)}dispose(){for(const[u,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const u=[];for(const[n,i]of this.d)u.push(i.wait());await Promise.all(u)}isActivated(u){const n=this.d.get(u);return!!(n&&n.value)}getActivatedExtension(u){const n=this.d.get(u);if(!n||!n.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return n.value}async activateByEvent(u,n){if(this.f[u])return;const i=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(i.map(d=>({id:d.identifier,reason:{startup:n,extensionId:d.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,n){const i=this.a.getExtensionDescription(u);if(!i)throw new Error(`Extension '${u.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(u){const n=u.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(u){if(this.d.has(u.id))return this.d.get(u.id);if(this.l(u.id))return this.k(u,null,[],null);const n=this.a.getExtensionDescription(u.id);if(!n){const o=new Error(`Cannot activate unknown extension '${u.id.value}'`),t=this.k(u,null,[],new k(o));return this.c.onExtensionActivationError(u.id,o,new R.$MG(u.id.value)),t}const i=[],d=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of d){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:u.reason}));continue}const l=this.a.getExtensionDescription(o);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:u.reason}));continue}const r=n.displayName||n.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${o}'`),s=this.k(u,n.displayName,[],new k(c));return this.c.onExtensionActivationError(n.identifier,c,new R.$MG(o)),s}return this.k(u,n.displayName,i,null)}k(u,n,i,d){const o=new h(u.id,n,u.reason,i,d,this.c,this.g);return this.d.set(u.id,o),o}l(u){return N.$U_b.isHostExtension(u,this.a,this.b)}m(u){const n=this.b.getExtensionDescription(u);return n?!n.main&&!n.browser:!1}};e.$Zlc=p,e.$Zlc=p=Je([Ue(3,L.$3j)],p);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,n,i,d,o,t,l){this.c=u,this.d=n,this.f=i,this.g=d,this.h=o,this.j=t,this.k=l,this.a=new $.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const n=this.g[u];if(n.value&&!n.value.activationFailed){this.g.splice(u,1),u--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new k(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const n=new Error;if(u&&u.name&&(n.name=u.name),u&&u.message?n.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(n.stack=u.stack),this.h=new k(n),this.b&&a.$4(u))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};h=Je([Ue(6,L.$3j)],h)}),define(ke[310],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[311],Se([1,0,248,13,42,139,110,36,25,310,108,141]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const b=$.$do.as(L.$eo.JSONContribution);class k{constructor(o,t,l){this.a=o,this.b=t,this.c=l}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(A.default.Error,o)}warn(o){this.d(A.default.Warning,o)}info(o){this.d(A.default.Info,o)}}e.$DG=k;class p{static a(o){const t=new m.$Tm;for(let l=0,r=o.length;l<r;l++)t.add(o[l].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new p(t,[]);if(!t||!t.length)return new p([],o);const l=this.a(o),r=this.a(t),c=t.filter(v=>!l.has(v.description.identifier)),s=o.filter(v=>!r.has(v.description.identifier));return new p(c,s)}constructor(o,t){this.added=o,this.removed=t}}e.$EG=p;class h{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=p.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,N.$1)(o)}}}e.$FG=h;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Rm},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:a.localize(42,null)},{label:"*",description:a.localize(43,null),body:"*"}]}},badges:{type:"array",description:a.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(45,null)},href:{type:"string",description:a.localize(46,null)},description:{type:"string",description:a.localize(47,null)}}}},markdown:{type:"string",description:a.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Uo}},extensionPack:{description:a.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Uo}},extensionKind:{description:a.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(53,null)},{body:["workspace"],description:a.localize(54,null)},{body:["ui","workspace"],description:a.localize(55,null)},{body:["workspace","ui"],description:a.localize(56,null)},{body:[],description:a.localize(57,null)}]},capabilities:{description:a.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(61,null),a.localize(62,null),a.localize(63,null)]},description:{type:"string",markdownDescription:a.localize(64,null)}}},untrustedWorkspaces:{description:a.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(67,null),a.localize(68,null),a.localize(69,null)]},restrictedConfigurations:{description:a.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(71,null)}}}}},sponsor:{description:a.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(74,null),type:"string"},"vscode:uninstall":{description:a.localize(75,null),type:"string"}}},icon:{type:"string",description:a.localize(76,null)},l10n:{type:"string",description:a.localize(77,null)},pricing:{type:"string",markdownDescription:a.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new h(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&P.$uG.register(o.extensionPoint,o.activationEventsGenerator),e.$GG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,b.registerSchema(u,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};$.$do.add(i.ExtensionsRegistry,new n),e.$IG=$.$do.as(i.ExtensionsRegistry),b.registerSchema(u,e.$GG),b.registerSchema(I.$kk,{properties:{extensionEnabledApiProposals:{description:a.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[312],Se([1,0,244,18,24,311,38,4]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var E;(function(b){function k(p,h,g){if(!p)return;const u=N.$9f(p.type)?p.type:void 0;if(!u||u.length===0){g.error(a.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const i of p.required)N.$9f(i)&&n.push(i);return{extensionId:h.value,taskType:u,required:n,properties:p.properties?A.$4n(p.properties):{},when:p.when?L.$uj.deserialize(p.when):void 0}}b.from=k})(E||(E={}));const I=R.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,k)=>{for(const p of b)p.type&&k.push(`onTaskType:${p.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:m}});class P{constructor(){this.d=new $.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,p)=>{I.setHandler((h,g)=>{this.c=void 0;try{for(const u of g.removed){const n=u.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const u of g.added){const n=u.value;for(const i of n){const d=E.from(i,u.description.identifier,u.collector);d&&(this.a[d.taskType]=d)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const p of this.all()){const h={type:"object",additionalProperties:!1};p.required.length>0&&(h.required=p.required.slice(0)),p.properties!==void 0?h.properties=A.$4n(p.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[p.taskType]},k.push(h)}this.c={oneOf:k}}return this.c}}e.$cI=new P}),define(ke[313],Se([1,0,245,18,23,24,38,312]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new L.$Nj("taskRunning",!1,a.localize(0,null)),e.$fI=a.localize2(2,"Tasks");var m;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$gI="$customized",function(M){function F(O){if(!O)return M.Strong;switch(O.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=F}(m||(e.ShellQuoting=m={}));var E;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var I;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(I||(e.RevealKind=I={})),function(M){function F(O){switch(O.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=F}(I||(e.RevealKind=I={}));var P;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(M){function F(O){switch(O.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=F}(P||(e.RevealProblemKind=P={}));var b;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(b||(e.PanelKind=b={})),function(M){function F(O){switch(O.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=F}(b||(e.PanelKind=b={}));var k;(function(M){M.defaults={echo:!0,reveal:I.Always,revealProblems:P.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var p;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(M){function F(q){switch(q.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=F;function O(q){switch(q){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=O}(p||(e.RuntimeType=p={}));var h;(function(M){function F(O){return N.$9f(O)?O:O.value}M.value=F})(h||(e.CommandString=h={}));var g;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function F(q){return q===M.Clean._id||q===M.Build._id||q===M.Rebuild._id||q===M.Test._id}M.is=F;function O(q){if(q!==void 0)return N.$9f(q)?F(q)?{_id:q,isDefault:!1}:void 0:q}M.from=O})(g||(e.TaskGroup=g={}));var u;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function F(O){switch(O){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var i;(function(M){M.parallel="parallel",M.sequence="sequence"})(i||(e.DependsOrder=i={}));var d;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(d||(e.RunOnOptions=d={}));var o;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:d.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(F,O,q,Y,V,J){this._label="",this._id=F,O&&(this._label=O),q&&(this.type=q),this.runOptions=Y,this.configurationProperties=V,this._source=J}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,O=!1){if(F===void 0)return!1;if(N.$9f(F))return F===this._label||F===this.configurationProperties.identifier||O&&F===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$hI=t;class l extends t{constructor(F,O,q,Y,V,J,x,ne){super(F,q,void 0,x,ne,O),this.command={},this._source=O,this.hasDefinedMatchers=J,V&&(this.command=V)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let O;switch(this.command?this.command.runtime:void 0){case p.Shell:O="shell";break;case p.Process:O="process";break;case p.CustomExecution:O="customExecution";break;case void 0:O="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:O,_key:this._id,id:this._id}}}static is(F){return F instanceof l}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let O=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(O+=this._source.kind);const q={type:e.$gI,folder:F,id:O};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new l(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$iI=l;class r extends t{constructor(F,O,q,Y,V,J,x){super(F,q,Y,J,x,O),this._source=O,this.configures=V}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let O=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(O+=this._source.kind);const q={type:e.$gI,folder:F,id:O};return JSON.stringify(q)}}e.$jI=r;class c extends t{constructor(F,O,q,Y,V,J,x,ne,de){super(F,q,Y,ne,de,O),this.defines=V,this.hasDefinedMatchers=x,this.command=J,this.icon=de.icon,this.hide=de.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof c}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new c(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$kI=c;class s extends t{constructor(F,O,q,Y,V,J){super(F,q,Y,V,J,O),this._source=O}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new s(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$lI=s;var v;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(M){M._default=M.Terminal}(v||(e.ExecutionEngine=v={}));var f;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class y{constructor(F){this.c=new Map;for(let O=0;O<F.length;O++)this.c.set(F[O].uri.toString(),O)}compare(F,O){const q=F.getWorkspaceFolder(),Y=O.getWorkspaceFolder();if(q&&Y){let V=this.c.get(q.uri.toString());V=V===void 0?0:V+1;let J=this.c.get(Y.uri.toString());return J=J===void 0?0:J+1,V===J?F._label.localeCompare(O._label):V-J}else return!q&&Y?-1:q&&!Y?1:0}}e.$mI=y;var w;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(w||(e.TaskEventKind=w={}));var D;(function(M){M.SingleRun="singleRun",M.Background="background"})(D||(e.TaskRunType=D={}));var S;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var C;(function(M){function F(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function O(ne,de,ce){return{...F(ne),kind:"start",terminalId:de,resolvedVariables:ce}}M.start=O;function q(ne,de,ce){return{...F(ne),kind:"processStarted",terminalId:de,processId:ce}}M.processStarted=q;function Y(ne,de,ce){return{...F(ne),kind:"processEnded",terminalId:de,exitCode:ce}}M.processEnded=Y;function V(ne,de,ce){return{...F(ne),kind:"terminated",exitReason:ce,terminalId:de}}M.terminated=V;function J(ne,de,ce){return{...F(de),kind:ne,terminalId:ce}}M.general=J;function x(){return{kind:"changed"}}M.changed=x})(C||(e.TaskEvent=C={}));var j;(function(M){function F(q){const Y=Object.keys(q).sort();let V="";for(const J of Y){let x=q[J];x instanceof Object?x=F(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),V+=J+","+x+","}return V}function O(q){const V={_key:F(q),type:q.taskType};return Object.assign(V,q),V}M.create=O})(j||(e.KeyedTaskIdentifier=j={}));var B;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(B||(e.TaskSettingId=B={}));var z;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var T;(function(M){function F(O,q){const Y=$.$cI.get(O.type);if(Y===void 0){const ne=R.$4n(O);return delete ne._key,j.create(ne)}const V=Object.create(null);V.type=Y.taskType;const J=new Set;Y.required.forEach(ne=>J.add(ne));const x=Y.properties;for(const ne of Object.keys(x)){const de=O[ne];if(de!=null)V[ne]=de;else if(J.has(ne)){const ce=x[ne];if(ce.default!==void 0)V[ne]=R.$4n(ce.default);else switch(ce.type){case"boolean":V[ne]=!1;break;case"number":case"integer":V[ne]=0;break;case"string":V[ne]="";break;default:q.error(a.localize(1,null,JSON.stringify(O,void 0,0),ne));return}}}return j.create(V)}M.createTaskIdentifier=F})(T||(e.TaskDefinition=T={}))}),define(ke[314],Se([1,0,13]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=e.$Y_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,$)=>{this.b=L,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,a.$1)(L))}then(L,$){return this.j().then(L,$)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$Y_b=N;class A extends N{constructor(){super(),this.h=!0,this.i=new a.$5}}e.$Z_b=A}),define(ke[48],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$zw=void 0,e.$Aw=A,e.$Bw=R;class a{constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++a.count}}e.$zw=a,a.count=0;const N=[];function A($){const m=new a($);return N[m.nid]=m,m}function R($){return N[$].sid}class L{constructor(m){this.value=m}}e.$Cw=L}),define(ke[6],Se([1,0,48]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var A;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var $;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var m;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var I;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(I||(e.CandidatePortSource=I={}));class P{static mixin(g){return g._id=P.a++,g}}e.$9M=P,P.a=0;var b;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var k;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var p;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$0M={MainThreadAuthentication:(0,a.$Aw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.$Aw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,a.$Aw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,a.$Aw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,a.$Aw)("MainThreadChatVariables"),MainThreadClipboard:(0,a.$Aw)("MainThreadClipboard"),MainThreadCommands:(0,a.$Aw)("MainThreadCommands"),MainThreadComments:(0,a.$Aw)("MainThreadComments"),MainThreadConfiguration:(0,a.$Aw)("MainThreadConfiguration"),MainThreadConsole:(0,a.$Aw)("MainThreadConsole"),MainThreadDebugService:(0,a.$Aw)("MainThreadDebugService"),MainThreadDecorations:(0,a.$Aw)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.$Aw)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.$Aw)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.$Aw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.$Aw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.$Aw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.$Aw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.$Aw)("MainThreadEditorTabs"),MainThreadErrors:(0,a.$Aw)("MainThreadErrors"),MainThreadTreeViews:(0,a.$Aw)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.$Aw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,a.$Aw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.$Aw)("MainThreadLanguages"),MainThreadLogger:(0,a.$Aw)("MainThreadLogger"),MainThreadMessageService:(0,a.$Aw)("MainThreadMessageService"),MainThreadOutputService:(0,a.$Aw)("MainThreadOutputService"),MainThreadProgress:(0,a.$Aw)("MainThreadProgress"),MainThreadQuickDiff:(0,a.$Aw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.$Aw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.$Aw)("MainThreadStatusBar"),MainThreadSecretState:(0,a.$Aw)("MainThreadSecretState"),MainThreadStorage:(0,a.$Aw)("MainThreadStorage"),MainThreadSpeech:(0,a.$Aw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,a.$Aw)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.$Aw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,a.$Aw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,a.$Aw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.$Aw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.$Aw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.$Aw)("MainThreadCustomEditors"),MainThreadUrls:(0,a.$Aw)("MainThreadUrls"),MainThreadUriOpeners:(0,a.$Aw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.$Aw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.$Aw)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.$Aw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,a.$Aw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,a.$Aw)("MainThreadExtensionService"),MainThreadSCM:(0,a.$Aw)("MainThreadSCM"),MainThreadSearch:(0,a.$Aw)("MainThreadSearch"),MainThreadShare:(0,a.$Aw)("MainThreadShare"),MainThreadTask:(0,a.$Aw)("MainThreadTask"),MainThreadWindow:(0,a.$Aw)("MainThreadWindow"),MainThreadLabelService:(0,a.$Aw)("MainThreadLabelService"),MainThreadNotebook:(0,a.$Aw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.$Aw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.$Aw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.$Aw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.$Aw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.$Aw)("MainThreadInteractive"),MainThreadInlineChat:(0,a.$Aw)("MainThreadInlineChatShape"),MainThreadTheming:(0,a.$Aw)("MainThreadTheming"),MainThreadTunnelService:(0,a.$Aw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,a.$Aw)("MainThreadManagedSockets"),MainThreadTimeline:(0,a.$Aw)("MainThreadTimeline"),MainThreadTesting:(0,a.$Aw)("MainThreadTesting"),MainThreadLocalization:(0,a.$Aw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,a.$Aw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,a.$Aw)("MainThreadAiEmbeddingVector")},e.$$M={ExtHostCommands:(0,a.$Aw)("ExtHostCommands"),ExtHostConfiguration:(0,a.$Aw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.$Aw)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.$Aw)("ExtHostDebugService"),ExtHostDecorations:(0,a.$Aw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.$Aw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.$Aw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.$Aw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.$Aw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.$Aw)("ExtHostEditors"),ExtHostTreeViews:(0,a.$Aw)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.$Aw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.$Aw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.$Aw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.$Aw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.$Aw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.$Aw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.$Aw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,a.$Aw)("ExtHostStatusBar"),ExtHostShare:(0,a.$Aw)("ExtHostShare"),ExtHostExtensionService:(0,a.$Aw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.$Aw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.$Aw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,a.$Aw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,a.$Aw)("ExtHostSCM"),ExtHostSearch:(0,a.$Aw)("ExtHostSearch"),ExtHostTask:(0,a.$Aw)("ExtHostTask"),ExtHostWorkspace:(0,a.$Aw)("ExtHostWorkspace"),ExtHostWindow:(0,a.$Aw)("ExtHostWindow"),ExtHostWebviews:(0,a.$Aw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.$Aw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.$Aw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.$Aw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.$Aw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.$Aw)("ExtHostEditorTabs"),ExtHostProgress:(0,a.$Aw)("ExtHostProgress"),ExtHostComments:(0,a.$Aw)("ExtHostComments"),ExtHostSecretState:(0,a.$Aw)("ExtHostSecretState"),ExtHostStorage:(0,a.$Aw)("ExtHostStorage"),ExtHostUrls:(0,a.$Aw)("ExtHostUrls"),ExtHostUriOpeners:(0,a.$Aw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.$Aw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.$Aw)("ExtHostOutputService"),ExtHostLabelService:(0,a.$Aw)("ExtHostLabelService"),ExtHostNotebook:(0,a.$Aw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.$Aw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.$Aw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.$Aw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.$Aw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,a.$Aw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,a.$Aw)("ExtHostInteractive"),ExtHostInlineChat:(0,a.$Aw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,a.$Aw)("ExtHostChatAgents"),ExtHostChatVariables:(0,a.$Aw)("ExtHostChatVariables"),ExtHostChatProvider:(0,a.$Aw)("ExtHostChatProvider"),ExtHostSpeech:(0,a.$Aw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,a.$Aw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,a.$Aw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,a.$Aw)("ExtHostTheming"),ExtHostTunnelService:(0,a.$Aw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,a.$Aw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,a.$Aw)("ExtHostAuthentication"),ExtHostTimeline:(0,a.$Aw)("ExtHostTimeline"),ExtHostTesting:(0,a.$Aw)("ExtHostTesting"),ExtHostTelemetry:(0,a.$Aw)("ExtHostTelemetry"),ExtHostLocalization:(0,a.$Aw)("ExtHostLocalization")}}),define(ke[91],Se([1,0,5,11,6,20]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=e.$hlc=void 0,e.$hlc=(0,a.$wi)("IExtHostApiDeprecationService");let L=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(A.$0M.MainThreadTelemetry)}report(m,E,I){const P=this.d(m,E);this.a.has(P)||(this.a.add(P),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$ilc=L,e.$ilc=L=Je([Ue(0,R.$xP),Ue(1,N.$3j)],L),e.$jlc=Object.freeze(new class{report($,m,E){}})}),define(ke[315],Se([1,0,6]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class N{constructor(R){const L=R.getProxy(a.$0M.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText($){return L.$writeText($)}})}}e.$wlc=N}),define(ke[316],Se([1,0,24,6,28,20]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;let L=class{constructor(I,P){this.a=I.getProxy(N.$0M.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,P){const b=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){b.e(I,P,k,arguments)}})}e(I,P,b,k){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:m(k,this.b)}),this.c&&this.f(I,b,k)}};e.$qnc=L,e.$qnc=L=Je([Ue(0,R.$xP),Ue(1,A.$NP)],L);const $=1e5;function m(E,I){const P=[];if(E.length)for(let b=0;b<E.length;b++){let k=E[b];if(typeof k>"u")k="undefined";else if(k instanceof Error){const p=k;p.stack?k=p.stack:k=p.toString()}P.push(k)}if(I){const b=new Error().stack;b&&P.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,a.$9n)(P);return b.length>$?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(ke[317],Se([1,0,2,6,26]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;class R{constructor($){this.a=$.getProxy(N.$0M.MainThreadDialogs)}showOpenDialog($,m){return m?.allowUIResources&&(0,A.$PG)($,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(I=>a.URI.revive(I)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(m=>m?a.URI.revive(m):void 0)}}e.$tmc=R}),define(ke[318],Se([1,0,3,6]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class A{constructor(L){this.b=0,this.a=L.getProxy(N.$0M.MainThreadLabelService)}$registerResourceLabelFormatter(L){const $=this.b++;return this.a.$registerResourceLabelFormatter($,L),(0,a.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Nmc=A}),define(ke[117],Se([1,0,12,14,2,5,11,6,28,20]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=void 0;let I=class{constructor(b,k,p){this.f=p,this.d=new Map,this.a=k.getProxy($.$0M.MainThreadLocalization),this.b=b.environment.appLanguage,this.c=this.b===a.$a}getMessage(b,k){const{message:p,args:h,comment:g}=k;if(this.c)return(0,N.$0e)(p,h??{});let u=p;g&&g.length>0&&(u+=`/${Array.isArray(g)?g.join(""):g}`);const n=this.d.get(b)?.contents[u];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,N.$0e)(n??p,h??{})}getBundle(b){return this.d.get(b)?.contents}getBundleUri(b){return this.d.get(b)?.uri}async initializeLocalizedMessages(b){if(this.c||!b.l10n&&!b.isBuiltin||this.d.has(b.identifier.value))return;let k;const p=await this.g(b);if(!p){this.f.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(p),g=JSON.parse(h);k=b.isBuiltin?g.contents?.bundle:g}catch(h){this.f.error(`Failed to load translations for ${b.identifier.value} from ${p}: ${h.message}`);return}k&&this.d.set(b.identifier.value,{contents:k,uri:p})}async g(b){if(b.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(b.identifier.value,this.b);return A.URI.revive(k)}return b.l10n?A.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$bmc=I,e.$bmc=I=Je([Ue(0,m.$NP),Ue(1,E.$xP),Ue(2,L.$3j)],I),e.$cmc=(0,R.$wi)("IExtHostLocalizationService")}),define(ke[151],Se([1,0,11,6,28,20,2,58]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;let m=class extends a.$bk{constructor(P,b){super(b.logLevel,b.logsLocation,b.loggers.map(k=>(0,$.$6h)(k))),this.r=P.getProxy(N.$0M.MainThreadLogger)}$setLogLevel(P,b){b?this.setLogLevel(L.URI.revive(b),P):this.setLogLevel(P)}setVisibility(P,b){super.setVisibility(P,b),this.r.$setVisibility(P,b)}s(P,b,k){return new E(this.r,P,b,k)}};e.$pnc=m,e.$pnc=m=Je([Ue(0,R.$xP),Ue(1,A.$NP)],m);class E extends a.$9j{constructor(P,b,k,p){super(p?.logLevel==="always"),this.r=P,this.s=b,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(b,p).then(()=>{this.u(this.n),this.m=!0})}g(P,b){const k=[[P,b]];this.m?this.u(k):this.n.push(...k)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[118],Se([1,0,6,5,3,20,21]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=void 0,e.$dmc=(0,N.$wi)("IExtHostManagedSockets");let $=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(a.$0M.MainThreadManagedSockets)}setFactory(P,b){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(P,b),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const b=++this.b,k=await this.c.makeConnection(),p=new A.$Uc;return this.d.set(b,new E(b,k,p)),p.add((0,A.$Tc)(()=>this.d.delete(b))),p.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(b),p.dispose()})),p.add(k.onDidClose(h=>{this.a.$onDidManagedSocketClose(b,h?.stack??h?.message),p.dispose()})),p.add(k.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(b,L.$Ge.wrap(h)))),b}$remoteSocketWrite(P,b){this.d.get(P)?.actual.send(b.buffer)}$remoteSocketEnd(P){const b=this.d.get(P);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$emc=$,e.$emc=$=Je([Ue(0,R.$xP)],$);class m{constructor(P,b){this.socketFactoryId=P,this.makeConnection=b}}class E extends A.$Vc{constructor(P,b,k){super(),this.socketId=P,this.actual=b,this.B(k)}}}),define(ke[319],Se([1,0,6,11,26]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;function R($){return $&&$.title}let L=class{constructor(m,E){this.b=E,this.a=m.getProxy(a.$0M.MainThreadMessageService)}showMessage(m,E,I,P,b){const k={source:{identifier:m.identifier,label:m.displayName||m.name}};let p;typeof P=="string"||R(P)?p=[P,...b]:(k.modal=P?.modal,k.useCustom=P?.useCustom,k.detail=P?.detail,p=b),k.useCustom&&(0,A.$PG)(m,"resolvers");const h=[];let g=!1;for(let u=0;u<p.length;u++){const n=p[u];if(typeof n=="string")h.push({title:n,handle:u,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:d}=n;h.push({title:i,isCloseAffordance:!!d,handle:u}),d&&(g?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):g=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,I,k,h).then(u=>{if(typeof u=="number")return p[u]})}};e.$Pmc=L,e.$Pmc=L=Je([Ue(1,N.$3j)],L)}),define(ke[320],Se([1,0,3,18,2,26,6]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class ${constructor(E){this.b=new Map,this.a=E.getProxy(L.$0M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,I,P){if((0,R.$PG)(E,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,P),this.a.$registerProfileContentHandler(I,P.name,P.description,E.identifier.value),(0,a.$Tc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(E,I,P,b){const k=this.b.get(E);if(!k)throw new Error(`Unknown handler with id: ${E}`);return k.saveProfile(I,P,b)}async $readProfile(E,I,P){const b=this.b.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.readProfile((0,N.$9f)(I)?I:A.URI.revive(I),P)}}e.$Ymc=$}),define(ke[119],Se([1,0,6,4,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0;class R{constructor($){this.b=new N.$ee,this.onDidChangePassword=this.b.event,this.a=$.getProxy(a.$0M.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,m){return this.a.$getPassword($,m)}store($,m,E){return this.a.$setPassword($,m,E)}delete($,m){return this.a.$deletePassword($,m)}}e.$$lc=R,e.$_lc=(0,A.$wi)("IExtHostSecretState")}),define(ke[321],Se([1,0,22,3,6]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class R{constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(A.$0M.MainThreadSpeech)}async $createSpeechToTextSession($,m,E){const I=this.c.get($);if(!I)return;const P=new N.$Uc,b=new a.$pe;this.d.set(m,b);const k=P.add(I.provideSpeechToTextSession(b.token,E?{language:E}:void 0));P.add(k.onDidChange(p=>{b.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,p)})),P.add(b.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}async $createKeywordRecognitionSession($,m){const E=this.c.get($);if(!E)return;const I=new N.$Uc,P=new a.$pe;this.d.set(m,P);const b=I.add(E.provideKeywordRecognitionSession(P.token));I.add(b.onDidChange(k=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,k)})),I.add(P.token.onCancellationRequested(()=>I.dispose()))}async $cancelKeywordRecognitionSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,m,E){const I=R.a++;return this.c.set(I,E),this.b.$registerProvider(I,m,{extension:$,displayName:$.value}),(0,N.$Tc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$6mc=R,R.a=1}),define(ke[120],Se([1,0,6,4,5]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=void 0;class R{constructor($,m){this.c=m,this.b=new N.$ee,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(a.$0M.MainThreadStorage)}registerExtensionStorageKeysToSync($,m){this.a.$registerExtensionStorageKeysToSync($,m)}async initializeExtensionStorage($,m,E){const I=await this.a.$initializeExtensionStorage($,m);let P;return I&&(P=this.d($,m,I)),P||E}setValue($,m,E){return this.a.$setValue($,m,E)}$acceptValue($,m,E){const I=this.d($,m,E);I&&this.b.fire({shared:$,key:m,value:I})}d($,m,E){try{return JSON.parse(E)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${$}): ${I}`)}}}e.$1lc=R,e.$2lc=(0,A.$wi)("IExtHostStorage")}),define(ke[322],Se([1,0,3,15,2,6]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;class L{constructor(m){this.c=new Map,this.b=m.getProxy(R.$0M.MainThreadUriOpeners)}registerExternalUriOpener(m,E,I,P){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const b=P.schemes.find(k=>!L.a.has(k));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this.c.set(E,I),this.b.$registerUriOpener(E,P.schemes,m,P.label),(0,a.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,I){const P=this.c.get(m);if(!P)throw new Error(`Unknown opener with id: ${m}`);const b=A.URI.revive(E);return P.canOpenExternalUri(b,I)}async $openUri(m,E,I){const P=this.c.get(m);if(!P)throw new Error(`Unknown opener id: '${m}'`);return P.openExternalUri(A.URI.revive(E.resolvedUri),{sourceUri:A.URI.revive(E.sourceUri)},I)}}e.$jnc=L,L.a=new Set([N.Schemas.http,N.Schemas.https])}),define(ke[323],Se([1,0,6,2,3,13,25]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;class ${constructor(E){this.c=new L.$Tm,this.d=new Map,this.b=E.getProxy(a.$0M.MainThreadUrls)}registerUriHandler(E,I){const P=E.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const b=$.a++;return this.c.add(P),this.d.set(b,I),this.b.$registerUriHandler(b,P,E.displayName||E.name),(0,A.$Tc)(()=>{this.c.delete(P),this.d.delete(b),this.b.$unregisterUriHandler(b)})}$handleExternalUri(E,I){const P=this.d.get(E);if(!P)return Promise.resolve(void 0);try{P.handleUri(N.URI.revive(I))}catch(b){(0,R.$1)(b)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$knc=$,$.a=0});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[92],Se([1,0,4,3,15,24,2,252,290,115,6]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";var P,b,k,p,h,g,u,n,i,d,o,t,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Llc=void 0,e.$Mlc=c,e.$Olc=f,e.$Plc=y;class r{constructor(C,j,B,z,T,M,F){P.set(this,void 0),b.set(this,void 0),k.set(this,void 0),p.set(this,void 0),h.set(this,void 0),g.set(this,void 0),u.set(this,""),n.set(this,void 0),i.set(this,!1),d.set(this,!1),o.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new a.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new a.$ee),this._onDidDispose=qe(this,l,"f").event,it(this,P,C,"f"),it(this,b,j,"f"),it(this,n,B,"f"),it(this,p,z,"f"),it(this,h,T,"f"),it(this,g,M,"f"),it(this,o,c(M),"f"),it(this,t,s(M),"f"),it(this,k,F,"f")}dispose(){it(this,i,!0,"f"),qe(this,l,"f").fire(),qe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(C){return it(this,d,!0,"f"),(0,E.$1Ab)(C,qe(this,p,"f"))}get cspSource(){const C=qe(this,g,"f").extensionLocation;if(C.scheme===A.Schemas.https||C.scheme===A.Schemas.http){let j=C.toString();return j.endsWith("/")||(j+="/"),j+" "+E.$ZAb}return E.$ZAb}get html(){return this.a(),qe(this,u,"f")}set html(C){this.a(),qe(this,u,"f")!==C&&(it(this,u,C,"f"),qe(this,t,"f")&&!qe(this,d,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(C)&&(it(this,d,!0,"f"),qe(this,k,"f").report("Webview vscode-resource: uris",qe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),qe(this,b,"f").$setHtml(qe(this,P,"f"),this.b(C)))}get options(){return this.a(),qe(this,n,"f")}set options(C){this.a(),R.$8n(qe(this,n,"f"),C)||qe(this,b,"f").$setOptions(qe(this,P,"f"),y(qe(this,g,"f"),qe(this,h,"f"),C)),it(this,n,C,"f")}async postMessage(C){if(qe(this,i,"f"))return!1;const j=(0,m.$Irb)(C,{serializeBuffersForPostMessage:qe(this,o,"f")});return qe(this,b,"f").$postMessage(qe(this,P,"f"),j.message,...j.buffers)}a(){if(qe(this,i,"f"))throw new Error("Webview is disposed")}b(C){if(!qe(this,t,"f"))return C;const j=qe(this,g,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,B=qe(this,g,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?qe(this,g,"f").extensionLocation.authority:void 0;return C.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,T,M,F,O,q)=>{const Y=L.URI.from({scheme:F||"file",path:decodeURIComponent(O)}),V=(0,E.$1Ab)(Y,{isRemote:j,authority:B}).toString();return`${T}${V}${q}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,T,M,F,O,q)=>{const Y=L.URI.from({scheme:F||"file",path:decodeURIComponent(O)}),V=(0,E.$1Ab)(Y,{isRemote:j,authority:B}).toString();return`${T}${V}${q}`})}}e.$Llc=r,P=new WeakMap,b=new WeakMap,k=new WeakMap,p=new WeakMap,h=new WeakMap,g=new WeakMap,u=new WeakMap,n=new WeakMap,i=new WeakMap,d=new WeakMap,o=new WeakMap,t=new WeakMap,l=new WeakMap;function c(S){try{const C=(0,$.$Jp)((0,$.$Ip)(S.engines.vscode));return!!C&&C.majorBase>=1&&C.minorBase>=57}catch{return!1}}function s(S){try{const C=(0,$.$Jp)((0,$.$Ip)(S.engines.vscode));return C?C.majorBase<1||C.majorBase===1&&C.minorBase<60:!1}catch{return!1}}class v extends N.$Vc{constructor(C,j,B,z,T){super(),this.c=j,this.f=B,this.g=z,this.h=T,this.b=new Map,this.a=C.getProxy(I.$0M.MainThreadWebviews)}dispose(){super.dispose();for(const C of this.b.values())C.dispose();this.b.clear()}$onMessage(C,j,B){const z=this.j(C);if(z){const{message:T}=(0,m.$Jrb)(j,B.value);z._onMessageEmitter.fire(T)}}$onMissingCsp(C,j){this.g.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(C,j,B){const z=new r(C,this.a,w(j),this.c,this.f,B,this.h);this.b.set(C,z);const T=z._onDidDispose(()=>{T.dispose(),this.deleteWebview(C)});return z}deleteWebview(C){this.b.delete(C)}j(C){return this.b.get(C)}}e.$Nlc=v;function f(S){return{id:S.identifier,location:S.extensionLocation}}function y(S,C,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||D(S,C)}}function w(S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots?.map(C=>L.URI.from(C))}}function D(S,C){return[...(C?.getWorkspaceFolders()||[]).map(j=>j.uri),S.extensionLocation]}}),define(ke[152],Se([1,0,4,15,14,2,5,20,6]),function(ie,e,a,N,A,R,L,$,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$mnc=void 0;let I=E=class{getState(){const b=this.d;return{get focused(){return b.focused},get active(){return b.active}}}constructor(b){this.c=new a.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=b.getProxy(m.$0M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,k){k!==this.d[b]&&(this.d={...this.d,[b]:k},this.c.fire(this.d))}openUri(b,k){let p;if(typeof b=="string"){p=b;try{b=R.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$8e)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,p,k)}async asExternalUri(b,k){if((0,A.$8e)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(b,k);return R.URI.from(p)}};e.$mnc=I,I.a={focused:!0,active:!0},e.$mnc=I=E=Je([Ue(0,$.$xP)],I),e.$nnc=(0,L.$wi)("IExtHostWindow")}),define(ke[324],Se([1,0,316,28,20]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0;const R=1024*1024;let L=class extends a.$qnc{constructor(m,E){super(m,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(m,E,I){const P=m==="error"||m==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),E.apply(console,I),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(m,E){const I=process[m],P=I.write;let b="";Object.defineProperty(I,"write",{set:()=>{},get:()=>(k,p,h)=>{if(!this.g){b+=k.toString(p);const g=b.length>R?b.length:b.lastIndexOf(`
`);g!==-1&&(console[E](b.slice(0,g)),b=b.slice(g+1))}P.call(I,k,p,h)}})}};e.$2nc=L,e.$2nc=L=Je([Ue(0,A.$xP),Ue(1,N.$NP)],L)}),define(ke[325],Se([1,0,151,15,267,31]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;class L extends a.$pnc{s(m,E,I){return m.scheme===N.Schemas.file?new A.$LQ(I?.name||(0,R.$Sg)(),m.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,E):super.s(m,E,I)}registerLogger(m){super.registerLogger(m),this.r.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this.r.$deregisterLogger(m)}}e.$boc=L}),define(ke[326],Se([1,0,7,21,22,13,4,3,132,314,48]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$1_b=g,e.$2_b=u;function b(S,C){try{return JSON.stringify(S,C)}catch{return"null"}}const k="$$ref$$",p={[k]:-1};class h{constructor(C,j){this.jsonString=C,this.referencedBuffers=j}}function g(S,C=null,j=!1){const B=[];return{jsonString:(j?b:JSON.stringify)(S,(T,M)=>{if(typeof M>"u")return p;if(typeof M=="object"){if(M instanceof N.$Ge){const F=B.push(M)-1;return{[k]:F}}if(C)return C(T,M)}return M}),referencedBuffers:B}}function u(S,C,j){return JSON.parse(S,(B,z)=>{if(z){const T=z[k];if(typeof T=="number")return C[T];if(j&&z.$mid===1)return j.transformIncoming(z)}return z})}function n(S,C){return JSON.stringify(S,C)}function i(S){return S?(C,j)=>j&&j.$mid===1?S.transformOutgoing(j):j:null}var d;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(d||(e.RequestInitiator=d={}));var o;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends $.$Vc{constructor(C,j=null,B=null){super(),this[P]=!0,this.b=this.B(new L.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=j,this.g=B,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,T=I.$zw.count;z<T;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new a.$Ih(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const j=this.w[C];delete this.w[C],j.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,m.$Cn)(C,this.g):C}getProxy(C){const{nid:j,sid:B}=C;return this.s[j]||(this.s[j]=this.J(j,B)),this.s[j]}J(C,j){const B={get:(z,T)=>(typeof T=="string"&&!z[T]&&T.charCodeAt(0)===36&&(z[T]=(...M)=>this.U(C,T,M)),T===r?j:z[T])};return new Proxy(Object.create(null),B)}set(C,j){return this.m[C.nid]=j,j}assertRegistered(C){for(let j=0,B=C.length;j<B;j++){const z=C[j];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(C){if(this.j)return;const j=C.byteLength,B=v.read(C,0),z=B.readUInt8(),T=B.readUInt32();switch(z){case 1:case 2:{let{rpcId:M,method:F,args:O}=y.deserializeRequestJSONArgs(B);this.g&&(O=(0,m.$Cn)(O,this.g)),this.M(j,T,M,F,O,z===2);break}case 3:case 4:{let{rpcId:M,method:F,args:O}=y.deserializeRequestMixedArgs(B);this.g&&(O=(0,m.$Cn)(O,this.g)),this.M(j,T,M,F,O,z===4);break}case 5:{this.f?.logIncoming(j,T,0,"ack"),this.G(T);break}case 6:{this.N(j,T);break}case 7:{this.O(j,T,void 0);break}case 9:{let M=y.deserializeReplyOKJSON(B);this.g&&(M=(0,m.$Cn)(M,this.g)),this.O(j,T,M);break}case 10:{const M=y.deserializeReplyOKJSONWithBuffers(B,this.g);this.O(j,T,M);break}case 8:{const M=y.deserializeReplyOKVSBuffer(B);this.O(j,T,M);break}case 11:{let M=y.deserializeReplyErrError(B);this.g&&(M=(0,m.$Cn)(M,this.g)),this.P(j,T,M);break}case 12:{this.P(j,T,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,j,B,z,T,M){this.f?.logIncoming(C,j,1,`receiveRequest ${(0,I.$Bw)(B)}.${z}(`,T);const F=String(j);let O,q;if(M){const V=new A.$pe;T.push(V.token),O=this.Q(B,z,T),q=()=>V.cancel()}else O=this.Q(B,z,T),q=t;this.u[F]=q;const Y=y.serializeAcknowledged(j);this.f?.logOutgoing(Y.byteLength,j,1,"ack"),this.c.send(Y),O.then(V=>{delete this.u[F];const J=y.serializeReplyOK(j,V,this.h);this.f?.logOutgoing(J.byteLength,j,1,"reply:",V),this.c.send(J)},V=>{delete this.u[F];const J=y.serializeReplyErr(j,V);this.f?.logOutgoing(J.byteLength,j,1,"replyErr:",V),this.c.send(J)})}N(C,j){this.f?.logIncoming(C,j,1,"receiveCancel");const B=String(j);this.u[B]?.()}O(C,j,B){this.f?.logIncoming(C,j,0,"receiveReply:",B);const z=String(j);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z],T.resolveOk(B)}P(C,j,B){this.f?.logIncoming(C,j,0,"receiveReplyErr:",B);const z=String(j);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z];let M;B&&(B.$isError?(M=new Error,M.name=B.name,M.message=B.message,M.stack=B.stack):M=B),T.resolveErr(M)}Q(C,j,B){try{return Promise.resolve(this.S(C,j,B))}catch(z){return Promise.reject(z)}}S(C,j,B){const z=this.m[C];if(!z)throw new Error("Unknown actor "+(0,I.$Bw)(C));const T=z[j];if(typeof T!="function")throw new Error("Unknown method "+j+" on actor "+(0,I.$Bw)(C));return T.apply(z,B)}U(C,j,B){if(this.j)return new E.$Z_b;let z=null;if(B.length>0&&A.CancellationToken.isCancellationToken(B[B.length-1])&&(z=B.pop()),z&&z.isCancellationRequested)return Promise.reject(R.$6());const T=y.serializeRequestArguments(B,this.h),M=++this.t,F=String(M),O=new E.$Y_b,q=new $.$Uc;z&&q.add(z.onCancellationRequested(()=>{const V=y.serializeCancel(M);this.f?.logOutgoing(V.byteLength,M,0,"cancel"),this.c.send(y.serializeCancel(M))})),this.w[F]=new s(O,q),this.F(M);const Y=y.serializeRequest(M,C,j,T,!!z);return this.f?.logOutgoing(Y.byteLength,M,0,`request: ${(0,I.$Bw)(C)}.${j}(`,B),this.c.send(Y),O}}e.$3_b=c,P=l,c.a=3*1e3;class s{constructor(C,j){this.a=C,this.b=j}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class v{static alloc(C,j,B){const z=new v(N.$Ge.alloc(B+1+4),0);return z.writeUInt8(C),z.writeUInt32(j),z}static read(C,j){return new v(C,j)}get buffer(){return this.a}constructor(C,j){this.a=C,this.b=j}static sizeUInt8(){return 1}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const B=this.a.slice(this.b,this.b+C).toString();return this.b+=C,B}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+C).toString();return this.b+=C,B}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C);return this.b+=C,j}static sizeMixedArray(C){let j=0;j+=1;for(let B=0,z=C.length;B<z;B++){const T=C[B];switch(j+=1,T.type){case 1:j+=this.sizeLongString(T.value);break;case 2:j+=this.sizeVSBuffer(T.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(T.value);for(let M=0;M<T.buffers.length;++M)j+=this.sizeVSBuffer(T.buffers[M]);break;case 4:break}}return j}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let j=0,B=C.length;j<B;j++){const z=C[j];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let T=0;T<z.buffers.length;++T)this.writeBuffer(z.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const j=new Array(C);for(let B=0;B<C;B++)switch(this.readUInt8()){case 1:j[B]=this.readLongString();break;case 2:j[B]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),M=this.readLongString(),F=[];for(let O=0;O<T;++O)F.push(this.readVSBuffer());j[B]=new I.$Cw(u(M,F,null));break}case 4:j[B]=void 0;break}return j}}v.sizeUInt32=4;var f;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(f||(f={}));class y{static a(C){for(let j=0,B=C.length;j<B;j++)if(C[j]instanceof N.$Ge||C[j]instanceof I.$Cw||typeof C[j]>"u")return!0;return!1}static serializeRequestArguments(C,j){if(this.a(C)){const B=[];for(let z=0,T=C.length;z<T;z++){const M=C[z];if(M instanceof N.$Ge)B[z]={type:2,value:M};else if(typeof M>"u")B[z]={type:4};else if(M instanceof I.$Cw){const{jsonString:F,referencedBuffers:O}=g(M.value,j);B[z]={type:3,value:N.$Ge.fromString(F),buffers:O}}else B[z]={type:1,value:N.$Ge.fromString(n(M,j))}}return{type:1,args:B}}return{type:0,args:n(C,j)}}static serializeRequest(C,j,B,z,T){switch(z.type){case 0:return this.b(C,j,B,z.args,T);case 1:return this.c(C,j,B,z.args,T)}}static b(C,j,B,z,T){const M=N.$Ge.fromString(B),F=N.$Ge.fromString(z);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(M),O+=v.sizeLongString(F);const q=v.alloc(T?2:1,C,O);return q.writeUInt8(j),q.writeShortString(M),q.writeLongString(F),q.buffer}static deserializeRequestJSONArgs(C){const j=C.readUInt8(),B=C.readShortString(),z=C.readLongString();return{rpcId:j,method:B,args:JSON.parse(z)}}static c(C,j,B,z,T){const M=N.$Ge.fromString(B);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(M),F+=v.sizeMixedArray(z);const O=v.alloc(T?4:3,C,F);return O.writeUInt8(j),O.writeShortString(M),O.writeMixedArray(z),O.buffer}static deserializeRequestMixedArgs(C){const j=C.readUInt8(),B=C.readShortString(),z=C.readMixedArray(),T=new Array(z.length);for(let M=0,F=z.length;M<F;M++){const O=z[M];typeof O=="string"?T[M]=JSON.parse(O):T[M]=O}return{rpcId:j,method:B,args:T}}static serializeAcknowledged(C){return v.alloc(5,C,0).buffer}static serializeCancel(C){return v.alloc(6,C,0).buffer}static serializeReplyOK(C,j,B){if(typeof j>"u")return this.d(C);if(j instanceof N.$Ge)return this.e(C,j);if(j instanceof I.$Cw){const{jsonString:z,referencedBuffers:T}=g(j.value,B,!0);return this.g(C,z,T)}else return this.f(C,b(j,B))}static d(C){return v.alloc(7,C,0).buffer}static e(C,j){let B=0;B+=v.sizeVSBuffer(j);const z=v.alloc(8,C,B);return z.writeVSBuffer(j),z.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,j){const B=N.$Ge.fromString(j);let z=0;z+=v.sizeLongString(B);const T=v.alloc(9,C,z);return T.writeLongString(B),T.buffer}static g(C,j,B){const z=N.$Ge.fromString(j);let T=0;T+=v.sizeUInt32,T+=v.sizeLongString(z);for(const F of B)T+=v.sizeVSBuffer(F);const M=v.alloc(10,C,T);M.writeUInt32(B.length),M.writeLongString(z);for(const F of B)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(C){const j=C.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(C,j){const B=C.readUInt32(),z=C.readLongString(),T=[];for(let M=0;M<B;++M)T.push(C.readVSBuffer());return new I.$Cw(u(z,T,j))}static serializeReplyErr(C,j){const B=j?b(R.$3(j),null):void 0;if(typeof B!="string")return this.h(C);const z=N.$Ge.fromString(B);let T=0;T+=v.sizeLongString(z);const M=v.alloc(11,C,T);return M.writeLongString(z),M.buffer}static deserializeReplyErrError(C){const j=C.readLongString();return JSON.parse(j)}static h(C){return v.alloc(12,C,0).buffer}}var w;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var D;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(D||(D={}))}),define(ke[327],Se([1,0,21,27,15,85,5]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=I,e.$NK=P,e.$LK=(0,L.$wi)("notebookDocumentService");const $=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${$.join("")}]+`),E=7;function I(k){if(k.scheme!==A.Schemas.vscodeNotebookCell)return;const p=k.fragment.indexOf("s");if(p<0)return;const h=parseInt(k.fragment.substring(0,p).replace(m,""),E),g=(0,a.$Ze)(k.fragment.substring(p+1)).toString();if(!isNaN(h))return{handle:h,notebook:k.with({scheme:g,fragment:null})}}function P(k,p){const h=p.toString(E),u=`${h.length<$.length?$[h.length-1]:"z"}${h}s${(0,a.$1e)(a.$Ge.fromString(k.scheme),!0,!0)}`;return k.with({scheme:A.Schemas.vscodeNotebookCell,fragment:u})}class b{constructor(){this.a=new N.$Bc}getNotebook(p){if(p.scheme===A.Schemas.vscodeNotebookCell){const h=I(p);if(h){const g=this.a.get(h.notebook);if(g)return g}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$OK=b,(0,R.$ys)(e.$LK,b,1)}),define(ke[121],Se([1,0,21,35,40,98,15,17,12,38,327]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=l,e.$3K=c,e.$4K=s,e.$7K=y,e.$8K=D,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var P;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(P||(e.CellKind=P={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",R.$Rs.latex,R.$Rs.markdown,"image/png","image/jpeg",R.$Rs.text],e.$VK=[R.$Rs.latex,R.$Rs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Rs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var b;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var k;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var p;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var h;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var g;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var u;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var n;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var d;(function(O){O.scheme=L.Schemas.vscodeNotebookCell;function q(de,ce){return(0,I.$NK)(de,ce)}O.generate=q;function Y(de){return(0,I.$MK)(de)}O.parse=Y;function V(de,ce){return de.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${de.scheme!==L.Schemas.file?de.scheme:""}`})}O.generateCellOutputUri=V;function J(de){if(de.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!ce)return;const ve=ce[1]&&ce[1]!==""?ce[1]:void 0,_=ce[2];return{outputId:ve,notebook:de.with({scheme:_||L.Schemas.file,fragment:null})}}O.parseCellOutputUri=J;function x(de,ce,ve){return O.generate(de,ce).with({scheme:ve})}O.generateCellPropertyUri=x;function ne(de,ce){if(de.scheme===ce)return O.parse(de.with({scheme:O.scheme}))}O.parseCellPropertyUri=ne})(d||(e.CellUri=d={}));const o=O=>m.$c?O.replace(/\//g,"\\"):O;class t{constructor(q=[],Y=e.$UK){this.e=Y,this.d=[...new Set(q)].map(V=>({pattern:V,matches:N.$qk(o(V))}))}sort(q){const Y=new Map(A.Iterable.map(q,J=>[J,o(J)]));let V=[];for(const{matches:J}of this.d)for(const[x,ne]of Y)if(J(ne)){V.push(x),Y.delete(x);break}return Y.size&&(V=V.concat([...Y.keys()].sort((J,x)=>this.e.indexOf(J)-this.e.indexOf(x)))),V}prioritize(q,Y){const V=this.f(q);if(V===-1){this.d.unshift({pattern:q,matches:N.$qk(o(q))});return}const J=new Set(Y.map(ne=>this.f(ne,V)));J.delete(-1);const x=Array.from(J).sort();this.d.splice(V+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(q=>q.pattern)}f(q,Y=this.d.length){const V=o(q);for(let J=0;J<Y;J++)if(this.d[J].matches(V))return J;return-1}}e.$YK=t;function l(O,q,Y,V=(J,x)=>J===x){const J=[];function x(ce,ve,_){if(ve===0&&_.length===0)return;const U=J[J.length-1];U&&U.start+U.deleteCount===ce?(U.deleteCount+=ve,U.toInsert.push(..._)):J.push({start:ce,deleteCount:ve,toInsert:_})}let ne=0,de=0;for(;;){if(ne===O.length){x(ne,0,q.slice(de));break}if(de===q.length){x(ne,O.length-ne,[]);break}const ce=O[ne],ve=q[de];if(V(ce,ve)){ne+=1,de+=1;continue}Y(ve)?(x(ne,1,[]),ne+=1):(x(ne,0,[ve]),de+=1)}return J}e.$1K=new E.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new E.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function c(O){const q=O;return!!((typeof q.include=="string"||N.$rk(q.include))&&(typeof q.exclude=="string"||N.$rk(q.exclude)))}function s(O,q,Y){if(Array.isArray(O.viewType)&&O.viewType.indexOf(q)>=0||O.viewType===q)return!0;if(O.filenamePattern){const V=c(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,J=c(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(N.$pk(V,(0,$.$oc)(Y.fsPath).toLowerCase()))return!(J&&N.$pk(J,(0,$.$oc)(Y.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var v;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class f{static create(q){return`${f.d}${q}`}static parse(q){if(q.startsWith(f.d))return q.substring(f.d.length)}}e.$6K=f,f.d="notebook/";function y(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}const w=new TextDecoder;function D(O){const q=[];let Y=!1;for(const ne of O)(q.length===0||Y)&&(q.push(ne),Y=!0);let V=j(q);const J=a.$Ge.concat(q.map(ne=>a.$Ge.wrap(ne))),x=F(J);return V=V||x.byteLength!==J.byteLength,{data:x,didCompression:V}}e.$9K="\x1B[A";const S=e.$9K.split("").map(O=>O.charCodeAt(0)),C=10;function j(O){let q=!1;return O.forEach((Y,V)=>{if(V===0||Y.length<e.$9K.length)return;const J=O[V-1],x=Y.subarray(0,e.$9K.length);if(x[0]===S[0]&&x[1]===S[1]&&x[2]===S[2]){const ne=J.lastIndexOf(C);if(ne===-1)return;q=!0,O[V-1]=J.subarray(0,ne),O[V]=Y.subarray(e.$9K.length)}}),q}function B(O){let q=O;do O=q,q=O.replace(/[^\n]\x08/gm,"");while(q.length<O.length);return O}function z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const q=O.match(/^(.*)\r+/m)[1];let Y=O.match(/\r+(.*)$/m)[1];Y=Y+q.slice(Y.length,q.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return O}const T=8,M=13;function F(O){return!O.buffer.includes(T)&&!O.buffer.includes(M)?O:a.$Ge.fromString(z(B(w.decode(O.buffer))))}});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[8],Se([1,0,19,13,80,27,98,14,18,2,31,25,33,67,121]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p){"use strict";var h,g,u,n,i,d,o,t,l,r,c,s,v,f,y,w,D,S,C,j,B,z,T,M,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$lP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$kP=e.$jP=e.$iP=e.$hP=e.ChatLocation=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$8O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$UO=e.$TO=e.$SO=e.$RO=e.$PO=e.$OO=e.$NO=e.$MO=e.TestRunProfileKind=e.TestResultState=e.$LO=e.$KO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$JO=e.NotebookVariablesRequestKind=e.$IO=e.$HO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$GO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.ColorThemeKind=e.$AO=e.$zO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$yO=e.$xO=e.DebugConsoleMode=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$rO=e.$qO=e.FileChangeType=e.$pO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$oO=e.$nO=e.$mO=e.$lO=e.InlineCompletionTriggerKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$$N=e.ConfigurationTarget=e.$0N=e.$9N=e.$8N=e.$7N=e.DocumentPasteTriggerKind=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ZN=e.ViewBadge=e.ProgressLocation=e.$YN=e.$XN=e.TaskScope=e.ShellQuoting=e.$WN=e.$VN=e.$UN=e.TaskPanelKind=e.TaskRevealKind=e.$TN=e.TerminalLocation=e.$SN=e.$RN=e.$QN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$PN=e.$ON=e.$NN=e.$MN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$GN=e.$FN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.LanguageStatusSeverity=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.CodeActionTriggerKind=e.$tN=e.$sN=e.SymbolTag=e.SymbolKind=e.$rN=e.$qN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.DiagnosticSeverity=e.DiagnosticTag=e.$kN=e.$jN=e.FileEditType=e.$iN=e.$hN=e.$gN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$LN=dn,e.$_N=qt,e.$QO=Ii;function O(G){return Object.assign(G,{apply:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const Me=me.length===1?[]:me[1];return Reflect.construct(G,Me,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const[Me,...Ye]=me;return Reflect.construct(G,Ye,Me.constructor)}}})}var q;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(q||(e.TerminalOutputAnchor=q={}));var Y;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(Y||(e.TerminalQuickFixType=Y={}));let V=l=class{static from(...H){let me=H;return new l(function(){if(me){for(const Me of me)Me&&typeof Me.dispose=="function"&&Me.dispose();me=void 0}})}constructor(H){h.set(this,void 0),it(this,h,H,"f")}dispose(){typeof qe(this,h,"f")=="function"&&(qe(this,h,"f").call(this),it(this,h,void 0,"f"))}};e.$_M=V,h=new WeakMap,e.$_M=V=l=Je([O],V);let J=r=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Me=1;Me<H.length;Me++){const Ye=H[Me];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Me=1;Me<H.length;Me++){const Ye=H[Me];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(H){if(!H)return!1;if(H instanceof r)return!0;const{line:me,character:Me}=H;return typeof me=="number"&&typeof Me=="number"}static of(H){if(H instanceof r)return H;if(this.isPosition(H))return new r(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,N.$7)("line must be non-negative");if(me<0)throw(0,N.$7)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,N.$7)();let Me;return typeof H>"u"?Me=0:typeof H=="number"?Me=H:(Me=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Me===0&&me===0?this:new r(this.line+Me,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,N.$7)();let Me;return typeof H>"u"?Me=this.line:typeof H=="number"?Me=H:(Me=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Me===this.line&&me===this.character?this:new r(Me,me)}toJSON(){return{line:this.line,character:this.character}}};e.$aN=J,e.$aN=J=r=Je([O],J);let x=c=class{static isRange(H){return H instanceof c?!0:H?J.isPosition(H.start)&&J.isPosition(H.end):!1}static of(H){if(H instanceof c)return H;if(this.isRange(H))return new c(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Me,Ye){let st,gt;if(typeof H=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Ye=="number"?(st=new J(H,me),gt=new J(Me,Ye)):J.isPosition(H)&&J.isPosition(me)&&(st=J.of(H),gt=J.of(me)),!st||!gt)throw new Error("Invalid arguments");st.isBefore(gt)?(this.c=st,this.e=gt):(this.c=gt,this.e=st)}contains(H){return c.isRange(H)?this.contains(H.start)&&this.contains(H.end):J.isPosition(H)?!(J.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=J.Max(H.start,this.c),Me=J.Min(H.end,this.e);if(!me.isAfter(Me))return new c(me,Me)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=J.Min(H.start,this.c),Me=J.Max(H.end,this.end);return new c(me,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,N.$7)();let Me;return H?J.isPosition(H)?Me=H:(Me=H.start||this.start,me=H.end||this.end):Me=this.start,Me.isEqual(this.c)&&me.isEqual(this.end)?this:new c(Me,me)}toJSON(){return[this.start,this.end]}};e.$bN=x,e.$bN=x=c=Je([O],x);let ne=s=class extends x{static isSelection(H){return H instanceof s?!0:H?x.isRange(H)&&J.isPosition(H.anchor)&&J.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Me,Ye){let st,gt;if(typeof H=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Ye=="number"?(st=new J(H,me),gt=new J(Me,Ye)):J.isPosition(H)&&J.isPosition(me)&&(st=J.of(H),gt=J.of(me)),!st||!gt)throw new Error("Invalid arguments");super(st,gt),this.f=st,this.g=gt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cN=ne,e.$cN=ne=s=Je([O],ne);const de=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,N.$7)("connectionToken")};class ce{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Me){if(typeof H!="string"||H.length===0)throw(0,N.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,N.$7)("port");typeof Me<"u"&&de(Me),this.host=H,this.port=Math.round(me),this.connectionToken=Me}}e.$dN=ce;class ve{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&de(me)}}e.$eN=ve;class _ extends Error{static NotAvailable(H,me){return new _(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new _(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=k.RemoteAuthorityResolverErrorCode.Unknown,Me){super(H),this._message=H,this._code=me,this._detail=Me,Object.setPrototypeOf(this,_.prototype)}}e.$fN=_;var U;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var le;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(le||(e.EnvironmentVariableMutatorType=le={}));let De=v=class{static isTextEdit(H){return H instanceof v?!0:H?x.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new v(H,me)}static insert(H,me){return v.replace(new x(H,H),me)}static delete(H){return v.replace(H,"")}static setEndOfLine(H){const me=new v(new x(new J(0,0),new J(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!x.isRange(H))throw(0,N.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,N.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,N.$7)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gN=De,e.$gN=De=v=Je([O],De);let $e=f=class{static isNotebookCellEdit(H){return H instanceof f?!0:H?pn.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new f(H,me)}static insertCells(H,me){return new f(new pn(H,H),me)}static deleteCells(H){return new f(H,[])}static updateCellMetadata(H,me){const Me=new f(new pn(H,H),[]);return Me.newCellMetadata=me,Me}static updateNotebookMetadata(H){const me=new f(new pn(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$hN=$e,e.$hN=$e=f=Je([O],$e);class re{static isSnippetTextEdit(H){return H instanceof re?!0:H?x.isRange(H.range)&&K.isSnippetString(H.snippet):!1}static replace(H,me){return new re(H,me)}static insert(H,me){return re.replace(new x(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$iN=re;var se;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Me,Ye){this.c.push({_type:1,from:H,to:me,options:Me,metadata:Ye})}createFile(H,me,Me){this.c.push({_type:1,from:void 0,to:H,options:me,metadata:Me})}deleteFile(H,me,Me){this.c.push({_type:1,from:H,to:void 0,options:me,metadata:Me})}e(H,me,Me){this.c.push({_type:3,metadata:Me,uri:H,edit:{editType:5,metadata:me},notebookMetadata:me})}f(H,me,Me,Ye){const st=me.start,gt=me.end;(st!==gt||Me.length>0)&&this.c.push({_type:5,uri:H,index:st,count:gt-st,cells:Me,metadata:Ye})}g(H,me,Me,Ye){this.c.push({_type:3,metadata:Ye,uri:H,edit:{editType:3,index:me,metadata:Me}})}replace(H,me,Me,Ye){this.c.push({_type:2,uri:H,edit:new De(me,Me),metadata:Ye})}insert(H,me,Me,Ye){this.replace(H,new x(me,me),Me,Ye)}delete(H,me,Me){this.replace(H,me,"",Me)}has(H){return this.c.some(me=>me._type===2&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Me of me){if(!Me)continue;let Ye,st;Array.isArray(Me)?(Ye=Me[0],st=Me[1]):Ye=Me,$e.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(H,Ye.range.start,Ye.newCellMetadata,st):Ye.newNotebookMetadata?this.e(H,Ye.newNotebookMetadata,st):this.f(H,Ye.range,Ye.newCells,st):re.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:H,range:Ye.range,edit:Ye.snippet,metadata:st}):this.c.push({_type:2,uri:H,edit:Ye,metadata:st})}else{for(let Me=0;Me<this.c.length;Me++){const Ye=this.c[Me];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===H.toString()&&(this.c[Me]=void 0);break}}(0,a.$Ib)(this.c)}}get(H){const me=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===H.toString()&&me.push(Me.edit);return me}entries(){const H=new R.$Bc;for(const me of this.c)if(me._type===2){let Me=H.get(me.uri);Me||(Me=[me.uri,[]],H.set(me.uri,Me)),Me[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jN=oe,e.$jN=oe=Je([O],oe);let K=y=class{static isSnippetString(H){return H instanceof y?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=y.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Me=new y;Me.e=this.e,H(Me),this.e=Me.e,H=Me.value}else H=y.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Me=H.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Me=new y;Me.e=this.e,me(Me),this.e=Me.e,me=Me.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$kN=K,e.$kN=K=y=Je([O],K);var te;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var ge;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ge||(e.DiagnosticSeverity=ge={}));let be=w=class{static isLocation(H){return H instanceof w?!0:H?x.isRange(H.range)&&E.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(x.isRange(me))this.range=x.of(me);else if(J.isPosition(me))this.range=new x(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lN=be,e.$lN=be=w=Je([O],be);let Re=class{static is(H){return H?typeof H.message=="string"&&H.location&&x.isRange(H.location.range)&&E.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$mN=Re,e.$mN=Re=Je([O],Re);let pe=class{constructor(H,me,Me=ge.Error){if(!x.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Me}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,a.$ub)(H.tags,me.tags)&&(0,a.$ub)(H.relatedInformation,me.relatedInformation,Re.isEqual)}};e.$nN=pe,e.$nN=pe=Je([O],pe);let Pe=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$oN=Pe,e.$oN=Pe=Je([O],Pe);let Ie=class extends Pe{constructor(H,me,Me,Ye){super(H,me),this.canIncreaseHover=Me,this.canDecreaseHover=Ye}};e.$pN=Ie,e.$pN=Ie=Je([O],Ie);var je;(function(G){G[G.Increase=0]="Increase",G[G.Decrease=1]="Decrease"})(je||(e.HoverVerbosityAction=je={}));var W;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(W||(e.DocumentHighlightKind=W={}));let Q=class{constructor(H,me=W.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:W[this.kind]}}};e.$qN=Q,e.$qN=Q=Je([O],Q);let X=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$rN=X,e.$rN=X=Je([O],X);var Z;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Z||(e.SymbolKind=Z={}));var he;(function(G){G[G.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let we=D=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Me,Ye,st){this.name=H,this.kind=me,this.containerName=st,typeof Me=="string"&&(this.containerName=Me),Ye instanceof be?this.location=Ye:Me instanceof x&&(this.location=new be(Ye,Me)),D.validate(this)}toJSON(){return{name:this.name,kind:Z[this.kind],location:this.location,containerName:this.containerName}}};e.$sN=we,e.$sN=we=D=Je([O],we);let Te=S=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(S.validate)}constructor(H,me,Me,Ye,st){this.name=H,this.detail=me,this.kind=Me,this.range=Ye,this.selectionRange=st,this.children=[],S.validate(this)}};e.$tN=Te,e.$tN=Te=S=Je([O],Te);var He;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(He||(e.CodeActionTriggerKind=He={}));let Xe=class{constructor(H,me){this.title=H,this.kind=me}};e.$uN=Xe,e.$uN=Xe=Je([O],Xe);let et=C=class{constructor(H){this.value=H}append(H){return new C(this.value?this.value+C.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+C.c)}};e.$vN=et,et.c=".",e.$vN=et=C=Je([O],et),et.Empty=new et(""),et.QuickFix=et.Empty.append("quickfix"),et.Refactor=et.Empty.append("refactor"),et.RefactorExtract=et.Refactor.append("extract"),et.RefactorInline=et.Refactor.append("inline"),et.RefactorMove=et.Refactor.append("move"),et.RefactorRewrite=et.Refactor.append("rewrite"),et.Source=et.Empty.append("source"),et.SourceOrganizeImports=et.Source.append("organizeImports"),et.SourceFixAll=et.Source.append("fixAll"),et.Notebook=et.Empty.append("notebook");let rt=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$wN=rt,e.$wN=rt=Je([O],rt);class at{constructor(H,me,Me,Ye,st,gt){this.kind=H,this.name=me,this.detail=Me,this.uri=Ye,this.range=st,this.selectionRange=gt}}e.$xN=at;class ot{constructor(H,me){this.fromRanges=me,this.from=H}}e.$yN=ot;class ct{constructor(H,me){this.fromRanges=me,this.to=H}}e.$zN=ct;var Ne;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ve=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$AN=Ve,e.$AN=Ve=Je([O],Ve);let Ae=j=class{static isMarkdownString(H){return H instanceof j?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){g.set(this,void 0),it(this,g,new A.$Tk(H,{supportThemeIcons:me}),"f")}get value(){return qe(this,g,"f").value}set value(H){qe(this,g,"f").value=H}get isTrusted(){return qe(this,g,"f").isTrusted}set isTrusted(H){qe(this,g,"f").isTrusted=H}get supportThemeIcons(){return qe(this,g,"f").supportThemeIcons}set supportThemeIcons(H){qe(this,g,"f").supportThemeIcons=H}get supportHtml(){return qe(this,g,"f").supportHtml}set supportHtml(H){qe(this,g,"f").supportHtml=H}get baseUri(){return qe(this,g,"f").baseUri}set baseUri(H){qe(this,g,"f").baseUri=H}appendText(H){return qe(this,g,"f").appendText(H),this}appendMarkdown(H){return qe(this,g,"f").appendMarkdown(H),this}appendCodeblock(H,me){return qe(this,g,"f").appendCodeblock(me??"",H),this}};e.$BN=Ae,g=new WeakMap,e.$BN=Ae=j=Je([O],Ae);let Ge=class{constructor(H,me){this.label=H,this.documentation=me}};e.$CN=Ge,e.$CN=Ge=Je([O],Ge);let ae=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$DN=ae,e.$DN=ae=Je([O],ae);let ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$EN=ue,e.$EN=ue=Je([O],ue);var Ce;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Ce||(e.SignatureHelpTriggerKind=Ce={}));var Ke;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Ke||(e.InlayHintKind=Ke={}));let Oe=class{constructor(H){this.value=H}};e.$FN=Oe,e.$FN=Oe=Je([O],Oe);let nt=class{constructor(H,me,Me){this.position=H,this.label=me,this.kind=Me}};e.$GN=nt,e.$GN=nt=Je([O],nt);var ht;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ht||(e.CompletionTriggerKind=ht={}));var yt;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(yt||(e.CompletionItemKind=yt={}));var Nt;(function(G){G[G.Deprecated=1]="Deprecated"})(Nt||(e.CompletionItemTag=Nt={}));let jt=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&yt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$HN=jt,e.$HN=jt=Je([O],jt);let _t=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$IN=_t,e.$IN=_t=Je([O],_t);let Xt=class{constructor(H,me,Me){this.insertText=H,this.range=me,this.command=Me}};e.$JN=Xt,e.$JN=Xt=Je([O],Xt);let Pt=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$KN=Pt,e.$KN=Pt=Je([O],Pt);var en;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(en||(e.PartialAcceptTriggerKind=en={}));var tn;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(tn||(e.ViewColumn=tn={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt||(e.StatusBarAlignment=tt={}));function dn(G,H){return`${P.$Sm.toKey(G)}.${H}`}var rn;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(rn||(e.TextEditorLineNumbersStyle=rn={}));var mt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(mt||(e.TextDocumentSaveReason=mt={}));var bt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(bt||(e.TextEditorRevealType=bt={}));var Gt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var Zt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var zt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(G){function H(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var $t;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})($t||(e.SyntaxTokenType=$t={})),function(G){function H(me){switch(me){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}($t||(e.SyntaxTokenType=$t={}));let Bt=class{constructor(H,me){if(me&&!E.URI.isUri(me))throw(0,N.$7)("target");if(!x.isRange(H)||H.isEmpty)throw(0,N.$7)("range");this.range=H,this.target=me}};e.$MN=Bt,e.$MN=Bt=Je([O],Bt);let Ht=class{constructor(H,me,Me,Ye){this.red=H,this.green=me,this.blue=Me,this.alpha=Ye}};e.$NN=Ht,e.$NN=Ht=Je([O],Ht);let Ft=class{constructor(H,me){if(me&&!(me instanceof Ht))throw(0,N.$7)("color");if(!x.isRange(H)||H.isEmpty)throw(0,N.$7)("range");this.range=H,this.color=me}};e.$ON=Ft,e.$ON=Ft=Je([O],Ft);let xe=class{constructor(H){if(!H||typeof H!="string")throw(0,N.$7)("label");this.label=H}};e.$PN=xe,e.$PN=xe=Je([O],xe);var un;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(un||(e.ColorFormat=un={}));var Yt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Yt||(e.SourceControlInputBoxValidationType=Yt={}));var Jt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Jt||(e.TerminalExitReason=Jt={}));var wt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Wt{constructor(H,me,Me){if(this.startIndex=H,this.length=me,this.tooltip=Me,typeof H!="number"||H<0)throw(0,N.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,N.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,N.$7)("tooltip")}}e.$QN=Wt;class Ut{constructor(H){this.uri=H}}e.$RN=Ut;class Qt{constructor(H){this.terminalCommand=H}}e.$SN=Qt;var sn;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(sn||(e.TerminalLocation=sn={}));class on{constructor(H){if(this.options=H,typeof H!="object")throw(0,N.$7)("options")}}e.$TN=on;var an;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(an||(e.TaskRevealKind=an={}));var Ot;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Ot||(e.TaskPanelKind=Ot={}));let Ct=B=class{static from(H){switch(H){case"clean":return B.Clean;case"build":return B.Build;case"rebuild":return B.Rebuild;case"test":return B.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,N.$7)("name");this.c=H}get id(){return this.c}};e.$UN=Ct,Ct.Clean=new B("clean","Clean"),Ct.Build=new B("build","Build"),Ct.Rebuild=new B("rebuild","Rebuild"),Ct.Test=new B("test","Test"),e.$UN=Ct=B=Je([O],Ct);function Mt(G){let H="";for(let me=0;me<G.length;me++)H+=G[me].replace(/,/g,",,")+",";return H}let It=class{constructor(H,me,Me){if(typeof H!="string")throw(0,N.$7)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Me):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,N.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return Mt(H)}};e.$VN=It,e.$VN=It=Je([O],It);let pt=class{constructor(H,me,Me){if(this.f=[],Array.isArray(me)){if(!H)throw(0,N.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,N.$7)("command");this.e=H,this.f=me,this.g=Me}else{if(typeof H!="string")throw(0,N.$7)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,N.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,N.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return Mt(H)}};e.$WN=pt,e.$WN=pt=Je([O],pt);var At;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var cn;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(cn||(e.TaskScope=cn={}));class Dt{constructor(H){this.c=H}computeId(){return"customExecution"+(0,I.$Sg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$XN=Dt;let xt=z=class{constructor(H,me,Me,Ye,st,gt){this.k=!1,this.l=this.definition=H;let vt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Me,this.execution=Ye,vt=st,this.k=!0):me===cn.Global||me===cn.Workspace?(this.target=me,this.o=this.name=Me,this.w=this.source=Ye,this.execution=st,vt=gt):(this.target=me,this.o=this.name=Me,this.w=this.source=Ye,this.execution=st,vt=gt),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof It?this.l={type:z.e,id:this.q.computeId()}:this.q instanceof pt?this.l={type:z.f,id:this.q.computeId()}:this.q instanceof Dt?this.l={type:z.c,id:this.q.computeId()}:this.l={type:z.g,id:(0,I.$Sg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,N.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(z.g===me||z.e===me||z.f===me||z.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$YN=xt,xt.c="customExecution",xt.e="process",xt.f="shell",xt.g="$empty",e.$YN=xt=z=Je([O],xt);var nn;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(nn||(e.ProgressLocation=nn={}));var En;(function(G){function H(me){const Me=me;return(0,m.$ag)(Me.value)?Me.tooltip&&!(0,m.$9f)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}G.isViewBadge=H})(En||(e.ViewBadge=En={}));let fn=T=class{static isTreeItem(H,me){const Me=H;if(Me.checkboxState!==void 0){const Ye=(0,m.$ag)(Me.checkboxState)?Me.checkboxState:(0,m.$$f)(Me.checkboxState)&&(0,m.$ag)(Me.checkboxState.state)?Me.checkboxState.state:void 0,st=!(0,m.$ag)(Me.checkboxState)&&(0,m.$$f)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Lt.Checked&&Ye!==Lt.Unchecked||st!==void 0&&!(0,m.$9f)(st))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(H instanceof T)return!0;if(Me.label!==void 0&&!(0,m.$9f)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,m.$9f)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,m.$9f)(Me.iconPath)&&!E.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,m.$9f)(Me.iconPath.id))){const Ye=Me.iconPath;if(!Ye||!(0,m.$9f)(Ye.light)&&!E.URI.isUri(Ye.light)&&!(0,m.$9f)(Ye.dark)&&!E.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,m.$9f)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!E.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,m.$9f)(Me.tooltip)&&!(Me.tooltip instanceof Ae)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<gn.None&&Me.collapsibleState>gn.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,m.$9f)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(H,me=gn.None){this.collapsibleState=me,E.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$ZN=fn,e.$ZN=fn=T=Je([O],fn);var gn;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(gn||(e.TreeItemCollapsibleState=gn={}));var Lt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Lt||(e.TreeItemCheckboxState=Lt={}));let $n=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$1N=$n,e.$1N=$n=Je([O],$n);class kn extends $n{}e.$2N=kn;class Le extends kn{constructor(H){super(""),u.set(this,void 0),it(this,u,H,"f")}asFile(){return qe(this,u,"f")}}e.$3N=Le,u=new WeakMap;class ze{constructor(H,me,Me,Ye){this.name=H,this.uri=me,this._itemId=Me,this.c=Ye}data(){return this.c()}}e.$4N=ze;let ye=class{constructor(H){n.add(this),i.set(this,new Map);for(const[me,Me]of H??[]){const Ye=qe(this,i,"f").get(qe(this,n,"m",d).call(this,me));Ye?Ye.push(Me):qe(this,i,"f").set(qe(this,n,"m",d).call(this,me),[Me])}}get(H){return qe(this,i,"f").get(qe(this,n,"m",d).call(this,H))?.[0]}set(H,me){qe(this,i,"f").set(qe(this,n,"m",d).call(this,H),[me])}forEach(H,me){for(const[Me,Ye]of qe(this,i,"f"))for(const st of Ye)H.call(me,st,Me,this)}*[(i=new WeakMap,n=new WeakSet,Symbol.iterator)](){for(const[H,me]of qe(this,i,"f"))for(const Me of me)yield[H,Me]}};e.$5N=ye,d=function(H){return H.toLowerCase()},e.$5N=ye=Je([O],ye);let ee=class{constructor(H,me,Me){this.insertText=H,this.title=me,this.kind=Me}};e.$6N=ee,e.$6N=ee=Je([O],ee);var Fe;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(Fe||(e.DocumentPasteTriggerKind=Fe={}));class Qe{constructor(H){this.value=H}append(...H){return new Qe((this.value?[this.value,...H]:H).join(Qe.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+Qe.c)}}e.$7N=Qe,Qe.c=".",Qe.Empty=new Qe("");class _e{constructor(H,me,Me){this.title=me,this.insertText=H,this.kind=Me}}e.$8N=_e;let Ze=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$9N=Ze,e.$9N=Ze=Je([O],Ze),Ze.File=new Ze("file"),Ze.Folder=new Ze("folder");let ft=class{constructor(H){this.id=H}};e.$0N=ft,e.$0N=ft=Je([O],ft);var St;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(St||(e.ConfigurationTarget=St={}));let Vt=class{get base(){return this.c}set base(H){this.c=H,this.e=E.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!E.URI.isUri(H)&&!E.URI.isUri(H.uri)))throw(0,N.$7)("base");if(typeof me!="string")throw(0,N.$7)("pattern");typeof H=="string"?this.baseUri=E.URI.file(H):E.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$N=Vt,e.$$N=Vt=Je([O],Vt);const dt=new WeakMap;function qt(G,H){dt.set(G,H)}let Rt=class{constructor(H,me,Me,Ye,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Me=="string"&&(this.hitCondition=Me),typeof Ye=="string"&&(this.logMessage=Ye),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=dt.get(this)??(0,I.$Sg)()),this.c}};e.$aO=Rt,e.$aO=Rt=Je([O],Rt);let wn=class extends Rt{constructor(H,me,Me,Ye,st,gt){if(super(me,Me,Ye,st,gt),H===null)throw(0,N.$7)("location");this.location=H}};e.$bO=wn,e.$bO=wn=Je([O],wn);let Cn=class extends Rt{constructor(H,me,Me,Ye,st,gt){super(me,Me,Ye,st,gt),this.functionName=H}};e.$cO=Cn,e.$cO=Cn=Je([O],Cn);let jn=class extends Rt{constructor(H,me,Me,Ye,st,gt,vt,Kt){if(super(Ye,st,gt,vt,Kt),!me)throw(0,N.$7)("dataId");this.label=H,this.dataId=me,this.canPersist=Me}};e.$dO=jn,e.$dO=jn=Je([O],jn);let zn=class{constructor(H,me,Me){this.command=H,this.args=me||[],this.options=Me}};e.$eO=zn,e.$eO=zn=Je([O],zn);let Bn=class{constructor(H,me){this.port=H,this.host=me}};e.$fO=Bn,e.$fO=Bn=Je([O],Bn);let In=class{constructor(H){this.path=H}};e.$gO=In,e.$gO=In=Je([O],In);let Vn=class{constructor(H){this.implementation=H}};e.$hO=Vn,e.$hO=Vn=Je([O],Vn);class Yn{constructor(H,me,Me){this.session=H,this.threadId=me,this.frameId=Me}}e.$iO=Yn;class $i{constructor(H,me){this.session=H,this.threadId=me}}e.$jO=$i;let Sn=class{constructor(H,me){this.range=H,this.expression=me}};e.$kO=Sn,e.$kO=Sn=Je([O],Sn);var An;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(An||(e.InlineCompletionTriggerKind=An={}));let Wn=class{constructor(H,me){this.range=H,this.text=me}};e.$lO=Wn,e.$lO=Wn=Je([O],Wn);let Un=class{constructor(H,me,Me=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Me}};e.$mO=Un,e.$mO=Un=Je([O],Un);let vn=class{constructor(H,me){this.range=H,this.expression=me}};e.$nO=vn,e.$nO=vn=Je([O],vn);let qn=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$oO=qn,e.$oO=qn=Je([O],qn);var xn;(function(G){G[G.AIGenerated=1]="AIGenerated"})(xn||(e.NewSymbolNameTag=xn={}));var _n;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(_n||(e.NewSymbolNameTriggerKind=_n={}));class Hn{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$pO=Hn;var ei;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(ei||(e.FileChangeType=ei={}));let Rn=M=class extends Error{static FileExists(H){return new M(H,b.FileSystemProviderErrorCode.FileExists,M.FileExists)}static FileNotFound(H){return new M(H,b.FileSystemProviderErrorCode.FileNotFound,M.FileNotFound)}static FileNotADirectory(H){return new M(H,b.FileSystemProviderErrorCode.FileNotADirectory,M.FileNotADirectory)}static FileIsADirectory(H){return new M(H,b.FileSystemProviderErrorCode.FileIsADirectory,M.FileIsADirectory)}static NoPermissions(H){return new M(H,b.FileSystemProviderErrorCode.NoPermissions,M.NoPermissions)}static Unavailable(H){return new M(H,b.FileSystemProviderErrorCode.Unavailable,M.Unavailable)}constructor(H,me=b.FileSystemProviderErrorCode.Unknown,Me){super(E.URI.isUri(H)?H.toString(!0):H),this.code=Me?.name??"Unknown",(0,b.$fl)(this,me),Object.setPrototypeOf(this,M.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$qO=Rn,e.$qO=Rn=M=Je([O],Rn);let Qn=class{constructor(H,me,Me){this.start=H,this.end=me,this.kind=Me}};e.$rO=Qn,e.$rO=Qn=Je([O],Qn);var Gn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Gn||(e.FoldingRangeKind=Gn={}));var ti;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(ti||(e.CommentThreadCollapsibleState=ti={}));var ni;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(ni||(e.CommentMode=ni={}));var ii;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(ii||(e.CommentState=ii={}));var ri;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(ri||(e.CommentThreadState=ri={}));var Nn;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Nn||(e.CommentThreadApplicability=Nn={}));class si{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$sO=si;function We(G){return typeof G>"u"||(0,m.$0f)(G)}class ln{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Me=H.tokenTypes.length;me<Me;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Me=H.tokenModifiers.length;me<Me;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Me,Ye,st){if(typeof H=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Ye=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Me,Ye,st);if(x.isRange(H)&&typeof me=="string"&&We(Me))return this.o(H,me,Me);throw(0,N.$7)()}o(H,me,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,st=H.start.character,gt=H.end.character-H.start.character,vt=this.k.get(me);let Kt=0;if(Me)for(const hn of Me){if(!this.l.has(hn))throw new Error("`tokenModifier` is not in the provided legend");const mn=this.l.get(hn);Kt|=1<<mn>>>0}this.q(Ye,st,gt,vt,Kt)}q(H,me,Me,Ye,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Kt=this.g.length/5|0;let hn=0,mn=0;for(let bn=0;bn<Kt;bn++){let yn=this.g[5*bn],Xn=this.g[5*bn+1];yn===0?(yn=hn,Xn+=mn):yn+=hn,this.g[5*bn]=yn,this.g[5*bn+1]=Xn,hn=yn,mn=Xn}}let gt=H,vt=me;this.f&&this.j>0&&(gt-=this.c,gt===0&&(vt-=this.e)),this.g[this.j++]=gt,this.g[this.j++]=vt,this.g[this.j++]=Me,this.g[this.j++]=Ye,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Me=H.length/5|0;for(let vt=0;vt<Me;vt++)me[vt]=vt;me.sort((vt,Kt)=>{const hn=H[5*vt],mn=H[5*Kt];if(hn===mn){const bn=H[5*vt+1],yn=H[5*Kt+1];return bn-yn}return hn-mn});const Ye=new Uint32Array(H.length);let st=0,gt=0;for(let vt=0;vt<Me;vt++){const Kt=5*me[vt],hn=H[Kt+0],mn=H[Kt+1],bn=H[Kt+2],yn=H[Kt+3],Xn=H[Kt+4],Ui=hn-st,Er=Ui===0?mn-gt:mn,Zn=5*vt;Ye[Zn+0]=Ui,Ye[Zn+1]=Er,Ye[Zn+2]=bn,Ye[Zn+3]=yn,Ye[Zn+4]=Xn,st=hn,gt=mn}return Ye}build(H){return this.f?new Ln(new Uint32Array(this.g),H):new Ln(ln.r(this.g),H)}}e.$tO=ln;class Ln{constructor(H,me){this.resultId=me,this.data=H}}e.$uO=Ln;class ut{constructor(H,me,Me){this.start=H,this.deleteCount=me,this.data=Me}}e.$vO=ut;class Et{constructor(H,me){this.resultId=me,this.edits=H}}e.$wO=Et;var oi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(oi||(e.DebugConsoleMode=oi={}));class pi{constructor(H){this.name=H}}e.$xO=pi;let Dn=class{constructor(){}};e.$yO=Dn,Dn.Back={iconPath:new Ze("arrow-left")},e.$yO=Dn=Je([O],Dn);var ai;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(ai||(e.QuickPickItemKind=ai={}));var Pn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Pn||(e.InputBoxValidationSeverity=Pn={}));var ci;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ci||(e.ExtensionKind=ci={}));class bi{static validate(H){if(typeof H.badge=="string"){let me=(0,$.$If)(H.badge,0);if(me<H.badge.length&&(me+=(0,$.$If)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Ze.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Me){this.badge=H,this.tooltip=me,this.color=Me}}e.$zO=bi;let Jn=class{constructor(H){this.kind=H}};e.$AO=Jn,e.$AO=Jn=Je([O],Jn);var Kn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Kn||(e.ColorThemeKind=Kn={}));class pn{static isNotebookRange(H){return H instanceof pn?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,N.$7)("start must be positive");if(me<0)throw(0,N.$7)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Me=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Me=H.end),me===this.c&&Me===this.e?this:new pn(me,Me)}}e.$BO=pn;class On{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>On.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Me,Ye,st,gt,vt){this.kind=H,this.value=me,this.languageId=Me,this.mime=Ye,this.outputs=st??[],this.metadata=gt,this.executionSummary=vt,On.validate(this)}}e.$CO=On;class wi{constructor(H){this.cells=H}}e.$DO=wi;class ui{static isNotebookCellOutputItem(H){return H instanceof o?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return o.json(me,"application/vnd.code.notebook.error")}static stdout(H){return o.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return o.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new o(H,me)}static text(H,me=L.$Rs.text){const Me=qe(o,o,"f",t).encode(String(H));return new o(Me,me)}static json(H,me="text/x-json"){const Me=JSON.stringify(H,void 0,"	");return o.text(Me,me)}constructor(H,me){this.data=H,this.mime=me;const Me=(0,L.$Vs)(me,!0);if(!Me)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$EO=ui,o=ui,t={value:new TextEncoder};class Mn{static isNotebookCellOutput(H){return H instanceof Mn?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Me=new Set,Ye=new Set;for(let st=0;st<H.length;st++){const gt=H[st],vt=(0,L.$Vs)(gt.mime);if(!Me.has(vt)||(0,p.$7K)(vt)){Me.add(vt);continue}Ye.add(st),me&&console.warn(`DUPLICATED mime type '${gt.mime}' will be dropped`)}return Ye.size===0?H:H.filter((st,gt)=>!Ye.has(gt))}constructor(H,me,Me){this.items=Mn.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Me):(this.id=(0,I.$Sg)(),this.metadata=me??Me)}}e.$FO=Mn;var li;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var hi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(hi||(e.NotebookCellExecutionState=hi={}));var di;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(di||(e.NotebookCellStatusBarAlignment=di={}));var fi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(fi||(e.NotebookEditorRevealType=fi={}));class vi{constructor(H,me){this.text=H,this.alignment=me}}e.$GO=vi;var gi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(gi||(e.NotebookControllerAffinity=gi={}));var fe;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(fe||(e.NotebookControllerAffinity2=fe={}));class Ee{constructor(H,me=[]){this.uri=H,this.provides=(0,a.$3b)(me)}}e.$HO=Ee;class Be{constructor(H){this.label=H}}e.$IO=Be;var lt;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(lt||(e.NotebookVariablesRequestKind=lt={}));let kt=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$JO=kt,e.$JO=kt=Je([O],kt);var Tt;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Tt||(e.ExtensionMode=Tt={}));var Tn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Tn||(e.ExtensionRuntime=Tn={}));var Di;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Di||(e.StandardTokenType=Di={}));class qi{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$KO=qi;class Hi{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$LO=Hi;var Pi;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Pi||(e.TestResultState=Pi={}));var Ci;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(Ci||(e.TestRunProfileKind=Ci={}));let yi=class{constructor(H=void 0,me=void 0,Me=void 0,Ye=!1,st=!0){this.include=H,this.exclude=me,this.profile=Me,this.continuous=Ye,this.preserveFocus=st}};e.$MO=yi,e.$MO=yi=Je([O],yi);let Ei=F=class{static diff(H,me,Me){const Ye=new F(H);return Ye.expectedOutput=me,Ye.actualOutput=Me,Ye}constructor(H){this.message=H}};e.$NO=Ei,e.$NO=Ei=F=Je([O],Ei);let ki=class{constructor(H){this.id=H}};e.$OO=ki,e.$OO=ki=Je([O],ki);class mi{constructor(H,me){this.covered=H,this.total=me,Ii(this)}}e.$PO=mi;function Ii(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class Si{static fromDetails(H,me){const Me=new mi(0,0),Ye=new mi(0,0),st=new mi(0,0);for(const vt of me)if("branches"in vt){Me.total+=1,Me.covered+=vt.executed?1:0;for(const Kt of vt.branches)Ye.total+=1,Ye.covered+=Kt.executed?1:0}else st.total+=1,st.covered+=vt.executed?1:0;const gt=new Si(H,Me,Ye.total>0?Ye:void 0,st.total>0?st:void 0);return gt.detailedCoverage=me,gt}constructor(H,me,Me,Ye){this.uri=H,this.statementCoverage=me,this.branchCoverage=Me,this.declarationCoverage=Ye}}e.$RO=Si;class Qi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Me=[]){this.executed=H,this.location=me,this.branches=Me}}e.$SO=Qi;class Gi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Me){this.executed=H,this.location=me,this.label=Me}}e.$TO=Gi;class Ji{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Me){this.name=H,this.executed=me,this.location=Me}}e.$UO=Ji;var Ai;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Ai||(e.ExternalUriOpenerPriority=Ai={}));var Ri;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Ri||(e.WorkspaceTrustState=Ri={}));var Ni;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ni||(e.PortAutoForwardAction=Ni={}));class Ki{constructor(H,me,Me,Ye,st,gt){this.kind=H,this.name=me,this.detail=Me,this.uri=Ye,this.range=st,this.selectionRange=gt}}e.$VO=Ki;class Xi{constructor(H){this.uri=H}}e.$WO=Xi;class Zi{constructor(H,me){this.original=H,this.modified=me}}e.$XO=Zi;class Yi{constructor(H,me,Me,Ye){this.base=H,this.input1=me,this.input2=Me,this.result=Ye}}e.$YO=Yi;class xi{constructor(H,me){this.uri=H,this.viewType=me}}e.$ZO=xi;class _i{constructor(H){this.viewType=H}}e.$1O=_i;class er{constructor(H,me){this.uri=H,this.notebookType=me}}e.$2O=er;class tr{constructor(H,me,Me){this.original=H,this.modified=me,this.notebookType=Me}}e.$3O=tr;class nr{constructor(){}}e.$4O=nr;class ir{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$5O=ir;class rr{constructor(){}}e.$6O=rr;class sr{constructor(H){this.textDiffs=H}}e.$7O=sr;var Li;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(Li||(e.InteractiveSessionVoteDirection=Li={}));var Oi;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Oi||(e.ChatCopyKind=Oi={}));var Mi;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Mi||(e.ChatVariableLevel=Mi={}));class or{constructor(H,me){this.label=H,this.values=me}}e.$8O=or;var Ti;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Ti||(e.InteractiveEditorResponseFeedbackKind=Ti={}));var Fi;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Fi||(e.ChatResultFeedbackKind=Fi={}));class ar{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ae(H):H}}e.$9O=ar;class cr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ae(H):H,this.vulnerabilities=me}}e.$0O=cr;class ur{constructor(H,me){this.participant=H,this.command=me}}e.$$O=ur;class lr{constructor(H,me){this.value=H,this.baseUri=me}}e.$_O=lr;class hr{constructor(H,me){this.value=H,this.title=me}}e.$aP=hr;class dr{constructor(H){this.value=H}}e.$bP=dr;class fr{constructor(H){this.value=H}}e.$cP=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$dP=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$eP=mr;class $r{constructor(H,me,Me,Ye){this.prompt=H,this.command=me,this.variables=Me,this.participant=Ye}}e.$fP=$r;class pr{constructor(H,me,Me,Ye){this.response=H,this.result=me,this.participant=Me,this.command=Ye}}e.$gP=pr;var ji;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(ji||(e.ChatLocation=ji={}));class br{constructor(H){this.content=H}}e.$hP=br;class wr{constructor(H,me){this.content=H,this.name=me}}e.$iP=wr;class vr{constructor(H,me){this.content=H,this.name=me}}e.$jP=vr;class Fn extends Error{static NotFound(H){return new Fn(H,Fn.NotFound.name)}static NoPermissions(H){return new Fn(H,Fn.NoPermissions.name)}constructor(H,me,Me){super(H,{cause:Me}),this.name="LanguageModelError",this.code=me??""}}e.$kP=Fn;var zi;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(zi||(e.RelatedInformationType=zi={}));var Bi;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(Bi||(e.SpeechToTextStatus=Bi={}));var Vi;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Vi||(e.KeywordRecognitionStatus=Vi={}));class yr{constructor(H,me){this.text=H,this.range=me}}e.$lP=yr;var Wi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Wi||(e.InlineEditTriggerKind=Wi={}))}),define(ke[328],Se([1,0,6,8]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(a.$0M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,$,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(L);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation($,m)??[]}getRelatedInformation(L,$,m){return this.c.$getAiRelatedInformation($,m)}registerRelatedInformationProvider(L,$,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,$),new N.$_M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$glc=A}),define(ke[122],Se([1,0,4,6,8,25,147,5,20]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=void 0,e.$rlc=(0,$.$wi)("IExtHostAuthentication");let E=class{constructor(b){this.b=new Map,this.c=new a.$ee,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=b.getProxy(N.$0M.MainThreadAuthentication)}async getSession(b,k,p,h={}){const g=R.$Sm.toKey(b.identifier),u=[...p].sort().join(" ");return await this.d.getOrCreate(`${g} ${k} ${u}`,async()=>{await this.a.$ensureProvider(k);const n=b.displayName||b.name;return this.a.$getSession(k,p,g,n,h)})}async getSessions(b,k,p){const h=R.$Sm.toKey(b.identifier),g=[...p].sort().join(" ");return await this.f.getOrCreate(`${h} ${g}`,async()=>{await this.a.$ensureProvider(k);const u=b.displayName||b.name;return this.a.$getSessions(k,p,h,u)})}async removeSession(b,k){const p=this.b.get(b);return p?p.provider.removeSession(k):this.a.$removeSession(b,k)}registerAuthenticationProvider(b,k,p,h){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:k,provider:p,options:h??{supportsMultipleAccounts:!1}});const g=p.onDidChangeSessions(u=>this.a.$sendDidChangeSessions(b,u));return this.a.$registerAuthenticationProvider(b,k,h?.supportsMultipleAccounts??!1),new A.$_M(()=>{g.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,k,p){const h=this.b.get(b);if(h)return Promise.resolve(h.provider.createSession(k,p));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,k){const p=this.b.get(b);if(p)return Promise.resolve(p.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,k){const p=this.b.get(b);if(p)return Promise.resolve(p.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,k){return b.startsWith(L.$_L)||this.c.fire({provider:{id:b,label:k}}),Promise.resolve()}};e.$slc=E,e.$slc=E=Je([Ue(0,m.$xP)],E);class I{constructor(){this.a=new Map}getOrCreate(b,k){const p=this.a.get(b);if(p)return p;const h=k().finally(()=>this.a.delete(b));return this.a.set(b,h),h}}}),define(ke[153],Se([1,0,2,6,8,5,20,11,19,14,17,26]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;let k=b=class{constructor(h,g){this.h=g,this.f=new Map,this.g=h.getProxy(N.$0M.MainThreadDecorations)}registerFileDecorationProvider(h,g){const u=b.c++;this.f.set(u,{provider:h,extensionDescription:g}),this.g.$registerDecorationProvider(u,g.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(u,null);return}const d=(0,m.$3b)(i);if(d.length<=b.d){this.g.$onDidChange(u,d);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,d.length);const o=d.map(r=>({uri:r,rank:(0,E.$bf)(r.path,"/")})),t=(0,m.$zb)(o,(r,c)=>r.rank-c.rank||(0,E.$rf)(r.uri.path,c.uri.path)),l=[];e:for(const r of t){let c;for(const s of r){const v=(0,I.$nc)(s.uri.path);if(c!==v&&(c=v,l.push(s.uri)>=b.d))break e}}this.g.$onDidChange(u,l)});return new A.$_M(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(u),this.f.delete(u)})}async $provideDecorations(h,g,u){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:d}=this.f.get(h);return await Promise.all(g.map(async o=>{try{const{uri:t,id:l}=o,r=await Promise.resolve(i.provideFileDecoration(a.URI.revive(t),u));if(!r)return;try{A.$zO.validate(r),r.badge&&typeof r.badge!="string"&&(0,P.$PG)(d,"codiconDecoration"),n[l]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this.h.warn(`INVALID decoration from extension '${d.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),n}};e.$rmc=k,k.c=0,k.d=250,e.$rmc=k=b=Je([Ue(0,L.$xP),Ue(1,$.$3j)],k),e.$smc=(0,R.$wi)("IExtHostDecorations")}),define(ke[329],Se([1,0,13,2,8,6,15,22,14]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class E{constructor(P,b,k){this.d=b,this.e=k,this.b=new Map,this.c=P.getProxy(R.$0M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,b){if(Object.keys(L.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const k=E.a++;this.b.set(k,b),this.c.$registerTextContentProvider(k,P);let p;if(typeof b.onDidChange=="function"){let h;p=b.onDidChange(async g=>{if(g.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;h&&await h;const u=this.$provideTextDocumentContent(k,g).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(g);if(!i)return;const d=(0,m.$lf)(n);if(!i.equalLines(d))return this.c.$onVirtualDocumentChange(g,n)}).catch(a.$1).finally(()=>{h===u&&(h=void 0)});h=u})}return new A.$_M(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(P,b){const k=this.b.get(P);return k?Promise.resolve(k.provideTextDocumentContent(N.URI.revive(b),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.$umc=E,E.a=0}),define(ke[154],Se([1,0,62,15,14,196,134,8,19]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=void 0,e.$zP=I;const E=new Map;function I(p,h){h?E.set(p,h):E.delete(p)}function P(p){return E.get(p)}class b extends R.$7v{constructor(h,g,u,n,i,d,o){super(g,u,n,i),this.c=h,this.m=d,this.q=o,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,m.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===N.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(g){return g?h.s(g):h.getText()},get eol(){return h.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(g){return h.t(g)},offsetAt(g){return h.u(g)},positionAt(g){return h.v(g)},validateRange(g){return h.w(g)},validatePosition(g){return h.x(g)},getWordRangeAtPosition(g,u){return h.y(g,u)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,a.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,a.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const g=this.w(h);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const u=this.g,n=g.start.line,i=g.end.line,d=[];d.push(this.f[n].substring(g.start.character));for(let o=n+1;o<i;o++)d.push(this.f[o]);return d.push(this.f[i].substring(0,g.end.character)),d.join(u)}t(h){let g;if(h instanceof $.$aN?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new k(g,this.f[g],g===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const g=this.j.getIndexOf(h),u=this.f[g.index].length;return new $.$aN(g.index,Math.min(g.remainder,u))}w(h){if(!(h instanceof $.$bN))throw new Error("Invalid argument");const g=this.x(h.start),u=this.x(h.end);return g===h.start&&u===h.end?h:new $.$bN(g.line,g.character,u.line,u.character)}x(h){if(!(h instanceof $.$aN))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:g,character:u}=h,n=!1;if(g<0)g=0,u=0,n=!0;else if(g>=this.f.length)g=this.f.length-1,u=this.f[g].length,n=!0;else{const i=this.f[g].length;u<0?(u=0,n=!0):u>i&&(u=i,n=!0)}return n?new $.$aN(g,u):h}y(h,g){const u=this.x(h);if(!g)g=P(this.m);else if((0,A.$kf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const n=(0,L.$0s)(u.character+1,(0,L.$8s)(g),this.f[u.line],0);if(n)return new $.$bN(u.line,n.startColumn-1,u.line,n.endColumn-1)}}e.$AP=b;class k{constructor(h,g,u){this.a=h,this.b=g,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$bN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$bN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$BP=k}),define(ke[330],Se([1,0,6,8]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(a.$0M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,$,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(L);if(!E)throw new Error("Embedding vector provider not found");const I=await E.provideEmbeddingVector($,m);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,$,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider($,E),new N.$_M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$wmc=A}),define(ke[70],Se([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=void 0;let p=k=class{constructor(g,u){this.b=new Map,this.c=new I.$Fh,this.a=g.getProxy(a.$0M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let d;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),d=await o.impl.stat(i)):d=await n.a.$stat(i),{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions===N.FilePermission.Readonly?1:void 0}}catch(d){k.e(d)}},async readDirectory(i){try{const d=n.b.get(i.scheme);return d?(await n.a.$ensureActivation(i.scheme),(await d.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(d){return k.e(d)}},async createDirectory(i){try{const d=n.b.get(i.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(d.impl,d.extUri,i)):await n.a.$mkdir(i)}catch(d){return k.e(d)}},async readFile(i){try{const d=n.b.get(i.scheme);return d?(await n.a.$ensureActivation(i.scheme),(await d.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(d){return k.e(d)}},async writeFile(i,d){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,d,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Ge.wrap(d))}catch(o){return k.e(o)}},async delete(i,d){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!d?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...d})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...d})}catch(o){return k.e(o)}},async rename(i,d,o){try{return await n.a.$rename(i,d,{overwrite:!1,...o})}catch(t){return k.e(t)}},async copy(i,d,o){try{return await n.a.$copy(i,d,{overwrite:!1,...o})}catch(t){return k.e(t)}},isWritableFileSystem(i){const d=u.getCapabilities(i);if(typeof d=="number")return!(d&2048)}})}async d(g,u,n){const i=[];for(;!u.isEqual(n,u.dirname(n));)try{if(!((await g.stat(n)).type&N.FileType.Directory))throw A.$qO.FileExists(`Unable to create folder '${n.scheme===b.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(d){if(N.$gl(d)!==N.FileSystemProviderErrorCode.FileNotFound)throw d;i.push(u.basename(n)),n=u.dirname(n)}for(let d=i.length-1;d>=0;d--){n=u.joinPath(n,i[d]);try{await g.createDirectory(n)}catch(o){if(N.$gl(o)!==N.FileSystemProviderErrorCode.FileExists)throw o}}}static e(g){if(g instanceof A.$qO)throw g;if(g instanceof N.$cl)switch(g.code){case N.FileSystemProviderErrorCode.FileExists:throw A.$qO.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw A.$qO.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw A.$qO.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw A.$qO.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw A.$qO.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw A.$qO.Unavailable(g.message);default:throw new A.$qO(g.message,g.name)}if(!(g instanceof Error))throw new A.$qO(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw A.$qO.Unavailable(g.message);switch(g.name){case N.FileSystemProviderErrorCode.FileExists:throw A.$qO.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw A.$qO.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw A.$qO.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw A.$qO.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw A.$qO.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw A.$qO.Unavailable(g.message);default:throw new A.$qO(g.message,g.name)}}addFileSystemProvider(g,u,n){return this.b.set(g,{impl:u,extUri:n?.isCaseSensitive?P.$Zg:P.$2g,isReadonly:!!n?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??P.$Zg}};e.$Hlc=p,e.$Hlc=p=k=Je([Ue(0,$.$xP),Ue(1,m.$llc)],p),e.$Ilc=(0,L.$wi)("IExtHostConsumerFileSystem")}),define(ke[93],Se([1,0,5,28,11,70,2]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0,e.$Jlc=(0,a.$wi)("IExtensionStoragePaths");let $=class{constructor(E,I,P){this.d=I,this.f=P,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(b=>this.c=b)}async g(E){return L.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,I=await this.g(E);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(E){if(this.c)return L.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return L.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Klc=$,e.$Klc=$=Je([Ue(0,N.$NP),Ue(1,A.$3j),Ue(2,R.$Ilc)],$)}),define(ke[331],Se([1,0,8,20,4]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;let R=class{constructor($){this.a=new a.$AO(a.ColorThemeKind.Dark),this.b=new A.$ee}get activeColorTheme(){return this.a}$onColorThemeChange($){let m;switch($){case"light":m=a.ColorThemeKind.Light;break;case"hcDark":m=a.ColorThemeKind.HighContrast;break;case"hcLight":m=a.ColorThemeKind.HighContrastLight;break;default:m=a.ColorThemeKind.Dark}this.a=new a.$AO(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$fnc=R,e.$fnc=R=Je([Ue(0,N.$xP)],R)}),define(ke[71],Se([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GDb=e.$FDb=e.TunnelDtoConverter=void 0;class k extends m.$tw{}var p;(function(g){function u(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}g.fromApiTunnel=u;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}g.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$FDb=(0,L.$wi)("IExtHostTunnelService");let h=class extends A.$Vc{constructor(u,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=u.getProxy(E.$0M.MainThreadTunnelService)}async openTunnel(u,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,u.displayName);if(i){const d=new k(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(d),d}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(u,n){u.portRange===void 0&&u.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:u,provider:n}),this.a.$registerPortsAttributesProvider(u,i),new b.$_M(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(u,n,i,d,o){const t=[];for(const r of u){const c=this.r.get(r);if(!c)return[];t.push(...await Promise.all(n.map(async s=>{let v;try{v=await c.provider.providePortAttributes({port:s,pid:i,commandLine:d},o)}catch{v=await c.provider.providePortAttributes(s,i,d,o)}return{providedAttributes:v,port:s}})))}const l=t.filter(r=>!!r.providedAttributes);return l.length>0?l.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(u){}registerTunnelProvider(u,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(d,o)=>await u.provideTunnel(d,o,a.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,A.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(u,n){if(u){u.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this.f=u.showCandidatePort,this.a.$setCandidateFilter());const i=u.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let d=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const o=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:d,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,A.$Tc)(()=>{this.b=void 0})}w(u){}async $closeTunnel(u,n){if(this.g.has(u.host)){const i=this.g.get(u.host);i.has(u.port)&&(n&&i.get(u.port).disposeListener.dispose(),await i.get(u.port).tunnel.dispose(),i.delete(u.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(u,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(u,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const d=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),d===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(u.remoteAddress.host)||this.g.set(u.remoteAddress.host,new Map);const o=this.B(d.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(d.remoteAddress))));return this.g.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:d,disposeListener:o}),p.fromApiTunnel(d)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(u){const n=await Promise.all(u.map(d=>this.f(d.host,d.port,d.detail??""))),i=u.filter((d,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(d=>d.port).join(", ")} to ${i.map(d=>d.port).join(", ")}`),i}};e.$GDb=h,e.$GDb=h=Je([Ue(0,P.$xP),Ue(1,I.$NP),Ue(2,$.$3j)],h)}),define(ke[16],Se([1,0,19,21,180,75,80,27,168,58,98,24,173,23,18,2,29,84,140,146,144,295,121,69,89,307,8,51]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l,r,c,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$uP=O,e.$vP=Y,e.$wP=V;var f;(function(Le){function ze(ee){const{selectionStartLineNumber:Fe,selectionStartColumn:Qe,positionLineNumber:_e,positionColumn:Ze}=ee,ft=new s.$aN(Fe-1,Qe-1),St=new s.$aN(_e-1,Ze-1);return new s.$cN(ft,St)}Le.to=ze;function ye(ee){const{anchor:Fe,active:Qe}=ee;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Le.from=ye})(f||(e.Selection=f={}));var y;(function(Le){function ze(ee){if(!ee)return;const{start:Fe,end:Qe}=ee;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Le.from=ze;function ye(ee){if(!ee)return;const{startLineNumber:Fe,startColumn:Qe,endLineNumber:_e,endColumn:Ze}=ee;return new s.$bN(Fe-1,Qe-1,_e-1,Ze-1)}Le.to=ye})(y||(e.Range=y={}));var w;(function(Le){function ze(ee){return{uri:ee.uri,range:y.from(ee.range)}}Le.from=ze;function ye(ee){return new s.$lN(h.URI.revive(ee.uri),y.to(ee.range))}Le.to=ye})(w||(e.Location=w={}));var D;(function(Le){function ze(ye){switch(ye){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Le.to=ze})(D||(e.TokenType=D={}));var S;(function(Le){function ze(ee){return new s.$aN(ee.lineNumber-1,ee.column-1)}Le.to=ze;function ye(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Le.from=ye})(S||(e.Position=S={}));var C;(function(Le){function ze(Fe,Qe,_e){return(0,a.$Hb)((0,a.$3b)(Fe).map(Ze=>ye(Ze,Qe,_e)))}Le.from=ze;function ye(Fe,Qe,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ee(Fe.scheme,Qe),pattern:Ce.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Fe,Qe){return Qe&&typeof Fe=="string"?Qe.transformOutgoingScheme(Fe):Fe}})(C||(e.DocumentSelector=C={}));var j;(function(Le){function ze(ee){switch(ee){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Le.from=ze;function ye(ee){switch(ee){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Le.to=ye})(j||(e.DiagnosticTag=j={}));var B;(function(Le){function ze(ee){let Fe;return ee.code&&((0,p.$9f)(ee.code)||(0,p.$ag)(ee.code)?Fe=String(ee.code):Fe={value:String(ee.code.value),target:ee.code.target}),{...y.from(ee.range),message:ee.message,source:ee.source,code:Fe,severity:T.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(z.from),tags:Array.isArray(ee.tags)?(0,a.$Hb)(ee.tags.map(j.from)):void 0}}Le.from=ze;function ye(ee){const Fe=new s.$nN(y.to(ee),ee.message,T.to(ee.severity));return Fe.source=ee.source,Fe.code=(0,p.$9f)(ee.code)?ee.code:ee.code?.value,Fe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(z.to),Fe.tags=ee.tags&&(0,a.$Hb)(ee.tags.map(j.to)),Fe}Le.to=ye})(B||(e.Diagnostic=B={}));var z;(function(Le){function ze(ee){return{...y.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Le.from=ze;function ye(ee){return new s.$mN(new s.$lN(ee.resource,y.to(ee)),ee.message)}Le.to=ye})(z||(e.DiagnosticRelatedInformation=z={}));var T;(function(Le){function ze(ee){switch(ee){case s.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Le.from=ze;function ye(ee){switch(ee){case n.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Le.to=ye})(T||(e.DiagnosticSeverity=T={}));var M;(function(Le){function ze(ee){return typeof ee=="number"&&ee>=s.ViewColumn.One?ee-1:ee===s.ViewColumn.Beside?c.$5D:c.$4D}Le.from=ze;function ye(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ye})(M||(e.ViewColumn=M={}));function F(Le){return typeof Le.range<"u"}function O(Le){return Le.length===0?!0:!!F(Le[0])}var q;(function(Le){function ze(Ze){return Ze.map(Le.from)}Le.fromMany=ze;function ye(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function ee(Ze){let ft;if(ye(Ze)){const{language:qt,value:Rt}=Ze;ft={value:"```"+qt+`
`+Rt+"\n```\n"}}else s.$BN.isMarkdownString(Ze)?ft={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons,supportHtml:Ze.supportHtml,baseUri:Ze.baseUri}:typeof Ze=="string"?ft={value:Ze}:ft={value:""};const St=Object.create(null);ft.uris=St;const Vt=qt=>{try{let Rt=h.URI.parse(qt,!0);Rt=Rt.with({query:Fe(Rt.query,St)}),St[qt]=Rt}catch{}return""},dt=new m.marked.Renderer;return dt.link=Vt,dt.image=qt=>typeof qt=="string"?Vt(L.$2k(qt).href):"",(0,m.marked)(ft.value,{renderer:dt}),ft}Le.from=ee;function Fe(Ze,ft){if(!Ze)return Ze;let St;try{St=(0,E.$5h)(Ze)}catch{}if(!St)return Ze;let Vt=!1;return St=(0,P.$6n)(St,dt=>{if(h.URI.isUri(dt)){const qt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[qt]=dt,Vt=!0,qt}else return}),Vt?JSON.stringify(St):Ze}function Qe(Ze){const ft=new s.$BN(Ze.value,Ze.supportThemeIcons);return ft.isTrusted=Ze.isTrusted,ft.supportHtml=Ze.supportHtml,ft.baseUri=Ze.baseUri?h.URI.from(Ze.baseUri):void 0,ft}Le.to=Qe;function _e(Ze){if(Ze)return typeof Ze=="string"?Ze:Le.from(Ze)}Le.fromStrict=_e})(q||(e.MarkdownString=q={}));function Y(Le){return O(Le)?Le.map(ze=>({range:y.from(ze.range),hoverMessage:Array.isArray(ze.hoverMessage)?q.fromMany(ze.hoverMessage):ze.hoverMessage?q.from(ze.hoverMessage):void 0,renderOptions:ze.renderOptions})):Le.map(ze=>({range:y.from(ze)}))}function V(Le){return typeof Le>"u"?Le:typeof Le=="string"?h.URI.file(Le):Le}var J;(function(Le){function ze(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?V(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Le.from=ze})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var x;(function(Le){function ze(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?V(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?J.from(ye.before):void 0,after:ye.after?J.from(ye.after):void 0}}Le.from=ze})(x||(e.ThemableDecorationRenderOptions=x={}));var ne;(function(Le){function ze(ye){if(typeof ye>"u")return ye;switch(ye){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=ze})(ne||(e.DecorationRangeBehavior=ne={}));var de;(function(Le){function ze(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ne.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?x.from(ye.light):void 0,dark:ye.dark?x.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?V(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?J.from(ye.before):void 0,after:ye.after?J.from(ye.after):void 0}}Le.from=ze})(de||(e.DecorationRenderOptions=de={}));var ce;(function(Le){function ze(ee){return{text:ee.newText,eol:ee.newEol&&Ve.from(ee.newEol),range:y.from(ee.range)}}Le.from=ze;function ye(ee){const Fe=new s.$gN(y.to(ee.range),ee.text);return Fe.newEol=typeof ee.eol>"u"?void 0:Ve.to(ee.eol),Fe}Le.to=ye})(ce||(e.TextEdit=ce={}));var ve;(function(Le){function ze(ee,Fe){const Qe={edits:[]};if(ee instanceof s.$jN){const _e=new $.$Cc;for(const Ze of ee._allEntries())Ze._type===1&&h.URI.isUri(Ze.to)&&Ze.from===void 0&&_e.add(Ze.to);for(const Ze of ee._allEntries())if(Ze._type===1){let ft;Ze.options?.contents&&(ArrayBuffer.isView(Ze.options.contents)?ft={type:"base64",value:(0,N.$1e)(N.$Ge.wrap(Ze.options.contents))}:ft={type:"dataTransferItem",id:Ze.options.contents._itemId}),Qe.edits.push({oldResource:Ze.from,newResource:Ze.to,options:{...Ze.options,contents:ft},metadata:Ze.metadata})}else Ze._type===2?Qe.edits.push({resource:Ze.uri,textEdit:ce.from(Ze.edit),versionId:_e.has(Ze.uri)?void 0:Fe?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata}):Ze._type===6?Qe.edits.push({resource:Ze.uri,textEdit:{range:y.from(Ze.range),text:Ze.edit.value,insertAsSnippet:!0},versionId:_e.has(Ze.uri)?void 0:Fe?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata}):Ze._type===3?Qe.edits.push({metadata:Ze.metadata,resource:Ze.uri,cellEdit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ze.uri)}):Ze._type===5&&Qe.edits.push({metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ze.uri),cellEdit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(_t.from)}})}return Qe}Le.from=ze;function ye(ee){const Fe=new s.$jN,Qe=new $.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Ze=_e,ft=h.URI.revive(Ze.resource),St=y.to(Ze.textEdit.range),Vt=Ze.textEdit.text,dt=Ze.textEdit.insertAsSnippet;let qt;dt?qt=s.$iN.replace(St,new s.$kN(Vt)):qt=s.$gN.replace(St,Vt);const Rt=Qe.get(ft);Rt?Rt.push(qt):Qe.set(ft,[qt])}else Fe.renameFile(h.URI.revive(_e.oldResource),h.URI.revive(_e.newResource),_e.options);for(const[_e,Ze]of Qe)Fe.set(_e,Ze);return Fe}Le.to=ye})(ve||(e.WorkspaceEdit=ve={}));var _;(function(Le){const ze=Object.create(null);ze[s.SymbolKind.File]=0,ze[s.SymbolKind.Module]=1,ze[s.SymbolKind.Namespace]=2,ze[s.SymbolKind.Package]=3,ze[s.SymbolKind.Class]=4,ze[s.SymbolKind.Method]=5,ze[s.SymbolKind.Property]=6,ze[s.SymbolKind.Field]=7,ze[s.SymbolKind.Constructor]=8,ze[s.SymbolKind.Enum]=9,ze[s.SymbolKind.Interface]=10,ze[s.SymbolKind.Function]=11,ze[s.SymbolKind.Variable]=12,ze[s.SymbolKind.Constant]=13,ze[s.SymbolKind.String]=14,ze[s.SymbolKind.Number]=15,ze[s.SymbolKind.Boolean]=16,ze[s.SymbolKind.Array]=17,ze[s.SymbolKind.Object]=18,ze[s.SymbolKind.Key]=19,ze[s.SymbolKind.Null]=20,ze[s.SymbolKind.EnumMember]=21,ze[s.SymbolKind.Struct]=22,ze[s.SymbolKind.Event]=23,ze[s.SymbolKind.Operator]=24,ze[s.SymbolKind.TypeParameter]=25;function ye(Fe){return typeof ze[Fe]=="number"?ze[Fe]:6}Le.from=ye;function ee(Fe){for(const Qe in ze)if(ze[Qe]===Fe)return Number(Qe);return s.SymbolKind.Property}Le.to=ee})(_||(e.SymbolKind=_={}));var U;(function(Le){function ze(ee){switch(ee){case s.SymbolTag.Deprecated:return 1}}Le.from=ze;function ye(ee){switch(ee){case 1:return s.SymbolTag.Deprecated}}Le.to=ye})(U||(e.SymbolTag=U={}));var le;(function(Le){function ze(ee){return{name:ee.name,kind:_.from(ee.kind),tags:ee.tags&&ee.tags.map(U.from),containerName:ee.containerName,location:oe.from(ee.location)}}Le.from=ze;function ye(ee){const Fe=new s.$sN(ee.name,_.to(ee.kind),ee.containerName,oe.to(ee.location));return Fe.tags=ee.tags&&ee.tags.map(U.to),Fe}Le.to=ye})(le||(e.WorkspaceSymbol=le={}));var De;(function(Le){function ze(ee){const Fe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:y.from(ee.range),selectionRange:y.from(ee.selectionRange),kind:_.from(ee.kind),tags:ee.tags?.map(U.from)??[]};return ee.children&&(Fe.children=ee.children.map(ze)),Fe}Le.from=ze;function ye(ee){const Fe=new s.$tN(ee.name,ee.detail,_.to(ee.kind),y.to(ee.range),y.to(ee.selectionRange));return(0,a.$Lb)(ee.tags)&&(Fe.tags=ee.tags.map(U.to)),ee.children&&(Fe.children=ee.children.map(ye)),Fe}Le.to=ye})(De||(e.DocumentSymbol=De={}));var $e;(function(Le){function ze(ee){const Fe=new s.$xN(_.to(ee.kind),ee.name,ee.detail||"",h.URI.revive(ee.uri),y.to(ee.range),y.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Le.to=ze;function ye(ee,Fe,Qe){if(Fe=Fe??ee._sessionId,Qe=Qe??ee._itemId,Fe===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Qe,name:ee.name,detail:ee.detail,kind:_.from(ee.kind),uri:ee.uri,range:y.from(ee.range),selectionRange:y.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Le.from=ye})($e||(e.CallHierarchyItem=$e={}));var re;(function(Le){function ze(ye){return new s.$yN($e.to(ye.from),ye.fromRanges.map(ee=>y.to(ee)))}Le.to=ze})(re||(e.CallHierarchyIncomingCall=re={}));var se;(function(Le){function ze(ye){return new s.$zN($e.to(ye.to),ye.fromRanges.map(ee=>y.to(ee)))}Le.to=ze})(se||(e.CallHierarchyOutgoingCall=se={}));var oe;(function(Le){function ze(ee){return{range:ee.range&&y.from(ee.range),uri:ee.uri}}Le.from=ze;function ye(ee){return new s.$lN(h.URI.revive(ee.uri),y.to(ee.range))}Le.to=ye})(oe||(e.location=oe={}));var K;(function(Le){function ze(ee){const Fe=ee,Qe=ee;return{originSelectionRange:Fe.originSelectionRange?y.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Qe.uri,range:y.from(Fe.targetRange?Fe.targetRange:Qe.range),targetSelectionRange:Fe.targetSelectionRange?y.from(Fe.targetSelectionRange):void 0}}Le.from=ze;function ye(ee){return{targetUri:h.URI.revive(ee.uri),targetRange:y.to(ee.range),targetSelectionRange:ee.targetSelectionRange?y.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?y.to(ee.originSelectionRange):void 0}}Le.to=ye})(K||(e.DefinitionLink=K={}));var te;(function(Le){function ze(ee){return{range:y.from(ee.range),contents:q.fromMany(ee.contents),canIncreaseVerbosity:ee.canIncreaseVerbosity,canDecreaseVerbosity:ee.canDecreaseVerbosity}}Le.from=ze;function ye(ee){const Fe=ee.contents.map(q.to),Qe=y.to(ee.range),_e=ee.canIncreaseVerbosity,Ze=ee.canDecreaseVerbosity;return new s.$pN(Fe,Qe,_e,Ze)}Le.to=ye})(te||(e.Hover=te={}));var ge;(function(Le){function ze(ee){return{range:y.from(ee.range),expression:ee.expression}}Le.from=ze;function ye(ee){return new s.$kO(y.to(ee.range),ee.expression)}Le.to=ye})(ge||(e.EvaluatableExpression=ge={}));var be;(function(Le){function ze(ee){if(ee instanceof s.$lO)return{type:"text",range:y.from(ee.range),text:ee.text};if(ee instanceof s.$mO)return{type:"variable",range:y.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof s.$nO)return{type:"expression",range:y.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=ze;function ye(ee){switch(ee.type){case"text":return{range:y.to(ee.range),text:ee.text};case"variable":return{range:y.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:y.to(ee.range),expression:ee.expression}}}Le.to=ye})(be||(e.InlineValue=be={}));var Re;(function(Le){function ze(ee){return{frameId:ee.frameId,stoppedLocation:y.from(ee.stoppedLocation)}}Le.from=ze;function ye(ee){return new s.$oO(ee.frameId,y.to(ee.stoppedLocation))}Le.to=ye})(Re||(e.InlineValueContext=Re={}));var pe;(function(Le){function ze(ee){return{range:y.from(ee.range),kind:ee.kind}}Le.from=ze;function ye(ee){return new s.$qN(y.to(ee.range),ee.kind)}Le.to=ye})(pe||(e.DocumentHighlight=pe={}));var Pe;(function(Le){function ze(ee){return{uri:ee.uri,highlights:ee.highlights.map(pe.from)}}Le.from=ze;function ye(ee){return new s.$rN(h.URI.revive(ee.uri),ee.highlights.map(pe.to))}Le.to=ye})(Pe||(e.MultiDocumentHighlight=Pe={}));var Ie;(function(Le){function ze(ye){switch(ye){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Le.to=ze})(Ie||(e.CompletionTriggerKind=Ie={}));var je;(function(Le){function ze(ye){return{triggerKind:Ie.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Le.to=ze})(je||(e.CompletionContext=je={}));var W;(function(Le){function ze(ee){switch(ee){case s.CompletionItemTag.Deprecated:return 1}}Le.from=ze;function ye(ee){switch(ee){case 1:return s.CompletionItemTag.Deprecated}}Le.to=ye})(W||(e.CompletionItemTag=W={}));var Q;(function(Le){const ze=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ye(Qe){return ze.get(Qe)??9}Le.from=ye;const ee=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(Qe){return ee.get(Qe)??s.CompletionItemKind.Property}Le.to=Fe})(Q||(e.CompletionItemKind=Q={}));var X;(function(Le){function ze(ye,ee){const Fe=new s.$HN(ye.label);return Fe.insertText=ye.insertText,Fe.kind=Q.to(ye.kind),Fe.tags=ye.tags?.map(W.to),Fe.detail=ye.detail,Fe.documentation=L.$Vk(ye.documentation)?q.to(ye.documentation):ye.documentation,Fe.sortText=ye.sortText,Fe.filterText=ye.filterText,Fe.preselect=ye.preselect,Fe.commitCharacters=ye.commitCharacters,g.$vt.isIRange(ye.range)?Fe.range=y.to(ye.range):typeof ye.range=="object"&&(Fe.range={inserting:y.to(ye.range.insert),replacing:y.to(ye.range.replace)}),Fe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Fe.insertText=new s.$kN(ye.insertText):(Fe.insertText=ye.insertText,Fe.textEdit=Fe.range instanceof s.$bN?new s.$gN(Fe.range,Fe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ye.additionalTextEdits.map(Qe=>ce.to(Qe))),Fe.command=ee&&ye.command?ee.fromInternal(ye.command):void 0,Fe}Le.to=ze})(X||(e.CompletionItem=X={}));var Z;(function(Le){function ze(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:q.fromStrict(ee.documentation)}}Le.from=ze;function ye(ee){return{label:ee.label,documentation:L.$Vk(ee.documentation)?q.to(ee.documentation):ee.documentation}}Le.to=ye})(Z||(e.ParameterInformation=Z={}));var he;(function(Le){function ze(ee){return{label:ee.label,documentation:q.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(Z.from):[],activeParameter:ee.activeParameter}}Le.from=ze;function ye(ee){return{label:ee.label,documentation:L.$Vk(ee.documentation)?q.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(Z.to):[],activeParameter:ee.activeParameter}}Le.to=ye})(he||(e.SignatureInformation=he={}));var we;(function(Le){function ze(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.from):[]}}Le.from=ze;function ye(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.to):[]}}Le.to=ye})(we||(e.SignatureHelp=we={}));var Te;(function(Le){function ze(ye,ee){const Fe=new s.$GN(S.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(He.to.bind(void 0,ye)),ee.kind&&Xe.to(ee.kind));return Fe.textEdits=ee.textEdits&&ee.textEdits.map(ce.to),Fe.tooltip=L.$Vk(ee.tooltip)?q.to(ee.tooltip):ee.tooltip,Fe.paddingLeft=ee.paddingLeft,Fe.paddingRight=ee.paddingRight,Fe}Le.to=ze})(Te||(e.InlayHint=Te={}));var He;(function(Le){function ze(ye,ee){const Fe=new s.$FN(ee.label);return Fe.tooltip=L.$Vk(ee.tooltip)?q.to(ee.tooltip):ee.tooltip,u.Command.is(ee.command)&&(Fe.command=ye.fromInternal(ee.command)),ee.location&&(Fe.location=oe.to(ee.location)),Fe}Le.to=ze})(He||(e.InlayHintLabelPart=He={}));var Xe;(function(Le){function ze(ee){return ee}Le.from=ze;function ye(ee){return ee}Le.to=ye})(Xe||(e.InlayHintKind=Xe={}));var et;(function(Le){function ze(ee){return{range:y.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Le.from=ze;function ye(ee){let Fe;if(ee.url)try{Fe=typeof ee.url=="string"?h.URI.parse(ee.url,!0):h.URI.revive(ee.url)}catch{}return new s.$MN(y.to(ee.range),Fe)}Le.to=ye})(et||(e.DocumentLink=et={}));var rt;(function(Le){function ze(ee){const Fe=new s.$PN(ee.label);return ee.textEdit&&(Fe.textEdit=ce.to(ee.textEdit)),ee.additionalTextEdits&&(Fe.additionalTextEdits=ee.additionalTextEdits.map(Qe=>ce.to(Qe))),Fe}Le.to=ze;function ye(ee){return{label:ee.label,textEdit:ee.textEdit?ce.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Fe=>ce.from(Fe)):void 0}}Le.from=ye})(rt||(e.ColorPresentation=rt={}));var at;(function(Le){function ze(ee){return new s.$NN(ee[0],ee[1],ee[2],ee[3])}Le.to=ze;function ye(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Le.from=ye})(at||(e.Color=at={}));var ot;(function(Le){function ze(ee){return{range:y.from(ee.range)}}Le.from=ze;function ye(ee){return new s.$wN(y.to(ee.range))}Le.to=ye})(ot||(e.SelectionRange=ot={}));var ct;(function(Le){function ze(ye){switch(ye){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Le.to=ze})(ct||(e.TextDocumentSaveReason=ct={}));var Ne;(function(Le){function ze(ee){switch(ee){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=ze;function ye(ee){switch(ee){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Le.to=ye})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var Ve;(function(Le){function ze(ee){if(ee===s.EndOfLine.CRLF)return 1;if(ee===s.EndOfLine.LF)return 0}Le.from=ze;function ye(ee){if(ee===1)return s.EndOfLine.CRLF;if(ee===0)return s.EndOfLine.LF}Le.to=ye})(Ve||(e.EndOfLine=Ve={}));var Ae;(function(Le){function ze(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=ze})(Ae||(e.ProgressLocation=Ae={}));var Ge;(function(Le){function ze(ee){const Fe={start:ee.start+1,end:ee.end+1};return ee.kind&&(Fe.kind=ae.from(ee.kind)),Fe}Le.from=ze;function ye(ee){const Fe={start:ee.start-1,end:ee.end-1};return ee.kind&&(Fe.kind=ae.to(ee.kind)),Fe}Le.to=ye})(Ge||(e.FoldingRange=Ge={}));var ae;(function(Le){function ze(ee){if(ee)switch(ee){case s.FoldingRangeKind.Comment:return u.$eu.Comment;case s.FoldingRangeKind.Imports:return u.$eu.Imports;case s.FoldingRangeKind.Region:return u.$eu.Region}}Le.from=ze;function ye(ee){if(ee)switch(ee.value){case u.$eu.Comment.value:return s.FoldingRangeKind.Comment;case u.$eu.Imports.value:return s.FoldingRangeKind.Imports;case u.$eu.Region.value:return s.FoldingRangeKind.Region}}Le.to=ye})(ae||(e.FoldingRangeKind=ae={}));var ue;(function(Le){function ze(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?y.from(ye.selection):void 0,override:typeof ye.override=="boolean"?d.$uF.id:void 0}}Le.from=ze})(ue||(e.TextEditorOpenOptions=ue={}));var Ce;(function(Le){function ze(Qe){return Qe instanceof s.$$N?Qe.toJSON():typeof Qe=="string"?Qe:ye(Qe)||ee(Qe)?new s.$$N(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Le.from=ze;function ye(Qe){const _e=Qe;return _e?h.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(Qe){const _e=Qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(Qe){return typeof Qe=="string"?Qe:new s.$$N(h.URI.revive(Qe.baseUri),Qe.pattern)}Le.to=Fe})(Ce||(e.GlobPattern=Ce={}));var Ke;(function(Le){function ze(ye){if(ye){if(Array.isArray(ye))return ye.map(ze);if(typeof ye=="string")return ye;{const ee=ye;return{language:ee.language,scheme:ee.scheme,pattern:Ce.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Le.from=ze})(Ke||(e.LanguageSelector=Ke={}));var Oe;(function(Le){function ze(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&h.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(_e=>_e instanceof s.$bN)))}Le.is=ze;function ye(ee){return{documents:ee.documents.map(Fe=>Fe.map(Qe=>({uri:h.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(_e=>y.from(_e))})))}}Le.from=ye})(Oe||(e.MappedEditsContext=Oe={}));var nt;(function(Le){function ze(ee){return{start:ee.start,end:ee.end}}Le.from=ze;function ye(ee){return new s.$BO(ee.start,ee.end)}Le.to=ye})(nt||(e.NotebookRange=nt={}));var ht;(function(Le){function ze(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Le.to=ze;function ye(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Le.from=ye})(ht||(e.NotebookCellExecutionSummary=ht={}));var yt;(function(Le){function ze(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Le.to=ze})(yt||(e.NotebookCellExecutionState=yt={}));var Nt;(function(Le){function ze(ee){switch(ee){case s.NotebookCellKind.Markup:return t.CellKind.Markup;case s.NotebookCellKind.Code:default:return t.CellKind.Code}}Le.from=ze;function ye(ee){switch(ee){case t.CellKind.Markup:return s.NotebookCellKind.Markup;case t.CellKind.Code:default:return s.NotebookCellKind.Code}}Le.to=ye})(Nt||(e.NotebookCellKind=Nt={}));var jt;(function(Le){function ze(ee){const Fe={metadata:ee.metadata??Object.create(null),cells:[]};for(const Qe of ee.cells)s.$CO.validate(Qe),Fe.cells.push(_t.from(Qe));return Fe}Le.from=ze;function ye(ee){const Fe=new s.$DO(ee.cells.map(_t.to));return(0,p.$jg)(ee.metadata)||(Fe.metadata=ee.metadata),Fe}Le.to=ye})(jt||(e.NotebookData=jt={}));var _t;(function(Le){function ze(ee){return{cellKind:Nt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:ht.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(Pt.from):[]}}Le.from=ze;function ye(ee){return new s.$CO(Nt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(Pt.to):void 0,ee.metadata,ee.internalMetadata?ht.to(ee.internalMetadata):void 0)}Le.to=ye})(_t||(e.NotebookCellData=_t={}));var Xt;(function(Le){function ze(ee){return{mime:ee.mime,valueBytes:N.$Ge.wrap(ee.data)}}Le.from=ze;function ye(ee){return new s.$EO(ee.valueBytes.buffer,ee.mime)}Le.to=ye})(Xt||(e.NotebookCellOutputItem=Xt={}));var Pt;(function(Le){function ze(ee){return{outputId:ee.id,items:ee.items.map(Xt.from),metadata:ee.metadata}}Le.from=ze;function ye(ee){const Fe=ee.items.map(Xt.to);return new s.$FO(Fe,ee.outputId,ee.metadata)}Le.to=ye})(Pt||(e.NotebookCellOutput=Pt={}));var en;(function(Le){function ze(Fe){return ee(Fe)?{include:Ce.from(Fe.include)??void 0,exclude:Ce.from(Fe.exclude)??void 0}:Ce.from(Fe)??void 0}Le.from=ze;function ye(Fe){return ee(Fe)?{include:Ce.to(Fe.include),exclude:Ce.to(Fe.exclude)}:Ce.to(Fe)}Le.to=ye;function ee(Fe){const Qe=Fe;return Qe?!(0,p.$fg)(Qe.include)&&!(0,p.$fg)(Qe.exclude):!1}})(en||(e.NotebookExclusiveDocumentPattern=en={}));var tn;(function(Le){function ze(ye,ee,Fe){const Qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Qe,Fe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Le.from=ze})(tn||(e.NotebookStatusBarItem=tn={}));var tt;(function(Le){function ze(ye,ee,Fe){const Qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ee.toInternal(Qe,Fe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Le.from=ze})(tt||(e.NotebookKernelSourceAction=tt={}));var dn;(function(Le){function ze(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Le.from=ze})(dn||(e.NotebookDocumentContentOptions=dn={}));var rn;(function(Le){function ze(ee){return{uri:ee.uri,provides:ee.provides}}Le.from=ze;function ye(ee){return new s.$HO(h.URI.revive(ee.uri),ee.provides)}Le.to=ye})(rn||(e.NotebookRendererScript=rn={}));var mt;(function(Le){function ze(ee){return{message:q.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:y.from(ee.location.range),uri:ee.location.uri}}}Le.from=ze;function ye(ee){const Fe=new s.$NO(typeof ee.message=="string"?ee.message:q.to(ee.message));return Fe.actualOutput=ee.actual,Fe.expectedOutput=ee.expected,Fe.contextValue=ee.contextValue,Fe.location=ee.location?oe.to(ee.location):void 0,Fe}Le.to=ye})(mt||(e.TestMessage=mt={}));var bt;(function(Le){Le.namespace=r.$1L,Le.denamespace=r.$2L})(bt||(e.TestTag=bt={}));var Gt;(function(Le){function ze(ee){const Fe=(0,i.$tP)(ee).controllerId;return{extId:l.$VL.fromExtHostTestItem(ee,Fe).toString(),label:ee.label,uri:h.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Qe=>bt.namespace(Fe,Qe.id)),range:g.$vt.lift(y.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&q.fromStrict(ee.error)||null}}Le.from=ze;function ye(ee){return{parent:void 0,error:void 0,id:l.$VL.fromString(ee.extId).localId,label:ee.label,uri:h.URI.revive(ee.uri),tags:(ee.tags||[]).map(Fe=>{const{tagId:Qe}=bt.denamespace(Fe);return new s.$OO(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Le.toPlain=ye})(Gt||(e.TestItem=Gt={})),function(Le){function ze(ee){return{id:ee.id}}Le.from=ze;function ye(ee){return new s.$OO(ee.id)}Le.to=ye}(bt||(e.TestTag=bt={}));var Zt;(function(Le){const ze=(ee,Fe)=>{const Qe=ee.value;if(!Qe)return;const _e={...Gt.toPlain(Qe.item),parent:Fe,taskStates:Qe.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(ft=>ft.type===0).map(mt.to)})),children:[]};if(ee.children)for(const Ze of ee.children.values()){const ft=ze(Ze,_e);ft&&_e.children.push(ft)}return _e};function ye(ee){const Fe=new b.$mP;for(const Ze of ee.items)Fe.insert(l.$VL.fromString(Ze.item.extId).path,Ze);const Qe=[Fe.nodes],_e=[];for(;Qe.length;)for(const Ze of Qe.pop())Ze.value?_e.push(Ze):Ze.children&&Qe.push(Ze.children.values());return{completedAt:ee.completedAt,results:_e.map(Ze=>ze(Ze)).filter(p.$eg)}}Le.to=ye})(Zt||(e.TestResults=Zt={}));var zt;(function(Le){function ze(Qe){return{covered:Qe.covered,total:Qe.total}}function ye(Qe){return"line"in Qe?S.from(Qe):y.from(Qe)}function ee(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ye(Qe.location),type:1,branches:Qe.branches.length?Qe.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:Qe.name,count:Qe.executed,location:ye(Qe.location)}}Le.fromDetails=ee;function Fe(Qe,_e){return s.$QO(_e.statementCoverage),s.$QO(_e.branchCoverage),s.$QO(_e.declarationCoverage),{id:Qe,uri:_e.uri,statement:ze(_e.statementCoverage),branch:_e.branchCoverage&&ze(_e.branchCoverage),declaration:_e.declarationCoverage&&ze(_e.declarationCoverage)}}Le.fromFile=Fe})(zt||(e.TestCoverage=zt={}));var $t;(function(Le){function ze(ye){switch(ye){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Le.to=ze})($t||(e.CodeActionTriggerKind=$t={}));var Bt;(function(Le){function ze(ee){const Fe=new s.$VO(_.to(ee.kind),ee.name,ee.detail||"",h.URI.revive(ee.uri),y.to(ee.range),y.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Le.to=ze;function ye(ee,Fe,Qe){if(Fe=Fe??ee._sessionId,Qe=Qe??ee._itemId,Fe===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Qe,kind:_.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:y.from(ee.range),selectionRange:y.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Le.from=ye})(Bt||(e.TypeHierarchyItem=Bt={}));var Ht;(function(Le){function ze(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Le.from=ze})(Ht||(e.ViewBadge=Ht={}));var Ft;(function(Le){function ze(Qe,_e,Ze){const ft=_e.fileData;return ft?new s.$3N(new s.$4N(ft.name,h.URI.revive(ft.uri),ft.id,(0,R.$db)(()=>Ze(ft.id)))):Qe===I.$Rs.uriList&&_e.uriListData?new s.$2N(Fe(_e.uriListData)):new s.$2N(_e.asString)}Le.to=ze;async function ye(Qe,_e){const Ze=await _e.asString();if(Qe===I.$Rs.uriList)return{asString:Ze,fileData:void 0,uriListData:ee(Ze)};const ft=_e.asFile();return{asString:Ze,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Le.from=ye;function ee(Qe){return A.$Vt.split(Qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return h.URI.parse(_e)}catch{}return _e})}function Fe(Qe){return A.$Vt.create(Qe.map(_e=>typeof _e=="string"?_e:h.URI.revive(_e)))}})(Ft||(e.DataTransferItem=Ft={}));var xe;(function(Le){function ze(ee,Fe){const Qe=ee.items.map(([_e,Ze])=>[_e,Ft.to(_e,Ze,Fe)]);return new s.$5N(Qe)}Le.toDataTransfer=ze;async function ye(ee){const Fe={items:[]},Qe=[];for(const[_e,Ze]of ee)Qe.push((async()=>{Fe.items.push([_e,await Ft.from(_e,Ze)])})());return await Promise.all(Qe),Fe}Le.from=ye})(xe||(e.DataTransfer=xe={}));var un;(function(Le){function ze(ee,Fe){return{kind:"reply",agentId:ee.participant??Fe?.agentId??"",subCommand:ee.command??Fe?.command,message:ee.prompt,title:ee.label}}Le.from=ze;function ye(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Le.to=ye})(un||(e.ChatFollowup=un={}));var Yt;(function(Le){function ze(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Le.from=ze})(Yt||(e.ChatInlineFollowup=Yt={}));var Jt;(function(Le){function ze(ee){switch(ee.role){case 0:return new s.$hP(ee.content);case 1:return new s.$iP(ee.content);case 2:return new s.$jP(ee.content)}}Le.to=ze;function ye(ee){if(ee instanceof s.$hP)return{role:0,content:ee.content};if(ee instanceof s.$iP)return{role:1,content:ee.content};if(ee instanceof s.$jP)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Le.from=ye})(Jt||(e.LanguageModelMessage=Jt={}));var wt;(function(Le){function ze(Fe){const Qe={};for(const _e of Object.keys(Fe))Qe[_e]=Fe[_e].map(Le.to);return Qe}Le.objectTo=ze;function ye(Fe){return{level:Wt.to(Fe.level),kind:Fe.kind,value:(0,h.$wc)(Fe.value)?h.URI.revive(Fe.value):Fe.value,description:Fe.description}}Le.to=ye;function ee(Fe){return{level:Wt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Le.from=ee})(wt||(e.ChatVariable=wt={}));var Wt;(function(Le){function ze(ee){switch(ee){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Le.to=ze;function ye(ee){switch(ee){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Le.from=ye})(Wt||(e.ChatVariableLevel=Wt={}));var Ut;(function(Le){function ze(ye){switch(ye){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=ze})(Ut||(e.InteractiveEditorResponseFeedbackKind=Ut={}));var Qt;(function(Le){function ze(ee){return{kind:"markdownContent",content:q.from(ee.value)}}Le.from=ze;function ye(ee){return new s.$9O(q.to(ee.content))}Le.to=ye})(Qt||(e.ChatResponseMarkdownPart=Qt={}));var sn;(function(Le){function ze(ee){return{kind:"markdownVuln",content:q.from(ee.value),vulnerabilities:ee.vulnerabilities}}Le.from=ze;function ye(ee){return new s.$0O(q.to(ee.content),ee.vulnerabilities)}Le.to=ye})(sn||(e.ChatResponseMarkdownWithVulnerabilitiesPart=sn={}));var on;(function(Le){function ze(ee){return{kind:"agentDetection",agentId:ee.participant,command:ee.command}}Le.from=ze;function ye(ee){return new s.$$O(ee.agentId,ee.command)}Le.to=ye})(on||(e.ChatResponseDetectedParticipantPart=on={}));var an;(function(Le){function ze(ee){const{value:Fe,baseUri:Qe}=ee;function _e(Ze,ft){return Ze.map(St=>{const Vt=h.URI.joinPath(ft,St.name);return{label:St.name,uri:Vt,children:St.children&&_e(St.children,Vt)}})}return{kind:"treeData",treeData:{label:(0,k.$7g)(Qe),uri:Qe,children:_e(Fe,Qe)}}}Le.from=ze;function ye(ee){const Fe=(0,E.$6h)(ee.treeData);function Qe(ft){return ft.map(St=>({name:St.label,children:St.children&&Qe(St.children)}))}const _e=Fe.uri,Ze=Fe.children?Qe(Fe.children):[];return new s.$_O(Ze,_e)}Le.to=ye})(an||(e.ChatResponseFilesPart=an={}));var Ot;(function(Le){function ze(ee){return{kind:"inlineReference",name:ee.title,inlineReference:h.URI.isUri(ee.value)?ee.value:w.from(ee.value)}}Le.from=ze;function ye(ee){const Fe=(0,E.$6h)(ee);return new s.$aP(h.URI.isUri(Fe.inlineReference)?Fe.inlineReference:w.to(Fe.inlineReference),ee.name)}Le.to=ye})(Ot||(e.ChatResponseAnchorPart=Ot={}));var Ct;(function(Le){function ze(ee){return{kind:"progressMessage",content:q.from(ee.value)}}Le.from=ze;function ye(ee){return new s.$bP(ee.content.value)}Le.to=ye})(Ct||(e.ChatResponseProgressPart=Ct={}));var Mt;(function(Le){function ze(ee,Fe,Qe){return{kind:"command",command:Fe.toInternal(ee.value,Qe)??{command:ee.value.command,title:ee.value.title}}}Le.from=ze;function ye(ee,Fe){return new s.$cP(Fe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Le.to=ye})(Mt||(e.ChatResponseCommandButtonPart=Mt={}));var It;(function(Le){function ze(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Fe=>ce.from(Fe))}}Le.from=ze;function ye(ee){return new s.$eP(h.URI.revive(ee.uri),ee.edits.map(Fe=>ce.to(Fe)))}Le.to=ye})(It||(e.ChatResponseTextEditPart=It={}));var pt;(function(Le){function ze(ee){const Fe=v.ThemeIcon.isThemeIcon(ee.iconPath)?ee.iconPath:void 0;return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:h.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:w.from(ee.value.value)},iconPath:Fe}:{kind:"reference",reference:h.URI.isUri(ee.value)?ee.value:w.from(ee.value),iconPath:Fe}}Le.from=ze;function ye(ee){const Fe=(0,E.$6h)(ee),Qe=_e=>h.URI.isUri(_e)?_e:w.to(_e);return new s.$dP("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&Qe(Fe.reference.value)}:Qe(Fe.reference))}Le.to=ye})(pt||(e.ChatResponseReferencePart=pt={}));var At;(function(Le){function ze(Fe,Qe,_e){return Fe instanceof s.$9O?Qt.from(Fe):Fe instanceof s.$aP?Ot.from(Fe):Fe instanceof s.$dP?pt.from(Fe):Fe instanceof s.$bP?Ct.from(Fe):Fe instanceof s.$_O?an.from(Fe):Fe instanceof s.$cP?Mt.from(Fe,Qe,_e):Fe instanceof s.$eP?It.from(Fe):Fe instanceof s.$0O?sn.from(Fe):Fe instanceof s.$$O?on.from(Fe):{kind:"markdownContent",content:q.from("")}}Le.from=ze;function ye(Fe,Qe){switch(Fe.kind){case"reference":return pt.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Fe,Qe)}}Le.to=ye;function ee(Fe,Qe){switch(Fe.kind){case"markdownContent":return Qt.to(Fe);case"inlineReference":return Ot.to(Fe);case"progressMessage":return;case"treeData":return an.to(Fe);case"command":return Mt.to(Fe,Qe)}}Le.toContent=ee})(At||(e.ChatResponsePart=At={}));var cn;(function(Le){function ze(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(xt.to),location:Dt.to(ye.location)}}Le.to=ze})(cn||(e.ChatAgentRequest=cn={}));var Dt;(function(Le){function ze(ye){switch(ye){case o.ChatAgentLocation.Notebook:return s.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return s.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return s.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return s.ChatLocation.Editor}}Le.to=ze})(Dt||(e.ChatLocation=Dt={}));var xt;(function(Le){function ze(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(wt.to)}}Le.to=ze})(xt||(e.ChatAgentResolvedVariable=xt={}));var nn;(function(Le){function ze(ye,ee,Fe){return{label:ye.label,values:ye.values.map(wt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation,command:ee.toInternal(ye.command,Fe)}}Le.from=ze})(nn||(e.ChatAgentCompletionItem=nn={}));var En;(function(Le){function ze(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Le.to=ze})(En||(e.ChatAgentResult=En={}));var fn;(function(Le){function ze(ye,ee,Fe){if(ee.action.kind==="vote")return;const Qe=En.to(ye);if(ee.action.kind==="command"){const _e=ee.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Qe}}else return ee.action.kind==="followUp"?{action:{kind:"followUp",followup:un.to(ee.action.followup)},result:Qe}:ee.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ee.action.action==="accepted"},result:Qe}:{action:ee.action,result:Qe}}Le.to=ze})(fn||(e.ChatAgentUserActionEvent=fn={}));var gn;(function(Le){function ze(ye,ee,Fe){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ee.toInternal(ye,Fe)}Le.from=ze})(gn||(e.TerminalQuickFix=gn={}));var Lt;(function(Le){function ze(ye){return{kind:$n.to(ye.kind)}}Le.to=ze})(Lt||(e.PartialAcceptInfo=Lt={}));var $n;(function(Le){function ze(ye){switch(ye){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Le.to=ze})($n||(e.PartialAcceptTriggerKind=$n={}));var kn;(function(Le){function ze(ye,ee){return{id:ee,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Le.from=ze})(kn||(e.DebugTreeItem=kn={}))}),define(ke[332],Se([1,0,6,20,16,48]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;let L=class{constructor(m,E){this.a=m.getProxy(a.$0M.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>E.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,I){const P=new R.$Cw(A.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,I?.isRefactoring??!1)}};e.$tlc=L,e.$tlc=L=Je([Ue(0,N.$xP)],L)}),define(ke[333],Se([1,0,19,7,47,4,40,3,41,18,2,25,6,16,8,296,26]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class u{constructor(o,t,l,r,c){this.j=o,this.k=t,this.l=l,this.m=r,this.n=c,this.b=m.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(o.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const o=this;this.b.reset();const l=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const c=new p.$9O(r),s=k.ChatResponseMarkdownPart.from(c);return l(s),this},markdownWithVulnerabilities(r,c){t(this.markdown),c&&(0,g.$PG)(o.j,"chatParticipantAdditions");const s=new p.$0O(r,c),v=k.ChatResponseMarkdownWithVulnerabilitiesPart.from(s);return l(v),this},filetree(r,c){t(this.filetree);const s=new p.$_O(r,c),v=k.ChatResponseFilesPart.from(s);return l(v),this},anchor(r,c){t(this.anchor);const s=new p.$aP(r,c),v=k.ChatResponseAnchorPart.from(s);return l(v),this},button(r){t(this.anchor);const c=new p.$cP(r),s=k.ChatResponseCommandButtonPart.from(c,o.m,o.n);return l(s),this},progress(r){t(this.progress);const c=new p.$bP(r),s=k.ChatResponseProgressPart.from(c);return l(s),this},reference(r,c){if(t(this.reference),"variableName"in r&&!r.value){const s=o.k.variables.variables.find(v=>v.name===r.variableName);if(s){let v;if(s.references?.length)v=s.references.map(f=>({kind:"reference",reference:{variableName:r.variableName,value:f.reference}}));else{const f=new p.$dP(r,c);v=[k.ChatResponseReferencePart.from(f)]}return v.forEach(f=>l(f)),this}}else{const s=new p.$dP(r,c),v=k.ChatResponseReferencePart.from(s);l(v)}return this},textEdit(r,c){t(this.textEdit),(0,g.$PG)(o.j,"chatParticipantAdditions");const s=new p.$eP(r,c),v=k.ChatResponseTextEditPart.from(s);return l(v),this},detectedParticipant(r,c){t(this.detectedParticipant),(0,g.$PG)(o.j,"chatParticipantAdditions");const s=new p.$$O(r,c),v=k.ChatResponseDetectedParticipantPart.from(s);return l(v),this},push(r){if(t(this.push),(r instanceof p.$eP||r instanceof p.$0O||r instanceof p.$$O)&&(0,g.$PG)(o.j,"chatParticipantAdditions"),r instanceof p.$dP)this.reference(r.value,r.iconPath);else{const c=k.ChatResponsePart.from(r,o.m,o.n);l(c)}return this}}}return this.g}}class n extends $.$Vc{constructor(o,t,l){super(),this.n=t,this.s=l,this.c=new Map,this.j=this.B(new $.$5c),this.m=this.B(new $.$Uc),this.g=o.getProxy(b.$0M.MainThreadChatAgents2)}transferActiveChat(o){this.g.$transferActiveChatSession(o)}createChatAgent(o,t,l){const r=n.b++,c=new i(o,t,this.g,r,l);return this.c.set(r,c),this.g.$registerAgent(r,o.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(o,t,l,r,c){const s=n.b++,v=new i(o,t,this.g,s,c);return this.c.set(s,v),this.g.$registerAgent(s,o.identifier,t,{isSticky:!0},{name:l,description:r}),v.apiAgent}async $invokeAgent(o,t,l,r){const c=this.c.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let s=this.j.get(t.sessionId);s||(s=new $.$Uc,this.j.set(t.sessionId,s));const v=new u(c.extension,t,this.g,this.s.converter,s);try{const f=await this.t(t.agentId,l),y=c.invoke(k.ChatAgentRequest.to(t),{history:f},v.apiObject,r);return await(0,N.$kh)(Promise.resolve(y).then(w=>{if(w?.metadata)try{JSON.stringify(w.metadata)}catch(D){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${c.extension.identifier.value}] [@${c.id}] ${S}`,c.extension),{errorDetails:{message:S},timings:v.timings}}return{errorDetails:w?.errorDetails,timings:v.timings,metadata:w?.metadata}}),r)}catch(f){return this.n.error(f,c.extension),{errorDetails:{message:(0,A.$hj)(f),responseIsIncomplete:!0}}}finally{v.close()}}async t(o,t){const l=[];for(const r of t.history){const c=k.ChatAgentResult.to(r.result),s=o===r.request.agentId?c:{...c,metadata:void 0};l.push(new p.$fP(r.request.message,r.request.command,r.request.variables.variables.map(k.ChatAgentResolvedVariable.to),r.request.agentId));const v=(0,a.$Hb)(r.response.map(f=>k.ChatResponsePart.toContent(f,this.s.converter)));l.push(new p.$gP(v,s,r.request.agentId,r.request.command))}return l}$releaseSession(o){this.j.deleteAndDispose(o)}async $provideFollowups(o,t,l,r,c){const s=this.c.get(t);if(!s)return Promise.resolve([]);const v=await this.t(s.id,r),f=k.ChatAgentResult.to(l);return(await s.provideFollowups(f,{history:v},c)).filter(y=>{const w=!y.participant||L.Iterable.some(this.c.values(),D=>D.id===y.participant&&P.$Sm.equals(D.extension.identifier,s.extension.identifier));return w||this.n.warn(`[@${s.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),w}).map(y=>k.ChatFollowup.from(y,o))}$acceptFeedback(o,t,l,r){const c=this.c.get(o);if(!c)return;const s=k.ChatAgentResult.to(t);let v;switch(l){case h.InteractiveSessionVoteDirection.Down:v=p.ChatResultFeedbackKind.Unhelpful;break;case h.InteractiveSessionVoteDirection.Up:v=p.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:s,kind:v,reportIssue:r}:{result:s,kind:v}))}$acceptAction(o,t,l){const r=this.c.get(o);if(!r||l.action.kind==="vote")return;const c=k.ChatAgentUserActionEvent.to(t,l,this.s.converter);c&&r.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,t,l){const r=this.c.get(o);return r?(await r.invokeCompletionProvider(t,l)).map(s=>k.ChatAgentCompletionItem.from(s,this.s.converter,this.m)):[]}async $provideWelcomeMessage(o,t,l){const r=this.c.get(o);if(r)return await r.provideWelcomeMessage(k.ChatLocation.to(t),l)}async $provideSampleQuestions(o,t,l){const r=this.c.get(o);if(r)return(await r.provideSampleQuestions(k.ChatLocation.to(t),l)).map(c=>k.ChatFollowup.from(c,void 0))}}e.$ulc=n,n.b=0;class i{constructor(o,t,l,r,c){this.extension=o,this.id=t,this.w=l,this.x=r,this.y=c,this.o=new R.$ee,this.p=new R.$ee}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.p.fire(o)}async invokeCompletionProvider(o,t){return this.s?await this.s.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,l){if(!this.b)return[];const r=await this.b.provideFollowups(o,t,l);return r?r.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(o,t){if(!this.t)return[];const l=await this.t.provideWelcomeMessage(o,t);return l?l.map(r=>typeof r=="string"?r:k.MarkdownString.from(r)):[]}async provideSampleQuestions(o,t){if(!this.t||!this.t.provideSampleQuestions)return[];const l=await this.t.provideSampleQuestions(o,t);return l||[]}get apiAgent(){let o=!1,t=!1;const l=()=>{o||t||(t=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{fullName:this.c,icon:this.d?this.d instanceof I.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof p.$9N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:k.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,requester:this.u}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.c=c,l()},get iconPath(){return r.d},set iconPath(c){r.d=c,l()},get requestHandler(){return r.y},set requestHandler(c){(0,E.$gg)(typeof c=="function","Invalid request handler"),r.y=c},get followupProvider(){return r.b},set followupProvider(c){r.b=c,l()},get isDefault(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.g=c,l()},get helpTextPrefix(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.j=c,l()},get helpTextVariablesPrefix(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.k=c,l()},get helpTextPostfix(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.l=c,l()},get isSecondary(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.n},set isSecondary(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.n=c,l()},get sampleRequest(){return r.m},set sampleRequest(c){r.m=c,l()},get supportIssueReporting(){return(0,g.$PG)(r.extension,"chatParticipantAdditions"),r.q},set supportIssueReporting(c){(0,g.$PG)(r.extension,"chatParticipantAdditions"),r.q=c,l()},get onDidReceiveFeedback(){return r.o.event},set participantVariableProvider(c){if((0,g.$PG)(r.extension,"chatParticipantAdditions"),r.s=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");r.w.$registerAgentCompletionsProvider(r.x,c.triggerCharacters)}else r.w.$unregisterAgentCompletionsProvider(r.x)},get participantVariableProvider(){return(0,g.$PG)(r.extension,"chatParticipantAdditions"),r.s},set welcomeMessageProvider(c){(0,g.$PG)(r.extension,"defaultChatParticipant"),r.t=c,l()},get welcomeMessageProvider(){return(0,g.$PG)(r.extension,"defaultChatParticipant"),r.t},onDidPerformAction:(0,g.$OG)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,set requester(c){r.u=c,l()},get requester(){return r.u},dispose(){o=!0,r.b=void 0,r.o.dispose(),r.w.$unregisterAgent(r.x)}}}invoke(o,t,l,r){return this.y(o,t,l,r)}}}),define(ke[334],Se([1,0,13,3,6,16,8,26]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class m{constructor(P){this.b=new Map,this.c=P.getProxy(A.$0M.MainThreadChatVariables)}async $resolveVariable(P,b,k,p){const h=this.b.get(P);if(h)try{if(h.resolver.resolve2){(0,$.$PG)(h.extension,"chatParticipantAdditions");const g=new E(b,this.c),u=await h.resolver.resolve2(h.data.name,{prompt:k},g.apiObject,p);if(u)return u.map(R.ChatVariable.from)}else{const g=await h.resolver.resolve(h.data.name,{prompt:k},p);if(g)return g.map(R.ChatVariable.from)}}catch(g){(0,a.$2)(g)}}registerVariableResolver(P,b,k,p){const h=m.a++;return this.b.set(h,{extension:P,data:{name:b,description:k},resolver:p}),this.c.$registerVariable(h,{name:b,description:k}),(0,N.$Tc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$vlc=m,m.a=0;class E{constructor(P,b){this.c=P,this.d=b,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let b=function(p){if(P.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,p),h}};const P=this,k=p=>{this.d.$handleProgressChunk(this.c,p)};this.b={progress(p){b(this.progress);const h=new L.$bP(p),g=R.ChatResponseProgressPart.from(h);return k(g),this},reference(p){b(this.reference);const h=new L.$dP(p),g=R.ChatResponseReferencePart.from(h);return k(g),this},push(p){return b(this.push),p instanceof L.$dP?k(R.ChatResponseReferencePart.from(p)):p instanceof L.$bP&&k(R.ChatResponseProgressPart.from(p)),this}}}return this.b}}}),define(ke[335],Se([1,0,7,56,4,3,2,84,25,16,8,6,26]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=k;function k(p,h,g){const u=p.getProxy(P.$0M.MainThreadComments);class n{constructor(){this.b=new Map,this.c=new m.$Um,h.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const y=this.b.get(f.handle);return y?y.value:f}else if(f&&f.$mid===7){const y=f,w=this.b.get(y.commentControlHandle);if(!w)return y;const D=w.getCommentThread(y.commentThreadHandle);return D?D.value:y}else if(f&&(f.$mid===9||f.$mid===8)){const y=this.b.get(f.thread.commentControlHandle);if(!y)return f;const w=y.getCommentThread(f.thread.commentThreadHandle);return w?f.$mid===8?w.value:{thread:w.value,text:f.text}:f}else if(f&&f.$mid===10){const y=this.b.get(f.thread.commentControlHandle);if(!y)return f;const w=y.getCommentThread(f.thread.commentThreadHandle);if(!w)return f;const D=f.commentUniqueId,S=w.getCommentByUniqueId(D);return S||f}else if(f&&f.$mid===11){const y=this.b.get(f.thread.commentControlHandle);if(!y)return f;const w=y.getCommentThread(f.thread.commentThreadHandle);if(!w)return f;const D=f.text,S=f.commentUniqueId,C=w.getCommentByUniqueId(S);return C?(typeof C.body=="string"?C.body=D:C.body=new I.$BN(D),C):f}return f}})}createCommentController(f,y,w){const D=n.a++,S=new d(f,D,y,w);this.b.set(S.handle,S);const C=this.c.get(f.identifier)||[];return C.push(S),this.c.set(f.identifier,C),S.value}async $createCommentThreadTemplate(f,y,w){const D=this.b.get(f);D&&D.$createCommentThreadTemplate(y,w)}async $setActiveComment(f,y){const w=this.b.get(f);w&&w.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(f,y,w){const D=this.b.get(f);D&&D.$updateCommentThreadTemplate(y,w)}$deleteCommentThread(f,y){this.b.get(f)?.$deleteCommentThread(y)}async $provideCommentingRanges(f,y,w){const D=this.b.get(f);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const S=await g.ensureDocumentData(L.URI.revive(y));return(0,a.$oh)(async()=>{const C=await D.commentingRangeProvider.provideCommentingRanges(S.document,w);let j;return Array.isArray(C)?j={ranges:C,fileComments:!1}:C?j={ranges:C.ranges||[],fileComments:C.fileComments||!1}:j=C??void 0,j}).then(C=>{let j;return C&&(j={ranges:C.ranges.map(B=>E.Range.from(B)),fileComments:C.fileComments}),j})}$toggleReaction(f,y,w,D,S){const C=this.b.get(f);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,a.$oh)(()=>{const j=C.getCommentThread(y);if(j){const B=j.getCommentByUniqueId(D.uniqueIdInThread);if(C!==void 0&&B&&C.reactionHandler)return C.reactionHandler(B,l(S))}return Promise.resolve(void 0)})}}n.a=0;class i{set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,typeof f=="object"?((0,b.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=f.resolved,this.b.applicability=f.applicability):this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,y,w,D,S,C,j,B){this.m=y,this.n=w,this.o=D,this.p=S,this.q=C,this.extensionDescription=j,this.r=B,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${f}.${this.handle}`),u.$createCommentThread(y,this.handle,this.n,this.o,E.Range.from(this.p),j.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{u.$deleteCommentThread(y,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(T){z.range=T},get comments(){return z.comments},set comments(T){z.comments=T},get collapsibleState(){return z.collapsibleState},set collapsibleState(T){z.collapsibleState=T},get canReply(){return z.canReply},set canReply(T){z.canReply=T},get contextValue(){return z.contextValue},set contextValue(T){z.contextValue=T},get label(){return z.label},set label(T){z.label=T},get state(){return z.state},set state(T){z.state=T},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const f=w=>Object.prototype.hasOwnProperty.call(this.b,w),y={};f("range")&&(y.range=E.Range.from(this.p)),f("label")&&(y.label=this.label),f("contextValue")&&(y.contextValue=this.contextValue??null),f("comments")&&(y.comments=this.q.map(w=>o(this,w,this.k,this.extensionDescription))),f("collapsibleState")&&(y.collapseState=r(this.g)),f("canReply")&&(y.canReply=this.canReply),f("state")&&(y.state=c(this.h)),f("applicability")&&(y.applicability=s(this.h)),f("isTemplate")&&(y.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(f){for(const y of this.k){const w=y[0],D=y[1];if(f===D)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}i.a=0,Je([(0,N.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class d{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,f?.resourceHints&&(0,b.$PG)(this.h,"commentingRangeHint"),u.$updateCommentingRanges(this.handle,f?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,b.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,b.$PG)(this.h,"activeComment"),this.f}constructor(f,y,w,D){this.h=f,this.i=y,this.j=w,this.k=D,this.a=new Map,u.$registerCommentController(this.handle,w,D,this.h.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(C){S.options=C},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(C){S.commentingRangeProvider=C},get reactionHandler(){return S.reactionHandler},set reactionHandler(C){S.reactionHandler=C},get activeCommentThread(){return S.activeCommentThread},createCommentThread(C,j,B){return S.createCommentThread(C,j,B).value},dispose:()=>{S.dispose()}}),this.g=[],this.g.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(f,y,w){y===void 0&&(0,b.$PG)(this.h,"fileComments");const D=new i(this.id,this.handle,void 0,f,y,w,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(f){if(!f){this.e=void 0,this.f=void 0;return}const y=this.a.get(f.commentThreadHandle);y&&(this.e=f.uniqueIdInThread?y.getCommentByUniqueId(f.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(f,y){const w=new i(this.id,this.handle,void 0,L.URI.revive(f),E.Range.to(y),[],this.h,!0);return w.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(f,y){const w=this.a.get(f);w&&(w.range=E.Range.to(y))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.g.forEach(f=>f.dispose())}}function o(v,f,y,w){let D=y.get(f);return D||(D=++v.commentHandle,y.set(f,D)),f.state!==void 0&&(0,b.$PG)(w,"commentsDraftState"),f.reactions?.some(S=>S.reactors!==void 0)&&(0,b.$PG)(w,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:D,body:typeof f.body=="string"?f.body:E.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(S=>t(S)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?E.$wP(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(f=>f.name):v.reactors}}function l(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?L.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(f=>({name:f}))}}function r(v){if(v!==void 0)switch(v){case I.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case I.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function c(v){let f;if(typeof v=="object"?f=v.resolved:f=v,f!==void 0)switch(f){case I.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case I.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function s(v){let f;if(typeof v=="object"&&(f=v.applicability),f!==void 0)switch(f){case I.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case I.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(ke[336],Se([1,0,22,57,3,15,23,2,16,92,112,6,8]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class k{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new I.$flc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=o(this.document.uri)+this.a++;return(0,L.$0g)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class p{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,c){const s=this.b(l,r.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const v=new k(r,c);return this.a.set(s,v),v}delete(l,r){const c=this.b(l,r.uri);this.a.delete(c)}b(l,r){return`${l}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this.a=new Map}addTextProvider(l,r,c){return this.b(0,l,r,c)}addCustomProvider(l,r,c){return this.b(1,l,r,c)}get(l){return this.a.get(l)}b(l,r,c,s){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:c,provider:s}),new b.$_M(()=>this.a.delete(r))}}class u{constructor(l,r,c,s,v){this.d=r,this.f=c,this.g=s,this.h=v,this.b=new g,this.c=new p,this.a=l.getProxy(P.$0M.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,c,s){const v=new A.$Uc;return i(c)?(v.add(this.b.addTextProvider(r,l,c)),this.a.$registerTextEditorProvider((0,E.$Olc)(l),r,s.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,E.$Mlc)(l))):(v.add(this.b.addCustomProvider(r,l,c)),n(c)&&v.add(c.onDidChangeCustomDocument(f=>{const y=this.i(r,f.document.uri);if(d(f)){const w=y.addEdit(f);this.a.$onDidEdit(f.document.uri,r,w,f.label)}else this.a.$onContentChange(f.document.uri,r)})),this.a.$registerCustomEditorProvider((0,E.$Olc)(l),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,E.$Mlc)(l))),b.$_M.from(v,new b.$_M(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,c,s,v){const f=this.b.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const y=$.URI.revive(l),w=await f.provider.openCustomDocument(y,{backupId:c,untitledDocumentData:s?.buffer},v);let D;return n(f.provider)&&this.f&&(D=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(r,w,D),{editable:n(f.provider)}}async $disposeCustomDocument(l,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=$.URI.revive(l),{document:v}=this.i(r,s);this.c.delete(r,v),v.dispose()}async $resolveCustomEditor(l,r,c,s,v,f){const y=this.b.get(c);if(!y)throw new Error(`No provider found for '${c}'`);const w=m.ViewColumn.to(v),D=this.g.createNewWebview(r,s.contentOptions,y.extension),S=this.h.createNewWebviewPanel(r,c,s.title,w,s.options,D,s.active),C=$.URI.revive(l);switch(y.type){case 1:{const{document:j}=this.i(c,C);return y.provider.resolveCustomEditor(j,S,f)}case 0:{const j=this.d.getDocument(C);return y.provider.resolveCustomTextEditor(j,S,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,c){this.i(r,l).disposeEdits(c)}async $onMoveCustomEditor(l,r,c){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const v=this.h.getWebviewPanel(l);if(!v)throw new Error("No webview found");const f=$.URI.revive(r),y=this.d.getDocument(f);await s.provider.moveCustomTextEditor(y,v,a.CancellationToken.None)}async $undo(l,r,c,s){return this.i(r,l).undo(c,s)}async $redo(l,r,c,s){return this.i(r,l).redo(c,s)}async $revert(l,r,c){const s=this.i(r,l);await this.j(r).revertCustomDocument(s.document,c),s.disposeBackup()}async $onSave(l,r,c){const s=this.i(r,l);await this.j(r).saveCustomDocument(s.document,c),s.disposeBackup()}async $onSaveAs(l,r,c,s){const v=this.i(r,l);return this.j(r).saveCustomDocumentAs(v.document,$.URI.revive(c),s)}async $backup(l,r,c){const s=this.i(r,l),f=await this.j(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},c);return s.updateBackup(f),f.id}i(l,r){const c=this.c.get(l,$.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(l){const c=this.b.get(l)?.provider;if(!c||!n(c))throw new Error("Custom document is not editable");return c}}e.$Rlc=u;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function d(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const l=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$kj)(l)+""}});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[337],Se([1,0,224,140,2,6,8,16,4,11,27,60]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";var b,k,p,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$mlc=void 0;class g{constructor(i,d,o,t,l,r,c,s){this.d=i,this.e=d,this.f=o,this.g=t,this.h=l,b.set(this,void 0),k.set(this,void 0),p.set(this,void 0),this.c=!1,this.f=Math.max(t,o),it(this,p,new I.$Bc(v=>r.getComparisonKey(v)),"f"),it(this,b,c,"f"),it(this,k,s,"f")}dispose(){this.c||(qe(this,k,"f").fire([...qe(this,p,"f").keys()]),qe(this,b,"f")?.$clear(this.e),qe(this,p,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,d){if(!i){this.clear();return}this.j();let o=[];if(A.URI.isUri(i)){if(!d){this.delete(i);return}qe(this,p,"f").set(i,d.slice()),o=[i]}else if(Array.isArray(i)){o=[];let r;i=[...i].sort(g.k);for(const c of i){const[s,v]=c;if((!r||s.toString()!==r.toString())&&(r&&qe(this,p,"f").get(r).length===0&&qe(this,p,"f").delete(r),r=s,o.push(s),qe(this,p,"f").set(s,[])),v)qe(this,p,"f").get(s)?.push(...v);else{const f=qe(this,p,"f").get(s);f&&(f.length=0)}}}if(qe(this,k,"f").fire(o),!qe(this,b,"f"))return;const t=[];let l=0;for(const r of o){let c=[];const s=qe(this,p,"f").get(r);if(s)if(s.length>this.g){c=[];const v=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const y of s)if(y.severity===v[f]&&c.push({...$.Diagnostic.from(y),modelVersionId:this.h(r)})===this.g)break e;c.push({severity:N.MarkerSeverity.Info,message:(0,a.localize)(0,null,s.length-this.g),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=s.map(v=>({...$.Diagnostic.from(v),modelVersionId:this.h(r)}));if(t.push([r,c]),l+=c.length,l>this.f)break}qe(this,b,"f").$changeMany(this.e,t)}delete(i){this.j(),qe(this,k,"f").fire([i]),qe(this,p,"f").delete(i),qe(this,b,"f")?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),qe(this,k,"f").fire([...qe(this,p,"f").keys()]),qe(this,p,"f").clear(),qe(this,b,"f")?.$clear(this.e)}forEach(i,d){this.j();for(const[o,t]of this)i.call(d,o,t,this)}*[(b=new WeakMap,k=new WeakMap,p=new WeakMap,Symbol.iterator)](){this.j();for(const i of qe(this,p,"f").keys())yield[i,this.get(i)]}get(i){this.j();const d=qe(this,p,"f").get(i);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(i){return this.j(),Array.isArray(qe(this,p,"f").get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,d){return i[0].toString()<d[0].toString()?-1:i[0].toString()>d[0].toString()?1:0}}e.$mlc=g;let u=h=class{static _mapper(i){const d=new I.$Bc;for(const o of i)d.set(o,o);return{uris:Object.freeze(Array.from(d.values()))}}constructor(i,d,o,t){this.j=d,this.k=o,this.l=t,this.g=new Map,this.h=new m.$ie({merge:l=>l.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,h._mapper),this.f=i.getProxy(R.$0M.MainThreadDiagnostics)}createDiagnosticCollection(i,d){const{g:o,f:t,h:l,j:r,k:c,l:s}=this,v=new class{$changeMany(w,D){t.$changeMany(w,D),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,w,D.length===0?"CLEARING":D)}$clear(w){t.$clear(w),r.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,w)}dispose(){t.dispose()}};let f;if(!d)d="_generated_diagnostic_collection_name_#"+h.c++,f=d;else if(!o.has(d))f=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do f=d+h.c++;while(o.has(f))}return new class extends g{constructor(){super(d,f,h.e,h.d,w=>s.getDocument(w)?.version,c.extUri,v,l),o.set(f,this)}dispose(){super.dispose(),o.delete(f)}}}getDiagnostics(i){if(i)return this.m(i);{const d=new Map,o=[];for(const t of this.g.values())t.forEach((l,r)=>{let c=d.get(l.toString());typeof c>"u"&&(c=o.length,d.set(l.toString(),c),o.push([l,[]])),o[c][1]=o[c][1].concat(...r)});return o}}m(i){let d=[];for(const o of this.g.values())o.has(i)&&(d=d.concat(o.get(i)));return d}$acceptMarkersChange(i){if(!this.n){const d="_generated_mirror",o=new g(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(d,o),this.n=o}for(const[d,o]of i)this.n.set(A.URI.revive(d),o.map($.Diagnostic.to))}};e.$nlc=u,u.c=0,u.d=1e3,u.e=1.1*h.d,e.$nlc=u=h=Je([Ue(1,E.$3j),Ue(2,P.$llc)],u)}),define(ke[338],Se([1,0,2,13,8,16,76,48]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class m{constructor(I,P,b,k={timeout:1500,errors:3}){this.c=I,this.d=P,this.f=b,this.g=k,this.a=new L.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(P,b,k)=>{const h={dispose:this.a.push([P,b,I])};return Array.isArray(k)&&k.push(h),h}}async $participateInSave(I,P){const b=a.URI.revive(I);let k=!1;const p=setTimeout(()=>k=!0,this.g.timeout),h=[];try{for(const g of[...this.a]){if(k)break;const u=this.d.getDocument(b),n=await this.h(g,{document:u,reason:R.TextDocumentSaveReason.to(P)});h.push(n)}}finally{clearTimeout(p)}return h}h([I,P,b],k){const p=this.b.get(I);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(b,I,P,k).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const g=this.b.get(I);this.b.set(I,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,P,b,k){const p=[],h=Date.now(),{document:g,reason:u}=k,{version:n}=g,i=Object.freeze({document:g,reason:u,waitUntil(d){if(Object.isFrozen(p))throw(0,N.$8)("waitUntil can not be called async");p.push(Promise.resolve(d))}});try{P.apply(b,[i])}catch(d){return Promise.reject(d)}return Object.freeze(p),new Promise((d,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(p).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(t),d(l)}).catch(l=>{clearTimeout(t),o(l)})}).then(d=>{const o={edits:[]};for(const t of d)if(Array.isArray(t)&&t.every(l=>l instanceof A.$gN))for(const{newText:l,newEol:r,range:c}of t)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:l,eol:r&&R.EndOfLine.from(r)}});if(o.edits.length!==0)return n===g.version?this.f.$tryApplyWorkspaceEdit(new $.$Cw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$vmc=m}),define(ke[339],Se([1,0,4,3,2,6,154,16,18,24,8]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;class P{constructor(k,p){this.a=new a.$ee,this.b=new a.$ee,this.c=new a.$ee,this.d=new a.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Uc,this.h=new Map,this.f=k.getProxy(R.$0M.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(h=>{for(const g of h)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const g of h)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let h=this.h.get(k.toString());return h||(h=this.f.$tryOpenDocument(k).then(g=>{this.h.delete(k.toString());const u=A.URI.revive(g);return(0,m.$hg)(this.g.getDocument(u))},g=>(this.h.delete(k.toString()),Promise.reject(g))),this.h.set(k.toString(),h)),h}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>A.URI.revive(p))}$acceptModelLanguageChanged(k,p){const h=A.URI.revive(k),g=this.g.getDocument(h);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(p),this.a.fire(g.document)}$acceptModelSaved(k){const p=A.URI.revive(k),h=this.g.getDocument(p);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(k,p){const h=A.URI.revive(k),g=this.g.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(p),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,h){const g=A.URI.revive(k),u=this.g.getDocument(g);if(!u)throw new Error("unknown document");u._acceptIsDirty(h),u.onEvents(p);let n;p.isUndoing?n=I.TextDocumentChangeReason.Undo:p.isRedoing&&(n=I.TextDocumentChangeReason.Redo),this.c.fire((0,E.$5n)({document:u.document,contentChanges:p.changes.map(i=>({range:$.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(k,p){(0,L.$zP)(k,p)}}e.$olc=P}),define(ke[72],Se([1,0,74,4,18,2,5,6,20,16,8]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=void 0,e.$Slc=(0,L.$wi)("IExtHostEditorTabs");class P{constructor(g,u,n){this.e=n,this.d=u,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,u={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new I.$WO(R.URI.revive(this.b.input.uri));case 2:return new I.$XO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new I.$YO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new I.$ZO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new I.$1O(this.b.input.viewType);case 4:return new I.$2O(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new I.$3O(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new I.$4O;case 9:return new I.$5O(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new I.$6O;case 11:return new I.$7O(this.b.input.diffEditors.map(g=>new I.$XO(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class b{constructor(g,u){this.c=[],this.d="",this.b=g,this.e=u;for(const n of g.tabs)n.isActive&&(this.d=n.id),this.c.push(new P(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,u={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return E.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(n=>n.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(n=>n.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const n=new P(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,n),g.tabDto.isActive&&(this.d=n.tabId),n}else if(g.kind===1){const n=this.c.splice(g.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(g.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,n),n}const u=this.c.find(n=>n.tabId===g.tabDto.id);if(!u)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(g.tabDto),u}activeTabId(){return this.d}}let k=class{constructor(g){this.b=new N.$ee,this.c=new N.$ee,this.e=[],this.a=g.getProxy($.$0M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,u={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(n=>n.apiObject))},get activeTabGroup(){const n=g.d;return(0,A.$hg)(g.e.find(d=>d.groupId===n)?.apiObject)},close:async(n,i)=>{const d=Array.isArray(n)?n:[n];return d.length?p(d[0])?this.j(d,i):this.i(d,i):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(g){const u=new Set(this.e.map(r=>r.groupId)),n=new Set(g.map(r=>r.groupId)),i=(0,a.$F)(u,n),d=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),o=[],t=[];this.e=g.map(r=>{const c=new b(r,()=>this.d);return i.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const l=(0,A.$hg)(g.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:o,closed:d,changed:t}))}$acceptTabGroupUpdate(g){const u=this.e.find(n=>n.groupId===g.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const u=this.e.find(i=>i.groupId===g.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const n=u.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(g){for(const u of this.e)for(const n of u.tabs)if(n.apiObject===g)return n}h(g){return this.e.find(u=>u.apiObject===g)}async i(g,u){const n=[];for(const i of g){const d=this.g(i);if(!d)throw new Error("Tab close: Invalid tab not found!");n.push(d.tabId)}return this.a.$closeTab(n,u)}async j(g,u){const n=[];for(const i of g){const d=this.h(i);if(!d)throw new Error("Group close: Invalid group not found!");n.push(d.groupId)}return this.a.$closeGroup(n,u)}};e.$Tlc=k,e.$Tlc=k=Je([Ue(0,m.$xP)],k);function p(h){return h.tabs!==void 0}}),define(ke[340],Se([1,0,2,6,3,8,16,193,14,21,26,80]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class b{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const g=this.a.indexOf(h);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),g=[];let u,n,i=14,d=14;for(const o of h){let t=u?(0,m.$Af)(u,o):0;for(t===0?n=1:n=d;t<o.length;t++)t+1===o.length?(i=d,d=9):d+=1,g.push([n,o.toUpperCase().charCodeAt(t),d]),g.push([n,o.toLowerCase().charCodeAt(t),d]),n=d;u=o,d=i}g.push([9,58,10]),g.push([10,47,12]),this.b=new $.$x3(g)}}provideDocumentLinks(h){this.c();const g=[],u=$.$y3.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of u){const i=L.DocumentLink.to(n);i.target&&g.push(i)}return g}}class k{constructor(h,g){this.i=g,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(N.$0M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,g,u,n={}){if(k.j(u),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,u);let d=2;n.isCaseSensitive&&(d+=1024),n.isReadonly&&(d+=2048),typeof u.copy=="function"&&(d+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,I.$PG)(h,"fsChunks"),d+=4);let o;n.isReadonly&&(0,P.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,d,o).catch(l=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${g}`),console.error(l)});const t=u.onDidChangeFile(l=>{const r=[];for(const c of l){const{uri:s,type:v}=c;if(s.scheme!==g)continue;let f;switch(v){case R.FileChangeType.Changed:f=0;break;case R.FileChangeType.Created:f=1;break;case R.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:f})}this.a.$onFileSystemChange(i,r)});return(0,A.$Tc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:g,ctime:u,mtime:n,size:i,permissions:d}=h;return{type:g,ctime:u,mtime:n,size:i,permissions:d}}$stat(h,g){return Promise.resolve(this.l(h).stat(a.URI.revive(g))).then(u=>k.k(u))}$readdir(h,g){return Promise.resolve(this.l(h).readDirectory(a.URI.revive(g)))}$readFile(h,g){return Promise.resolve(this.l(h).readFile(a.URI.revive(g))).then(u=>E.$Ge.wrap(u))}$writeFile(h,g,u,n){return Promise.resolve(this.l(h).writeFile(a.URI.revive(g),u.buffer,n))}$delete(h,g,u){return Promise.resolve(this.l(h).delete(a.URI.revive(g),u))}$rename(h,g,u,n){return Promise.resolve(this.l(h).rename(a.URI.revive(g),a.URI.revive(u),n))}$copy(h,g,u,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(a.URI.revive(g),a.URI.revive(u),n))}$mkdir(h,g){return Promise.resolve(this.l(h).createDirectory(a.URI.revive(g)))}$watch(h,g,u,n){const i=this.l(h).watch(a.URI.revive(u),n);this.f.set(g,i)}$unwatch(h,g){const u=this.f.get(g);u&&(u.dispose(),this.f.delete(g))}$open(h,g,u){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(a.URI.revive(g),u))}$close(h,g){const u=this.l(h);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(g))}$read(h,g,u,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const d=E.$Ge.alloc(n);return Promise.resolve(i.read(g,u,d.buffer,0,n)).then(o=>d.slice(0,o))}$write(h,g,u,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,u,n.buffer,0,n.byteLength))}l(h){const g=this.c.get(h);if(!g){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return g}}e.$xmc=k}),define(ke[341],Se([1,0,4,35,2,6,16,8,46]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(k,p,h,g,u,n){this.a=Math.random(),this.b=new a.$ee,this.c=new a.$ee,this.d=new a.$ee,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$qk)(u),d=typeof u=="string",o=n?.correlate,t=g(l=>{if(!(typeof l.session=="number"&&l.session!==this.a)&&!(o&&typeof l.session>"u")){if(!n?.ignoreCreateEvents)for(const r of l.created){const c=A.URI.revive(r);i(c.fsPath)&&(!d||p.getWorkspaceFolder(c))&&this.b.fire(c)}if(!n?.ignoreChangeEvents)for(const r of l.changed){const c=A.URI.revive(r);i(c.fsPath)&&(!d||p.getWorkspaceFolder(c))&&this.c.fire(c)}if(!n?.ignoreDeleteEvents)for(const r of l.deleted){const c=A.URI.revive(r);i(c.fsPath)&&(!d||p.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=$.$_M.from(this.i(k,h,u,n,n?.correlate),this.b,this.c,this.d,t)}i(k,p,h,g,u){const n=$.$_M.from();if(typeof h=="string"||g?.ignoreChangeEvents&&g?.ignoreCreateEvents&&g?.ignoreDeleteEvents)return n;const i=k.getProxy(R.$0M.MainThreadFileSystemEventService);let d=!1;(h.pattern.includes(N.$mk)||h.pattern.includes(N.$nk))&&(d=!0);let o;return u&&(g?.ignoreChangeEvents||g?.ignoreCreateEvents||g?.ignoreDeleteEvents)&&(o=14,g?.ignoreChangeEvents&&(o&=-3),g?.ignoreCreateEvents&&(o&=-5),g?.ignoreDeleteEvents&&(o&=-9)),i.$watch(p.identifier.value,this.a,h.baseUri,{recursive:d,excludes:g?.excludes??[],filter:o},!!u),$.$_M.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class I{constructor(k){this.a=k,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(A.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(k,p,h){this.j=k,this.k=p,this.l=h,this.a=new a.$ee,this.b=new a.$ee,this.c=new a.$ee,this.d=new a.$ee,this.g=new a.$ge,this.h=new a.$ge,this.i=new a.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,p,h,g){return new E(this.j,k,p,this.a.event,L.GlobPattern.from(h),g)}$onFileEvent(k){this.a.fire(new I(k))}$onDidRunFileOperation(k,p){switch(k){case 2:this.b.fire(Object.freeze({files:p.map(h=>({oldUri:A.URI.revive(h.source),newUri:A.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(h=>A.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(h=>A.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,p){return(h,g,u)=>{const n=function(d){h.call(g,d)};return n.extension=k,p.event(n,void 0,u)}}async $onWillRunFileOperation(k,p,h,g){switch(k){case 2:return await this.n(this.g,{files:p.map(u=>({oldUri:A.URI.revive(u.source),newUri:A.URI.revive(u.target)}))},h,g);case 1:return await this.n(this.i,{files:p.map(u=>A.URI.revive(u.target))},h,g);case 0:case 3:return await this.n(this.h,{files:p.map(u=>A.URI.revive(u.target))},h,g)}}async n(k,p,h,g){const u=new Set,n=[];if(await k.fireAsync(p,g,async(d,o)=>{const t=Date.now(),l=await Promise.resolve(d);l instanceof $.$jN&&(n.push([o.extension,l]),u.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",o.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,d]of n){const{edits:o}=L.WorkspaceEdit.from(d,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(u)}}}e.$ymc=P}),define(ke[342],Se([1,0,19,7,22,13,126,3,24,41,14,18,2,29,186,84,136,226,25,16,8,26,112,6]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class r{constructor(W,Q){this.d=W,this.e=Q}async provideDocumentSymbols(W,Q){const X=this.d.getDocument(W),Z=await this.e.provideDocumentSymbols(X,Q);if(!(0,a.$Kb)(Z))return Z[0]instanceof d.$tN?Z.map(i.DocumentSymbol.from):r.f(Z)}static f(W){W=W.slice(0).sort((Z,he)=>{let we=Z.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(Z.location.range.end)),we});const Q=[],X=[];for(const Z of W){const he={name:Z.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Z.kind),tags:Z.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:i.Range.from(Z.location.range),selectionRange:i.Range.from(Z.location.range),children:[]};for(;;){if(X.length===0){X.push(he),Q.push(he);break}const we=X[X.length-1];if(k.$vt.containsRange(we.range,he.range)&&!k.$vt.equalsRange(we.range,he.range)){we.children?.push(he),X.push(he);break}X.pop()}}return Q}}class c{constructor(W,Q,X,Z,he,we){this.f=W,this.g=Q,this.h=X,this.j=Z,this.k=he,this.l=we,this.d=new t.$flc("CodeLens"),this.e=new Map}async provideCodeLenses(W,Q){const X=this.f.getDocument(W),Z=await this.h.provideCodeLenses(X,Q);if(!Z||Q.isCancellationRequested)return;const he=this.d.add(Z),we=new $.$Uc;this.e.set(he,we);const Te={cacheId:he,lenses:[]};for(let He=0;He<Z.length;He++)Te.lenses.push({cacheId:[he,He],range:i.Range.from(Z[He].range),command:this.g.toInternal(Z[He].command,we)});return Te}async resolveCodeLens(W,Q){const X=W.cacheId&&this.d.get(...W.cacheId);if(!X)return;let Z;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Z=X:Z=await this.h.resolveCodeLens(X,Q),Z||(Z=X),Q.isCancellationRequested)return;const he=W.cacheId&&this.e.get(W.cacheId[0]);if(he){if(!Z.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return W.command=this.g.toInternal(Z.command,he),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function s(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class v{constructor(W,Q){this.d=W,this.e=Q}async provideDefinition(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideDefinition(Z,he,X);return s(we)}}class f{constructor(W,Q){this.d=W,this.e=Q}async provideDeclaration(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideDeclaration(Z,he,X);return s(we)}}class y{constructor(W,Q){this.d=W,this.e=Q}async provideImplementation(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideImplementation(Z,he,X);return s(we)}}class w{constructor(W,Q){this.d=W,this.e=Q}async provideTypeDefinition(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideTypeDefinition(Z,he,X);return s(we)}}class D{constructor(W,Q){this.g=W,this.h=Q,this.d=0,this.e=new Map}async provideHover(W,Q,X,Z){const he=this.g.getDocument(W),we=i.Position.to(Q);let Te;if(X&&X.verbosityRequest){const rt=X.verbosityRequest.previousHover.id,at=this.e.get(rt);if(!at)throw new Error(`Hover with id ${rt} not found`);const ot={action:X.verbosityRequest.action,previousHover:at};Te=await this.h.provideHover(he,we,Z,ot)}else Te=await this.h.provideHover(he,we,Z);if(!Te||(0,a.$Kb)(Te.contents))return;Te.range||(Te.range=he.getWordRangeAtPosition(we)),Te.range||(Te.range=new d.$bN(we,we));const He=i.Hover.from(Te),Xe=this.d;if(this.e.size===D.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Xe,Te),this.d+=1,{...He,id:Xe}}releaseHover(W){this.e.delete(W)}}D.f=10;class S{constructor(W,Q){this.d=W,this.e=Q}async provideEvaluatableExpression(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideEvaluatableExpression(Z,he,X);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(W,Q){this.d=W,this.e=Q}async provideInlineValues(W,Q,X,Z){const he=this.d.getDocument(W),we=await this.e.provideInlineValues(he,i.Range.to(Q),i.InlineValueContext.to(X),Z);if(Array.isArray(we))return we.map(Te=>i.InlineValue.from(Te))}}class j{constructor(W,Q){this.d=W,this.e=Q}async provideDocumentHighlights(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideDocumentHighlights(Z,he,X);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class B{constructor(W,Q){this.d=W,this.e=Q}async provideMultiDocumentHighlights(W,Q,X,Z){const he=this.d.getDocument(W),we=X.map(Xe=>this.d.getDocument(Xe)),Te=i.Position.to(Q),He=await this.e.provideMultiDocumentHighlights(he,Te,we,Z);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class z{constructor(W,Q){this.d=W,this.e=Q}async provideLinkedEditingRanges(W,Q,X){const Z=this.d.getDocument(W),he=i.Position.to(Q),we=await this.e.provideLinkedEditingRanges(Z,he,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,a.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class T{constructor(W,Q){this.d=W,this.e=Q}async provideReferences(W,Q,X,Z){const he=this.d.getDocument(W),we=i.Position.to(Q),Te=await this.e.provideReferences(he,we,X,Z);if(Array.isArray(Te))return Te.map(i.location.from)}}class M{constructor(W,Q,X,Z,he,we,Te){this.g=W,this.h=Q,this.j=X,this.k=Z,this.l=he,this.m=we,this.n=Te,this.e=new t.$flc("CodeAction"),this.f=new Map}async provideCodeActions(W,Q,X,Z){const he=this.g.getDocument(W),we=p.$xt.isISelection(Q)?i.Selection.to(Q):i.Range.to(Q),Te=[];for(const ot of this.j.getDiagnostics(W))if(we.intersection(ot.range)&&Te.push(ot)>M.d)break;const He={diagnostics:Te,only:X.only?new d.$vN(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Xe=await this.k.provideCodeActions(he,we,He,Z);if(!(0,a.$Lb)(Xe)||Z.isCancellationRequested)return;const et=this.e.add(Xe),rt=new $.$Uc;this.f.set(et,rt);const at=[];for(let ot=0;ot<Xe.length;ot++){const ct=Xe[ot];if(ct)if(M.o(ct))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:ct.title,command:this.h.toInternal(ct,rt)});else{He.only&&(ct.kind?He.only.contains(ct.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Ne=ct.ranges??[];at.push({cacheId:[et,ot],title:ct.title,command:ct.command&&this.h.toInternal(ct.command,rt),diagnostics:ct.diagnostics&&ct.diagnostics.map(i.Diagnostic.from),edit:ct.edit&&i.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,o.$OG)(this.m,"codeActionAI")?ct.isAI:!1,ranges:(0,o.$OG)(this.m,"codeActionRanges")?(0,a.$Hb)(Ne.map(i.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:et,actions:at}}async resolveCodeAction(W,Q){const[X,Z]=W,he=this.e.get(X,Z);if(!he||M.o(he))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(he,Q)??he;let Te;we.edit&&(Te=i.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const Xe=this.f.get(X);Xe&&(He=this.h.toInternal(we.command,Xe))}return{edit:Te,command:He}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}M.d=1e3;class F{constructor(W,Q,X,Z,he){this.e=W,this.f=Q,this.g=X,this.h=Z,this.j=he,this.d=new t.$flc("DocumentPasteEdit")}async prepareDocumentPaste(W,Q,X,Z){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(W),we=Q.map(Xe=>i.Range.to(Xe)),Te=i.DataTransfer.toDataTransfer(X,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,we,Te,Z),Z.isCancellationRequested)return;const He=Array.from(Te).filter(([,Xe])=>!(Xe instanceof d.$2N));return i.DataTransfer.from(He)}async providePasteEdits(W,Q,X,Z,he,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(Q),He=X.map(at=>i.Range.to(at)),Xe=i.DataTransfer.toDataTransfer(Z,async at=>(await this.e.$resolvePasteFileData(this.h,W,at)).buffer),et=await this.g.provideDocumentPasteEdits(Te,He,Xe,{only:he.only?new d.$7N(he.only):void 0,triggerKind:he.triggerKind},we);if(!et||we.isCancellationRequested)return[];const rt=this.d.add(et);return et.map((at,ot)=>({_cacheId:[rt,ot],title:at.title??(0,u.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(ct=>ct.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,Q){const[X,Z]=W,he=this.d.get(X,Z);if(!he||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(he,Q)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class O{constructor(W,Q){this.d=W,this.e=Q}async provideDocumentFormattingEdits(W,Q,X){const Z=this.d.getDocument(W),he=await this.e.provideDocumentFormattingEdits(Z,Q,X);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class q{constructor(W,Q){this.d=W,this.e=Q}async provideDocumentRangeFormattingEdits(W,Q,X,Z){const he=this.d.getDocument(W),we=i.Range.to(Q),Te=await this.e.provideDocumentRangeFormattingEdits(he,we,X,Z);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,Q,X,Z){(0,P.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(W),we=Q.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(he,we,X,Z);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class Y{constructor(W,Q){this.d=W,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Q,X,Z,he){const we=this.d.getDocument(W),Te=i.Position.to(Q),He=await this.e.provideOnTypeFormattingEdits(we,Te,X,Z,he);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class V{constructor(W,Q){this.e=W,this.f=Q,this.d=new t.$flc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,Q){const X=await this.e.provideWorkspaceSymbols(W,Q);if(!(0,a.$Lb)(X))return{symbols:[]};const Z=this.d.add(X),he={cacheId:Z,symbols:[]};for(let we=0;we<X.length;we++){const Te=X[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}he.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[Z,we]})}return he}async resolveWorkspaceSymbol(W,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const X=this.d.get(...W.cacheId);if(X){const Z=await this.e.resolveWorkspaceSymbol(X,Q);return Z&&(0,m.$7n)(W,i.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class J{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,Q,X){this.d=W,this.e=Q,this.f=X}async provideRenameEdits(W,Q,X,Z){const he=this.d.getDocument(W),we=i.Position.to(Q);try{const Te=await this.e.provideRenameEdits(he,we,X,Z);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=J.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(W,Q,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(W),he=i.Position.to(Q);try{const we=await this.e.prepareRename(Z,he,X);let Te,He;if(d.$bN.isRange(we)?(Te=we,He=Z.getText(we)):(0,P.$$f)(we)&&(Te=we.range,He=we.placeholder),!Te||!He)return;if(Te.start.line>he.line||Te.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(we){const Te=J.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class x{constructor(W,Q,X){this.e=W,this.f=Q,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(W,Q,X,Z){const he=this.e.getDocument(W),we=i.Range.to(Q);try{const Te=x.d[X],He=await this.f.provideNewSymbolNames(he,we,Te,Z);return He?He.map(Xe=>typeof Xe=="string"?{newSymbolName:Xe}:{newSymbolName:Xe.newSymbolName,tags:Xe.tags}):void 0}catch(Te){this.g.error(x.h(Te)??JSON.stringify(Te,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}x.d={[h.NewSymbolNameTriggerKind.Invoke]:d.NewSymbolNameTriggerKind.Invoke,[h.NewSymbolNameTriggerKind.Automatic]:d.NewSymbolNameTriggerKind.Automatic};class ne{constructor(W,Q){this.resultId=W,this.tokens=Q}}class de{constructor(W,Q){this.f=W,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,Q,X){const Z=this.f.getDocument(W),he=Q!==0?this.d.get(Q):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,he.resultId,X):await this.g.provideDocumentSemanticTokens(Z,X);return he&&this.d.delete(Q),we?(we=de.h(we),this.o(de.n(he,we),we)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return de.j(W)?de.k(W)?W:new d.$uO(new Uint32Array(W.data),W.resultId):de.l(W)?de.m(W)?W:new d.$wO(W.edits.map(Q=>new d.$vO(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const Q of W.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(W,Q){if(!de.j(Q)||!W||!W.tokens)return Q;const X=W.tokens,Z=X.length,he=Q.data,we=he.length;let Te=0;const He=Math.min(Z,we);for(;Te<He&&X[Te]===he[Te];)Te++;if(Te===Z&&Te===we)return new d.$wO([],Q.resultId);let Xe=0;const et=He-Te;for(;Xe<et&&X[Z-Xe-1]===he[we-Xe-1];)Xe++;return new d.$wO([{start:Te,deleteCount:Z-Te-Xe,data:he.subarray(Te,we-Xe)}],Q.resultId)}o(W,Q){if(de.j(W)){const X=this.e++;return this.d.set(X,new ne(W.resultId,W.data)),(0,g.$dcb)({id:X,type:"full",data:W.data})}if(de.l(W)){const X=this.e++;return de.j(Q)?this.d.set(X,new ne(Q.resultId,Q.data)):this.d.set(X,new ne(W.resultId)),(0,g.$dcb)({id:X,type:"delta",deltas:(W.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class ce{constructor(W,Q){this.d=W,this.e=Q}async provideDocumentRangeSemanticTokens(W,Q,X){const Z=this.d.getDocument(W),he=await this.e.provideDocumentRangeSemanticTokens(Z,i.Range.to(Q),X);return he?this.f(he):null}f(W){return(0,g.$dcb)({id:0,type:"full",data:W.data})}}class ve{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,Q,X,Z,he){this.f=W,this.g=Q,this.h=X,this.j=Z,this.k=he,this.d=new t.$flc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,Q,X,Z){const he=this.f.getDocument(W),we=i.Position.to(Q),Te=he.getWordRangeAtPosition(we)||new d.$bN(we,we),He=Te.with({end:we}),Xe=new E.$ae,et=await this.h.provideCompletionItems(he,we,Z,i.CompletionContext.to(X));if(!et||Z.isCancellationRequested)return;const rt=Array.isArray(et)?new d.$IN(et):et,at=ve.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),ot=new $.$Uc;this.e.set(at,ot);const ct=[],Ne={x:at,b:ct,a:{replace:i.Range.from(Te),insert:i.Range.from(He)},c:rt.isIncomplete||void 0,d:Xe.elapsed()};for(let Ve=0;Ve<rt.items.length;Ve++){const Ae=rt.items[Ve],Ge=this.l(Ae,[at,Ve],He,Te);ct.push(Ge)}return Ne}async resolveCompletionItem(W,Q){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...W);if(!X)return;const Z=this.l(X,W),he=await this.h.resolveCompletionItem(X,Q);if(!he)return;const we=this.l(he,W);return(Z.h!==we.h||Z.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z.n!==we.n||Z.o!==we.o||!(0,m.$8n)(Z.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,Q,X,Z){const he=this.e.get(Q[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(W.command,he),Te={x:Q,a:W.label,b:W.kind!==void 0?i.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(i.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:i.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=W.textEdit.newText):typeof W.insertText=="string"?Te.h=W.insertText:W.insertText instanceof d.$kN&&(Te.h=W.insertText.value,Te.i|=4);let He;return W.textEdit?He=W.textEdit.range:W.range&&(He=W.range),d.$bN.isRange(He)?Te.j=i.Range.from(He):He&&(!X?.isEqual(He.inserting)||!Z?.isEqual(He.replacing))&&(Te.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class _{async provideInlineCompletions(W,Q,X,Z){}disposeCompletions(W){}handleDidShowCompletionItem(W,Q,X){}handlePartialAccept(W,Q,X,Z){}}class U extends _{constructor(W,Q,X,Z){super(),this.f=W,this.g=Q,this.h=X,this.j=Z,this.d=new De,this.e=(0,o.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:d.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:d.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,Q,X,Z){const he=this.g.getDocument(W),we=i.Position.to(Q),Te=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Z);if(!Te||Z.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],et=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:He}),items:He.map((ot,ct)=>{let Ne;ot.command&&(rt||(rt=new $.$Uc),Ne=this.j.toInternal(ot.command,rt));const Ve=ot.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:Ne,idx:ct,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Xe.map(ot=>(rt||(rt=new $.$Uc),this.j.toInternal(ot,rt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,Q,X){const Z=this.d.get(W)?.items[Q];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,X)}handlePartialAccept(W,Q,X,Z){const he=this.d.get(W)?.items[Q];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,X),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(Z)))}}class le{async provideInlineEdits(W,Q,X){const Z=this.f.getDocument(W),he=await this.g.provideInlineEdit(Z,{triggerKind:this.e[Q.triggerKind]},X);if(!he||X.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:he});let He;he.accepted&&(we||(we=new $.$Uc),He=this.h.toInternal(he.accepted,we));let Xe;return he.rejected&&(we||(we=new $.$Uc),Xe=this.h.toInternal(he.rejected,we)),{pid:Te,text:he.text,range:i.Range.from(he.range),accepted:He,rejected:Xe}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,Q,X,Z){this.f=Q,this.g=X,this.h=Z,this.d=new De,this.e={[h.InlineEditTriggerKind.Automatic]:d.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:d.InlineEditTriggerKind.Invoke}}}class De{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const Q=this.e++;return this.d.set(Q,W),Q}disposeReferenceId(W){const Q=this.d.get(W);return this.d.delete(W),Q}get(W){return this.d.get(W)}}class $e{constructor(W,Q){this.e=W,this.f=Q,this.d=new t.$flc("SignatureHelp")}async provideSignatureHelp(W,Q,X,Z){const he=this.e.getDocument(W),we=i.Position.to(Q),Te=this.g(X),He=await this.f.provideSignatureHelp(he,we,Z,Te);if(He){const Xe=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Xe}}}g(W){let Q;if(W.activeSignatureHelp){const X=i.SignatureHelp.to(W.activeSignatureHelp),Z=this.d.get(W.activeSignatureHelp.id,0);Z?(Q=Z,Q.activeSignature=X.activeSignature,Q.activeParameter=X.activeParameter):Q=X}return{...W,activeSignatureHelp:Q}}releaseSignatureHelp(W){this.d.delete(W)}}class re{constructor(W,Q,X,Z,he){this.f=W,this.g=Q,this.h=X,this.j=Z,this.k=he,this.d=new t.$flc("InlayHints"),this.e=new Map}async provideInlayHints(W,Q,X){const Z=this.f.getDocument(W),he=i.Range.to(Q),we=await this.h.provideInlayHints(Z,he,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(X.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new $.$Uc);const He={hints:[],cacheId:Te};for(let Xe=0;Xe<we.length;Xe++)this.l(we[Xe],he)&&He.hints.push(this.m(we[Xe],[Te,Xe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),He}async resolveInlayHint(W,Q){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...W);if(!X)return;const Z=await this.h.resolveInlayHint(X,Q);if(Z&&this.l(Z))return this.m(Z,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,Q){return W.label.length===0||Array.isArray(W.label)&&W.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(Q&&!Q.contains(W.position))}m(W,Q){const X=this.e.get(Q[0]);if(!X)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:Q,tooltip:i.MarkdownString.fromStrict(W.tooltip),position:i.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(i.TextEdit.from),kind:W.kind&&i.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")Z.label=W.label;else{const he=[];Z.label=he;for(const we of W.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};d.$lN.isLocation(we.location)&&(Te.location=i.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,X)),he.push(Te)}}return Z}}class se{constructor(W,Q){this.e=W,this.f=Q,this.d=new t.$flc("DocumentLink")}async provideLinks(W,Q){const X=this.e.getDocument(W),Z=await this.f.provideDocumentLinks(X,Q);if(!(!Array.isArray(Z)||Z.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(se.g).map(i.DocumentLink.from)};{const he=this.d.add(Z),we={links:[],cacheId:he};for(let Te=0;Te<Z.length;Te++){if(!se.g(Z[Te]))continue;const He=i.DocumentLink.from(Z[Te]);He.cacheId=[he,Te],we.links.push(He)}return we}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Q){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...W);if(!X)return;const Z=await this.f.resolveDocumentLink(X,Q);if(!(!Z||!se.g(Z)))return i.DocumentLink.from(Z)}releaseLinks(W){this.d.delete(W)}}class oe{constructor(W,Q){this.d=W,this.e=Q}async provideColors(W,Q){const X=this.d.getDocument(W),Z=await this.e.provideDocumentColors(X,Q);return Array.isArray(Z)?Z.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(W,Q,X){const Z=this.d.getDocument(W),he=i.Range.to(Q.range),we=i.Color.to(Q.color),Te=await this.e.provideColorPresentations(we,{document:Z,range:he},X);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class K{constructor(W,Q){this.d=W,this.e=Q}async provideFoldingRanges(W,Q,X){const Z=this.d.getDocument(W),he=await this.e.provideFoldingRanges(Z,Q,X);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class te{constructor(W,Q,X){this.d=W,this.e=Q,this.f=X}async provideSelectionRanges(W,Q,X){const Z=this.d.getDocument(W),he=Q.map(i.Position.to),we=await this.e.provideSelectionRanges(Z,he,X);if(!(0,a.$Lb)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<he.length;He++){const Xe=[];Te.push(Xe);let et=he[He],rt=we[He];for(;;){if(!rt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(i.SelectionRange.from(rt)),!rt.parent)break;et=rt.range,rt=rt.parent}}return Te}}class ge{constructor(W,Q){this.f=W,this.g=Q,this.d=new L.$CP(""),this.e=new Map}async prepareSession(W,Q,X){const Z=this.f.getDocument(W),he=i.Position.to(Q),we=await this.g.prepareCallHierarchy(Z,he,X);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideCallsTo(W,Q,X){const Z=this.j(W,Q);if(!Z)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Z,X);if(he)return he.map(we=>({from:this.h(W,we.from),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(W,Q,X){const Z=this.j(W,Q);if(!Z)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Z,X);if(he)return he.map(we=>({to:this.h(W,we.to),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(W){this.e.delete(W)}h(W,Q){const X=this.e.get(W),Z=i.CallHierarchyItem.from(Q,W,X.size.toString(36));return X.set(Z._itemId,Q),Z}j(W,Q){return this.e.get(W)?.get(Q)}}class be{constructor(W,Q){this.f=W,this.g=Q,this.d=new L.$CP(""),this.e=new Map}async prepareSession(W,Q,X){const Z=this.f.getDocument(W),he=i.Position.to(Q),we=await this.g.prepareTypeHierarchy(Z,he,X);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideSupertypes(W,Q,X){const Z=this.j(W,Q);if(!Z)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Z,X);if(he)return he.map(we=>this.h(W,we))}async provideSubtypes(W,Q,X){const Z=this.j(W,Q);if(!Z)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Z,X);if(he)return he.map(we=>this.h(W,we))}releaseSession(W){this.e.delete(W)}h(W,Q){const X=this.e.get(W),Z=i.TypeHierarchyItem.from(Q,W,X.size.toString(36));return X.set(Z._itemId,Q),Z}j(W,Q){return this.e.get(W)?.get(Q)}}class Re{constructor(W,Q,X,Z,he){this.e=W,this.f=Q,this.g=X,this.h=Z,this.j=he,this.d=new t.$flc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,Q,X,Z,he){const we=this.f.getDocument(Q),Te=i.Position.to(X),He=i.DataTransfer.toDataTransfer(Z,async at=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,at)).buffer),Xe=await this.g.provideDocumentDropEdits(we,Te,He,he);if(!Xe)return;const et=(0,a.$3b)(Xe),rt=this.d.add(et);return et.map((at,ot)=>({_cacheId:[rt,ot],title:at.title??(0,u.localize)(1,null,this.j.displayName||this.j.name),kind:at.kind?.value,yieldTo:at.yieldTo?.map(ct=>ct.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,Q){const[X,Z]=W,he=this.d.get(X,Z);if(!he||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(he,Q)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class pe{constructor(W,Q){this.d=W,this.e=Q}async provideMappedEdits(W,Q,X,Z){const he=b.URI.revive(W),we=this.d.getDocument(he),Te=X.documents.map(et=>et.map(rt=>({uri:b.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(at=>i.Range.to(at))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(we,Q,He,Z);return Xe?i.WorkspaceEdit.from(Xe):null}}class Pe{constructor(W,Q){this.adapter=W,this.extension=Q}}class Ie{constructor(W,Q,X,Z,he,we,Te,He){this.g=Q,this.h=X,this.j=Z,this.k=he,this.l=we,this.m=Te,this.n=He,this.f=new Map,this.e=W.getProxy(l.$0M.MainThreadLanguageFeatures)}o(W,Q){return i.DocumentSelector.from(W,this.g,Q)}p(W){return new d.$_M(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Ie.d++}async s(W,Q,X,Z,he,we=!1){const Te=this.f.get(W);if(!Te||!(Te.adapter instanceof Q))return Z;const He=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Xe=X(Te.adapter,Te.extension);return Promise.resolve(Xe).catch(et=>{(0,R.$4)(et)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Te.extension.identifier,et))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),A.CancellationToken.isCancellationToken(he)?(0,N.$lh)(Xe,he):Xe}t(W,Q){const X=this.q();return this.f.set(X,new Pe(W,Q)),X}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Q,X,Z){const he=this.t(new r(this.h,X),W),we=Z&&Z.label||Ie.u(W);return this.e.$registerDocumentSymbolProvider(he,this.o(Q,W),we),this.p(he)}$provideDocumentSymbols(W,Q,X){return this.s(W,r,Z=>Z.provideDocumentSymbols(b.URI.revive(Q),X),void 0,X)}registerCodeLensProvider(W,Q,X){const Z=this.q(),he=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new Pe(new c(this.h,this.j.converter,X,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(Z,this.o(Q,W),he);let we=this.p(Z);if(he!==void 0){const Te=X.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(he));we=d.$_M.from(we,Te)}return we}$provideCodeLenses(W,Q,X){return this.s(W,c,Z=>Z.provideCodeLenses(b.URI.revive(Q),X),void 0,X)}$resolveCodeLens(W,Q,X){return this.s(W,c,Z=>Z.resolveCodeLens(Q,X),void 0,void 0)}$releaseCodeLenses(W,Q){this.s(W,c,X=>Promise.resolve(X.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(W,Q,X){const Z=this.t(new v(this.h,X),W);return this.e.$registerDefinitionSupport(Z,this.o(Q,W)),this.p(Z)}$provideDefinition(W,Q,X,Z){return this.s(W,v,he=>he.provideDefinition(b.URI.revive(Q),X,Z),[],Z)}registerDeclarationProvider(W,Q,X){const Z=this.t(new f(this.h,X),W);return this.e.$registerDeclarationSupport(Z,this.o(Q,W)),this.p(Z)}$provideDeclaration(W,Q,X,Z){return this.s(W,f,he=>he.provideDeclaration(b.URI.revive(Q),X,Z),[],Z)}registerImplementationProvider(W,Q,X){const Z=this.t(new y(this.h,X),W);return this.e.$registerImplementationSupport(Z,this.o(Q,W)),this.p(Z)}$provideImplementation(W,Q,X,Z){return this.s(W,y,he=>he.provideImplementation(b.URI.revive(Q),X,Z),[],Z)}registerTypeDefinitionProvider(W,Q,X){const Z=this.t(new w(this.h,X),W);return this.e.$registerTypeDefinitionSupport(Z,this.o(Q,W)),this.p(Z)}$provideTypeDefinition(W,Q,X,Z){return this.s(W,w,he=>he.provideTypeDefinition(b.URI.revive(Q),X,Z),[],Z)}registerHoverProvider(W,Q,X,Z){const he=this.t(new D(this.h,X),W);return this.e.$registerHoverProvider(he,this.o(Q,W)),this.p(he)}$provideHover(W,Q,X,Z,he){return this.s(W,D,we=>we.provideHover(b.URI.revive(Q),X,Z,he),void 0,he)}$releaseHover(W,Q){this.s(W,D,X=>Promise.resolve(X.releaseHover(Q)),void 0,void 0)}registerEvaluatableExpressionProvider(W,Q,X,Z){const he=this.t(new S(this.h,X),W);return this.e.$registerEvaluatableExpressionProvider(he,this.o(Q,W)),this.p(he)}$provideEvaluatableExpression(W,Q,X,Z){return this.s(W,S,he=>he.provideEvaluatableExpression(b.URI.revive(Q),X,Z),void 0,Z)}registerInlineValuesProvider(W,Q,X,Z){const he=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,X),W);this.e.$registerInlineValuesProvider(we,this.o(Q,W),he);let Te=this.p(we);if(he!==void 0){const He=X.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(he));Te=d.$_M.from(Te,He)}return Te}$provideInlineValues(W,Q,X,Z,he){return this.s(W,C,we=>we.provideInlineValues(b.URI.revive(Q),X,Z,he),void 0,he)}registerDocumentHighlightProvider(W,Q,X){const Z=this.t(new j(this.h,X),W);return this.e.$registerDocumentHighlightProvider(Z,this.o(Q,W)),this.p(Z)}registerMultiDocumentHighlightProvider(W,Q,X){const Z=this.t(new B(this.h,X),W);return this.e.$registerMultiDocumentHighlightProvider(Z,this.o(Q,W)),this.p(Z)}$provideDocumentHighlights(W,Q,X,Z){return this.s(W,j,he=>he.provideDocumentHighlights(b.URI.revive(Q),X,Z),void 0,Z)}$provideMultiDocumentHighlights(W,Q,X,Z,he){return this.s(W,B,we=>we.provideMultiDocumentHighlights(b.URI.revive(Q),X,Z.map(Te=>b.URI.revive(Te)),he),void 0,he)}registerLinkedEditingRangeProvider(W,Q,X){const Z=this.t(new z(this.h,X),W);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(Q,W)),this.p(Z)}$provideLinkedEditingRanges(W,Q,X,Z){return this.s(W,z,async he=>{const we=await he.provideLinkedEditingRanges(b.URI.revive(Q),X,Z);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.w(we.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(W,Q,X){const Z=this.t(new T(this.h,X),W);return this.e.$registerReferenceSupport(Z,this.o(Q,W)),this.p(Z)}$provideReferences(W,Q,X,Z,he){return this.s(W,T,we=>we.provideReferences(b.URI.revive(Q),X,Z,he),void 0,he)}registerCodeActionProvider(W,Q,X,Z){const he=new $.$Uc,we=this.t(new M(this.h,this.j.converter,this.k,X,this.l,W,this.m),W);return this.e.$registerQuickFixSupport(we,this.o(Q,W),{providedKinds:Z?.providedCodeActionKinds?.map(Te=>Te.value),documentation:Z?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,he)}))},Ie.u(W),!!X.resolveCodeAction),he.add(this.p(we)),he}$provideCodeActions(W,Q,X,Z,he){return this.s(W,M,we=>we.provideCodeActions(b.URI.revive(Q),X,Z,he),void 0,he)}$resolveCodeAction(W,Q,X){return this.s(W,M,Z=>Z.resolveCodeAction(Q,X),{},void 0)}$releaseCodeActions(W,Q){this.s(W,M,X=>Promise.resolve(X.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(W,Q,X){const Z=this.t(new O(this.h,X),W);return this.e.$registerDocumentFormattingSupport(Z,this.o(Q,W),W.identifier,W.displayName||W.name),this.p(Z)}$provideDocumentFormattingEdits(W,Q,X,Z){return this.s(W,O,he=>he.provideDocumentFormattingEdits(b.URI.revive(Q),X,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(W,Q,X){const Z=typeof X.provideDocumentRangesFormattingEdits=="function",he=this.t(new q(this.h,X),W);return this.e.$registerRangeFormattingSupport(he,this.o(Q,W),W.identifier,W.displayName||W.name,Z),this.p(he)}$provideDocumentRangeFormattingEdits(W,Q,X,Z,he){return this.s(W,q,we=>we.provideDocumentRangeFormattingEdits(b.URI.revive(Q),X,Z,he),void 0,he)}$provideDocumentRangesFormattingEdits(W,Q,X,Z,he){return this.s(W,q,we=>we.provideDocumentRangesFormattingEdits(b.URI.revive(Q),X,Z,he),void 0,he)}registerOnTypeFormattingEditProvider(W,Q,X,Z){const he=this.t(new Y(this.h,X),W);return this.e.$registerOnTypeFormattingSupport(he,this.o(Q,W),Z,W.identifier),this.p(he)}$provideOnTypeFormattingEdits(W,Q,X,Z,he,we){return this.s(W,Y,Te=>Te.provideOnTypeFormattingEdits(b.URI.revive(Q),X,Z,he,we),void 0,we)}registerWorkspaceSymbolProvider(W,Q){const X=this.t(new V(Q,this.l),W);return this.e.$registerNavigateTypeSupport(X,typeof Q.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(W,Q,X){return this.s(W,V,Z=>Z.provideWorkspaceSymbols(Q,X),{symbols:[]},X)}$resolveWorkspaceSymbol(W,Q,X){return this.s(W,V,Z=>Z.resolveWorkspaceSymbol(Q,X),void 0,void 0)}$releaseWorkspaceSymbols(W,Q){this.s(W,V,X=>X.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(W,Q,X){const Z=this.t(new J(this.h,X,this.l),W);return this.e.$registerRenameSupport(Z,this.o(Q,W),J.supportsResolving(X)),this.p(Z)}$provideRenameEdits(W,Q,X,Z,he){return this.s(W,J,we=>we.provideRenameEdits(b.URI.revive(Q),X,Z,he),void 0,he)}$resolveRenameLocation(W,Q,X,Z){return this.s(W,J,he=>he.resolveRenameLocation(b.URI.revive(Q),X,Z),void 0,Z)}registerNewSymbolNamesProvider(W,Q,X){const Z=this.t(new x(this.h,X,this.l),W);return this.e.$registerNewSymbolNamesProvider(Z,this.o(Q,W)),this.p(Z)}$supportsAutomaticNewSymbolNamesTriggerKind(W){return this.s(W,x,Q=>Q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(W,Q,X,Z,he){return this.s(W,x,we=>we.provideNewSymbolNames(b.URI.revive(Q),X,Z,he),void 0,he)}registerDocumentSemanticTokensProvider(W,Q,X,Z){const he=this.t(new de(this.h,X),W),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(Q,W),Z,we);let Te=this.p(he);if(we){const He=X.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(we));Te=d.$_M.from(Te,He)}return Te}$provideDocumentSemanticTokens(W,Q,X,Z){return this.s(W,de,he=>he.provideDocumentSemanticTokens(b.URI.revive(Q),X,Z),null,Z)}$releaseDocumentSemanticTokens(W,Q){this.s(W,de,X=>X.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,Q,X,Z){const he=this.t(new ce(this.h,X),W);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(Q,W),Z),this.p(he)}$provideDocumentRangeSemanticTokens(W,Q,X,Z){return this.s(W,ce,he=>he.provideDocumentRangeSemanticTokens(b.URI.revive(Q),X,Z),null,Z)}registerCompletionItemProvider(W,Q,X,Z){const he=this.t(new ve(this.h,this.j.converter,X,this.m,W),W);return this.e.$registerCompletionsProvider(he,this.o(Q,W),Z,ve.supportsResolving(X),W.identifier),this.p(he)}$provideCompletionItems(W,Q,X,Z,he){return this.s(W,ve,we=>we.provideCompletionItems(b.URI.revive(Q),X,Z,he),void 0,he)}$resolveCompletionItem(W,Q,X){return this.s(W,ve,Z=>Z.resolveCompletionItem(Q,X),void 0,X)}$releaseCompletionItems(W,Q){this.s(W,ve,X=>X.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(W,Q,X,Z){const he=new U(W,this.h,X,this.j.converter),we=this.t(he,W);return this.e.$registerInlineCompletionsSupport(we,this.o(Q,W),he.supportsHandleEvents,n.$Sm.toKey(W.identifier.value),Z?.yieldTo?.map(Te=>n.$Sm.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(W,Q,X,Z,he){return this.s(W,_,we=>we.provideInlineCompletions(b.URI.revive(Q),X,Z,he),void 0,he)}$handleInlineCompletionDidShow(W,Q,X,Z){this.s(W,_,async he=>{he.handleDidShowCompletionItem(Q,X,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,Q,X,Z,he){this.s(W,_,async we=>{we.handlePartialAccept(Q,X,Z,he)},void 0,void 0)}$freeInlineCompletionsList(W,Q){this.s(W,_,async X=>{X.disposeCompletions(Q)},void 0,void 0)}registerInlineEditProvider(W,Q,X){const Z=new le(W,this.h,X,this.j.converter),he=this.t(Z,W);return this.e.$registerInlineEditProvider(he,this.o(Q,W),W.identifier),this.p(he)}$provideInlineEdit(W,Q,X,Z){return this.s(W,le,he=>he.provideInlineEdits(b.URI.revive(Q),X,Z),void 0,Z)}$freeInlineEdit(W,Q){this.s(W,le,async X=>{X.disposeEdit(Q)},void 0,void 0)}registerSignatureHelpProvider(W,Q,X,Z){const he=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,we=this.t(new $e(this.h,X),W);return this.e.$registerSignatureHelpProvider(we,this.o(Q,W),he),this.p(we)}$provideSignatureHelp(W,Q,X,Z,he){return this.s(W,$e,we=>we.provideSignatureHelp(b.URI.revive(Q),X,Z,he),void 0,he)}$releaseSignatureHelp(W,Q){this.s(W,$e,X=>X.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(W,Q,X){const Z=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new re(this.h,this.j.converter,X,this.l,W),W);this.e.$registerInlayHintsProvider(he,this.o(Q,W),typeof X.resolveInlayHint=="function",Z,Ie.u(W));let we=this.p(he);if(Z!==void 0){const Te=X.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(Z));we=d.$_M.from(we,Te)}return we}$provideInlayHints(W,Q,X,Z){return this.s(W,re,he=>he.provideInlayHints(b.URI.revive(Q),X,Z),void 0,Z)}$resolveInlayHint(W,Q,X){return this.s(W,re,Z=>Z.resolveInlayHint(Q,X),void 0,X)}$releaseInlayHints(W,Q){this.s(W,re,X=>X.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(W,Q,X){const Z=this.t(new se(this.h,X),W);return this.e.$registerDocumentLinkProvider(Z,this.o(Q,W),typeof X.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(W,Q,X){return this.s(W,se,Z=>Z.provideLinks(b.URI.revive(Q),X),void 0,X,Q.scheme==="output")}$resolveDocumentLink(W,Q,X){return this.s(W,se,Z=>Z.resolveLink(Q,X),void 0,void 0,!0)}$releaseDocumentLinks(W,Q){this.s(W,se,X=>X.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(W,Q,X){const Z=this.t(new oe(this.h,X),W);return this.e.$registerDocumentColorProvider(Z,this.o(Q,W)),this.p(Z)}$provideDocumentColors(W,Q,X){return this.s(W,oe,Z=>Z.provideColors(b.URI.revive(Q),X),[],X)}$provideColorPresentations(W,Q,X,Z){return this.s(W,oe,he=>he.provideColorPresentations(b.URI.revive(Q),X,Z),void 0,Z)}registerFoldingRangeProvider(W,Q,X){const Z=this.q(),he=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new Pe(new K(this.h,X),W)),this.e.$registerFoldingRangeProvider(Z,this.o(Q,W),W.identifier,he);let we=this.p(Z);if(he!==void 0){const Te=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=d.$_M.from(we,Te)}return we}$provideFoldingRanges(W,Q,X,Z){return this.s(W,K,he=>he.provideFoldingRanges(b.URI.revive(Q),X,Z),void 0,Z)}registerSelectionRangeProvider(W,Q,X){const Z=this.t(new te(this.h,X,this.l),W);return this.e.$registerSelectionRangeProvider(Z,this.o(Q,W)),this.p(Z)}$provideSelectionRanges(W,Q,X,Z){return this.s(W,te,he=>he.provideSelectionRanges(b.URI.revive(Q),X,Z),[],Z)}registerCallHierarchyProvider(W,Q,X){const Z=this.t(new ge(this.h,X),W);return this.e.$registerCallHierarchyProvider(Z,this.o(Q,W)),this.p(Z)}$prepareCallHierarchy(W,Q,X,Z){return this.s(W,ge,he=>Promise.resolve(he.prepareSession(b.URI.revive(Q),X,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(W,Q,X,Z){return this.s(W,ge,he=>he.provideCallsTo(Q,X,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(W,Q,X,Z){return this.s(W,ge,he=>he.provideCallsFrom(Q,X,Z),void 0,Z)}$releaseCallHierarchy(W,Q){this.s(W,ge,X=>Promise.resolve(X.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(W,Q,X){const Z=this.t(new be(this.h,X),W);return this.e.$registerTypeHierarchyProvider(Z,this.o(Q,W)),this.p(Z)}$prepareTypeHierarchy(W,Q,X,Z){return this.s(W,be,he=>Promise.resolve(he.prepareSession(b.URI.revive(Q),X,Z)),void 0,Z)}$provideTypeHierarchySupertypes(W,Q,X,Z){return this.s(W,be,he=>he.provideSupertypes(Q,X,Z),void 0,Z)}$provideTypeHierarchySubtypes(W,Q,X,Z){return this.s(W,be,he=>he.provideSubtypes(Q,X,Z),void 0,Z)}$releaseTypeHierarchy(W,Q){this.s(W,be,X=>Promise.resolve(X.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(W,Q,X,Z){const he=this.q();return this.f.set(he,new Pe(new Re(this.e,this.h,X,he,W),W)),this.e.$registerDocumentOnDropEditProvider(he,this.o(Q,W),(0,o.$OG)(W,"documentPaste")&&Z?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:Z.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(W,Q,X,Z,he,we){return this.s(W,Re,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(Q,b.URI.revive(X),Z,he,we)),void 0,void 0)}$resolveDropEdit(W,Q,X){return this.s(W,Re,Z=>Z.resolveDropEdit(Q,X),{},void 0)}$releaseDropEdits(W,Q){this.s(W,Re,X=>Promise.resolve(X.releaseDropEdits(Q)),void 0,void 0)}registerMappedEditsProvider(W,Q,X){const Z=this.t(new pe(this.h,X),W);return this.e.$registerMappedEditsProvider(Z,this.o(Q,W)),this.p(Z)}$provideMappedEdits(W,Q,X,Z,he){return this.s(W,pe,we=>Promise.resolve(we.provideMappedEdits(Q,X,Z,he)),null,he)}registerDocumentPasteEditProvider(W,Q,X,Z){const he=this.q();return this.f.set(he,new Pe(new F(this.e,this.h,X,he,W),W)),this.e.$registerPasteEditProvider(he,this.o(Q,W),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Z.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(W,Q,X,Z,he){return this.s(W,F,we=>we.prepareDocumentPaste(b.URI.revive(Q),X,Z,he),void 0,he)}$providePasteEdits(W,Q,X,Z,he,we,Te){return this.s(W,F,He=>He.providePasteEdits(Q,b.URI.revive(X),Z,he,we,Te),void 0,Te)}$resolvePasteEdit(W,Q,X){return this.s(W,F,Z=>Z.resolvePasteEdit(Q,X),{},void 0)}$releasePasteEdits(W,Q){this.s(W,F,X=>Promise.resolve(X.releasePasteEdits(Q)),void 0,void 0)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:Ie.w(W.decreaseIndentPattern),increaseIndentPattern:Ie.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Ie.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Ie.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:Ie.w(W.beforeText),afterText:W.afterText?Ie.w(W.afterText):void 0,previousLineText:W.previousLineText?Ie.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(Ie.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(Q=>d.SyntaxTokenType.toString(Q)):void 0}}static D(W){return W.map(Ie.C)}setLanguageConfiguration(W,Q,X){const{wordPattern:Z}=X;if(Z&&(0,I.$kf)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(Q,Z):this.h.setWordDefinitionFor(Q,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const he=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ie.w(X.wordPattern):void 0,indentationRules:X.indentationRules?Ie.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ie.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ie.D(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,Q,we),this.p(he)}$setWordDefinitions(W){for(const Q of W)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$plc=Ie,Ie.d=0}),define(ke[123],Se([1,0,3,6,16,8,109,25,7,4,227,147,13,5,20,122,11,40]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=void 0,e.$9lc=(0,k.$wi)("IExtHostLanguageModels");class i{constructor(l,r){this.option=l,this.stream=new m.$Zh,this.stream=r??new m.$Zh}}class d{constructor(){this.a=new Map,this.b=new m.$Zh,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let r=this.a.get(l.index);r||(this.a.size===0?r=new i(l.index,this.b):r=new i(l.index),this.a.set(l.index,r)),r.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const r of this.f())r.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let o=n=class{constructor(l,r,c){this.j=r,this.k=c,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new $.$Um,this.i=new Map,this.o=new Set,this.b=l.getProxy(N.$0M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,r,c,s){const v=n.a++;this.f.set(v,{extension:l.identifier,provider:c,languageModelId:r});let f;s.auth&&(f={providerLabel:l.displayName||l.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,r,{extension:l.identifier,identifier:r,name:s.name??"",version:s.version,tokens:s.tokens,auth:f});const y=c.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:D,tokenCount:S})=>{this.b.$whenLanguageModelChatRequestMade(r,new $.$Sm(w),D,S)});return(0,a.$Tc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v),y?.dispose()})}async $provideLanguageModelResponse(l,r,c,s,v,f){const y=this.f.get(l);if(!y)return;const w=new L.$ew(async D=>{if(f.isCancellationRequested){this.j.warn(`[CHAT](${y.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:D.index,part:D.part})});return y.provider.provideLanguageModelResponse2(s.map(A.LanguageModelMessage.to),v,$.$Sm.toKey(c),w,f)}$provideTokenLength(l,r,c){const s=this.f.get(l);return s?Promise.resolve(s.provider.provideTokenCount(r,c)):Promise.resolve(0)}$updateLanguageModels(l){const r=[],c=[];if(l.added)for(const s of l.added)this.g.set(s.identifier,s),r.push(s.identifier);if(l.removed)for(const s of l.removed){this.g.delete(s),c.push(s);for(const[v,f]of this.i)f.languageModelId===s&&(f.res.reject(new b.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(c)})),l.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(l){const r=new Array;for(const{from:c,to:s,enabled:v}of l){const f=this.h.get(c)??new $.$Tm;if(f.has(s)!==v){v?f.add(s):f.delete(s),this.h.set(c,f);const w={from:c,to:s};r.push(w),this.c.fire(w)}}}async sendChatRequest(l,r,c,s,v){const f=l.identifier,y=await this.b.$prepareChatAccess(f,r,s.justification);if(!y||!this.g.has(r))throw R.$kP.NotFound(`Language model '${r}' is unknown.`);if(this.m(f,y)&&(!await this.l(l,{identifier:y.extension,displayName:y.auth.providerLabel},s.justification,s.silent)||!this.h.get(f)?.has(y.extension)))throw R.$kP.NoPermissions(`Language model '${r}' cannot be used by '${f.value}'.`);const w=Math.random()*1e6|0,D=this.b.$fetchResponse(f,r,w,c.map(A.LanguageModelMessage.from),s.modelOptions??{},v),S=new m.$vh,C=new d;this.i.set(w,{languageModelId:r,res:C});let j;if(D.catch(B=>{S.isOpen()?C.reject(B):j=B}).finally(()=>{this.i.delete(w),C.resolve(),S.open()}),await S.wait(),j)throw new R.$kP(`Language model '${r}' errored, check cause for more details`,"Unknown",j);return C.apiObject}async $handleResponseFragment(l,r){const c=this.i.get(l);c&&c.res.handleFragment(r)}async l(l,r,c,s){const v=P.$_L+r.identifier.value;if(await this.k.getSession(l,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:r.identifier,enabled:!0}]),!0;if(s)return!1;try{const y=c?(0,I.localize)(0,null,r.displayName,c):(0,I.localize)(1,null,r.displayName);return await this.k.getSession(l,v,[],{forceNewSession:{detail:y}}),this.$updateModelAccesslist([{from:l.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}m(l,r){return!!r.auth&&!$.$Sm.equals(r.extension,l)}async n(l){for(const r of this.o)try{await this.l(r,{identifier:l.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}async computeTokenLength(l,r,c){const s=this.g.get(l);if(!s)throw R.$kP.NotFound(`Language model '${l}' is unknown.`);const v=u.Iterable.find(this.f.values(),f=>f.languageModelId===l);return v?v.provider.provideTokenCount(r,c):this.b.$countTokens(s.identifier,typeof r=="string"?r:A.LanguageModelMessage.from(r),c)}getLanguageModelInfo(l){const r=this.g.get(l);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(l){this.o.add(l);const r=this,c=E.Event.signal(E.Event.filter(this.c.event,v=>$.$Sm.equals(v.from,l.identifier))),s=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,s)},canSendRequest(v){const f=r.g.get(v);if(!f)return;if(!r.m(l.identifier,f))return!0;const y=r.h.get(l.identifier);if(y)return y.has(f.extension)}}}};e.$0lc=o,o.a=1,e.$0lc=o=n=Je([Ue(0,p.$xP),Ue(1,g.$3j),Ue(2,h.$rlc)],o)}),define(ke[343],Se([1,0,6,16,8,42,7,3,26]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class E{constructor(P,b,k,p){this.c=b,this.d=k,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(a.$0M.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,b){await this.a.$changeLanguage(P,b);const k=this.c.getDocumentData(P);if(!k)throw new Error(`document '${P.toString()}' NOT found`);return k.document}async tokenAtPosition(P,b){const k=P.version,p=N.Position.from(b),h=await this.a.$tokensAtPosition(P.uri,p),g={type:A.StandardTokenType.Other,range:P.getWordRangeAtPosition(b)??new A.$bN(b.line,b.character,b.line,b.character)};if(!h)return g;const u={range:N.Range.to(h.range),type:N.TokenType.to(h.type)};return!u.range.contains(b)||k!==P.version?g:u}createLanguageStatusItem(P,b,k){const p=this.f++,h=this.a,g=this.g,u=`${P.identifier.value}/${b}`;if(g.has(u))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);g.add(u);const n={selector:k,id:b,name:P.displayName??P.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const d=new $.$Uc,o=()=>{if(i?.dispose(),!g.has(u)){console.warn(`LanguageStatusItem (${b}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.$yh)(()=>{d.clear(),this.a.$setLanguageStatus(p,{id:u,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===A.LanguageStatusSeverity.Error?R.default.Error:n.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,d),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){d.dispose(),i?.dispose(),h.$removeLanguageStatus(p),g.delete(u)},get id(){return n.id},get name(){return n.name},set name(l){n.name=l,o()},get selector(){return n.selector},set selector(l){n.selector=l,o()},get text(){return n.text},set text(l){n.text=l,o()},set text2(l){(0,m.$PG)(P,"languageStatusText"),n.text=l,o()},get text2(){return(0,m.$PG)(P,"languageStatusText"),n.text},get detail(){return n.detail},set detail(l){n.detail=l,o()},get severity(){return n.severity},set severity(l){n.severity=l,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(l){n.accessibilityInformation=l,o()},get command(){return n.command},set command(l){n.command=l,o()},get busy(){return n.busy},set busy(l){n.busy=l,o()}};return o(),t}}e.$Omc=E}),define(ke[344],Se([1,0,15,2,16,8,121]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0;class ${constructor(P,b,k,p){this.start=P,this.deletedCount=b,this.deletedItems=k,this.items=p}asApiEvent(){return{range:new R.$BO(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,b,k){this.notebook=P,this.h=b,this.j=k,this.handle=k.handle,this.uri=N.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(A.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,b=this.h.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:b.document,get mime(){return P.g},set mime(p){P.g=p},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(k)}return this.f}setOutputs(P){this.a=P.map(A.NotebookCellOutput.to)}setOutputItems(P,b,k){const p=k.map(A.NotebookCellOutputItem.to),h=this.a.find(g=>g.id===P);if(h&&(b||(h.items.length=0),h.items.push(...p),h.items.length>1&&h.items.every(g=>L.$7K(g.mime)))){const g=new Map,u=[];h.items.forEach(n=>{let i;g.has(n.mime)?i=g.get(n.mime):(i=[],g.set(n.mime,i),u.push(n.mime)),i.push(n.data)}),h.items.length=0,u.forEach(n=>{const i=L.$8K(g.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Amc=m;class E{constructor(P,b,k,p,h){this.k=P,this.l=b,this.m=k,this.uri=p,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,b={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===a.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(k){return k=P.n(k),P.b[k].apiCell},getCells(k){return(k?P.p(k):P.b).map(h=>h.apiCell)},save(){return P.q()}};this.e=Object.freeze(b)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,b,k){this.g=P.versionId,this.h=b,this.acceptDocumentPropertiesChanged({metadata:k});const p={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},h=[];for(const u of P.rawEvents)u.kind===L.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,p.contentChanges):u.kind===L.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,p.contentChanges):u.kind===L.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),h.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===L.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),h.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),h.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===L.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),h.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),h.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const g=new Map;for(let u=0;u<h.length;u++){const n=h[u],i=g.get(n.cell);if(i===void 0){const d=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});g.set(n.cell,d-1)}else p.cellChanges[i]={...p.cellChanges[i],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let b=P.start|0,k=P.end|0;return b<0&&(b=0),k>this.b.length&&(k=this.b.length),P.with({start:b,end:k})}p(P){P=this.o(P);const b=[];for(let k=P.start;k<P.end;k++)b.push(this.b[k]);return b}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,b,k){if(this.j)return;const p=[],h=[],g=[];if(P.reverse().forEach(u=>{const i=u[2].map(t=>{const l=new m(this,this.l,t);return b||h.push(m.asModelAddData(t)),l}),d=new $(u[0],u[1],[],i),o=this.b.splice(u[0],u[1],...i);for(const t of o)g.push(t.uri),d.deletedItems.push(t.apiCell);p.push(d)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),k)for(const u of p)k.push(u.asApiEvent())}s(P,b,k,p){const h=this.b.splice(P,b);this.b.splice(k,0,...h);const g=[new $(P,b,h.map(u=>u.apiCell),[]),new $(k,0,[],h)];for(const u of g)p.push(u.asApiEvent())}t(P,b){this.b[P].setOutputs(b)}u(P,b,k,p){this.b[P].setOutputItems(b,k,p)}v(P,b){const k=this.b[P];k.apiCell.document.languageId!==b&&this.m.$acceptModelLanguageChanged(k.uri,b)}w(P,b){const k=this.b[P];k.apiCell.mime=b}x(P,b){this.b[P].setMetadata(b)}y(P,b){this.b[P].setInternalMetadata(b)}getCellFromApiCell(P){return this.b.find(b=>b.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(b=>b.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Bmc=E,E.a=0}),define(ke[345],Se([1,0,4,2,16,8,48]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class ${constructor(E,I,P,b={timeout:1500,errors:3}){this.b=E,this.c=I,this.d=P,this.f=b,this.a=new a.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(I,P,b)=>{const k=function(h){I.call(P,h)};return k.extension=E,this.a.event(k,void 0,b)}}async $participateInSave(E,I,P){const b=N.URI.revive(E),k=this.c.getNotebookDocument(b);if(!k)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:A.TextDocumentSaveReason.to(I)},P,async(g,u)=>{const n=Date.now(),i=await await Promise.resolve(g);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!P.isCancellationRequested&&i&&(i instanceof R.$jN?p.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const h={edits:[]};for(const g of p){const{edits:u}=A.WorkspaceEdit.from(g);h.edits=h.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(new L.$Cw(h))}}e.$Qmc=$}),define(ke[155],Se([1,0,13,16,8]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;class R{constructor($,m,E,I,P,b){this.id=$,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=I,this.c=b}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(m){this.selections=[m]},get selections(){return $.a},set selections(m){if(!Array.isArray(m)||!m.every(A.$BO.isNotebookRange))throw(0,a.$7)("selections");$.a=m,$.g(m)},get visibleRanges(){return $.b},revealRange(m,E){$.f.$tryRevealRange($.id,N.NotebookRange.from(m),E??A.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(N.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Cmc=R,R.apiEditorsToExtHost=new WeakMap}),define(ke[346],Se([1,0,4,11,16]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;let R=class{constructor($,m){this.c=$,this.d=m,this.a=new a.$ee,this.b=new a.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,m);const E=this.d.getEditorById($);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(A.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(A.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns($){for(const m in $)this.d.getEditorById(m)._acceptViewColumn(A.ViewColumn.to($[m]))}};e.$Smc=R,e.$Smc=R=Je([Ue(0,N.$3j)],R)}),define(ke[347],Se([1,0,4,6,155]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class R{constructor($,m){this.c=m,this.a=new Map,this.b=$.getProxy(N.$0M.MainThreadNotebookRenderers)}$postRendererMessage($,m,E){const I=this.c.getEditorById($);this.a.get(m)?.fire({editor:I.apiEditor,message:E})}createRendererMessaging($,m){if(!$.contributes?.notebookRenderer?.some(I=>I.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(I,P,b)=>this.d(m).event(I,P,b),postMessage:(I,P)=>{A.$Cmc.apiEditorsToExtHost.has(I)&&([I,P]=[P,I]);const b=P&&A.$Cmc.apiEditorsToExtHost.get(P);return this.b.$postMessage(b?.id,m,I)}}}d($){let m=this.a.get($);return m||(m=new a.$ee({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete($)}}),this.a.set($,m),m)}}e.$Vmc=R}),define(ke[348],Se([1,0,16,109,22,56,13]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class ${constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,b,k){const p=this.b++,{title:h,location:g,cancellable:u}=b,n={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(p,{location:a.ProgressLocation.from(g),title:h,source:n,cancellable:u},P.isUnderDevelopment?void 0:P.identifier.value).catch(L.$2),this.d(p,k,!!u)}d(P,b,k){let p;k&&(p=new A.$pe,this.c.set(P,p));const h=u=>{this.a.$progressEnd(u),this.c.delete(u),p?.dispose()};let g;try{g=b(new E(this.a,P),k&&p?p.token:A.CancellationToken.None)}catch(u){throw h(P),u}return g.then(u=>h(P),u=>h(P)),g}$acceptProgressCanceled(P){const b=this.c.get(P);b&&(b.cancel(),this.c.delete(P))}}e.$Zmc=$;function m(I,P){return I.message=P.message,typeof P.increment=="number"&&(typeof I.increment=="number"?I.increment+=P.increment:I.increment=P.increment),I}class E extends N.$ew{constructor(P,b){super(k=>this.throttledReport(k)),this.c=P,this.d=b}throttledReport(P){this.c.$progressReport(this.d,P)}}Je([(0,R.$3h)(100,(I,P)=>m(I,P),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[349],Se([1,0,2,6,7,16]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class L{constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(N.$0M.MainThreadQuickDiff)}$provideOriginalResource(m,E,I){const P=a.URI.revive(E),b=this.c.get(m);return b?(0,A.$oh)(()=>b.provideOriginalResource(P,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,I,P){const b=L.a++;return this.c.set(b,E),this.b.$registerQuickDiffProvider(b,R.DocumentSelector.from(m,this.d),I,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(b),this.c.delete(b)}}}}e.$1mc=L,L.a=0}),define(ke[350],Se([1,0,22,4,3,6,2,8,13,19,42,51,26,16]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=p;function p(h,g,u){const n=h.getProxy(R.$0M.MainThreadQuickOpen);class i{constructor(f,y){this.e=new Map,this.f=0,this.a=f,this.b=y}showQuickPick(f,y,w,D=a.CancellationToken.None){this.c=void 0;const S=Promise.resolve(y),C=++this.f,j=n.$show(C,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},D),B={},z=j.then(()=>B);return Promise.race([z,S]).then(T=>{if(T===B)return;const M=(0,b.$OG)(f,"quickPickItemTooltip");return S.then(F=>{const O=[];for(let q=0;q<F.length;q++){const Y=F[q];if(typeof Y=="string")O.push({label:Y,handle:q});else if(Y.kind===$.QuickPickItemKind.Separator)O.push({type:"separator",label:Y.label});else{Y.tooltip&&!M&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const V=Y.iconPath?r(Y.iconPath):void 0;O.push({label:Y.label,iconPath:V?.iconPath,iconClass:V?.iconClass,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:M?k.MarkdownString.fromStrict(Y.tooltip):void 0,handle:q})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=q=>{w.onDidSelectItem(F[q])}),n.$setItems(C,O),j.then(q=>{if(typeof q=="number")return F[q];if(Array.isArray(q))return q.map(Y=>F[Y])})})}).then(void 0,T=>{if(!(0,m.$4)(T))return n.$setError(C,T),Promise.reject(T)})}$onItemSelected(f){this.c?.(f)}showInput(f,y=a.CancellationToken.None){return this.d=f?.validateInput,n.$input(f,typeof this.d=="function",y).then(void 0,w=>{if(!(0,m.$4)(w))return Promise.reject(w)})}async $validateInput(f){if(!this.d)return;const y=await this.d(f);if(!y||typeof y=="string")return y;let w;switch(y.severity){case $.InputBoxValidationSeverity.Info:w=I.default.Info;break;case $.InputBoxValidationSeverity.Warning:w=I.default.Warning;break;case $.InputBoxValidationSeverity.Error:w=I.default.Error;break;default:w=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:w}}async showWorkspaceFolderPick(f,y=a.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!w)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(S=>S.uri.toString()===w.uri.toString())}createQuickPick(f){const y=new c(f,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(f){const y=new s(f,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(f,y){this.e.get(f)?._fireDidChangeValue(y)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,y){const w=this.e.get(f);w instanceof c&&w._fireDidChangeActive(y)}$onDidChangeSelection(f,y){const w=this.e.get(f);w instanceof c&&w._fireDidChangeSelection(y)}$onDidTriggerButton(f,y){this.e.get(f)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(f,y,w){const D=this.e.get(f);D instanceof c&&D._fireDidTriggerItemButton(y,w)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class d{constructor(f,y){this.x=f,this.y=y,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$ee,this.q=new N.$ee,this.r=new N.$ee,this.s=new N.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((y,w)=>{const D=y===$.$yO.Back?-1:w;this.o.set(D,y)}),this.z({buttons:f.map((y,w)=>({...r(y.iconPath),tooltip:y.tooltip,handle:y===$.$yO.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const y=this.o.get(f);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(f){if(!this.v){for(const y of Object.keys(f)){const w=f[y];this.u[y]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}d.a=1;function o(v){if(v instanceof $.$9N)return{id:v.id};const f=l(v),y=t(v);return{dark:typeof f=="string"?L.URI.file(f):f,light:typeof y=="string"?L.URI.file(y):y}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function l(v){return typeof v=="object"&&"dark"in v?v.dark:v}function r(v){const f=o(v);let y,w;return"id"in f?w=P.ThemeIcon.asClassName(f):y=f,{iconPath:y,iconClass:w}}class c extends d{constructor(f,y){super(f.identifier,y),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$ee,this.L=[],this.M=new N.$ee,this.N=new N.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((D,S)=>{this.C.set(S,D),this.D.set(D,S)});const y=(0,b.$OG)(this.O,"quickPickItemTooltip"),w=[];for(let D=0;D<f.length;D++){const S=f[D];if(S.kind===$.QuickPickItemKind.Separator)w.push({type:"separator",label:S.label});else{S.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=S.iconPath?r(S.iconPath):void 0;w.push({handle:D,label:S.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:y?k.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((j,B)=>({...r(j.iconPath),tooltip:j.tooltip,handle:B}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(f){const y=(0,E.$Hb)(f.map(w=>this.C.get(w)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(f){const y=(0,E.$Hb)(f.map(w=>this.C.get(w)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(f,y){const w=this.C.get(f);if(!w||!w.buttons||!w.buttons.length)return;const D=w.buttons[y];D&&this.N.fire({button:D,item:w})}}class s extends d{constructor(f,y){super(f.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:I.default.Error}):this.z({validationMessage:f.message,severity:f.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(g,u)}});var qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)},it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a};define(ke[351],Se([1,0,2,4,56,3,7,6,19,128,11,25,51,16,26,15,12]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";var u,n,i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=void 0;function o(z){return z instanceof a.URI}function t(z,T){return z.scheme===h.Schemas.file&&T.scheme===h.Schemas.file&&g.$e?z.toString()===T.toString():z.toString().toLowerCase()===T.toString().toLowerCase()}function l(z){if(z)return typeof z.iconPath=="string"?a.URI.file(z.iconPath):a.URI.isUri(z.iconPath)||b.ThemeIcon.isThemeIcon(z.iconPath)?z.iconPath:void 0}function r(z){if(z.icon){if(a.URI.isUri(z.icon))return z.icon;if(b.ThemeIcon.isThemeIcon(z.icon))return z.icon;{const T=z.icon;return{light:T.light,dark:T.dark}}}else return}function c(z,T){if(!z.iconPath&&!T.iconPath)return 0;if(z.iconPath){if(!T.iconPath)return 1}else return-1;const M=typeof z.iconPath=="string"?z.iconPath:a.URI.isUri(z.iconPath)?z.iconPath.fsPath:z.iconPath.id,F=typeof T.iconPath=="string"?T.iconPath:a.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,E.$rr)(M,F)}function s(z,T){let M=0;if(z.strikeThrough!==T.strikeThrough)return z.strikeThrough?1:-1;if(z.faded!==T.faded)return z.faded?1:-1;if(z.tooltip!==T.tooltip)return(z.tooltip||"").localeCompare(T.tooltip||"");if(M=c(z,T),M!==0)return M;if(z.light&&T.light)M=c(z.light,T.light);else{if(z.light)return 1;if(T.light)return-1}if(M!==0)return M;if(z.dark&&T.dark)M=c(z.dark,T.dark);else{if(z.dark)return 1;if(T.dark)return-1}return M}function v(z,T){if(z.command!==T.command)return z.command<T.command?-1:1;if(z.title!==T.title)return z.title<T.title?-1:1;if(z.tooltip!==T.tooltip){if(z.tooltip!==void 0&&T.tooltip!==void 0)return z.tooltip<T.tooltip?-1:1;if(z.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(z.arguments===T.arguments)return 0;if(z.arguments)if(T.arguments){if(z.arguments.length!==T.arguments.length)return z.arguments.length-T.arguments.length}else return 1;else return-1;for(let M=0;M<z.arguments.length;M++){const F=z.arguments[M],O=T.arguments[M];if(F!==O&&!(o(F)&&o(O)&&t(F,O)))return F<O?-1:1}return 0}function f(z,T){let M=(0,E.$rr)(z.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(M!==0)return M;if(z.command&&T.command)M=v(z.command,T.command);else{if(z.command)return 1;if(T.command)return-1}if(M!==0)return M;if(z.decorations&&T.decorations)M=s(z.decorations,T.decorations);else{if(z.decorations)return 1;if(T.decorations)return-1}if(z.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)M=(0,E.$rr)(z.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(z.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(z.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)M=(0,E.$rr)(z.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(z.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return M}function y(z,T){for(let M=0;M<z.length;M++)if(z[M]!==T[M])return!1;return!0}function w(z,T){return z.command===T.command&&z.title===T.title&&z.tooltip===T.tooltip&&(z.arguments&&T.arguments?y(z.arguments,T.arguments):z.arguments===T.arguments)}function D(z,T){return(0,m.$ub)(z,T,w)}class S{get value(){return this.d}set value(T){T=T??"",qe(this,u,"f").$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){qe(this,u,"f").$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,p.$PG)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,p.$PG)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,qe(this,u,"f").$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,qe(this,u,"f").$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,qe(this,u,"f").$setInputBoxVisibility(this.l,T))}get document(){return(0,p.$PG)(this.k,"scmTextDocument"),qe(this,n,"f").getDocument(this.m)}constructor(T,M,F,O,q){this.k=T,this.l=O,this.m=q,u.set(this,void 0),n.set(this,void 0),this.d="",this.e=new N.$ee,this.f="",this.h=!0,this.j=!0,it(this,n,M,"f"),it(this,u,F,"f")}showValidationMessage(T,M){(0,p.$PG)(this.k,"scmValidation"),qe(this,u,"f").$showValidationMessage(this.l,T,M)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$3mc=S,u=new WeakMap,n=new WeakMap;class C{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,M,F,O,q,Y,V){this.q=T,this.s=M,this.t=F,this.u=O,this.v=q,this.multiDiffEditorEnableViewChanges=Y,this.w=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=C.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,M){const F=this.h.get(T);return F?(0,L.$oh)(()=>this.s.executeCommand(F.command,...F.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(f),F=(0,m.$Db)(this.o,T,f).map(Y=>{const V=Y.toInsert.map(J=>{const x=this.e++;this.g.set(x,J);const ne=J.resourceUri;let de;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const ge=new R.$Uc;de=this.s.converter.toInternal(J.command,ge),this.j.set(x,ge)}else this.h.set(x,J.command);const ce=(0,p.$OG)(this.w,"scmMultiDiffEditor"),ve=ce?J.multiDiffEditorOriginalUri:void 0,_=ce?J.multiFileDiffEditorModifiedUri:void 0,U=l(J.decorations),le=J.decorations&&l(J.decorations.light)||U,De=J.decorations&&l(J.decorations.dark)||U,$e=[le,De],re=J.decorations&&J.decorations.tooltip||"",se=J.decorations&&!!J.decorations.strikeThrough,oe=J.decorations&&!!J.decorations.faded,K=J.contextValue||"";return{rawResource:[x,ne,$e,re,se,oe,K,de,ve,_],handle:x}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:V}}),O=F.map(({start:Y,deleteCount:V,toInsert:J})=>[Y,V,J.map(x=>x.rawResource)]),q=F.reverse();for(const{start:Y,deleteCount:V,toInsert:J}of q){const x=J.map(de=>de.handle),ne=this.n.splice(Y,V,...x);for(const de of ne)this.g.delete(de),this.h.delete(de),this.j.get(de)?.dispose(),this.j.delete(de)}return this.o=T,O}dispose(){this.l=!0,this.m.fire()}}C.d=0;class j{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,qe(this,i,"f").$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let M;(0,p.$OG)(this.x,"quickDiffProvider")&&(M=T?.label),qe(this,i,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:M})}get historyProvider(){return(0,p.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,p.$PG)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new R.$Uc,qe(this,i,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,qe(this,i,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,qe(this,i,"f").$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new R.$Uc,this.o=T;const M=this.y.converter.toInternal(T,this.n.value);qe(this,i,"f").$updateSourceControl(this.w,{acceptInputCommand:M})}get actionButton(){return(0,p.$PG)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,p.$PG)(this.x,"scmActionButton"),this.p.value=new R.$Uc,this.q=T;const M=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(F=>F.map(O=>this.y.converter.toInternal(O,this.p.value))),description:T.description,enabled:T.enabled}:void 0;qe(this,i,"f").$updateSourceControl(this.w,{actionButton:M??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&D(this.t,T))return;this.s.value=new R.$Uc,this.t=T;const M=(T||[]).map(F=>this.y.converter.toInternal(F,this.s.value));qe(this,i,"f").$updateSourceControl(this.w,{statusBarCommands:M})}get selected(){return this.u}constructor(T,M,F,O,q,Y,V){this.x=T,this.y=O,this.z=q,this.A=Y,this.B=V,i.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.m=void 0,this.n=new R.$Wc,this.o=void 0,this.p=new R.$Wc,this.s=new R.$Wc,this.t=void 0,this.u=!1,this.v=new N.$ee,this.onDidChangeSelection=this.v.event,this.w=j.d++,this.C=new Map,this.D=new Set,it(this,i,F,"f");const J=a.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${q}/scm${this.w}/input`,query:V?`rootUri=${encodeURIComponent(V.toString())}`:void 0});this.f=new S(T,M,qe(this,i,"f"),this.w,J),qe(this,i,"f").$registerSourceControl(this.w,q,Y,V,J)}createResourceGroup(T,M,F){const O=(0,p.$OG)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,q=new C(qe(this,i,"f"),this.y,this.w,T,M,O,this.x),Y=N.Event.once(q.onDidDispose)(()=>this.C.delete(q));return this.C.set(q,Y),this.eventuallyAddResourceGroups(),q}eventuallyAddResourceGroups(){const T=[],M=[];for(const[F,O]of this.C){O.dispose();const q=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});N.Event.once(F.onDidDispose)(()=>{this.D.delete(F),q.dispose(),this.e.delete(F.handle),qe(this,i,"f").$unregisterGroup(this.w,F.handle)}),T.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const Y=F._takeResourceStateSnapshot();Y.length>0&&M.push([F.handle,Y]),this.e.set(F.handle,F)}qe(this,i,"f").$registerGroups(this.w,T,M),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(M=>{const F=M._takeResourceStateSnapshot();F.length!==0&&T.push([M.handle,F])}),T.length>0&&qe(this,i,"f").$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),qe(this,i,"f").$unregisterSourceControl(this.w)}}i=new WeakMap,j.d=0,Je([(0,A.$2h)(100)],j.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$2h)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let B=d=class{get onDidChangeActiveProvider(){return this.j.event}constructor(T,M,F,O){this.l=M,this.m=F,this.n=O,this.g=new Map,this.h=new P.$Um,this.j=new N.$ee,this.e=T.getProxy($.$0M.MainThreadSCM),this.f=T.getProxy($.$0M.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const Y=this.g.get(q.sourceControlHandle);if(!Y)return q;const V=Y.getResourceGroup(q.groupHandle);return V?V.getResourceState(q.handle):q}else if(q&&q.$mid===4){const Y=this.g.get(q.sourceControlHandle);return Y?Y.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const Y=this.g.get(q.handle);return Y||q}return q}})}createSourceControl(T,M,F,O){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,M,F,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const q=d.d++,Y=new j(T,this.m,this.e,this.l,M,F,O);this.g.set(q,Y);const V=this.h.get(T.identifier)||[];return V.push(Y),this.h.set(T.identifier,V),Y}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const M=this.h.get(T.identifier),F=M&&M[M.length-1];return F&&F.inputBox}$provideOriginalResource(T,M,F){const O=a.URI.revive(M);this.n.trace("ExtHostSCM#$provideOriginalResource",T,O.toString());const q=this.g.get(T);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$oh)(()=>q.quickDiffProvider.provideOriginalResource(O,F)).then(Y=>Y||null)}$onInputBoxValueChange(T,M){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const F=this.g.get(T);return F&&F.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(T,M,F,O){this.n.trace("ExtHostSCM#$executeResourceCommand",T,M,F);const q=this.g.get(T);if(!q)return Promise.resolve(void 0);const Y=q.getResourceGroup(M);return Y?Y.$executeResourceCommand(F,O):Promise.resolve(void 0)}$validateInput(T,M,F){this.n.trace("ExtHostSCM#$validateInput",T);const O=this.g.get(T);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,L.$oh)(()=>O.inputBox.validateInput(M,F)).then(q=>{if(!q)return Promise.resolve(void 0);const Y=k.MarkdownString.fromStrict(q.message);return Y?Promise.resolve([Y,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,M,F,O){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,F,O)??void 0}async $provideHistoryItems(T,M,F,O){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(M,F,O))?.map(V=>({...V,icon:r(V)}))??void 0}async $provideHistoryItemSummary(T,M,F,O){const q=this.g.get(T)?.historyProvider;if(typeof q?.provideHistoryItemSummary!="function")return;const Y=await q.provideHistoryItemSummary(M,F,O);return Y?{...Y,icon:r(Y)}:void 0}async $provideHistoryItemChanges(T,M,F,O){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(M,F,O)??void 0}};e.$4mc=B,B.d=0,e.$4mc=B=d=Je([Ue(3,I.$3j)],B)}),define(ke[352],Se([1,0,6,16,2]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class R{constructor($,m){this.d=m,this.c=new Map,this.b=$.getProxy(a.$0M.MainThreadShare)}async $provideShare($,m,E){return await this.c.get($)?.provideShare({selection:N.Range.to(m.selection),resourceUri:A.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider($,m){const E=R.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,N.DocumentSelector.from($,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$5mc=R,R.a=0});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[353],Se([1,0,8,6,230,3,16,18]),function(ie,e,a,N,A,R,L,$){"use strict";var m,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=e.$7mc=void 0;class I{constructor(p,h,g,u,n,i=a.StatusBarAlignment.Left,d){if(m.set(this,void 0),E.set(this,void 0),this.i=!1,this.k="",this.q=new R.$Uc,it(this,m,p,"f"),it(this,E,h,"f"),n&&u){this.c=(0,a.$LN)(u.identifier,n);const o=g.get(this.c);o&&(i=o.alignLeft?a.StatusBarAlignment.Left:a.StatusBarAlignment.Right,d=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(I.a++);this.e=u,this.f=n,this.g=i,this.h=this.u(d)}u(p){if((0,$.$ag)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!I.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof p=="string"?this.r={fromApi:p,internal:qe(this,E,"f").toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:qe(this,E,"f").toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,qe(this,m,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let h;this.m?h=this.m:h=(0,A.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=I.b.get(this.o.id));const u=L.MarkdownString.fromStrict(this.l);qe(this,m,"f").$setEntry(this.c,p,this.e?.identifier.value,h,this.k,u,this.r?.internal,g,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$7mc=I,m=new WeakMap,E=new WeakMap,I.a=0,I.b=new Map([["statusBarItem.errorBackground",new a.$0N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.$0N("statusBarItem.warningForeground")]]);class P{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const h={message:p};return this.b.unshift(h),this.c(),new a.$_M(()=>{const g=this.b.indexOf(h);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class b{constructor(p,h){this.e=new Map,this.a=p.getProxy(N.$0M.MainThreadStatusBar),this.b=h,this.c=new P(this)}$acceptStaticEntries(p){for(const h of p)this.e.set(h.entryId,h)}createStatusBarEntry(p,h,g,u){return new I(this.a,this.b,this.e,p,h,g,u)}setStatusBarMessage(p,h){const g=this.c.setMessage(p);let u;return typeof h=="number"?u=setTimeout(()=>g.dispose(),h):typeof h<"u"&&h.then(()=>g.dispose(),()=>g.dispose()),new a.$_M(()=>{g.dispose(),clearTimeout(u)})}}e.$8mc=b}),define(ke[156],Se([1,0,29,146,69,114,89,16,2]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.$LP=e.$KP=e.$JP=void 0;const E=(i,d,o,t)=>{let l=d;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!o(l,r)){const c=l;l=r,i.listener?.(t(r,c))}}}},I=(i,d)=>i===d,P={range:(i,d)=>i===d?!0:!i||!d?!1:i.isEqual(d),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,d)=>!(i.length!==d.length||i.some(o=>!d.find(t=>o.id===t.id)))},b=i=>d=>({op:4,update:i(d)}),k=(i,d)=>({range:(()=>{let o;const t=b(l=>({range:a.$vt.lift($.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return o},set(l){i.listener?.({op:6}),P.range(o,l)||(o=l,i.listener?.(t(l)))}}})(),label:E(i,d,P.label,b(o=>({label:o}))),description:E(i,void 0,P.description,b(o=>({description:o}))),sortText:E(i,void 0,P.sortText,b(o=>({sortText:o}))),canResolveChildren:E(i,!1,P.canResolveChildren,o=>({op:2,state:o})),busy:E(i,!1,P.busy,b(o=>({busy:o}))),error:E(i,void 0,P.error,b(o=>({error:$.MarkdownString.fromStrict(o)||null}))),tags:E(i,[],P.tags,(o,t)=>({op:1,new:o.map($.TestTag.from),old:t.map($.TestTag.from)}))}),p=i=>{const d=A.$VL.fromString(i.extId),o=new g(d.controllerId,d.localId,i.label,m.URI.revive(i.uri)||void 0);return o.range=$.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>$.TestTag.to({id:(0,L.$2L)(t).tagId})),o},h=i=>{let d;for(const o of i.tests){const t=p(o.item);(0,N.$tP)(t).parent=d,d=t}return d};e.$JP=h;class g{constructor(d,o,t,l){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const r=(0,N.$sP)(this,d);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,R.$rP)(r,N.$tP,g),enumerable:!0,writable:!1},...k(r,t)})}}e.$KP=g;class u extends g{constructor(d,o){super(d,d,o,void 0),this._isRoot=!0}}e.$LP=u;class n extends R.$nP{constructor(d,o,t){super({controllerId:d,getDocumentVersion:l=>l&&t.getDocument(l)?.version,getApiFor:N.$tP,getChildren:l=>l.children,root:new u(d,o),toITestItem:$.TestItem.from})}}e.$MP=n});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[34],Se([1,0,18,8,16,24,6,19,11,58,29,54,2,3,5,20,156,21,48,47,41,87,90,31]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l){"use strict";var r,c,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=void 0;let v=class{constructor(C,j,B){r.set(this,void 0),this.b=new Map,this.c=new Map,c.set(this,void 0),s.set(this,void 0),it(this,r,C.getProxy(L.$0M.MainThreadCommands),"f"),this.d=j,it(this,s,B,"f"),it(this,c,C.getProxy(L.$0M.MainThreadTelemetry),"f"),this.converter=new f(this,z=>{const T=this.c.get(z);return T?.result===w.Void?T:void 0},j),this.f=[{processArgument(z){return(0,E.$6h)(z)}},{processArgument(z){return(0,R.$6n)(z,function(T){if(I.$vt.isIRange(T))return A.Range.to(T);if(P.$ut.isIPosition(T))return A.Position.to(T);if(I.$vt.isIRange(T.range)&&b.URI.isUri(T.uri))return A.location.to(T);if(T instanceof u.$Ge)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const j=this.registerCommand(!1,C.id,async(...B)=>{const z=C.args.map((M,F)=>{if(!M.validate(B[F]))throw new Error(`Invalid argument '${M.name}' when running '${C.id}', received: ${typeof B[F]=="object"?JSON.stringify(B[F],null,"	"):B[F]} `);return M.convert(B[F])}),T=await this.executeCommand(C.internalId,...z);return C.result.convert(T,B,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new N.$_M(()=>{j.dispose(),this.c.delete(C.id)})}registerCommand(C,j,B,z,T,M){if(this.d.trace("ExtHostCommands#registerCommand",j),!j.trim().length)throw new Error("invalid id");if(this.b.has(j))throw new Error(`command '${j}' already exists`);return this.b.set(j,{callback:B,thisArg:z,metadata:T,extension:M}),C&&qe(this,r,"f").$registerCommand(j),new N.$_M(()=>{this.b.delete(j)&&C&&qe(this,r,"f").$unregisterCommand(j)})}executeCommand(C,...j){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,j,!0)}async g(C,j,B){if(this.b.has(C))return qe(this,r,"f").$fireCommandActivationEvent(C),this.h(C,j,!1);{let z=!1;const T=(0,R.$6n)(j,function(M){if(M instanceof N.$aN)return A.Position.from(M);if(M instanceof N.$bN)return A.Range.from(M);if(M instanceof N.$lN)return A.location.from(M);if(N.$BO.isNotebookRange(M))return A.NotebookRange.from(M);if(M instanceof ArrayBuffer)return z=!0,u.$Ge.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return z=!0,u.$Ge.wrap(M);if(M instanceof u.$Ge)return z=!0,M;if(!Array.isArray(M))return M});try{const M=await qe(this,r,"f").$executeCommand(C,z?new n.$Cw(T):T,B);return(0,E.$6h)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this.g(C,j,!1);throw M}}}async h(C,j,B){const z=this.b.get(C);if(!z)throw new Error("Unknown command");const{callback:T,thisArg:M,metadata:F}=z;if(F?.args)for(let q=0;q<F.args.length;q++)try{(0,a.$ng)(j[q],F.args[q].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${F.args[q].name}' - ${F.args[q].description}`)}const O=d.$ae.create();try{return await T.apply(M,j)}catch(q){if(C===this.converter.delegatingCommandId){const Y=this.converter.getActualCommand(...j);Y&&(C=Y.command)}if(this.d.error(q,C,z.extension?.identifier),!B)throw q;if(z.extension?.identifier){const Y=qe(this,s,"f").onExtensionError(z.extension.identifier,q);this.d.trace("forwarded error to extension?",Y,z.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(q)),this.id=C,this.source=z.extension?.displayName??z.extension?.name}}}finally{this.j(z,C,O.elapsed())}}j(C,j,B){C.extension&&qe(this,c,"f").$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new o.$gp(j),duration:B})}$executeContributedCommand(C,...j){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const B=this.b.get(C);return B?(j=j.map(z=>this.f.reduce((T,M)=>M.processArgument(T,B.extension?.identifier),z)),this.h(C,j,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),qe(this,r,"f").$getCommands().then(j=>(C&&(j=j.filter(B=>B[0]!=="_")),j))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[j,B]of this.b){const{metadata:z}=B;z&&(C[j]=z)}return Promise.resolve(C)}};e.$SP=v,r=new WeakMap,c=new WeakMap,s=new WeakMap,e.$SP=v=Je([Ue(0,h.$xP),Ue(1,m.$3j),Ue(2,t.$RP)],v),e.$TP=(0,p.$wi)("IExtHostCommands");class f{constructor(C,j,B){this.d=C,this.f=j,this.g=B,this.delegatingCommandId=`__vsc${(0,l.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,j){if(!C)return;const B={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return B;const z=this.f(C.command);if(z)B.id=z.internalId,B.arguments=z.args.map((T,M)=>T.convert(C.arguments&&C.arguments[M]));else if((0,$.$Lb)(C.arguments)){const T=`${C.command} /${++this.c}`;this.b.set(T,C),j.add((0,k.$Tc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),B.$ident=T,B.id=this.delegatingCommandId,B.arguments=[T],this.g.trace("CommandsConverter#CREATE",C.command,T)}return B}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const j=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],j?j.command:"MISSING"),j?this.d.executeCommand(j.command,...j.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$UP=f;class y{static Arr(C){return new y(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,j=>Array.isArray(j)&&j.every(B=>C.validate(B)),j=>j.map(B=>C.convert(B)))}constructor(C,j,B,z){this.name=C,this.description=j,this.validate=B,this.convert=z}optional(){return new y(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,j){return new y(C??this.name,j??this.description,this.validate,this.convert)}}e.$VP=y,y.Uri=new y("uri","Uri of a text document",S=>b.URI.isUri(S),S=>S),y.Position=new y("position","A position in a text document",S=>N.$aN.isPosition(S),A.Position.from),y.Range=new y("range","A range in a text document",S=>N.$bN.isRange(S),A.Range.from),y.Selection=new y("selection","A selection in a text document",S=>N.$cN.isSelection(S),A.Selection.from),y.Number=new y("number","",S=>typeof S=="number",S=>S),y.String=new y("string","",S=>typeof S=="string",S=>S),y.StringArray=y.Arr(y.String),y.CallHierarchyItem=new y("item","A call hierarchy item",S=>S instanceof N.$xN,A.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",S=>S instanceof N.$VO,A.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",S=>S instanceof g.$KP,A.TestItem.from);class w{constructor(C,j){this.description=C,this.convert=j}}e.$WP=w,w.Void=new w("no result",S=>S);class D{constructor(C,j,B,z,T){this.id=C,this.internalId=j,this.description=B,this.args=z,this.result=T}}e.$XP=D}),define(ke[354],Se([1,0,19,15,2,84,136,38,34,16,8]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;const P=[new m.$XP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of DocumentHighlight-instances.",k(E.DocumentHighlight.to))),new m.$XP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$VP.Uri],new m.$WP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,g)=>{if((0,a.$Kb)(h))return;class u extends I.$sN{static to(i){const d=new u(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new I.$lN(g[0],E.Range.to(i.range)));return d.detail=i.detail,d.range=d.location.range,d.selectionRange=E.Range.to(i.selectionRange),d.children=i.children?i.children.map(u.to):[],d}}return h.map(u.to)})),new m.$XP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$VP.Uri,new m.$VP("options","Formatting options",h=>!0,h=>h)],new m.$WP("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new m.$XP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$VP.Uri,m.$VP.Range,new m.$VP("options","Formatting options",h=>!0,h=>h)],new m.$WP("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new m.$XP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$VP.Uri,m.$VP.Position,new m.$VP("ch","Trigger character",h=>typeof h=="string",h=>h),new m.$VP("options","Formatting options",h=>!0,h=>h)],new m.$WP("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new m.$XP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$XP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$XP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$XP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$XP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of Location-instances.",k(E.location.to))),new m.$XP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of Hover-instances.",k(E.Hover.to))),new m.$XP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$VP.Uri,new m.$VP("position","A position in a text document",h=>Array.isArray(h)&&h.every(g=>I.$aN.isPosition(g)),h=>h.map(E.Position.from))],new m.$WP("A promise that resolves to an array of ranges.",h=>h.map(g=>{let u;for(const n of g.reverse())u=new I.$wN(E.Range.to(n),u);return u}))),new m.$XP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$VP.String.with("query","Search string")],new m.$WP("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(E.WorkspaceSymbol.to))),new m.$XP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(E.CallHierarchyItem.to))),new m.$XP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$VP.CallHierarchyItem],new m.$WP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(E.CallHierarchyIncomingCall.to))),new m.$XP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$VP.CallHierarchyItem],new m.$WP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(E.CallHierarchyOutgoingCall.to))),new m.$XP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:E.Range.to(h.range),placeholder:h.text}})),new m.$XP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$VP.Uri,m.$VP.Position,m.$VP.String.with("newName","The new symbol name")],new m.$WP("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return E.WorkspaceEdit.to(h)}})),new m.$XP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$VP.Uri,m.$VP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$WP("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(E.DocumentLink.to))),new m.$XP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$VP.Uri],new m.$WP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new I.$sO(h.tokenTypes,h.tokenModifiers)})),new m.$XP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$VP.Uri],new m.$WP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,L.$ecb)(h);if(g.type==="full")return new I.$uO(g.data,void 0)})),new m.$XP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$VP.Uri,m.$VP.Range.optional()],new m.$WP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new I.$sO(h.tokenTypes,h.tokenModifiers)})),new m.$XP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$VP.Uri,m.$VP.Range],new m.$WP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,L.$ecb)(h);if(g.type==="full")return new I.$uO(g.data,void 0)})),new m.$XP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$VP.Uri,m.$VP.Position,m.$VP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$VP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$WP("A promise that resolves to a CompletionList-instance.",(h,g,u)=>{if(!h)return new I.$IN([]);const n=h.suggestions.map(i=>E.CompletionItem.to(i,u));return new I.$IN(n,h.incomplete)})),new m.$XP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$VP.Uri,m.$VP.Position,m.$VP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$WP("A promise that resolves to SignatureHelp.",h=>{if(h)return E.SignatureHelp.to(h)})),new m.$XP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$VP.Uri,m.$VP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$WP("A promise that resolves to an array of CodeLens-instances.",(h,g,u)=>k(n=>new I.$AN(E.Range.to(n.range),n.command&&u.fromInternal(n.command)))(h))),new m.$XP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$VP.Uri,new m.$VP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>I.$bN.isRange(h),h=>I.$cN.isSelection(h)?E.Selection.from(h):E.Range.from(h)),m.$VP.String.with("kind","Code action kind to return code actions for").optional(),m.$VP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$WP("A promise that resolves to an array of Command-instances.",(h,g,u)=>k(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(n.command)}else{const i=new I.$uN(n.title,n.kind?new I.$vN(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=u.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new m.$XP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$VP.Uri],new m.$WP("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(g=>new I.$ON(E.Range.to(g.range),E.Color.to(g.color))):[])),new m.$XP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$VP("color","The color to show and insert",h=>h instanceof I.$NN,E.Color.from),new m.$VP("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:E.Range.from(h.range)}))],new m.$WP("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(E.ColorPresentation.to):[])),new m.$XP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$VP.Uri,m.$VP.Range],new m.$WP("A promise that resolves to an array of Inlay objects",(h,g,u)=>h.map(E.InlayHint.to.bind(void 0,u)))),new m.$XP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$VP.Uri],new m.$WP("A promise that resolves to an array of FoldingRange objects",(h,g)=>{if(h)return h.map(E.FoldingRange.to)})),new m.$XP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$WP("A promise that resolves to an array of NotebookContentProvider static info objects.",k(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(g=>E.NotebookExclusiveDocumentPattern.to(g))})))),new m.$XP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$VP.Uri,m.$VP.Range,new m.$VP("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof I.$bN,h=>E.InlineValueContext.from(h))],new m.$WP("A promise that resolves to an array of InlineValue objects",h=>h.map(E.InlineValue.to))),new m.$XP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$VP("uriOrString","Uri-instance or string (only http/https)",h=>A.URI.isUri(h)||typeof h=="string"&&(0,N.$Gg)(h,N.Schemas.http,N.Schemas.https),h=>h),new m.$VP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional(),m.$VP.String.with("label","").optional()],m.$WP.Void),new m.$XP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$VP.Uri.with("resource","Resource to open"),m.$VP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$VP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional()],m.$WP.Void),new m.$XP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$VP.Uri.with("left","Left-hand side resource of the diff editor"),m.$VP.Uri.with("right","Right-hand side resource of the diff editor"),m.$VP.String.with("title","Human readable title for the diff editor").optional(),new m.$VP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)]).optional()],m.$WP.Void),new m.$XP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$VP.String.with("title","Human readable title for the changes editor"),new m.$VP("resourceList","List of resources to compare",h=>{for(const g of h){if(g.length!==3)return!1;const[u,n,i]=g;if(!A.URI.isUri(u)||!A.URI.isUri(n)&&n!==void 0&&n!==null||!A.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],m.$WP.Void),new m.$XP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$VP.Uri,m.$VP.Position],new m.$WP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$XP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$VP.TypeHierarchyItem],new m.$WP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$XP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$VP.TypeHierarchyItem],new m.$WP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$XP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$VP.TestItem],m.$WP.Void),new m.$XP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$VP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$WP.Void),new m.$XP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$VP.String.with("name","The context key name"),new m.$VP("value","The context key value",()=>!0,h=>h)],m.$WP.Void),new m.$XP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$VP.Uri,m.$VP.StringArray,new m.$VP("MappedEditsContext","Mapped Edits Context",h=>E.MappedEditsContext.is(h),h=>E.MappedEditsContext.from(h))],new m.$WP("A promise that resolves to a workspace edit or null",h=>h?E.WorkspaceEdit.to(h):null))];class b{static register(g){P.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",$.$vj)}}e.$qlc=b;function k(h){return g=>{if(Array.isArray(g))return g.map(h)}}function p(h){if(!Array.isArray(h))return;const g=[];for(const u of h)R.$au(u)?g.push(E.DefinitionLink.to(u)):g.push(E.location.to(u));return g}}),define(ke[355],Se([1,0,7,3,2,6,34,16,8]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class E{constructor(k,p){this.extension=k,this.provider=p,this.handle=E.a++}}E.a=0;class I{constructor(k){this.session=k,this.responses=[]}}class P{constructor(k,p,h,g){this.f=h,this.g=g,this.b=new Map,this.d=new Map,this.e=k.getProxy(R.$0M.MainThreadInlineChat),p.registerApiCommand(new L.$XP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new L.$VP("Run arguments","",u=>!0,u=>{if(u)return{initialRange:u.initialRange?$.Range.from(u.initialRange):void 0,initialSelection:m.$cN.isSelection(u.initialSelection)?$.Selection.from(u.initialSelection):void 0,message:u.message,autoSend:u.autoSend,position:u.position?$.Position.from(u.position):void 0}})],L.$WP.Void))}registerProvider(k,p,h){const g=new E(k,p);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,h?.label??k.displayName??k.name,k.identifier,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",h?.supportReportIssue??!1),(0,N.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(k,p,h,g){const u=this.b.get(k);if(!u){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(A.URI.revive(p)),i=$.Selection.to(h),d=await u.provider.prepareInteractiveEditorSession({document:n,selection:i},g);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=P.a++;return this.d.set(o,new I(d)),{id:o,placeholder:d.placeholder,input:d.input,slashCommands:d.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:$.Range.from(d.wholeRange),message:d.message}}async $provideResponse(k,p,h,g){const u=this.b.get(k);if(!u)return;const n=this.d.get(p.id);if(!n)return;const i={prompt:h.prompt,selection:$.Selection.to(h.selection),wholeRange:$.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,previewDocument:this.f.getDocument(A.URI.revive(h.previewDocument)),withIntentDetection:h.withIntentDetection};let d=!1;const o={report:async y=>{if(!h.live&&y.edits?.length)throw new Error("Progress reporting is only supported for live sessions");d||g.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:y.message,edits:y.edits?.map($.TextEdit.from),editsShouldBeInstant:y.editsShouldBeInstant,slashCommand:y.slashCommand?.command,markdownFragment:m.$BN.isMarkdownString(y.content)?y.content.value:y.content})}},t=Promise.resolve(u.provider.provideInteractiveEditorResponse(n.session,i,o,g));let l;try{l=await(0,a.$kh)(t,g)}finally{d=!0}if(!l)return;const r=n.responses.push(l)-1,c={wholeRange:$.Range.from(l.wholeRange),placeholder:l.placeholder};if(!P.h(l))return{...c,id:r,type:"editorEdit",message:$.MarkdownString.from(l.contents),edits:[]};const{edits:s,contents:v}=l,f=v!==void 0?$.MarkdownString.from(v):void 0;return s instanceof m.$jN?{...c,id:r,type:"bulkEdit",edits:$.WorkspaceEdit.from(s),message:f}:{...c,id:r,type:"editorEdit",edits:s.map($.TextEdit.from),message:f}}async $provideFollowups(k,p,h,g){const u=this.b.get(k),n=this.d.get(p),i=n?.responses[h];if(u&&i&&u.provider.provideFollowups){const d=Promise.resolve(u.provider.provideFollowups(n.session,i,g));return(await(0,a.$kh)(d,g))?.map($.ChatInlineFollowup.from)}}$handleFeedback(k,p,h,g){const u=this.b.get(k),n=this.d.get(p),i=n?.responses[h];if(u&&i){const d=$.InteractiveEditorResponseFeedbackKind.to(g);u.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,d)}}$releaseSession(k,p){}static h(k){return typeof k=="object"&&typeof k.edits=="object"}}e.$zmc=P,P.a=0}),define(ke[356],Se([1,0,2,34]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class A{constructor(L,$,m,E,I){this.a=$,this.b=m,this.c=E;const P=new N.$XP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$VP("showOptions","Show Options",b=>!0,b=>b),new N.$VP("resource","Interactive resource Uri",b=>!0,b=>b),new N.$VP("controllerId","Notebook controller Id",b=>!0,b=>b),new N.$VP("title","Interactive editor title",b=>!0,b=>b)],new N.$WP("Notebook and input URI",b=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const k=this.a.getEditorById(b.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(b.notebookUri),inputUri:a.URI.revive(b.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:a.URI.revive(b.notebookUri),inputUri:a.URI.revive(b.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(L,$,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:m,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Mmc=A}),define(ke[357],Se([1,0,19,7,22,4,3,27,2,25,11,6,34,16,8,115,301,26,48,302]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0,e.$Umc=s;let d=class{constructor(f,y,w,D,S){this.m=y,this.n=w,this.o=D,this.q=S,this.b=new $.$Bc,this.c=new $.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(P.$0M.MainThreadNotebookKernels);const C=new b.$XP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$VP("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const z=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:z}}else if(B&&"notebookEditor"in B){const z=this.n.getIdByEditor(B.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return B})],b.$WP.Void),j=new b.$XP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[b.$VP.Uri],new b.$WP("A promise that resolves to an array of variables",(B,z)=>B.map(T=>({variable:{name:T.name,value:T.value,expression:T.expression,type:T.type,language:T.language},hasNamedChildren:T.hasNamedChildren,indexedChildrenCount:T.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(j)}createNotebookController(f,y,w,D,S,C){for(const ce of this.j.values())if(ce.controller.id===y&&E.$Sm.equals(f.identifier,ce.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const j=this.k++,B=this;this.q.trace(`NotebookController[${j}], CREATED by ${f.identifier.value}, ${y}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${f.identifier}'`);let T=!1;const M=new R.$ee,F=new R.$ee,O={id:s(f.identifier,y),notebookType:w,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:D||f.identifier.value,preloads:C?C.map(k.NotebookRendererScript.from):[]};let q=S??z,Y,V;this.a.$addKernel(j,O).catch(ce=>{console.log(ce),T=!0});let J=0;const x=()=>{if(T)return;const ce=++J;Promise.resolve().then(()=>{ce===J&&this.a.$updateKernel(j,O)})},ne=new $.$Bc,de={get id(){return y},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return O.label},set label(ce){O.label=ce??f.displayName??f.name,x()},get detail(){return O.detail??""},set detail(ce){O.detail=ce,x()},get description(){return O.description??""},set description(ce){O.description=ce,x()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ce){O.supportedLanguages=ce,x()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){O.supportsExecutionOrder=ce,x()},get rendererScripts(){return O.preloads?O.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ce){q=ce??z},get interruptHandler(){return Y},set interruptHandler(ce){Y=ce,O.supportsInterrupt=!!ce,x()},set variableProvider(ce){(0,u.$PG)(f,"notebookVariableProvider"),V=ce,O.hasVariableProvider=!!ce,ce?.onDidChangeVariables(ve=>B.a.$variablesUpdated(ve.uri)),x()},get variableProvider(){return V},createNotebookCellExecution(ce){if(T)throw new Error("notebook controller is DISPOSED");if(!ne.has(ce.notebook.uri))throw B.q.trace(`NotebookController[${j}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return B._createNotebookCellExecution(ce,s(f.identifier,this.id))},createNotebookExecution(ce){if((0,u.$PG)(f,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!ne.has(ce.uri))throw B.q.trace(`NotebookController[${j}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.uri.toString()}`);return B._createNotebookExecution(ce,s(f.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${j}], DISPOSED`),T=!0,this.j.delete(j),M.dispose(),F.dispose(),this.a.$removeKernel(j))},updateNotebookAffinity(ce,ve){ve===p.NotebookControllerAffinity2.Hidden&&(0,u.$PG)(f,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(j,ce.uri,ve)},onDidReceiveMessage:F.event,postMessage(ce,ve){return(0,u.$PG)(f,"notebookMessaging"),B.a.$postMessage(j,ve&&B.n.getIdByEditor(ve),ce)},asWebviewUri(ce){return(0,u.$PG)(f,"notebookMessaging"),(0,h.$1Ab)(ce,B.m.remote)}};return this.j.set(j,{extensionId:f.identifier,controller:de,onDidReceiveMessage:F,onDidChangeSelection:M,associatedNotebooks:ne}),de}getIdByController(f){for(const[y,w]of this.j)if(w.controller===f)return s(w.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,y){const w=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(w,y);const S={dispose:()=>{this.f.delete(w),D.a.$removeKernelDetectionTask(w)}};return this.f.set(w,S),S}registerKernelSourceActionProvider(f,y,w){const D=this.i++,S=typeof w.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,w),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,y);let j;return S!==void 0&&(j=w.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),j?.dispose()}}}async $provideKernelSourceActions(f,y){const w=this.h.get(f);if(w){const D=new L.$Uc;return(await w.provideNotebookKernelSourceActions(y)??[]).map(C=>k.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(f,y,w){const D=this.j.get(f);if(D){const S=this.n.getNotebookDocument(m.URI.revive(y));w?D.associatedNotebooks.set(S.uri,!0):D.associatedNotebooks.delete(S.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,S.uri.toString(),w),D.onDidChangeSelection.fire({selected:w,notebook:S.apiNotebook})}}async $executeCells(f,y,w){const D=this.j.get(f);if(!D)return;const S=this.n.getNotebookDocument(m.URI.revive(y)),C=[];for(const j of w){const B=S.getCell(j);B&&C.push(B.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,S.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,S.apiNotebook,D.controller)}catch(j){this.q.error(`NotebookController[${f}] execute cells FAILED`,j),console.error(j)}}async $cancelCells(f,y,w){const D=this.j.get(f);if(!D)return;const S=this.n.getNotebookDocument(m.URI.revive(y));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,S.apiNotebook);else for(const C of w){const j=S.getCell(C);j&&this.b.get(j.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(S.uri);w.length&&Array.isArray(C)&&C.length&&C.forEach(j=>j.dispose())}}async $provideVariables(f,y,w,D,S,C,j){const B=this.j.get(f);if(!B)return;const z=this.n.getNotebookDocument(m.URI.revive(w)),T=B.controller.variableProvider;if(!T)return;let M;if(D!==void 0){if(M=this.s[D],!M)return}else this.s={};const F=S==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,O=T.provideVariables(z.apiNotebook,M,F,C,j);let q=0;for await(const Y of O){if(j.isCancellationRequested)return;const V={id:this.r++,name:Y.variable.name,value:Y.variable.value,type:Y.variable.type,interfaces:Y.variable.interfaces,language:Y.variable.language,expression:Y.variable.expression,hasNamedChildren:Y.hasNamedChildren,indexedChildrenCount:Y.indexedChildrenCount,extensionId:B.extensionId.value};if(this.s[V.id]=Y.variable,this.a.$receiveVariable(y,V),q++>=i.$ljb)return}}$acceptKernelMessageFromRenderer(f,y,w){const D=this.j.get(f);if(!D)return;const S=this.n.getEditorById(y);D.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:w}))}$cellExecutionChanged(f,y,w){const S=this.n.getNotebookDocument(m.URI.revive(f)).getCell(y);if(S){const C=w?k.NotebookCellExecutionState.to(w):p.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:S.apiCell,state:C})}}_createNotebookCellExecution(f,y){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const S=new t(y,D,this.a);this.b.set(D.uri,S);const C=S.onDidChangeState(()=>{S.state===o.Resolved&&(S.dispose(),C.dispose(),this.b.delete(D.uri))});return S.asApiObject()}_createNotebookExecution(f,y){const w=this.n.getNotebookDocument(f.uri),D=f.getCells().find(j=>{const B=w.getCellFromApiCell(j);return B&&this.b.has(B.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const S=new r(y,w,this.a),C=S.onDidChangeState(()=>{S.state===l.Resolved&&(S.dispose(),C.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[S,C]),S.asApiObject()}};e.$Tmc=d,e.$Tmc=d=Je([Ue(4,I.$3j)],d);var o;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(o||(o={}));class t extends L.$Vc{get state(){return this.f}constructor(f,y,w){super(),this.m=y,this.n=w,this.b=t.a++,this.c=new R.$ee,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new A.$pe),this.h=new c(10,D=>this.s(D)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const y=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Cw(y))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let y=this.m;if(f&&(y=this.m.notebook.getCellFromApiCell(f)),!y)throw new Error("INVALID cell");return y.handle}y(f){return f.map(y=>{const w=p.$FO.ensureUniqueMimeTypes(y.items,!0);return w===y.items?k.NotebookCellOutput.from(y):k.NotebookCellOutput.from({items:w,id:y.id,metadata:y.metadata})})}async z(f,y,w){const D=this.w(y),S=this.y((0,a.$3b)(f));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:D,append:w,outputs:S})}async C(f,y,w){return f=p.$FO.ensureUniqueMimeTypes((0,a.$3b)(f),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:f.map(k.NotebookCellOutputItem.from),outputId:y.id,append:w})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(w){f.j=w,f.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(w){if(f.f===o.Resolved||f.f===o.Started)throw new Error("Cannot call start again");f.f=o.Started,f.c.fire(),f.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,D,S){if(f.f===o.Resolved)throw new Error("Cannot call resolve twice");f.f=o.Resolved,f.c.fire(),f.h.flush();const C=S?{message:S.message,stack:S.stack,location:S?.location?{startLineNumber:S.location.start.line,startColumn:S.location.start.character,endLineNumber:S.location.end.line,endColumn:S.location.end.character}:void 0,uri:S.uri}:void 0;f.n.$completeExecution(f.b,new n.$Cw({runEndTime:D,lastRunSuccess:w,error:C}))},clearOutput(w){return f.t(),f.z([],w,!1)},appendOutput(w,D){return f.t(),f.z(w,D,!0)},replaceOutput(w,D){return f.t(),f.z(w,D,!1)},appendOutputItems(w,D){return f.t(),f.C(w,D,!0)},replaceOutputItems(w,D){return f.t(),f.C(w,D,!1)}})}}t.a=0;var l;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(l||(l={}));class r extends L.$Vc{get state(){return this.f}constructor(f,y,w){super(),this.h=y,this.j=w,this.b=r.a++,this.c=new R.$ee,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new A.$pe),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}r.a=0;class c{constructor(f,y){this.f=f,this.g=y,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new N.$Th,this.b=Date.now(),(0,N.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>f.complete())}}function s(v,f){return`${v.value}/${f}`}}),define(ke[44],Se([1,0,4,6,5,2,20,3,8,232,13,279,22,31,280,51,7,16,34]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=e.$6lc=e.$5lc=void 0,e.$5lc=(0,A.$wi)("IExtHostTerminalService");class i extends $.$Vc{constructor(w,D,S,C){super(),this.u=w,this._id=D,this.w=S,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new a.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(B=>this.g=B);const j=this;this.value={get name(){return j.y||""},get processId(){return j.b},get creationOptions(){return j.w},get exitStatus(){return j.j},get state(){return j.m},get selection(){return j.n},get shellIntegration(){return j.shellIntegration},sendText(B,z=!0){j.C(),j.u.$sendText(j._id,B,z)},show(B){j.C(),j.u.$show(j._id,B)},hide(){j.C(),j.u.$hide(j._id)},dispose(){j.a||(j.a=!0,j.u.$dispose(j._id))},get dimensions(){if(!(j.f===void 0||j.h===void 0))return{columns:j.f,rows:j.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??D?.cwd??void 0,env:w.env??void 0,icon:s(w.iconPath)??void 0,color:h.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(w.location,D?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,D,S,C,j){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:h.ThemeColor.isThemeColor(j)?j.id:void 0,location:D?.location||this.z(w,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,D){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in w?{viewColumn:u.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,D){this.j=Object.freeze({code:w,reason:D})}setDimensions(w,D){return w===this.f&&D===this.h||w===0||D===0?!1:(this.f=w,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(D=>{D!==w&&(this.b=Promise.resolve(w))})}}e.$6lc=i;class d{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new a.$ee,this.onProcessData=this.a.event,this.b=new a.$ee,this.d=new a.$ee,this.onDidChangeProperty=this.d.event,this.f=new a.$ee,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,D){this.g.setDimensions?.({columns:w,rows:D})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends $.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,D,S){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new a.$ee,this.onDidCloseTerminal=this.H.event,this.I=new a.$ee,this.onDidOpenTerminal=this.I.event,this.J=new a.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new a.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new a.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new a.$ee,this.onDidChangeShell=this.N.event,this.O=new a.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new a.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(N.$0M.MainThreadTerminalService),this.y=new p.$Svb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:C=>{const j=B=>{const z=B;return this.getTerminalById(z.instanceId)?.value};switch(C?.$mid){case 15:return j(C);default:{if(Array.isArray(C))for(let B=0;B<C.length&&C[B].$mid===15;B++)C[B]=j(C[B]);return C}}}}),this.B({dispose:()=>{for(const[C,j]of this.g)j.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,D){const S=new i(this.a,(0,k.$Sg)(),w,w.name),C=new d(w.pty);return S.createExtensionTerminal(w.location,D,this.R(w,D).resolvedExtHostIdentifier,s(w.iconPath),v(w.color)).then(j=>{const B=this.S(j,C);this.h[j]=B}),this.f.push(S),S.value}R(w,D){if(D=D||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const S=w.location.parentTerminal;if(S){const C=this.f.find(j=>j.value===S);C&&(D.resolvedExtHostIdentifier=C._id)}}else w.location&&typeof w.location!="object"?D.location=w.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(w,D){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const C=new d(D),j=this.S(w,C);this.h[w]=j}async $acceptActiveTerminalChanged(w){const D=this.b;if(w===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const S=this.getTerminalById(w);S&&(this.b=S,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,D){const S=this.getTerminalById(w);S&&this.O.fire({terminal:S.value,data:D})}async $acceptTerminalDimensions(w,D,S){const C=this.getTerminalById(w);C&&C.setDimensions(D,S)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(w,D){const S=this.getTerminalById(w);S&&this.P.fire({terminal:S.value,...D})}async $acceptTerminalMaximumDimensions(w,D,S){this.g.get(w)?.resize(D,S)}async $acceptTerminalTitleChange(w,D){const S=this.getTerminalById(w);S&&(S.name=D)}async $acceptTerminalClosed(w,D,S){const C=this.X(this.f,w);if(C!==null){const j=this.f.splice(C,1)[0];j.setExitStatus(D,S),this.H.fire(j.value)}}$acceptTerminalOpened(w,D,S,C){if(D){const z=this.X(this.f,D);if(z!==null){this.f[z]._id=w,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const j={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},B=new i(this.a,w,j,S);this.f.push(B),this.I.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(w,D){this.getTerminalById(w)?._setProcessId(D)}async $startExtensionTerminal(w,D){const S=this.getTerminalById(w);if(!S)return{message:(0,E.localize)(0,null,w)};S.isOpen||await new Promise(j=>{const B=this.onDidOpenTerminal(async z=>{z===S.value&&(B.dispose(),j())})});const C=this.g.get(w);C?C.startSendingEvents(D):this.j[w]={initialDimensions:D}}S(w,D){const S=new $.$Uc;S.add(D.onProcessReady(j=>this.a.$sendProcessReady(w,j.pid,j.cwd,j.windowsPty))),S.add(D.onDidChangeProperty(j=>this.a.$sendProcessProperty(w,j))),this.y.startBuffering(w,D.onProcessData),S.add(D.onProcessExit(j=>this.U(w,j))),this.g.set(w,D);const C=this.j[w];return C&&D instanceof d&&(D.startSendingEvents(C.initialDimensions),delete this.j[w]),S}$acceptProcessAckDataEvent(w,D){this.g.get(w)?.acknowledgeDataEvent(D)}$acceptProcessInput(w,D){this.g.get(w)?.input(D)}$acceptTerminalInteraction(w){const D=this.getTerminalById(w);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(w,D){this.getTerminalById(w)?.setSelection(D)}$acceptProcessResize(w,D,S){try{this.g.get(w)?.resize(D,S)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(w,D){this.g.get(w)?.shutdown(D)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(D=>this.a.$sendProcessProperty(w,{type:"cwd",value:D}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new m.$_M(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,D,S){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,S),this.a.$registerProfileProvider(D,w.identifier.value),new m.$_M(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(w,D,S){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,S),this.a.$registerQuickFixProvider(w,D),new m.$_M(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,D){const S=new b.$pe().token;if(S.isCancellationRequested)return;const C=this.D.get(w);if(!C)return;const j=await C.provideTerminalQuickFixes(D,S);if(j===null||Array.isArray(j)&&j.length===0)return;const B=new $.$Uc;if(this.w.value=B,!Array.isArray(j))return j?u.TerminalQuickFix.from(j,this.Q.converter,B):void 0;const z=[];for(const T of j){const M=u.TerminalQuickFix.from(T,this.Q.converter,B);M&&z.push(M)}return z}async $createContributedProfileTerminal(w,D){const S=new b.$pe().token;let C=await this.C.get(w)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks(w,D){const S=this.getTerminalById(w);if(!S)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const j=new b.$pe;this.G.set(w,j);const B=[],z={terminal:S.value,line:D},T=[];for(const O of this.z)T.push(g.Promises.withAsyncBody(async q=>{j.token.onCancellationRequested(()=>q({provider:O,links:[]}));const Y=await O.provideTerminalLinks(z,j.token)||[];j.token.isCancellationRequested||q({provider:O,links:Y})}));const M=await Promise.all(T);if(j.token.isCancellationRequested)return[];const F=new Map;for(const O of M)O&&O.links.length>0&&B.push(...O.links.map(q=>{const Y={id:o++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return F.set(Y.id,{provider:O.provider,link:q}),Y}));return this.F.set(w,F),B}$activateLink(w,D){const S=this.F.get(w)?.get(D);S&&S.provider.handleTerminalLink(S.link)}U(w,D){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const S=this.h[w];S&&(S.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,D)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const D=this.f.findIndex(S=>S.value===w);return D>=0?D:null}W(w,D){const S=this.X(w,D);return S!==null?w[S]:null}X(w,D){const S=w.findIndex(C=>C._id===D);return S>=0?S:null}getEnvironmentVariableCollection(w){let D=this.n.get(w.identifier.value);return D||(D=new l,this.Z(w.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(w,D){const S=(0,P.$ms)(D.map),C=(0,P.$ns)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(w,D.persistent,S.length===0?void 0:S,C)}$initEnvironmentVariableCollections(w){w.forEach(D=>{const S=D[0],C=new l(D[1]);this.Z(S,C)})}$acceptDefaultProfile(w,D){const S=this.s;this.s=w,this.u=D,S?.path!==w.path&&this.N.fire(w.path)}Z(w,D){this.n.set(w,D),D.onDidChangeCollection(()=>{this.Y(w,D)})}};e.$7lc=t,e.$7lc=t=Je([Ue(1,n.$TP),Ue(2,L.$xP)],t);class l{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new a.$ee,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const D=this.h(w);let S=this.a.get(D);return S||(S=new r(this,w),this.a.set(D,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(w,D,S,C){this.f(w,{value:D,type:m.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:C})}append(w,D,S,C){this.f(w,{value:D,type:m.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:C})}prepend(w,D,S,C){this.f(w,{value:D,type:m.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:C})}f(w,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(w,D.scope),C=this.map.get(S),j=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==j.applyAtProcessCreation||C.options?.applyAtShellIntegration!==j.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const B=this.g(w,D.scope),z={variable:w,...D,options:j};this.map.set(B,z),this.d.fire()}}get(w,D){const S=this.g(w,D),C=this.map.get(S);return C?f(C):void 0}g(w,D){const S=this.h(D);return S.length?`${w}:::${S}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const D=new Map;for(const[S,C]of this.map)this.h(C.scope)===this.h(w)&&D.set(C.variable,f(C));return D}delete(w,D){const S=this.g(w,D);this.map.delete(S),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[D,S]of this.map)S.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(D);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,D){const S=this.h(D),C=this.descriptionMap.get(S);if(!C||C.description!==w){let j;typeof w=="string"?j=w:j=w?.value.split(`

`)[0];const B={description:j,scope:D};this.descriptionMap.set(S,B),this.d.fire()}}getDescription(w){const D=this.h(w);return this.descriptionMap.get(D)?.description}k(w){const D=this.h(w);this.descriptionMap.delete(D)}}class r{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,D){this.b=w,this.d=D,this.a=new a.$ee}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,D,S){this.b.replace(w,D,S,this.d)}append(w,D,S){this.b.append(w,D,S,this.d)}prepend(w,D,S){this.b.prepend(w,D,S,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,D){this.b.getVariableMap(this.d).forEach((S,C)=>w.call(D,C,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(w,D){super(!1,w,D)}createTerminal(w,D,S){throw new I.$_}createTerminalFromOptions(w,D){throw new I.$_}};e.$8lc=c,e.$8lc=c=Je([Ue(0,n.$TP),Ue(1,L.$xP)],c);function s(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function v(y){return h.ThemeColor.isThemeColor(y)?y:void 0}function f(y){const w={...y};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ke[157],Se([1,0,8,3,5,6,20,44,4,2,7]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,A.$wi)("IExtHostTerminalShellIntegration");let P=class extends N.$Vc{constructor(g,u){super(),this.h=u,this.b=new Map,this.c=new m.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$0M.MainThreadTerminalShellIntegration),this.B((0,N.$Tc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(g){const u=this.h.getTerminalById(g);if(!u)return;const n=u.value;let i=this.b.get(g);i||(i=new b(u.value,this.f),this.b.set(g,i),i.store.add(u.onWillDispose(()=>this.b.get(g)?.dispose())),i.store.add(i.onDidRequestShellExecution(d=>this.a.$executeCommand(g,d))),i.store.add(i.onDidRequestEndExecution(d=>this.g.fire(d))),i.store.add(i.onDidRequestChangeShellIntegration(d=>this.c.fire(d))),u.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(g,u,n,i,d){this.b.has(g)||this.$shellIntegrationChange(g);const o={value:u,confidence:n,isTrusted:i};this.b.get(g)?.startShellExecution(o,d)}$shellExecutionEnd(g,u,n,i,d){const o={value:u,confidence:n,isTrusted:i};this.b.get(g)?.endShellExecution(o,d)}$shellExecutionData(g,u){this.b.get(g)?.emitData(u)}$cwdChange(g,u){this.b.get(g)?.setCwd((0,E.$wc)(u)?E.URI.revive(u):u)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$anc=P,e.$anc=P=Je([Ue(0,L.$xP),Ue(1,$.$5lc)],P);class b extends N.$Vc{get currentExecution(){return this.a}constructor(g,u){super(),this.j=g,this.m=u,this.b=!1,this.store=this.B(new N.$Uc),this.f=this.B(new m.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$ee),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,d){let o=i;d&&(o+=` "${d.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(o);const t={value:o,confidence:a.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=n.startShellExecution(t,n.c,!0).value;return n.b=!0,l}}}startShellExecution(g,u,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new k(g,u);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,u){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:u}),this.a=void 0)}setCwd(g){let u=!1;E.URI.isUri(this.c)?u=!E.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(u=!0),u&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(g,u){this.c=g,this.cwd=u,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return I.$Wh.EMPTY;this.a=new p}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class p extends N.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$vh);const g=this.a;return new I.$Wh(async n=>{this.b.push(n),await g.wait()})}emitData(g){for(const u of this.b)u.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}});var qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)},it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a};define(ke[358],Se([1,0,7,21,22,4,75,57,3,18,31,11,6,20,156,16,8,69,114,89]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i){"use strict";var d,o,t,l,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=e.$cnc=e.$bnc=void 0;let c=class extends m.$Vc{constructor(F,O,q,Y){super(),this.w=Y,this.f=this.B(new R.$ee),this.g=new Map,this.s=this.B(new R.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(b.$0M.MainThreadTesting),this.m=new j(this.h),this.j=new y(this.h,O),q.registerArgumentProcessor({processArgument:V=>{switch(V?.$mid){case 16:{const J=V,x=J.tests[J.tests.length-1].item.extId;return this.g.get(u.$VL.root(x))?.collection.tree.get(x)?.actual??(0,p.$JP)(V)}case 18:{const{test:J,message:x}=V,ne=J.item.extId;return{test:this.g.get(u.$VL.root(ne))?.collection.tree.get(ne)?.actual??(0,p.$JP)({$mid:16,tests:[J]}),message:h.TestMessage.to(x)}}default:return V}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const V=await q.executeCommand("_testing.getExplorerSelection"),J=x=>{const ne=this.g.get(u.$VL.root(x));if(ne)return u.$VL.isRoot(x)?ne.controller:ne.collection.tree.get(x)?.actual};return{include:V?.include.map(J).filter(E.$eg)||[],exclude:V?.exclude.map(J).filter(E.$eg)||[]}})}createTestController(F,O,q,Y){if(this.g.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const V=new m.$Uc,J=V.add(new p.$MP(O,q,this.w));J.root.label=q;const x=new Map,ne=new Set,de=this.h,ce={items:J.root.children,get label(){return q},set label(_){q=_,J.root.label=_,de.$updateController(O,{label:q})},get refreshHandler(){return Y},set refreshHandler(_){Y=_,de.$updateController(O,{canRefresh:!!_})},get id(){return O},createRunProfile:(_,U,le,De,$e,re)=>{let se=(0,$.$kj)(_);for(;x.has(se);)se++;return new z(this.h,x,ne,this.s.event,O,se,_,U,le,De,$e,re)},createTestItem(_,U,le){return new p.$KP(O,_,U,le)},createTestRun:(_,U,le=!0)=>this.j.createTestRun(O,J,_,U,le),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const U=_ instanceof Array?_:[_];this.h.$markTestRetired(U.map(le=>u.$VL.fromExtHostTestItem(le,O).toString()))}},set resolveHandler(_){J.resolveHandler=_},get resolveHandler(){return J.resolveHandler},dispose:()=>{V.dispose()}};de.$registerTestController(O,q,!!Y),V.add((0,m.$Tc)(()=>de.$unregisterTestController(O)));const ve={controller:ce,collection:J,profiles:x,extension:F,activeProfiles:ne};return this.g.set(O,ve),V.add((0,m.$Tc)(()=>this.g.delete(O))),V.add(J.onDidGenerateDiff(_=>de.$publishDiff(O,_.map(i.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.m.checkout()}async runTests(F,O=A.CancellationToken.None){const q=w(F);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const Y=this.g.get(q.controllerId);if(!Y)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:F.preserveFocus??!0,targets:[{testIds:F.include?.map(V=>u.$VL.fromExtHostTestItem(V,Y.collection.root.id).toString())??[Y.collection.root.id],profileGroup:T[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:F.exclude?.map(V=>V.id)},O)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,O){return(await this.j.getCoverageDetails(F,O))?.map(h.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,O){this.g.get(F)?.profiles.get(O)?.configureHandler?.()}$setDefaultRunProfiles(F){const O=new Map;for(const[q,Y]of Object.entries(F)){const V=this.g.get(q);if(!V)continue;const J=new Map,x=Y.filter(de=>!V.activeProfiles.has(de)),ne=[...V.activeProfiles].filter(de=>!Y.includes(de));for(const de of x)J.set(de,!0),V.activeProfiles.add(de);for(const de of ne)J.set(de,!1),V.activeProfiles.delete(de);J.size&&O.set(q,J)}this.s.fire(O)}async $refreshTests(F,O){await this.g.get(F)?.controller.refreshHandler?.(O)}$publishTestResults(F){this.results=Object.freeze(F.map(h.TestResults.to).concat(this.results).sort((O,q)=>q.completedAt-O.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,O){const q=this.g.get(u.$VL.fromString(F).controllerId)?.collection;q&&(await q.expand(F,O<0?1/0:O),q.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(O=>i.TestsDiffOp.deserialize({asCanonicalUri:q=>q},O)))}async $runControllerTests(F,O){return Promise.all(F.map(q=>this.y(q,!1,O)))}async $startContinuousRun(F,O){const q=new A.$pe(O),Y=await Promise.all(F.map(V=>this.y(V,!0,q.token)));return!O.isCancellationRequested&&!Y.some(V=>V.error)&&await new Promise(V=>O.onCancellationRequested(V)),q.dispose(!0),Y}async y(F,O,q){const Y=this.g.get(F.controllerId);if(!Y)return{};const{collection:V,profiles:J}=Y,x=J.get(F.profileId);if(!x)return{};const ne=F.testIds.map(_=>V.tree.get(_)).filter(E.$eg),de=F.excludeExtIds.map(_=>Y.collection.tree.get(_)).filter(E.$eg).filter(_=>ne.some(U=>U.fullId.compare(_.fullId)===2));if(!ne.length)return{};const ce=new g.$MO(ne.some(_=>_.actual instanceof p.$LP)?void 0:ne.map(_=>_.actual),de.map(_=>_.actual),x,O),ve=(0,i.$YL)(F)&&this.j.prepareForMainThreadTestRun(ce,D.fromInternal(F,Y.collection),x,q);try{return await x.runHandler(ce,q),{}}catch(_){return{error:String(_)}}finally{ve&&ve.hasRunningTasks&&!q.isCancellationRequested&&await R.Event.toPromise(ve.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$bnc=c,e.$bnc=c=Je([Ue(0,k.$xP),Ue(1,P.$3j)],c);const s=1e4;var v;(function(M){M[M.Running=0]="Running",M[M.Cancelling=1]="Cancelling",M[M.Ended=2]="Ended"})(v||(v={}));class f extends m.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(F,O,q,Y,V){super(),this.y=F,this.z=O,this.C=q,this.D=Y,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$pe(V));const J=this.B(new a.$Ih(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>J.schedule()));const x=new R.$ee;this.s=x.event,this.B((0,m.$Tc)(()=>{x.fire(),x.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(F,O){const[,q,Y]=u.$VL.fromString(F).path,V=this.w.get(Y);if(!V)return[];const J=this.g.get(q);if(!J)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(J.run,V,O)??[]}createRun(F){const O=this.y.id,q=this.y.controllerId,Y=(0,I.$Sg)(),V=de=>(ce,...ve)=>{if(x){this.C.warn(`Setting the state of test "${ce.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ce)&&(this.H(ce),de(ce,...ve))},J=(de,ce)=>{const ve=ce instanceof Array?ce.map(h.TestMessage.from):[h.TestMessage.from(ce)];if(de.uri&&de.range){const _={range:h.Range.from(de.range),uri:de.uri};for(const U of ve)U.location=U.location||_}this.z.$appendTestMessagesInRun(O,Y,u.$VL.fromExtHostTestItem(de,q).toString(),ve)};let x=!1;const ne={isPersisted:this.y.isPersisted,token:this.j.token,name:F,onDidDispose:this.s,addCoverage:de=>{const ce=de.uri.toString(),ve=new u.$VL([O,Y,ce]).toString();this.w.set(ce,de),this.z.$appendCoverage(O,Y,h.TestCoverage.fromFile(ve,de))},enqueued:V(de=>{this.z.$updateTestStateInRun(O,Y,u.$VL.fromExtHostTestItem(de,q).toString(),1)}),skipped:V(de=>{this.z.$updateTestStateInRun(O,Y,u.$VL.fromExtHostTestItem(de,q).toString(),5)}),started:V(de=>{this.z.$updateTestStateInRun(O,Y,u.$VL.fromExtHostTestItem(de,q).toString(),2)}),errored:V((de,ce,ve)=>{J(de,ce),this.z.$updateTestStateInRun(O,Y,u.$VL.fromExtHostTestItem(de,q).toString(),6,ve)}),failed:V((de,ce,ve)=>{J(de,ce),this.z.$updateTestStateInRun(O,Y,u.$VL.fromExtHostTestItem(de,q).toString(),4,ve)}),passed:V((de,ce)=>{this.z.$updateTestStateInRun(O,Y,u.$VL.fromExtHostTestItem(de,this.y.controllerId).toString(),3,ce)}),appendOutput:(de,ce,ve)=>{x||(ve&&(this.y.isIncluded(ve)?this.H(ve):ve=void 0),this.z.$appendOutputToRun(O,Y,N.$Ge.fromString(de),ce&&h.location.from(ce),ve&&u.$VL.fromExtHostTestItem(ve,q).toString()))},end:()=>{x||(x=!0,this.z.$finishedTestRunTask(O,Y),--this.f||this.G())}};return this.f++,this.g.set(Y,{run:ne}),this.z.$startedTestRunTask(O,{id:Y,name:F,running:!0}),ne}F(){for(const{run:F}of this.g.values())F.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(F){if(!(F instanceof p.$KP))throw new n.$pP(F.id);if(this.h.has(u.$VL.fromExtHostTestItem(F,this.y.controllerId).toString()))return;const O=[],q=this.y.colllection.root;for(;;){const Y=h.TestItem.from(F);if(O.unshift(Y),this.h.has(Y.extId)||(this.h.add(Y.extId),F===q))break;F=F.parent||q}this.z.$addTestsToRun(this.y.controllerId,this.y.id,O)}dispose(){this.G(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(F,O){this.g=F,this.h=O,this.c=new Map,this.f=new Map}getCoverageDetails(F,O){const q=u.$VL.root(F);return this.f.get(q)?.getCoverageDetails(F,O)||[]}disposeTestRun(F){this.f.get(F)?.dispose(),this.f.delete(F);for(const[O,{id:q}]of this.c)q===F&&this.c.delete(O)}prepareForMainThreadTestRun(F,O,q,Y){return this.j(F,O,q,Y)}cancelRunById(F){this.f.get(F)?.cancel()}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,O,q,Y,V){const J=this.c.get(q);if(J)return J.createRun(Y);const x=D.fromPublic(F,O,q,V),ne=w(q);this.g.$startedExtensionTestRun({controllerId:F,continuous:!!q.continuous,profile:ne&&{group:T[ne.kind],id:ne.profileId},exclude:q.exclude?.map(ce=>u.$VL.fromExtHostTestItem(ce,O.root.id).toString())??[],id:x.id,include:q.include?.map(ce=>u.$VL.fromExtHostTestItem(ce,O.root.id).toString())??[O.root.id],preserveFocus:q.preserveFocus??!0,persist:V});const de=this.j(q,x,q.profile);return R.Event.once(de.onEnd)(()=>{this.g.$finishedExtensionTestRun(x.id)}),de.createRun(Y)}j(F,O,q,Y){const V=new f(O,this.g,this.h,q,Y);return this.c.set(F,V),this.f.set(V.id,V),V}}e.$cnc=y;const w=M=>{if(M.profile){if(!(M.profile instanceof z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class D{static fromPublic(F,O,q,Y){return new D(F,(0,I.$Sg)(),q.include?.map(V=>u.$VL.fromExtHostTestItem(V,F).toString())??[F],q.exclude?.map(V=>u.$VL.fromExtHostTestItem(V,F).toString())??[],Y,O)}static fromInternal(F,O){return new D(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,O)}constructor(F,O,q,Y,V,J){this.controllerId=F,this.id=O,this.isPersisted=V,this.colllection=J,this.c=q.map(x=>x+"\0"),this.f=Y.map(x=>x+"\0")}isIncluded(F){const O=u.$VL.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const q of this.f)if(O===q||O.startsWith(q))return!1;for(const q of this.c)if(O===q||O.startsWith(q))return!0;return!1}}e.$dnc=D;class S{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,h.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const O=u.$VL.parentId(F.item.extId);if(O&&this.h.has(O.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:O,g:q}=this;return{get added(){return[...F].map(Y=>Y.revived)},get updated(){return[...O].map(Y=>Y.revived)},get removed(){return[...q].map(Y=>Y.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class C extends i.$5L{constructor(){super(...arguments),this.s=new R.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,O){return{...F,revived:h.TestItem.toPlain(F.item),depth:O?O.depth+1:0,children:new Set}}v(){return new S(this.s)}}class j{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(O=>O.revived)},dispose:(0,L.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new C({asCanonicalUri:O=>O});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const B=(M,F,O,q)=>{O?Object.assign(O,q):F.$updateTestRunConfig(M.controllerId,M.profileId,q)};class z{get label(){return this.f}set label(F){F!==this.f&&(this.f=F,B(this,qe(this,d,"f"),qe(this,l,"f"),{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,B(this,qe(this,d,"f"),qe(this,l,"f"),{supportsContinuousRun:F}))}get isDefault(){return qe(this,o,"f").has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?qe(this,o,"f").add(this.profileId):qe(this,o,"f").delete(this.profileId),B(this,qe(this,d,"f"),qe(this,l,"f"),{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,B(this,qe(this,d,"f"),qe(this,l,"f"),{tag:F?h.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,B(this,qe(this,d,"f"),qe(this,l,"f"),{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return R.Event.chain(qe(this,t,"f"),F=>F.map(O=>O.get(this.controllerId)?.get(this.profileId)).filter(E.$eg))}constructor(F,O,q,Y,V,J,x,ne,de,ce=!1,ve=void 0,_=!1){this.controllerId=V,this.profileId=J,this.f=x,this.kind=ne,this.runHandler=de,this._tag=ve,this.g=_,d.set(this,void 0),o.set(this,void 0),t.set(this,void 0),l.set(this,void 0),r.set(this,void 0),it(this,d,F,"f"),it(this,r,O,"f"),it(this,o,q,"f"),it(this,t,Y,"f"),O.set(J,this);const U=T[ne];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${ne}`);ce&&q.add(J),it(this,l,{profileId:J,controllerId:V,tag:ve?h.TestTag.namespace(this.controllerId,ve.id):null,label:x,group:U,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:_},"f"),queueMicrotask(()=>{qe(this,l,"f")&&(qe(this,d,"f").$publishTestRunProfile(qe(this,l,"f")),it(this,l,void 0,"f"))})}dispose(){qe(this,r,"f")?.delete(this.profileId)&&(it(this,r,void 0,"f"),qe(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)),it(this,l,void 0,"f")}}e.$enc=z,d=new WeakMap,o=new WeakMap,t=new WeakMap,l=new WeakMap,r=new WeakMap;const T={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ke[158],Se([1,0,62,13,126,16,8]),function(ie,e,a,N,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.$FP=e.$EP=void 0;class ${constructor(b,k,p){const h=$.c.nextId();b.$registerTextEditorDecorationType(k.identifier,h,R.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:h,dispose(){b.$removeTextEditorDecorationType(h)}})}}e.$EP=$,$.c=new A.$CP("TextEditorDecorationType");class m{constructor(b,k){this.g=[],this.h=void 0,this.j=!1,this.c=b,this.d=b.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(b,k){this.k();let p=null;if(b instanceof L.$aN)p=new L.$bN(b,b);else if(b instanceof L.$bN)p=b;else throw new Error("Unrecognized location");this.l(p,k,!1)}insert(b,k){this.k(),this.l(new L.$bN(b,b),k,!0)}delete(b){this.k();let k=null;if(b instanceof L.$bN)k=b;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(b,k,p){const h=this.c.validateRange(b);this.g.push({range:h,text:k,forceMoveMarkers:p})}setEndOfLine(b){if(this.k(),b!==L.EndOfLine.LF&&b!==L.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=b}}class E{constructor(b,k,p,h){this.c=b,this.d=k,this._accept(p),this.e=h;const g=this;this.value={get tabSize(){return g.f},set tabSize(u){g.n(u)},get indentSize(){return g.g},set indentSize(u){g.p(u)},get insertSpaces(){return g.j},set insertSpaces(u){g.s(u)},get cursorStyle(){return g.k},set cursorStyle(u){g.t(u)},get lineNumbers(){return g.l},set lineNumbers(u){g.u(u)}}}_accept(b){this.f=b.tabSize,this.g=b.indentSize,this.h=b.originalIndentSize,this.j=b.insertSpaces,this.k=b.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(b.lineNumbers)}m(b){if(b==="auto")return"auto";if(typeof b=="number"){const k=Math.floor(b);return k>0?k:null}if(typeof b=="string"){const k=parseInt(b,10);return isNaN(k)?null:k>0?k:null}return null}n(b){const k=this.m(b);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const k=Math.floor(b);return k>0?k:null}if(typeof b=="string"){const k=parseInt(b,10);return isNaN(k)?null:k>0?k:null}return null}p(b){const k=this.o(b);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(b){return b==="auto"?"auto":b==="false"?!1:!!b}s(b){const k=this.q(b);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(b){this.k!==b&&(this.k=b,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:b})))}u(b){this.l!==b&&(this.l=b,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(b)})))}assign(b){const k={};let p=!1;if(typeof b.tabSize<"u"){const h=this.m(b.tabSize);h==="auto"?(p=!0,k.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,p=!0,k.tabSize=h)}if(typeof b.indentSize<"u"){const h=this.o(b.indentSize);h==="tabSize"?(p=!0,k.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,p=!0,k.indentSize=h)}if(typeof b.insertSpaces<"u"){const h=this.q(b.insertSpaces);h==="auto"?(p=!0,k.insertSpaces=h):this.j!==h&&(this.j=h,p=!0,k.insertSpaces=h)}typeof b.cursorStyle<"u"&&this.k!==b.cursorStyle&&(this.k=b.cursorStyle,p=!0,k.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this.l!==b.lineNumbers&&(this.l=b.lineNumbers,p=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(b.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(b,k){k.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this.e.warn(p)})}}e.$FP=E;class I{constructor(b,k,p,h,g,u,n,i){this.id=b,this.j=k,this.k=p,this.g=!1,this.h=new Set,this.c=g,this.d=new E(this.j,this.id,u,p),this.e=n,this.f=i;const d=this;this.value=Object.freeze({get document(){return h.value},set document(o){throw new N.$9("document")},get selection(){return d.c&&d.c[0]},set selection(o){if(!(o instanceof L.$cN))throw(0,N.$7)("selection");d.c=[o],d.l()},get selections(){return d.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof L.$cN)))throw(0,N.$7)("selections");d.c=o,d.l()},get visibleRanges(){return d.e},set visibleRanges(o){throw new N.$9("visibleRanges")},get options(){return d.d.value},set options(o){d.g||d.d.assign(o)},get viewColumn(){return d.f},set viewColumn(o){throw new N.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(d.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new m(h.value,t);return o(l),d.m(l)},insertSnippet(o,t,l={undoStopBefore:!0,undoStopAfter:!0}){if(d.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=d.c.map(c=>R.Range.from(c));else if(t instanceof L.$aN){const{lineNumber:c,column:s}=R.Position.from(t);r=[{startLineNumber:c,startColumn:s,endLineNumber:c,endColumn:s}]}else if(t instanceof L.$bN)r=[R.Range.from(t)];else{r=[];for(const c of t)if(c instanceof L.$bN)r.push(R.Range.from(c));else{const{lineNumber:s,column:v}=R.Position.from(c);r.push({startLineNumber:s,startColumn:v,endLineNumber:s,endColumn:v})}}return k.$tryInsertSnippet(b,h.value.version,o.value,r,l)},setDecorations(o,t){const l=t.length===0;l&&!d.h.has(o.key)||(l?d.h.delete(o.key):d.h.add(o.key),d.n(()=>{if(R.$uP(t))return k.$trySetDecorations(b,o.key,R.$vP(t));{const r=new Array(4*t.length);for(let c=0,s=t.length;c<s;c++){const v=t[c];r[4*c]=v.start.line+1,r[4*c+1]=v.start.character+1,r[4*c+2]=v.end.line+1,r[4*c+3]=v.end.character+1}return k.$trySetDecorationsFast(b,o.key,r)}}))},revealRange(o,t){d.n(()=>k.$tryRevealRange(b,R.Range.from(o),t||L.TextEditorRevealType.Default))},show(o){k.$tryShowEditor(b,R.ViewColumn.from(o))},hide(){k.$tryHideEditor(b)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(b){(0,a.ok)(!this.g),this.d._accept(b)}_acceptVisibleRanges(b){(0,a.ok)(!this.g),this.e=b}_acceptViewColumn(b){(0,a.ok)(!this.g),this.f=b}_acceptSelections(b){(0,a.ok)(!this.g),this.c=b}async l(){const b=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,b)),this.value}m(b){const k=b.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const p=k.edits.map(g=>g.range);p.sort((g,u)=>g.end.line===u.end.line?g.end.character===u.end.character?g.start.line===u.start.line?g.start.character-u.start.character:g.start.line-u.start.line:g.end.character-u.end.character:g.end.line-u.end.line);for(let g=0,u=p.length-1;g<u;g++){const n=p[g].end;if(p[g+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=k.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,h,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(b){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$GP=I}),define(ke[73],Se([1,0,62,4,3,2,5,6,154,20,158,16,11,27,15,40,46]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=void 0;class u{constructor(d){this.value=d,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(d,o){this.h=d,this.i=o,this.a=null,this.b=new Map,this.c=new k.$Bc,this.d=new N.$ee,this.e=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const o=[],t=[],l=[];if(d.removedDocuments)for(const r of d.removedDocuments){const c=R.URI.revive(r),s=this.c.get(c);s?.unref()&&(this.c.delete(c),o.push(s.value))}if(d.addedDocuments)for(const r of d.addedDocuments){const c=R.URI.revive(r.uri);let s=this.c.get(c);if(s&&c.scheme!==p.Schemas.vscodeNotebookCell&&c.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);s||(s=new u(new m.$AP(this.h.getProxy($.$0M.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(c,s),t.push(s.value)),s.ref()}if(d.removedEditors)for(const r of d.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&l.push(c)}if(d.addedEditors)for(const r of d.addedEditors){const c=R.URI.revive(r.documentUri);a.ok(this.c.has(c),`document '${c}' does not exist`),a.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const s=this.c.get(c).value,v=new I.$GP(r.id,this.h.getProxy($.$0M.MainThreadTextEditors),this.i,new g.$V(()=>s.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(f=>P.Range.to(f)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,v)}d.newActiveEditor!==void 0&&(a.ok(d.newActiveEditor===null||this.b.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this.a=d.newActiveEditor),(0,A.$Qc)(o),(0,A.$Qc)(l),d.removedDocuments&&this.e.fire(o),d.addedDocuments&&this.d.fire(t),(d.removedEditors||d.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),d.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(d){return this.c.get(d)?.value}allDocuments(){return h.Iterable.map(this.c.values(),d=>d.value)}getEditor(d){return this.b.get(d)}activeEditor(d){if(!this.a)return;const o=this.b.get(this.a);return d?o:o?.value}allEditors(){return[...this.b.values()]}};e.$HP=n,e.$HP=n=Je([Ue(0,E.$xP),Ue(1,b.$3j)],n),e.$IP=(0,L.$wi)("IExtHostDocumentsAndEditors")}),define(ke[359],Se([1,0,19,4,6,158,16,8]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class m{constructor(I,P){this.i=P,this.a=new N.$ee,this.b=new N.$ee,this.c=new N.$ee,this.d=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(A.$0M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const P=this.i.allEditors();return I?P:P.map(b=>b.value)}async showTextDocument(I,P,b){let k;typeof P=="number"?k={position:L.ViewColumn.from(P),preserveFocus:b}:typeof P=="object"?k={position:L.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?L.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:k={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,k),h=p&&this.i.getEditor(p);if(h)return h.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,P){return new R.$EP(this.h,I,P).value}$acceptEditorPropertiesChanged(I,P){const b=this.i.getEditor(I);if(!b)throw new Error("unknown text editor");if(P.options&&b._acceptOptions(P.options),P.selections){const k=P.selections.selections.map(L.Selection.to);b._acceptSelections(k)}if(P.visibleRanges){const k=a.$Hb(P.visibleRanges.map(L.Range.to));b._acceptVisibleRanges(k)}if(P.options&&this.b.fire({textEditor:b.value,options:{...P.options,lineNumbers:L.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const k=$.TextEditorSelectionChangeKind.fromValue(P.selections.source),p=P.selections.selections.map(L.Selection.to);this.a.fire({textEditor:b.value,selections:p,kind:k})}if(P.visibleRanges){const k=a.$Hb(P.visibleRanges.map(L.Range.to));this.c.fire({textEditor:b.value,visibleRanges:k})}}$acceptEditorPositionData(I){for(const P in I){const b=this.i.getEditor(P);if(!b)throw new Error("Unknown text editor");const k=L.ViewColumn.to(I[P]);b.value.viewColumn!==k&&(b._acceptViewColumn(k),this.d.fire({textEditor:b.value,viewColumn:k}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$xlc=m}),define(ke[360],Se([1,0,2,5,6,3,8,16,25,18]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=void 0,e.$gnc=(0,N.$wi)("IExtHostTimeline");class I{constructor(k,p){this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$0M.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(h,g)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&m.$Sm.equals(g,this.b.get(h.source)?.extension)){const u=h.uri===void 0?void 0:a.URI.revive(h.uri);return this.c.get(h.source)?.get(P(u))?.get(h.handle)}else return;return h}})}async $getTimeline(k,p,h,g){return this.b.get(k)?.provider.provideTimeline(a.URI.revive(p),h,g)}registerTimelineProvider(k,p,h,g){const u=new R.$Uc,n=this.d(p.id,g,u).bind(this);let i;p.onDidChange&&(i=p.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:p.id}),this));const d=this.c;return this.f({...p,scheme:k,onDidChange:void 0,async provideTimeline(o,t,l){t?.resetCache&&(u.clear(),d.get(p.id)?.clear());const r=await p.provideTimeline(o,t,l);if(r==null)return;const c=n(o,t);return{...r,source:p.id,items:r.items.map(c)}},dispose(){for(const o of d.values())o.get(p.id)?.clear();i?.dispose(),u.dispose()}},h)}d(k,p,h){return(g,u)=>{let n;if(u?.cacheResults){let i=this.c.get(k);i===void 0&&(i=new Map,this.c.set(k,i));const d=P(g);n=i.get(d),n===void 0&&(n=new Map,i.set(d,n))}return i=>{const{iconPath:d,...o}=i,t=`${k}|${i.id??i.timestamp}`;n?.set(t,i);let l,r,c;i.iconPath&&(d instanceof L.$9N?c={id:d.id,color:d.color}:a.URI.isUri(d)?(l=d,r=d):{light:l,dark:r}=d);let s;return L.$BN.isMarkdownString(o.tooltip)?s=$.MarkdownString.from(o.tooltip):(0,E.$9f)(o.tooltip)?s=o.tooltip:L.$BN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=$.MarkdownString.from(o.detail)):(0,E.$9f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=o.detail),{...o,id:o.id??void 0,handle:t,source:k,command:i.command?p.toInternal(i.command,h):void 0,icon:l,iconDark:r,themeIcon:c,tooltip:s,accessibilityInformation:i.accessibilityInformation}}}}f(k,p){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:p}),(0,R.$Tc)(()=>{for(const g of this.c.values())g.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$hnc=I;function P(b){return b?.toString()}}),define(ke[361],Se([1,0,233,23,2,4,3,293,7,8,18,19,16,80,22,199,26]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;function u(d,o){if((0,I.$9f)(d))return{label:d};if(d&&typeof d=="object"&&typeof d.label=="string"){let t;return Array.isArray(d.highlights)&&(t=d.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),t=t.length?t:void 0),{label:d.label,highlights:t}}}class n extends L.$Vc{constructor(o,t,l){super(),this.f=o,this.g=t,this.h=l,this.a=new Map,this.b=new h.$w$;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(s=>r(s)?this.r(s):s):c})}registerTreeDataProvider(o,t,l){const r=this.createTreeView(o,{treeDataProvider:t},l);return{dispose:()=>r.dispose()}}createTreeView(o,t,l){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,f=this.m(o,t,l),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:s,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(o,y),D={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,g.$PG)(l,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,g.$PG)(l,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(S){(0,k.$Vk)(S)&&(0,g.$PG)(l,"treeViewMarkdownMessage"),f.message=S},get title(){return f.title},set title(S){f.title=S},get description(){return f.description},set description(S){f.description=S},get badge(){return f.badge},set badge(S){S!==void 0&&E.ViewBadge.isViewBadge(S)?f.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(f.badge=void 0)},reveal:(S,C)=>f.reveal(S,C),dispose:async()=>{await w,this.a.delete(o),f.dispose()}};return this.B(D),D}$getChildren(o,t){const l=this.a.get(o);return l?l.getChildren(t):Promise.reject(new $.$4F(o))}async $handleDrop(o,t,l,r,c,s,v,f){const y=this.a.get(o);if(!y)return Promise.reject(new $.$4F(o));const w=b.DataTransfer.toDataTransfer(l,async D=>(await this.f.$resolveDropFileData(o,t,D)).buffer);return v===o&&f&&await this.j(w,y,f,c,s),y.onDrop(w,r,c)}async j(o,t,l,r,c){const s=this.b.removeDragOperationTransfer(c);if(s)(await s)?.forEach((v,f)=>{v&&o.set(f,v)});else if(c&&t.handleDrag){const v=t.handleDrag(l,o,r);this.b.addDragOperationTransfer(c,v),await v}return o}async $handleDrag(o,t,l,r){const c=this.a.get(o);if(!c)return Promise.reject(new $.$4F(o));const s=await this.j(new E.$5N,c,t,r,l);if(!(!s||r.isCancellationRequested))return b.DataTransfer.from(s)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new $.$4F(o);return t.hasResolve}$resolve(o,t,l){const r=this.a.get(o);if(!r)throw new $.$4F(o);return r.resolveTreeItem(t,l)}$setExpanded(o,t,l){const r=this.a.get(o);if(!r)throw new $.$4F(o);r.setExpanded(t,l)}$setSelectionAndFocus(o,t,l){const r=this.a.get(o);if(!r)throw new $.$4F(o);r.setSelectionAndFocus(t,l)}$setVisible(o,t){const l=this.a.get(o);if(!l){if(!t)return;throw new $.$4F(o)}l.setVisible(t)}$changeCheckboxState(o,t){const l=this.a.get(o);if(!l)throw new $.$4F(o);l.setCheckboxState(t)}m(o,t,l){const r=this.B(new i(o,t,this.f,this.g.converter,this.h,l));return this.a.set(o,r),r}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$inc=n;class i extends L.$Vc{get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,I.$fg)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,l,r,c,s){if(super(),this.I=o,this.J=l,this.L=r,this.M=c,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$pe,s.contributes&&s.contributes.views)for(const w in s.contributes.views)for(const D of s.contributes.views[w])D.id===o&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>{Array.isArray(w)&&w.length===0||this.F.fire({message:!1,element:w})}));let v,f;const y=R.Event.debounce(this.F.event,(w,D)=>(w||(w={message:!1,elements:[]}),D.element!==!1&&(v||(v=new Promise(S=>f=S),this.G=this.G.then(()=>v)),Array.isArray(D.element)?w.elements.push(...D.element):w.elements.push(D.element)),D.message&&(w.message=!0),w),200,!0);this.B(y(({message:w,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const S=f;return v=null,this.$(D).then(()=>S())})),w&&this.J.$setMessage(this.I,b.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let l=this.X(o);return l||(l=await this.Y(t)),l?l.map(r=>r.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const l=(0,I.$fg)(t.select)?!0:t.select,r=(0,I.$fg)(t.focus)?!1:t.focus,c=(0,I.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(s=>this.W(o,s[s.length-1]).then(v=>this.J.$reveal(this.I,{item:v.item,parentChain:s.map(f=>f.item)},{select:l,focus:r,expand:c})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:l,focus:r,expand:c})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=b.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const l=this.getExtensionElement(o);l&&(t?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(o,t){const l=!(0,P.$ub)(this.s,o);this.s=o;const r=this.t!==t;this.t=t,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);t.forEach(l=>{l.treeItem.checkboxState=l.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(l=>[l.extensionItem,l.newState])})}async handleDrag(o,t,l){const r=[];for(const c of o){const s=this.getExtensionElement(c);s&&r.push(s)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,l),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,l){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,m.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(r,o,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const l=this.j.get(o);if(l){const r=this.m.get(l);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,l,t)??r.extensionItem;return this.hb(c),r.item.tooltip=this.eb(c.tooltip),r.item.command=this.fb(r.disposableStore,c.command),r.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(l=>this.W(t,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$oh)(()=>this.f.getParent(o))}W(o,t){const l=this.m.get(o);return l?Promise.resolve(l):(0,m.$oh)(()=>this.f.getTreeItem(o)).then(r=>this.kb(o,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const s=this.m.get(c);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const l=this.getExtensionElement(o);t=l?this.m.get(l):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new p.$pe(this.Z.token);try{const l=o?this.m.get(o):void 0,r=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,P.$Hb)(r||[]),s=await Promise.all((0,P.$Hb)(c).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const v=s.map((f,y)=>f?this.db(c[y],f,l):null);return(0,P.$Hb)(v)}finally{t.dispose()}}$(o){if(o.some(l=>!l))return this.Z.dispose(!0),this.Z=new p.$pe,this.tb(),this.J.$refresh(this.I);{const l=this.ab(o);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(o){const t=new Set,l=o.map(c=>this.m.get(c));for(const c of l)if(c&&!t.has(c.item.handle)){let s=c;for(;s&&s.parent&&l.findIndex(v=>s&&s.parent&&v&&v.item.handle===s.parent.item.handle)===-1;){const v=this.j.get(s.parent.item.handle);s=v?this.m.get(v):void 0}s&&!s.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const s=this.j.get(c);if(s){const v=this.m.get(s);v&&(!v.parent||!t.has(v.parent.item.handle))&&r.push(c)}}),r}bb(o){const t={};return Promise.all(o.map(l=>this.cb(l).then(r=>{r&&(t[l]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const l=this.m.get(t);if(l)return this.rb(t),(0,m.$oh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const c=this.ib(t,r,l.parent);return this.pb(t,c,l,l.parent),l.dispose(),c}return null})}return Promise.resolve(null)}db(o,t,l){const r=this.ib(o,t,l);if(t.id&&this.j.has(r.item.handle))throw new Error((0,a.localize)(0,null,t.id));return this.ob(o,r),this.qb(r,l),r}eb(o){return E.$BN.isMarkdownString(o)?b.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,l,r;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,l=o.checkboxState.tooltip,r=o.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:r}}hb(o){if(!E.$ZN.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,l){this.hb(t);const r=this.B(new L.$Uc),c=this.kb(o,t,l),s=this.lb(t);return{item:{handle:c,parentHandle:l?l.item.handle:void 0,label:u(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,I.$fg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(o){return o.iconPath instanceof E.$9N?o.iconPath:void 0}kb(o,{id:t,label:l,resourceUri:r},c,s){if(t)return`${i.b}/${t}`;const v=u(l,this.N),f=c?c.item.handle:i.a;let y=v?v.label:r?(0,N.$7g)(r):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const w=this.m.has(o)?this.m.get(o).item.handle:void 0,D=this.X(c)||[];let S,C=0;do{if(S=`${f}/${C}:${y}`,s||!this.j.has(S)||w===S)break;C++}while(C<=D.length);return S}lb(o){if(o.iconPath&&!(o.iconPath instanceof E.$9N))return typeof o.iconPath=="string"||A.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof E.$9N)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return A.URI.isUri(o)?o:A.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,l,r){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(o,t);const c=this.X(r)||[],s=c.filter(v=>v.item.handle===l.item.handle)[0];s&&c.splice(c.indexOf(s),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const l of t.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const l of t.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}i.a="0",i.b="1"});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[362],Se([1,0,4,3,2,31,16,92,6,8]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";var I,P,b,k,p,h,g,u,n,i,d,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class l extends N.$Vc{constructor(v,f,y,w){super(),I.set(this,void 0),P.set(this,void 0),b.set(this,void 0),k.set(this,void 0),p.set(this,void 0),h.set(this,void 0),g.set(this,void 0),u.set(this,void 0),n.set(this,!0),i.set(this,void 0),d.set(this,!1),o.set(this,this.B(new a.$ee)),this.onDidDispose=qe(this,o,"f").event,t.set(this,this.B(new a.$ee)),this.onDidChangeViewState=qe(this,t,"f").event,it(this,I,v,"f"),it(this,P,f,"f"),it(this,k,y,"f"),it(this,b,w.viewType,"f"),it(this,p,w.panelOptions,"f"),it(this,u,w.viewColumn,"f"),it(this,h,w.title,"f"),it(this,i,w.active,"f")}dispose(){qe(this,d,"f")||(it(this,d,!0,"f"),qe(this,o,"f").fire(),qe(this,P,"f").$disposeWebview(qe(this,I,"f")),qe(this,k,"f").dispose(),super.dispose())}get webview(){return this.c(),qe(this,k,"f")}get viewType(){return this.c(),qe(this,b,"f")}get title(){return this.c(),qe(this,h,"f")}set title(v){this.c(),qe(this,h,"f")!==v&&(it(this,h,v,"f"),qe(this,P,"f").$setTitle(qe(this,I,"f"),v))}get iconPath(){return this.c(),qe(this,g,"f")}set iconPath(v){this.c(),qe(this,g,"f")!==v&&(it(this,g,v,"f"),qe(this,P,"f").$setIconPath(qe(this,I,"f"),A.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return qe(this,p,"f")}get viewColumn(){if(this.c(),!(typeof qe(this,u,"f")=="number"&&qe(this,u,"f")<0))return qe(this,u,"f")}get active(){return this.c(),qe(this,i,"f")}get visible(){return this.c(),qe(this,n,"f")}_updateViewState(v){qe(this,d,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(it(this,i,v.active,"f"),it(this,n,v.visible,"f"),it(this,u,v.viewColumn,"f"),qe(this,t,"f").fire({webviewPanel:this}))}reveal(v,f){this.c(),qe(this,P,"f").$reveal(qe(this,I,"f"),{viewColumn:typeof v>"u"?void 0:L.ViewColumn.from(v),preserveFocus:!!f})}c(){if(qe(this,d,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,P=new WeakMap,b=new WeakMap,k=new WeakMap,p=new WeakMap,h=new WeakMap,g=new WeakMap,u=new WeakMap,n=new WeakMap,i=new WeakMap,d=new WeakMap,o=new WeakMap,t=new WeakMap;class r extends N.$Vc{static c(){return(0,R.$Sg)()}constructor(v,f,y){super(),this.j=f,this.m=y,this.g=new Map,this.h=new Map,this.f=v.getProxy(m.$0M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,f,y,w,D={}){const S=typeof w=="object"?w.viewColumn:w,C={viewColumn:L.ViewColumn.from(S),preserveFocus:typeof w=="object"&&!!w.preserveFocus},j=(0,$.$Mlc)(v),B=r.c();this.f.$createWebviewPanel((0,$.$Olc)(v),B,f,{title:y,panelOptions:c(D),webviewOptions:(0,$.$Plc)(v,this.m,D),serializeBuffersForPostMessage:j},C);const z=this.j.createNewWebview(B,D,v);return this.createNewWebviewPanel(B,f,y,S,D,z,!0)}$onDidChangeWebviewPanelViewStates(v){const f=Object.keys(v);f.sort((y,w)=>{const D=v[y],S=v[w];return D.active?1:S.active?-1:+D.visible-+S.visible});for(const y of f){const w=this.getWebviewPanel(y);if(!w)continue;const D=v[y];w._updateViewState({active:D.active,visible:D.visible,viewColumn:L.ViewColumn.to(D.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,f,y){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:y,extension:v}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$Mlc)(v)}),new E.$_M(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(v,f,y,w){const D=this.h.get(f);if(!D)throw new Error(`No serializer found for '${f}'`);const{serializer:S,extension:C}=D,j=this.j.createNewWebview(v,y.webviewOptions,C),B=this.createNewWebviewPanel(v,f,y.title,w,y.panelOptions,j,y.active);await S.deserializeWebviewPanel(B,y.state)}createNewWebviewPanel(v,f,y,w,D,S,C){const j=new l(v,this.f,S,{viewType:f,title:y,viewColumn:w,panelOptions:D,active:C});return this.g.set(v,j),j}getWebviewPanel(v){return this.g.get(v)}}e.$Qlc=r;function c(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[363],Se([1,0,4,3,92,16,6,8]),function(ie,e,a,N,A,R,L,$){"use strict";var m,E,I,P,b,k,p,h,g,u,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class i extends N.$Vc{constructor(t,l,r,c,s,v){super(),m.set(this,void 0),E.set(this,void 0),I.set(this,void 0),P.set(this,void 0),b.set(this,!1),k.set(this,void 0),p.set(this,void 0),h.set(this,void 0),g.set(this,void 0),u.set(this,this.B(new a.$ee)),this.onDidChangeVisibility=qe(this,u,"f").event,n.set(this,this.B(new a.$ee)),this.onDidDispose=qe(this,n,"f").event,it(this,I,r,"f"),it(this,p,c,"f"),it(this,m,t,"f"),it(this,E,l,"f"),it(this,P,s,"f"),it(this,k,v,"f")}dispose(){qe(this,b,"f")||(it(this,b,!0,"f"),qe(this,n,"f").fire(),qe(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),qe(this,p,"f")}set title(t){this.a(),qe(this,p,"f")!==t&&(it(this,p,t,"f"),qe(this,E,"f").$setWebviewViewTitle(qe(this,m,"f"),t))}get description(){return this.a(),qe(this,h,"f")}set description(t){this.a(),qe(this,h,"f")!==t&&(it(this,h,t,"f"),qe(this,E,"f").$setWebviewViewDescription(qe(this,m,"f"),t))}get visible(){return qe(this,k,"f")}get webview(){return qe(this,P,"f")}get viewType(){return qe(this,I,"f")}_setVisible(t){t===qe(this,k,"f")||qe(this,b,"f")||(it(this,k,t,"f"),qe(this,u,"f").fire())}get badge(){return this.a(),qe(this,g,"f")}set badge(t){this.a(),!(t?.value===qe(this,g,"f")?.value&&t?.tooltip===qe(this,g,"f")?.tooltip)&&(it(this,g,R.ViewBadge.from(t),"f"),qe(this,E,"f").$setWebviewViewBadge(qe(this,m,"f"),t))}show(t){this.a(),qe(this,E,"f").$show(qe(this,m,"f"),!!t)}a(){if(qe(this,b,"f"))throw new Error("Webview is disposed")}}m=new WeakMap,E=new WeakMap,I=new WeakMap,P=new WeakMap,b=new WeakMap,k=new WeakMap,p=new WeakMap,h=new WeakMap,g=new WeakMap,u=new WeakMap,n=new WeakMap;class d{constructor(t,l){this.d=l,this.b=new Map,this.c=new Map,this.a=t.getProxy(L.$0M.MainThreadWebviewViews)}registerWebviewViewProvider(t,l,r,c){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,A.$Olc)(t),l,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Mlc)(t)}),new $.$_M(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(t,l,r,c,s){const v=this.b.get(l);if(!v)throw new Error(`No view provider found for '${l}'`);const{provider:f,extension:y}=v,w=this.d.createNewWebview(t,{},y),D=new i(t,this.a,l,r,w,!0);this.c.set(t,D),await f.resolveWebviewView(D,{state:c},s)}async $onDidChangeWebviewViewVisibility(t,l){this.e(t)._setVisible(l)}async $disposeWebviewView(t){const l=this.e(t);this.c.delete(t),l.dispose(),this.d.deleteWebview(t)}e(t){const l=this.c.get(t);if(!l)throw new Error("No webview found");return l}}e.$lnc=d}),define(ke[364],Se([1,0,70,15,11,265,33,12]),function(ie,e,a,N,A,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;let m=class{constructor(P,b){P.addFileSystemProvider(N.Schemas.file,new E(b),{isCaseSensitive:$.$e})}};e.$3nc=m,e.$3nc=m=Je([Ue(0,a.$Ilc),Ue(1,A.$3j)],m);class E{constructor(P){this.b=P,this.a=new R.$ar(this.b)}async stat(P){const b=await this.a.stat(P);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,b,k){return this.a.writeFile(P,b,{...k,unlock:!1,atomic:!1})}delete(P,b){return this.a.delete(P,{...b,useTrash:!1,atomic:!1})}rename(P,b,k){return this.a.rename(P,b,k)}copy(P,b,k){return this.a.copy(P,b,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,b){throw new Error("Method not implemented.")}}}),define(ke[365],Se([1,0,17,63,31,34,3,6,2,20]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;let I=class extends L.$Vc{constructor(b,k){super();const p=b.getProxy($.$0M.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async h=>{const g=m.URI.file((0,a.$kc)((0,N.tmpdir)(),(0,A.$Sg)()));return await p.$download(h,g),g})}};e.$1nc=I,e.$1nc=I=Je([Ue(0,E.$xP),Ue(1,R.$TP)],I)}),define(ke[366],Se([1,0,52,17,2,93,3,15,7,32]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=void 0;class I extends R.$Klc{constructor(){super(...arguments),this.i=null}async g(t){const l=await super.g(t);if(l.scheme!==$.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const r=l.fsPath;let c=0;do{let s;c===0?s=r:s=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await P(s);const v=N.$kc(s,"vscode.lock"),f=await h(this.d,v,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),A.URI.file(s);c++}while(c<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$aoc=I;async function P(o){try{await E.Promises.stat(o);return}catch{}try{await E.Promises.mkdir(o,{recursive:!0})}catch{}}const b=1e3,k=10*60*1e3;class p extends L.$Vc{constructor(t,l){super(),this.b=t,this.c=l,this.a=this.B(new m.$Hh),this.a.cancelAndSet(async()=>{const r=await g(t,l);(!r||r.pid!==process.pid)&&(t.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(l,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${l}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function h(o,t,l){try{const c={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const r=await g(o,t);return!r||r.pid!==process.pid?l?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new p(o,t))}async function g(o,t){let l;try{l=await E.Promises.readFile(t)}catch(r){return o.error(r),null}try{return JSON.parse(String(l))}catch(r){return o.error(r),null}}async function u(o,t){let l;try{l=await E.Promises.stat(t)}catch(r){return o.error(r),0}return l.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const l=await g(o,t);if(!l)return o.info(`Lock '${t}': Could not read pid of lock holder.`),d(o,t);if(l.willReleaseAt){let f=l.willReleaseAt-Date.now();if(f<5e3){for(f>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,m.$xh)(Math.min(100,f)),await u(o,t)===0)return d(o,t);f=l.willReleaseAt-Date.now()}return d(o,t)}}if(!n(l.pid))return o.info(`Lock '${t}': The pid ${l.pid} appears to be gone.`),d(o,t);const r=await u(o,t),c=Date.now()-r;if(c<=k)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,m.$xh)(2e3);const s=await u(o,t),v=Date.now()-s;return v<=k?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),d(o,t))}async function d(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return h(o,t,!0)}}),define(ke[367],Se([1,0,31,20,44,34]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;let L=class extends A.$7lc{constructor(m,E){super(!0,m,E)}createTerminal(m,E,I){return this.createTerminalFromOptions({name:m,shellPath:E,shellArgs:I})}createTerminalFromOptions(m,E){const I=new A.$6lc(this.a,(0,a.$Sg)(),m,m.name);return this.f.push(I),I.create(m,this.R(m,E)),I.value}};e.$vnc=L,e.$vnc=L=Je([Ue(0,R.$TP),Ue(1,N.$xP)],L)}),define(ke[368],Se([1,0,4,36,38,5]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.OutputChannelUpdateMode=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=void 0,e.$fM="text/x-code-output",e.$gM="output",e.$hM="Log",e.$iM="text/x-code-log-output",e.$jM="log",e.$kM="workbench.panel.output",e.$lM=new A.$Nj("inOutput",!1),e.$mM=new A.$Nj("activeLogOutput",!1),e.$nM=new A.$Nj("activeLogOutput.levelSettable",!1),e.$oM=new A.$Nj("activeLogOutput.level",""),e.$pM=new A.$Nj("activeLogOutput.levelIsDefault",!1),e.$qM=new A.$Nj("outputView.scrollLock",!1),e.$rM=(0,R.$wi)("outputService");var L;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$sM={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new a.$ee,this.onDidRegisterChannel=this.b.event,this.c=new a.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(I=>E.push(I)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$do.add(e.$sM.OutputChannels,new $),e.$tM=new A.$Nj("activeOutputChannel","")}),define(ke[159],Se([1,0,6,5,20,25,11,368,70,28,60,204,21,18,33,4,3]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0;class u extends L.$9j{get disposed(){return this.n}constructor(o,t,l,r,c){super(),this.id=o,this.name=t,this.r=l,this.s=r,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=b.$Ge.fromString(t).byteLength,(0,L.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends u{appendLine(o){this.append(o)}}let i=class{constructor(o,t,l,r,c,s){this.i=t,this.j=l,this.k=r,this.l=c,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(a.$0M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,l]of this.g)l.visible=t===this.h}createOutputChannel(o,t,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,k.$9f)(t)?t:void 0;if((0,k.$9f)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const v=this.i.environment.extensionLogLevel?.find(([y])=>R.$Sm.equals(l.identifier,y))?.[1];v&&(s=(0,L.$hk)(v));const f=r?this.o(o,s,l):this.n(o,c,l);return f.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),r?this.r(o,s??this.m.getLevel(),f):this.q(o,f)}async n(o,t,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(o,c,t,l.identifier.value);return new u(v,o,s,this.a,l)}async o(o,t,l){const r=await this.p(l),c=o.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(r,`${c}.log`),v=`${l.identifier.value}.${c}`,f=this.l.createLogger(s,{id:v,name:o,logLevel:t,extensionId:l.identifier.value});return new n(v,o,f,this.a,l)}p(o){let t=this.d.get(o.identifier.value);if(!t){const l=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,p.$gl)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return t}q(o,t){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return o},append(c){r(),t.then(s=>s.append(c))},appendLine(c){r(),t.then(s=>s.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(s=>s.replace(c))},show(c,s){r(),t.then(v=>v.show(c,s))},hide(){r(),t.then(c=>c.hide())},dispose(){l=!0,t.then(c=>c.dispose())}}}r(o,t,l){const r=new g.$Uc,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},s=r.add(new h.$ee);function v(f){t=f,s.fire(f)}return l.then(f=>{r.add(f),f.logLevel!==t&&v(f.logLevel),r.add(f.onDidChangeLogLevel(y=>v(y)))}),{...this.q(o,l),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(f,...y){c(),l.then(w=>w.trace(f,...y))},debug(f,...y){c(),l.then(w=>w.debug(f,...y))},info(f,...y){c(),l.then(w=>w.info(f,...y))},warn(f,...y){c(),l.then(w=>w.warn(f,...y))},error(f,...y){c(),l.then(w=>w.error(f,...y))},dispose(){r.dispose()}}}};e.$Wmc=i,e.$Wmc=i=Je([Ue(0,A.$xP),Ue(1,E.$NP),Ue(2,m.$Ilc),Ue(3,I.$llc),Ue(4,L.$4j),Ue(5,L.$3j)],i),e.$Xmc=(0,N.$wi)("IExtHostOutputService")}),define(ke[160],Se([1,0,5,7]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=void 0,e.$hn=(0,a.$wi)("remoteAgentService"),e.$in=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let $=0;$<this.maxSampleCount;$++){const m=await A.getRoundTripTime();if(m===void 0)return;R=Math.min(R,m/2),await(0,N.$xh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce(($,m)=>$+m,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce(($,m)=>$+m,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[369],Se([1,0,237,66,36,43,55,3,4,160,12,24,7]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=Object.freeze({id:"application",order:100,title:(0,a.localize)(0,null),type:"object"}),e.$LJ=Object.freeze({id:"workbench",order:7,title:(0,a.localize)(1,null),type:"object"}),e.$MJ=Object.freeze({id:"security",scope:1,title:(0,a.localize)(2,null),type:"object",order:7}),e.$NJ=Object.freeze({id:"problems",title:(0,a.localize)(3,null),type:"object",order:101}),e.$OJ={ConfigurationMigration:"base.contributions.configuration.migration"};class k{constructor(){this.migrations=[],this.a=new m.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const p=new k;A.$do.add(e.$OJ.ConfigurationMigration,p);let h=class extends $.$Vc{constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async d=>{for(const o of d.added)await this.f(o,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(d=>this.c(d)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(d=>this.g(d,n?.uri))])}async g(n,i){const d=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,l]of o){const r=d[t];if(!r)continue;const c=[];if(r.value!==void 0){const s=await this.h(n,t,r.value,i,void 0);for(const v of s??[])c.push([v,[]])}for(const{identifiers:s,value:v}of r.overrides??[])if(v!==void 0){const f=await this.h(n,t,v,i,s);for(const y of f??[])c.push([y,s])}c.length&&await Promise.allSettled(c.map(async([[s,v],f])=>this.a.updateValue(s,v.value,{resource:i,overrideIdentifiers:f},l)))}}async h(n,i,d,o,t){const l=c=>{const v=this.a.inspect(c,{resource:o})[i];if(v)return t?v.overrides?.find(({identifiers:f})=>(0,P.$8n)(f,t))?.value:v.value},r=await n.migrateFn(d,l);return Array.isArray(r)?r:[[n.key,r]]}};e.$PJ=h,h.ID="workbench.contrib.configurationMigration",e.$PJ=h=Je([Ue(0,L.$3i),Ue(1,R.$Fi)],h);let g=class extends $.$Vc{constructor(n){super(),this.b=n,this.a=new b.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$c&&(await this.b.getEnvironment())?.os!==1)return;A.$do.as(N.$io.Configuration).registerConfiguration({...e.$MJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,a.localize)(4,null)},default:[],markdownDescription:(0,a.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,a.localize)(6,null),scope:2}}})}};e.$QJ=g,g.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$QJ=g=Je([Ue(0,E.$hn)],g)}),define(ke[370],Se([1,0,35,15,17,23,247,369,66,5,36]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$ihb=e.$hhb=void 0,e.$jhb=h,e.$khb=g,e.$hhb=(0,E.$wi)("editorResolverService"),e.$ihb="workbench.editorAssociations";const P=I.$do.as(m.$io.Configuration),b={...$.$LJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(b);var k;(function(u){u.builtin="builtin",u.option="option",u.exclusive="exclusive",u.default="default"})(k||(e.RegisteredEditorPriority=k={}));var p;(function(u){u[u.ABORT=1]="ABORT",u[u.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function h(u){switch(u){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function g(u,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof u=="string"&&u.indexOf(A.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$7g)(n);return a.$pk(typeof u=="string"?u.toLowerCase():u,o.toLowerCase())}}),define(ke[371],Se([1,0,30,15,17,12,23,2,5,284,43,149,160]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0,e.$LM=(0,m.$wi)("pathService");let p=k=class{constructor(g,u,n,i){this.d=g,this.e=u,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const d=await this.e.getEnvironment();return this.c=d?.userHome??g})()}hasValidBasename(g,u,n){return typeof u=="string"||typeof u>"u"?this.a.then(i=>this.h(g,i,u)):this.h(g,u,n)}h(g,u,n){return g.scheme===N.Schemas.file||g.scheme===N.Schemas.vscodeRemote?(0,a.$tg)(n??(0,L.$7g)(g),u===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,u){if(g.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,E.$IM)(u.getWorkspace());if(n)return n;const i=u.getWorkspace().folders[0];if(i)return i.uri.scheme;const d=u.getWorkspace().configuration;return d?d.scheme:N.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?A.$gc:A.$hc)}async fileURI(g){let u="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const i=g.indexOf("/",2);i===-1?(u=g.substring(2),g="/"):(u=g.substring(2,i),g=g.substring(i)||"/")}return $.URI.from({scheme:N.Schemas.file,authority:u,path:g,query:"",fragment:""})}};e.$MM=p,e.$MM=p=k=Je([Ue(1,b.$hn),Ue(2,P.$uM),Ue(3,I.$Fi)],p)}),define(ke[372],Se([1,0,249,19,56,4,57,3,2,55,254,11,67,143,88,43,149,26,22,18,24,38]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.OnPortForward=e.$zM=e.$yM=e.TunnelSource=e.TunnelCloseReason=e.$wM=e.$vM=void 0,e.$xM=s,e.$AM=y,e.$BM=w,e.$CM=D,e.$DM=C;const t=10*1e3,l="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",c=1e3*60*60*24*14;e.$vM="onTunnel",e.$wM=new o.$Nj("forwardedPortsViewEnabled",!1,a.localize(0,null));function s(z){const T=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var v;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(v||(e.TunnelCloseReason=v={}));var f;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$yM={source:f.User,description:a.localize(1,null)},e.$zM={source:f.Auto,description:a.localize(2,null)};function y(z,T,M){const F=z.get(D(T,M));if(F)return F;if((0,p.$pw)(T))for(const O of p.$ow){const q=D(O,M);if(z.has(q))return z.get(q)}else if((0,p.$rw)(T))for(const O of p.$qw){const q=D(O,M);if(z.has(q))return z.get(q)}}function w(z,T,M){const F=y(z,T,M);if(F)return F;const O=(0,p.$rw)(T)?"localhost":(0,p.$pw)(T)?"0.0.0.0":void 0;if(O)return y(z,O,M)}function D(z,T){return z+":"+T}var S;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(S||(e.OnPortForward=S={}));function C(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}class j extends $.$Vc{constructor(T){super(),this.r=T,this.j=[],this.n=new R.$ee,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(M=>{(M.affectsConfiguration(j.c)||M.affectsConfiguration(j.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,M,F){let O=this.w(T,M,F,this.j,0);const q={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;O>=0;){const Y=this.j[O];Y.key===T?(q.onAutoForward=Y.onAutoForward??q.onAutoForward,q.elevateIfNeeded=Y.elevateIfNeeded!==void 0?Y.elevateIfNeeded:q.elevateIfNeeded,q.label=Y.label??q.label,q.requireLocalPort=Y.requireLocalPort,q.protocol=Y.protocol):(q.onAutoForward=q.onAutoForward??Y.onAutoForward,q.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:Y.elevateIfNeeded,q.label=q.label??Y.label,q.requireLocalPort=q.requireLocalPort!==void 0?q.requireLocalPort:void 0,q.protocol=q.protocol??Y.protocol),O=this.w(T,M,F,this.j,O+1)}return q.onAutoForward!==void 0||q.elevateIfNeeded!==void 0||q.label!==void 0||q.requireLocalPort!==void 0||q.protocol!==void 0?q:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,i.$9f)(T.host)&&(0,i.$ag)(T.port)}w(T,M,F,O,q){if(q>=O.length)return-1;const Y=!(0,p.$pw)(M)&&!(0,p.$rw)(M),J=O.slice(q).findIndex(x=>(0,i.$ag)(x.key)?Y?!1:x.key===T:this.t(x.key)?Y?!1:T>=x.key.start&&T<=x.key.end:this.u(x.key)?T===x.key.port&&M===x.key.host:F?x.key.test(F):!1);return J>=0?J+q:-1}y(){const T=this.r.getValue(j.c);if(!T||!(0,i.$$f)(T))return[];const M=[];for(const O in T){if(O===void 0)continue;const q=T[O];let Y;if(Number(O))Y=Number(O);else if((0,i.$9f)(O))if(j.g.test(O)){const V=O.match(j.g);Y={start:Number(V[1]),end:Number(V[2])}}else if(j.h.test(O)){const V=O.match(j.h);Y={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(O)}catch{}V&&(Y=V)}Y&&M.push({key:Y,elevateIfNeeded:q.elevateIfNeeded,onAutoForward:q.onAutoForward,label:q.label,requireLocalPort:q.requireLocalPort,protocol:q.protocol})}const F=this.r.getValue(j.f);return F&&(this.m={elevateIfNeeded:F.elevateIfNeeded,label:F.label,onAutoForward:F.onAutoForward,requireLocalPort:F.requireLocalPort,protocol:F.protocol}),this.z(M)}z(T){function M(F,O){return(0,i.$ag)(F.key)?F.key:O.t(F.key)?F.key.start:O.u(F.key)?F.key.port:Number.MAX_VALUE}return T.sort((F,O)=>M(F,this)-M(O,this))}C(){return this.m}static providedActionToAction(T){switch(T){case p.ProvidedOnAutoForward.Notify:return S.Notify;case p.ProvidedOnAutoForward.OpenBrowser:return S.OpenBrowser;case p.ProvidedOnAutoForward.OpenBrowserOnce:return S.OpenBrowserOnce;case p.ProvidedOnAutoForward.OpenPreview:return S.OpenPreview;case p.ProvidedOnAutoForward.Silent:return S.Silent;case p.ProvidedOnAutoForward.Ignore:return S.Ignore;default:return}}async addAttributes(T,M,F){const q=this.r.inspect(j.c).userRemoteValue;let Y;!q||!(0,i.$$f)(q)?Y={}:Y=(0,d.$4n)(q),Y[`${T}`]||(Y[`${T}`]={});for(const V in M)Y[`${T}`][V]=M[V];return this.r.updateValue(j.c,Y,F)}}e.$EM=j,j.c="remote.portsAttributes",j.f="remote.otherPortsAttributes",j.g=/^(\d+)\-(\d+)$/,j.h=/^([a-z0-9\-]+):(\d{1,5})$/;let B=class extends $.$Vc{constructor(T,M,F,O,q,Y,V,J,x,ne){super(),this.H=T,this.I=M,this.J=F,this.L=O,this.M=q,this.N=Y,this.O=V,this.P=J,this.Q=x,this.R=ne,this.c=new Map,this.g=new R.$ee,this.onForwardPort=this.g.event,this.h=new R.$ee,this.onClosePort=this.h.event,this.j=new R.$ee,this.onPortName=this.j.event,this.n=new R.$ee,this.onCandidatesChanged=this.n.event,this.t=new R.$ee,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$ee,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new j(F),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async de=>{const ce=await this.getAttributes(de.map(ve=>({port:ve.tunnelRemotePort,host:ve.tunnelRemoteHost})));for(const ve of de)if(ve.localAddress){const _=D(ve.tunnelRemoteHost,ve.tunnelRemotePort),U=w(this.m??new Map,ve.tunnelRemoteHost,ve.tunnelRemotePort);this.forwarded.set(_,{remotePort:ve.tunnelRemotePort,remoteHost:ve.tunnelRemoteHost,localAddress:ve.localAddress,protocol:ce?.get(ve.tunnelRemotePort)?.protocol??p.TunnelProtocol.Http,localUri:await this.X(ve.localAddress,ce?.get(ve.tunnelRemotePort)),localPort:ve.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:ve.privacy,source:e.$yM}),this.f.set(_,ve)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async de=>{const ce=D(de.tunnelRemoteHost,de.tunnelRemotePort);if(!w(this.forwarded,de.tunnelRemoteHost,de.tunnelRemotePort)&&!w(this.detected,de.tunnelRemoteHost,de.tunnelRemotePort)&&!w(this.c,de.tunnelRemoteHost,de.tunnelRemotePort)&&de.localAddress){const ve=w(this.m??new Map,de.tunnelRemoteHost,de.tunnelRemotePort),_=(await this.getAttributes([{port:de.tunnelRemotePort,host:de.tunnelRemoteHost}]))?.get(de.tunnelRemotePort);this.forwarded.set(ce,{remoteHost:de.tunnelRemoteHost,remotePort:de.tunnelRemotePort,localAddress:de.localAddress,protocol:_?.protocol??p.TunnelProtocol.Http,localUri:await this.X(de.localAddress,_),localPort:de.tunnelLocalPort,closeable:!0,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:de.privacy,source:e.$yM})}await this.cb(),this.f.set(ce,de),this.g.fire(this.forwarded.get(ce))})),this.B(this.H.onTunnelClosed(de=>this.W(de,v.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$vM))?(this.R.createKey(e.$wM.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,M){const F=D(T.host,T.port);this.forwarded.has(F)&&(this.forwarded.delete(F),await this.cb(),this.h.fire(T))}X(T,M){if(T.startsWith("http"))return m.URI.parse(T);const F=M?.protocol??"http";return m.URI.parse(`${F}://${T}`)}async Y(T){const M=this.N.getWorkspace(),F=M.configuration?(0,L.$kj)(M.configuration.path):M.folders.length>0?(0,L.$kj)(M.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${F}`}async Z(){return this.Y(l)}async $(){return this.Y(r)}async ab(){const T=this.I.get(l,1);if(T)return this.I.remove(l,1),await this.cb(),T;const M=await this.Z();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const M=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(F=>F.remotePort).join(", ")}`);for(const F of M){const O=w(this.detected,F.remoteHost,F.remotePort);F.source.source!==f.Extension&&!O||F.source.source===f.Extension&&O?await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,elevateIfNeeded:!0,source:F.source}):F.source.source===f.Extension&&!O&&this.D.set(D(F.remoteHost,F.remotePort),F)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new $.$Uc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(M=>M.startsWith(r));for(const M of T){const F=this.I.getNumber(M,0);if(F&&F<Date.now()){this.s=Promise.resolve(void 0);const O=M.replace(r,l);this.I.remove(M,0),this.I.remove(O,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),M=T.map(Y=>({remoteHost:Y.remoteHost,remotePort:Y.remotePort,localPort:Y.localPort,name:Y.name,localAddress:Y.localAddress,localUri:Y.localUri,protocol:Y.protocol,source:Y.source}));let F;T.length>0&&(F=JSON.stringify(M));const O=await this.Z(),q=await this.$();!F&&O&&q?(this.I.remove(O,0),this.I.remove(q,0)):F!==this.y&&O&&q&&(this.I.store(O,F,0,0),this.I.store(q,Date.now()+c,0,0)),this.y=F}}async eb(T,M,F){if(!T.tunnelLocalPort||!F?.requireLocalPort||T.tunnelLocalPort===M)return;const O=new Date;if(this.db.getTime()+t>O.getTime())return;this.db=O;const q=a.localize(3,null,M,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(q)}async forward(T,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(T,M)}async fb(T,M){await this.Q.activateByEvent(e.$vM);const F=w(this.forwarded,T.remote.host,T.remote.port);M=M??(M!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const O=T.local!==void 0?T.local:T.remote.port;let q;if(F)return this.hb(F,T,M);{const Y=this.L.remoteAuthority,V=Y?{getAddress:async()=>(await this.M.resolveAuthority(Y)).authority}:void 0,J=D(T.remote.host,T.remote.port);this.c.set(J,!0),T=this.gb(J,T);const x=await this.H.openTunnel(V,T.remote.host,T.remote.port,void 0,O,T.elevateIfNeeded?T.elevateIfNeeded:M?.elevateIfNeeded,T.privacy,M?.protocol);if(typeof x=="string")q=x;else if(x&&x.localAddress){const ne=w(this.m??new Map,T.remote.host,T.remote.port),de=x.protocol?x.protocol===p.TunnelProtocol.Https?p.TunnelProtocol.Https:p.TunnelProtocol.Http:M?.protocol??p.TunnelProtocol.Http,ce={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:M?.label??T.name,closeable:!0,localAddress:x.localAddress,protocol:de,localUri:await this.X(x.localAddress,M),runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,source:T.source??e.$yM,privacy:x.privacy};return this.forwarded.set(J,ce),this.f.set(J,x),this.c.delete(J),await this.cb(),await this.eb(x,O,M),this.g.fire(ce),x}this.c.delete(J)}return q}gb(T,M){const F=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(F){const O=F.get(T);F.delete(T),O&&(M.name=O.name??M.name,M.local=("local"in O?O.local:"localPort"in O?O.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(T,M,F){const O=F?.label??M.name;let q;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(q||(q={}));let Y=q.None;switch(O!==T.name&&(T.name=O,Y=q.Fire),(F?.protocol||T.protocol!==p.TunnelProtocol.Http)&&F?.protocol!==T.protocol&&(M.source=T.source,Y=q.Reopen),M.privacy&&T.privacy!==M.privacy&&(Y=q.Reopen),Y){case q.Fire:{this.g.fire();break}case q.Reopen:await this.close(T.remoteHost,T.remotePort,v.User),await this.fb(M,F)}return w(this.f,M.remote.host,M.remote.port)}async name(T,M,F){const O=w(this.forwarded,T,M),q=D(T,M);if(O){O.name=F,await this.cb(),this.j.fire({host:T,port:M});return}else this.detected.has(q)&&(this.detected.get(q).name=F,this.j.fire({host:T,port:M}))}async close(T,M,F){const O=D(T,M),q=this.forwarded.get(O);return F===v.AutoForwardEnd&&q&&q.source.source===f.Auto&&this.F.set(O,{local:q.localPort,name:q.name,privacy:q.privacy}),await this.H.closeTunnel(T,M),this.W({host:T,port:M},F)}address(T,M){const F=D(T,M);return(this.forwarded.get(F)||this.detected.get(F))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const M of T){const F=w(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),O=typeof M.localAddress=="string"?M.localAddress:D(M.localAddress.host,M.localAddress.port);this.detected.set(D(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:O,protocol:p.TunnelProtocol.Http,localUri:this.X(O),closeable:!1,runningProcess:F?.detail,hasRunningProcess:!!F,pid:F?.pid,privacy:p.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:a.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,O,p.TunnelPrivacyId.ConstantPrivate,p.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let M=T;this.r&&(M=await this.r(T));const F=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(F.values()).map(O=>O.port).join(", ")}`),this.n.fire(F)}ib(T){const M=this.m??new Map,F=new Map;return this.m=F,T.forEach(O=>{const q=D(O.host,O.port);F.set(q,{host:O.host,port:O.port,detail:O.detail,pid:O.pid}),M.has(q)&&M.delete(q);const Y=w(this.forwarded,O.host,O.port);Y&&(Y.runningProcess=O.detail,Y.hasRunningProcess=!0,Y.pid=O.pid)}),M.forEach((O,q)=>{const Y=s(q);if(!Y)return;const V=w(this.forwarded,Y.host,Y.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const J=w(this.detected,Y.host,Y.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),M=await this.getAttributes(T.map(F=>({port:F.remotePort,host:F.remoteHost})),!1);if(M)for(const F of T){const O=M.get(F.remotePort);(O?.protocol||F.protocol!==p.TunnelProtocol.Http)&&O?.protocol!==F.protocol&&await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,source:F.source},O),O&&O.label&&O.label!==F.name&&await this.name(F.remoteHost,F.remotePort,O.label)}}async getAttributes(T,M=!0){const F=new Map,O=new Map;T.forEach(x=>{const ne=w(this.m??new Map,p.$ow[0],x.port)??x;if(ne){F.set(x.port,ne);const de=C(ne)?ne.pid:void 0;O.has(de)||O.set(de,[]),O.get(de)?.push(x.port)}});const q=new Map;if(T.forEach(x=>{const ne=this.configPortsAttributes.getAttributes(x.port,x.host,F.get(x.port)?.detail);ne&&q.set(x.port,ne)}),this.G.length===0||!M)return q.size>0?q:void 0;const Y=await Promise.all((0,N.$Rb)(this.G.map(x=>Array.from(O.entries()).map(ne=>{const de=ne[1],ce=F.get(de[0]);return x.providePortAttributes(de,ce?.pid,ce?.detail,n.CancellationToken.None)})))),V=new Map;if(Y.forEach(x=>x.forEach(ne=>{ne&&V.set(ne.port,ne)})),!q&&!V)return;const J=new Map;return T.forEach(x=>{const ne=q.get(x.port),de=V.get(x.port);J.set(x.port,{elevateIfNeeded:ne?.elevateIfNeeded,label:ne?.label,onAutoForward:ne?.onAutoForward??j.providedActionToAction(de?.autoForwardAction),requireLocalPort:ne?.requireLocalPort,protocol:ne?.protocol})}),J}addAttributesProvider(T){this.G.push(T)}};e.$FM=B,Je([(0,A.$2h)(1e3)],B.prototype,"cb",null),e.$FM=B=Je([Ue(0,p.$jw),Ue(1,k.$2p),Ue(2,E.$3i),Ue(3,g.$uM),Ue(4,b.$Hl),Ue(5,h.$Fi),Ue(6,P.$3j),Ue(7,I.$Ow),Ue(8,u.$LG),Ue(9,o.$Oj)],B)}),define(ke[94],Se([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$fL=e.$eL=void 0;class a{constructor(L,$){this.line=L,this.character=$}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,$){return new a(0,0)}with(L){return new a(0,0)}}e.$eL=a;class N{constructor(L,$,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(L,$),this.end=new a(m,E)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new N(0,0,0,0)}with(L){return new N(0,0,0,0)}}e.$fL=N;var A;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(ke[37],Se([1,0,19,35,24,30,14,5,17,13,94,7]),function(ie,e,a,N,A,R,L,$,m,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.TextSearchCompleteMessageType=void 0,e.$mL=u,e.$nL=n,e.$oL=i,e.$tL=f,e.$uL=y,e.$wL=S,e.$xL=C,e.$yL=j,e.$zL=B,e.$AL=z,e.$BL=T,e.$DL=F,e.$FL=Y,e.$GL=V,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$gL="workbench.view.search",e.$hL="workbench.panel.search",e.$iL="workbench.view.search",e.$jL="search-result",e.$kL="search.exclude";const b="\u27EA ",k=" characters skipped \u27EB",p=(b.length+k.length+5)*2;e.$lL=(0,$.$wi)("searchService");var h;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var g;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(g||(e.QueryType=g={}));function u(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var d;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(d||(e.SearchCompletionExitCode=d={}));class o{constructor(ne){this.resource=ne,this.results=[]}}e.$pL=o;class t{constructor(ne,de,ce,ve){this.ranges=de,this.webviewIndex=ve;const _=Array.isArray(de)?de:[de];if(ce&&ce.matchLines===1&&l(_)){ne=(0,L.$2f)(ne,ce.matchLines);let U="",le=0,De=0;const $e=Math.floor(ce.charsPerLine/5),re=[];for(const se of _){const oe=Math.max(se.startColumn-$e,0),K=se.startColumn+ce.charsPerLine;if(oe>De+$e+p){const te=b+(oe-De)+k;U+=te+ne.slice(oe,K),le+=oe-(De+te.length)}else U+=ne.slice(De,K);re.push(new c(0,se.startColumn-le,se.endColumn-le)),De=K}this.preview={text:U,matches:Array.isArray(this.ranges)?re:re[0]}}else{const U=Array.isArray(de)?de[0].startLineNumber:de.startLineNumber;this.preview={text:ne,matches:(0,a.$2b)(de,le=>new r(le.startLineNumber-U,le.startColumn,le.endLineNumber-U,le.endColumn))}}}}e.$qL=t;function l(x){const ne=x[0].startLineNumber;for(const de of x)if(de.startLineNumber!==ne||de.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,de,ce,ve){this.startLineNumber=ne,this.startColumn=de,this.endLineNumber=ce,this.endColumn=ve}}e.$rL=r;class c extends r{constructor(ne,de,ce){super(ne,de,ne,ce)}}e.$sL=c;var s;(function(x){x.List="list",x.Tree="tree"})(s||(e.ViewMode=s={}));var v;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function f(x,ne=!0){const de=x&&x.files&&x.files.exclude,ce=ne&&x&&x.search&&x.search.exclude;if(!de&&!ce)return;if(!de||!ce)return de||ce;let ve=Object.create(null);return ve=A.$7n(ve,A.$4n(de)),ve=A.$7n(ve,A.$4n(ce),!0),ve}function y(x,ne){return x.excludePattern&&N.$pk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&N.$pk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(de=>{const ce=de.folder.fsPath;if(R.$vg(ne,ce)){const ve=m.$mc(ce,ne);return!de.includePattern||!!N.$pk(de.includePattern,ve)}else return!1}):!1:!0}var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class D extends Error{constructor(ne,de){super(ne),this.code=de}}e.$vL=D;function S(x){const ne=x.message;if((0,E.$4)(x))return new D(ne,w.canceled);try{const de=JSON.parse(ne);return new D(de.message,de.code)}catch{return new D(ne,w.other)}}function C(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function j(x){return x.type==="error"?!0:x.type==="success"}function B(x){return x.type==="success"}function z(x){return!!x.path}function T(x,ne,de=!0){const ce=x.searchPath?x.searchPath:x.relativePath;return de?(0,L.$Yf)(ce,ne):N.$pk(ne,ce)}class M{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=M;function F(x,ne){const de={...x||{},...ne||{}};return Object.keys(de).filter(ce=>{const ve=de[ce];return typeof ve=="boolean"&&ve})}class O{constructor(ne,de){this.c=null,this.a={...ne.excludePattern||{},...de.excludePattern||{}},this.b=N.$qk(this.a);let ce=ne.includePattern;de.includePattern&&(ce?ce={...ce,...de.includePattern}:ce=de.includePattern),ce&&(this.c=N.$qk(ce))}matchesExcludesSync(ne,de,ce){return!!(this.b&&this.b(ne,de,ce))}includedInQuerySync(ne,de,ce){return!(this.b&&this.b(ne,de,ce)||this.c&&!this.c(ne,de,ce))}includedInQuery(ne,de,ce){const ve=this.b(ne,de,ce),_=()=>this.c?!!this.c(ne,de,ce):!0;return(0,P.$ih)(ve)?ve.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return q(this.a)}}e.$EL=O;function q(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function Y(x){if(!x)return;let ne;return de=>(ne||(ne=(x()||Promise.resolve([])).then(ce=>ce?J(ce):{})),ne.then(ce=>!!ce[de]))}function V(x){if(!x)return;let ne;return de=>{if(!ne){const ce=x();ne=ce?J(ce):{}}return!!ne[de]}}function J(x){const ne={};for(const de of x)ne[de]=!0;return ne}}),define(ke[39],Se([1,0,19,7,22,4,3,78,15,127,23,14,2,235,5,11,268,43,60,28,20,16,8,68,37,6,58]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;function v(B,z,T){return new I.$Yg(M=>D(M,T)).isEqual(B,z)}function f(B,z,T){return v(B.uri,z.uri,T)?0:(0,P.$rf)(B.uri.toString(),z.uri.toString())}function y(B,z,T){return B.index!==z.index?B.index<z.index?-1:1:v(B.uri,z.uri,T)?(0,P.$rf)(B.name,z.name):(0,P.$rf)(B.uri.toString(),z.uri.toString())}function w(B,z,T,M){const F=B.slice(0).sort((q,Y)=>T(q,Y,M)),O=z.slice(0).sort((q,Y)=>T(q,Y,M));return(0,a.$Eb)(F,O,(q,Y)=>T(q,Y,M))}function D(B,z){const T=z.getCapabilities(B.scheme);return!(T&&T&1024)}class S extends u.$Pi{static toExtHostWorkspace(z,T,M,F){if(!z)return{workspace:null,added:[],removed:[]};const{id:O,name:q,folders:Y,configuration:V,transient:J,isUntitled:x}=z,ne=[],de=T;T?Y.forEach((U,le)=>{const De=b.URI.revive(U.uri),$e=S.o(M||T,De,F);$e?($e.name=U.name,$e.index=U.index,ne.push($e)):ne.push({uri:De,name:U.name,index:le})}):ne.push(...Y.map(({uri:U,name:le,index:De})=>({uri:b.URI.revive(U),name:le,index:De}))),ne.sort((U,le)=>U.index<le.index?-1:1);const ce=new S(O,q,ne,!!J,V?b.URI.revive(V):null,!!x,U=>D(U,F)),{added:ve,removed:_}=w(de?de.workspaceFolders:[],ce.workspaceFolders,f,F);return{workspace:ce,added:ve,removed:_}}static o(z,T,M){for(let F=0;F<z.folders.length;F++){const O=z.workspaceFolders[F];if(v(O.uri,T,M))return O}}constructor(z,T,M,F,O,q,Y){super(z,M.map(V=>new u.$Qi(V)),F,O,Y),this.t=T,this.u=q,this.q=[],this.s=$.$Ci.forUris(Y),M.forEach(V=>{this.q.push(V),this.s.set(V.uri,V)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,T){return T&&this.s.get(z)&&(z=(0,I.$9g)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let C=class{constructor(z,T,M,F,O){this.c=new R.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new R.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$ge,this.C=new Map,this.h=F,this.s=M,this.t=O,this.j=new E.$Em,this.k=new N.$vh,this.o=z.getProxy(c.$0M.MainThreadWorkspace),this.q=z.getProxy(c.$0M.MainThreadMessageService);const q=T.workspace;this.l=q?new S(q.id,q.name,[],!!q.transient,q.configuration?b.URI.revive(q.configuration):null,!!q.isUntitled,Y=>D(Y,M)):void 0}$initializeWorkspace(z,T){this.v=T,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:m.Schemas.untitled,path:(0,I.$7g)((0,I.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,T,M,...F){const O=[];if(Array.isArray(F)&&F.forEach(x=>{b.URI.isUri(x.uri)&&!O.some(ne=>v(ne.uri,x.uri,this.s))&&O.push({uri:x.uri,name:x.name||(0,I.$6g)(x.uri)})}),this.n||[T,M].some(x=>typeof x!="number"||x<0)||M===0&&O.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(T+M>q.length)return!1;const Y=q.slice(0);Y.splice(T,M,...O.map(x=>({uri:x.uri,name:x.name||(0,I.$6g)(x.uri),index:void 0})));for(let x=0;x<Y.length;x++){const ne=Y[x];if(Y.some((de,ce)=>ce!==x&&v(ne.uri,de.uri,this.s)))return!1}Y.forEach((x,ne)=>x.index=ne);const{added:V,removed:J}=w(q,Y,y,this.s);if(V.length===0&&J.length===0)return!1;if(this.o){const x=z.displayName||z.name;this.o.$updateWorkspaceFolders(x,T,M,O).then(void 0,ne=>{this.n=void 0;const de={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(g.Severity.Error,(0,k.localize)(0,null,x,ne.toString()),de,[])})}return this.y(Y),!0}getWorkspaceFolder(z,T){if(this.x)return this.x.getWorkspaceFolder(z,T)}async getWorkspaceFolder2(z,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,T)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,T){let M,F="";if(typeof z=="string"?(M=b.URI.file(z),F=z):typeof z<"u"&&(M=z,F=z.fsPath),!M)return F;const O=this.getWorkspaceFolder(M,!0);if(!O)return F;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let q=(0,I.$_g)(O.uri,M);return T&&O.name&&(q=`${O.name}/${q}`),q}y(z){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:T,added:M,removed:F}=S.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:F}))}findFiles(z,T,M,F,O=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let q="",Y=!0;return T===null?Y=!1:T!==void 0&&(typeof T=="string"?q=T:q=T.pattern),this.z(z,void 0,{exclude:q,maxResults:M,useDefaultExcludes:Y,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},O)}findFiles2(z,T={},M,F=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,z,T,F)}async z(z,T,M,F=A.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const O=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,q={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:O,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let Y;if(z){const{includePattern:V,folder:J}=j(o.GlobPattern.from(z));Y=J,q.includePattern=V}else{const{includePattern:V,folder:J}=j(o.GlobPattern.from(T));Y=J,q.filePattern=V}return this.o.$startFileSearch(Y??null,q,F).then(V=>Array.isArray(V)?V.map(J=>b.URI.revive(J)):[])}async findTextInFiles(z,T,M,F,O=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),Y=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:V,folder:J}=j(o.GlobPattern.from(T.include)),x=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,ne={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:Y,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:V,excludePattern:x},de=!1;if(this.u[q]=ce=>{if(de)return;const ve=b.URI.revive(ce.resource);ce.results.forEach(_=>{const U=(0,s.$6h)(_);(0,r.$mL)(U)?M({uri:ve,preview:{text:U.preview.text,matches:(0,a.$2b)(U.preview.matches,le=>new t.$bN(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))},ranges:(0,a.$2b)(U.ranges,le=>new t.$bN(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))}):M({uri:ve,text:U.text,lineNumber:U.lineNumber})})},O.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(z,J??null,ne,q,O);return delete this.u[q],ce||{}}catch(ce){throw delete this.u[q],ce}}$handleTextSearchResult(z,T){this.u[T]?.(z)}async save(z){const T=await this.o.$save(z,{saveAs:!1});return b.URI.revive(T)}async saveAs(z){const T=await this.o.$save(z,{saveAs:!0});return b.URI.revive(T)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,T){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,T);const M=this.t.transformOutgoingScheme(z),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,M),(0,L.$Tc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(z,T){this.h.info("Getting edit session identifier for workspaceFolder",z);const M=await this.resolveWorkspaceFolder(b.URI.revive(z));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const F=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!F),!F)return;const O=await F.provideEditSessionIdentity(M,T);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(z,T,M,F){this.h.info("Getting edit session identifier for workspaceFolder",z);const O=await this.resolveWorkspaceFolder(b.URI.revive(z));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const q=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!q),!q)return;const Y=await q.provideEditSessionIdentityMatch?.(T,M,F);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(z){return(T,M,F)=>{const O=function(Y){T.call(M,Y)};return O.extension=z,this.B.event(O,void 0,F)}}async $onWillCreateEditSessionIdentity(z,T,M){const F=await this.resolveWorkspaceFolder(b.URI.revive(z));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},T,async(O,q)=>{const Y=Date.now();await Promise.resolve(O),Date.now()-Y>M&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(z,T){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,T);const M=this.t.transformOutgoingScheme(z),F=this.A++;return this.o.$registerCanonicalUriProvider(F,M),(0,L.$Tc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(z,T,M){const F=this.C.get(z.scheme);if(!F)return;const O=await F.provideCanonicalUri?.(b.URI.revive(z),T,M);if(O)return O}async $provideCanonicalUri(z,T,M){return this.provideCanonicalUri(b.URI.revive(z),{targetScheme:T},M)}};e.$Clc=C,e.$Clc=C=Je([Ue(0,d.$xP),Ue(1,i.$NP),Ue(2,n.$llc),Ue(3,h.$3j),Ue(4,l.$Alc)],C),e.$Dlc=(0,p.$wi)("IExtHostWorkspace");function j(B){let z,T;return B&&(typeof B=="string"?z=B:(z=B.pattern,T=b.URI.revive(B.baseUri))),{includePattern:z,folder:T}}}),define(ke[45],Se([1,0,24,4,39,6,8,270,66,18,7,5,20,11,2]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=e.$Elc=void 0;function h(l,r){if(r){const c=r.split(".");let s=l;for(let v=0;s&&v<c.length;v++)s=s[c[v]];return s}}function g(l){return l instanceof p.URI}function u(l){return l&&l.uri instanceof p.URI&&l.languageId&&typeof l.languageId=="string"}function n(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function i(l){return l&&l.uri instanceof p.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function d(l){if(g(l))return{resource:l};if(u(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(n(l))return{overrideIdentifier:l.languageId};if(i(l))return{resource:l.uri};if(l===null)return{resource:null}}let o=class{constructor(r,c,s){this.a=r.getProxy(R.$0M.MainThreadConfiguration),this.c=c,this.b=s,this.d=new I.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,c))}};e.$Elc=o,e.$Elc=o=Je([Ue(0,b.$xP),Ue(1,A.$Dlc),Ue(2,k.$3j)],o);class t{constructor(r,c,s,v){this.a=new N.$ee,this.b=r,this.f=v,this.c=c,this.e=$.$Bo.parse(s,v),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Bo.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,s))}getConfiguration(r,c,s){const v=d(c)||{},f=this.g(r?h(this.e.getValue(void 0,v,this.c.workspace),r):this.e.getValue(void 0,v,this.c.workspace));r&&this.h(r,v,s?.identifier);function y(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(D){return typeof h(f,D)<"u"},get:(D,S)=>{this.h(r?`${r}.${D}`:D,v,s?.identifier);let C=h(f,D);if(typeof C>"u")C=S;else{let j;const B=(z,T)=>{if((0,E.$$f)(z)){let M;const F=()=>{j=j||(0,a.$4n)(f),M=M||h(j,T)};return new Proxy(z,{get:(O,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return F(),()=>M;if(j)return M=M||h(j,T),M[q];const Y=O[q];return typeof q=="string"?B(Y,`${T}.${q}`):Y},set:(O,q,Y)=>(F(),M&&(M[q]=Y),!0),deleteProperty:(O,q)=>(F(),M&&delete M[q],!0),defineProperty:(O,q,Y)=>(F(),M&&Object.defineProperty(M,q,Y),!0)})}return Array.isArray(z)?(0,a.$4n)(z):z};C=B(C,D)}return C},update:(D,S,C,j)=>{D=r?`${r}.${D}`:D;const B=y(C);return S!==void 0?this.b.$updateConfigurationOption(B,D,S,v,j):this.b.$removeConfigurationOption(B,D,v,j)},inspect:D=>{D=r?`${r}.${D}`:D;const S=this.e.inspect(D,v,this.c.workspace);if(S)return{key:D,defaultValue:(0,a.$4n)(S.policy?.value??S.default?.value),globalValue:(0,a.$4n)(S.user?.value??S.application?.value),workspaceValue:(0,a.$4n)(S.workspace?.value),workspaceFolderValue:(0,a.$4n)(S.workspaceFolder?.value),defaultLanguageValue:(0,a.$4n)(S.default?.override),globalLanguageValue:(0,a.$4n)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,a.$4n)(S.workspace?.override),workspaceFolderLanguageValue:(0,a.$4n)(S.workspaceFolder?.override),languageIds:(0,a.$4n)(S.overrideIdentifiers)}}};return typeof f=="object"&&(0,a.$7n)(w,f,!1),Object.freeze(w)}g(r){const c=s=>(0,E.$$f)(s)?new Proxy(s,{get:(v,f)=>c(v[f]),set:(v,f,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(v,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(v,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return c(r)}h(r,c,s){const v=m.$so.test(r)?4:this.d.get(r),f=s?`[${s.value}] `:"";if(v===4){typeof c?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){c?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const s=new $.$Do(r,c,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(v,f)=>s.affectsConfiguration(v,d(f))})}k(r){return r.reduce((c,s)=>(c.set(s[0],s[1]),c),new Map)}}e.$Flc=t,e.$Glc=(0,P.$wi)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[95],Se([1,0,2,7,4,6,8,39,73,45,22,44,20,28,5,15,12,11,91,313,13]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=e.$0mc=e.$9mc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(z){function T(F){if(F!=null)return F}z.from=T;function M(F){if(F!=null)return F}z.to=M})(t||(t={}));var l;(function(z){function T(F){if(F!=null)return F}z.from=T;function M(F){if(F!=null)return F}z.to=M})(l||(l={}));var r;(function(z){function T(F){if(F!=null)return F}z.from=T;function M(F){if(F!=null)return F}z.to=M})(r||(r={}));var c;(function(z){function T(O){if(O){const q=O;return q&&!!q.process}else return!1}z.is=T;function M(O){if(O==null)return;const q={process:O.process,args:O.args};return O.options&&(q.options=r.from(O.options)),q}z.from=M;function F(O){if(O!=null)return new L.$VN(O.process,O.args,O.options)}z.to=F})(c||(c={}));var s;(function(z){function T(F){if(F!=null)return F}z.from=T;function M(F){if(F!=null)return F}z.to=M})(s||(s={}));var v;(function(z){function T(O){if(O){const q=O;return q&&(!!q.commandLine||!!q.command)}else return!1}z.is=T;function M(O){if(O==null)return;const q={};return O.commandLine!==void 0?q.commandLine=O.commandLine:(q.command=O.command,q.args=O.args),O.options&&(q.options=s.from(O.options)),q}z.from=M;function F(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new L.$WN(O.commandLine,O.options):new L.$WN(O.command,O.args?O.args:[],O.options)}z.to=F})(v||(v={}));var f;(function(z){function T(O){if(O){const q=O;return q&&q.customExecution==="customExecution"}else return!1}z.is=T;function M(O){return{customExecution:"customExecution"}}z.from=M;function F(O,q){return q.get(O)}z.to=F})(f||(e.CustomExecutionDTO=f={}));var y;(function(z){function T(M,F){let O;return M.scope!==void 0&&typeof M.scope!="number"?O=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===L.TaskScope.Workspace&&F&&F.workspaceFile?O=F.workspaceFile:O=i.$dI),{id:M._id,workspaceFolder:O}}z.from=T})(y||(e.TaskHandleDTO=y={}));var w;(function(z){function T(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}z.from=T})(w||(w={}));var D;(function(z){function T(O,q){if(O==null)return[];const Y=[];for(const V of O){const J=M(V,q);J&&Y.push(J)}return Y}z.fromMany=T;function M(O,q){if(O==null)return;let Y;O.execution instanceof L.$VN?Y=c.from(O.execution):O.execution instanceof L.$WN?Y=v.from(O.execution):O.execution&&O.execution instanceof L.$XN&&(Y=f.from(O.execution));const V=t.from(O.definition);let J;return O.scope?typeof O.scope=="number"?J=O.scope:J=O.scope.uri:J=L.TaskScope.Workspace,!V||!J?void 0:{_id:O._id,definition:V,name:O.name,source:{extensionId:q.identifier.value,label:O.source,scope:J},execution:Y,isBackground:O.isBackground,group:w.from(O.group),presentationOptions:l.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=M;async function F(O,q,Y){if(O==null)return;let V;c.is(O.execution)?V=c.to(O.execution):v.is(O.execution)?V=v.to(O.execution):f.is(O.execution)&&(V=f.to(O._id,Y));const J=t.to(O.definition);let x;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?x=O.source.scope:x=await q.resolveWorkspaceFolder(a.URI.revive(O.source.scope)):x=L.TaskScope.Workspace),!J||!x)return;const ne=new L.$YN(J,x,O.name,O.source.label,V,O.problemMatchers);return O.isBackground!==void 0&&(ne.isBackground=O.isBackground),O.group!==void 0&&(ne.group=L.$UN.from(O.group._id),ne.group&&O.group.isDefault&&(ne.group=new L.$UN(ne.group.id,ne.group.label),O.group.isDefault===!0&&(ne.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ne.presentationOptions=l.to(O.presentationOptions)),O._id&&(ne._id=O._id),O.detail&&(ne.detail=O.detail),ne}z.to=F})(D||(e.TaskDTO=D={}));var S;(function(z){function T(F){return F}z.from=T;function M(F){if(F)return Object.assign(Object.create(null),F)}z.to=M})(S||(S={}));class C{constructor(T,M,F){this._id=M,this.a=F,o.set(this,void 0),it(this,o,T,"f")}get task(){return this.a}terminate(){qe(this,o,"f").terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}o=new WeakMap;let j=class{constructor(T,M,F,O,q,Y,V,J){this.q=new A.$ee,this.r=new A.$ee,this.s=new A.$ee,this.u=new A.$ee,this.a=T.getProxy(R.$0M.MainThreadTask),this.b=F,this.c=O,this.d=q,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,M,F){if(!F)return new L.$_M(()=>{});const O=this.x();return this.j.set(O,{type:M,provider:F,extension:T}),this.a.$registerTaskProvider(O,M),new L.$_M(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(T,M){this.a.$registerTaskSystem(T,M)}fetchTasks(T){return this.a.$fetchTasks(S.from(T)).then(async M=>{const F=[];for(const O of M){const q=await D.to(O,this.b,this.m);q&&F.push(q)}return F})}get taskExecutions(){const T=[];return this.k.forEach(M=>T.push(M)),T}terminateTask(T){if(!(T instanceof C))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,M,F){const O=this.m.get(T.id);O&&(this.o.set(T.id,O),this.e.attachPtyToTerminal(M,await O.callback(F))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const M=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const M=await this.z(T.id);this.s.fire({execution:M,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const M=await this.z(T.id);this.u.fire({execution:M,exitCode:T.exitCode})}$provideTasks(T,M){const F=this.j.get(T);if(!F)return Promise.reject(new Error("no handler found"));const O=[],q=(0,N.$oh)(()=>F.provider.provideTasks(I.CancellationToken.None)).then(Y=>this.v(M,O,F,Y));return new Promise(Y=>{q.then(V=>{Promise.all(O).then(()=>{Y(V)})})})}async $resolveTask(T,M){const F=this.j.get(T);if(!F)return Promise.reject(new Error("no handler found"));if(M.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${F.type}].`);const O=await D.to(M,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const q=await F.provider.resolveTask(O,I.CancellationToken.None);if(!q)return;this.A(q,F);const Y=D.from(q,F.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(Y.execution)&&await this.y(Y,q,!0),await this.w(Y)}x(){return this.h++}async y(T,M,F){const O=await this.a.$createTaskId(T);!F&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,M.execution)),this.m.set(O,M.execution)}async z(T,M){if(typeof T=="string"){const q=this.l.get(T);if(!q)throw new d.$bb("Unexpected: The specified task is missing an execution");return q}const F=this.l.get(T.id);if(F)return F;let O;return M?O=Promise.resolve(new C(this,T.id,M)):O=D.to(T.task,this.b,this.m).then(q=>{if(!q)throw new d.$bb("Unexpected: Task does not exist.");return new C(this,T.id,q)}),this.l.set(T.id,O),O.then(q=>(this.k.set(T.id,q),q))}A(T,M){T._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const F=this.n.values();let O=F.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=F.next()}};e.$9mc=j,e.$9mc=j=Je([Ue(0,b.$xP),Ue(1,k.$NP),Ue(2,$.$Dlc),Ue(3,m.$IP),Ue(4,E.$Glc),Ue(5,P.$5lc),Ue(6,u.$3j),Ue(7,n.$hlc)],j);let B=class extends j{constructor(T,M,F,O,q,Y,V,J){super(T,M,F,O,q,Y,V,J),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.$b(0)})}async executeTask(T,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const F=D.from(M,T);if(F===void 0)throw new Error("Task is not valid");if(f.is(F.execution))await this.y(F,M,!1);else throw new d.$_;const O=await this.z(await this.a.$getTaskExecution(F),M);return this.a.$executeTask(F).catch(q=>{throw new Error(q)}),O}v(T,M,F,O){const q=[];if(O)for(const Y of O){if(this.A(Y,F),!Y.definition||!T[Y.definition.type]){const J=Y.source?Y.source:"No task source";this.f.warn(`The task [${J}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const V=D.from(Y,F.extension);V&&f.is(V.execution)?(q.push(V),M.push(this.y(V,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:F.extension}}async w(T){if(f.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,M,F){}};e.$0mc=B,e.$0mc=B=Je([Ue(0,b.$xP),Ue(1,k.$NP),Ue(2,$.$Dlc),Ue(3,m.$IP),Ue(4,E.$Glc),Ue(5,P.$5lc),Ue(6,u.$3j),Ue(7,n.$hlc)],B),e.$$mc=(0,p.$wi)("IExtHostTask")}),define(ke[373],Se([1,0,37,29]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=A,e.$OL=R;function A(L){return"cellResults"in L}e.$NL="rawCell#";function R(L,$){let m=-1;const E=[];let I=[];return L.forEach(b=>{b.range.startLineNumber!==m&&I.length>0&&(E.push([...I]),I=[]),I.push(b),m=b.range.endLineNumber}),I.length>0&&E.push([...I]),E.map(b=>{const k=[],p=b[0].range.startLineNumber,h=b[b.length-1].range.endLineNumber;for(let g=p;g<=h;g++)k.push($.getLineContent(g));return new a.$qL(k.join(`
`)+`
`,b.map(g=>new N.$vt(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(ke[374],Se([1,0,229,21,4,3,27,14,18,2,33,112,6,34,16,8,48,344,155,24,15,303,373,370]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;class r{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,v,f,y,w,D){this.q=f,this.r=y,this.s=w,this.t=D,this.f=new Map,this.g=new L.$Bc,this.h=new Map,this.j=new A.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$flc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=s.getProxy(b.$0M.MainThreadNotebook),this.c=s.getProxy(b.$0M.MainThreadNotebookDocuments),this.d=s.getProxy(b.$0M.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const C=S.notebookEditor?.notebookUri,j=S.cell.handle,z=this.g.get(C)?.getCell(j);if(z)return z.apiCell}if(S&&S.$mid===14){const C=S.uri,j=this.g.get(C);if(j)return j.apiNotebook}return S}}),r.B(v)}getEditorById(s){const v=this.h.get(s);if(!v)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(s){for(const[v,f]of this.h)if(f.apiEditor===s)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,v){const f=this.g.get(s);if(!f&&!v)throw new Error(`NO notebook document for '${s}'`);return f}static u(s,v){if(!v)return;const f=v.filenamePattern.map(y=>p.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(v.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:v.displayName,filenamePattern:f,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,v,f){const y=r.a++,w=typeof f.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(y,f),this.b.$registerNotebookCellStatusBarItemProvider(y,w,v);let D;return w!==void 0&&(D=f.onDidChangeCellStatusBarItems(S=>this.b.$emitCellStatusBarEvent(w))),new h.$_M(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,w),D?.dispose()})}async createNotebookDocument(s){const v=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&p.NotebookData.from(s.content)});return E.URI.revive(v)}async openNotebookDocument(s){const v=this.g.get(s);if(v)return v.apiNotebook;const f=await this.c.$tryOpenNotebook(s),y=this.g.get(E.URI.revive(f));return(0,m.$hg)(y?.apiNotebook)}async showNotebookDocument(s,v){E.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let f;typeof v=="object"?f={position:p.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(p.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:f={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,f),w=y&&this.h.get(y)?.apiEditor;if(w)return w;throw y?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,v,f,y){const w=this.f.get(s),D=E.URI.revive(v),S=this.g.get(D);if(!S||!w)return;const C=S.getCellFromIndex(f);if(!C)return;const j=await w.provideCellStatusBarItems(C.apiCell,y);if(!j)return;const B=new R.$Uc,z=this.p.add([B]),M=(Array.isArray(j)?j:[j]).map(F=>p.NotebookStatusBarItem.from(F,this.i,B));return{cacheId:z,items:M}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,v,f,y,w){if((0,$.$8e)(v))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:v,serializer:f,options:y}),this.b.$registerNotebookSerializer(D,{id:s.identifier,location:s.extensionLocation},v,p.NotebookDocumentContentOptions.from(y),r.u(s,w)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(s,v,f){const y=this.x.get(s);if(!y)throw new Error("NO serializer found");const w=await y.serializer.deserializeNotebook(v.buffer,f);return new g.$Cw(p.NotebookData.from(w))}async $notebookToData(s,v,f){const y=this.x.get(s);if(!y)throw new Error("NO serializer found");const w=await y.serializer.serializeNotebook(p.NotebookData.to(v.value),f);return N.$Ge.wrap(w)}async $saveNotebook(s,v,f,y,w){const D=E.URI.revive(v),S=this.x.get(s);if(!S)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new I.$ll((0,a.localize)(0,null,this.z(D)),6);await this.y(D,y);const j={metadata:(0,i.$_n)(C.apiNotebook.metadata,F=>!(S.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of C.apiNotebook.getCells()){const O=new h.$CO(F.kind,F.document.getText(),F.document.languageId,F.mime,S.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);O.metadata=(0,i.$_n)(F.metadata,q=>!(S.options?.transientCellMetadata??{})[q]),j.cells.push(O)}const B=await S.serializer.serializeNotebook(j,w);await this.s.value.writeFile(D,B);const z=this.s.getFileSystemProviderExtUri(D.scheme),T=await this.s.value.stat(D);return{name:z.basename(D),isFile:(T.type&I.FileType.File)!==0,isDirectory:(T.type&I.FileType.Directory)!==0,isSymbolicLink:(T.type&I.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&I.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((T.permissions??0)&I.FilePermission.Locked),etag:I.$wl({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(s,v,f,y,w){const D=this.x.get(s)?.serializer;if(!D)return{limitHit:!1,results:[]};const S=new L.$Cc;await(async(T,M,F)=>{await Promise.all(T.map(async O=>await Promise.all(O.filenamePatterns.map(q=>{const Y={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:q};return this.t.doInternalFileSearchWithCustomCallback(Y,M,V=>{V.forEach(J=>{S.has(J)||y.some(ne=>O.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(de=>(0,l.$khb)(de,J)))||S.add(J)})}).catch(V=>{if(V.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw V})}))))})(f,w,v);const j=new L.$Bc;let B=!1;const z=Array.from(S).map(async T=>{const M=[];try{if(w.isCancellationRequested)return;if(v.maxResults&&[...j.values()].reduce((Y,V)=>Y+V.cellResults.length,0)>v.maxResults){B=!0;return}const F=[],O=this.g.get(T);if(O)O.apiNotebook.getCells().forEach(V=>F.push({input:V.document.getText(),outputs:V.outputs.flatMap(J=>J.items.map(x=>x.data.toString()))}));else{const Y=await this.s.value.readFile(T),V=N.$Ge.fromString(Y.toString()),J=await D.deserializeNotebook(V.buffer,w);if(w.isCancellationRequested)return;p.NotebookData.from(J).cells.forEach(ne=>F.push({input:ne.source,outputs:ne.outputs.flatMap(de=>de.items.map(ce=>ce.valueBytes.toString()))}))}if(w.isCancellationRequested)return;F.forEach((Y,V)=>{const J=v.contentPattern.pattern,x=new o.$oXb(Y.input,void 0,Y.outputs),ne=x.findInInputs(J),de=x.findInOutputs(J),ce=de.flatMap(ve=>(0,t.$OL)(ve.matches,ve.textBuffer)).map((ve,_)=>(ve.webviewIndex=_,ve));if(ne.length>0||de.length>0){const ve={index:V,contentResults:(0,t.$OL)(ne,x.inputTextBuffer),webviewResults:ce};M.push(ve)}});const q={resource:T,cellResults:M};j.set(T,q);return}catch{return}});return await Promise.all(z),{limitHit:B,results:[...j.values()]}}async y(s,v){const f=await this.s.value.stat(s);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==I.$vl&&typeof f.mtime=="number"&&typeof f.size=="number"&&v.mtime<f.mtime&&v.etag!==I.$wl({mtime:v.mtime,size:f.size}))throw new I.$ll((0,a.localize)(1,null),3,v)}z(s){return s.scheme===d.Schemas.file?s.fsPath:s.toString()}A(s,v,f){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const y=new n.$Cmc(v,this.d,s,f.visibleRanges.map(p.NotebookRange.to),f.selections.map(p.NotebookRange.to),typeof f.viewColumn=="number"?p.ViewColumn.to(f.viewColumn):void 0);this.h.set(v,y)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const f of s.value.removedDocuments){const y=E.URI.revive(f),w=this.g.get(y);w&&(w.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(w.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===y.toString()&&this.h.delete(D.id)}if(s.value.addedDocuments){const f=[];for(const y of s.value.addedDocuments){const w=E.URI.revive(y.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const D=new u.$Bmc(this.c,this.q,this.r,w,y);f.push(...y.cells.map(S=>u.$Amc.asModelAddData(S))),this.g.get(w)?.dispose(),this.g.set(w,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(D.apiNotebook)}}if(s.value.addedEditors)for(const f of s.value.addedEditors){if(this.h.has(f.id))return;const y=E.URI.revive(f.documentUri),w=this.g.get(y);w&&this.A(w,f.id,f)}const v=[];if(s.value.removedEditors)for(const f of s.value.removedEditors){const y=this.h.get(f);y&&(this.h.delete(f),this.k?.id===y.id&&(this.k=void 0),v.push(y))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const f=new Set;this.l.forEach(y=>f.add(y.id));for(const y of this.h.values()){const w=f.has(y.id);y._acceptVisibility(w)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(s){const v=k.$VP.String.with("notebookType","A notebook type"),f=new k.$XP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new k.$VP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>N.$Ge.wrap(w))],new k.$WP("Notebook Data",w=>p.NotebookData.to(w.value))),y=new k.$XP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new k.$VP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new g.$Cw(p.NotebookData.from(w)))],new k.$WP("Bytes",w=>w.buffer));s.registerApiCommand(f),s.registerApiCommand(y)}}e.$Lmc=r,r.a=0}),define(ke[375],Se([1,0,17,22,47,35,23,41,37]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class E{constructor(b,k,p){this.k=b,this.l=k,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=b.filePattern,this.b=b.includePattern&&R.$qk(b.includePattern),this.c=b.maxResults||void 0,this.d=b.exists,this.h=new Set,this.j=b.excludePattern&&R.$qk(b.excludePattern)}cancel(){this.g=!0,this.h.forEach(b=>b.cancel()),this.h=new Set}search(b){const k=this.k.folderQueries||[];return new Promise((p,h)=>{const g=u=>{this.f++,b(u)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const n=u.toString(),i=a.$oc(n);this.j&&this.j(n,i)||this.v(g,{base:u,basename:i})}),Promise.all(k.map(u=>this.p(u,g))).then(u=>{p({limitHit:this.e,stats:u[0]||void 0})},u=>{h(new Error((0,A.$hj)(u)))})})}async p(b,k){const p=new N.$pe,h=this.q(b),g=this.r(),u=new m.$EL(this.k,b),n=!u.hasSiblingExcludeClauses();let i;try{this.h.add(p),i=$.$ae.create();const d=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,p.token),o=i.elapsed(),t=$.$ae.create();return this.g&&!this.e||(d&&d.forEach(l=>{const r=a.$hc.relative(b.folder.path,l.path);if(n){const c=a.$oc(l.path);this.v(k,{base:b.folder,relativePath:r,basename:c});return}this.s(g,b.folder,r,k)}),this.g&&!this.e)?null:(this.u(g,u,k),{providerTime:o,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(b){const k=(0,m.$DL)(this.k.includePattern,b.includePattern),p=(0,m.$DL)(this.k.excludePattern,b.excludePattern);return{folder:b.folder,excludes:p,includes:k,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}s({pathToEntries:b},k,p,h){if(p===this.a){const u=a.$oc(this.a);this.v(h,{base:k,relativePath:this.a,basename:u})}function g(u){const n=a.$oc(u),i=a.$nc(u);let d=b[i];d||(d=b[i]=[],g(i)),d.push({base:k,relativePath:u,basename:n})}g(p)}u({rootEntries:b,pathToEntries:k},p,h){const g=this,u=this.a;function n(i){const d=(0,m.$GL)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const l=i[o],{relativePath:r,basename:c}=l;if(p.matchesExcludesSync(r,c,u!==c?d:void 0))continue;const s=k[r];if(s)n(s);else{if(r===u)continue;g.v(h,l)}if(g.e)break}}n(b)}v(b,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||b(k))}}class I{constructor(){this.b=new Map}fileSearch(b,k,p,h){const g=this.c(b.cacheKey),u=new E(b,k,g&&g.token);let n=0;const i=d=>{n+=d.length,p(d.map(o=>this.d(o)))};return this.e(u,I.a,i,h).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:d.stats}}))}clearCache(b){this.c(b)?.cancel()}c(b){if(b)return this.b.has(b)||this.b.set(b,new N.$pe),this.b.get(b)}d(b){return b.relativePath?{resource:L.$0g(b.base,b.relativePath)}:{resource:b.base}}e(b,k,p,h){const g=h.onCancellationRequested(()=>{b.cancel()}),u=i=>{i&&(n.push(i),k>0&&n.length>=k&&(p(n),n=[]))};let n=[];return b.search(u).then(i=>(n.length&&p(n),g.dispose(),i),i=>(n.length&&p(n),g.dispose(),Promise.reject(i)))}}e.$Dmc=I,I.a=512}),define(ke[376],Se([1,0,19,74,35,102,27,15,17,23,14,18,2,105,250,55,11,43,148,371,37]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0,e.$OM=y;let o=class{constructor(D,S,C,j,B){this.a=D,this.b=S,this.c=C,this.d=j,this.e=B}text(D,S,C={}){D=this.f(D,C);const j=this.a.getValue(),B=S&&S.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(S?.map(u.$Ri),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:j.search.usePCRE2||B||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,S){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const j={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,S)&&(j.isCaseSensitive=!0),this.k(D)&&(j.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),j}file(D,S={}){return{...this.h(D,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}g(D,S){return D?(D=Array.isArray(D)?D.map(s):s(D),S?this.parseSearchPaths(D):{pattern:l(...Array.isArray(D)?D:[D])}):{}}h(D=[],S={}){const C=this.g(S.includePattern,S.expandPatterns),j=this.g(S.excludePattern,S.expandPatterns),B=D.length>1,z=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(F=>this.q(F,S,j)):D.map(F=>this.r(F,S,j,B))).filter(F=>!!F),T={_reason:S._reason,folderQueries:z,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:j.pattern,includePattern:C.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const F=a.$Hb(a.$Rb(this.c.groups.map(Y=>Y.editors.map(V=>V.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const O=F.filter(Y=>(0,d.$uL)(T,Y.fsPath)),q=this.i(O);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...T,...q}}const M=S.extraFileResources&&S.extraFileResources.filter(F=>(0,d.$uL)(T,F.fsPath));return T.extraFileResources=M&&M.length?M:void 0,T}i(D){const S=[],C=new L.$Bc,j={};let B=!1;return D.forEach(z=>{if(z.scheme===$.Schemas.walkThrough)return;if((0,E.$bh)(z)){const M=this.b.getWorkspaceFolder(z)?.uri??z.with({path:m.$nc(z.fsPath)});let F=C.get(M);F||(B=!0,F={folder:M,includePattern:{}},S.push(F),C.set(M,F));const O=m.$mc(M.fsPath,z.fsPath);(0,P.$hg)(F.includePattern)[O.replace(/\\/g,"/")]=!0}else z.fsPath&&(B=!0,j[z.fsPath]=!0)}),{folderQueries:S,includePattern:j,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(D,S){if(S.isSmartCase){if(D.isRegExp){if(I.$Zf(D.pattern,!0))return!0}else if(I.$Zf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,k.$RC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const S=q=>m.$jc(q)||/^\.\.?([\/\\]|$)/.test(q),j=(Array.isArray(D)?D:r(D)).map(q=>{const Y=this.e.resolvedUserHome;return Y?(0,R.$Hw)(q,Y.scheme===$.Schemas.file?Y.fsPath:Y.path):q}),B=N.$E(j,q=>S(q)?"searchPaths":"exprSegments"),z=(B.exprSegments||[]).map(q=>I.$gf(q,"/")).map(q=>I.$gf(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),c(q))),T={},M=this.m(B.searchPaths||[]);M&&M.length&&(T.searchPaths=M);const F=a.$Rb(z),O=l(...F);return O&&(T.pattern=O),T}l(D,S){return S.disregardExcludeSettings?void 0:(0,d.$tL)(D,!S.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const S=D.flatMap(j=>{let{pathPortion:B,globPortion:z}=t(j);return z&&(z=v(z)),this.n(B).flatMap(M=>this.o(M,z))}),C=new Map;return S.forEach(j=>{const B=j.searchPath.toString(),z=C.get(B);z?j.pattern&&(z.pattern=z.pattern||{},z.pattern[j.pattern]=!0):C.set(B,{searchPath:j.searchPath,pattern:j.pattern?l(j.pattern):void 0})}),Array.from(C.values())}n(D){if(m.$jc(D)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==$.Schemas.file?[{searchPath:S[0].uri.with({path:D})}]:[{searchPath:b.URI.file(m.$ic(D))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(D=s(D),D.startsWith("../")||D===".."){const j=m.$hc.resolve(S.path,D);return[{searchPath:S.with({path:j})}]}const C=v(D);return[{searchPath:S,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const S=D.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(B=>{const z=S.match(new RegExp(`^${I.$af(B.name)}(?:/(.*)|$)`));return z?{match:z,folder:B}:null}).filter(P.$eg);if(j.length)return j.map(B=>{const z=B.match[1];return{searchPath:B.folder.uri,pattern:z&&v(z)}});{const B=D.match(/\.[\/\\](.+)[\/\\]?/),z=B?B[1]:D,T=p.localize(0,null,z);throw new Error(T)}}}}o(D,S){const C=D.pattern&&S?`${D.pattern}/${S}`:D.pattern||S,j=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&j.push({searchPath:D.searchPath,pattern:C+"/**"}),j}q(D,S,C){const j=this.r((0,u.$Ri)(D.searchPath),S,C,!1);return j?{...j,includePattern:D.pattern}:null}r(D,S,C,j){let B;const z=b.URI.isUri(D)?D:D.uri;if(C.searchPaths){const q=C.searchPaths.filter(Y=>(0,E.$3g)(Y.searchPath,z))[0];if(q&&!q.pattern)return null;q&&(B=q.pattern)}const T=this.a.getValue({resource:z}),F={...this.l(T,S)||{},...B||{}},O=b.URI.isUri(D)?(0,E.$7g)(D):D.name;return{folder:z,folderName:j?O:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!T.search.followSymlinks}}};e.$NM=o,e.$NM=o=Je([Ue(0,h.$3i),Ue(1,u.$Fi),Ue(2,n.$YD),Ue(3,g.$3j),Ue(4,i.$LM)],o);function t(w){const D=w.match(/[\*\{\}\(\)\[\]\?]/);if(D){const S=D.index,C=w.substr(0,S).match(/[/|\\][^/\\]*$/);if(C){let j=w.substr(0,C.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:w.substr((C.index||0)+1)}}}return{pathPortion:w}}function l(...w){return w.length?w.reduce((D,S)=>(D[S]=!0,D),Object.create(null)):void 0}function r(w){return A.$ok(w,",").map(D=>D.trim()).filter(D=>!!D.length)}function c(w){return[`**/${w}/**`,`**/${w}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function s(w){return w.replace(/\\/g,"/")}function v(w){return s(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(w){return w.replace(/([?*[\]])/g,"[$1]")}function y(w,D){w=a.$Mb(w,j=>j.toString());const S=[],C=D.getWorkspace();return w&&w.forEach(j=>{let B;if(D.getWorkbenchState()===2)B=(0,E.$_g)(C.folders[0].uri,j),B&&B!=="."&&(B="./"+B);else{const z=D.getWorkspaceFolder(j);if(z){const T=z.name;if(C.folders.filter(F=>F.name===T).length===1){const F=(0,E.$_g)(z.uri,j);F===""?B=`./${z.name}`:B=`./${z.name}/${F}`}else B=j.fsPath}}B&&S.push(f(B))}),S}}),define(ke[377],Se([1,0,23,2,22,13,5,376,37,43,7]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zwb=b,e.$Awb=h;const P=7e3;function b(g,u){const n=u.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],d=[];for(const s of n)if(/^workspaceContains:/.test(s)){const v=s.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||g.forceUsingSearch?d.push(v):i.push(v)}if(i.length===0&&d.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,I.$ph)(),l=s=>t({activationEvent:s}),r=Promise.all(i.map(s=>k(g,s,l))).then(()=>{}),c=p(g,u.identifier,d,l);return Promise.all([r,c]).then(()=>{t(void 0)}),o}async function k(g,u,n){for(const i of g.folders)if(await g.exists(a.$0g(N.URI.revive(i),u))){n(`workspaceContains:${u}`);return}}async function p(g,u,n,i){if(n.length===0)return Promise.resolve(void 0);const d=new A.$pe,o=g.checkExists(g.folders,n,d.token),t=setTimeout(async()=>{d.cancel(),g.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let l=!1;try{l=await o}catch(r){R.$4(r)||R.$1(r)}d.dispose(),clearTimeout(t),l&&i(`workspaceContains:${n.join(",")}`)}function h(g,u,n,i){const d=g.get(L.$vi),o=g.get(m.$lL),l=d.createInstance($.$NM).file(u.map(r=>(0,E.$Ri)(N.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(l,i).then(r=>!!r.limitHit,r=>R.$4(r)?!1:Promise.reject(r))}});var it=this&&this.__classPrivateFieldSet||function(ie,e,a,N,A){if(N==="m")throw new TypeError("Private method is not writable");if(N==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return N==="a"?A.call(ie,a):A?A.value=a:e.set(ie,a),a},qe=this&&this.__classPrivateFieldGet||function(ie,e,a,N){if(a==="a"&&!N)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!N:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?N:a==="a"?N.call(ie):N?N.value:e.get(ie)};define(ke[49],Se([1,0,225,17,59,23,7,3,78,2,11,6,45,309,120,39,26,150,13,25,21,287,8,67,5,28,93,20,107,71,44,123,4,377,119,289,15,117,41,12,118]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l,r,c,s,v,f,y,w,D,S,C,j,B,z,T,M,F,O){"use strict";var q,Y,V,J;Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=e.$fmc=void 0,e.$fmc=(0,r.$wi)("IHostUtils");let x=J=class extends $.$Vc{constructor($e,re,se,oe,K,te,ge,be,Re,pe,Pe,Ie,je){super(),this.Y=Ie,this.Z=je,this.a=this.B(new S.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=re,this.g=se,this.f=ge,this.j=oe,this.m=K,this.s=te,this.t=Re,this.u=pe,this.w=Pe,this.y=this.g.getProxy(P.$0M.MainThreadWorkspace),this.z=this.g.getProxy(P.$0M.MainThreadTelemetry),this.C=this.g.getProxy(P.$0M.MainThreadExtensionService),this.D=new L.$vh,this.F=new L.$vh,this.G=new L.$vh,this.H=new L.$vh,this.I=new le(this.f.extensions.activationEvents),this.L=new u.$U_b(this.I,this.f.extensions.allExtensions);const W=new i.$Tm(this.f.extensions.myExtensions);this.J=new u.$U_b(this.I,_(this.L,W)),F.$n&&(this.s.info(`Creating extension host with the following global extensions: ${ce(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ce(this.J)}`)),this.M=new p.$1lc(this.g,this.s),this.N=new j.$$lc(this.g),this.O=be,this.h=$e.createChild(new f.$ui([p.$2lc,this.M],[j.$_lc,this.N])),this.P=this.B(new k.$Zlc(this.J,this.L,{onExtensionActivationError:(Q,X,Z)=>{this.C.$onExtensionActivationError(Q,n.$3(X),Z)},actualActivateExtension:async(Q,X)=>{if(u.$U_b.isHostExtension(Q,this.J,this.L))return await this.C.$activateExtension(Q,X),new k.$Ylc;const Z=this.J.getExtensionDescription(Q);return this.fb(Z,X)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch($e){n.$1($e)}}async $(){this.O.onWillDeactivateAll();let $e=[];try{$e=this.J.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this.eb(K))}catch{}await Promise.all($e)}terminate($e,re=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${$e}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$xh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${re}`):this.s.info(`Extension host exiting with code ${re}`),this.s.flush(),this.s.dispose(),this.c.exit(re)})}isActivated($e){return this.G.isOpen()?this.P.isActivated($e):!1}async getExtension($e){const re=await this.C.$getExtension($e);return re&&{...re,identifier:new i.$Sm(re.identifier.value),extensionLocation:E.URI.revive(re.extensionLocation)}}ab($e,re){return this.P.activateByEvent($e,re)}bb($e,re){return this.P.activateById($e,re)}activateByIdWithErrors($e,re){return this.bb($e,re).then(()=>{const se=this.P.getActivatedExtension($e);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then($e=>this.J)}getExtensionExports($e){if(this.G.isOpen())return this.P.getActivatedExtension($e).exports;try{return this.P.getActivatedExtension($e).exports}catch{return null}}async cb($e){if($e.scheme===z.Schemas.file&&this.c.fsRealpath){const re=$e.fsPath;this.R.has(re)||this.R.set(re,this.c.fsRealpath(re));const se=await this.R.get(re);return E.URI.file(se)}return $e}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then($e=>new U($e))),this.Q}async db($e){const re=m.$Ci.forUris(se=>R.$1g.ignorePathCasing(se));return await Promise.all($e.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);re.set(oe,se)}})),re}eb($e){let re=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated($e))return re;const se=this.P.getActivatedExtension($e);if(!se)return re;try{typeof se.module.deactivate=="function"&&(re=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${$e.value}':`),this.s.error(oe)}try{(0,$.$Qc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${$e.value}':`),this.s.error(oe)}return re}async fb($e,re){return this.f.remote.isRemote?this.C.$onWillActivateExtension($e.identifier):await this.C.$onWillActivateExtension($e.identifier),this.hb($e,re).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension($e.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,re),this.gb($e,re,"success",oe),se},se=>{throw this.gb($e,re,"failure"),se})}gb($e,re,se,oe){const K=de($e,re);this.z.$publicLog2("extensionActivationTimes",{...K,...oe||{},outcome:se})}hb($e,re){const se=de($e,re);this.z.$publicLog2("activatePlugin",se);const oe=this.wb($e);if(!oe)return Promise.resolve(new k.$Xlc(k.$Ulc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${$e.identifier.value}, startup: ${re.startup}, activationEvent: '${re.activationEvent}'${$e.identifier.value!==re.extensionId.value?`, root cause: ${re.extensionId.value}`:""}`),this.s.flush();const K=new k.$Vlc(re.startup);return Promise.all([this.xb($e,(0,R.$0g)($e.extensionLocation,oe),K),this.ib($e)]).then(te=>(A.mark(`code/extHost/willActivateExtension/${$e.identifier.value}`),J.jb(this.s,$e.identifier,te[0],te[1],K))).then(te=>(A.mark(`code/extHost/didActivateExtension/${$e.identifier.value}`),te))}ib($e){const re=this.Z.createLanguageModelAccessInformation($e),se=new o.$4lc($e,this.M),oe=new o.$3lc($e.identifier.value,!1,this.M),K=new B.$amc($e,this.N),te=$e.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${$e.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const be=this;let Re,pe;const Pe=(0,g.$OG)($e,"ipc")?this.f.messagePorts?.get(i.$Sm.toKey($e.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:K,subscriptions:[],get languageModelAccessInformation(){return re},get extensionUri(){return $e.extensionLocation},get extensionPath(){return $e.extensionLocation.fsPath},asAbsolutePath(Ie){return N.$kc($e.extensionLocation.fsPath,Ie)},get storagePath(){return be.O.workspaceValue($e)?.fsPath},get globalStoragePath(){return be.O.globalValue($e).fsPath},get logPath(){return N.$kc(be.f.logsLocation.fsPath,$e.identifier.value)},get logUri(){return E.URI.joinPath(be.f.logsLocation,$e.identifier.value)},get storageUri(){return be.O.workspaceValue($e)},get globalStorageUri(){return be.O.globalValue($e)},get extensionMode(){return te},get extension(){return Re===void 0&&(Re=new ve(be,$e.identifier,$e,ge,!1)),Re},get extensionRuntime(){return(0,g.$PG)($e,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection($e)},get messagePassingProtocol(){if(!pe){if(!Pe)return;const Ie=S.Event.buffer(S.Event.fromDOMEventEmitter(Pe,"message",je=>je.data));Pe.start(),pe={onDidReceiveMessage:Ie,postMessage:Pe.postMessage.bind(Pe)}}return pe}})})}static jb($e,re,se,oe,K){return se=se||{activate:void 0,deactivate:void 0},this.kb($e,re,se,oe,K).then(te=>new k.$Wlc(!1,null,K.build(),se,te,oe.subscriptions))}static kb($e,re,se,oe,K){if(typeof se.activate=="function")try{K.activateCallStart(),$e.trace(`ExtensionService#_callActivateOptional ${re.value}`);const te=typeof global=="object"?global:self,ge=se.activate.apply(te,[oe]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ge).then(be=>(K.activateResolveStop(),be))}catch(te){return Promise.reject(te)}else return Promise.resolve(se)}lb($e,re){this.bb($e.identifier,{startup:!1,extensionId:$e.identifier,activationEvent:re}).then(void 0,se=>{this.s.error(se)})}mb($e,re=0){const oe=Date.now();(0,F.$v)(()=>{for(let K=re;K<$e.length;K+=1){const te=$e[K];for(const ge of te.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-oe>50){this.mb($e,K);break}else this.lb(te,ge)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then($e=>{const re=$e.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(re)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const K of oe.activationEvents)K==="onStartupFinished"&&this.lb(oe,K)})}ob(){const $e=this.ab("*",!0).then(void 0,te=>{this.s.error(te)});this.B(this.j.onDidChangeWorkspace(te=>this.pb(te.added)));const re=this.j.workspace?this.j.workspace.folders:[],se=this.pb(re),oe=this.rb(),K=Promise.all([oe,$e,se]).then(()=>{});return Promise.race([K,(0,L.$xh)(1e4)]).then(()=>{this.nb()}),K}pb($e){return $e.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(re=>this.qb($e,re))).then(()=>{})}async qb($e,re){if(this.isActivated(re.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:$e.map(te=>te.uri),forceUsingSearch:se||!this.c.fsExists,exists:te=>this.c.fsExists(te.fsPath),checkExists:(te,ge,be)=>this.y.$checkExists(te,ge,be)},K=await(0,C.$zwb)(oe,re);if(K)return this.bb(re.identifier,{startup:!0,extensionId:re.identifier,activationEvent:K.activationEvent}).then(void 0,te=>this.s.error(te))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch($e){throw console.error($e),$e}}async sb(){const{extensionDevelopmentLocationURI:$e,extensionTestsLocationURI:re}=this.f.environment;if(!$e||!re)throw new Error(a.localize(0,null));const se=await this.xb(null,re,new k.$Vlc(!1));if(!se||typeof se.run!="function")throw new Error(a.localize(1,null,re.toString()));return new Promise((oe,K)=>{const te=(Re,pe)=>{Re?(F.$n&&this.s.error("Test runner called back with error",Re),K(Re)):(F.$n&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof pe=="number"&&pe>0?1:0))},ge=(0,R.$Xg)(re),be=se.run(ge,te);be&&be.then&&be.then(()=>{F.$n&&this.s.info("Test runner finished successfully."),oe(0)}).catch(Re=>{F.$n&&this.s.error("Test runner finished with error",Re),K(Re instanceof Error&&Re.stack?Re.stack:String(Re))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver($e,re){return this.S[$e]=re,(0,$.$Tc)(()=>{delete this.S[$e]})}async getRemoteExecServer($e){const{resolver:re}=await this.ub($e);return re?.resolveExecServer?.($e,{resolveAttempt:0})}async ub($e){const re=$e.indexOf("+");if(re===-1)throw new t.$fN("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=$e.substr(0,re);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority($e,re){const se=M.$ae.create(!1),oe=()=>`[resolveAuthority(${(0,l.$Ll)($e)},${re})][${se.elapsed()}ms] `,K=he=>this.s.info(`${oe()}${he}`),te=he=>this.s.warn(`${oe()}${he}`),ge=(he,we=void 0)=>this.s.error(`${oe()}${he}`,we),be=he=>{if(he instanceof t.$fN)return{type:"error",error:{code:he._code,message:he._message,detail:he._detail}};throw he},Re=async he=>{K(`activating resolver for ${he}...`);const{resolver:we,authorityPrefix:Te}=await this.ub(he);if(!we)throw ge(`no resolver for ${Te}`),new t.$fN(`No remote extension installed to resolve ${Te}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:we,authorityPrefix:Te,remoteAuthority:he}},pe=$e.split(/@|%40/g).reverse();K(`activating remote resolvers ${pe.join(" -> ")}`);let Pe;try{Pe=await Promise.all(pe.map(Re)).catch(async he=>{if(!(he instanceof t.$fN)||he._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw he;return te(`resolving nested authorities failed: ${he.message}`),[await Re($e)]})}catch(he){return be(he)}const Ie=new L.$Hh;Ie.cancelAndSet(()=>K("waiting..."),1e3);let je,W;for(const[he,{authorityPrefix:we,resolver:Te,remoteAuthority:He}]of Pe.entries())try{if(he===Pe.length-1)K("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${we}`),je=await Te.resolve(He,{resolveAttempt:re,execServer:W}),A.mark(`code/extHost/didResolveAuthorityOK/${we}`),K("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Te,t.$eN.isManagedResolvedAuthority(je)?je:void 0));else{if(K(`invoking resolveExecServer() for ${He}`),A.mark(`code/extHost/willResolveExecServer/${we}`),W=await Te.resolveExecServer?.(He,{resolveAttempt:re,execServer:W}),!W)throw new t.$fN(`Exec server was not available for ${He}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${we}`)}}catch(Xe){return A.mark(`code/extHost/didResolveAuthorityError/${we}`),ge("returned an error",Xe),Ie.dispose(),be(Xe)}Ie.dispose();const Q={environmentTunnels:je.environmentTunnels,features:je.tunnelFeatures?{elevation:je.tunnelFeatures.elevation,privacyOptions:je.tunnelFeatures.privacyOptions,protocol:je.tunnelFeatures.protocol===void 0?!0:je.tunnelFeatures.protocol}:void 0},X={extensionHostEnv:je.extensionHostEnv,isTrusted:je.isTrusted,authenticationSession:je.authenticationSessionForInitializingExtensions?{id:je.authenticationSessionForInitializingExtensions.id,providerId:je.authenticationSessionForInitializingExtensions.providerId}:void 0};K(`returned ${t.$eN.isManagedResolvedAuthority(je)?"managed authority":`${je.host}:${je.port}`}`);let Z;if(t.$eN.isManagedResolvedAuthority(je)){const he=re;this.Y.setFactory(he,je.makeConnection),Z={authority:$e,connectTo:new l.$Il(he),connectionToken:je.connectionToken}}else Z={authority:$e,connectTo:new l.$Jl(je.host,je.port),connectionToken:je.connectionToken};return{type:"ok",value:{authority:Z,options:X,tunnelInformation:Q}}}async $getCanonicalURI($e,re){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Ll)($e)})`);const{resolver:se}=await this.ub($e);if(!se)return null;const oe=E.URI.revive(re);if(typeof se.getCanonicalURI>"u")return oe;const K=await(0,L.$oh)(()=>se.getCanonicalURI(oe));return K||oe}async $startExtensionHost($e){$e.toAdd.forEach(te=>te.extensionLocation=E.URI.revive(te.extensionLocation));const{globalRegistry:re,myExtensions:se}=ne(this.I,this.L,this.J,$e),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(re.getAllExtensionDescriptions()),this.J.set(se),F.$n&&(this.s.info(`$startExtensionHost: global extensions: ${ce(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ce(this.J)}`)),this.tb()}$activateByEvent($e,re){return re===1?this.D.wait().then(se=>this.ab($e,!1)):this.G.wait().then(se=>this.ab($e,!1))}async $activate($e,re){return await this.G.wait(),this.J.getExtensionDescription($e)?(await this.bb($e,re),!0):!1}async $deltaExtensions($e){$e.toAdd.forEach(te=>te.extensionLocation=E.URI.revive(te.extensionLocation));const{globalRegistry:re,myExtensions:se}=ne(this.I,this.L,this.J,$e),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(re.getAllExtensionDescriptions()),this.J.set(se),F.$n&&(this.s.info(`$deltaExtensions: global extensions: ${ce(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ce(this.J)}`)),Promise.resolve(void 0)}async $test_latency($e){return $e}async $test_up($e){return $e.byteLength}async $test_down($e){const re=d.$Ge.alloc($e),se=Math.random()%256;for(let oe=0;oe<$e;oe++)re.writeUInt8(se,oe);return re}async $updateRemoteConnectionData($e){this.X=$e,this.a.fire()}};e.$gmc=x,e.$gmc=x=J=Je([Ue(0,r.$vi),Ue(1,e.$fmc),Ue(2,v.$xP),Ue(3,h.$Dlc),Ue(4,b.$Glc),Ue(5,I.$3j),Ue(6,c.$NP),Ue(7,s.$Jlc),Ue(8,y.$FDb),Ue(9,w.$5lc),Ue(10,T.$cmc),Ue(11,O.$dmc),Ue(12,D.$9lc)],x);function ne(De,$e,re,se){De.addActivationEvents(se.addActivationEvents);const oe=new u.$U_b(De,$e.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const K=new i.$Tm(re.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of se.myToRemove)K.delete(ge);for(const ge of se.myToAdd)K.add(ge);const te=_(oe,K);return{globalRegistry:oe,myExtensions:te}}function de(De,$e){return{id:De.identifier.value,name:De.name,extensionVersion:De.version,publisherDisplayName:De.publisher,activationEvents:De.activationEvents?De.activationEvents.join(","):null,isBuiltin:De.isBuiltin,reason:$e.activationEvent,reasonId:$e.extensionId.value}}function ce(De){return De.getAllExtensionDescriptions().map($e=>$e.identifier.value).join(",")}e.$hmc=(0,r.$wi)("IExtHostExtensionService");class ve{constructor($e,re,se,oe,K){q.set(this,void 0),Y.set(this,void 0),V.set(this,void 0),it(this,q,$e,"f"),it(this,Y,re,"f"),it(this,V,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=N.$ic((0,R.$Xg)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=K}get isActive(){return qe(this,q,"f").isActivated(qe(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return qe(this,q,"f").getExtensionExports(qe(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await qe(this,q,"f").activateByIdWithErrors(qe(this,V,"f"),{startup:!1,extensionId:qe(this,Y,"f"),activationEvent:"api"}),this.exports}}e.$imc=ve,q=new WeakMap,Y=new WeakMap,V=new WeakMap;function _(De,$e){return De.getAllExtensionDescriptions().filter(re=>$e.has(re.identifier))}class U{constructor($e){this.a=$e}setSearchTree($e){this.a=$e}findSubstr($e){return this.a.findSubstr($e)}forEach($e){return this.a.forEach($e)}}e.$jmc=U;class le{constructor($e){this.a=new i.$Um,this.addActivationEvents($e)}readActivationEvents($e){return this.a.get($e.identifier)??[]}addActivationEvents($e){for(const re of Object.keys($e))this.a.set(re,$e[re])}}}),define(ke[378],Se([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let h=class{constructor(d,o,t,l,r,c,s){this.c=d,this.d=o,this.f=t,this.g=l,this.h=r,this.i=c,this.j=s,this.a=new Map,this.b=[]}async install(){this.k(),a.mark("code/extHost/willWaitForConfig");const d=await this.g.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const o=await this.h.getExtensionPathIndex();this.register(new u(this.c,o,this.d,d,this.j)),this.register(this.f.createInstance(g)),this.i.remote.isRemote&&this.register(this.f.createInstance(n,o,this.i.environment.appUriScheme))}register(d){if("nodeModuleName"in d)if(Array.isArray(d.nodeModuleName))for(const o of d.nodeModuleName)this.a.set(o,d);else this.a.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this.b.push(o=>d.alternativeModuleName(o))}};e.$snc=h,e.$snc=h=Je([Ue(2,I.$vi),Ue(3,R.$Glc),Ue(4,P.$hmc),Ue(5,E.$NP),Ue(6,b.$3j)],h);let g=p=class{constructor(d){if(d.environment.appRoot&&p.a.size){const o=(0,k.$af)(this.c(d.environment.appRoot.fsPath)),t="[a-z0-9_.-]",l=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${r}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(d){if(!this.b)return;const o=this.b.exec(this.c(d));if(!o)return;const[,t,l,r]=o,c=p.a.get(l);if(c!==void 0)return console.warn(`${l} as been renamed to ${c}, please update your imports`),t+c+r}c(d){return d.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=p=Je([Ue(0,E.$NP)],g);class u{constructor(d,o,t,l,r){this.c=d,this.d=o,this.e=t,this.f=l,this.g=r,this.nodeModuleName="vscode",this.a=new $.$Um}load(d,o){const t=this.d.findSubstr(o);if(t){let l=this.a.get(t.identifier);return l||(l=this.c(t,this.e,this.f),this.a.set(t.identifier,l)),l}if(!this.b){let l="";this.d.forEach((r,c)=>l+=`	${c} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${l}`),this.b=this.c(L.$JG,this.e,this.f)}return this.b}}let n=class{constructor(d,o,t){this.e=d,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$0M.MainThreadTelemetry);const l=t.getProxy(A.$0M.MainThreadWindow);this.c=(r,c)=>{const s=N.URI.parse(r);return c?this.g(r,c):s.scheme==="http"||s.scheme==="https"?l.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?l.$openUri(s,r,{}):this.g(r,c)}}load(d,o,t){const l=this.e.findSubstr(o);return l&&(this.a=l.identifier.value,this.h()),this.b=t(d),this.c}g(d,o){return this.i(),this.b(d,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ue(2,m.$xP)],n)}),define(ke[61],Se([1,0,46,3,17,50,5,73,72,49,8,39,306,45]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0,e.$kmc=(0,L.$wi)("IExtHostVariableResolverProvider");class p extends b.$zQ{constructor(u,n,i,d,o,t,l){function r(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const s=d.tabGroups.all.find(v=>v.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof I.$XO||s.input instanceof I.$3O)return s.input.modified;if(s.input instanceof I.$WO||s.input instanceof I.$2O||s.input instanceof I.$ZO)return s.input.uri}}}super({getFolderUri:c=>{const s=t.folders.filter(v=>v.name===c);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,s)=>o.getConfiguration(void 0,c).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return A.$ic(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const c=r();if(c){const s=n.getWorkspaceFolder(c);if(s)return A.$ic(s.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>u.getExtension(c)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(R.env))}}let h=class extends N.$Vc{constructor(u,n,i,d,o){super(),this.b=u,this.c=n,this.g=i,this.h=d,this.j=o,this.a=new a.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$lmc=h,e.$lmc=h=Je([Ue(0,E.$hmc),Ue(1,P.$Dlc),Ue(2,$.$IP),Ue(3,k.$Glc),Ue(4,m.$Slc)],h)}),define(ke[96],Se([1,0,7,4,2,25,5,6,72,49,20,8,39,145,298,45,61,3,51,34,16]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=e.$omc=e.$nmc=e.$mmc=void 0,e.$mmc=(0,L.$wi)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,y,w,D,S,C,j){this.N=y,this.O=w,this.P=D,this.Q=S,this.R=C,this.S=j,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$ee,this.o=new N.$ee,this.q=new N.$ee,this.w=new N.$ee,this.l=f.getProxy($.$0M.MainThreadDebugService),this.A=new N.$ee,this.C=new N.$ee,this.y=new l(this.l),this.z=new Map,this.O.getExtensionRegistry().then(B=>{B.onDidChange(z=>{this.V(B)}),this.V(B)})}async $getVisualizerTreeItem(f,y){const w=this.W(y);if(!w)return;const D=await this.H.get(f)?.getTreeItem?.(w);return D?this.U(f,D):void 0}registerDebugVisualizationTree(f,y,w){const D=R.$Sm.toKey(f.identifier),S=this.jb(D,y);if(this.G.has(S))throw new Error(`A debug visualization provider with id '${y}' is already registered`);return this.H.set(S,w),this.l.$registerDebugVisualizerTree(S,!!w.editItem),(0,u.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(S),this.H.delete(y)})}async $getVisualizerTreeItemChildren(f,y){const w=this.J.get(y)?.item;return w?(await this.H.get(f)?.getChildren?.(w))?.map(S=>this.U(f,S))||[]:[]}async $editVisualizerTreeItem(f,y){const w=this.J.get(f);if(!w)return;const D=await this.H.get(w.provider)?.editItem?.(w.item,y);return this.U(w.provider,D||w.item)}$disposeVisualizedTree(f){const y=this.J.get(f);if(!y)return;const w=[y.children];for(const D of w)if(D)for(const S of D)w.push(this.J.get(S)?.children),this.J.delete(S)}U(f,y){let w=this.I.get(y);return w||(w=this.F++,this.I.set(y,w),this.J.set(w,{provider:f,item:y})),d.DebugTreeItem.from(y,w)}asDebugSourceUri(f,y){const w=f;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let D=`debug:${encodeURIComponent(w.path||"")}`,S="?";return y&&(D+=`${S}session=${encodeURIComponent(y.id)}`,S="&"),D+=`${S}ref=${w.sourceReference}`,A.URI.parse(D)}else{if(w.path)return A.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const y=[];for(const w of f.getAllExtensionDescriptions())if(w.contributes){const D=w.contributes.debuggers;if(D&&D.length>0)for(const S of D)(0,p.$tH)(S)&&y.push(S.type)}this.l.$registerDebugTypes(y)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(y=>f.push(y)),f}async $resolveDebugVisualizer(f,y){const w=this.L.get(f);if(!w)throw new Error(`No debug visualizer found with id '${f}'`);let{v:D,provider:S,extensionId:C}=w;if(D.visualization||(D=await S.resolveDebugVisualization?.(D,y)||D,w.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${S}'`);return this.kb(C,D.visualization)}async $executeDebugVisualizerCommand(f){const y=this.L.get(f);if(!y)throw new Error(`No debug visualizer found with id '${f}'`);const w=y.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(f){const y=this.m.get(f.sessionId);return y&&{session:y.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,y,w,D){const S=this.W(w),C=this.jb(f,y),j=this.G.get(C);if(!S||!j)return[];const B=await j.provideDebugVisualization(S,D);return B?B.map(z=>{const T=++this.M;this.L.set(T,{v:z,provider:j,extensionId:f});const M=z.iconPath?this.lb(z.iconPath):void 0;return{id:T,name:z.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.kb(f,z.visualization)}}):[]}$disposeDebugVisualizers(f){for(const y of f)this.L.delete(y)}registerDebugVisualizationProvider(f,y,w){if(!f.contributes?.debugVisualizers?.some(C=>C.id===y))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${y})`);const D=R.$Sm.toKey(f.identifier),S=this.jb(D,y);if(this.G.has(S))throw new Error(`A debug visualization provider with id '${y}' is already registered`);return this.G.set(S,w),this.l.$registerDebugVisualizer(D,y),(0,u.$Tc)(()=>{this.l.$unregisterDebugVisualizer(D,y),this.G.delete(y)})}addBreakpoints(f){const y=f.filter(S=>{const C=S.id;return this.z.has(C)?!1:(this.z.set(C,S),!0)});this.gb(y,[],[]);const w=[],D=new Map;for(const S of y)if(S instanceof P.$bO){let C=D.get(S.location.uri.toString());C||(C={type:"sourceMulti",uri:S.location.uri,lines:[]},D.set(S.location.uri.toString(),C),w.push(C)),C.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character,mode:S.mode})}else S instanceof P.$cO&&w.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName,mode:S.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(f){const y=f.filter(C=>this.z.delete(C.id));this.gb([],y,[]);const w=y.filter(C=>C instanceof P.$bO).map(C=>C.id),D=y.filter(C=>C instanceof P.$cO).map(C=>C.id),S=y.filter(C=>C instanceof P.$dO).map(C=>C.id);return this.l.$unregisterBreakpoints(w,D,S)}startDebugging(f,y,w){return this.l.$startDebugging(f?f.uri:void 0,y,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,y,w){if(!y)return new P.$_M(()=>{});const D=this.d++;return this.f.push({type:f,handle:D,provider:y}),this.l.$registerDebugConfigurationProvider(f,w,!!y.provideDebugConfigurations,!!y.resolveDebugConfiguration,!!y.resolveDebugConfigurationWithSubstitutedVariables,D),new P.$_M(()=>{this.f=this.f.filter(S=>S.provider!==y),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(f,y,w){if(!w)return new P.$_M(()=>{});if(!this.cb(f,y))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${y}' debugger.`);if(this.$(y))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:y,handle:D,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(y,D),new P.$_M(()=>{this.h=this.h.filter(S=>S.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(f,y){if(!y)return new P.$_M(()=>{});const w=this.j++;return this.k.push({type:f,handle:w,factory:y}),new P.$_M(()=>{this.k=this.k.filter(D=>D.factory!==y)})}async $runInTerminal(f,y){return Promise.resolve(void 0)}async $substituteVariables(f,y){let w;const D=await this.ib(f);return D&&(w={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,y)}X(f,y){if(f.type==="implementation")return new c(f.implementation)}Y(){}async $startDASession(f,y){const w=this,D=await this.hb(y);return this.eb(this.$(D.type),D).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const C=this.Z(S),j=this.X(C,D);if(!j)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const B=j;return this.D.set(f,B),this.db(D).then(z=>(z&&this.E.set(f,z),B.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const M=T,F={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const O=await this.K.sign(M.arguments.value);F.body={signature:O},B.sendResponse(F)}else throw new Error("no signer")}catch(O){F.success=!1,F.message=O.message,B.sendResponse(F)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(T),T=(0,p.$yH)(T,!0),w.l.$acceptDAMessage(f,T)}),B.onError(T=>{z&&z.onError&&z.onError(T),this.l.$acceptDAError(f,T.name,T.message,T.stack)}),B.onExit(T=>{z&&z.onExit&&z.onExit(T??void 0,void 0),this.l.$acceptDAExit(f,T??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),B.startSession()))})}$sendDAMessage(f,y){y=(0,p.$xH)(y,!1);const w=this.E.get(f);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(y),this.D.get(f)?.sendMessage(y)}$stopDASession(f){const y=this.E.get(f);this.E.delete(f),y&&y.onWillStopSession&&y.onWillStopSession();const w=this.D.get(f);return this.D.delete(f),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const y=[],w=[],D=[];if(f.added)for(const S of f.added){const C=S.id;if(C&&!this.z.has(C)){let j;if(S.type==="function")j=new P.$cO(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode);else if(S.type==="data")j=new P.$dO(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage,S.mode);else{const B=A.URI.revive(S.uri);j=new P.$bO(new P.$lN(B,new P.$aN(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode)}(0,P.$_N)(j,C),this.z.set(C,j),y.push(j)}}if(f.removed)for(const S of f.removed){const C=this.z.get(S);C&&(this.z.delete(S),w.push(C))}if(f.changed){for(const S of f.changed)if(S.id){const C=this.z.get(S.id);if(C){if(C instanceof P.$cO&&S.type==="function"){const j=C;j.enabled=S.enabled,j.condition=S.condition,j.hitCondition=S.hitCondition,j.logMessage=S.logMessage,j.functionName=S.functionName}else if(C instanceof P.$bO&&S.type==="source"){const j=C;j.enabled=S.enabled,j.condition=S.condition,j.hitCondition=S.hitCondition,j.logMessage=S.logMessage,j.location=new P.$lN(A.URI.revive(S.uri),new P.$aN(S.line,S.character))}D.push(C)}}}this.gb(y,w,D)}async $acceptStackFrameFocus(f){let y;if(f){const w=await this.hb(f.sessionId);f.kind==="thread"?y=new P.$jO(w.api,f.threadId):y=new P.$iO(w.api,f.threadId,f.frameId)}this.B=y,this.C.fire(this.B)}$provideDebugConfigurations(f,y,w){return(0,a.$oh)(async()=>{const D=this.bb(f);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.ib(y);return D.provideDebugConfigurations(S,w)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(f,y,w,D){return(0,a.$oh)(async()=>{const S=this.bb(f);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(y);return S.resolveDebugConfiguration(C,w,D)})}$resolveDebugConfigurationWithSubstitutedVariables(f,y,w,D){return(0,a.$oh)(async()=>{const S=this.bb(f);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(y);return S.resolveDebugConfigurationWithSubstitutedVariables(C,w,D)})}async $provideDebugAdapter(f,y){const w=this.ab(f);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(y);return this.eb(w,D).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(S)})}async $acceptDebugSessionStarted(f){const y=await this.hb(f);this.n.fire(y.api)}async $acceptDebugSessionTerminated(f){const y=await this.hb(f);y&&(this.o.fire(y.api),this.m.delete(y.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,y){(await this.hb(f))?._acceptNameChanged(y)}async $acceptDebugSessionCustomEvent(f,y){const D={session:(await this.hb(f)).api,event:y.event,body:y.body};this.w.fire(D)}Z(f){if(f instanceof P.$eO)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof P.$fO)return{type:"server",port:f.port,host:f.host};if(f instanceof P.$gO)return{type:"pipeServer",path:f.path};if(f instanceof P.$hO)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const y=this.h.filter(w=>w.type===f);if(y.length>0)return y[0].factory}ab(f){const y=this.h.filter(w=>w.handle===f);if(y.length>0)return y[0].factory}bb(f){const y=this.f.filter(w=>w.handle===f);if(y.length>0)return y[0].provider}cb(f,y){if(f.contributes){const w=f.contributes.debuggers;if(w&&w.length>0){for(const D of w)if(D.label&&D.type&&D.type===y)return!0}}return!1}db(f){const w=f.configuration.type,D=this.k.filter(S=>S.type===w||S.type==="*").map(S=>(0,a.$oh)(()=>S.factory.createDebugAdapterTracker(f.api)).then(C=>C,C=>null));return Promise.race([Promise.all(D).then(S=>{const C=S.filter(j=>!!j);if(C.length>0)return new r(C)}),new Promise(S=>setTimeout(()=>S(void 0),1e3))]).catch(S=>{})}async eb(f,y){const w=y.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new P.$fO(w));if(f){const S=await this.O.getExtensionRegistry();return(0,a.$oh)(()=>f.createDebugAdapterDescriptor(y.api,this.fb(y,S))).then(C=>{if(C)return C})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(y,D))}fb(f,y){}gb(f,y,w){(f.length>0||y.length>0||w.length>0)&&this.A.fire(Object.freeze({added:f,removed:y,changed:w}))}async hb(f){if(f)if(typeof f=="string"){const y=this.m.get(f);if(y)return y}else{let y=this.m.get(f.id);if(!y){const w=await this.ib(f.folderUri),D=f.parent?this.m.get(f.parent):void 0;y=new t(this.l,f.id,f.type,f.name,w,f.configuration,D?.api),this.m.set(y.id,y),this.l.$sessionCached(y.id)}return y}throw new Error("cannot find session")}ib(f){if(f){const y=A.URI.revive(f);return this.N.resolveWorkspaceFolder(y)}return Promise.resolve(void 0)}jb(f,y){return`${f}\0${y}`}kb(f,y){if(y){if("title"in y&&"command"in y)return{type:0};if("treeId"in y)return{type:1,id:`${f}\0${y.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const y=this.mb(f);let w,D;return"id"in y?D=n.ThemeIcon.asClassName(y):w=y,{iconPath:w,iconClass:D}}mb(f){if(f instanceof P.$9N)return{id:f.id};const y=typeof f=="object"&&"dark"in f?f.dark:f,w=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof y=="string"?A.URI.file(y):y,light:typeof w=="string"?A.URI.file(w):w}}};e.$nmc=o,e.$nmc=o=Je([Ue(0,I.$xP),Ue(1,b.$Dlc),Ue(2,E.$hmc),Ue(3,h.$Glc),Ue(4,m.$Slc),Ue(5,g.$kmc),Ue(6,i.$TP)],o);class t{constructor(f,y,w,D,S,C,j){this.f=f,this.g=y,this.h=w,this.j=D,this.k=S,this.l=C,this.m=j}get api(){const f=this;return this.d??(this.d=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(y){f.j=y,f.f.$setDebugSessionName(f.g,y)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(y,w){return f.f.$customDebugAdapterRequest(f.g,y,w)},getDebugProtocolBreakpoint(y){return f.f.$getDebugProtocolBreakpoint(f.g,y.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$omc=t;class l{constructor(f){this.value=Object.freeze({append(y){f.$appendDebugConsole(y)},appendLine(y){this.append(y+`
`)}})}}e.$pmc=l;class r{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(y=>y.onWillReceiveMessage?y.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(y=>y.onDidSendMessage?y.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(y=>y.onError?y.onError(f):void 0)}onExit(f,y){this.d.forEach(w=>w.onExit?w.onExit(f,y):void 0)}}class c extends k.$Vrb{constructor(f){super(),this.h=f,f.onDidSendMessage(y=>{this.acceptMessage(y)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(f,y,w,D,S,C,j){super(f,y,w,D,S,C,j)}};e.$qmc=s,e.$qmc=s=Je([Ue(0,I.$xP),Ue(1,b.$Dlc),Ue(2,E.$hmc),Ue(3,h.$Glc),Ue(4,m.$Slc),Ue(5,g.$kmc),Ue(6,i.$TP)],s)}),define(ke[379],Se([1,0,13,59,2,6,326,11,85,107,28,263,20,68,49,90]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0;class g{static async installEarlyHandler(i){Error.stackTraceLimit=100;const d=i.get($.$3j),t=i.get(b.$xP).getProxy(R.$0M.MainThreadErrors);a.setUnexpectedErrorHandler(l=>{d.error(l);const r=a.$3(l);t.$onUnexpectedError(r)})}static async installFullHandler(i){const d=i.get($.$3j),o=i.get(b.$xP),t=i.get(p.$hmc),l=i.get(h.$RP),r=o.getProxy(R.$0M.MainThreadExtensionService),c=o.getProxy(R.$0M.MainThreadErrors),s=await t.getExtensionPathIndex(),v=new WeakMap;function f(D,S){if(v.has(D))return v.get(D).stack;let C="",j,B;for(const T of S)C+=`
	at ${T.toString()}`,B=T.getFileName(),!j&&B&&(j=s.findSubstr(A.URI.file(B)));const z=`${D.name||"Error"}: ${D.message||""}${C}`;return v.set(D,{extensionIdentifier:j?.identifier,stack:z}),z}const y=Symbol("prepareStackTrace wrapped");let w=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(D){if(D===f||!D||D[y]){w=D||f;return}w=function(S,C){return f(S,C),D.call(Error,S,C)},Object.assign(w,{[y]:!0})}}),a.setUnexpectedErrorHandler(D=>{d.error(D);const S=a.$3(D),C=v.get(D);if(!C?.extensionIdentifier){c.$onUnexpectedError(S);return}r.$onExtensionRuntimeError(C.extensionIdentifier,S);const j=l.onExtensionError(C.extensionIdentifier,D);d.trace("forwarded error to extension?",j,C)})}}e.$tnc=g;class u{constructor(i,d,o,t,l){this.a=o,this.b=new L.$3_b(i,null,t),d=u.e(d,this.b);const r=new E.$ui(...(0,m.$zs)());r.set(I.$NP,{_serviceBrand:void 0,...d,messagePorts:l}),r.set(b.$xP,new b.$yP(this.b)),r.set(k.$Alc,new k.$Blc(t)),r.set(p.$fmc,o);const c=new P.$dr(r,!0);c.invokeFunction(g.installEarlyHandler),this.d=c.invokeFunction(s=>s.get($.$3j)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",d),this.c=c.invokeFunction(s=>s.get(p.$hmc)),this.c.initialize(),c.invokeFunction(g.installFullHandler)}async asBrowserUri(i){const d=this.b.getProxy(R.$0M.MainThreadExtensionService);return A.URI.revive(await d.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,d){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(d.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=A.URI.revive(d.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>A.URI.revive(d.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=A.URI.revive(d.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=A.URI.revive(d.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=A.URI.revive(d.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=A.URI.revive(d.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=A.URI.revive(d.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=A.URI.revive(d.transformIncomingURIs(i.logsLocation)),i.workspace=d.transformIncomingURIs(i.workspace),i}}e.$unc=u}),define(ke[380],Se([1,0,7,12,236,256,142,96,72,49,20,44,8,61,39,299,300,45,34]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;let i=class extends $.$nmc{constructor(r,c,s,v,f,y,w,D){super(r,c,s,v,y,w,D),this.pb=f,this.nb=new t}X(r,c){switch(r.type){case"server":return new h.$znc(r);case"pipeServer":return new h.$Anc(r);case"executable":return new h.$Bnc(r,c.type)}return super.X(r,c)}fb(r,c){const s=h.$Bnc.platformAdapterExecutable(c.getAllExtensionDescriptions(),r.type);if(s)return new b.$eO(s.command,s.args,s.options)}Y(){return new L.$Pdc}async $runInTerminal(r,c){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(T=>{this.nb.onTerminalClosed(T)}));const s=await this.P.getConfigProvider(),v=this.pb.getDefaultShell(!0),f=this.pb.getDefaultShellArgs(!0),y=r.title||A.localize(0,null),w=JSON.stringify({shell:v,shellArgs:f});let D=await this.nb.checkout(w,y),S,C=!1;if(D)S=r.cwd;else{const T={shellPath:v,shellArgs:f,cwd:r.cwd,name:y,iconPath:new b.$9N("debug")};C=!0,D=this.pb.createTerminalFromOptions(T,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(D,w)}D.show(!0);const j=await D.processId;C?await new Promise(T=>setTimeout(T,1e3)):(D.state.isInteractedWith&&D.sendText(""),s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0||v.indexOf("cmd.exe")>=0?D.sendText("cls"):v.indexOf("bash")>=0?D.sendText("clear"):N.$c?D.sendText("cls"):D.sendText("clear")));const B=(0,g.$Dnc)(v,r.args,!!r.argsCanBeInterpretedByShell,S,r.env);D.sendText(B);const z=this.onDidTerminateDebugSession(T=>{T.id===c&&(this.nb.free(D),z.dispose())});return j}else if(r.kind==="external")return o(r,await this.P.getConfigProvider());return super.$runInTerminal(r,c)}};e.$Enc=i,e.$Enc=i=Je([Ue(0,I.$xP),Ue(1,p.$Dlc),Ue(2,E.$hmc),Ue(3,u.$Glc),Ue(4,P.$5lc),Ue(5,m.$Slc),Ue(6,k.$kmc),Ue(7,n.$TP)],i);let d;function o(l,r){if(!d)if(N.$c)d=new R.$Acc;else if(N.$d)d=new R.$Bcc;else if(N.$e)d=new R.$Ccc;else throw new Error("external terminals not supported on this platform");const c=r.getConfiguration("terminal");return d.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}class t{constructor(){this.b=new Map}async checkout(r,c,s=!1){const f=[...this.b.entries()].map(([y,w])=>(0,a.$jh)(async D=>{if(y.name!==c||w.lastUsedAt!==-1&&await(0,g.$Cnc)(await y.processId))return null;const S=Date.now();return w.lastUsedAt+t.a>S||D.isCancellationRequested?null:w.config!==r?(s&&y.dispose(),null):(w.lastUsedAt=S,y)}));return await(0,a.$Bh)(f,y=>!!y)}insert(r,c){this.b.set(r,{lastUsedAt:Date.now(),config:c})}free(r){const c=this.b.get(r);c&&(c.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}t.a=1e3}),define(ke[381],Se([1,0,17,2,104,39,73,45,43,44,20,28,95,15,11,91,23,63,61]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;let i=class extends b.$9mc{constructor(o,t,l,r,c,s,v,f,y){super(o,t,l,r,c,s,v,f),this.C=l,this.D=y,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const l=t;if(!t.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const r=b.TaskHandleDTO.from(l,this.C),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.z(c,t);return this.a.$executeTask(r).catch(()=>{}),s}else{const r=b.TaskDTO.from(t,o);if(r===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const c=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),c}}v(o,t,l,r){const c=[];if(r)for(const s of r){this.A(s,l),(!s.definition||!o[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const v=b.TaskDTO.from(s,l.extension);v&&(c.push(v),b.CustomExecutionDTO.is(v.execution)&&t.push(this.y(v,s,!0)))}return{tasks:c,extension:l.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const l=N.URI.file((0,u.homedir)());t=new m.$Qi({uri:l,name:g.$7g(l),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const l=N.URI.revive(o),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(l),s=await this.b.getWorkspaceFolders2()??[],v=await this.D.getResolver(),f=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(s);for(const y of t.variables)r.variables[y]=await v.resolveAsync(f,y);if(t.process!==void 0){let y;if(t.process.path!==void 0){y=t.process.path.split(a.$uc);for(let w=0;w<y.length;w++)y[w]=await v.resolveAsync(f,y[w])}r.process=await A.win32.findExecutable(await v.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(f,t.process.cwd):void 0,y)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,l){return A.win32.findExecutable(o,t,l)}};e.$wnc=i,e.$wnc=i=Je([Ue(0,I.$xP),Ue(1,P.$NP),Ue(2,R.$Dlc),Ue(3,L.$IP),Ue(4,$.$Glc),Ue(5,E.$5lc),Ue(6,p.$3j),Ue(7,h.$hlc),Ue(8,n.$kmc)],i)}),define(ke[382],Se([1,0,63,61]),function(ie,e,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class A extends N.$lmc{m(){return(0,a.homedir)()}}e.$coc=A}),define(ke[161],Se([1,0,19,7,22,47,15,17,23,2,37]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Fmc=e.$Emc=void 0,e.$Gmc=h;class P{constructor(n,i,d){this.d=n,this.e=i,this.f=d,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const d=this.g.folderQueries||[],o=new A.$pe(i);return new Promise((t,l)=>{this.a=new k(n);let r=!1;const c=(s,v)=>{if(!r&&!this.b){const f=this.h(s);h(s)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,r=!0,o.cancel(),s=this.j(s,this.g.maxResults-this.c));const y=this.h(s);this.c+=y,(y>0||!h(s))&&this.a.add(s,v)}};Promise.all(d.map((s,v)=>this.k(s,f=>c(f,v),o.token))).then(s=>{o.dispose(),this.a.flush();const v=s.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||v,messages:(0,a.$Rb)(s.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},s=>{o.dispose();const v=(0,R.$hj)(s);l(new Error(v))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const d=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:d.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,d){const o=new I.$EL(this.g,n),t=[],l={report:s=>{if(!this.l(s))return;const v=n.folder.scheme===L.Schemas.file?(0,I.$FL)(()=>this.e.readdir(m.$9g(s.uri))):void 0,f=m.$_g(n.folder,s.uri);if(f){const y=o.includedInQuery(f,$.$oc(f),v);(0,N.$ih)(y)?t.push(y.then(w=>{w&&i(s)})):y&&i(s)}}},r=this.n(n);let c;return this.d.query.type===3?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,l,d):c=await this.d.provider.provideTextSearchResults(b(this.d.query.contentPattern),r,l,d),t.length&&await Promise.all(t),c}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,I.$DL)(this.g.includePattern,n.includePattern),d=(0,I.$DL)(this.g.excludePattern,n.excludePattern),o={folder:E.URI.from(n.folder),excludes:d,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$Emc=P;function b(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class k{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new g(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Fmc=k;function p(u){return h(u)?{preview:{matches:(0,a.$2b)(u.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:u.preview.text},ranges:(0,a.$2b)(u.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function h(u){return!!u.preview}class g{constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Hmc=g,g.a=4e3,g.b=50}),define(ke[97],Se([1,0,3,6,5,375,20,68,11,2,161]),function(ie,e,a,N,A,R,L,$,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Imc=void 0,e.$Kmc=b,e.$Imc=(0,A.$wi)("IExtHostSearch");let P=class{constructor(h,g,u){this.n=h,this.o=g,this.q=u,this.c=this.n.getProxy(N.$0M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Dmc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const u=this.d++;return this.e.set(u,g),this.c.$registerTextSearchProvider(u,this.s(h)),(0,a.$Tc)(()=>{this.g.delete(h),this.e.delete(u),this.c.$unregisterProvider(u)})}registerAITextSearchProvider(h,g){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const u=this.d++;return this.h.set(u,g),this.c.$registerAITextSearchProvider(u,this.s(h)),(0,a.$Tc)(()=>{this.i.delete(h),this.h.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(h,g){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const u=this.d++;return this.j.set(u,g),this.c.$registerFileSearchProvider(u,this.s(h)),(0,a.$Tc)(()=>{this.k.delete(h),this.j.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(h,g,u,n){const i=b(u),d=this.j.get(h);if(d)return this.l.fileSearch(i,d,o=>{this.c.$handleFileMatch(h,g,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,g,u){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,u,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const d=b(u);return this.t(d,i).search(t=>this.c.$handleTextMatch(h,g,t),n)}$provideAITextSearchResults(h,g,u,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const d=b(u);return this.v(d,i).search(t=>this.c.$handleTextMatch(h,g,t),n)}$enableExtensionHostSearch(){}t(h,g){return new I.$Emc({query:h,provider:g},{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}v(h,g){return new I.$Emc({query:h,provider:g},{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"aiTextSearchProvider")}};e.$Jmc=P,e.$Jmc=P=Je([Ue(0,L.$xP),Ue(1,$.$Alc),Ue(2,m.$3j)],P);function b(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(k),extraFileResources:p.extraFileResources&&p.extraFileResources.map(h=>E.URI.revive(h))}}function k(p){return{...p,folder:E.URI.revive(p.folder)}}}),define(ke[383],Se([1,0,22,13,4,3,15,42,2,137,191,192,83,25,33,11,86,87,283,6,328,354,91,122,332,333,334,315,304,34,335,45,336,96,153,337,317,329,338,339,73,72,330,49,340,70,341,60,28,355,356,318,342,123,343,117,118,319,374,345,288,346,357,347,159,320,348,349,350,20,351,97,119,352,321,353,120,93,95,90,44,157,358,359,331,360,361,71,16,8,322,68,323,92,362,363,152,39,297,116,26,94]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l,r,c,s,v,f,y,w,D,S,C,j,B,z,T,M,F,O,q,Y,V,J,x,ne,de,ce,ve,_,U,le,De,$e,re,se,oe,K,te,ge,be,Re,pe,Pe,Ie,je,W,Q,X,Z,he,we,Te,He,Xe,et,rt,at,ot,ct,Ne,Ve,Ae,Ge,ae,ue,Ce,Ke,Oe,nt,ht,yt,Nt,jt,_t,Xt,Pt,en,tn,tt,dn){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=rn;function rn(mt){const bt=mt.get(ce.$NP),Gt=mt.get(de.$llc),Zt=mt.get(x.$Ilc),zt=mt.get(V.$hmc),$t=mt.get(Pt.$Dlc),Bt=mt.get(ot.$RP),Ht=mt.get(D.$Glc),Ft=mt.get(ht.$Alc),xe=mt.get(X.$xP),un=mt.get(et.$2lc),Yt=mt.get(rt.$Jlc),Jt=mt.get(h.$4j),wt=mt.get(h.$3j),Wt=mt.get(Ce.$FDb),Ut=mt.get(t.$hlc),Qt=mt.get(Xt.$nnc),sn=mt.get(we.$_lc),on=mt.get(q.$Slc),an=mt.get(se.$dmc),Ot=mt.get(l.$rlc),Ct=mt.get(De.$9lc);xe.set(i.$$M.ExtHostFileSystemInfo,Gt),xe.set(i.$$M.ExtHostLogLevelServiceShape,Jt),xe.set(i.$$M.ExtHostWorkspace,$t),xe.set(i.$$M.ExtHostConfiguration,Ht),xe.set(i.$$M.ExtHostExtensionService,zt),xe.set(i.$$M.ExtHostStorage,un),xe.set(i.$$M.ExtHostTunnelService,Wt),xe.set(i.$$M.ExtHostWindow,Qt),xe.set(i.$$M.ExtHostSecretState,sn),xe.set(i.$$M.ExtHostTelemetry,Bt),xe.set(i.$$M.ExtHostEditorTabs,on),xe.set(i.$$M.ExtHostManagedSockets,an),xe.set(i.$$M.ExtHostAuthentication,Ot),xe.set(i.$$M.ExtHostChatProvider,Ct);const Mt=xe.set(i.$$M.ExtHostDecorations,mt.get(j.$smc)),It=xe.set(i.$$M.ExtHostDocumentsAndEditors,mt.get(O.$IP)),pt=xe.set(i.$$M.ExtHostCommands,mt.get(y.$TP)),At=xe.set(i.$$M.ExtHostTerminalService,mt.get(ct.$5lc)),cn=xe.set(i.$$M.ExtHostTerminalShellIntegration,mt.get(Ne.$_mc)),Dt=xe.set(i.$$M.ExtHostDebugService,mt.get(C.$mmc)),xt=xe.set(i.$$M.ExtHostSearch,mt.get(he.$Imc)),nn=xe.set(i.$$M.ExtHostTask,mt.get(at.$$mc)),En=xe.set(i.$$M.ExtHostOutputService,mt.get(Pe.$Xmc)),fn=xe.set(i.$$M.ExtHostLocalization,mt.get(re.$cmc)),gn=xe.set(i.$$M.ExtHostUrls,new yt.$knc(xe)),Lt=xe.set(i.$$M.ExtHostDocuments,new F.$olc(xe,It)),$n=xe.set(i.$$M.ExtHostDocumentContentProviders,new T.$umc(xe,It,wt)),kn=xe.set(i.$$M.ExtHostDocumentSaveParticipant,new M.$vmc(wt,Lt,xe.getProxy(i.$0M.MainThreadBulkEdits))),Le=xe.set(i.$$M.ExtHostNotebook,new K.$Lmc(xe,pt,It,Lt,Zt,xt)),ze=xe.set(i.$$M.ExtHostNotebookDocuments,new ge.$Rmc(Le)),ye=xe.set(i.$$M.ExtHostNotebookEditors,new be.$Smc(wt,Le)),ee=xe.set(i.$$M.ExtHostNotebookKernels,new Re.$Tmc(xe,bt,Le,pt,wt)),Fe=xe.set(i.$$M.ExtHostNotebookRenderers,new pe.$Vmc(xe,Le)),Qe=xe.set(i.$$M.ExtHostNotebookDocumentSaveParticipant,new te.$Qmc(wt,Le,xe.getProxy(i.$0M.MainThreadBulkEdits))),_e=xe.set(i.$$M.ExtHostEditors,new Ae.$xlc(xe,It)),Ze=xe.set(i.$$M.ExtHostTreeViews,new ue.$inc(xe.getProxy(i.$0M.MainThreadTreeViews),pt,wt)),ft=xe.set(i.$$M.ExtHostEditorInsets,new f.$ylc(xe.getProxy(i.$0M.MainThreadEditorInsets),_e,bt.remote)),St=xe.set(i.$$M.ExtHostDiagnostics,new B.$nlc(xe,wt,Gt,It)),Vt=xe.set(i.$$M.ExtHostLanguages,new $e.$Omc(xe,Lt,pt.converter,Ft)),dt=xe.set(i.$$M.ExtHostLanguageFeatures,new le.$plc(xe,Ft,Lt,pt,St,wt,Ut,Bt)),qt=xe.set(i.$$M.ExtHostFileSystem,new J.$xmc(xe,dt)),Rt=xe.set(i.$$M.ExtHostFileSystemEventService,new ne.$ymc(xe,wt,It)),wn=xe.set(i.$$M.ExtHostQuickOpen,(0,Q.$2mc)(xe,$t,pt)),Cn=xe.set(i.$$M.ExtHostSCM,new Z.$4mc(xe,pt,Lt,wt)),jn=xe.set(i.$$M.ExtHostQuickDiff,new W.$1mc(xe,Ft)),zn=xe.set(i.$$M.ExtHostShare,new Te.$5mc(xe,Ft)),Bn=xe.set(i.$$M.ExtHostComments,(0,w.$zlc)(xe,pt,Lt)),In=xe.set(i.$$M.ExtHostProgress,new je.$Zmc(xe.getProxy(i.$0M.MainThreadProgress))),Vn=xe.set(i.$$M.ExtHostLabelService,new U.$Nmc(xe)),Yn=xe.set(i.$$M.ExtHostTheming,new Ge.$fnc(xe)),$i=xe.set(i.$$M.ExtHostTimeline,new ae.$hnc(xe,pt)),Sn=xe.set(i.$$M.ExtHostWebviews,new Nt.$Nlc(xe,bt.remote,$t,wt,Ut)),An=xe.set(i.$$M.ExtHostWebviewPanels,new jt.$Qlc(xe,Sn,$t)),Wn=xe.set(i.$$M.ExtHostCustomEditors,new S.$Rlc(xe,Lt,Yt,Sn,An)),Un=xe.set(i.$$M.ExtHostWebviewViews,new _t.$lnc(xe,Sn)),vn=xe.set(i.$$M.ExtHostTesting,new Ve.$bnc(xe,wt,pt,It)),qn=xe.set(i.$$M.ExtHostUriOpeners,new nt.$jnc(xe)),xn=xe.set(i.$$M.ExtHostProfileContentHandlers,new Ie.$Ymc(xe));xe.set(i.$$M.ExtHostInteractive,new _.$Mmc(xe,Le,It,pt,wt));const _n=xe.set(i.$$M.ExtHostInlineChat,new ve.$zmc(xe,pt,Lt,wt)),Hn=xe.set(i.$$M.ExtHostChatAgents2,new c.$ulc(xe,wt,pt)),ei=xe.set(i.$$M.ExtHostChatVariables,new s.$vlc(xe)),Rn=xe.set(i.$$M.ExtHostAiRelatedInformation,new d.$glc(xe)),Qn=xe.set(i.$$M.ExtHostAiEmbeddingVector,new Y.$wmc(xe)),Gn=xe.set(i.$$M.ExtHostStatusBar,new Xe.$8mc(xe,pt.converter)),ti=xe.set(i.$$M.ExtHostSpeech,new He.$6mc(xe)),ni=Object.values(i.$$M);xe.assertRegistered(ni);const ii=new r.$tlc(xe,It),ri=new v.$wlc(xe),Nn=new oe.$Pmc(xe,wt),si=new z.$tmc(xe);return o.$qlc.register(pt),function(We,ln,Ln){function ut(fe){return(Ee,Be,lt)=>{const kt=fe(Tt=>{try{Ee.call(Be,Tt)}catch(Tn){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Tn.toString()}`,{cause:Tn})),Bt.onExtensionError(We.identifier,Tn)}});return lt?.push(kt),kt}}const Et=function(){let fe=!We.isUnderDevelopment;function Ee(){fe||(wt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(lt){if(Array.isArray(lt))lt.forEach(Be);else if(typeof lt=="string")Ee();else{const kt=lt;typeof kt.scheme>"u"&&Ee(),typeof kt.exclusive=="boolean"&&(0,tt.$PG)(We,"documentFiltersExclusive")}return lt}}(),oi={getSession(fe,Ee,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,tt.$PG)(We,"authLearnMore"),Ot.getSession(We,fe,Ee,Be)},getSessions(fe,Ee){return(0,tt.$PG)(We,"authGetSessions"),Ot.getSessions(We,fe,Ee)},async hasSession(fe,Ee){return(0,tt.$PG)(We,"authSession"),!!await Ot.getSession(We,fe,Ee,{silent:!0})},get onDidChangeSessions(){return ut(Ot.onDidChangeSessions)},registerAuthenticationProvider(fe,Ee,Be,lt){return Ot.registerAuthenticationProvider(fe,Ee,Be,lt)}},pi={registerCommand(fe,Ee,Be){return pt.registerCommand(!0,fe,Ee,Be,void 0,We)},registerTextEditorCommand(fe,Ee,Be){return pt.registerCommand(!0,fe,(...lt)=>{const kt=_e.getActiveTextEditor();if(!kt){wt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return kt.edit(Tt=>{Ee.apply(Be,[kt,Tt,...lt])}).then(Tt=>{Tt||wt.warn("Edits from command "+fe+" were not applied.")},Tt=>{wt.warn("An error occurred while running command "+fe,Tt)})},void 0,void 0,We)},registerDiffInformationCommand:(fe,Ee,Be)=>((0,tt.$PG)(We,"diffCommand"),pt.registerCommand(!0,fe,async(...lt)=>{const kt=It.activeEditor(!0);if(!kt){wt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Tt=await _e.getDiffInformation(kt.id);Ee.apply(Be,[Tt,...lt])},void 0,void 0,We)),executeCommand(fe,...Ee){return pt.executeCommand(fe,...Ee)},getCommands(fe=!1){return pt.getCommands(fe)}},Dn={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return At.getDefaultShell(!1)},get onDidChangeShell(){return ut(At.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ut(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$PG)(We,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$PG)(We,"telemetry"),ut(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$QP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Ee){return ot.$PP.validateSender(fe),Bt.instantiateLogger(We,fe,Ee)},openExternal(fe,Ee){return Qt.openUri(fe,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===bt.environment.appUriScheme)return gn.createAppUri(fe);try{return await Qt.asExternalUri(fe,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,L.$Fg)(fe,L.Schemas.http)||(0,L.$Fg)(fe,L.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,g.$Jm)(bt.remote.authority)},get remoteAuthority(){return(0,tt.$PG)(We,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return ut(wt.onDidChangeLogLevel)},get appQuality(){return(0,tt.$PG)(We,"resolvers"),bt.quality},get appCommit(){return(0,tt.$PG)(We,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Dn);const ai={createTestController(fe,Ee,Be){return vn.createTestController(We,fe,Ee,Be)},createTestObserver(){return(0,tt.$PG)(We,"testObserver"),vn.createTestObserver()},runTests(fe){return(0,tt.$PG)(We,"testObserver"),vn.runTests(fe)},get onDidChangeTestResults(){return(0,tt.$PG)(We,"testObserver"),ut(vn.onResultsChanged)},get testResults(){return(0,tt.$PG)(We,"testObserver"),vn.results}},Pn=bt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,ci={getExtension(fe,Ee){(0,tt.$OG)(We,"extensionsAny")||(Ee=!1);const Be=ln.mine.getExtensionDescription(fe);if(Be)return new V.$imc(zt,We.identifier,Be,Pn,!1);if(Ee){const lt=ln.all.getExtensionDescription(fe);if(lt)return new V.$imc(zt,We.identifier,lt,Pn,!0)}},get all(){const fe=[];for(const Ee of ln.mine.getAllExtensionDescriptions())fe.push(new V.$imc(zt,We.identifier,Ee,Pn,!1));return fe},get allAcrossExtensionHosts(){(0,tt.$PG)(We,"extensionsAny");const fe=new k.$Tm(ln.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of ln.all.getAllExtensionDescriptions()){const lt=!fe.has(Be.identifier);Ee.push(new V.$imc(zt,We.identifier,Be,Pn,lt))}return Ee},get onDidChange(){return(0,tt.$OG)(We,"extensionsAny")?ut(A.Event.any(ln.mine.onDidChange,ln.all.onDidChange)):ut(ln.mine.onDidChange)}},bi={createDiagnosticCollection(fe){return St.createDiagnosticCollection(We.identifier,fe)},get onDidChangeDiagnostics(){return ut(St.onDidChangeDiagnostics)},getDiagnostics:fe=>St.getDiagnostics(fe),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(fe,Ee){return Vt.changeLanguage(fe.uri,Ee)},match(fe,Ee){const Be=Ke.LanguageSelector.from(fe);let lt;return(0,I.$Zt)(Be)&&(lt=Le.notebookDocuments.find(kt=>kt.apiNotebook.getCells().find(Tt=>Tt.document===Ee))?.apiNotebook),(0,I.$Yt)(Be,Ee.uri,Ee.languageId,!0,lt?.uri,lt?.notebookType)},registerCodeActionsProvider(fe,Ee,Be){return dt.registerCodeActionProvider(We,Et(fe),Ee,Be)},registerDocumentPasteEditProvider(fe,Ee,Be){return(0,tt.$PG)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,Et(fe),Ee,Be)},registerCodeLensProvider(fe,Ee){return dt.registerCodeLensProvider(We,Et(fe),Ee)},registerDefinitionProvider(fe,Ee){return dt.registerDefinitionProvider(We,Et(fe),Ee)},registerDeclarationProvider(fe,Ee){return dt.registerDeclarationProvider(We,Et(fe),Ee)},registerImplementationProvider(fe,Ee){return dt.registerImplementationProvider(We,Et(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return dt.registerTypeDefinitionProvider(We,Et(fe),Ee)},registerHoverProvider(fe,Ee){return dt.registerHoverProvider(We,Et(fe),Ee,We.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return dt.registerEvaluatableExpressionProvider(We,Et(fe),Ee,We.identifier)},registerInlineValuesProvider(fe,Ee){return dt.registerInlineValuesProvider(We,Et(fe),Ee,We.identifier)},registerDocumentHighlightProvider(fe,Ee){return dt.registerDocumentHighlightProvider(We,Et(fe),Ee)},registerMultiDocumentHighlightProvider(fe,Ee){return dt.registerMultiDocumentHighlightProvider(We,Et(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return dt.registerLinkedEditingRangeProvider(We,Et(fe),Ee)},registerReferenceProvider(fe,Ee){return dt.registerReferenceProvider(We,Et(fe),Ee)},registerRenameProvider(fe,Ee){return dt.registerRenameProvider(We,Et(fe),Ee)},registerNewSymbolNamesProvider(fe,Ee){return(0,tt.$PG)(We,"newSymbolNamesProvider"),dt.registerNewSymbolNamesProvider(We,Et(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,Be){return dt.registerDocumentSymbolProvider(We,Et(fe),Ee,Be)},registerWorkspaceSymbolProvider(fe){return dt.registerWorkspaceSymbolProvider(We,fe)},registerDocumentFormattingEditProvider(fe,Ee){return dt.registerDocumentFormattingEditProvider(We,Et(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return dt.registerDocumentRangeFormattingEditProvider(We,Et(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,Be,...lt){return dt.registerOnTypeFormattingEditProvider(We,Et(fe),Ee,[Be].concat(lt))},registerDocumentSemanticTokensProvider(fe,Ee,Be){return dt.registerDocumentSemanticTokensProvider(We,Et(fe),Ee,Be)},registerDocumentRangeSemanticTokensProvider(fe,Ee,Be){return dt.registerDocumentRangeSemanticTokensProvider(We,Et(fe),Ee,Be)},registerSignatureHelpProvider(fe,Ee,Be,...lt){return typeof Be=="object"?dt.registerSignatureHelpProvider(We,Et(fe),Ee,Be):dt.registerSignatureHelpProvider(We,Et(fe),Ee,typeof Be>"u"?[]:[Be,...lt])},registerCompletionItemProvider(fe,Ee,...Be){return dt.registerCompletionItemProvider(We,Et(fe),Ee,Be)},registerInlineCompletionItemProvider(fe,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,tt.$PG)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$PG)(We,"inlineCompletionsAdditions"),Be&&(0,tt.$PG)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,Et(fe),Ee,Be)},registerInlineEditProvider(fe,Ee){return(0,tt.$PG)(We,"inlineEdit"),dt.registerInlineEditProvider(We,Et(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return dt.registerDocumentLinkProvider(We,Et(fe),Ee)},registerColorProvider(fe,Ee){return dt.registerColorProvider(We,Et(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return dt.registerFoldingRangeProvider(We,Et(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return dt.registerSelectionRangeProvider(We,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return dt.registerCallHierarchyProvider(We,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return dt.registerTypeHierarchyProvider(We,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>dt.setLanguageConfiguration(We,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,tt.$PG)(We,"tokenInformation"),Vt.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return dt.registerInlayHintsProvider(We,fe,Ee)},createLanguageStatusItem(fe,Ee){return Vt.createLanguageStatusItem(We,fe,Ee)},registerDocumentDropEditProvider(fe,Ee,Be){return dt.registerDocumentOnDropEditProvider(We,fe,Ee,(0,tt.$OG)(We,"documentPaste")?Be:void 0)}},Jn={get activeTextEditor(){return _e.getActiveTextEditor()},get visibleTextEditors(){return _e.getVisibleTextEditors()},get activeTerminal(){return At.activeTerminal},get terminals(){return At.terminals},async showTextDocument(fe,Ee,Be){m.URI.isUri(fe)&&fe.scheme===L.Schemas.vscodeRemote&&!fe.authority&&Ut.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const lt=await(m.URI.isUri(fe)?Promise.resolve(Kn.openTextDocument(fe)):Promise.resolve(fe));return _e.showTextDocument(lt,Ee,Be)},createTextEditorDecorationType(fe){return _e.createTextEditorDecorationType(We,fe)},onDidChangeActiveTextEditor(fe,Ee,Be){return ut(_e.onDidChangeActiveTextEditor)(fe,Ee,Be)},onDidChangeVisibleTextEditors(fe,Ee,Be){return ut(_e.onDidChangeVisibleTextEditors)(fe,Ee,Be)},onDidChangeTextEditorSelection(fe,Ee,Be){return ut(_e.onDidChangeTextEditorSelection)(fe,Ee,Be)},onDidChangeTextEditorOptions(fe,Ee,Be){return ut(_e.onDidChangeTextEditorOptions)(fe,Ee,Be)},onDidChangeTextEditorVisibleRanges(fe,Ee,Be){return ut(_e.onDidChangeTextEditorVisibleRanges)(fe,Ee,Be)},onDidChangeTextEditorViewColumn(fe,Ee,Be){return ut(_e.onDidChangeTextEditorViewColumn)(fe,Ee,Be)},onDidCloseTerminal(fe,Ee,Be){return ut(At.onDidCloseTerminal)(fe,Ee,Be)},onDidOpenTerminal(fe,Ee,Be){return ut(At.onDidOpenTerminal)(fe,Ee,Be)},onDidChangeActiveTerminal(fe,Ee,Be){return ut(At.onDidChangeActiveTerminal)(fe,Ee,Be)},onDidChangeTerminalDimensions(fe,Ee,Be){return(0,tt.$PG)(We,"terminalDimensions"),ut(At.onDidChangeTerminalDimensions)(fe,Ee,Be)},onDidChangeTerminalState(fe,Ee,Be){return ut(At.onDidChangeTerminalState)(fe,Ee,Be)},onDidWriteTerminalData(fe,Ee,Be){return(0,tt.$PG)(We,"terminalDataWriteEvent"),ut(At.onDidWriteTerminalData)(fe,Ee,Be)},onDidExecuteTerminalCommand(fe,Ee,Be){return(0,tt.$PG)(We,"terminalExecuteCommandEvent"),ut(At.onDidExecuteTerminalCommand)(fe,Ee,Be)},onDidChangeTerminalShellIntegration(fe,Ee,Be){return(0,tt.$PG)(We,"terminalShellIntegration"),ut(cn.onDidChangeTerminalShellIntegration)(fe,Ee,Be)},onDidStartTerminalShellExecution(fe,Ee,Be){return(0,tt.$PG)(We,"terminalShellIntegration"),ut(cn.onDidStartTerminalShellExecution)(fe,Ee,Be)},onDidEndTerminalShellExecution(fe,Ee,Be){return(0,tt.$PG)(We,"terminalShellIntegration"),ut(cn.onDidEndTerminalShellExecution)(fe,Ee,Be)},get state(){return Qt.getState()},onDidChangeWindowState(fe,Ee,Be){return ut(Qt.onDidChangeWindowState)(fe,Ee,Be)},showInformationMessage(fe,...Ee){return Nn.showMessage(We,$.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return Nn.showMessage(We,$.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return Nn.showMessage(We,$.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,Be){return wn.showQuickPick(We,fe,Ee,Be)},showWorkspaceFolderPick(fe){return wn.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return wn.showInput(fe,Ee)},showOpenDialog(fe){return si.showOpenDialog(We,fe)},showSaveDialog(fe){return si.showSaveDialog(fe)},createStatusBarItem(fe,Ee,Be){let lt,kt,Tt;return typeof fe=="string"?(lt=fe,kt=Ee,Tt=Be):(kt=fe,Tt=Ee),Gn.createStatusBarEntry(We,lt,kt,Tt)},setStatusBarMessage(fe,Ee){return Gn.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Ut.report("window.withScmProgress",We,"Use 'withProgress' instead."),In.withProgress(We,{location:Oe.ProgressLocation.SourceControl},(Ee,Be)=>fe({report(lt){}}))},withProgress(fe,Ee){return In.withProgress(We,fe,Ee)},createOutputChannel(fe,Ee){return En.createOutputChannel(fe,Ee,We)},createWebviewPanel(fe,Ee,Be,lt){return An.createWebviewPanel(We,fe,Ee,Be,lt)},createWebviewTextEditorInset(fe,Ee,Be,lt){return(0,tt.$PG)(We,"editorInsets"),ft.createWebviewEditorInset(fe,Ee,Be,lt,We)},createTerminal(fe,Ee,Be){return typeof fe=="object"?"pty"in fe?At.createExtensionTerminal(fe):At.createTerminalFromOptions(fe):At.createTerminal(fe,Ee,Be)},registerTerminalLinkProvider(fe){return At.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return At.registerProfileProvider(We,fe,Ee)},registerTerminalQuickFixProvider(fe,Ee){return(0,tt.$PG)(We,"terminalQuickFixProvider"),At.registerTerminalQuickFixProvider(fe,We.identifier.value,Ee)},registerTreeDataProvider(fe,Ee){return Ze.registerTreeDataProvider(fe,Ee,We)},createTreeView(fe,Ee){return Ze.createTreeView(fe,Ee,We)},registerWebviewPanelSerializer:(fe,Ee)=>An.registerWebviewPanelSerializer(We,fe,Ee),registerCustomEditorProvider:(fe,Ee,Be={})=>Wn.registerCustomEditorProvider(We,fe,Ee,Be),registerFileDecorationProvider(fe){return Mt.registerFileDecorationProvider(fe,We)},registerUriHandler(fe){return gn.registerUriHandler(We,fe)},createQuickPick(){return wn.createQuickPick(We)},createInputBox(){return wn.createInputBox(We)},get activeColorTheme(){return Yn.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,Be){return ut(Yn.onDidChangeActiveColorTheme)(fe,Ee,Be)},registerWebviewViewProvider(fe,Ee,Be){return Un.registerWebviewViewProvider(We,fe,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return Le.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,Be){return ut(Le.onDidChangeActiveNotebookEditor)(fe,Ee,Be)},get visibleNotebookEditors(){return Le.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ut(Le.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Ee,Be){return ut(ye.onDidChangeNotebookEditorSelection)(fe,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,Be){return ut(ye.onDidChangeNotebookEditorVisibleRanges)(fe,Ee,Be)},showNotebookDocument(fe,Ee){return Le.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,Be){return(0,tt.$PG)(We,"externalUriOpener"),qn.registerExternalUriOpener(We.identifier,fe,Ee,Be)},registerProfileContentHandler(fe,Ee){return(0,tt.$PG)(We,"profileContentHandlers"),xn.registerProfileContentHandler(We,fe,Ee)},registerQuickDiffProvider(fe,Ee,Be,lt){return(0,tt.$PG)(We,"quickDiffProvider"),jn.registerQuickDiffProvider(Et(fe),Ee,Be,lt)},get tabGroups(){return on.tabGroups},registerShareProvider(fe,Ee){return(0,tt.$PG)(We,"shareProvider"),zn.registerShareProvider(Et(fe),Ee)}},Kn={get rootPath(){return Ut.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$t.getPath()},set rootPath(fe){throw new N.$9("rootPath")},getWorkspaceFolder(fe){return $t.getWorkspaceFolder(fe)},get workspaceFolders(){return $t.getWorkspaceFolders()},get name(){return $t.name},set name(fe){throw new N.$9("name")},get workspaceFile(){return $t.workspaceFile},set workspaceFile(fe){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(fe,Ee,...Be)=>$t.updateWorkspaceFolders(We,fe,Ee||0,...Be),onDidChangeWorkspaceFolders:function(fe,Ee,Be){return ut($t.onDidChangeWorkspace)(fe,Ee,Be)},asRelativePath:(fe,Ee)=>$t.getRelativePath(fe,Ee),findFiles:(fe,Ee,Be,lt)=>$t.findFiles(fe,Ee,Be,We.identifier,lt),findFiles2:(fe,Ee,Be)=>((0,tt.$PG)(We,"findFiles2"),$t.findFiles2(fe,Ee,We.identifier,Be)),findTextInFiles:(fe,Ee,Be,lt)=>{(0,tt.$PG)(We,"findTextInFiles");let kt,Tt;return typeof Ee=="object"?(kt=Ee,Tt=Be):(kt={},Tt=Ee,lt=Be),$t.findTextInFiles(fe,kt||{},Tt,We.identifier,lt)},save:fe=>$t.save(fe),saveAs:fe=>$t.saveAs(fe),saveAll:fe=>$t.saveAll(fe),applyEdit(fe,Ee){return ii.applyWorkspaceEdit(fe,We,Ee)},createFileSystemWatcher:(fe,Ee,Be,lt)=>{let kt;return typeof Ee=="boolean"?kt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!lt,correlate:!1}:Ee&&((0,tt.$PG)(We,"createFileSystemWatcher"),kt={...Ee,correlate:!0}),Rt.createFileSystemWatcher($t,We,fe,kt)},get textDocuments(){return Lt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new N.$9("textDocuments")},openTextDocument(fe){let Ee;const Be=fe;if(typeof fe=="string")Ee=Promise.resolve(m.URI.file(fe));else if(m.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!Be||typeof Be=="object")Ee=Lt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(lt=>(lt.scheme===L.Schemas.vscodeRemote&&!lt.authority&&Ut.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Lt.ensureDocumentData(lt).then(kt=>kt.document)))},onDidOpenTextDocument:(fe,Ee,Be)=>ut(Lt.onDidAddDocument)(fe,Ee,Be),onDidCloseTextDocument:(fe,Ee,Be)=>ut(Lt.onDidRemoveDocument)(fe,Ee,Be),onDidChangeTextDocument:(fe,Ee,Be)=>ut(Lt.onDidChangeDocument)(fe,Ee,Be),onDidSaveTextDocument:(fe,Ee,Be)=>ut(Lt.onDidSaveDocument)(fe,Ee,Be),onWillSaveTextDocument:(fe,Ee,Be)=>ut(kn.getOnWillSaveTextDocumentEvent(We))(fe,Ee,Be),get notebookDocuments(){return Le.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let Be;if(m.URI.isUri(fe))Be=fe,await Le.openNotebookDocument(fe);else if(typeof fe=="string")Be=m.URI.revive(await Le.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return Le.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,Ee,Be){return ut(ze.onDidSaveNotebookDocument)(fe,Ee,Be)},onDidChangeNotebookDocument(fe,Ee,Be){return ut(ze.onDidChangeNotebookDocument)(fe,Ee,Be)},onWillSaveNotebookDocument(fe,Ee,Be){return ut(Qe.getOnWillSaveNotebookDocumentEvent(We))(fe,Ee,Be)},get onDidOpenNotebookDocument(){return ut(Le.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ut(Le.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Ee,Be,lt){return Le.registerNotebookSerializer(We,fe,Ee,Be,(0,tt.$OG)(We,"notebookLiveShare")?lt:void 0)},onDidChangeConfiguration:(fe,Ee,Be)=>ut(Ln.onDidChangeConfiguration)(fe,Ee,Be),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,Ln.getConfiguration(fe,Ee,We)},registerTextDocumentContentProvider(fe,Ee){return $n.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Ut.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),nn.registerTaskProvider(We,fe,Ee)),registerFileSystemProvider(fe,Ee,Be){return(0,R.$Sc)(qt.registerFileSystemProvider(We,fe,Ee,Be),Zt.addFileSystemProvider(fe,Ee,Be))},get fs(){return Zt.value},registerFileSearchProvider:(fe,Ee)=>((0,tt.$PG)(We,"fileSearchProvider"),xt.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,tt.$PG)(We,"textSearchProvider"),xt.registerTextSearchProvider(fe,Ee)),registerAITextSearchProvider:(fe,Ee)=>((0,tt.$PG)(We,"aiTextSearchProvider"),(0,tt.$PG)(We,"textSearchProvider"),xt.registerAITextSearchProvider(fe,Ee)),registerRemoteAuthorityResolver:(fe,Ee)=>((0,tt.$PG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,tt.$PG)(We,"resolvers"),Vn.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,tt.$PG)(We,"resolvers"),zt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Ee,Be)=>ut(Rt.onDidCreateFile)(fe,Ee,Be),onDidDeleteFiles:(fe,Ee,Be)=>ut(Rt.onDidDeleteFile)(fe,Ee,Be),onDidRenameFiles:(fe,Ee,Be)=>ut(Rt.onDidRenameFile)(fe,Ee,Be),onWillCreateFiles:(fe,Ee,Be)=>ut(Rt.getOnWillCreateFileEvent(We))(fe,Ee,Be),onWillDeleteFiles:(fe,Ee,Be)=>ut(Rt.getOnWillDeleteFileEvent(We))(fe,Ee,Be),onWillRenameFiles:(fe,Ee,Be)=>ut(Rt.getOnWillRenameFileEvent(We))(fe,Ee,Be),openTunnel:fe=>((0,tt.$PG)(We,"tunnels"),Wt.openTunnel(We,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$PG)(We,"tunnels"),Wt.getTunnels()},onDidChangeTunnels:(fe,Ee,Be)=>((0,tt.$PG)(We,"tunnels"),ut(Wt.onDidChangeTunnels)(fe,Ee,Be)),registerPortAttributesProvider:(fe,Ee)=>((0,tt.$PG)(We,"portsAttributes"),Wt.registerPortsAttributesProvider(fe,Ee)),registerTunnelProvider:(fe,Ee)=>((0,tt.$PG)(We,"tunnelFactory"),Wt.registerTunnelProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,tt.$PG)(We,"timeline"),$i.registerTimelineProvider(fe,Ee,We.identifier,pt.converter)),get isTrusted(){return $t.trusted},requestWorkspaceTrust:fe=>((0,tt.$PG)(We,"workspaceTrust"),$t.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,Be)=>ut($t.onDidGrantWorkspaceTrust)(fe,Ee,Be),registerEditSessionIdentityProvider:(fe,Ee)=>((0,tt.$PG)(We,"editSessionIdentityProvider"),$t.registerEditSessionIdentityProvider(fe,Ee)),onWillCreateEditSessionIdentity:(fe,Ee,Be)=>((0,tt.$PG)(We,"editSessionIdentityProvider"),ut($t.getOnWillCreateEditSessionIdentityEvent(We))(fe,Ee,Be)),registerCanonicalUriProvider:(fe,Ee)=>((0,tt.$PG)(We,"canonicalUriProvider"),$t.registerCanonicalUriProvider(fe,Ee)),getCanonicalUri:(fe,Ee,Be)=>((0,tt.$PG)(We,"canonicalUriProvider"),$t.provideCanonicalUri(fe,Ee,Be))},pn={get inputBox(){return Ut.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Cn.getLastInputBox(We)},createSourceControl(fe,Ee,Be){return Cn.createSourceControl(We,fe,Ee,Be)}},On={createCommentController(fe,Ee){return Bn.createCommentController(We,fe,Ee)}},wi={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,tt.$OG)(We,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(fe,Ee){return(0,tt.$PG)(We,"debugVisualization"),Dt.registerDebugVisualizationProvider(We,fe,Ee)},registerDebugVisualizationTreeProvider(fe,Ee){return(0,tt.$PG)(We,"debugVisualization"),Dt.registerDebugVisualizationTree(We,fe,Ee)},onDidStartDebugSession(fe,Ee,Be){return ut(Dt.onDidStartDebugSession)(fe,Ee,Be)},onDidTerminateDebugSession(fe,Ee,Be){return ut(Dt.onDidTerminateDebugSession)(fe,Ee,Be)},onDidChangeActiveDebugSession(fe,Ee,Be){return ut(Dt.onDidChangeActiveDebugSession)(fe,Ee,Be)},onDidReceiveDebugSessionCustomEvent(fe,Ee,Be){return ut(Dt.onDidReceiveDebugSessionCustomEvent)(fe,Ee,Be)},onDidChangeBreakpoints(fe,Ee,Be){return ut(Dt.onDidChangeBreakpoints)(fe,Ee,Be)},onDidChangeActiveStackItem(fe,Ee,Be){return(0,tt.$PG)(We,"debugFocus"),ut(Dt.onDidChangeActiveStackItem)(fe,Ee,Be)},registerDebugConfigurationProvider(fe,Ee,Be){return Dt.registerDebugConfigurationProvider(fe,Ee,Be||en.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return Dt.registerDebugAdapterDescriptorFactory(We,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return Dt.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Dt.startDebugging(fe,Ee,{parentSession:Be}):Dt.startDebugging(fe,Ee,Be||{})},stopDebugging(fe){return Dt.stopDebugging(fe)},addBreakpoints(fe){return Dt.addBreakpoints(fe)},removeBreakpoints(fe){return Dt.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return Dt.asDebugSourceUri(fe,Ee)}},ui={registerTaskProvider:(fe,Ee)=>nn.registerTaskProvider(We,fe,Ee),fetchTasks:fe=>nn.fetchTasks(fe),executeTask:fe=>nn.executeTask(We,fe),get taskExecutions(){return nn.taskExecutions},onDidStartTask:(fe,Ee,Be)=>ut(nn.onDidStartTask)(fe,Ee,Be),onDidEndTask:(fe,Ee,Be)=>ut(nn.onDidEndTask)(fe,Ee,Be),onDidStartTaskProcess:(fe,Ee,Be)=>ut(nn.onDidStartTaskProcess)(fe,Ee,Be),onDidEndTaskProcess:(fe,Ee,Be)=>ut(nn.onDidEndTaskProcess)(fe,Ee,Be)},Mn={createNotebookController(fe,Ee,Be,lt,kt){return ee.createNotebookController(We,fe,Ee,Be,lt,(0,tt.$OG)(We,"notebookMessaging")?kt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>Le.registerNotebookCellStatusBarItemProvider(We,fe,Ee),createRendererMessaging(fe){return Fe.createRendererMessaging(We,fe)},createNotebookControllerDetectionTask(fe){return(0,tt.$PG)(We,"notebookKernelSource"),ee.createNotebookControllerDetectionTask(We,fe)},registerKernelSourceActionProvider(fe,Ee){return(0,tt.$PG)(We,"notebookKernelSource"),ee.registerKernelSourceActionProvider(We,fe,Ee)},onDidChangeNotebookCellExecutionState(fe,Ee,Be){return(0,tt.$PG)(We,"notebookCellExecutionState"),ut(ee.onDidChangeNotebookCellExecutionState)(fe,Ee,Be)}},li={t(...fe){if(typeof fe[0]=="string"){const Ee=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return fn.getMessage(We.identifier.value,{message:Ee,args:Be})}return fn.getMessage(We.identifier.value,fe[0])},get bundle(){return fn.getBundle(We.identifier.value)},get uri(){return fn.getBundleUri(We.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(fe,Ee){return(0,tt.$PG)(We,"interactive"),_n.registerProvider(We,fe,Ee)},transferActiveChat(fe){return(0,tt.$PG)(We,"interactive"),Hn.transferActiveChat(fe)}},di={getRelatedInformation(fe,Ee){return(0,tt.$PG)(We,"aiRelatedInformation"),Rn.getRelatedInformation(We,fe,Ee)},registerRelatedInformationProvider(fe,Ee){return(0,tt.$PG)(We,"aiRelatedInformation"),Rn.registerRelatedInformationProvider(We,fe,Ee)},registerEmbeddingVectorProvider(fe,Ee){return(0,tt.$PG)(We,"aiRelatedInformation"),Qn.registerEmbeddingVectorProvider(We,fe,Ee)}},fi={registerChatResponseProvider(fe,Ee,Be){return(0,tt.$PG)(We,"chatProvider"),Ct.registerLanguageModel(We,fe,Ee,Be)},registerChatVariableResolver(fe,Ee,Be){return(0,tt.$PG)(We,"chatVariableResolver"),ei.registerVariableResolver(We,fe,Ee,Be)},registerMappedEditsProvider(fe,Ee){return(0,tt.$PG)(We,"mappedEditsProvider"),dt.registerMappedEditsProvider(We,fe,Ee)},createChatParticipant(fe,Ee){return(0,tt.$PG)(We,"chatParticipant"),Hn.createChatAgent(We,fe,Ee)},createDynamicChatParticipant(fe,Ee,Be,lt){return(0,tt.$PG)(We,"chatParticipantAdditions"),Hn.createDynamicChatAgent(We,fe,Ee,Be,lt)}},vi={get languageModels(){return(0,tt.$PG)(We,"languageModels"),Ct.getLanguageModelIds()},onDidChangeLanguageModels:(fe,Ee,Be)=>((0,tt.$PG)(We,"languageModels"),Ct.onDidChangeProviders(fe,Ee,Be)),sendChatRequest(fe,Ee,Be,lt){return(0,tt.$PG)(We,"languageModels"),Ct.sendChatRequest(We,fe,Ee,Be,lt)},computeTokenLength(fe,Ee,Be){return(0,tt.$PG)(We,"languageModels"),Be??(Be=a.CancellationToken.None),Ct.computeTokenLength(fe,Ee,Be)},getLanguageModelInformation(fe){return(0,tt.$PG)(We,"languageModels"),Ct.getLanguageModelInfo(fe)}},gi={registerSpeechProvider(fe,Ee){return(0,tt.$PG)(We,"speech"),ti.registerProvider(We.identifier,fe,Ee)}};return{version:bt.version,ai:di,authentication:oi,commands:pi,comments:On,chat:fi,debug:wi,env:Dn,extensions:ci,interactive:hi,l10n:li,languages:bi,lm:vi,notebooks:Mn,scm:pn,speech:gi,tasks:ui,tests:ai,window:Jn,workspace:Kn,Breakpoint:Oe.$aO,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatResultFeedbackKind:Oe.ChatResultFeedbackKind,ChatVariableLevel:Oe.ChatVariableLevel,ChatCompletionItem:Oe.$8O,CallHierarchyIncomingCall:Oe.$yN,CallHierarchyItem:Oe.$xN,CallHierarchyOutgoingCall:Oe.$zN,CancellationError:N.$5,CancellationTokenSource:a.$pe,CandidatePortSource:i.CandidatePortSource,CodeAction:Oe.$uN,CodeActionKind:Oe.$vN,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$AN,Color:Oe.$NN,ColorInformation:Oe.$ON,ColorPresentation:Oe.$PN,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CommentThreadApplicability:Oe.CommentThreadApplicability,CompletionItem:Oe.$HN,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$IN,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$XN,DebugAdapterExecutable:Oe.$eO,DebugAdapterInlineImplementation:Oe.$hO,DebugAdapterNamedPipeServer:Oe.$gO,DebugAdapterServer:Oe.$fO,DebugConfigurationProviderTriggerKind:en.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$xO,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$nN,DiagnosticRelatedInformation:Oe.$mN,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$_M,DocumentHighlight:Oe.$qN,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$rN,DocumentLink:Oe.$MN,DocumentSymbol:Oe.$tN,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$kO,InlineValueText:Oe.$lO,InlineValueVariableLookup:Oe.$mO,InlineValueEvaluatableExpression:Oe.$nO,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:A.$ee,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$zO,FileDecoration2:Oe.$zO,FileSystemError:Oe.$qO,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Oe.$rO,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$cO,InlineCompletionItem:Oe.$JN,InlineCompletionList:Oe.$KN,Hover:Oe.$oN,VerboseHover:Oe.$pN,HoverVerbosityAction:Oe.HoverVerbosityAction,IndentAction:P.IndentAction,Location:Oe.$lN,MarkdownString:Oe.$BN,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:Oe.$CN,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$aN,ProcessExecution:Oe.$VN,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$yO,Range:Oe.$bN,RelativePattern:Oe.$$N,Selection:Oe.$cN,SelectionRange:Oe.$wN,SemanticTokens:Oe.$uO,SemanticTokensBuilder:Oe.$tO,SemanticTokensEdit:Oe.$vO,SemanticTokensEdits:Oe.$wO,SemanticTokensLegend:Oe.$sO,ShellExecution:Oe.$WN,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$EN,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$DN,SnippetString:Oe.$kN,SourceBreakpoint:Oe.$bO,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$sN,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$YN,TaskGroup:Oe.$UN,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$QN,TerminalQuickFixTerminalCommand:Oe.$SN,TerminalQuickFixOpener:Oe.$RN,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$TN,TerminalExitReason:Oe.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Oe.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$gN,SnippetTextEdit:Oe.$iN,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$0N,ThemeIcon:Oe.$9N,TreeItem:Oe.$ZN,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$VO,UIKind:tn.UIKind,Uri:m.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$jN,DocumentPasteTriggerKind:Oe.DocumentPasteTriggerKind,DocumentDropEdit:Oe.$6N,DocumentDropOrPasteEditKind:Oe.$7N,DocumentPasteEdit:Oe.$8N,InlayHint:Oe.$GN,InlayHintLabelPart:Oe.$FN,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$fN,ResolvedAuthority:Oe.$dN,ManagedResolvedAuthority:Oe.$eN,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$JO,NotebookRange:Oe.$BO,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$CO,NotebookData:Oe.$DO,NotebookRendererScript:Oe.$HO,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$FO,NotebookCellOutputItem:Oe.$EO,NotebookCellStatusBarItem:Oe.$GO,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$hN,NotebookKernelSourceAction:Oe.$IO,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$LO,LinkedEditingRanges:Oe.$KO,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$MO,TestRunRequest2:Oe.$MO,TestMessage:Oe.$NO,TestTag:Oe.$OO,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:dn.TextSearchCompleteMessageType,DataTransfer:Oe.$5N,DataTransferItem:Oe.$1N,TestCoverageCount:Oe.$PO,FileCoverage:Oe.$RO,StatementCoverage:Oe.$SO,BranchCoverage:Oe.$TO,DeclarationCoverage:Oe.$UO,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$WO,TabInputTextDiff:Oe.$XO,TabInputTextMerge:Oe.$YO,TabInputCustom:Oe.$ZO,TabInputNotebook:Oe.$2O,TabInputNotebookDiff:Oe.$3O,TabInputWebview:Oe.$1O,TabInputTerminal:Oe.$4O,TabInputInteractiveWindow:Oe.$5O,TabInputChat:Oe.$6O,TabInputTextMultiDiff:Oe.$7O,TelemetryTrustedValue:u.$gp,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatCopyKind:Oe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Oe.$iO,DebugThread:Oe.$jO,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,PartialAcceptTriggerKind:Oe.PartialAcceptTriggerKind,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Oe.$9O,ChatResponseFileTreePart:Oe.$_O,ChatResponseAnchorPart:Oe.$aP,ChatResponseProgressPart:Oe.$bP,ChatResponseReferencePart:Oe.$dP,ChatResponseTextEditPart:Oe.$eP,ChatResponseMarkdownWithVulnerabilitiesPart:Oe.$0O,ChatResponseCommandButtonPart:Oe.$cP,ChatResponseDetectedParticipantPart:Oe.$$O,ChatRequestTurn:Oe.$fP,ChatResponseTurn:Oe.$gP,ChatLocation:Oe.ChatLocation,LanguageModelChatSystemMessage:Oe.$hP,LanguageModelChatUserMessage:Oe.$iP,LanguageModelChatAssistantMessage:Oe.$jP,LanguageModelSystemMessage:Oe.$hP,LanguageModelUserMessage:Oe.$iP,LanguageModelAssistantMessage:Oe.$jP,LanguageModelError:Oe.$kP,NewSymbolName:Oe.$pO,NewSymbolNameTag:Oe.NewSymbolNameTag,NewSymbolNameTriggerKind:Oe.NewSymbolNameTriggerKind,InlineEdit:Oe.$lP,InlineEditTriggerKind:Oe.InlineEditTriggerKind}}}}),define(ke[384],Se([1,0,85,159,39,153,45,34,73,44,95,96,97,120,71,91,152,70,60,119,90,72,151,11,61,117,118,122,123,157]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l,r,c,s,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.$ys)(c.$cmc,c.$bmc,1),(0,a.$ys)(l.$4j,t.$pnc,1),(0,a.$ys)(h.$hlc,h.$ilc,1),(0,a.$ys)($.$TP,$.$SP,0),(0,a.$ys)(v.$rlc,v.$slc,0),(0,a.$ys)(f.$9lc,f.$0lc,0),(0,a.$ys)(L.$Glc,L.$Elc,0),(0,a.$ys)(u.$Ilc,u.$Hlc,0),(0,a.$ys)(P.$mmc,P.$qmc,0),(0,a.$ys)(R.$smc,R.$rmc,0),(0,a.$ys)(m.$IP,m.$HP,0),(0,a.$ys)(s.$dmc,s.$emc,0),(0,a.$ys)(n.$llc,n.$klc,0),(0,a.$ys)(N.$Xmc,N.$Wmc,1),(0,a.$ys)(b.$Imc,b.$Jmc,0),(0,a.$ys)(k.$2lc,k.$1lc,0),(0,a.$ys)(I.$$mc,I.$0mc,0),(0,a.$ys)(E.$5lc,E.$8lc,0),(0,a.$ys)(y.$_mc,y.$anc,0),(0,a.$ys)(p.$FDb,p.$GDb,0),(0,a.$ys)(g.$nnc,g.$mnc,0),(0,a.$ys)(A.$Dlc,A.$Clc,0),(0,a.$ys)(i.$_lc,i.$$lc,0),(0,a.$ys)(d.$RP,d.$OP,0),(0,a.$ys)(o.$Slc,o.$Tlc,0),(0,a.$ys)(r.$kmc,r.$lmc,0)}),define(ke[124],Se([1,0,19,11,37,94]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0,e.$Fnc=L,e.$Gnc=$;function L(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function $(P,b,k,p){const h=(0,a.$2b)(k,m),g=new A.$qL(b,h,p),u=g.preview.matches;return{ranges:(0,a.$2b)(h,E),uri:P,preview:{text:g.preview.text,matches:(0,a.$2b)(u,E)}}}function m(P){return new A.$rL(P.start.line,P.start.character,P.end.line,P.end.character)}function E(P){return new R.$fL(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let I=class{constructor(b,k){this.a=b,this.b=k}appendLine(b){this.b.debug(`${this.a}#search`,b)}};e.$Hnc=I,e.$Hnc=I=Je([Ue(1,N.$3j)],I)}),define(ke[385],Se([1,0,53,17,77,30,12,14,124,386]),function(ie,e,a,N,A,R,L,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=P,e.$Jnc=g,e.$Knc=n;const I=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(i,d,o,t){const l=b(i,d,o,t),r=d.folder.fsPath;return{cmd:a.spawn(I,l.args,{cwd:r}),rgDiskPath:I,siblingClauses:l.siblingClauses,rgArgs:l,cwd:r}}function b(i,d,o,t){const l=["--files","--hidden","--case-sensitive","--no-require-git"];p([d],o,!1).forEach(c=>{const s=(0,m.$Fnc)(c);if(l.push("-g",s),L.$d){const v=(0,A.$dm)(s);v!==s&&l.push("-g",v)}});const r=k([d],t,void 0,!1);return r.globArgs.forEach(c=>{const s=`!${(0,m.$Fnc)(c)}`;if(l.push("-g",s),L.$d){const v=(0,A.$dm)(s);v!==s&&l.push("-g",v)}}),d.disregardIgnoreFiles!==!1?l.push("--no-ignore"):d.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),d.ignoreSymlinks||l.push("--follow"),i.exists&&l.push("--quiet"),l.push("--no-config"),d.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:r.siblingClauses}}function k(i,d,o,t=!0){const l=[];let r={};return i.forEach(c=>{const s=Object.assign({},c.excludePattern||{},d||{}),v=h(s,t?c.folder.fsPath:void 0,o);l.push(...v.globArgs),v.siblingClauses&&(r=Object.assign(r,v.siblingClauses))}),{globArgs:l,siblingClauses:r}}function p(i,d,o=!0){const t=[];return i.forEach(l=>{const r=Object.assign({},d||{},l.includePattern||{}),c=h(r,o?l.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function h(i,d,o){const t=[],l={};return Object.keys(i).forEach(r=>{if(o&&o.has(r)||!r)return;const c=i[r];r=u(d?g(d,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):c&&c.when&&(l[r]=c)}),{globArgs:t,siblingClauses:l}}function g(i,d){return N.$jc(d)?d:N.$kc(i,d)}function u(i){return i=$.$gf(i,"\\"),$.$gf(i,"/")}function n(i){return R.$rg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[387],Se([1,0,53,52,17,388,19,47,35,77,30,12,41,14,18,32,37,385,130]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class d{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&m.$qk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,n.$yr)(this.b).normalizedLowercase),this.u=c.excludePattern&&m.$qk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(s=>{const v=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),f=s.folder.fsPath;c.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==f).forEach(y=>{(0,I.$vg)(y,f)&&(v[A.$mc(f,y)]=!0)}),this.t.set(f,new t(v,f))})}cancel(){this.l=!0,i.forEach(c=>c())}walk(c,s,v,f,y){if(this.m=b.$ae.create(!1),this.l)return y(null,this.j);s.forEach(w=>{const D=A.$oc(w.fsPath);this.u&&this.u(w.fsPath,D)||this.J(v,{relativePath:w.fsPath,searchPath:void 0})}),this.r=b.$ae.create(!1),this.w(c,(w,D)=>{this.x(this.y,this,w,v,f,S=>{if(S){const C=(0,$.$hj)(S);console.error(C),this.q.push(C),D(S,void 0)}else D(null,void 0)})},(w,D)=>{this.m.stop();const S=w?L.$Hb(w)[0]:null;y(S,this.j)})}w(c,s,v){const f=new Array(c.length),y=new Array(c.length);let w=!1,D=0;if(c.length===0)return v(null,[]);c.forEach((S,C)=>{s(S,(j,B)=>{if(j?(w=!0,f[C]=null,y[C]=j):(f[C]=B,y[C]=null),++D===c.length)return v(w?y:null,f)})})}x(c,s,...v){try{c.apply(s,v)}catch(f){v[v.length-1](f)}}y(c,s,v,f){const y=c.folder.fsPath,w=P.$d,D=()=>z&&z.kill();i.add(D);let S=O=>{i.delete(D),S=()=>{},f(O)},C="";const j=this.D(),B=(0,u.$Inc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),z=B.cmd,T=!Object.keys(B.siblingClauses).length,M=B.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let F=`${B.rgDiskPath} ${M}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),v({message:F}),this.s=0,this.z(z,"utf8",v,(O,q,Y)=>{if(O){S(O);return}if(this.j){S();return}const J=(C+(w?E.$cm(q||""):q)).split(`
`);if(Y){const x=J.length;J[x-1]=J[x-1].trim(),J[x-1]||J.pop()}else C=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.s+=J.length,T){for(const x of J)if(this.J(s,{base:y,relativePath:x,searchPath:this.N(c,x)}),this.j){D();break}(Y||this.j)&&S();return}this.G(c,j,y,J,s),Y&&(this.H(j,y,s),S())})}spawnFindCmd(c){const s=this.t.get(c.folder.fsPath),v=s.getBasenameTerms(),f=s.getPathTerms(),y=["-L","."];if(v.length||f.length){y.push("-not","(","(");for(const w of v)y.push("-name",w),y.push("-o");for(const w of f)y.push("-path",w),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),a.spawn("find",y,{cwd:c.folder.fsPath})}readStdout(c,s,v){let f="";this.z(c,s,()=>{},(y,w,D)=>{if(y){v(y);return}f+=w,D&&v(null,f)})}z(c,s,v,f){let y=(S,C,j)=>{(S||j)&&(y=()=>{},this.r?.stop()),f(S,C,j)},w=!1;c.stdout?(this.A(c.stdout,s,y),c.stdout.once("data",()=>w=!0)):v({message:"stdout is null"});let D;c.stderr?D=this.B(c.stderr):v({message:"stderr is null"}),c.on("error",S=>{y(S)}),c.on("close",S=>{let C;!w&&(C=this.C(D,s))&&l(C)?y(new Error(`command failed with error code ${S}: ${this.C(D,s)}`)):(this.g&&S===0&&(this.j=!0),y(null,"",!0))})}A(c,s,v){const f=new R.StringDecoder(s);return c.on("data",y=>{v(null,f.write(y))}),f}B(c){const s=[];return c.on("data",v=>{s.push(v)}),s}C(c,s){const v=new R.StringDecoder(s);return c.map(f=>v.write(f)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:s},v,f,y){f.indexOf(this.b)!==-1&&this.J(y,{base:v,relativePath:this.b,searchPath:this.N(c,this.b)});const w=D=>{const S=A.$oc(D),C=A.$nc(D);let j=s[C];j||(j=s[C]=[],w(C)),j.push({base:v,relativePath:D,basename:S,searchPath:this.N(c,D)})};f.forEach(w)}H({rootEntries:c,pathToEntries:s},v,f){const y=this,w=this.t.get(v),D=this.b;function S(C){y.o++;const j=(0,g.$GL)(()=>C.map(B=>B.basename));for(let B=0,z=C.length;B<z;B++){const T=C[B],{relativePath:M,basename:F}=T;if(w.test(M,F,D!==F?j:void 0))continue;const O=s[M];if(O)S(O);else{if(y.p++,M===D)continue;y.J(f,T)}if(y.j)break}}S(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,s,v,f,y){const w=c.folder,D=(0,g.$GL)(()=>v);this.w(v,(S,C)=>{if(this.l||this.j)return C(null);const j=s?[s,S].join(A.sep):S;if(this.t.get(c.folder.fsPath).test(j,S,this.a.filePattern!==S?D:void 0))return C(null);const B=[w.fsPath,j].join(A.sep);N.lstat(B,(z,T)=>{if(z||this.l||this.j)return C(null);this.L(B,T,(M,F)=>M||this.l||this.j?C(null):F.isDirectory()?(this.o++,this.M(B,T,(O,q)=>O||this.l||this.j||(q=q||"",this.v[q])?C(null):(this.v[q]=!0,h.Promises.readdir(B).then(Y=>{if(this.l||this.j)return C(null);this.I(c,j,Y,f,V=>C(V||null))},Y=>{C(null)})))):(this.p++,j===this.b||this.h&&p.$ag(F.size)&&F.size>this.h||this.J(f,{base:w.fsPath,relativePath:j,searchPath:this.N(c,j)}),C(null,void 0)))})},S=>{const C=S&&L.$Hb(S);return y(C&&C.length>0?C[0]:void 0)})}J(c,s){this.K(s)&&(!this.d||this.d(s.relativePath,A.$oc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(s))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$BL)(c,this.c);if(this.b)return(0,g.$BL)(c,this.b,!1)}return!0}L(c,s,v){return s.isSymbolicLink()?N.stat(c,v):v(null,s)}M(c,s,v){return s.isSymbolicLink()?N.realpath(c,(f,y)=>f?v(f):v(null,y)):v(null,c)}N(c,s){return c.folderName?A.$kc(c.folderName,s):s}}e.$Lnc=d;class o{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new d(c)}search(c,s,v){this.c.walk(this.a,this.b,c,s,(f,y)=>{v(f,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Mnc=o;class t{constructor(c,s){this.expression=c,this.c=s,this.d(c)}d(c){let s,v;Object.keys(c).filter(f=>c[f]).forEach(f=>{A.$jc(f)?(s=s||m.$lk(),s[f]=c[f]):(v=v||m.$lk(),v[f]=c[f])}),this.a=s&&m.$qk(s,{trimForExclusions:!0}),this.b=v&&m.$qk(v,{trimForExclusions:!0})}test(c,s,v){return this.b&&this.b(c,s,v)||this.a&&this.a(A.$kc(this.c,c),s,v)}getBasenameTerms(){const c=[];return this.a&&c.push(...m.$sk(this.a)),this.b&&c.push(...m.$sk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...m.$tk(this.a)),this.b&&c.push(...m.$tk(this.b)),c}}function l(r){const c=r.trim().split(`
`),s=c[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return k.$1f(c[c.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(ke[389],Se([1,0,100,21,179,22]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$eE=e.DecodeStreamErrorKind=e.$dE=e.$cE=e.$bE=e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=L,e.$fE=p,e.$gE=h,e.$hE=g,e.$iE=u,e.$jE=n,e.$kE=r,e.$lE=c,e.$9D="utf8",e.$0D="utf8bom",e.$$D="utf16be",e.$_D="utf16le";function L(s){return[e.$9D,e.$0D,e.$$D,e.$_D].some(v=>v===s)}e.$bE=[254,255],e.$cE=[255,254],e.$dE=[239,187,191];const $=512,m=512,E=512*8,I=512*128;var P;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class b extends Error{constructor(v,f){super(v),this.decodeStreamErrorKind=f}}e.$eE=b;class k{static async create(v){let f;if(v!==e.$9D)f=(await(0,A.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(u(v));else{const y=new TextDecoder;f={write(w){return y.decode(w,{stream:!0})},end(){return y.decode()}}}return new k(f)}constructor(v){this.a=v}write(v){return this.a.write(v)}end(){return this.a.end()}}function p(s,v){const f=v.minBytesRequiredForDetection??v.guessEncoding?E:m;return new Promise((y,w)=>{const D=(0,a.$ue)(T=>T.join("")),S=[];let C=0,j;const B=new R.$pe,z=async()=>{try{const T=await c({buffer:N.$Ge.concat(S),bytesRead:C},v.guessEncoding);if(T.seemsBinary&&v.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);T.encoding=await v.overwriteEncoding(T.encoding),j=await k.create(T.encoding);const M=j.write(N.$Ge.concat(S).buffer);D.write(M),S.length=0,C=0,y({stream:D,detected:T})}catch(T){B.cancel(),D.destroy(),w(T)}};(0,a.$ye)(s,{onData:async T=>{j?D.write(j.write(T.buffer)):(S.push(T),C+=T.byteLength,C>=f&&(s.pause(),await z(),setTimeout(()=>s.resume())))},onError:T=>D.error(T),onEnd:async()=>{j||await z(),D.end(j?.end())}},B.token)})}async function h(s,v,f){const w=(await(0,A.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(u(v),f);let D=!1,S=!1;return{read(){if(S)return null;const C=s.read();if(typeof C!="string"){if(S=!0,!D&&f?.addBOM)switch(v){case e.$9D:case e.$0D:return N.$Ge.wrap(Uint8Array.from(e.$dE));case e.$$D:return N.$Ge.wrap(Uint8Array.from(e.$bE));case e.$_D:return N.$Ge.wrap(Uint8Array.from(e.$cE))}const j=w.end();return j&&j.length>0?(D=!0,N.$Ge.wrap(j)):null}return D=!0,N.$Ge.wrap(w.write(C))}}}async function g(s){return(await(0,A.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(u(s))}function u(s){return s===e.$0D||s===null?e.$9D:s}function n(s,v){if(!s||v<e.$bE.length)return null;const f=s.readUInt8(0),y=s.readUInt8(1);if(f===e.$bE[0]&&y===e.$bE[1])return e.$$D;if(f===e.$cE[0]&&y===e.$cE[1])return e.$_D;if(v<e.$dE.length)return null;const w=s.readUInt8(2);return f===e.$dE[0]&&y===e.$dE[1]&&w===e.$dE[2]?e.$0D:null}const i=["ascii","utf-16","utf-32"];async function d(s){const v=await(0,A.$8D)("jschardet","dist/jschardet.min.js"),f=s.slice(0,I),y=l(f.buffer),w=v.detect(y);if(!w||!w.encoding)return null;const D=w.encoding.toLowerCase();return 0<=i.indexOf(D)?null:t(w.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(s){const v=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[v]||v}function l(s){let v="";for(let f=0;f<s.length;f++)v+=String.fromCharCode(s[f]);return v}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const v=s.match(/windows(\d+)/);return v?"windows-"+v[1]:s}}}function c({buffer:s,bytesRead:v},f){let y=n(s,v),w=!1;if(y!==e.$$D&&y!==e.$_D&&s){let D=!0,S=!0,C=!1;for(let j=0;j<v&&j<$;j++){const B=j%2===1,z=s.readUInt8(j)===0;if(z&&(C=!0),D&&(B&&!z||!B&&z)&&(D=!1),S&&(B&&z||!B&&!z)&&(S=!1),z&&!D&&!S)break}C&&(D?y=e.$_D:S?y=e.$$D:w=!0)}return f&&!w&&!y&&s?d(s.slice(0,v)).then(D=>({seemsBinary:!1,encoding:D})):{seemsBinary:w,encoding:y}}e.$mE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[162],Se([1,0,389,32,161]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=void 0;class R extends A.$Emc{constructor($,m,E=N,I="searchProcess"){super({query:$,provider:m},{readdir:P=>E.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,a.$kE)(P)},I)}}e.$Unc=R}),define(ke[163],Se([1,0,53,405,388,19,74,35,14,2,37,94,406,386,124]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=void 0,e.$Pnc=t,e.$Qnc=r,e.$Rnc=s,e.$Snc=v,e.$Tnc=y;const h=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(D){this.a=D}provideTextSearchResults(D,S,C,j){return this.a.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((B,z)=>{j.onCancellationRequested(()=>J());const T=t(D,S),M=S.folder.fsPath,F=T.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${h} ${F}
 - cwd: ${M}`);let O=a.spawn(h,T,{cwd:M});O.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),z((0,I.$xL)(new I.$vL(ve&&ve.message,I.SearchErrorCode.rgProcessError)))});let q=!1;const Y=new i(S.maxResults,S.folder,S.previewOptions);Y.on("result",ve=>{q=!0,ne="",C.report(ve)});let V=!1;const J=()=>{V=!0,O?.kill(),Y?.cancel()};let x=!1;Y.on("hitLimit",()=>{x=!0,J()});let ne="";O.stdout.on("data",ve=>{Y.handleData(ve),q||(ne+=ve)});let de=!1;O.stdout.once("data",()=>de=!0);let ce="";O.stderr.on("data",ve=>{const _=ve.toString();this.a.appendLine(_),ce.length+_.length<1e6&&(ce+=_)}),O.on("close",()=>{if(this.a.appendLine(de?"Got data from stdout":"No data from stdout"),this.a.appendLine(q?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),V)B({limitHit:x});else{Y.flush(),O=null;let ve;ce&&!de&&(ve=u(ce))?z((0,I.$xL)(new I.$vL(ve.message,ve.code))):B({limitHit:x})}})})}}e.$Nnc=g;function u(w){const D=w.split(`
`),S=D[0].trim();if(D.some(j=>j.startsWith("regex parse error")))return new I.$vL(n(D),I.SearchErrorCode.regexParseError);const C=S.match(/grep config error: unknown encoding: (.*)/);if(C)return new I.$vL(`Unknown encoding: ${C[1]}`,I.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new I.$vL(S.charAt(0).toUpperCase()+S.substr(1),I.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new I.$vL(S.charAt(0).toUpperCase()+S.substr(1),I.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new I.$vL(S,I.SearchErrorCode.regexParseError)}function n(w){const D=["Regex parse error"],S=w.filter(C=>C.startsWith("PCRE2:"));if(S.length>=1){const C=S[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const j=C.split(":")[1];D.push(":"+j)}}return D.join("")}class i extends N.EventEmitter{constructor(D,S,C){super(),this.g=D,this.h=S,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(D,S){return super.on(D,S),this}handleData(D){if(this.b)return;const S=typeof D=="string"?D:this.d.write(D);this.k(S)}k(D){let S=D.indexOf(`
`);const C=this.a+D;if(S>=0)S+=this.a.length;else{this.a=C;return}let j=0;for(;S>=0;)this.m(C.substring(j,S).trim()),j=S+1,S=C.indexOf(`
`,j);this.a=C.substring(j)}m(D){if(this.b||!D)return;let S;try{S=JSON.parse(D)}catch{throw new Error(`malformed line from rg: ${D}`)}if(S.type==="match"){const C=d(S.data.path),j=E.URI.joinPath(this.h,C),B=this.n(S.data,j);this.p(B),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const C=d(S.data.path),j=E.URI.joinPath(this.h,C);this.o(S.data,j).forEach(z=>this.p(z))}}n(D,S){const C=D.line_number-1,j=d(D.lines),B=Buffer.from(j);let z=0,T=0,M=C;D.submatches.length===0&&D.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.$Hb)(D.submatches.map((O,q)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Y=d(O.match),V=B.slice(z,O.start).toString(),J=o(V),x=J.numLines>0?J.lastLineLength:J.lastLineLength+T,ne=o(Y),de=J.numLines+M,ce=ne.numLines+de,ve=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return z=O.end,T=ve,M=ce,new P.$fL(de,x,ce,ve)}));return(0,p.$Gnc)(S,j,F,this.j)}o(D,S){const C=d(D.lines),j=D.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((B,z)=>({text:B,uri:S,lineNumber:j+z}))}p(D){this.emit("result",D)}}e.$Onc=i;function d(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function o(w){const D=/\n/g;let S=0,C=-1,j;for(;j=D.exec(w);)S++,C=j.index;const B=C>=0?w.length-C-1:w.length;return{numLines:S,lastLineLength:B}}function t(w,D){const S=["--hidden","--no-require-git"];S.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:j}=(0,L.$E)(D.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const z=new Set;j.forEach(T=>{z.add(T)}),S.push("-g","!*"),z.forEach(T=>{l(T).map(p.$Fnc).forEach(M=>{S.push("-g",M)})})}C&&C.length&&C.forEach(z=>{S.push("-g",z)}),D.excludes.map(p.$Fnc).forEach(z=>S.push("-g",`!${z}`)),D.maxFileSize&&S.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?D.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),D.followSymlinks&&S.push("--follow"),D.encoding&&D.encoding!=="utf8"&&S.push("--encoding",D.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,m.$af)(w.pattern),w.isRegExp=!0),D.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),w.isRegExp&&(w.pattern=r(w.pattern),S.push("--engine","auto"));let B;if(w.isWordMatch){const T=(0,m.$jf)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",T)}else if(w.isRegExp){let z=s(w.pattern);z=v(z),S.push("--regexp",z)}else B=w.pattern,S.push("--fixed-strings");return S.push("--no-config"),D.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),w.isMultiline&&S.push("--multiline"),D.beforeContext&&S.push("--before-context",D.beforeContext+""),D.afterContext&&S.push("--after-context",D.afterContext+""),S.push("--"),B&&S.push(B),S.push("."),S}function l(w){return y(w).flatMap(S=>{const C=(0,$.$ok)(S,"/");return C.map((j,B)=>C.slice(0,B+1).join("/"))})}function r(w){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(D);)w=w.replace(D,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(S);)w=w.replace(S,"$1\\x{$2}");return w}const c=w=>w.type==="Assertion"&&w.kind==="lookbehind";function s(w){let D;try{D=new b.RegExpParser().parsePattern(w)}catch{return w}let S="",C=0;const j=(T,M,F)=>{S+=w.slice(C,T)+F,C=M},B=[];return new b.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const M=B[0];if(!M)j(T.start,T.end,"\\r?\\n");else if(!B.some(c))if(M.type==="CharacterClass")if(M.negate){const F=w.slice(M.start+2,T.start)+w.slice(T.end,M.end-1);M.parent?.type==="Quantifier"?j(M.start,M.end,F?`[^${F}]`:"."):j(M.start,M.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=w.slice(M.start+1,T.start)+w.slice(T.end,M.end-1);j(M.start,M.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else M.type==="Quantifier"&&j(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){B.unshift(T)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(T){B.unshift(T)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(T){B.unshift(T)},onCharacterClassLeave(){B.shift()},onAssertionEnter(T){c(T)&&B.push(T)},onAssertionLeave(T){B[0]===T&&B.shift()}}).visit(D),S+=w.slice(C),S}function v(w){return w.replace(/\n/g,"\\r?\\n")}function f(w){let D=!1,S=!1,C="",j="";for(let B=0;B<w.length;B++){const z=w[B];switch(z){case"\\":S?(D?j+="\\"+z:C+="\\"+z,S=!1):S=!0;break;case"{":if(S)D?j+=z:C+=z,S=!1;else{if(D)return{strInBraces:C+"{"+j+"{"+w.substring(B+1)};D=!0}break;case"}":if(S)D?j+=z:C+=z,S=!1;else{if(D)return{fixedStart:C,strInBraces:j,fixedEnd:w.substring(B+1)};C+=z}break;default:D?j+=(S?"\\":"")+z:C+=(S?"\\":"")+z,S=!1;break}}return{strInBraces:C+(D?"{"+j:"")}}function y(w){const{fixedStart:D,strInBraces:S,fixedEnd:C}=f(w);if(D===void 0||C===void 0)return[S];let j=(0,$.$ok)(S,",");j.length||(j=[""]);const B=y(C);return j.flatMap(z=>{const T=D+z;return B.map(M=>T+M)})}}),define(ke[390],Se([1,0,22,163,109,15]),function(ie,e,a,N,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class L{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,I,P,b){const k=new N.$Nnc(this.b);if(I.folder.scheme===R.Schemas.vscodeUserData){const p={...I,folder:I.folder.with({scheme:R.Schemas.file})},h=new A.$ew(g=>P.report({...g,uri:g.uri.with({scheme:I.folder.scheme})}));return this.c(b,g=>k.provideTextSearchResults(E,p,h,g))}else return this.c(b,p=>k.provideTextSearchResults(E,I,P,p))}async c(E,I){const P=$(E);this.a.add(P);const b=await I(P.token);return this.a.delete(P),b}d(){this.a.forEach(E=>E.cancel())}}e.$Xnc=L;function $(m){const E=new a.$pe;return m.onCancellationRequested(()=>E.cancel()),E}}),define(ke[391],Se([1,0,32,163,162]),function(ie,e,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=void 0;class R{constructor(m){this.a=m}search(m,E,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(k){I({message:k})}},b=new A.$Unc(this.a,new N.$Nnc(P),a);return new Promise((k,p)=>b.search(h=>{E(h.map(L))},m).then(h=>k({limitHit:h.limitHit,type:"success",stats:h.stats}),p))}}e.$Vnc=R;function L($){return{path:$.resource&&$.resource.fsPath,results:$.results,numMatches:($.results||[]).reduce((m,E)=>{if(E.ranges){const I=E;return m+(Array.isArray(I.ranges)?I.ranges.length:1)}else return m+1},0)}}}),define(ke[392],Se([1,0,19,7,13,4,130,17,41,2,33,37,387,391]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class p{constructor(d="searchProcess"){this.d=d,this.b=Object.create(null)}fileSearch(d){let o;const t=u(d),l=new R.$ee({onDidAddFirstListener:()=>{o=(0,N.$jh)(r=>this.doFileSearchWithEngine(b.$Mnc,t,c=>l.fire(c),r)),o.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return l.event}textSearch(d){let o;const t=u(d),l=new R.$ee({onDidAddFirstListener:()=>{o=(0,N.$jh)(r=>this.f(t,c=>l.fire(c),r)),o.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return l.event}f(d,o,t){return d.maxFileSize=this.g().maxFileSize,new k.$Vnc(d).search(t,o,o)}g(){return{maxFileSize:16*I.$yl.GB}}doFileSearch(d,o,t){return this.doFileSearchWithEngine(b.$Mnc,d,o,t)}doFileSearchWithEngine(d,o,t,l,r=p.a){let c=0;const s=f=>{Array.isArray(f)?(c+=f.length,t(f.map(y=>this.h(y)))):f.relativePath?(c++,t(this.h(f))):t(f)};if(o.sortByScore){let f=this.l(o,s,l);if(!f){const y=o.maxResults?Object.assign({},o,{maxResults:null}):o,w=new d(y);f=this.j(w,o,t,s,l)}return new Promise((y,w)=>{f.then(([D,S])=>{const C=S.map(j=>this.h(j));this.o(C,t,r),y(D)},w)})}const v=new d(o);return this.r(v,s,r,l).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(d){return{path:d.base?(0,$.$kc)(d.base,d.relativePath):d.relativePath}}j(d,o,t,l,r){const c=new R.$ee;let s=(0,N.$jh)(f=>{let y=[];const w=D=>{Array.isArray(D)?y=D:(l(D),c.fire(D))};return this.r(d,w,-1,f).then(D=>[D,y])}),v;if(o.cacheKey){v=this.k(o.cacheKey);const f={promise:s,event:c.event,resolved:!1};v.resultsToSearchCache[o.filePattern||""]=f,s.then(()=>{f.resolved=!0},y=>{delete v.resultsToSearchCache[o.filePattern||""]}),s=this.s(s)}return s.then(([f,y])=>{const w=v?v.scorerCache:Object.create(null),D=(typeof o.maxResults!="number"||o.maxResults>0)&&m.$ae.create(!1);return this.n(o,y,w,r).then(S=>{const C=D?D.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:S.length},messages:f.messages,limitHit:f.limitHit||typeof o.maxResults=="number"&&y.length>o.maxResults},S]})})}k(d){const o=this.b[d];return o||(this.b[d]=new h)}l(d,o,t){const l=d.cacheKey&&this.b[d.cacheKey];if(!l)return;const r=this.q(l,d.filePattern||"",o,t);if(r)return r.then(([c,s,v])=>{const f=m.$ae.create(!1);return this.n(d,s,l.scorerCache,t).then(y=>{const w=f.elapsed(),D={fromCache:!0,detailStats:v,type:this.d,resultCount:s.length,sortingTime:w};return[{type:"success",limitHit:c.limitHit||typeof d.maxResults=="number"&&s.length>d.maxResults,stats:D},y]})})}n(d,o,t,l){const r=(0,L.$yr)(d.filePattern||""),c=(v,f)=>(0,L.$xr)(v,f,r,!0,g,t),s=typeof d.maxResults=="number"?d.maxResults:Number.MAX_VALUE;return a.$Gb(o,c,s,1e4,l)}o(d,o,t){if(t&&t>0)for(let l=0;l<d.length;l+=t)o(d.slice(l,l+t));else o(d)}q(d,o,t,l){const r=m.$ae.create(!1),c=o.indexOf($.sep)>=0;let s;for(const w in d.resultsToSearchCache)if(o.startsWith(w)){if(c&&w.indexOf($.sep)<0&&w!=="")continue;const D=d.resultsToSearchCache[w];s={promise:this.s(D.promise),event:D.event,resolved:D.resolved};break}if(!s)return null;const v=r.elapsed(),f=m.$ae.create(!1),y=s.event(t);return l&&l.onCancellationRequested(()=>{y.dispose()}),s.promise.then(([w,D])=>{if(l&&l.isCancellationRequested)throw(0,A.$6)();const S=[],C=(0,L.$yr)(o).normalizedLowercase;for(const j of D)(0,P.$BL)(j,C)&&S.push(j);return[w,S,{cacheWasResolved:s.resolved,cacheLookupTime:v,cacheFilterTime:f.elapsed(),cacheEntryCount:D.length}]})}r(d,o,t,l){return new Promise((r,c)=>{let s=[];l?.onCancellationRequested(()=>d.cancel()),d.search(v=>{v&&(t?(s.push(v),t>0&&s.length>=t&&(o(s),s=[])):o(v))},v=>{o(v)},(v,f)=>{s.length&&o(s),v?(o({message:"Search finished. Error: "+v.message}),c(v)):(o({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),r(f))})})}clearCache(d){return delete this.b[d],Promise.resolve(void 0)}s(d){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return d.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return d.finally(o)}}}}e.$Wnc=p,p.a=512;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(i){return(0,$.$oc)(i.relativePath)}getItemDescription(i){return(0,$.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function u(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(d=>E.URI.revive(d))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[393],Se([1,0,3,15,2,32,11,28,20,97,68,37,392,390,124,162]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;let g=class extends E.$Jmc{constructor(n,i,d,o){super(n,d,o),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new a.$Uc;const t=new p.$Hnc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new k.$Xnc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new p.$Hnc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new k.$Xnc(n))),this.A.add(this.C(N.Schemas.file,new b.$Wnc("fileSearchProvider")))}C(n,i){const d=this.d++;return this.y=i,this.x=d,this.c.$registerFileSearchProvider(d,this.s(n)),(0,a.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(d)})}$provideFileSearchResults(n,i,d,o){const t=(0,E.$Kmc)(d);if(n===this.x){const l=Date.now();return this.D(n,i,t,o).then(r=>{const c=Date.now()-l;return this.q.debug(`Ext host file search time: ${c}ms`),r})}return super.$provideFileSearchResults(n,i,d,o)}doInternalFileSearchWithCustomCallback(n,i,d){const o=t=>{if((0,P.$AL)(t)&&(t=[t]),Array.isArray(t)){d(t.map(l=>A.URI.file(l.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,d,o){return this.doInternalFileSearchWithCustomCallback(d,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$Unc(n,i,void 0,"textSearchProvider")}};e.$Ync=g,e.$Ync=g=Je([Ue(0,m.$xP),Ue(1,$.$NP),Ue(2,I.$Alc),Ue(3,L.$3j)],g)}),define(ke[125],Se([1,0,407,64,63,408,21,13,4,3,17,12,31,81,82]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=c,e.$ri=f,e.$si=y;class h{traceSocketEvent(D,S){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,S)}constructor(D,S=""){this.f=!0,this.debugLabel=S,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,$.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const S=C=>{this.traceSocketEvent("read",C),D(L.$Ge.wrap(C))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(D){const S=C=>{D({type:0,hadError:C,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(D){const S=()=>{D()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,$.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,$.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$li=h;var g;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var u;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(u||(u={}));class n extends E.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,S){this.socket.traceSocketEvent(D,S)}constructor(D,S,C,j){super(),this.f=this.B(new m.$ee),this.g=this.B(new m.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:C?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new i(this,S,C,j,this.f,(B,z)=>this.m(B,z))),this.B(this.a.onError(B=>{console.error(B),(0,$.$1)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new p.$gi,this.B(this.socket.onData(B=>this.n(B))),this.B(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let S=0;for(;S<D.byteLength;)this.a.writeMessage(D.slice(S,Math.min(S+262144,D.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(D,{compressed:S,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let j=2;D.byteLength<126?j+=0:D.byteLength<2**16?j+=2:j+=8;const B=L.$Ge.alloc(j),z=S?64:0,T=C&15;if(B.writeUInt8(128|z|T,0),D.byteLength<126)B.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){B.writeUInt8(126,1);let M=1;B.writeUInt8(D.byteLength>>>8&255,++M),B.writeUInt8(D.byteLength>>>0&255,++M)}else{B.writeUInt8(127,1);let M=1;B.writeUInt8(0,++M),B.writeUInt8(0,++M),B.writeUInt8(0,++M),B.writeUInt8(0,++M),B.writeUInt8(D.byteLength>>>24&255,++M),B.writeUInt8(D.byteLength>>>16&255,++M),B.writeUInt8(D.byteLength>>>8&255,++M),B.writeUInt8(D.byteLength>>>0&255,++M)}this.socket.write(L.$Ge.concat([B,D]))}end(){this.h=!0,this.socket.end()}n(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),C=S.readUInt8(0),j=(C&128)>>>7,B=(C&64)>>>6,z=C&15,T=S.readUInt8(1),M=(T&128)>>>7,F=T&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!B),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),C=S.readUInt8(1),j=(C&128)>>>7;let B=C&127,z=1;B===126?B=S.readUInt8(++z)*2**8+S.readUInt8(++z):B===127&&(B=S.readUInt8(++z)*0+S.readUInt8(++z)*0+S.readUInt8(++z)*0+S.readUInt8(++z)*0+S.readUInt8(++z)*2**24+S.readUInt8(++z)*2**16+S.readUInt8(++z)*2**8+S.readUInt8(++z));let T=0;j&&(T=S.readUInt8(++z)*2**24+S.readUInt8(++z)*2**16+S.readUInt8(++z)*2**8+S.readUInt8(++z)),this.j.state=3,this.j.readLen=B,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=n;class i extends E.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Ge.alloc(0)}constructor(D,S,C,j,B,z){super(),this.n=D,this.r=B,this.s=z,this.a=this.B(new m.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new m.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new m.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new d(this.n,j,C,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(D,S){this.g.push({data:D,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:D,options:S}=this.g.shift();if(this.f&&S.compressed){const C=await this.w(this.f,D);this.s(C,S)}else this.s(D,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(D,S){return new Promise((C,j)=>{D.write(S),D.flush(B=>C(B))})}acceptFrame(D,S,C){this.h.push({data:D,isCompressed:S,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const S=await this.C(this.b,D.data,D.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(D.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(D,S,C){return new Promise((j,B)=>{D.write(S),C&&D.write(L.$Ge.fromByteArray([0,0,255,255])),D.flush(z=>j(z))})}}class d extends E.$Vc{get recordedInflateBytes(){return this.j?L.$Ge.concat(this.f):L.$Ge.alloc(0)}constructor(D,S,C,j){super(),this.h=D,this.j=S,this.a=this.B(new m.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(j),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(L.$Ge.wrap(B))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent("zlibInflateWrite",D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=L.$Ge.concat(this.g);this.g.length=0,D(S)})}}class o extends E.$Vc{constructor(D,S){super(),this.g=D,this.a=this.B(new m.$ee),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(L.$Ge.wrap(C))})}write(D){this.g.traceSocketEvent("zlibDeflateWrite",D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=L.$Ge.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),D(S)})}}function t(w,D){if(D===0)return;const S=w.byteLength>>>2;for(let M=0;M<S;M++){const F=w.readUInt32BE(M*4);w.writeUInt32BE(F^D,M*4)}const C=S*4,j=w.byteLength-C,B=D>>>24&255,z=D>>>16&255,T=D>>>8&255;j>=1&&w.writeUInt8(w.readUInt8(C)^B,C),j>=2&&w.writeUInt8(w.readUInt8(C+1)^z,C+1),j>=3&&w.writeUInt8(w.readUInt8(C+2)^T,C+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const l={2:107,1:103};function r(){const w=(0,b.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const D=process.platform!=="darwin"&&e.$ni?e.$ni:(0,A.tmpdir)(),S=(0,I.$kc)(D,`vscode-ipc-${w}.sock`);return s(S),S}function c(w,D,S){const j=(0,a.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${S}-${D}-sock`;const B=S.substr(0,4),z=D.substr(0,6);let T;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?T=(0,I.$kc)(e.$ni,`vscode-${j}-${B}-${z}.sock`):T=(0,I.$kc)(w,`${B}-${z}.sock`),s(T),T}function s(w){const D=l[P.$o];typeof D=="number"&&w.length>=D&&console.warn(`WARNING: IPC handle "${w}" is longer than ${D} chars, try a shorter --user-data-dir`)}class v extends k.$ai{static b(D){const S=m.Event.fromNodeEventEmitter(D,"connection");return m.Event.map(S,C=>({protocol:new p.$hi(new h(C,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(C,"close"))}))}constructor(D){super(v.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=v;function f(w){return new Promise((D,S)=>{const C=(0,N.createServer)();C.on("error",S),C.listen(w,()=>{C.removeListener("error",S),D(new v(C))})})}function y(w,D){return new Promise((S,C)=>{const j=(0,N.createConnection)(w,()=>{j.removeListener("error",C),S(p.$ii.fromSocket(new h(j,`ipc-client${D}`),D))});j.once("error",C)})}}),define(ke[394],Se([1,0,64,63,181,125,7,3,12,55,11,108,272,273,111,88,21]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=e.$Ldc=e.$Kdc=void 0;async function u(t,l,r,c,s){let v;for(let f=3;f&&(v?.dispose(),v=await new n(t,l,r,c,s).waitForReady(),!(s&&A.$Vg[s]||!A.$Vg[v.tunnelLocalPort]));f--);return v}class n extends $.$Vc{constructor(l,r,c,s,v){super(),this.m=r,this.n=v,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=a.createServer(),this.c=new L.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,h.$rw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,A.$Wg)(l,2,1e3,r),s=null;return this.b.listen(c,this.m),await this.c.wait(),s=this.b.address(),s||(c=0,this.b.listen(c,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(l){l.pause();const r=(0,h.$pw)(this.tunnelRemoteHost)||(0,h.$rw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.$Sl)(this.a,r,this.tunnelRemotePort),s=c.getSocket(),v=c.readEntireBuffer();c.dispose(),v.byteLength>0&&l.write(v.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),s.end()}),l.on("close",()=>s.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),s instanceof R.$li?s.socket.destroy():s.end()}),s instanceof R.$li?this.t(l,s):this.s(l,s),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),s.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(c=>l.write(c.buffer)),l.on("data",c=>r.write(g.$Ge.wrap(c))),l.resume()}t(l,r){const c=r.socket;c.on("end",()=>l.end()),c.on("close",()=>l.end()),c.on("error",()=>{l.destroy()}),c.pipe(l),l.pipe(c)}}e.$Kdc=n;let i=class extends h.$uw{constructor(l,r,c,s,v){super(r,v),this.v=l,this.w=c,this.y=s}isPortPrivileged(l){return(0,h.$sw)(l,this.m,m.OS,N.release())}t(l,r,c,s,v,f,y,w){const D=this.s(r,c);if(D)return++D.refcount,D.value;if((0,h.$lw)(l))return this.u(l,r,c,v,f,y,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${c} on local port ${v}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:l,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=u(S,s,r,c,v);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,c,C),C}}};e.$Ldc=i,e.$Ldc=i=Je([Ue(0,k.$Ml),Ue(1,I.$3j),Ue(2,p.$Pl),Ue(3,P.$jk),Ue(4,E.$3i)],i);let d=class extends i{constructor(l,r,c,s,v){super(l,r,c,s,v)}};e.$Mdc=d,e.$Mdc=d=Je([Ue(0,k.$Ml),Ue(1,I.$3j),Ue(2,p.$Pl),Ue(3,P.$jk),Ue(4,E.$3i)],d);let o=class extends $.$Vc{constructor(l,r,c,s,v){super(),this.b=l,this.c=r,this.f=c,this.g=s,this.h=v,this.a=new Map}async openTunnel(l,r,c,s,v,f,y,w,D){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${f}.`),!this.a.has(l)){const S=new d(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(l,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,c,s,v,f,y,w,D)}};e.$Ndc=o,e.$Ndc=o=Je([Ue(0,k.$Ml),Ue(1,I.$3j),Ue(2,P.$jk),Ue(3,p.$Pl),Ue(4,E.$3i)],o)}),define(ke[395],Se([1,0,125,113,52,34,2,11,43]),function(ie,e,a,N,A,R,L,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=void 0;class E{constructor(b,k,p){this.b=b,this.c=k,this.f=p,this.a=N.createServer((h,g)=>this.h(h,g)),this.g().catch(h=>(k.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,k){const p=(g,u)=>{k.writeHead(g,{"content-type":"application/json"}),k.end(JSON.stringify(u||null),n=>n&&this.c.error(n))},h=[];b.setEncoding("utf8"),b.on("data",g=>h.push(g)),b.on("end",async()=>{try{const g=JSON.parse(h.join(""));let u;switch(g.type){case"open":u=await this.i(g);break;case"openExternal":u=await this.j(g);break;case"status":u=await this.l(g);break;case"extensionManagement":u=await this.k(g);break;default:p(404,`Unknown message type: ${g.type}`);break}p(200,u)}catch(g){const u=g instanceof Error?g.message:JSON.stringify(g);p(500,u),this.c.error("Error while processing pipe request",g)}})}async i(b){const{fileURIs:k,folderURIs:p,forceNewWindow:h,diffMode:g,mergeMode:u,addMode:n,forceReuseWindow:i,gotoLineMode:d,waitMarkerFilePath:o,remoteAuthority:t}=b,l=[];if(Array.isArray(p))for(const v of p)try{l.push({folderUri:L.URI.parse(v)})}catch{}if(Array.isArray(k))for(const v of k)try{(0,m.$2i)(v)?l.push({workspaceUri:L.URI.parse(v)}):l.push({fileUri:L.URI.parse(v)})}catch{}const r=o?L.URI.file(o):void 0,s={forceNewWindow:h,diffMode:g,mergeMode:u,addMode:n,gotoLineMode:d,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",l,s)}async j(b){for(const k of b.uris){const p=L.URI.parse(k),h=p.scheme==="file"?p:k;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(b){const k=h=>h?.map(g=>/\.vsix$/i.test(g)?L.URI.parse(g):g),p={list:b.list,install:k(b.install),uninstall:k(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$YP=E;let I=class extends E{constructor(b,k){super(b,k,(0,a.$oi)())}};e.$ZP=I,e.$ZP=I=Je([Ue(0,R.$TP),Ue(1,$.$3j)],I)}),define(ke[396],Se([1,0,113,59,383,378,291,49,365,2,15,8,395,103,324,39,364]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;class u extends R.$snc{k(){const d=this,o=globalThis._VSCODE_NODE_MODULES.module,t=o._load;o._load=function(s,v,f){return s=r(s),d.a.has(s)?d.a.get(s).load(s,E.URI.file((0,k.$8q)(v.filename)),y=>t.apply(this,[y,v,f])):t.apply(this,arguments)};const l=o._resolveLookupPaths;o._resolveLookupPaths=(c,s)=>l.call(this,r(c),s);const r=c=>{for(const s of d.b){const v=s(c);if(v){c=v;break}}return c}}}class n extends $.$gmc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async vb(){this.h.createInstance(p.$2nc);const d=this.h.invokeFunction(A.$onc);if(this.h.createInstance(m.$1nc),this.f.remote.isRemote&&this.f.remote.authority){const l=this.h.createInstance(b.$ZP);process.env.VSCODE_IPC_HOOK_CLI=l.ipcHandlePath}this.h.createInstance(g.$3nc),await this.h.createInstance(u,d,{mine:this.J,all:this.L}).install(),N.mark("code/extHost/didInitAPI"),(async()=>{const l=process.env.VSCODE_IPC_HOOK_CLI,r=process.env.CODE_SERVER_SESSION_SOCKET;if(!l||!r)return;const s={workspace:this.h.invokeFunction(f=>f.get(h.$Dlc).workspace),socketPath:l},v=JSON.stringify({entry:s});await new Promise((f,y)=>{const w={path:"/add-session",socketPath:r,method:"POST",headers:{"content-type":"application/json"}},D=a.request(w,S=>{S.on("error",y),S.on("end",()=>{try{S.statusCode===200?f():y(new Error("Unexpected status code: "+S.statusCode))}catch(C){y(C)}})});D.on("error",y),D.write(v),D.end()})})().catch(l=>{this.s.error(l)});const t=await this.m.getConfigProvider();await(0,L.$Znc)(this.j,t,this,this.s,this.z,this.f),N.mark("code/extHost/didInitProxyResolver")}wb(d){return d.main}async xb(d,o,t){if(o.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${o}', must be of file-scheme`);let l=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${o.toString(!0)}`),this.s.flush();const r=d?.identifier.value;d&&await this.w.initializeLocalizedMessages(d);try{r&&N.mark(`code/extHost/willLoadExtensionCode/${r}`),l=ie.__$__nodeRequire(o.fsPath)}finally{r&&N.mark(`code/extHost/didLoadExtensionCode/${r}`),t.codeLoadingStop()}return l}async $setRemoteEnvironment(d){if(this.f.remote.isRemote)for(const o in d){const t=d[o];t===null?delete process.env[o]:process.env[o]=t}}}e.$4nc=n}),define(ke[397],Se([1,0,53,21,4,3,127,12,23,2,32,11,271,67,111,88,394,28,20,71,372]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0,e.$5nc=o,e.$6nc=t,e.$7nc=l,e.$8nc=r,e.$9nc=s,e.$0nc=v,e.$$nc=f;function o(D){const S=D.trim().split(`
`),C=[];return S.forEach(B=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(B);z&&z.length>=3&&C.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),C.reduce((B,z)=>(B[z.socket]=z,B),{})}function t(...D){const S=[].concat(...D.map(r));return[...new Map(S.filter(C=>C.st==="0A").map(C=>{const j=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:l(j[0]),port:parseInt(j[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function l(D){let S="";if(D.length===8)for(let C=D.length-2;C>=0;C-=2)S+=parseInt(D.substr(C,2),16),C!==0&&(S+=".");else for(let C=0;C<D.length;C+=8){const j=D.substring(C,C+8);let B="";for(let z=8;z>=2;z-=2)B+=j.substring(z-2,z),(z===6||z===2)&&(B=parseInt(B,16).toString(16),S+=`${B}`,B="",C+z!==D.length-6&&(S+=":"))}return S}function r(D){const S=D.trim().split(`
`),C=S.shift().trim().split(/\s+/).filter(B=>B!=="rx_queue"&&B!=="tm->when");return S.map(B=>B.trim().split(/\s+/).reduce((z,T,M)=>(z[C[M]||M]=T,z),{}))}function c(D){return!!D.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||D.indexOf("out/server-main.js")!==-1||D.indexOf("_productName=VSCode")!==-1}function s(D){const S=D.trim().split(`
`),C=[];return S.forEach(j=>{const B=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(j);B&&B.length>=4&&C.push({pid:parseInt(B[1],10),ppid:parseInt(B[2]),cmd:B[3]})}),C}async function v(D,S,C){const j=C.reduce((z,T)=>(z[T.pid]=T,z),{}),B=[];return D.forEach(({socket:z,ip:T,port:M})=>{const F=S[z]?S[z].pid:void 0,O=F?j[F]?.cmd:void 0;F&&O&&!c(O)&&B.push({host:T,port:M,detail:O,pid:F})}),B}function f(D,S,C){const j=new Map,B=s(S);for(const z of D){const T=C.get(z.port);if(T){j.set(z.port,T);continue}const M=B.find(F=>F.cmd.includes(`${z.port}`));if(M){let F=M,O;do O=B.find(q=>q.ppid===F.pid),O&&(F=O);while(O);j.set(z.port,{host:z.ip,port:z.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else j.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return j}let y=class extends i.$GDb{constructor(S,C,j,B){super(S,C,j),this.D=C,this.F=B,this.y=void 0,this.z=new Map,this.C=!1,$.$e&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(S){if(S&&this.C)return;this.C=S;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const j=new L.$Fm;let B=0;for(;this.C;){const z=new Date().getTime(),T=(await this.I()).filter(O=>(0,h.$pw)(O.host)||(0,h.$rw)(O.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(O=>O.port).join(", ")}`);const M=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),B++>3&&j.update(M),(!C||JSON.stringify(C)!==JSON.stringify(T))&&(C=T,await this.a.$onFoundNewCandidates(C));const F=this.G(j.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(O=>setTimeout(()=>O(),F))}}G(S){return Math.max(S*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(S=>S.port).join(", ")}`)}async I(){let S="",C="";try{S=await I.Promises.readFile("/proc/net/tcp","utf8"),C=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const j=t(S,C),B=await new Promise(V=>{(0,a.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,x,ne)=>{V(x)})}),z=o(B),T=await I.Promises.readdir("/proc"),M=[];for(const V of T)try{const J=Number(V),x=m.$0g(E.URI.file("/proc"),V);if((await I.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(J)){const de=await I.Promises.readlink(m.$0g(x,"cwd").fsPath),ce=await I.Promises.readFile(m.$0g(x,"cmdline").fsPath,"utf8");M.push({pid:J,cwd:de,cmd:ce})}}catch{}const F=[],O=j.filter(V=>{const J=z[V.socket];return J||F.push(V),J}),q=v(O,z,M);let Y;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const V=await new Promise(J=>{(0,a.exec)("ps -F -A -l | grep root",(x,ne,de)=>{J(ne)})});this.z=f(F,V,this.z),Y=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Y.map(J=>J.port).join(", ")}`)}return q.then(V=>Y?V.concat(Y):V)}w(S){return async C=>{const j=new g.$Kdc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,T,M,F){const O=await S.makeConnection();return w.connect(O,T,M,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$Il(0),connectionToken:S.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await j.waitForReady();const B=new A.$ee;return{localAddress:(0,d.$xM)(j.localAddress)??j.localAddress,remoteAddress:{port:j.tunnelRemotePort,host:j.tunnelRemoteHost},onDidDispose:B.event,dispose:()=>{j.dispose(),B.fire(),B.dispose()}}}}};e.$_nc=y,e.$_nc=y=Je([Ue(0,n.$xP),Ue(1,u.$NP),Ue(2,P.$3j),Ue(3,p.$Pl)],y);class w extends b.$Avb{static connect(S,C,j,B){const z=new R.$Uc,T={onClose:z.add(new A.$ee),onData:z.add(new A.$ee),onEnd:z.add(new A.$ee)};z.add(S.onDidReceiveMessage(F=>T.onData.fire(N.$Ge.wrap(F)))),z.add(S.onDidEnd(()=>T.onEnd.fire())),z.add(S.onDidClose(F=>T.onClose.fire({type:0,error:F,hadError:!!F})));const M=new w(S,B,T);return M.B(z),(0,b.$zvb)(M,C,j,B,T)}constructor(S,C,j){super(C,j),this.n=S}write(S){this.n.send(S.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[398],Se([1,0,85,367,381,380,393,396,397,96,49,97,95,44,71,93,366,325,11,382,61,286,106,111,142]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n,i,d,o,t,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.$ys)(I.$hmc,$.$4nc,0),(0,a.$ys)(n.$4j,u.$boc,1),(0,a.$ys)(n.$3j,new t.$ti(o.$rnc,[!1],!0)),(0,a.$ys)(l.$Pl,r.$Pdc,1),(0,a.$ys)(h.$Jlc,g.$aoc,0),(0,a.$ys)(E.$mmc,R.$Enc,0),(0,a.$ys)(P.$Imc,L.$Ync,0),(0,a.$ys)(b.$$mc,A.$wnc,0),(0,a.$ys)(k.$5lc,N.$vnc,0),(0,a.$ys)(p.$FDb,m.$_nc,0),(0,a.$ys)(d.$kmc,i.$coc,0)}),define(ke[409],Se([1,0,113,64,410,59,13,82,125,269,116,379,21,32,103,7,137,292,308,384,398]),function(ie,e,a,N,A,R,L,$,m,E,I,P,b,k,p,h,g,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let y=0;y<process.execArgv.length;y++)process.execArgv[y]==="--inspect-port=0"&&(process.execArgv.splice(y,1),y--)}();const i=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const f=globalThis._VSCODE_NODE_MODULES.module,y=f._load;f._load=function(w){if(w==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return y.apply(this,arguments)}})();const d=process.exit.bind(process),o=process.on.bind(process);function t(f){process.exit=function(y){if(f)d(y);else{const w=new Error("An extension called process.exit() and this was prevented.");console.warn(w.stack)}},process.crash=function(){const y=new Error("An extension called process.crash() and this was prevented.");console.warn(y.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(y,w){y==="uncaughtException"&&(w=function(){try{return w.call(void 0,arguments)}catch{}}),o(y,w)}}let l=function(f){d()};function r(){const f=(0,n.$pn)(process.env);if(f.type===3)return new Promise((y,w)=>{const D=S=>{const C=S[0],j=new $.$ji;C.on("message",B=>j.fire(b.$Ge.wrap(B.data))),C.on("close",()=>{l("renderer closed the MessagePort")}),C.start(),y({onMessage:j.event,send:B=>C.postMessage(B.buffer)})};process.parentPort.on("message",S=>D(S.ports))});if(f.type===2)return new Promise((y,w)=>{let D=null;const S=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),C=108e5,j=3e5,B=new h.$Jh(()=>l("renderer disconnected for too long (1)"),C),z=new h.$Jh(()=>l("renderer disconnected for too long (2)"),j);process.on("message",(M,F)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){F.setNoDelay(!0);const O=b.$Ge.wrap(Buffer.from(M.initialDataChunk,"base64"));let q;if(M.skipWebSocketFrames)q=new m.$li(F,"extHost-socket");else{const Y=b.$Ge.wrap(Buffer.from(M.inflateBytes,"base64"));q=new m.$mi(new m.$li(F,"extHost-socket"),M.permessageDeflate,Y,!1)}D?(B.cancel(),z.cancel(),D.beginAcceptReconnection(q,O),D.endAcceptReconnection(),D.sendResume()):(clearTimeout(S),D=new $.$ki({socket:q,initialChunk:O}),D.sendResume(),D.onDidDispose(()=>l("renderer disconnected")),y(D),D.onSocketClose(()=>{B.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;B.isScheduled()&&z.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const y=f.pipeName;return new Promise((w,D)=>{const S=N.createConnection(y,()=>{S.removeListener("error",D);const C=new $.$ki({socket:new m.$li(S,"extHost-renderer")});C.sendResume(),w(C)});S.once("error",D),S.on("close",()=>{l("renderer closed the socket")})})}}async function c(){const f=await r();return new class{constructor(){this.a=new $.$ji,this.onMessage=this.a.event,this.b=!1,f.onMessage(y=>{(0,I.$2m)(y,2)?(this.b=!0,l("received terminate message from renderer")):this.a.fire(y)})}send(y){this.b||f.send(y)}async drain(){if(f.drain)return f.drain()}}}function s(f){return new Promise(y=>{const w=f.onMessage(D=>{w.dispose();const S=JSON.parse(D.toString()),C=S.commit,j=E.default.commit;if(C&&j&&C!==j&&d(55),S.parentPid){let B=0;setInterval(function(){try{process.kill(S.parentPid,0),B=0}catch(T){T&&T.code==="EPERM"?(B++,B>=3&&l(`parent process ${S.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):l(`parent process ${S.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(S.parentPid)}catch(T){(0,L.$1)(T)}}f.send((0,I.$1m)(0)),y({protocol:f,initData:S})});f.send((0,I.$1m)(1))})}async function v(){const f=[];process.on("unhandledRejection",(B,z)=>{f.push(z),setTimeout(()=>{const T=f.indexOf(z);T>=0&&z.catch(M=>{f.splice(T,1),(0,L.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),B&&(0,L.$1)(B))})},1e3)}),process.on("rejectionHandled",B=>{const z=f.indexOf(B);z>=0&&f.splice(z,1)}),process.on("uncaughtException",function(B){(0,L.$Z)(B)||(0,L.$1)(B)}),R.mark("code/extHost/willConnectToRenderer");const y=await c();R.mark("code/extHost/didConnectToRenderer");const w=await s(y);R.mark("code/extHost/didWaitForInitData");const{initData:D}=w;t(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,g.boolean)(i.skipWorkspaceStorageLock,!1);const S=new class{constructor(){this.pid=process.pid}exit(z){d(z)}fsExists(z){return k.Promises.exists(z)}fsRealpath(z){return(0,p.$7q)(z)}};let C=null;D.remote.authority&&i.transformURIs&&(C=(0,u.$Cs)(D.remote.authority));const j=new P.$unc(w.protocol,D,S,C);l=B=>{j.terminate(B);const z=process.env.VSCODE_IPC_HOOK_CLI,T=process.env.CODE_SERVER_SESSION_SOCKET;if(!z||!T)return;const M=JSON.stringify({socketPath:z}),F={path:"/delete-session",socketPath:T,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},O=a.request(F);O.write(M),O.end()}}v().catch(f=>console.log(f))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
