"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ee){for(var e=[],y=0,A=ee.length;y<A;y++)e[y]=Ce[ee[y]];return e};define(Ce[69],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=A,e.$2h=C,e.$3h=O;function y(N){return(p,$,E)=>{let M=null,S=null;if(typeof E.value=="function"?(M="value",S=E.value):typeof E.get=="function"&&(M="get",S=E.get),!S)throw new Error("not supported");E[M]=N(S,$)}}function A(N,p,$){let E=null,M=null;if(typeof $.value=="function"?(E="value",M=$.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(E="get",M=$.get),!M)throw new Error("not supported");const S=`$memoize$${p}`;$[E]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,m)}),this[S]}}function C(N,p,$){return y((E,M)=>{const S=`$debounce$${M}`,m=`$debounce$result$${M}`;return function(...w){this[m]||(this[m]=$?$():void 0),clearTimeout(this[S]),p&&(this[m]=p(this[m],...w),w=[this[m]]),this[S]=setTimeout(()=>{E.apply(this,w),this[m]=$?$():void 0},N)}})}function O(N,p,$){return y((E,M)=>{const S=`$throttle$timer$${M}`,m=`$throttle$result$${M}`,w=`$throttle$lastRun$${M}`,g=`$throttle$pending$${M}`;return function(...r){if(this[m]||(this[m]=$?$():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),p&&(this[m]=p(this[m],...r)),this[g])return;const a=this[w]+N;a<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[m]]),this[m]=$?$():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[w]=Date.now(),E.apply(this,[this[m]]),this[m]=$?$():void 0},a-Date.now()))}})}}),define(Ce[125],Ae([1,0,18]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=C,e.$9c=O,e.$0c=N,e.$$c=p,e.$_c=$,e.$ad=E;const A=(w,g)=>w===g;e.$7c=A;function C(w=e.$7c){return(g,r)=>y.$ub(g,r,w)}function O(){return(w,g)=>JSON.stringify(w)===JSON.stringify(g)}function N(){return(w,g)=>w.equals(g)}function p(w,g,r){return!w||!g?w===g:r(w,g)}function $(w,g){if(w===g)return!0;if(Array.isArray(w)&&Array.isArray(g)){if(w.length!==g.length)return!1;for(let r=0;r<w.length;r++)if(!$(w[r],g[r]))return!1;return!0}if(w&&typeof w=="object"&&g&&typeof g=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(g)===Object.prototype){const r=w,a=g,s=Object.keys(r),n=Object.keys(a),i=new Set(n);if(s.length!==n.length)return!1;for(const c of s)if(!i.has(c)||!$(r[c],a[c]))return!1;return!0}return!1}function E(w){return JSON.stringify(m(w))}let M=0;const S=new WeakMap;function m(w){if(Array.isArray(w))return w.map(m);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const g=w,r=Object.create(null);for(const a of Object.keys(g).sort())r[a]=m(g[a]);return r}else{let g=S.get(w);return g===void 0&&(g=M++,S.set(w,g)),g+"----2b76a038c20c4bcc"}return w}}),define(Ce[91],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$CP=y,e.$DP=new y("id#")}),define(Ce[126],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$In=N,e.$Jn=S,e.$Kn=m,e.$Ln=w,e.$Mn=g,e.$Nn=r,e.$On=a,e.$Pn=s,e.$Qn=n,e.$Rn=i,e.$Sn=c,e.$Tn=h;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function N(t,d=!1){let o=0;const f=t.length;let u="",D=0,l=16,v=0;function b(L){let R=0,F=0;for(;R<L;){const T=t.charCodeAt(o);if(T>=48&&T<=57)F=F*16+T-48;else if(T>=65&&T<=70)F=F*16+T-65+10;else if(T>=97&&T<=102)F=F*16+T-97+10;else break;o++,R++}return R<L&&(F=-1),F}function P(L){o=L,u="",D=0,l=16,v=0}function k(){const L=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&E(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&E(t.charCodeAt(o)))for(o++;o<t.length&&E(t.charCodeAt(o));)o++;else return v=3,t.substring(L,o);let R=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&E(t.charCodeAt(o))){for(o++;o<t.length&&E(t.charCodeAt(o));)o++;R=o}else v=3;return t.substring(L,R)}function I(){let L="",R=o;for(;;){if(o>=f){L+=t.substring(R,o),v=2;break}const F=t.charCodeAt(o);if(F===34){L+=t.substring(R,o),o++;break}if(F===92){if(L+=t.substring(R,o),o++,o>=f){v=2;break}switch(t.charCodeAt(o++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const X=b(4);X>=0?L+=String.fromCharCode(X):v=4;break}default:v=5}R=o;continue}if(F>=0&&F<=31)if($(F)){L+=t.substring(R,o),v=2;break}else v=6;o++}return L}function U(){if(u="",v=0,D=o,o>=f)return D=f,l=17;let L=t.charCodeAt(o);if(p(L)){do o++,u+=String.fromCharCode(L),L=t.charCodeAt(o);while(p(L));return l=15}if($(L))return o++,u+=String.fromCharCode(L),L===13&&t.charCodeAt(o)===10&&(o++,u+=`
`),l=14;switch(L){case 123:return o++,l=1;case 125:return o++,l=2;case 91:return o++,l=3;case 93:return o++,l=4;case 58:return o++,l=6;case 44:return o++,l=5;case 34:return o++,u=I(),l=10;case 47:{const R=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<f&&!$(t.charCodeAt(o));)o++;return u=t.substring(R,o),l=12}if(t.charCodeAt(o+1)===42){o+=2;const F=f-1;let T=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,T=!0;break}o++}return T||(o++,v=1),u=t.substring(R,o),l=13}return u+=String.fromCharCode(L),o++,l=16}case 45:if(u+=String.fromCharCode(L),o++,o===f||!E(t.charCodeAt(o)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=k(),l=11;default:for(;o<f&&Q(L);)o++,L=t.charCodeAt(o);if(D!==o){switch(u=t.substring(D,o),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(L),o++,l=16}}function Q(L){if(p(L)||$(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:P,getPosition:()=>o,scan:d?G:U,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>D,getTokenLength:()=>o-D,getTokenError:()=>v}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function S(t,d){const o=[],f=new Object;let u;const D={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function v(b,P,k,I){D.value=b,D.offset=P,D.length=k,D.type=I,D.colonOffset=void 0,u=D}try{i(t,{onObjectBegin:(b,P)=>{if(d<=b)throw f;u=void 0,l=d>b,o.push("")},onObjectProperty:(b,P,k)=>{if(d<P||(v(b,P,k,"property"),o[o.length-1]=b,d<=P+k))throw f},onObjectEnd:(b,P)=>{if(d<=b)throw f;u=void 0,o.pop()},onArrayBegin:(b,P)=>{if(d<=b)throw f;u=void 0,o.push(0)},onArrayEnd:(b,P)=>{if(d<=b)throw f;u=void 0,o.pop()},onLiteralValue:(b,P,k)=>{if(d<P||(v(b,P,k,h(b)),d<=P+k))throw f},onSeparator:(b,P,k)=>{if(d<=P)throw f;if(b===":"&&u&&u.type==="property")u.colonOffset=P,l=!1,u=void 0;else if(b===","){const I=o[o.length-1];typeof I=="number"?o[o.length-1]=I+1:(l=!0,o[o.length-1]=""),u=void 0}}})}catch(b){if(b!==f)throw b}return{path:o,previousNode:u,isAtPropertyKey:l,matches:b=>{let P=0;for(let k=0;P<b.length&&k<o.length;k++)if(b[P]===o[k]||b[P]==="*")P++;else if(b[P]!=="**")return!1;return P===b.length}}}function m(t,d=[],o=O.DEFAULT){let f=null,u=[];const D=[];function l(b){Array.isArray(u)?u.push(b):f!==null&&(u[f]=b)}return i(t,{onObjectBegin:()=>{const b={};l(b),D.push(u),u=b,f=null},onObjectProperty:b=>{f=b},onObjectEnd:()=>{u=D.pop()},onArrayBegin:()=>{const b=[];l(b),D.push(u),u=b,f=null},onArrayEnd:()=>{u=D.pop()},onLiteralValue:l,onError:(b,P,k)=>{d.push({error:b,offset:P,length:k})}},o),u[0]}function w(t,d=[],o=O.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(b){f.type==="property"&&(f.length=b-f.offset,f=f.parent)}function D(b){return f.children.push(b),b}i(t,{onObjectBegin:b=>{f=D({type:"object",offset:b,length:-1,parent:f,children:[]})},onObjectProperty:(b,P,k)=>{f=D({type:"property",offset:P,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:b,offset:P,length:k,parent:f})},onObjectEnd:(b,P)=>{f.length=b+P-f.offset,f=f.parent,u(b+P)},onArrayBegin:(b,P)=>{f=D({type:"array",offset:b,length:-1,parent:f,children:[]})},onArrayEnd:(b,P)=>{f.length=b+P-f.offset,f=f.parent,u(b+P)},onLiteralValue:(b,P,k)=>{D({type:h(b),offset:P,length:k,parent:f,value:b}),u(P+k)},onSeparator:(b,P,k)=>{f.type==="property"&&(b===":"?f.colonOffset=P:b===","&&u(P))},onError:(b,P,k)=>{d.push({error:b,offset:P,length:k})}},o);const v=f.children[0];return v&&delete v.parent,v}function g(t,d){if(!t)return;let o=t;for(const f of d)if(typeof f=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let u=!1;for(const D of o.children)if(Array.isArray(D.children)&&D.children[0].value===f){o=D.children[1],u=!0;break}if(!u)return}else{const u=f;if(o.type!=="array"||u<0||!Array.isArray(o.children)||u>=o.children.length)return;o=o.children[u]}return o}function r(t){if(!t.parent||!t.parent.children)return[];const d=r(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;d.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&d.push(o)}return d}function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const d=Object.create(null);for(const o of t.children){const f=o.children[1];f&&(d[o.children[0].value]=a(f))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,d,o=!1){return d>=t.offset&&d<t.offset+t.length||o&&d===t.offset+t.length}function n(t,d,o=!1){if(s(t,d,o)){const f=t.children;if(Array.isArray(f))for(let u=0;u<f.length&&f[u].offset<=d;u++){const D=n(f[u],d,o);if(D)return D}return t}}function i(t,d,o=O.DEFAULT){const f=N(t,!1);function u(ke){return ke?()=>ke(f.getTokenOffset(),f.getTokenLength()):()=>!0}function D(ke){return ke?se=>ke(se,f.getTokenOffset(),f.getTokenLength()):()=>!0}const l=u(d.onObjectBegin),v=D(d.onObjectProperty),b=u(d.onObjectEnd),P=u(d.onArrayBegin),k=u(d.onArrayEnd),I=D(d.onLiteralValue),U=D(d.onSeparator),Q=u(d.onComment),G=D(d.onError),L=o&&o.disallowComments,R=o&&o.allowTrailingComma;function F(){for(;;){const ke=f.scan();switch(f.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:L||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(ke){case 12:case 13:L?T(10):Q();break;case 16:T(1);break;case 15:case 14:break;default:return ke}}}function T(ke,se=[],Pe=[]){if(G(ke),se.length+Pe.length>0){let re=f.getToken();for(;re!==17;){if(se.indexOf(re)!==-1){F();break}else if(Pe.indexOf(re)!==-1)break;re=F()}}}function X(ke){const se=f.getTokenValue();return ke?I(se):v(se),F(),!0}function ne(){switch(f.getToken()){case 11:{let ke=0;try{ke=JSON.parse(f.getTokenValue()),typeof ke!="number"&&(T(2),ke=0)}catch{T(2)}I(ke);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return F(),!0}function me(){return f.getToken()!==10?(T(3,[],[2,5]),!1):(X(!1),f.getToken()===6?(U(":"),F(),$e()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function we(){l(),F();let ke=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(ke||T(4,[],[]),U(","),F(),f.getToken()===2&&R)break}else ke&&T(6,[],[]);me()||T(4,[],[2,5]),ke=!0}return b(),f.getToken()!==2?T(7,[2],[]):F(),!0}function de(){P(),F();let ke=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(ke||T(4,[],[]),U(","),F(),f.getToken()===4&&R)break}else ke&&T(6,[],[]);$e()||T(4,[],[4,5]),ke=!0}return k(),f.getToken()!==4?T(8,[4],[]):F(),!0}function $e(){switch(f.getToken()){case 3:return de();case 1:return we();case 10:return X(!0);default:return ne()}}return F(),f.getToken()===17?o.allowEmptyContent?!0:(T(4,[],[]),!1):$e()?(f.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}function c(t,d){const o=N(t),f=[];let u,D=0,l;do switch(l=o.getPosition(),u=o.scan(),u){case 12:case 13:case 17:D!==l&&f.push(t.substring(D,l)),d!==void 0&&f.push(o.getTokenValue().replace(/[^\r\n]/g,d)),D=o.getPosition();break}while(u!==17);return f.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ee,e){typeof define=="function"&&define.amd?define(Ce[127],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(be,ge){for(var ae=0;ae<ge.length;ae++){var K=ge[ae];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(be,K.key,K)}}function y(be,ge,ae){return ge&&e(be.prototype,ge),ae&&e(be,ae),Object.defineProperty(be,"prototype",{writable:!1}),be}function A(be,ge){if(be){if(typeof be=="string")return C(be,ge);var ae=Object.prototype.toString.call(be).slice(8,-1);if(ae==="Object"&&be.constructor&&(ae=be.constructor.name),ae==="Map"||ae==="Set")return Array.from(be);if(ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ae))return C(be,ge)}}function C(be,ge){(ge==null||ge>be.length)&&(ge=be.length);for(var ae=0,K=new Array(ge);ae<ge;ae++)K[ae]=be[ae];return K}function O(be,ge){var ae=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(ae)return(ae=ae.call(be)).next.bind(ae);if(Array.isArray(be)||(ae=A(be))||ge&&be&&typeof be.length=="number"){ae&&(be=ae);var K=0;return function(){return K>=be.length?{done:!0}:{done:!1,value:be[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=N();function p(be){ee.defaults=be}var $=/[&<>"']/,E=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(ge){return m[ge]};function g(be,ge){if(ge){if($.test(be))return be.replace(E,w)}else if(M.test(be))return be.replace(S,w);return be}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(be){return be.replace(r,function(ge,ae){return ae=ae.toLowerCase(),ae==="colon"?":":ae.charAt(0)==="#"?ae.charAt(1)==="x"?String.fromCharCode(parseInt(ae.substring(2),16)):String.fromCharCode(+ae.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(be,ge){be=typeof be=="string"?be:be.source,ge=ge||"";var ae={replace:function(Z,fe){return fe=fe.source||fe,fe=fe.replace(s,"$1"),be=be.replace(Z,fe),ae},getRegex:function(){return new RegExp(be,ge)}};return ae}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(be,ge,ae){if(be){var K;try{K=decodeURIComponent(a(ae)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ge&&!c.test(ae)&&(ae=u(ge,ae));try{ae=encodeURI(ae).replace(/%25/g,"%")}catch{return null}return ae}var t={},d=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(be,ge){t[" "+be]||(d.test(be)?t[" "+be]=be+"/":t[" "+be]=b(be,"/",!0)),be=t[" "+be];var ae=be.indexOf(":")===-1;return ge.substring(0,2)==="//"?ae?ge:be.replace(o,"$1")+ge:ge.charAt(0)==="/"?ae?ge:be.replace(f,"$1")+ge:be+ge}var D={exec:function(){}};function l(be){for(var ge=1,ae,K;ge<arguments.length;ge++){ae=arguments[ge];for(K in ae)Object.prototype.hasOwnProperty.call(ae,K)&&(be[K]=ae[K])}return be}function v(be,ge){var ae=be.replace(/\|/g,function(fe,le,Me){for(var ve=!1,Re=le;--Re>=0&&Me[Re]==="\\";)ve=!ve;return ve?"|":" |"}),K=ae.split(/ \|/),Z=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ge)K.splice(ge);else for(;K.length<ge;)K.push("");for(;Z<K.length;Z++)K[Z]=K[Z].trim().replace(/\\\|/g,"|");return K}function b(be,ge,ae){var K=be.length;if(K===0)return"";for(var Z=0;Z<K;){var fe=be.charAt(K-Z-1);if(fe===ge&&!ae)Z++;else if(fe!==ge&&ae)Z++;else break}return be.slice(0,K-Z)}function P(be,ge){if(be.indexOf(ge[1])===-1)return-1;for(var ae=be.length,K=0,Z=0;Z<ae;Z++)if(be[Z]==="\\")Z++;else if(be[Z]===ge[0])K++;else if(be[Z]===ge[1]&&(K--,K<0))return Z;return-1}function k(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(be,ge){if(ge<1)return"";for(var ae="";ge>1;)ge&1&&(ae+=be),ge>>=1,be+=be;return ae+be}function U(be,ge,ae,K){var Z=ge.href,fe=ge.title?g(ge.title):null,le=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){K.state.inLink=!0;var Me={type:"link",raw:ae,href:Z,title:fe,text:le,tokens:K.inlineTokens(le)};return K.state.inLink=!1,Me}return{type:"image",raw:ae,href:Z,title:fe,text:g(le)}}function Q(be,ge){var ae=be.match(/^(\s+)(?:```)/);if(ae===null)return ge;var K=ae[1];return ge.split(`
`).map(function(Z){var fe=Z.match(/^\s+/);if(fe===null)return Z;var le=fe[0];return le.length>=K.length?Z.slice(K.length):Z}).join(`
`)}var G=function(){function be(ae){this.options=ae||ee.defaults}var ge=be.prototype;return ge.space=function(K){var Z=this.rules.block.newline.exec(K);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ge.code=function(K){var Z=this.rules.block.code.exec(K);if(Z){var fe=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:b(fe,`
`)}}},ge.fences=function(K){var Z=this.rules.block.fences.exec(K);if(Z){var fe=Z[0],le=Q(fe,Z[3]||"");return{type:"code",raw:fe,lang:Z[2]?Z[2].trim():Z[2],text:le}}},ge.heading=function(K){var Z=this.rules.block.heading.exec(K);if(Z){var fe=Z[2].trim();if(/#$/.test(fe)){var le=b(fe,"#");(this.options.pedantic||!le||/ $/.test(le))&&(fe=le.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:fe,tokens:this.lexer.inline(fe)}}},ge.hr=function(K){var Z=this.rules.block.hr.exec(K);if(Z)return{type:"hr",raw:Z[0]}},ge.blockquote=function(K){var Z=this.rules.block.blockquote.exec(K);if(Z){var fe=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},ge.list=function(K){var Z=this.rules.block.list.exec(K);if(Z){var fe,le,Me,ve,Re,Oe,Ue,j,V,W,q,_,oe=Z[1].trim(),Ne=oe.length>1,Ve={type:"list",raw:"",ordered:Ne,start:Ne?+oe.slice(0,-1):"",loose:!1,items:[]};oe=Ne?"\\d{1,9}\\"+oe.slice(-1):"\\"+oe,this.options.pedantic&&(oe=Ne?oe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(_=!1,!(!(Z=Ke.exec(K))||this.rules.block.hr.test(K)));){if(fe=Z[0],K=K.substring(fe.length),j=Z[2].split(`
`,1)[0],V=K.split(`
`,1)[0],this.options.pedantic?(ve=2,q=j.trimLeft()):(ve=Z[2].search(/[^ ]/),ve=ve>4?1:ve,q=j.slice(ve),ve+=Z[1].length),Oe=!1,!j&&/^ *$/.test(V)&&(fe+=V+`
`,K=K.substring(V.length+1),_=!0),!_)for(var Ye=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");K&&(W=K.split(`
`,1)[0],j=W,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(j)||nt.test(j)||Ye.test(j)||tt.test(K)));){if(j.search(/[^ ]/)>=ve||!j.trim())q+=`
`+j.slice(ve);else if(!Oe)q+=`
`+j;else break;!Oe&&!j.trim()&&(Oe=!0),fe+=W+`
`,K=K.substring(W.length+1)}Ve.loose||(Ue?Ve.loose=!0:/\n *\n *$/.test(fe)&&(Ue=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(q),le&&(Me=le[0]!=="[ ] ",q=q.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:fe,task:!!le,checked:Me,loose:!1,text:q}),Ve.raw+=fe}Ve.items[Ve.items.length-1].raw=fe.trimRight(),Ve.items[Ve.items.length-1].text=q.trimRight(),Ve.raw=Ve.raw.trimRight();var st=Ve.items.length;for(Re=0;Re<st;Re++){this.lexer.state.top=!1,Ve.items[Re].tokens=this.lexer.blockTokens(Ve.items[Re].text,[]);var ut=Ve.items[Re].tokens.filter(function(je){return je.type==="space"}),$t=ut.every(function(je){for(var ct=je.raw.split(""),x=0,Y=O(ct),ye;!(ye=Y()).done;){var Ge=ye.value;if(Ge===`
`&&(x+=1),x>1)return!0}return!1});!Ve.loose&&ut.length&&$t&&(Ve.loose=!0,Ve.items[Re].loose=!0)}return Ve}},ge.html=function(K){var Z=this.rules.block.html.exec(K);if(Z){var fe={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]);fe.type="paragraph",fe.text=le,fe.tokens=this.lexer.inline(le)}return fe}},ge.def=function(K){var Z=this.rules.block.def.exec(K);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var fe=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:Z[0],href:Z[2],title:Z[3]}}},ge.table=function(K){var Z=this.rules.block.table.exec(K);if(Z){var fe={type:"table",header:v(Z[1]).map(function(Ue){return{text:Ue}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=Z[0];var le=fe.align.length,Me,ve,Re,Oe;for(Me=0;Me<le;Me++)/^ *-+: *$/.test(fe.align[Me])?fe.align[Me]="right":/^ *:-+: *$/.test(fe.align[Me])?fe.align[Me]="center":/^ *:-+ *$/.test(fe.align[Me])?fe.align[Me]="left":fe.align[Me]=null;for(le=fe.rows.length,Me=0;Me<le;Me++)fe.rows[Me]=v(fe.rows[Me],fe.header.length).map(function(Ue){return{text:Ue}});for(le=fe.header.length,ve=0;ve<le;ve++)fe.header[ve].tokens=this.lexer.inline(fe.header[ve].text);for(le=fe.rows.length,ve=0;ve<le;ve++)for(Oe=fe.rows[ve],Re=0;Re<Oe.length;Re++)Oe[Re].tokens=this.lexer.inline(Oe[Re].text);return fe}}},ge.lheading=function(K){var Z=this.rules.block.lheading.exec(K);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},ge.paragraph=function(K){var Z=this.rules.block.paragraph.exec(K);if(Z){var fe=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:fe,tokens:this.lexer.inline(fe)}}},ge.text=function(K){var Z=this.rules.block.text.exec(K);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},ge.escape=function(K){var Z=this.rules.inline.escape.exec(K);if(Z)return{type:"escape",raw:Z[0],text:g(Z[1])}},ge.tag=function(K){var Z=this.rules.inline.tag.exec(K);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]}},ge.link=function(K){var Z=this.rules.inline.link.exec(K);if(Z){var fe=Z[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var le=b(fe.slice(0,-1),"\\");if((fe.length-le.length)%2===0)return}else{var Me=P(Z[2],"()");if(Me>-1){var ve=Z[0].indexOf("!")===0?5:4,Re=ve+Z[1].length+Me;Z[2]=Z[2].substring(0,Me),Z[0]=Z[0].substring(0,Re).trim(),Z[3]=""}}var Oe=Z[2],Ue="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);j&&(Oe=j[1],Ue=j[3])}else Ue=Z[3]?Z[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(fe)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),U(Z,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ge.reflink=function(K,Z){var fe;if((fe=this.rules.inline.reflink.exec(K))||(fe=this.rules.inline.nolink.exec(K))){var le=(fe[2]||fe[1]).replace(/\s+/g," ");if(le=Z[le.toLowerCase()],!le||!le.href){var Me=fe[0].charAt(0);return{type:"text",raw:Me,text:Me}}return U(fe,le,fe[0],this.lexer)}},ge.emStrong=function(K,Z,fe){fe===void 0&&(fe="");var le=this.rules.inline.emStrong.lDelim.exec(K);if(le&&!(le[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=le[1]||le[2]||"";if(!Me||Me&&(fe===""||this.rules.inline.punctuation.exec(fe))){var ve=le[0].length-1,Re,Oe,Ue=ve,j=0,V=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,Z=Z.slice(-1*K.length+ve);(le=V.exec(Z))!=null;)if(Re=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!Re){if(Oe=Re.length,le[3]||le[4]){Ue+=Oe;continue}else if((le[5]||le[6])&&ve%3&&!((ve+Oe)%3)){j+=Oe;continue}if(Ue-=Oe,!(Ue>0)){if(Oe=Math.min(Oe,Oe+Ue+j),Math.min(ve,Oe)%2){var W=K.slice(1,ve+le.index+Oe);return{type:"em",raw:K.slice(0,ve+le.index+Oe+1),text:W,tokens:this.lexer.inlineTokens(W)}}var q=K.slice(2,ve+le.index+Oe-1);return{type:"strong",raw:K.slice(0,ve+le.index+Oe+1),text:q,tokens:this.lexer.inlineTokens(q)}}}}}},ge.codespan=function(K){var Z=this.rules.inline.code.exec(K);if(Z){var fe=Z[2].replace(/\n/g," "),le=/[^ ]/.test(fe),Me=/^ /.test(fe)&&/ $/.test(fe);return le&&Me&&(fe=fe.substring(1,fe.length-1)),fe=g(fe,!0),{type:"codespan",raw:Z[0],text:fe}}},ge.br=function(K){var Z=this.rules.inline.br.exec(K);if(Z)return{type:"br",raw:Z[0]}},ge.del=function(K){var Z=this.rules.inline.del.exec(K);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},ge.autolink=function(K,Z){var fe=this.rules.inline.autolink.exec(K);if(fe){var le,Me;return fe[2]==="@"?(le=g(this.options.mangle?Z(fe[1]):fe[1]),Me="mailto:"+le):(le=g(fe[1]),Me=le),{type:"link",raw:fe[0],text:le,href:Me,tokens:[{type:"text",raw:le,text:le}]}}},ge.url=function(K,Z){var fe;if(fe=this.rules.inline.url.exec(K)){var le,Me;if(fe[2]==="@")le=g(this.options.mangle?Z(fe[0]):fe[0]),Me="mailto:"+le;else{var ve;do ve=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(ve!==fe[0]);le=g(fe[0]),fe[1]==="www."?Me="http://"+le:Me=le}return{type:"link",raw:fe[0],text:le,href:Me,tokens:[{type:"text",raw:le,text:le}]}}},ge.inlineText=function(K,Z){var fe=this.rules.inline.text.exec(K);if(fe){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):g(fe[0]):fe[0]:le=g(this.options.smartypants?Z(fe[0]):fe[0]),{type:"text",raw:fe[0],text:le}}},be}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=n(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=n(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=n(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=n(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=n(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=n(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=l({},L),L.gfm=l({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=n(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=n(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=l({},L.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:n(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=n(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=n(L._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=n(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=n(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=n(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=n(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=n(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=n(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=n(R.reflink).replace("label",R._label).replace("ref",L._label).getRegex(),R.nolink=n(R.nolink).replace("ref",L._label).getRegex(),R.reflinkSearch=n(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=l({},R),R.pedantic=l({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=l({},R.normal,{escape:n(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=n(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=l({},R.gfm,{br:n(R.br).replace("{2,}","*").getRegex(),text:n(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function T(be){var ge="",ae,K,Z=be.length;for(ae=0;ae<Z;ae++)K=be.charCodeAt(ae),Math.random()>.5&&(K="x"+K.toString(16)),ge+="&#"+K+";";return ge}var X=function(){function be(ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=ae||ee.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:L.normal,inline:R.normal};this.options.pedantic?(K.block=L.pedantic,K.inline=R.pedantic):this.options.gfm&&(K.block=L.gfm,this.options.breaks?K.inline=R.breaks:K.inline=R.gfm),this.tokenizer.rules=K}be.lex=function(K,Z){var fe=new be(Z);return fe.lex(K)},be.lexInline=function(K,Z){var fe=new be(Z);return fe.inlineTokens(K)};var ge=be.prototype;return ge.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ge.blockTokens=function(K,Z){var fe=this;Z===void 0&&(Z=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Ue,j,V){return j+"    ".repeat(V.length)});for(var le,Me,ve,Re;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(le=Ue.call({lexer:fe},K,Z))?(K=K.substring(le.raw.length),Z.push(le),!0):!1}))){if(le=this.tokenizer.space(K)){K=K.substring(le.raw.length),le.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(le);continue}if(le=this.tokenizer.code(K)){K=K.substring(le.raw.length),Me=Z[Z.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+le.raw,Me.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Z.push(le);continue}if(le=this.tokenizer.fences(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.heading(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.hr(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.blockquote(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.list(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.html(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.def(K)){K=K.substring(le.raw.length),Me=Z[Z.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+le.raw,Me.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.lheading(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(ve=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,j=K.slice(1),V=void 0;fe.options.extensions.startBlock.forEach(function(W){V=W.call({lexer:this},j),typeof V=="number"&&V>=0&&(Ue=Math.min(Ue,V))}),Ue<1/0&&Ue>=0&&(ve=K.substring(0,Ue+1))}(),this.state.top&&(le=this.tokenizer.paragraph(ve))){Me=Z[Z.length-1],Re&&Me.type==="paragraph"?(Me.raw+=`
`+le.raw,Me.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Z.push(le),Re=ve.length!==K.length,K=K.substring(le.raw.length);continue}if(le=this.tokenizer.text(K)){K=K.substring(le.raw.length),Me=Z[Z.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+le.raw,Me.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Z.push(le);continue}if(K){var Oe="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return this.state.top=!0,Z},ge.inline=function(K,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:K,tokens:Z}),Z},ge.inlineTokens=function(K,Z){var fe=this;Z===void 0&&(Z=[]);var le,Me,ve,Re=K,Oe,Ue,j;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)V.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,Oe.index)+"["+I("a",Oe[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,Oe.index)+"["+I("a",Oe[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,Oe.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Ue||(j=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(le=q.call({lexer:fe},K,Z))?(K=K.substring(le.raw.length),Z.push(le),!0):!1}))){if(le=this.tokenizer.escape(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.tag(K)){K=K.substring(le.raw.length),Me=Z[Z.length-1],Me&&le.type==="text"&&Me.type==="text"?(Me.raw+=le.raw,Me.text+=le.text):Z.push(le);continue}if(le=this.tokenizer.link(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(le.raw.length),Me=Z[Z.length-1],Me&&le.type==="text"&&Me.type==="text"?(Me.raw+=le.raw,Me.text+=le.text):Z.push(le);continue}if(le=this.tokenizer.emStrong(K,Re,j)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.codespan(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.br(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.del(K)){K=K.substring(le.raw.length),Z.push(le);continue}if(le=this.tokenizer.autolink(K,T)){K=K.substring(le.raw.length),Z.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(K,T))){K=K.substring(le.raw.length),Z.push(le);continue}if(ve=K,this.options.extensions&&this.options.extensions.startInline&&function(){var q=1/0,_=K.slice(1),oe=void 0;fe.options.extensions.startInline.forEach(function(Ne){oe=Ne.call({lexer:this},_),typeof oe=="number"&&oe>=0&&(q=Math.min(q,oe))}),q<1/0&&q>=0&&(ve=K.substring(0,q+1))}(),le=this.tokenizer.inlineText(ve,F)){K=K.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(j=le.raw.slice(-1)),Ue=!0,Me=Z[Z.length-1],Me&&Me.type==="text"?(Me.raw+=le.raw,Me.text+=le.text):Z.push(le);continue}if(K){var W="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return Z},y(be,null,[{key:"rules",get:function(){return{block:L,inline:R}}}]),be}(),ne=function(){function be(ae){this.options=ae||ee.defaults}var ge=be.prototype;return ge.code=function(K,Z,fe){var le=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(K,le);Me!=null&&Me!==K&&(fe=!0,K=Me)}return K=K.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+g(le,!0)+'">'+(fe?K:g(K,!0))+`</code></pre>
`:"<pre><code>"+(fe?K:g(K,!0))+`</code></pre>
`},ge.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ge.html=function(K){return K},ge.heading=function(K,Z,fe,le){if(this.options.headerIds){var Me=this.options.headerPrefix+le.slug(fe);return"<h"+Z+' id="'+Me+'">'+K+"</h"+Z+`>
`}return"<h"+Z+">"+K+"</h"+Z+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(K,Z,fe){var le=Z?"ol":"ul",Me=Z&&fe!==1?' start="'+fe+'"':"";return"<"+le+Me+`>
`+K+"</"+le+`>
`},ge.listitem=function(K){return"<li>"+K+`</li>
`},ge.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(K){return"<p>"+K+`</p>
`},ge.table=function(K,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+Z+`</table>
`},ge.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ge.tablecell=function(K,Z){var fe=Z.header?"th":"td",le=Z.align?"<"+fe+' align="'+Z.align+'">':"<"+fe+">";return le+K+("</"+fe+`>
`)},ge.strong=function(K){return"<strong>"+K+"</strong>"},ge.em=function(K){return"<em>"+K+"</em>"},ge.codespan=function(K){return"<code>"+K+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(K){return"<del>"+K+"</del>"},ge.link=function(K,Z,fe){if(K=h(this.options.sanitize,this.options.baseUrl,K),K===null)return fe;var le='<a href="'+g(K)+'"';return Z&&(le+=' title="'+Z+'"'),le+=">"+fe+"</a>",le},ge.image=function(K,Z,fe){if(K=h(this.options.sanitize,this.options.baseUrl,K),K===null)return fe;var le='<img src="'+K+'" alt="'+fe+'"';return Z&&(le+=' title="'+Z+'"'),le+=this.options.xhtml?"/>":">",le},ge.text=function(K){return K},be}(),me=function(){function be(){}var ge=be.prototype;return ge.strong=function(K){return K},ge.em=function(K){return K},ge.codespan=function(K){return K},ge.del=function(K){return K},ge.html=function(K){return K},ge.text=function(K){return K},ge.link=function(K,Z,fe){return""+fe},ge.image=function(K,Z,fe){return""+fe},ge.br=function(){return""},be}(),we=function(){function be(){this.seen={}}var ge=be.prototype;return ge.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(K,Z){var fe=K,le=0;if(this.seen.hasOwnProperty(fe)){le=this.seen[K];do le++,fe=K+"-"+le;while(this.seen.hasOwnProperty(fe))}return Z||(this.seen[K]=le,this.seen[fe]=0),fe},ge.slug=function(K,Z){Z===void 0&&(Z={});var fe=this.serialize(K);return this.getNextSafeSlug(fe,Z.dryrun)},be}(),de=function(){function be(ae){this.options=ae||ee.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new we}be.parse=function(K,Z){var fe=new be(Z);return fe.parse(K)},be.parseInline=function(K,Z){var fe=new be(Z);return fe.parseInline(K)};var ge=be.prototype;return ge.parse=function(K,Z){Z===void 0&&(Z=!0);var fe="",le,Me,ve,Re,Oe,Ue,j,V,W,q,_,oe,Ne,Ve,Ke,Ye,tt,it,nt,st=K.length;for(le=0;le<st;le++){if(q=K[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(nt=this.options.extensions.renderers[q.type].call({parser:this},q),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){fe+=nt||"";continue}switch(q.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(q.tokens),q.depth,a(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(V="",j="",Re=q.header.length,Me=0;Me<Re;Me++)j+=this.renderer.tablecell(this.parseInline(q.header[Me].tokens),{header:!0,align:q.align[Me]});for(V+=this.renderer.tablerow(j),W="",Re=q.rows.length,Me=0;Me<Re;Me++){for(Ue=q.rows[Me],j="",Oe=Ue.length,ve=0;ve<Oe;ve++)j+=this.renderer.tablecell(this.parseInline(Ue[ve].tokens),{header:!1,align:q.align[ve]});W+=this.renderer.tablerow(j)}fe+=this.renderer.table(V,W);continue}case"blockquote":{W=this.parse(q.tokens),fe+=this.renderer.blockquote(W);continue}case"list":{for(_=q.ordered,oe=q.start,Ne=q.loose,Re=q.items.length,W="",Me=0;Me<Re;Me++)Ke=q.items[Me],Ye=Ke.checked,tt=Ke.task,Ve="",Ke.task&&(it=this.renderer.checkbox(Ye),Ne?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=it+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=it+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:it}):Ve+=it),Ve+=this.parse(Ke.tokens,Ne),W+=this.renderer.listitem(Ve,tt,Ye);fe+=this.renderer.list(W,_,oe);continue}case"html":{fe+=this.renderer.html(q.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(W=q.tokens?this.parseInline(q.tokens):q.text;le+1<st&&K[le+1].type==="text";)q=K[++le],W+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);fe+=Z?this.renderer.paragraph(W):W;continue}default:{var ut='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return fe},ge.parseInline=function(K,Z){Z=Z||this.renderer;var fe="",le,Me,ve,Re=K.length;for(le=0;le<Re;le++){if(Me=K[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(ve=this.options.extensions.renderers[Me.type].call({parser:this},Me),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){fe+=ve||"";continue}switch(Me.type){case"escape":{fe+=Z.text(Me.text);break}case"html":{fe+=Z.html(Me.text);break}case"link":{fe+=Z.link(Me.href,Me.title,this.parseInline(Me.tokens,Z));break}case"image":{fe+=Z.image(Me.href,Me.title,Me.text);break}case"strong":{fe+=Z.strong(this.parseInline(Me.tokens,Z));break}case"em":{fe+=Z.em(this.parseInline(Me.tokens,Z));break}case"codespan":{fe+=Z.codespan(Me.text);break}case"br":{fe+=Z.br();break}case"del":{fe+=Z.del(this.parseInline(Me.tokens,Z));break}case"text":{fe+=Z.text(Me.text);break}default:{var Oe='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return fe},be}();function $e(be,ge,ae){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof ge=="function"&&(ae=ge,ge=null),ge=l({},$e.defaults,ge||{}),k(ge),ae){var K=ge.highlight,Z;try{Z=X.lex(be,ge)}catch(Re){return ae(Re)}var fe=function(Oe){var Ue;if(!Oe)try{ge.walkTokens&&$e.walkTokens(Z,ge.walkTokens),Ue=de.parse(Z,ge)}catch(j){Oe=j}return ge.highlight=K,Oe?ae(Oe):ae(null,Ue)};if(!K||K.length<3||(delete ge.highlight,!Z.length))return fe();var le=0;$e.walkTokens(Z,function(Re){Re.type==="code"&&(le++,setTimeout(function(){K(Re.text,Re.lang,function(Oe,Ue){if(Oe)return fe(Oe);Ue!=null&&Ue!==Re.text&&(Re.text=Ue,Re.escaped=!0),le--,le===0&&fe()})},0))}),le===0&&fe();return}function Me(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+g(Re.message+"",!0)+"</pre>";throw Re}try{var ve=X.lex(be,ge);if(ge.walkTokens){if(ge.async)return Promise.all($e.walkTokens(ve,ge.walkTokens)).then(function(){return de.parse(ve,ge)}).catch(Me);$e.walkTokens(ve,ge.walkTokens)}return de.parse(ve,ge)}catch(Re){Me(Re)}}$e.options=$e.setOptions=function(be){return l($e.defaults,be),p($e.defaults),$e},$e.getDefaults=N,$e.defaults=ee.defaults,$e.use=function(){for(var be=arguments.length,ge=new Array(be),ae=0;ae<be;ae++)ge[ae]=arguments[ae];var K=l.apply(void 0,[{}].concat(ge)),Z=$e.defaults.extensions||{renderers:{},childTokens:{}},fe;ge.forEach(function(le){if(le.extensions&&(fe=!0,le.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Re=Z.renderers?Z.renderers[ve.name]:null;Re?Z.renderers[ve.name]=function(){for(var Oe=arguments.length,Ue=new Array(Oe),j=0;j<Oe;j++)Ue[j]=arguments[j];var V=ve.renderer.apply(this,Ue);return V===!1&&(V=Re.apply(this,Ue)),V}:Z.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[ve.level]?Z[ve.level].unshift(ve.tokenizer):Z[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?Z.startBlock?Z.startBlock.push(ve.start):Z.startBlock=[ve.start]:ve.level==="inline"&&(Z.startInline?Z.startInline.push(ve.start):Z.startInline=[ve.start]))}ve.childTokens&&(Z.childTokens[ve.name]=ve.childTokens)})),le.renderer&&function(){var ve=$e.defaults.renderer||new ne,Re=function(j){var V=ve[j];ve[j]=function(){for(var W=arguments.length,q=new Array(W),_=0;_<W;_++)q[_]=arguments[_];var oe=le.renderer[j].apply(ve,q);return oe===!1&&(oe=V.apply(ve,q)),oe}};for(var Oe in le.renderer)Re(Oe);K.renderer=ve}(),le.tokenizer&&function(){var ve=$e.defaults.tokenizer||new G,Re=function(j){var V=ve[j];ve[j]=function(){for(var W=arguments.length,q=new Array(W),_=0;_<W;_++)q[_]=arguments[_];var oe=le.tokenizer[j].apply(ve,q);return oe===!1&&(oe=V.apply(ve,q)),oe}};for(var Oe in le.tokenizer)Re(Oe);K.tokenizer=ve}(),le.walkTokens){var Me=$e.defaults.walkTokens;K.walkTokens=function(ve){var Re=[];return Re.push(le.walkTokens.call(this,ve)),Me&&(Re=Re.concat(Me.call(this,ve))),Re}}fe&&(K.extensions=Z),$e.setOptions(K)})},$e.walkTokens=function(be,ge){for(var ae=[],K=function(){var Me=fe.value;switch(ae=ae.concat(ge.call($e,Me)),Me.type){case"table":{for(var ve=O(Me.header),Re;!(Re=ve()).done;){var Oe=Re.value;ae=ae.concat($e.walkTokens(Oe.tokens,ge))}for(var Ue=O(Me.rows),j;!(j=Ue()).done;)for(var V=j.value,W=O(V),q;!(q=W()).done;){var _=q.value;ae=ae.concat($e.walkTokens(_.tokens,ge))}break}case"list":{ae=ae.concat($e.walkTokens(Me.items,ge));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Me.type]?$e.defaults.extensions.childTokens[Me.type].forEach(function(oe){ae=ae.concat($e.walkTokens(Me[oe],ge))}):Me.tokens&&(ae=ae.concat($e.walkTokens(Me.tokens,ge)))}},Z=O(be),fe;!(fe=Z()).done;)K();return ae},$e.parseInline=function(be,ge){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");ge=l({},$e.defaults,ge||{}),k(ge);try{var ae=X.lexInline(be,ge);return ge.walkTokens&&$e.walkTokens(ae,ge.walkTokens),de.parseInline(ae,ge)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+g(K.message+"",!0)+"</pre>";throw K}},$e.Parser=de,$e.parser=de.parse,$e.Renderer=ne,$e.TextRenderer=me,$e.Lexer=X,$e.lexer=X.lex,$e.Tokenizer=G,$e.Slugger=we,$e.parse=$e;var ke=$e.options,se=$e.setOptions,Pe=$e.use,re=$e.walkTokens,H=$e.parseInline,he=$e,Fe=de.parse,pe=X.lex;ee.Lexer=X,ee.Parser=de,ee.Renderer=ne,ee.Slugger=we,ee.TextRenderer=me,ee.Tokenizer=G,ee.getDefaults=N,ee.lexer=pe,ee.marked=$e,ee.options=ke,ee.parse=he,ee.parseInline=H,ee.parser=Fe,ee.setOptions=se,ee.use=Pe,ee.walkTokens=re,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ce[128],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=y;function y(r){const a=O(r);if(a&&a.length>0)return new Uint32Array(a)}let A=0;const C=new Uint32Array(10);function O(r){if(A=0,N(r,S,4352),A>0||(N(r,m,4449),A>0)||(N(r,w,4520),A>0)||(N(r,g,12593),A))return C.subarray(0,A);if(r>=44032&&r<=55203){const a=r-44032,s=a%588,n=Math.floor(a/588),i=Math.floor(s/28),c=s%28-1;if(n<S.length?N(n,S,0):4352+n-12593<g.length&&N(4352+n,g,12593),i<m.length?N(i,m,0):4449+i-12593<g.length&&N(4449+i-12593,g,12593),c>=0&&(c<w.length?N(c,w,0):4520+c-12593<g.length&&N(4520+c-12593,g,12593)),A>0)return C.subarray(0,A)}}function N(r,a,s){r>=s&&r<s+a.length&&p(a[r-s])}function p(r){r!==0&&(C[A++]=r&255,r>>8&&(C[A++]=r>>8&255),r>>16&&(C[A++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var M;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(M||(M={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[129],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0,e.$Cm=y,e.rot=A;function y(p,$,E){return Math.min(Math.max(p,$),E)}function A(p,$){return($+p%$)%$}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Em=C;class O{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Fm=O;class N{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const E=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Gm=N}),define(Ce[130],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=O,e.$dd=m;class y{constructor(g,r,a){this.owner=g,this.debugNameSource=r,this.referenceFn=a}getDebugName(g){return O(g,this)}}e.$bd=y;const A=new Map,C=new WeakMap;function O(w,g){const r=C.get(w);if(r)return r;const a=N(w,g);if(a){let s=A.get(a)??0;s++,A.set(a,s);const n=s===1?a:`${a}#${s}`;return C.set(w,n),n}}function N(w,g){const r=C.get(w);if(r)return r;const a=g.owner?M(g.owner)+".":"";let s;const n=g.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(s=n(),s!==void 0)return a+s}else return a+n;const i=g.referenceFn;if(i!==void 0&&(s=m(i),s!==void 0))return a+s;if(g.owner!==void 0){const c=p(g.owner,w);if(c!==void 0)return a+c}}function p(w,g){for(const r in w)if(w[r]===g)return r}const $=new Map,E=new WeakMap;function M(w){const g=E.get(w);if(g)return g;const r=S(w);let a=$.get(r)??0;a++,$.set(r,a);const s=a===1?r:`${r}#${a}`;return E.set(w,s),s}function S(w){const g=w.constructor;return g?g.name:"Object"}function m(w){const g=w.toString(),a=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(g);return(a?a[1]:void 0)?.trim()}}),define(Ce[131],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=A,e.$Jd=C;let y;function A(r){y=r}function C(){return y}class O{constructor(){this.a=0,this.d=new WeakMap}b(a){return N([p(w("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[p(" "),E(M(a.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),E(M(a.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),E(M(a.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(a,s){console.log(...this.b([$("observable value changed"),E(a.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(a){if(a.size!==0)return E(" (changed deps: "+[...a].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const s=a.handleChange;this.d.set(a,new Set),a.handleChange=(n,i)=>(this.d.get(a).add(n),s.apply(a,[n,i]))}handleDerivedRecomputed(a,s){const n=this.d.get(a);console.log(...this.b([$("derived recomputed"),E(a.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(n),{data:[{fn:a._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(a,s){console.log(...this.b([$("observable from event triggered"),E(a.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const s=a.handleChange;this.d.set(a,new Set),a.handleChange=(n,i)=>(this.d.get(a).add(n),s.apply(a,[n,i]))}handleAutorunTriggered(a){const s=this.d.get(a);console.log(...this.b([$("autorun"),E(a.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:a._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let s=a.getDebugName();s===void 0&&(s=""),console.log(...this.b([$("transaction"),E(s,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=O;function N(r){const a=new Array,s=[];let n="";function i(h){if("length"in h)for(const t of h)t&&i(t);else"text"in h?(n+=`%c${h.text}`,a.push(h.style),h.data&&s.push(...h.data)):"data"in h&&s.push(...h.data)}i(r);const c=[n,...a];return c.push(...s),c}function p(r){return E(r,{color:"black"})}function $(r){return E(g(`${r}: `,10),{color:"black",bold:!0})}function E(r,a={color:"black"}){function s(i){return Object.entries(i).reduce((c,[h,t])=>`${c}${h}:${t};`,"")}const n={color:a.color};return a.strikeThrough&&(n["text-decoration"]="line-through"),a.bold&&(n["font-weight"]="bold"),{text:r,style:s(n)}}function M(r,a){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=a?`"${r}"`:`"${r.substr(0,a-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?S(r,a):m(r,a);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function S(r,a){let s="[ ",n=!0;for(const i of r){if(n||(s+=", "),s.length-5>a){s+="...";break}n=!1,s+=`${M(i,a-s.length)}`}return s+=" ]",s}function m(r,a){let s="{ ",n=!0;for(const[i,c]of Object.entries(r)){if(n||(s+=", "),s.length-5>a){s+="...";break}n=!1,s+=`${i}: ${M(c,a-s.length)}`}return s+=" }",s}function w(r,a){let s="";for(let n=1;n<=a;n++)s+=r;return s}function g(r,a){for(;r.length<a;)r+=" ";return r}}),define(Ce[132],Ae([1,0,125,130,131]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=N,e.$Sd=$,e.$Td=M,e.$Wd=w,e.$Xd=r,e.$Yd=a,e.$Zd=s,e.$2d=i,e.$3d=c,e.$5d=t;let O;function N(o){O=o}let p;function $(o){p=o}let E;function M(o){E=o}class S{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,u){const D=u===void 0?void 0:f,l=u===void 0?f:u;return E({owner:D,debugName:()=>{const v=(0,A.$dd)(l);if(v!==void 0)return v;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(l.toString());if(P)return`${this.debugName}.${P[2]}`;if(!D)return`${this.debugName} (mapped)`},debugReferenceFn:l},v=>l(this.read(v),v))}recomputeInitiallyAndOnChange(f,u){return f.add(O(this,u)),this}keepObserved(f){return f.add(p(this)),this}get a(){return this.get()}}e.$Ud=S;class m extends S{constructor(){super(...arguments),this.b=new Set}addObserver(f){const u=this.b.size;this.b.add(f),u===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=m;function w(o,f){const u=new n(o,f);try{o(u)}finally{u.finish()}}let g;function r(o){if(g)o(g);else{const f=new n(o,void 0);g=f;try{o(f)}finally{f.finish(),g=void 0}}}async function a(o,f){const u=new n(o,f);try{await o(u)}finally{u.finish()}}function s(o,f,u){o?f(o):w(f,u)}class n{constructor(f,u){this._fn=f,this.b=u,this.a=[],(0,C.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,A.$dd)(this._fn)}updateObserver(f,u){this.a.push({observer:f,observable:u}),f.beginUpdate(u)}finish(){const f=this.a;for(let u=0;u<f.length;u++){const{observer:D,observable:l}=f[u];D.endUpdate(l)}this.a=null,(0,C.$Jd)()?.handleEndTransaction()}}e.$1d=n;function i(o,f){let u;return typeof o=="string"?u=new A.$bd(void 0,o,void 0):u=new A.$bd(o,void 0,void 0),new h(u,f,y.$7c)}function c(o,f){return new h(new A.$bd(o.owner,o.debugName,void 0),f,o.equalsFn??y.$7c)}class h extends m{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,u,D){super(),this.e=f,this.g=D,this.d=u}get(){return this.d}set(f,u,D){if(this.g(this.d,f))return;let l;u||(u=l=new n(()=>{},()=>`Setting ${this.debugName}`));try{const v=this.d;this.h(f),(0,C.$Jd)()?.handleObservableChanged(this,{oldValue:v,newValue:f,change:D,didChange:!0,hadValue:!0});for(const b of this.b)u.updateObserver(b,this),b.handleChange(this,D)}finally{l&&l.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$4d=h;function t(o,f){let u;return typeof o=="string"?u=new A.$bd(void 0,o,void 0):u=new A.$bd(o,void 0,void 0),new d(u,f,y.$7c)}class d extends h{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$6d=d}),function(){function ee(C){const O=[];typeof C=="number"&&O.push("code/timeOrigin",C);function N($){O.push($,Date.now())}function p(){const $=[];for(let E=0;E<O.length;E+=2)$.push({name:O[E],startTime:O[E+1]});return $}return{mark:N,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const N of performance.getEntriesByType("mark"))O.push({name:N.name,startTime:Math.round(C+N.startTime)});return O}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=y(A))}(),define(Ce[133],Ae([1,0,42]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=void 0;const A=Symbol("unset");class C{constructor(){this.a=new N,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||y.Iterable.empty()}insert($,E,M){this.d($,S=>S._value=E,M)}mutate($,E){this.d($,M=>M._value=E(M._value===A?void 0:M._value))}delete($){const E=this.c($);if(!E)return;let M=E.length-1;const S=E[M].node._value;if(S!==A){for(this.b--,E[M].node._value=A;M>0;M--){const{node:m,part:w}=E[M];if(m.children?.size||m._value!==A)break;E[M-1].node.children.delete(w)}return S}}*deleteRecursive($){const E=this.c($);if(!E)return;const M=E[E.length-1].node;for(let S=E.length-1;S>0;S--){const m=E[S-1];if(m.node.children.delete(E[S].part),m.node.children.size>0||m.node._value!==A)break}for(const S of O(M))S._value!==A&&(this.b--,yield S._value)}find($){let E=this.a;for(const M of $){const S=E.children?.get(M);if(!S)return;E=S}return E._value===A?void 0:E._value}hasKeyOrParent($){let E=this.a;for(const M of $){const S=E.children?.get(M);if(!S)return!1;if(S._value!==A)return!0;E=S}return!1}hasKeyOrChildren($){let E=this.a;for(const M of $){const S=E.children?.get(M);if(!S)return!1;E=S}return!0}hasKey($){let E=this.a;for(const M of $){const S=E.children?.get(M);if(!S)return!1;E=S}return E._value!==A}c($){const E=[{part:"",node:this.a}];let M=0;for(const S of $){const m=E[M].node.children?.get(S);if(!m)return;E.push({part:S,node:m}),M++}return E}d($,E,M){let S=this.a;for(const g of $){if(S.children)if(S.children.has(g))S=S.children.get(g);else{const r=new N;S.children.set(g,r),S=r}else{const r=new N;S.children=new Map([[g,r]]),S=r}M?.(S)}const m=S._value===A?0:1;E(S);const w=S._value===A?0:1;this.b+=w-m}*values(){for(const{_value:$}of O(this.a))$!==A&&(yield $)}}e.$mP=C;function*O(p){const $=[p];for(;$.length>0;){const E=$.pop();if(yield E,E.children)for(const M of E.children.values())$.push(M)}}class N{constructor(){this._value=A}get value(){return this._value===A?void 0:this._value}set value($){this._value=$===void 0?A:$}}}),define(Ce[134],Ae([1,0,43,19]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=p,e.$ir=$,e.$jr=E,e.$kr=M,e.$lr=S,e.$mr=m,e.$nr=w,e.$or=g,e.$pr=r,e.$qr=a,e.$rr=u,e.$sr=D,e.$tr=l;const C=new y.$V(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),O=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),N=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(v,b,P=!1){const k=v||"",I=b||"",U=C.value.collator.compare(k,I);return C.value.collatorIsNumeric&&U===0&&k!==I?k<I?-1:1:U}function $(v,b){const P=O.value.collator;return v=v||"",b=b||"",c(P,v,b)}function E(v,b){const P=O.value.collator;return v=v||"",b=b||"",o(v,b)||c(P,v,b)}function M(v,b){const P=O.value.collator;return v=v||"",b=b||"",d(v,b)||c(P,v,b)}function S(v,b){return v=v||"",b=b||"",v===b?0:v<b?-1:1}function m(v,b){const[P,k]=n(v),[I,U]=n(b);let Q=C.value.collator.compare(k,U);if(Q===0){if(C.value.collatorIsNumeric&&k!==U)return k<U?-1:1;if(Q=C.value.collator.compare(P,I),C.value.collatorIsNumeric&&Q===0&&P!==I)return P<I?-1:1}return Q}function w(v,b){v=v||"",b=b||"";const P=i(v),k=i(b),I=O.value.collator,U=N.value.collator;return c(U,P,k)||c(I,v,b)}function g(v,b){v=v||"",b=b||"";const P=i(v),k=i(b),I=O.value.collator,U=N.value.collator;return c(U,P,k)||o(v,b)||c(I,v,b)}function r(v,b){v=v||"",b=b||"";const P=i(v),k=i(b),I=O.value.collator,U=N.value.collator;return c(U,P,k)||d(v,b)||c(I,v,b)}function a(v,b){v=v||"",b=b||"";const P=i(v).toLowerCase(),k=i(b).toLowerCase();return P!==k?P<k?-1:1:v!==b?v<b?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(v,b=!1){const P=v?s.exec(v):[];let k=[P&&P[1]||"",P&&P[3]||""];return b&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(v){const b=v?s.exec(v):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function c(v,b,P){const k=v.compare(b,P);return k!==0?k:b.length!==P.length?b.length<P.length?-1:1:0}function h(v){const b=v.charAt(0);return b.toLocaleUpperCase()!==b}function t(v){const b=v.charAt(0);return b.toLocaleLowerCase()!==b}function d(v,b){return h(v)&&t(b)?-1:t(v)&&h(b)?1:0}function o(v,b){return t(v)&&h(b)?-1:h(v)&&t(b)?1:0}function f(v,b,P=!1){return P||(v=v&&v.toLowerCase(),b=b&&b.toLowerCase()),v===b?0:v<b?-1:1}function u(v,b,P=!1){const k=v.split(A.sep),I=b.split(A.sep),U=k.length-1,Q=I.length-1;let G,L;for(let R=0;;R++){if(G=U===R,L=Q===R,G&&L)return p(k[R],I[R],P);if(G)return-1;if(L)return 1;const F=f(k[R],I[R],P);if(F!==0)return F}}function D(v,b,P){const k=v.toLowerCase(),I=b.toLowerCase(),U=l(v,b,P);if(U)return U;const Q=k.endsWith(P),G=I.endsWith(P);if(Q!==G)return Q?-1:1;const L=p(k,I);return L!==0?L:k.localeCompare(I)}function l(v,b,P){const k=v.toLowerCase(),I=b.toLowerCase(),U=k.startsWith(P),Q=I.startsWith(P);if(U!==Q)return U?-1:1;if(U&&Q){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}}),define(Ce[70],Ae([1,0,19]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Ss=O,e.$Ts=N,e.$Us=p,e.$Vs=E,e.$Rs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(M){const S=(0,y.$pc)(M),m=A[S.toLowerCase()];return m!==void 0?m:N(M)}function N(M){const S=(0,y.$pc)(M);return C[S.toLowerCase()]}function p(M){for(const S in C)if(C[S]===M)return S}const $=/^(.+)\/(.+?)(;.+)?$/;function E(M,S){const m=$.exec(M);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:M}}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var A in y)(typeof exports=="object"?exports:ee)[A]=y[A]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function y(A){if(e[A])return e[A].exports;var C=e[A]={i:A,l:!1,exports:{}};return ee[A].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=ee,y.c=e,y.d=function(A,C,O){y.o(A,C)||Object.defineProperty(A,C,{enumerable:!0,get:O})},y.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},y.t=function(A,C){if(1&C&&(A=y(A)),8&C||4&C&&typeof A=="object"&&A&&A.__esModule)return A;var O=Object.create(null);if(y.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:A}),2&C&&typeof A!="string")for(var N in A)y.d(O,N,function(p){return A[p]}.bind(null,N));return O},y.n=function(A){var C=A&&A.__esModule?function(){return A.default}:function(){return A};return y.d(C,"a",C),C},y.o=function(A,C){return Object.prototype.hasOwnProperty.call(A,C)},y.p="",y(y.s=0)}([function(ee,e,y){(function(A){var C;e=ee.exports=Pe,C=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],E=0,M=E++;$[M]="0|[1-9]\\d*";var S=E++;$[S]="[0-9]+";var m=E++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;$[w]="("+$[M]+")\\.("+$[M]+")\\.("+$[M]+")";var g=E++;$[g]="("+$[S]+")\\.("+$[S]+")\\.("+$[S]+")";var r=E++;$[r]="(?:"+$[M]+"|"+$[m]+")";var a=E++;$[a]="(?:"+$[S]+"|"+$[m]+")";var s=E++;$[s]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var n=E++;$[n]="(?:-?("+$[a]+"(?:\\."+$[a]+")*))";var i=E++;$[i]="[0-9A-Za-z-]+";var c=E++;$[c]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var h=E++,t="v?"+$[w]+$[s]+"?"+$[c]+"?";$[h]="^"+t+"$";var d="[v=\\s]*"+$[g]+$[n]+"?"+$[c]+"?",o=E++;$[o]="^"+d+"$";var f=E++;$[f]="((?:<|>)?=?)";var u=E++;$[u]=$[S]+"|x|X|\\*";var D=E++;$[D]=$[M]+"|x|X|\\*";var l=E++;$[l]="[v=\\s]*("+$[D]+")(?:\\.("+$[D]+")(?:\\.("+$[D]+")(?:"+$[s]+")?"+$[c]+"?)?)?";var v=E++;$[v]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[n]+")?"+$[c]+"?)?)?";var b=E++;$[b]="^"+$[f]+"\\s*"+$[l]+"$";var P=E++;$[P]="^"+$[f]+"\\s*"+$[v]+"$";var k=E++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=E++;$[I]="(?:~>?)";var U=E++;$[U]="(\\s*)"+$[I]+"\\s+",p[U]=new RegExp($[U],"g");var Q=E++;$[Q]="^"+$[I]+$[l]+"$";var G=E++;$[G]="^"+$[I]+$[v]+"$";var L=E++;$[L]="(?:\\^)";var R=E++;$[R]="(\\s*)"+$[L]+"\\s+",p[R]=new RegExp($[R],"g");var F=E++;$[F]="^"+$[L]+$[l]+"$";var T=E++;$[T]="^"+$[L]+$[v]+"$";var X=E++;$[X]="^"+$[f]+"\\s*("+d+")$|^$";var ne=E++;$[ne]="^"+$[f]+"\\s*("+t+")$|^$";var me=E++;$[me]="(\\s*)"+$[f]+"\\s*("+d+"|"+$[l]+")",p[me]=new RegExp($[me],"g");var we=E++;$[we]="^\\s*("+$[l]+")\\s+-\\s+("+$[l]+")\\s*$";var de=E++;$[de]="^\\s*("+$[v]+")\\s+-\\s+("+$[v]+")\\s*$";var $e=E++;$[$e]="(<|>)?=?\\s*\\*";for(var ke=0;ke<35;ke++)C(ke,$[ke]),p[ke]||(p[ke]=new RegExp($[ke]));function se(V,W){if(V instanceof Pe)return V;if(typeof V!="string"||V.length>O||!(W?p[o]:p[h]).test(V))return null;try{return new Pe(V,W)}catch{return null}}function Pe(V,W){if(V instanceof Pe){if(V.loose===W)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Pe))return new Pe(V,W);C("SemVer",V,W),this.loose=W;var q=V.trim().match(W?p[o]:p[h]);if(!q)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(_){if(/^[0-9]+$/.test(_)){var oe=+_;if(oe>=0&&oe<N)return oe}return _}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}e.parse=se,e.valid=function(V,W){var q=se(V,W);return q?q.version:null},e.clean=function(V,W){var q=se(V.trim().replace(/^[=v]+/,""),W);return q?q.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(V){return C("SemVer.compare",this.version,this.loose,V),V instanceof Pe||(V=new Pe(V,this.loose)),this.compareMain(V)||this.comparePre(V)},Pe.prototype.compareMain=function(V){return V instanceof Pe||(V=new Pe(V,this.loose)),H(this.major,V.major)||H(this.minor,V.minor)||H(this.patch,V.patch)},Pe.prototype.comparePre=function(V){if(V instanceof Pe||(V=new Pe(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var W=0;do{var q=this.prerelease[W],_=V.prerelease[W];if(C("prerelease compare",W,q,_),q===void 0&&_===void 0)return 0;if(_===void 0)return 1;if(q===void 0)return-1;if(q!==_)return H(q,_)}while(++W)},Pe.prototype.inc=function(V,W){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,W,q,_){typeof q=="string"&&(_=q,q=void 0);try{return new Pe(V,q).inc(W,_).version}catch{return null}},e.diff=function(V,W){if(be(V,W))return null;var q=se(V),_=se(W);if(q.prerelease.length||_.prerelease.length){for(var oe in q)if((oe==="major"||oe==="minor"||oe==="patch")&&q[oe]!==_[oe])return"pre"+oe;return"prerelease"}for(var oe in q)if((oe==="major"||oe==="minor"||oe==="patch")&&q[oe]!==_[oe])return oe},e.compareIdentifiers=H;var re=/^[0-9]+$/;function H(V,W){var q=re.test(V),_=re.test(W);return q&&_&&(V=+V,W=+W),q&&!_?-1:_&&!q?1:V<W?-1:V>W?1:0}function he(V,W,q){return new Pe(V,q).compare(new Pe(W,q))}function Fe(V,W,q){return he(V,W,q)>0}function pe(V,W,q){return he(V,W,q)<0}function be(V,W,q){return he(V,W,q)===0}function ge(V,W,q){return he(V,W,q)!==0}function ae(V,W,q){return he(V,W,q)>=0}function K(V,W,q){return he(V,W,q)<=0}function Z(V,W,q,_){var oe;switch(W){case"===":typeof V=="object"&&(V=V.version),typeof q=="object"&&(q=q.version),oe=V===q;break;case"!==":typeof V=="object"&&(V=V.version),typeof q=="object"&&(q=q.version),oe=V!==q;break;case"":case"=":case"==":oe=be(V,q,_);break;case"!=":oe=ge(V,q,_);break;case">":oe=Fe(V,q,_);break;case">=":oe=ae(V,q,_);break;case"<":oe=pe(V,q,_);break;case"<=":oe=K(V,q,_);break;default:throw new TypeError("Invalid operator: "+W)}return oe}function fe(V,W){if(V instanceof fe){if(V.loose===W)return V;V=V.value}if(!(this instanceof fe))return new fe(V,W);C("comparator",V,W),this.loose=W,this.parse(V),this.semver===le?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(V,W){return H(W,V)},e.major=function(V,W){return new Pe(V,W).major},e.minor=function(V,W){return new Pe(V,W).minor},e.patch=function(V,W){return new Pe(V,W).patch},e.compare=he,e.compareLoose=function(V,W){return he(V,W,!0)},e.rcompare=function(V,W,q){return he(W,V,q)},e.sort=function(V,W){return V.sort(function(q,_){return e.compare(q,_,W)})},e.rsort=function(V,W){return V.sort(function(q,_){return e.rcompare(q,_,W)})},e.gt=Fe,e.lt=pe,e.eq=be,e.neq=ge,e.gte=ae,e.lte=K,e.cmp=Z,e.Comparator=fe;var le={};function Me(V,W){if(V instanceof Me)return V.loose===W?V:new Me(V.raw,W);if(V instanceof fe)return new Me(V.value,W);if(!(this instanceof Me))return new Me(V,W);if(this.loose=W,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ve(V){return!V||V.toLowerCase()==="x"||V==="*"}function Re(V,W,q,_,oe,Ne,Ve,Ke,Ye,tt,it,nt,st){return((W=ve(q)?"":ve(_)?">="+q+".0.0":ve(oe)?">="+q+"."+_+".0":">="+W)+" "+(Ke=ve(Ye)?"":ve(tt)?"<"+(+Ye+1)+".0.0":ve(it)?"<"+Ye+"."+(+tt+1)+".0":nt?"<="+Ye+"."+tt+"."+it+"-"+nt:"<="+Ke)).trim()}function Oe(V,W){for(var q=0;q<V.length;q++)if(!V[q].test(W))return!1;if(W.prerelease.length){for(q=0;q<V.length;q++)if(C(V[q].semver),V[q].semver!==le&&V[q].semver.prerelease.length>0){var _=V[q].semver;if(_.major===W.major&&_.minor===W.minor&&_.patch===W.patch)return!0}return!1}return!0}function Ue(V,W,q){try{W=new Me(W,q)}catch{return!1}return W.test(V)}function j(V,W,q,_){var oe,Ne,Ve,Ke,Ye;switch(V=new Pe(V,_),W=new Me(W,_),q){case">":oe=Fe,Ne=K,Ve=pe,Ke=">",Ye=">=";break;case"<":oe=pe,Ne=ae,Ve=Fe,Ke="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(V,W,_))return!1;for(var tt=0;tt<W.set.length;++tt){var it=W.set[tt],nt=null,st=null;if(it.forEach(function(ut){ut.semver===le&&(ut=new fe(">=0.0.0")),nt=nt||ut,st=st||ut,oe(ut.semver,nt.semver,_)?nt=ut:Ve(ut.semver,st.semver,_)&&(st=ut)}),nt.operator===Ke||nt.operator===Ye||(!st.operator||st.operator===Ke)&&Ne(V,st.semver)||st.operator===Ye&&Ve(V,st.semver))return!1}return!0}fe.prototype.parse=function(V){var W=this.loose?p[X]:p[ne],q=V.match(W);if(!q)throw new TypeError("Invalid comparator: "+V);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new Pe(q[2],this.loose):this.semver=le},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return C("Comparator.test",V,this.loose),this.semver===le||(typeof V=="string"&&(V=new Pe(V,this.loose)),Z(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,W){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new Me(V.value,W),Ue(this.value,q,W);if(V.operator==="")return q=new Me(this.value,W),Ue(V.semver,q,W);var _=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ke=Z(this.semver,"<",V.semver,W)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ye=Z(this.semver,">",V.semver,W)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return _||oe||Ne&&Ve||Ke||Ye},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(V){var W=this.loose;V=V.trim(),C("range",V,W);var q=W?p[de]:p[we];V=V.replace(q,Re),C("hyphen replace",V),V=V.replace(p[me],"$1$2$3"),C("comparator trim",V,p[me]),V=(V=(V=V.replace(p[U],"$1~")).replace(p[R],"$1^")).split(/\s+/).join(" ");var _=W?p[X]:p[ne],oe=V.split(" ").map(function(Ne){return function(Ve,Ke){return C("comp",Ve),Ve=function(Ye,tt){return Ye.trim().split(/\s+/).map(function(it){return function(nt,st){C("caret",nt,st);var ut=st?p[T]:p[F];return nt.replace(ut,function($t,je,ct,x,Y){var ye;return C("caret",nt,$t,je,ct,x,Y),ve(je)?ye="":ve(ct)?ye=">="+je+".0.0 <"+(+je+1)+".0.0":ve(x)?ye=je==="0"?">="+je+"."+ct+".0 <"+je+"."+(+ct+1)+".0":">="+je+"."+ct+".0 <"+(+je+1)+".0.0":Y?(C("replaceCaret pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),ye=je==="0"?ct==="0"?">="+je+"."+ct+"."+x+Y+" <"+je+"."+ct+"."+(+x+1):">="+je+"."+ct+"."+x+Y+" <"+je+"."+(+ct+1)+".0":">="+je+"."+ct+"."+x+Y+" <"+(+je+1)+".0.0"):(C("no pr"),ye=je==="0"?ct==="0"?">="+je+"."+ct+"."+x+" <"+je+"."+ct+"."+(+x+1):">="+je+"."+ct+"."+x+" <"+je+"."+(+ct+1)+".0":">="+je+"."+ct+"."+x+" <"+(+je+1)+".0.0"),C("caret return",ye),ye})}(it,tt)}).join(" ")}(Ve,Ke),C("caret",Ve),Ve=function(Ye,tt){return Ye.trim().split(/\s+/).map(function(it){return function(nt,st){var ut=st?p[G]:p[Q];return nt.replace(ut,function($t,je,ct,x,Y){var ye;return C("tilde",nt,$t,je,ct,x,Y),ve(je)?ye="":ve(ct)?ye=">="+je+".0.0 <"+(+je+1)+".0.0":ve(x)?ye=">="+je+"."+ct+".0 <"+je+"."+(+ct+1)+".0":Y?(C("replaceTilde pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),ye=">="+je+"."+ct+"."+x+Y+" <"+je+"."+(+ct+1)+".0"):ye=">="+je+"."+ct+"."+x+" <"+je+"."+(+ct+1)+".0",C("tilde return",ye),ye})}(it,tt)}).join(" ")}(Ve,Ke),C("tildes",Ve),Ve=function(Ye,tt){return C("replaceXRanges",Ye,tt),Ye.split(/\s+/).map(function(it){return function(nt,st){nt=nt.trim();var ut=st?p[P]:p[b];return nt.replace(ut,function($t,je,ct,x,Y,ye){C("xRange",nt,$t,je,ct,x,Y,ye);var Ge=ve(ct),De=Ge||ve(x),at=De||ve(Y);return je==="="&&at&&(je=""),Ge?$t=je===">"||je==="<"?"<0.0.0":"*":je&&at?(De&&(x=0),at&&(Y=0),je===">"?(je=">=",De?(ct=+ct+1,x=0,Y=0):at&&(x=+x+1,Y=0)):je==="<="&&(je="<",De?ct=+ct+1:x=+x+1),$t=je+ct+"."+x+"."+Y):De?$t=">="+ct+".0.0 <"+(+ct+1)+".0.0":at&&($t=">="+ct+"."+x+".0 <"+ct+"."+(+x+1)+".0"),C("xRange return",$t),$t})}(it,tt)}).join(" ")}(Ve,Ke),C("xrange",Ve),Ve=function(Ye,tt){return C("replaceStars",Ye,tt),Ye.trim().replace(p[$e],"")}(Ve,Ke),C("stars",Ve),Ve}(Ne,W)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Ne){return!!Ne.match(_)})),oe=oe.map(function(Ne){return new fe(Ne,W)})},Me.prototype.intersects=function(V,W){if(!(V instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(_){return V.set.some(function(oe){return oe.every(function(Ne){return _.intersects(Ne,W)})})})})},e.toComparators=function(V,W){return new Me(V,W).set.map(function(q){return q.map(function(_){return _.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new Pe(V,this.loose));for(var W=0;W<this.set.length;W++)if(Oe(this.set[W],V))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(V,W,q){var _=null,oe=null;try{var Ne=new Me(W,q)}catch{return null}return V.forEach(function(Ve){Ne.test(Ve)&&(_&&oe.compare(Ve)!==-1||(oe=new Pe(_=Ve,q)))}),_},e.minSatisfying=function(V,W,q){var _=null,oe=null;try{var Ne=new Me(W,q)}catch{return null}return V.forEach(function(Ve){Ne.test(Ve)&&(_&&oe.compare(Ve)!==1||(oe=new Pe(_=Ve,q)))}),_},e.validRange=function(V,W){try{return new Me(V,W).range||"*"}catch{return null}},e.ltr=function(V,W,q){return j(V,W,"<",q)},e.gtr=function(V,W,q){return j(V,W,">",q)},e.outside=j,e.prerelease=function(V,W){var q=se(V,W);return q&&q.prerelease.length?q.prerelease:null},e.intersects=function(V,W,q){return V=new Me(V,q),W=new Me(W,q),V.intersects(W)},e.coerce=function(V){if(V instanceof Pe)return V;if(typeof V!="string")return null;var W=V.match(p[k]);return W==null?null:se((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,y(1))},function(ee,e){var y,A,C=ee.exports={};function O(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function p(a){if(y===setTimeout)return setTimeout(a,0);if((y===O||!y)&&setTimeout)return y=setTimeout,setTimeout(a,0);try{return y(a,0)}catch{try{return y.call(null,a,0)}catch{return y.call(this,a,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:O}catch{y=O}try{A=typeof clearTimeout=="function"?clearTimeout:N}catch{A=N}})();var $,E=[],M=!1,S=-1;function m(){M&&$&&(M=!1,$.length?E=$.concat(E):S=-1,E.length&&w())}function w(){if(!M){var a=p(m);M=!0;for(var s=E.length;s;){for($=E,E=[];++S<s;)$&&$[S].run();S=-1,s=E.length}$=null,M=!1,function(n){if(A===clearTimeout)return clearTimeout(n);if((A===N||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(n);try{A(n)}catch{try{return A.call(null,n)}catch{return A.call(this,n)}}}(a)}}function g(a,s){this.fun=a,this.array=s}function r(){}C.nextTick=function(a){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];E.push(new g(a,s)),E.length!==1||M||p(w)},g.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=r,C.addListener=r,C.once=r,C.off=r,C.removeListener=r,C.removeAllListeners=r,C.emit=r,C.prependListener=r,C.prependOnceListener=r,C.listeners=function(a){return[]},C.binding=function(a){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(a){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ce[135],Ae([1,0,14,6]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=C,e.$se=O,e.$te=N,e.$ue=p,e.$ve=E,e.$we=M,e.$xe=S,e.$ye=m,e.$ze=w,e.$Ae=g,e.$Be=r,e.$Ce=a,e.$De=s,e.$Ee=n,e.$Fe=i;function C(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function N(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function p(c,h){return new $(c,h)}class ${constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,y.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let d;switch(h){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const o=d.indexOf(t);o>=0&&d.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,h){const t=[];let d;for(;(d=c.read())!==null;)t.push(d);return h(t)}function M(c,h,t){const d=[];let o;for(;(o=c.read())!==null&&d.length<t;)d.push(o);return o===null&&d.length>0?h(d):{read:()=>{if(d.length>0)return d.shift();if(typeof o<"u"){const f=o;return o=void 0,f}return c.read()}}}function S(c,h){return new Promise((t,d)=>{const o=[];m(c,{onData:f=>{h&&o.push(f)},onError:f=>{h?d(f):t(void 0)},onEnd:()=>{t(h?h(o):void 0)}})})}function m(c,h,t){c.on("error",d=>{t?.isCancellationRequested||h.onError(d)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",d=>{t?.isCancellationRequested||h.onData(d)})}function w(c,h){return new Promise((t,d)=>{const o=new A.$Uc,f=[],u=v=>{if(f.push(v),f.length>h)return o.dispose(),c.pause(),t({stream:c,buffer:f,ended:!1})},D=v=>(o.dispose(),d(v)),l=()=>(o.dispose(),t({stream:c,buffer:f,ended:!0}));o.add((0,A.$Tc)(()=>c.removeListener("error",D))),c.on("error",D),o.add((0,A.$Tc)(()=>c.removeListener("end",l))),c.on("end",l),o.add((0,A.$Tc)(()=>c.removeListener("data",u))),c.on("data",u)})}function g(c,h){const t=p(h);return t.end(c),t}function r(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function a(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function s(c,h,t){const d=p(t);return m(c,{onData:o=>d.write(h.data(o)),onError:o=>d.error(h.error?h.error(o):o),onEnd:()=>d.end()}),d}function n(c,h,t){let d=!1;return{read:()=>{const o=h.read();return d?o:(d=!0,o!==null?t([c,o]):c)}}}function i(c,h,t){let d=!1;const o=p(t);return m(h,{onData:f=>d?o.write(f):(d=!0,o.write(t([c,f]))),onError:f=>o.error(f),onEnd:()=>{d||(d=!0,o.write(c)),o.end()}}),o}}),define(Ce[21],Ae([1,0,43,135]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=E,e.$Ie=M,e.$Je=S,e.$Ke=m,e.$Le=w,e.$Me=g,e.$Ne=r,e.$Oe=a,e.$Pe=s,e.$Qe=n,e.$Re=i,e.$Se=c,e.$Te=h,e.$Ue=t,e.$Ve=d,e.$We=o,e.$Xe=f,e.$Ye=u,e.$Ze=D,e.$1e=b;const C=typeof Buffer<"u",O=new y.$V(()=>new Uint8Array(256));let N,p;class ${static alloc(k){return C?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return C&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&C?new $(Buffer.from(k)):(N||(N=new TextEncoder),new $(N.encode(k)))}static fromByteArray(k){const I=$.alloc(k.length);for(let U=0,Q=k.length;U<Q;U++)I.buffer[U]=k[U];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let G=0,L=k.length;G<L;G++)I+=k[G].byteLength}const U=$.alloc(I);let Q=0;for(let G=0,L=k.length;G<L;G++){const R=k[G];U.set(R,Q),Q+=R.byteLength}return U}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return C?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,I){return new $(this.buffer.subarray(k,I))}set(k,I){if(k instanceof $)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return m(this.buffer,k)}writeUInt32BE(k,I){w(this.buffer,k,I)}readUInt32LE(k){return g(this.buffer,k)}writeUInt32LE(k,I){r(this.buffer,k,I)}readUInt8(k){return a(this.buffer,k)}writeUInt8(k,I){s(this.buffer,k,I)}indexOf(k,I=0){return E(this.buffer,k instanceof $?k.buffer:k,I)}}e.$Ge=$;function E(P,k,I=0){const U=k.byteLength,Q=P.byteLength;if(U===0)return 0;if(U===1)return P.indexOf(k[0]);if(U>Q-I)return-1;const G=O.value;G.fill(k.length);for(let T=0;T<k.length;T++)G[k[T]]=k.length-T-1;let L=I+k.length-1,R=L,F=-1;for(;L<Q;)if(P[L]===k[R]){if(R===0){F=L;break}L--,R--}else L+=Math.max(k.length-R,G[P[L]]),R=k.length-1;return F}function M(P,k){return P[k+0]<<0>>>0|P[k+1]<<8>>>0}function S(P,k,I){P[I+0]=k&255,k=k>>>8,P[I+1]=k&255}function m(P,k){return P[k]*2**24+P[k+1]*2**16+P[k+2]*2**8+P[k+3]}function w(P,k,I){P[I+3]=k,k=k>>>8,P[I+2]=k,k=k>>>8,P[I+1]=k,k=k>>>8,P[I]=k}function g(P,k){return P[k+0]<<0>>>0|P[k+1]<<8>>>0|P[k+2]<<16>>>0|P[k+3]<<24>>>0}function r(P,k,I){P[I+0]=k&255,k=k>>>8,P[I+1]=k&255,k=k>>>8,P[I+2]=k&255,k=k>>>8,P[I+3]=k&255}function a(P,k){return P[k]}function s(P,k,I){P[I]=k}function n(P){return A.$ve(P,k=>$.concat(k))}function i(P){return A.$Ce(P)}function c(P){return A.$xe(P,k=>$.concat(k))}async function h(P){return P.ended?$.concat(P.buffer):$.concat([...P.buffer,await c(P.stream)])}function t(P){return A.$Ae(P,k=>$.concat(k))}function d(P){return A.$De(P,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function o(P){return A.$ue(k=>$.concat(k),P)}function f(P,k){return A.$Ee(P,k,I=>$.concat(I))}function u(P,k){return A.$Fe(P,k,I=>$.concat(I))}function D(P){let k=0,I=0,U=0;const Q=new Uint8Array(Math.floor(P.length/4*3)),G=R=>{switch(I){case 3:Q[U++]=k|R,I=0;break;case 2:Q[U++]=k|R>>>2,k=R<<6,I=3;break;case 1:Q[U++]=k|R>>>4,k=R<<4,I=2;break;default:k=R<<2,I=1}};for(let R=0;R<P.length;R++){const F=P.charCodeAt(R);if(F>=65&&F<=90)G(F-65);else if(F>=97&&F<=122)G(F-97+26);else if(F>=48&&F<=57)G(F-48+52);else if(F===43||F===45)G(62);else if(F===47||F===95)G(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${P[R]}`)}}const L=U;for(;I>0;)G(0);return $.wrap(Q).slice(0,L)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:P},k=!0,I=!1){const U=I?v:l;let Q="";const G=P.byteLength%3;let L=0;for(;L<P.byteLength-G;L+=3){const R=P[L+0],F=P[L+1],T=P[L+2];Q+=U[R>>>2],Q+=U[(R<<4|F>>>4)&63],Q+=U[(F<<2|T>>>6)&63],Q+=U[T&63]}if(G===1){const R=P[L+0];Q+=U[R>>>2],Q+=U[R<<4&63],k&&(Q+="==")}else if(G===2){const R=P[L+0],F=P[L+1];Q+=U[R>>>2],Q+=U[(R<<4|F>>>4)&63],Q+=U[F<<2&63],k&&(Q+="=")}return Q}}),define(Ce[136],Ae([1,0,28,128,13]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=O,e.$zk=p,e.$Ak=$,e.$Bk=S,e.$Ck=D,e.$Dk=l,e.$Ek=U,e.$Fk=Q,e.$Gk=G,e.$Hk=L,e.$Ik=he,e.$Kk=ge,e.$Lk=Z,e.$Mk=fe;function O(...ve){return function(Re,Oe){for(let Ue=0,j=ve.length;Ue<j;Ue++){const V=ve[Ue](Re,Oe);if(V)return V}return null}}e.$xk=N.bind(void 0,!1),e.$yk=N.bind(void 0,!0);function N(ve,Re,Oe){if(!Oe||Oe.length<Re.length)return null;let Ue;return ve?Ue=C.$zf(Oe,Re):Ue=Oe.indexOf(Re)===0,Ue?Re.length>0?[{start:0,end:Re.length}]:[]:null}function p(ve,Re){const Oe=Re.toLowerCase().indexOf(ve.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ve.length}]}function $(ve,Re){return E(ve.toLowerCase(),Re.toLowerCase(),0,0)}function E(ve,Re,Oe,Ue){if(Oe===ve.length)return[];if(Ue===Re.length)return null;if(ve[Oe]===Re[Ue]){let j=null;return(j=E(ve,Re,Oe+1,Ue+1))?c({start:Ue,end:Ue+1},j):null}return E(ve,Re,Oe,Ue+1)}function M(ve){return 97<=ve&&ve<=122}function S(ve){return 65<=ve&&ve<=90}function m(ve){return 48<=ve&&ve<=57}function w(ve){return ve===32||ve===9||ve===10||ve===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>g.add(ve.charCodeAt(0)));function r(ve){return w(ve)||g.has(ve)}function a(ve,Re){return ve===Re||r(ve)&&r(Re)}const s=new Map;function n(ve){if(s.has(ve))return s.get(ve);let Re;const Oe=(0,A.$vk)(ve);return Oe&&(Re=Oe),s.set(ve,Re),Re}function i(ve){return M(ve)||S(ve)||m(ve)}function c(ve,Re){return Re.length===0?Re=[ve]:ve.end===Re[0].start?Re[0].start=ve.start:Re.unshift(ve),Re}function h(ve,Re){for(let Oe=Re;Oe<ve.length;Oe++){const Ue=ve.charCodeAt(Oe);if(S(Ue)||m(Ue)||Oe>0&&!i(ve.charCodeAt(Oe-1)))return Oe}return ve.length}function t(ve,Re,Oe,Ue){if(Oe===ve.length)return[];if(Ue===Re.length)return null;if(ve[Oe]!==Re[Ue].toLowerCase())return null;{let j=null,V=Ue+1;for(j=t(ve,Re,Oe+1,Ue+1);!j&&(V=h(Re,V))<Re.length;)j=t(ve,Re,Oe+1,V),V++;return j===null?null:c({start:Ue,end:Ue+1},j)}}function d(ve){let Re=0,Oe=0,Ue=0,j=0,V=0;for(let Ne=0;Ne<ve.length;Ne++)V=ve.charCodeAt(Ne),S(V)&&Re++,M(V)&&Oe++,i(V)&&Ue++,m(V)&&j++;const W=Re/ve.length,q=Oe/ve.length,_=Ue/ve.length,oe=j/ve.length;return{upperPercent:W,lowerPercent:q,alphaPercent:_,numericPercent:oe}}function o(ve){const{upperPercent:Re,lowerPercent:Oe}=ve;return Oe===0&&Re>.6}function f(ve){const{upperPercent:Re,lowerPercent:Oe,alphaPercent:Ue,numericPercent:j}=ve;return Oe>.2&&Re<.8&&Ue>.6&&j<.2}function u(ve){let Re=0,Oe=0,Ue=0,j=0;for(let V=0;V<ve.length;V++)Ue=ve.charCodeAt(V),S(Ue)&&Re++,M(Ue)&&Oe++,w(Ue)&&j++;return(Re===0||Oe===0)&&j===0?ve.length<=30:Re<=5}function D(ve,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!u(ve))return null;Re.length>60&&(Re=Re.substring(0,60));const Oe=d(Re);if(!f(Oe)){if(!o(Oe))return null;Re=Re.toLowerCase()}let Ue=null,j=0;for(ve=ve.toLowerCase();j<Re.length&&(Ue=t(ve,Re,0,j))===null;)j=h(Re,j+1);return Ue}function l(ve,Re,Oe=!1){if(!Re||Re.length===0)return null;let Ue=null,j=0;for(ve=ve.toLowerCase(),Re=Re.toLowerCase();j<Re.length&&(Ue=v(ve,Re,0,j,Oe),Ue===null);)j=b(Re,j+1);return Ue}function v(ve,Re,Oe,Ue,j){let V=0;if(Oe===ve.length)return[];if(Ue===Re.length)return null;if(!a(ve.charCodeAt(Oe),Re.charCodeAt(Ue))){const _=n(ve.charCodeAt(Oe));if(!_)return null;for(let oe=0;oe<_.length;oe++)if(!a(_[oe],Re.charCodeAt(Ue+oe)))return null;V+=_.length-1}let W=null,q=Ue+V+1;if(W=v(ve,Re,Oe+1,q,j),!j)for(;!W&&(q=b(Re,q))<Re.length;)W=v(ve,Re,Oe+1,q,j),q++;if(!W)return null;if(ve.charCodeAt(Oe)!==Re.charCodeAt(Ue)){const _=n(ve.charCodeAt(Oe));if(!_)return W;for(let oe=0;oe<_.length;oe++)if(_[oe]!==Re.charCodeAt(Ue+oe))return W}return c({start:Ue,end:Ue+V+1},W)}function b(ve,Re){for(let Oe=Re;Oe<ve.length;Oe++)if(r(ve.charCodeAt(Oe))||Oe>0&&r(ve.charCodeAt(Oe-1)))return Oe;return ve.length}const P=O(e.$yk,D,p),k=O(e.$yk,D,$),I=new y.$Ec(1e4);function U(ve,Re,Oe=!1){if(typeof ve!="string"||typeof Re!="string")return null;let Ue=I.get(ve);Ue||(Ue=new RegExp(C.$hf(ve),"i"),I.set(ve,Ue));const j=Ue.exec(Re);return j?[{start:j.index,end:j.index+j[0].length}]:Oe?k(ve,Re):P(ve,Re)}function Q(ve,Re){const Oe=ge(ve,ve.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?L(Oe):null}function G(ve,Re,Oe,Ue,j,V){const W=Math.min(13,ve.length);for(;Oe<W;Oe++){const q=ge(ve,Re,Oe,Ue,j,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(q)return q}return[0,V]}function L(ve){if(typeof ve>"u")return[];const Re=[],Oe=ve[1];for(let Ue=ve.length-1;Ue>1;Ue--){const j=ve[Ue]+Oe,V=Re[Re.length-1];V&&V.end===j?V.end=j+1:Re.push({start:j,end:j+1})}return Re}const R=128;function F(){const ve=[],Re=[];for(let Oe=0;Oe<=R;Oe++)Re[Oe]=0;for(let Oe=0;Oe<=R;Oe++)ve.push(Re.slice(0));return ve}function T(ve){const Re=[];for(let Oe=0;Oe<=ve;Oe++)Re[Oe]=0;return Re}const X=T(2*R),ne=T(2*R),me=F(),we=F(),de=F(),$e=!1;function ke(ve,Re,Oe,Ue,j){function V(q,_,oe=" "){for(;q.length<_;)q=oe+q;return q}let W=` |   |${Ue.split("").map(q=>V(q,3)).join("|")}
`;for(let q=0;q<=Oe;q++)q===0?W+=" |":W+=`${Re[q-1]}|`,W+=ve[q].slice(0,j+1).map(_=>V(_.toString(),3)).join("|")+`
`;return W}function se(ve,Re,Oe,Ue){ve=ve.substr(Re),Oe=Oe.substr(Ue),console.log(ke(we,ve,ve.length,Oe,Oe.length)),console.log(ke(de,ve,ve.length,Oe,Oe.length)),console.log(ke(me,ve,ve.length,Oe,Oe.length))}function Pe(ve,Re){if(Re<0||Re>=ve.length)return!1;const Oe=ve.codePointAt(Re);switch(Oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$Rf(Oe)}}function re(ve,Re){if(Re<0||Re>=ve.length)return!1;switch(ve.charCodeAt(Re)){case 32:case 9:return!0;default:return!1}}function H(ve,Re,Oe){return Re[ve]!==Oe[ve]}function he(ve,Re,Oe,Ue,j,V,W=!1){for(;Re<Oe&&j<V;)ve[Re]===Ue[j]&&(W&&(X[Re]=j),Re+=1),j+=1;return Re===Oe}var Fe;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var pe;(function(ve){ve.Default=[-100,0];function Re(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ve.isDefault=Re})(pe||(e.FuzzyScore=pe={}));class be{constructor(Re,Oe){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Oe}}e.$Jk=be,be.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ge(ve,Re,Oe,Ue,j,V,W=be.default){const q=ve.length>R?R:ve.length,_=Ue.length>R?R:Ue.length;if(Oe>=q||V>=_||q-Oe>_-V||!he(Re,Oe,q,j,V,_,!0))return;ae(q,_,Oe,V,Re,j);let oe=1,Ne=1,Ve=Oe,Ke=V;const Ye=[!1];for(oe=1,Ve=Oe;Ve<q;oe++,Ve++){const ut=X[Ve],$t=ne[Ve],je=Ve+1<q?ne[Ve+1]:_;for(Ne=ut-V+1,Ke=ut;Ke<je;Ne++,Ke++){let ct=Number.MIN_SAFE_INTEGER,x=!1;Ke<=$t&&(ct=K(ve,Re,Ve,Oe,Ue,j,Ke,_,V,me[oe-1][Ne-1]===0,Ye));let Y=0;ct!==Number.MAX_SAFE_INTEGER&&(x=!0,Y=ct+we[oe-1][Ne-1]);const ye=Ke>ut,Ge=ye?we[oe][Ne-1]+(me[oe][Ne-1]>0?-5:0):0,De=Ke>ut+1&&me[oe][Ne-1]>0,at=De?we[oe][Ne-2]+(me[oe][Ne-2]>0?-5:0):0;if(De&&(!ye||at>=Ge)&&(!x||at>=Y))we[oe][Ne]=at,de[oe][Ne]=3,me[oe][Ne]=0;else if(ye&&(!x||Ge>=Y))we[oe][Ne]=Ge,de[oe][Ne]=2,me[oe][Ne]=0;else if(x)we[oe][Ne]=Y,de[oe][Ne]=1,me[oe][Ne]=me[oe-1][Ne-1]+1;else throw new Error("not possible")}}if($e&&se(ve,Oe,Ue,V),!Ye[0]&&!W.firstMatchCanBeWeak)return;oe--,Ne--;const tt=[we[oe][Ne],V];let it=0,nt=0;for(;oe>=1;){let ut=Ne;do{const $t=de[oe][ut];if($t===3)ut=ut-2;else if($t===2)ut=ut-1;else break}while(ut>=1);it>1&&Re[Oe+oe-1]===j[V+Ne-1]&&!H(ut+V-1,Ue,j)&&it+1>me[oe][ut]&&(ut=Ne),ut===Ne?it++:it=1,nt||(nt=ut),oe--,Ne=ut-1,tt.push(Ne)}_===q&&W.boostFullMatch&&(tt[0]+=2);const st=nt-q;return tt[0]-=st,tt}function ae(ve,Re,Oe,Ue,j,V){let W=ve-1,q=Re-1;for(;W>=Oe&&q>=Ue;)j[W]===V[q]&&(ne[W]=q,W--),q--}function K(ve,Re,Oe,Ue,j,V,W,q,_,oe,Ne){if(Re[Oe]!==V[W])return Number.MIN_SAFE_INTEGER;let Ve=1,Ke=!1;return W===Oe-Ue?Ve=ve[Oe]===j[W]?7:5:H(W,j,V)&&(W===0||!H(W-1,j,V))?(Ve=ve[Oe]===j[W]?7:5,Ke=!0):Pe(V,W)&&(W===0||!Pe(V,W-1))?Ve=5:(Pe(V,W-1)||re(V,W-1))&&(Ve=5,Ke=!0),Ve>1&&Oe===Ue&&(Ne[0]=!0),Ke||(Ke=H(W,j,V)||Pe(V,W-1)||re(V,W-1)),Oe===Ue?W>_&&(Ve-=Ke?3:5):oe?Ve+=Ke?2:0:Ve+=Ke?0:1,W+1===q&&(Ve-=Ke?3:5),Ve}function Z(ve,Re,Oe,Ue,j,V,W){return le(ve,Re,Oe,Ue,j,V,!0,W)}function fe(ve,Re,Oe,Ue,j,V,W){return le(ve,Re,Oe,Ue,j,V,!1,W)}function le(ve,Re,Oe,Ue,j,V,W,q){let _=ge(ve,Re,Oe,Ue,j,V,q);if(_&&!W)return _;if(ve.length>=3){const oe=Math.min(7,ve.length-1);for(let Ne=Oe+1;Ne<oe;Ne++){const Ve=Me(ve,Ne);if(Ve){const Ke=ge(Ve,Ve.toLowerCase(),Oe,Ue,j,V,q);Ke&&(Ke[0]-=3,(!_||Ke[0]>_[0])&&(_=Ke))}}}return _}function Me(ve,Re){if(Re+1>=ve.length)return;const Oe=ve[Re],Ue=ve[Re+1];if(Oe!==Ue)return ve.slice(0,Re)+Ue+Oe+ve.slice(Re+2)}}),define(Ce[33],Ae([1,0,13]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(A||(A={})),function(C){const O="error",N="warning",p="warn",$="info",E="ignore";function M(m){return m?y.$yf(O,m)?C.Error:y.$yf(N,m)||y.$yf(p,m)?C.Warning:y.$yf($,m)?C.Info:C.Ignore:C.Ignore}C.fromValue=M;function S(m){switch(m){case C.Error:return O;case C.Warning:return N;case C.Info:return $;default:return E}}C.toString=S}(A||(A={})),e.default=A}),define(Ce[137],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(Ce[54],Ae([1,0,18,13]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class C{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const g=w.charCodeAt(0),r=this.b.charCodeAt(this.c);return g-r}value(){return this.b[this.c]}}e.$yi=C;class O{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,A.$sf)(w,this.b,0,w.length,this.c,this.d):(0,A.$uf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=O;class N{constructor(w=!0,g=!0){this.f=w,this.g=g}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let g=w.length-1;g>=0;g--,this.c--){const r=this.b.charCodeAt(g);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,A.$sf)(w,this.b,0,w.length,this.d,this.e):(0,A.$uf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=N;var p;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(w,g){this.f=w,this.g=g,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,A.$tf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,A.$tf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,A.$rf)(w,this.c.query);if(this.d[this.e]===5)return(0,A.$rf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=$;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(M||(M={}));class S{static forUris(w=()=>!1,g=()=>!1){return new S(new $(w,g))}static forPaths(w=!1){return new S(new N(void 0,!w))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new O)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,g){if(g){const r=g.slice(0);(0,y.$Xb)(r);for(const a of r)this.set(a,w)}else{const r=w.slice(0);(0,y.$Xb)(r);for(const a of r)this.set(a[0],a[1])}}set(w,g){const r=this.b.reset(w);let a;this.c||(this.c=new E,this.c.segment=r.value());const s=[];for(a=this.c;;){const i=r.cmp(a.segment);if(i>0)a.left||(a.left=new E,a.left.segment=r.value()),s.push([-1,a]),a=a.left;else if(i<0)a.right||(a.right=new E,a.right.segment=r.value()),s.push([1,a]),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new E,a.mid.segment=r.value()),s.push([0,a]),a=a.mid;else break}const n=a.value;a.value=g,a.key=w;for(let i=s.length-1;i>=0;i--){const c=s[i][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=s[i][0],d=s[i+1][0];if(t===1&&d===1)s[i][1]=c.rotateLeft();else if(t===-1&&d===-1)s[i][1]=c.rotateRight();else if(t===1&&d===-1)c.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=c.rotateLeft();else if(t===-1&&d===1)c.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return n}get(w){return this.d(w)?.value}d(w){const g=this.b.reset(w);let r=this.c;for(;r;){const a=g.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(w){const g=this.d(w);return!(g?.value===void 0&&g?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,g){const r=this.b.reset(w),a=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)a.push([-1,s]),s=s.left;else if(n<0)a.push([1,s]),s=s.right;else if(r.hasNext())r.next(),a.push([0,s]),s=s.mid;else break}if(s){if(g?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:i,value:c,segment:h}=n;this.e(n.key,!1),s.key=i,s.value=c,s.segment=h}}else{const n=s.left??s.right;if(a.length>0){const[i,c]=a[a.length-1];switch(i){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const i=a[n][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),a[n][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),a[n][1]=i.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const g=this.b.reset(w);let r=this.c,a;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(w){return this.g(w,!1)}g(w,g){const r=this.b.reset(w);let a=this.c;for(;a;){const s=r.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this.h(a.mid):g?a.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[g,r]of this)w(r,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const g=[];return this.j(w,g),g[Symbol.iterator]()}j(w,g){w&&(w.left&&this.j(w.left,g),w.value&&g.push([w.key,w.value]),w.mid&&this.j(w.mid,g),w.right&&this.j(w.right,g))}_isBalanced(){const w=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:w(g.left)&&w(g.right)};return w(this.c)}}e.$Ci=S}),define(Ce[48],Ae([1,0,19,22,13,15]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=N,e.$pg=p,e.$qg=$,e.$rg=E,e.$sg=M,e.$tg=g,e.$ug=r,e.$vg=a,e.$wg=s,e.$xg=n,e.$yg=i,e.$zg=c,e.$Ag=h,e.$Bg=t,e.$Cg=d,e.$Dg=o,e.$Eg=D;function N(l){return l===47||l===92}function p(l){return l.replace(/[\\/]/g,y.$hc.sep)}function $(l){return l.indexOf("/")===-1&&(l=p(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function E(l,v=y.$hc.sep){if(!l)return"";const b=l.length,P=l.charCodeAt(0);if(N(P)){if(N(l.charCodeAt(1))&&!N(l.charCodeAt(2))){let I=3;const U=I;for(;I<b&&!N(l.charCodeAt(I));I++);if(U!==I&&!N(l.charCodeAt(I+1))){for(I+=1;I<b;I++)if(N(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,v)}}return v}else if(s(P)&&l.charCodeAt(1)===58)return N(l.charCodeAt(2))?l.slice(0,2)+v:l.slice(0,2);let k=l.indexOf("://");if(k!==-1){for(k+=3;k<b;k++)if(N(l.charCodeAt(k)))return l.slice(0,k+1)}return""}function M(l){if(!A.$c||!l||l.length<5)return!1;let v=l.charCodeAt(0);if(v!==92||(v=l.charCodeAt(1),v!==92))return!1;let b=2;const P=b;for(;b<l.length&&(v=l.charCodeAt(b),v!==92);b++);return!(P===b||(v=l.charCodeAt(b+1),isNaN(v)||v===92))}const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(l,v=A.$c){const b=v?S:m;return!(!l||l.length===0||/^\s+$/.test(l)||(b.lastIndex=0,b.test(l))||v&&w.test(l)||l==="."||l===".."||v&&l[l.length-1]==="."||v&&l.length!==l.trim().length||l.length>255)}function r(l,v,b){const P=l===v;return!b||P?P:!l||!v?!1:(0,C.$yf)(l,v)}function a(l,v,b,P=y.sep){if(l===v)return!0;if(!l||!v||v.length>l.length)return!1;if(b){if(!(0,C.$zf)(l,v))return!1;if(v.length===l.length)return!0;let I=v.length;return v.charAt(v.length-1)===P&&I--,l.charAt(I)===P}return v.charAt(v.length-1)!==P&&(v+=P),l.indexOf(v)===0}function s(l){return l>=65&&l<=90||l>=97&&l<=122}function n(l,v){return A.$c&&l.endsWith(":")&&(l+=y.sep),(0,y.$jc)(l)||(l=(0,y.$kc)(v,l)),l=(0,y.$ic)(l),i(l)}function i(l){return A.$c?(l=(0,C.$gf)(l,y.sep),l.endsWith(":")&&(l+=y.sep)):(l=(0,C.$gf)(l,y.sep),l||(l=y.sep)),l}function c(l){const v=(0,y.$ic)(l);return A.$c?l.length>3?!1:h(v)&&(l.length===2||v.charCodeAt(2)===92):v===y.$hc.sep}function h(l,v=A.$c){return v?s(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}function t(l,v=A.$c){return h(l,v)?l[0]:void 0}function d(l,v,b){return v.length>l.length?-1:l===v?0:(b&&(l=l.toLowerCase(),v=v.toLowerCase()),l.indexOf(v))}function o(l){const v=l.split(":");let b,P,k;for(const I of v){const U=Number(I);(0,O.$ag)(U)?P===void 0?P=U:k===void 0&&(k=U):b=b?[b,I].join(":"):I}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:P!==void 0?P:void 0,column:k!==void 0?k:P!==void 0?1:void 0}}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(l,v,b=8){let P="";for(let I=0;I<b;I++){let U;I===0&&A.$c&&!v&&(b===3||b===4)?U=u:U=f,P+=U.charAt(Math.floor(Math.random()*U.length))}let k;return v?k=`${v}-${P}`:k=P,l?(0,y.$kc)(l,k):k}}),define(Ce[36],Ae([1,0,92]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=C;var A;(function(N){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}N.isThemeColor=p})(A||(e.ThemeColor=A={}));function C(N){return{id:N}}var O;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function $(n){const i=p.exec(n.id);if(!i)return $(y.$Vj.error);const[,c,h]=i,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}N.asClassNameArray=$;function E(n){return $(n).join(" ")}N.asClassName=E;function M(n){return"."+$(n).join(".")}N.asCSSSelector=M;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||A.isThemeColor(n.color))}N.isThemeIcon=S;const m=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function w(n){const i=m.exec(n);if(!i)return;const[,c]=i;return{id:c}}N.fromString=w;function g(n){return{id:n}}N.fromId=g;function r(n,i){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),i&&(c=`${c}~${i}`),{id:c}}N.modify=r;function a(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}N.getModifier=a;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}N.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Ce[138],Ae([1,0,136,13,36]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=$,e.$Ok=M,e.$Pk=m,e.$Qk=w,e.$Rk=r,e.$Sk=a;const O="$(",N=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${N.source}`,"g");function $(s){return s.replace(p,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${N.source}`,"g");function M(s){return s.replace(E,n=>`\\${n}`)}const S=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function m(s){return s.indexOf(O)===-1?s:s.replace(S,(n,i,c,h)=>c?n:i||h||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const g=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){g.lastIndex=0;let n="";const i=[];let c=0;for(;;){const h=g.lastIndex,t=g.exec(s),d=s.substring(h,t?.index);if(d.length>0){n+=d;for(let o=0;o<d.length;o++)i.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:i}}function a(s,n,i=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,y.$Ek)(s,c,i);const t=(0,A.$ff)(c," "),d=c.length-t.length,o=(0,y.$Ek)(s,t,i);if(o)for(const f of o){const u=h[f.start+d]+d;f.start+=u,f.end+=u}return o}}),define(Ce[49],Ae([1,0,21,2]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=C,e.$5h=O,e.$6h=p;function C($){return JSON.stringify($,N)}function O($){let E=JSON.parse($);return E=p(E),E}function N($,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function p($,E=0){if(!$||E>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return A.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof y.$Ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let M=0;M<$.length;++M)$[M]=p($[M],E+1);else for(const M in $)Object.hasOwnProperty.call($,M)&&($[M]=p($[M],E+1))}return $}}),define(Ce[16],Ae([1,0,14,22,13,2,19]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=$,e.$Gg=E,e.$Kg=S;var p;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(g,r){return O.URI.isUri(g)?(0,C.$yf)(g.scheme,r):(0,C.$zf)(g,r+":")}function E(g,...r){return r.some(a=>$(g,a))}e.$Hg="vscode-tkn",e.$Ig="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,a){this.f=S(r,a)}getServerRootPath(){return this.f}get g(){return N.$hc.join(this.f,p.vscodeRemoteResource)}set(r,a,s){this.a[r]=a,this.b[r]=s}setConnectionToken(r,a){this.c[r]=a}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return y.$1(h),r}const a=r.authority;let s=this.a[a];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[a],i=this.c[a];let c=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(c+=`&${e.$Ig}=${encodeURIComponent(i)}`),O.URI.from({scheme:A.$i?this.d:p.vscodeRemoteResource,authority:`${s}:${n}`,path:A.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:c})}}e.$Jg=new M;function S(g,r){return N.$hc.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class m{asBrowserUri(r){const a=this.b(r,ee);return this.uriToBrowserUri(a)}uriToBrowserUri(r){return r.scheme===p.vscodeRemote?e.$Jg.rewrite(r):r.scheme===p.file&&(A.$g||A.$k===`${p.vscodeFileResource}://${m.a}`)?r.with({scheme:p.vscodeFileResource,authority:r.authority||m.a,query:null,fragment:null}):r}asFileUri(r){const a=this.b(r,ee);return this.uriToFileUri(a)}uriToFileUri(r){return r.scheme===p.vscodeFileResource?r.with({scheme:p.file,authority:r.authority!==m.a?r.authority:null,query:null,fragment:null}):r}b(r,a){return O.URI.isUri(r)?r:O.URI.parse(a.toUrl(r))}}m.a=e.$Pg,e.$Qg=new m;var w;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const a="vscode-coi";function s(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:O.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const h=c?.get(a);if(h)return r.get(h)}g.getHeadersFromQuery=s;function n(i,c,h){if(!globalThis.crossOriginIsolated)return;const t=c&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(a,t):i[a]=t}g.addSearchParam=n})(w||(e.COI=w={}))}),define(Ce[23],Ae([1,0,48,16,19,22,13,2]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=$,e.$gh=M,e.$hh=m;function $(w){return(0,p.$xc)(w,!0)}class E{constructor(g){this.a=g}compare(g,r,a=!1){return g===r?0:(0,N.$rf)(this.getComparisonKey(g,a),this.getComparisonKey(r,a))}isEqual(g,r,a=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,a)===this.getComparisonKey(r,a)}getComparisonKey(g,r=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,r,a=!1){if(g.scheme===r.scheme){if(g.scheme===A.Schemas.file)return y.$vg($(g),$(r),this.a(g))&&g.query===r.query&&(a||g.fragment===r.fragment);if((0,e.$ch)(g.authority,r.authority))return y.$vg(g.path,r.path,this.a(g),"/")&&g.query===r.query&&(a||g.fragment===r.fragment)}return!1}joinPath(g,...r){return p.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.$7g)(g)||g.authority}basename(g){return C.$hc.basename(g.path)}extname(g){return C.$hc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===A.Schemas.file?r=p.URI.file(C.$nc($(g))).path:(r=C.$hc.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===A.Schemas.file?r=p.URI.file(C.$ic($(g))).path:r=C.$hc.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.$ch)(g.authority,r.authority))return;if(g.scheme===A.Schemas.file){const n=C.$mc($(g),$(r));return O.$c?y.$pg(n):n}let a=g.path||"/";const s=r.path||"/";if(this.a(g)){let n=0;for(const i=Math.min(a.length,s.length);n<i&&!(a.charCodeAt(n)!==s.charCodeAt(n)&&a.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);a=s.substr(0,n)+a.substr(n)}return C.$hc.relative(a,s)}resolvePath(g,r){if(g.scheme===A.Schemas.file){const a=p.URI.file(C.$lc($(g),r));return g.with({authority:a.authority,path:a.path})}return r=y.$qg(r),g.with({path:C.$hc.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,N.$yf)(g,r)}hasTrailingPathSeparator(g,r=C.sep){if(g.scheme===A.Schemas.file){const a=$(g);return a.length>y.$rg(a).length&&a[a.length-1]===r}else{const a=g.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=C.sep){return(0,e.$dh)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=C.sep){let a=!1;if(g.scheme===A.Schemas.file){const s=$(g);a=s!==void 0&&s.length===y.$rg(s).length&&s[s.length-1]===r}else{r="/";const s=g.path;a=s.length===1&&s.charCodeAt(s.length-1)===47}return!a&&!(0,e.$dh)(g,r)?g.with({path:g.path+"/"}):g}}e.$Yg=E,e.$Zg=new E(()=>!1),e.$1g=new E(w=>w.scheme===A.Schemas.file?!O.$e:!0),e.$2g=new E(w=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function M(w,g){const r=[];for(let a=0;a<w.length;a++){const s=g(w[a]);w.some((n,i)=>i===a?!1:(0,e.$4g)(s,g(n)))||r.push(w[a])}return r}var S;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function g(r){const a=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,h]=i.split(":");c&&h&&a.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&a.set(w.META_DATA_MIME,n),a}w.parseMetaData=g})(S||(e.DataUri=S={}));function m(w,g,r){if(g){let a=w.path;return a&&a[0]!==C.$hc.sep&&(a=C.$hc.sep+a),w.with({scheme:r,authority:g,path:a})}return w.with({scheme:r})}}),define(Ce[9],Ae([1,0,24,14,5,6,23,22,137,43]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=M,e.$jh=S,e.$kh=m,e.$lh=w,e.$mh=g,e.$nh=r,e.$oh=a,e.$ph=s,e.$xh=D,e.$yh=l,e.$zh=v,e.$Ah=b,e.$Bh=P,e.$Qh=we,e.$Yh=be;function M(ae){return!!ae&&typeof ae.then=="function"}function S(ae){const K=new y.$pe,Z=ae(K.token),fe=new Promise((le,Me)=>{const ve=K.token.onCancellationRequested(()=>{ve.dispose(),Me(new A.$5)});Promise.resolve(Z).then(Re=>{ve.dispose(),K.dispose(),le(Re)},Re=>{ve.dispose(),K.dispose(),Me(Re)})});return new class{cancel(){K.cancel(),K.dispose()}then(le,Me){return fe.then(le,Me)}catch(le){return this.then(void 0,le)}finally(le){return fe.finally(le)}}}function m(ae,K,Z){return new Promise((fe,le)=>{const Me=K.onCancellationRequested(()=>{Me.dispose(),fe(Z)});ae.then(fe,le).finally(()=>Me.dispose())})}function w(ae,K){return new Promise((Z,fe)=>{const le=K.onCancellationRequested(()=>{le.dispose(),fe(new A.$5)});ae.then(Z,fe).finally(()=>le.dispose())})}async function g(ae){let K=-1;const Z=ae.map((fe,le)=>fe.then(Me=>(K=le,Me)));try{return await Promise.race(Z)}finally{ae.forEach((fe,le)=>{le!==K&&fe.cancel()})}}function r(ae,K,Z){let fe;const le=setTimeout(()=>{fe?.(void 0),Z?.()},K);return Promise.race([ae.finally(()=>clearTimeout(le)),new Promise(Me=>fe=Me)])}function a(ae){return new Promise((K,Z)=>{const fe=ae();M(fe)?fe.then(K,Z):K(fe)})}function s(){let ae,K;return{promise:new Promise((fe,le)=>{ae=fe,K=le}),resolve:ae,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const Z=()=>{if(this.b=null,this.f)return;const fe=this.queue(this.d);return this.d=null,fe};this.b=new Promise(fe=>{this.a.then(Z,Z).then(fe)})}return new Promise((Z,fe)=>{this.b.then(Z,fe)})}return this.a=K(),new Promise((Z,fe)=>{this.a.then(le=>{this.a=null,Z(le)},le=>{this.a=null,fe(le)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$rh=i;class c{constructor(){this.a=new Map}queue(K,Z){const le=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(K)===le&&this.a.delete(K)});return this.a.set(K,le),le}}e.$sh=c;const h=(ae,K)=>{let Z=!0;const fe=setTimeout(()=>{Z=!1,K()},ae);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(fe),Z=!1}}},t=ae=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,ae())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class d{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,Z=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((le,Me)=>{this.d=le,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const fe=()=>{this.a=null,this.d?.(null)};return this.a=Z===$.$be?t(fe):h(Z,fe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=d;class o{constructor(K){this.a=new d(K),this.b=new n}trigger(K,Z){return this.a.trigger(()=>this.b.queue(K),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=o;class f{constructor(){this.a=!1,this.b=new Promise((K,Z)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=f;class u extends f{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$wh=u;function D(ae,K){return K?new Promise((Z,fe)=>{const le=setTimeout(()=>{Me.dispose(),Z()},ae),Me=K.onCancellationRequested(()=>{clearTimeout(le),Me.dispose(),fe(new A.$5)})}):S(Z=>D(ae,Z))}function l(ae,K=0,Z){const fe=setTimeout(()=>{ae(),Z&&le.dispose()},K),le=(0,O.$Tc)(()=>{clearTimeout(fe),Z?.deleteAndLeak(le)});return Z?.add(le),le}function v(ae){const K=[];let Z=0;const fe=ae.length;function le(){return Z<fe?ae[Z++]():null}function Me(ve){ve!=null&&K.push(ve);const Re=le();return Re?Re.then(Me):Promise.resolve(K)}return Promise.resolve(null).then(Me)}function b(ae,K=fe=>!!fe,Z=null){let fe=0;const le=ae.length,Me=()=>{if(fe>=le)return Promise.resolve(Z);const ve=ae[fe++];return Promise.resolve(ve()).then(Oe=>K(Oe)?Promise.resolve(Oe):Me())};return Me()}function P(ae,K=fe=>!!fe,Z=null){if(ae.length===0)return Promise.resolve(Z);let fe=ae.length;const le=()=>{fe=-1;for(const Me of ae)Me.cancel?.()};return new Promise((Me,ve)=>{for(const Re of ae)Re.then(Oe=>{--fe>=0&&K(Oe)?(le(),Me(Oe)):fe===0&&Me(Z)}).catch(Oe=>{--fe>=0&&(le(),ve(Oe))})})}class k{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new C.$ee}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,fe)=>{this.g.push({factory:K,c:Z,e:fe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const Z=K.factory();Z.then(K.c,K.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=k;class I extends k{constructor(){super(1)}}e.$Dh=I;class U{constructor(){this.a=new de,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Eh=U;class Q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new se;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,Z=N.$Zg){const fe=Z.getComparisonKey(K);return this.a.get(fe)?.size??0}queueFor(K,Z,fe=N.$Zg){const le=fe.getComparisonKey(K);let Me=this.a.get(le);if(!Me){Me=new I;const ve=this.f++,Re=C.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$5c),this.d.set(ve,Re),this.a.set(le,Me)}return Me.queue(Z)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=Q;class G{constructor(K,Z){this.a=-1,typeof K=="function"&&typeof Z=="number"&&this.setIfNotSet(K,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},Z)}setIfNotSet(K,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},Z))}}e.$Gh=G;class L{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,Z,fe=globalThis){this.cancel();const le=fe.setInterval(()=>{K()},Z);this.d=(0,O.$Tc)(()=>{fe.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=L;class R{constructor(K,Z){this.b=-1,this.a=K,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=R;class F{constructor(K,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=K,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=F;class T extends R{constructor(K,Z){super(K,Z),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Kh=T;class X extends O.$Vc{constructor(K,Z){super(),this.g=K,this.h=Z,this.a=[],this.b=this.B(new O.$Wc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of K)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(ae,K)=>{(0,p.$v)(()=>{if(Z)return;const fe=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$Nh=(ae,K,Z)=>{const fe=ae.requestIdleCallback(K,typeof Z=="number"?{timeout:Z}:void 0);let le=!1;return{dispose(){le||(le=!0,ae.cancelIdleCallback(fe))}}},e.$Mh=ae=>(0,e.$Nh)(globalThis,ae)}();class ne{constructor(K,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(fe){this.l=fe}finally{this.g=!0}},this.f=(0,e.$Nh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ne;class me extends ne{constructor(K){super(globalThis,K)}}e.$Ph=me;async function we(ae,K,Z){let fe;for(let le=0;le<Z;le++)try{return await ae()}catch(Me){fe=Me,await D(K)}throw fe}class de{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,Z,fe){return this.a={taskId:K,cancel:()=>fe?.(),promise:Z},Z.then(()=>this.d(K),()=>this.d(K)),Z}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:Z,resolve:fe,reject:le}=s();this.b={run:K,promise:Z,promiseResolve:fe,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=de;class $e{constructor(K,Z=()=>Date.now()){this.d=K,this.f=Z,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Sh=$e;var ke;(function(ae){ae[ae.Resolved=0]="Resolved",ae[ae.Rejected=1]="Rejected"})(ke||(ke={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,Z)=>{this.a=K,this.b=Z})}complete(K){return new Promise(Z=>{this.a(K),this.d={outcome:0,value:K},Z()})}error(K){return new Promise(Z=>{this.b(K),this.d={outcome:1,value:K},Z()})}cancel(){return this.error(new A.$5)}}e.$Th=se;var Pe;(function(ae){async function K(fe){let le;const Me=await Promise.all(fe.map(ve=>ve.then(Re=>Re,Re=>{le||(le=Re)})));if(typeof le<"u")throw le;return Me}ae.settled=K;function Z(fe){return new Promise(async(le,Me)=>{try{await fe(le,Me)}catch(ve){Me(ve)}})}ae.withAsyncBody=Z})(Pe||(e.Promises=Pe={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=re;class H{constructor(K){this.b=K,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=H;var he;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(he||(he={}));class Fe{static fromArray(K){return new Fe(Z=>{Z.emitMany(K)})}static fromPromise(K){return new Fe(async Z=>{Z.emitMany(await K)})}static fromPromises(K){return new Fe(async Z=>{await Promise.all(K.map(async fe=>Z.emitOne(await fe)))})}static merge(K){return new Fe(async Z=>{await Promise.all(K.map(async fe=>{for await(const le of fe)Z.emitOne(le)}))})}constructor(K,Z){this.a=0,this.b=[],this.d=null,this.f=Z,this.g=new C.$ee,queueMicrotask(async()=>{const fe={emitOne:le=>this.h(le),emitMany:le=>this.j(le),reject:le=>this.l(le)};try{await Promise.resolve(K(fe)),this.k()}catch(le){this.l(le)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,Z){return new Fe(async fe=>{for await(const le of K)fe.emitOne(Z(le))})}map(K){return Fe.map(this,K)}static filter(K,Z){return new Fe(async fe=>{for await(const le of K)Z(le)&&fe.emitOne(le)})}filter(K){return Fe.filter(this,K)}static coalesce(K){return Fe.filter(K,Z=>!!Z)}coalesce(){return Fe.coalesce(this)}static async toPromise(K){const Z=[];for await(const fe of K)Z.push(fe);return Z}toPromise(){return Fe.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Wh=Fe,Fe.EMPTY=Fe.fromArray([]);class pe extends Fe{constructor(K,Z){super(Z),this.m=K}cancel(){this.m.cancel()}}e.$Xh=pe;function be(ae){const K=new y.$pe,Z=ae(K.token);return new pe(K,async fe=>{const le=K.token.onCancellationRequested(()=>{le.dispose(),K.dispose(),fe.reject(new A.$5)});try{for await(const Me of Z){if(K.token.isCancellationRequested)return;fe.emitOne(Me)}le.dispose(),K.dispose()}catch(Me){le.dispose(),K.dispose(),fe.reject(Me)}})}class ge{constructor(K){this.a=new se,this.b=new Fe(le=>{if(Z){le.reject(Z);return}return fe&&le.emitMany(fe),this.d=Me=>le.reject(Me),this.f=Me=>le.emitOne(Me),this.a.p},K);let Z,fe;this.f=le=>{fe||(fe=[]),fe.push(le)},this.d=le=>{Z||(Z=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Zh=ge}),define(Ce[37],Ae([1,0,18,9,48,28,19,22,13]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=E,e.$ok=g,e.$pk=I,e.$qk=U,e.$rk=Q,e.$sk=G,e.$tk=L,e.$uk=X;function E(){return Object.create(null)}e.$mk="**",e.$nk="/";const M="[/\\\\]",S="[^/\\\\]",m=/\//g;function w(ne,me){switch(ne){case 0:return"";case 1:return`${S}*?`;default:return`(?:${M}|${S}+${M}${me?`|${M}${S}+`:""})*?`}}function g(ne,me){if(!ne)return[];const we=[];let de=!1,$e=!1,ke="";for(const se of ne){switch(se){case me:if(!de&&!$e){we.push(ke),ke="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ke+=se}return ke&&we.push(ke),we}function r(ne){if(!ne)return"";let me="";const we=g(ne,e.$nk);if(we.every(de=>de===e.$mk))me=".*";else{let de=!1;we.forEach(($e,ke)=>{if($e===e.$mk){if(de)return;me+=w(2,ke===we.length-1)}else{let se=!1,Pe="",re=!1,H="";for(const he of $e){if(he!=="}"&&se){Pe+=he;continue}if(re&&(he!=="]"||!H)){let Fe;he==="-"?Fe=he:(he==="^"||he==="!")&&!H?Fe="^":he===e.$nk?Fe="":Fe=(0,$.$af)(he),H+=Fe;continue}switch(he){case"{":se=!0;continue;case"[":re=!0;continue;case"}":{const pe=`(?:${g(Pe,",").map(be=>r(be)).join("|")})`;me+=pe,se=!1,Pe="";break}case"]":{me+="["+H+"]",re=!1,H="";break}case"?":me+=S;continue;case"*":me+=w(1);continue;default:me+=(0,$.$af)(he)}}ke<we.length-1&&(we[ke+1]!==e.$mk||ke+2<we.length)&&(me+=M)}de=$e===e.$mk})}return me}const a=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ec(1e4),d=function(){return!1},o=function(){return null};function f(ne,me){if(!ne)return o;let we;typeof ne!="string"?we=ne.pattern:we=ne,we=we.trim();const de=`${we}_${!!me.trimForExclusions}`;let $e=t.get(de);if($e)return u($e,ne);let ke;return a.test(we)?$e=l(we.substr(4),we):(ke=s.exec(D(we,me)))?$e=v(ke[1],we):(me.trimForExclusions?i:n).test(we)?$e=b(we,me):(ke=c.exec(D(we,me)))?$e=P(ke[1].substr(1),we,!0):(ke=h.exec(D(we,me)))?$e=P(ke[1],we,!1):$e=k(we),t.set(de,$e),u($e,ne)}function u(ne,me){if(typeof me=="string")return ne;const we=function(de,$e){return(0,C.$vg)(de,me.base,!p.$e)?ne((0,$.$ff)(de.substr(me.base.length),N.sep),$e):null};return we.allBasenames=ne.allBasenames,we.allPaths=ne.allPaths,we.basenames=ne.basenames,we.patterns=ne.patterns,we}function D(ne,me){return me.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function l(ne,me){return function(we,de){return typeof we=="string"&&we.endsWith(ne)?me:null}}function v(ne,me){const we=`/${ne}`,de=`\\${ne}`,$e=function(se,Pe){return typeof se!="string"?null:Pe?Pe===ne?me:null:se===ne||se.endsWith(we)||se.endsWith(de)?me:null},ke=[ne];return $e.basenames=ke,$e.patterns=[me],$e.allBasenames=ke,$e}function b(ne,me){const we=T(ne.slice(1,-1).split(",").map(Pe=>f(Pe,me)).filter(Pe=>Pe!==o),ne),de=we.length;if(!de)return o;if(de===1)return we[0];const $e=function(Pe,re){for(let H=0,he=we.length;H<he;H++)if(we[H](Pe,re))return ne;return null},ke=we.find(Pe=>!!Pe.allBasenames);ke&&($e.allBasenames=ke.allBasenames);const se=we.reduce((Pe,re)=>re.allPaths?Pe.concat(re.allPaths):Pe,[]);return se.length&&($e.allPaths=se),$e}function P(ne,me,we){const de=N.sep===N.$hc.sep,$e=de?ne:ne.replace(m,N.sep),ke=N.sep+$e,se=N.$hc.sep+ne;let Pe;return we?Pe=function(re,H){return typeof re=="string"&&(re===$e||re.endsWith(ke)||!de&&(re===ne||re.endsWith(se)))?me:null}:Pe=function(re,H){return typeof re=="string"&&(re===$e||!de&&re===ne)?me:null},Pe.allPaths=[(we?"*/":"./")+ne],Pe}function k(ne){try{const me=new RegExp(`^${r(ne)}$`);return function(we){return me.lastIndex=0,typeof we=="string"&&me.test(we)?ne:null}}catch{return o}}function I(ne,me,we){return!ne||typeof me!="string"?!1:U(ne)(me,void 0,we)}function U(ne,me={}){if(!ne)return d;if(typeof ne=="string"||Q(ne)){const we=f(ne,me);if(we===o)return d;const de=function($e,ke){return!!we($e,ke)};return we.allBasenames&&(de.allBasenames=we.allBasenames),we.allPaths&&(de.allPaths=we.allPaths),de}return R(ne,me)}function Q(ne){const me=ne;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function G(ne){return ne.allBasenames||[]}function L(ne){return ne.allPaths||[]}function R(ne,me){const we=T(Object.getOwnPropertyNames(ne).map(Pe=>F(Pe,ne[Pe],me)).filter(Pe=>Pe!==o)),de=we.length;if(!de)return o;if(!we.some(Pe=>!!Pe.requiresSiblings)){if(de===1)return we[0];const Pe=function(he,Fe){let pe;for(let be=0,ge=we.length;be<ge;be++){const ae=we[be](he,Fe);if(typeof ae=="string")return ae;(0,A.$ih)(ae)&&(pe||(pe=[]),pe.push(ae))}return pe?(async()=>{for(const be of pe){const ge=await be;if(typeof ge=="string")return ge}return null})():null},re=we.find(he=>!!he.allBasenames);re&&(Pe.allBasenames=re.allBasenames);const H=we.reduce((he,Fe)=>Fe.allPaths?he.concat(Fe.allPaths):he,[]);return H.length&&(Pe.allPaths=H),Pe}const $e=function(Pe,re,H){let he,Fe;for(let pe=0,be=we.length;pe<be;pe++){const ge=we[pe];ge.requiresSiblings&&H&&(re||(re=(0,N.$oc)(Pe)),he||(he=re.substr(0,re.length-(0,N.$pc)(Pe).length)));const ae=ge(Pe,re,he,H);if(typeof ae=="string")return ae;(0,A.$ih)(ae)&&(Fe||(Fe=[]),Fe.push(ae))}return Fe?(async()=>{for(const pe of Fe){const be=await pe;if(typeof be=="string")return be}return null})():null},ke=we.find(Pe=>!!Pe.allBasenames);ke&&($e.allBasenames=ke.allBasenames);const se=we.reduce((Pe,re)=>re.allPaths?Pe.concat(re.allPaths):Pe,[]);return se.length&&($e.allPaths=se),$e}function F(ne,me,we){if(me===!1)return o;const de=f(ne,we);if(de===o)return o;if(typeof me=="boolean")return de;if(me){const $e=me.when;if(typeof $e=="string"){const ke=(se,Pe,re,H)=>{if(!H||!de(se,Pe))return null;const he=$e.replace("$(basename)",()=>re),Fe=H(he);return(0,A.$ih)(Fe)?Fe.then(pe=>pe?ne:null):Fe?ne:null};return ke.requiresSiblings=!0,ke}}return de}function T(ne,me){const we=ne.filter(Pe=>!!Pe.basenames);if(we.length<2)return ne;const de=we.reduce((Pe,re)=>{const H=re.basenames;return H?Pe.concat(H):Pe},[]);let $e;if(me){$e=[];for(let Pe=0,re=de.length;Pe<re;Pe++)$e.push(me)}else $e=we.reduce((Pe,re)=>{const H=re.patterns;return H?Pe.concat(H):Pe},[]);const ke=function(Pe,re){if(typeof Pe!="string")return null;if(!re){let he;for(he=Pe.length;he>0;he--){const Fe=Pe.charCodeAt(he-1);if(Fe===47||Fe===92)break}re=Pe.substr(he)}const H=de.indexOf(re);return H!==-1?$e[H]:null};ke.basenames=de,ke.patterns=$e,ke.allBasenames=de;const se=ne.filter(Pe=>!Pe.basenames);return se.push(ke),se}function X(ne,me){return(0,y.$ub)(ne,me,(we,de)=>typeof we=="string"&&typeof de=="string"?we===de:typeof we!="string"&&typeof de!="string"?we.base===de.base&&we.pattern===de.pattern:!1)}}),define(Ce[55],Ae([1,0,14,138,23,13,2]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=E,e.$Vk=M,e.$Wk=S,e.$Xk=m,e.$Yk=w,e.$Zk=g,e.$1k=r,e.$2k=a;var p;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,y.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=m(this.supportThemeIcons?(0,A.$Nk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${w(i,n)}
`,this}appendLink(n,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,i){const c=new RegExp((0,O.$af)(i),"g");return n.replace(c,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Tk=$;function E(s){return M(s)?!s.value:Array.isArray(s)?s.every(E):!0}function M(s){return s instanceof $?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function S(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,C.$3g)(N.URI.from(s.baseUri),N.URI.from(n.baseUri)))}function m(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,n){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${n}`,s,`${"`".repeat(c)}`].join(`
`)}function g(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(s){const n=[],i=s.split("|").map(h=>h.trim());s=i[0];const c=i[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),d=h?h[1]:"",o=t?t[1]:"",f=isFinite(parseInt(o)),u=isFinite(parseInt(d));f&&n.push(`width="${o}"`),u&&n.push(`height="${d}"`)}return{href:s,dimensions:n}}}),define(Ce[93],Ae([1,0,18,48,19,22,23,13]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=$,e.$Fw=M,e.$Gw=m,e.$Hw=w,e.$Iw=s,e.$Jw=i,e.$Kw=c,e.$Lw=h,e.$Mw=t,e.$Nw=d;function $(f,u){const{os:D,tildify:l,relative:v}=u;if(v){const k=E(f,v,D);if(typeof k=="string")return k}let b=f.fsPath;if(D===1&&!O.$c?b=b.replace(/\//g,"\\"):D!==1&&O.$c&&(b=b.replace(/\\/g,"/")),D!==1&&l?.userHome){const k=l.userHome.fsPath;let I;f.scheme!==l.userHome.scheme&&f.path[0]===C.$hc.sep&&f.path[1]!==C.$hc.sep?I=l.userHome.with({path:f.path}).fsPath:I=b,b=m(I,k,D)}return(D===1?C.$gc:C.$hc).normalize(M(b,D===1))}function E(f,u,D){const l=D===1?C.$gc:C.$hc,v=D===3?N.$Zg:N.$2g,b=u.getWorkspace(),P=(0,y.$Ob)(b.folders);if(!P)return;f.scheme!==P.uri.scheme&&f.path[0]===C.$hc.sep&&f.path[1]!==C.$hc.sep&&(f=P.uri.with({path:f.path}));const k=u.getWorkspaceFolder(f);if(!k)return;let I;if(v.isEqual(k.uri,f)?I="":I=v.relativePath(k.uri,f)??"",I&&(I=l.normalize(I)),b.folders.length>1&&!u.noPrefix){const U=k.name?k.name:v.basenameOrAuthority(k.uri);I=I?`${U} \u2022 ${I}`:U}return I}function M(f,u=O.$c){return(0,A.$Ag)(f,u)?f.charAt(0).toUpperCase()+f.slice(1):f}let S=Object.create(null);function m(f,u,D=O.OS){if(D===1||!f||!u)return f;let l=S.original===u?S.normalized:void 0;l||(l=u,O.$c&&(l=(0,A.$pg)(l)),l=`${(0,p.$gf)(l,C.$hc.sep)}${C.$hc.sep}`,S={original:u,normalized:l});let v=f;return O.$c&&(v=(0,A.$pg)(v)),(D===3?v.startsWith(l):(0,p.$zf)(v,l))?`~/${v.substr(l.length)}`:f}function w(f,u){return f.replace(/^~($|\/|\\)/,`${u}$1`)}const g="\u2026",r="\\\\",a="~";function s(f,u=C.sep){const D=new Array(f.length);let l=!1;for(let v=0;v<f.length;v++){const b=f[v];if(b===""){D[v]=`.${u}`;continue}if(!b){D[v]=b;continue}l=!0;let P="",k=b;k.indexOf(r)===0?(P=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(u)===0?(P=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(a)===0&&(P=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length));const I=k.split(u);for(let U=1;l&&U<=I.length;U++)for(let Q=I.length-U;l&&Q>=0;Q--){l=!1;let G=I.slice(Q,Q+U).join(u);for(let L=0;!l&&L<f.length;L++)if(L!==v&&f[L]&&f[L].indexOf(G)>-1){const R=Q+U===I.length,F=Q>0&&f[L].indexOf(u)>-1?u+G:G,T=f[L].endsWith(F);l=!R||T}if(!l){let L="";(I[0].endsWith(":")||P!=="")&&(Q===1&&(Q=0,U++,G=I[0]+u+G),Q>0&&(L=I[0]+u),L=P+L),Q>0&&(L=L+g+u),L=L+G,Q+U<I.length&&(L=L+u+g),D[v]=L}}l&&(D[v]=b)}return D}var n;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(f,u=Object.create(null)){const D=[];let l=!1,v="";for(const b of f)if(b==="$"||l&&b==="{")v&&D.push({value:v,type:n.TEXT}),v="",l=!0;else if(b==="}"&&l){const P=u[v];if(typeof P=="string")P.length&&D.push({value:P,type:n.VARIABLE});else if(P){const k=D[D.length-1];(!k||k.type!==n.SEPARATOR)&&D.push({value:P.label,type:n.SEPARATOR})}v="",l=!1}else v+=b;return v&&!l&&D.push({value:v,type:n.TEXT}),D.filter((b,P)=>{if(b.type===n.SEPARATOR){const k=D[P-1],I=D[P+1];return[k,I].every(U=>U&&(U.type===n.VARIABLE||U.type===n.TEXT)&&U.value.length>0)}return!0}).map(b=>b.value).join("")}function c(f,u){return O.$d||u?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$d?"&":"&&"):f.replace(/&&|&/g,D=>D==="&"?"&&":"&")}function h(f,u){return O.$d||u?f.replace(/\(&&\w\)|&&/g,""):O.$c?f.replace(/&&|&/g,D=>D==="&"?"&&":"&"):f.replace(/&&/g,"_")}function t(f){return f.replace(/&/g,"&&")}function d(f){if(f.endsWith("]")){const u=f.lastIndexOf(" [",f.length-2);if(u!==-1){const D=o(f.substring(0,u)),l=f.substring(u);return{name:D.name+l,parentPath:D.parentPath}}}return o(f)}function o(f){const u=f.indexOf("/")!==-1?C.$hc:C.$gc,D=u.basename(f),l=u.dirname(f);return D.length?{name:D,parentPath:l}:{name:l,parentPath:""}}}),define(Ce[139],Ae([1,0,21,2]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=void 0,e.$Bn=p,e.$Cn=E,e.$Dn=M;function C(S){return S.toJSON()}class O{constructor(m){this.a=m}transformIncoming(m){const w=this.a.transformIncoming(m);return w===m?m:C(A.URI.from(w))}transformOutgoing(m){const w=this.a.transformOutgoing(m);return w===m?m:C(A.URI.from(w))}transformOutgoingURI(m){const w=this.a.transformOutgoing(m);return w===m?m:A.URI.from(w)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$zn=O,e.$An=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function N(S,m,w){if(!S||w>200)return null;if(typeof S=="object"){if(S instanceof A.URI)return m.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const r=N(S[g],m,w+1);r!==null&&(S[g]=r)}}return null}function p(S,m){const w=N(S,m,0);return w===null?S:w}function $(S,m,w,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return w?A.URI.revive(m.transformIncoming(S)):m.transformIncoming(S);if(S instanceof y.$Ge)return null;for(const r in S)if(Object.hasOwnProperty.call(S,r)){const a=$(S[r],m,w,g+1);a!==null&&(S[r]=a)}}return null}function E(S,m){const w=$(S,m,!1,0);return w===null?S:w}function M(S,m){const w=$(S,m,!0,0);return w===null?S:w}}),define(Ce[34],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=A;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(C){return y.test(C)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),N=[];for(let p=0;p<256;p++)N.push(p.toString(16).padStart(2,"0"));return function(){C(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,E="";return E+=N[O[$++]],E+=N[O[$++]],E+=N[O[$++]],E+=N[O[$++]],E+="-",E+=N[O[$++]],E+=N[O[$++]],E+="-",E+=N[O[$++]],E+=N[O[$++]],E+="-",E+=N[O[$++]],E+=N[O[$++]],E+="-",E+=N[O[$++]],E+=N[O[$++]],E+=N[O[$++]],E+=N[O[$++]],E+=N[O[$++]],E+=N[O[$++]],E}}()}),define(Ce[140],Ae([1,0,18,42,34]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.$Tt=void 0,e.$Rt=O,e.$St=N,e.$Ut=E;function O(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function N(S,m,w){const g={id:(0,C.$Sg)(),name:S,uri:m,data:w};return{asString:async()=>"",asFile:()=>g,value:void 0}}class p{constructor(){this.a=new Map}get size(){let m=0;for(const w of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const w=[...this.a.keys()];return A.Iterable.some(this,([g,r])=>r.asFile())&&w.push("files"),M($(m),w)}get(m){return this.a.get(this.b(m))?.[0]}append(m,w){const g=this.a.get(m);g?g.push(w):this.a.set(this.b(m),[w])}replace(m,w){this.a.set(this.b(m),[w])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,w]of this.a)for(const g of w)yield[m,g]}b(m){return $(m)}}e.$Tt=p;function $(S){return S.toLowerCase()}function E(S,m){return M($(S),m.map($))}function M(S,m){if(S==="*/*")return m.length>0;if(m.includes(S))return!0;const w=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[g,r,a]=w;return a==="*"?m.some(s=>s.startsWith(r+"/")):!1}e.$Vt=Object.freeze({create:S=>(0,y.$Mb)(S.map(m=>m.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Vt.split(S).filter(m=>!m.startsWith("#"))})}),define(Ce[141],Ae([1,0,9,5,6,49,15]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.StorageState=e.StorageHint=void 0,e.$Wp=$;var p;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(m){const w=m;return w?.changed instanceof Map||w?.deleted instanceof Set}var E;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(E||(e.StorageState=E={}));class M extends C.$Vc{constructor(w,g=Object.create(null)){super(),this.r=w,this.s=g,this.b=this.B(new A.$he),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new y.$uh(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((g,r)=>this.w(r,g)),w.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(w,g){if(this.c===E.Closed)return;let r=!1;(0,N.$fg)(g)?r=this.f.delete(w):this.f.get(w)!==g&&(this.f.set(w,g),r=!0),r&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,g){const r=this.f.get(w);return(0,N.$fg)(r)?g:r}getBoolean(w,g){const r=this.get(w);return(0,N.$fg)(r)?g:r==="true"}getNumber(w,g){const r=this.get(w);return(0,N.$fg)(r)?g:parseInt(r,10)}getObject(w,g){const r=this.get(w);return(0,N.$fg)(r)?g:(0,O.$5h)(r)}async set(w,g,r=!1){if(this.c===E.Closed)return;if((0,N.$fg)(g))return this.delete(w,r);const a=(0,N.$$f)(g)||Array.isArray(g)?(0,O.$4h)(g):String(g);if(this.f.get(w)!==a)return this.f.set(w,a),this.j.set(w,a),this.h.delete(w),this.b.fire({key:w,external:r}),this.D()}async delete(w,g=!1){if(!(this.c===E.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:g}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(this.z)return this.D(w)}async D(w){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Xp=M,M.a=100;class S{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((g,r)=>this.a.set(r,g)),w.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Yp=S}),define(Ce[142],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$2t=A;var y;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function A(C){let O=0,N=0,p=0,$=0;for(let E=0,M=C.length;E<M;E++){const S=C.charCodeAt(E);S===13?(O===0&&(N=E),O++,E+1<M&&C.charCodeAt(E+1)===10?($|=2,E++):$|=3,p=E+1):S===10&&($|=1,O===0&&(N=E),O++,p=E+1)}return O===0&&(N=C.length),[O,N,C.length-p,$]}}),define(Ce[143],Ae([1,0,13,22,21]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Et=M,e.$Ft=S;let O;function N(){return O||(O=new TextDecoder("UTF-16LE")),O}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let E;function M(){return E||(E=A.$x()?N():$()),E}function S(g,r,a){const s=new Uint16Array(g.buffer,r,a);return a>0&&(s[0]===65279||s[0]===65534)?m(g,r,a):N().decode(s)}function m(g,r,a){const s=[];let n=0;for(let i=0;i<a;i++){const c=C.$Ie(g,r);r+=2,s[n++]=String.fromCharCode(c)}return s.join("")}class w{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return M().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const a=this.a-this.d;a<=1&&(a===0||y.$Cf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const a=r.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<a;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$Gt=w}),define(Ce[144],Ae([1,0,21,143]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0,e.$It=N;function C($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,M,S,m){this.oldPosition=E,this.oldText=M,this.newPosition=S,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,M,S){const m=M.length;y.$Le(E,m,S),S+=4;for(let w=0;w<m;w++)y.$Je(E,M.charCodeAt(w),S),S+=2;return S}static d(E,M){const S=y.$Ke(E,M);return M+=4,(0,A.$Ft)(E,M,S)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(E,M){return y.$Le(E,this.oldPosition,M),M+=4,y.$Le(E,this.newPosition,M),M+=4,M=O.c(E,this.oldText,M),M=O.c(E,this.newText,M),M}static read(E,M,S){const m=y.$Ke(E,M);M+=4;const w=y.$Ke(E,M);M+=4;const g=O.d(E,M);M+=O.a(g);const r=O.d(E,M);return M+=O.a(r),S.push(new O(m,g,w,r)),M}}e.$Ht=O;function N($,E){return $===null||$.length===0?E:new p($,E).compress()}class p{constructor(E,M){this.a=E,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,M=0,S=this.n(E),m=this.l(M);for(;E<this.f||M<this.h;){if(S===null){this.k(m),m=this.l(++M);continue}if(m===null){this.m(S),S=this.n(++E);continue}if(m.oldEnd<=S.newPosition){this.k(m),m=this.l(++M);continue}if(S.newEnd<=m.oldPosition){this.m(S),S=this.n(++E);continue}if(m.oldPosition<S.newPosition){const[s,n]=p.r(m,S.newPosition-m.oldPosition);this.k(s),m=n;continue}if(S.newPosition<m.oldPosition){const[s,n]=p.q(S,m.oldPosition-S.newPosition);this.m(s),S=n;continue}let r,a;if(m.oldEnd===S.newEnd)r=S,a=m,S=this.n(++E),m=this.l(++M);else if(m.oldEnd<S.newEnd){const[s,n]=p.q(S,m.oldLength);r=s,a=m,S=n,m=this.l(++M)}else{const[s,n]=p.r(m,S.newLength);r=S,a=s,S=this.n(++E),m=n}this.d[this.e++]=new O(r.oldPosition,r.oldText,a.newPosition,a.newText),this.g+=r.newLength-r.oldLength,this.j+=a.newLength-a.oldLength}const w=p.s(this.d);return p.t(w)}k(E){this.d[this.e++]=p.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=p.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,M){return new O(M.oldPosition-E,M.oldText,M.newPosition,M.newText)}static p(E,M){return new O(M.oldPosition,M.oldText,M.newPosition+E,M.newText)}static q(E,M){const S=E.newText.substr(0,M),m=E.newText.substr(M);return[new O(E.oldPosition,E.oldText,E.newPosition,S),new O(E.oldEnd,"",E.newPosition+M,m)]}static r(E,M){const S=E.oldText.substr(0,M),m=E.oldText.substr(M);return[new O(E.oldPosition,S,E.newPosition,E.newText),new O(E.oldPosition+M,m,E.newEnd,"")]}static s(E){if(E.length===0)return E;const M=[];let S=0,m=E[0];for(let w=1;w<E.length;w++){const g=E[w];m.oldEnd===g.oldPosition?m=new O(m.oldPosition,m.oldText+g.oldText,m.newPosition,m.newText+g.newText):(M[S++]=m,m=g)}return M[S++]=m,M}static t(E){if(E.length===0)return E;const M=[];let S=0;for(let m=0;m<E.length;m++){const w=E[m];w.oldText!==w.newText&&(M[S++]=w)}return M}}}),define(Ce[145],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$5s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[146],Ae([1,0,37,19]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yt=C,e.$Zt=O;function C(N,p,$,E,M,S){if(Array.isArray(N)){let m=0;for(const w of N){const g=C(w,p,$,E,M,S);if(g===10)return g;g>m&&(m=g)}return m}else{if(typeof N=="string")return E?N==="*"?5:N===$?10:0:0;if(N){const{language:m,pattern:w,scheme:g,hasAccessToAllModels:r,notebookType:a}=N;if(!E&&!r)return 0;a&&M&&(p=M);let s=0;if(g)if(g===p.scheme)s=10;else if(g==="*")s=5;else return 0;if(m)if(m===$)s=10;else if(m==="*")s=Math.max(s,5);else return 0;if(a)if(a===S)s=10;else if(a==="*"&&S!==void 0)s=Math.max(s,5);else return 0;if(w){let n;if(typeof w=="string"?n=w:n={...w,base:(0,A.$ic)(w.base)},n===p.fsPath||(0,y.$pk)(n,p.fsPath))s=10;else return 0}return s}else return 0}}function O(N){return typeof N=="string"?!1:Array.isArray(N)?N.some(O):!!N.notebookType}}),define(Ce[147],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=e.$lu=e.IndentAction=void 0;var y;(function(N){N[N.None=0]="None",N[N.Indent=1]="Indent",N[N.IndentOutdent=2]="IndentOutdent",N[N.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class A{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,E=p.notIn.length;$<E;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const E=p.findTokenIndexAtOffset($-2),M=p.getStandardTokenType(E);return this.isOK(M)}g(p,$){for(let E=p;E<=$;E++){const M=String.fromCharCode(E);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$lu=A;class C{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)O(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),O(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),O(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),O(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&O(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$mu=C;function O(N,p,$){N.has(p)?N.get(p).push($):N.set(p,[$])}}),define(Ce[148],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.NodeColor=e.$GC=void 0,e.$IC=C,e.$JC=O,e.$KC=E,e.$LC=M,e.$MC=S,e.$NC=m,e.$OC=w,e.$PC=g;class y{constructor(a,s){this.piece=a,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$HC)return C(this.right);let a=this;for(;a.parent!==e.$HC&&a.parent.left!==a;)a=a.parent;return a.parent===e.$HC?e.$HC:a.parent}prev(){if(this.left!==e.$HC)return O(this.left);let a=this;for(;a.parent!==e.$HC&&a.parent.right!==a;)a=a.parent;return a.parent===e.$HC?e.$HC:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$GC=y;var A;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(A||(e.NodeColor=A={})),e.$HC=new y(null,0),e.$HC.parent=e.$HC,e.$HC.left=e.$HC,e.$HC.right=e.$HC,e.$HC.color=0;function C(r){for(;r.left!==e.$HC;)r=r.left;return r}function O(r){for(;r.right!==e.$HC;)r=r.right;return r}function N(r){return r===e.$HC?0:r.size_left+r.piece.length+N(r.right)}function p(r){return r===e.$HC?0:r.lf_left+r.piece.lineFeedCnt+p(r.right)}function $(){e.$HC.parent=e.$HC}function E(r,a){const s=a.right;s.size_left+=a.size_left+(a.piece?a.piece.length:0),s.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=s.left,s.left!==e.$HC&&(s.left.parent=a),s.parent=a.parent,a.parent===e.$HC?r.root=s:a.parent.left===a?a.parent.left=s:a.parent.right=s,s.left=a,a.parent=s}function M(r,a){const s=a.left;a.left=s.right,s.right!==e.$HC&&(s.right.parent=a),s.parent=a.parent,a.size_left-=s.size_left+(s.piece?s.piece.length:0),a.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),a.parent===e.$HC?r.root=s:a===a.parent.right?a.parent.right=s:a.parent.left=s,s.right=a,a.parent=s}function S(r,a){let s,n;if(a.left===e.$HC?(n=a,s=n.right):a.right===e.$HC?(n=a,s=n.left):(n=C(a.right),s=n.right),n===r.root){r.root=s,s.color=0,a.detach(),$(),r.root.parent=e.$HC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===a?(s.parent=n.parent,g(r,s)):(n.parent===a?s.parent=n:s.parent=n.parent,g(r,s),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===r.root?r.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$HC&&(n.left.parent=n),n.right!==e.$HC&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,g(r,n)),a.detach(),s.parent.left===s){const h=N(s),t=p(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const d=h-s.parent.size_left,o=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,w(r,s.parent,d,o)}}if(g(r,s.parent),i){$();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,E(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,M(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,E(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,M(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,M(r,s.parent),s=r.root));s.color=0,$()}function m(r,a){for(g(r,a);a!==r.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const s=a.parent.parent.right;s.color===1?(a.parent.color=0,s.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,E(r,a)),a.parent.color=0,a.parent.parent.color=1,M(r,a.parent.parent))}else{const s=a.parent.parent.left;s.color===1?(a.parent.color=0,s.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,M(r,a)),a.parent.color=0,a.parent.parent.color=1,E(r,a.parent.parent))}r.root.color=0}function w(r,a,s,n){for(;a!==r.root&&a!==e.$HC;)a.parent.left===a&&(a.parent.size_left+=s,a.parent.lf_left+=n),a=a.parent}function g(r,a){let s=0,n=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,s=N(a.left)-a.size_left,n=p(a.left)-a.lf_left,a.size_left+=s,a.lf_left+=n;a!==r.root&&(s!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=s,a.parent.lf_left+=n),a=a.parent}}}),define(Ce[94],Ae([1,0,95,30,96,148,97]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=void 0,e.$WC=M,e.$XC=S;const p=65535;function $(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class E{constructor(n,i,c,h,t){this.lineStarts=n,this.cr=i,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function M(s,n=!0){const i=[0];let c=1;for(let h=0,t=s.length;h<t;h++){const d=s.charCodeAt(h);d===13?h+1<t&&s.charCodeAt(h+1)===10?(i[c++]=h+2,h++):i[c++]=h+1:d===10&&(i[c++]=h+1)}return n?$(i):i}function S(s,n){s.length=0,s[0]=0;let i=1,c=0,h=0,t=0,d=!0;for(let f=0,u=n.length;f<u;f++){const D=n.charCodeAt(f);D===13?f+1<u&&n.charCodeAt(f+1)===10?(t++,s[i++]=f+2,f++):(c++,s[i++]=f+1):D===10?(h++,s[i++]=f+1):d&&D!==9&&(D<32||D>126)&&(d=!1)}const o=new E($(s),c,h,t,d);return s.length=0,o}class m{constructor(n,i,c,h,t){this.bufferIndex=n,this.start=i,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$YC=m;class w{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$ZC=w;class g{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==O.$HC&&n.iterate(n.root,c=>(c!==O.$HC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=n){c[h]=null,i=!0;continue}}if(i){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class a{constructor(n,i,c){this.create(n,i,c)}create(n,i,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=O.$HC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let h=null;for(let t=0,d=n.length;t<d;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=M(n[t].buffer));const o=new m(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,o)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=p,c=i-Math.floor(i/3),h=c*2;let t="",d=0;const o=[];if(this.iterate(this.root,f=>{const u=this.R(f),D=u.length;if(d<=c||d+D<h)return t+=u,d+=D,!0;const l=t.replace(/\r\n|\r|\n/g,n);return o.push(new w(l,M(l))),t=u,d=D,!0}),d>0){const f=t.replace(/\r\n|\r|\n/g,n);o.push(new w(f,M(f)))}this.create(o,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new g(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===O.$HC)return!0;const t=this.R(h),d=t.length,o=n.G(i),f=n.G(i+d),u=n.getValueInRange2(o,f);return i+=d,t===u})}getOffsetAt(n,i){let c=0,h=this.root;for(;h!==O.$HC;)if(h.left!==O.$HC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const t=this.B(h,n-h.lf_left-2);return c+=t+i-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,c=0;const h=n;for(;i!==O.$HC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const d=this.getOffsetAt(c+1,1),o=h-d;return new y.$ut(c+1,o+1)}return new y.$ut(c+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===O.$HC){const t=this.getOffsetAt(c+1,1),d=h-n-t;return new y.$ut(c+1,d+1)}else i=i.right;return new y.$ut(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const o=n.node,f=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);return f.substring(u+n.remainder,u+i.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let d=h.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==O.$HC;){const o=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){d+=o.substring(f,f+i.remainder);break}else d+=o.substr(f,c.piece.length);c=c.next()}return d}getLinesContent(){const n=[];let i=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===O.$HC)return!0;const d=t.piece;let o=d.length;if(o===0)return!0;const f=this.a[d.bufferIndex].buffer,u=this.a[d.bufferIndex].lineStarts,D=d.start.line,l=d.end.line;let v=u[D]+d.start.column;if(h&&(f.charCodeAt(v)===10&&(v++,o--),n[i++]=c,c="",h=!1,o===0))return!0;if(D===l)return!this.f&&f.charCodeAt(v+o-1)===13?(h=!0,c+=f.substr(v,o-1)):c+=f.substr(v,o),!0;c+=this.f?f.substring(v,Math.max(v,u[D+1]-this.e)):f.substring(v,u[D+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;for(let b=D+1;b<l;b++)c=this.f?f.substring(u[b],u[b+1]-this.e):f.substring(u[b],u[b+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;return!this.f&&f.charCodeAt(u[l]+d.end.column-1)===13?(h=!0,d.end.column===0?i--:c=f.substr(u[l],d.end.column-1)):c=f.substr(u[l],d.end.column),!0}),h&&(n[i++]=c,c=""),n[i++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(h)}else{const i=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(n,i){const c=this.H(n,i+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,c,h,t,d,o,f,u,D,l){const v=this.a[n.piece.bufferIndex],b=this.u(n.piece.bufferIndex,n.piece.start),P=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,d);let I;const U={line:0,column:0};let Q,G;i._wordSeparators?(Q=v.buffer.substring(P,k),G=L=>L+P,i.reset(0)):(Q=v.buffer,G=L=>L,i.reset(P));do if(I=i.next(Q),I){if(G(I.index)>=k)return D;this.s(n,G(I.index)-b,U);const L=this.t(n.piece.bufferIndex,t,U),R=U.line===t.line?U.column-t.column+h:U.column+1,F=R+I[0].length;if(l[D++]=(0,N.$SC)(new A.$vt(c+L,R,c+L,F),I,f),G(I.index)+I[0].length>=k||D>=u)return D}while(I);return D}findMatchesLineByLine(n,i,c,h){const t=[];let d=0;const o=new N.$VC(i.wordSeparators,i.regex);let f=this.H(n.startLineNumber,n.startColumn);if(f===null)return[];const u=this.H(n.endLineNumber,n.endColumn);if(u===null)return[];let D=this.s(f.node,f.remainder);const l=this.s(u.node,u.remainder);if(f.node===u.node)return this.findMatchesInNode(f.node,o,n.startLineNumber,n.startColumn,D,l,i,c,h,d,t),t;let v=n.startLineNumber,b=f.node;for(;b!==u.node;){const k=this.t(b.piece.bufferIndex,D,b.piece.end);if(k>=1){const U=this.a[b.piece.bufferIndex].lineStarts,Q=this.u(b.piece.bufferIndex,b.piece.start),G=U[D.line+k],L=v===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(b,o,v,L,D,this.s(b,G-Q),i,c,h,d,t),d>=h)return t;v+=k}const I=v===n.startLineNumber?n.startColumn-1:0;if(v===n.endLineNumber){const U=this.getLineContent(v).substring(I,n.endColumn-1);return d=this.n(i,o,U,n.endLineNumber,I,d,t,c,h),t}if(d=this.n(i,o,this.getLineContent(v).substr(I),v,I,d,t,c,h),d>=h)return t;v++,f=this.H(v,1),b=f.node,D=this.s(f.node,f.remainder)}if(v===n.endLineNumber){const k=v===n.startLineNumber?n.startColumn-1:0,I=this.getLineContent(v).substring(k,n.endColumn-1);return d=this.n(i,o,I,n.endLineNumber,k,d,t,c,h),t}const P=v===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(u.node,o,v,P,D,l,i,c,h,d,t),t}n(n,i,c,h,t,d,o,f,u){const D=n.wordSeparators;if(!f&&n.simpleSearch){const v=n.simpleSearch,b=v.length,P=c.length;let k=-b;for(;(k=c.indexOf(v,k+b))!==-1;)if((!D||(0,N.$UC)(D,c,P,k,b))&&(o[d++]=new C.$Gv(new A.$vt(h,k+1+t,h,k+1+b+t),null),d>=u))return d;return d}let l;i.reset(0);do if(l=i.next(c),l&&(o[d++]=(0,N.$SC)(new A.$vt(h,l.index+1+t,h,l.index+1+l[0].length+t),l,f),d>=u))return d;while(l);return d}insert(n,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$HC){const{node:h,remainder:t,nodeStartOffset:d}=this.G(n),o=h.piece,f=o.bufferIndex,u=this.s(h,t);if(h.piece.bufferIndex===0&&o.end.line===this.g.line&&o.end.column===this.g.column&&d+o.length===n&&i.length<p){this.F(h,i),this.y();return}if(d===n)this.o(i,h),this.h.validate(n);else if(d+h.piece.length>n){const D=[];let l=new m(o.bufferIndex,u,o.end,this.t(o.bufferIndex,u,o.end),this.u(f,o.end)-this.u(f,u));if(this.K()&&this.M(i)&&this.I(h,t)===10){const k={line:l.start.line+1,column:0};l=new m(l.bufferIndex,k,l.end,this.t(l.bufferIndex,k,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const k=this.s(h,t-1);this.C(h,k),i="\r"+i,h.piece.length===0&&D.push(h)}else this.C(h,u);else this.C(h,u);const v=this.w(i);l.length>0&&this.S(h,l);let b=h;for(let P=0;P<v.length;P++)b=this.S(b,v[P]);this.v(D)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let d=1;d<h.length;d++)t=this.S(t,h[d])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===O.$HC)return;const c=this.G(n),h=this.G(n+i),t=c.node,d=h.node;if(t===d){const v=this.s(t,c.remainder),b=this.s(t,h.remainder);if(c.nodeStartOffset===n){if(i===t.piece.length){const P=t.next();(0,O.$MC)(this,t),this.N(P),this.y();return}this.D(t,b),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+i){this.C(t,v),this.O(t),this.y();return}this.E(t,v,b),this.y();return}const o=[],f=this.s(t,c.remainder);this.C(t,f),this.h.validate(n),t.piece.length===0&&o.push(t);const u=this.s(d,h.remainder);this.D(d,u),d.piece.length===0&&o.push(d);const D=t.next();for(let v=D;v!==O.$HC&&v!==d;v=v.next())o.push(v);const l=t.piece.length===0?t.prev():t;this.v(o),this.O(l),this.y()}o(n,i){const c=[];if(this.K()&&this.M(n)&&this.L(i)){const d=i.piece,o={line:d.start.line+1,column:0},f=new m(d.bufferIndex,o,d.end,this.t(d.bufferIndex,o,d.end),d.length-1);i.piece=f,n+=`
`,(0,O.$OC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const h=this.w(n);let t=this.T(i,h[h.length-1]);for(let d=h.length-2;d>=0;d--)t=this.T(t,h[d]);this.N(t),this.v(c)}q(n,i){this.Q(n,i)&&(n+=`
`);const c=this.w(n),h=this.S(i,c[0]);let t=h;for(let d=1;d<c.length;d++)t=this.S(t,c[d]);this.N(h)}s(n,i,c){const h=n.piece,t=n.piece.bufferIndex,d=this.a[t].lineStarts,f=d[h.start.line]+h.start.column+i;let u=h.start.line,D=h.end.line,l=0,v=0,b=0;for(;u<=D&&(l=u+(D-u)/2|0,b=d[l],l!==D);)if(v=d[l+1],f<b)D=l-1;else if(f>=v)u=l+1;else break;return c?(c.line=l,c.column=f-b,null):{line:l,column:f-b}}t(n,i,c){if(c.column===0)return c.line-i.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-i.line;const t=h[c.line+1],d=h[c.line]+c.column;if(t>d+1)return c.line-i.line;const o=d-1;return this.a[n].buffer.charCodeAt(o)===13?c.line-i.line+1:c.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,O.$MC)(this,n[i])}w(n){if(n.length>p){const D=[];for(;n.length>p;){const v=n.charCodeAt(p-1);let b;v===13||v>=55296&&v<=56319?(b=n.substring(0,p-1),n=n.substring(p-1)):(b=n.substring(0,p),n=n.substring(p));const P=M(b);D.push(new m(this.a.length,{line:0,column:0},{line:P.length-1,column:b.length-P[P.length-1]},P.length-1,b.length)),this.a.push(new w(b,P))}const l=M(n);return D.push(new m(this.a.length,{line:0,column:0},{line:l.length-1,column:n.length-l[l.length-1]},l.length-1,n.length)),this.a.push(new w(n,l)),D}let i=this.a[0].buffer.length;const c=M(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let D=0;D<c.length;D++)c[D]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let D=0;D<c.length;D++)c[D]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,o=t-this.a[0].lineStarts[d],f={line:d,column:o},u=new m(0,h,f,this.t(0,h,f),t-i);return this.g=f,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let c=this.root,h="";const t=this.h.get2(n);if(t){c=t.node;const d=this.B(c,n-t.nodeStartLineNumber-1),o=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=o.substring(f+d,f+c.piece.length);else{const u=this.B(c,n-t.nodeStartLineNumber);return o.substring(f+d,f+u-i)}}else{let d=0;const o=n;for(;c!==O.$HC;)if(c.left!==O.$HC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const f=this.B(c,n-c.lf_left-2),u=this.B(c,n-c.lf_left-1),D=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);return d+=c.size_left,this.h.set({node:c,nodeStartOffset:d,nodeStartLineNumber:o-(n-1-c.lf_left)}),D.substring(l+f,l+u-i)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const f=this.B(c,n-c.lf_left-2),u=this.a[c.piece.bufferIndex].buffer,D=this.u(c.piece.bufferIndex,c.piece.start);h=u.substring(D+f,D+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$HC;){const d=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const o=this.B(c,0),f=this.u(c.piece.bufferIndex,c.piece.start);return h+=d.substring(f,f+o-i),h}else{const o=this.u(c.piece.bufferIndex,c.piece.start);h+=d.substr(o,c.piece.length)}c=c.next()}return h}y(){let n=this.root,i=1,c=0;for(;n!==O.$HC;)i+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=c,this.h.validate(this.c)}A(n,i){const c=n.piece,h=this.s(n,i),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const d=this.t(n.piece.bufferIndex,c.start,h);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:h.column}}B(n,i){if(i<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(n,i){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),d=i,o=this.u(c.bufferIndex,d),f=this.t(c.bufferIndex,c.start,d),u=f-h,D=o-t,l=c.length+D;n.piece=new m(c.bufferIndex,c.start,d,f,l),(0,O.$OC)(this,n,D,u)}D(n,i){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),d=i,o=this.t(c.bufferIndex,d,c.end),f=this.u(c.bufferIndex,d),u=o-h,D=t-f,l=c.length+D;n.piece=new m(c.bufferIndex,d,c.end,o,l),(0,O.$OC)(this,n,D,u)}E(n,i,c){const h=n.piece,t=h.start,d=h.end,o=h.length,f=h.lineFeedCnt,u=i,D=this.t(h.bufferIndex,h.start,u),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);n.piece=new m(h.bufferIndex,h.start,u,D,l),(0,O.$OC)(this,n,l-o,D-f);const v=new m(h.bufferIndex,c,d,this.t(h.bufferIndex,c,d),this.u(h.bufferIndex,d)-this.u(h.bufferIndex,c)),b=this.S(n,v);this.N(b)}F(n,i){this.Q(i,n)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=M(i,!1);for(let b=0;b<t.length;b++)t[b]+=h;if(c){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,o=this.a[0].buffer.length-this.a[0].lineStarts[d],f={line:d,column:o},u=n.piece.length+i.length,D=n.piece.lineFeedCnt,l=this.t(0,n.piece.start,f),v=l-D;n.piece=new m(n.piece.bufferIndex,n.piece.start,f,l,u),this.g=f,(0,O.$OC)(this,n,i.length,v)}G(n){let i=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;i!==O.$HC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){h+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let c=this.root,h=0;for(;c!==O.$HC;)if(c.left!==O.$HC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),d=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+i-1,d),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:h};i-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$HC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),d=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:d}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+i;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===O.$HC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,c=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=c[h]+i.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===O.$HC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,o=n.piece.lineFeedCnt-1;n.piece=new m(n.piece.bufferIndex,n.piece.start,t,o,d),(0,O.$OC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const f={line:i.piece.start.line+1,column:0},u=i.piece.length-1,D=this.t(i.piece.bufferIndex,f,i.piece.end);i.piece=new m(i.piece.bufferIndex,f,i.piece.end,D,u),(0,O.$OC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const l=this.w(`\r
`);this.S(n,l[0]);for(let v=0;v<c.length;v++)(0,O.$MC)(this,c[v])}Q(n,i){if(this.K()&&this.M(n)){const c=i.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,O.$MC)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},d=h.length-1,o=this.t(h.bufferIndex,t,h.end);c.piece=new m(h.bufferIndex,t,h.end,o,d),(0,O.$OC)(this,c,-1,-1)}return!0}}return!1}iterate(n,i){if(n===O.$HC)return i(O.$HC);const c=this.iterate(n.left,i);return c&&i(n)&&this.iterate(n.right,i)}R(n){if(n===O.$HC)return"";const i=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(h,t)}getPieceContent(n){const i=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return i.buffer.substring(c,h)}S(n,i){const c=new O.$GC(i,1);if(c.left=O.$HC,c.right=O.$HC,c.parent=O.$HC,c.size_left=0,c.lf_left=0,this.root===O.$HC)this.root=c,c.color=0;else if(n.right===O.$HC)n.right=c,c.parent=n;else{const t=(0,O.$IC)(n.right);t.left=c,c.parent=t}return(0,O.$NC)(this,c),c}T(n,i){const c=new O.$GC(i,1);if(c.left=O.$HC,c.right=O.$HC,c.parent=O.$HC,c.size_left=0,c.lf_left=0,this.root===O.$HC)this.root=c,c.color=0;else if(n.left===O.$HC)n.left=c,c.parent=n;else{const h=(0,O.$JC)(n.left);h.right=c,c.parent=h}return(0,O.$NC)(this,c),c}U(n){let i="";return this.iterate(n,c=>(i+=this.R(c),!0)),i}}e.$1C=a}),define(Ce[149],Ae([1,0,5,13,30,96,94,142,144,6]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class M extends E.$Vc{constructor(m,w,g,r,a,s,n){super(),this.m=this.B(new y.$ee),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=r,this.h=a,this.c=new N.$1C(m,g,n)}equals(m){return!(m instanceof M)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,w){return this.c.getOffsetAt(m,w)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,w){const g=m+w,r=this.getPositionAt(m),a=this.getPositionAt(g);return new C.$vt(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(m,w=0){if(m.isEmpty())return"";const g=this.n(w);return this.c.getValueInRange(m,g)}getValueLengthInRange(m,w=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const g=this.getOffsetAt(m.startLineNumber,m.startColumn),r=this.getOffsetAt(m.endLineNumber,m.endColumn);let a=0;const s=this.n(w),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,c=m.endLineNumber-m.startLineNumber;a=i*c}return r-g+a}getCharacterCountInRange(m,w=0){if(this.j){let g=0;const r=m.startLineNumber,a=m.endLineNumber;for(let s=r;s<=a;s++){const n=this.getLineContent(s),i=s===r?m.startColumn-1:0,c=s===a?m.endColumn-1:n.length;for(let h=i;h<c;h++)A.$Cf(n.charCodeAt(h))?(g=g+1,h=h+1):g=g+1}return g+=this.n(w).length*(a-r),g}return this.getValueLengthInRange(m,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,w){return this.c.getLineCharCode(m,w)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const w=A.$nf(this.getLineContent(m));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(m){const w=A.$pf(this.getLineContent(m));return w===-1?0:w+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,w,g){let r=this.g,a=this.h,s=this.j,n=!0,i=[];for(let u=0;u<m.length;u++){const D=m[u];n&&D._isTracked&&(n=!1);const l=D.range;if(D.text){let I=!0;s||(I=!A.$Nf(D.text),s=I),!r&&I&&(r=A.$Mf(D.text)),!a&&I&&(a=A.$Pf(D.text))}let v="",b=0,P=0,k=0;if(D.text){let I;[b,P,k,I]=(0,p.$2t)(D.text);const U=this.getEOL();I===0||I===(U===`\r
`?2:1)?v=D.text:v=D.text.replace(/\r\n|\r|\n/g,U)}i[u]={sortIndex:u,identifier:D.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:v,eolCount:b,firstLineLength:P,lastLineLength:k,forceMoveMarkers:!!D.forceMoveMarkers,isAutoWhitespaceEdit:D.isAutoWhitespaceEdit||!1}}i.sort(M.u);let c=!1;for(let u=0,D=i.length-1;u<D;u++){const l=i[u].range.getEndPosition(),v=i[u+1].range.getStartPosition();if(v.isBeforeOrEqual(l)){if(v.isBefore(l))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(i=this.s(i));const h=g||w?M._getInverseEditRanges(i):[],t=[];if(w)for(let u=0;u<i.length;u++){const D=i[u],l=h[u];if(D.isAutoWhitespaceEdit&&D.range.isEmpty())for(let v=l.startLineNumber;v<=l.endLineNumber;v++){let b="";v===l.startLineNumber&&(b=this.getLineContent(D.range.startLineNumber),A.$nf(b)!==-1)||t.push({lineNumber:v,oldContent:b})}}let d=null;if(g){let u=0;d=[];for(let D=0;D<i.length;D++){const l=i[D],v=h[D],b=this.getValueInRange(l.range),P=l.rangeOffset+u;u+=l.text.length-b.length,d[D]={sortIndex:l.sortIndex,identifier:l.identifier,range:v,text:b,textChange:new $.$Ht(l.rangeOffset,b,P,l.text)}}c||d.sort((D,l)=>D.sortIndex-l.sortIndex)}this.g=r,this.h=a,this.j=s;const o=this.t(i);let f=null;if(w&&t.length>0){t.sort((u,D)=>D.lineNumber-u.lineNumber),f=[];for(let u=0,D=t.length;u<D;u++){const l=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===l)continue;const v=t[u].oldContent,b=this.getLineContent(l);b.length===0||b===v||A.$nf(b)!==-1||f.push(l)}}return this.m.fire(),new O.$Kv(d,o,f)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let w=!1;const g=m[0].range,r=m[m.length-1].range,a=new C.$vt(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let s=g.startLineNumber,n=g.startColumn;const i=[];for(let o=0,f=m.length;o<f;o++){const u=m[o],D=u.range;w=w||u.forceMoveMarkers,i.push(this.getValueInRange(new C.$vt(s,n,D.startLineNumber,D.startColumn))),u.text.length>0&&i.push(u.text),s=D.endLineNumber,n=D.endColumn}const c=i.join(""),[h,t,d]=(0,p.$2t)(c);return{sortIndex:0,identifier:m[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:d,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(m){m.sort(M.w);const w=[];for(let g=0;g<m.length;g++){const r=m[g],a=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(a===n&&s===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new C.$vt(a,s,n,i);w.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return w}findMatchesLineByLine(m,w,g,r){return this.c.findMatchesLineByLine(m,w,g,r)}getPieceTree(){return this.c}static _getInverseEditRange(m,w){const g=m.startLineNumber,r=m.startColumn,[a,s,n]=(0,p.$2t)(w);let i;if(w.length>0){const c=a+1;c===1?i=new C.$vt(g,r,g,r+s):i=new C.$vt(g,r,g+c-1,n+1)}else i=new C.$vt(g,r,g,r);return i}static _getInverseEditRanges(m){const w=[];let g=0,r=0,a=null;for(let s=0,n=m.length;s<n;s++){const i=m[s];let c,h;a?a.range.endLineNumber===i.range.startLineNumber?(c=g,h=r+(i.range.startColumn-a.range.endColumn)):(c=g+(i.range.startLineNumber-a.range.endLineNumber),h=i.range.startColumn):(c=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const d=i.eolCount+1;d===1?t=new C.$vt(c,h,c,h+i.firstLineLength):t=new C.$vt(c,h,c+d-1,i.lastLineLength+1)}else t=new C.$vt(c,h,c,h);g=t.endLineNumber,r=t.endColumn,w.push(t),a=i}return w}static u(m,w){const g=C.$vt.compareRangesUsingEnds(m.range,w.range);return g===0?m.sortIndex-w.sortIndex:g}static w(m,w){const g=C.$vt.compareRangesUsingEnds(m.range,w.range);return g===0?w.sortIndex-m.sortIndex:-g}}e.$2C=M}),define(Ce[150],Ae([1,0,13,94,149]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=void 0;class O{constructor($,E,M,S,m,w,g,r,a){this.a=$,this.b=E,this.c=M,this.d=S,this.e=m,this.f=w,this.g=g,this.h=r,this.j=a}k($){const E=this.c+this.d+this.e,M=this.c+this.e;return E===0?$===1?`
`:`\r
`:M>E/2?`\r
`:`
`}create($){const E=this.k($),M=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let m=0,w=M.length;m<w;m++){const g=M[m].buffer.replace(/\r\n|\r|\n/g,E),r=(0,A.$WC)(g);M[m]=new A.$ZC(g,r)}const S=new C.$2C(M,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class N{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&y.$Wf($)&&(this.b=y.$Vf,$=$.substr(1));const E=$.charCodeAt($.length-1);E===13||E>=55296&&E<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=E):(this.m($,!1),this.c=!1,this.d=E)}m($,E){!E&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const E=(0,A.$XC)(this.e,$);this.a.push(new A.$ZC($,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=y.$Mf($)),this.k||(this.k=y.$Pf($)))}finish($=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const E=(0,A.$WC)($.buffer);$.lineStarts=E,this.d===13&&this.f++}}}e.$3C=N}),define(Ce[98],Ae([1,0,21,22]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcb=$,e.$ecb=M;var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function O(S){for(let m=0,w=S.length;m<w;m+=4){const g=S[m+0],r=S[m+1],a=S[m+2],s=S[m+3];S[m+0]=s,S[m+1]=a,S[m+2]=r,S[m+3]=g}}function N(S){const m=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return A.$x()||O(m),y.$Ge.wrap(m)}function p(S){const m=S.buffer;if(A.$x()||O(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const w=new Uint8Array(m.byteLength);return w.set(m),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function $(S){const m=new Uint32Array(E(S));let w=0;if(m[w++]=S.id,S.type==="full")m[w++]=1,m[w++]=S.data.length,m.set(S.data,w),w+=S.data.length;else{m[w++]=2,m[w++]=S.deltas.length;for(const g of S.deltas)m[w++]=g.start,m[w++]=g.deleteCount,g.data?(m[w++]=g.data.length,m.set(g.data,w),w+=g.data.length):m[w++]=0}return N(m)}function E(S){let m=0;if(m+=2,S.type==="full")m+=1+S.data.length;else{m+=1,m+=3*S.deltas.length;for(const w of S.deltas)w.data&&(m+=w.data.length)}return m}function M(S){const m=p(S);let w=0;const g=m[w++];if(m[w++]===1){const n=m[w++],i=m.subarray(w,w+n);return w+=n,{id:g,type:"full",data:i}}const a=m[w++],s=[];for(let n=0;n<a;n++){const i=m[w++],c=m[w++],h=m[w++];let t;h>0&&(t=m.subarray(w,w+h),w+=h),s[n]={start:i,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:s}}}),define(Ce[151],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const N=this.a.get(O);return this.a.delete(O),N}}addDragOperationTransfer(O,N){this.a.set(O,N)}}e.$w$=y;class A{constructor(O){this.identifier=O}}e.$x$=A}),define(Ce[152],Ae([10,11]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ce[153],Ae([1,0,5,6,152]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=M;class O extends A.$Vc{constructor(m,w="",g="",r=!0,a){super(),this.h=this.B(new y.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=w,this.u=g,this.w=r,this.C=a}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,w){this.C&&await this.C(m)}}e.$bj=O;class N extends A.$Vc{constructor(){super(...arguments),this.f=this.B(new y.$ee),this.onWillRun=this.f.event,this.m=this.B(new y.$ee),this.onDidRun=this.m.event}async run(m,w){if(!m.enabled)return;this.f.fire({action:m});let g;try{await this.u(m,w)}catch(r){g=r}this.m.fire({action:m,error:g})}async u(m,w){await m.run(w)}}e.$cj=N;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let w=[];for(const g of m)g.length&&(w.length?w=[...w,new p,...g]:w=g);return w}async run(){}}e.$dj=p,p.ID="vs.actions.separator";class ${get actions(){return this.a}constructor(m,w,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=w,this.class=r,this.a=g}async run(){}}e.$ej=$;class E extends O{constructor(){super(E.ID,C.localize(0,null),void 0,!1)}}e.$fj=E,E.ID="vs.actions.empty";function M(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...m)=>S.run(...m),tooltip:S.label}}}),define(Ce[154],Ae([10,11]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ce[155],Ae([1,0,154]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=E,e.$4m=M,e.$5m=S;const A=60,C=A*60,O=C*24,N=O*7,p=O*30,$=O*365;function E(m,w,g,r){typeof m!="number"&&(m=m.getTime());const a=Math.round((new Date().getTime()-m)/1e3);if(a<-30)return(0,y.localize)(0,null,E(new Date().getTime()+a*1e3,!1));if(!r&&a<30)return(0,y.localize)(1,null);let s;return a<A?(s=a,w?s===1?g?(0,y.localize)(2,null,s):(0,y.localize)(3,null,s):g?(0,y.localize)(4,null,s):(0,y.localize)(5,null,s):s===1?g?(0,y.localize)(6,null,s):(0,y.localize)(7,null,s):g?(0,y.localize)(8,null,s):(0,y.localize)(9,null,s)):a<C?(s=Math.floor(a/A),w?s===1?g?(0,y.localize)(10,null,s):(0,y.localize)(11,null,s):g?(0,y.localize)(12,null,s):(0,y.localize)(13,null,s):s===1?g?(0,y.localize)(14,null,s):(0,y.localize)(15,null,s):g?(0,y.localize)(16,null,s):(0,y.localize)(17,null,s)):a<O?(s=Math.floor(a/C),w?s===1?g?(0,y.localize)(18,null,s):(0,y.localize)(19,null,s):g?(0,y.localize)(20,null,s):(0,y.localize)(21,null,s):s===1?g?(0,y.localize)(22,null,s):(0,y.localize)(23,null,s):g?(0,y.localize)(24,null,s):(0,y.localize)(25,null,s)):a<N?(s=Math.floor(a/O),w?s===1?(0,y.localize)(26,null,s):(0,y.localize)(27,null,s):s===1?(0,y.localize)(28,null,s):(0,y.localize)(29,null,s)):a<p?(s=Math.floor(a/N),w?s===1?g?(0,y.localize)(30,null,s):(0,y.localize)(31,null,s):g?(0,y.localize)(32,null,s):(0,y.localize)(33,null,s):s===1?g?(0,y.localize)(34,null,s):(0,y.localize)(35,null,s):g?(0,y.localize)(36,null,s):(0,y.localize)(37,null,s)):a<$?(s=Math.floor(a/p),w?s===1?g?(0,y.localize)(38,null,s):(0,y.localize)(39,null,s):g?(0,y.localize)(40,null,s):(0,y.localize)(41,null,s):s===1?g?(0,y.localize)(42,null,s):(0,y.localize)(43,null,s):g?(0,y.localize)(44,null,s):(0,y.localize)(45,null,s)):(s=Math.floor(a/$),w?s===1?g?(0,y.localize)(46,null,s):(0,y.localize)(47,null,s):g?(0,y.localize)(48,null,s):(0,y.localize)(49,null,s):s===1?g?(0,y.localize)(50,null,s):(0,y.localize)(51,null,s):g?(0,y.localize)(52,null,s):(0,y.localize)(53,null,s))}function M(m,w){const g=Math.abs(m/1e3);return g<1?w?(0,y.localize)(54,null,m):(0,y.localize)(55,null,m):g<A?w?(0,y.localize)(56,null,Math.round(m)/1e3):(0,y.localize)(57,null,Math.round(m)/1e3):g<C?w?(0,y.localize)(58,null,Math.round(m/(1e3*A))):(0,y.localize)(59,null,Math.round(m/(1e3*A))):g<O?w?(0,y.localize)(60,null,Math.round(m/(1e3*C))):(0,y.localize)(61,null,Math.round(m/(1e3*C))):(0,y.localize)(62,null,Math.round(m/(1e3*O)))}function S(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[156],Ae([10,11]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ae([1,0,18,15,156]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=$,e.$ij=E,e.$jj=M;function O(S,m){return m&&(S.stack||S.stacktrace)?C.localize(0,null,p(S),N(S.stack)||N(S.stacktrace)):p(S)}function N(S){return Array.isArray(S)?S.join(`
`):S}function p(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function $(S=null,m=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const w=y.$Hb(S),g=$(w[0],m);return w.length>1?C.localize(4,null,g,w.length):g}if(A.$9f(S))return S;if(S.detail){const w=S.detail;if(w.error)return O(w.error,m);if(w.exception)return O(w.exception,m)}return S.stack?O(S,m):S.message?S.message:C.localize(5,null)}function E(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}function M(S,m){let w;return typeof S=="string"?w=new Error(S):w=S,w.actions=m,w}}),define(Ce[157],Ae([10,11]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ce[158],Ae([1,0,18,25,22,145,159,157]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=a,e.clampedInt=n,e.clampedFloat=c,e.stringSet=d,e.cursorStyleToString=k,e.filterValidationDecorations=le;var $;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=E;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class S{constructor(Y,ye,Ge,De){this.id=Y,this.name=ye,this.defaultValue=Ge,this.schema=De}applyUpdate(Y,ye){return w(Y,ye)}compute(Y,ye,Ge){return Ge}}class m{constructor(Y,ye){this.newValue=Y,this.didChange=ye}}e.ApplyUpdateResult=m;function w(x,Y){if(typeof x!="object"||typeof Y!="object"||!x||!Y)return new m(Y,x!==Y);if(Array.isArray(x)||Array.isArray(Y)){const Ge=Array.isArray(x)&&Array.isArray(Y)&&y.$ub(x,Y);return new m(Y,!Ge)}let ye=!1;for(const Ge in Y)if(Y.hasOwnProperty(Ge)){const De=w(x[Ge],Y[Ge]);De.didChange&&(x[Ge]=De.newValue,ye=!0)}return new m(x,ye)}class g{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ye){return w(Y,ye)}validate(Y){return this.defaultValue}}class r{constructor(Y,ye,Ge,De){this.id=Y,this.name=ye,this.defaultValue=Ge,this.schema=De}applyUpdate(Y,ye){return w(Y,ye)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,ye,Ge){return Ge}}function a(x,Y){return typeof x>"u"?Y:x==="false"?!1:!!x}class s extends r{constructor(Y,ye,Ge,De=void 0){typeof De<"u"&&(De.type="boolean",De.default=Ge),super(Y,ye,Ge,De)}validate(Y){return a(Y,this.defaultValue)}}function n(x,Y,ye,Ge){if(typeof x>"u")return Y;let De=parseInt(x,10);return isNaN(De)?Y:(De=Math.max(ye,De),De=Math.min(Ge,De),De|0)}class i extends r{static clampedInt(Y,ye,Ge,De){return n(Y,ye,Ge,De)}constructor(Y,ye,Ge,De,at,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Ge,gt.minimum=De,gt.maximum=at),super(Y,ye,Ge,gt),this.minimum=De,this.maximum=at}validate(Y){return i.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function c(x,Y,ye,Ge){if(typeof x>"u")return Y;const De=h.float(x,Y);return h.clamp(De,ye,Ge)}class h extends r{static clamp(Y,ye,Ge){return Y<ye?ye:Y>Ge?Ge:Y}static float(Y,ye){if(typeof Y=="number")return Y;if(typeof Y>"u")return ye;const Ge=parseFloat(Y);return isNaN(Ge)?ye:Ge}constructor(Y,ye,Ge,De,at){typeof at<"u"&&(at.type="number",at.default=Ge),super(Y,ye,Ge,at),this.validationFn=De}validate(Y){return this.validationFn(h.float(Y,this.defaultValue))}}class t extends r{static string(Y,ye){return typeof Y!="string"?ye:Y}constructor(Y,ye,Ge,De=void 0){typeof De<"u"&&(De.type="string",De.default=Ge),super(Y,ye,Ge,De)}validate(Y){return t.string(Y,this.defaultValue)}}function d(x,Y,ye,Ge){return typeof x!="string"?Y:Ge&&x in Ge?Ge[x]:ye.indexOf(x)===-1?Y:x}class o extends r{constructor(Y,ye,Ge,De,at=void 0){typeof at<"u"&&(at.type="string",at.enum=De,at.default=Ge),super(Y,ye,Ge,at),this.c=De}validate(Y){return d(Y,this.defaultValue,this.c)}}class f extends S{constructor(Y,ye,Ge,De,at,gt,Rt=void 0){typeof Rt<"u"&&(Rt.type="string",Rt.enum=at,Rt.default=De),super(Y,ye,Ge,Rt),this.c=at,this.d=gt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function u(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ye,Ge){return Ge===0?Y.accessibilitySupport:Ge}}class l extends S{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{insertSpace:a(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var v;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(v||(e.TextEditorCursorBlinkingStyle=v={}));function b(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var P;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(P||(e.TextEditorCursorStyle=P={}));function k(x){switch(x){case P.Line:return"line";case P.Block:return"block";case P.Underline:return"underline";case P.LineThin:return"line-thin";case P.BlockOutline:return"block-outline";case P.UnderlineThin:return"underline-thin"}}function I(x){switch(x){case"line":return P.Line;case"block":return P.Block;case"underline":return P.Underline;case"line-thin":return P.LineThin;case"block-outline":return P.BlockOutline;case"underline-thin":return P.UnderlineThin}}class U extends g{constructor(){super(142)}compute(Y,ye,Ge){const De=["monaco-editor"];return ye.get(39)&&De.push(ye.get(39)),Y.extraEditorClassName&&De.push(Y.extraEditorClassName),ye.get(74)==="default"?De.push("mouse-default"):ye.get(74)==="copy"&&De.push("mouse-copy"),ye.get(111)&&De.push("showUnused"),ye.get(140)&&De.push("showDeprecated"),De.join(" ")}}class Q extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Y,ye,Ge){return Ge&&Y.emptySelectionClipboard}}class G extends S{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:p.localize(16,null),included:C.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:p.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{cursorMoveOnType:a(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":d(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":d(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(ye.loop,this.defaultValue.loop)}}}class L extends S{constructor(){super(51,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"||Y.length===0?L.OFF:Y==="true"?L.ON:Y:Y?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class R extends S{constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?R.OFF:Y==="true"?R.TRANSLATE:Y:Y?R.TRANSLATE:R.OFF}compute(Y,ye,Ge){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=R,R.OFF="normal",R.TRANSLATE="translate";class F extends g{constructor(){super(50)}compute(Y,ye,Ge){return Y.fontInfo}}class T extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Y){const ye=h.float(Y,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ye,6,100)}compute(Y,ye,Ge){return Y.fontInfo.fontSize}}class X extends S{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(i.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}X.c=["normal","bold","100","200","300","400","500","600","700","800","900"],X.d=1,X.e=1e3;class ne extends S{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{multiple:d(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??d(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??d(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??d(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??d(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??d(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class me extends S{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:p.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),delay:i.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:a(ye.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(ye.above,this.defaultValue.above)}}}var we;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class de extends g{constructor(){super(145)}compute(Y,ye,Ge){return de.computeLayout(ye,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const ye=Y.height/Y.lineHeight,Ge=Math.floor(Y.paddingTop/Y.lineHeight);let De=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(De=Math.max(De,ye-1));const at=(Ge+Y.viewLineCount+De)/(Y.pixelRatio*Y.height),gt=Math.floor(Y.viewLineCount/at);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:De,desiredRatio:at,minimapLineCount:gt}}static c(Y,ye){const Ge=Y.outerWidth,De=Y.outerHeight,at=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*De),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:De};const gt=ye.stableMinimapLayoutInput,Rt=gt&&Y.outerHeight===gt.outerHeight&&Y.lineHeight===gt.lineHeight&&Y.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===gt.pixelRatio&&Y.scrollBeyondLastLine===gt.scrollBeyondLastLine&&Y.paddingTop===gt.paddingTop&&Y.paddingBottom===gt.paddingBottom&&Y.minimap.enabled===gt.minimap.enabled&&Y.minimap.side===gt.minimap.side&&Y.minimap.size===gt.minimap.size&&Y.minimap.showSlider===gt.minimap.showSlider&&Y.minimap.renderCharacters===gt.minimap.renderCharacters&&Y.minimap.maxColumn===gt.minimap.maxColumn&&Y.minimap.scale===gt.minimap.scale&&Y.verticalScrollbarWidth===gt.verticalScrollbarWidth&&Y.isViewportWrapping===gt.isViewportWrapping,Wt=Y.lineHeight,Qt=Y.typicalHalfwidthCharacterWidth,_t=Y.scrollBeyondLastLine,Xt=Y.minimap.renderCharacters;let St=at>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const ei=Y.minimap.maxColumn,ti=Y.minimap.size,xe=Y.minimap.side,hi=Y.verticalScrollbarWidth,ni=Y.viewLineCount,ft=Y.remainingWidth,wt=Y.isViewportWrapping,Gt=Xt?2:3;let Zt=Math.floor(at*De);const Lt=Zt/at;let mt=!1,zt=!1,qt=Gt*St,Ft=St/at,Xe=1;if(ti==="fill"||ti==="fit"){const{typicalViewportLineCount:Ht,extraLinesBeforeFirstLine:ri,extraLinesBeyondLastLine:si,desiredRatio:oi,minimapLineCount:Mt}=de.computeContainedMinimapLineCount({viewLineCount:ni,scrollBeyondLastLine:_t,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:De,lineHeight:Wt,pixelRatio:at});if(ni/Mt>1)mt=!0,zt=!0,St=1,qt=1,Ft=St/at;else{let Ot=!1,It=St+1;if(ti==="fit"){const pt=Math.ceil((ri+ni+si)*qt);wt&&Rt&&ft<=ye.stableFitRemainingWidth?(Ot=!0,It=ye.stableFitMaxMinimapScale):Ot=pt>Zt}if(ti==="fill"||Ot){mt=!0;const pt=St;qt=Math.min(Wt*at,Math.max(1,Math.floor(1/oi))),wt&&Rt&&ft<=ye.stableFitRemainingWidth&&(It=ye.stableFitMaxMinimapScale),St=Math.min(It,Math.max(1,Math.floor(qt/Gt))),St>pt&&(Xe=Math.min(2,St/pt)),Ft=St/at/Xe,Zt=Math.ceil(Math.max(Ht,ri+ni+si)*qt),wt?(ye.stableMinimapLayoutInput=Y,ye.stableFitRemainingWidth=ft,ye.stableFitMaxMinimapScale=St):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const ci=Math.floor(ei*Ft),Yt=Math.min(ci,Math.max(0,Math.floor((ft-hi-2)*Ft/(Qt+Ft)))+e.MINIMAP_GUTTER_WIDTH);let Kt=Math.floor(at*Yt);const vt=Kt/at;Kt=Math.floor(Kt*Xe);const jt=Xt?1:2,Bt=xe==="left"?0:Ge-Yt-hi;return{renderMinimap:jt,minimapLeft:Bt,minimapWidth:Yt,minimapHeightIsEditorHeight:mt,minimapIsSampling:zt,minimapScale:St,minimapLineHeight:qt,minimapCanvasInnerWidth:Kt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:vt,minimapCanvasOuterHeight:Lt}}static computeLayout(Y,ye){const Ge=ye.outerWidth|0,De=ye.outerHeight|0,at=ye.lineHeight|0,gt=ye.lineNumbersDigitCount|0,Rt=ye.typicalHalfwidthCharacterWidth,Wt=ye.maxDigitWidth,Qt=ye.pixelRatio,_t=ye.viewLineCount,Xt=Y.get(137),St=Xt==="inherit"?Y.get(136):Xt,ei=St==="inherit"?Y.get(132):St,ti=Y.get(135),xe=ye.isDominatedByLongLines,hi=Y.get(57),ni=Y.get(68).renderType!==0,ft=Y.get(69),wt=Y.get(105),Gt=Y.get(84),Zt=Y.get(73),Lt=Y.get(103),mt=Lt.verticalScrollbarSize,zt=Lt.verticalHasArrows,qt=Lt.arrowSize,Ft=Lt.horizontalScrollbarSize,Xe=Y.get(43),ci=Y.get(110)!=="never";let Yt=Y.get(66);Xe&&ci&&(Yt+=16);let Kt=0;if(ni){const ai=Math.max(gt,ft);Kt=Math.round(ai*Wt)}let vt=0;hi&&(vt=at*ye.glyphMarginDecorationLaneCount);let jt=0,Bt=jt+vt,Ht=Bt+Kt,ri=Ht+Yt;const si=Ge-vt-Kt-Yt;let oi=!1,Mt=!1,Pt=-1;St==="inherit"&&xe?(oi=!0,Mt=!0):ei==="on"||ei==="bounded"?Mt=!0:ei==="wordWrapColumn"&&(Pt=ti);const Ot=de.c({outerWidth:Ge,outerHeight:De,lineHeight:at,typicalHalfwidthCharacterWidth:Rt,pixelRatio:Qt,scrollBeyondLastLine:wt,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:Zt,verticalScrollbarWidth:mt,viewLineCount:_t,remainingWidth:si,isViewportWrapping:Mt},ye.memory||new M);Ot.renderMinimap!==0&&Ot.minimapLeft===0&&(jt+=Ot.minimapWidth,Bt+=Ot.minimapWidth,Ht+=Ot.minimapWidth,ri+=Ot.minimapWidth);const It=si-Ot.minimapWidth,pt=Math.max(1,Math.floor((It-mt-2)/Rt)),Ct=zt?qt:0;return Mt&&(Pt=Math.max(1,pt),ei==="bounded"&&(Pt=Math.min(Pt,ti))),{width:Ge,height:De,glyphMarginLeft:jt,glyphMarginWidth:vt,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:Bt,lineNumbersWidth:Kt,decorationsLeft:Ht,decorationsWidth:Yt,contentLeft:ri,contentWidth:It,minimap:Ot,viewportColumn:pt,isWordWrapMinified:oi,isViewportWrapping:Mt,wrappingColumn:Pt,verticalScrollbarWidth:mt,horizontalScrollbarHeight:Ft,overviewRuler:{top:Ct,width:mt,height:De-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=de;class $e extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Y){return d(Y,"simple",["simple","advanced"])}compute(Y,ye,Ge){return ye.get(2)===2?"advanced":Ge}}var ke;(function(x){x.Off="off",x.OnCode="onCode",x.On="on"})(ke||(e.ShowLightbulbIconMode=ke={}));class se extends S{constructor(){const Y={enabled:ke.On};super(65,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ke.Off,ke.OnCode,ke.On],default:Y.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:d(Y.enabled,this.defaultValue.enabled,[ke.Off,ke.OnCode,ke.On])}}}class Pe extends S{constructor(){const Y={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:p.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends S{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,C.$d?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,C.$d?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:p.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:d(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily),padding:a(ye.padding,this.defaultValue.padding)}}}class H extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):i.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,ye,Ge){return Ge<0?i.clampedInt(-Ge*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class he extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>h.clamp(Y,0,150),{markdownDescription:p.localize(66,null)})}compute(Y,ye,Ge){return Y.fontInfo.lineHeight}}class Fe extends S{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Y.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Y.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Y.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Y.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),autohide:a(ye.autohide,this.defaultValue.autohide),size:d(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(ye.side,this.defaultValue.side,["right","left"]),showSlider:d(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(ye.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ye.scale,1,1,3),maxColumn:i.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:a(ye.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:a(ye.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(ye.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function pe(x){return x==="ctrlCmd"?C.$d?"metaKey":"ctrlKey":"altKey"}class be extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{top:i.clampedInt(ye.top,0,0,1e3),bottom:i.clampedInt(ye.bottom,0,0,1e3)}}}class ge extends S{constructor(){const Y={enabled:!0,cycle:!0};super(86,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:p.localize(84,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),cycle:a(ye.cycle,this.defaultValue.cycle)}}}class ae extends g{constructor(){super(143)}compute(Y,ye,Ge){return Y.pixelRatio}}class K extends S{constructor(){const Y={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:Y.strings,description:p.localize(88,null)},comments:{anyOf:ye,default:Y.comments,description:p.localize(89,null)},other:{anyOf:ye,default:Y.other,description:p.localize(90,null)}},default:Y,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Qt=Y?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ye,comments:Ge,strings:De}=Y,at=["on","inline","off"];let gt,Rt,Wt;return typeof ye=="boolean"?gt=ye?"on":"off":gt=d(ye,this.defaultValue.other,at),typeof Ge=="boolean"?Rt=Ge?"on":"off":Rt=d(Ge,this.defaultValue.comments,at),typeof De=="boolean"?Wt=De?"on":"off":Wt=d(De,this.defaultValue.strings,at),{other:gt,comments:Rt,strings:Wt}}}var Z;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class fe extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Y){let ye=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(ye=4,Ge=Y):Y==="interval"?ye=3:Y==="relative"?ye=2:Y==="on"?ye=1:ye=0),{renderType:ye,renderFn:Ge}}}function le(x){const Y=x.get(98);return Y==="editable"?x.get(91):Y!=="on"}class Me extends S{constructor(){const Y=[],ye={type:"number",description:p.localize(97,null)};super(102,"rulers",Y,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Y,description:p.localize(99,null)})}validate(Y){if(Array.isArray(Y)){const ye=[];for(const Ge of Y)if(typeof Ge=="number")ye.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const De=Ge;ye.push({column:i.clampedInt(De.column,0,0,1e4),color:De.color})}return ye.sort((Ge,De)=>Ge.column-De.column),ye}return this.defaultValue}}class ve extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Re(x,Y){if(typeof x!="string")return Y;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class Oe extends S{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y,Ge=i.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),De=i.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Re(ye.vertical,this.defaultValue.vertical),horizontal:Re(ye.horizontal,this.defaultValue.horizontal),useShadows:a(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(ye.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:De,verticalSliderSize:i.clampedInt(ye.verticalSliderSize,De,0,1e3),scrollByPage:a(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends S{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Y,ye){let Ge=!1;ye.allowedCharacters&&Y&&(A.$8n(Y.allowedCharacters,ye.allowedCharacters)||(Y={...Y,allowedCharacters:ye.allowedCharacters},Ge=!0)),ye.allowedLocales&&Y&&(A.$8n(Y.allowedLocales,ye.allowedLocales)||(Y={...Y,allowedLocales:ye.allowedLocales},Ge=!0));const De=super.applyUpdate(Y,ye);return Ge?new m(De.newValue,!0):De}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{nonBasicASCII:_(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,ye){if(typeof Y!="object"||!Y)return ye;const Ge={};for(const[De,at]of Object.entries(Y))at===!0&&(Ge[De]=!0);return Ge}}class j extends S{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Y.fontFamily,description:p.localize(125,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),mode:d(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(ye.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily)}}}class V extends S{constructor(){const Y={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Y,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Y.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Y.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Y.backgroundColoring,description:p.localize(132,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),showToolbar:d(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily),keepOnBlur:a(ye.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:a(ye.backgroundColoring,this.defaultValue.backgroundColoring)}}}class W extends S{constructor(){const Y={enabled:O.$5s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$5s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Y.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Y.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Y.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{bracketPairs:_(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(x,Y,ye){const Ge=ye.indexOf(x);return Ge===-1?Y:ye[Ge]}class oe extends S{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Y.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Y.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{insertMode:d(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(ye.showIcons,this.defaultValue.showIcons),showStatusBar:a(ye.showStatusBar,this.defaultValue.showStatusBar),preview:a(ye.preview,this.defaultValue.preview),previewMode:d(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(ye.showMethods,this.defaultValue.showMethods),showFunctions:a(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:a(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(ye.showFields,this.defaultValue.showFields),showVariables:a(ye.showVariables,this.defaultValue.showVariables),showClasses:a(ye.showClasses,this.defaultValue.showClasses),showStructs:a(ye.showStructs,this.defaultValue.showStructs),showInterfaces:a(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:a(ye.showModules,this.defaultValue.showModules),showProperties:a(ye.showProperties,this.defaultValue.showProperties),showEvents:a(ye.showEvents,this.defaultValue.showEvents),showOperators:a(ye.showOperators,this.defaultValue.showOperators),showUnits:a(ye.showUnits,this.defaultValue.showUnits),showValues:a(ye.showValues,this.defaultValue.showValues),showConstants:a(ye.showConstants,this.defaultValue.showConstants),showEnums:a(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:a(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(ye.showKeywords,this.defaultValue.showKeywords),showWords:a(ye.showWords,this.defaultValue.showWords),showColors:a(ye.showColors,this.defaultValue.showColors),showFiles:a(ye.showFiles,this.defaultValue.showFiles),showReferences:a(ye.showReferences,this.defaultValue.showReferences),showFolders:a(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:a(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(ye.showSnippets,this.defaultValue.showSnippets),showUsers:a(ye.showUsers,this.defaultValue.showUsers),showIssues:a(ye.showIssues,this.defaultValue.showIssues)}}}class Ne extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(Y.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends S{constructor(){const Y=[];super(130,"wordSegmenterLocales",Y,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Y){if(typeof Y=="string"&&(Y=[Y]),Array.isArray(Y)){const ye=[];for(const Ge of Y)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&ye.push(Ge)}catch{}return ye}return this.defaultValue}}var Ke;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class Ye extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,ye,Ge){return ye.get(2)===2?0:Ge}}class tt extends g{constructor(){super(146)}compute(Y,ye,Ge){const De=ye.get(145);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:De.isWordWrapMinified,isViewportWrapping:De.isViewportWrapping,wrappingColumn:De.wrappingColumn}}}class it extends S{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),showDropSelector:d(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends S{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:a(ye.enabled,this.defaultValue.enabled),showPasteSelector:d(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",ut="Menlo, Monaco, 'Courier New', monospace",$t="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$d?ut:C.$e?$t:st,fontWeight:"normal",fontSize:C.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(x){return e.editorOptionsRegistry[x.id]=x,x}var ct;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.autoClosingComments=7]="autoClosingComments",x[x.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=9]="autoClosingDelete",x[x.autoClosingOvertype=10]="autoClosingOvertype",x[x.autoClosingQuotes=11]="autoClosingQuotes",x[x.autoIndent=12]="autoIndent",x[x.automaticLayout=13]="automaticLayout",x[x.autoSurround=14]="autoSurround",x[x.bracketPairColorization=15]="bracketPairColorization",x[x.guides=16]="guides",x[x.codeLens=17]="codeLens",x[x.codeLensFontFamily=18]="codeLensFontFamily",x[x.codeLensFontSize=19]="codeLensFontSize",x[x.colorDecorators=20]="colorDecorators",x[x.colorDecoratorsLimit=21]="colorDecoratorsLimit",x[x.columnSelection=22]="columnSelection",x[x.comments=23]="comments",x[x.contextmenu=24]="contextmenu",x[x.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",x[x.cursorBlinking=26]="cursorBlinking",x[x.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",x[x.cursorStyle=28]="cursorStyle",x[x.cursorSurroundingLines=29]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",x[x.cursorWidth=31]="cursorWidth",x[x.disableLayerHinting=32]="disableLayerHinting",x[x.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",x[x.domReadOnly=34]="domReadOnly",x[x.dragAndDrop=35]="dragAndDrop",x[x.dropIntoEditor=36]="dropIntoEditor",x[x.emptySelectionClipboard=37]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",x[x.extraEditorClassName=39]="extraEditorClassName",x[x.fastScrollSensitivity=40]="fastScrollSensitivity",x[x.find=41]="find",x[x.fixedOverflowWidgets=42]="fixedOverflowWidgets",x[x.folding=43]="folding",x[x.foldingStrategy=44]="foldingStrategy",x[x.foldingHighlight=45]="foldingHighlight",x[x.foldingImportsByDefault=46]="foldingImportsByDefault",x[x.foldingMaximumRegions=47]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=49]="fontFamily",x[x.fontInfo=50]="fontInfo",x[x.fontLigatures=51]="fontLigatures",x[x.fontSize=52]="fontSize",x[x.fontWeight=53]="fontWeight",x[x.fontVariations=54]="fontVariations",x[x.formatOnPaste=55]="formatOnPaste",x[x.formatOnType=56]="formatOnType",x[x.glyphMargin=57]="glyphMargin",x[x.gotoLocation=58]="gotoLocation",x[x.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",x[x.hover=60]="hover",x[x.inDiffEditor=61]="inDiffEditor",x[x.inlineSuggest=62]="inlineSuggest",x[x.inlineEdit=63]="inlineEdit",x[x.letterSpacing=64]="letterSpacing",x[x.lightbulb=65]="lightbulb",x[x.lineDecorationsWidth=66]="lineDecorationsWidth",x[x.lineHeight=67]="lineHeight",x[x.lineNumbers=68]="lineNumbers",x[x.lineNumbersMinChars=69]="lineNumbersMinChars",x[x.linkedEditing=70]="linkedEditing",x[x.links=71]="links",x[x.matchBrackets=72]="matchBrackets",x[x.minimap=73]="minimap",x[x.mouseStyle=74]="mouseStyle",x[x.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=76]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",x[x.multiCursorModifier=78]="multiCursorModifier",x[x.multiCursorPaste=79]="multiCursorPaste",x[x.multiCursorLimit=80]="multiCursorLimit",x[x.occurrencesHighlight=81]="occurrencesHighlight",x[x.overviewRulerBorder=82]="overviewRulerBorder",x[x.overviewRulerLanes=83]="overviewRulerLanes",x[x.padding=84]="padding",x[x.pasteAs=85]="pasteAs",x[x.parameterHints=86]="parameterHints",x[x.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",x[x.quickSuggestions=89]="quickSuggestions",x[x.quickSuggestionsDelay=90]="quickSuggestionsDelay",x[x.readOnly=91]="readOnly",x[x.readOnlyMessage=92]="readOnlyMessage",x[x.renameOnType=93]="renameOnType",x[x.renderControlCharacters=94]="renderControlCharacters",x[x.renderFinalNewline=95]="renderFinalNewline",x[x.renderLineHighlight=96]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=98]="renderValidationDecorations",x[x.renderWhitespace=99]="renderWhitespace",x[x.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",x[x.roundedSelection=101]="roundedSelection",x[x.rulers=102]="rulers",x[x.scrollbar=103]="scrollbar",x[x.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=105]="scrollBeyondLastLine",x[x.scrollPredominantAxis=106]="scrollPredominantAxis",x[x.selectionClipboard=107]="selectionClipboard",x[x.selectionHighlight=108]="selectionHighlight",x[x.selectOnLineNumbers=109]="selectOnLineNumbers",x[x.showFoldingControls=110]="showFoldingControls",x[x.showUnused=111]="showUnused",x[x.snippetSuggestions=112]="snippetSuggestions",x[x.smartSelect=113]="smartSelect",x[x.smoothScrolling=114]="smoothScrolling",x[x.stickyScroll=115]="stickyScroll",x[x.stickyTabStops=116]="stickyTabStops",x[x.stopRenderingLineAfter=117]="stopRenderingLineAfter",x[x.suggest=118]="suggest",x[x.suggestFontSize=119]="suggestFontSize",x[x.suggestLineHeight=120]="suggestLineHeight",x[x.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",x[x.suggestSelection=122]="suggestSelection",x[x.tabCompletion=123]="tabCompletion",x[x.tabIndex=124]="tabIndex",x[x.unicodeHighlighting=125]="unicodeHighlighting",x[x.unusualLineTerminators=126]="unusualLineTerminators",x[x.useShadowDOM=127]="useShadowDOM",x[x.useTabStops=128]="useTabStops",x[x.wordBreak=129]="wordBreak",x[x.wordSegmenterLocales=130]="wordSegmenterLocales",x[x.wordSeparators=131]="wordSeparators",x[x.wordWrap=132]="wordWrap",x[x.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=135]="wordWrapColumn",x[x.wordWrapOverride1=136]="wordWrapOverride1",x[x.wordWrapOverride2=137]="wordWrapOverride2",x[x.wrappingIndent=138]="wrappingIndent",x[x.wrappingStrategy=139]="wrappingStrategy",x[x.showDeprecated=140]="showDeprecated",x[x.inlayHints=141]="inlayHints",x[x.editorClassName=142]="editorClassName",x[x.pixelRatio=143]="pixelRatio",x[x.tabFocusMode=144]="tabFocusMode",x[x.layoutInfo=145]="layoutInfo",x[x.wrappingInfo=146]="wrappingInfo",x[x.defaultColorDecorators=147]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",x[x.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ct||(e.EditorOption=ct={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new D),accessibilityPageSize:je(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new s(13,"automaticLayout",!1)),autoSurround:je(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new W),bracketPairGuides:je(new q),stickyTabStops:je(new s(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new s(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new s(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new o(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new s(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new l),contextmenu:je(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new s(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new f(28,"cursorStyle",P.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:p.localize(260,null)})),cursorSurroundingLines:je(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new s(34,"domReadOnly",!1)),dragAndDrop:je(new s(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new Q),dropIntoEditor:je(new it),stickyScroll:je(new Pe),experimentalWhitespaceRendering:je(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:p.localize(271,null)})),find:je(new G),fixedOverflowWidgets:je(new s(42,"fixedOverflowWidgets",!1)),folding:je(new s(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new s(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new s(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new F),fontLigatures2:je(new L),fontSize:je(new T),fontWeight:je(new X),fontVariations:je(new R),formatOnPaste:je(new s(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new s(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new s(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ne),hideCursorInOverviewRuler:je(new s(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new me),inDiffEditor:je(new s(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>h.clamp(x,-5,20),{description:p.localize(285,null)})),lightbulb:je(new se),lineDecorationsWidth:je(new H),lineHeight:je(new he),lineNumbers:je(new fe),lineNumbersMinChars:je(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new s(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new s(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new o(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new Fe),mouseStyle:je(new o(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new s(76,"mouseWheelZoom",!1,{markdownDescription:C.$d?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new s(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new f(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new o(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new o(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new s(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new i(83,"overviewRulerLanes",3,0,3)),padding:je(new be),pasteAs:je(new nt),parameterHints:je(new ge),peekWidgetDefaultFocus:je(new o(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new s(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new K),quickSuggestionsDelay:je(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new s(91,"readOnly",!1)),readOnlyMessage:je(new ve),renameOnType:je(new s(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new s(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new o(95,"renderFinalNewline",C.$e?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new o(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new o(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new o(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new s(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Me),scrollbar:je(new Oe),scrollBeyondLastColumn:je(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new s(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new s(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new s(107,"selectionClipboard",!0,{description:p.localize(325,null),included:C.$e})),selectionHighlight:je(new s(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new o(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new s(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new s(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new re),snippetSuggestions:je(new o(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Ne),smoothScrolling:je(new s(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new oe),inlineSuggest:je(new j),inlineEdit:je(new V),inlineCompletionsAccessibilityVerbose:je(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new s(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new o(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new o(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new Ue),unusualLineTerminators:je(new o(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new s(127,"useShadowDOM",!0)),useTabStops:je(new s(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new o(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Ve),wordSeparators:je(new t(131,"wordSeparators",N.$6s,{description:p.localize(359,null)})),wordWrap:je(new o(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new o(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new o(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new U),defaultColorDecorators:je(new s(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new ae),tabFocusMode:je(new s(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new de),wrappingInfo:je(new tt),wrappingIndent:je(new Ye),wrappingStrategy:je(new $e)}}),define(Ce[160],Ae([10,11]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[161],Ae([10,11]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[162],Ae([10,11]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[163],Ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[164],Ae([10,11]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[165],Ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ce[166],Ae([10,11]),function(ee,e){return ee.create("vs/platform/log/common/log",e)}),define(Ce[167],Ae([10,11]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ce[168],Ae([10,11]),function(ee,e){return ee.create("vs/platform/request/common/request",e)}),define(Ce[169],Ae([10,11]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[170],Ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[171],Ae([10,11]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ce[172],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[173],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[174],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[175],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[176],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[177],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[178],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[179],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[180],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[181],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[182],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[183],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[184],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/common/configuration",e)}),define(Ce[185],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ce[186],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ce[187],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[188],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[189],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[190],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[191],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[192],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[193],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[194],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[195],Ae([10,11]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[196],Ae([1,0,14,162]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var C;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(C||(e.TokenType=C={}));function O(...E){switch(E.length){case 1:return(0,A.localize)(0,null,E[0]);case 2:return(0,A.localize)(1,null,E[0],E[1]);case 3:return(0,A.localize)(2,null,E[0],E[1],E[2]);default:return}}const N=(0,A.localize)(3,null),p=(0,A.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const S=this.d,m=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:m};this.g.push({offset:S,lexeme:m,additionalInfo:M}),this.f.push(w)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const S=this.c.substring(this.d,this.e),m=$.b.get(S);m?this.k(m):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,S=!1,m=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(p);return}const g=this.c.charCodeAt(M);if(S)S=!1;else if(g===47&&!m){M++;break}else g===91?m=!0:g===92?S=!0:g===93&&(m=!1);M++}for(;M<this.c.length&&$.a.has(this.c.charCodeAt(M));)M++;this.e=M;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=$,$.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0))),$.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ce[197],Ae([1,0,23,33,164,311]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=$,e.$Ip=E,e.$Jp=M,e.$Kp=S,e.$Lp=m,e.$Mp=w,e.$Np=g;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||N.test(s)}function E(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(N);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function M(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,c=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let d=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),d=!1);let o=0;if(s.preRelease){const f=p.exec(s.preRelease);if(f){const[,u,D,l]=f;o=Date.UTC(Number(u),Number(D)-1,Number(l))}}return{majorBase:n,majorMustEqual:i,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:d,isMinimum:s.hasGreaterEquals,notBefore:o}}function S(s,n,i){let c;typeof s=="string"?c=M(E(s)):c=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof i=="string"?t=M(E(i)):t=i,!c||!t)return!1;const d=c.majorBase,o=c.minorBase,f=c.patchBase;let u=t.majorBase,D=t.minorBase,l=t.patchBase;const v=t.notBefore;let b=t.majorMustEqual,P=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?d>u?!0:d<u?!1:o>D?!0:o<D||h&&h<v?!1:f>=l:(d===1&&u===0&&(!b||!P||!k)&&(u=1,D=0,l=0,b=!0,P=!1,k=!1),d<u?!1:d>u?!b:o<D?!1:o>D?!P:f<l?!1:f>l?!k:!(h&&h<v))}function m(s,n,i,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([A.default.Error,C.localize(0,null)]),t;if(typeof c.name!="string")return t.push([A.default.Error,C.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([A.default.Error,C.localize(2,null,"version")]),t;if(!c.engines)return t.push([A.default.Error,C.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([A.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([A.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([A.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([A.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([A.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([A.default.Error,C.localize(9,null,"main")]),t;{const f=(0,y.$0g)(i,c.main);(0,y.$4g)(f,i)||t.push([A.default.Warning,C.localize(10,null,f.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([A.default.Error,C.localize(11,null,"browser")]),t;{const f=(0,y.$0g)(i,c.browser);(0,y.$4g)(f,i)||t.push([A.default.Warning,C.localize(12,null,f.path,i.path)])}}if(!O.valid(c.version))return t.push([A.default.Error,C.localize(13,null)]),t;const d=[];if(!w(s,n,c,h,d))for(const f of d)t.push([A.default.Error,f]);return t}function w(s,n,i,c,h){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,h)}function g(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,c=[]){const h=M(E(i));if(!h)return c.push(C.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,i)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,i)),!1;return S(s,n,h)?!0:(c.push(C.localize(17,null,s,i)),!1)}function a(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Ce[71],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class y{constructor(C,O=[],N=!1){this.ctor=C,this.staticArguments=O,this.supportsDelayedInstantiation=N}}e.$ti=y}),define(Ce[56],Ae([1,0,71]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ys=O,e.$zs=N;const A=[];var C;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function O(p,$,E){$ instanceof y.$ti||($=new y.$ti($,[],!!E)),A.push([p,$])}function N(){return A}}),define(Ce[198],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;class y{constructor(O,N){this.key=O,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$br=y;class A{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const N of this.a.values())N.outgoing.size===0&&O.push(N);return O}insertEdge(O,N){const p=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(N);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(O){const N=this.b(O);this.a.delete(N);for(const p of this.a.values())p.outgoing.delete(N),p.incoming.delete(N)}lookupOrInsertNode(O){const N=this.b(O);let p=this.a.get(N);return p||(p=new y(N,O),this.a.set(N,p)),p}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[N,p]of this.a)O.push(`${N}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,N]of this.a){const p=new Set([O]),$=this.c(N,p);if($)return $}}c(O,N){for(const[p,$]of O.outgoing){if(N.has(p))return[...N,p].join(" -> ");N.add(p);const E=this.c($,N);if(E)return E;N.delete(p)}}}e.$cr=A}),define(Ce[3],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=C,e.$xi=O;var y;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function p($){return $[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=p})(y||(e._util=y={})),e.$vi=C("instantiationService");function A(N,p,$){p[y.DI_TARGET]===p?p[y.DI_DEPENDENCIES].push({id:N,index:$}):(p[y.DI_DEPENDENCIES]=[{id:N,index:$}],p[y.DI_TARGET]=p)}function C(N){if(y.serviceIds.has(N))return y.serviceIds.get(N);const p=function($,E,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(p,$,M)};return p.toString=()=>N,y.serviceIds.set(N,p),p}function O(N){return N}}),define(Ce[50],Ae([1,0,15,2,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=O,e.$5i=N,e.$6i=$,e.$7i=E,e.$8i=M,e.$9i=S,e.$0i=m,e.$$i=g,e.$_i=r,e.$aj=a,e.$3i=(0,C.$wi)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof A.URI)}function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof A.URI)}var p;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function M(s,n){const i=Object.create(null);for(const c in s)S(i,c,s[c],n);return i}function S(s,n,i,c){const h=n.split("."),t=h.pop();let d=s;for(let o=0;o<h.length;o++){const f=h[o];let u=d[f];switch(typeof u){case"undefined":u=d[f]=Object.create(null);break;case"object":if(u===null){c(`Ignoring ${n} as ${h.slice(0,o+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(u)}`);return}d=u}if(typeof d=="object"&&d!==null)try{d[t]=i}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(d)}`)}function m(s,n){const i=n.split(".");w(s,i)}function w(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const c=s[i];typeof c=="object"&&!Array.isArray(c)&&(w(c,n),Object.keys(c).length===0&&delete s[i])}}function g(s,n,i){function c(d,o){let f=d;for(const u of o){if(typeof f!="object"||f===null)return;f=f[u]}return f}const h=n.split("."),t=c(s,h);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?y.$$f(s[c])&&y.$$f(n[c])?r(s[c],n[c],i):i&&(s[c]=n[c]):s[c]=n[c])})}function a(s){return s.replace(/[\[\]]/g,"")}}),define(Ce[31],Ae([1,0,22,13,196,3,161,14]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=E,e.$vj=d,e.$wj=o,e.$Pj=ke;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",y.$d),$.set("isLinux",y.$e),$.set("isWindows",y.$c),$.set("isWeb",y.$i),$.set("isMacNative",y.$d&&!y.$i),$.set("isEdge",y.$B),$.set("isFirefox",y.$z),$.set("isChrome",y.$y),$.set("isSafari",y.$A);function E(re,H){if($.get(re)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(re,H)}const M=Object.prototype.hasOwnProperty;var S;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const m={regexParsingWithErrorRecovery:!0},w=(0,N.localize)(0,null),g=(0,N.localize)(1,null),r=(0,N.localize)(2,null),a=(0,N.localize)(3,null),s=(0,N.localize)(4,null),n=(0,N.localize)(5,null),i=(0,N.localize)(6,null),c=(0,N.localize)(7,null);class h{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(H=m){this.k=H,this.d=new C.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(H){if(H===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(H).scan(),this.g=0,this.h=[];try{const he=this.l();if(!this.E()){const Fe=this.D(),pe=Fe.type===17?n:void 0;throw this.h.push({message:s,offset:Fe.offset,lexeme:C.$rj.getLexeme(Fe),additionalInfo:pe}),h.c}return he}catch(he){if(he!==h.c)throw he;return}}l(){return this.m()}m(){const H=[this.o()];for(;this.y(16);){const he=this.o();H.push(he)}return H.length===1?H[0]:t.or(...H)}o(){const H=[this.s()];for(;this.y(15);){const he=this.s();H.push(he)}return H.length===1?H[0]:t.and(...H)}s(){if(this.y(2)){const H=this.D();switch(H.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),D.INSTANCE;case 0:{this.z();const he=this.l();return this.A(1,a),he?.negate()}case 17:return this.z(),I.create(H.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",H)}}return this.t()}t(){const H=this.D();switch(H.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const he=this.l();return this.A(1,a),he}case 17:{const he=H.lexeme;if(this.z(),this.y(9)){const pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),pe.type!==10)throw this.B("REGEX",pe);const be=pe.lexeme,ge=be.lastIndexOf("/"),ae=ge===be.length-1?void 0:this.w(be.substring(ge+1));let K;try{K=new RegExp(be.substring(1,ge),ae)}catch{throw this.B("REGEX",pe)}return F.create(he,K)}switch(pe.type){case 10:case 19:{const be=[pe.lexeme];this.z();let ge=this.D(),ae=0;for(let Me=0;Me<pe.lexeme.length;Me++)pe.lexeme.charCodeAt(Me)===40?ae++:pe.lexeme.charCodeAt(Me)===41&&ae--;for(;!this.E()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let Me=0;Me<ge.lexeme.length;Me++)ge.lexeme.charCodeAt(Me)===40?ae++:pe.lexeme.charCodeAt(Me)===41&&ae--}if(ae<0)break;be.push(C.$rj.getLexeme(ge)),this.z(),ge=this.D()}const K=be.join(""),Z=K.lastIndexOf("/"),fe=Z===K.length-1?void 0:this.w(K.substring(Z+1));let le;try{le=new RegExp(K.substring(1,Z),fe)}catch{throw this.B("REGEX",pe)}return t.regex(he,le)}case 18:{const be=pe.lexeme;this.z();let ge=null;if(!(0,A.$8e)(be)){const ae=be.indexOf("/"),K=be.lastIndexOf("/");if(ae!==K&&ae>=0){const Z=be.slice(ae+1,K),fe=be[K+1]==="i"?"i":"";try{ge=new RegExp(Z,fe)}catch{throw this.B("REGEX",pe)}}}if(ge===null)throw this.B("REGEX",pe);return F.create(he,ge)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const pe=this.u();return t.notIn(he,pe)}switch(this.D().type){case 3:{this.z();const pe=this.u();if(this.x().type===18)return t.equals(he,pe);switch(pe){case"true":return t.has(he);case"false":return t.not(he);default:return t.equals(he,pe)}}case 4:{this.z();const pe=this.u();if(this.x().type===18)return t.notEquals(he,pe);switch(pe){case"true":return t.not(he);case"false":return t.has(he);default:return t.notEquals(he,pe)}}case 5:return this.z(),L.create(he,this.u());case 6:return this.z(),R.create(he,this.u());case 7:return this.z(),Q.create(he,this.u());case 8:return this.z(),G.create(he,this.u());case 13:return this.z(),t.in(he,this.u());default:return t.has(he)}}case 20:throw this.h.push({message:i,offset:H.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const H=this.D();switch(H.type){case 17:case 18:return this.z(),H.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(H){return H.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(H){return this.C(H)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(H,he){if(this.C(H))return this.z();throw this.B(he,this.D())}B(H,he,Fe){const pe=(0,N.localize)(8,null,H,C.$rj.getLexeme(he)),be=he.offset,ge=C.$rj.getLexeme(he);return this.h.push({message:pe,offset:be,lexeme:ge,additionalInfo:Fe}),h.c}C(H){return this.D().type===H}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=h,h.c=new Error;class t{static false(){return u.INSTANCE}static true(){return D.INSTANCE}static has(H){return l.create(H)}static equals(H,he){return v.create(H,he)}static notEquals(H,he){return k.create(H,he)}static regex(H,he){return F.create(H,he)}static in(H,he){return b.create(H,he)}static notIn(H,he){return P.create(H,he)}static not(H){return I.create(H)}static and(...H){return ne.create(H,null,!0)}static or(...H){return me.create(H,null,!0)}static greater(H,he){return Q.create(H,he)}static greaterEquals(H,he){return G.create(H,he)}static smaller(H,he){return L.create(H,he)}static smallerEquals(H,he){return R.create(H,he)}static deserialize(H){return H==null?void 0:this.c.parse(H)}}e.$uj=t,t.c=new h({regexParsingWithErrorRecovery:!1});function d(re){const H=new h({regexParsingWithErrorRecovery:!1});return re.map(he=>(H.parse(he),H.lexingErrors.length>0?H.lexingErrors.map(Fe=>({errorMessage:Fe.additionalInfo?(0,N.localize)(9,null,Fe.additionalInfo):(0,N.localize)(10,null),offset:Fe.offset,length:Fe.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(Fe=>({errorMessage:Fe.additionalInfo?`${Fe.message}. ${Fe.additionalInfo}`:Fe.message,offset:Fe.offset,length:Fe.lexeme.length})):[]))}function o(re,H){const he=re?re.substituteConstants():void 0,Fe=H?H.substituteConstants():void 0;return!he&&!Fe?!0:!he||!Fe?!1:he.equals(Fe)}function f(re,H){return re.cmp(H)}class u{constructor(){this.type=0}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return D.INSTANCE}}e.$xj=u,u.INSTANCE=new u;class D{constructor(){this.type=1}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return u.INSTANCE}}e.$yj=D,D.INSTANCE=new D;class l{static create(H,he=null){const Fe=$.get(H);return typeof Fe=="boolean"?Fe?D.INSTANCE:u.INSTANCE:new l(H,he)}constructor(H,he){this.key=H,this.c=he,this.type=2}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=$.get(this.key);return typeof H=="boolean"?H?D.INSTANCE:u.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$zj=l;class v{static create(H,he,Fe=null){if(typeof he=="boolean")return he?l.create(H,Fe):I.create(H,Fe);const pe=$.get(H);return typeof pe=="boolean"?he===(pe?"true":"false")?D.INSTANCE:u.INSTANCE:new v(H,he,Fe)}constructor(H,he,Fe){this.c=H,this.d=he,this.f=Fe,this.type=4}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=$.get(this.c);if(typeof H=="boolean"){const he=H?"true":"false";return this.d===he?D.INSTANCE:u.INSTANCE}return this}evaluate(H){return H.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(H){return H.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Aj=v;class b{static create(H,he){return new b(H,he)}constructor(H,he){this.d=H,this.f=he,this.type=10,this.c=null}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.d,this.f,H.d,H.f)}equals(H){return H.type===this.type?this.d===H.d&&this.f===H.f:!1}substituteConstants(){return this}evaluate(H){const he=H.getValue(this.f),Fe=H.getValue(this.d);return Array.isArray(he)?he.includes(Fe):typeof Fe=="string"&&typeof he=="object"&&he!==null?M.call(he,Fe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(H){return H.mapIn(this.d,this.f)}negate(){return this.c||(this.c=P.create(this.d,this.f)),this.c}}e.$Bj=b;class P{static create(H,he){return new P(H,he)}constructor(H,he){this.d=H,this.f=he,this.type=11,this.c=b.create(H,he)}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(H){return H.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=P;class k{static create(H,he,Fe=null){if(typeof he=="boolean")return he?I.create(H,Fe):l.create(H,Fe);const pe=$.get(H);return typeof pe=="boolean"?he===(pe?"true":"false")?u.INSTANCE:D.INSTANCE:new k(H,he,Fe)}constructor(H,he,Fe){this.c=H,this.d=he,this.f=Fe,this.type=5}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=$.get(this.c);if(typeof H=="boolean"){const he=H?"true":"false";return this.d===he?u.INSTANCE:D.INSTANCE}return this}evaluate(H){return H.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(H){return H.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Dj=k;class I{static create(H,he=null){const Fe=$.get(H);return typeof Fe=="boolean"?Fe?u.INSTANCE:D.INSTANCE:new I(H,he)}constructor(H,he){this.c=H,this.d=he,this.type=3}cmp(H){return H.type!==this.type?this.type-H.type:de(this.c,H.c)}equals(H){return H.type===this.type?this.c===H.c:!1}substituteConstants(){const H=$.get(this.c);return typeof H=="boolean"?H?u.INSTANCE:D.INSTANCE:this}evaluate(H){return!H.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(H){return H.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Ej=I;function U(re,H){if(typeof re=="string"){const he=parseFloat(re);isNaN(he)||(re=he)}return typeof re=="string"||typeof re=="number"?H(re):u.INSTANCE}class Q{static create(H,he,Fe=null){return U(he,pe=>new Q(H,pe,Fe))}constructor(H,he,Fe){this.c=H,this.d=he,this.f=Fe,this.type=12}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Fj=Q;class G{static create(H,he,Fe=null){return U(he,pe=>new G(H,pe,Fe))}constructor(H,he,Fe){this.c=H,this.d=he,this.f=Fe,this.type=13}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Gj=G;class L{static create(H,he,Fe=null){return U(he,pe=>new L(H,pe,Fe))}constructor(H,he,Fe){this.c=H,this.d=he,this.f=Fe,this.type=14}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Hj=L;class R{static create(H,he,Fe=null){return U(he,pe=>new R(H,pe,Fe))}constructor(H,he,Fe){this.c=H,this.d=he,this.f=Fe,this.type=15}cmp(H){return H.type!==this.type?this.type-H.type:$e(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Ij=R;class F{static create(H,he){return new F(H,he)}constructor(H,he){this.d=H,this.f=he,this.type=7,this.c=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.d<H.d)return-1;if(this.d>H.d)return 1;const he=this.f?this.f.source:"",Fe=H.f?H.f.source:"";return he<Fe?-1:he>Fe?1:0}equals(H){if(H.type===this.type){const he=this.f?this.f.source:"",Fe=H.f?H.f.source:"";return this.d===H.d&&he===Fe}return!1}substituteConstants(){return this}evaluate(H){const he=H.getValue(this.d);return this.f?this.f.test(he):!1}serialize(){const H=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${H}`}keys(){return[this.d]}map(H){return H.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=T.create(this)),this.c}}e.$Jj=F;class T{static create(H){return new T(H)}constructor(H){this.c=H,this.type=8}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(H){return new T(this.c.map(H))}negate(){return this.c}}e.$Kj=T;function X(re){let H=null;for(let he=0,Fe=re.length;he<Fe;he++){const pe=re[he].substituteConstants();if(re[he]!==pe&&H===null){H=[];for(let be=0;be<he;be++)H[be]=re[be]}H!==null&&(H[he]=pe)}return H===null?re:H}class ne{static create(H,he,Fe){return ne.d(H,he,Fe)}constructor(H,he){this.expr=H,this.c=he,this.type=6}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let he=0,Fe=this.expr.length;he<Fe;he++){const pe=f(this.expr[he],H.expr[he]);if(pe!==0)return pe}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let he=0,Fe=this.expr.length;he<Fe;he++)if(!this.expr[he].equals(H.expr[he]))return!1;return!0}return!1}substituteConstants(){const H=X(this.expr);return H===this.expr?this:ne.create(H,this.c,!1)}evaluate(H){for(let he=0,Fe=this.expr.length;he<Fe;he++)if(!this.expr[he].evaluate(H))return!1;return!0}static d(H,he,Fe){const pe=[];let be=!1;for(const ge of H)if(ge){if(ge.type===1){be=!0;continue}if(ge.type===0)return u.INSTANCE;if(ge.type===6){pe.push(...ge.expr);continue}pe.push(ge)}if(pe.length===0&&be)return D.INSTANCE;if(pe.length!==0){if(pe.length===1)return pe[0];pe.sort(f);for(let ge=1;ge<pe.length;ge++)pe[ge-1].equals(pe[ge])&&(pe.splice(ge,1),ge--);if(pe.length===1)return pe[0];for(;pe.length>1;){const ge=pe[pe.length-1];if(ge.type!==9)break;pe.pop();const ae=pe.pop(),K=pe.length===0,Z=me.create(ge.expr.map(fe=>ne.create([fe,ae],null,Fe)),null,K);Z&&(pe.push(Z),pe.sort(f))}if(pe.length===1)return pe[0];if(Fe){for(let ge=0;ge<pe.length;ge++)for(let ae=ge+1;ae<pe.length;ae++)if(pe[ge].negate().equals(pe[ae]))return u.INSTANCE;if(pe.length===1)return pe[0]}return new ne(pe,he)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const he of this.expr)H.push(...he.keys());return H}map(H){return new ne(this.expr.map(he=>he.map(H)),null)}negate(){if(!this.c){const H=[];for(const he of this.expr)H.push(he.negate());this.c=me.create(H,this,!0)}return this.c}}e.$Lj=ne;class me{static create(H,he,Fe){return me.d(H,he,Fe)}constructor(H,he){this.expr=H,this.c=he,this.type=9}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let he=0,Fe=this.expr.length;he<Fe;he++){const pe=f(this.expr[he],H.expr[he]);if(pe!==0)return pe}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let he=0,Fe=this.expr.length;he<Fe;he++)if(!this.expr[he].equals(H.expr[he]))return!1;return!0}return!1}substituteConstants(){const H=X(this.expr);return H===this.expr?this:me.create(H,this.c,!1)}evaluate(H){for(let he=0,Fe=this.expr.length;he<Fe;he++)if(this.expr[he].evaluate(H))return!0;return!1}static d(H,he,Fe){let pe=[],be=!1;if(H){for(let ge=0,ae=H.length;ge<ae;ge++){const K=H[ge];if(K){if(K.type===0){be=!0;continue}if(K.type===1)return D.INSTANCE;if(K.type===9){pe=pe.concat(K.expr);continue}pe.push(K)}}if(pe.length===0&&be)return u.INSTANCE;pe.sort(f)}if(pe.length!==0){if(pe.length===1)return pe[0];for(let ge=1;ge<pe.length;ge++)pe[ge-1].equals(pe[ge])&&(pe.splice(ge,1),ge--);if(pe.length===1)return pe[0];if(Fe){for(let ge=0;ge<pe.length;ge++)for(let ae=ge+1;ae<pe.length;ae++)if(pe[ge].negate().equals(pe[ae]))return D.INSTANCE;if(pe.length===1)return pe[0]}return new me(pe,he)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const he of this.expr)H.push(...he.keys());return H}map(H){return new me(this.expr.map(he=>he.map(H)),null)}negate(){if(!this.c){const H=[];for(const he of this.expr)H.push(he.negate());for(;H.length>1;){const he=H.shift(),Fe=H.shift(),pe=[];for(const be of Pe(he))for(const ge of Pe(Fe))pe.push(ne.create([be,ge],null,!1));H.unshift(me.create(pe,null,!1))}this.c=me.create(H,this,!0)}return this.c}}e.$Mj=me;class we extends l{static all(){return we.d.values()}constructor(H,he,Fe){super(H,null),this.f=he,typeof Fe=="object"?we.d.push({...Fe,key:H}):Fe!==!0&&we.d.push({key:H,description:Fe,type:he!=null?typeof he:void 0})}bindTo(H){return H.createKey(this.key,this.f)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return v.create(this.key,H)}notEqualsTo(H){return k.create(this.key,H)}}e.$Nj=we,we.d=[],e.$Oj=(0,O.$wi)("contextKeyService");function de(re,H){return re<H?-1:re>H?1:0}function $e(re,H,he,Fe){return re<he?-1:re>he?1:H<Fe?-1:H>Fe?1:0}function ke(re,H){if(re.type===0||H.type===1)return!0;if(re.type===9)return H.type===9?se(re.expr,H.expr):!1;if(H.type===9){for(const he of H.expr)if(ke(re,he))return!0;return!1}if(re.type===6){if(H.type===6)return se(H.expr,re.expr);for(const he of re.expr)if(ke(he,H))return!0;return!1}return re.equals(H)}function se(re,H){let he=0,Fe=0;for(;he<re.length&&Fe<H.length;){const pe=re[he].cmp(H[Fe]);if(pe<0)return!1;pe===0&&he++,Fe++}return he===re.length}function Pe(re){return re.type===9?re.expr:[re]}}),define(Ce[99],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,y.$wi)("environmentService"),e.$Ei=(0,y.$xi)(e.$Di)}),define(Ce[100],Ae([1,0,163,3]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.ExtensionGalleryErrorCode=e.$8o=e.ExtensionManagementErrorCode=e.$7o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$1o=C,e.$2o=O,e.$3o=N,e.$4o=p,e.$5o=$,e.$6o=E,e.$Uo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vo=new RegExp(e.$Uo),e.$Wo="__web_extension",e.$Xo="skipWalkthrough",e.$Yo="extensionsSync",e.$Zo="dependecyOrPackExtensionInstall";function C(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function N(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(n,i){return i==="web"&&!n.includes("web")}function $(n,i,c){return p(i,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var M;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var S;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var m;(function(n){n.Install="install",n.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var w;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$7o=(0,A.$wi)("extensionGalleryService");var g;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));class r extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$8o=r;var a;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class s extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$9o=s,e.$0o=(0,A.$wi)("extensionManagementService"),e.$$o="extensionsIdentifiers/disabled",e.$_o="extensionsIdentifiers/enabled",e.$ap=(0,A.$wi)("IGlobalExtensionEnablementService"),e.$bp=(0,A.$wi)("IExtensionTipsService"),e.$cp=(0,y.localize2)(0,"Extensions"),e.$dp=(0,y.localize2)(1,"Preferences")}),define(Ce[38],Ae([1,0,54,19,13,15,2,165,3,22,16,43]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=m,e.$5k=a,e.$6k=n,e.$7k=i,e.$8k=c,e.$9k=h,e.$0k=t,e.$$k=d,e.$_k=o,e.$al=f,e.$bl=u,e.$dl=v,e.$el=b,e.$fl=P,e.$gl=k,e.$hl=I,e.$kl=R,e.$wl=we,e.$xl=de,e.$zl=ke,e.$3k=(0,$.$wi)("fileService");function m(se){return se.create===!0}var w;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var g;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var r;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function a(se){const Pe=se;return!!Pe&&typeof Pe.onDidChange=="function"}var s;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function n(se){return!!(se.capabilities&2)}function i(se){return!!(se.capabilities&8)}function c(se){return!!(se.capabilities&131072)}function h(se){return!!(se.capabilities&4)}function t(se){return!!(se.capabilities&16)}function d(se){return n(se)?!!(se.capabilities&16384):!1}function o(se){return n(se)?!!(se.capabilities&32768):!1}function f(se){return!!(se.capabilities&65536)}function u(se){return!!(se.capabilities&2048)}var D;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class l extends Error{static create(Pe,re){const H=new l(Pe.toString(),re);return P(H,re),H}constructor(Pe,re){super(Pe),this.code=re}}e.$cl=l;function v(se,Pe){return l.create(se,Pe)}function b(se){return se||v((0,p.localize)(0,null),D.Unknown)}function P(se,Pe){return se.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",se}function k(se){if(!se)return D.Unknown;if(se instanceof l)return se.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Pe)return D.Unknown;switch(Pe[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}function I(se){if(se instanceof F)return se.fileOperationResult;switch(k(se)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 9;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileTooLarge:return 7;default:return 10}}var U;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(U||(e.FileOperation=U={}));class Q{constructor(Pe,re,H){this.resource=Pe,this.operation=re,this.target=H}isOperation(Pe){return this.operation===Pe}}e.$il=Q;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class L{constructor(Pe,re){this.c=re,this.b=void 0,this.d=new S.$V(()=>{const H=y.$Ci.forUris(()=>this.c);return H.fill(this.rawAdded.map(he=>[he,!0])),H}),this.f=new S.$V(()=>{const H=y.$Ci.forUris(()=>this.c);return H.fill(this.rawUpdated.map(he=>[he,!0])),H}),this.g=new S.$V(()=>{const H=y.$Ci.forUris(()=>this.c);return H.fill(this.rawDeleted.map(he=>[he,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of Pe){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==L.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=L.a):this.b!==void 0&&(this.b=L.a))}}contains(Pe,...re){return this.h(Pe,{includeChildren:!1},...re)}affects(Pe,...re){return this.h(Pe,{includeChildren:!0},...re)}h(Pe,re,...H){if(!Pe)return!1;const he=H.length>0;return!!((!he||H.includes(1))&&(this.d.value.get(Pe)||re.includeChildren&&this.d.value.findSuperstr(Pe))||(!he||H.includes(0))&&(this.f.value.get(Pe)||re.includeChildren&&this.f.value.findSuperstr(Pe))||(!he||H.includes(2))&&(this.g.value.findSubstr(Pe)||re.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$jl=L,L.a=null;function R(se,Pe,re){return!se||!Pe||se===Pe||Pe.length>se.length?!1:(Pe.charAt(Pe.length-1)!==A.sep&&(Pe+=A.sep),re?(0,C.$zf)(se,Pe):se.indexOf(Pe)===0)}class F extends Error{constructor(Pe,re,H){super(Pe),this.fileOperationResult=re,this.options=H}}e.$ll=F;class T extends F{constructor(Pe,re,H,he){super(Pe,re,he),this.fileOperationResult=re,this.size=H}}e.$ml=T;class X extends F{constructor(Pe,re,H){super(Pe,2,H),this.stat=re}}e.$nl=X;var ne;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var me;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$vl="";function we(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function de(se,Pe){if(!Pe.hasProvider(N.URI.from({scheme:se.scheme})))return new Promise(re=>{const H=Pe.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===se.scheme&&he.added&&(H.dispose(),re())})})}class $e{static formatSize(Pe){return(0,O.$ag)(Pe)||(Pe=0),Pe<$e.KB?(0,p.localize)(1,null,Pe.toFixed(0)):Pe<$e.MB?(0,p.localize)(2,null,(Pe/$e.KB).toFixed(2)):Pe<$e.GB?(0,p.localize)(3,null,(Pe/$e.MB).toFixed(2)):Pe<$e.TB?(0,p.localize)(4,null,(Pe/$e.GB).toFixed(2)):(0,p.localize)(5,null,(Pe/$e.TB).toFixed(2))}}e.$yl=$e,$e.KB=1024,$e.MB=$e.KB*$e.KB,$e.GB=$e.MB*$e.KB,$e.TB=$e.GB*$e.KB;function ke(se){const Pe=typeof se=="string"||se?.scheme===M.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===M.Schemas.file?1024*$e.MB:Pe?10*$e.MB:E.$i?50*$e.MB:1024*$e.MB}}),define(Ce[72],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class y{constructor(...C){this.a=new Map;for(const[O,N]of C)this.set(O,N)}set(C,O){const N=this.a.get(C);return this.a.set(C,O),N}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$ui=y}),define(Ce[199],Ae([1,0,9,14,6,71,198,3,72,200]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;const M=!1;class S extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class m{constructor(a=new $.$ui,s=!1,n,i=M){this.i=a,this.j=s,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$vi,this),this._globalGraph=i?n?._globalGraph??new N.$cr(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Qc)(this.h),this.h.clear();for(const a of this.g)(0,C.$Pc)(a)&&a.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(a){this.m();const s=new class extends m{dispose(){this.h.delete(s),super.dispose()}}(a,this.j,this,this.l);return this.h.add(s),s}invokeFunction(a,...s){this.m();const n=g.traceInvocation(this.l,a);let i=!1;try{return a({get:h=>{if(i)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(a,...s){this.m();let n,i;return a instanceof O.$ti?(n=g.traceCreation(this.l,a.ctor),i=this.o(a.ctor,a.staticArguments.concat(s),n)):(n=g.traceCreation(this.l,a),i=this.o(a,s,n)),n.stop(),i}o(a,s=[],n){const i=p._util.getServiceDependencies(a).sort((t,d)=>t.index-d.index),c=[];for(const t of i){const d=this.s(t.id,n);d||this.y(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(d)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(a,s.concat(c))}q(a,s){if(this.i.get(a)instanceof O.$ti)this.i.set(a,s);else if(this.k)this.k.q(a,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(a){const s=this.i.get(a);return!s&&this.k?this.k.r(a):s}s(a,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.r(a);return n instanceof O.$ti?this.u(a,n,s.branch(a,!0)):(s.branch(a,!1),n)}u(a,s,n){if(this.t.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.t.add(a);try{return this.v(a,s,n)}finally{this.t.delete(a)}}v(a,s,n){const i=new N.$cr(t=>t.id.toString());let c=0;const h=[{id:a,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new S(i);for(const d of p._util.getServiceDependencies(t.desc.ctor)){const o=this.r(d.id);if(o||this.y(`[createInstance] ${a} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),o instanceof O.$ti){const f={id:d.id,desc:o,_trace:t._trace.branch(d.id,!0)};i.insertEdge(t,f),h.push(f)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new S(i);break}for(const{data:d}of t){if(this.r(d.id)instanceof O.$ti){const f=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,f)}i.removeNode(d)}}return this.r(a)}w(a,s,n=[],i,c){if(this.i.get(a)instanceof O.$ti)return this.x(a,s,n,i,c,this.g);if(this.k)return this.k.w(a,s,n,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(a,s,n=[],i,c,h){if(i){const t=new m(void 0,this.j,this,this.l);t.c=String(a);const d=new Map,o=new y.$Ph(()=>{const f=t.o(s,n,c);for(const[u,D]of d){const l=f[u];if(typeof l=="function")for(const v of D)v.disposable=l.apply(f,v.listener)}return d.clear(),h.add(f),f});return new Proxy(Object.create(null),{get(f,u){if(!o.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let v=d.get(u);return v||(v=new E.$6c,d.set(u,v)),(P,k,I)=>{if(o.isInitialized)return o.value[u](P,k,I);{const U={listener:[P,k,I],disposable:void 0},Q=v.push(U);return(0,C.$Tc)(()=>{Q(),U.disposable?.dispose()})}}}if(u in f)return f[u];const D=o.value;let l=D[u];return typeof l!="function"||(l=l.bind(D),f[u]=l),l},set(f,u,D){return o.value[u]=D,!0},getPrototypeOf(f){return s.prototype}})}else{const t=this.o(s,n,c);return h.add(t),t}}y(a,s){if(s&&console.warn(a),this.j)throw new Error(a)}}e.$dr=m;var w;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(w||(w={}));class g{static traceInvocation(a,s){return a?new g(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(a,s){return a?new g(1,s.name):g.c}constructor(a,s){this.type=a,this.name=s,this.g=Date.now(),this.h=[]}branch(a,s){const n=new g(3,a.toString());return this.h.push([a,s,n]),n}stop(){const a=Date.now()-this.g;g.f+=a;let s=!1;function n(c,h){const t=[],d=new Array(c+1).join("	");for(const[o,f,u]of h.h)if(f&&u){s=!0,t.push(`${d}CREATES -> ${o}`);const D=n(c+1,u);D&&t.push(D)}else t.push(`${d}uses -> ${o}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(a>2||s)&&g.all.add(i.join(`
`))}}e.$er=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(Ce[12],Ae([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=r,e.log=s,e.$ek=l,e.$fk=v,e.$gk=b,e.$hk=P,e.$3j=(0,w.$wi)("logService"),e.$4j=(0,w.$wi)("loggerService");function g(){return new Date().toISOString()}function r(k){return(0,M.$ag)(k)}var a;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$6j=a.Info;function s(k,I,U){switch(I){case a.Trace:k.trace(U);break;case a.Debug:k.debug(U);break;case a.Info:k.info(U);break;case a.Warning:k.warn(U);break;case a.Error:k.error(U);break;case a.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function n(k,I=!1){let U="";for(let Q=0;Q<k.length;Q++){let G=k[Q];if(G instanceof Error&&(G=(0,A.$hj)(G,I)),typeof G=="object")try{G=JSON.stringify(G)}catch{}U+=(Q>0?" ":"")+G}return U}class i extends N.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new C.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==a.Off&&this.b<=I}}e.$8j=i;class c extends i{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...U){this.f(a.Trace)&&this.g(a.Trace,n([I,...U],!0))}debug(I,...U){this.f(a.Debug)&&this.g(a.Debug,n([I,...U]))}info(I,...U){this.f(a.Info)&&this.g(a.Info,n([I,...U]))}warn(I,...U){this.f(a.Warning)&&this.g(a.Warning,n([I,...U]))}error(I,...U){if(this.f(a.Error))if(I instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=I.stack,this.g(a.Error,n(Q))}else this.g(a.Error,n([I,...U]))}flush(){}}e.$9j=c;class h extends i{constructor(I=e.$6j){super(),this.setLevel(I),this.g=!$.$c}trace(I,...U){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...U):console.log(`[main ${g()}]`,I,...U))}debug(I,...U){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...U):console.log(`[main ${g()}]`,I,...U))}info(I,...U){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...U):console.log(`[main ${g()}]`,I,...U))}warn(I,...U){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,I,...U):console.warn(`[main ${g()}]`,I,...U))}error(I,...U){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,I,...U):console.error(`[main ${g()}]`,I,...U))}flush(){}}e.$0j=h;class t extends i{constructor(I=e.$6j,U=!0){super(),this.g=U,this.setLevel(I)}trace(I,...U){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...U):console.log(I,...U))}debug(I,...U){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...U):console.log(I,...U))}info(I,...U){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...U):console.log(I,...U))}warn(I,...U){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...U):console.log(I,...U))}error(I,...U){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...U):console.error(I,...U))}flush(){}}e.$$j=t;class d extends i{constructor(I,U=e.$6j){super(),this.g=I,this.setLevel(U)}trace(I,...U){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(I),...U])}debug(I,...U){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(I),...U])}info(I,...U){this.f(a.Info)&&this.g.log(a.Info,[this.h(I),...U])}warn(I,...U){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(I),...U])}error(I,...U){this.f(a.Error)&&this.g.log(a.Error,[this.h(I),...U])}h(I){return typeof I=="string"?I:(0,A.$hj)(I,this.f(a.Trace))}flush(){}}e.$_j=d;class o extends i{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const U of this.g)U.setLevel(I);super.setLevel(I)}trace(I,...U){for(const Q of this.g)Q.trace(I,...U)}debug(I,...U){for(const Q of this.g)Q.debug(I,...U)}info(I,...U){for(const Q of this.g)Q.info(I,...U)}warn(I,...U){for(const Q of this.g)Q.warn(I,...U)}error(I,...U){for(const Q of this.g)Q.error(I,...U)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ak=o;class f extends N.$Vc{constructor(I,U,Q){if(super(),this.h=I,this.j=U,this.b=new p.$Bc,this.c=this.B(new C.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$ee),this.onDidChangeVisibility=this.g.event,Q)for(const G of Q)this.b.set(G.resource,{logger:void 0,info:G})}m(I){return(0,M.$9f)(I)?[...this.b.values()].find(U=>U.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,U){const Q=this.n(I),G=(0,M.$9f)(I)?I:U?.id??(0,O.$kj)(Q.toString()).toString(16);let L=this.b.get(Q)?.logger;const R=U?.logLevel==="always"?a.Trace:U?.logLevel;L||(L=this.s(Q,R??this.getLogLevel(Q)??this.h,{...U,id:G}));const F={logger:L,info:{resource:Q,id:G,logLevel:R,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(F.info),this.b.set(Q,F),L}n(I){return(0,M.$9f)(I)?(0,E.$0g)(this.j,`${I}.log`):I}setLogLevel(I,U){if(S.URI.isUri(I)){const Q=I,G=U,L=this.b.get(Q);L&&G!==L.info.logLevel&&(L.info.logLevel=G===this.h?void 0:G,L.logger?.setLevel(G),this.b.set(L.info.resource,L),this.f.fire([Q,G]))}else{this.h=I;for(const[Q,G]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&G.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,U){const Q=this.m(I);Q&&U!==!Q.info.hidden&&(Q.info.hidden=!U,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,U]))}getLogLevel(I){let U;return I&&(U=this.b.get(I)?.info.logLevel),U??this.h}registerLogger(I){const U=this.b.get(I.resource);U?U.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const U=this.b.get(I);U&&(U.logger&&U.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=f;class u{constructor(){this.onDidChangeLogLevel=new C.$ee().event}setLevel(I){}getLevel(){return a.Info}trace(I,...U){}debug(I,...U){}info(I,...U){}warn(I,...U){}error(I,...U){}critical(I,...U){}dispose(){}flush(){}}e.$ck=u;class D extends u{}e.$dk=D;function l(k){if(k.verbose)return a.Trace;if(typeof k.logLevel=="string"){const I=P(k.logLevel.toLowerCase());if(I!==void 0)return I}return e.$6j}function v(k){switch(k){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}function b(k){switch(k){case a.Trace:return{original:"Trace",value:y.localize(0,null)};case a.Debug:return{original:"Debug",value:y.localize(1,null)};case a.Info:return{original:"Info",value:y.localize(2,null)};case a.Warning:return{original:"Warning",value:y.localize(3,null)};case a.Error:return{original:"Error",value:y.localize(4,null)};case a.Off:return{original:"Off",value:y.localize(5,null)}}}function P(k){switch(k){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$ik=new m.$Nj("logLevel",v(a.Info))}),define(Ce[201],Ae([1,0,6,12]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WQ=void 0;class C extends y.$Vc{constructor(N,p=[]){super(),this.a=new A.$ak([N,...p]),this.B(N.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...p){this.a.trace(N,...p)}debug(N,...p){this.a.debug(N,...p)}info(N,...p){this.a.info(N,...p)}warn(N,...p){this.a.warn(N,...p)}error(N,...p){this.a.error(N,...p)}flush(){this.a.flush()}}e.$WQ=C}),define(Ce[101],Ae([1,0,33,167,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var N;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(N||(e.MarkerSeverity=N={})),function($){function E(g,r){return r-g}$.compare=E;const M=Object.create(null);M[$.Error]=(0,A.localize)(0,null),M[$.Warning]=(0,A.localize)(1,null),M[$.Info]=(0,A.localize)(2,null);function S(g){return M[g]||""}$.toString=S;function m(g){switch(g){case y.default.Error:return $.Error;case y.default.Warning:return $.Warning;case y.default.Info:return $.Info;case y.default.Ignore:return $.Hint}}$.fromSeverity=m;function w(g){switch(g){case $.Error:return y.default.Error;case $.Warning:return y.default.Warning;case $.Info:return y.default.Info;case $.Hint:return y.default.Ignore}}$.toSeverity=w}(N||(e.MarkerSeverity=N={}));var p;(function($){const E="";function M(m){return S(m,!0)}$.makeKey=M;function S(m,w){const g=[E];return m.source?g.push(m.source.replace("\xA6","\\\xA6")):g.push(E),m.code?typeof m.code=="string"?g.push(m.code.replace("\xA6","\\\xA6")):g.push(m.code.value.replace("\xA6","\\\xA6")):g.push(E),m.severity!==void 0&&m.severity!==null?g.push(N.toString(m.severity)):g.push(E),m.message&&w?g.push(m.message.replace("\xA6","\\\xA6")):g.push(E),m.startLineNumber!==void 0&&m.startLineNumber!==null?g.push(m.startLineNumber.toString()):g.push(E),m.startColumn!==void 0&&m.startColumn!==null?g.push(m.startColumn.toString()):g.push(E),m.endLineNumber!==void 0&&m.endLineNumber!==null?g.push(m.endLineNumber.toString()):g.push(E),m.endColumn!==void 0&&m.endColumn!==null?g.push(m.endColumn.toString()):g.push(E),g.push(E),g.join("\xA6")}$.makeKeyOptionalMessage=S})(p||(e.IMarkerData=p={})),e.$8t=(0,C.$wi)("markerService")}),define(Ce[202],Ae([1,0,5,33,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$$v=e.Severity=void 0,e.$_v=p,e.Severity=A.default,e.$$v=(0,C.$wi)("notificationService");var O;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var N;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(N||(e.NeverShowAgainScope=N={}));function p(S){if(S){const m=S;return typeof m.id=="string"&&typeof m.label=="string"}return!1}var $;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new M,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$aw=E;class M{infinite(){}done(){}total(m){}worked(m){}}e.$bw=M}),define(Ce[102],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,y.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(ee,e,y,A){var C=arguments.length,O=C<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,y):A,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ee,e,y,A);else for(var p=ee.length-1;p>=0;p--)(N=ee[p])&&(O=(C<3?N(O):C>3?N(e,y,O):N(e,y))||O);return C>3&&O&&Object.defineProperty(e,y,O),O},qe=this&&this.__param||function(ee,e){return function(y,A){e(y,A,ee)}};define(Ce[103],Ae([1,0,9,24,6,3]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.ProgressLocation=e.$cw=void 0,e.$cw=(0,O.$wi)("progressService");var N;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(N||(e.ProgressLocation=N={})),e.$dw=Object.freeze({total(){},worked(){},done(){}});class p{get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$ew=p,p.None=Object.freeze({report(){}});class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const w=this.d;this.d=()=>{w?.(),m()}}):Promise.resolve()}}e.$fw=$;let E=class extends C.$Vc{constructor(m,w){super(),this.a=new y.$Th,w.withProgress(m,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,C.$Tc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$gw=E,e.$gw=E=Qe([qe(1,e.$cw)],E);class M extends C.$Vc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new C.$Uc)}start(m){this.stop();const w=++this.a,g=new A.$pe;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,C.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Tc)(()=>g.cancel())),this.b.add((0,C.$Tc)(()=>this.c?this.c.done():void 0)),{id:w,token:g.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$hw=M,e.$iw=(0,O.$wi)("editorProgressService")}),define(Ce[29],Ae([1,0,57,15]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0;class C{constructor(){this.a=new Map}add(N,p){y.ok(A.$9f(N)),y.ok(A.$$f(p)),y.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,p)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$do=new C}),define(Ce[74],Ae([1,0,5,29]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=void 0,e.$eo={JSONContribution:"base.contributions.json"};function C(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new y.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,E){this.a[C($)]=E,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const N=new O;A.$do.add(e.$eo.JSONContribution,N)}),define(Ce[51],Ae([1,0,18,5,15,160,50,74,29]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.ConfigurationScope=e.$io=e.EditPresentationTypes=void 0,e.$to=r,e.$uo=a,e.$vo=s,e.$wo=i,e.$xo=c;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$io={Configuration:"base.contributions.configuration"};var M;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po="vscode://schemas/settings/resourceLanguage",e.$qo="vscode://schemas/settings/configurationDefaults";const S=$.$do.as(p.$eo.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.$ee,this.onDidSchemaChange=this.i.event,this.j=new A.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$po,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const o=new Set;this.n(t,d,o),S.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const d=new Set;this.o(t,d),S.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const o=new Set;this.o(d,o),this.n(t,!1,o),S.registerSchema(e.$po,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const o=[];for(const{overrides:f,source:u}of t)for(const D in f)if(d.add(D),e.$so.test(D)){const l=this.a.get(D),v=l?.valuesSources??new Map;if(u)for(const I of Object.keys(f[D]))v.set(I,u);const b={...l?.value||{},...f[D]};this.a.set(D,{source:u,value:b,valuesSources:v});const P=(0,N.$aj)(D),k={type:"object",default:b,description:O.localize(1,null,P),$ref:e.$po,defaultDefaultValue:b,source:C.$9f(u)?void 0:u,defaultValueSource:u};o.push(...r(D)),this.d[D]=k,this.b.properties[D]=k}else{this.a.set(D,{value:f[D],source:u});const l=this.d[D];l&&(this.w(D,l),this.r(D,l))}this.m(o)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:o,source:f}of t)for(const u in o){const D=this.a.get(u),l=C.$9f(f)?f:f?.id,v=C.$9f(D?.source)?D?.source:D?.source?.id;if(l===v)if(d.add(u),this.a.delete(u),e.$so.test(u))delete this.d[u],delete this.b.properties[u];else{const b=this.d[u];b&&(this.w(u,b),this.r(u,b))}}this.u()}deltaConfiguration(t){let d=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,o){t.forEach(f=>{this.p(f,d,f.extensionInfo,f.restrictedProperties,void 0,o),this.c.push(f),this.q(f)})}o(t,d){const o=f=>{if(f.properties)for(const u in f.properties){d.add(u);const D=this.d[u];D?.policy?.name&&this.e.delete(D.policy.name),delete this.d[u],this.s(u,f.properties[u])}f.allOf?.forEach(u=>o(u))};for(const f of t){o(f);const u=this.c.indexOf(f);u!==-1&&this.c.splice(u,1)}}p(t,d=!0,o,f,u=3,D){u=C.$fg(t.scope)?u:t.scope;const l=t.properties;if(l)for(const b in l){const P=l[b];if(d&&i(b,P)){delete l[b];continue}if(P.source=o,P.defaultDefaultValue=l[b].default,this.w(b,P),e.$so.test(b)?P.scope=void 0:(P.scope=C.$fg(P.scope)?u:P.scope,P.restricted=C.$fg(P.restricted)?!!f?.includes(b):P.restricted),l[b].hasOwnProperty("included")&&!l[b].included){this.f[b]=l[b],delete l[b];continue}else this.d[b]=l[b],l[b].policy?.name&&this.e.set(l[b].policy.name,b);!l[b].deprecationMessage&&l[b].markdownDeprecationMessage&&(l[b].deprecationMessage=l[b].markdownDeprecationMessage),D.add(b)}const v=t.allOf;if(v)for(const b of v)this.p(b,d,o,f,u,D)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=o=>{const f=o.properties;if(f)for(const D in f)this.r(D,f[D]);o.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$jo.properties[t]=d,d.scope){case 1:e.$ko.properties[t]=d;break;case 2:e.$lo.properties[t]=d;break;case 6:e.$mo.properties[t]=d;break;case 3:e.$no.properties[t]=d;break;case 4:e.$oo.properties[t]=d;break;case 5:e.$oo.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$jo.properties[t],d.scope){case 1:delete e.$ko.properties[t];break;case 2:delete e.$lo.properties[t];break;case 6:delete e.$mo.properties[t];break;case 3:delete e.$no.properties[t];break;case 4:case 5:delete e.$oo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,o={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$po};this.w(d,o),e.$jo.properties[d]=o,e.$ko.properties[d]=o,e.$lo.properties[d]=o,e.$mo.properties[d]=o,e.$no.properties[d]=o,e.$oo.properties[d]=o}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$po};e.$jo.patternProperties[e.$ro]=t,e.$ko.patternProperties[e.$ro]=t,e.$lo.patternProperties[e.$ro]=t,e.$mo.patternProperties[e.$ro]=t,e.$no.patternProperties[e.$ro]=t,e.$oo.patternProperties[e.$ro]=t,this.i.fire()}w(t,d){const o=this.a.get(t);let f=o?.value,u=o?.source;C.$dg(f)&&(f=d.defaultDefaultValue,u=void 0),C.$dg(f)&&(f=s(d.type)),d.default=f,d.defaultValueSource=u}}const w="\\[([^\\]]+)\\]",g=new RegExp(w,"g");e.$ro=`^(${w})+$`,e.$so=new RegExp(e.$ro);function r(h){const t=[];if(e.$so.test(h)){let d=g.exec(h);for(;d?.length;){const o=d[1].trim();o&&t.push(o),d=g.exec(h)}}return(0,y.$Mb)(t)}function a(h){return h.reduce((t,d)=>`${t}[${d}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new m;$.$do.add(e.$io.Configuration,n);function i(h,t){return h.trim()?e.$so.test(h)?O.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function c(){const h=[],t=n.getConfigurationProperties();for(const d of Object.keys(t))h.push([d,t[d].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Ce[203],Ae([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$Co=i;function w(d){return Object.isFrozen(d)?d:p.$5n(d)}class g{static createEmptyModel(o){return new g({},[],[],void 0,o)}constructor(o,f,u,D,l){this.b=o,this.c=f,this.d=u,this.raw=D,this.f=l,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map(f=>{if(f instanceof g)return f;const u=new r("",this.f);return u.parseRaw(f),u.configurationModel});this.g=o.reduce((f,u)=>u===f?u:f.merge(u),o[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,M.$$i)(this.contents,o):this.contents}inspect(o,f){const u=this;return{get value(){return w(u.rawConfiguration.getValue(o))},get override(){return f?w(u.rawConfiguration.getOverrideValue(o,f)):void 0},get merged(){return w(f?u.rawConfiguration.override(f).getValue(o):u.rawConfiguration.getValue(o))},get overrides(){const D=[];for(const{contents:l,identifiers:v,keys:b}of u.rawConfiguration.overrides){const P=new g(l,b,[],void 0,u.f).getValue(o);P!==void 0&&D.push({identifiers:v,value:P})}return D.length?w(D):void 0}}}getOverrideValue(o,f){const u=this.j(f);return u?o?(0,M.$$i)(u,o):u:void 0}getKeysForOverrideIdentifier(o){const f=[];for(const u of this.overrides)u.identifiers.includes(o)&&f.push(...u.keys);return y.$Mb(f)}getAllOverrideIdentifiers(){const o=[];for(const f of this.overrides)o.push(...f.identifiers);return y.$Mb(o)}override(o){let f=this.a.get(o);return f||(f=this.h(o),this.a.set(o,f)),f}merge(...o){const f=p.$4n(this.contents),u=p.$4n(this.overrides),D=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const v of o)if(l.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i(f,v.contents);for(const b of v.overrides){const[P]=u.filter(k=>y.$ub(k.identifiers,b.identifiers));P?(this.i(P.contents,b.contents),P.keys.push(...b.keys),P.keys=y.$Mb(P.keys)):u.push(p.$4n(b))}for(const b of v.keys)D.indexOf(b)===-1&&D.push(b)}return new g(f,D,u,l.every(v=>v instanceof g)?void 0:l,this.f)}h(o){const f=this.j(o);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const u={};for(const D of y.$Mb([...Object.keys(this.contents),...Object.keys(f)])){let l=this.contents[D];const v=f[D];v&&(typeof l=="object"&&typeof v=="object"?(l=p.$4n(l),this.i(l,v)):l=v),u[D]=l}return new g(u,this.keys,this.overrides,void 0,this.f)}i(o,f){for(const u of Object.keys(f)){if(u in o&&$.$$f(o[u])&&$.$$f(f[u])){this.i(o[u],f[u]);continue}o[u]=p.$4n(f[u])}}j(o){let f=null,u=null;const D=l=>{l&&(u?this.i(u,l):u=p.$4n(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===o?f=l.contents:l.identifiers.includes(o)&&D(l.contents);return D(f),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,f){this.k(o,f,!0)}setValue(o,f){this.k(o,f,!1)}removeValue(o){const f=this.keys.indexOf(o);f!==-1&&(this.keys.splice(f,1),(0,M.$0i)(this.contents,o),S.$so.test(o)&&this.overrides.splice(this.overrides.findIndex(u=>y.$ub(u.identifiers,(0,S.$to)(o))),1))}k(o,f,u){(0,M.$9i)(this.contents,o,f,D=>this.f.error(D)),u=u||this.keys.indexOf(o)===-1,u&&this.keys.push(o),S.$so.test(o)&&this.overrides.push({identifiers:(0,S.$to)(o),keys:Object.keys(this.contents[o]),contents:(0,M.$8i)(this.contents[o],D=>this.f.error(D))})}}e.$yo=g;class r{constructor(o,f){this.f=o,this.g=f,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,f){if(!$.$fg(o)){const u=this.h(o);this.parseRaw(u,f)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,f){this.a=o;const{contents:u,keys:D,overrides:l,restricted:v,hasExcludedProperties:b}=this.i(o,f);this.b=new g(u,D,l,b?[o]:void 0,this.g),this.c=v||[]}h(o){let f={},u=null,D=[];const l=[],v=[];function b(k){Array.isArray(D)?D.push(k):u!==null&&(D[u]=k)}const P={onObjectBegin:()=>{const k={};b(k),l.push(D),D=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{D=l.pop()},onArrayBegin:()=>{const k=[];b(k),l.push(D),D=k,u=null},onArrayEnd:()=>{D=l.pop()},onLiteralValue:b,onError:(k,I,U)=>{v.push({error:k,offset:I,length:U})}};if(o)try{C.$Rn(o,P),f=D[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return f}i(o,f){const u=m.$do.as(S.$io.Configuration).getConfigurationProperties(),D=this.j(o,u,!0,f);o=D.raw;const l=(0,M.$8i)(o,P=>this.g.error(`Conflict in settings file ${this.f}: ${P}`)),v=Object.keys(o),b=this.l(o,P=>this.g.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:l,keys:v,overrides:b,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(o,f,u,D){let l=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:l};const v={},b=[];for(const P in o)if(S.$so.test(P)&&u){const k=this.j(o[P],f,!1,D);v[P]=k.raw,l=l||k.hasExcludedProperties,b.push(...k.restricted)}else{const k=f[P],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&b.push(P),!D.exclude?.includes(P)&&(D.include?.includes(P)||(I===void 0||D.scopes===void 0||D.scopes.includes(I))&&!(D.skipRestricted&&k?.restricted))?v[P]=o[P]:l=!0}return{raw:v,restricted:b,hasExcludedProperties:l}}l(o,f){const u=[];for(const D of Object.keys(o))if(S.$so.test(D)){const l={};for(const v in o[D])l[v]=o[D][v];u.push({identifiers:(0,S.$to)(D),keys:Object.keys(l),contents:(0,M.$8i)(l,f)})}return u}}e.$zo=r;class a extends O.$Vc{constructor(o,f,u,D,l){super(),this.c=o,this.f=f,this.g=D,this.h=l,this.b=this.B(new A.$ee),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),l),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&u.isEqual(v.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ao=a;class s{constructor(o,f,u,D,l,v,b,P,k,I,U,Q,G){this.a=o,this.b=f,this.c=u,this.overrideIdentifiers=D,this.d=l,this.f=v,this.g=b,this.h=P,this.i=k,this.j=I,this.k=U,this.l=Q,this.m=G}get value(){return w(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(o,f,u,D,l,v,b,P,k,I){this.j=o,this.l=f,this.m=u,this.n=D,this.p=l,this.q=v,this.r=b,this.s=P,this.t=k,this.u=I,this.h=null,this.i=new N.$Bc,this.v=null}getValue(o,f,u){return this.w(o,f,u).getValue(o)}updateValue(o,f,u={}){let D;u.resource?(D=this.t.get(u.resource),D||(D=g.createEmptyModel(this.u),this.t.set(u.resource,D))):D=this.s,f===void 0?D.removeValue(o):D.setValue(o,f),u.resource||(this.h=null)}inspect(o,f,u){const D=this.w(o,f,u),l=this.A(f.resource,u),v=f.resource?this.t.get(f.resource)||this.s:this.s,b=new Set;for(const P of D.overrides)for(const k of P.identifiers)D.getOverrideValue(o,k)!==void 0&&b.add(k);return new s(o,f,D.getValue(o),b.size?[...b]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,l||void 0,v)}keys(o){const f=this.A(void 0,o);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(o){this.j=o,this.h=null,this.i.clear()}updatePolicyConfiguration(o){this.l=o}updateApplicationConfiguration(o){this.m=o,this.h=null,this.i.clear()}updateLocalUserConfiguration(o){this.n=o,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(o){this.p=o,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(o){this.q=o,this.h=null,this.i.clear()}updateFolderConfiguration(o,f){this.r.set(o,f),this.i.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.i.delete(o)}compareAndUpdateDefaultConfiguration(o,f){const u=[];if(!f){const{added:D,updated:l,removed:v}=h(this.j,o);f=[...D,...l,...v]}for(const D of f)for(const l of(0,S.$to)(D)){const v=this.j.getKeysForOverrideIdentifier(l),b=o.getKeysForOverrideIdentifier(l),P=[...b.filter(k=>v.indexOf(k)===-1),...v.filter(k=>b.indexOf(k)===-1),...v.filter(k=>!p.$8n(this.j.override(l).getValue(k),o.override(l).getValue(k)))];u.push([l,P])}return this.updateDefaultConfiguration(o),{keys:f,overrides:u}}compareAndUpdatePolicyConfiguration(o){const{added:f,updated:u,removed:D}=h(this.l,o),l=[...f,...u,...D];return l.length&&this.updatePolicyConfiguration(o),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:f,updated:u,removed:D,overrides:l}=h(this.applicationConfiguration,o),v=[...f,...u,...D];return v.length&&this.updateApplicationConfiguration(o),{keys:v,overrides:l}}compareAndUpdateLocalUserConfiguration(o){const{added:f,updated:u,removed:D,overrides:l}=h(this.localUserConfiguration,o),v=[...f,...u,...D];return v.length&&this.updateLocalUserConfiguration(o),{keys:v,overrides:l}}compareAndUpdateRemoteUserConfiguration(o){const{added:f,updated:u,removed:D,overrides:l}=h(this.remoteUserConfiguration,o),v=[...f,...u,...D];return v.length&&this.updateRemoteUserConfiguration(o),{keys:v,overrides:l}}compareAndUpdateWorkspaceConfiguration(o){const{added:f,updated:u,removed:D,overrides:l}=h(this.workspaceConfiguration,o),v=[...f,...u,...D];return v.length&&this.updateWorkspaceConfiguration(o),{keys:v,overrides:l}}compareAndUpdateFolderConfiguration(o,f){const u=this.folderConfigurations.get(o),{added:D,updated:l,removed:v,overrides:b}=h(u,f),P=[...D,...l,...v];return(P.length||!u)&&this.updateFolderConfiguration(o,f),{keys:P,overrides:b}}compareAndDeleteFolderConfiguration(o){const f=this.folderConfigurations.get(o);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:u,updated:D,removed:l,overrides:v}=h(f,void 0);return{keys:[...u,...D,...l],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(o,f,u){let D=this.x(f,u);return f.overrideIdentifier&&(D=D.override(f.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(o)!==void 0&&(D=D.merge(this.l)),D}x({resource:o},f){let u=this.y();if(f&&o){const D=f.getFolder(o);D&&(u=this.z(D.uri)||u);const l=this.t.get(o);l&&(u=u.merge(l))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(o){let f=this.i.get(o);if(!f){const u=this.y(),D=this.r.get(o);D?(f=u.merge(D),this.i.set(o,f)):f=u}return f}A(o,f){if(f&&o){const u=f.getFolder(o);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((o,f)=>{const{contents:u,overrides:D,keys:l}=this.r.get(f);return o.push([f,{contents:u,overrides:D,keys:l}]),o},[])}}allKeys(){const o=new Set;return this.j.keys.forEach(f=>o.add(f)),this.userConfiguration.keys.forEach(f=>o.add(f)),this.q.keys.forEach(f=>o.add(f)),this.r.forEach(f=>f.keys.forEach(u=>o.add(u))),[...o.values()]}B(){const o=new Set;return this.j.getAllOverrideIdentifiers().forEach(f=>o.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>o.add(f)),this.q.getAllOverrideIdentifiers().forEach(f=>o.add(f)),this.r.forEach(f=>f.getAllOverrideIdentifiers().forEach(u=>o.add(u))),[...o.values()]}D(o){const f=new Set;return this.j.getKeysForOverrideIdentifier(o).forEach(u=>f.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(u=>f.add(u)),this.q.getKeysForOverrideIdentifier(o).forEach(u=>f.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(o).forEach(D=>f.add(D))),[...f.values()]}static parse(o,f){const u=this.E(o.defaults,f),D=this.E(o.policy,f),l=this.E(o.application,f),v=this.E(o.user,f),b=this.E(o.workspace,f),P=o.folders.reduce((k,I)=>(k.set(E.URI.revive(I[0]),this.E(I[1],f)),k),new N.$Bc);return new n(u,D,l,v,g.createEmptyModel(f),b,P,g.createEmptyModel(f),new N.$Bc,f)}static E(o,f){return new g(o.contents,o.keys,o.overrides,void 0,f)}}e.$Bo=n;function i(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const o=new Set,f=new Map;for(const D of d)D.keys.forEach(l=>o.add(l)),D.overrides.forEach(([l,v])=>{const b=(0,N.$yc)(f,l,new Set);v.forEach(P=>b.add(P))});const u=[];return f.forEach((D,l)=>u.push([l,[...D.values()]])),{keys:[...o.values()],overrides:u}}class c{constructor(o,f,u,D,l){this.change=o,this.f=f,this.g=u,this.h=D,this.i=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of o.keys)this.affectedKeys.add(v);for(const[,v]of o.overrides)for(const b of v)this.affectedKeys.add(b);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(o,f){const u=this.a+o,D=this.d.indexOf(u);if(D<0)return!1;const l=D+u.length;if(l>=this.d.length)return!1;const v=this.d.charCodeAt(l);if(v!==this.b&&v!==this.c)return!1;if(f){const b=this.previousConfiguration?this.previousConfiguration.getValue(o,f,this.f?.workspace):void 0,P=this.g.getValue(o,f,this.h);return!p.$8n(b,P)}return!0}}e.$Do=c;function h(d,o){const{added:f,removed:u,updated:D}=t(o?.rawConfiguration,d?.rawConfiguration),l=[],v=d?.getAllOverrideIdentifiers()||[],b=o?.getAllOverrideIdentifiers()||[];if(o){const P=b.filter(k=>!v.includes(k));for(const k of P)l.push([k,o.getKeysForOverrideIdentifier(k)])}if(d){const P=v.filter(k=>!b.includes(k));for(const k of P)l.push([k,d.getKeysForOverrideIdentifier(k)])}if(o&&d){for(const P of v)if(b.includes(P)){const k=t({contents:d.getOverrideValue(void 0,P)||{},keys:d.getKeysForOverrideIdentifier(P)},{contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)});l.push([P,[...k.added,...k.removed,...k.updated]])}}return{added:f,removed:u,updated:D,overrides:l}}function t(d,o){const f=d?o?d.keys.filter(l=>o.keys.indexOf(l)===-1):[...d.keys]:[],u=o?d?o.keys.filter(l=>d.keys.indexOf(l)===-1):[...o.keys]:[],D=[];if(d&&o){for(const l of o.keys)if(d.keys.indexOf(l)!==-1){const v=(0,M.$$i)(o.contents,l),b=(0,M.$$i)(d.contents,l);p.$8n(v,b)||D.push(l)}}return{added:f,removed:u,updated:D}}}),define(Ce[104],Ae([1,0,14,3]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=E,e.$Hl=(0,A.$wi)("remoteAuthorityResolverService");var C;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class O{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=O;class N{constructor(S,m){this.host=S,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=N;var p;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends y.$bb{static isNotAvailable(S){return S instanceof $&&S._code===p.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof $&&S._code===p.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof $&&S._code===p.NoResolverFound}static isInvalidAuthority(S){return S instanceof $&&S._code===p.InvalidAuthority}static isHandled(S){return S instanceof $&&S.isHandled}constructor(S,m=p.Unknown,w){super(S),this._message=S,this._code=m,this._detail=w,this.isHandled=m===p.NotAvailable&&w===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Kl=$;function E(M){const S=M.indexOf("+");return S===-1?M:M.substring(0,S)}}),define(Ce[58],Ae([1,0,16]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=A,e.$Jm=C,e.$Km=O,e.$Lm=N;function A($){return $.scheme===y.Schemas.vscodeRemote?$.authority:void 0}function C($){if(!$)return;const E=$.indexOf("+");return E<0?$:$.substr(0,E)}function O($){const{host:E,port:M}=p($);if(typeof M>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:M}}function N($,E){let{host:M,port:S}=p($);return typeof S>"u"&&(S=E),{host:M,port:S}}function p($){const E=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const M=$.match(/^(\[[0-9a-z:]+\])$/);if(M)return{host:M[1],port:void 0};const S=$.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:$,port:void 0}}}),define(Ce[20],Ae([1,0,13,3,58]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Um=e.$Tm=e.$Sm=e.TargetPlatform=e.ExtensionType=e.$Rm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0,e.$Qm=O,e.$Vm=S,e.$Wm=m,e.$Xm=w,e.$Ym=g,e.$Mm="extensions.user.cache",e.$Nm="extensions.builtin.cache",e.$Om="undefined_publisher",e.$Pm=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Rm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(N||(e.ExtensionType=N={}));var p;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,s){if(typeof a>"u"||a===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof a=="string"||typeof s=="string"){const n=typeof a=="string"?a:a.value,i=typeof s=="string"?s:s.value;return y.$yf(n,i)}return a._lower===s._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$Sm=$;class E{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const s of a)this.add(s)}add(a){this.c.add($.toKey(a))}delete(a){return this.c.delete($.toKey(a))}has(a){return this.c.has($.toKey(a))}}e.$Tm=E;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete($.toKey(a))}get(a){return this.c.get($.toKey(a))}has(a){return this.c.has($.toKey(a))}set(a,s){this.c.set($.toKey(a),s)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Um=M;function S(r){return m(r)}function m(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function w(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,a){if(a){const s=`onResolveRemoteAuthority:${(0,C.$Jm)(a)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Zm=(0,A.$wi)("IBuiltinExtensionsScannerService")}),define(Ce[105],Ae([1,0,14,20]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(N,p){this.a.set(N,p)}readActivationEvents(N){return this.b.has(N)||this.b.set(N,this.c(N)),this.b.get(N)}createActivationEventsMap(N){const p=Object.create(null);for(const $ of N){const E=this.readActivationEvents($);E.length>0&&(p[A.$Sm.toKey($.identifier)]=E)}return p}c(N){if(typeof N.main>"u"&&typeof N.browser>"u")return[];const p=Array.isArray(N.activationEvents)?N.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${A.$Sm.toKey(N.identifier)}`);if(!N.contributes)return p;for(const $ in N.contributes){const E=this.a.get($);if(!E)continue;const M=N.contributes[$],S=Array.isArray(M)?M:[M];try{E(S,p)}catch(m){(0,y.$1)(m)}}return p}}e.$tG=C,e.$uG=new C}),define(Ce[204],Ae([1,0,21,14,6,168,51,3,12,29]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0,e.$Qp=m,e.$Rp=w,e.$Sp=g,e.$Tp=r,e.$Up=a,e.$Vp=s,e.$Op=(0,p.$wi)("requestService");class M{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class S extends C.$Vc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,O.localize)(0,null),when:$.$ik.isEqualTo((0,$.$fk)($.LogLevel.Trace)).serialize()})}async c(h,t,d){const o=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new M(t.headers??{}));try{const f=await d();return this.a.trace(`${o} - end`,t.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.a.error(`${o} - error`,t.type,(0,A.$0)(f)),f}}}e.$Pp=S;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function w(c){return c.res.statusCode===204}async function g(c){return w(c)?null:(await(0,y.$Se)(c.stream)).toString()}async function r(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}async function a(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(w(c))return null;const t=(await(0,y.$Se)(c.stream)).toString();try{return JSON.parse(t)}catch(d){throw d.message+=`:
`+t,d}}function s(c){i(c)}let n;function i(c){const h=E.$do.as(N.$io.Configuration),t=n;n={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(Ce[205],Ae([1,0,22,75,34]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=N,e.$fp=p;function O($){if(y.$o===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function N($,E,M,S,m,w,g,r,a){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=g,s.sessionID=(0,C.$Sg)()+Date.now(),s.commitHash=S,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,y.$b)(y.$o),s["common.nodePlatform"]=A.$ec,s["common.nodeArch"]=M,s["common.product"]=a||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),y.$f&&(s["common.snap"]="true");const c=O(E);return c&&(s["common.platformDetail"]=c),s}function p($){const E=A.env.USERDNSDOMAIN;if(!E)return!1;const M=E.toLowerCase();return $.some(S=>M===S)}}),define(Ce[206],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,y.$wi)("telemetryService"),e.$3l=(0,y.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var A;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var C;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ce[59],Ae([1,0,25,15,58,205,206]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$np=M,e.$op=S,e.$pp=m,e.$qp=w,e.$rp=r,e.$sp=s,e.$tp=n,e.$up=h;class p{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$gp=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$hp=$,e.$ip=new $;class E{async publicLog(d,o,f){}async publicLogError(d,o,f){}}e.$jp=E,e.$kp="telemetry",e.$lp="extensionTelemetryLog",e.$mp={log:()=>null,flush:()=>Promise.resolve(null)};function M(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}function S(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function m(t){const d=t.getValue(N.$0l),o=t.getValue(N.$$l);if(t.getValue(N.$_l)===!1||o===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const d={},o={},f={};a(t,f);for(let u in f){u=u.length>150?u.substr(u.length-149):u;const D=f[u];typeof D=="number"?o[u]=D:typeof D=="boolean"?o[u]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${D.length}`),d[u]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(d[u]=D)}return{properties:d,measurements:o}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const d=(0,C.$Jm)(t);return g.has(d)?d:"other"}function a(t,d,o=0,f){if(t)for(const u of Object.getOwnPropertyNames(t)){const D=t[u],l=f?f+u:u;Array.isArray(D)?d[l]=(0,y.$9n)(D):D instanceof Date?d[l]=D.toISOString():(0,A.$$f)(D)?o<2?a(D,d,o+1,l+"."):d[l]=(0,y.$9n)(D):d[l]=D}}function s(t,d){const o=t.msftInternalDomains||[],f=d.getValue("telemetry.internalTesting");return(0,O.$fp)(o)||f}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const f=[];for(const v of d)for(;;){const b=v.exec(t);if(!b)break;f.push([b.index,v.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(o="";;){const v=D.exec(t);if(!v)break;const b=f.some(([P,k])=>v.index<k&&P<D.lastIndex);!u.test(v[0])&&!b&&(o+=t.substring(l,v.index)+"<REDACTED: user-file-path>",l=D.lastIndex)}return l<t.length&&(o+=t.substr(l)),o}function c(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of d)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function h(t,d){return(0,y.$6n)(t,o=>{if(o instanceof p||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let f=o.replaceAll("%20"," ");f=i(f,d);for(const u of d)f=f.replace(u,"");return f=c(f),f}})}}),define(Ce[207],Ae([1,0,13,100,20,22,2,14,75,59]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$wp=void 0,e.$vp=M,e.$xp=g,e.$yp=r,e.$zp=a,e.$Ap=s,e.$Bp=n,e.$Cp=i,e.$Dp=c,e.$Fp=h,e.$Gp=d;function M(o,f){return o.uuid&&f.uuid?o.uuid===f.uuid:o.id===f.id?!0:(0,y.$tf)(o.id,f.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(f){const u=f.manifest?f.manifest.version:f.version,D=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new m(f.identifier,u,D)}static parse(f){const u=S.exec(f);return u&&u[1]&&u[2]?new m({id:u[1]},u[2],u[4]||void 0):null}constructor(f,u,D="undefined"){this.version=u,this.targetPlatform=D,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof m?M(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$wp=m;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const f=w.exec(o);return f&&f[1]?[a(f[1]),f[2]]:[a(o),void 0]}function r(o,f){return`${o}.${f}`}function a(o){return o.toLowerCase()}function s(o,f){return a(r(o??C.$Om,f))}function n(o,f){const u=[],D=l=>{for(const v of u)if(v.some(b=>M(f(b),f(l))))return v;return null};for(const l of o){const v=D(l);v?v.push(l):u.push([l])}return u}function i(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function c(o){return{id:new E.$gp(o.identifier.id),name:new E.$gp(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Ep=new C.$Sm("pprice.better-merge");function h(o,f){const u=[],D=f.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const l=D.shift();if(l&&u.every(v=>!M(v.identifier,{id:l}))){const v=o.filter(b=>M(b.identifier,{id:l}));v.length===1&&(u.push(v[0]),D.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function t(o,f){if(!O.$e)return!1;let u;try{u=(await o.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await o.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){f.debug("Error while getting the os-release file.",(0,p.$0)(l))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(o,f){const u=await t(o,f),D=(0,A.$3o)(u?"alpine":O.$o,$.$fc);return f.debug("ComputeTargetPlatform:",D),D}}),define(Ce[208],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=y,e.$ns=A,e.$os=C,e.$ps=O,e.$qs=N,e.$rs=p;function y($){return[...$.entries()]}function A($){return $?[...$.entries()]:[]}function C($){return new Map($)}function O($){return new Map($??[])}function N($){return Array.from($.entries()).map(E=>[E[0],y(E[1].map),A(E[1].descriptionMap)])}function p($){return new Map($.map(E=>[E[0],{map:C(E[1]),descriptionMap:O(E[2])}]))}}),define(Ce[209],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Svb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,O,N=5){const p=O($=>{const E=typeof $=="string"?$:$.data;let M=this.a.get(C);if(M){M.data.push(E);return}const S=setTimeout(()=>this.flushBuffer(C),N);M={data:[E],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),p.dispose()}},this.a.set(C,M)});return p}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const O=this.a.get(C);O&&(this.a.delete(C),this.b(C,O.data.join("")))}}e.$Svb=y}),define(Ce[210],Ae([1,0,9,92,312,36,5,15,2,169,74,29]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nx=e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.IconFontDefinition=e.IconContribution=e.$fx=void 0,e.$gx=a,e.$hx=s,e.$fx={IconContribution:"base.contributions.icons"};var m;(function(h){function t(d,o){let f=d.defaults;for(;O.ThemeIcon.isThemeIcon(f);){const u=r.getIcon(f.id);if(!u)return;f=u.defaults}return f}h.getDefinition=t})(m||(e.IconContribution=m={}));var w;(function(h){function t(o){return{weight:o.weight,style:o.style,src:o.src.map(f=>({format:f.format,location:f.location.toString()}))}}h.toJSONObject=t;function d(o){const f=u=>(0,p.$9f)(u)?u:void 0;if(o&&Array.isArray(o.src)&&o.src.every(u=>(0,p.$9f)(u.format)&&(0,p.$9f)(u.location)))return{weight:f(o.weight),style:f(o.style),src:o.src.map(u=>({format:u.format,location:$.URI.parse(u.location)}))}}h.fromJSONObject=d})(w||(e.IconFontDefinition=w={}));class g{constructor(){this.a=new N.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,d,o,f){const u=this.b[t];if(u){if(o&&!u.description){u.description=o,this.d.properties[t].markdownDescription=`${o} $(${t})`;const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enumDescriptions[v]=o),this.a.fire()}return u}const D={id:t,description:o,defaults:d,deprecationMessage:f};this.b[t]=D;const l={$ref:"#/definitions/icons"};return f&&(l.deprecationMessage=f),o&&(l.markdownDescription=`${o}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const d=this.e.enum.indexOf(t);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,d){const o=this.f[t];return o||(this.f[t]=d,this.a.fire(),d)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(u,D)=>u.id.localeCompare(D.id),d=u=>{for(;O.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map(u=>this.b[u]);for(const u of f.filter(D=>!!D.description).sort(t))o.push(`|<i class="${d(u)}"></i>|${u.id}|${O.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const u of f.filter(D=>!O.ThemeIcon.isThemeIcon(D.defaults)).sort(t))o.push(`|<i class="${d(u)}"></i>|${u.id}|`);return o.join(`
`)}}const r=new g;S.$do.add(e.$fx.IconContribution,r);function a(h,t,d,o){return r.registerIcon(h,t,d,o)}function s(){return r}function n(){const h=(0,C.$Rj)();for(const t in h){const d="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:d})}}n(),e.$ix="vscode://schemas/icons";const i=S.$do.as(M.$eo.JSONContribution);i.registerSchema(e.$ix,r.getIconSchema());const c=new y.$Ih(()=>i.notifySchemaChanged(e.$ix),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$jx=a("widget-close",A.$Vj.close,(0,E.localize)(2,null)),e.$kx=a("goto-previous-location",A.$Vj.arrowUp,(0,E.localize)(3,null)),e.$lx=a("goto-next-location",A.$Vj.arrowDown,(0,E.localize)(4,null)),e.$mx=O.ThemeIcon.modify(A.$Vj.sync,"spin"),e.$nx=O.ThemeIcon.modify(A.$Vj.loading,"spin")}),define(Ce[211],Ae([1,0,5,2,50,3,12]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$tw=e.$qw=e.$ow=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$kw=e.$jw=void 0,e.$lw=E,e.$mw=S,e.$nw=m,e.$pw=w,e.$rw=g,e.$sw=r,e.$jw=(0,O.$wi)("tunnelService"),e.$kw=(0,O.$wi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(n){return!!n.forwardPort}var M;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(M||(e.ProvidedOnAutoForward=M={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function m(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const c of i){const h=c.split("=")[1];if(/^https?:/.exec(h)){const t=S(A.URI.parse(h));if(t)return t}}}e.$ow=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(n){return e.$ow.indexOf(n)>=0}e.$qw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(n){return e.$qw.indexOf(n)>=0}function r(n,i,c,h){if(c===1)return!1;if(c===2&&g(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class a{constructor(i,c,h){this.remoteAddress=i,this.localAddress=c,this.b=h,this.a=new y.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$tw=a;let s=class{constructor(i,c){this.k=i,this.l=c,this.a=new y.$ee,this.onTunnelOpened=this.a.event,this.b=new y.$ee,this.onTunnelClosed=this.b.event,this.c=new y.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const h of c){const t=Array.from(h.values());for(const d of t){const o=await d.value;o&&typeof o!="string"&&i.push(o)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,h,t,d){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:h,privacy:t,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(g(i)||w(i))&&(i=e.$ow[0]);const h=this.s(i,c);if(h)return++h.refcount,h.value}openTunnel(i,c,h,t,d,o=!1,f,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${d}.`);const D=this.f??i;if(!D)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(D,c,h,t,d,o,f,u);return l?l.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(v);return(v.tunnelRemoteHost!==c||v.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),f&&v.privacy!==f&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const h=c.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=h.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const h=this.e.get(i);if(h&&h.has(c)){const t=h.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:h})}async r(i,c){const h=this.e.get(i);if(h){const t=h.get(c),d=t?await t.value:void 0;(!d||typeof d=="string")&&h.delete(c),h.size===0&&this.e.delete(i)}}s(i,c){const h=[i];w(i)?(h.push(...e.$ow),h.push(...e.$qw)):g(i)&&h.push(...e.$qw);const t=h.map(d=>this.e.get(d));for(const d of t){const o=d?.get(c);if(o)return o}}canTunnel(i){return!!S(i)}u(i,c,h,t,d,o,f){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${t}.`);const u=h;this.j.add(u);const D=t===void 0?h:t,l={elevationRequired:d?this.isPortPrivileged(D):!1},v={remoteAddress:{host:c,port:h},localAddressPort:t,privacy:o,public:o?o!==$.Private:void 0,protocol:f},b=i.forwardPort(v,l);return b?(this.q(c,h,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),b}};e.$uw=s,e.$uw=s=Qe([qe(0,N.$3j),qe(1,C.$3i)],s)}),define(Ce[212],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,y.$wi)("IUriIdentityService")}),define(Ce[213],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$vw=void 0,e.$vw=(0,y.$wi)("editSessionIdentityService");var A;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(A||(e.EditSessionIdentityMatch=A={}))}),define(Ce[214],Ae([1,0,16]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=A,e.$HM=C,e.$IM=O,e.$JM=N,e.$KM=p;function A($){return $.scheme!==y.Schemas.file&&$.scheme!==y.Schemas.vscodeRemote}function C($){if($.folders.length)return $.folders.every(E=>A(E.uri))?$.folders[0].uri:void 0;if($.configuration&&A($.configuration))return $.configuration}function O($){return C($)?.scheme}function N($){return C($)?.authority}function p($){return C($)!==void 0}}),define(Ce[45],Ae([1,0,171,19,54,23,2,3,16]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=E,e.$Hi=M,e.$Ki=S,e.$Li=m,e.$Mi=w,e.$Ni=r,e.$Oi=a,e.$Ri=i,e.$Wi=c,e.$Xi=h,e.$Zi=t,e.$1i=d,e.$2i=o,e.$Fi=(0,p.$wi)("contextService");function E(f){const u=f;return typeof u?.id=="string"&&N.URI.isUri(u.uri)}function M(f){return typeof f?.id=="string"&&!E(f)&&!m(f)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function S(f,u){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,A.$oc)(f)}:u?e.$Ii:e.$Ji;const D=f;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}function m(f){const u=f;return typeof u?.id=="string"&&N.URI.isUri(u.configPath)}function w(f){const u=f;if(u?.uri)return{id:u.id,uri:N.URI.revive(u.uri)};const D=f;if(D?.configPath)return{id:D.id,configPath:N.URI.revive(D.configPath)};if(f?.id)return{id:f.id}}var g;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r(f){const u=f;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function a(f){const u=f;return!!(u&&typeof u=="object"&&N.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class s{constructor(u,D,l,v,b){this.h=u,this.j=l,this.k=v,this.l=b,this.c=C.$Ci.forUris(this.l,()=>!0),this.folders=D}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=C.$Ci.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=s;class n{constructor(u,D){this.raw=D,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,O.$0g)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(f){return new n({uri:f,index:0,name:(0,O.$6g)(f)},{uri:f.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,y.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function c(f,u){return O.$1g.isEqualOrParent(f,u.untitledWorkspacesHome)}function h(f){let u;return N.URI.isUri(f)?u=f:u=f.configuration,u?.scheme===$.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(f){return f.id===e.$Yi}function d(f,u){return!c(f,u)&&!h(f)}function o(f){return(typeof f=="string"?(0,A.$pc)(f):(0,O.$8g)(f))===e.$Ti}}),define(Ce[215],Ae([1,0,73,5,6,23,2,170,99,38,3,12,45,28,212,9,34,13,15]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=c,e.$Dl=h,e.$El=t;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function c(f){const u=f;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&N.URI.isUri(u.location)&&N.URI.isUri(u.globalStorageHome)&&N.URI.isUri(u.settingsResource)&&N.URI.isUri(u.keybindingsResource)&&N.URI.isUri(u.tasksResource)&&N.URI.isUri(u.snippetsHome)&&N.URI.isUri(u.extensionsResource))}e.$Cl=(0,M.$wi)("IUserDataProfilesService");function h(f,u){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:N.URI.revive(f.location).with({scheme:u}),globalStorageHome:N.URI.revive(f.globalStorageHome).with({scheme:u}),settingsResource:N.URI.revive(f.settingsResource).with({scheme:u}),keybindingsResource:N.URI.revive(f.keybindingsResource).with({scheme:u}),tasksResource:N.URI.revive(f.tasksResource).with({scheme:u}),snippetsHome:N.URI.revive(f.snippetsHome).with({scheme:u}),extensionsResource:N.URI.revive(f.extensionsResource).with({scheme:u}),cacheHome:N.URI.revive(f.cacheHome).with({scheme:u}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function t(f,u,D,l,v,b){return{id:f,name:u,location:D,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:b&&v?.useDefaultFlags?.globalState?b.globalStorageHome:(0,O.$0g)(D,"globalStorage"),settingsResource:b&&v?.useDefaultFlags?.settings?b.settingsResource:(0,O.$0g)(D,"settings.json"),keybindingsResource:b&&v?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,O.$0g)(D,"keybindings.json"),tasksResource:b&&v?.useDefaultFlags?.tasks?b.tasksResource:(0,O.$0g)(D,"tasks.json"),snippetsHome:b&&v?.useDefaultFlags?.snippets?b.snippetsHome:(0,O.$0g)(D,"snippets"),extensionsResource:b&&v?.useDefaultFlags?.extensions?b.extensionsResource:(0,O.$0g)(D,"extensions.json"),cacheHome:(0,O.$0g)(l,f),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let d=class extends C.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,D,l,v){super(),this.t=u,this.u=D,this.w=l,this.y=v,this.f=!0,this.h=this.B(new A.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Bc,emptyWindows:new Map},this.profilesHome=(0,O.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),D=[u];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,n.$9f)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}D.push(t((0,O.$7g)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},u))}}catch(b){this.y.error(b)}const l=new w.$Bc,v=new Map;if(D.length)try{const b=this.Q();if(b.workspaces)for(const[P,k]of Object.entries(b.workspaces)){const I=N.URI.parse(P),U=D.find(Q=>Q.id===k);U&&l.set(I,U)}if(b.emptyWindows)for(const[P,k]of Object.entries(b.emptyWindows)){const I=D.find(U=>U.id===k);I&&v.set(P,I)}}catch(b){this.y.error(b)}this.z={profiles:D,workspaces:l,emptyWindows:v}}return this.z}D(){const u=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const D="Temp",l=new RegExp(`${(0,s.$af)(D)}\\s(\\d+)`);let v=0;for(const P of this.profiles){const k=l.exec(P.name),I=k?parseInt(k[1]):0;v=I>v?I:v}const b=`${D} ${v+1}`;return this.createProfile((0,y.$kj)((0,a.$Sg)()).toString(16),b,{transient:!0},u)}async createNamedProfile(u,D,l){return this.createProfile((0,y.$kj)((0,a.$Sg)()).toString(16),u,D,l)}async createProfile(u,D,l,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(u,D,l);return v&&await this.setProfileForWorkspace(v,b),b}async F(u,D,l){if(!(0,n.$9f)(D)||!D)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(D);return v||(v=(async()=>{try{if(this.profiles.find(I=>I.name===D||I.id===u))throw new Error(`Profile with ${D} name already exists`);const P=t(u,D,(0,O.$0g)(this.profilesHome,u),this.g,l,this.defaultProfile);await this.u.createFolder(P.location);const k=[];return this.j.fire({profile:P,join(I){k.push(I)}}),await r.Promises.settled(k),this.I([P],[],[]),P}finally{this.r.delete(D)}})(),this.r.set(D,v)),v}async updateProfile(u,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(v=>v.id===u.id);if(!l)throw new Error(`Profile '${u.name}' does not exist`);return l=t(l.id,D.name??l.name,l.location,this.g,{shortName:D.shortName??l.shortName,icon:D.icon===null?void 0:D.icon??l.icon,transient:D.transient??l.isTransient,useDefaultFlags:D.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const D=this.profiles.find(v=>v.id===u.id);if(!D)throw new Error(`Profile '${u.name}' does not exist`);const l=[];this.m.fire({profile:D,join(v){l.push(v)}});try{await Promise.allSettled(l)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])D.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])D.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[D],[]);try{await this.u.del(D.cacheHome,{recursive:!0})}catch(v){(0,E.$hl)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(u,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(v=>v.id===D.id);if(!l)throw new Error(`Profile '${D.name}' does not exist`);this.L(u,l)}unsetWorkspace(u,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,D)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(D=>D.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,D.resource))).map(D=>this.u.del(D.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(D=>!this.H(D));await Promise.allSettled(u.map(D=>this.removeProfile(D)))}getProfileForWorkspace(u){const D=this.G(u);return N.URI.isUri(D)?this.s.workspaces.get(D)??this.C.workspaces.get(D):this.s.emptyWindows.get(D)??this.C.emptyWindows.get(D)}G(u){return(0,m.$Gi)(u)?u.uri:(0,m.$Li)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(D=>this.w.extUri.isEqual(D.location,u.location))||[...this.s.workspaces.values()].some(D=>this.w.extUri.isEqual(D.location,u.location))||[...this.C.emptyWindows.values()].some(D=>this.w.extUri.isEqual(D.location,u.location))||[...this.C.workspaces.values()].some(D=>this.w.extUri.isEqual(D.location,u.location)))}I(u,D,l){const v=[...this.profiles,...u],b=[];this.s.profiles=[];for(let P of v)P.isDefault||D.some(k=>P.id===k.id)||(P=l.find(k=>P.id===k.id)??P,P.isTransient?this.s.profiles.push(P):b.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.P(b),this.z=void 0,this.J(u,D,l)}J(u,D,l){this.h.fire({added:u,removed:D,updated:l,all:this.profiles})}L(u,D,l){l=D?.isTransient?!0:l,l||this.L(u,void 0,!0);const v=this.G(u),b=l?this.s:this.C;N.URI.isUri(v)?(b.workspaces.delete(v),D&&b.workspaces.set(v,D)):(b.emptyWindows.delete(v),D&&b.emptyWindows.set(v,D)),l||this.M()}M(){const u={};for(const[l,v]of this.C.workspaces.entries())u[l.toString()]=v.id;const D={};for(const[l,v]of this.C.emptyWindows.entries())D[l.toString()]=v.id;this.R({workspaces:u,emptyWindows:D}),this.z=void 0}N(u){const D={},l=this.D();if(u.workspaces)for(const[b,P]of Object.entries(u.workspaces)){const k=N.URI.parse(P);D[b]=this.w.extUri.isEqual(k,l.location)?l.id:this.w.extUri.basename(k)}const v={};if(u.emptyWindows)for(const[b,P]of Object.entries(u.emptyWindows)){const k=N.URI.parse(P);v[b]=this.w.extUri.isEqual(k,l.location)?l.id:this.w.extUri.basename(k)}return{workspaces:D,emptyWindows:v}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Fl=d,d.b="userDataProfiles",d.c="profileAssociations",e.$Fl=d=Qe([qe(0,$.$Di),qe(1,E.$3k),qe(2,g.$Al),qe(3,S.$3j)],d);class o extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Gl=o}),define(Ce[216],Ae([1,0,9,5,6,60,15,141,3,215]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$4p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2p=e.$1p=e.$Zp=void 0,e.$3p=w,e.$5p=r,e.$7p=s,e.$Zp="__$__isNewStorageMarker",e.$1p="__$__targetStorageMarker",e.$2p=(0,$.$wi)("storageService");var M;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var S;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var m;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function w(n){const i=n.get(e.$1p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class g extends C.$Vc{constructor(i={flushInterval:g.a}){super(),this.m=i,this.b=this.B(new A.$he),this.c=this.B(new A.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new y.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,c,h){return A.Event.filter(this.b.event,t=>t.scope===i&&(c===void 0||t.key===c),h)}n(){this.j.value=(0,y.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,c){const{key:h,external:t}=c;if(h===e.$1p){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:h,target:this.J(i)[h],external:t})}w(i){this.f.fire({reason:i})}get(i,c,h){return this.P(c)?.get(i,h)}getBoolean(i,c,h){return this.P(c)?.getBoolean(i,h)}getNumber(i,c,h){return this.P(c)?.getNumber(i,h)}getObject(i,c,h){return this.P(c)?.getObject(i,h)}storeAll(i,c){this.y(()=>{for(const h of i)this.store(h.key,h.value,h.scope,h.target,c)})}store(i,c,h,t,d=!1){if((0,N.$fg)(c)){this.remove(i,h,d);return}this.y(()=>{this.z(i,h,t),this.P(h)?.set(i,c,d)})}remove(i,c,h=!1){this.y(()=>{this.z(i,c,void 0),this.P(c)?.delete(i,h)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,c){const h=[],t=this.J(i);for(const d of Object.keys(t))t[d]===c&&h.push(d);return h}z(i,c,h,t=!1){const d=this.J(c);typeof h=="number"?d[i]!==h&&(d[i]=h,this.P(c)?.set(e.$1p,JSON.stringify(d),t)):typeof d[i]=="number"&&(delete d[i],this.P(c)?.set(e.$1p,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const c=this.P(i);return c?w(c):Object.create(null)}isNew(i){return this.getBoolean(e.$Zp,i)===!0}async flush(i=M.NONE){this.f.fire({reason:i});const c=this.P(-1),h=this.P(0),t=this.P(1);switch(i){case M.NONE:await y.Promises.settled([c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await y.Promises.settled([c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return s(i,c,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,c){return this.w(M.NONE),(0,E.$Bl)(i)?this.R(i,c):this.S(i,c)}M(i,c){return!(i.id===c.id||r(c)&&r(i))}N(i,c,h){this.y(()=>{const t=new Set;for(const[d,o]of i)t.add(d),c.get(d)!==o&&this.u(h,{key:d,external:!0});for(const[d]of c.items)t.has(d)||this.u(h,{key:d,external:!0})})}}e.$4p=g,g.a=60*1e3;function r(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class a extends g{constructor(){super(),this.U=this.B(new p.$Xp(new p.$Yp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Xp(new p.$Yp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Xp(new p.$Yp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$6p=a;async function s(n,i,c,h,t,d){const o=I=>{try{return JSON.parse(I)}catch{return I}},f=new Map,u=new Map;n.forEach((I,U)=>{f.set(U,I),u.set(U,o(I))});const D=new Map,l=new Map;i.forEach((I,U)=>{D.set(U,I),l.set(U,o(I))});const v=new Map,b=new Map;c.forEach((I,U)=>{v.set(U,I),b.set(U,o(I))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const P=[];if(f.forEach((I,U)=>{P.push({key:U,value:I})}),console.table(P),console.groupEnd(),console.log(u),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];D.forEach((U,Q)=>{I.push({key:Q,value:U})}),console.table(I),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${d})`);const k=[];v.forEach((I,U)=>{k.push({key:U,value:I})}),console.table(k),console.groupEnd(),console.log(b)}}),define(Ce[76],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class y{constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const O=this.c++;return this.b.set(O,C),this.e(),O}get(C,O){return this.b.has(C)?this.b.get(C)[O]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$flc=y,y.a=!1}),define(Ce[46],Ae([1,0,16,23,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0;class O{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new A.$Yg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$klc=O,e.$llc=(0,C.$wi)("IExtHostFileSystemInfo")}),define(Ce[27],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0,e.$NP=(0,y.$wi)("IExtHostInitDataService")}),define(Ce[217],Ae([1,0,176,12,201,27]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;let N=class extends C.$WQ{constructor($,E,M){const S=M.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=M.remote.isRemote?(0,y.localize)(0,null):$?(0,y.localize)(1,null):(0,y.localize)(2,null);super(E.createLogger(S,{name:m}))}};e.$rnc=N,e.$rnc=N=Qe([qe(1,A.$4j),qe(2,O.$NP)],N)}),define(Ce[218],Ae([1,0,9]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;class A{constructor(N,p,$){this.h=new Map,this.a=N,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new y.$Ih(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of E.values())M.complete()}catch(M){for(const S of E.values())S.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,N])=>N!==void 0).map(([N])=>N)}get whenReady(){return this.d}get(N,p){let $=this.f[N];return typeof $>"u"&&($=p),$}update(N,p){this.f[N]=p;const $=this.h.get(N);if($!==void 0)return $.p;const E=new y.$Th;return this.h.set(N,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$3lc=A;class C extends A{setKeysForSync(N){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},N)}constructor(N,p){super(N.identifier.value,!0,p),this.j=N}}e.$4lc=C}),define(Ce[219],Ae([1,0,5,2]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class C{constructor(N){this.c=N,this.a=new y.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(N,p,$,E){const S=this.c.getNotebookDocument(A.URI.revive(N)).acceptModelChanged(p.value,$,E);this.b.fire(S)}$acceptDirtyStateChanged(N,p){this.c.getNotebookDocument(A.URI.revive(N)).acceptDirty(p)}$acceptModelSaved(N){const p=this.c.getNotebookDocument(A.URI.revive(N));this.a.fire(p.apiNotebook)}}e.$Rmc=C}),define(Ce[17],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$xP=(0,y.$wi)("IExtHostRpcService");class A{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$yP=A});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[220],Ae([1,0,20,5]),function(ee,e,y,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;class O{constructor(p,$){C.set(this,void 0),this.b=new A.$ee,this.onDidChange=this.b.event,this.a=y.$Sm.toKey(p.identifier),_e(this,C,$,"f"),Be(this,C,"f").onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(p){return Be(this,C,"f").get(this.a,p)}store(p,$){return Be(this,C,"f").store(this.a,p,$)}delete(p){return Be(this,C,"f").delete(this.a,p)}}e.$amc=O,C=new WeakMap}),define(Ce[61],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0,e.$Alc=(0,y.$wi)("IURITransformerService");class A{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=N=>N,this.transformOutgoing=N=>N,this.transformOutgoingURI=N=>N,this.transformOutgoingScheme=N=>N)}}e.$Blc=A}),define(Ce[221],Ae([1,0,21]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irb=C,e.$Jrb=N;class A{constructor(){this.buffers=[]}add($){let E=this.buffers.indexOf($);return E<0&&(E=this.buffers.length,this.buffers.push($)),E}}function C(p,$){if($.serializeBuffersForPostMessage){const E=new A,S=JSON.stringify(p,(w,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g)};if(ArrayBuffer.isView(g)){const r=O(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),m=E.buffers.map(w=>{const g=new Uint8Array(w);return y.$Ge.wrap(g)});return{message:S,buffers:m}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function N(p,$){const E=$.map(m=>{const w=new ArrayBuffer(m.byteLength);return new Uint8Array(w).set(m.buffer),w}),M=$.length?(m,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const g=w,{index:r}=g,a=E[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(a,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return w}:void 0;return{message:JSON.parse(p,M),arrayBuffers:E}}}),define(Ce[106],Ae([1,0,185,15,2,6,3,29,38,16,44,153,33]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=r,e.$zF=a,e.$AF=s,e.$BF=n,e.$CF=i,e.$DF=c,e.$EF=h,e.$FF=t,e.$GF=d,e.$JF=v,e.$KF=P,e.$LF=k,e.$MF=I,e.$NF=U,e.$OF=Q,e.$PF=G,e.$QF=ne,e.$SF=de,e.$TF=ke,e.$UF=se,e.$VF=Pe,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var w;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var g;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(re){const H=re;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}function a(re){const H=re;return!!H&&typeof H.getScrollPosition=="function"&&typeof H.setScrollPosition=="function"&&!!H.onDidChangeScroll}function s(re,H,he){for(const Fe of he.visibleEditorPanes)if(Fe.group.id===H&&re.matches(Fe.input))return Fe.getViewState()}function n(re){if(v(re))return!1;const H=re;return C.URI.isUri(H?.resource)}function i(re){if(v(re))return!1;const H=re;return H?.original!==void 0&&H.modified!==void 0}function c(re){if(v(re))return!1;const H=re;return!H||H.resources&&!Array.isArray(H.resources)?!1:!!H.resources||!!H.multiDiffSource}function h(re){if(v(re)||i(re))return!1;const H=re;return H?.primary!==void 0&&H.secondary!==void 0}function t(re){if(v(re))return!1;const H=re;return H?H.resource===void 0||H.resource.scheme===E.Schemas.untitled||H.forceUntitled===!0:!1}function d(re){if(v(re))return!1;const H=re;return C.URI.isUri(H?.base?.resource)&&C.URI.isUri(H?.input1?.resource)&&C.URI.isUri(H?.input2?.resource)&&C.URI.isUri(H?.result?.resource)}var o;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(o||(e.Verbosity=o={}));var f;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class u{constructor(){this.a=new Map}registerSource(H,he){let Fe=this.a.get(H);return Fe||(Fe={source:H,label:he},this.a.set(H,Fe)),Fe.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$HF=new u;var D;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(D||(e.EditorInputCapabilities=D={}));class l extends O.$Vc{}e.$IF=l;function v(re){return re instanceof l}function b(re){const H=re;return C.URI.isUri(H?.preferredResource)}function P(re){const H=re;return v(H?.primary)&&v(H?.secondary)}function k(re){const H=re;return v(H?.modified)&&v(H?.original)}function I(re,H,he,Fe,pe){return Pe(Fe,[(0,S.$gj)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const be={...he,limits:{size:Number.MAX_VALUE}};re.openEditor(H,be)}}),(0,S.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}function U(re){return v(re?.editor)}function Q(re){const H=re;return U(re)&&H?.group!==void 0}function G(re){const H=re;return typeof H?.groupId=="number"&&v(H.editor)}var L;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(L||(e.EditorCloseContext=L={}));var R;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=12]="EDITOR_STICKY",re[re.EDITOR_DIRTY=13]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var F;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class T{getOriginalUri(H,he){if(!H)return;if(d(H))return e.$RF.getOriginalUri(H.result,he);if(he?.supportSideBySide){const{primary:pe,secondary:be}=this.a(H);if(pe&&be){if(he?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===F.ANY)return this.getOriginalUri(pe,{filterByScheme:he.filterByScheme})??this.getOriginalUri(be,{filterByScheme:he.filterByScheme});H=he.supportSideBySide===F.PRIMARY?pe:be}}if(i(H)||c(H)||h(H)||d(H))return;const Fe=b(H)?H.preferredResource:H.resource;return!Fe||!he||!he.filterByScheme?Fe:this.b(Fe,he.filterByScheme)}a(H){return P(H)||h(H)?{primary:H.primary,secondary:H.secondary}:k(H)||i(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,he){if(!H)return;if(d(H))return e.$RF.getCanonicalUri(H.result,he);if(he?.supportSideBySide){const{primary:pe,secondary:be}=this.a(H);if(pe&&be){if(he?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===F.ANY)return this.getCanonicalUri(pe,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:he.filterByScheme});H=he.supportSideBySide===F.PRIMARY?pe:be}}if(i(H)||c(H)||h(H)||d(H))return;const Fe=H.resource;return!Fe||!he||!he.filterByScheme?Fe:this.b(Fe,he.filterByScheme)}b(H,he){if(Array.isArray(he)){if(he.some(Fe=>H.scheme===Fe))return H}else if(he===H.scheme)return H}}var X;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function ne(re,H,he,Fe){if(!re.isSticky(H))return!1;switch(Fe.preventPinnedEditorClose){case"keyboardAndMouse":return he===X.MOUSE||he===X.KEYBOARD;case"mouse":return he===X.MOUSE;case"keyboard":return he===X.KEYBOARD}return!1}e.$RF=new T;var me;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class we{constructor(){this.c=new Map,this.d=new Map}start(H){const he=this.a=H.get(N.$vi);for(const[Fe,pe]of this.c)this.e(Fe,pe,he);this.c.clear()}e(H,he,Fe){const pe=Fe.createInstance(he);this.d.set(H,pe)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,A.$hg)(this.b)}registerEditorSerializer(H,he){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,he,this.a):this.c.set(H,he),(0,O.$Tc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}p.$do.add(e.$tF.EditorFactory,new we);async function de(re,H,he){return!re||!re.length?[]:await Promise.all(re.map(async Fe=>{const pe=C.URI.revive(Fe.fileUri);if(!pe){he.info("Cannot resolve the path because it is not valid.",Fe);return}if(!await H.canHandleResource(pe)){he.info("Cannot resolve the path because it cannot be handled",Fe);return}let ge=Fe.exists,ae=Fe.type;if(typeof ge!="boolean"||typeof ae!="number")try{ae=(await H.stat(pe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(Z){he.error(Z),ge=!1}if(!ge&&Fe.openOnlyIfExists){he.info("Cannot resolve the path because it does not exist",Fe);return}if(ae===$.FileType.Directory){he.info("Cannot resolve the path because it is a directory",Fe);return}const K={...Fe.options,pinned:!0};return ge?{resource:pe,options:K}:{resource:pe,options:K,forceUntitled:!0}}))}var $e;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function ke(re){const H=re;if(!H)return!1;const he=H;if(he.modified)return ke(he.modified);const Fe=H;return!!(Fe.contributionsState&&Fe.viewState&&Array.isArray(Fe.cursorState))}function se(re){return(0,M.$ij)(re)}function Pe(re,H,he){const Fe=(0,M.$jj)(re,H);return Fe.forceMessage=he?.forceMessage,Fe.forceSeverity=he?.forceSeverity,Fe.allowDialog=he?.allowDialog,Fe}}),define(Ce[222],Ae([1,0,5,186,3,6,28,29,18,25,92,210]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=g,e.$WF="views",e.$XF=(0,A.localize)(0,null),e.$YF=(0,S.$gx)("default-view-icon",M.$Vj.window,(0,A.localize)(1,null));var m;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var w;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$ZF=[0,1,2];function g(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new y.$ee),this.onDidRegister=this.c.event,this.f=this.B(new y.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(o,f,u){const D=this.get(o.id);if(D)return D;const l=o;return l.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,N.$yc)(this.g,f,[]).push(l),u?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:f}),l}deregisterViewContainer(o){for(const f of this.g.keys()){const u=this.g.get(f),D=u?.indexOf(o);if(D!==-1){u?.splice(D,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:o,viewContainerLocation:f});return}}}get(o){return this.all.filter(f=>f.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(f=>this.getViewContainerLocation(f)===o)}}p.$do.add(m.ViewContainersRegistry,new r);var a;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(a||(e.ViewContentGroups=a={}));function s(d,o){const f=d.group??a.More,u=o.group??a.More;return f!==u?f.localeCompare(u):(d.order??5)-(o.order??5)}class n extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new y.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new N.$Ic}registerViews(o,f){this.registerViews2([{views:o,viewContainer:f}])}registerViews2(o){o.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(o)}deregisterViews(o,f){const u=this.s(o,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(o,f){for(const u of this.m.keys())if(u!==f){const D=this.s(o,u);D.length&&(this.r(D,f),this.g.fire({views:D,from:u,to:f}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const f of this.j){const u=(this.m.get(f)||[]).filter(D=>D.id===o)[0];if(u)return u}return null}getViewContainer(o){for(const f of this.j)if((this.m.get(f)||[]).filter(D=>D.id===o)[0])return f;return null}registerViewWelcomeContent(o,f){return this.n.add(o,f),this.h.fire(o),(0,O.$Tc)(()=>{this.n.delete(o,f),this.h.fire(o)})}registerViewWelcomeContent2(o,f){const u=new Map;for(const[D,l]of f)this.n.add(o,l),u.set(D,(0,O.$Tc)(()=>{this.n.delete(o,l),this.h.fire(o)}));return this.h.fire(o),u}getViewWelcomeContent(o){const f=[];return this.n.forEach(o,u=>f.push(u)),f.sort(s)}r(o,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const D of o){if(this.getView(D.id)!==null)throw new Error((0,A.localize)(2,null,D.id));u.push(D)}}s(o,f){const u=this.m.get(f);if(!u)return[];const D=[],l=[];for(const v of u)o.includes(v)?D.push(v):l.push(v);return D.length&&(l.length?this.m.set(f,l):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),D}}p.$do.add(m.ViewsRegistry,new n),e.$2F=(0,C.$wi)("viewDescriptorService");var i;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var c;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(o,f){this.c=!1,this.d=!1,(0,E.$7n)(this,o),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const D=await f(u);D&&(this.tooltip=this.tooltip??D.tooltip,this.command=this.command??D.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=h;class t extends Error{constructor(o){super((0,A.localize)(3,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$4F=t}),define(Ce[223],Ae([1,0,187,31]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new A.$Nj("chatSessionResponseVote","",{type:"string",description:(0,y.localize)(0,null)}),e.$9F=new A.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,y.localize)(1,null)}),e.$0F=new A.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,y.localize)(2,null)}),e.$$F=new A.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,y.localize)(3,null)}),e.$_F=new A.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,y.localize)(4,null)}),e.$aG=new A.$Nj("chatResponse",!1,{type:"boolean",description:(0,y.localize)(5,null)}),e.$bG=new A.$Nj("chatRequest",!1,{type:"boolean",description:(0,y.localize)(6,null)}),e.$cG=new A.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,y.localize)(7,null)}),e.$dG=new A.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,y.localize)(8,null)}),e.$eG=new A.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,y.localize)(9,null)}),e.$fG=new A.$Nj("inChatInput",!1,{type:"boolean",description:(0,y.localize)(10,null)}),e.$gG=new A.$Nj("inChat",!1,{type:"boolean",description:(0,y.localize)(11,null)}),e.$hG=new A.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,y.localize)(12,null)}),e.$iG=new A.$Nj("chatCursorAtTop",!1),e.$jG=new A.$Nj("chatInputHasAgent",!1),e.$kG=new A.$Nj("chatLocation",void 0)}),define(Ce[224],Ae([1,0,9,24,5,42,6,132,13,31,3,12,102,204,216,223]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var s;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(h){function t(d){switch(d){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=t}(s||(e.ChatAgentLocation=s={})),e.$iH=(0,M.$wi)("chatAgentService");let n=class{constructor(t){this.f=t,this.b=[],this.d=new C.$ee,this.onDidChangeAgents=this.d.event,this.e=r.$hG.bindTo(this.f)}registerAgent(t,d){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const f=this,u=d.slashCommands;d={...d,get slashCommands(){return u.filter(l=>!l.when||f.f.contextMatchesRules(E.$uj.deserialize(l.when)))}};const D={data:d};return this.b.push(D),(0,N.$Tc)(()=>{this.b=this.b.filter(l=>l!==D),this.d.fire(void 0)})}registerAgentImplementation(t,d){const o=this.g(t);if(!o)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(o.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return o.data.isDefault&&this.e.set(!0),o.impl=d,this.d.fire(new i(o.data,d)),(0,N.$Tc)(()=>{o.impl=void 0,this.d.fire(void 0),o.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,d){const o={data:t,impl:d};return this.b.push(o),this.d.fire(new i(t,d)),(0,N.$Tc)(()=>{this.b=this.b.filter(f=>f!==o),this.d.fire(void 0)})}updateAgent(t,d){const o=this.g(t);if(!o?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);o.data.metadata={...o.data.metadata,...d},this.d.fire(new i(o.data,o.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(d=>!!d.isDefault&&d.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(d=>!!d.isDefault&&d.locations.includes(t))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(d=>d.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(d=>d.name===t)}async invokeAgent(t,d,o,f,u){const D=this.g(t);if(!D?.impl)throw new Error(`No activated agent with id ${t}`);return await D.impl.invoke(d,o,f,u)}async getFollowups(t,d,o,f,u){const D=this.g(t);if(!D?.impl)throw new Error(`No activated agent with id ${t}`);return D.impl?.provideFollowups?D.impl.provideFollowups(d,o,f,u):[]}};e.$jH=n,n.AGENT_LEADER="@",e.$jH=n=Qe([qe(0,E.$Oj)],n);class i{constructor(t,d){this.b=t,this.d=d}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,d,o,f){return this.d.invoke(t,d,o,f)}async provideFollowups(t,d,o,f){return this.d.provideFollowups?this.d.provideFollowups(t,d,o,f):[]}provideWelcomeMessage(t,d){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,d)}provideSampleQuestions(t,d){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,d)}}e.$kH=i,e.$lH=(0,M.$wi)("chatAgentNameService");let c=a=class{constructor(t,d,o,f){if(this.g=d,this.h=o,this.i=f,this.e=(0,p.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const u=f.get(a.b,-1);try{this.e.set(JSON.parse(u??"{}"),void 0)}catch{f.remove(a.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,y.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const d=await(0,w.$Up)(t);if(!d||d.version!==1)throw new Error("Unexpected chat participant registry response.");const o=d.restrictedChatParticipants;this.e.set(o,void 0),this.i.store(a.b,JSON.stringify(o),-1,1)}getAgentNameRestriction(t){return this.e.map(o=>o[t.name.toLowerCase()]).map(o=>o?o.some(f=>(0,$.$yf)(f,f.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=c,c.b="chat.participantNameRegistry",e.$mH=c=a=Qe([qe(0,m.$jk),qe(1,w.$Op),qe(2,S.$3j),qe(3,g.$2p)],c)}),define(Ce[225],Ae([1,0,2,30,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=O,e.$qG=N;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof y.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(A.$vt.isIRange)}function N(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$rG=(0,C.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Ce[226],Ae([1,0,5,9,188]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new y.$ee,this.o=new y.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,E,M){const S={command:p};if($&&Object.keys($).length>0&&(S.arguments=$),this.u("request",S),typeof M=="number"){const m=setTimeout(()=>{clearTimeout(m);const w=this.f.get(S.seq);if(w){this.f.delete(S.seq);const g={type:"response",seq:0,request_seq:S.seq,success:!1,command:p,message:(0,C.localize)(0,null,M,p)};w(g)}},M)}return E&&this.f.set(S.seq,E),S.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,A.$xh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,E=this.f.get($.request_seq);E&&(this.f.delete($.request_seq),E($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,E)=>p.set(E,$)),await(0,A.$xh)(500),p.forEach(($,E)=>{$({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Vrb=O}),define(Ce[227],Ae([1,0,2,189,31,3]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=$,e.$BJ=M,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new C.$Nj("debugType",void 0,{type:"string",description:A.localize(0,null)}),e.$xI=new C.$Nj("debugConfigurationType",void 0,{type:"string",description:A.localize(1,null)}),e.$yI=new C.$Nj("debugState","inactive",{type:"string",description:A.localize(2,null)}),e.$zI="debugUx",e.$AI=new C.$Nj(e.$zI,"default",{type:"string",description:A.localize(3,null)}),e.$BI=new C.$Nj("hasDebugged",!1,{type:"boolean",description:A.localize(4,null)}),e.$CI=new C.$Nj("inDebugMode",!1,{type:"boolean",description:A.localize(5,null)}),e.$DI=new C.$Nj("inDebugRepl",!1,{type:"boolean",description:A.localize(6,null)}),e.$EI=new C.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:A.localize(7,null)}),e.$FI=new C.$Nj("inBreakpointWidget",!1,{type:"boolean",description:A.localize(8,null)}),e.$GI=new C.$Nj("breakpointsFocused",!0,{type:"boolean",description:A.localize(9,null)}),e.$HI=new C.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:A.localize(10,null)}),e.$II=new C.$Nj("watchExpressionsExist",!1,{type:"boolean",description:A.localize(11,null)}),e.$JI=new C.$Nj("variablesFocused",!0,{type:"boolean",description:A.localize(12,null)}),e.$KI=new C.$Nj("expressionSelected",!1,{type:"boolean",description:A.localize(13,null)}),e.$LI=new C.$Nj("breakpointInputFocused",!1,{type:"boolean",description:A.localize(14,null)}),e.$MI=new C.$Nj("callStackItemType",void 0,{type:"string",description:A.localize(15,null)}),e.$NI=new C.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:A.localize(16,null)}),e.$OI=new C.$Nj("callStackItemStopped",!1,{type:"boolean",description:A.localize(17,null)}),e.$PI=new C.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:A.localize(18,null)}),e.$QI=new C.$Nj("watchItemType",void 0,{type:"string",description:A.localize(19,null)}),e.$RI=new C.$Nj("canViewMemory",void 0,{type:"boolean",description:A.localize(20,null)}),e.$SI=new C.$Nj("breakpointItemType",void 0,{type:"string",description:A.localize(21,null)}),e.$TI=new C.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:A.localize(22,null)}),e.$UI=new C.$Nj("breakpointHasModes",!1,{type:"boolean",description:A.localize(23,null)}),e.$VI=new C.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:A.localize(24,null)}),e.$WI=new C.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:A.localize(25,null)}),e.$XI=new C.$Nj("loadedScriptsItemType",void 0,{type:"string",description:A.localize(26,null)}),e.$YI=new C.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:A.localize(27,null)}),e.$ZI=new C.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:A.localize(28,null)}),e.$1I=new C.$Nj("stepBackSupported",!1,{type:"boolean",description:A.localize(29,null)}),e.$2I=new C.$Nj("restartFrameSupported",!1,{type:"boolean",description:A.localize(30,null)}),e.$3I=new C.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:A.localize(31,null)}),e.$4I=new C.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:A.localize(32,null)}),e.$5I=new C.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:A.localize(33,null)}),e.$6I=new C.$Nj("breakpointsExist",!1,{type:"boolean",description:A.localize(34,null)}),e.$7I=new C.$Nj("debuggersAvailable",!1,{type:"boolean",description:A.localize(35,null)}),e.$8I=new C.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:A.localize(36,null)}),e.$9I=new C.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:A.localize(37,null)}),e.$0I=new C.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:A.localize(38,null)}),e.$$I=new C.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:A.localize(39,null)}),e.$_I=new C.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:A.localize(40,null)}),e.$aJ=new C.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:A.localize(41,null)}),e.$bJ=new C.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:A.localize(42,null)}),e.$cJ=new C.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:A.localize(43,null)}),e.$dJ=new C.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:A.localize(44,null)}),e.$eJ=new C.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:A.localize(45,null)}),e.$fJ=new C.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:A.localize(46,null)}),e.$gJ=new C.$Nj("variableIsReadonly",!1,{type:"boolean",description:A.localize(47,null)}),e.$hJ=new C.$Nj("variableValue",!1,{type:"string",description:A.localize(48,null)}),e.$iJ=new C.$Nj("variableType",!1,{type:"string",description:A.localize(49,null)}),e.$jJ=new C.$Nj("variableInterfaces",!1,{type:"array",description:A.localize(50,null)}),e.$kJ=new C.$Nj("variableName",!1,{type:"string",description:A.localize(51,null)}),e.$lJ=new C.$Nj("variableLanguage",!1,{type:"string",description:A.localize(52,null)}),e.$mJ=new C.$Nj("variableExtensionId",!1,{type:"string",description:A.localize(53,null)}),e.$nJ=new C.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:A.localize(54,null)}),e.$oJ=new C.$Nj("multiSessionRepl",!1,{type:"boolean",description:A.localize(55,null)}),e.$pJ=new C.$Nj("multiSessionDebug",!1,{type:"boolean",description:A.localize(56,null)}),e.$qJ=new C.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:A.localize(57,null)}),e.$rJ=new C.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:A.localize(58,null)}),e.$sJ=new C.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:A.localize(59,null)}),e.$tJ=new C.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:A.localize(60,null)});const N=i=>A.localize(61,null,i);e.$uJ=N,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:A.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$AJ="vscode-debug-memory";function M(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var S;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var m;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var w;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$CJ=(0,O.$wi)("debugService");var g;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(g||(e.BreakpointWidgetContext=g={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var s;(function(i){i.deserialize=c=>c,i.serialize=c=>c})(s||(e.IDebugVisualizationTreeItem=s={}));var n;(function(i){i.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:y.URI.revive(c.iconPath.light),dark:y.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),i.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Ce[228],Ae([1,0,13,2,19,25,16,30,24,18]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=S,e.$qH=m,e.$rH=w,e.$sH=g,e.$tH=r,e.$uH=a,e.$vH=s,e.$wH=i,e.$xH=t,e.$yH=d,e.$zH=f,e.$AH=D;const M=/{([^}]+)}/g;function S(v,b,P){return v.replace(M,function(k,I){return b&&I.length>0&&I[0]!=="_"?k:P&&P.hasOwnProperty(I)?P[I]:k})}function m(v){const b={};for(const P of Object.keys(v))P.startsWith("!")||(b[P]=v[P]);return b}function w(v){return v.configuration.request==="attach"&&!g(v)&&(!v.parentSession||w(v.parentSession))}function g(v){let b=v.configuration.type;if(b)return b==="vslsShare"&&(b=v.configuration.adapterProxy.configuration.type),(0,y.$yf)(b,"extensionhost")||(0,y.$yf)(b,"pwa-extensionhost")?v:v.parentSession?g(v.parentSession):void 0}function r(v){return v.type&&(v.label||v.program||v.runtime)}function a(v,b,P){let k,I=0;const U=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Q=null;for(;Q=U.exec(v);){const G=Q.index+1,L=G+Q[0].length;if(G<=b&&L>=P){k=Q[0],I=G;break}}if(k){const G=/\w+/g;let L=null;for(;(L=G.exec(k))&&!(L.index+1+I+L[0].length>=P););L&&(k=k.substring(0,G.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}async function s(v,b,P,k){if(v.evaluatableExpressionProvider.has(b)){const I=v.evaluatableExpressionProvider.ordered(b),U=(0,E.$Hb)(await Promise.all(I.map(async Q=>{try{return await Q.provideEvaluatableExpression(b,P,k??$.CancellationToken.None)}catch{return}})));if(U.length>0){let Q=U[0].expression;const G=U[0].range;return Q||(Q=b.getLineContent(P.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:Q}}}else{const I=b.getLineContent(P.lineNumber),{start:U,end:Q}=a(I,P.column,P.column),G=I.substring(U-1,Q);return{matchingExpression:G,range:new p.$vt(P.lineNumber,U,P.lineNumber,U+G.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(v){return!!(v&&v.match(n))}function c(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(i(v.path))return A.URI.parse(v.path);if((0,C.$jc)(v.path))return A.URI.file(v.path)}return v.path}function h(v){if(typeof v.path=="object"){const b=A.URI.revive(v.path);if(b)return b.scheme===N.Schemas.file?b.fsPath:b.toString()}return v.path}function t(v,b){const P=b?c:h,k=(0,O.$4n)(v);return o(k,(I,U)=>{I&&U&&(U.path=P(U))}),k}function d(v,b){const P=b?c:h,k=(0,O.$4n)(v);return o(k,(I,U)=>{!I&&U&&(U.path=P(U))}),k}function o(v,b){switch(v.type){case"event":{const P=v;switch(P.event){case"output":b(!1,P.body.source);break;case"loadedSource":b(!1,P.body.source);break;case"breakpoint":b(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=v;switch(P.command){case"setBreakpoints":b(!0,P.arguments.source);break;case"breakpointLocations":b(!0,P.arguments.source);break;case"source":b(!0,P.arguments.source);break;case"gotoTargets":b(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(k=>b(!1,k));break;default:break}break}case"response":{const P=v;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(k=>b(!1,k.source));break;case"loadedSources":P.body.sources.forEach(k=>b(!1,k));break;case"scopes":P.body.scopes.forEach(k=>b(!1,k.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(k=>b(!1,k.source));break;case"setBreakpoints":P.body.breakpoints.forEach(k=>b(!1,k.source));break;case"disassemble":P.body?.instructions.forEach(I=>b(!1,I.location));break;default:break}break}}}function f(v){return v.filter(b=>!b.presentation?.hidden).sort((b,P)=>b.presentation?P.presentation?b.presentation.group?P.presentation.group?b.presentation.group!==P.presentation.group?b.presentation.group.localeCompare(P.presentation.group):u(b.presentation.order,P.presentation.order):-1:P.presentation.group?1:u(b.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function u(v,b){return typeof v!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:v-b}async function D(v,b){const P=v.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(P!=="none"&&(await b.saveAll(),P==="allEditorsInActiveGroup")){const k=b.activeEditorPane;k&&k.input.resource?.scheme===N.Schemas.untitled&&await b.save({editor:k.input,groupId:k.group.id})}await v.reloadConfiguration()}const l=(v,b)=>!v||!b?v===b:v.name===b.name&&v.path===b.path&&v.sourceReference===b.sourceReference;e.$BH=l}),define(Ce[229],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.CellExecutionUpdateType=void 0;var A;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(A||(e.CellExecutionUpdateType=A={})),e.$PK=(0,y.$wi)("INotebookExecutionService")}),define(Ce[230],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njb=e.$mjb=e.ProxyKernelState=e.$ljb=void 0,e.$ljb=100;var A;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(A||(e.ProxyKernelState=A={})),e.$mjb=(0,y.$wi)("INotebookKernelService"),e.$njb=(0,y.$wi)("INotebookKernelHistoryService")}),define(Ce[231],Ae([1,0,6,30,150,97]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oXb=void 0;class N extends y.$Vc{constructor($,E,M){super(),this._source=$,this.b=E,this.c=M,this.a=void 0}f($){const E=$.getLineCount();return new A.$vt(1,1,E,this.g($,E))}g($,E){if(E<1||E>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const $=new C.$3C;$.acceptChunk(this._source);const E=$.finish(!0),{textBuffer:M,disposable:S}=E.create(1);this.b=M,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const E=new C.$3C;E.acceptChunk($);const M=E.finish(!0),{textBuffer:S,disposable:m}=M.create(1);return this.B(m),S})),this.a}findInInputs($){const M=new O.$QC($,!1,!1,null).parseSearchRequest();if(!M)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,M,!0,5e3)}findInOutputs($){const M=new O.$QC($,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(S=>{const m=S.findMatchesLineByLine(this.f(S),M,!0,5e3);if(m.length!==0)return{textBuffer:S,matches:m}}).filter(S=>!!S):[]}}e.$oXb=N}),define(Ce[52],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(O){O.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var A;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class C{static fromExtHostTestItem(N,p,$=N.parent){if(N._isRoot)return new C([p]);const E=[N.id];for(let M=$;M&&M.id!==p;M=M.parent)E.push(M.id);return E.push(p),new C(E.reverse())}static isRoot(N){return!N.includes("\0")}static root(N){const p=N.indexOf("\0");return p===-1?N:N.slice(0,p)}static fromString(N){return new C(N.split("\0"))}static join(N,p){return new C([...N.path,p])}static joinToString(N,p){return N.toString()+"\0"+p}static parentId(N){const p=N.lastIndexOf("\0");return p===-1?void 0:N.slice(0,p)}static localId(N){const p=N.lastIndexOf("\0");return p===-1?N:N.slice(p+1)}static isChild(N,p){return p.startsWith(N)&&p[N.length]==="\0"}static compare(N,p){return N===p?0:C.isChild(N,p)?2:C.isChild(p,N)?3:1}constructor(N,p=N.length){if(this.path=N,this.d=p,N.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let N=1;N<=this.d;N++)yield new C(this.path,N)}*idsToRoot(){for(let N=this.d;N>0;N--)yield new C(this.path,N)}compare(N){if(typeof N=="string")return C.compare(this.toString(),N);for(let p=0;p<N.d&&p<this.d;p++)if(N.path[p]!==this.path[p])return 1;return N.d>this.d?2:N.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let N=1;N<this.d;N++)this.c+="\0",this.c+=this.path[N]}return this.c}}e.$VL=C}),define(Ce[62],Ae([1,0,2,95,30,52]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$3L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2L=e.$1L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YL=e.$XL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$WL=e.TestResultState=void 0;var N;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(N||(e.TestResultState=N={})),e.$WL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$XL=[2,4,8,16,32,64];const E=R=>"runId"in R;e.$YL=E;var M;(function(R){R.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),R.deserialize=(F,T)=>({range:C.$vt.lift(T.range),uri:F.asCanonicalUri(y.URI.revive(T.uri))})})(M||(e.IRichLocation=M={}));var S;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(S||(e.TestMessageType=S={}));var m;(function(R){R.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&M.serialize(F.location)}),R.deserialize=(F,T)=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&M.deserialize(F,T.location)})})(m||(e.ITestErrorMessage=m={}));const w=(R,F)=>`${F?"s":"e"}${R}`;e.$ZL=w;var g;(function(R){R.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&M.serialize(F.location)}),R.deserialize=(F,T)=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&M.deserialize(F,T.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(R){R.serialize=F=>F.type===0?m.serialize(F):g.serialize(F),R.deserialize=(F,T)=>T.type===0?m.deserialize(F,T):g.deserialize(F,T)})(r||(e.ITestMessage=r={}));var a;(function(R){R.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),R.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(r.serialize)}),R.deserialize=(F,T)=>({state:T.state,duration:T.duration,messages:T.messages.map(X=>r.deserialize(F,X))})})(a||(e.ITestTaskState=a={}));const s="\0",n=(R,F)=>R+s+F;e.$1L=n;const i=R=>{const F=R.indexOf(s);return{ctrlId:R.slice(0,F),tagId:R.slice(F+1)}};e.$2L=i;var c;(function(R){R.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),R.deserialize=(F,T)=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?F.asCanonicalUri(y.URI.revive(T.uri)):void 0,range:T.range?C.$vt.lift(T.range):null,description:T.description,error:T.error,sortText:T.sortText})})(c||(e.ITestItem=c={}));var h;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(R){R.serialize=F=>({expand:F.expand,item:c.serialize(F.item)}),R.deserialize=(F,T)=>({controllerId:O.$VL.root(T.item.extId),expand:T.expand,item:c.deserialize(F,T.item)})})(t||(e.InternalTestItem=t={}));var d;(function(R){R.serialize=F=>{let T;return F.item&&(T={},F.item.label!==void 0&&(T.label=F.item.label),F.item.tags!==void 0&&(T.tags=F.item.tags),F.item.busy!==void 0&&(T.busy=F.item.busy),F.item.uri!==void 0&&(T.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(T.range=F.item.range?.toJSON()),F.item.description!==void 0&&(T.description=F.item.description),F.item.error!==void 0&&(T.error=F.item.error),F.item.sortText!==void 0&&(T.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:T}},R.deserialize=F=>{let T;return F.item&&(T={},F.item.label!==void 0&&(T.label=F.item.label),F.item.tags!==void 0&&(T.tags=F.item.tags),F.item.busy!==void 0&&(T.busy=F.item.busy),F.item.range!==void 0&&(T.range=F.item.range?C.$vt.lift(F.item.range):null),F.item.description!==void 0&&(T.description=F.item.description),F.item.error!==void 0&&(T.error=F.item.error),F.item.sortText!==void 0&&(T.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:T}}})(d||(e.ITestItemUpdate=d={}));const o=(R,F)=>{F.expand!==void 0&&(R.expand=F.expand),F.item!==void 0&&(R.item=R.item?Object.assign(R.item,F.item):F.item)};e.$3L=o;var f;(function(R){R.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(a.serializeWithoutMessages)}),R.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(a.serialize)}),R.deserialize=(F,T)=>({...t.deserialize(F,T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(X=>a.deserialize(F,X)),retired:!0})})(f||(e.TestResultItem=f={}));var u;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(F,T)=>{F.covered+=T.covered,F.total+=T.total}})(u||(e.ICoverageCount=u={}));var D;(function(R){R.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,uri:F.uri.toJSON()}),R.deserialize=(F,T)=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:F.asCanonicalUri(y.URI.revive(T.uri))})})(D||(e.IFileCoverage=D={}));function l(R){return{...R,location:R.location?.toJSON()}}function v(R){return R.location=R.location?A.$ut.isIPosition(R.location)?A.$ut.lift(R.location):C.$vt.lift(R.location):void 0,R}e.$4L=3;var b;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(b||(e.DetailType=b={}));var P;(function(R){R.serialize=F=>F.type===0?I.serialize(F):U.serialize(F),R.deserialize=F=>F.type===0?I.deserialize(F):U.deserialize(F)})(P||(e.CoverageDetails=P={}));var k;(function(R){R.serialize=l,R.deserialize=v})(k||(e.IBranchCoverage=k={}));var I;(function(R){R.serialize=l,R.deserialize=v})(I||(e.IDeclarationCoverage=I={}));var U;(function(R){R.serialize=F=>({...l(F),branches:F.branches?.map(k.serialize)}),R.deserialize=F=>({...v(F),branches:F.branches?.map(k.deserialize)})})(U||(e.IStatementCoverage=U={}));var Q;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(Q||(e.TestDiffOpType=Q={}));var G;(function(R){R.deserialize=(F,T)=>T.op===0?{op:T.op,item:t.deserialize(F,T.item)}:T.op===1?{op:T.op,item:d.deserialize(T.item)}:T.op===2?{op:T.op,uri:F.asCanonicalUri(y.URI.revive(T.uri)),docv:T.docv}:T,R.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:d.serialize(F.item)}:F})(G||(e.TestsDiffOp=G={}));class L{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const T=this.v();for(const X of F)switch(X.op){case 0:this.l(t.deserialize(this.k,X.item),T);break;case 1:this.o(d.deserialize(X.item),T);break;case 3:this.p(X.itemId,T);break;case 5:this.q(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}T.complete?.()}l(F,T){const X=O.$VL.parentId(F.item.extId)?.toString();let ne;if(!X)ne=this.w(F),this.g.add(ne),this.f.set(F.item.extId,ne);else if(this.f.has(X)){const me=this.f.get(X);me.children.add(F.item.extId),ne=this.w(F,me),this.f.set(F.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return T.add?.(ne),F.expand===2&&this.h++,ne}o(F,T){const X=this.f.get(F.extId);if(X)return F.expand!==void 0&&(X.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$3L)(X,F),T.update?.(X),X}p(F,T){const X=this.f.get(F);if(!X)return;const ne=O.$VL.parentId(X.item.extId)?.toString();ne?this.f.get(ne).children.delete(X.item.extId):this.g.delete(X);const me=[[F]];for(;me.length;)for(const we of me.pop()){const de=this.f.get(we);de&&(me.push(de.children),this.f.delete(we),T.remove?.(de,de!==X),de.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$5L=L}),define(Ce[77],Ae([1,0,9,5,6,57,62,52]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const E=(n,i)=>n===i,S=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(c=>!i.includes(c)))}),m=(n,i)=>{let c;for(const[h,t]of S)t(n[h],i[h])||(c?c[h]=i[h]:c={[h]:i[h]});return c};class w extends C.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new y.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new A.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,N.$3L)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,N.$3L)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O(p.$VL.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const h of c.ops)this.w(i,h);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,O.$fd)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const h=p.$VL.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let d=this.tree.get(h.toString());if(!d){d={fullId:h,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(i)}}),this.I(i,d,c);return}if(d.actual===i){this.H(i,d,c);return}if(d.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,c);const o=this.s.getChildren(d.actual),f=d.actual,u=m(this.s.toITestItem(f),this.s.toITestItem(i));this.s.getApiFor(f).listener=void 0,d.actual=i,d.resolveBarrier=void 0,d.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(i.tags,f.tags,h.toString()),delete u.tags),this.w(d,{op:4,update:u})),this.I(i,d,c);for(const[l,v]of o)this.s.getChildren(i).get(v.id)||this.O(p.$VL.joinToString(h,v.id));const D=d.expandLevels;D!==void 0&&queueMicrotask(()=>{d.expand===1&&(d.expandLevels=void 0,this.expand(h.toString(),D))}),this.y(d.actual.uri)}C(i,c,h){const t=new Set(c.map(d=>d.id));for(const d of i)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(d=>(0,N.$1L)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,N.$1L)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,N.$1L)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=d=>this.w(c,d),this.J(c)}I(i,c,h){this.H(i,c,h);for(const[t,d]of this.s.getChildren(i))this.z(d,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const h=[];for(const[t,d]of this.s.getChildren(i.actual)){const o=this.expand(p.$VL.joinToString(i.fullId,d.id),c);(0,y.$ih)(o)&&h.push(o)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const d=new y.$vh;return d.open(),d}i.expand=2,this.N(i);const c=i.resolveBarrier=new y.$vh,h=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(d){h(d)}return(0,y.$ih)(t)?t.catch(h).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,o]of this.s.getChildren(t.actual))h.push(this.tree.get(p.$VL.joinToString(t.fullId,o.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$nP=w;class g extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$oP=g;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pP=r;class a extends Error{constructor(i,c,h){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$qP=a;const s=(n,i,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,d){for(const o of h.values())t.call(d,o,this)},[Symbol.iterator](){return h.entries()},replace(t){const d=new Map,o=new Set(h.keys()),f={op:5,ops:[]};for(const u of t){if(!(u instanceof c))throw new r(u.id);const D=i(u).controllerId;if(D!==n.controllerId)throw new a(u.id,D,n.controllerId);if(d.has(u.id))throw new g(u.id);d.set(u.id,u),o.delete(u.id),f.ops.push({op:0,item:u})}for(const u of o.keys())f.ops.push({op:3,id:u});n.listener?.(f),h=d},add(t){if(!(t instanceof c))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$rP=s}),define(Ce[107],Ae([1,0,77]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=void 0;const A=new WeakMap,C=(N,p)=>{const $={controllerId:p};return A.set(N,$),$};e.$sP=C;const O=N=>{const p=A.get(N);if(!p)throw new y.$pP(N?.id||"<unknown>");return p};e.$tP=O}),define(Ce[78],Ae([1,0,16,2]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZAb=e.$YAb=e.$XAb=void 0,e.$1Ab=C,e.$2Ab=N,e.$XAb="vscode-cdn.net",e.$YAb=`vscode-resource.${e.$XAb}`,e.$ZAb=`'self' https://*.${e.$XAb}`;function C(p,$){return p.scheme===y.Schemas.http||p.scheme===y.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===y.Schemas.file&&(p=A.URI.from({scheme:y.Schemas.vscodeRemote,authority:$.authority,path:p.path})),A.URI.from({scheme:y.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$YAb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,$=>{const E=$.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?$:"-"+E.toString(16).padStart(4,"0")})}function N(p){return p.replace(/-([0-9a-f]{4})/g,($,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Ce[232],Ae([1,0,5,6,78]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class O{constructor(p,$,E){this.d=p,this.e=$,this.f=E,this.a=0,this.b=new A.$Uc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const M=$.getVisibleTextEditors();for(const S of this.c.values())M.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,E,M,S){let m;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){m=i;break}if(!m)throw new Error("not a visible editor");const w=this,g=this.a++,r=new y.$ee,a=new y.$ee,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$1Ab)(i,w.f)}get cspSource(){return C.$ZAb}set options(i){this.b=i,w.d.$setOptions(g,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(g,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return w.d.$postMessage(g,i)}},n=new class{constructor(){this.editor=p,this.line=$,this.height=E,this.webview=s,this.onDidDispose=a.event}dispose(){w.c.has(g)&&(w.c.delete(g),w.d.$disposeEditorInset(g),a.fire(),a.dispose(),r.dispose())}};return this.d.$createEditorInset(g,m.id,m.value.document.uri,$+1,E,M||{},S.identifier,S.extensionLocation),this.c.set(g,{editor:p,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$ylc=O}),define(Ce[108],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=void 0,e.$_L="__",e.$aM=(0,y.$wi)("IAuthenticationService"),e.$bM=(0,y.$wi)("IAuthenticationExtensionsService")}),define(Ce[233],Ae([1,0,3]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.VariableKind=e.$jQ=void 0,e.$jQ=(0,y.$wi)("configurationResolverService");var A;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(A||(e.VariableKind=A={}));class C extends Error{constructor(N,p){super(p),this.variable=N}}e.$kQ=C}),define(Ce[234],Ae([1,0,19,75,15,25,22,93,192,233,13]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;class S{constructor(w,g,r,a){this.h=new Map,this.a=w,this.b=g,this.g=r,a&&(this.c=a.then(s=>this.i(s)))}i(w){if(N.$c){const g=Object.create(null);return Object.keys(w).forEach(r=>{g[r.toLowerCase()]=w[r]}),g}return w}resolveWithEnvironment(w,g,r){return this.l({env:this.i(w),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(w,g){const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,g)}async j(w,g,r,a){const s=O.$4n(g);N.$c&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):N.$d&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):N.$e&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,s,r,a)}async resolveAnyAsync(w,g,r){return this.j(w,g,r)}async resolveAnyMap(w,g,r){const a=new Map;return{newConfig:await this.j(w,g,r,a),resolvedVariables:a}}resolveWithInteractionReplace(w,g,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,g,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,g){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,g)}async l(w,g,r,a,s){if(C.$9f(r))return this.m(w,g,r,a,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(w,g,n,a,s)));if(C.$$f(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async c=>[await this.m(w,g,c,a,s),await this.l(w,g,r[c],a,s)]));for(const[c,h]of i)n[c]=h;return n}return r}m(w,g,r,a,s){return(0,M.$qf)(r,S.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(S.VARIABLE_LHS))return n;let c=await this.o(w,n,i,g,a);return s?.set(i,c),c!==n&&C.$9f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(w,g,c,a,s)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,g,r,a,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const c=d=>{const o=this.a.getFilePath();if(o)return(0,p.$Fw)(o);throw new E.$kQ(d,(0,$.localize)(0,null,g))},h=d=>{const o=c(d);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,p.$Fw)(f)}throw new E.$kQ(d,(0,$.localize)(1,null,g,y.$oc(o)))},t=d=>{if(n){const o=this.a.getFolderUri(n);if(o)return o;throw new E.$kQ(d,(0,$.localize)(2,null,g,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new E.$kQ(d,(0,$.localize)(3,null,g)):new E.$kQ(d,(0,$.localize)(4,null,g))};switch(r){case"env":if(n){if(w.env){const d=w.env[N.$c?n.toLowerCase():n];if(C.$9f(d))return d}return""}throw new E.$kQ(E.VariableKind.Env,(0,$.localize)(5,null,g));case"config":if(n){const d=this.a.getConfigurationValue(a,n);if(C.$fg(d))throw new E.$kQ(E.VariableKind.Config,(0,$.localize)(6,null,g,n));if(C.$$f(d))throw new E.$kQ(E.VariableKind.Config,(0,$.localize)(7,null,g,n));return d}throw new E.$kQ(E.VariableKind.Config,(0,$.localize)(8,null,g));case"command":return this.p(E.VariableKind.Command,g,n,s,"command");case"input":return this.p(E.VariableKind.Input,g,n,s,"input");case"extensionInstallFolder":if(n){const d=await this.a.getExtension(n);if(!d)throw new E.$kQ(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,g,n));return this.n(d.extensionLocation)}throw new E.$kQ(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,p.$Fw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,p.$Fw)(this.n(t(E.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Fw)(y.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new E.$kQ(E.VariableKind.UserHome,(0,$.localize)(11,null,g))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new E.$kQ(E.VariableKind.LineNumber,(0,$.localize)(12,null,g))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new E.$kQ(E.VariableKind.SelectedText,(0,$.localize)(13,null,g))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?y.$mc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const d=y.$nc(c(E.VariableKind.RelativeFileDirname));if(a||n){const o=y.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),d);return o.length===0?".":o}return d}case"fileDirname":return y.$nc(c(E.VariableKind.FileDirname));case"fileExtname":return y.$pc(c(E.VariableKind.FileExtname));case"fileBasename":return y.$oc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=y.$oc(c(E.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-y.$pc(d).length)}case"fileDirnameBasename":return y.$oc(y.$nc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||g}case"execInstallFolder":{const d=this.a.getAppRoot();return d||g}case"pathSeparator":case"/":return y.sep;default:try{const d=n?`${r}:${n}`:r;return this.p(E.VariableKind.Unknown,g,d,s,void 0)}catch{return g}}}}p(w,g,r,a,s){if(r&&a){const n=s===void 0?a[r]:a[s+":"+r];if(typeof n=="string")return n;throw new E.$kQ(w,(0,$.localize)(14,null,g))}return g}}e.$zQ=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[109],Ae([1,0,3,106]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=E,e.$1D=m,e.$2D=w,e.$YD=(0,y.$wi)("editorGroupsService");var C;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var O;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var N;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(N||(e.GroupLocation=N={}));var p;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function E(g){const r=g;return(0,A.$JF)(r?.editor)&&(0,A.$JF)(r?.replacement)}var M;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function m(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function w(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ce[235],Ae([1,0,3,109]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=C,e.$3D=(0,y.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function C(O){const N=O;return typeof O=="number"||(0,A.$1D)(N)}}),define(Ce[236],Ae([1,0,3,99]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=void 0,e.$uM=(0,y.$xi)(A.$Di)}),define(Ce[110],Ae([1,0,20,5,19,6,9]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=e.$T_b=void 0;class p{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$T_b=p;class ${static isHostExtension(n,i,c){if(i.getExtensionDescription(n))return!1;const h=c.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,i){this.j=n,this.c=new A.$ee,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new y.$Um,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=a(this.e,i),this.e=this.e.concat(n);const c=$.l(this.e);return this.e=a(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(o){this.d.has(o)||(this.d.add(o),this.e.push(o))}addArc(o,f){this.addNode(o),this.addNode(f),this.c.has(o)?this.c.get(o).push(f):this.c.set(o,[f])}getArcs(o){return this.c.has(o)?this.c.get(o):[]}hasOnlyGoodArcs(o,f){const u=i.getArcs(o);for(let D=0;D<u.length;D++)if(!f.has(u[D]))return!1;return!0}getNodes(){return this.e}},c=new y.$Um;for(const o of n)if(c.set(o.identifier,o),o.extensionDependencies)for(const f of o.extensionDependencies)i.addArc(y.$Sm.toKey(o.identifier),y.$Sm.toKey(f));const h=new Set;i.getNodes().filter(o=>i.getArcs(o).length===0).forEach(o=>h.add(o));const t=i.getNodes().filter(o=>!h.has(o));let d;do{d=!1;for(let o=0;o<t.length;o++){const f=t[o];i.hasOnlyGoodArcs(f,h)&&(t.splice(o,1),o--,h.add(f),d=!0)}}while(d);return t.map(o=>c.get(o))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$U_b=$;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$V_b=E;class M{constructor(n){this.d=new w,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new S(this,i)}deltaExtensions(n,i,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$W_b=M;class S extends O.$Vc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$X_b=S;class m{constructor(n){this.name=n;const i=(0,N.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class w{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new m(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};n.resolve((0,O.$Tc)(h))}}var g;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(g||(g={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==c)return i-c;const h=C.$hc.basename(s.extensionLocation.path),t=C.$hc.basename(n.extensionLocation.path);return h<t?-1:h>t?1:0}function a(s,n){const i=new y.$Tm(n);return s.filter(c=>!i.has(c.identifier))}}),define(Ce[79],Ae([1,0,21]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$1m=N,e.$2m=p;var A;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(A||(e.UIKind=A={}));var C;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var O;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function N(E){const M=y.$Ge.alloc(1);switch(E){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}function p(E,M){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}var $;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ce[63],Ae([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=e.$PP=e.$OP=void 0,e.$QP=r;let w=class extends S.$Vc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new A.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$lp,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,C.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,i){const c=this.getTelemetryDetails(),h=new g(n,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this.f=s,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Jm)((0,$.$rp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((i,c)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$OP=w,e.$OP=w=Qe([qe(0,O.$NP),qe(1,C.$4j)],w);class g{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,c,h,t,d){this.g=i,this.h=c,this.i=h,this.j=t,this.a=new A.$ee,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,$.$up)(n,[]),this.c&&(n=(0,E.$7n)(n,this.c)),this.b||(n=(0,E.$7n)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,$.$up)(i,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$PP=g;function r(a){const s=Date.now()-new Date(a).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$RP=(0,y.$wi)("IExtHostTelemetry")}),define(Ce[26],Ae([1,0,5,2,207,105,20,3]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=m,e.$PG=w,e.$SG=s,e.$TG=n,e.$JG=Object.freeze({identifier:new N.$Sm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,p.$wi)("extensionService");class ${constructor(h){this.dependency=h}}e.$MG=$;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,d){this.c=h,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$uG.createActivationEventsMap(this.d)}}set(h,t,d){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const o=[],f=[],u=[],D=[],l=S(this.d),v=S(t),b=(Q,G)=>Q.extensionLocation.toString()===G.extensionLocation.toString()||Q.isBuiltin===G.isBuiltin||Q.isUserBuiltin===G.isUserBuiltin||Q.isUnderDevelopment===G.isUnderDevelopment;for(const Q of this.d){const G=v.get(Q.identifier);if(!G){o.push(Q.identifier),l.delete(Q.identifier);continue}if(!b(Q,G)){o.push(Q.identifier),l.delete(Q.identifier);continue}}for(const Q of t){const G=l.get(Q.identifier);if(!G){f.push(Q);continue}if(!b(G,Q)){o.push(G.identifier),l.delete(G.identifier);continue}}const P=new N.$Tm(this.e),k=new N.$Tm(d);for(const Q of this.e)k.has(Q)||u.push(Q);for(const Q of d)P.has(Q)||D.push(Q);const I=O.$uG.createActivationEventsMap(f),U={versionId:h,toRemove:o,toAdd:f,addActivationEvents:I,myToRemove:u,myToAdd:D};return this.delta(U),U}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:o,myToAdd:f}=h,u=new N.$Tm(t),D=new N.$Tm(o);for(let l=0;l<this.d.length;l++)u.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)D.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of d)this.d.push(l);for(const l of f)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(N.$Sm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=O.$uG.readActivationEvents(t);for(const o of d)h.add(o)}return h}}e.$NG=M;function S(c){const h=new N.$Um;for(const t of c)h.set(t.identifier,t);return h}function m(c,h){return!0}function w(c,h){if(!m(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class g{constructor(h,t,d,o){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=o}}e.$QG=g;class r{constructor(h,t){this.description=h,this.value=t}}e.$RG=r;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$Ap)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,h){return{identifier:new N.$Sm((0,C.$yp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(Ce[237],Ae([1,0,14,110,20,26,12,9]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=e.$Xlc=e.$Wlc=e.$Vlc=e.$Ulc=void 0;class ${constructor(s,n,i,c){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=c}}e.$Ulc=$,$.NONE=new $(!1,-1,-1,-1);class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Vlc=E;class M{constructor(s,n,i,c,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=c,this.exports=h,this.subscriptions=t}}e.$Wlc=M;class S extends M{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xlc=S;class m extends M{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ylc=m;class w extends M{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(s,n,i,c){this.g=c,this.a=s,this.b=n,this.c=i,this.d=new C.$Um,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(h));return this.c.onExtensionActivationError(s.id,h,new O.$MG(s.id.value)),t}const i=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const d=this.a.getExtensionDescription(h);if(d){if(!d.main&&!d.browser)continue;i.push(this.j({id:d.identifier,reason:s.reason}));continue}const o=n.displayName||n.identifier.value,f=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${h}'`),u=this.k(s,n.displayName,[],new w(f));return this.c.onExtensionActivationError(n.identifier,f,new O.$MG(h)),u}return this.k(s,n.displayName,i,null)}k(s,n,i,c){const h=new r(s.id,n,s.reason,i,c,this.c,this.g);return this.d.set(s.id,h),h}l(s){return A.$U_b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Zlc=g,e.$Zlc=g=Qe([qe(3,N.$3j)],g);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,i,c,h,t,d){this.c=s,this.d=n,this.f=i,this.g=c,this.h=h,this.j=t,this.k=d,this.a=new p.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new w(n),this.b&&y.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Qe([qe(6,N.$3j)],r)}),define(Ce[238],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[239],Ae([1,0,194,14,33,100,74,29,20,238,102,105]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const m=p.$do.as(N.$eo.JSONContribution);class w{constructor(h,t,d){this.a=h,this.b=t,this.c=d}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$DG=w;class g{static a(h){const t=new $.$Tm;for(let d=0,o=h.length;d<o;d++)t.add(h[d].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new g(t,[]);if(!t||!t.length)return new g([],h);const d=this.a(h),o=this.a(t),f=t.filter(D=>!d.has(D.description.identifier)),u=h.filter(D=>!o.has(D.description.identifier));return new g(f,u)}constructor(h,t){this.added=h,this.removed=t}}e.$EG=g;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=g.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,A.$1)(h)}}}e.$FG=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Rm},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Uo}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Uo}},extensionKind:{description:y.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&S.$uG.register(h.extensionPoint,h.activationEventsGenerator),e.$GG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,m.registerSchema(s,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$do.add(i.ExtensionsRegistry,new n),e.$IG=p.$do.as(i.ExtensionsRegistry),m.registerSchema(s,e.$GG),m.registerSchema(M.$kk,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Ce[240],Ae([1,0,190,15,25,239,31,5]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var E;(function(m){function w(g,r,a){if(!g)return;const s=A.$9f(g.type)?g.type:void 0;if(!s||s.length===0){a.error(y.localize(3,null));return}const n=[];if(Array.isArray(g.required))for(const i of g.required)A.$9f(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:g.properties?C.$4n(g.properties):{},when:g.when?N.$uj.deserialize(g.when):void 0}}m.from=w})(E||(E={}));const M=O.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,w)=>{for(const g of m)g.type&&w.push(`onTaskType:${g.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:$}});class S{constructor(){this.d=new p.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,g)=>{M.setHandler((r,a)=>{this.c=void 0;try{for(const s of a.removed){const n=s.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of a.added){const n=s.value;for(const i of n){const c=E.from(i,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=C.$4n(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},w.push(r)}this.c={oneOf:w}}return this.c}}e.$cI=new S}),define(Ce[241],Ae([1,0,191,15,23,25,31,240]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new N.$Nj("taskRunning",!1,y.localize(0,null)),e.$fI=y.localize2(2,"Tasks");var $;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$gI="$customized",function(R){function F(T){if(!T)return R.Strong;switch(T.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=F}($||(e.ShellQuoting=$={}));var E;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var M;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(M||(e.RevealKind=M={})),function(R){function F(T){switch(T.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=F}(M||(e.RevealKind=M={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(R){function F(T){switch(T.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=F}(S||(e.RevealProblemKind=S={}));var m;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(m||(e.PanelKind=m={})),function(R){function F(T){switch(T.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=F}(m||(e.PanelKind=m={}));var w;(function(R){R.defaults={echo:!0,reveal:M.Always,revealProblems:S.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var g;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(R){function F(X){switch(X.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=F;function T(X){switch(X){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=T}(g||(e.RuntimeType=g={}));var r;(function(R){function F(T){return A.$9f(T)?T:T.value}R.value=F})(r||(e.CommandString=r={}));var a;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function F(X){return X===R.Clean._id||X===R.Build._id||X===R.Rebuild._id||X===R.Test._id}R.is=F;function T(X){if(X!==void 0)return A.$9f(X)?F(X)?{_id:X,isDefault:!1}:void 0:X}R.from=T})(a||(e.TaskGroup=a={}));var s;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function F(T){switch(T){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var i;(function(R){R.parallel="parallel",R.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(F,T,X,ne,me,we){this._label="",this._id=F,T&&(this._label=T),X&&(this.type=X),this.runOptions=ne,this.configurationProperties=me,this._source=we}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,T=!1){if(F===void 0)return!1;if(A.$9f(F))return F===this._label||F===this.configurationProperties.identifier||T&&F===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$hI=t;class d extends t{constructor(F,T,X,ne,me,we,de,$e){super(F,X,void 0,de,$e,T),this.command={},this._source=T,this.hasDefinedMatchers=we,me&&(this.command=me)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let T;switch(this.command?this.command.runtime:void 0){case g.Shell:T="shell";break;case g.Process:T="process";break;case g.CustomExecution:T="customExecution";break;case void 0:T="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:T,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let T=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(T+=this._source.kind);const X={type:e.$gI,folder:F,id:T};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$iI=d;class o extends t{constructor(F,T,X,ne,me,we,de){super(F,X,ne,we,de,T),this._source=T,this.configures=me}static is(F){return F instanceof o}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let T=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(T+=this._source.kind);const X={type:e.$gI,folder:F,id:T};return JSON.stringify(X)}}e.$jI=o;class f extends t{constructor(F,T,X,ne,me,we,de,$e,ke){super(F,X,ne,$e,ke,T),this.defines=me,this.hasDefinedMatchers=de,this.command=we,this.icon=ke.icon,this.hide=ke.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof f}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new f(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$kI=f;class u extends t{constructor(F,T,X,ne,me,we){super(F,X,ne,me,we,T),this._source=T}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new u(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$lI=u;var D;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(R){R._default=R.Terminal}(D||(e.ExecutionEngine=D={}));var l;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class v{constructor(F){this.c=new Map;for(let T=0;T<F.length;T++)this.c.set(F[T].uri.toString(),T)}compare(F,T){const X=F.getWorkspaceFolder(),ne=T.getWorkspaceFolder();if(X&&ne){let me=this.c.get(X.uri.toString());me=me===void 0?0:me+1;let we=this.c.get(ne.uri.toString());return we=we===void 0?0:we+1,me===we?F._label.localeCompare(T._label):me-we}else return!X&&ne?-1:X&&!ne?1:0}}e.$mI=v;var b;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(b||(e.TaskEventKind=b={}));var P;(function(R){R.SingleRun="singleRun",R.Background="background"})(P||(e.TaskRunType=P={}));var k;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(R){function F($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function T($e,ke,se){return{...F($e),kind:"start",terminalId:ke,resolvedVariables:se}}R.start=T;function X($e,ke,se){return{...F($e),kind:"processStarted",terminalId:ke,processId:se}}R.processStarted=X;function ne($e,ke,se){return{...F($e),kind:"processEnded",terminalId:ke,exitCode:se}}R.processEnded=ne;function me($e,ke,se){return{...F($e),kind:"terminated",exitReason:se,terminalId:ke}}R.terminated=me;function we($e,ke,se){return{...F(ke),kind:$e,terminalId:se}}R.general=we;function de(){return{kind:"changed"}}R.changed=de})(I||(e.TaskEvent=I={}));var U;(function(R){function F(X){const ne=Object.keys(X).sort();let me="";for(const we of ne){let de=X[we];de instanceof Object?de=F(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),me+=we+","+de+","}return me}function T(X){const me={_key:F(X),type:X.taskType};return Object.assign(me,X),me}R.create=T})(U||(e.KeyedTaskIdentifier=U={}));var Q;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(Q||(e.TaskSettingId=Q={}));var G;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var L;(function(R){function F(T,X){const ne=p.$cI.get(T.type);if(ne===void 0){const $e=O.$4n(T);return delete $e._key,U.create($e)}const me=Object.create(null);me.type=ne.taskType;const we=new Set;ne.required.forEach($e=>we.add($e));const de=ne.properties;for(const $e of Object.keys(de)){const ke=T[$e];if(ke!=null)me[$e]=ke;else if(we.has($e)){const se=de[$e];if(se.default!==void 0)me[$e]=O.$4n(se.default);else switch(se.type){case"boolean":me[$e]=!1;break;case"number":case"integer":me[$e]=0;break;case"string":me[$e]="";break;default:X.error(y.localize(1,null,JSON.stringify(T,void 0,0),$e));return}}}return U.create(me)}R.createTaskIdentifier=F})(L||(e.TaskDefinition=L={}))}),define(Ce[242],Ae([1,0,14]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=e.$Y_b=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((N,p)=>{this.b=N,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(N){this.f||this.h||(this.f=!0,this.g=N,this.a&&this.b(N))}resolveErr(N){this.f||this.h||(this.h=!0,this.i=N,this.a?this.d(N):(0,y.$1)(N))}then(N,p){return this.j().then(N,p)}catch(N){return this.j().then(void 0,N)}finally(N){return this.j().finally(N)}}e.$Y_b=A;class C extends A{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$Z_b=C}),define(Ce[35],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$zw=void 0,e.$Aw=C,e.$Bw=O;class y{constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++y.count}}e.$zw=y,y.count=0;const A=[];function C(p){const $=new y(p);return A[$.nid]=$,$}function O(p){return A[p].sid}class N{constructor($){this.value=$}}e.$Cw=N}),define(Ce[4],Ae([1,0,35]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var C;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var N;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(N||(e.WebviewEditorCapabilities=N={}));var p;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var M;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class S{static mixin(a){return a._id=S.a++,a}}e.$9M=S,S.a=0;var m;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var w;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$0M={MainThreadAuthentication:(0,y.$Aw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Aw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,y.$Aw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,y.$Aw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Aw)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Aw)("MainThreadClipboard"),MainThreadCommands:(0,y.$Aw)("MainThreadCommands"),MainThreadComments:(0,y.$Aw)("MainThreadComments"),MainThreadConfiguration:(0,y.$Aw)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Aw)("MainThreadConsole"),MainThreadDebugService:(0,y.$Aw)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Aw)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Aw)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Aw)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Aw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Aw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Aw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Aw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Aw)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Aw)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Aw)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Aw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Aw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Aw)("MainThreadLanguages"),MainThreadLogger:(0,y.$Aw)("MainThreadLogger"),MainThreadMessageService:(0,y.$Aw)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Aw)("MainThreadOutputService"),MainThreadProgress:(0,y.$Aw)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Aw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Aw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Aw)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Aw)("MainThreadSecretState"),MainThreadStorage:(0,y.$Aw)("MainThreadStorage"),MainThreadSpeech:(0,y.$Aw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Aw)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Aw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,y.$Aw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,y.$Aw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Aw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Aw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Aw)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Aw)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Aw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Aw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Aw)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Aw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Aw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Aw)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Aw)("MainThreadSCM"),MainThreadSearch:(0,y.$Aw)("MainThreadSearch"),MainThreadShare:(0,y.$Aw)("MainThreadShare"),MainThreadTask:(0,y.$Aw)("MainThreadTask"),MainThreadWindow:(0,y.$Aw)("MainThreadWindow"),MainThreadLabelService:(0,y.$Aw)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Aw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Aw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Aw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Aw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Aw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Aw)("MainThreadInteractive"),MainThreadInlineChat:(0,y.$Aw)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Aw)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Aw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Aw)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Aw)("MainThreadTimeline"),MainThreadTesting:(0,y.$Aw)("MainThreadTesting"),MainThreadLocalization:(0,y.$Aw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Aw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Aw)("MainThreadAiEmbeddingVector")},e.$$M={ExtHostCommands:(0,y.$Aw)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Aw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Aw)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Aw)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Aw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Aw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Aw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Aw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Aw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Aw)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Aw)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Aw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Aw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Aw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Aw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Aw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Aw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Aw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Aw)("ExtHostStatusBar"),ExtHostShare:(0,y.$Aw)("ExtHostShare"),ExtHostExtensionService:(0,y.$Aw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Aw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Aw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,y.$Aw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,y.$Aw)("ExtHostSCM"),ExtHostSearch:(0,y.$Aw)("ExtHostSearch"),ExtHostTask:(0,y.$Aw)("ExtHostTask"),ExtHostWorkspace:(0,y.$Aw)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Aw)("ExtHostWindow"),ExtHostWebviews:(0,y.$Aw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Aw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Aw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Aw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Aw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Aw)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Aw)("ExtHostProgress"),ExtHostComments:(0,y.$Aw)("ExtHostComments"),ExtHostSecretState:(0,y.$Aw)("ExtHostSecretState"),ExtHostStorage:(0,y.$Aw)("ExtHostStorage"),ExtHostUrls:(0,y.$Aw)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Aw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Aw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Aw)("ExtHostOutputService"),ExtHostLabelService:(0,y.$Aw)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Aw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Aw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Aw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Aw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Aw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Aw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Aw)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Aw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,y.$Aw)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Aw)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Aw)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Aw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Aw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Aw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Aw)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Aw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Aw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Aw)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Aw)("ExtHostTimeline"),ExtHostTesting:(0,y.$Aw)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Aw)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Aw)("ExtHostLocalization")}}),define(Ce[80],Ae([1,0,3,12,4,17]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=e.$hlc=void 0,e.$hlc=(0,y.$wi)("IExtHostApiDeprecationService");let N=class{constructor($,E){this.c=E,this.a=new Set,this.b=$.getProxy(C.$0M.MainThreadTelemetry)}report($,E,M){const S=this.d($,E);this.a.has(S)||(this.a.add(S),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:$}))}d($,E){return`${$}-${E.identifier.value}`}};e.$ilc=N,e.$ilc=N=Qe([qe(0,O.$xP),qe(1,A.$3j)],N),e.$jlc=Object.freeze(new class{report(p,$,E){}})}),define(Ce[243],Ae([1,0,4]),function(ee,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class A{constructor(O){const N=O.getProxy(y.$0M.MainThreadClipboard);this.value=Object.freeze({readText(){return N.$readText()},writeText(p){return N.$writeText(p)}})}}e.$wlc=A}),define(Ce[244],Ae([1,0,25,4,27,17]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;let N=class{constructor(M,S){this.a=M.getProxy(A.$0M.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,S){const m=this,w=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){m.e(M,S,w,arguments)}})}e(M,S,m,w){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:$(w,this.b)}),this.c&&this.f(M,m,w)}};e.$qnc=N,e.$qnc=N=Qe([qe(0,O.$xP),qe(1,C.$NP)],N);const p=1e5;function $(E,M){const S=[];if(E.length)for(let m=0;m<E.length;m++){let w=E[m];if(typeof w>"u")w="undefined";else if(w instanceof Error){const g=w;g.stack?w=g.stack:w=g.toString()}S.push(w)}if(M){const m=new Error().stack;m&&S.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,y.$9n)(S);return m.length>p?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[245],Ae([1,0,2,4,26]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;class O{constructor(p){this.a=p.getProxy(A.$0M.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,C.$PG)(p,"showLocal"),this.a.$showOpenDialog($).then(E=>E?E.map(M=>y.URI.revive(M)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?y.URI.revive($):void 0)}}e.$tmc=O}),define(Ce[246],Ae([1,0,6,4]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class C{constructor(N){this.b=0,this.a=N.getProxy(A.$0M.MainThreadLabelService)}$registerResourceLabelFormatter(N){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,N),(0,y.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Nmc=C}),define(Ce[81],Ae([1,0,22,13,2,3,12,4,27,17]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=void 0;let M=class{constructor(m,w,g){this.f=g,this.d=new Map,this.a=w.getProxy(p.$0M.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===y.$a}getMessage(m,w){const{message:g,args:r,comment:a}=w;if(this.c)return(0,A.$0e)(g,r??{});let s=g;a&&a.length>0&&(s+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(m)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,A.$0e)(n??g,r??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let w;const g=await this.g(m);if(!g){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(g),a=JSON.parse(r);w=m.isBuiltin?a.contents?.bundle:a}catch(r){this.f.error(`Failed to load translations for ${m.identifier.value} from ${g}: ${r.message}`);return}w&&this.d.set(m.identifier.value,{contents:w,uri:g})}async g(m){if(m.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return C.URI.revive(w)}return m.l10n?C.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$bmc=M,e.$bmc=M=Qe([qe(0,$.$NP),qe(1,E.$xP),qe(2,N.$3j)],M),e.$cmc=(0,O.$wi)("IExtHostLocalizationService")}),define(Ce[247],Ae([1,0,12,4,27,17,2,49]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;let $=class extends y.$bk{constructor(S,m){super(m.logLevel,m.logsLocation,m.loggers.map(w=>(0,p.$6h)(w))),this.r=S.getProxy(A.$0M.MainThreadLogger)}$setLogLevel(S,m){m?this.setLogLevel(N.URI.revive(m),S):this.setLogLevel(S)}setVisibility(S,m){super.setVisibility(S,m),this.r.$setVisibility(S,m)}s(S,m,w){return new E(this.r,S,m,w)}};e.$pnc=$,e.$pnc=$=Qe([qe(0,O.$xP),qe(1,C.$NP)],$);class E extends y.$9j{constructor(S,m,w,g){super(g?.logLevel==="always"),this.r=S,this.s=m,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(m,g).then(()=>{this.u(this.n),this.m=!0})}g(S,m){const w=[[S,m]];this.m?this.u(w):this.n.push(...w)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ce[82],Ae([1,0,4,3,6,17,21]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=void 0,e.$dmc=(0,A.$wi)("IExtHostManagedSockets");let p=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(y.$0M.MainThreadManagedSockets)}setFactory(S,m){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(S,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const m=++this.b,w=await this.c.makeConnection(),g=new C.$Uc;return this.d.set(m,new E(m,w,g)),g.add((0,C.$Tc)(()=>this.d.delete(m))),g.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),g.dispose()})),g.add(w.onDidClose(r=>{this.a.$onDidManagedSocketClose(m,r?.stack??r?.message),g.dispose()})),g.add(w.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(m,N.$Ge.wrap(r)))),m}$remoteSocketWrite(S,m){this.d.get(S)?.actual.send(m.buffer)}$remoteSocketEnd(S){const m=this.d.get(S);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$emc=p,e.$emc=p=Qe([qe(0,O.$xP)],p);class ${constructor(S,m){this.socketFactoryId=S,this.makeConnection=m}}class E extends C.$Vc{constructor(S,m,w){super(),this.socketId=S,this.actual=m,this.B(w)}}}),define(Ce[248],Ae([1,0,4,12,26]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;function O(p){return p&&p.title}let N=class{constructor($,E){this.b=E,this.a=$.getProxy(y.$0M.MainThreadMessageService)}showMessage($,E,M,S,m){const w={source:{identifier:$.identifier,label:$.displayName||$.name}};let g;typeof S=="string"||O(S)?g=[S,...m]:(w.modal=S?.modal,w.useCustom=S?.useCustom,w.detail=S?.detail,g=m),w.useCustom&&(0,C.$PG)($,"resolvers");const r=[];let a=!1;for(let s=0;s<g.length;s++){const n=g[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:c}=n;r.push({title:i,isCloseAffordance:!!c,handle:s}),c&&(a?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,M,w,r).then(s=>{if(typeof s=="number")return g[s]})}};e.$Pmc=N,e.$Pmc=N=Qe([qe(1,A.$3j)],N)}),define(Ce[249],Ae([1,0,6,15,2,26,4]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class p{constructor(E){this.b=new Map,this.a=E.getProxy(N.$0M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,M,S){if((0,O.$PG)(E,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,S),this.a.$registerProfileContentHandler(M,S.name,S.description,E.identifier.value),(0,y.$Tc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(E,M,S,m){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.saveProfile(M,S,m)}async $readProfile(E,M,S){const m=this.b.get(E);if(!m)throw new Error(`Unknown handler with id: ${E}`);return m.readProfile((0,A.$9f)(M)?M:C.URI.revive(M),S)}}e.$Ymc=p}),define(Ce[83],Ae([1,0,4,5,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0;class O{constructor(p){this.b=new A.$ee,this.onDidChangePassword=this.b.event,this.a=p.getProxy(y.$0M.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,E){return this.a.$setPassword(p,$,E)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$$lc=O,e.$_lc=(0,C.$wi)("IExtHostSecretState")}),define(Ce[250],Ae([1,0,24,6,4]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class O{constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(C.$0M.MainThreadSpeech)}async $createSpeechToTextSession(p,$,E){const M=this.c.get(p);if(!M)return;const S=new A.$Uc,m=new y.$pe;this.d.set($,m);const w=S.add(M.provideSpeechToTextSession(m.token,E?{language:E}:void 0));S.add(w.onDidChange(g=>{m.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,g)})),S.add(m.token.onCancellationRequested(()=>S.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,$){const E=this.c.get(p);if(!E)return;const M=new A.$Uc,S=new y.$pe;this.d.set($,S);const m=M.add(E.provideKeywordRecognitionSession(S.token));M.add(m.onDidChange(w=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,w)})),M.add(S.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,E){const M=O.a++;return this.c.set(M,E),this.b.$registerProvider(M,$,{extension:p,displayName:p.value}),(0,A.$Tc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$6mc=O,O.a=1}),define(Ce[84],Ae([1,0,4,5,3]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=void 0;class O{constructor(p,$){this.c=$,this.b=new A.$ee,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(y.$0M.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,E){const M=await this.a.$initializeExtensionStorage(p,$);let S;return M&&(S=this.d(p,$,M)),S||E}setValue(p,$,E){return this.a.$setValue(p,$,E)}$acceptValue(p,$,E){const M=this.d(p,$,E);M&&this.b.fire({shared:p,key:$,value:M})}d(p,$,E){try{return JSON.parse(E)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${M}`)}}}e.$1lc=O,e.$2lc=(0,C.$wi)("IExtHostStorage")}),define(Ce[251],Ae([1,0,6,16,2,4]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;class N{constructor($){this.c=new Map,this.b=$.getProxy(O.$0M.MainThreadUriOpeners)}registerExternalUriOpener($,E,M,S){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const m=S.schemes.find(w=>!N.a.has(w));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(E,M),this.b.$registerUriOpener(E,S.schemes,$,S.label),(0,y.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri($,E,M){const S=this.c.get($);if(!S)throw new Error(`Unknown opener with id: ${$}`);const m=C.URI.revive(E);return S.canOpenExternalUri(m,M)}async $openUri($,E,M){const S=this.c.get($);if(!S)throw new Error(`Unknown opener id: '${$}'`);return S.openExternalUri(C.URI.revive(E.resolvedUri),{sourceUri:C.URI.revive(E.sourceUri)},M)}}e.$jnc=N,N.a=new Set([A.Schemas.http,A.Schemas.https])}),define(Ce[252],Ae([1,0,4,2,6,14,20]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;class p{constructor(E){this.c=new N.$Tm,this.d=new Map,this.b=E.getProxy(y.$0M.MainThreadUrls)}registerUriHandler(E,M){const S=E.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const m=p.a++;return this.c.add(S),this.d.set(m,M),this.b.$registerUriHandler(m,S,E.displayName||E.name),(0,C.$Tc)(()=>{this.c.delete(S),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(E,M){const S=this.d.get(E);if(!S)return Promise.resolve(void 0);try{S.handleUri(A.URI.revive(M))}catch(m){(0,O.$1)(m)}return Promise.resolve(void 0)}async createAppUri(E){return A.URI.revive(await this.b.$createAppUri(E))}}e.$knc=p,p.a=0});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[64],Ae([1,0,5,6,16,25,2,197,221,78,4]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";var S,m,w,g,r,a,s,n,i,c,h,t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Llc=void 0,e.$Mlc=f,e.$Olc=l,e.$Plc=v;class o{constructor(I,U,Q,G,L,R,F){S.set(this,void 0),m.set(this,void 0),w.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,void 0),s.set(this,""),n.set(this,void 0),i.set(this,!1),c.set(this,!1),h.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new y.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new y.$ee),this._onDidDispose=Be(this,d,"f").event,_e(this,S,I,"f"),_e(this,m,U,"f"),_e(this,n,Q,"f"),_e(this,g,G,"f"),_e(this,r,L,"f"),_e(this,a,R,"f"),_e(this,h,f(R),"f"),_e(this,t,u(R),"f"),_e(this,w,F,"f")}dispose(){_e(this,i,!0,"f"),Be(this,d,"f").fire(),Be(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(I){return _e(this,c,!0,"f"),(0,E.$1Ab)(I,Be(this,g,"f"))}get cspSource(){const I=Be(this,a,"f").extensionLocation;if(I.scheme===C.Schemas.https||I.scheme===C.Schemas.http){let U=I.toString();return U.endsWith("/")||(U+="/"),U+" "+E.$ZAb}return E.$ZAb}get html(){return this.a(),Be(this,s,"f")}set html(I){this.a(),Be(this,s,"f")!==I&&(_e(this,s,I,"f"),Be(this,t,"f")&&!Be(this,c,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(I)&&(_e(this,c,!0,"f"),Be(this,w,"f").report("Webview vscode-resource: uris",Be(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,m,"f").$setHtml(Be(this,S,"f"),this.b(I)))}get options(){return this.a(),Be(this,n,"f")}set options(I){this.a(),O.$8n(Be(this,n,"f"),I)||Be(this,m,"f").$setOptions(Be(this,S,"f"),v(Be(this,a,"f"),Be(this,r,"f"),I)),_e(this,n,I,"f")}async postMessage(I){if(Be(this,i,"f"))return!1;const U=(0,$.$Irb)(I,{serializeBuffersForPostMessage:Be(this,h,"f")});return Be(this,m,"f").$postMessage(Be(this,S,"f"),U.message,...U.buffers)}a(){if(Be(this,i,"f"))throw new Error("Webview is disposed")}b(I){if(!Be(this,t,"f"))return I;const U=Be(this,a,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,Q=Be(this,a,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Be(this,a,"f").extensionLocation.authority:void 0;return I.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,L,R,F,T,X)=>{const ne=N.URI.from({scheme:F||"file",path:decodeURIComponent(T)}),me=(0,E.$1Ab)(ne,{isRemote:U,authority:Q}).toString();return`${L}${me}${X}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,L,R,F,T,X)=>{const ne=N.URI.from({scheme:F||"file",path:decodeURIComponent(T)}),me=(0,E.$1Ab)(ne,{isRemote:U,authority:Q}).toString();return`${L}${me}${X}`})}}e.$Llc=o,S=new WeakMap,m=new WeakMap,w=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,s=new WeakMap,n=new WeakMap,i=new WeakMap,c=new WeakMap,h=new WeakMap,t=new WeakMap,d=new WeakMap;function f(k){try{const I=(0,p.$Jp)((0,p.$Ip)(k.engines.vscode));return!!I&&I.majorBase>=1&&I.minorBase>=57}catch{return!1}}function u(k){try{const I=(0,p.$Jp)((0,p.$Ip)(k.engines.vscode));return I?I.majorBase<1||I.majorBase===1&&I.minorBase<60:!1}catch{return!1}}class D extends A.$Vc{constructor(I,U,Q,G,L){super(),this.c=U,this.f=Q,this.g=G,this.h=L,this.b=new Map,this.a=I.getProxy(M.$0M.MainThreadWebviews)}dispose(){super.dispose();for(const I of this.b.values())I.dispose();this.b.clear()}$onMessage(I,U,Q){const G=this.j(I);if(G){const{message:L}=(0,$.$Jrb)(U,Q.value);G._onMessageEmitter.fire(L)}}$onMissingCsp(I,U){this.g.warn(`${U} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(I,U,Q){const G=new o(I,this.a,b(U),this.c,this.f,Q,this.h);this.b.set(I,G);const L=G._onDidDispose(()=>{L.dispose(),this.deleteWebview(I)});return G}deleteWebview(I){this.b.delete(I)}j(I){return this.b.get(I)}}e.$Nlc=D;function l(k){return{id:k.identifier,location:k.extensionLocation}}function v(k,I,U){return{enableCommandUris:U.enableCommandUris,enableScripts:U.enableScripts,enableForms:U.enableForms,portMapping:U.portMapping,localResourceRoots:U.localResourceRoots||P(k,I)}}function b(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(I=>N.URI.from(I))}}function P(k,I){return[...(I?.getWorkspaceFolders()||[]).map(U=>U.uri),k.extensionLocation]}}),define(Ce[111],Ae([1,0,5,16,13,2,3,17,4]),function(ee,e,y,A,C,O,N,p,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$mnc=void 0;let M=E=class{getState(){const m=this.d;return{get focused(){return m.focused},get active(){return m.active}}}constructor(m){this.c=new y.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=m.getProxy($.$0M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:g})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(m){this.onDidChangeWindowProperty("focused",m)}$onDidChangeWindowActive(m){this.onDidChangeWindowProperty("active",m)}onDidChangeWindowProperty(m,w){w!==this.d[m]&&(this.d={...this.d,[m]:w},this.c.fire(this.d))}openUri(m,w){let g;if(typeof m=="string"){g=m;try{m=O.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,C.$8e)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this.b.$openUri(m,g,w)}async asExternalUri(m,w){if((0,C.$8e)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(m,w);return O.URI.from(g)}};e.$mnc=M,M.a={focused:!0,active:!0},e.$mnc=M=E=Qe([qe(0,p.$xP)],M),e.$nnc=(0,N.$wi)("IExtHostWindow")}),define(Ce[253],Ae([1,0,244,27,17]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=void 0;let O=class extends y.$qnc{constructor(p,$){super(p,$)}f(p,$,E){$.apply(console,E)}};e.$ypc=O,e.$ypc=O=Qe([qe(0,C.$xP),qe(1,A.$NP)],O)}),define(Ce[254],Ae([1,0,9,21,24,14,5,6,139,242,35]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$1_b=a,e.$2_b=s;function m(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const w="$$ref$$",g={[w]:-1};class r{constructor(I,U){this.jsonString=I,this.referencedBuffers=U}}function a(k,I=null,U=!1){const Q=[];return{jsonString:(U?m:JSON.stringify)(k,(L,R)=>{if(typeof R>"u")return g;if(typeof R=="object"){if(R instanceof A.$Ge){const F=Q.push(R)-1;return{[w]:F}}if(I)return I(L,R)}return R}),referencedBuffers:Q}}function s(k,I,U){return JSON.parse(k,(Q,G)=>{if(G){const L=G[w];if(typeof L=="number")return I[L];if(U&&G.$mid===1)return U.transformIncoming(G)}return G})}function n(k,I){return JSON.stringify(k,I)}function i(k){return k?(I,U)=>U&&U.$mid===1?k.transformOutgoing(U):U:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},d=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class f extends p.$Vc{constructor(I,U=null,Q=null){super(),this[S]=!0,this.b=this.B(new N.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=U,this.g=Q,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let G=0,L=M.$zw.count;G<L;G++)this.m[G]=null,this.s[G]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$Ih(()=>this.H(),1e3)),this.c.onMessage(G=>this.L(G))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const U=this.w[I];delete this.w[I],U.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,$.$Cn)(I,this.g):I}getProxy(I){const{nid:U,sid:Q}=I;return this.s[U]||(this.s[U]=this.J(U,Q)),this.s[U]}J(I,U){const Q={get:(G,L)=>(typeof L=="string"&&!G[L]&&L.charCodeAt(0)===36&&(G[L]=(...R)=>this.U(I,L,R)),L===o?U:G[L])};return new Proxy(Object.create(null),Q)}set(I,U){return this.m[I.nid]=U,U}assertRegistered(I){for(let U=0,Q=I.length;U<Q;U++){const G=I[U];if(!this.m[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}L(I){if(this.j)return;const U=I.byteLength,Q=D.read(I,0),G=Q.readUInt8(),L=Q.readUInt32();switch(G){case 1:case 2:{let{rpcId:R,method:F,args:T}=v.deserializeRequestJSONArgs(Q);this.g&&(T=(0,$.$Cn)(T,this.g)),this.M(U,L,R,F,T,G===2);break}case 3:case 4:{let{rpcId:R,method:F,args:T}=v.deserializeRequestMixedArgs(Q);this.g&&(T=(0,$.$Cn)(T,this.g)),this.M(U,L,R,F,T,G===4);break}case 5:{this.f?.logIncoming(U,L,0,"ack"),this.G(L);break}case 6:{this.N(U,L);break}case 7:{this.O(U,L,void 0);break}case 9:{let R=v.deserializeReplyOKJSON(Q);this.g&&(R=(0,$.$Cn)(R,this.g)),this.O(U,L,R);break}case 10:{const R=v.deserializeReplyOKJSONWithBuffers(Q,this.g);this.O(U,L,R);break}case 8:{const R=v.deserializeReplyOKVSBuffer(Q);this.O(U,L,R);break}case 11:{let R=v.deserializeReplyErrError(Q);this.g&&(R=(0,$.$Cn)(R,this.g)),this.P(U,L,R);break}case 12:{this.P(U,L,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,U,Q,G,L,R){this.f?.logIncoming(I,U,1,`receiveRequest ${(0,M.$Bw)(Q)}.${G}(`,L);const F=String(U);let T,X;if(R){const me=new C.$pe;L.push(me.token),T=this.Q(Q,G,L),X=()=>me.cancel()}else T=this.Q(Q,G,L),X=t;this.u[F]=X;const ne=v.serializeAcknowledged(U);this.f?.logOutgoing(ne.byteLength,U,1,"ack"),this.c.send(ne),T.then(me=>{delete this.u[F];const we=v.serializeReplyOK(U,me,this.h);this.f?.logOutgoing(we.byteLength,U,1,"reply:",me),this.c.send(we)},me=>{delete this.u[F];const we=v.serializeReplyErr(U,me);this.f?.logOutgoing(we.byteLength,U,1,"replyErr:",me),this.c.send(we)})}N(I,U){this.f?.logIncoming(I,U,1,"receiveCancel");const Q=String(U);this.u[Q]?.()}O(I,U,Q){this.f?.logIncoming(I,U,0,"receiveReply:",Q);const G=String(U);if(!this.w.hasOwnProperty(G))return;const L=this.w[G];delete this.w[G],L.resolveOk(Q)}P(I,U,Q){this.f?.logIncoming(I,U,0,"receiveReplyErr:",Q);const G=String(U);if(!this.w.hasOwnProperty(G))return;const L=this.w[G];delete this.w[G];let R;Q&&(Q.$isError?(R=new Error,R.name=Q.name,R.message=Q.message,R.stack=Q.stack):R=Q),L.resolveErr(R)}Q(I,U,Q){try{return Promise.resolve(this.S(I,U,Q))}catch(G){return Promise.reject(G)}}S(I,U,Q){const G=this.m[I];if(!G)throw new Error("Unknown actor "+(0,M.$Bw)(I));const L=G[U];if(typeof L!="function")throw new Error("Unknown method "+U+" on actor "+(0,M.$Bw)(I));return L.apply(G,Q)}U(I,U,Q){if(this.j)return new E.$Z_b;let G=null;if(Q.length>0&&C.CancellationToken.isCancellationToken(Q[Q.length-1])&&(G=Q.pop()),G&&G.isCancellationRequested)return Promise.reject(O.$6());const L=v.serializeRequestArguments(Q,this.h),R=++this.t,F=String(R),T=new E.$Y_b,X=new p.$Uc;G&&X.add(G.onCancellationRequested(()=>{const me=v.serializeCancel(R);this.f?.logOutgoing(me.byteLength,R,0,"cancel"),this.c.send(v.serializeCancel(R))})),this.w[F]=new u(T,X),this.F(R);const ne=v.serializeRequest(R,I,U,L,!!G);return this.f?.logOutgoing(ne.byteLength,R,0,`request: ${(0,M.$Bw)(I)}.${U}(`,Q),this.c.send(ne),T}}e.$3_b=f,S=d,f.a=3*1e3;class u{constructor(I,U){this.a=I,this.b=U}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class D{static alloc(I,U,Q){const G=new D(A.$Ge.alloc(Q+1+4),0);return G.writeUInt8(I),G.writeUInt32(U),G}static read(I,U){return new D(I,U)}get buffer(){return this.a}constructor(I,U){this.a=I,this.b=U}static sizeUInt8(){return 1}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const Q=this.a.slice(this.b,this.b+I).toString();return this.b+=I,Q}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const Q=this.a.slice(this.b,this.b+I).toString();return this.b+=I,Q}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+I);return this.b+=I,U}static sizeMixedArray(I){let U=0;U+=1;for(let Q=0,G=I.length;Q<G;Q++){const L=I[Q];switch(U+=1,L.type){case 1:U+=this.sizeLongString(L.value);break;case 2:U+=this.sizeVSBuffer(L.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(L.value);for(let R=0;R<L.buffers.length;++R)U+=this.sizeVSBuffer(L.buffers[R]);break;case 4:break}}return U}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let U=0,Q=I.length;U<Q;U++){const G=I[U];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let L=0;L<G.buffers.length;++L)this.writeBuffer(G.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const U=new Array(I);for(let Q=0;Q<I;Q++)switch(this.readUInt8()){case 1:U[Q]=this.readLongString();break;case 2:U[Q]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),R=this.readLongString(),F=[];for(let T=0;T<L;++T)F.push(this.readVSBuffer());U[Q]=new M.$Cw(s(R,F,null));break}case 4:U[Q]=void 0;break}return U}}D.sizeUInt32=4;var l;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(l||(l={}));class v{static a(I){for(let U=0,Q=I.length;U<Q;U++)if(I[U]instanceof A.$Ge||I[U]instanceof M.$Cw||typeof I[U]>"u")return!0;return!1}static serializeRequestArguments(I,U){if(this.a(I)){const Q=[];for(let G=0,L=I.length;G<L;G++){const R=I[G];if(R instanceof A.$Ge)Q[G]={type:2,value:R};else if(typeof R>"u")Q[G]={type:4};else if(R instanceof M.$Cw){const{jsonString:F,referencedBuffers:T}=a(R.value,U);Q[G]={type:3,value:A.$Ge.fromString(F),buffers:T}}else Q[G]={type:1,value:A.$Ge.fromString(n(R,U))}}return{type:1,args:Q}}return{type:0,args:n(I,U)}}static serializeRequest(I,U,Q,G,L){switch(G.type){case 0:return this.b(I,U,Q,G.args,L);case 1:return this.c(I,U,Q,G.args,L)}}static b(I,U,Q,G,L){const R=A.$Ge.fromString(Q),F=A.$Ge.fromString(G);let T=0;T+=D.sizeUInt8(),T+=D.sizeShortString(R),T+=D.sizeLongString(F);const X=D.alloc(L?2:1,I,T);return X.writeUInt8(U),X.writeShortString(R),X.writeLongString(F),X.buffer}static deserializeRequestJSONArgs(I){const U=I.readUInt8(),Q=I.readShortString(),G=I.readLongString();return{rpcId:U,method:Q,args:JSON.parse(G)}}static c(I,U,Q,G,L){const R=A.$Ge.fromString(Q);let F=0;F+=D.sizeUInt8(),F+=D.sizeShortString(R),F+=D.sizeMixedArray(G);const T=D.alloc(L?4:3,I,F);return T.writeUInt8(U),T.writeShortString(R),T.writeMixedArray(G),T.buffer}static deserializeRequestMixedArgs(I){const U=I.readUInt8(),Q=I.readShortString(),G=I.readMixedArray(),L=new Array(G.length);for(let R=0,F=G.length;R<F;R++){const T=G[R];typeof T=="string"?L[R]=JSON.parse(T):L[R]=T}return{rpcId:U,method:Q,args:L}}static serializeAcknowledged(I){return D.alloc(5,I,0).buffer}static serializeCancel(I){return D.alloc(6,I,0).buffer}static serializeReplyOK(I,U,Q){if(typeof U>"u")return this.d(I);if(U instanceof A.$Ge)return this.e(I,U);if(U instanceof M.$Cw){const{jsonString:G,referencedBuffers:L}=a(U.value,Q,!0);return this.g(I,G,L)}else return this.f(I,m(U,Q))}static d(I){return D.alloc(7,I,0).buffer}static e(I,U){let Q=0;Q+=D.sizeVSBuffer(U);const G=D.alloc(8,I,Q);return G.writeVSBuffer(U),G.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,U){const Q=A.$Ge.fromString(U);let G=0;G+=D.sizeLongString(Q);const L=D.alloc(9,I,G);return L.writeLongString(Q),L.buffer}static g(I,U,Q){const G=A.$Ge.fromString(U);let L=0;L+=D.sizeUInt32,L+=D.sizeLongString(G);for(const F of Q)L+=D.sizeVSBuffer(F);const R=D.alloc(10,I,L);R.writeUInt32(Q.length),R.writeLongString(G);for(const F of Q)R.writeBuffer(F);return R.buffer}static deserializeReplyOKJSON(I){const U=I.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(I,U){const Q=I.readUInt32(),G=I.readLongString(),L=[];for(let R=0;R<Q;++R)L.push(I.readVSBuffer());return new M.$Cw(s(G,L,U))}static serializeReplyErr(I,U){const Q=U?m(O.$3(U),null):void 0;if(typeof Q!="string")return this.h(I);const G=A.$Ge.fromString(Q);let L=0;L+=D.sizeLongString(G);const R=D.alloc(11,I,L);return R.writeLongString(G),R.buffer}static deserializeReplyErrError(I){const U=I.readLongString();return JSON.parse(U)}static h(I){return D.alloc(12,I,0).buffer}}var b;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var P;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(P||(P={}))}),define(Ce[255],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;const y=function(O){const N=p=>{globalThis.removeEventListener("message",N);const $=p.data;Object.defineProperties(globalThis,{postMessage:{value(E,M){$.postMessage(E,M)}},onmessage:{get(){return $.onmessage},set(E){$.onmessage=E}}}),$.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",N)}.toString();class A extends EventTarget{constructor(O,N,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${y})('${N}'))`,E=new Blob([$],{type:"application/javascript"}),M=URL.createObjectURL(E),S=new MessageChannel,m=M,w={type:"_newWorker",id:m,port:S.port2,url:M,options:p};O(w,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{O({type:"_terminateWorker",id:m}),URL.revokeObjectURL(M),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(g){S.port1.onmessage=g}},onmessageerror:{get(){return S.port1.onmessageerror},set(g){S.port1.onmessageerror=g}}}),S.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),S.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),S.port1.start()}}e.$Apc=A}),define(Ce[256],Ae([1,0,21,28,16,56,3]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=M,e.$NK=S,e.$LK=(0,N.$wi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),E=7;function M(w){if(w.scheme!==C.Schemas.vscodeNotebookCell)return;const g=w.fragment.indexOf("s");if(g<0)return;const r=parseInt(w.fragment.substring(0,g).replace($,""),E),a=(0,y.$Ze)(w.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:w.with({scheme:a,fragment:null})}}function S(w,g){const r=g.toString(E),s=`${r.length<p.length?p[r.length-1]:"z"}${r}s${(0,y.$1e)(y.$Ge.fromString(w.scheme),!0,!0)}`;return w.with({scheme:C.Schemas.vscodeNotebookCell,fragment:s})}class m{constructor(){this.a=new A.$Bc}getNotebook(g){if(g.scheme===C.Schemas.vscodeNotebookCell){const r=M(g);if(r){const a=this.a.get(r.notebook);if(a)return a}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$OK=m,(0,O.$ys)(e.$LK,m,1)}),define(Ce[85],Ae([1,0,21,37,42,70,16,19,22,31,256]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=d,e.$3K=f,e.$4K=u,e.$7K=v,e.$8K=P,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var S;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(S||(e.CellKind=S={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",O.$Rs.latex,O.$Rs.markdown,"image/png","image/jpeg",O.$Rs.text],e.$VK=[O.$Rs.latex,O.$Rs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Rs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var m;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var w;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var g;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var a;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(T){T.scheme=N.Schemas.vscodeNotebookCell;function X(ke,se){return(0,M.$NK)(ke,se)}T.generate=X;function ne(ke){return(0,M.$MK)(ke)}T.parse=ne;function me(ke,se){return ke.with({scheme:N.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${ke.scheme!==N.Schemas.file?ke.scheme:""}`})}T.generateCellOutputUri=me;function we(ke){if(ke.scheme!==N.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ke.fragment);if(!se)return;const Pe=se[1]&&se[1]!==""?se[1]:void 0,re=se[2];return{outputId:Pe,notebook:ke.with({scheme:re||N.Schemas.file,fragment:null})}}T.parseCellOutputUri=we;function de(ke,se,Pe){return T.generate(ke,se).with({scheme:Pe})}T.generateCellPropertyUri=de;function $e(ke,se){if(ke.scheme===se)return T.parse(ke.with({scheme:T.scheme}))}T.parseCellPropertyUri=$e})(c||(e.CellUri=c={}));const h=T=>$.$c?T.replace(/\//g,"\\"):T;class t{constructor(X=[],ne=e.$UK){this.e=ne,this.d=[...new Set(X)].map(me=>({pattern:me,matches:A.$qk(h(me))}))}sort(X){const ne=new Map(C.Iterable.map(X,we=>[we,h(we)]));let me=[];for(const{matches:we}of this.d)for(const[de,$e]of ne)if(we($e)){me.push(de),ne.delete(de);break}return ne.size&&(me=me.concat([...ne.keys()].sort((we,de)=>this.e.indexOf(we)-this.e.indexOf(de)))),me}prioritize(X,ne){const me=this.f(X);if(me===-1){this.d.unshift({pattern:X,matches:A.$qk(h(X))});return}const we=new Set(ne.map($e=>this.f($e,me)));we.delete(-1);const de=Array.from(we).sort();this.d.splice(me+1,0,...de.map($e=>this.d[$e]));for(let $e=de.length-1;$e>=0;$e--)this.d.splice(de[$e],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ne=this.d.length){const me=h(X);for(let we=0;we<ne;we++)if(this.d[we].matches(me))return we;return-1}}e.$YK=t;function d(T,X,ne,me=(we,de)=>we===de){const we=[];function de(se,Pe,re){if(Pe===0&&re.length===0)return;const H=we[we.length-1];H&&H.start+H.deleteCount===se?(H.deleteCount+=Pe,H.toInsert.push(...re)):we.push({start:se,deleteCount:Pe,toInsert:re})}let $e=0,ke=0;for(;;){if($e===T.length){de($e,0,X.slice(ke));break}if(ke===X.length){de($e,T.length-$e,[]);break}const se=T[$e],Pe=X[ke];if(me(se,Pe)){$e+=1,ke+=1;continue}ne(Pe)?(de($e,1,[]),$e+=1):(de($e,0,[Pe]),ke+=1)}return we}e.$1K=new E.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new E.$Nj("notebookEditorCursorAtLineBoundary","none");var o;(function(T){T.default="default",T.option="option"})(o||(e.NotebookEditorPriority=o={}));function f(T){const X=T;return!!((typeof X.include=="string"||A.$rk(X.include))&&(typeof X.exclude=="string"||A.$rk(X.exclude)))}function u(T,X,ne){if(Array.isArray(T.viewType)&&T.viewType.indexOf(X)>=0||T.viewType===X)return!0;if(T.filenamePattern){const me=f(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,we=f(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(A.$pk(me,(0,p.$oc)(ne.fsPath).toLowerCase()))return!(we&&A.$pk(we,(0,p.$oc)(ne.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class l{static create(X){return`${l.d}${X}`}static parse(X){if(X.startsWith(l.d))return X.substring(l.d.length)}}e.$6K=l,l.d="notebook/";function v(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}const b=new TextDecoder;function P(T){const X=[];let ne=!1;for(const $e of T)(X.length===0||ne)&&(X.push($e),ne=!0);let me=U(X);const we=y.$Ge.concat(X.map($e=>y.$Ge.wrap($e))),de=F(we);return me=me||de.byteLength!==we.byteLength,{data:de,didCompression:me}}e.$9K="\x1B[A";const k=e.$9K.split("").map(T=>T.charCodeAt(0)),I=10;function U(T){let X=!1;return T.forEach((ne,me)=>{if(me===0||ne.length<e.$9K.length)return;const we=T[me-1],de=ne.subarray(0,e.$9K.length);if(de[0]===k[0]&&de[1]===k[1]&&de[2]===k[2]){const $e=we.lastIndexOf(I);if($e===-1)return;X=!0,T[me-1]=we.subarray(0,$e),T[me]=ne.subarray(e.$9K.length)}}),X}function Q(T){let X=T;do T=X,X=T.replace(/[^\n]\x08/gm,"");while(X.length<T.length);return T}function G(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const X=T.match(/^(.*)\r+/m)[1];let ne=T.match(/\r+(.*)$/m)[1];ne=ne+X.slice(ne.length,X.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return T}const L=8,R=13;function F(T){return!T.buffer.includes(L)&&!T.buffer.includes(R)?T:y.$Ge.fromString(G(Q(b.decode(T.buffer))))}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[7],Ae([1,0,18,14,55,28,70,13,15,2,34,20,38,104,85]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g){"use strict";var r,a,s,n,i,c,h,t,d,o,f,u,D,l,v,b,P,k,I,U,Q,G,L,R,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$lP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$kP=e.$jP=e.$iP=e.$hP=e.ChatLocation=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$8O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$UO=e.$TO=e.$SO=e.$RO=e.$PO=e.$OO=e.$NO=e.$MO=e.TestRunProfileKind=e.TestResultState=e.$LO=e.$KO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$JO=e.NotebookVariablesRequestKind=e.$IO=e.$HO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$GO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.ColorThemeKind=e.$AO=e.$zO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$yO=e.$xO=e.DebugConsoleMode=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$rO=e.$qO=e.FileChangeType=e.$pO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$oO=e.$nO=e.$mO=e.$lO=e.InlineCompletionTriggerKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$$N=e.ConfigurationTarget=e.$0N=e.$9N=e.$8N=e.$7N=e.DocumentPasteTriggerKind=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ZN=e.ViewBadge=e.ProgressLocation=e.$YN=e.$XN=e.TaskScope=e.ShellQuoting=e.$WN=e.$VN=e.$UN=e.TaskPanelKind=e.TaskRevealKind=e.$TN=e.TerminalLocation=e.$SN=e.$RN=e.$QN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$PN=e.$ON=e.$NN=e.$MN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$GN=e.$FN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.LanguageStatusSeverity=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.CodeActionTriggerKind=e.$tN=e.$sN=e.SymbolTag=e.SymbolKind=e.$rN=e.$qN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.DiagnosticSeverity=e.DiagnosticTag=e.$kN=e.$jN=e.FileEditType=e.$iN=e.$hN=e.$gN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$LN=hi,e.$_N=Vt,e.$QO=Cn;function T(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const Se=ie.length===1?[]:ie[1];return Reflect.construct(B,Se,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[Se,...Je]=ie;return Reflect.construct(B,Je,Se.constructor)}}})}var X;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(X||(e.TerminalOutputAnchor=X={}));var ne;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(ne||(e.TerminalQuickFixType=ne={}));let me=d=class{static from(...z){let ie=z;return new d(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}constructor(z){r.set(this,void 0),_e(this,r,z,"f")}dispose(){typeof Be(this,r,"f")=="function"&&(Be(this,r,"f").call(this),_e(this,r,void 0,"f"))}};e.$_M=me,r=new WeakMap,e.$_M=me=d=Qe([T],me);let we=o=class{static Min(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isBefore(ie)&&(ie=Je)}return ie}static Max(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isAfter(ie)&&(ie=Je)}return ie}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:ie,character:Se}=z;return typeof ie=="number"&&typeof Se=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ie){if(z<0)throw(0,A.$7)("line must be non-negative");if(ie<0)throw(0,A.$7)("character must be non-negative");this.c=z,this.e=ie}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ie=0){if(z===null||ie===null)throw(0,A.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ie=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ie===0?this:new o(this.line+Se,this.character+ie)}with(z,ie=this.character){if(z===null||ie===null)throw(0,A.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ie=typeof z.character=="number"?z.character:this.character),Se===this.line&&ie===this.character?this:new o(Se,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$aN=we,e.$aN=we=o=Qe([T],we);let de=f=class{static isRange(z){return z instanceof f?!0:z?we.isPosition(z.start)&&we.isPosition(z.end):!1}static of(z){if(z instanceof f)return z;if(this.isRange(z))return new f(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ie,Se,Je){let et,dt;if(typeof z=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new we(z,ie),dt=new we(Se,Je)):we.isPosition(z)&&we.isPosition(ie)&&(et=we.of(z),dt=we.of(ie)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(z){return f.isRange(z)?this.contains(z.start)&&this.contains(z.end):we.isPosition(z)?!(we.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ie=we.Max(z.start,this.c),Se=we.Min(z.end,this.e);if(!ie.isAfter(Se))return new f(ie,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ie=we.Min(z.start,this.c),Se=we.Max(z.end,this.end);return new f(ie,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ie=this.end){if(z===null||ie===null)throw(0,A.$7)();let Se;return z?we.isPosition(z)?Se=z:(Se=z.start||this.start,ie=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ie.isEqual(this.end)?this:new f(Se,ie)}toJSON(){return[this.start,this.end]}};e.$bN=de,e.$bN=de=f=Qe([T],de);let $e=u=class extends de{static isSelection(z){return z instanceof u?!0:z?de.isRange(z)&&we.isPosition(z.anchor)&&we.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ie,Se,Je){let et,dt;if(typeof z=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new we(z,ie),dt=new we(Se,Je)):we.isPosition(z)&&we.isPosition(ie)&&(et=we.of(z),dt=we.of(ie)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cN=$e,e.$cN=$e=u=Qe([T],$e);const ke=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,A.$7)("connectionToken")};class se{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie,Se){if(typeof z!="string"||z.length===0)throw(0,A.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,A.$7)("port");typeof Se<"u"&&ke(Se),this.host=z,this.port=Math.round(ie),this.connectionToken=Se}}e.$dN=se;class Pe{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie){this.makeConnection=z,this.connectionToken=ie,typeof ie<"u"&&ke(ie)}}e.$eN=Pe;class re extends Error{static NotAvailable(z,ie){return new re(z,w.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(z){return new re(z,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ie=w.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ie,this._detail=Se,Object.setPrototypeOf(this,re.prototype)}}e.$fN=re;var H;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var he;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(he||(e.EnvironmentVariableMutatorType=he={}));let Fe=D=class{static isTextEdit(z){return z instanceof D?!0:z?de.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ie){return new D(z,ie)}static insert(z,ie){return D.replace(new de(z,z),ie)}static delete(z){return D.replace(z,"")}static setEndOfLine(z){const ie=new D(new de(new we(0,0),new we(0,0)),"");return ie.newEol=z,ie}get range(){return this.c}set range(z){if(z&&!de.isRange(z))throw(0,A.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,A.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,A.$7)("newEol");this.f=z}constructor(z,ie){this.c=z,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gN=Fe,e.$gN=Fe=D=Qe([T],Fe);let pe=l=class{static isNotebookCellEdit(z){return z instanceof l?!0:z?$i.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ie){return new l(z,ie)}static insertCells(z,ie){return new l(new $i(z,z),ie)}static deleteCells(z){return new l(z,[])}static updateCellMetadata(z,ie){const Se=new l(new $i(z,z),[]);return Se.newCellMetadata=ie,Se}static updateNotebookMetadata(z){const ie=new l(new $i(0,0),[]);return ie.newNotebookMetadata=z,ie}constructor(z,ie){this.range=z,this.newCells=ie}};e.$hN=pe,e.$hN=pe=l=Qe([T],pe);class be{static isSnippetTextEdit(z){return z instanceof be?!0:z?de.isRange(z.range)&&K.isSnippetString(z.snippet):!1}static replace(z,ie){return new be(z,ie)}static insert(z,ie){return be.replace(new de(z,z),ie)}constructor(z,ie){this.range=z,this.snippet=ie}}e.$iN=be;var ge;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ie,Se,Je){this.c.push({_type:1,from:z,to:ie,options:Se,metadata:Je})}createFile(z,ie,Se){this.c.push({_type:1,from:void 0,to:z,options:ie,metadata:Se})}deleteFile(z,ie,Se){this.c.push({_type:1,from:z,to:void 0,options:ie,metadata:Se})}e(z,ie,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(z,ie,Se,Je){const et=ie.start,dt=ie.end;(et!==dt||Se.length>0)&&this.c.push({_type:5,uri:z,index:et,count:dt-et,cells:Se,metadata:Je})}g(z,ie,Se,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:ie,metadata:Se}})}replace(z,ie,Se,Je){this.c.push({_type:2,uri:z,edit:new Fe(ie,Se),metadata:Je})}insert(z,ie,Se,Je){this.replace(z,new de(ie,ie),Se,Je)}delete(z,ie,Se){this.replace(z,ie,"",Se)}has(z){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===z.toString())}set(z,ie){if(ie)for(const Se of ie){if(!Se)continue;let Je,et;Array.isArray(Se)?(Je=Se[0],et=Se[1]):Je=Se,pe.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,et):this.f(z,Je.range,Je.newCells,et):be.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:2,uri:z,edit:Je,metadata:et})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,y.$Ib)(this.c)}}get(z){const ie=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&ie.push(Se.edit);return ie}entries(){const z=new O.$Bc;for(const ie of this.c)if(ie._type===2){let Se=z.get(ie.uri);Se||(Se=[ie.uri,[]],z.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jN=ae,e.$jN=ae=Qe([T],ae);let K=v=class{static isSnippetString(z){return z instanceof v?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=v.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ie=this.e++){if(typeof z=="function"){const Se=new v;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=v.c(z);return this.value+="${",this.value+=ie,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ie=this.e++){const Se=z.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ie){if(typeof ie=="function"){const Se=new v;Se.e=this.e,ie(Se),this.e=Se.e,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$kN=K,e.$kN=K=v=Qe([T],K);var Z;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var fe;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(fe||(e.DiagnosticSeverity=fe={}));let le=b=class{static isLocation(z){return z instanceof b?!0:z?de.isRange(z.range)&&E.URI.isUri(z.uri):!1}constructor(z,ie){if(this.uri=z,ie)if(de.isRange(ie))this.range=de.of(ie);else if(we.isPosition(ie))this.range=new de(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lN=le,e.$lN=le=b=Qe([T],le);let Me=class{static is(z){return z?typeof z.message=="string"&&z.location&&de.isRange(z.location.range)&&E.URI.isUri(z.location.uri):!1}constructor(z,ie){this.location=z,this.message=ie}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.location.range.isEqual(ie.location.range)&&z.location.uri.toString()===ie.location.uri.toString()}};e.$mN=Me,e.$mN=Me=Qe([T],Me);let ve=class{constructor(z,ie,Se=fe.Error){if(!de.isRange(z))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=z,this.message=ie,this.severity=Se}toJSON(){return{severity:fe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.severity===ie.severity&&z.code===ie.code&&z.severity===ie.severity&&z.source===ie.source&&z.range.isEqual(ie.range)&&(0,y.$ub)(z.tags,ie.tags)&&(0,y.$ub)(z.relatedInformation,ie.relatedInformation,Me.isEqual)}};e.$nN=ve,e.$nN=ve=Qe([T],ve);let Re=class{constructor(z,ie){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ie}};e.$oN=Re,e.$oN=Re=Qe([T],Re);let Oe=class extends Re{constructor(z,ie,Se,Je){super(z,ie),this.canIncreaseHover=Se,this.canDecreaseHover=Je}};e.$pN=Oe,e.$pN=Oe=Qe([T],Oe);var Ue;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(Ue||(e.HoverVerbosityAction=Ue={}));var j;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(j||(e.DocumentHighlightKind=j={}));let V=class{constructor(z,ie=j.Text){this.range=z,this.kind=ie}toJSON(){return{range:this.range,kind:j[this.kind]}}};e.$qN=V,e.$qN=V=Qe([T],V);let W=class{constructor(z,ie){this.uri=z,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$rN=W,e.$rN=W=Qe([T],W);var q;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(q||(e.SymbolKind=q={}));var _;(function(B){B[B.Deprecated=1]="Deprecated"})(_||(e.SymbolTag=_={}));let oe=P=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ie,Se,Je,et){this.name=z,this.kind=ie,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),Je instanceof le?this.location=Je:Se instanceof de&&(this.location=new le(Je,Se)),P.validate(this)}toJSON(){return{name:this.name,kind:q[this.kind],location:this.location,containerName:this.containerName}}};e.$sN=oe,e.$sN=oe=P=Qe([T],oe);let Ne=k=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(k.validate)}constructor(z,ie,Se,Je,et){this.name=z,this.detail=ie,this.kind=Se,this.range=Je,this.selectionRange=et,this.children=[],k.validate(this)}};e.$tN=Ne,e.$tN=Ne=k=Qe([T],Ne);var Ve;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ve||(e.CodeActionTriggerKind=Ve={}));let Ke=class{constructor(z,ie){this.title=z,this.kind=ie}};e.$uN=Ke,e.$uN=Ke=Qe([T],Ke);let Ye=I=class{constructor(z){this.value=z}append(z){return new I(this.value?this.value+I.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+I.c)}};e.$vN=Ye,Ye.c=".",e.$vN=Ye=I=Qe([T],Ye),Ye.Empty=new Ye(""),Ye.QuickFix=Ye.Empty.append("quickfix"),Ye.Refactor=Ye.Empty.append("refactor"),Ye.RefactorExtract=Ye.Refactor.append("extract"),Ye.RefactorInline=Ye.Refactor.append("inline"),Ye.RefactorMove=Ye.Refactor.append("move"),Ye.RefactorRewrite=Ye.Refactor.append("rewrite"),Ye.Source=Ye.Empty.append("source"),Ye.SourceOrganizeImports=Ye.Source.append("organizeImports"),Ye.SourceFixAll=Ye.Source.append("fixAll"),Ye.Notebook=Ye.Empty.append("notebook");let tt=class{constructor(z,ie){if(this.range=z,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$wN=tt,e.$wN=tt=Qe([T],tt);class it{constructor(z,ie,Se,Je,et,dt){this.kind=z,this.name=ie,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=dt}}e.$xN=it;class nt{constructor(z,ie){this.fromRanges=ie,this.from=z}}e.$yN=nt;class st{constructor(z,ie){this.fromRanges=ie,this.to=z}}e.$zN=st;var ut;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ut||(e.LanguageStatusSeverity=ut={}));let $t=class{constructor(z,ie){this.range=z,this.command=ie}get isResolved(){return!!this.command}};e.$AN=$t,e.$AN=$t=Qe([T],$t);let je=U=class{static isMarkdownString(z){return z instanceof U?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ie=!1){a.set(this,void 0),_e(this,a,new C.$Tk(z,{supportThemeIcons:ie}),"f")}get value(){return Be(this,a,"f").value}set value(z){Be(this,a,"f").value=z}get isTrusted(){return Be(this,a,"f").isTrusted}set isTrusted(z){Be(this,a,"f").isTrusted=z}get supportThemeIcons(){return Be(this,a,"f").supportThemeIcons}set supportThemeIcons(z){Be(this,a,"f").supportThemeIcons=z}get supportHtml(){return Be(this,a,"f").supportHtml}set supportHtml(z){Be(this,a,"f").supportHtml=z}get baseUri(){return Be(this,a,"f").baseUri}set baseUri(z){Be(this,a,"f").baseUri=z}appendText(z){return Be(this,a,"f").appendText(z),this}appendMarkdown(z){return Be(this,a,"f").appendMarkdown(z),this}appendCodeblock(z,ie){return Be(this,a,"f").appendCodeblock(ie??"",z),this}};e.$BN=je,a=new WeakMap,e.$BN=je=U=Qe([T],je);let ct=class{constructor(z,ie){this.label=z,this.documentation=ie}};e.$CN=ct,e.$CN=ct=Qe([T],ct);let x=class{constructor(z,ie){this.label=z,this.documentation=ie,this.parameters=[]}};e.$DN=x,e.$DN=x=Qe([T],x);let Y=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$EN=Y,e.$EN=Y=Qe([T],Y);var ye;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(ye||(e.SignatureHelpTriggerKind=ye={}));var Ge;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Ge||(e.InlayHintKind=Ge={}));let De=class{constructor(z){this.value=z}};e.$FN=De,e.$FN=De=Qe([T],De);let at=class{constructor(z,ie,Se){this.position=z,this.label=ie,this.kind=Se}};e.$GN=at,e.$GN=at=Qe([T],at);var gt;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(gt||(e.CompletionTriggerKind=gt={}));var Rt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Rt||(e.CompletionItemKind=Rt={}));var Wt;(function(B){B[B.Deprecated=1]="Deprecated"})(Wt||(e.CompletionItemTag=Wt={}));let Qt=class{constructor(z,ie){this.label=z,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$HN=Qt,e.$HN=Qt=Qe([T],Qt);let _t=class{constructor(z=[],ie=!1){this.items=z,this.isIncomplete=ie}};e.$IN=_t,e.$IN=_t=Qe([T],_t);let Xt=class{constructor(z,ie,Se){this.insertText=z,this.range=ie,this.command=Se}};e.$JN=Xt,e.$JN=Xt=Qe([T],Xt);let St=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$KN=St,e.$KN=St=Qe([T],St);var ei;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(ei||(e.PartialAcceptTriggerKind=ei={}));var ti;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ti||(e.ViewColumn=ti={}));var xe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(xe||(e.StatusBarAlignment=xe={}));function hi(B,z){return`${S.$Sm.toKey(B)}.${z}`}var ni;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(ni||(e.TextEditorLineNumbersStyle=ni={}));var ft;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var wt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Gt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var Zt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Lt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Lt||(e.DecorationRangeBehavior=Lt={})),function(B){function z(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var mt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(mt||(e.SyntaxTokenType=mt={})),function(B){function z(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(mt||(e.SyntaxTokenType=mt={}));let zt=class{constructor(z,ie){if(ie&&!E.URI.isUri(ie))throw(0,A.$7)("target");if(!de.isRange(z)||z.isEmpty)throw(0,A.$7)("range");this.range=z,this.target=ie}};e.$MN=zt,e.$MN=zt=Qe([T],zt);let qt=class{constructor(z,ie,Se,Je){this.red=z,this.green=ie,this.blue=Se,this.alpha=Je}};e.$NN=qt,e.$NN=qt=Qe([T],qt);let Ft=class{constructor(z,ie){if(ie&&!(ie instanceof qt))throw(0,A.$7)("color");if(!de.isRange(z)||z.isEmpty)throw(0,A.$7)("range");this.range=z,this.color=ie}};e.$ON=Ft,e.$ON=Ft=Qe([T],Ft);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,A.$7)("label");this.label=z}};e.$PN=Xe,e.$PN=Xe=Qe([T],Xe);var ci;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ci||(e.ColorFormat=ci={}));var Yt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Yt||(e.SourceControlInputBoxValidationType=Yt={}));var Kt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Kt||(e.TerminalExitReason=Kt={}));var vt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(vt||(e.TerminalShellExecutionCommandLineConfidence=vt={}));class jt{constructor(z,ie,Se){if(this.startIndex=z,this.length=ie,this.tooltip=Se,typeof z!="number"||z<0)throw(0,A.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,A.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,A.$7)("tooltip")}}e.$QN=jt;class Bt{constructor(z){this.uri=z}}e.$RN=Bt;class Ht{constructor(z){this.terminalCommand=z}}e.$SN=Ht;var ri;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ri||(e.TerminalLocation=ri={}));class si{constructor(z){if(this.options=z,typeof z!="object")throw(0,A.$7)("options")}}e.$TN=si;var oi;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(oi||(e.TaskRevealKind=oi={}));var Mt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Mt||(e.TaskPanelKind=Mt={}));let Pt=Q=class{static from(z){switch(z){case"clean":return Q.Clean;case"build":return Q.Build;case"rebuild":return Q.Rebuild;case"test":return Q.Test;default:return}}constructor(z,ie){if(this.label=ie,typeof z!="string"||typeof ie!="string")throw(0,A.$7)("name");this.c=z}get id(){return this.c}};e.$UN=Pt,Pt.Clean=new Q("clean","Clean"),Pt.Build=new Q("build","Build"),Pt.Rebuild=new Q("rebuild","Rebuild"),Pt.Test=new Q("test","Test"),e.$UN=Pt=Q=Qe([T],Pt);function Ot(B){let z="";for(let ie=0;ie<B.length;ie++)z+=B[ie].replace(/,/g,",,")+",";return z}let It=class{constructor(z,ie,Se){if(typeof z!="string")throw(0,A.$7)("process");this.e=[],this.c=z,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Se):this.f=ie)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,A.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)z.push(ie);return Ot(z)}};e.$VN=It,e.$VN=It=Qe([T],It);let pt=class{constructor(z,ie,Se){if(this.f=[],Array.isArray(ie)){if(!z)throw(0,A.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,A.$7)("command");this.e=z,this.f=ie,this.g=Se}else{if(typeof z!="string")throw(0,A.$7)("commandLine");this.c=z,this.g=ie}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,A.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,A.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)z.push(typeof ie=="string"?ie:ie.value);return Ot(z)}};e.$WN=pt,e.$WN=pt=Qe([T],pt);var Ct;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Ct||(e.ShellQuoting=Ct={}));var ai;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ai||(e.TaskScope=ai={}));class kt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,M.$Sg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$XN=kt;let xt=G=class{constructor(z,ie,Se,Je,et,dt){this.k=!1,this.l=this.definition=z;let bt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=Se,this.execution=Je,bt=et,this.k=!0):ie===ai.Global||ie===ai.Workspace?(this.target=ie,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,bt=dt):(this.target=ie,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,bt=dt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof It?this.l={type:G.e,id:this.q.computeId()}:this.q instanceof pt?this.l={type:G.f,id:this.q.computeId()}:this.q instanceof kt?this.l={type:G.c,id:this.q.computeId()}:this.l={type:G.g,id:(0,M.$Sg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,A.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,A.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ie=this.l.type;(G.g===ie||G.e===ie||G.f===ie||G.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,A.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$YN=xt,xt.c="customExecution",xt.e="process",xt.f="shell",xt.g="$empty",e.$YN=xt=G=Qe([T],xt);var ii;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ii||(e.ProgressLocation=ii={}));var yi;(function(B){function z(ie){const Se=ie;return(0,$.$ag)(Se.value)?Se.tooltip&&!(0,$.$9f)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(yi||(e.ViewBadge=yi={}));let di=L=class{static isTreeItem(z,ie){const Se=z;if(Se.checkboxState!==void 0){const Je=(0,$.$ag)(Se.checkboxState)?Se.checkboxState:(0,$.$$f)(Se.checkboxState)&&(0,$.$ag)(Se.checkboxState.state)?Se.checkboxState.state:void 0,et=!(0,$.$ag)(Se.checkboxState)&&(0,$.$$f)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Nt.Checked&&Je!==Nt.Unchecked||et!==void 0&&!(0,$.$9f)(et))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof L)return!0;if(Se.label!==void 0&&!(0,$.$9f)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,$.$9f)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,$.$9f)(Se.iconPath)&&!E.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,$.$9f)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,$.$9f)(Je.light)&&!E.URI.isUri(Je.light)&&!(0,$.$9f)(Je.dark)&&!E.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,$.$9f)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!E.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,$.$9f)(Se.tooltip)&&!(Se.tooltip instanceof je)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<fi.None&&Se.collapsibleState>fi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,$.$9f)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ie=fi.None){this.collapsibleState=ie,E.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$ZN=di,e.$ZN=di=L=Qe([T],di);var fi;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(fi||(e.TreeItemCollapsibleState=fi={}));var Nt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Nt||(e.TreeItemCheckboxState=Nt={}));let mi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$1N=mi,e.$1N=mi=Qe([T],mi);class Ei extends mi{}e.$2N=Ei;class Ee extends Ei{constructor(z){super(""),s.set(this,void 0),_e(this,s,z,"f")}asFile(){return Be(this,s,"f")}}e.$3N=Ee,s=new WeakMap;class Te{constructor(z,ie,Se,Je){this.name=z,this.uri=ie,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$4N=Te;let ce=class{constructor(z){n.add(this),i.set(this,new Map);for(const[ie,Se]of z??[]){const Je=Be(this,i,"f").get(Be(this,n,"m",c).call(this,ie));Je?Je.push(Se):Be(this,i,"f").set(Be(this,n,"m",c).call(this,ie),[Se])}}get(z){return Be(this,i,"f").get(Be(this,n,"m",c).call(this,z))?.[0]}set(z,ie){Be(this,i,"f").set(Be(this,n,"m",c).call(this,z),[ie])}forEach(z,ie){for(const[Se,Je]of Be(this,i,"f"))for(const et of Je)z.call(ie,et,Se,this)}*[(i=new WeakMap,n=new WeakSet,Symbol.iterator)](){for(const[z,ie]of Be(this,i,"f"))for(const Se of ie)yield[z,Se]}};e.$5N=ce,c=function(z){return z.toLowerCase()},e.$5N=ce=Qe([T],ce);let J=class{constructor(z,ie,Se){this.insertText=z,this.title=ie,this.kind=Se}};e.$6N=J,e.$6N=J=Qe([T],J);var Ie;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Ie||(e.DocumentPasteTriggerKind=Ie={}));class We{constructor(z){this.value=z}append(...z){return new We((this.value?[this.value,...z]:z).join(We.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+We.c)}}e.$7N=We,We.c=".",We.Empty=new We("");class Ze{constructor(z,ie,Se){this.title=ie,this.insertText=z,this.kind=Se}}e.$8N=Ze;let He=class{constructor(z,ie){this.id=z,this.color=ie}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$9N=He,e.$9N=He=Qe([T],He),He.File=new He("file"),He.Folder=new He("folder");let ht=class{constructor(z){this.id=z}};e.$0N=ht,e.$0N=ht=Qe([T],ht);var Dt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Dt||(e.ConfigurationTarget=Dt={}));let Ut=class{get base(){return this.c}set base(z){this.c=z,this.e=E.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ie){if(typeof z!="string"&&(!z||!E.URI.isUri(z)&&!E.URI.isUri(z.uri)))throw(0,A.$7)("base");if(typeof ie!="string")throw(0,A.$7)("pattern");typeof z=="string"?this.baseUri=E.URI.file(z):E.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$N=Ut,e.$$N=Ut=Qe([T],Ut);const lt=new WeakMap;function Vt(B,z){lt.set(B,z)}let At=class{constructor(z,ie,Se,Je,et){this.enabled=typeof z=="boolean"?z:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=lt.get(this)??(0,M.$Sg)()),this.c}};e.$aO=At,e.$aO=At=Qe([T],At);let wi=class extends At{constructor(z,ie,Se,Je,et,dt){if(super(ie,Se,Je,et,dt),z===null)throw(0,A.$7)("location");this.location=z}};e.$bO=wi,e.$bO=wi=Qe([T],wi);let Pi=class extends At{constructor(z,ie,Se,Je,et,dt){super(ie,Se,Je,et,dt),this.functionName=z}};e.$cO=Pi,e.$cO=Pi=Qe([T],Pi);let Li=class extends At{constructor(z,ie,Se,Je,et,dt,bt,Jt){if(super(Je,et,dt,bt,Jt),!ie)throw(0,A.$7)("dataId");this.label=z,this.dataId=ie,this.canPersist=Se}};e.$dO=Li,e.$dO=Li=Qe([T],Li);let zi=class{constructor(z,ie,Se){this.command=z,this.args=ie||[],this.options=Se}};e.$eO=zi,e.$eO=zi=Qe([T],zi);let Ui=class{constructor(z,ie){this.port=z,this.host=ie}};e.$fO=Ui,e.$fO=Ui=Qe([T],Ui);let Ii=class{constructor(z){this.path=z}};e.$gO=Ii,e.$gO=Ii=Qe([T],Ii);let ji=class{constructor(z){this.implementation=z}};e.$hO=ji,e.$hO=ji=Qe([T],ji);class Zi{constructor(z,ie,Se){this.session=z,this.threadId=ie,this.frameId=Se}}e.$iO=Zi;class $n{constructor(z,ie){this.session=z,this.threadId=ie}}e.$jO=$n;let Di=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$kO=Di,e.$kO=Di=Qe([T],Di);var Ci;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ci||(e.InlineCompletionTriggerKind=Ci={}));let Bi=class{constructor(z,ie){this.range=z,this.text=ie}};e.$lO=Bi,e.$lO=Bi=Qe([T],Bi);let Vi=class{constructor(z,ie,Se=!0){this.range=z,this.variableName=ie,this.caseSensitiveLookup=Se}};e.$mO=Vi,e.$mO=Vi=Qe([T],Vi);let vi=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$nO=vi,e.$nO=vi=Qe([T],vi);let Wi=class{constructor(z,ie){this.frameId=z,this.stoppedLocation=ie}};e.$oO=Wi,e.$oO=Wi=Qe([T],Wi);var Yi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));var xi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(xi||(e.NewSymbolNameTriggerKind=xi={}));class qi{constructor(z,ie){this.newSymbolName=z,this.tags=ie}}e.$pO=qi;var _i;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(_i||(e.FileChangeType=_i={}));let Ai=R=class extends Error{static FileExists(z){return new R(z,m.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(z){return new R(z,m.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(z){return new R(z,m.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(z){return new R(z,m.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(z){return new R(z,m.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(z){return new R(z,m.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(z,ie=m.FileSystemProviderErrorCode.Unknown,Se){super(E.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,m.$fl)(this,ie),Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$qO=Ai,e.$qO=Ai=R=Qe([T],Ai);let Hi=class{constructor(z,ie,Se){this.start=z,this.end=ie,this.kind=Se}};e.$rO=Hi,e.$rO=Hi=Qe([T],Hi);var Gi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Gi||(e.FoldingRangeKind=Gi={}));var en;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(en||(e.CommentThreadCollapsibleState=en={}));var tn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(tn||(e.CommentMode=tn={}));var nn;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(nn||(e.CommentState=nn={}));var rn;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(rn||(e.CommentThreadState=rn={}));var Ri;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Ri||(e.CommentThreadApplicability=Ri={}));class sn{constructor(z,ie=[]){this.tokenTypes=z,this.tokenModifiers=ie}}e.$sO=sn;function ze(B){return typeof B>"u"||(0,$.$0f)(B)}class ui{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ie=0,Se=z.tokenTypes.length;ie<Se;ie++)this.k.set(z.tokenTypes[ie],ie);for(let ie=0,Se=z.tokenModifiers.length;ie<Se;ie++)this.l.set(z.tokenModifiers[ie],ie)}}push(z,ie,Se,Je,et){if(typeof z=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(z,ie,Se,Je,et);if(de.isRange(z)&&typeof ie=="string"&&ze(Se))return this.o(z,ie,Se);throw(0,A.$7)()}o(z,ie,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,et=z.start.character,dt=z.end.character-z.start.character,bt=this.k.get(ie);let Jt=0;if(Se)for(const li of Se){if(!this.l.has(li))throw new Error("`tokenModifier` is not in the provided legend");const gi=this.l.get(li);Jt|=1<<gi>>>0}this.q(Je,et,dt,bt,Jt)}q(z,ie,Se,Je,et){if(this.f&&(z<this.c||z===this.c&&ie<this.e)){this.f=!1;const Jt=this.g.length/5|0;let li=0,gi=0;for(let pi=0;pi<Jt;pi++){let bi=this.g[5*pi],Qi=this.g[5*pi+1];bi===0?(bi=li,Qi+=gi):bi+=li,this.g[5*pi]=bi,this.g[5*pi+1]=Qi,li=bi,gi=Qi}}let dt=z,bt=ie;this.f&&this.j>0&&(dt-=this.c,dt===0&&(bt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=bt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=et,this.c=z,this.e=ie}static r(z){const ie=[],Se=z.length/5|0;for(let bt=0;bt<Se;bt++)ie[bt]=bt;ie.sort((bt,Jt)=>{const li=z[5*bt],gi=z[5*Jt];if(li===gi){const pi=z[5*bt+1],bi=z[5*Jt+1];return pi-bi}return li-gi});const Je=new Uint32Array(z.length);let et=0,dt=0;for(let bt=0;bt<Se;bt++){const Jt=5*ie[bt],li=z[Jt+0],gi=z[Jt+1],pi=z[Jt+2],bi=z[Jt+3],Qi=z[Jt+4],Wn=li-et,Er=Wn===0?gi-dt:gi,Xi=5*bt;Je[Xi+0]=Wn,Je[Xi+1]=Er,Je[Xi+2]=pi,Je[Xi+3]=bi,Je[Xi+4]=Qi,et=li,dt=gi}return Je}build(z){return this.f?new Ni(new Uint32Array(this.g),z):new Ni(ui.r(this.g),z)}}e.$tO=ui;class Ni{constructor(z,ie){this.resultId=ie,this.data=z}}e.$uO=Ni;class rt{constructor(z,ie,Se){this.start=z,this.deleteCount=ie,this.data=Se}}e.$vO=rt;class yt{constructor(z,ie){this.resultId=ie,this.edits=z}}e.$wO=yt;var on;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(on||(e.DebugConsoleMode=on={}));class pn{constructor(z){this.name=z}}e.$xO=pn;let ki=class{constructor(){}};e.$yO=ki,ki.Back={iconPath:new He("arrow-left")},e.$yO=ki=Qe([T],ki);var an;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(an||(e.QuickPickItemKind=an={}));var Si;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Si||(e.InputBoxValidationSeverity=Si={}));var cn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(cn||(e.ExtensionKind=cn={}));class wn{static validate(z){if(typeof z.badge=="string"){let ie=(0,p.$If)(z.badge,0);if(ie<z.badge.length&&(ie+=(0,p.$If)(z.badge,ie)),z.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!He.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ie,Se){this.badge=z,this.tooltip=ie,this.color=Se}}e.$zO=wn;let Ki=class{constructor(z){this.kind=z}};e.$AO=Ki,e.$AO=Ki=Qe([T],Ki);var Ji;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class $i{static isNotebookRange(z){return z instanceof $i?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ie){if(z<0)throw(0,A.$7)("start must be positive");if(ie<0)throw(0,A.$7)("end must be positive");z<=ie?(this.c=z,this.e=ie):(this.c=ie,this.e=z)}with(z){let ie=this.c,Se=this.e;return z.start!==void 0&&(ie=z.start),z.end!==void 0&&(Se=z.end),ie===this.c&&Se===this.e?this:new $i(ie,Se)}}e.$BO=$i;class Mi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ie=>Mi.isNotebookCellData(ie))}static isNotebookCellData(z){return!0}constructor(z,ie,Se,Je,et,dt,bt){this.kind=z,this.value=ie,this.languageId=Se,this.mime=Je,this.outputs=et??[],this.metadata=dt,this.executionSummary=bt,Mi.validate(this)}}e.$CO=Mi;class vn{constructor(z){this.cells=z}}e.$DO=vn;class un{static isNotebookCellOutputItem(z){return z instanceof h?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ie={name:z.name,message:z.message,stack:z.stack};return h.json(ie,"application/vnd.code.notebook.error")}static stdout(z){return h.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return h.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ie="application/octet-stream"){return new h(z,ie)}static text(z,ie=N.$Rs.text){const Se=Be(h,h,"f",t).encode(String(z));return new h(Se,ie)}static json(z,ie="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return h.text(Se,ie)}constructor(z,ie){this.data=z,this.mime=ie;const Se=(0,N.$Vs)(ie,!0);if(!Se)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$EO=un,h=un,t={value:new TextEncoder};class Oi{static isNotebookCellOutput(z){return z instanceof Oi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ie=!1){const Se=new Set,Je=new Set;for(let et=0;et<z.length;et++){const dt=z[et],bt=(0,N.$Vs)(dt.mime);if(!Se.has(bt)||(0,g.$7K)(bt)){Se.add(bt);continue}Je.add(et),ie&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?z:z.filter((et,dt)=>!Je.has(dt))}constructor(z,ie,Se){this.items=Oi.ensureUniqueMimeTypes(z,!0),typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=(0,M.$Sg)(),this.metadata=ie??Se)}}e.$FO=Oi;var ln;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ln||(e.NotebookCellKind=ln={}));var hn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(hn||(e.NotebookCellExecutionState=hn={}));var dn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class bn{constructor(z,ie){this.text=z,this.alignment=ie}}e.$GO=bn;var gn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var te;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(te||(e.NotebookControllerAffinity2=te={}));class ue{constructor(z,ie=[]){this.uri=z,this.provides=(0,y.$3b)(ie)}}e.$HO=ue;class Le{constructor(z){this.label=z}}e.$IO=Le;var ot;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(ot||(e.NotebookVariablesRequestKind=ot={}));let Et=class{constructor(z,ie){this.label=z,this.timestamp=ie}};e.$JO=Et,e.$JO=Et=Qe([T],Et);var Tt;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Tt||(e.ExtensionMode=Tt={}));var Ti;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Ti||(e.ExtensionRuntime=Ti={}));var Sn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Sn||(e.StandardTokenType=Sn={}));class qn{constructor(z,ie){this.ranges=z,this.wordPattern=ie}}e.$KO=qn;class Hn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$LO=Hn;var Pn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Pn||(e.TestResultState=Pn={}));var In;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(In||(e.TestRunProfileKind=In={}));let yn=class{constructor(z=void 0,ie=void 0,Se=void 0,Je=!1,et=!0){this.include=z,this.exclude=ie,this.profile=Se,this.continuous=Je,this.preserveFocus=et}};e.$MO=yn,e.$MO=yn=Qe([T],yn);let En=F=class{static diff(z,ie,Se){const Je=new F(z);return Je.expectedOutput=ie,Je.actualOutput=Se,Je}constructor(z){this.message=z}};e.$NO=En,e.$NO=En=F=Qe([T],En);let Dn=class{constructor(z){this.id=z}};e.$OO=Dn,e.$OO=Dn=Qe([T],Dn);class mn{constructor(z,ie){this.covered=z,this.total=ie,Cn(this)}}e.$PO=mn;function Cn(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class kn{static fromDetails(z,ie){const Se=new mn(0,0),Je=new mn(0,0),et=new mn(0,0);for(const bt of ie)if("branches"in bt){Se.total+=1,Se.covered+=bt.executed?1:0;for(const Jt of bt.branches)Je.total+=1,Je.covered+=Jt.executed?1:0}else et.total+=1,et.covered+=bt.executed?1:0;const dt=new kn(z,Se,Je.total>0?Je:void 0,et.total>0?et:void 0);return dt.detailedCoverage=ie,dt}constructor(z,ie,Se,Je){this.uri=z,this.statementCoverage=ie,this.branchCoverage=Se,this.declarationCoverage=Je}}e.$RO=kn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,Se=[]){this.executed=z,this.location=ie,this.branches=Se}}e.$SO=Gn;class Kn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,Se){this.executed=z,this.location=ie,this.label=Se}}e.$TO=Kn;class Jn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,Se){this.name=z,this.executed=ie,this.location=Se}}e.$UO=Jn;var An;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Rn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var Nn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Nn||(e.PortAutoForwardAction=Nn={}));class Qn{constructor(z,ie,Se,Je,et,dt){this.kind=z,this.name=ie,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=dt}}e.$VO=Qn;class Xn{constructor(z){this.uri=z}}e.$WO=Xn;class Zn{constructor(z,ie){this.original=z,this.modified=ie}}e.$XO=Zn;class Yn{constructor(z,ie,Se,Je){this.base=z,this.input1=ie,this.input2=Se,this.result=Je}}e.$YO=Yn;class xn{constructor(z,ie){this.uri=z,this.viewType=ie}}e.$ZO=xn;class _n{constructor(z){this.viewType=z}}e.$1O=_n;class er{constructor(z,ie){this.uri=z,this.notebookType=ie}}e.$2O=er;class tr{constructor(z,ie,Se){this.original=z,this.modified=ie,this.notebookType=Se}}e.$3O=tr;class ir{constructor(){}}e.$4O=ir;class nr{constructor(z,ie){this.uri=z,this.inputBoxUri=ie}}e.$5O=nr;class rr{constructor(){}}e.$6O=rr;class sr{constructor(z){this.textDiffs=z}}e.$7O=sr;var Mn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(Mn||(e.InteractiveSessionVoteDirection=Mn={}));var On;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(On||(e.ChatCopyKind=On={}));var Tn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Tn||(e.ChatVariableLevel=Tn={}));class or{constructor(z,ie){this.label=z,this.values=ie}}e.$8O=or;var Fn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Ln;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class ar{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new je(z):z}}e.$9O=ar;class cr{constructor(z,ie){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new je(z):z,this.vulnerabilities=ie}}e.$0O=cr;class ur{constructor(z,ie){this.participant=z,this.command=ie}}e.$$O=ur;class lr{constructor(z,ie){this.value=z,this.baseUri=ie}}e.$_O=lr;class hr{constructor(z,ie){this.value=z,this.title=ie}}e.$aP=hr;class dr{constructor(z){this.value=z}}e.$bP=dr;class fr{constructor(z){this.value=z}}e.$cP=fr;class gr{constructor(z,ie){this.value=z,this.iconPath=ie}}e.$dP=gr;class mr{constructor(z,ie){this.uri=z,this.edits=Array.isArray(ie)?ie:[ie]}}e.$eP=mr;class $r{constructor(z,ie,Se,Je){this.prompt=z,this.command=ie,this.variables=Se,this.participant=Je}}e.$fP=$r;class pr{constructor(z,ie,Se,Je){this.response=z,this.result=ie,this.participant=Se,this.command=Je}}e.$gP=pr;var zn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));class wr{constructor(z){this.content=z}}e.$hP=wr;class vr{constructor(z,ie){this.content=z,this.name=ie}}e.$iP=vr;class br{constructor(z,ie){this.content=z,this.name=ie}}e.$jP=br;class Fi extends Error{static NotFound(z){return new Fi(z,Fi.NotFound.name)}static NoPermissions(z){return new Fi(z,Fi.NoPermissions.name)}constructor(z,ie,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=ie??""}}e.$kP=Fi;var Un;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Un||(e.RelatedInformationType=Un={}));var jn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(jn||(e.SpeechToTextStatus=jn={}));var Bn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Bn||(e.KeywordRecognitionStatus=Bn={}));class yr{constructor(z,ie){this.text=z,this.range=ie}}e.$lP=yr;var Vn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Ce[257],Ae([1,0,4,7]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class C{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(y.$0M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(N,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(N);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(p,$)??[]}getRelatedInformation(N,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(N,p,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiRelatedInformationProvider(E,p),new A.$_M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$glc=C}),define(Ce[86],Ae([1,0,5,4,7,20,108,3,17]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=void 0,e.$rlc=(0,p.$wi)("IExtHostAuthentication");let E=class{constructor(m){this.b=new Map,this.c=new y.$ee,this.onDidChangeSessions=this.c.event,this.d=new M,this.f=new M,this.a=m.getProxy(A.$0M.MainThreadAuthentication)}async getSession(m,w,g,r={}){const a=O.$Sm.toKey(m.identifier),s=[...g].sort().join(" ");return await this.d.getOrCreate(`${a} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const n=m.displayName||m.name;return this.a.$getSession(w,g,a,n,r)})}async getSessions(m,w,g){const r=O.$Sm.toKey(m.identifier),a=[...g].sort().join(" ");return await this.f.getOrCreate(`${r} ${a}`,async()=>{await this.a.$ensureProvider(w);const s=m.displayName||m.name;return this.a.$getSessions(w,g,r,s)})}async removeSession(m,w){const g=this.b.get(m);return g?g.provider.removeSession(w):this.a.$removeSession(m,w)}registerAuthenticationProvider(m,w,g,r){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:w,provider:g,options:r??{supportsMultipleAccounts:!1}});const a=g.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(m,s));return this.a.$registerAuthenticationProvider(m,w,r?.supportsMultipleAccounts??!1),new C.$_M(()=>{a.dispose(),this.b.delete(m),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,w,g){const r=this.b.get(m);if(r)return Promise.resolve(r.provider.createSession(w,g));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,w){const g=this.b.get(m);if(g)return Promise.resolve(g.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,w){const g=this.b.get(m);if(g)return Promise.resolve(g.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,w){return m.startsWith(N.$_L)||this.c.fire({provider:{id:m,label:w}}),Promise.resolve()}};e.$slc=E,e.$slc=E=Qe([qe(0,$.$xP)],E);class M{constructor(){this.a=new Map}getOrCreate(m,w){const g=this.a.get(m);if(g)return g;const r=w().finally(()=>this.a.delete(m));return this.a.set(m,r),r}}}),define(Ce[112],Ae([1,0,2,4,7,3,17,12,18,13,19,26]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;let w=m=class{constructor(r,a){this.h=a,this.f=new Map,this.g=r.getProxy(A.$0M.MainThreadDecorations)}registerFileDecorationProvider(r,a){const s=m.c++;this.f.set(s,{provider:r,extensionDescription:a}),this.g.$registerDecorationProvider(s,a.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const c=(0,$.$3b)(i);if(c.length<=m.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const h=c.map(o=>({uri:o,rank:(0,E.$bf)(o.path,"/")})),t=(0,$.$zb)(h,(o,f)=>o.rank-f.rank||(0,E.$rf)(o.uri.path,f.uri.path)),d=[];e:for(const o of t){let f;for(const u of o){const D=(0,M.$nc)(u.uri.path);if(f!==D&&(f=D,d.push(u.uri)>=m.d))break e}}this.g.$onDidChange(s,d)});return new C.$_M(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,a,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(r);return await Promise.all(a.map(async h=>{try{const{uri:t,id:d}=h,o=await Promise.resolve(i.provideFileDecoration(y.URI.revive(t),s));if(!o)return;try{C.$zO.validate(o),o.badge&&typeof o.badge!="string"&&(0,S.$PG)(c,"codiconDecoration"),n[d]=[o.propagate,o.tooltip,o.badge,o.color]}catch(f){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${f}`)}}catch(t){this.h.error(t)}})),n}};e.$rmc=w,w.c=0,w.d=250,e.$rmc=w=m=Qe([qe(0,N.$xP),qe(1,p.$3j)],w),e.$smc=(0,O.$wi)("IExtHostDecorations")}),define(Ce[258],Ae([1,0,14,2,7,4,16,24,13]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class E{constructor(S,m,w){this.d=m,this.e=w,this.b=new Map,this.c=S.getProxy(O.$0M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,m){if(Object.keys(N.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const w=E.a++;this.b.set(w,m),this.c.$registerTextContentProvider(w,S);let g;if(typeof m.onDidChange=="function"){let r;g=m.onDidChange(async a=>{if(a.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;r&&await r;const s=this.$provideTextDocumentContent(w,a).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(a);if(!i)return;const c=(0,$.$lf)(n);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(y.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new C.$_M(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(S,m){const w=this.b.get(S);return w?Promise.resolve(w.provideTextDocumentContent(A.URI.revive(m),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$umc=E,E.a=0}),define(Ce[113],Ae([1,0,57,16,13,313,159,7,18]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=void 0,e.$zP=M;const E=new Map;function M(g,r){r?E.set(g,r):E.delete(g)}function S(g){return E.get(g)}class m extends O.$7v{constructor(r,a,s,n,i,c,h){super(a,s,n,i),this.c=r,this.m=c,this.q=h,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===A.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(a){return a?r.s(a):r.getText()},get eol(){return r.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(a){return r.t(a)},offsetAt(a){return r.u(a)},positionAt(a){return r.v(a)},validateRange(a){return r.w(a)},validatePosition(a){return r.x(a)},getWordRangeAtPosition(a,s){return r.y(a,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,y.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,y.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const a=this.w(r);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const s=this.g,n=a.start.line,i=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let h=n+1;h<i;h++)c.push(this.f[h]);return c.push(this.f[i].substring(0,a.end.character)),c.join(s)}t(r){let a;if(r instanceof p.$aN?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new w(a,this.f[a],a===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),s=this.f[a.index].length;return new p.$aN(a.index,Math.min(a.remainder,s))}w(r){if(!(r instanceof p.$bN))throw new Error("Invalid argument");const a=this.x(r.start),s=this.x(r.end);return a===r.start&&s===r.end?r:new p.$bN(a.line,a.character,s.line,s.character)}x(r){if(!(r instanceof p.$aN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:a,character:s}=r,n=!1;if(a<0)a=0,s=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,s=this.f[a].length,n=!0;else{const i=this.f[a].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new p.$aN(a,s):r}y(r,a){const s=this.x(r);if(!a)a=S(this.m);else if((0,C.$kf)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,N.$0s)(s.character+1,(0,N.$8s)(a),this.f[s.line],0);if(n)return new p.$bN(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$AP=m;class w{constructor(r,a,s){this.a=r,this.b=a,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$bN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$bN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$BP=w}),define(Ce[259],Ae([1,0,4,7]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class C{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(y.$0M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(N,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(N);if(!E)throw new Error("Embedding vector provider not found");const M=await E.provideEmbeddingVector(p,$);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(N,p,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiEmbeddingVectorProvider(p,E),new A.$_M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$wmc=C}),define(Ce[65],Ae([1,0,4,38,7,21,3,17,46,6,9,23,16]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=void 0;let g=w=class{constructor(a,s){this.b=new Map,this.c=new M.$Fh,this.a=a.getProxy(y.$0M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let c;const h=n.b.get(i.scheme);return h?(await n.a.$ensureActivation(i.scheme),c=await h.impl.stat(i)):c=await n.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===A.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(c){return w.e(c)}},async createDirectory(i){try{const c=n.b.get(i.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(c.impl,c.extUri,i)):await n.a.$mkdir(i)}catch(c){return w.e(c)}},async readFile(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(c){return w.e(c)}},async writeFile(i,c){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,O.$Ge.wrap(c))}catch(h){return w.e(h)}},async delete(i,c){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...c})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return w.e(h)}},async rename(i,c,h){try{return await n.a.$rename(i,c,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(i,c,h){try{return await n.a.$copy(i,c,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(i){const c=s.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(a,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await a.stat(n)).type&A.FileType.Directory))throw C.$qO.FileExists(`Unable to create folder '${n.scheme===m.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(A.$gl(c)!==A.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(s.basename(n)),n=s.dirname(n)}for(let c=i.length-1;c>=0;c--){n=s.joinPath(n,i[c]);try{await a.createDirectory(n)}catch(h){if(A.$gl(h)!==A.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof C.$qO)throw a;if(a instanceof A.$cl)switch(a.code){case A.FileSystemProviderErrorCode.FileExists:throw C.$qO.FileExists(a.message);case A.FileSystemProviderErrorCode.FileNotFound:throw C.$qO.FileNotFound(a.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw C.$qO.FileNotADirectory(a.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw C.$qO.FileIsADirectory(a.message);case A.FileSystemProviderErrorCode.NoPermissions:throw C.$qO.NoPermissions(a.message);case A.FileSystemProviderErrorCode.Unavailable:throw C.$qO.Unavailable(a.message);default:throw new C.$qO(a.message,a.name)}if(!(a instanceof Error))throw new C.$qO(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw C.$qO.Unavailable(a.message);switch(a.name){case A.FileSystemProviderErrorCode.FileExists:throw C.$qO.FileExists(a.message);case A.FileSystemProviderErrorCode.FileNotFound:throw C.$qO.FileNotFound(a.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw C.$qO.FileNotADirectory(a.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw C.$qO.FileIsADirectory(a.message);case A.FileSystemProviderErrorCode.NoPermissions:throw C.$qO.NoPermissions(a.message);case A.FileSystemProviderErrorCode.Unavailable:throw C.$qO.Unavailable(a.message);default:throw new C.$qO(a.message,a.name)}}addFileSystemProvider(a,s,n){return this.b.set(a,{impl:s,extUri:n?.isCaseSensitive?S.$Zg:S.$2g,isReadonly:!!n?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??S.$Zg}};e.$Hlc=g,e.$Hlc=g=w=Qe([qe(0,p.$xP),qe(1,$.$llc)],g),e.$Ilc=(0,N.$wi)("IExtHostConsumerFileSystem")}),define(Ce[87],Ae([1,0,3,27,12,65,2]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0,e.$Jlc=(0,y.$wi)("IExtensionStoragePaths");let p=class{constructor(E,M,S){this.d=M,this.f=S,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(E){return N.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,M=await this.g(E);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(N.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:N.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(E){if(this.c)return N.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return N.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Klc=p,e.$Klc=p=Qe([qe(0,A.$NP),qe(1,C.$3j),qe(2,O.$Ilc)],p)}),define(Ce[260],Ae([1,0,7,17,5]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;let O=class{constructor(p){this.a=new y.$AO(y.ColorThemeKind.Dark),this.b=new C.$ee}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=y.ColorThemeKind.Light;break;case"hcDark":$=y.ColorThemeKind.HighContrast;break;case"hcLight":$=y.ColorThemeKind.HighContrastLight;break;default:$=y.ColorThemeKind.Dark}this.a=new y.$AO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$fnc=O,e.$fnc=O=Qe([qe(0,A.$xP)],O)}),define(Ce[88],Ae([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GDb=e.$FDb=e.TunnelDtoConverter=void 0;class w extends $.$tw{}var g;(function(a){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}a.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}a.fromServiceTunnel=n})(g||(e.TunnelDtoConverter=g={})),e.$FDb=(0,N.$wi)("IExtHostTunnelService");let r=class extends C.$Vc{constructor(s,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new A.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$0M.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,s.displayName);if(i){const c=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,i),new m.$_M(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,c,h){const t=[];for(const o of s){const f=this.r.get(o);if(!f)return[];t.push(...await Promise.all(n.map(async u=>{let D;try{D=await f.provider.providePortAttributes({port:u,pid:i,commandLine:c},h)}catch{D=await f.provider.providePortAttributes(u,i,c,h)}return{providedAttributes:D,port:u}})))}const d=t.filter(o=>!!o.providedAttributes);return d.length>0?d.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await s.provideTunnel(c,h,y.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Tc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:h}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),i=s.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$GDb=r,e.$GDb=r=Qe([qe(0,S.$xP),qe(1,M.$NP),qe(2,p.$3j)],r)}),define(Ce[8],Ae([1,0,18,21,140,261,55,28,127,49,70,25,133,23,15,2,30,89,101,107,106,224,85,52,62,235,7,36]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d,o,f,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$uP=T,e.$vP=ne,e.$wP=me;var l;(function(Ee){function Te(J){const{selectionStartLineNumber:Ie,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:He}=J,ht=new u.$aN(Ie-1,We-1),Dt=new u.$aN(Ze-1,He-1);return new u.$cN(ht,Dt)}Ee.to=Te;function ce(J){const{anchor:Ie,active:We}=J;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Ee.from=ce})(l||(e.Selection=l={}));var v;(function(Ee){function Te(J){if(!J)return;const{start:Ie,end:We}=J;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Ee.from=Te;function ce(J){if(!J)return;const{startLineNumber:Ie,startColumn:We,endLineNumber:Ze,endColumn:He}=J;return new u.$bN(Ie-1,We-1,Ze-1,He-1)}Ee.to=ce})(v||(e.Range=v={}));var b;(function(Ee){function Te(J){return{uri:J.uri,range:v.from(J.range)}}Ee.from=Te;function ce(J){return new u.$lN(r.URI.revive(J.uri),v.to(J.range))}Ee.to=ce})(b||(e.Location=b={}));var P;(function(Ee){function Te(ce){switch(ce){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ee.to=Te})(P||(e.TokenType=P={}));var k;(function(Ee){function Te(J){return new u.$aN(J.lineNumber-1,J.column-1)}Ee.to=Te;function ce(J){return{lineNumber:J.line+1,column:J.character+1}}Ee.from=ce})(k||(e.Position=k={}));var I;(function(Ee){function Te(Ie,We,Ze){return(0,y.$Hb)((0,y.$3b)(Ie).map(He=>ce(He,We,Ze)))}Ee.from=Te;function ce(Ie,We,Ze){if(typeof Ie=="string")return{$serialized:!0,language:Ie,isBuiltin:Ze?.isBuiltin};if(Ie)return{$serialized:!0,language:Ie.language,scheme:J(Ie.scheme,We),pattern:ye.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType,isBuiltin:Ze?.isBuiltin}}function J(Ie,We){return We&&typeof Ie=="string"?We.transformOutgoingScheme(Ie):Ie}})(I||(e.DocumentSelector=I={}));var U;(function(Ee){function Te(J){switch(J){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ee.from=Te;function ce(J){switch(J){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(U||(e.DiagnosticTag=U={}));var Q;(function(Ee){function Te(J){let Ie;return J.code&&((0,g.$9f)(J.code)||(0,g.$ag)(J.code)?Ie=String(J.code):Ie={value:String(J.code.value),target:J.code.target}),{...v.from(J.range),message:J.message,source:J.source,code:Ie,severity:L.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(G.from),tags:Array.isArray(J.tags)?(0,y.$Hb)(J.tags.map(U.from)):void 0}}Ee.from=Te;function ce(J){const Ie=new u.$nN(v.to(J),J.message,L.to(J.severity));return Ie.source=J.source,Ie.code=(0,g.$9f)(J.code)?J.code:J.code?.value,Ie.relatedInformation=J.relatedInformation&&J.relatedInformation.map(G.to),Ie.tags=J.tags&&(0,y.$Hb)(J.tags.map(U.to)),Ie}Ee.to=ce})(Q||(e.Diagnostic=Q={}));var G;(function(Ee){function Te(J){return{...v.from(J.location.range),message:J.message,resource:J.location.uri}}Ee.from=Te;function ce(J){return new u.$mN(new u.$lN(J.resource,v.to(J)),J.message)}Ee.to=ce})(G||(e.DiagnosticRelatedInformation=G={}));var L;(function(Ee){function Te(J){switch(J){case u.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Ee.from=Te;function ce(J){switch(J){case n.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ee.to=ce})(L||(e.DiagnosticSeverity=L={}));var R;(function(Ee){function Te(J){return typeof J=="number"&&J>=u.ViewColumn.One?J-1:J===u.ViewColumn.Beside?f.$5D:f.$4D}Ee.from=Te;function ce(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(R||(e.ViewColumn=R={}));function F(Ee){return typeof Ee.range<"u"}function T(Ee){return Ee.length===0?!0:!!F(Ee[0])}var X;(function(Ee){function Te(He){return He.map(Ee.from)}Ee.fromMany=Te;function ce(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function J(He){let ht;if(ce(He)){const{language:Vt,value:At}=He;ht={value:"```"+Vt+`
`+At+"\n```\n"}}else u.$BN.isMarkdownString(He)?ht={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ht={value:He}:ht={value:""};const Dt=Object.create(null);ht.uris=Dt;const Ut=Vt=>{try{let At=r.URI.parse(Vt,!0);At=At.with({query:Ie(At.query,Dt)}),Dt[Vt]=At}catch{}return""},lt=new $.marked.Renderer;return lt.link=Ut,lt.image=Vt=>typeof Vt=="string"?Ut(N.$2k(Vt).href):"",(0,$.marked)(ht.value,{renderer:lt}),ht}Ee.from=J;function Ie(He,ht){if(!He)return He;let Dt;try{Dt=(0,E.$5h)(He)}catch{}if(!Dt)return He;let Ut=!1;return Dt=(0,S.$6n)(Dt,lt=>{if(r.URI.isUri(lt)){const Vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[Vt]=lt,Ut=!0,Vt}else return}),Ut?JSON.stringify(Dt):He}function We(He){const ht=new u.$BN(He.value,He.supportThemeIcons);return ht.isTrusted=He.isTrusted,ht.supportHtml=He.supportHtml,ht.baseUri=He.baseUri?r.URI.from(He.baseUri):void 0,ht}Ee.to=We;function Ze(He){if(He)return typeof He=="string"?He:Ee.from(He)}Ee.fromStrict=Ze})(X||(e.MarkdownString=X={}));function ne(Ee){return T(Ee)?Ee.map(Te=>({range:v.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?X.fromMany(Te.hoverMessage):Te.hoverMessage?X.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Ee.map(Te=>({range:v.from(Te)}))}function me(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?r.URI.file(Ee):Ee}var we;(function(Ee){function Te(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?me(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=Te})(we||(e.ThemableDecorationAttachmentRenderOptions=we={}));var de;(function(Ee){function Te(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?me(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?we.from(ce.before):void 0,after:ce.after?we.from(ce.after):void 0}}Ee.from=Te})(de||(e.ThemableDecorationRenderOptions=de={}));var $e;(function(Ee){function Te(ce){if(typeof ce>"u")return ce;switch(ce){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Te})($e||(e.DecorationRangeBehavior=$e={}));var ke;(function(Ee){function Te(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?$e.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?de.from(ce.light):void 0,dark:ce.dark?de.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?me(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?we.from(ce.before):void 0,after:ce.after?we.from(ce.after):void 0}}Ee.from=Te})(ke||(e.DecorationRenderOptions=ke={}));var se;(function(Ee){function Te(J){return{text:J.newText,eol:J.newEol&&$t.from(J.newEol),range:v.from(J.range)}}Ee.from=Te;function ce(J){const Ie=new u.$gN(v.to(J.range),J.text);return Ie.newEol=typeof J.eol>"u"?void 0:$t.to(J.eol),Ie}Ee.to=ce})(se||(e.TextEdit=se={}));var Pe;(function(Ee){function Te(J,Ie){const We={edits:[]};if(J instanceof u.$jN){const Ze=new p.$Cc;for(const He of J._allEntries())He._type===1&&r.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of J._allEntries())if(He._type===1){let ht;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ht={type:"base64",value:(0,A.$1e)(A.$Ge.wrap(He.options.contents))}:ht={type:"dataTransferItem",id:He.options.contents._itemId}),We.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ht},metadata:He.metadata})}else He._type===2?We.edits.push({resource:He.uri,textEdit:se.from(He.edit),versionId:Ze.has(He.uri)?void 0:Ie?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?We.edits.push({resource:He.uri,textEdit:{range:v.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:Ie?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?We.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(He.uri)}):He._type===5&&We.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(_t.from)}})}return We}Ee.from=Te;function ce(J){const Ie=new u.$jN,We=new p.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const He=Ze,ht=r.URI.revive(He.resource),Dt=v.to(He.textEdit.range),Ut=He.textEdit.text,lt=He.textEdit.insertAsSnippet;let Vt;lt?Vt=u.$iN.replace(Dt,new u.$kN(Ut)):Vt=u.$gN.replace(Dt,Ut);const At=We.get(ht);At?At.push(Vt):We.set(ht,[Vt])}else Ie.renameFile(r.URI.revive(Ze.oldResource),r.URI.revive(Ze.newResource),Ze.options);for(const[Ze,He]of We)Ie.set(Ze,He);return Ie}Ee.to=ce})(Pe||(e.WorkspaceEdit=Pe={}));var re;(function(Ee){const Te=Object.create(null);Te[u.SymbolKind.File]=0,Te[u.SymbolKind.Module]=1,Te[u.SymbolKind.Namespace]=2,Te[u.SymbolKind.Package]=3,Te[u.SymbolKind.Class]=4,Te[u.SymbolKind.Method]=5,Te[u.SymbolKind.Property]=6,Te[u.SymbolKind.Field]=7,Te[u.SymbolKind.Constructor]=8,Te[u.SymbolKind.Enum]=9,Te[u.SymbolKind.Interface]=10,Te[u.SymbolKind.Function]=11,Te[u.SymbolKind.Variable]=12,Te[u.SymbolKind.Constant]=13,Te[u.SymbolKind.String]=14,Te[u.SymbolKind.Number]=15,Te[u.SymbolKind.Boolean]=16,Te[u.SymbolKind.Array]=17,Te[u.SymbolKind.Object]=18,Te[u.SymbolKind.Key]=19,Te[u.SymbolKind.Null]=20,Te[u.SymbolKind.EnumMember]=21,Te[u.SymbolKind.Struct]=22,Te[u.SymbolKind.Event]=23,Te[u.SymbolKind.Operator]=24,Te[u.SymbolKind.TypeParameter]=25;function ce(Ie){return typeof Te[Ie]=="number"?Te[Ie]:6}Ee.from=ce;function J(Ie){for(const We in Te)if(Te[We]===Ie)return Number(We);return u.SymbolKind.Property}Ee.to=J})(re||(e.SymbolKind=re={}));var H;(function(Ee){function Te(J){switch(J){case u.SymbolTag.Deprecated:return 1}}Ee.from=Te;function ce(J){switch(J){case 1:return u.SymbolTag.Deprecated}}Ee.to=ce})(H||(e.SymbolTag=H={}));var he;(function(Ee){function Te(J){return{name:J.name,kind:re.from(J.kind),tags:J.tags&&J.tags.map(H.from),containerName:J.containerName,location:ae.from(J.location)}}Ee.from=Te;function ce(J){const Ie=new u.$sN(J.name,re.to(J.kind),J.containerName,ae.to(J.location));return Ie.tags=J.tags&&J.tags.map(H.to),Ie}Ee.to=ce})(he||(e.WorkspaceSymbol=he={}));var Fe;(function(Ee){function Te(J){const Ie={name:J.name||"!!MISSING: name!!",detail:J.detail,range:v.from(J.range),selectionRange:v.from(J.selectionRange),kind:re.from(J.kind),tags:J.tags?.map(H.from)??[]};return J.children&&(Ie.children=J.children.map(Te)),Ie}Ee.from=Te;function ce(J){const Ie=new u.$tN(J.name,J.detail,re.to(J.kind),v.to(J.range),v.to(J.selectionRange));return(0,y.$Lb)(J.tags)&&(Ie.tags=J.tags.map(H.to)),J.children&&(Ie.children=J.children.map(ce)),Ie}Ee.to=ce})(Fe||(e.DocumentSymbol=Fe={}));var pe;(function(Ee){function Te(J){const Ie=new u.$xN(re.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),v.to(J.range),v.to(J.selectionRange));return Ie._sessionId=J._sessionId,Ie._itemId=J._itemId,Ie}Ee.to=Te;function ce(J,Ie,We){if(Ie=Ie??J._sessionId,We=We??J._itemId,Ie===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:We,name:J.name,detail:J.detail,kind:re.from(J.kind),uri:J.uri,range:v.from(J.range),selectionRange:v.from(J.selectionRange),tags:J.tags?.map(H.from)}}Ee.from=ce})(pe||(e.CallHierarchyItem=pe={}));var be;(function(Ee){function Te(ce){return new u.$yN(pe.to(ce.from),ce.fromRanges.map(J=>v.to(J)))}Ee.to=Te})(be||(e.CallHierarchyIncomingCall=be={}));var ge;(function(Ee){function Te(ce){return new u.$zN(pe.to(ce.to),ce.fromRanges.map(J=>v.to(J)))}Ee.to=Te})(ge||(e.CallHierarchyOutgoingCall=ge={}));var ae;(function(Ee){function Te(J){return{range:J.range&&v.from(J.range),uri:J.uri}}Ee.from=Te;function ce(J){return new u.$lN(r.URI.revive(J.uri),v.to(J.range))}Ee.to=ce})(ae||(e.location=ae={}));var K;(function(Ee){function Te(J){const Ie=J,We=J;return{originSelectionRange:Ie.originSelectionRange?v.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:We.uri,range:v.from(Ie.targetRange?Ie.targetRange:We.range),targetSelectionRange:Ie.targetSelectionRange?v.from(Ie.targetSelectionRange):void 0}}Ee.from=Te;function ce(J){return{targetUri:r.URI.revive(J.uri),targetRange:v.to(J.range),targetSelectionRange:J.targetSelectionRange?v.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?v.to(J.originSelectionRange):void 0}}Ee.to=ce})(K||(e.DefinitionLink=K={}));var Z;(function(Ee){function Te(J){return{range:v.from(J.range),contents:X.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}Ee.from=Te;function ce(J){const Ie=J.contents.map(X.to),We=v.to(J.range),Ze=J.canIncreaseVerbosity,He=J.canDecreaseVerbosity;return new u.$pN(Ie,We,Ze,He)}Ee.to=ce})(Z||(e.Hover=Z={}));var fe;(function(Ee){function Te(J){return{range:v.from(J.range),expression:J.expression}}Ee.from=Te;function ce(J){return new u.$kO(v.to(J.range),J.expression)}Ee.to=ce})(fe||(e.EvaluatableExpression=fe={}));var le;(function(Ee){function Te(J){if(J instanceof u.$lO)return{type:"text",range:v.from(J.range),text:J.text};if(J instanceof u.$mO)return{type:"variable",range:v.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof u.$nO)return{type:"expression",range:v.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Te;function ce(J){switch(J.type){case"text":return{range:v.to(J.range),text:J.text};case"variable":return{range:v.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:v.to(J.range),expression:J.expression}}}Ee.to=ce})(le||(e.InlineValue=le={}));var Me;(function(Ee){function Te(J){return{frameId:J.frameId,stoppedLocation:v.from(J.stoppedLocation)}}Ee.from=Te;function ce(J){return new u.$oO(J.frameId,v.to(J.stoppedLocation))}Ee.to=ce})(Me||(e.InlineValueContext=Me={}));var ve;(function(Ee){function Te(J){return{range:v.from(J.range),kind:J.kind}}Ee.from=Te;function ce(J){return new u.$qN(v.to(J.range),J.kind)}Ee.to=ce})(ve||(e.DocumentHighlight=ve={}));var Re;(function(Ee){function Te(J){return{uri:J.uri,highlights:J.highlights.map(ve.from)}}Ee.from=Te;function ce(J){return new u.$rN(r.URI.revive(J.uri),J.highlights.map(ve.to))}Ee.to=ce})(Re||(e.MultiDocumentHighlight=Re={}));var Oe;(function(Ee){function Te(ce){switch(ce){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ee.to=Te})(Oe||(e.CompletionTriggerKind=Oe={}));var Ue;(function(Ee){function Te(ce){return{triggerKind:Oe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=Te})(Ue||(e.CompletionContext=Ue={}));var j;(function(Ee){function Te(J){switch(J){case u.CompletionItemTag.Deprecated:return 1}}Ee.from=Te;function ce(J){switch(J){case 1:return u.CompletionItemTag.Deprecated}}Ee.to=ce})(j||(e.CompletionItemTag=j={}));var V;(function(Ee){const Te=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ce(We){return Te.get(We)??9}Ee.from=ce;const J=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Ie(We){return J.get(We)??u.CompletionItemKind.Property}Ee.to=Ie})(V||(e.CompletionItemKind=V={}));var W;(function(Ee){function Te(ce,J){const Ie=new u.$HN(ce.label);return Ie.insertText=ce.insertText,Ie.kind=V.to(ce.kind),Ie.tags=ce.tags?.map(j.to),Ie.detail=ce.detail,Ie.documentation=N.$Vk(ce.documentation)?X.to(ce.documentation):ce.documentation,Ie.sortText=ce.sortText,Ie.filterText=ce.filterText,Ie.preselect=ce.preselect,Ie.commitCharacters=ce.commitCharacters,a.$vt.isIRange(ce.range)?Ie.range=v.to(ce.range):typeof ce.range=="object"&&(Ie.range={inserting:v.to(ce.range.insert),replacing:v.to(ce.range.replace)}),Ie.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&1),typeof ce.insertTextRules<"u"&&ce.insertTextRules&4?Ie.insertText=new u.$kN(ce.insertText):(Ie.insertText=ce.insertText,Ie.textEdit=Ie.range instanceof u.$bN?new u.$gN(Ie.range,Ie.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ce.additionalTextEdits.map(We=>se.to(We))),Ie.command=J&&ce.command?J.fromInternal(ce.command):void 0,Ie}Ee.to=Te})(W||(e.CompletionItem=W={}));var q;(function(Ee){function Te(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:X.fromStrict(J.documentation)}}Ee.from=Te;function ce(J){return{label:J.label,documentation:N.$Vk(J.documentation)?X.to(J.documentation):J.documentation}}Ee.to=ce})(q||(e.ParameterInformation=q={}));var _;(function(Ee){function Te(J){return{label:J.label,documentation:X.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(q.from):[],activeParameter:J.activeParameter}}Ee.from=Te;function ce(J){return{label:J.label,documentation:N.$Vk(J.documentation)?X.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(q.to):[],activeParameter:J.activeParameter}}Ee.to=ce})(_||(e.SignatureInformation=_={}));var oe;(function(Ee){function Te(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(_.from):[]}}Ee.from=Te;function ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(_.to):[]}}Ee.to=ce})(oe||(e.SignatureHelp=oe={}));var Ne;(function(Ee){function Te(ce,J){const Ie=new u.$GN(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Ve.to.bind(void 0,ce)),J.kind&&Ke.to(J.kind));return Ie.textEdits=J.textEdits&&J.textEdits.map(se.to),Ie.tooltip=N.$Vk(J.tooltip)?X.to(J.tooltip):J.tooltip,Ie.paddingLeft=J.paddingLeft,Ie.paddingRight=J.paddingRight,Ie}Ee.to=Te})(Ne||(e.InlayHint=Ne={}));var Ve;(function(Ee){function Te(ce,J){const Ie=new u.$FN(J.label);return Ie.tooltip=N.$Vk(J.tooltip)?X.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(Ie.command=ce.fromInternal(J.command)),J.location&&(Ie.location=ae.to(J.location)),Ie}Ee.to=Te})(Ve||(e.InlayHintLabelPart=Ve={}));var Ke;(function(Ee){function Te(J){return J}Ee.from=Te;function ce(J){return J}Ee.to=ce})(Ke||(e.InlayHintKind=Ke={}));var Ye;(function(Ee){function Te(J){return{range:v.from(J.range),url:J.target,tooltip:J.tooltip}}Ee.from=Te;function ce(J){let Ie;if(J.url)try{Ie=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new u.$MN(v.to(J.range),Ie)}Ee.to=ce})(Ye||(e.DocumentLink=Ye={}));var tt;(function(Ee){function Te(J){const Ie=new u.$PN(J.label);return J.textEdit&&(Ie.textEdit=se.to(J.textEdit)),J.additionalTextEdits&&(Ie.additionalTextEdits=J.additionalTextEdits.map(We=>se.to(We))),Ie}Ee.to=Te;function ce(J){return{label:J.label,textEdit:J.textEdit?se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ie=>se.from(Ie)):void 0}}Ee.from=ce})(tt||(e.ColorPresentation=tt={}));var it;(function(Ee){function Te(J){return new u.$NN(J[0],J[1],J[2],J[3])}Ee.to=Te;function ce(J){return[J.red,J.green,J.blue,J.alpha]}Ee.from=ce})(it||(e.Color=it={}));var nt;(function(Ee){function Te(J){return{range:v.from(J.range)}}Ee.from=Te;function ce(J){return new u.$wN(v.to(J.range))}Ee.to=ce})(nt||(e.SelectionRange=nt={}));var st;(function(Ee){function Te(ce){switch(ce){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ee.to=Te})(st||(e.TextDocumentSaveReason=st={}));var ut;(function(Ee){function Te(J){switch(J){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Te;function ce(J){switch(J){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ee.to=ce})(ut||(e.TextEditorLineNumbersStyle=ut={}));var $t;(function(Ee){function Te(J){if(J===u.EndOfLine.CRLF)return 1;if(J===u.EndOfLine.LF)return 0}Ee.from=Te;function ce(J){if(J===1)return u.EndOfLine.CRLF;if(J===0)return u.EndOfLine.LF}Ee.to=ce})($t||(e.EndOfLine=$t={}));var je;(function(Ee){function Te(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Te})(je||(e.ProgressLocation=je={}));var ct;(function(Ee){function Te(J){const Ie={start:J.start+1,end:J.end+1};return J.kind&&(Ie.kind=x.from(J.kind)),Ie}Ee.from=Te;function ce(J){const Ie={start:J.start-1,end:J.end-1};return J.kind&&(Ie.kind=x.to(J.kind)),Ie}Ee.to=ce})(ct||(e.FoldingRange=ct={}));var x;(function(Ee){function Te(J){if(J)switch(J){case u.FoldingRangeKind.Comment:return s.$eu.Comment;case u.FoldingRangeKind.Imports:return s.$eu.Imports;case u.FoldingRangeKind.Region:return s.$eu.Region}}Ee.from=Te;function ce(J){if(J)switch(J.value){case s.$eu.Comment.value:return u.FoldingRangeKind.Comment;case s.$eu.Imports.value:return u.FoldingRangeKind.Imports;case s.$eu.Region.value:return u.FoldingRangeKind.Region}}Ee.to=ce})(x||(e.FoldingRangeKind=x={}));var Y;(function(Ee){function Te(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?v.from(ce.selection):void 0,override:typeof ce.override=="boolean"?c.$uF.id:void 0}}Ee.from=Te})(Y||(e.TextEditorOpenOptions=Y={}));var ye;(function(Ee){function Te(We){return We instanceof u.$$N?We.toJSON():typeof We=="string"?We:ce(We)||J(We)?new u.$$N(We.baseUri??We.base,We.pattern).toJSON():We}Ee.from=Te;function ce(We){const Ze=We;return Ze?r.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ie(We){return typeof We=="string"?We:new u.$$N(r.URI.revive(We.baseUri),We.pattern)}Ee.to=Ie})(ye||(e.GlobPattern=ye={}));var Ge;(function(Ee){function Te(ce){if(ce){if(Array.isArray(ce))return ce.map(Te);if(typeof ce=="string")return ce;{const J=ce;return{language:J.language,scheme:J.scheme,pattern:ye.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Ee.from=Te})(Ge||(e.LanguageSelector=Ge={}));var De;(function(Ee){function Te(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ie=>Array.isArray(Ie)&&Ie.every(We=>We&&typeof We=="object"&&"uri"in We&&r.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof u.$bN)))}Ee.is=Te;function ce(J){return{documents:J.documents.map(Ie=>Ie.map(We=>({uri:r.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>v.from(Ze))})))}}Ee.from=ce})(De||(e.MappedEditsContext=De={}));var at;(function(Ee){function Te(J){return{start:J.start,end:J.end}}Ee.from=Te;function ce(J){return new u.$BO(J.start,J.end)}Ee.to=ce})(at||(e.NotebookRange=at={}));var gt;(function(Ee){function Te(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Ee.to=Te;function ce(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Ee.from=ce})(gt||(e.NotebookCellExecutionSummary=gt={}));var Rt;(function(Ee){function Te(ce){if(ce===t.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(ce===t.NotebookCellExecutionState.Pending)return;if(ce===t.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}Ee.to=Te})(Rt||(e.NotebookCellExecutionState=Rt={}));var Wt;(function(Ee){function Te(J){switch(J){case u.NotebookCellKind.Markup:return t.CellKind.Markup;case u.NotebookCellKind.Code:default:return t.CellKind.Code}}Ee.from=Te;function ce(J){switch(J){case t.CellKind.Markup:return u.NotebookCellKind.Markup;case t.CellKind.Code:default:return u.NotebookCellKind.Code}}Ee.to=ce})(Wt||(e.NotebookCellKind=Wt={}));var Qt;(function(Ee){function Te(J){const Ie={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)u.$CO.validate(We),Ie.cells.push(_t.from(We));return Ie}Ee.from=Te;function ce(J){const Ie=new u.$DO(J.cells.map(_t.to));return(0,g.$jg)(J.metadata)||(Ie.metadata=J.metadata),Ie}Ee.to=ce})(Qt||(e.NotebookData=Qt={}));var _t;(function(Ee){function Te(J){return{cellKind:Wt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:gt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(St.from):[]}}Ee.from=Te;function ce(J){return new u.$CO(Wt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(St.to):void 0,J.metadata,J.internalMetadata?gt.to(J.internalMetadata):void 0)}Ee.to=ce})(_t||(e.NotebookCellData=_t={}));var Xt;(function(Ee){function Te(J){return{mime:J.mime,valueBytes:A.$Ge.wrap(J.data)}}Ee.from=Te;function ce(J){return new u.$EO(J.valueBytes.buffer,J.mime)}Ee.to=ce})(Xt||(e.NotebookCellOutputItem=Xt={}));var St;(function(Ee){function Te(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}Ee.from=Te;function ce(J){const Ie=J.items.map(Xt.to);return new u.$FO(Ie,J.outputId,J.metadata)}Ee.to=ce})(St||(e.NotebookCellOutput=St={}));var ei;(function(Ee){function Te(Ie){return J(Ie)?{include:ye.from(Ie.include)??void 0,exclude:ye.from(Ie.exclude)??void 0}:ye.from(Ie)??void 0}Ee.from=Te;function ce(Ie){return J(Ie)?{include:ye.to(Ie.include),exclude:ye.to(Ie.exclude)}:ye.to(Ie)}Ee.to=ce;function J(Ie){const We=Ie;return We?!(0,g.$fg)(We.include)&&!(0,g.$fg)(We.exclude):!1}})(ei||(e.NotebookExclusiveDocumentPattern=ei={}));var ti;(function(Ee){function Te(ce,J,Ie){const We=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(We,Ie),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Ee.from=Te})(ti||(e.NotebookStatusBarItem=ti={}));var xe;(function(Ee){function Te(ce,J,Ie){const We=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:J.toInternal(We,Ie),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}Ee.from=Te})(xe||(e.NotebookKernelSourceAction=xe={}));var hi;(function(Ee){function Te(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}Ee.from=Te})(hi||(e.NotebookDocumentContentOptions=hi={}));var ni;(function(Ee){function Te(J){return{uri:J.uri,provides:J.provides}}Ee.from=Te;function ce(J){return new u.$HO(r.URI.revive(J.uri),J.provides)}Ee.to=ce})(ni||(e.NotebookRendererScript=ni={}));var ft;(function(Ee){function Te(J){return{message:X.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:v.from(J.location.range),uri:J.location.uri}}}Ee.from=Te;function ce(J){const Ie=new u.$NO(typeof J.message=="string"?J.message:X.to(J.message));return Ie.actualOutput=J.actual,Ie.expectedOutput=J.expected,Ie.contextValue=J.contextValue,Ie.location=J.location?ae.to(J.location):void 0,Ie}Ee.to=ce})(ft||(e.TestMessage=ft={}));var wt;(function(Ee){Ee.namespace=o.$1L,Ee.denamespace=o.$2L})(wt||(e.TestTag=wt={}));var Gt;(function(Ee){function Te(J){const Ie=(0,i.$tP)(J).controllerId;return{extId:d.$VL.fromExtHostTestItem(J,Ie).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>wt.namespace(Ie,We.id)),range:a.$vt.lift(v.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&X.fromStrict(J.error)||null}}Ee.from=Te;function ce(J){return{parent:void 0,error:void 0,id:d.$VL.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(Ie=>{const{tagId:We}=wt.denamespace(Ie);return new u.$OO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Ee.toPlain=ce})(Gt||(e.TestItem=Gt={})),function(Ee){function Te(J){return{id:J.id}}Ee.from=Te;function ce(J){return new u.$OO(J.id)}Ee.to=ce}(wt||(e.TestTag=wt={}));var Zt;(function(Ee){const Te=(J,Ie)=>{const We=J.value;if(!We)return;const Ze={...Gt.toPlain(We.item),parent:Ie,taskStates:We.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(J.children)for(const He of J.children.values()){const ht=Te(He,Ze);ht&&Ze.children.push(ht)}return Ze};function ce(J){const Ie=new m.$mP;for(const He of J.items)Ie.insert(d.$VL.fromString(He.item.extId).path,He);const We=[Ie.nodes],Ze=[];for(;We.length;)for(const He of We.pop())He.value?Ze.push(He):He.children&&We.push(He.children.values());return{completedAt:J.completedAt,results:Ze.map(He=>Te(He)).filter(g.$eg)}}Ee.to=ce})(Zt||(e.TestResults=Zt={}));var Lt;(function(Ee){function Te(We){return{covered:We.covered,total:We.total}}function ce(We){return"line"in We?k.from(We):v.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ce(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ce(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:ce(We.location)}}Ee.fromDetails=J;function Ie(We,Ze){return u.$QO(Ze.statementCoverage),u.$QO(Ze.branchCoverage),u.$QO(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Te(Ze.statementCoverage),branch:Ze.branchCoverage&&Te(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Te(Ze.declarationCoverage)}}Ee.fromFile=Ie})(Lt||(e.TestCoverage=Lt={}));var mt;(function(Ee){function Te(ce){switch(ce){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ee.to=Te})(mt||(e.CodeActionTriggerKind=mt={}));var zt;(function(Ee){function Te(J){const Ie=new u.$VO(re.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),v.to(J.range),v.to(J.selectionRange));return Ie._sessionId=J._sessionId,Ie._itemId=J._itemId,Ie}Ee.to=Te;function ce(J,Ie,We){if(Ie=Ie??J._sessionId,We=We??J._itemId,Ie===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:We,kind:re.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:v.from(J.range),selectionRange:v.from(J.selectionRange),tags:J.tags?.map(H.from)}}Ee.from=ce})(zt||(e.TypeHierarchyItem=zt={}));var qt;(function(Ee){function Te(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}Ee.from=Te})(qt||(e.ViewBadge=qt={}));var Ft;(function(Ee){function Te(We,Ze,He){const ht=Ze.fileData;return ht?new u.$3N(new u.$4N(ht.name,r.URI.revive(ht.uri),ht.id,(0,O.$db)(()=>He(ht.id)))):We===M.$Rs.uriList&&Ze.uriListData?new u.$2N(Ie(Ze.uriListData)):new u.$2N(Ze.asString)}Ee.to=Te;async function ce(We,Ze){const He=await Ze.asString();if(We===M.$Rs.uriList)return{asString:He,fileData:void 0,uriListData:J(He)};const ht=Ze.asFile();return{asString:He,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Ee.from=ce;function J(We){return C.$Vt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return r.URI.parse(Ze)}catch{}return Ze})}function Ie(We){return C.$Vt.create(We.map(Ze=>typeof Ze=="string"?Ze:r.URI.revive(Ze)))}})(Ft||(e.DataTransferItem=Ft={}));var Xe;(function(Ee){function Te(J,Ie){const We=J.items.map(([Ze,He])=>[Ze,Ft.to(Ze,He,Ie)]);return new u.$5N(We)}Ee.toDataTransfer=Te;async function ce(J){const Ie={items:[]},We=[];for(const[Ze,He]of J)We.push((async()=>{Ie.items.push([Ze,await Ft.from(Ze,He)])})());return await Promise.all(We),Ie}Ee.from=ce})(Xe||(e.DataTransfer=Xe={}));var ci;(function(Ee){function Te(J,Ie){return{kind:"reply",agentId:J.participant??Ie?.agentId??"",subCommand:J.command??Ie?.command,message:J.prompt,title:J.label}}Ee.from=Te;function ce(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}Ee.to=ce})(ci||(e.ChatFollowup=ci={}));var Yt;(function(Ee){function Te(ce){return"commandId"in ce?{kind:"command",title:ce.title??"",commandId:ce.commandId??"",when:ce.when??"",args:ce.args}:{kind:"reply",message:ce.message,title:ce.title,tooltip:ce.tooltip}}Ee.from=Te})(Yt||(e.ChatInlineFollowup=Yt={}));var Kt;(function(Ee){function Te(J){switch(J.role){case 0:return new u.$hP(J.content);case 1:return new u.$iP(J.content);case 2:return new u.$jP(J.content)}}Ee.to=Te;function ce(J){if(J instanceof u.$hP)return{role:0,content:J.content};if(J instanceof u.$iP)return{role:1,content:J.content};if(J instanceof u.$jP)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}Ee.from=ce})(Kt||(e.LanguageModelMessage=Kt={}));var vt;(function(Ee){function Te(Ie){const We={};for(const Ze of Object.keys(Ie))We[Ze]=Ie[Ze].map(Ee.to);return We}Ee.objectTo=Te;function ce(Ie){return{level:jt.to(Ie.level),kind:Ie.kind,value:(0,r.$wc)(Ie.value)?r.URI.revive(Ie.value):Ie.value,description:Ie.description}}Ee.to=ce;function J(Ie){return{level:jt.from(Ie.level),kind:Ie.kind,value:Ie.value,description:Ie.description}}Ee.from=J})(vt||(e.ChatVariable=vt={}));var jt;(function(Ee){function Te(J){switch(J){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}Ee.to=Te;function ce(J){switch(J){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}Ee.from=ce})(jt||(e.ChatVariableLevel=jt={}));var Bt;(function(Ee){function Te(ce){switch(ce){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Te})(Bt||(e.InteractiveEditorResponseFeedbackKind=Bt={}));var Ht;(function(Ee){function Te(J){return{kind:"markdownContent",content:X.from(J.value)}}Ee.from=Te;function ce(J){return new u.$9O(X.to(J.content))}Ee.to=ce})(Ht||(e.ChatResponseMarkdownPart=Ht={}));var ri;(function(Ee){function Te(J){return{kind:"markdownVuln",content:X.from(J.value),vulnerabilities:J.vulnerabilities}}Ee.from=Te;function ce(J){return new u.$0O(X.to(J.content),J.vulnerabilities)}Ee.to=ce})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var si;(function(Ee){function Te(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}Ee.from=Te;function ce(J){return new u.$$O(J.agentId,J.command)}Ee.to=ce})(si||(e.ChatResponseDetectedParticipantPart=si={}));var oi;(function(Ee){function Te(J){const{value:Ie,baseUri:We}=J;function Ze(He,ht){return He.map(Dt=>{const Ut=r.URI.joinPath(ht,Dt.name);return{label:Dt.name,uri:Ut,children:Dt.children&&Ze(Dt.children,Ut)}})}return{kind:"treeData",treeData:{label:(0,w.$7g)(We),uri:We,children:Ze(Ie,We)}}}Ee.from=Te;function ce(J){const Ie=(0,E.$6h)(J.treeData);function We(ht){return ht.map(Dt=>({name:Dt.label,children:Dt.children&&We(Dt.children)}))}const Ze=Ie.uri,He=Ie.children?We(Ie.children):[];return new u.$_O(He,Ze)}Ee.to=ce})(oi||(e.ChatResponseFilesPart=oi={}));var Mt;(function(Ee){function Te(J){return{kind:"inlineReference",name:J.title,inlineReference:r.URI.isUri(J.value)?J.value:b.from(J.value)}}Ee.from=Te;function ce(J){const Ie=(0,E.$6h)(J);return new u.$aP(r.URI.isUri(Ie.inlineReference)?Ie.inlineReference:b.to(Ie.inlineReference),J.name)}Ee.to=ce})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Pt;(function(Ee){function Te(J){return{kind:"progressMessage",content:X.from(J.value)}}Ee.from=Te;function ce(J){return new u.$bP(J.content.value)}Ee.to=ce})(Pt||(e.ChatResponseProgressPart=Pt={}));var Ot;(function(Ee){function Te(J,Ie,We){return{kind:"command",command:Ie.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}Ee.from=Te;function ce(J,Ie){return new u.$cP(Ie.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}Ee.to=ce})(Ot||(e.ChatResponseCommandButtonPart=Ot={}));var It;(function(Ee){function Te(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Ie=>se.from(Ie))}}Ee.from=Te;function ce(J){return new u.$eP(r.URI.revive(J.uri),J.edits.map(Ie=>se.to(Ie)))}Ee.to=ce})(It||(e.ChatResponseTextEditPart=It={}));var pt;(function(Ee){function Te(J){const Ie=D.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:b.from(J.value.value)},iconPath:Ie}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:b.from(J.value),iconPath:Ie}}Ee.from=Te;function ce(J){const Ie=(0,E.$6h)(J),We=Ze=>r.URI.isUri(Ze)?Ze:b.to(Ze);return new u.$dP("variableName"in Ie.reference?{variableName:Ie.reference.variableName,value:Ie.reference.value&&We(Ie.reference.value)}:We(Ie.reference))}Ee.to=ce})(pt||(e.ChatResponseReferencePart=pt={}));var Ct;(function(Ee){function Te(Ie,We,Ze){return Ie instanceof u.$9O?Ht.from(Ie):Ie instanceof u.$aP?Mt.from(Ie):Ie instanceof u.$dP?pt.from(Ie):Ie instanceof u.$bP?Pt.from(Ie):Ie instanceof u.$_O?oi.from(Ie):Ie instanceof u.$cP?Ot.from(Ie,We,Ze):Ie instanceof u.$eP?It.from(Ie):Ie instanceof u.$0O?ri.from(Ie):Ie instanceof u.$$O?si.from(Ie):{kind:"markdownContent",content:X.from("")}}Ee.from=Te;function ce(Ie,We){switch(Ie.kind){case"reference":return pt.to(Ie);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Ie,We)}}Ee.to=ce;function J(Ie,We){switch(Ie.kind){case"markdownContent":return Ht.to(Ie);case"inlineReference":return Mt.to(Ie);case"progressMessage":return;case"treeData":return oi.to(Ie);case"command":return Ot.to(Ie,We)}}Ee.toContent=J})(Ct||(e.ChatResponsePart=Ct={}));var ai;(function(Ee){function Te(ce){return{prompt:ce.message,command:ce.command,attempt:ce.attempt??0,enableCommandDetection:ce.enableCommandDetection??!0,variables:ce.variables.variables.map(xt.to),location:kt.to(ce.location)}}Ee.to=Te})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(Ee){function Te(ce){switch(ce){case h.ChatAgentLocation.Notebook:return u.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return u.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return u.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return u.ChatLocation.Editor}}Ee.to=Te})(kt||(e.ChatLocation=kt={}));var xt;(function(Ee){function Te(ce){return{name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],values:ce.values.map(vt.to)}}Ee.to=Te})(xt||(e.ChatAgentResolvedVariable=xt={}));var ii;(function(Ee){function Te(ce,J,Ie){return{label:ce.label,values:ce.values.map(vt.from),insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation,command:J.toInternal(ce.command,Ie)}}Ee.from=Te})(ii||(e.ChatAgentCompletionItem=ii={}));var yi;(function(Ee){function Te(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata}}Ee.to=Te})(yi||(e.ChatAgentResult=yi={}));var di;(function(Ee){function Te(ce,J,Ie){if(J.action.kind==="vote")return;const We=yi.to(ce);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ie.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ci.to(J.action.followup)},result:We}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:We}:{action:J.action,result:We}}Ee.to=Te})(di||(e.ChatAgentUserActionEvent=di={}));var fi;(function(Ee){function Te(ce,J,Ie){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:J.toInternal(ce,Ie)}Ee.from=Te})(fi||(e.TerminalQuickFix=fi={}));var Nt;(function(Ee){function Te(ce){return{kind:mi.to(ce.kind)}}Ee.to=Te})(Nt||(e.PartialAcceptInfo=Nt={}));var mi;(function(Ee){function Te(ce){switch(ce){case 0:return u.PartialAcceptTriggerKind.Word;case 1:return u.PartialAcceptTriggerKind.Line;case 2:return u.PartialAcceptTriggerKind.Suggest;default:return u.PartialAcceptTriggerKind.Unknown}}Ee.to=Te})(mi||(e.PartialAcceptTriggerKind=mi={}));var Ei;(function(Ee){function Te(ce,J){return{id:J,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||0,contextValue:ce.contextValue}}Ee.from=Te})(Ei||(e.DebugTreeItem=Ei={}))}),define(Ce[262],Ae([1,0,4,17,8,35]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;let N=class{constructor($,E){this.a=$.getProxy(y.$0M.MainThreadBulkEdits),this.b={getTextDocumentVersion:M=>E.getDocument(M)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,M){const S=new O.$Cw(C.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,M?.isRefactoring??!1)}};e.$tlc=N,e.$tlc=N=Qe([qe(0,A.$xP)],N)}),define(Ce[263],Ae([1,0,18,9,44,5,42,6,66,15,2,20,4,8,7,225,26]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class s{constructor(h,t,d,o,f){this.j=h,this.k=t,this.l=d,this.m=o,this.n=f,this.b=$.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(o){if(h.c){const f=new Error("Response stream has been closed");throw Error.captureStackTrace(f,o),f}};const h=this;this.b.reset();const d=o=>{typeof this.d>"u"&&"content"in o&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,o)};this.g={markdown(o){t(this.markdown);const f=new g.$9O(o),u=w.ChatResponseMarkdownPart.from(f);return d(u),this},markdownWithVulnerabilities(o,f){t(this.markdown),f&&(0,a.$PG)(h.j,"chatParticipantAdditions");const u=new g.$0O(o,f),D=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(u);return d(D),this},filetree(o,f){t(this.filetree);const u=new g.$_O(o,f),D=w.ChatResponseFilesPart.from(u);return d(D),this},anchor(o,f){t(this.anchor);const u=new g.$aP(o,f),D=w.ChatResponseAnchorPart.from(u);return d(D),this},button(o){t(this.anchor);const f=new g.$cP(o),u=w.ChatResponseCommandButtonPart.from(f,h.m,h.n);return d(u),this},progress(o){t(this.progress);const f=new g.$bP(o),u=w.ChatResponseProgressPart.from(f);return d(u),this},reference(o,f){if(t(this.reference),"variableName"in o&&!o.value){const u=h.k.variables.variables.find(D=>D.name===o.variableName);if(u){let D;if(u.references?.length)D=u.references.map(l=>({kind:"reference",reference:{variableName:o.variableName,value:l.reference}}));else{const l=new g.$dP(o,f);D=[w.ChatResponseReferencePart.from(l)]}return D.forEach(l=>d(l)),this}}else{const u=new g.$dP(o,f),D=w.ChatResponseReferencePart.from(u);d(D)}return this},textEdit(o,f){t(this.textEdit),(0,a.$PG)(h.j,"chatParticipantAdditions");const u=new g.$eP(o,f),D=w.ChatResponseTextEditPart.from(u);return d(D),this},detectedParticipant(o,f){t(this.detectedParticipant),(0,a.$PG)(h.j,"chatParticipantAdditions");const u=new g.$$O(o,f),D=w.ChatResponseDetectedParticipantPart.from(u);return d(D),this},push(o){if(t(this.push),(o instanceof g.$eP||o instanceof g.$0O||o instanceof g.$$O)&&(0,a.$PG)(h.j,"chatParticipantAdditions"),o instanceof g.$dP)this.reference(o.value,o.iconPath);else{const f=w.ChatResponsePart.from(o,h.m,h.n);d(f)}return this}}}return this.g}}class n extends p.$Vc{constructor(h,t,d){super(),this.n=t,this.s=d,this.c=new Map,this.j=this.B(new p.$5c),this.m=this.B(new p.$Uc),this.g=h.getProxy(m.$0M.MainThreadChatAgents2)}transferActiveChat(h){this.g.$transferActiveChatSession(h)}createChatAgent(h,t,d){const o=n.b++,f=new i(h,t,this.g,o,d);return this.c.set(o,f),this.g.$registerAgent(o,h.identifier,t,{},void 0),f.apiAgent}createDynamicChatAgent(h,t,d,o,f){const u=n.b++,D=new i(h,t,this.g,u,f);return this.c.set(u,D),this.g.$registerAgent(u,h.identifier,t,{isSticky:!0},{name:d,description:o}),D.apiAgent}async $invokeAgent(h,t,d,o){const f=this.c.get(h);if(!f)throw new Error(`[CHAT](${h}) CANNOT invoke agent because the agent is not registered`);let u=this.j.get(t.sessionId);u||(u=new p.$Uc,this.j.set(t.sessionId,u));const D=new s(f.extension,t,this.g,this.s.converter,u);try{const l=await this.t(t.agentId,d),v=f.invoke(w.ChatAgentRequest.to(t),{history:l},D.apiObject,o);return await(0,A.$kh)(Promise.resolve(v).then(b=>{if(b?.metadata)try{JSON.stringify(b.metadata)}catch(P){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${P.message}`;return this.n.error(`[${f.extension.identifier.value}] [@${f.id}] ${k}`,f.extension),{errorDetails:{message:k},timings:D.timings}}return{errorDetails:b?.errorDetails,timings:D.timings,metadata:b?.metadata}}),o)}catch(l){return this.n.error(l,f.extension),{errorDetails:{message:(0,C.$hj)(l),responseIsIncomplete:!0}}}finally{D.close()}}async t(h,t){const d=[];for(const o of t.history){const f=w.ChatAgentResult.to(o.result),u=h===o.request.agentId?f:{...f,metadata:void 0};d.push(new g.$fP(o.request.message,o.request.command,o.request.variables.variables.map(w.ChatAgentResolvedVariable.to),o.request.agentId));const D=(0,y.$Hb)(o.response.map(l=>w.ChatResponsePart.toContent(l,this.s.converter)));d.push(new g.$gP(D,u,o.request.agentId,o.request.command))}return d}$releaseSession(h){this.j.deleteAndDispose(h)}async $provideFollowups(h,t,d,o,f){const u=this.c.get(t);if(!u)return Promise.resolve([]);const D=await this.t(u.id,o),l=w.ChatAgentResult.to(d);return(await u.provideFollowups(l,{history:D},f)).filter(v=>{const b=!v.participant||N.Iterable.some(this.c.values(),P=>P.id===v.participant&&S.$Sm.equals(P.extension.identifier,u.extension.identifier));return b||this.n.warn(`[@${u.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),b}).map(v=>w.ChatFollowup.from(v,h))}$acceptFeedback(h,t,d,o){const f=this.c.get(h);if(!f)return;const u=w.ChatAgentResult.to(t);let D;switch(d){case r.InteractiveSessionVoteDirection.Down:D=g.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:D=g.ChatResultFeedbackKind.Helpful;break}f.acceptFeedback(Object.freeze(o?{result:u,kind:D,reportIssue:o}:{result:u,kind:D}))}$acceptAction(h,t,d){const o=this.c.get(h);if(!o||d.action.kind==="vote")return;const f=w.ChatAgentUserActionEvent.to(t,d,this.s.converter);f&&o.acceptAction(Object.freeze(f))}async $invokeCompletionProvider(h,t,d){const o=this.c.get(h);return o?(await o.invokeCompletionProvider(t,d)).map(u=>w.ChatAgentCompletionItem.from(u,this.s.converter,this.m)):[]}async $provideWelcomeMessage(h,t,d){const o=this.c.get(h);if(o)return await o.provideWelcomeMessage(w.ChatLocation.to(t),d)}async $provideSampleQuestions(h,t,d){const o=this.c.get(h);if(o)return(await o.provideSampleQuestions(w.ChatLocation.to(t),d)).map(f=>w.ChatFollowup.from(f,void 0))}}e.$ulc=n,n.b=0;class i{constructor(h,t,d,o,f){this.extension=h,this.id=t,this.w=d,this.x=o,this.y=f,this.o=new O.$ee,this.p=new O.$ee}acceptFeedback(h){this.o.fire(h)}acceptAction(h){this.p.fire(h)}async invokeCompletionProvider(h,t){return this.s?await this.s.provider.provideCompletionItems(h,t)??[]:[]}async provideFollowups(h,t,d){if(!this.b)return[];const o=await this.b.provideFollowups(h,t,d);return o?o.filter(f=>!(f&&"commandId"in f)).filter(f=>!(f&&"message"in f)):[]}async provideWelcomeMessage(h,t){if(!this.t)return[];const d=await this.t.provideWelcomeMessage(h,t);return d?d.map(o=>typeof o=="string"?o:w.MarkdownString.from(o)):[]}async provideSampleQuestions(h,t){if(!this.t||!this.t.provideSampleQuestions)return[];const d=await this.t.provideSampleQuestions(h,t);return d||[]}get apiAgent(){let h=!1,t=!1;const d=()=>{h||t||(t=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{fullName:this.c,icon:this.d?this.d instanceof M.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof g.$9N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:w.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,requester:this.u}),t=!1}))},o=this;return{get id(){return o.id},get fullName(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.c??o.extension.displayName??o.extension.name},set fullName(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.c=f,d()},get iconPath(){return o.d},set iconPath(f){o.d=f,d()},get requestHandler(){return o.y},set requestHandler(f){(0,E.$gg)(typeof f=="function","Invalid request handler"),o.y=f},get followupProvider(){return o.b},set followupProvider(f){o.b=f,d()},get isDefault(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.g},set isDefault(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.g=f,d()},get helpTextPrefix(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.j},set helpTextPrefix(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.j=f,d()},get helpTextVariablesPrefix(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.k},set helpTextVariablesPrefix(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.k=f,d()},get helpTextPostfix(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.l},set helpTextPostfix(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.l=f,d()},get isSecondary(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.n},set isSecondary(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.n=f,d()},get sampleRequest(){return o.m},set sampleRequest(f){o.m=f,d()},get supportIssueReporting(){return(0,a.$PG)(o.extension,"chatParticipantAdditions"),o.q},set supportIssueReporting(f){(0,a.$PG)(o.extension,"chatParticipantAdditions"),o.q=f,d()},get onDidReceiveFeedback(){return o.o.event},set participantVariableProvider(f){if((0,a.$PG)(o.extension,"chatParticipantAdditions"),o.s=f,f){if(!f.triggerCharacters.length)throw new Error("triggerCharacters are required");o.w.$registerAgentCompletionsProvider(o.x,f.triggerCharacters)}else o.w.$unregisterAgentCompletionsProvider(o.x)},get participantVariableProvider(){return(0,a.$PG)(o.extension,"chatParticipantAdditions"),o.s},set welcomeMessageProvider(f){(0,a.$PG)(o.extension,"defaultChatParticipant"),o.t=f,d()},get welcomeMessageProvider(){return(0,a.$PG)(o.extension,"defaultChatParticipant"),o.t},onDidPerformAction:(0,a.$OG)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,set requester(f){o.u=f,d()},get requester(){return o.u},dispose(){h=!0,o.b=void 0,o.o.dispose(),o.w.$unregisterAgent(o.x)}}}invoke(h,t,d,o){return this.y(h,t,d,o)}}}),define(Ce[264],Ae([1,0,14,6,4,8,7,26]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class ${constructor(S){this.b=new Map,this.c=S.getProxy(C.$0M.MainThreadChatVariables)}async $resolveVariable(S,m,w,g){const r=this.b.get(S);if(r)try{if(r.resolver.resolve2){(0,p.$PG)(r.extension,"chatParticipantAdditions");const a=new E(m,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:w},a.apiObject,g);if(s)return s.map(O.ChatVariable.from)}else{const a=await r.resolver.resolve(r.data.name,{prompt:w},g);if(a)return a.map(O.ChatVariable.from)}}catch(a){(0,y.$2)(a)}}registerVariableResolver(S,m,w,g){const r=$.a++;return this.b.set(r,{extension:S,data:{name:m,description:w},resolver:g}),this.c.$registerVariable(r,{name:m,description:w}),(0,A.$Tc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$vlc=$,$.a=0;class E{constructor(S,m){this.c=S,this.d=m,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let m=function(g){if(S.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const S=this,w=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){m(this.progress);const r=new N.$bP(g),a=O.ChatResponseProgressPart.from(r);return w(a),this},reference(g){m(this.reference);const r=new N.$dP(g),a=O.ChatResponseReferencePart.from(r);return w(a),this},push(g){return m(this.push),g instanceof N.$dP?w(O.ChatResponseReferencePart.from(g)):g instanceof N.$bP&&w(O.ChatResponseProgressPart.from(g)),this}}}return this.b}}}),define(Ce[265],Ae([1,0,9,69,5,6,2,89,20,8,7,4,26]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=w;function w(g,r,a){const s=g.getProxy(S.$0M.MainThreadComments);class n{constructor(){this.b=new Map,this.c=new $.$Um,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const v=this.b.get(l.handle);return v?v.value:l}else if(l&&l.$mid===7){const v=l,b=this.b.get(v.commentControlHandle);if(!b)return v;const P=b.getCommentThread(v.commentThreadHandle);return P?P.value:v}else if(l&&(l.$mid===9||l.$mid===8)){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const b=v.getCommentThread(l.thread.commentThreadHandle);return b?l.$mid===8?b.value:{thread:b.value,text:l.text}:l}else if(l&&l.$mid===10){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const b=v.getCommentThread(l.thread.commentThreadHandle);if(!b)return l;const P=l.commentUniqueId,k=b.getCommentByUniqueId(P);return k||l}else if(l&&l.$mid===11){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const b=v.getCommentThread(l.thread.commentThreadHandle);if(!b)return l;const P=l.text,k=l.commentUniqueId,I=b.getCommentByUniqueId(k);return I?(typeof I.body=="string"?I.body=P:I.body=new M.$BN(P),I):l}return l}})}createCommentController(l,v,b){const P=n.a++,k=new c(l,P,v,b);this.b.set(k.handle,k);const I=this.c.get(l.identifier)||[];return I.push(k),this.c.set(l.identifier,I),k.value}async $createCommentThreadTemplate(l,v,b){const P=this.b.get(l);P&&P.$createCommentThreadTemplate(v,b)}async $setActiveComment(l,v){const b=this.b.get(l);b&&b.$setActiveComment(v??void 0)}async $updateCommentThreadTemplate(l,v,b){const P=this.b.get(l);P&&P.$updateCommentThreadTemplate(v,b)}$deleteCommentThread(l,v){this.b.get(l)?.$deleteCommentThread(v)}async $provideCommentingRanges(l,v,b){const P=this.b.get(l);if(!P||!P.commentingRangeProvider)return Promise.resolve(void 0);const k=await a.ensureDocumentData(N.URI.revive(v));return(0,y.$oh)(async()=>{const I=await P.commentingRangeProvider.provideCommentingRanges(k.document,b);let U;return Array.isArray(I)?U={ranges:I,fileComments:!1}:I?U={ranges:I.ranges||[],fileComments:I.fileComments||!1}:U=I??void 0,U}).then(I=>{let U;return I&&(U={ranges:I.ranges.map(Q=>E.Range.from(Q)),fileComments:I.fileComments}),U})}$toggleReaction(l,v,b,P,k){const I=this.b.get(l);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,y.$oh)(()=>{const U=I.getCommentThread(v);if(U){const Q=U.getCommentByUniqueId(P.uniqueIdInThread);if(I!==void 0&&Q&&I.reactionHandler)return I.reactionHandler(Q,d(k))}return Promise.resolve(void 0)})}}n.a=0;class i{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,m.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,v,b,P,k,I,U,Q){this.m=v,this.n=b,this.o=P,this.p=k,this.q=I,this.extensionDescription=U,this.r=Q,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Wc,this.l.value=new O.$Uc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(v,this.handle,this.n,this.o,E.Range.from(this.p),U.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{s.$deleteCommentThread(v,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(L){G.range=L},get comments(){return G.comments},set comments(L){G.comments=L},get collapsibleState(){return G.collapsibleState},set collapsibleState(L){G.collapsibleState=L},get canReply(){return G.canReply},set canReply(L){G.canReply=L},get contextValue(){return G.contextValue},set contextValue(L){G.contextValue=L},get label(){return G.label},set label(L){G.label=L},get state(){return G.state},set state(L){G.state=L},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Uc);const l=b=>Object.prototype.hasOwnProperty.call(this.b,b),v={};l("range")&&(v.range=E.Range.from(this.p)),l("label")&&(v.label=this.label),l("contextValue")&&(v.contextValue=this.contextValue??null),l("comments")&&(v.comments=this.q.map(b=>h(this,b,this.k,this.extensionDescription))),l("collapsibleState")&&(v.collapseState=o(this.g)),l("canReply")&&(v.canReply=this.canReply),l("state")&&(v.state=f(this.h)),l("applicability")&&(v.applicability=u(this.h)),l("isTemplate")&&(v.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(l){for(const v of this.k){const b=v[0],P=v[1];if(l===P)return b}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}i.a=0,Qe([(0,A.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,m.$PG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,m.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,m.$PG)(this.h,"activeComment"),this.f}constructor(l,v,b,P){this.h=l,this.i=v,this.j=b,this.k=P,this.a=new Map,s.$registerCommentController(this.handle,b,P,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(I){k.options=I},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(I){k.commentingRangeProvider=I},get reactionHandler(){return k.reactionHandler},set reactionHandler(I){k.reactionHandler=I},get activeCommentThread(){return k.activeCommentThread},createCommentThread(I,U,Q){return k.createCommentThread(I,U,Q).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,v,b){v===void 0&&(0,m.$PG)(this.h,"fileComments");const P=new i(this.id,this.handle,void 0,l,v,b,this.h,!1);return this.a.set(P.handle,P),P}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const v=this.a.get(l.commentThreadHandle);v&&(this.e=l.uniqueIdInThread?v.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=v)}$createCommentThreadTemplate(l,v){const b=new i(this.id,this.handle,void 0,N.URI.revive(l),E.Range.to(v),[],this.h,!0);return b.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(l,v){const b=this.a.get(l);b&&(b.range=E.Range.to(v))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(D,l,v,b){let P=v.get(l);return P||(P=++D.commentHandle,v.set(l,P)),l.state!==void 0&&(0,m.$PG)(b,"commentsDraftState"),l.reactions?.some(k=>k.reactors!==void 0)&&(0,m.$PG)(b,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:P,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(k=>t(k)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(D){return{label:D.label,iconPath:D.iconPath?E.$wP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(l=>l.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?N.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(l=>({name:l}))}}function o(D){if(D!==void 0)switch(D){case M.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function f(D){let l;if(typeof D=="object"?l=D.resolved:l=D,l!==void 0)switch(l){case M.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function u(D){let l;if(typeof D=="object"&&(l=D.applicability),l!==void 0)switch(l){case M.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case M.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Ce[266],Ae([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class w{constructor(d,o){this.document=d,this.b=o,this.a=1,this.c=new M.$flc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,o){await this.f(d).undo(),o||this.disposeBackup()}async redo(d,o){await this.f(d).redo(),o||this.disposeBackup()}disposeEdits(d){for(const o of d)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=h(this.document.uri)+this.a++;return(0,N.$0g)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const o=this.c.get(d,0);if(!o)throw new Error("No edit found");return o}}class g{constructor(){this.a=new Map}get(d,o){return this.a.get(this.b(d,o))}add(d,o,f){const u=this.b(d,o.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${d} resource:${o.uri}`);const D=new w(o,f);return this.a.set(u,D),D}delete(d,o){const f=this.b(d,o.uri);this.a.delete(f)}b(d,o){return`${d}@@@${o}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this.a=new Map}addTextProvider(d,o,f){return this.b(0,d,o,f)}addCustomProvider(d,o,f){return this.b(1,d,o,f)}get(d){return this.a.get(d)}b(d,o,f,u){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:d,extension:f,provider:u}),new m.$_M(()=>this.a.delete(o))}}class s{constructor(d,o,f,u,D){this.d=o,this.f=f,this.g=u,this.h=D,this.b=new a,this.c=new g,this.a=d.getProxy(S.$0M.MainThreadCustomEditors)}registerCustomEditorProvider(d,o,f,u){const D=new C.$Uc;return i(f)?(D.add(this.b.addTextProvider(o,d,f)),this.a.$registerTextEditorProvider((0,E.$Olc)(d),o,u.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,E.$Mlc)(d))):(D.add(this.b.addCustomProvider(o,d,f)),n(f)&&D.add(f.onDidChangeCustomDocument(l=>{const v=this.i(o,l.document.uri);if(c(l)){const b=v.addEdit(l);this.a.$onDidEdit(l.document.uri,o,b,l.label)}else this.a.$onContentChange(l.document.uri,o)})),this.a.$registerCustomEditorProvider((0,E.$Olc)(d),o,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,E.$Mlc)(d))),m.$_M.from(D,new m.$_M(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(d,o,f,u,D){const l=this.b.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${o}'`);const v=p.URI.revive(d),b=await l.provider.openCustomDocument(v,{backupId:f,untitledDocumentData:u?.buffer},D);let P;return n(l.provider)&&this.f&&(P=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(o,b,P),{editable:n(l.provider)}}async $disposeCustomDocument(d,o){const f=this.b.get(o);if(!f)throw new Error(`No provider found for '${o}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${o}'`);const u=p.URI.revive(d),{document:D}=this.i(o,u);this.c.delete(o,D),D.dispose()}async $resolveCustomEditor(d,o,f,u,D,l){const v=this.b.get(f);if(!v)throw new Error(`No provider found for '${f}'`);const b=$.ViewColumn.to(D),P=this.g.createNewWebview(o,u.contentOptions,v.extension),k=this.h.createNewWebviewPanel(o,f,u.title,b,u.options,P,u.active),I=p.URI.revive(d);switch(v.type){case 1:{const{document:U}=this.i(f,I);return v.provider.resolveCustomEditor(U,k,l)}case 0:{const U=this.d.getDocument(I);return v.provider.resolveCustomTextEditor(U,k,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,o,f){this.i(o,d).disposeEdits(f)}async $onMoveCustomEditor(d,o,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const D=this.h.getWebviewPanel(d);if(!D)throw new Error("No webview found");const l=p.URI.revive(o),v=this.d.getDocument(l);await u.provider.moveCustomTextEditor(v,D,y.CancellationToken.None)}async $undo(d,o,f,u){return this.i(o,d).undo(f,u)}async $redo(d,o,f,u){return this.i(o,d).redo(f,u)}async $revert(d,o,f){const u=this.i(o,d);await this.j(o).revertCustomDocument(u.document,f),u.disposeBackup()}async $onSave(d,o,f){const u=this.i(o,d);await this.j(o).saveCustomDocument(u.document,f),u.disposeBackup()}async $onSaveAs(d,o,f,u){const D=this.i(o,d);return this.j(o).saveCustomDocumentAs(D.document,p.URI.revive(f),u)}async $backup(d,o,f){const u=this.i(o,d),l=await this.j(o).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},f);return u.updateBackup(l),l.id}i(d,o){const f=this.c.get(d,p.URI.revive(o));if(!f)throw new Error("No custom document found");return f}j(d){const f=this.b.get(d)?.provider;if(!f||!n(f))throw new Error("Custom document is not editable");return f}}e.$Rlc=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const d=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,A.$kj)(d)+""}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[267],Ae([1,0,172,101,2,4,7,8,5,12,28,46]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";var m,w,g,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$mlc=void 0;class a{constructor(i,c,h,t,d,o,f,u){this.d=i,this.e=c,this.f=h,this.g=t,this.h=d,m.set(this,void 0),w.set(this,void 0),g.set(this,void 0),this.c=!1,this.f=Math.max(t,h),_e(this,g,new M.$Bc(D=>o.getComparisonKey(D)),"f"),_e(this,m,f,"f"),_e(this,w,u,"f")}dispose(){this.c||(Be(this,w,"f").fire([...Be(this,g,"f").keys()]),Be(this,m,"f")?.$clear(this.e),Be(this,g,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,c){if(!i){this.clear();return}this.j();let h=[];if(C.URI.isUri(i)){if(!c){this.delete(i);return}Be(this,g,"f").set(i,c.slice()),h=[i]}else if(Array.isArray(i)){h=[];let o;i=[...i].sort(a.k);for(const f of i){const[u,D]=f;if((!o||u.toString()!==o.toString())&&(o&&Be(this,g,"f").get(o).length===0&&Be(this,g,"f").delete(o),o=u,h.push(u),Be(this,g,"f").set(u,[])),D)Be(this,g,"f").get(u)?.push(...D);else{const l=Be(this,g,"f").get(u);l&&(l.length=0)}}}if(Be(this,w,"f").fire(h),!Be(this,m,"f"))return;const t=[];let d=0;for(const o of h){let f=[];const u=Be(this,g,"f").get(o);if(u)if(u.length>this.g){f=[];const D=[N.DiagnosticSeverity.Error,N.DiagnosticSeverity.Warning,N.DiagnosticSeverity.Information,N.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const v of u)if(v.severity===D[l]&&f.push({...p.Diagnostic.from(v),modelVersionId:this.h(o)})===this.g)break e;f.push({severity:A.MarkerSeverity.Info,message:(0,y.localize)(0,null,u.length-this.g),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=u.map(D=>({...p.Diagnostic.from(D),modelVersionId:this.h(o)}));if(t.push([o,f]),d+=f.length,d>this.f)break}Be(this,m,"f").$changeMany(this.e,t)}delete(i){this.j(),Be(this,w,"f").fire([i]),Be(this,g,"f").delete(i),Be(this,m,"f")?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),Be(this,w,"f").fire([...Be(this,g,"f").keys()]),Be(this,g,"f").clear(),Be(this,m,"f")?.$clear(this.e)}forEach(i,c){this.j();for(const[h,t]of this)i.call(c,h,t,this)}*[(m=new WeakMap,w=new WeakMap,g=new WeakMap,Symbol.iterator)](){this.j();for(const i of Be(this,g,"f").keys())yield[i,this.get(i)]}get(i){this.j();const c=Be(this,g,"f").get(i);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(i){return this.j(),Array.isArray(Be(this,g,"f").get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,c){return i[0].toString()<c[0].toString()?-1:i[0].toString()>c[0].toString()?1:0}}e.$mlc=a;let s=r=class{static _mapper(i){const c=new M.$Bc;for(const h of i)c.set(h,h);return{uris:Object.freeze(Array.from(c.values()))}}constructor(i,c,h,t){this.j=c,this.k=h,this.l=t,this.g=new Map,this.h=new $.$ie({merge:d=>d.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,r._mapper),this.f=i.getProxy(O.$0M.MainThreadDiagnostics)}createDiagnosticCollection(i,c){const{g:h,f:t,h:d,j:o,k:f,l:u}=this,D=new class{$changeMany(b,P){t.$changeMany(b,P),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,b,P.length===0?"CLEARING":P)}$clear(b){t.$clear(b),o.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,b)}dispose(){t.dispose()}};let l;if(!c)c="_generated_diagnostic_collection_name_#"+r.c++,l=c;else if(!h.has(c))l=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do l=c+r.c++;while(h.has(l))}return new class extends a{constructor(){super(c,l,r.e,r.d,b=>u.getDocument(b)?.version,f.extUri,D,d),h.set(l,this)}dispose(){super.dispose(),h.delete(l)}}}getDiagnostics(i){if(i)return this.m(i);{const c=new Map,h=[];for(const t of this.g.values())t.forEach((d,o)=>{let f=c.get(d.toString());typeof f>"u"&&(f=h.length,c.set(d.toString(),f),h.push([d,[]])),h[f][1]=h[f][1].concat(...o)});return h}}m(i){let c=[];for(const h of this.g.values())h.has(i)&&(c=c.concat(h.get(i)));return c}$acceptMarkersChange(i){if(!this.n){const c="_generated_mirror",h=new a(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(c,h),this.n=h}for(const[c,h]of i)this.n.set(C.URI.revive(c),h.map(p.Diagnostic.to))}};e.$nlc=s,s.c=0,s.d=1e3,s.e=1.1*r.d,e.$nlc=s=r=Qe([qe(1,E.$3j),qe(2,S.$llc)],s)}),define(Ce[268],Ae([1,0,2,14,7,8,200,35]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class ${constructor(M,S,m,w={timeout:1500,errors:3}){this.c=M,this.d=S,this.f=m,this.g=w,this.a=new N.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(M){return(S,m,w)=>{const r={dispose:this.a.push([S,m,M])};return Array.isArray(w)&&w.push(r),r}}async $participateInSave(M,S){const m=y.URI.revive(M);let w=!1;const g=setTimeout(()=>w=!0,this.g.timeout),r=[];try{for(const a of[...this.a]){if(w)break;const s=this.d.getDocument(m),n=await this.h(a,{document:s,reason:O.TextDocumentSaveReason.to(S)});r.push(n)}}finally{clearTimeout(g)}return r}h([M,S,m],w){const g=this.b.get(M);return typeof g=="number"&&g>this.g.errors?Promise.resolve(!1):this.i(m,M,S,w).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this.b.get(M);this.b.set(M,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(M,S,m,w){const g=[],r=Date.now(),{document:a,reason:s}=w,{version:n}=a,i=Object.freeze({document:a,reason:s,waitUntil(c){if(Object.isFrozen(g))throw(0,A.$8)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{S.apply(m,[i])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,h)=>{const t=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(g).then(d=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${M.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(d)}).catch(d=>{clearTimeout(t),h(d)})}).then(c=>{const h={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(d=>d instanceof C.$gN))for(const{newText:d,newEol:o,range:f}of t)h.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:f&&O.Range.from(f),text:d,eol:o&&O.EndOfLine.from(o)}});if(h.edits.length!==0)return n===a.version?this.f.$tryApplyWorkspaceEdit(new p.$Cw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$vmc=$}),define(Ce[269],Ae([1,0,5,6,2,4,113,8,15,25,7]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;class S{constructor(w,g){this.a=new y.$ee,this.b=new y.$ee,this.c=new y.$ee,this.d=new y.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.$Uc,this.h=new Map,this.f=w.getProxy(O.$0M.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(r=>{for(const a of r)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const a of r)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const g=this.g.getDocument(w);if(g)return g}getDocument(w){const g=this.getDocumentData(w);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this.g.getDocument(w);if(g)return Promise.resolve(g);let r=this.h.get(w.toString());return r||(r=this.f.$tryOpenDocument(w).then(a=>{this.h.delete(w.toString());const s=C.URI.revive(a);return(0,$.$hg)(this.g.getDocument(s))},a=>(this.h.delete(w.toString()),Promise.reject(a))),this.h.set(w.toString(),r)),r}createDocumentData(w){return this.f.$tryCreateDocument(w).then(g=>C.URI.revive(g))}$acceptModelLanguageChanged(w,g){const r=C.URI.revive(w),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(g),this.a.fire(a.document)}$acceptModelSaved(w){const g=C.URI.revive(w),r=this.g.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(w,g){const r=C.URI.revive(w),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,g,r){const a=C.URI.revive(w),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(g);let n;g.isUndoing?n=M.TextDocumentChangeReason.Undo:g.isRedoing&&(n=M.TextDocumentChangeReason.Redo),this.c.fire((0,E.$5n)({document:s.document,contentChanges:g.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(w,g){(0,N.$zP)(w,g)}}e.$olc=S}),define(Ce[67],Ae([1,0,270,5,15,2,3,4,17,8,7]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=void 0,e.$Slc=(0,N.$wi)("IExtHostEditorTabs");class S{constructor(a,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,s={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$WO(O.URI.revive(this.b.input.uri));case 2:return new M.$XO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new M.$YO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new M.$ZO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$1O(this.b.input.viewType);case 4:return new M.$2O(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$3O(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$4O;case 9:return new M.$5O(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$6O;case 11:return new M.$7O(this.b.input.diffEditors.map(a=>new M.$XO(O.URI.revive(a.original),O.URI.revive(a.modified))));default:return}}}class m{constructor(a,s){this.c=[],this.d="",this.b=a,this.e=s;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,s={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return E.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new S(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const s=this.c.find(n=>n.tabId===a.tabDto.id);if(!s)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(a.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(a){this.b=new A.$ee,this.c=new A.$ee,this.e=[],this.a=a.getProxy(p.$0M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,s={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,C.$hg)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,i)=>{const c=Array.isArray(n)?n:[n];return c.length?g(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(a){const s=new Set(this.e.map(o=>o.groupId)),n=new Set(a.map(o=>o.groupId)),i=(0,y.$F)(s,n),c=this.e.filter(o=>i.removed.includes(o.groupId)).map(o=>o.apiObject),h=[],t=[];this.e=a.map(o=>{const f=new m(o,()=>this.d);return i.added.includes(f.groupId)?h.push(f.apiObject):t.push(f.apiObject),f});const d=(0,C.$hg)(a.find(o=>o.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const s=this.e.find(n=>n.groupId===a.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const s=this.e.find(i=>i.groupId===a.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(s=>s.apiObject===a)}async i(a,s){const n=[];for(const i of a){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,s)}async j(a,s){const n=[];for(const i of a){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,s)}};e.$Tlc=w,e.$Tlc=w=Qe([qe(0,$.$xP)],w);function g(r){return r.tabs!==void 0}}),define(Ce[271],Ae([1,0,2,4,6,7,8,314,13,21,26,55]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class m{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const a=this.a.indexOf(r);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),a=[];let s,n,i=14,c=14;for(const h of r){let t=s?(0,$.$Af)(s,h):0;for(t===0?n=1:n=c;t<h.length;t++)t+1===h.length?(i=c,c=9):c+=1,a.push([n,h.toUpperCase().charCodeAt(t),c]),a.push([n,h.toLowerCase().charCodeAt(t),c]),n=c;s=h,c=i}a.push([9,58,10]),a.push([10,47,12]),this.b=new p.$x3(a)}}provideDocumentLinks(r){this.c();const a=[],s=p.$y3.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const i=N.DocumentLink.to(n);i.target&&a.push(i)}return a}}class w{constructor(r,a){this.i=a,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(A.$0M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,a,s,n={}){if(w.j(s),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(a),this.d.add(a),this.c.set(i,s);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,M.$PG)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,S.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,a,c,h).catch(d=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${a}`),console.error(d)});const t=s.onDidChangeFile(d=>{const o=[];for(const f of d){const{uri:u,type:D}=f;if(u.scheme!==a)continue;let l;switch(D){case O.FileChangeType.Changed:l=0;break;case O.FileChangeType.Created:l=1;break;case O.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:u,type:l})}this.a.$onFileSystemChange(i,o)});return(0,C.$Tc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:a,ctime:s,mtime:n,size:i,permissions:c}=r;return{type:a,ctime:s,mtime:n,size:i,permissions:c}}$stat(r,a){return Promise.resolve(this.l(r).stat(y.URI.revive(a))).then(s=>w.k(s))}$readdir(r,a){return Promise.resolve(this.l(r).readDirectory(y.URI.revive(a)))}$readFile(r,a){return Promise.resolve(this.l(r).readFile(y.URI.revive(a))).then(s=>E.$Ge.wrap(s))}$writeFile(r,a,s,n){return Promise.resolve(this.l(r).writeFile(y.URI.revive(a),s.buffer,n))}$delete(r,a,s){return Promise.resolve(this.l(r).delete(y.URI.revive(a),s))}$rename(r,a,s,n){return Promise.resolve(this.l(r).rename(y.URI.revive(a),y.URI.revive(s),n))}$copy(r,a,s,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(y.URI.revive(a),y.URI.revive(s),n))}$mkdir(r,a){return Promise.resolve(this.l(r).createDirectory(y.URI.revive(a)))}$watch(r,a,s,n){const i=this.l(r).watch(y.URI.revive(s),n);this.f.set(a,i)}$unwatch(r,a){const s=this.f.get(a);s&&(s.dispose(),this.f.delete(a))}$open(r,a,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(a),s))}$close(r,a){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(a))}$read(r,a,s,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Ge.alloc(n);return Promise.resolve(i.read(a,s,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,a,s,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(a,s,n.buffer,0,n.byteLength))}l(r){const a=this.c.get(r);if(!a){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return a}}e.$xmc=w}),define(Ce[272],Ae([1,0,5,37,2,4,8,7,43]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,g,r,a,s,n){this.a=Math.random(),this.b=new y.$ee,this.c=new y.$ee,this.d=new y.$ee,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,A.$qk)(s),c=typeof s=="string",h=n?.correlate,t=a(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(h&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const o of d.created){const f=C.URI.revive(o);i(f.fsPath)&&(!c||g.getWorkspaceFolder(f))&&this.b.fire(f)}if(!n?.ignoreChangeEvents)for(const o of d.changed){const f=C.URI.revive(o);i(f.fsPath)&&(!c||g.getWorkspaceFolder(f))&&this.c.fire(f)}if(!n?.ignoreDeleteEvents)for(const o of d.deleted){const f=C.URI.revive(o);i(f.fsPath)&&(!c||g.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=p.$_M.from(this.i(w,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(w,g,r,a,s){const n=p.$_M.from();if(typeof r=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return n;const i=w.getProxy(O.$0M.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(A.$mk)||r.pattern.includes(A.$nk))&&(c=!0);let h;return s&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(h=14,a?.ignoreChangeEvents&&(h&=-3),a?.ignoreCreateEvents&&(h&=-5),a?.ignoreDeleteEvents&&(h&=-9)),i.$watch(g.identifier.value,this.a,r.baseUri,{recursive:c,excludes:a?.excludes??[],filter:h},!!s),p.$_M.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(w){this.a=w,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(C.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(w,g,r){this.j=w,this.k=g,this.l=r,this.a=new y.$ee,this.b=new y.$ee,this.c=new y.$ee,this.d=new y.$ee,this.g=new y.$ge,this.h=new y.$ge,this.i=new y.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,g,r,a){return new E(this.j,w,g,this.a.event,N.GlobPattern.from(r),a)}$onFileEvent(w){this.a.fire(new M(w))}$onDidRunFileOperation(w,g){switch(w){case 2:this.b.fire(Object.freeze({files:g.map(r=>({oldUri:C.URI.revive(r.source),newUri:C.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(r=>C.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(r=>C.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,g){return(r,a,s)=>{const n=function(c){r.call(a,c)};return n.extension=w,g.event(n,void 0,s)}}async $onWillRunFileOperation(w,g,r,a){switch(w){case 2:return await this.n(this.g,{files:g.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))},r,a);case 1:return await this.n(this.i,{files:g.map(s=>C.URI.revive(s.target))},r,a);case 0:case 3:return await this.n(this.h,{files:g.map(s=>C.URI.revive(s.target))},r,a)}}async n(w,g,r,a){const s=new Set,n=[];if(await w.fireAsync(g,a,async(c,h)=>{const t=Date.now(),d=await Promise.resolve(c);d instanceof p.$jN&&(n.push([h.extension,d]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,c]of n){const{edits:h}=N.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$ymc=S}),define(Ce[273],Ae([1,0,18,9,24,14,91,6,25,66,13,15,2,30,315,89,98,174,20,8,7,26,76,4]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class o{constructor(j,V){this.d=j,this.e=V}async provideDocumentSymbols(j,V){const W=this.d.getDocument(j),q=await this.e.provideDocumentSymbols(W,V);if(!(0,y.$Kb)(q))return q[0]instanceof c.$tN?q.map(i.DocumentSymbol.from):o.f(q)}static f(j){j=j.slice(0).sort((q,_)=>{let oe=q.location.range.start.compareTo(_.location.range.start);return oe===0&&(oe=_.location.range.end.compareTo(q.location.range.end)),oe});const V=[],W=[];for(const q of j){const _={name:q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(q.kind),tags:q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:i.Range.from(q.location.range),selectionRange:i.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(_),V.push(_);break}const oe=W[W.length-1];if(w.$vt.containsRange(oe.range,_.range)&&!w.$vt.equalsRange(oe.range,_.range)){oe.children?.push(_),W.push(_);break}W.pop()}}return V}}class f{constructor(j,V,W,q,_,oe){this.f=j,this.g=V,this.h=W,this.j=q,this.k=_,this.l=oe,this.d=new t.$flc("CodeLens"),this.e=new Map}async provideCodeLenses(j,V){const W=this.f.getDocument(j),q=await this.h.provideCodeLenses(W,V);if(!q||V.isCancellationRequested)return;const _=this.d.add(q),oe=new p.$Uc;this.e.set(_,oe);const Ne={cacheId:_,lenses:[]};for(let Ve=0;Ve<q.length;Ve++)Ne.lenses.push({cacheId:[_,Ve],range:i.Range.from(q[Ve].range),command:this.g.toInternal(q[Ve].command,oe)});return Ne}async resolveCodeLens(j,V){const W=j.cacheId&&this.d.get(...j.cacheId);if(!W)return;let q;if(typeof this.h.resolveCodeLens!="function"||W.isResolved?q=W:q=await this.h.resolveCodeLens(W,V),q||(q=W),V.isCancellationRequested)return;const _=j.cacheId&&this.e.get(j.cacheId[0]);if(_){if(!q.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return j.command=this.g.toInternal(q.command,_),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function u(Ue){return Array.isArray(Ue)?Ue.map(i.DefinitionLink.from):Ue?[i.DefinitionLink.from(Ue)]:[]}class D{constructor(j,V){this.d=j,this.e=V}async provideDefinition(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideDefinition(q,_,W);return u(oe)}}class l{constructor(j,V){this.d=j,this.e=V}async provideDeclaration(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideDeclaration(q,_,W);return u(oe)}}class v{constructor(j,V){this.d=j,this.e=V}async provideImplementation(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideImplementation(q,_,W);return u(oe)}}class b{constructor(j,V){this.d=j,this.e=V}async provideTypeDefinition(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideTypeDefinition(q,_,W);return u(oe)}}class P{constructor(j,V){this.g=j,this.h=V,this.d=0,this.e=new Map}async provideHover(j,V,W,q){const _=this.g.getDocument(j),oe=i.Position.to(V);let Ne;if(W&&W.verbosityRequest){const tt=W.verbosityRequest.previousHover.id,it=this.e.get(tt);if(!it)throw new Error(`Hover with id ${tt} not found`);const nt={action:W.verbosityRequest.action,previousHover:it};Ne=await this.h.provideHover(_,oe,q,nt)}else Ne=await this.h.provideHover(_,oe,q);if(!Ne||(0,y.$Kb)(Ne.contents))return;Ne.range||(Ne.range=_.getWordRangeAtPosition(oe)),Ne.range||(Ne.range=new c.$bN(oe,oe));const Ve=i.Hover.from(Ne),Ke=this.d;if(this.e.size===P.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ke,Ne),this.d+=1,{...Ve,id:Ke}}releaseHover(j){this.e.delete(j)}}P.f=10;class k{constructor(j,V){this.d=j,this.e=V}async provideEvaluatableExpression(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideEvaluatableExpression(q,_,W);if(oe)return i.EvaluatableExpression.from(oe)}}class I{constructor(j,V){this.d=j,this.e=V}async provideInlineValues(j,V,W,q){const _=this.d.getDocument(j),oe=await this.e.provideInlineValues(_,i.Range.to(V),i.InlineValueContext.to(W),q);if(Array.isArray(oe))return oe.map(Ne=>i.InlineValue.from(Ne))}}class U{constructor(j,V){this.d=j,this.e=V}async provideDocumentHighlights(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideDocumentHighlights(q,_,W);if(Array.isArray(oe))return oe.map(i.DocumentHighlight.from)}}class Q{constructor(j,V){this.d=j,this.e=V}async provideMultiDocumentHighlights(j,V,W,q){const _=this.d.getDocument(j),oe=W.map(Ke=>this.d.getDocument(Ke)),Ne=i.Position.to(V),Ve=await this.e.provideMultiDocumentHighlights(_,Ne,oe,q);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class G{constructor(j,V){this.d=j,this.e=V}async provideLinkedEditingRanges(j,V,W){const q=this.d.getDocument(j),_=i.Position.to(V),oe=await this.e.provideLinkedEditingRanges(q,_,W);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,y.$Hb)(oe.ranges.map(i.Range.from)),wordPattern:oe.wordPattern}}}class L{constructor(j,V){this.d=j,this.e=V}async provideReferences(j,V,W,q){const _=this.d.getDocument(j),oe=i.Position.to(V),Ne=await this.e.provideReferences(_,oe,W,q);if(Array.isArray(Ne))return Ne.map(i.location.from)}}class R{constructor(j,V,W,q,_,oe,Ne){this.g=j,this.h=V,this.j=W,this.k=q,this.l=_,this.m=oe,this.n=Ne,this.e=new t.$flc("CodeAction"),this.f=new Map}async provideCodeActions(j,V,W,q){const _=this.g.getDocument(j),oe=g.$xt.isISelection(V)?i.Selection.to(V):i.Range.to(V),Ne=[];for(const nt of this.j.getDiagnostics(j))if(oe.intersection(nt.range)&&Ne.push(nt)>R.d)break;const Ve={diagnostics:Ne,only:W.only?new c.$vN(W.only):void 0,triggerKind:i.CodeActionTriggerKind.to(W.trigger)},Ke=await this.k.provideCodeActions(_,oe,Ve,q);if(!(0,y.$Lb)(Ke)||q.isCancellationRequested)return;const Ye=this.e.add(Ke),tt=new p.$Uc;this.f.set(Ye,tt);const it=[];for(let nt=0;nt<Ke.length;nt++){const st=Ke[nt];if(st)if(R.o(st))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:st.title,command:this.h.toInternal(st,tt)});else{Ve.only&&(st.kind?Ve.only.contains(st.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${st.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ut=st.ranges??[];it.push({cacheId:[Ye,nt],title:st.title,command:st.command&&this.h.toInternal(st.command,tt),diagnostics:st.diagnostics&&st.diagnostics.map(i.Diagnostic.from),edit:st.edit&&i.WorkspaceEdit.from(st.edit,void 0),kind:st.kind&&st.kind.value,isPreferred:st.isPreferred,isAI:(0,h.$OG)(this.m,"codeActionAI")?st.isAI:!1,ranges:(0,h.$OG)(this.m,"codeActionRanges")?(0,y.$Hb)(ut.map(i.Range.from)):void 0,disabled:st.disabled?.reason})}}return{cacheId:Ye,actions:it}}async resolveCodeAction(j,V){const[W,q]=j,_=this.e.get(W,q);if(!_||R.o(_))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(_,V)??_;let Ne;oe.edit&&(Ne=i.WorkspaceEdit.from(oe.edit,void 0));let Ve;if(oe.command){const Ke=this.f.get(W);Ke&&(Ve=this.h.toInternal(oe.command,Ke))}return{edit:Ne,command:Ve}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}R.d=1e3;class F{constructor(j,V,W,q,_){this.e=j,this.f=V,this.g=W,this.h=q,this.j=_,this.d=new t.$flc("DocumentPasteEdit")}async prepareDocumentPaste(j,V,W,q){if(!this.g.prepareDocumentPaste)return;const _=this.f.getDocument(j),oe=V.map(Ke=>i.Range.to(Ke)),Ne=i.DataTransfer.toDataTransfer(W,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(_,oe,Ne,q),q.isCancellationRequested)return;const Ve=Array.from(Ne).filter(([,Ke])=>!(Ke instanceof c.$2N));return i.DataTransfer.from(Ve)}async providePasteEdits(j,V,W,q,_,oe){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(V),Ve=W.map(it=>i.Range.to(it)),Ke=i.DataTransfer.toDataTransfer(q,async it=>(await this.e.$resolvePasteFileData(this.h,j,it)).buffer),Ye=await this.g.provideDocumentPasteEdits(Ne,Ve,Ke,{only:_.only?new c.$7N(_.only):void 0,triggerKind:_.triggerKind},oe);if(!Ye||oe.isCancellationRequested)return[];const tt=this.d.add(Ye);return Ye.map((it,nt)=>({_cacheId:[tt,nt],title:it.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:it.kind,yieldTo:it.yieldTo?.map(st=>st.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,V){const[W,q]=j,_=this.d.get(W,q);if(!_||!this.g.resolveDocumentPasteEdit)return{};const oe=await this.g.resolveDocumentPasteEdit(_,V)??_;return{additionalEdit:oe.additionalEdit?i.WorkspaceEdit.from(oe.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class T{constructor(j,V){this.d=j,this.e=V}async provideDocumentFormattingEdits(j,V,W){const q=this.d.getDocument(j),_=await this.e.provideDocumentFormattingEdits(q,V,W);if(Array.isArray(_))return _.map(i.TextEdit.from)}}class X{constructor(j,V){this.d=j,this.e=V}async provideDocumentRangeFormattingEdits(j,V,W,q){const _=this.d.getDocument(j),oe=i.Range.to(V),Ne=await this.e.provideDocumentRangeFormattingEdits(_,oe,W,q);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,V,W,q){(0,S.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(j),oe=V.map(i.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(_,oe,W,q);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}}class ne{constructor(j,V){this.d=j,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,V,W,q,_){const oe=this.d.getDocument(j),Ne=i.Position.to(V),Ve=await this.e.provideOnTypeFormattingEdits(oe,Ne,W,q,_);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class me{constructor(j,V){this.e=j,this.f=V,this.d=new t.$flc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,V){const W=await this.e.provideWorkspaceSymbols(j,V);if(!(0,y.$Lb)(W))return{symbols:[]};const q=this.d.add(W),_={cacheId:q,symbols:[]};for(let oe=0;oe<W.length;oe++){const Ne=W[oe];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}_.symbols.push({...i.WorkspaceSymbol.from(Ne),cacheId:[q,oe]})}return _}async resolveWorkspaceSymbol(j,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const W=this.d.get(...j.cacheId);if(W){const q=await this.e.resolveWorkspaceSymbol(W,V);return q&&(0,$.$7n)(j,i.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class we{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,V,W){this.d=j,this.e=V,this.f=W}async provideRenameEdits(j,V,W,q){const _=this.d.getDocument(j),oe=i.Position.to(V);try{const Ne=await this.e.provideRenameEdits(_,oe,W,q);return Ne?i.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ve=we.g(Ne);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(j,V,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(j),_=i.Position.to(V);try{const oe=await this.e.prepareRename(q,_,W);let Ne,Ve;if(c.$bN.isRange(oe)?(Ne=oe,Ve=q.getText(oe)):(0,S.$$f)(oe)&&(Ne=oe.range,Ve=oe.placeholder),!Ne||!Ve)return;if(Ne.start.line>_.line||Ne.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ne),text:Ve}}catch(oe){const Ne=we.g(oe);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(oe)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class de{constructor(j,V,W){this.e=j,this.f=V,this.g=W}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,V,W,q){const _=this.e.getDocument(j),oe=i.Range.to(V);try{const Ne=de.d[W],Ve=await this.f.provideNewSymbolNames(_,oe,Ne,q);return Ve?Ve.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ne){this.g.error(de.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}de.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic};class $e{constructor(j,V){this.resultId=j,this.tokens=V}}class ke{constructor(j,V){this.f=j,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,V,W){const q=this.f.getDocument(j),_=V!==0?this.d.get(V):null;let oe=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,_.resultId,W):await this.g.provideDocumentSemanticTokens(q,W);return _&&this.d.delete(V),oe?(oe=ke.h(oe),this.o(ke.n(_,oe),oe)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return ke.j(j)?ke.k(j)?j:new c.$uO(new Uint32Array(j.data),j.resultId):ke.l(j)?ke.m(j)?j:new c.$wO(j.edits.map(V=>new c.$vO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const V of j.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(j,V){if(!ke.j(V)||!j||!j.tokens)return V;const W=j.tokens,q=W.length,_=V.data,oe=_.length;let Ne=0;const Ve=Math.min(q,oe);for(;Ne<Ve&&W[Ne]===_[Ne];)Ne++;if(Ne===q&&Ne===oe)return new c.$wO([],V.resultId);let Ke=0;const Ye=Ve-Ne;for(;Ke<Ye&&W[q-Ke-1]===_[oe-Ke-1];)Ke++;return new c.$wO([{start:Ne,deleteCount:q-Ne-Ke,data:_.subarray(Ne,oe-Ke)}],V.resultId)}o(j,V){if(ke.j(j)){const W=this.e++;return this.d.set(W,new $e(j.resultId,j.data)),(0,a.$dcb)({id:W,type:"full",data:j.data})}if(ke.l(j)){const W=this.e++;return ke.j(V)?this.d.set(W,new $e(V.resultId,V.data)):this.d.set(W,new $e(j.resultId)),(0,a.$dcb)({id:W,type:"delta",deltas:(j.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class se{constructor(j,V){this.d=j,this.e=V}async provideDocumentRangeSemanticTokens(j,V,W){const q=this.d.getDocument(j),_=await this.e.provideDocumentRangeSemanticTokens(q,i.Range.to(V),W);return _?this.f(_):null}f(j){return(0,a.$dcb)({id:0,type:"full",data:j.data})}}class Pe{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,V,W,q,_){this.f=j,this.g=V,this.h=W,this.j=q,this.k=_,this.d=new t.$flc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,V,W,q){const _=this.f.getDocument(j),oe=i.Position.to(V),Ne=_.getWordRangeAtPosition(oe)||new c.$bN(oe,oe),Ve=Ne.with({end:oe}),Ke=new E.$ae,Ye=await this.h.provideCompletionItems(_,oe,q,i.CompletionContext.to(W));if(!Ye||q.isCancellationRequested)return;const tt=Array.isArray(Ye)?new c.$IN(Ye):Ye,it=Pe.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),nt=new p.$Uc;this.e.set(it,nt);const st=[],ut={x:it,b:st,a:{replace:i.Range.from(Ne),insert:i.Range.from(Ve)},c:tt.isIncomplete||void 0,d:Ke.elapsed()};for(let $t=0;$t<tt.items.length;$t++){const je=tt.items[$t],ct=this.l(je,[it,$t],Ve,Ne);st.push(ct)}return ut}async resolveCompletionItem(j,V){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...j);if(!W)return;const q=this.l(W,j),_=await this.h.resolveCompletionItem(W,V);if(!_)return;const oe=this.l(_,j);return(q.h!==oe.h||q.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==oe.n||q.o!==oe.o||!(0,$.$8n)(q.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,V,W,q){const _=this.e.get(V[0]);if(!_)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(j.command,_),Ne={x:V,a:j.label,b:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(i.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=j.textEdit.newText):typeof j.insertText=="string"?Ne.h=j.insertText:j.insertText instanceof c.$kN&&(Ne.h=j.insertText.value,Ne.i|=4);let Ve;return j.textEdit?Ve=j.textEdit.range:j.range&&(Ve=j.range),c.$bN.isRange(Ve)?Ne.j=i.Range.from(Ve):Ve&&(!W?.isEqual(Ve.inserting)||!q?.isEqual(Ve.replacing))&&(Ne.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Ne}}class re{async provideInlineCompletions(j,V,W,q){}disposeCompletions(j){}handleDidShowCompletionItem(j,V,W){}handlePartialAccept(j,V,W,q){}}class H extends re{constructor(j,V,W,q){super(),this.f=j,this.g=V,this.h=W,this.j=q,this.d=new Fe,this.e=(0,h.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,V,W,q){const _=this.g.getDocument(j),oe=i.Position.to(V),Ne=await this.h.provideInlineCompletionItems(_,oe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:i.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},q);if(!Ne||q.isCancellationRequested)return;const Ve=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],Ye=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ve}),items:Ve.map((nt,st)=>{let ut;nt.command&&(tt||(tt=new p.$Uc),ut=this.j.toInternal(nt.command,tt));const $t=nt.insertText;return{insertText:typeof $t=="string"?$t:{snippet:$t.value},filterText:nt.filterText,range:nt.range?i.Range.from(nt.range):void 0,command:ut,idx:st,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(tt||(tt=new p.$Uc),this.j.toInternal(nt,tt))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,V,W){const q=this.d.get(j)?.items[V];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q,W)}handlePartialAccept(j,V,W,q){const _=this.d.get(j)?.items[V];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(_,W),this.h.handleDidPartiallyAcceptCompletionItem(_,i.PartialAcceptInfo.to(q)))}}class he{async provideInlineEdits(j,V,W){const q=this.f.getDocument(j),_=await this.g.provideInlineEdit(q,{triggerKind:this.e[V.triggerKind]},W);if(!_||W.isCancellationRequested)return;let oe;const Ne=this.d.createReferenceId({dispose(){oe?.dispose()},item:_});let Ve;_.accepted&&(oe||(oe=new p.$Uc),Ve=this.h.toInternal(_.accepted,oe));let Ke;return _.rejected&&(oe||(oe=new p.$Uc),Ke=this.h.toInternal(_.rejected,oe)),{pid:Ne,text:_.text,range:i.Range.from(_.range),accepted:Ve,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,V,W,q){this.f=V,this.g=W,this.h=q,this.d=new Fe,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class Fe{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const V=this.e++;return this.d.set(V,j),V}disposeReferenceId(j){const V=this.d.get(j);return this.d.delete(j),V}get(j){return this.d.get(j)}}class pe{constructor(j,V){this.e=j,this.f=V,this.d=new t.$flc("SignatureHelp")}async provideSignatureHelp(j,V,W,q){const _=this.e.getDocument(j),oe=i.Position.to(V),Ne=this.g(W),Ve=await this.f.provideSignatureHelp(_,oe,q,Ne);if(Ve){const Ke=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ke}}}g(j){let V;if(j.activeSignatureHelp){const W=i.SignatureHelp.to(j.activeSignatureHelp),q=this.d.get(j.activeSignatureHelp.id,0);q?(V=q,V.activeSignature=W.activeSignature,V.activeParameter=W.activeParameter):V=W}return{...j,activeSignatureHelp:V}}releaseSignatureHelp(j){this.d.delete(j)}}class be{constructor(j,V,W,q,_){this.f=j,this.g=V,this.h=W,this.j=q,this.k=_,this.d=new t.$flc("InlayHints"),this.e=new Map}async provideInlayHints(j,V,W){const q=this.f.getDocument(j),_=i.Range.to(V),oe=await this.h.provideInlayHints(q,_,W);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(W.isCancellationRequested)return;const Ne=this.d.add(oe);this.e.set(Ne,new p.$Uc);const Ve={hints:[],cacheId:Ne};for(let Ke=0;Ke<oe.length;Ke++)this.l(oe[Ke],_)&&Ve.hints.push(this.m(oe[Ke],[Ne,Ke]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ve}async resolveInlayHint(j,V){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...j);if(!W)return;const q=await this.h.resolveInlayHint(W,V);if(q&&this.l(q))return this.m(q,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,V){return j.label.length===0||Array.isArray(j.label)&&j.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(V&&!V.contains(j.position))}m(j,V){const W=this.e.get(V[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")q.label=j.label;else{const _=[];q.label=_;for(const oe of j.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:oe.value,tooltip:i.MarkdownString.fromStrict(oe.tooltip)};c.$lN.isLocation(oe.location)&&(Ne.location=i.location.from(oe.location)),oe.command&&(Ne.command=this.g.toInternal(oe.command,W)),_.push(Ne)}}return q}}class ge{constructor(j,V){this.e=j,this.f=V,this.d=new t.$flc("DocumentLink")}async provideLinks(j,V){const W=this.e.getDocument(j),q=await this.f.provideDocumentLinks(W,V);if(!(!Array.isArray(q)||q.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(ge.g).map(i.DocumentLink.from)};{const _=this.d.add(q),oe={links:[],cacheId:_};for(let Ne=0;Ne<q.length;Ne++){if(!ge.g(q[Ne]))continue;const Ve=i.DocumentLink.from(q[Ne]);Ve.cacheId=[_,Ne],oe.links.push(Ve)}return oe}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,V){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...j);if(!W)return;const q=await this.f.resolveDocumentLink(W,V);if(!(!q||!ge.g(q)))return i.DocumentLink.from(q)}releaseLinks(j){this.d.delete(j)}}class ae{constructor(j,V){this.d=j,this.e=V}async provideColors(j,V){const W=this.d.getDocument(j),q=await this.e.provideDocumentColors(W,V);return Array.isArray(q)?q.map(oe=>({color:i.Color.from(oe.color),range:i.Range.from(oe.range)})):[]}async provideColorPresentations(j,V,W){const q=this.d.getDocument(j),_=i.Range.to(V.range),oe=i.Color.to(V.color),Ne=await this.e.provideColorPresentations(oe,{document:q,range:_},W);if(Array.isArray(Ne))return Ne.map(i.ColorPresentation.from)}}class K{constructor(j,V){this.d=j,this.e=V}async provideFoldingRanges(j,V,W){const q=this.d.getDocument(j),_=await this.e.provideFoldingRanges(q,V,W);if(Array.isArray(_))return _.map(i.FoldingRange.from)}}class Z{constructor(j,V,W){this.d=j,this.e=V,this.f=W}async provideSelectionRanges(j,V,W){const q=this.d.getDocument(j),_=V.map(i.Position.to),oe=await this.e.provideSelectionRanges(q,_,W);if(!(0,y.$Lb)(oe))return[];if(oe.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ve=0;Ve<_.length;Ve++){const Ke=[];Ne.push(Ke);let Ye=_[Ve],tt=oe[Ve];for(;;){if(!tt.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(tt)),!tt.parent)break;Ye=tt.range,tt=tt.parent}}return Ne}}class fe{constructor(j,V){this.f=j,this.g=V,this.d=new N.$CP(""),this.e=new Map}async prepareSession(j,V,W){const q=this.f.getDocument(j),_=i.Position.to(V),oe=await this.g.prepareCallHierarchy(q,_,W);if(!oe)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(oe)?oe.map(Ve=>this.h(Ne,Ve)):[this.h(Ne,oe)]}async provideCallsTo(j,V,W){const q=this.j(j,V);if(!q)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(q,W);if(_)return _.map(oe=>({from:this.h(j,oe.from),fromRanges:oe.fromRanges.map(Ne=>i.Range.from(Ne))}))}async provideCallsFrom(j,V,W){const q=this.j(j,V);if(!q)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(q,W);if(_)return _.map(oe=>({to:this.h(j,oe.to),fromRanges:oe.fromRanges.map(Ne=>i.Range.from(Ne))}))}releaseSession(j){this.e.delete(j)}h(j,V){const W=this.e.get(j),q=i.CallHierarchyItem.from(V,j,W.size.toString(36));return W.set(q._itemId,V),q}j(j,V){return this.e.get(j)?.get(V)}}class le{constructor(j,V){this.f=j,this.g=V,this.d=new N.$CP(""),this.e=new Map}async prepareSession(j,V,W){const q=this.f.getDocument(j),_=i.Position.to(V),oe=await this.g.prepareTypeHierarchy(q,_,W);if(!oe)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(oe)?oe.map(Ve=>this.h(Ne,Ve)):[this.h(Ne,oe)]}async provideSupertypes(j,V,W){const q=this.j(j,V);if(!q)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(q,W);if(_)return _.map(oe=>this.h(j,oe))}async provideSubtypes(j,V,W){const q=this.j(j,V);if(!q)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(q,W);if(_)return _.map(oe=>this.h(j,oe))}releaseSession(j){this.e.delete(j)}h(j,V){const W=this.e.get(j),q=i.TypeHierarchyItem.from(V,j,W.size.toString(36));return W.set(q._itemId,V),q}j(j,V){return this.e.get(j)?.get(V)}}class Me{constructor(j,V,W,q,_){this.e=j,this.f=V,this.g=W,this.h=q,this.j=_,this.d=new t.$flc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,V,W,q,_){const oe=this.f.getDocument(V),Ne=i.Position.to(W),Ve=i.DataTransfer.toDataTransfer(q,async it=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,it)).buffer),Ke=await this.g.provideDocumentDropEdits(oe,Ne,Ve,_);if(!Ke)return;const Ye=(0,y.$3b)(Ke),tt=this.d.add(Ye);return Ye.map((it,nt)=>({_cacheId:[tt,nt],title:it.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(st=>st.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,V){const[W,q]=j,_=this.d.get(W,q);if(!_||!this.g.resolveDocumentDropEdit)return{};const oe=await this.g.resolveDocumentDropEdit(_,V)??_;return{additionalEdit:oe.additionalEdit?i.WorkspaceEdit.from(oe.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class ve{constructor(j,V){this.d=j,this.e=V}async provideMappedEdits(j,V,W,q){const _=m.URI.revive(j),oe=this.d.getDocument(_),Ne=W.documents.map(Ye=>Ye.map(tt=>({uri:m.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(it=>i.Range.to(it))}))),Ve={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(oe,V,Ve,q);return Ke?i.WorkspaceEdit.from(Ke):null}}class Re{constructor(j,V){this.adapter=j,this.extension=V}}class Oe{constructor(j,V,W,q,_,oe,Ne,Ve){this.g=V,this.h=W,this.j=q,this.k=_,this.l=oe,this.m=Ne,this.n=Ve,this.f=new Map,this.e=j.getProxy(d.$0M.MainThreadLanguageFeatures)}o(j,V){return i.DocumentSelector.from(j,this.g,V)}p(j){return new c.$_M(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Oe.d++}async s(j,V,W,q,_,oe=!1){const Ne=this.f.get(j);if(!Ne||!(Ne.adapter instanceof V))return q;const Ve=Date.now();oe||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const Ke=W(Ne.adapter,Ne.extension);return Promise.resolve(Ke).catch(Ye=>{(0,O.$4)(Ye)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Ne.extension.identifier,Ye))}).finally(()=>{oe||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),C.CancellationToken.isCancellationToken(_)?(0,A.$lh)(Ke,_):Ke}t(j,V){const W=this.q();return this.f.set(W,new Re(j,V)),W}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,V,W,q){const _=this.t(new o(this.h,W),j),oe=q&&q.label||Oe.u(j);return this.e.$registerDocumentSymbolProvider(_,this.o(V,j),oe),this.p(_)}$provideDocumentSymbols(j,V,W){return this.s(j,o,q=>q.provideDocumentSymbols(m.URI.revive(V),W),void 0,W)}registerCodeLensProvider(j,V,W){const q=this.q(),_=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new Re(new f(this.h,this.j.converter,W,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(q,this.o(V,j),_);let oe=this.p(q);if(_!==void 0){const Ne=W.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(_));oe=c.$_M.from(oe,Ne)}return oe}$provideCodeLenses(j,V,W){return this.s(j,f,q=>q.provideCodeLenses(m.URI.revive(V),W),void 0,W)}$resolveCodeLens(j,V,W){return this.s(j,f,q=>q.resolveCodeLens(V,W),void 0,void 0)}$releaseCodeLenses(j,V){this.s(j,f,W=>Promise.resolve(W.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(j,V,W){const q=this.t(new D(this.h,W),j);return this.e.$registerDefinitionSupport(q,this.o(V,j)),this.p(q)}$provideDefinition(j,V,W,q){return this.s(j,D,_=>_.provideDefinition(m.URI.revive(V),W,q),[],q)}registerDeclarationProvider(j,V,W){const q=this.t(new l(this.h,W),j);return this.e.$registerDeclarationSupport(q,this.o(V,j)),this.p(q)}$provideDeclaration(j,V,W,q){return this.s(j,l,_=>_.provideDeclaration(m.URI.revive(V),W,q),[],q)}registerImplementationProvider(j,V,W){const q=this.t(new v(this.h,W),j);return this.e.$registerImplementationSupport(q,this.o(V,j)),this.p(q)}$provideImplementation(j,V,W,q){return this.s(j,v,_=>_.provideImplementation(m.URI.revive(V),W,q),[],q)}registerTypeDefinitionProvider(j,V,W){const q=this.t(new b(this.h,W),j);return this.e.$registerTypeDefinitionSupport(q,this.o(V,j)),this.p(q)}$provideTypeDefinition(j,V,W,q){return this.s(j,b,_=>_.provideTypeDefinition(m.URI.revive(V),W,q),[],q)}registerHoverProvider(j,V,W,q){const _=this.t(new P(this.h,W),j);return this.e.$registerHoverProvider(_,this.o(V,j)),this.p(_)}$provideHover(j,V,W,q,_){return this.s(j,P,oe=>oe.provideHover(m.URI.revive(V),W,q,_),void 0,_)}$releaseHover(j,V){this.s(j,P,W=>Promise.resolve(W.releaseHover(V)),void 0,void 0)}registerEvaluatableExpressionProvider(j,V,W,q){const _=this.t(new k(this.h,W),j);return this.e.$registerEvaluatableExpressionProvider(_,this.o(V,j)),this.p(_)}$provideEvaluatableExpression(j,V,W,q){return this.s(j,k,_=>_.provideEvaluatableExpression(m.URI.revive(V),W,q),void 0,q)}registerInlineValuesProvider(j,V,W,q){const _=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new I(this.h,W),j);this.e.$registerInlineValuesProvider(oe,this.o(V,j),_);let Ne=this.p(oe);if(_!==void 0){const Ve=W.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(_));Ne=c.$_M.from(Ne,Ve)}return Ne}$provideInlineValues(j,V,W,q,_){return this.s(j,I,oe=>oe.provideInlineValues(m.URI.revive(V),W,q,_),void 0,_)}registerDocumentHighlightProvider(j,V,W){const q=this.t(new U(this.h,W),j);return this.e.$registerDocumentHighlightProvider(q,this.o(V,j)),this.p(q)}registerMultiDocumentHighlightProvider(j,V,W){const q=this.t(new Q(this.h,W),j);return this.e.$registerMultiDocumentHighlightProvider(q,this.o(V,j)),this.p(q)}$provideDocumentHighlights(j,V,W,q){return this.s(j,U,_=>_.provideDocumentHighlights(m.URI.revive(V),W,q),void 0,q)}$provideMultiDocumentHighlights(j,V,W,q,_){return this.s(j,Q,oe=>oe.provideMultiDocumentHighlights(m.URI.revive(V),W,q.map(Ne=>m.URI.revive(Ne)),_),void 0,_)}registerLinkedEditingRangeProvider(j,V,W){const q=this.t(new G(this.h,W),j);return this.e.$registerLinkedEditingRangeProvider(q,this.o(V,j)),this.p(q)}$provideLinkedEditingRanges(j,V,W,q){return this.s(j,G,async _=>{const oe=await _.provideLinkedEditingRanges(m.URI.revive(V),W,q);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Oe.w(oe.wordPattern):void 0}},void 0,q)}registerReferenceProvider(j,V,W){const q=this.t(new L(this.h,W),j);return this.e.$registerReferenceSupport(q,this.o(V,j)),this.p(q)}$provideReferences(j,V,W,q,_){return this.s(j,L,oe=>oe.provideReferences(m.URI.revive(V),W,q,_),void 0,_)}registerCodeActionProvider(j,V,W,q){const _=new p.$Uc,oe=this.t(new R(this.h,this.j.converter,this.k,W,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(oe,this.o(V,j),{providedKinds:q?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:q?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,_)}))},Oe.u(j),!!W.resolveCodeAction),_.add(this.p(oe)),_}$provideCodeActions(j,V,W,q,_){return this.s(j,R,oe=>oe.provideCodeActions(m.URI.revive(V),W,q,_),void 0,_)}$resolveCodeAction(j,V,W){return this.s(j,R,q=>q.resolveCodeAction(V,W),{},void 0)}$releaseCodeActions(j,V){this.s(j,R,W=>Promise.resolve(W.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(j,V,W){const q=this.t(new T(this.h,W),j);return this.e.$registerDocumentFormattingSupport(q,this.o(V,j),j.identifier,j.displayName||j.name),this.p(q)}$provideDocumentFormattingEdits(j,V,W,q){return this.s(j,T,_=>_.provideDocumentFormattingEdits(m.URI.revive(V),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(j,V,W){const q=typeof W.provideDocumentRangesFormattingEdits=="function",_=this.t(new X(this.h,W),j);return this.e.$registerRangeFormattingSupport(_,this.o(V,j),j.identifier,j.displayName||j.name,q),this.p(_)}$provideDocumentRangeFormattingEdits(j,V,W,q,_){return this.s(j,X,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(V),W,q,_),void 0,_)}$provideDocumentRangesFormattingEdits(j,V,W,q,_){return this.s(j,X,oe=>oe.provideDocumentRangesFormattingEdits(m.URI.revive(V),W,q,_),void 0,_)}registerOnTypeFormattingEditProvider(j,V,W,q){const _=this.t(new ne(this.h,W),j);return this.e.$registerOnTypeFormattingSupport(_,this.o(V,j),q,j.identifier),this.p(_)}$provideOnTypeFormattingEdits(j,V,W,q,_,oe){return this.s(j,ne,Ne=>Ne.provideOnTypeFormattingEdits(m.URI.revive(V),W,q,_,oe),void 0,oe)}registerWorkspaceSymbolProvider(j,V){const W=this.t(new me(V,this.l),j);return this.e.$registerNavigateTypeSupport(W,typeof V.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(j,V,W){return this.s(j,me,q=>q.provideWorkspaceSymbols(V,W),{symbols:[]},W)}$resolveWorkspaceSymbol(j,V,W){return this.s(j,me,q=>q.resolveWorkspaceSymbol(V,W),void 0,void 0)}$releaseWorkspaceSymbols(j,V){this.s(j,me,W=>W.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(j,V,W){const q=this.t(new we(this.h,W,this.l),j);return this.e.$registerRenameSupport(q,this.o(V,j),we.supportsResolving(W)),this.p(q)}$provideRenameEdits(j,V,W,q,_){return this.s(j,we,oe=>oe.provideRenameEdits(m.URI.revive(V),W,q,_),void 0,_)}$resolveRenameLocation(j,V,W,q){return this.s(j,we,_=>_.resolveRenameLocation(m.URI.revive(V),W,q),void 0,q)}registerNewSymbolNamesProvider(j,V,W){const q=this.t(new de(this.h,W,this.l),j);return this.e.$registerNewSymbolNamesProvider(q,this.o(V,j)),this.p(q)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,de,V=>V.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,V,W,q,_){return this.s(j,de,oe=>oe.provideNewSymbolNames(m.URI.revive(V),W,q,_),void 0,_)}registerDocumentSemanticTokensProvider(j,V,W,q){const _=this.t(new ke(this.h,W),j),oe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(V,j),q,oe);let Ne=this.p(_);if(oe){const Ve=W.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(oe));Ne=c.$_M.from(Ne,Ve)}return Ne}$provideDocumentSemanticTokens(j,V,W,q){return this.s(j,ke,_=>_.provideDocumentSemanticTokens(m.URI.revive(V),W,q),null,q)}$releaseDocumentSemanticTokens(j,V){this.s(j,ke,W=>W.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,V,W,q){const _=this.t(new se(this.h,W),j);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(V,j),q),this.p(_)}$provideDocumentRangeSemanticTokens(j,V,W,q){return this.s(j,se,_=>_.provideDocumentRangeSemanticTokens(m.URI.revive(V),W,q),null,q)}registerCompletionItemProvider(j,V,W,q){const _=this.t(new Pe(this.h,this.j.converter,W,this.m,j),j);return this.e.$registerCompletionsProvider(_,this.o(V,j),q,Pe.supportsResolving(W),j.identifier),this.p(_)}$provideCompletionItems(j,V,W,q,_){return this.s(j,Pe,oe=>oe.provideCompletionItems(m.URI.revive(V),W,q,_),void 0,_)}$resolveCompletionItem(j,V,W){return this.s(j,Pe,q=>q.resolveCompletionItem(V,W),void 0,W)}$releaseCompletionItems(j,V){this.s(j,Pe,W=>W.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(j,V,W,q){const _=new H(j,this.h,W,this.j.converter),oe=this.t(_,j);return this.e.$registerInlineCompletionsSupport(oe,this.o(V,j),_.supportsHandleEvents,n.$Sm.toKey(j.identifier.value),q?.yieldTo?.map(Ne=>n.$Sm.toKey(Ne))||[]),this.p(oe)}$provideInlineCompletions(j,V,W,q,_){return this.s(j,re,oe=>oe.provideInlineCompletions(m.URI.revive(V),W,q,_),void 0,_)}$handleInlineCompletionDidShow(j,V,W,q){this.s(j,re,async _=>{_.handleDidShowCompletionItem(V,W,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,V,W,q,_){this.s(j,re,async oe=>{oe.handlePartialAccept(V,W,q,_)},void 0,void 0)}$freeInlineCompletionsList(j,V){this.s(j,re,async W=>{W.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(j,V,W){const q=new he(j,this.h,W,this.j.converter),_=this.t(q,j);return this.e.$registerInlineEditProvider(_,this.o(V,j),j.identifier),this.p(_)}$provideInlineEdit(j,V,W,q){return this.s(j,he,_=>_.provideInlineEdits(m.URI.revive(V),W,q),void 0,q)}$freeInlineEdit(j,V){this.s(j,he,async W=>{W.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(j,V,W,q){const _=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,oe=this.t(new pe(this.h,W),j);return this.e.$registerSignatureHelpProvider(oe,this.o(V,j),_),this.p(oe)}$provideSignatureHelp(j,V,W,q,_){return this.s(j,pe,oe=>oe.provideSignatureHelp(m.URI.revive(V),W,q,_),void 0,_)}$releaseSignatureHelp(j,V){this.s(j,pe,W=>W.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(j,V,W){const q=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new be(this.h,this.j.converter,W,this.l,j),j);this.e.$registerInlayHintsProvider(_,this.o(V,j),typeof W.resolveInlayHint=="function",q,Oe.u(j));let oe=this.p(_);if(q!==void 0){const Ne=W.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(q));oe=c.$_M.from(oe,Ne)}return oe}$provideInlayHints(j,V,W,q){return this.s(j,be,_=>_.provideInlayHints(m.URI.revive(V),W,q),void 0,q)}$resolveInlayHint(j,V,W){return this.s(j,be,q=>q.resolveInlayHint(V,W),void 0,W)}$releaseInlayHints(j,V){this.s(j,be,W=>W.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(j,V,W){const q=this.t(new ge(this.h,W),j);return this.e.$registerDocumentLinkProvider(q,this.o(V,j),typeof W.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(j,V,W){return this.s(j,ge,q=>q.provideLinks(m.URI.revive(V),W),void 0,W,V.scheme==="output")}$resolveDocumentLink(j,V,W){return this.s(j,ge,q=>q.resolveLink(V,W),void 0,void 0,!0)}$releaseDocumentLinks(j,V){this.s(j,ge,W=>W.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(j,V,W){const q=this.t(new ae(this.h,W),j);return this.e.$registerDocumentColorProvider(q,this.o(V,j)),this.p(q)}$provideDocumentColors(j,V,W){return this.s(j,ae,q=>q.provideColors(m.URI.revive(V),W),[],W)}$provideColorPresentations(j,V,W,q){return this.s(j,ae,_=>_.provideColorPresentations(m.URI.revive(V),W,q),void 0,q)}registerFoldingRangeProvider(j,V,W){const q=this.q(),_=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new Re(new K(this.h,W),j)),this.e.$registerFoldingRangeProvider(q,this.o(V,j),j.identifier,_);let oe=this.p(q);if(_!==void 0){const Ne=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));oe=c.$_M.from(oe,Ne)}return oe}$provideFoldingRanges(j,V,W,q){return this.s(j,K,_=>_.provideFoldingRanges(m.URI.revive(V),W,q),void 0,q)}registerSelectionRangeProvider(j,V,W){const q=this.t(new Z(this.h,W,this.l),j);return this.e.$registerSelectionRangeProvider(q,this.o(V,j)),this.p(q)}$provideSelectionRanges(j,V,W,q){return this.s(j,Z,_=>_.provideSelectionRanges(m.URI.revive(V),W,q),[],q)}registerCallHierarchyProvider(j,V,W){const q=this.t(new fe(this.h,W),j);return this.e.$registerCallHierarchyProvider(q,this.o(V,j)),this.p(q)}$prepareCallHierarchy(j,V,W,q){return this.s(j,fe,_=>Promise.resolve(_.prepareSession(m.URI.revive(V),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(j,V,W,q){return this.s(j,fe,_=>_.provideCallsTo(V,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(j,V,W,q){return this.s(j,fe,_=>_.provideCallsFrom(V,W,q),void 0,q)}$releaseCallHierarchy(j,V){this.s(j,fe,W=>Promise.resolve(W.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(j,V,W){const q=this.t(new le(this.h,W),j);return this.e.$registerTypeHierarchyProvider(q,this.o(V,j)),this.p(q)}$prepareTypeHierarchy(j,V,W,q){return this.s(j,le,_=>Promise.resolve(_.prepareSession(m.URI.revive(V),W,q)),void 0,q)}$provideTypeHierarchySupertypes(j,V,W,q){return this.s(j,le,_=>_.provideSupertypes(V,W,q),void 0,q)}$provideTypeHierarchySubtypes(j,V,W,q){return this.s(j,le,_=>_.provideSubtypes(V,W,q),void 0,q)}$releaseTypeHierarchy(j,V){this.s(j,le,W=>Promise.resolve(W.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(j,V,W,q){const _=this.q();return this.f.set(_,new Re(new Me(this.e,this.h,W,_,j),j)),this.e.$registerDocumentOnDropEditProvider(_,this.o(V,j),(0,h.$OG)(j,"documentPaste")&&q?{supportsResolve:!!W.resolveDocumentDropEdit,dropMimeTypes:q.dropMimeTypes}:void 0),this.p(_)}$provideDocumentOnDropEdits(j,V,W,q,_,oe){return this.s(j,Me,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(V,m.URI.revive(W),q,_,oe)),void 0,void 0)}$resolveDropEdit(j,V,W){return this.s(j,Me,q=>q.resolveDropEdit(V,W),{},void 0)}$releaseDropEdits(j,V){this.s(j,Me,W=>Promise.resolve(W.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(j,V,W){const q=this.t(new ve(this.h,W),j);return this.e.$registerMappedEditsProvider(q,this.o(V,j)),this.p(q)}$provideMappedEdits(j,V,W,q,_){return this.s(j,ve,oe=>Promise.resolve(oe.provideMappedEdits(V,W,q,_)),null,_)}registerDocumentPasteEditProvider(j,V,W,q){const _=this.q();return this.f.set(_,new Re(new F(this.e,this.h,W,_,j),j)),this.e.$registerPasteEditProvider(_,this.o(V,j),{supportsCopy:!!W.prepareDocumentPaste,supportsPaste:!!W.provideDocumentPasteEdits,supportsResolve:!!W.resolveDocumentPasteEdit,providedPasteEditKinds:q.providedPasteEditKinds?.map(oe=>oe.value),copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(j,V,W,q,_){return this.s(j,F,oe=>oe.prepareDocumentPaste(m.URI.revive(V),W,q,_),void 0,_)}$providePasteEdits(j,V,W,q,_,oe,Ne){return this.s(j,F,Ve=>Ve.providePasteEdits(V,m.URI.revive(W),q,_,oe,Ne),void 0,Ne)}$resolvePasteEdit(j,V,W){return this.s(j,F,q=>q.resolvePasteEdit(V,W),{},void 0)}$releasePasteEdits(j,V){this.s(j,F,W=>Promise.resolve(W.releasePasteEdits(V)),void 0,void 0)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Oe.w(j.decreaseIndentPattern),increaseIndentPattern:Oe.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Oe.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Oe.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Oe.w(j.beforeText),afterText:j.afterText?Oe.w(j.afterText):void 0,previousLineText:j.previousLineText?Oe.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Oe.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(V=>c.SyntaxTokenType.toString(V)):void 0}}static D(j){return j.map(Oe.C)}setLanguageConfiguration(j,V,W){const{wordPattern:q}=W;if(q&&(0,M.$kf)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(V,q):this.h.setWordDefinitionFor(V,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const _=this.q(),oe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?Oe.w(W.wordPattern):void 0,indentationRules:W.indentationRules?Oe.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?Oe.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport,autoClosingPairs:W.autoClosingPairs?Oe.D(W.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,V,oe),this.p(_)}$setWordDefinitions(j){for(const V of j)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$plc=Oe,Oe.d=0}),define(Ce[90],Ae([1,0,6,4,8,7,103,20,9,5,175,108,14,3,17,86,12,42]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=void 0,e.$9lc=(0,w.$wi)("IExtHostLanguageModels");class i{constructor(d,o){this.option=d,this.stream=new $.$Zh,this.stream=o??new $.$Zh}}class c{constructor(){this.a=new Map,this.b=new $.$Zh,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let o=this.a.get(d.index);o||(this.a.size===0?o=new i(d.index,this.b):o=new i(d.index),this.a.set(d.index,o)),o.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const o of this.f())o.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let h=n=class{constructor(d,o,f){this.j=o,this.k=f,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Um,this.i=new Map,this.o=new Set,this.b=d.getProxy(A.$0M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,o,f,u){const D=n.a++;this.f.set(D,{extension:d.identifier,provider:f,languageModelId:o});let l;u.auth&&(l={providerLabel:d.displayName||d.name,accountLabel:typeof u.auth=="object"?u.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,o,{extension:d.identifier,identifier:o,name:u.name??"",version:u.version,tokens:u.tokens,auth:l});const v=f.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:P,tokenCount:k})=>{this.b.$whenLanguageModelChatRequestMade(o,new p.$Sm(b),P,k)});return(0,y.$Tc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D),v?.dispose()})}async $provideLanguageModelResponse(d,o,f,u,D,l){const v=this.f.get(d);if(!v)return;const b=new N.$ew(async P=>{if(l.isCancellationRequested){this.j.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(o,{index:P.index,part:P.part})});return v.provider.provideLanguageModelResponse2(u.map(C.LanguageModelMessage.to),D,p.$Sm.toKey(f),b,l)}$provideTokenLength(d,o,f){const u=this.f.get(d);return u?Promise.resolve(u.provider.provideTokenCount(o,f)):Promise.resolve(0)}$updateLanguageModels(d){const o=[],f=[];if(d.added)for(const u of d.added)this.g.set(u.identifier,u),o.push(u.identifier);if(d.removed)for(const u of d.removed){this.g.delete(u),f.push(u);for(const[D,l]of this.i)l.languageModelId===u&&(l.res.reject(new m.$5),this.i.delete(D))}this.d.fire(Object.freeze({added:Object.freeze(o),removed:Object.freeze(f)})),d.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(d){const o=new Array;for(const{from:f,to:u,enabled:D}of d){const l=this.h.get(f)??new p.$Tm;if(l.has(u)!==D){D?l.add(u):l.delete(u),this.h.set(f,l);const b={from:f,to:u};o.push(b),this.c.fire(b)}}}async sendChatRequest(d,o,f,u,D){const l=d.identifier,v=await this.b.$prepareChatAccess(l,o,u.justification);if(!v||!this.g.has(o))throw O.$kP.NotFound(`Language model '${o}' is unknown.`);if(this.m(l,v)&&(!await this.l(d,{identifier:v.extension,displayName:v.auth.providerLabel},u.justification,u.silent)||!this.h.get(l)?.has(v.extension)))throw O.$kP.NoPermissions(`Language model '${o}' cannot be used by '${l.value}'.`);const b=Math.random()*1e6|0,P=this.b.$fetchResponse(l,o,b,f.map(C.LanguageModelMessage.from),u.modelOptions??{},D),k=new $.$vh,I=new c;this.i.set(b,{languageModelId:o,res:I});let U;if(P.catch(Q=>{k.isOpen()?I.reject(Q):U=Q}).finally(()=>{this.i.delete(b),I.resolve(),k.open()}),await k.wait(),U)throw new O.$kP(`Language model '${o}' errored, check cause for more details`,"Unknown",U);return I.apiObject}async $handleResponseFragment(d,o){const f=this.i.get(d);f&&f.res.handleFragment(o)}async l(d,o,f,u){const D=S.$_L+o.identifier.value;if(await this.k.getSession(d,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:o.identifier,enabled:!0}]),!0;if(u)return!1;try{const v=f?(0,M.localize)(0,null,o.displayName,f):(0,M.localize)(1,null,o.displayName);return await this.k.getSession(d,D,[],{forceNewSession:{detail:v}}),this.$updateModelAccesslist([{from:d.identifier,to:o.identifier,enabled:!0}]),!0}catch{return!1}}m(d,o){return!!o.auth&&!p.$Sm.equals(o.extension,d)}async n(d){for(const o of this.o)try{await this.l(o,{identifier:d.extension,displayName:""},void 0,!0)}catch(f){this.j.error("Fake Auth request failed"),this.j.error(f)}}async computeTokenLength(d,o,f){const u=this.g.get(d);if(!u)throw O.$kP.NotFound(`Language model '${d}' is unknown.`);const D=s.Iterable.find(this.f.values(),l=>l.languageModelId===d);return D?D.provider.provideTokenCount(o,f):this.b.$countTokens(u.identifier,typeof o=="string"?o:C.LanguageModelMessage.from(o),f)}getLanguageModelInfo(d){const o=this.g.get(d);if(o)return{id:o.identifier,name:o.name,version:o.version,tokens:o.tokens}}createLanguageModelAccessInformation(d){this.o.add(d);const o=this,f=E.Event.signal(E.Event.filter(this.c.event,D=>p.$Sm.equals(D.from,d.identifier))),u=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(f,u)},canSendRequest(D){const l=o.g.get(D);if(!l)return;if(!o.m(d.identifier,l))return!0;const v=o.h.get(d.identifier);if(v)return v.has(l.extension)}}}};e.$0lc=h,h.a=1,e.$0lc=h=n=Qe([qe(0,g.$xP),qe(1,a.$3j),qe(2,r.$rlc)],h)}),define(Ce[274],Ae([1,0,4,8,7,33,9,6,26]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class E{constructor(S,m,w,g){this.c=m,this.d=w,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(y.$0M.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,m){await this.a.$changeLanguage(S,m);const w=this.c.getDocumentData(S);if(!w)throw new Error(`document '${S.toString()}' NOT found`);return w.document}async tokenAtPosition(S,m){const w=S.version,g=A.Position.from(m),r=await this.a.$tokensAtPosition(S.uri,g),a={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(m)??new C.$bN(m.line,m.character,m.line,m.character)};if(!r)return a;const s={range:A.Range.to(r.range),type:A.TokenType.to(r.type)};return!s.range.contains(m)||w!==S.version?a:s}createLanguageStatusItem(S,m,w){const g=this.f++,r=this.a,a=this.g,s=`${S.identifier.value}/${m}`;if(a.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);a.add(s);const n={selector:w,id:m,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new p.$Uc,h=()=>{if(i?.dispose(),!a.has(s)){console.warn(`LanguageStatusItem (${m}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,N.$yh)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:s,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:A.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?O.default.Error:n.severity===C.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),r.$removeLanguageStatus(g),a.delete(s)},get id(){return n.id},get name(){return n.name},set name(d){n.name=d,h()},get selector(){return n.selector},set selector(d){n.selector=d,h()},get text(){return n.text},set text(d){n.text=d,h()},set text2(d){(0,$.$PG)(S,"languageStatusText"),n.text=d,h()},get text2(){return(0,$.$PG)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(d){n.detail=d,h()},get severity(){return n.severity},set severity(d){n.severity=d,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(d){n.accessibilityInformation=d,h()},get command(){return n.command},set command(d){n.command=d,h()},get busy(){return n.busy},set busy(d){n.busy=d,h()}};return h(),t}}e.$Omc=E}),define(Ce[275],Ae([1,0,16,2,8,7,85]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0;class p{constructor(S,m,w,g){this.start=S,this.deletedCount=m,this.deletedItems=w,this.items=g}asApiEvent(){return{range:new O.$BO(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,m,w){this.notebook=S,this.h=m,this.j=w,this.handle=w.handle,this.uri=A.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(C.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return S.g},set mime(g){S.g=g},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(w)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,m,w){const g=w.map(C.NotebookCellOutputItem.to),r=this.a.find(a=>a.id===S);if(r&&(m||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(a=>N.$7K(a.mime)))){const a=new Map,s=[];r.items.forEach(n=>{let i;a.has(n.mime)?i=a.get(n.mime):(i=[],a.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=N.$8K(a.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Amc=$;class E{constructor(S,m,w,g,r){this.k=S,this.l=m,this.m=w,this.uri=g,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,m={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===y.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(w){return w=S.n(w),S.b[w].apiCell},getCells(w){return(w?S.p(w):S.b).map(r=>r.apiCell)},save(){return S.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,m,w){this.g=S.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:w});const g={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},r=[];for(const s of S.rawEvents)s.kind===N.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,g.contentChanges):s.kind===N.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,g.contentChanges):s.kind===N.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===N.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===N.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===N.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===N.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===N.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===N.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const a=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=a.get(n.cell);if(i===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else g.cellChanges[i]={...g.cellChanges[i],...n}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let m=S.start|0,w=S.end|0;return m<0&&(m=0),w>this.b.length&&(w=this.b.length),S.with({start:m,end:w})}p(S){S=this.o(S);const m=[];for(let w=S.start;w<S.end;w++)m.push(this.b[w]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,m,w){if(this.j)return;const g=[],r=[],a=[];if(S.reverse().forEach(s=>{const i=s[2].map(t=>{const d=new $(this,this.l,t);return m||r.push($.asModelAddData(t)),d}),c=new p(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)a.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),w)for(const s of g)w.push(s.asApiEvent())}s(S,m,w,g){const r=this.b.splice(S,m);this.b.splice(w,0,...r);const a=[new p(S,m,r.map(s=>s.apiCell),[]),new p(w,0,[],r)];for(const s of a)g.push(s.asApiEvent())}t(S,m){this.b[S].setOutputs(m)}u(S,m,w,g){this.b[S].setOutputItems(m,w,g)}v(S,m){const w=this.b[S];w.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(w.uri,m)}w(S,m){const w=this.b[S];w.apiCell.mime=m}x(S,m){this.b[S].setMetadata(m)}y(S,m){this.b[S].setInternalMetadata(m)}getCellFromApiCell(S){return this.b.find(m=>m.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(m=>m.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Bmc=E,E.a=0}),define(Ce[276],Ae([1,0,5,2,8,7,35]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class p{constructor(E,M,S,m={timeout:1500,errors:3}){this.b=E,this.c=M,this.d=S,this.f=m,this.a=new y.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(M,S,m)=>{const w=function(r){M.call(S,r)};return w.extension=E,this.a.event(w,void 0,m)}}async $participateInSave(E,M,S){const m=A.URI.revive(E),w=this.c.getNotebookDocument(m);if(!w)throw new Error("Unable to resolve notebook document");const g=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:C.TextDocumentSaveReason.to(M)},S,async(a,s)=>{const n=Date.now(),i=await await Promise.resolve(a);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!S.isCancellationRequested&&i&&(i instanceof O.$jN?g.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(g.length===0)return!0;const r={edits:[]};for(const a of g){const{edits:s}=C.WorkspaceEdit.from(a);r.edits=r.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new N.$Cw(r))}}e.$Qmc=p}),define(Ce[114],Ae([1,0,14,8,7]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;class O{constructor(p,$,E,M,S,m){this.id=p,this.f=$,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=M,this.c=m}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(C.$BO.isNotebookRange))throw(0,y.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,E){p.f.$tryRevealRange(p.id,A.NotebookRange.from($),E??C.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(A.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Cmc=O,O.apiEditorsToExtHost=new WeakMap}),define(Ce[277],Ae([1,0,5,12,8]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;let O=class{constructor(p,$){this.c=p,this.d=$,this.a=new y.$ee,this.b=new y.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const E=this.d.getEditorById(p);$.visibleRanges&&E._acceptVisibleRanges($.visibleRanges.ranges.map(C.NotebookRange.to)),$.selections&&E._acceptSelections($.selections.selections.map(C.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(C.ViewColumn.to(p[$]))}};e.$Smc=O,e.$Smc=O=Qe([qe(0,A.$3j)],O)}),define(Ce[278],Ae([1,0,5,4,114]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class O{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(A.$0M.MainThreadNotebookRenderers)}$postRendererMessage(p,$,E){const M=this.c.getEditorById(p);this.a.get($)?.fire({editor:M.apiEditor,message:E})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(M=>M.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(M,S,m)=>this.d($).event(M,S,m),postMessage:(M,S)=>{C.$Cmc.apiEditorsToExtHost.has(M)&&([M,S]=[S,M]);const m=S&&C.$Cmc.apiEditorsToExtHost.get(S);return this.b.$postMessage(m?.id,$,M)}}}d(p){let $=this.a.get(p);return $||($=new y.$ee({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$Vmc=O}),define(Ce[279],Ae([1,0,8,103,24,69,14]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class p{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,m,w){const g=this.b++,{title:r,location:a,cancellable:s}=m,n={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(g,{location:y.ProgressLocation.from(a),title:r,source:n,cancellable:s},S.isUnderDevelopment?void 0:S.identifier.value).catch(N.$2),this.d(g,w,!!s)}d(S,m,w){let g;w&&(g=new C.$pe,this.c.set(S,g));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),g?.dispose()};let a;try{a=m(new E(this.a,S),w&&g?g.token:C.CancellationToken.None)}catch(s){throw r(S),s}return a.then(s=>r(S),s=>r(S)),a}$acceptProgressCanceled(S){const m=this.c.get(S);m&&(m.cancel(),this.c.delete(S))}}e.$Zmc=p;function $(M,S){return M.message=S.message,typeof S.increment=="number"&&(typeof M.increment=="number"?M.increment+=S.increment:M.increment=S.increment),M}class E extends A.$ew{constructor(S,m){super(w=>this.throttledReport(w)),this.c=S,this.d=m}throttledReport(S){this.c.$progressReport(this.d,S)}}Qe([(0,O.$3h)(100,(M,S)=>$(M,S),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Ce[280],Ae([1,0,2,4,9,8]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class N{constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(A.$0M.MainThreadQuickDiff)}$provideOriginalResource($,E,M){const S=y.URI.revive(E),m=this.c.get($);return m?(0,C.$oh)(()=>m.provideOriginalResource(S,M)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider($,E,M,S){const m=N.a++;return this.c.set(m,E),this.b.$registerQuickDiffProvider(m,O.DocumentSelector.from($,this.d),M,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$1mc=N,N.a=0}),define(Ce[281],Ae([1,0,24,5,6,4,2,7,14,18,33,36,26,8]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=g;function g(r,a,s){const n=r.getProxy(O.$0M.MainThreadQuickOpen);class i{constructor(l,v){this.e=new Map,this.f=0,this.a=l,this.b=v}showQuickPick(l,v,b,P=y.CancellationToken.None){this.c=void 0;const k=Promise.resolve(v),I=++this.f,U=n.$show(I,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},P),Q={},G=U.then(()=>Q);return Promise.race([G,k]).then(L=>{if(L===Q)return;const R=(0,m.$OG)(l,"quickPickItemTooltip");return k.then(F=>{const T=[];for(let X=0;X<F.length;X++){const ne=F[X];if(typeof ne=="string")T.push({label:ne,handle:X});else if(ne.kind===p.QuickPickItemKind.Separator)T.push({type:"separator",label:ne.label});else{ne.tooltip&&!R&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const me=ne.iconPath?o(ne.iconPath):void 0;T.push({label:ne.label,iconPath:me?.iconPath,iconClass:me?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:R?w.MarkdownString.fromStrict(ne.tooltip):void 0,handle:X})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=X=>{b.onDidSelectItem(F[X])}),n.$setItems(I,T),U.then(X=>{if(typeof X=="number")return F[X];if(Array.isArray(X))return X.map(ne=>F[ne])})})}).then(void 0,L=>{if(!(0,$.$4)(L))return n.$setError(I,L),Promise.reject(L)})}$onItemSelected(l){this.c?.(l)}showInput(l,v=y.CancellationToken.None){return this.d=l?.validateInput,n.$input(l,typeof this.d=="function",v).then(void 0,b=>{if(!(0,$.$4)(b))return Promise.reject(b)})}async $validateInput(l){if(!this.d)return;const v=await this.d(l);if(!v||typeof v=="string")return v;let b;switch(v.severity){case p.InputBoxValidationSeverity.Info:b=M.default.Info;break;case p.InputBoxValidationSeverity.Warning:b=M.default.Warning;break;case p.InputBoxValidationSeverity.Error:b=M.default.Error;break;default:b=v.message?M.default.Error:M.default.Ignore;break}return{content:v.message,severity:b}}async showWorkspaceFolderPick(l,v=y.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(k=>k.uri.toString()===b.uri.toString())}createQuickPick(l){const v=new f(l,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}createInputBox(l){const v=new u(l,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}$onDidChangeValue(l,v){this.e.get(l)?._fireDidChangeValue(v)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,v){const b=this.e.get(l);b instanceof f&&b._fireDidChangeActive(v)}$onDidChangeSelection(l,v){const b=this.e.get(l);b instanceof f&&b._fireDidChangeSelection(v)}$onDidTriggerButton(l,v){this.e.get(l)?._fireDidTriggerButton(v)}$onDidTriggerItemButton(l,v,b){const P=this.e.get(l);P instanceof f&&P._fireDidTriggerItemButton(v,b)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class c{constructor(l,v){this.x=l,this.y=v,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.$ee,this.q=new A.$ee,this.r=new A.$ee,this.s=new A.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((v,b)=>{const P=v===p.$yO.Back?-1:b;this.o.set(P,v)}),this.z({buttons:l.map((v,b)=>({...o(v.iconPath),tooltip:v.tooltip,handle:v===p.$yO.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const v=this.o.get(l);v&&this.r.fire(v)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(l){if(!this.v){for(const v of Object.keys(l)){const b=l[v];this.u[v]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}c.a=1;function h(D){if(D instanceof p.$9N)return{id:D.id};const l=d(D),v=t(D);return{dark:typeof l=="string"?N.URI.file(l):l,light:typeof v=="string"?N.URI.file(v):v}}function t(D){return typeof D=="object"&&"light"in D?D.light:D}function d(D){return typeof D=="object"&&"dark"in D?D.dark:D}function o(D){const l=h(D);let v,b;return"id"in l?b=S.ThemeIcon.asClassName(l):v=l,{iconPath:v,iconClass:b}}class f extends c{constructor(l,v){super(l.identifier,v),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.$ee,this.L=[],this.M=new A.$ee,this.N=new A.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((P,k)=>{this.C.set(k,P),this.D.set(P,k)});const v=(0,m.$OG)(this.O,"quickPickItemTooltip"),b=[];for(let P=0;P<l.length;P++){const k=l[P];if(k.kind===p.QuickPickItemKind.Separator)b.push({type:"separator",label:k.label});else{k.tooltip&&!v&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?o(k.iconPath):void 0;b.push({handle:P,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:v?w.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((U,Q)=>({...o(U.iconPath),tooltip:U.tooltip,handle:Q}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(v=>this.D.has(v)),this.z({activeItems:this.J.map(v=>this.D.get(v))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(v=>this.D.has(v)),this.z({selectedItems:this.L.map(v=>this.D.get(v))})}_fireDidChangeActive(l){const v=(0,E.$Hb)(l.map(b=>this.C.get(b)));this.J=v,this.K.fire(v)}_fireDidChangeSelection(l){const v=(0,E.$Hb)(l.map(b=>this.C.get(b)));this.L=v,this.M.fire(v)}_fireDidTriggerItemButton(l,v){const b=this.C.get(l);if(!b||!b.buttons||!b.buttons.length)return;const P=b.buttons[v];P&&this.N.fire({button:P,item:b})}}class u extends c{constructor(l,v){super(l.identifier,v),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:M.default.Error}):this.z({validationMessage:l.message,severity:l.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new i(a,s)}});var Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)},_e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y};define(Ce[282],Ae([1,0,2,5,69,6,9,4,18,134,12,20,36,8,26,16,22]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a){"use strict";var s,n,i,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=void 0;function h(G){return G instanceof y.URI}function t(G,L){return G.scheme===r.Schemas.file&&L.scheme===r.Schemas.file&&a.$e?G.toString()===L.toString():G.toString().toLowerCase()===L.toString().toLowerCase()}function d(G){if(G)return typeof G.iconPath=="string"?y.URI.file(G.iconPath):y.URI.isUri(G.iconPath)||m.ThemeIcon.isThemeIcon(G.iconPath)?G.iconPath:void 0}function o(G){if(G.icon){if(y.URI.isUri(G.icon))return G.icon;if(m.ThemeIcon.isThemeIcon(G.icon))return G.icon;{const L=G.icon;return{light:L.light,dark:L.dark}}}else return}function f(G,L){if(!G.iconPath&&!L.iconPath)return 0;if(G.iconPath){if(!L.iconPath)return 1}else return-1;const R=typeof G.iconPath=="string"?G.iconPath:y.URI.isUri(G.iconPath)?G.iconPath.fsPath:G.iconPath.id,F=typeof L.iconPath=="string"?L.iconPath:y.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,E.$rr)(R,F)}function u(G,L){let R=0;if(G.strikeThrough!==L.strikeThrough)return G.strikeThrough?1:-1;if(G.faded!==L.faded)return G.faded?1:-1;if(G.tooltip!==L.tooltip)return(G.tooltip||"").localeCompare(L.tooltip||"");if(R=f(G,L),R!==0)return R;if(G.light&&L.light)R=f(G.light,L.light);else{if(G.light)return 1;if(L.light)return-1}if(R!==0)return R;if(G.dark&&L.dark)R=f(G.dark,L.dark);else{if(G.dark)return 1;if(L.dark)return-1}return R}function D(G,L){if(G.command!==L.command)return G.command<L.command?-1:1;if(G.title!==L.title)return G.title<L.title?-1:1;if(G.tooltip!==L.tooltip){if(G.tooltip!==void 0&&L.tooltip!==void 0)return G.tooltip<L.tooltip?-1:1;if(G.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(G.arguments===L.arguments)return 0;if(G.arguments)if(L.arguments){if(G.arguments.length!==L.arguments.length)return G.arguments.length-L.arguments.length}else return 1;else return-1;for(let R=0;R<G.arguments.length;R++){const F=G.arguments[R],T=L.arguments[R];if(F!==T&&!(h(F)&&h(T)&&t(F,T)))return F<T?-1:1}return 0}function l(G,L){let R=(0,E.$rr)(G.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(R!==0)return R;if(G.command&&L.command)R=D(G.command,L.command);else{if(G.command)return 1;if(L.command)return-1}if(R!==0)return R;if(G.decorations&&L.decorations)R=u(G.decorations,L.decorations);else{if(G.decorations)return 1;if(L.decorations)return-1}if(G.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)R=(0,E.$rr)(G.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(G.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(G.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)R=(0,E.$rr)(G.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(G.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return R}function v(G,L){for(let R=0;R<G.length;R++)if(G[R]!==L[R])return!1;return!0}function b(G,L){return G.command===L.command&&G.title===L.title&&G.tooltip===L.tooltip&&(G.arguments&&L.arguments?v(G.arguments,L.arguments):G.arguments===L.arguments)}function P(G,L){return(0,$.$ub)(G,L,b)}class k{get value(){return this.d}set value(L){L=L??"",Be(this,s,"f").$setInputBoxValue(this.l,L),this.n(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){Be(this,s,"f").$setInputBoxPlaceholder(this.l,L),this.f=L}get validateInput(){return(0,g.$PG)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,g.$PG)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,Be(this,s,"f").$setValidationProviderIsEnabled(this.l,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,Be(this,s,"f").$setInputBoxEnablement(this.l,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,Be(this,s,"f").$setInputBoxVisibility(this.l,L))}get document(){return(0,g.$PG)(this.k,"scmTextDocument"),Be(this,n,"f").getDocument(this.m)}constructor(L,R,F,T,X){this.k=L,this.l=T,this.m=X,s.set(this,void 0),n.set(this,void 0),this.d="",this.e=new A.$ee,this.f="",this.h=!0,this.j=!0,_e(this,n,R,"f"),_e(this,s,F,"f")}showValidationMessage(L,R){(0,g.$PG)(this.k,"scmValidation"),Be(this,s,"f").$showValidationMessage(this.l,L,R)}$onInputBoxValueChange(L){this.n(L)}n(L){this.d=L,this.e.fire(L)}}e.$3mc=k,s=new WeakMap,n=new WeakMap;class I{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(L){this.v=L,this.q.$updateGroupLabel(this.t,this.handle,L)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(L){this.p=L,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,R,F,T,X,ne,me){this.q=L,this.s=R,this.t=F,this.u=T,this.v=X,this.multiDiffEditorEnableViewChanges=ne,this.w=me,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,R){const F=this.h.get(L);return F?(0,N.$oh)(()=>this.s.executeCommand(F.command,...F.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(l),F=(0,$.$Db)(this.o,L,l).map(ne=>{const me=ne.toInsert.map(we=>{const de=this.e++;this.g.set(de,we);const $e=we.resourceUri;let ke;if(we.command)if(we.command.command==="vscode.open"||we.command.command==="vscode.diff"||we.command.command==="vscode.changes"){const fe=new O.$Uc;ke=this.s.converter.toInternal(we.command,fe),this.j.set(de,fe)}else this.h.set(de,we.command);const se=(0,g.$OG)(this.w,"scmMultiDiffEditor"),Pe=se?we.multiDiffEditorOriginalUri:void 0,re=se?we.multiFileDiffEditorModifiedUri:void 0,H=d(we.decorations),he=we.decorations&&d(we.decorations.light)||H,Fe=we.decorations&&d(we.decorations.dark)||H,pe=[he,Fe],be=we.decorations&&we.decorations.tooltip||"",ge=we.decorations&&!!we.decorations.strikeThrough,ae=we.decorations&&!!we.decorations.faded,K=we.contextValue||"";return{rawResource:[de,$e,pe,be,ge,ae,K,ke,Pe,re],handle:de}});return{start:ne.start,deleteCount:ne.deleteCount,toInsert:me}}),T=F.map(({start:ne,deleteCount:me,toInsert:we})=>[ne,me,we.map(de=>de.rawResource)]),X=F.reverse();for(const{start:ne,deleteCount:me,toInsert:we}of X){const de=we.map(ke=>ke.handle),$e=this.n.splice(ne,me,...de);for(const ke of $e)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=L,T}dispose(){this.l=!0,this.m.fire()}}I.d=0;class U{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,Be(this,i,"f").$updateSourceControl(this.w,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let R;(0,g.$OG)(this.x,"quickDiffProvider")&&(R=L?.label),Be(this,i,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!L,quickDiffLabel:R})}get historyProvider(){return(0,g.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(L){(0,g.$PG)(this.x,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Uc,Be(this,i,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.l=L?.currentHistoryItemGroup,Be(this,i,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(L){L!==this.m&&(this.m=L,Be(this,i,"f").$updateSourceControl(this.w,{commitTemplate:L}))}get acceptInputCommand(){return this.o}set acceptInputCommand(L){this.n.value=new O.$Uc,this.o=L;const R=this.y.converter.toInternal(L,this.n.value);Be(this,i,"f").$updateSourceControl(this.w,{acceptInputCommand:R})}get actionButton(){return(0,g.$PG)(this.x,"scmActionButton"),this.q}set actionButton(L){(0,g.$PG)(this.x,"scmActionButton"),this.p.value=new O.$Uc,this.q=L;const R=L!==void 0?{command:this.y.converter.toInternal(L.command,this.p.value),secondaryCommands:L.secondaryCommands?.map(F=>F.map(T=>this.y.converter.toInternal(T,this.p.value))),description:L.description,enabled:L.enabled}:void 0;Be(this,i,"f").$updateSourceControl(this.w,{actionButton:R??null})}get statusBarCommands(){return this.t}set statusBarCommands(L){if(this.t&&L&&P(this.t,L))return;this.s.value=new O.$Uc,this.t=L;const R=(L||[]).map(F=>this.y.converter.toInternal(F,this.s.value));Be(this,i,"f").$updateSourceControl(this.w,{statusBarCommands:R})}get selected(){return this.u}constructor(L,R,F,T,X,ne,me){this.x=L,this.y=T,this.z=X,this.A=ne,this.B=me,i.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Wc,this.m=void 0,this.n=new O.$Wc,this.o=void 0,this.p=new O.$Wc,this.s=new O.$Wc,this.t=void 0,this.u=!1,this.v=new A.$ee,this.onDidChangeSelection=this.v.event,this.w=U.d++,this.C=new Map,this.D=new Set,_e(this,i,F,"f");const we=y.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${X}/scm${this.w}/input`,query:me?`rootUri=${encodeURIComponent(me.toString())}`:void 0});this.f=new k(L,R,Be(this,i,"f"),this.w,we),Be(this,i,"f").$registerSourceControl(this.w,X,ne,me,we)}createResourceGroup(L,R,F){const T=(0,g.$OG)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,X=new I(Be(this,i,"f"),this.y,this.w,L,R,T,this.x),ne=A.Event.once(X.onDidDispose)(()=>this.C.delete(X));return this.C.set(X,ne),this.eventuallyAddResourceGroups(),X}eventuallyAddResourceGroups(){const L=[],R=[];for(const[F,T]of this.C){T.dispose();const X=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});A.Event.once(F.onDidDispose)(()=>{this.D.delete(F),X.dispose(),this.e.delete(F.handle),Be(this,i,"f").$unregisterGroup(this.w,F.handle)}),L.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const ne=F._takeResourceStateSnapshot();ne.length>0&&R.push([F.handle,ne]),this.e.set(F.handle,F)}Be(this,i,"f").$registerGroups(this.w,L,R),this.C.clear()}eventuallyUpdateResourceStates(){const L=[];this.D.forEach(R=>{const F=R._takeResourceStateSnapshot();F.length!==0&&L.push([R.handle,F])}),L.length>0&&Be(this,i,"f").$spliceResourceStates(this.w,L),this.D.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.u=L,this.v.fire(L)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(L=>L.dispose()),Be(this,i,"f").$unregisterSourceControl(this.w)}}i=new WeakMap,U.d=0,Qe([(0,C.$2h)(100)],U.prototype,"eventuallyAddResourceGroups",null),Qe([(0,C.$2h)(100)],U.prototype,"eventuallyUpdateResourceStates",null);let Q=c=class{get onDidChangeActiveProvider(){return this.j.event}constructor(L,R,F,T){this.l=R,this.m=F,this.n=T,this.g=new Map,this.h=new S.$Um,this.j=new A.$ee,this.e=L.getProxy(p.$0M.MainThreadSCM),this.f=L.getProxy(p.$0M.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:X=>{if(X&&X.$mid===3){const ne=this.g.get(X.sourceControlHandle);if(!ne)return X;const me=ne.getResourceGroup(X.groupHandle);return me?me.getResourceState(X.handle):X}else if(X&&X.$mid===4){const ne=this.g.get(X.sourceControlHandle);return ne?ne.getResourceGroup(X.groupHandle):X}else if(X&&X.$mid===5){const ne=this.g.get(X.handle);return ne||X}return X}})}createSourceControl(L,R,F,T){this.n.trace("ExtHostSCM#createSourceControl",L.identifier.value,R,F,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const X=c.d++,ne=new U(L,this.m,this.e,this.l,R,F,T);this.g.set(X,ne);const me=this.h.get(L.identifier)||[];return me.push(ne),this.h.set(L.identifier,me),ne}getLastInputBox(L){this.n.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const R=this.h.get(L.identifier),F=R&&R[R.length-1];return F&&F.inputBox}$provideOriginalResource(L,R,F){const T=y.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",L,T.toString());const X=this.g.get(L);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,N.$oh)(()=>X.quickDiffProvider.provideOriginalResource(T,F)).then(ne=>ne||null)}$onInputBoxValueChange(L,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",L);const F=this.g.get(L);return F&&F.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(L,R,F,T){this.n.trace("ExtHostSCM#$executeResourceCommand",L,R,F);const X=this.g.get(L);if(!X)return Promise.resolve(void 0);const ne=X.getResourceGroup(R);return ne?ne.$executeResourceCommand(F,T):Promise.resolve(void 0)}$validateInput(L,R,F){this.n.trace("ExtHostSCM#$validateInput",L);const T=this.g.get(L);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,N.$oh)(()=>T.inputBox.validateInput(R,F)).then(X=>{if(!X)return Promise.resolve(void 0);const ne=w.MarkdownString.fromStrict(X.message);return ne?Promise.resolve([ne,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,R,F,T){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,F,T)??void 0}async $provideHistoryItems(L,R,F,T){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(R,F,T))?.map(me=>({...me,icon:o(me)}))??void 0}async $provideHistoryItemSummary(L,R,F,T){const X=this.g.get(L)?.historyProvider;if(typeof X?.provideHistoryItemSummary!="function")return;const ne=await X.provideHistoryItemSummary(R,F,T);return ne?{...ne,icon:o(ne)}:void 0}async $provideHistoryItemChanges(L,R,F,T){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(R,F,T)??void 0}};e.$4mc=Q,Q.d=0,e.$4mc=Q=c=Qe([qe(3,M.$3j)],Q)}),define(Ce[283],Ae([1,0,4,8,2]),function(ee,e,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class O{constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(y.$0M.MainThreadShare)}async $provideShare(p,$,E){return await this.c.get(p)?.provideShare({selection:A.Range.to($.selection),resourceUri:C.URI.revive($.resourceUri)},E)??void 0}registerShareProvider(p,$){const E=O.a++;return this.c.set(E,$),this.b.$registerShareProvider(E,A.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$5mc=O,O.a=0});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[284],Ae([1,0,7,4,178,6,8,15]),function(ee,e,y,A,C,O,N,p){"use strict";var $,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=e.$7mc=void 0;class M{constructor(g,r,a,s,n,i=y.StatusBarAlignment.Left,c){if($.set(this,void 0),E.set(this,void 0),this.i=!1,this.k="",this.q=new O.$Uc,_e(this,$,g,"f"),_e(this,E,r,"f"),n&&s){this.c=(0,y.$LN)(s.identifier,n);const h=a.get(this.c);h&&(i=h.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=h.priority,this.j=!0,this.name=h.name,this.text=h.text,this.tooltip=h.tooltip,this.command=h.command,this.accessibilityInformation=h.accessibilityInformation)}else this.c=String(M.a++);this.e=s,this.f=n,this.g=i,this.h=this.u(c)}u(g){if((0,p.$ag)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!M.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new O.$Uc,typeof g=="string"?this.r={fromApi:g,internal:Be(this,E,"f").toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:Be(this,E,"f").toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,$,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let r;this.m?r=this.m:r=(0,C.localize)(0,null,this.e.displayName||this.e.name);let a=this.n;this.o&&(a=M.b.get(this.o.id));const s=N.MarkdownString.fromStrict(this.l);Be(this,$,"f").$setEntry(this.c,g,this.e?.identifier.value,r,this.k,s,this.r?.internal,a,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$7mc=M,$=new WeakMap,E=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new y.$0N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$0N("statusBarItem.warningForeground")]]);class S{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const r={message:g};return this.b.unshift(r),this.c(),new y.$_M(()=>{const a=this.b.indexOf(r);a>=0&&(this.b.splice(a,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(g,r){this.e=new Map,this.a=g.getProxy(A.$0M.MainThreadStatusBar),this.b=r,this.c=new S(this)}$acceptStaticEntries(g){for(const r of g)this.e.set(r.entryId,r)}createStatusBarEntry(g,r,a,s){return new M(this.a,this.b,this.e,g,r,a,s)}setStatusBarMessage(g,r){const a=this.c.setMessage(g);let s;return typeof r=="number"?s=setTimeout(()=>a.dispose(),r):typeof r<"u"&&r.then(()=>a.dispose(),()=>a.dispose()),new y.$_M(()=>{a.dispose(),clearTimeout(s)})}}e.$8mc=m}),define(Ce[115],Ae([1,0,30,107,52,77,62,8,2]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.$LP=e.$KP=e.$JP=void 0;const E=(i,c,h,t)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(o){if(!h(d,o)){const f=d;d=o,i.listener?.(t(o,f))}}}},M=(i,c)=>i===c,S={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(i,c)=>!(i.length!==c.length||i.some(h=>!c.find(t=>h.id===t.id)))},m=i=>c=>({op:4,update:i(c)}),w=(i,c)=>({range:(()=>{let h;const t=m(d=>({range:y.$vt.lift(p.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return h},set(d){i.listener?.({op:6}),S.range(h,d)||(h=d,i.listener?.(t(d)))}}})(),label:E(i,c,S.label,m(h=>({label:h}))),description:E(i,void 0,S.description,m(h=>({description:h}))),sortText:E(i,void 0,S.sortText,m(h=>({sortText:h}))),canResolveChildren:E(i,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:E(i,!1,S.busy,m(h=>({busy:h}))),error:E(i,void 0,S.error,m(h=>({error:p.MarkdownString.fromStrict(h)||null}))),tags:E(i,[],S.tags,(h,t)=>({op:1,new:h.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),g=i=>{const c=C.$VL.fromString(i.extId),h=new a(c.controllerId,c.localId,i.label,$.URI.revive(i.uri)||void 0);return h.range=p.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>p.TestTag.to({id:(0,N.$2L)(t).tagId})),h},r=i=>{let c;for(const h of i.tests){const t=g(h.item);(0,A.$tP)(t).parent=c,c=t}return c};e.$JP=r;class a{constructor(c,h,t,d){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const o=(0,A.$sP)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof s?void 0:o.parent}},children:{value:(0,O.$rP)(o,A.$tP,a),enumerable:!0,writable:!1},...w(o,t)})}}e.$KP=a;class s extends a{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$LP=s;class n extends O.$nP{constructor(c,h,t){super({controllerId:c,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:A.$tP,getChildren:d=>d.children,root:new s(c,h),toITestItem:p.TestItem.from})}}e.$MP=n});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[32],Ae([1,0,15,7,8,25,4,18,12,49,30,95,2,6,3,17,115,21,35,44,66,59,63,34]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d){"use strict";var o,f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=void 0;let D=class{constructor(I,U,Q){o.set(this,void 0),this.b=new Map,this.c=new Map,f.set(this,void 0),u.set(this,void 0),_e(this,o,I.getProxy(N.$0M.MainThreadCommands),"f"),this.d=U,_e(this,u,Q,"f"),_e(this,f,I.getProxy(N.$0M.MainThreadTelemetry),"f"),this.converter=new l(this,G=>{const L=this.c.get(G);return L?.result===b.Void?L:void 0},U),this.f=[{processArgument(G){return(0,E.$6h)(G)}},{processArgument(G){return(0,O.$6n)(G,function(L){if(M.$vt.isIRange(L))return C.Range.to(L);if(S.$ut.isIPosition(L))return C.Position.to(L);if(M.$vt.isIRange(L.range)&&m.URI.isUri(L.uri))return C.location.to(L);if(L instanceof s.$Ge)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const U=this.registerCommand(!1,I.id,async(...Q)=>{const G=I.args.map((R,F)=>{if(!R.validate(Q[F]))throw new Error(`Invalid argument '${R.name}' when running '${I.id}', received: ${typeof Q[F]=="object"?JSON.stringify(Q[F],null,"	"):Q[F]} `);return R.convert(Q[F])}),L=await this.executeCommand(I.internalId,...G);return I.result.convert(L,Q,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new A.$_M(()=>{U.dispose(),this.c.delete(I.id)})}registerCommand(I,U,Q,G,L,R){if(this.d.trace("ExtHostCommands#registerCommand",U),!U.trim().length)throw new Error("invalid id");if(this.b.has(U))throw new Error(`command '${U}' already exists`);return this.b.set(U,{callback:Q,thisArg:G,metadata:L,extension:R}),I&&Be(this,o,"f").$registerCommand(U),new A.$_M(()=>{this.b.delete(U)&&I&&Be(this,o,"f").$unregisterCommand(U)})}executeCommand(I,...U){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,U,!0)}async g(I,U,Q){if(this.b.has(I))return Be(this,o,"f").$fireCommandActivationEvent(I),this.h(I,U,!1);{let G=!1;const L=(0,O.$6n)(U,function(R){if(R instanceof A.$aN)return C.Position.from(R);if(R instanceof A.$bN)return C.Range.from(R);if(R instanceof A.$lN)return C.location.from(R);if(A.$BO.isNotebookRange(R))return C.NotebookRange.from(R);if(R instanceof ArrayBuffer)return G=!0,s.$Ge.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return G=!0,s.$Ge.wrap(R);if(R instanceof s.$Ge)return G=!0,R;if(!Array.isArray(R))return R});try{const R=await Be(this,o,"f").$executeCommand(I,G?new n.$Cw(L):L,Q);return(0,E.$6h)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this.g(I,U,!1);throw R}}}async h(I,U,Q){const G=this.b.get(I);if(!G)throw new Error("Unknown command");const{callback:L,thisArg:R,metadata:F}=G;if(F?.args)for(let X=0;X<F.args.length;X++)try{(0,y.$ng)(U[X],F.args[X].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${F.args[X].name}' - ${F.args[X].description}`)}const T=c.$ae.create();try{return await L.apply(R,U)}catch(X){if(I===this.converter.delegatingCommandId){const ne=this.converter.getActualCommand(...U);ne&&(I=ne.command)}if(this.d.error(X,I,G.extension?.identifier),!Q)throw X;if(G.extension?.identifier){const ne=Be(this,u,"f").onExtensionError(G.extension.identifier,X);this.d.trace("forwarded error to extension?",ne,G.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(X)),this.id=I,this.source=G.extension?.displayName??G.extension?.name}}}finally{this.j(G,I,T.elapsed())}}j(I,U,Q){I.extension&&Be(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new h.$gp(U),duration:Q})}$executeContributedCommand(I,...U){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const Q=this.b.get(I);return Q?(U=U.map(G=>this.f.reduce((L,R)=>R.processArgument(L,Q.extension?.identifier),G)),this.h(I,U,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),Be(this,o,"f").$getCommands().then(U=>(I&&(U=U.filter(Q=>Q[0]!=="_")),U))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[U,Q]of this.b){const{metadata:G}=Q;G&&(I[U]=G)}return Promise.resolve(I)}};e.$SP=D,o=new WeakMap,f=new WeakMap,u=new WeakMap,e.$SP=D=Qe([qe(0,r.$xP),qe(1,$.$3j),qe(2,t.$RP)],D),e.$TP=(0,g.$wi)("IExtHostCommands");class l{constructor(I,U,Q){this.d=I,this.f=U,this.g=Q,this.delegatingCommandId=`__vsc${(0,d.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,U){if(!I)return;const Q={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return Q;const G=this.f(I.command);if(G)Q.id=G.internalId,Q.arguments=G.args.map((L,R)=>L.convert(I.arguments&&I.arguments[R]));else if((0,p.$Lb)(I.arguments)){const L=`${I.command} /${++this.c}`;this.b.set(L,I),U.add((0,w.$Tc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),Q.$ident=L,Q.id=this.delegatingCommandId,Q.arguments=[L],this.g.trace("CommandsConverter#CREATE",I.command,L)}return Q}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const U=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],U?U.command:"MISSING"),U?this.d.executeCommand(U.command,...U.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$UP=l;class v{static Arr(I){return new v(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,U=>Array.isArray(U)&&U.every(Q=>I.validate(Q)),U=>U.map(Q=>I.convert(Q)))}constructor(I,U,Q,G){this.name=I,this.description=U,this.validate=Q,this.convert=G}optional(){return new v(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,U){return new v(I??this.name,U??this.description,this.validate,this.convert)}}e.$VP=v,v.Uri=new v("uri","Uri of a text document",k=>m.URI.isUri(k),k=>k),v.Position=new v("position","A position in a text document",k=>A.$aN.isPosition(k),C.Position.from),v.Range=new v("range","A range in a text document",k=>A.$bN.isRange(k),C.Range.from),v.Selection=new v("selection","A selection in a text document",k=>A.$cN.isSelection(k),C.Selection.from),v.Number=new v("number","",k=>typeof k=="number",k=>k),v.String=new v("string","",k=>typeof k=="string",k=>k),v.StringArray=v.Arr(v.String),v.CallHierarchyItem=new v("item","A call hierarchy item",k=>k instanceof A.$xN,C.CallHierarchyItem.from),v.TypeHierarchyItem=new v("item","A type hierarchy item",k=>k instanceof A.$VO,C.TypeHierarchyItem.from),v.TestItem=new v("testItem","A VS Code TestItem",k=>k instanceof a.$KP,C.TestItem.from);class b{constructor(I,U){this.description=I,this.convert=U}}e.$WP=b,b.Void=new b("no result",k=>k);class P{constructor(I,U,Q,G,L){this.id=I,this.internalId=U,this.description=Q,this.args=G,this.result=L}}e.$XP=P}),define(Ce[285],Ae([1,0,18,16,2,89,98,31,32,8,7]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;const S=[new $.$XP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of DocumentHighlight-instances.",w(E.DocumentHighlight.to))),new $.$XP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$VP.Uri],new $.$WP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,y.$Kb)(r))return;class s extends M.$sN{static to(i){const c=new s(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new M.$lN(a[0],E.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=E.Range.to(i.selectionRange),c.children=i.children?i.children.map(s.to):[],c}}return r.map(s.to)})),new $.$XP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$VP.Uri,new $.$VP("options","Formatting options",r=>!0,r=>r)],new $.$WP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new $.$XP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$VP.Uri,$.$VP.Range,new $.$VP("options","Formatting options",r=>!0,r=>r)],new $.$WP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new $.$XP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$VP.Uri,$.$VP.Position,new $.$VP("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$VP("options","Formatting options",r=>!0,r=>r)],new $.$WP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new $.$XP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$XP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$XP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$XP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$XP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of Location-instances.",w(E.location.to))),new $.$XP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of Hover-instances.",w(E.Hover.to))),new $.$XP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$VP.Uri,new $.$VP("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>M.$aN.isPosition(a)),r=>r.map(E.Position.from))],new $.$WP("A promise that resolves to an array of ranges.",r=>r.map(a=>{let s;for(const n of a.reverse())s=new M.$wN(E.Range.to(n),s);return s}))),new $.$XP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$VP.String.with("query","Search string")],new $.$WP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new $.$XP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new $.$XP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$VP.CallHierarchyItem],new $.$WP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new $.$XP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$VP.CallHierarchyItem],new $.$WP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new $.$XP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new $.$XP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$VP.Uri,$.$VP.Position,$.$VP.String.with("newName","The new symbol name")],new $.$WP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new $.$XP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$VP.Uri,$.$VP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$WP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new $.$XP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$VP.Uri],new $.$WP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new M.$sO(r.tokenTypes,r.tokenModifiers)})),new $.$XP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$VP.Uri],new $.$WP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,N.$ecb)(r);if(a.type==="full")return new M.$uO(a.data,void 0)})),new $.$XP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$VP.Uri,$.$VP.Range.optional()],new $.$WP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new M.$sO(r.tokenTypes,r.tokenModifiers)})),new $.$XP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$VP.Uri,$.$VP.Range],new $.$WP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,N.$ecb)(r);if(a.type==="full")return new M.$uO(a.data,void 0)})),new $.$XP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$VP.Uri,$.$VP.Position,$.$VP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$VP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$WP("A promise that resolves to a CompletionList-instance.",(r,a,s)=>{if(!r)return new M.$IN([]);const n=r.suggestions.map(i=>E.CompletionItem.to(i,s));return new M.$IN(n,r.incomplete)})),new $.$XP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$VP.Uri,$.$VP.Position,$.$VP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$WP("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new $.$XP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$VP.Uri,$.$VP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$WP("A promise that resolves to an array of CodeLens-instances.",(r,a,s)=>w(n=>new M.$AN(E.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new $.$XP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$VP.Uri,new $.$VP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>M.$bN.isRange(r),r=>M.$cN.isSelection(r)?E.Selection.from(r):E.Range.from(r)),$.$VP.String.with("kind","Code action kind to return code actions for").optional(),$.$VP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$WP("A promise that resolves to an array of Command-instances.",(r,a,s)=>w(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new M.$uN(n.title,n.kind?new M.$vN(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new $.$XP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$VP.Uri],new $.$WP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new M.$ON(E.Range.to(a.range),E.Color.to(a.color))):[])),new $.$XP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$VP("color","The color to show and insert",r=>r instanceof M.$NN,E.Color.from),new $.$VP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new $.$WP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new $.$XP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$VP.Uri,$.$VP.Range],new $.$WP("A promise that resolves to an array of Inlay objects",(r,a,s)=>r.map(E.InlayHint.to.bind(void 0,s)))),new $.$XP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$VP.Uri],new $.$WP("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(E.FoldingRange.to)})),new $.$XP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$WP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>E.NotebookExclusiveDocumentPattern.to(a))})))),new $.$XP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$VP.Uri,$.$VP.Range,new $.$VP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof M.$bN,r=>E.InlineValueContext.from(r))],new $.$WP("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new $.$XP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$VP("uriOrString","Uri-instance or string (only http/https)",r=>C.URI.isUri(r)||typeof r=="string"&&(0,A.$Gg)(r,A.Schemas.http,A.Schemas.https),r=>r),new $.$VP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),$.$VP.String.with("label","").optional()],$.$WP.Void),new $.$XP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$VP.Uri.with("resource","Resource to open"),$.$VP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$VP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],$.$WP.Void),new $.$XP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$VP.Uri.with("left","Left-hand side resource of the diff editor"),$.$VP.Uri.with("right","Right-hand side resource of the diff editor"),$.$VP.String.with("title","Human readable title for the diff editor").optional(),new $.$VP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],$.$WP.Void),new $.$XP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$VP.String.with("title","Human readable title for the changes editor"),new $.$VP("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[s,n,i]=a;if(!C.URI.isUri(s)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],$.$WP.Void),new $.$XP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$VP.Uri,$.$VP.Position],new $.$WP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new $.$XP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$VP.TypeHierarchyItem],new $.$WP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new $.$XP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$VP.TypeHierarchyItem],new $.$WP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new $.$XP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$VP.TestItem],$.$WP.Void),new $.$XP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$VP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$WP.Void),new $.$XP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$VP.String.with("name","The context key name"),new $.$VP("value","The context key value",()=>!0,r=>r)],$.$WP.Void),new $.$XP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$VP.Uri,$.$VP.StringArray,new $.$VP("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new $.$WP("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null))];class m{static register(a){S.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",p.$vj)}}e.$qlc=m;function w(r){return a=>{if(Array.isArray(a))return a.map(r)}}function g(r){if(!Array.isArray(r))return;const a=[];for(const s of r)O.$au(s)?a.push(E.DefinitionLink.to(s)):a.push(E.location.to(s));return a}}),define(Ce[286],Ae([1,0,9,6,2,4,32,8,7]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class E{constructor(w,g){this.extension=w,this.provider=g,this.handle=E.a++}}E.a=0;class M{constructor(w){this.session=w,this.responses=[]}}class S{constructor(w,g,r,a){this.f=r,this.g=a,this.b=new Map,this.d=new Map,this.e=w.getProxy(O.$0M.MainThreadInlineChat),g.registerApiCommand(new N.$XP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new N.$VP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?p.Range.from(s.initialRange):void 0,initialSelection:$.$cN.isSelection(s.initialSelection)?p.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?p.Position.from(s.position):void 0}})],N.$WP.Void))}registerProvider(w,g,r){const a=new E(w,g);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,r?.label??w.displayName??w.name,w.identifier,typeof g.handleInteractiveEditorResponseFeedback=="function",typeof g.provideFollowups=="function",r?.supportReportIssue??!1),(0,A.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(w,g,r,a){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(C.URI.revive(g)),i=p.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=S.a++;return this.d.set(h,new M(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,g,r,a){const s=this.b.get(w);if(!s)return;const n=this.d.get(g.id);if(!n)return;const i={prompt:r.prompt,selection:p.Selection.to(r.selection),wholeRange:p.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(C.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let c=!1;const h={report:async v=>{if(!r.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:v.message,edits:v.edits?.map(p.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:$.$BN.isMarkdownString(v.content)?v.content.value:v.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,h,a));let d;try{d=await(0,y.$kh)(t,a)}finally{c=!0}if(!d)return;const o=n.responses.push(d)-1,f={wholeRange:p.Range.from(d.wholeRange),placeholder:d.placeholder};if(!S.h(d))return{...f,id:o,type:"editorEdit",message:p.MarkdownString.from(d.contents),edits:[]};const{edits:u,contents:D}=d,l=D!==void 0?p.MarkdownString.from(D):void 0;return u instanceof $.$jN?{...f,id:o,type:"bulkEdit",edits:p.WorkspaceEdit.from(u),message:l}:{...f,id:o,type:"editorEdit",edits:u.map(p.TextEdit.from),message:l}}async $provideFollowups(w,g,r,a){const s=this.b.get(w),n=this.d.get(g),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(n.session,i,a));return(await(0,y.$kh)(c,a))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(w,g,r,a){const s=this.b.get(w),n=this.d.get(g),i=n?.responses[r];if(s&&i){const c=p.InteractiveEditorResponseFeedbackKind.to(a);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,c)}}$releaseSession(w,g){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$zmc=S,S.a=0}),define(Ce[287],Ae([1,0,2,32]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class C{constructor(N,p,$,E,M){this.a=p,this.b=$,this.c=E;const S=new A.$XP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.$VP("showOptions","Show Options",m=>!0,m=>m),new A.$VP("resource","Interactive resource Uri",m=>!0,m=>m),new A.$VP("controllerId","Notebook controller Id",m=>!0,m=>m),new A.$VP("title","Interactive editor title",m=>!0,m=>m)],new A.$WP("Notebook and input URI",m=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const w=this.a.getEditorById(m.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:y.URI.revive(m.notebookUri),inputUri:y.URI.revive(m.inputUri),notebookEditor:w.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:y.URI.revive(m.notebookUri),inputUri:y.URI.revive(m.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(N,p,$,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:N,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(N,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[N]})}}e.$Mmc=C}),define(Ce[288],Ae([1,0,18,9,24,5,6,28,2,20,12,4,32,8,7,78,229,26,35,230]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0,e.$Umc=u;let c=class{constructor(l,v,b,P,k){this.m=v,this.n=b,this.o=P,this.q=k,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(S.$0M.MainThreadNotebookKernels);const I=new m.$XP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$VP("options","Select kernel options",Q=>!0,Q=>{if(Q&&"notebookEditor"in Q&&"id"in Q){const G=this.n.getIdByEditor(Q.notebookEditor);return{id:Q.id,extension:Q.extension,notebookEditorId:G}}else if(Q&&"notebookEditor"in Q){const G=this.n.getIdByEditor(Q.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${Q.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return Q})],m.$WP.Void),U=new m.$XP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[m.$VP.Uri],new m.$WP("A promise that resolves to an array of variables",(Q,G)=>Q.map(L=>({variable:{name:L.name,value:L.value,expression:L.expression,type:L.type,language:L.language},hasNamedChildren:L.hasNamedChildren,indexedChildrenCount:L.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(U)}createNotebookController(l,v,b,P,k,I){for(const se of this.j.values())if(se.controller.id===v&&E.$Sm.equals(l.identifier,se.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const U=this.k++,Q=this;this.q.trace(`NotebookController[${U}], CREATED by ${l.identifier.value}, ${v}`);const G=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${l.identifier}'`);let L=!1;const R=new O.$ee,F=new O.$ee,T={id:u(l.identifier,v),notebookType:b,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:P||l.identifier.value,preloads:I?I.map(w.NotebookRendererScript.from):[]};let X=k??G,ne,me;this.a.$addKernel(U,T).catch(se=>{console.log(se),L=!0});let we=0;const de=()=>{if(L)return;const se=++we;Promise.resolve().then(()=>{se===we&&this.a.$updateKernel(U,T)})},$e=new p.$Bc,ke={get id(){return v},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return T.label},set label(se){T.label=se??l.displayName??l.name,de()},get detail(){return T.detail??""},set detail(se){T.detail=se,de()},get description(){return T.description??""},set description(se){T.description=se,de()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(se){T.supportedLanguages=se,de()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(se){T.supportsExecutionOrder=se,de()},get rendererScripts(){return T.preloads?T.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(se){X=se??G},get interruptHandler(){return ne},set interruptHandler(se){ne=se,T.supportsInterrupt=!!se,de()},set variableProvider(se){(0,s.$PG)(l,"notebookVariableProvider"),me=se,T.hasVariableProvider=!!se,se?.onDidChangeVariables(Pe=>Q.a.$variablesUpdated(Pe.uri)),de()},get variableProvider(){return me},createNotebookCellExecution(se){if(L)throw new Error("notebook controller is DISPOSED");if(!$e.has(se.notebook.uri))throw Q.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return Q._createNotebookCellExecution(se,u(l.identifier,this.id))},createNotebookExecution(se){if((0,s.$PG)(l,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!$e.has(se.uri))throw Q.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return Q._createNotebookExecution(se,u(l.identifier,this.id))},dispose:()=>{L||(this.q.trace(`NotebookController[${U}], DISPOSED`),L=!0,this.j.delete(U),R.dispose(),F.dispose(),this.a.$removeKernel(U))},updateNotebookAffinity(se,Pe){Pe===g.NotebookControllerAffinity2.Hidden&&(0,s.$PG)(l,"notebookControllerAffinityHidden"),Q.a.$updateNotebookPriority(U,se.uri,Pe)},onDidReceiveMessage:F.event,postMessage(se,Pe){return(0,s.$PG)(l,"notebookMessaging"),Q.a.$postMessage(U,Pe&&Q.n.getIdByEditor(Pe),se)},asWebviewUri(se){return(0,s.$PG)(l,"notebookMessaging"),(0,r.$1Ab)(se,Q.m.remote)}};return this.j.set(U,{extensionId:l.identifier,controller:ke,onDidReceiveMessage:F,onDidChangeSelection:R,associatedNotebooks:$e}),ke}getIdByController(l){for(const[v,b]of this.j)if(b.controller===l)return u(b.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,v){const b=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(b,v);const k={dispose:()=>{this.f.delete(b),P.a.$removeKernelDetectionTask(b)}};return this.f.set(b,k),k}registerKernelSourceActionProvider(l,v,b){const P=this.i++,k=typeof b.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,I=this;this.h.set(P,b),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,v);let U;return k!==void 0&&(U=b.onDidChangeNotebookKernelSourceActions(Q=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(P),I.a.$removeKernelSourceActionProvider(P,P),U?.dispose()}}}async $provideKernelSourceActions(l,v){const b=this.h.get(l);if(b){const P=new N.$Uc;return(await b.provideNotebookKernelSourceActions(v)??[]).map(I=>w.NotebookKernelSourceAction.from(I,this.o.converter,P))}return[]}$acceptNotebookAssociation(l,v,b){const P=this.j.get(l);if(P){const k=this.n.getNotebookDocument($.URI.revive(v));b?P.associatedNotebooks.set(k.uri,!0):P.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,k.uri.toString(),b),P.onDidChangeSelection.fire({selected:b,notebook:k.apiNotebook})}}async $executeCells(l,v,b){const P=this.j.get(l);if(!P)return;const k=this.n.getNotebookDocument($.URI.revive(v)),I=[];for(const U of b){const Q=k.getCell(U);Q&&I.push(Q.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,k.uri.toString(),I.length),await P.controller.executeHandler.call(P.controller,I,k.apiNotebook,P.controller)}catch(U){this.q.error(`NotebookController[${l}] execute cells FAILED`,U),console.error(U)}}async $cancelCells(l,v,b){const P=this.j.get(l);if(!P)return;const k=this.n.getNotebookDocument($.URI.revive(v));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,k.apiNotebook);else for(const I of b){const U=k.getCell(I);U&&this.b.get(U.uri)?.cancel()}if(P.controller.interruptHandler){const I=this.c.get(k.uri);b.length&&Array.isArray(I)&&I.length&&I.forEach(U=>U.dispose())}}async $provideVariables(l,v,b,P,k,I,U){const Q=this.j.get(l);if(!Q)return;const G=this.n.getNotebookDocument($.URI.revive(b)),L=Q.controller.variableProvider;if(!L)return;let R;if(P!==void 0){if(R=this.s[P],!R)return}else this.s={};const F=k==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,T=L.provideVariables(G.apiNotebook,R,F,I,U);let X=0;for await(const ne of T){if(U.isCancellationRequested)return;const me={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,interfaces:ne.variable.interfaces,language:ne.variable.language,expression:ne.variable.expression,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:Q.extensionId.value};if(this.s[me.id]=ne.variable,this.a.$receiveVariable(v,me),X++>=i.$ljb)return}}$acceptKernelMessageFromRenderer(l,v,b){const P=this.j.get(l);if(!P)return;const k=this.n.getEditorById(v);P.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:b}))}$cellExecutionChanged(l,v,b){const k=this.n.getNotebookDocument($.URI.revive(l)).getCell(v);if(k){const I=b?w.NotebookCellExecutionState.to(b):g.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:k.apiCell,state:I})}}_createNotebookCellExecution(l,v){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const k=new t(v,P,this.a);this.b.set(P.uri,k);const I=k.onDidChangeState(()=>{k.state===h.Resolved&&(k.dispose(),I.dispose(),this.b.delete(P.uri))});return k.asApiObject()}_createNotebookExecution(l,v){const b=this.n.getNotebookDocument(l.uri),P=l.getCells().find(U=>{const Q=b.getCellFromApiCell(U);return Q&&this.b.has(Q.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const k=new o(v,b,this.a),I=k.onDidChangeState(()=>{k.state===d.Resolved&&(k.dispose(),I.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[k,I]),k.asApiObject()}};e.$Tmc=c,e.$Tmc=c=Qe([qe(4,M.$3j)],c);var h;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(h||(h={}));class t extends N.$Vc{get state(){return this.f}constructor(l,v,b){super(),this.m=v,this.n=b,this.b=t.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new C.$pe),this.h=new f(10,P=>this.s(P)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const v=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new n.$Cw(v))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let v=this.m;if(l&&(v=this.m.notebook.getCellFromApiCell(l)),!v)throw new Error("INVALID cell");return v.handle}y(l){return l.map(v=>{const b=g.$FO.ensureUniqueMimeTypes(v.items,!0);return b===v.items?w.NotebookCellOutput.from(v):w.NotebookCellOutput.from({items:b,id:v.id,metadata:v.metadata})})}async z(l,v,b){const P=this.w(v),k=this.y((0,y.$3b)(l));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:P,append:b,outputs:k})}async C(l,v,b){return l=g.$FO.ensureUniqueMimeTypes((0,y.$3b)(l),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:l.map(w.NotebookCellOutputItem.from),outputId:v.id,append:b})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(b){l.j=b,l.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(b){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,P,k){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const I=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;l.n.$completeExecution(l.b,new n.$Cw({runEndTime:P,lastRunSuccess:b,error:I}))},clearOutput(b){return l.t(),l.z([],b,!1)},appendOutput(b,P){return l.t(),l.z(b,P,!0)},replaceOutput(b,P){return l.t(),l.z(b,P,!1)},appendOutputItems(b,P){return l.t(),l.C(b,P,!0)},replaceOutputItems(b,P){return l.t(),l.C(b,P,!1)}})}}t.a=0;var d;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(d||(d={}));class o extends N.$Vc{get state(){return this.f}constructor(l,v,b){super(),this.h=v,this.j=b,this.b=o.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new C.$pe),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}o.a=0;class f{constructor(l,v){this.f=l,this.g=v,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new A.$Th,this.b=Date.now(),(0,A.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>l.complete())}}function u(D,l){return`${D.value}/${l}`}}),define(Ce[53],Ae([1,0,5,4,3,2,17,6,7,180,14,208,24,34,209,36,9,8,32]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=e.$6lc=e.$5lc=void 0,e.$5lc=(0,C.$wi)("IExtHostTerminalService");class i extends p.$Vc{constructor(b,P,k,I){super(),this.u=b,this._id=P,this.w=k,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new y.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(Q=>this.g=Q);const U=this;this.value={get name(){return U.y||""},get processId(){return U.b},get creationOptions(){return U.w},get exitStatus(){return U.j},get state(){return U.m},get selection(){return U.n},get shellIntegration(){return U.shellIntegration},sendText(Q,G=!0){U.C(),U.u.$sendText(U._id,Q,G)},show(Q){U.C(),U.u.$show(U._id,Q)},hide(){U.C(),U.u.$hide(U._id)},dispose(){U.a||(U.a=!0,U.u.$dispose(U._id))},get dimensions(){if(!(U.f===void 0||U.h===void 0))return{columns:U.f,rows:U.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??P?.cwd??void 0,env:b.env??void 0,icon:u(b.iconPath)??void 0,color:r.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:P?.forceShellIntegration??void 0,isFeatureTerminal:P?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:P?.useShellEnvironment??void 0,location:P?.location||this.z(b.location,P?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,P,k,I,U){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:r.ThemeColor.isThemeColor(U)?U.id:void 0,location:P?.location||this.z(b,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,P){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&P?{parentTerminal:P}:"viewColumn"in b?{viewColumn:s.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,P){this.j=Object.freeze({code:b,reason:P})}setDimensions(b,P){return b===this.f&&P===this.h||b===0||P===0?!1:(this.f=b,this.h=P,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(P=>{P!==b&&(this.b=Promise.resolve(b))})}}e.$6lc=i;class c{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new y.$ee,this.onProcessData=this.a.event,this.b=new y.$ee,this.d=new y.$ee,this.onDidChangeProperty=this.d.event,this.f=new y.$ee,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,P){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${P}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,P){this.g.setDimensions?.({columns:b,rows:P})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(P=>this.a.fire(P)),this.g.onDidClose?.((P=void 0)=>{this.f.fire(P===void 0?void 0:P)}),this.g.onDidOverrideDimensions?.(P=>{P&&this.d.fire({type:"overrideDimensions",value:{cols:P.columns,rows:P.rows}})}),this.g.onDidChangeName?.(P=>{this.d.fire({type:"title",value:P})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends p.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,P,k){super(),this.Q=P,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$ee,this.onDidCloseTerminal=this.H.event,this.I=new y.$ee,this.onDidOpenTerminal=this.I.event,this.J=new y.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new y.$ee,this.onDidChangeShell=this.N.event,this.O=new y.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(A.$0M.MainThreadTerminalService),this.y=new g.$Svb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:I=>{const U=Q=>{const G=Q;return this.getTerminalById(G.instanceId)?.value};switch(I?.$mid){case 15:return U(I);default:{if(Array.isArray(I))for(let Q=0;Q<I.length&&I[Q].$mid===15;Q++)I[Q]=U(I[Q]);return I}}}}),this.B({dispose:()=>{for(const[I,U]of this.g)U.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,P){const k=new i(this.a,(0,w.$Sg)(),b,b.name),I=new c(b.pty);return k.createExtensionTerminal(b.location,P,this.R(b,P).resolvedExtHostIdentifier,u(b.iconPath),D(b.color)).then(U=>{const Q=this.S(U,I);this.h[U]=Q}),this.f.push(k),k.value}R(b,P){if(P=P||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const k=b.location.parentTerminal;if(k){const I=this.f.find(U=>U.value===k);I&&(P.resolvedExtHostIdentifier=I._id)}}else b.location&&typeof b.location!="object"?P.location=b.location:P.location&&typeof P.location=="object"&&"splitActiveTerminal"in P.location&&(P.location={splitActiveTerminal:!0});return P}attachPtyToTerminal(b,P){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const I=new c(P),U=this.S(b,I);this.h[b]=U}async $acceptActiveTerminalChanged(b){const P=this.b;if(b===null){this.b=void 0,P!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(b);k&&(this.b=k,P!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,P){const k=this.getTerminalById(b);k&&this.O.fire({terminal:k.value,data:P})}async $acceptTerminalDimensions(b,P,k){const I=this.getTerminalById(b);I&&I.setDimensions(P,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(b,P){const k=this.getTerminalById(b);k&&this.P.fire({terminal:k.value,...P})}async $acceptTerminalMaximumDimensions(b,P,k){this.g.get(b)?.resize(P,k)}async $acceptTerminalTitleChange(b,P){const k=this.getTerminalById(b);k&&(k.name=P)}async $acceptTerminalClosed(b,P,k){const I=this.X(this.f,b);if(I!==null){const U=this.f.splice(I,1)[0];U.setExitStatus(P,k),this.H.fire(U.value)}}$acceptTerminalOpened(b,P,k,I){if(P){const G=this.X(this.f,P);if(G!==null){this.f[G]._id=b,this.I.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const U={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:O.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},Q=new i(this.a,b,U,k);this.f.push(Q),this.I.fire(Q.value),Q.isOpen=!0}async $acceptTerminalProcessId(b,P){this.getTerminalById(b)?._setProcessId(P)}async $startExtensionTerminal(b,P){const k=this.getTerminalById(b);if(!k)return{message:(0,E.localize)(0,null,b)};k.isOpen||await new Promise(U=>{const Q=this.onDidOpenTerminal(async G=>{G===k.value&&(Q.dispose(),U())})});const I=this.g.get(b);I?I.startSendingEvents(P):this.j[b]={initialDimensions:P}}S(b,P){const k=new p.$Uc;k.add(P.onProcessReady(U=>this.a.$sendProcessReady(b,U.pid,U.cwd,U.windowsPty))),k.add(P.onDidChangeProperty(U=>this.a.$sendProcessProperty(b,U))),this.y.startBuffering(b,P.onProcessData),k.add(P.onProcessExit(U=>this.U(b,U))),this.g.set(b,P);const I=this.j[b];return I&&P instanceof c&&(P.startSendingEvents(I.initialDimensions),delete this.j[b]),k}$acceptProcessAckDataEvent(b,P){this.g.get(b)?.acknowledgeDataEvent(P)}$acceptProcessInput(b,P){this.g.get(b)?.input(P)}$acceptTerminalInteraction(b){const P=this.getTerminalById(b);P?.setInteractedWith()&&this.M.fire(P.value)}$acceptTerminalSelection(b,P){this.getTerminalById(b)?.setSelection(P)}$acceptProcessResize(b,P,k){try{this.g.get(b)?.resize(P,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(b,P){this.g.get(b)?.shutdown(P)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(P=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:P}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(P=>this.a.$sendProcessProperty(b,{type:"cwd",value:P}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$_M(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,P,k){if(this.C.has(P))throw new Error(`Terminal profile provider "${P}" already registered`);return this.C.set(P,k),this.a.$registerProfileProvider(P,b.identifier.value),new $.$_M(()=>{this.C.delete(P),this.a.$unregisterProfileProvider(P)})}registerTerminalQuickFixProvider(b,P,k){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,k),this.a.$registerQuickFixProvider(b,P),new $.$_M(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,P){const k=new m.$pe().token;if(k.isCancellationRequested)return;const I=this.D.get(b);if(!I)return;const U=await I.provideTerminalQuickFixes(P,k);if(U===null||Array.isArray(U)&&U.length===0)return;const Q=new p.$Uc;if(this.w.value=Q,!Array.isArray(U))return U?s.TerminalQuickFix.from(U,this.Q.converter,Q):void 0;const G=[];for(const L of U){const R=s.TerminalQuickFix.from(L,this.Q.converter,Q);R&&G.push(R)}return G}async $createContributedProfileTerminal(b,P){const k=new m.$pe().token;let I=await this.C.get(b)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,P);return}this.createTerminalFromOptions(I.options,P)}}async $provideLinks(b,P){const k=this.getTerminalById(b);if(!k)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const U=new m.$pe;this.G.set(b,U);const Q=[],G={terminal:k.value,line:P},L=[];for(const T of this.z)L.push(a.Promises.withAsyncBody(async X=>{U.token.onCancellationRequested(()=>X({provider:T,links:[]}));const ne=await T.provideTerminalLinks(G,U.token)||[];U.token.isCancellationRequested||X({provider:T,links:ne})}));const R=await Promise.all(L);if(U.token.isCancellationRequested)return[];const F=new Map;for(const T of R)T&&T.links.length>0&&Q.push(...T.links.map(X=>{const ne={id:h++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return F.set(ne.id,{provider:T.provider,link:X}),ne}));return this.F.set(b,F),Q}$activateLink(b,P){const k=this.F.get(b)?.get(P);k&&k.provider.handleTerminalLink(k.link)}U(b,P){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const k=this.h[b];k&&(k.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,P)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const P=this.f.findIndex(k=>k.value===b);return P>=0?P:null}W(b,P){const k=this.X(b,P);return k!==null?b[k]:null}X(b,P){const k=b.findIndex(I=>I._id===P);return k>=0?k:null}getEnvironmentVariableCollection(b){let P=this.n.get(b.identifier.value);return P||(P=new d,this.Z(b.identifier.value,P)),P.getScopedEnvironmentVariableCollection(void 0)}Y(b,P){const k=(0,S.$ms)(P.map),I=(0,S.$ns)(P.descriptionMap);this.a.$setEnvironmentVariableCollection(b,P.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(b){b.forEach(P=>{const k=P[0],I=new d(P[1]);this.Z(k,I)})}$acceptDefaultProfile(b,P){const k=this.s;this.s=b,this.u=P,k?.path!==b.path&&this.N.fire(b.path)}Z(b,P){this.n.set(b,P),P.onDidChangeCollection(()=>{this.Y(b,P)})}};e.$7lc=t,e.$7lc=t=Qe([qe(1,n.$TP),qe(2,N.$xP)],t);class d{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$ee,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const P=this.h(b);let k=this.a.get(P);return k||(k=new o(this,b),this.a.set(P,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(b,P,k,I){this.f(b,{value:P,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(b,P,k,I){this.f(b,{value:P,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(b,P,k,I){this.f(b,{value:P,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(b,P){if(P.options&&P.options.applyAtProcessCreation===!1&&!P.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(b,P.scope),I=this.map.get(k),U=P.options?{applyAtProcessCreation:P.options.applyAtProcessCreation??!1,applyAtShellIntegration:P.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==P.value||I.type!==P.type||I.options?.applyAtProcessCreation!==U.applyAtProcessCreation||I.options?.applyAtShellIntegration!==U.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==P.scope?.workspaceFolder?.index){const Q=this.g(b,P.scope),G={variable:b,...P,options:U};this.map.set(Q,G),this.d.fire()}}get(b,P){const k=this.g(b,P),I=this.map.get(k);return I?l(I):void 0}g(b,P){const k=this.h(P);return k.length?`${b}:::${k}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const P=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(b)&&P.set(I.variable,l(I));return P}delete(b,P){const k=this.g(b,P);this.map.delete(k),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[P,k]of this.map)k.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(P);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,P){const k=this.h(P),I=this.descriptionMap.get(k);if(!I||I.description!==b){let U;typeof b=="string"?U=b:U=b?.value.split(`

`)[0];const Q={description:U,scope:P};this.descriptionMap.set(k,Q),this.d.fire()}}getDescription(b){const P=this.h(b);return this.descriptionMap.get(P)?.description}k(b){const P=this.h(b);this.descriptionMap.delete(P)}}class o{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,P){this.b=b,this.d=P,this.a=new y.$ee}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,P,k){this.b.replace(b,P,k,this.d)}append(b,P,k){this.b.append(b,P,k,this.d)}prepend(b,P,k){this.b.prepend(b,P,k,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,P){this.b.getVariableMap(this.d).forEach((k,I)=>b.call(P,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends t{constructor(b,P){super(!1,b,P)}createTerminal(b,P,k){throw new M.$_}createTerminalFromOptions(b,P){throw new M.$_}};e.$8lc=f,e.$8lc=f=Qe([qe(0,n.$TP),qe(1,N.$xP)],f);function u(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function D(v){return r.ThemeColor.isThemeColor(v)?v:void 0}function l(v){const b={...v};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Ce[116],Ae([1,0,7,6,3,4,17,53,5,2,9]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,C.$wi)("IExtHostTerminalShellIntegration");let S=class extends A.$Vc{constructor(a,s){super(),this.h=s,this.b=new Map,this.c=new $.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(O.$0M.MainThreadTerminalShellIntegration),this.B((0,A.$Tc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(a){const s=this.h.getTerminalById(a);if(!s)return;const n=s.value;let i=this.b.get(a);i||(i=new m(s.value,this.f),this.b.set(a,i),i.store.add(s.onWillDispose(()=>this.b.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(c=>this.a.$executeCommand(a,c))),i.store.add(i.onDidRequestEndExecution(c=>this.g.fire(c))),i.store.add(i.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),s.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(a,s,n,i,c){this.b.has(a)||this.$shellIntegrationChange(a);const h={value:s,confidence:n,isTrusted:i};this.b.get(a)?.startShellExecution(h,c)}$shellExecutionEnd(a,s,n,i,c){const h={value:s,confidence:n,isTrusted:i};this.b.get(a)?.endShellExecution(h,c)}$shellExecutionData(a,s){this.b.get(a)?.emitData(s)}$cwdChange(a,s){this.b.get(a)?.setCwd((0,E.$wc)(s)?E.URI.revive(s):s)}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$anc=S,e.$anc=S=Qe([qe(0,N.$xP),qe(1,p.$5lc)],S);class m extends A.$Vc{get currentExecution(){return this.a}constructor(a,s){super(),this.j=a,this.m=s,this.b=!1,this.store=this.B(new A.$Uc),this.f=this.B(new $.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$ee),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,c){let h=i;c&&(h+=` "${c.map(o=>`${o.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(h);const t={value:h,confidence:y.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},d=n.startShellExecution(t,n.c,!0).value;return n.b=!0,d}}}startShellExecution(a,s,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new w(a,s);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,s){this.a&&(this.a.endExecution(a),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(a){let s=!1;E.URI.isUri(this.c)?s=!E.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(s=!0),s&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(a,s){this.c=a,this.cwd=s,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return M.$Wh.EMPTY;this.a=new g}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class g extends A.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new M.$vh);const a=this.a;return new M.$Wh(async n=>{this.b.push(n),await a.wait()})}emitData(a){for(const s of this.b)s.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}});var Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)},_e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y};define(Ce[289],Ae([1,0,9,21,24,5,261,73,6,15,34,12,4,17,115,8,7,52,77,62]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i){"use strict";var c,h,t,d,o;Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=e.$cnc=e.$bnc=void 0;let f=class extends $.$Vc{constructor(F,T,X,ne){super(),this.w=ne,this.f=this.B(new O.$ee),this.g=new Map,this.s=this.B(new O.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(m.$0M.MainThreadTesting),this.m=new U(this.h),this.j=new v(this.h,T),X.registerArgumentProcessor({processArgument:me=>{switch(me?.$mid){case 16:{const we=me,de=we.tests[we.tests.length-1].item.extId;return this.g.get(s.$VL.root(de))?.collection.tree.get(de)?.actual??(0,g.$JP)(me)}case 18:{const{test:we,message:de}=me,$e=we.item.extId;return{test:this.g.get(s.$VL.root($e))?.collection.tree.get($e)?.actual??(0,g.$JP)({$mid:16,tests:[we]}),message:r.TestMessage.to(de)}}default:return me}}}),X.registerCommand(!1,"testing.getExplorerSelection",async()=>{const me=await X.executeCommand("_testing.getExplorerSelection"),we=de=>{const $e=this.g.get(s.$VL.root(de));if($e)return s.$VL.isRoot(de)?$e.controller:$e.collection.tree.get(de)?.actual};return{include:me?.include.map(we).filter(E.$eg)||[],exclude:me?.exclude.map(we).filter(E.$eg)||[]}})}createTestController(F,T,X,ne){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const me=new $.$Uc,we=me.add(new g.$MP(T,X,this.w));we.root.label=X;const de=new Map,$e=new Set,ke=this.h,se={items:we.root.children,get label(){return X},set label(re){X=re,we.root.label=re,ke.$updateController(T,{label:X})},get refreshHandler(){return ne},set refreshHandler(re){ne=re,ke.$updateController(T,{canRefresh:!!re})},get id(){return T},createRunProfile:(re,H,he,Fe,pe,be)=>{let ge=(0,p.$kj)(re);for(;de.has(ge);)ge++;return new G(this.h,de,$e,this.s.event,T,ge,re,H,he,Fe,pe,be)},createTestItem(re,H,he){return new g.$KP(T,re,H,he)},createTestRun:(re,H,he=!0)=>this.j.createTestRun(T,we,re,H,he),invalidateTestResults:re=>{if(re===void 0)this.h.$markTestRetired(void 0);else{const H=re instanceof Array?re:[re];this.h.$markTestRetired(H.map(he=>s.$VL.fromExtHostTestItem(he,T).toString()))}},set resolveHandler(re){we.resolveHandler=re},get resolveHandler(){return we.resolveHandler},dispose:()=>{me.dispose()}};ke.$registerTestController(T,X,!!ne),me.add((0,$.$Tc)(()=>ke.$unregisterTestController(T)));const Pe={controller:se,collection:we,profiles:de,extension:F,activeProfiles:$e};return this.g.set(T,Pe),me.add((0,$.$Tc)(()=>this.g.delete(T))),me.add(we.onDidGenerateDiff(re=>ke.$publishDiff(T,re.map(i.TestsDiffOp.serialize)))),se}createTestObserver(){return this.m.checkout()}async runTests(F,T=C.CancellationToken.None){const X=b(F);if(!X)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ne=this.g.get(X.controllerId);if(!ne)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:F.preserveFocus??!0,targets:[{testIds:F.include?.map(me=>s.$VL.fromExtHostTestItem(me,ne.collection.root.id).toString())??[ne.collection.root.id],profileGroup:L[X.kind],profileId:X.profileId,controllerId:X.controllerId}],exclude:F.exclude?.map(me=>me.id)},T)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,T){return(await this.j.getCoverageDetails(F,T))?.map(r.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,T){this.g.get(F)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(F){const T=new Map;for(const[X,ne]of Object.entries(F)){const me=this.g.get(X);if(!me)continue;const we=new Map,de=ne.filter(ke=>!me.activeProfiles.has(ke)),$e=[...me.activeProfiles].filter(ke=>!ne.includes(ke));for(const ke of de)we.set(ke,!0),me.activeProfiles.add(ke);for(const ke of $e)we.set(ke,!1),me.activeProfiles.delete(ke);we.size&&T.set(X,we)}this.s.fire(T)}async $refreshTests(F,T){await this.g.get(F)?.controller.refreshHandler?.(T)}$publishTestResults(F){this.results=Object.freeze(F.map(r.TestResults.to).concat(this.results).sort((T,X)=>X.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,T){const X=this.g.get(s.$VL.fromString(F).controllerId)?.collection;X&&(await X.expand(F,T<0?1/0:T),X.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(T=>i.TestsDiffOp.deserialize({asCanonicalUri:X=>X},T)))}async $runControllerTests(F,T){return Promise.all(F.map(X=>this.y(X,!1,T)))}async $startContinuousRun(F,T){const X=new C.$pe(T),ne=await Promise.all(F.map(me=>this.y(me,!0,X.token)));return!T.isCancellationRequested&&!ne.some(me=>me.error)&&await new Promise(me=>T.onCancellationRequested(me)),X.dispose(!0),ne}async y(F,T,X){const ne=this.g.get(F.controllerId);if(!ne)return{};const{collection:me,profiles:we}=ne,de=we.get(F.profileId);if(!de)return{};const $e=F.testIds.map(re=>me.tree.get(re)).filter(E.$eg),ke=F.excludeExtIds.map(re=>ne.collection.tree.get(re)).filter(E.$eg).filter(re=>$e.some(H=>H.fullId.compare(re.fullId)===2));if(!$e.length)return{};const se=new a.$MO($e.some(re=>re.actual instanceof g.$LP)?void 0:$e.map(re=>re.actual),ke.map(re=>re.actual),de,T),Pe=(0,i.$YL)(F)&&this.j.prepareForMainThreadTestRun(se,P.fromInternal(F,ne.collection),de,X);try{return await de.runHandler(se,X),{}}catch(re){return{error:String(re)}}finally{Pe&&Pe.hasRunningTasks&&!X.isCancellationRequested&&await O.Event.toPromise(Pe.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$bnc=f,e.$bnc=f=Qe([qe(0,w.$xP),qe(1,S.$3j)],f);const u=1e4;var D;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(D||(D={}));class l extends $.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(F,T,X,ne,me){super(),this.y=F,this.z=T,this.C=X,this.D=ne,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$pe(me));const we=this.B(new y.$Ih(()=>this.F(),u));this.B(this.j.token.onCancellationRequested(()=>we.schedule()));const de=new O.$ee;this.s=de.event,this.B((0,$.$Tc)(()=>{de.fire(),de.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(F,T){const[,X,ne]=s.$VL.fromString(F).path,me=this.w.get(ne);if(!me)return[];const we=this.g.get(X);if(!we)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(we.run,me,T)??[]}createRun(F){const T=this.y.id,X=this.y.controllerId,ne=(0,M.$Sg)(),me=ke=>(se,...Pe)=>{if(de){this.C.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.y.isIncluded(se)&&(this.H(se),ke(se,...Pe))},we=(ke,se)=>{const Pe=se instanceof Array?se.map(r.TestMessage.from):[r.TestMessage.from(se)];if(ke.uri&&ke.range){const re={range:r.Range.from(ke.range),uri:ke.uri};for(const H of Pe)H.location=H.location||re}this.z.$appendTestMessagesInRun(T,ne,s.$VL.fromExtHostTestItem(ke,X).toString(),Pe)};let de=!1;const $e={isPersisted:this.y.isPersisted,token:this.j.token,name:F,onDidDispose:this.s,addCoverage:ke=>{const se=ke.uri.toString(),Pe=new s.$VL([T,ne,se]).toString();this.w.set(se,ke),this.z.$appendCoverage(T,ne,r.TestCoverage.fromFile(Pe,ke))},enqueued:me(ke=>{this.z.$updateTestStateInRun(T,ne,s.$VL.fromExtHostTestItem(ke,X).toString(),1)}),skipped:me(ke=>{this.z.$updateTestStateInRun(T,ne,s.$VL.fromExtHostTestItem(ke,X).toString(),5)}),started:me(ke=>{this.z.$updateTestStateInRun(T,ne,s.$VL.fromExtHostTestItem(ke,X).toString(),2)}),errored:me((ke,se,Pe)=>{we(ke,se),this.z.$updateTestStateInRun(T,ne,s.$VL.fromExtHostTestItem(ke,X).toString(),6,Pe)}),failed:me((ke,se,Pe)=>{we(ke,se),this.z.$updateTestStateInRun(T,ne,s.$VL.fromExtHostTestItem(ke,X).toString(),4,Pe)}),passed:me((ke,se)=>{this.z.$updateTestStateInRun(T,ne,s.$VL.fromExtHostTestItem(ke,this.y.controllerId).toString(),3,se)}),appendOutput:(ke,se,Pe)=>{de||(Pe&&(this.y.isIncluded(Pe)?this.H(Pe):Pe=void 0),this.z.$appendOutputToRun(T,ne,A.$Ge.fromString(ke),se&&r.location.from(se),Pe&&s.$VL.fromExtHostTestItem(Pe,X).toString()))},end:()=>{de||(de=!0,this.z.$finishedTestRunTask(T,ne),--this.f||this.G())}};return this.f++,this.g.set(ne,{run:$e}),this.z.$startedTestRunTask(T,{id:ne,name:F,running:!0}),$e}F(){for(const{run:F}of this.g.values())F.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(F){if(!(F instanceof g.$KP))throw new n.$pP(F.id);if(this.h.has(s.$VL.fromExtHostTestItem(F,this.y.controllerId).toString()))return;const T=[],X=this.y.colllection.root;for(;;){const ne=r.TestItem.from(F);if(T.unshift(ne),this.h.has(ne.extId)||(this.h.add(ne.extId),F===X))break;F=F.parent||X}this.z.$addTestsToRun(this.y.controllerId,this.y.id,T)}dispose(){this.G(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(F,T){this.g=F,this.h=T,this.c=new Map,this.f=new Map}getCoverageDetails(F,T){const X=s.$VL.root(F);return this.f.get(X)?.getCoverageDetails(F,T)||[]}disposeTestRun(F){this.f.get(F)?.dispose(),this.f.delete(F);for(const[T,{id:X}]of this.c)X===F&&this.c.delete(T)}prepareForMainThreadTestRun(F,T,X,ne){return this.j(F,T,X,ne)}cancelRunById(F){this.f.get(F)?.cancel()}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,T,X,ne,me){const we=this.c.get(X);if(we)return we.createRun(ne);const de=P.fromPublic(F,T,X,me),$e=b(X);this.g.$startedExtensionTestRun({controllerId:F,continuous:!!X.continuous,profile:$e&&{group:L[$e.kind],id:$e.profileId},exclude:X.exclude?.map(se=>s.$VL.fromExtHostTestItem(se,T.root.id).toString())??[],id:de.id,include:X.include?.map(se=>s.$VL.fromExtHostTestItem(se,T.root.id).toString())??[T.root.id],preserveFocus:X.preserveFocus??!0,persist:me});const ke=this.j(X,de,X.profile);return O.Event.once(ke.onEnd)(()=>{this.g.$finishedExtensionTestRun(de.id)}),ke.createRun(ne)}j(F,T,X,ne){const me=new l(T,this.g,this.h,X,ne);return this.c.set(F,me),this.f.set(me.id,me),me}}e.$cnc=v;const b=R=>{if(R.profile){if(!(R.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class P{static fromPublic(F,T,X,ne){return new P(F,(0,M.$Sg)(),X.include?.map(me=>s.$VL.fromExtHostTestItem(me,F).toString())??[F],X.exclude?.map(me=>s.$VL.fromExtHostTestItem(me,F).toString())??[],ne,T)}static fromInternal(F,T){return new P(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,T)}constructor(F,T,X,ne,me,we){this.controllerId=F,this.id=T,this.isPersisted=me,this.colllection=we,this.c=X.map(de=>de+"\0"),this.f=ne.map(de=>de+"\0")}isIncluded(F){const T=s.$VL.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const X of this.f)if(T===X||T.startsWith(X))return!1;for(const X of this.c)if(T===X||T.startsWith(X))return!0;return!1}}e.$dnc=P;class k{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,r.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const T=s.$VL.parentId(F.item.extId);if(T&&this.h.has(T.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:T,g:X}=this;return{get added(){return[...F].map(ne=>ne.revived)},get updated(){return[...T].map(ne=>ne.revived)},get removed(){return[...X].map(ne=>ne.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class I extends i.$5L{constructor(){super(...arguments),this.s=new O.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,T){return{...F,revived:r.TestItem.toPlain(F.item),depth:T?T.depth+1:0,children:new Set}}v(){return new k(this.s)}}class U{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(T=>T.revived)},dispose:(0,N.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new I({asCanonicalUri:T=>T});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const Q=(R,F,T,X)=>{T?Object.assign(T,X):F.$updateTestRunConfig(R.controllerId,R.profileId,X)};class G{get label(){return this.f}set label(F){F!==this.f&&(this.f=F,Q(this,Be(this,c,"f"),Be(this,d,"f"),{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,Q(this,Be(this,c,"f"),Be(this,d,"f"),{supportsContinuousRun:F}))}get isDefault(){return Be(this,h,"f").has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?Be(this,h,"f").add(this.profileId):Be(this,h,"f").delete(this.profileId),Q(this,Be(this,c,"f"),Be(this,d,"f"),{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Q(this,Be(this,c,"f"),Be(this,d,"f"),{tag:F?r.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,Q(this,Be(this,c,"f"),Be(this,d,"f"),{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return O.Event.chain(Be(this,t,"f"),F=>F.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(E.$eg))}constructor(F,T,X,ne,me,we,de,$e,ke,se=!1,Pe=void 0,re=!1){this.controllerId=me,this.profileId=we,this.f=de,this.kind=$e,this.runHandler=ke,this._tag=Pe,this.g=re,c.set(this,void 0),h.set(this,void 0),t.set(this,void 0),d.set(this,void 0),o.set(this,void 0),_e(this,c,F,"f"),_e(this,o,T,"f"),_e(this,h,X,"f"),_e(this,t,ne,"f"),T.set(we,this);const H=L[$e];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);se&&X.add(we),_e(this,d,{profileId:we,controllerId:me,tag:Pe?r.TestTag.namespace(this.controllerId,Pe.id):null,label:de,group:H,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:re},"f"),queueMicrotask(()=>{Be(this,d,"f")&&(Be(this,c,"f").$publishTestRunProfile(Be(this,d,"f")),_e(this,d,void 0,"f"))})}dispose(){Be(this,o,"f")?.delete(this.profileId)&&(_e(this,o,void 0,"f"),Be(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)),_e(this,d,void 0,"f")}}e.$enc=G,c=new WeakMap,h=new WeakMap,t=new WeakMap,d=new WeakMap,o=new WeakMap;const L={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Ce[117],Ae([1,0,57,14,91,8,7]),function(ee,e,y,A,C,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.$FP=e.$EP=void 0;class p{constructor(m,w,g){const r=p.c.nextId();m.$registerTextEditorDecorationType(w.identifier,r,O.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){m.$removeTextEditorDecorationType(r)}})}}e.$EP=p,p.c=new C.$CP("TextEditorDecorationType");class ${constructor(m,w){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,w){this.k();let g=null;if(m instanceof N.$aN)g=new N.$bN(m,m);else if(m instanceof N.$bN)g=m;else throw new Error("Unrecognized location");this.l(g,w,!1)}insert(m,w){this.k(),this.l(new N.$bN(m,m),w,!0)}delete(m){this.k();let w=null;if(m instanceof N.$bN)w=m;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(m,w,g){const r=this.c.validateRange(m);this.g.push({range:r,text:w,forceMoveMarkers:g})}setEndOfLine(m){if(this.k(),m!==N.EndOfLine.LF&&m!==N.EndOfLine.CRLF)throw(0,A.$7)("endOfLine");this.h=m}}class E{constructor(m,w,g,r){this.c=m,this.d=w,this._accept(g),this.e=r;const a=this;this.value={get tabSize(){return a.f},set tabSize(s){a.n(s)},get indentSize(){return a.g},set indentSize(s){a.p(s)},get insertSpaces(){return a.j},set insertSpaces(s){a.s(s)},get cursorStyle(){return a.k},set cursorStyle(s){a.t(s)},get lineNumbers(){return a.l},set lineNumbers(s){a.u(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}n(m){const w=this.m(m);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}p(m){const w=this.o(m);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const w=this.q(m);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(m)})))}assign(m){const w={};let g=!1;if(typeof m.tabSize<"u"){const r=this.m(m.tabSize);r==="auto"?(g=!0,w.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,g=!0,w.tabSize=r)}if(typeof m.indentSize<"u"){const r=this.o(m.indentSize);r==="tabSize"?(g=!0,w.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,g=!0,w.indentSize=r)}if(typeof m.insertSpaces<"u"){const r=this.q(m.insertSpaces);r==="auto"?(g=!0,w.insertSpaces=r):this.j!==r&&(this.j=r,g=!0,w.insertSpaces=r)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,g=!0,w.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,g=!0,w.lineNumbers=O.TextEditorLineNumbersStyle.from(m.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(m,w){w.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(g)})}}e.$FP=E;class M{constructor(m,w,g,r,a,s,n,i){this.id=m,this.j=w,this.k=g,this.g=!1,this.h=new Set,this.c=a,this.d=new E(this.j,this.id,s,g),this.e=n,this.f=i;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new A.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof N.$cN))throw(0,A.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof N.$cN)))throw(0,A.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new A.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new A.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new $(r.value,t);return h(d),c.m(d)},insertSnippet(h,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=c.c.map(f=>O.Range.from(f));else if(t instanceof N.$aN){const{lineNumber:f,column:u}=O.Position.from(t);o=[{startLineNumber:f,startColumn:u,endLineNumber:f,endColumn:u}]}else if(t instanceof N.$bN)o=[O.Range.from(t)];else{o=[];for(const f of t)if(f instanceof N.$bN)o.push(O.Range.from(f));else{const{lineNumber:u,column:D}=O.Position.from(f);o.push({startLineNumber:u,startColumn:D,endLineNumber:u,endColumn:D})}}return w.$tryInsertSnippet(m,r.value.version,h.value,o,d)},setDecorations(h,t){const d=t.length===0;d&&!c.h.has(h.key)||(d?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$uP(t))return w.$trySetDecorations(m,h.key,O.$vP(t));{const o=new Array(4*t.length);for(let f=0,u=t.length;f<u;f++){const D=t[f];o[4*f]=D.start.line+1,o[4*f+1]=D.start.character+1,o[4*f+2]=D.end.line+1,o[4*f+3]=D.end.character+1}return w.$trySetDecorationsFast(m,h.key,o)}}))},revealRange(h,t){c.n(()=>w.$tryRevealRange(m,O.Range.from(h),t||N.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(m,O.ViewColumn.from(h))},hide(){w.$tryHideEditor(m)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,y.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,y.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,y.ok)(!this.g),this.f=m}_acceptSelections(m){(0,y.ok)(!this.g),this.c=m}async l(){const m=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const w=m.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const g=w.edits.map(a=>a.range);g.sort((a,s)=>a.end.line===s.end.line?a.end.character===s.end.character?a.start.line===s.start.line?a.start.character-s.start.character:a.start.line-s.start.line:a.end.character-s.end.character:a.end.line-s.end.line);for(let a=0,s=g.length-1;a<s;a++){const n=g[a].end;if(g[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=w.edits.map(a=>({range:O.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,r,{setEndOfLine:typeof w.setEndOfLine=="number"?O.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$GP=M}),define(Ce[68],Ae([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new A.$ee,this.e=new A.$ee,this.f=new A.$ee,this.g=new A.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],d=[];if(c.removedDocuments)for(const o of c.removedDocuments){const f=O.URI.revive(o),u=this.c.get(f);u?.unref()&&(this.c.delete(f),h.push(u.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const f=O.URI.revive(o.uri);let u=this.c.get(f);if(u&&f.scheme!==g.Schemas.vscodeNotebookCell&&f.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);u||(u=new s(new $.$AP(this.h.getProxy(p.$0M.MainThreadDocuments),f,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty)),this.c.set(f,u),t.push(u.value)),u.ref()}if(c.removedEditors)for(const o of c.removedEditors){const f=this.b.get(o);this.b.delete(o),f&&d.push(f)}if(c.addedEditors)for(const o of c.addedEditors){const f=O.URI.revive(o.documentUri);y.ok(this.c.has(f),`document '${f}' does not exist`),y.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const u=this.c.get(f).value,D=new M.$GP(o.id,this.h.getProxy(p.$0M.MainThreadTextEditors),this.i,new a.$V(()=>u.document),o.selections.map(S.Selection.to),o.options,o.visibleRanges.map(l=>S.Range.to(l)),typeof o.editorPosition=="number"?S.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,D)}c.newActiveEditor!==void 0&&(y.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Qc)(h),(0,C.$Qc)(d),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$HP=n,e.$HP=n=Qe([qe(0,E.$xP),qe(1,m.$3j)],n),e.$IP=(0,N.$wi)("IExtHostDocumentsAndEditors")}),define(Ce[290],Ae([1,0,18,5,4,117,8,7]),function(ee,e,y,A,C,O,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class ${constructor(M,S){this.i=S,this.a=new A.$ee,this.b=new A.$ee,this.c=new A.$ee,this.d=new A.$ee,this.f=new A.$ee,this.g=new A.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(C.$0M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const S=this.i.allEditors();return M?S:S.map(m=>m.value)}async showTextDocument(M,S,m){let w;typeof S=="number"?w={position:N.ViewColumn.from(S),preserveFocus:m}:typeof S=="object"?w={position:N.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?N.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:w={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(M.uri,w),r=g&&this.i.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,S){return new O.$EP(this.h,M,S).value}$acceptEditorPropertiesChanged(M,S){const m=this.i.getEditor(M);if(!m)throw new Error("unknown text editor");if(S.options&&m._acceptOptions(S.options),S.selections){const w=S.selections.selections.map(N.Selection.to);m._acceptSelections(w)}if(S.visibleRanges){const w=y.$Hb(S.visibleRanges.map(N.Range.to));m._acceptVisibleRanges(w)}if(S.options&&this.b.fire({textEditor:m.value,options:{...S.options,lineNumbers:N.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const w=p.TextEditorSelectionChangeKind.fromValue(S.selections.source),g=S.selections.selections.map(N.Selection.to);this.a.fire({textEditor:m.value,selections:g,kind:w})}if(S.visibleRanges){const w=y.$Hb(S.visibleRanges.map(N.Range.to));this.c.fire({textEditor:m.value,visibleRanges:w})}}$acceptEditorPositionData(M){for(const S in M){const m=this.i.getEditor(S);if(!m)throw new Error("Unknown text editor");const w=N.ViewColumn.to(M[S]);m.value.viewColumn!==w&&(m._acceptViewColumn(w),this.d.fire({textEditor:m.value,viewColumn:w}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$xlc=$}),define(Ce[291],Ae([1,0,2,3,4,6,7,8,20,15]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=void 0,e.$gnc=(0,A.$wi)("IExtHostTimeline");class M{constructor(w,g){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$0M.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,a)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&$.$Sm.equals(a,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:y.URI.revive(r.uri);return this.c.get(r.source)?.get(S(s))?.get(r.handle)}else return;return r}})}async $getTimeline(w,g,r,a){return this.b.get(w)?.provider.provideTimeline(y.URI.revive(g),r,a)}registerTimelineProvider(w,g,r,a){const s=new O.$Uc,n=this.d(g.id,a,s).bind(this);let i;g.onDidChange&&(i=g.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:g.id}),this));const c=this.c;return this.f({...g,scheme:w,onDidChange:void 0,async provideTimeline(h,t,d){t?.resetCache&&(s.clear(),c.get(g.id)?.clear());const o=await g.provideTimeline(h,t,d);if(o==null)return;const f=n(h,t);return{...o,source:g.id,items:o.items.map(f)}},dispose(){for(const h of c.values())h.get(g.id)?.clear();i?.dispose(),s.dispose()}},r)}d(w,g,r){return(a,s)=>{let n;if(s?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const c=S(a);n=i.get(c),n===void 0&&(n=new Map,i.set(c,n))}return i=>{const{iconPath:c,...h}=i,t=`${w}|${i.id??i.timestamp}`;n?.set(t,i);let d,o,f;i.iconPath&&(c instanceof N.$9N?f={id:c.id,color:c.color}:y.URI.isUri(c)?(d=c,o=c):{light:d,dark:o}=c);let u;return N.$BN.isMarkdownString(h.tooltip)?u=p.MarkdownString.from(h.tooltip):(0,E.$9f)(h.tooltip)?u=h.tooltip:N.$BN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=p.MarkdownString.from(h.detail)):(0,E.$9f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:i.command?g.toInternal(i.command,r):void 0,icon:d,iconDark:o,themeIcon:f,tooltip:u,accessibilityInformation:i.accessibilityInformation}}}}f(w,g){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:g}),(0,O.$Tc)(()=>{for(const a of this.c.values())a.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$hnc=M;function S(m){return m?.toString()}}),define(Ce[292],Ae([1,0,181,23,2,5,6,222,9,7,15,18,8,55,24,151,26]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;function s(c,h){if((0,M.$9f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends N.$Vc{constructor(h,t,d){super(),this.f=h,this.g=t,this.h=d,this.a=new Map,this.b=new r.$w$;function o(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:f=>o(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(u=>o(u)?this.r(u):u):f})}registerTreeDataProvider(h,t,d){const o=this.createTreeView(h,{treeDataProvider:t},d);return{dispose:()=>o.dispose()}}createTreeView(h,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],f=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,D=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,d),v={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:f,hasHandleDrag:u,hasHandleDrop:D,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(h,v),P={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,a.$PG)(d,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,a.$PG)(d,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(k){(0,w.$Vk)(k)&&(0,a.$PG)(d,"treeViewMarkdownMessage"),l.message=k},get title(){return l.title},set title(k){l.title=k},get description(){return l.description},set description(k){l.description=k},get badge(){return l.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?l.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(l.badge=void 0)},reveal:(k,I)=>l.reveal(k,I),dispose:async()=>{await b,this.a.delete(h),l.dispose()}};return this.B(P),P}$getChildren(h,t){const d=this.a.get(h);return d?d.getChildren(t):Promise.reject(new p.$4F(h))}async $handleDrop(h,t,d,o,f,u,D,l){const v=this.a.get(h);if(!v)return Promise.reject(new p.$4F(h));const b=m.DataTransfer.toDataTransfer(d,async P=>(await this.f.$resolveDropFileData(h,t,P)).buffer);return D===h&&l&&await this.j(b,v,l,f,u),v.onDrop(b,o,f)}async j(h,t,d,o,f){const u=this.b.removeDragOperationTransfer(f);if(u)(await u)?.forEach((D,l)=>{D&&h.set(l,D)});else if(f&&t.handleDrag){const D=t.handleDrag(d,h,o);this.b.addDragOperationTransfer(f,D),await D}return h}async $handleDrag(h,t,d,o){const f=this.a.get(h);if(!f)return Promise.reject(new p.$4F(h));const u=await this.j(new E.$5N,f,t,o,d);if(!(!u||o.isCancellationRequested))return m.DataTransfer.from(u)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new p.$4F(h);return t.hasResolve}$resolve(h,t,d){const o=this.a.get(h);if(!o)throw new p.$4F(h);return o.resolveTreeItem(t,d)}$setExpanded(h,t,d){const o=this.a.get(h);if(!o)throw new p.$4F(h);o.setExpanded(t,d)}$setSelectionAndFocus(h,t,d){const o=this.a.get(h);if(!o)throw new p.$4F(h);o.setSelectionAndFocus(t,d)}$setVisible(h,t){const d=this.a.get(h);if(!d){if(!t)return;throw new p.$4F(h)}d.setVisible(t)}$changeCheckboxState(h,t){const d=this.a.get(h);if(!d)throw new p.$4F(h);d.setCheckboxState(t)}m(h,t,d){const o=this.B(new i(h,t,this.f,this.g.converter,this.h,d));return this.a.set(h,o),o}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$inc=n;class i extends N.$Vc{get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,M.$fg)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,d,o,f,u){if(super(),this.I=h,this.J=d,this.L=o,this.M=f,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$pe,u.contributes&&u.contributes.views)for(const b in u.contributes.views)for(const P of u.contributes.views[b])P.id===h&&(this.P=P.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>{Array.isArray(b)&&b.length===0||this.F.fire({message:!1,element:b})}));let D,l;const v=O.Event.debounce(this.F.event,(b,P)=>(b||(b={message:!1,elements:[]}),P.element!==!1&&(D||(D=new Promise(k=>l=k),this.G=this.G.then(()=>D)),Array.isArray(P.element)?b.elements.push(...P.element):b.elements.push(P.element)),P.message&&(b.message=!0),b),200,!0);this.B(v(({message:b,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const k=l;return D=null,this.$(P).then(()=>k())})),b&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let d=this.X(h);return d||(d=await this.Y(t)),d?d.map(o=>o.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const d=(0,M.$fg)(t.select)?!0:t.select,o=(0,M.$fg)(t.focus)?!1:t.focus,f=(0,M.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(u=>this.W(h,u[u.length-1]).then(D=>this.J.$reveal(this.I,{item:D.item,parentChain:u.map(l=>l.item)},{select:d,focus:o,expand:f})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:d,focus:o,expand:f})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=m.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const d=this.getExtensionElement(h);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(h,t){const d=!(0,S.$ub)(this.s,h);this.s=h;const o=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),o&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async d=>{const o=this.getExtensionElement(d.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(h,t,d){const o=[];for(const f of h){const u=this.getExtensionElement(f);u&&o.push(u)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,d){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,$.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(o,h,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(h);if(d){const o=this.m.get(d);if(o){const f=await this.f.resolveTreeItem(o.extensionItem,d,t)??o.extensionItem;return this.hb(f),o.item.tooltip=this.eb(f.tooltip),o.item.command=this.fb(o.disposableStore,f.command),o.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(o=>(d.push(o),d))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$oh)(()=>this.f.getParent(h))}W(h,t){const d=this.m.get(h);return d?Promise.resolve(d):(0,$.$oh)(()=>this.f.getTreeItem(h)).then(o=>this.kb(h,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const f=this.getExtensionElement(o);if(f){const u=this.m.get(f);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const d=this.getExtensionElement(h);t=d?this.m.get(d):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new g.$pe(this.Z.token);try{const d=h?this.m.get(h):void 0,o=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const f=(0,S.$Hb)(o||[]),u=await Promise.all((0,S.$Hb)(f).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const D=u.map((l,v)=>l?this.db(f[v],l,d):null);return(0,S.$Hb)(D)}finally{t.dispose()}}$(h){if(h.some(d=>!d))return this.Z.dispose(!0),this.Z=new g.$pe,this.tb(),this.J.$refresh(this.I);{const d=this.ab(h);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(h){const t=new Set,d=h.map(f=>this.m.get(f));for(const f of d)if(f&&!t.has(f.item.handle)){let u=f;for(;u&&u.parent&&d.findIndex(D=>u&&u.parent&&D&&D.item.handle===u.parent.item.handle)===-1;){const D=this.j.get(u.parent.item.handle);u=D?this.m.get(D):void 0}u&&!u.parent&&t.add(f.item.handle)}const o=[];return t.forEach(f=>{const u=this.j.get(f);if(u){const D=this.m.get(u);D&&(!D.parent||!t.has(D.parent.item.handle))&&o.push(f)}}),o}bb(h){const t={};return Promise.all(h.map(d=>this.cb(d).then(o=>{o&&(t[d]=o.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,$.$oh)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const f=this.ib(t,o,d.parent);return this.pb(t,f,d,d.parent),d.dispose(),f}return null})}return Promise.resolve(null)}db(h,t,d){const o=this.ib(h,t,d);if(t.id&&this.j.has(o.item.handle))throw new Error((0,y.localize)(0,null,t.id));return this.ob(h,o),this.qb(o,d),o}eb(h){return E.$BN.isMarkdownString(h)?m.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,d,o;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,d=h.checkboxState.tooltip,o=h.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:o}}hb(h){if(!E.$ZN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,d){this.hb(t);const o=this.B(new N.$Uc),f=this.kb(h,t,d),u=this.lb(t);return{item:{handle:f,parentHandle:d?d.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(o,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,M.$fg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:o,dispose(){o.dispose()}}}jb(h){return h.iconPath instanceof E.$9N?h.iconPath:void 0}kb(h,{id:t,label:d,resourceUri:o},f,u){if(t)return`${i.b}/${t}`;const D=s(d,this.N),l=f?f.item.handle:i.a;let v=D?D.label:o?(0,A.$7g)(o):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const b=this.m.has(h)?this.m.get(h).item.handle:void 0,P=this.X(f)||[];let k,I=0;do{if(k=`${l}/${I}:${v}`,u||!this.j.has(k)||b===k)break;I++}while(I<=P.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$9N))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$9N)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,d,o){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(h,t);const f=this.X(o)||[],u=f.filter(D=>D.item.handle===d.item.handle)[0];u&&f.splice(f.indexOf(u),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const d of t.children){const o=this.j.get(d.item.handle);o&&this.sb(o)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const d of t.children){const o=this.j.get(d.item.handle);o&&this.sb(o)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}i.a="0",i.b="1"});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[293],Ae([1,0,5,6,2,34,8,64,4,7]),function(ee,e,y,A,C,O,N,p,$,E){"use strict";var M,S,m,w,g,r,a,s,n,i,c,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class d extends A.$Vc{constructor(D,l,v,b){super(),M.set(this,void 0),S.set(this,void 0),m.set(this,void 0),w.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,void 0),s.set(this,void 0),n.set(this,!0),i.set(this,void 0),c.set(this,!1),h.set(this,this.B(new y.$ee)),this.onDidDispose=Be(this,h,"f").event,t.set(this,this.B(new y.$ee)),this.onDidChangeViewState=Be(this,t,"f").event,_e(this,M,D,"f"),_e(this,S,l,"f"),_e(this,w,v,"f"),_e(this,m,b.viewType,"f"),_e(this,g,b.panelOptions,"f"),_e(this,s,b.viewColumn,"f"),_e(this,r,b.title,"f"),_e(this,i,b.active,"f")}dispose(){Be(this,c,"f")||(_e(this,c,!0,"f"),Be(this,h,"f").fire(),Be(this,S,"f").$disposeWebview(Be(this,M,"f")),Be(this,w,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,w,"f")}get viewType(){return this.c(),Be(this,m,"f")}get title(){return this.c(),Be(this,r,"f")}set title(D){this.c(),Be(this,r,"f")!==D&&(_e(this,r,D,"f"),Be(this,S,"f").$setTitle(Be(this,M,"f"),D))}get iconPath(){return this.c(),Be(this,a,"f")}set iconPath(D){this.c(),Be(this,a,"f")!==D&&(_e(this,a,D,"f"),Be(this,S,"f").$setIconPath(Be(this,M,"f"),C.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return Be(this,g,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,s,"f")=="number"&&Be(this,s,"f")<0))return Be(this,s,"f")}get active(){return this.c(),Be(this,i,"f")}get visible(){return this.c(),Be(this,n,"f")}_updateViewState(D){Be(this,c,"f")||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(_e(this,i,D.active,"f"),_e(this,n,D.visible,"f"),_e(this,s,D.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(D,l){this.c(),Be(this,S,"f").$reveal(Be(this,M,"f"),{viewColumn:typeof D>"u"?void 0:N.ViewColumn.from(D),preserveFocus:!!l})}c(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,S=new WeakMap,m=new WeakMap,w=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,s=new WeakMap,n=new WeakMap,i=new WeakMap,c=new WeakMap,h=new WeakMap,t=new WeakMap;class o extends A.$Vc{static c(){return(0,O.$Sg)()}constructor(D,l,v){super(),this.j=l,this.m=v,this.g=new Map,this.h=new Map,this.f=D.getProxy($.$0M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,l,v,b,P={}){const k=typeof b=="object"?b.viewColumn:b,I={viewColumn:N.ViewColumn.from(k),preserveFocus:typeof b=="object"&&!!b.preserveFocus},U=(0,p.$Mlc)(D),Q=o.c();this.f.$createWebviewPanel((0,p.$Olc)(D),Q,l,{title:v,panelOptions:f(P),webviewOptions:(0,p.$Plc)(D,this.m,P),serializeBuffersForPostMessage:U},I);const G=this.j.createNewWebview(Q,P,D);return this.createNewWebviewPanel(Q,l,v,k,P,G,!0)}$onDidChangeWebviewPanelViewStates(D){const l=Object.keys(D);l.sort((v,b)=>{const P=D[v],k=D[b];return P.active?1:k.active?-1:+P.visible-+k.visible});for(const v of l){const b=this.getWebviewPanel(v);if(!b)continue;const P=D[v];b._updateViewState({active:P.active,visible:P.visible,viewColumn:N.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,l,v){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:v,extension:D}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,p.$Mlc)(D)}),new E.$_M(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(D,l,v,b){const P=this.h.get(l);if(!P)throw new Error(`No serializer found for '${l}'`);const{serializer:k,extension:I}=P,U=this.j.createNewWebview(D,v.webviewOptions,I),Q=this.createNewWebviewPanel(D,l,v.title,b,v.panelOptions,U,v.active);await k.deserializeWebviewPanel(Q,v.state)}createNewWebviewPanel(D,l,v,b,P,k,I){const U=new d(D,this.f,k,{viewType:l,title:v,viewColumn:b,panelOptions:P,active:I});return this.g.set(D,U),U}getWebviewPanel(D){return this.g.get(D)}}e.$Qlc=o;function f(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[294],Ae([1,0,5,6,64,8,4,7]),function(ee,e,y,A,C,O,N,p){"use strict";var $,E,M,S,m,w,g,r,a,s,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class i extends A.$Vc{constructor(t,d,o,f,u,D){super(),$.set(this,void 0),E.set(this,void 0),M.set(this,void 0),S.set(this,void 0),m.set(this,!1),w.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,void 0),s.set(this,this.B(new y.$ee)),this.onDidChangeVisibility=Be(this,s,"f").event,n.set(this,this.B(new y.$ee)),this.onDidDispose=Be(this,n,"f").event,_e(this,M,o,"f"),_e(this,g,f,"f"),_e(this,$,t,"f"),_e(this,E,d,"f"),_e(this,S,u,"f"),_e(this,w,D,"f")}dispose(){Be(this,m,"f")||(_e(this,m,!0,"f"),Be(this,n,"f").fire(),Be(this,S,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,g,"f")}set title(t){this.a(),Be(this,g,"f")!==t&&(_e(this,g,t,"f"),Be(this,E,"f").$setWebviewViewTitle(Be(this,$,"f"),t))}get description(){return this.a(),Be(this,r,"f")}set description(t){this.a(),Be(this,r,"f")!==t&&(_e(this,r,t,"f"),Be(this,E,"f").$setWebviewViewDescription(Be(this,$,"f"),t))}get visible(){return Be(this,w,"f")}get webview(){return Be(this,S,"f")}get viewType(){return Be(this,M,"f")}_setVisible(t){t===Be(this,w,"f")||Be(this,m,"f")||(_e(this,w,t,"f"),Be(this,s,"f").fire())}get badge(){return this.a(),Be(this,a,"f")}set badge(t){this.a(),!(t?.value===Be(this,a,"f")?.value&&t?.tooltip===Be(this,a,"f")?.tooltip)&&(_e(this,a,O.ViewBadge.from(t),"f"),Be(this,E,"f").$setWebviewViewBadge(Be(this,$,"f"),t))}show(t){this.a(),Be(this,E,"f").$show(Be(this,$,"f"),!!t)}a(){if(Be(this,m,"f"))throw new Error("Webview is disposed")}}$=new WeakMap,E=new WeakMap,M=new WeakMap,S=new WeakMap,m=new WeakMap,w=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,s=new WeakMap,n=new WeakMap;class c{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(N.$0M.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,o,f){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:o,extension:t}),this.a.$registerWebviewViewProvider((0,C.$Olc)(t),d,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Mlc)(t)}),new p.$_M(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,o,f,u){const D=this.b.get(d);if(!D)throw new Error(`No view provider found for '${d}'`);const{provider:l,extension:v}=D,b=this.d.createNewWebview(t,{},v),P=new i(t,this.a,d,o,b,!0);this.c.set(t,P),await l.resolveWebviewView(P,{state:f},u)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.$lnc=c}),define(Ce[295],Ae([1,0,5,29,31,3]),function(ee,e,y,A,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.OutputChannelUpdateMode=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=void 0,e.$fM="text/x-code-output",e.$gM="output",e.$hM="Log",e.$iM="text/x-code-log-output",e.$jM="log",e.$kM="workbench.panel.output",e.$lM=new C.$Nj("inOutput",!1),e.$mM=new C.$Nj("activeLogOutput",!1),e.$nM=new C.$Nj("activeLogOutput.levelSettable",!1),e.$oM=new C.$Nj("activeLogOutput.level",""),e.$pM=new C.$Nj("activeLogOutput.levelIsDefault",!1),e.$qM=new C.$Nj("outputView.scrollLock",!1),e.$rM=(0,O.$wi)("outputService");var N;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(N||(e.OutputChannelUpdateMode=N={})),e.$sM={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new y.$ee,this.onDidRegisterChannel=this.b.event,this.c=new y.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(M=>E.push(M)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}A.$do.add(e.$sM.OutputChannels,new p),e.$tM=new C.$Nj("activeOutputChannel","")}),define(Ce[118],Ae([1,0,4,3,17,20,12,295,65,27,46,155,21,15,38,5,6]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0;class s extends N.$9j{get disposed(){return this.n}constructor(h,t,d,o,f){super(),this.id=h,this.name=t,this.r=d,this.s=o,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=m.$Ge.fromString(t).byteLength,(0,N.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,d,o,f,u){this.i=t,this.j=d,this.k=o,this.l=f,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(y.$0M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(h,t,d){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,f=(0,w.$9f)(t)?t:void 0;if((0,w.$9f)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const D=this.i.environment.extensionLogLevel?.find(([v])=>O.$Sm.equals(d.identifier,v))?.[1];D&&(u=(0,N.$hk)(D));const l=o?this.o(h,u,d):this.n(h,f,d);return l.then(v=>{this.g.set(v.id,v),v.visible=v.id===this.h}),o?this.r(h,u??this.m.getLevel(),l):this.q(h,l)}async n(h,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,f=this.k.extUri.joinPath(o,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.a.$register(h,f,t,d.identifier.value);return new s(D,h,u,this.a,d)}async o(h,t,d){const o=await this.p(d),f=h.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(o,`${f}.log`),D=`${d.identifier.value}.${f}`,l=this.l.createLogger(u,{id:D,name:h,logLevel:t,extensionId:d.identifier.value});return new n(D,h,l,this.a,d)}p(h){let t=this.d.get(h.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(o){if((0,g.$gl)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}return d})())}return t}q(h,t){let d=!1;const o=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return h},append(f){o(),t.then(u=>u.append(f))},appendLine(f){o(),t.then(u=>u.appendLine(f))},clear(){o(),t.then(f=>f.clear())},replace(f){o(),t.then(u=>u.replace(f))},show(f,u){o(),t.then(D=>D.show(f,u))},hide(){o(),t.then(f=>f.hide())},dispose(){d=!0,t.then(f=>f.dispose())}}}r(h,t,d){const o=new a.$Uc,f=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},u=o.add(new r.$ee);function D(l){t=l,u.fire(l)}return d.then(l=>{o.add(l),l.logLevel!==t&&D(l.logLevel),o.add(l.onDidChangeLogLevel(v=>D(v)))}),{...this.q(h,d),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(l,...v){f(),d.then(b=>b.trace(l,...v))},debug(l,...v){f(),d.then(b=>b.debug(l,...v))},info(l,...v){f(),d.then(b=>b.info(l,...v))},warn(l,...v){f(),d.then(b=>b.warn(l,...v))},error(l,...v){f(),d.then(b=>b.error(l,...v))},dispose(){o.dispose()}}}};e.$Wmc=i,e.$Wmc=i=Qe([qe(0,C.$xP),qe(1,E.$NP),qe(2,$.$Ilc),qe(3,M.$llc),qe(4,N.$4j),qe(5,N.$3j)],i),e.$Xmc=(0,A.$wi)("IExtHostOutputService")}),define(Ce[119],Ae([1,0,3,9]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=void 0,e.$hn=(0,y.$wi)("remoteAgentService"),e.$in=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let O=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await C.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,A.$xh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let N;return this.initial.length<this.maxInitialCount?this.initial.push(O):N=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:N,current:O,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof N>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>N*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[296],Ae([1,0,184,51,29,45,50,6,5,119,22,25,9]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$LJ=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$MJ=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$NJ=Object.freeze({id:"problems",title:(0,y.localize)(3,null),type:"object",order:101}),e.$OJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new $.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const g=new w;C.$do.add(e.$OJ.ConfigurationMigration,g);let r=class extends p.$Vc{constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(c=>this.g(c,n?.uri))])}async g(n,i){const c=this.a.inspect(n.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of h){const o=c[t];if(!o)continue;const f=[];if(o.value!==void 0){const u=await this.h(n,t,o.value,i,void 0);for(const D of u??[])f.push([D,[]])}for(const{identifiers:u,value:D}of o.overrides??[])if(D!==void 0){const l=await this.h(n,t,D,i,u);for(const v of l??[])f.push([v,u])}f.length&&await Promise.allSettled(f.map(async([[u,D],l])=>this.a.updateValue(u,D.value,{resource:i,overrideIdentifiers:l},d)))}}async h(n,i,c,h,t){const d=f=>{const D=this.a.inspect(f,{resource:h})[i];if(D)return t?D.overrides?.find(({identifiers:l})=>(0,S.$8n)(l,t))?.value:D.value},o=await n.migrateFn(c,d);return Array.isArray(o)?o:[[n.key,o]]}};e.$PJ=r,r.ID="workbench.contrib.configurationMigration",e.$PJ=r=Qe([qe(0,N.$3i),qe(1,O.$Fi)],r);let a=class extends p.$Vc{constructor(n){super(),this.b=n,this.a=new m.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!M.$c&&(await this.b.getEnvironment())?.os!==1)return;C.$do.as(A.$io.Configuration).registerConfiguration({...e.$MJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(4,null)},default:[],markdownDescription:(0,y.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(6,null),scope:2}}})}};e.$QJ=a,a.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$QJ=a=Qe([qe(0,E.$hn)],a)}),define(Ce[297],Ae([1,0,37,16,19,23,193,296,51,3,29]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$ihb=e.$hhb=void 0,e.$jhb=r,e.$khb=a,e.$hhb=(0,E.$wi)("editorResolverService"),e.$ihb="workbench.editorAssociations";const S=M.$do.as($.$io.Configuration),m={...p.$LJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,N.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(m);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var g;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function a(s,n){if(new Set([A.Schemas.extension,A.Schemas.webviewPanel,A.Schemas.vscodeWorkspaceTrust,A.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(C.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,O.$7g)(n);return y.$pk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Ce[298],Ae([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0,e.$LM=(0,$.$wi)("pathService");let g=w=class{constructor(a,s,n,i){this.d=a,this.e=s,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(a,i,s)):this.h(a,s,n)}h(a,s,n){return a.scheme===A.Schemas.file||a.scheme===A.Schemas.vscodeRemote?(0,y.$tg)(n??(0,N.$7g)(a),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,s){if(a.remoteAuthority)return A.Schemas.vscodeRemote;const n=(0,E.$IM)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:A.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?C.$gc:C.$hc)}async fileURI(a){let s="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const i=a.indexOf("/",2);i===-1?(s=a.substring(2),a="/"):(s=a.substring(2,i),a=a.substring(i)||"/")}return p.URI.from({scheme:A.Schemas.file,authority:s,path:a,query:"",fragment:""})}};e.$MM=g,e.$MM=g=w=Qe([qe(1,m.$hn),qe(2,S.$uM),qe(3,M.$Fi)],g)}),define(Ce[120],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$fL=e.$eL=void 0;class y{constructor(N,p){this.line=N,this.character=p}isBefore(N){return!1}isBeforeOrEqual(N){return!1}isAfter(N){return!1}isAfterOrEqual(N){return!1}isEqual(N){return!1}compareTo(N){return 0}translate(N,p){return new y(0,0)}with(N){return new y(0,0)}}e.$eL=y;class A{constructor(N,p,$,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(N,p),this.end=new y($,E)}contains(N){return!1}isEqual(N){return!1}intersection(N){}union(N){return new A(0,0,0,0)}with(N){return new A(0,0,0,0)}}e.$fL=A;var C;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ce[47],Ae([1,0,18,37,25,48,13,3,19,14,120,9]),function(ee,e,y,A,C,O,N,p,$,E,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.TextSearchCompleteMessageType=void 0,e.$mL=s,e.$nL=n,e.$oL=i,e.$tL=l,e.$uL=v,e.$wL=k,e.$xL=I,e.$yL=U,e.$zL=Q,e.$AL=G,e.$BL=L,e.$DL=F,e.$FL=ne,e.$GL=me,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$gL="workbench.view.search",e.$hL="workbench.panel.search",e.$iL="workbench.view.search",e.$jL="search-result",e.$kL="search.exclude";const m="\u27EA ",w=" characters skipped \u27EB",g=(m.length+w.length+5)*2;e.$lL=(0,p.$wi)("searchService");var r;(function(de){de[de.file=0]="file",de[de.text=1]="text",de[de.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var a;(function(de){de[de.File=1]="File",de[de.Text=2]="Text",de[de.aiText=3]="aiText"})(a||(e.QueryType=a={}));function s(de){return!!de.preview}function n(de){return!!de.resource}function i(de){return!!de.message}var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$pL=h;class t{constructor($e,ke,se,Pe){this.ranges=ke,this.webviewIndex=Pe;const re=Array.isArray(ke)?ke:[ke];if(se&&se.matchLines===1&&d(re)){$e=(0,N.$2f)($e,se.matchLines);let H="",he=0,Fe=0;const pe=Math.floor(se.charsPerLine/5),be=[];for(const ge of re){const ae=Math.max(ge.startColumn-pe,0),K=ge.startColumn+se.charsPerLine;if(ae>Fe+pe+g){const Z=m+(ae-Fe)+w;H+=Z+$e.slice(ae,K),he+=ae-(Fe+Z.length)}else H+=$e.slice(Fe,K);be.push(new f(0,ge.startColumn-he,ge.endColumn-he)),Fe=K}this.preview={text:H,matches:Array.isArray(this.ranges)?be:be[0]}}else{const H=Array.isArray(ke)?ke[0].startLineNumber:ke.startLineNumber;this.preview={text:$e,matches:(0,y.$2b)(ke,he=>new o(he.startLineNumber-H,he.startColumn,he.endLineNumber-H,he.endColumn))}}}}e.$qL=t;function d(de){const $e=de[0].startLineNumber;for(const ke of de)if(ke.startLineNumber!==$e||ke.endLineNumber!==$e)return!1;return!0}class o{constructor($e,ke,se,Pe){this.startLineNumber=$e,this.startColumn=ke,this.endLineNumber=se,this.endColumn=Pe}}e.$rL=o;class f extends o{constructor($e,ke,se){super($e,ke,$e,se)}}e.$sL=f;var u;(function(de){de.List="list",de.Tree="tree"})(u||(e.ViewMode=u={}));var D;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function l(de,$e=!0){const ke=de&&de.files&&de.files.exclude,se=$e&&de&&de.search&&de.search.exclude;if(!ke&&!se)return;if(!ke||!se)return ke||se;let Pe=Object.create(null);return Pe=C.$7n(Pe,C.$4n(ke)),Pe=C.$7n(Pe,C.$4n(se),!0),Pe}function v(de,$e){return de.excludePattern&&A.$pk(de.excludePattern,$e)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&A.$pk(de.includePattern,$e)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(ke=>{const se=ke.folder.fsPath;if(O.$vg($e,se)){const Pe=$.$mc(se,$e);return!ke.includePattern||!!A.$pk(ke.includePattern,Pe)}else return!1}):!1:!0}var b;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class P extends Error{constructor($e,ke){super($e),this.code=ke}}e.$vL=P;function k(de){const $e=de.message;if((0,E.$4)(de))return new P($e,b.canceled);try{const ke=JSON.parse($e);return new P(ke.message,ke.code)}catch{return new P($e,b.other)}}function I(de){const $e={message:de.message,code:de.code};return new Error(JSON.stringify($e))}function U(de){return de.type==="error"?!0:de.type==="success"}function Q(de){return de.type==="success"}function G(de){return!!de.path}function L(de,$e,ke=!0){const se=de.searchPath?de.searchPath:de.relativePath;return ke?(0,N.$Yf)(se,$e):A.$pk($e,se)}class R{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=R;function F(de,$e){const ke={...de||{},...$e||{}};return Object.keys(ke).filter(se=>{const Pe=ke[se];return typeof Pe=="boolean"&&Pe})}class T{constructor($e,ke){this.c=null,this.a={...$e.excludePattern||{},...ke.excludePattern||{}},this.b=A.$qk(this.a);let se=$e.includePattern;ke.includePattern&&(se?se={...se,...ke.includePattern}:se=ke.includePattern),se&&(this.c=A.$qk(se))}matchesExcludesSync($e,ke,se){return!!(this.b&&this.b($e,ke,se))}includedInQuerySync($e,ke,se){return!(this.b&&this.b($e,ke,se)||this.c&&!this.c($e,ke,se))}includedInQuery($e,ke,se){const Pe=this.b($e,ke,se),re=()=>this.c?!!this.c($e,ke,se):!0;return(0,S.$ih)(Pe)?Pe.then(H=>H?!1:re()):re()}hasSiblingExcludeClauses(){return X(this.a)}}e.$EL=T;function X(de){for(const $e in de)if(typeof de[$e]!="boolean")return!0;return!1}function ne(de){if(!de)return;let $e;return ke=>($e||($e=(de()||Promise.resolve([])).then(se=>se?we(se):{})),$e.then(se=>!!se[ke]))}function me(de){if(!de)return;let $e;return ke=>{if(!$e){const se=de();$e=se?we(se):{}}return!!$e[ke]}}function we(de){const $e={};for(const ke of de)$e[ke]=!0;return $e}}),define(Ce[39],Ae([1,0,18,9,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d,o,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;function D(Q,G,L){return new M.$Yg(R=>P(R,L)).isEqual(Q,G)}function l(Q,G,L){return D(Q.uri,G.uri,L)?0:(0,S.$rf)(Q.uri.toString(),G.uri.toString())}function v(Q,G,L){return Q.index!==G.index?Q.index<G.index?-1:1:D(Q.uri,G.uri,L)?(0,S.$rf)(Q.name,G.name):(0,S.$rf)(Q.uri.toString(),G.uri.toString())}function b(Q,G,L,R){const F=Q.slice(0).sort((X,ne)=>L(X,ne,R)),T=G.slice(0).sort((X,ne)=>L(X,ne,R));return(0,y.$Eb)(F,T,(X,ne)=>L(X,ne,R))}function P(Q,G){const L=G.getCapabilities(Q.scheme);return!(L&&L&1024)}class k extends s.$Pi{static toExtHostWorkspace(G,L,R,F){if(!G)return{workspace:null,added:[],removed:[]};const{id:T,name:X,folders:ne,configuration:me,transient:we,isUntitled:de}=G,$e=[],ke=L;L?ne.forEach((H,he)=>{const Fe=m.URI.revive(H.uri),pe=k.o(R||L,Fe,F);pe?(pe.name=H.name,pe.index=H.index,$e.push(pe)):$e.push({uri:Fe,name:H.name,index:he})}):$e.push(...ne.map(({uri:H,name:he,index:Fe})=>({uri:m.URI.revive(H),name:he,index:Fe}))),$e.sort((H,he)=>H.index<he.index?-1:1);const se=new k(T,X,$e,!!we,me?m.URI.revive(me):null,!!de,H=>P(H,F)),{added:Pe,removed:re}=b(ke?ke.workspaceFolders:[],se.workspaceFolders,l,F);return{workspace:se,added:Pe,removed:re}}static o(G,L,R){for(let F=0;F<G.folders.length;F++){const T=G.workspaceFolders[F];if(D(T.uri,L,R))return T}}constructor(G,L,R,F,T,X,ne){super(G,R.map(me=>new s.$Qi(me)),F,T,ne),this.t=L,this.u=X,this.q=[],this.s=p.$Ci.forUris(ne),R.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,L){return L&&this.s.get(G)&&(G=(0,M.$9g)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let I=class{constructor(G,L,R,F,T){this.c=new O.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ge,this.C=new Map,this.h=F,this.s=R,this.t=T,this.j=new E.$Em,this.k=new A.$vh,this.o=G.getProxy(f.$0M.MainThreadWorkspace),this.q=G.getProxy(f.$0M.MainThreadMessageService);const X=L.workspace;this.l=X?new k(X.id,X.name,[],!!X.transient,X.configuration?m.URI.revive(X.configuration):null,!!X.isUntitled,ne=>P(ne,R)):void 0}$initializeWorkspace(G,L){this.v=L,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,M.$7g)((0,M.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,L,R,...F){const T=[];if(Array.isArray(F)&&F.forEach(de=>{m.URI.isUri(de.uri)&&!T.some($e=>D($e.uri,de.uri,this.s))&&T.push({uri:de.uri,name:de.name||(0,M.$6g)(de.uri)})}),this.n||[L,R].some(de=>typeof de!="number"||de<0)||R===0&&T.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(L+R>X.length)return!1;const ne=X.slice(0);ne.splice(L,R,...T.map(de=>({uri:de.uri,name:de.name||(0,M.$6g)(de.uri),index:void 0})));for(let de=0;de<ne.length;de++){const $e=ne[de];if(ne.some((ke,se)=>se!==de&&D($e.uri,ke.uri,this.s)))return!1}ne.forEach((de,$e)=>de.index=$e);const{added:me,removed:we}=b(X,ne,v,this.s);if(me.length===0&&we.length===0)return!1;if(this.o){const de=G.displayName||G.name;this.o.$updateWorkspaceFolders(de,L,R,T).then(void 0,$e=>{this.n=void 0;const ke={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(a.Severity.Error,(0,w.localize)(0,null,de,$e.toString()),ke,[])})}return this.y(ne),!0}getWorkspaceFolder(G,L){if(this.x)return this.x.getWorkspaceFolder(G,L)}async getWorkspaceFolder2(G,L){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,L)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,L){let R,F="";if(typeof G=="string"?(R=m.URI.file(G),F=G):typeof G<"u"&&(R=G,F=G.fsPath),!R)return F;const T=this.getWorkspaceFolder(R,!0);if(!T)return F;typeof L>"u"&&this.x&&(L=this.x.folders.length>1);let X=(0,M.$_g)(T.uri,R);return L&&T.name&&(X=`${T.name}/${X}`),X}y(G){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:L,added:R,removed:F}=k.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=L||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:F}))}findFiles(G,L,R,F,T=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let X="",ne=!0;return L===null?ne=!1:L!==void 0&&(typeof L=="string"?X=L:X=L.pattern),this.z(G,void 0,{exclude:X,maxResults:R,useDefaultExcludes:ne,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},T)}findFiles2(G,L={},R,F=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,G,L,F)}async z(G,L,R,F=C.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const T=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,X={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:T,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let ne;if(G){const{includePattern:me,folder:we}=U(h.GlobPattern.from(G));ne=we,X.includePattern=me}else{const{includePattern:me,folder:we}=U(h.GlobPattern.from(L));ne=we,X.filePattern=me}return this.o.$startFileSearch(ne??null,X,F).then(me=>Array.isArray(me)?me.map(we=>m.URI.revive(we)):[])}async findTextInFiles(G,L,R,F,T=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),ne=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:me,folder:we}=U(h.GlobPattern.from(L.include)),de=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,$e={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:ne,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:me,excludePattern:de},ke=!1;if(this.u[X]=se=>{if(ke)return;const Pe=m.URI.revive(se.resource);se.results.forEach(re=>{const H=(0,u.$6h)(re);(0,o.$mL)(H)?R({uri:Pe,preview:{text:H.preview.text,matches:(0,y.$2b)(H.preview.matches,he=>new t.$bN(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,y.$2b)(H.ranges,he=>new t.$bN(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):R({uri:Pe,text:H.text,lineNumber:H.lineNumber})})},T.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(G,we??null,$e,X,T);return delete this.u[X],se||{}}catch(se){throw delete this.u[X],se}}$handleTextSearchResult(G,L){this.u[L]?.(G)}async save(G){const L=await this.o.$save(G,{saveAs:!1});return m.URI.revive(L)}async saveAs(G){const L=await this.o.$save(G,{saveAs:!0});return m.URI.revive(L)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,L){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,L);const R=this.t.transformOutgoingScheme(G),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,R),(0,N.$Tc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(G,L){this.h.info("Getting edit session identifier for workspaceFolder",G);const R=await this.resolveWorkspaceFolder(m.URI.revive(G));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const F=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!F),!F)return;const T=await F.provideEditSessionIdentity(R,L);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(G,L,R,F){this.h.info("Getting edit session identifier for workspaceFolder",G);const T=await this.resolveWorkspaceFolder(m.URI.revive(G));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const X=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!X),!X)return;const ne=await X.provideEditSessionIdentityMatch?.(L,R,F);if(this.h.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}getOnWillCreateEditSessionIdentityEvent(G){return(L,R,F)=>{const T=function(ne){L.call(R,ne)};return T.extension=G,this.B.event(T,void 0,F)}}async $onWillCreateEditSessionIdentity(G,L,R){const F=await this.resolveWorkspaceFolder(m.URI.revive(G));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},L,async(T,X)=>{const ne=Date.now();await Promise.resolve(T),Date.now()-ne>R&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),L.isCancellationRequested}registerCanonicalUriProvider(G,L){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,L);const R=this.t.transformOutgoingScheme(G),F=this.A++;return this.o.$registerCanonicalUriProvider(F,R),(0,N.$Tc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(G,L,R){const F=this.C.get(G.scheme);if(!F)return;const T=await F.provideCanonicalUri?.(m.URI.revive(G),L,R);if(T)return T}async $provideCanonicalUri(G,L,R){return this.provideCanonicalUri(m.URI.revive(G),{targetScheme:L},R)}};e.$Clc=I,e.$Clc=I=Qe([qe(0,c.$xP),qe(1,i.$NP),qe(2,n.$llc),qe(3,r.$3j),qe(4,d.$Alc)],I),e.$Dlc=(0,g.$wi)("IExtHostWorkspace");function U(Q){let G,L;return Q&&(typeof Q=="string"?G=Q:(G=Q.pattern,L=m.URI.revive(Q.baseUri))),{includePattern:G,folder:L}}}),define(Ce[40],Ae([1,0,25,5,39,4,7,203,51,15,9,3,17,12,2]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=e.$Elc=void 0;function r(d,o){if(o){const f=o.split(".");let u=d;for(let D=0;u&&D<f.length;D++)u=u[f[D]];return u}}function a(d){return d instanceof g.URI}function s(d){return d&&d.uri instanceof g.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&d.uri instanceof g.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(a(d))return{resource:d};if(s(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(i(d))return{resource:d.uri};if(d===null)return{resource:null}}let h=class{constructor(o,f,u){this.a=o.getProxy(O.$0M.MainThreadConfiguration),this.c=f,this.b=u,this.d=new M.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,f){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(o,f))}};e.$Elc=h,e.$Elc=h=Qe([qe(0,m.$xP),qe(1,C.$Dlc),qe(2,w.$3j)],h);class t{constructor(o,f,u,D){this.a=new A.$ee,this.b=o,this.f=D,this.c=f,this.e=p.$Bo.parse(u,D),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,f){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Bo.parse(o,this.f),this.d=this.k(o.configurationScopes),this.a.fire(this.j(f,u))}getConfiguration(o,f,u){const D=c(f)||{},l=this.g(o?r(this.e.getValue(void 0,D,this.c.workspace),o):this.e.getValue(void 0,D,this.c.workspace));o&&this.h(o,D,u?.identifier);function v(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case N.ConfigurationTarget.Global:return 2;case N.ConfigurationTarget.Workspace:return 5;case N.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(P){return typeof r(l,P)<"u"},get:(P,k)=>{this.h(o?`${o}.${P}`:P,D,u?.identifier);let I=r(l,P);if(typeof I>"u")I=k;else{let U;const Q=(G,L)=>{if((0,E.$$f)(G)){let R;const F=()=>{U=U||(0,y.$4n)(l),R=R||r(U,L)};return new Proxy(G,{get:(T,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return F(),()=>R;if(U)return R=R||r(U,L),R[X];const ne=T[X];return typeof X=="string"?Q(ne,`${L}.${X}`):ne},set:(T,X,ne)=>(F(),R&&(R[X]=ne),!0),deleteProperty:(T,X)=>(F(),R&&delete R[X],!0),defineProperty:(T,X,ne)=>(F(),R&&Object.defineProperty(R,X,ne),!0)})}return Array.isArray(G)?(0,y.$4n)(G):G};I=Q(I,P)}return I},update:(P,k,I,U)=>{P=o?`${o}.${P}`:P;const Q=v(I);return k!==void 0?this.b.$updateConfigurationOption(Q,P,k,D,U):this.b.$removeConfigurationOption(Q,P,D,U)},inspect:P=>{P=o?`${o}.${P}`:P;const k=this.e.inspect(P,D,this.c.workspace);if(k)return{key:P,defaultValue:(0,y.$4n)(k.policy?.value??k.default?.value),globalValue:(0,y.$4n)(k.user?.value??k.application?.value),workspaceValue:(0,y.$4n)(k.workspace?.value),workspaceFolderValue:(0,y.$4n)(k.workspaceFolder?.value),defaultLanguageValue:(0,y.$4n)(k.default?.override),globalLanguageValue:(0,y.$4n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,y.$4n)(k.workspace?.override),workspaceFolderLanguageValue:(0,y.$4n)(k.workspaceFolder?.override),languageIds:(0,y.$4n)(k.overrideIdentifiers)}}};return typeof l=="object"&&(0,y.$7n)(b,l,!1),Object.freeze(b)}g(o){const f=u=>(0,E.$$f)(u)?new Proxy(u,{get:(D,l)=>f(D[l]),set:(D,l,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(D,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(D,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return f(o)}h(o,f,u){const D=$.$so.test(o)?4:this.d.get(o),l=u?`[${u.value}] `:"";if(D===4){typeof f?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(D===3){f?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,f){const u=new p.$Do(o,f,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,l)=>u.affectsConfiguration(D,c(l))})}k(o){return o.reduce((f,u)=>(f.set(u[0],u[1]),f),new Map)}}e.$Flc=t,e.$Glc=(0,S.$wi)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[121],Ae([1,0,2,9,5,4,7,39,68,40,24,53,17,27,3,16,22,12,80,241,14]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=e.$0mc=e.$9mc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(G){function L(F){if(F!=null)return F}G.from=L;function R(F){if(F!=null)return F}G.to=R})(t||(t={}));var d;(function(G){function L(F){if(F!=null)return F}G.from=L;function R(F){if(F!=null)return F}G.to=R})(d||(d={}));var o;(function(G){function L(F){if(F!=null)return F}G.from=L;function R(F){if(F!=null)return F}G.to=R})(o||(o={}));var f;(function(G){function L(T){if(T){const X=T;return X&&!!X.process}else return!1}G.is=L;function R(T){if(T==null)return;const X={process:T.process,args:T.args};return T.options&&(X.options=o.from(T.options)),X}G.from=R;function F(T){if(T!=null)return new N.$VN(T.process,T.args,T.options)}G.to=F})(f||(f={}));var u;(function(G){function L(F){if(F!=null)return F}G.from=L;function R(F){if(F!=null)return F}G.to=R})(u||(u={}));var D;(function(G){function L(T){if(T){const X=T;return X&&(!!X.commandLine||!!X.command)}else return!1}G.is=L;function R(T){if(T==null)return;const X={};return T.commandLine!==void 0?X.commandLine=T.commandLine:(X.command=T.command,X.args=T.args),T.options&&(X.options=u.from(T.options)),X}G.from=R;function F(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new N.$WN(T.commandLine,T.options):new N.$WN(T.command,T.args?T.args:[],T.options)}G.to=F})(D||(D={}));var l;(function(G){function L(T){if(T){const X=T;return X&&X.customExecution==="customExecution"}else return!1}G.is=L;function R(T){return{customExecution:"customExecution"}}G.from=R;function F(T,X){return X.get(T)}G.to=F})(l||(e.CustomExecutionDTO=l={}));var v;(function(G){function L(R,F){let T;return R.scope!==void 0&&typeof R.scope!="number"?T=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===N.TaskScope.Workspace&&F&&F.workspaceFile?T=F.workspaceFile:T=i.$dI),{id:R._id,workspaceFolder:T}}G.from=L})(v||(e.TaskHandleDTO=v={}));var b;(function(G){function L(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}G.from=L})(b||(b={}));var P;(function(G){function L(T,X){if(T==null)return[];const ne=[];for(const me of T){const we=R(me,X);we&&ne.push(we)}return ne}G.fromMany=L;function R(T,X){if(T==null)return;let ne;T.execution instanceof N.$VN?ne=f.from(T.execution):T.execution instanceof N.$WN?ne=D.from(T.execution):T.execution&&T.execution instanceof N.$XN&&(ne=l.from(T.execution));const me=t.from(T.definition);let we;return T.scope?typeof T.scope=="number"?we=T.scope:we=T.scope.uri:we=N.TaskScope.Workspace,!me||!we?void 0:{_id:T._id,definition:me,name:T.name,source:{extensionId:X.identifier.value,label:T.source,scope:we},execution:ne,isBackground:T.isBackground,group:b.from(T.group),presentationOptions:d.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}G.from=R;async function F(T,X,ne){if(T==null)return;let me;f.is(T.execution)?me=f.to(T.execution):D.is(T.execution)?me=D.to(T.execution):l.is(T.execution)&&(me=l.to(T._id,ne));const we=t.to(T.definition);let de;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?de=T.source.scope:de=await X.resolveWorkspaceFolder(y.URI.revive(T.source.scope)):de=N.TaskScope.Workspace),!we||!de)return;const $e=new N.$YN(we,de,T.name,T.source.label,me,T.problemMatchers);return T.isBackground!==void 0&&($e.isBackground=T.isBackground),T.group!==void 0&&($e.group=N.$UN.from(T.group._id),$e.group&&T.group.isDefault&&($e.group=new N.$UN($e.group.id,$e.group.label),T.group.isDefault===!0&&($e.group.isDefault=T.group.isDefault))),T.presentationOptions&&($e.presentationOptions=d.to(T.presentationOptions)),T._id&&($e._id=T._id),T.detail&&($e.detail=T.detail),$e}G.to=F})(P||(e.TaskDTO=P={}));var k;(function(G){function L(F){return F}G.from=L;function R(F){if(F)return Object.assign(Object.create(null),F)}G.to=R})(k||(k={}));class I{constructor(L,R,F){this._id=R,this.a=F,h.set(this,void 0),_e(this,h,L,"f")}get task(){return this.a}terminate(){Be(this,h,"f").terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}h=new WeakMap;let U=class{constructor(L,R,F,T,X,ne,me,we){this.q=new C.$ee,this.r=new C.$ee,this.s=new C.$ee,this.u=new C.$ee,this.a=L.getProxy(O.$0M.MainThreadTask),this.b=F,this.c=T,this.d=X,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,R,F){if(!F)return new N.$_M(()=>{});const T=this.x();return this.j.set(T,{type:R,provider:F,extension:L}),this.a.$registerTaskProvider(T,R),new N.$_M(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(L,R){this.a.$registerTaskSystem(L,R)}fetchTasks(L){return this.a.$fetchTasks(k.from(L)).then(async R=>{const F=[];for(const T of R){const X=await P.to(T,this.b,this.m);X&&F.push(X)}return F})}get taskExecutions(){const L=[];return this.k.forEach(R=>L.push(R)),L}terminateTask(L){if(!(L instanceof I))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,R,F){const T=this.m.get(L.id);T&&(this.o.set(L.id,T),this.e.attachPtyToTerminal(R,await T.callback(F))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const R=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const R=await this.z(L.id);this.s.fire({execution:R,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const R=await this.z(L.id);this.u.fire({execution:R,exitCode:L.exitCode})}$provideTasks(L,R){const F=this.j.get(L);if(!F)return Promise.reject(new Error("no handler found"));const T=[],X=(0,A.$oh)(()=>F.provider.provideTasks(M.CancellationToken.None)).then(ne=>this.v(R,T,F,ne));return new Promise(ne=>{X.then(me=>{Promise.all(T).then(()=>{ne(me)})})})}async $resolveTask(L,R){const F=this.j.get(L);if(!F)return Promise.reject(new Error("no handler found"));if(R.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${F.type}].`);const T=await P.to(R,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const X=await F.provider.resolveTask(T,M.CancellationToken.None);if(!X)return;this.A(X,F);const ne=P.from(X,F.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(ne.execution)&&await this.y(ne,X,!0),await this.w(ne)}x(){return this.h++}async y(L,R,F){const T=await this.a.$createTaskId(L);!F&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,R.execution)),this.m.set(T,R.execution)}async z(L,R){if(typeof L=="string"){const X=this.l.get(L);if(!X)throw new c.$bb("Unexpected: The specified task is missing an execution");return X}const F=this.l.get(L.id);if(F)return F;let T;return R?T=Promise.resolve(new I(this,L.id,R)):T=P.to(L.task,this.b,this.m).then(X=>{if(!X)throw new c.$bb("Unexpected: Task does not exist.");return new I(this,L.id,X)}),this.l.set(L.id,T),T.then(X=>(this.k.set(L.id,X),X))}A(L,R){L._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const F=this.n.values();let T=F.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=F.next()}};e.$9mc=U,e.$9mc=U=Qe([qe(0,m.$xP),qe(1,w.$NP),qe(2,p.$Dlc),qe(3,$.$IP),qe(4,E.$Glc),qe(5,S.$5lc),qe(6,s.$3j),qe(7,n.$hlc)],U);let Q=class extends U{constructor(L,R,F,T,X,ne,me,we){super(L,R,F,T,X,ne,me,we),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.$b(0)})}async executeTask(L,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const F=P.from(R,L);if(F===void 0)throw new Error("Task is not valid");if(l.is(F.execution))await this.y(F,R,!1);else throw new c.$_;const T=await this.z(await this.a.$getTaskExecution(F),R);return this.a.$executeTask(F).catch(X=>{throw new Error(X)}),T}v(L,R,F,T){const X=[];if(T)for(const ne of T){if(this.A(ne,F),!ne.definition||!L[ne.definition.type]){const we=ne.source?ne.source:"No task source";this.f.warn(`The task [${we}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=P.from(ne,F.extension);me&&l.is(me.execution)?(X.push(me),R.push(this.y(me,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:F.extension}}async w(L){if(l.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,R,F){}};e.$0mc=Q,e.$0mc=Q=Qe([qe(0,m.$xP),qe(1,w.$NP),qe(2,p.$Dlc),qe(3,$.$IP),qe(4,E.$Glc),qe(5,S.$5lc),qe(6,s.$3j),qe(7,n.$hlc)],Q),e.$$mc=(0,g.$wi)("IExtHostTask")}),define(Ce[299],Ae([1,0,47,30]),function(ee,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=C,e.$OL=O;function C(N){return"cellResults"in N}e.$NL="rawCell#";function O(N,p){let $=-1;const E=[];let M=[];return N.forEach(m=>{m.range.startLineNumber!==$&&M.length>0&&(E.push([...M]),M=[]),M.push(m),$=m.range.endLineNumber}),M.length>0&&E.push([...M]),E.map(m=>{const w=[],g=m[0].range.startLineNumber,r=m[m.length-1].range.endLineNumber;for(let a=g;a<=r;a++)w.push(p.getLineContent(a));return new y.$qL(w.join(`
`)+`
`,m.map(a=>new A.$vt(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}}),define(Ce[300],Ae([1,0,177,21,5,6,28,13,15,2,38,76,4,32,8,7,35,275,114,25,16,231,299,297]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;class o{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,D,l,v,b,P){this.q=l,this.r=v,this.s=b,this.t=P,this.f=new Map,this.g=new N.$Bc,this.h=new Map,this.j=new C.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$flc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(m.$0M.MainThreadNotebook),this.c=u.getProxy(m.$0M.MainThreadNotebookDocuments),this.d=u.getProxy(m.$0M.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const I=k.notebookEditor?.notebookUri,U=k.cell.handle,G=this.g.get(I)?.getCell(U);if(G)return G.apiCell}if(k&&k.$mid===14){const I=k.uri,U=this.g.get(I);if(U)return U.apiNotebook}return k}}),o.B(D)}getEditorById(u){const D=this.h.get(u);if(!D)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(u){for(const[D,l]of this.h)if(l.apiEditor===u)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,D){const l=this.g.get(u);if(!l&&!D)throw new Error(`NO notebook document for '${u}'`);return l}static u(u,D){if(!D)return;const l=D.filenamePattern.map(v=>g.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(D.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:D.displayName,filenamePattern:l,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,D,l){const v=o.a++,b=typeof l.onDidChangeCellStatusBarItems=="function"?o.a++:void 0;this.f.set(v,l),this.b.$registerNotebookCellStatusBarItemProvider(v,b,D);let P;return b!==void 0&&(P=l.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(b))),new r.$_M(()=>{this.f.delete(v),this.b.$unregisterNotebookCellStatusBarItemProvider(v,b),P?.dispose()})}async createNotebookDocument(u){const D=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&g.NotebookData.from(u.content)});return E.URI.revive(D)}async openNotebookDocument(u){const D=this.g.get(u);if(D)return D.apiNotebook;const l=await this.c.$tryOpenNotebook(u),v=this.g.get(E.URI.revive(l));return(0,$.$hg)(v?.apiNotebook)}async showNotebookDocument(u,D){E.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let l;typeof D=="object"?l={position:g.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(g.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:l={preserveFocus:!1};const v=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,l),b=v&&this.h.get(v)?.apiEditor;if(b)return b;throw v?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,D,l,v){const b=this.f.get(u),P=E.URI.revive(D),k=this.g.get(P);if(!k||!b)return;const I=k.getCellFromIndex(l);if(!I)return;const U=await b.provideCellStatusBarItems(I.apiCell,v);if(!U)return;const Q=new O.$Uc,G=this.p.add([Q]),R=(Array.isArray(U)?U:[U]).map(F=>g.NotebookStatusBarItem.from(F,this.i,Q));return{cacheId:G,items:R}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,D,l,v,b){if((0,p.$8e)(D))throw new Error("viewType cannot be empty or just whitespace");const P=this.w++;return this.x.set(P,{viewType:D,serializer:l,options:v}),this.b.$registerNotebookSerializer(P,{id:u.identifier,location:u.extensionLocation},D,g.NotebookDocumentContentOptions.from(v),o.u(u,b)),(0,O.$Tc)(()=>{this.b.$unregisterNotebookSerializer(P)})}async $dataToNotebook(u,D,l){const v=this.x.get(u);if(!v)throw new Error("NO serializer found");const b=await v.serializer.deserializeNotebook(D.buffer,l);return new a.$Cw(g.NotebookData.from(b))}async $notebookToData(u,D,l){const v=this.x.get(u);if(!v)throw new Error("NO serializer found");const b=await v.serializer.serializeNotebook(g.NotebookData.to(D.value),l);return A.$Ge.wrap(b)}async $saveNotebook(u,D,l,v,b){const P=E.URI.revive(D),k=this.x.get(u);if(!k)throw new Error("NO serializer found");const I=this.g.get(P);if(!I)throw new Error("Document NOT found");if(I.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(P.scheme))throw new M.$ll((0,y.localize)(0,null,this.z(P)),6);await this.y(P,v);const U={metadata:(0,i.$_n)(I.apiNotebook.metadata,F=>!(k.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of I.apiNotebook.getCells()){const T=new r.$CO(F.kind,F.document.getText(),F.document.languageId,F.mime,k.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);T.metadata=(0,i.$_n)(F.metadata,X=>!(k.options?.transientCellMetadata??{})[X]),U.cells.push(T)}const Q=await k.serializer.serializeNotebook(U,b);await this.s.value.writeFile(P,Q);const G=this.s.getFileSystemProviderExtUri(P.scheme),L=await this.s.value.stat(P);return{name:G.basename(P),isFile:(L.type&M.FileType.File)!==0,isDirectory:(L.type&M.FileType.Directory)!==0,isSymbolicLink:(L.type&M.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(P.scheme),locked:!!((L.permissions??0)&M.FilePermission.Locked),etag:M.$wl({mtime:L.mtime,size:L.size}),children:void 0}}async $searchInNotebooks(u,D,l,v,b){const P=this.x.get(u)?.serializer;if(!P)return{limitHit:!1,results:[]};const k=new N.$Cc;await(async(L,R,F)=>{await Promise.all(L.map(async T=>await Promise.all(T.filenamePatterns.map(X=>{const ne={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:X};return this.t.doInternalFileSearchWithCustomCallback(ne,R,me=>{me.forEach(we=>{k.has(we)||v.some($e=>T.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(ke=>(0,d.$khb)(ke,we)))||k.add(we)})}).catch(me=>{if(me.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw me})}))))})(l,b,D);const U=new N.$Bc;let Q=!1;const G=Array.from(k).map(async L=>{const R=[];try{if(b.isCancellationRequested)return;if(D.maxResults&&[...U.values()].reduce((ne,me)=>ne+me.cellResults.length,0)>D.maxResults){Q=!0;return}const F=[],T=this.g.get(L);if(T)T.apiNotebook.getCells().forEach(me=>F.push({input:me.document.getText(),outputs:me.outputs.flatMap(we=>we.items.map(de=>de.data.toString()))}));else{const ne=await this.s.value.readFile(L),me=A.$Ge.fromString(ne.toString()),we=await P.deserializeNotebook(me.buffer,b);if(b.isCancellationRequested)return;g.NotebookData.from(we).cells.forEach($e=>F.push({input:$e.source,outputs:$e.outputs.flatMap(ke=>ke.items.map(se=>se.valueBytes.toString()))}))}if(b.isCancellationRequested)return;F.forEach((ne,me)=>{const we=D.contentPattern.pattern,de=new h.$oXb(ne.input,void 0,ne.outputs),$e=de.findInInputs(we),ke=de.findInOutputs(we),se=ke.flatMap(Pe=>(0,t.$OL)(Pe.matches,Pe.textBuffer)).map((Pe,re)=>(Pe.webviewIndex=re,Pe));if($e.length>0||ke.length>0){const Pe={index:me,contentResults:(0,t.$OL)($e,de.inputTextBuffer),webviewResults:se};R.push(Pe)}});const X={resource:L,cellResults:R};U.set(L,X);return}catch{return}});return await Promise.all(G),{limitHit:Q,results:[...U.values()]}}async y(u,D){const l=await this.s.value.stat(u);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==M.$vl&&typeof l.mtime=="number"&&typeof l.size=="number"&&D.mtime<l.mtime&&D.etag!==M.$wl({mtime:D.mtime,size:l.size}))throw new M.$ll((0,y.localize)(1,null),3,D)}z(u){return u.scheme===c.Schemas.file?u.fsPath:u.toString()}A(u,D,l){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const v=new n.$Cmc(D,this.d,u,l.visibleRanges.map(g.NotebookRange.to),l.selections.map(g.NotebookRange.to),typeof l.viewColumn=="number"?g.ViewColumn.to(l.viewColumn):void 0);this.h.set(D,v)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const l of u.value.removedDocuments){const v=E.URI.revive(l),b=this.g.get(v);b&&(b.dispose(),this.g.delete(v),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(P=>P.document.uri)}),this.n.fire(b.apiNotebook));for(const P of this.h.values())P.notebookData.uri.toString()===v.toString()&&this.h.delete(P.id)}if(u.value.addedDocuments){const l=[];for(const v of u.value.addedDocuments){const b=E.URI.revive(v.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const P=new s.$Bmc(this.c,this.q,this.r,b,v);l.push(...v.cells.map(k=>s.$Amc.asModelAddData(k))),this.g.get(b)?.dispose(),this.g.set(b,P),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(P.apiNotebook)}}if(u.value.addedEditors)for(const l of u.value.addedEditors){if(this.h.has(l.id))return;const v=E.URI.revive(l.documentUri),b=this.g.get(v);b&&this.A(b,l.id,l)}const D=[];if(u.value.removedEditors)for(const l of u.value.removedEditors){const v=this.h.get(l);v&&(this.h.delete(l),this.k?.id===v.id&&(this.k=void 0),D.push(v))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(v=>this.h.get(v)).filter(v=>!!v);const l=new Set;this.l.forEach(v=>l.add(v.id));for(const v of this.h.values()){const b=l.has(v.id);v._acceptVisibility(b)}this.l=[...this.h.values()].map(v=>v).filter(v=>v.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const D=w.$VP.String.with("notebookType","A notebook type"),l=new w.$XP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new w.$VP("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>A.$Ge.wrap(b))],new w.$WP("Notebook Data",b=>g.NotebookData.to(b.value))),v=new w.$XP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new w.$VP("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new a.$Cw(g.NotebookData.from(b)))],new w.$WP("Bytes",b=>b.buffer));u.registerApiCommand(l),u.registerApiCommand(v)}}e.$Lmc=o,o.a=0}),define(Ce[301],Ae([1,0,19,24,44,37,23,66,47]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class E{constructor(m,w,g){this.k=m,this.l=w,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&O.$qk(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&O.$qk(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const w=this.k.folderQueries||[];return new Promise((g,r)=>{const a=s=>{this.f++,m(s)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),i=y.$oc(n);this.j&&this.j(n,i)||this.v(a,{base:s,basename:i})}),Promise.all(w.map(s=>this.p(s,a))).then(s=>{g({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,C.$hj)(s)))})})}async p(m,w){const g=new A.$pe,r=this.q(m),a=this.r(),s=new $.$EL(this.k,m),n=!s.hasSiblingExcludeClauses();let i;try{this.h.add(g),i=p.$ae.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,g.token),h=i.elapsed(),t=p.$ae.create();return this.g&&!this.e||(c&&c.forEach(d=>{const o=y.$hc.relative(m.folder.path,d.path);if(n){const f=y.$oc(d.path);this.v(w,{base:m.folder,relativePath:o,basename:f});return}this.s(a,m.folder,o,w)}),this.g&&!this.e)?null:(this.u(a,s,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(m){const w=(0,$.$DL)(this.k.includePattern,m.includePattern),g=(0,$.$DL)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:g,includes:w,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},w,g,r){if(g===this.a){const s=y.$oc(this.a);this.v(r,{base:w,relativePath:this.a,basename:s})}function a(s){const n=y.$oc(s),i=y.$nc(s);let c=m[i];c||(c=m[i]=[],a(i)),c.push({base:w,relativePath:s,basename:n})}a(g)}u({rootEntries:m,pathToEntries:w},g,r){const a=this,s=this.a;function n(i){const c=(0,$.$GL)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const d=i[h],{relativePath:o,basename:f}=d;if(g.matchesExcludesSync(o,f,s!==f?c:void 0))continue;const u=w[o];if(u)n(u);else{if(o===s)continue;a.v(r,d)}if(a.e)break}}n(m)}v(m,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(w))}}class M{constructor(){this.b=new Map}fileSearch(m,w,g,r){const a=this.c(m.cacheKey),s=new E(m,w,a&&a.token);let n=0;const i=c=>{n+=c.length,g(c.map(h=>this.d(h)))};return this.e(s,M.a,i,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new A.$pe),this.b.get(m)}d(m){return m.relativePath?{resource:N.$0g(m.base,m.relativePath)}:{resource:m.base}}e(m,w,g,r){const a=r.onCancellationRequested(()=>{m.cancel()}),s=i=>{i&&(n.push(i),w>0&&n.length>=w&&(g(n),n=[]))};let n=[];return m.search(s).then(i=>(n.length&&g(n),a.dispose(),i),i=>(n.length&&g(n),a.dispose(),Promise.reject(i)))}}e.$Dmc=M,M.a=512}),define(Ce[302],Ae([1,0,18,270,37,93,28,16,19,23,13,15,2,97,195,50,12,45,109,298,47]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0,e.$OM=v;let h=class{constructor(P,k,I,U,Q){this.a=P,this.b=k,this.c=I,this.d=U,this.e=Q}text(P,k,I={}){P=this.f(P,I);const U=this.a.getValue(),Q=k&&k.some(L=>!this.a.getValue({resource:L}).search.useRipgrep);return{...this.h(k?.map(s.$Ri),I),type:2,contentPattern:P,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:U.search.usePCRE2||Q||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(P,k){const I=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const U={...P,wordSeparators:I.editor.wordSeparators};return this.j(P,k)&&(U.isCaseSensitive=!0),this.k(P)&&(U.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),U}file(P,k={}){return{...this.h(P,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(P,k){return P?(P=Array.isArray(P)?P.map(u):u(P),k?this.parseSearchPaths(P):{pattern:d(...Array.isArray(P)?P:[P])}):{}}h(P=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),U=this.g(k.excludePattern,k.expandPatterns),Q=P.length>1,G=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(F=>this.q(F,k,U)):P.map(F=>this.r(F,k,U,Q))).filter(F=>!!F),L={_reason:k._reason,folderQueries:G,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:U.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const F=y.$Hb(y.$Rb(this.c.groups.map(ne=>ne.editors.map(me=>me.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const T=F.filter(ne=>(0,c.$uL)(L,ne.fsPath)),X=this.i(T);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...L,...X}}const R=k.extraFileResources&&k.extraFileResources.filter(F=>(0,c.$uL)(L,F.fsPath));return L.extraFileResources=R&&R.length?R:void 0,L}i(P){const k=[],I=new N.$Bc,U={};let Q=!1;return P.forEach(G=>{if(G.scheme===p.Schemas.walkThrough)return;if((0,E.$bh)(G)){const R=this.b.getWorkspaceFolder(G)?.uri??G.with({path:$.$nc(G.fsPath)});let F=I.get(R);F||(Q=!0,F={folder:R,includePattern:{}},k.push(F),I.set(R,F));const T=$.$mc(R.fsPath,G.fsPath);(0,S.$hg)(F.includePattern)[T.replace(/\\/g,"/")]=!0}else G.fsPath&&(Q=!0,U[G.fsPath]=!0)}),{folderQueries:k,includePattern:U,usingSearchPaths:!0,excludePattern:Q?void 0:{"**/*":!0}}}j(P,k){if(k.isSmartCase){if(P.isRegExp){if(M.$Zf(P.pattern,!0))return!0}else if(M.$Zf(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,w.$RC)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const k=X=>$.$jc(X)||/^\.\.?([\/\\]|$)/.test(X),U=(Array.isArray(P)?P:o(P)).map(X=>{const ne=this.e.resolvedUserHome;return ne?(0,O.$Hw)(X,ne.scheme===p.Schemas.file?ne.fsPath:ne.path):X}),Q=A.$E(U,X=>k(X)?"searchPaths":"exprSegments"),G=(Q.exprSegments||[]).map(X=>M.$gf(X,"/")).map(X=>M.$gf(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),f(X))),L={},R=this.m(Q.searchPaths||[]);R&&R.length&&(L.searchPaths=R);const F=y.$Rb(G),T=d(...F);return T&&(L.pattern=T),L}l(P,k){return k.disregardExcludeSettings?void 0:(0,c.$tL)(P,!k.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const k=P.flatMap(U=>{let{pathPortion:Q,globPortion:G}=t(U);return G&&(G=D(G)),this.n(Q).flatMap(R=>this.o(R,G))}),I=new Map;return k.forEach(U=>{const Q=U.searchPath.toString(),G=I.get(Q);G?U.pattern&&(G.pattern=G.pattern||{},G.pattern[U.pattern]=!0):I.set(Q,{searchPath:U.searchPath,pattern:U.pattern?d(U.pattern):void 0})}),Array.from(I.values())}n(P){if($.$jc(P)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:P})}]:[{searchPath:m.URI.file($.$ic(P))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(P=u(P),P.startsWith("../")||P===".."){const U=$.$hc.resolve(k.path,P);return[{searchPath:k.with({path:U})}]}const I=D(P);return[{searchPath:k,pattern:I}]}else{if(P==="./"||P===".\\")return[];{const k=P.replace(/^\.[\/\\]/,""),U=this.b.getWorkspace().folders.map(Q=>{const G=k.match(new RegExp(`^${M.$af(Q.name)}(?:/(.*)|$)`));return G?{match:G,folder:Q}:null}).filter(S.$eg);if(U.length)return U.map(Q=>{const G=Q.match[1];return{searchPath:Q.folder.uri,pattern:G&&D(G)}});{const Q=P.match(/\.[\/\\](.+)[\/\\]?/),G=Q?Q[1]:P,L=g.localize(0,null,G);throw new Error(L)}}}}o(P,k){const I=P.pattern&&k?`${P.pattern}/${k}`:P.pattern||k,U=[{searchPath:P.searchPath,pattern:I}];return I&&!I.endsWith("**")&&U.push({searchPath:P.searchPath,pattern:I+"/**"}),U}q(P,k,I){const U=this.r((0,s.$Ri)(P.searchPath),k,I,!1);return U?{...U,includePattern:P.pattern}:null}r(P,k,I,U){let Q;const G=m.URI.isUri(P)?P:P.uri;if(I.searchPaths){const X=I.searchPaths.filter(ne=>(0,E.$3g)(ne.searchPath,G))[0];if(X&&!X.pattern)return null;X&&(Q=X.pattern)}const L=this.a.getValue({resource:G}),F={...this.l(L,k)||{},...Q||{}},T=m.URI.isUri(P)?(0,E.$7g)(P):P.name;return{folder:G,folderName:U?T:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!L.search.followSymlinks}}};e.$NM=h,e.$NM=h=Qe([qe(0,r.$3i),qe(1,s.$Fi),qe(2,n.$YD),qe(3,a.$3j),qe(4,i.$LM)],h);function t(b){const P=b.match(/[\*\{\}\(\)\[\]\?]/);if(P){const k=P.index,I=b.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let U=b.substr(0,I.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:b.substr((I.index||0)+1)}}}return{pathPortion:b}}function d(...b){return b.length?b.reduce((P,k)=>(P[k]=!0,P),Object.create(null)):void 0}function o(b){return C.$ok(b,",").map(P=>P.trim()).filter(P=>!!P.length)}function f(b){return[`**/${b}/**`,`**/${b}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function u(b){return b.replace(/\\/g,"/")}function D(b){return u(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(b){return b.replace(/([?*[\]])/g,"[$1]")}function v(b,P){b=y.$Mb(b,U=>U.toString());const k=[],I=P.getWorkspace();return b&&b.forEach(U=>{let Q;if(P.getWorkbenchState()===2)Q=(0,E.$_g)(I.folders[0].uri,U),Q&&Q!=="."&&(Q="./"+Q);else{const G=P.getWorkspaceFolder(U);if(G){const L=G.name;if(I.folders.filter(F=>F.name===L).length===1){const F=(0,E.$_g)(G.uri,U);F===""?Q=`./${G.name}`:Q=`./${G.name}/${F}`}else Q=U.fsPath}}Q&&k.push(l(Q))}),k}}),define(Ce[303],Ae([1,0,23,2,24,14,3,302,47,45,9]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zwb=m,e.$Awb=r;const S=7e3;function m(a,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],c=[];for(const u of n)if(/^workspaceContains:/.test(u)){const D=u.substr(18);D.indexOf("*")>=0||D.indexOf("?")>=0||a.forceUsingSearch?c.push(D):i.push(D)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,M.$ph)(),d=u=>t({activationEvent:u}),o=Promise.all(i.map(u=>w(a,u,d))).then(()=>{}),f=g(a,s.identifier,c,d);return Promise.all([o,f]).then(()=>{t(void 0)}),h}async function w(a,s,n){for(const i of a.folders)if(await a.exists(y.$0g(A.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function g(a,s,n,i){if(n.length===0)return Promise.resolve(void 0);const c=new C.$pe,h=a.checkExists(a.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},S);let d=!1;try{d=await h}catch(o){O.$4(o)||O.$1(o)}c.dispose(),clearTimeout(t),d&&i(`workspaceContains:${n.join(",")}`)}function r(a,s,n,i){const c=a.get(N.$vi),h=a.get($.$lL),d=c.createInstance(p.$NM).file(s.map(o=>(0,E.$Ri)(A.URI.revive(o))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(d,i).then(o=>!!o.limitHit,o=>O.$4(o)?!1:Promise.reject(o))}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,y,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,y):C?C.value=y:e.set(ee,y),y},Be=this&&this.__classPrivateFieldGet||function(ee,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(ee):A?A.value:e.get(ee)};define(Ce[41],Ae([1,0,173,19,60,23,9,6,54,2,12,4,40,237,84,39,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,22,82]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d,o,f,u,D,l,v,b,P,k,I,U,Q,G,L,R,F,T){"use strict";var X,ne,me,we;Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=e.$fmc=void 0,e.$fmc=(0,o.$wi)("IHostUtils");let de=we=class extends p.$Vc{constructor(pe,be,ge,ae,K,Z,fe,le,Me,ve,Re,Oe,Ue){super(),this.Y=Oe,this.Z=Ue,this.a=this.B(new k.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=be,this.g=ge,this.f=fe,this.j=ae,this.m=K,this.s=Z,this.t=Me,this.u=ve,this.w=Re,this.y=this.g.getProxy(S.$0M.MainThreadWorkspace),this.z=this.g.getProxy(S.$0M.MainThreadTelemetry),this.C=this.g.getProxy(S.$0M.MainThreadExtensionService),this.D=new N.$vh,this.F=new N.$vh,this.G=new N.$vh,this.H=new N.$vh,this.I=new he(this.f.extensions.activationEvents),this.L=new s.$U_b(this.I,this.f.extensions.allExtensions);const j=new i.$Tm(this.f.extensions.myExtensions);this.J=new s.$U_b(this.I,re(this.L,j)),F.$n&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new g.$1lc(this.g,this.s),this.N=new U.$$lc(this.g),this.O=le,this.h=pe.createChild(new l.$ui([g.$2lc,this.M],[U.$_lc,this.N])),this.P=this.B(new w.$Zlc(this.J,this.L,{onExtensionActivationError:(V,W,q)=>{this.C.$onExtensionActivationError(V,n.$3(W),q)},actualActivateExtension:async(V,W)=>{if(s.$U_b.isHostExtension(V,this.J,this.L))return await this.C.$activateExtension(V,W),new w.$Ylc;const q=this.J.getExtensionDescription(V);return this.fb(q,W)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(pe){n.$1(pe)}}async $(){this.O.onWillDeactivateAll();let pe=[];try{pe=this.J.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this.eb(K))}catch{}await Promise.all(pe)}terminate(pe,be=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${pe}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ae=>{this.s.error(ae)}),this.g.dispose();const ge=this.$();Promise.race([(0,N.$xh)(5e3),ge]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${be}`):this.s.info(`Extension host exiting with code ${be}`),this.s.flush(),this.s.dispose(),this.c.exit(be)})}isActivated(pe){return this.G.isOpen()?this.P.isActivated(pe):!1}async getExtension(pe){const be=await this.C.$getExtension(pe);return be&&{...be,identifier:new i.$Sm(be.identifier.value),extensionLocation:E.URI.revive(be.extensionLocation)}}ab(pe,be){return this.P.activateByEvent(pe,be)}bb(pe,be){return this.P.activateById(pe,be)}activateByIdWithErrors(pe,be){return this.bb(pe,be).then(()=>{const ge=this.P.getActivatedExtension(pe);if(ge.activationFailed)return Promise.reject(ge.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(pe=>this.J)}getExtensionExports(pe){if(this.G.isOpen())return this.P.getActivatedExtension(pe).exports;try{return this.P.getActivatedExtension(pe).exports}catch{return null}}async cb(pe){if(pe.scheme===G.Schemas.file&&this.c.fsRealpath){const be=pe.fsPath;this.R.has(be)||this.R.set(be,this.c.fsRealpath(be));const ge=await this.R.get(be);return E.URI.file(ge)}return pe}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(pe=>new H(pe))),this.Q}async db(pe){const be=$.$Ci.forUris(ge=>O.$1g.ignorePathCasing(ge));return await Promise.all(pe.map(async ge=>{if(this.wb(ge)){const ae=await this.cb(ge.extensionLocation);be.set(ae,ge)}})),be}eb(pe){let be=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(pe))return be;const ge=this.P.getActivatedExtension(pe);if(!ge)return be;try{typeof ge.module.deactivate=="function"&&(be=Promise.resolve(ge.module.deactivate()).then(void 0,ae=>(this.s.error(ae),Promise.resolve(void 0))))}catch(ae){this.s.error(`An error occurred when deactivating the extension '${pe.value}':`),this.s.error(ae)}try{(0,p.$Qc)(ge.subscriptions)}catch(ae){this.s.error(`An error occurred when deactivating the subscriptions for extension '${pe.value}':`),this.s.error(ae)}return be}async fb(pe,be){return this.f.remote.isRemote?this.C.$onWillActivateExtension(pe.identifier):await this.C.$onWillActivateExtension(pe.identifier),this.hb(pe,be).then(ge=>{const ae=ge.activationTimes;return this.C.$onDidActivateExtension(pe.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,be),this.gb(pe,be,"success",ae),ge},ge=>{throw this.gb(pe,be,"failure"),ge})}gb(pe,be,ge,ae){const K=ke(pe,be);this.z.$publicLog2("extensionActivationTimes",{...K,...ae||{},outcome:ge})}hb(pe,be){const ge=ke(pe,be);this.z.$publicLog2("activatePlugin",ge);const ae=this.wb(pe);if(!ae)return Promise.resolve(new w.$Xlc(w.$Ulc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${pe.identifier.value}, startup: ${be.startup}, activationEvent: '${be.activationEvent}'${pe.identifier.value!==be.extensionId.value?`, root cause: ${be.extensionId.value}`:""}`),this.s.flush();const K=new w.$Vlc(be.startup);return Promise.all([this.xb(pe,(0,O.$0g)(pe.extensionLocation,ae),K),this.ib(pe)]).then(Z=>(C.mark(`code/extHost/willActivateExtension/${pe.identifier.value}`),we.jb(this.s,pe.identifier,Z[0],Z[1],K))).then(Z=>(C.mark(`code/extHost/didActivateExtension/${pe.identifier.value}`),Z))}ib(pe){const be=this.Z.createLanguageModelAccessInformation(pe),ge=new h.$4lc(pe,this.M),ae=new h.$3lc(pe.identifier.value,!1,this.M),K=new Q.$amc(pe,this.N),Z=pe.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${pe.identifier.value}`),Promise.all([ge.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const le=this;let Me,ve;const Re=(0,a.$OG)(pe,"ipc")?this.f.messagePorts?.get(i.$Sm.toKey(pe.identifier)):void 0;return Object.freeze({globalState:ge,workspaceState:ae,secrets:K,subscriptions:[],get languageModelAccessInformation(){return be},get extensionUri(){return pe.extensionLocation},get extensionPath(){return pe.extensionLocation.fsPath},asAbsolutePath(Oe){return A.$kc(pe.extensionLocation.fsPath,Oe)},get storagePath(){return le.O.workspaceValue(pe)?.fsPath},get globalStoragePath(){return le.O.globalValue(pe).fsPath},get logPath(){return A.$kc(le.f.logsLocation.fsPath,pe.identifier.value)},get logUri(){return E.URI.joinPath(le.f.logsLocation,pe.identifier.value)},get storageUri(){return le.O.workspaceValue(pe)},get globalStorageUri(){return le.O.globalValue(pe)},get extensionMode(){return Z},get extension(){return Me===void 0&&(Me=new Pe(le,pe.identifier,pe,fe,!1)),Me},get extensionRuntime(){return(0,a.$PG)(pe,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.u.getEnvironmentVariableCollection(pe)},get messagePassingProtocol(){if(!ve){if(!Re)return;const Oe=k.Event.buffer(k.Event.fromDOMEventEmitter(Re,"message",Ue=>Ue.data));Re.start(),ve={onDidReceiveMessage:Oe,postMessage:Re.postMessage.bind(Re)}}return ve}})})}static jb(pe,be,ge,ae,K){return ge=ge||{activate:void 0,deactivate:void 0},this.kb(pe,be,ge,ae,K).then(Z=>new w.$Wlc(!1,null,K.build(),ge,Z,ae.subscriptions))}static kb(pe,be,ge,ae,K){if(typeof ge.activate=="function")try{K.activateCallStart(),pe.trace(`ExtensionService#_callActivateOptional ${be.value}`);const Z=typeof global=="object"?global:self,fe=ge.activate.apply(Z,[ae]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(fe).then(le=>(K.activateResolveStop(),le))}catch(Z){return Promise.reject(Z)}else return Promise.resolve(ge)}lb(pe,be){this.bb(pe.identifier,{startup:!1,extensionId:pe.identifier,activationEvent:be}).then(void 0,ge=>{this.s.error(ge)})}mb(pe,be=0){const ae=Date.now();(0,F.$v)(()=>{for(let K=be;K<pe.length;K+=1){const Z=pe[K];for(const fe of Z.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-ae>50){this.mb(pe,K);break}else this.lb(Z,fe)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(pe=>{const be=pe.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ge=this.J.getAllExtensionDescriptions();if(be)this.mb(ge);else for(const ae of ge)if(ae.activationEvents)for(const K of ae.activationEvents)K==="onStartupFinished"&&this.lb(ae,K)})}ob(){const pe=this.ab("*",!0).then(void 0,Z=>{this.s.error(Z)});this.B(this.j.onDidChangeWorkspace(Z=>this.pb(Z.added)));const be=this.j.workspace?this.j.workspace.folders:[],ge=this.pb(be),ae=this.rb(),K=Promise.all([ae,pe,ge]).then(()=>{});return Promise.race([K,(0,N.$xh)(1e4)]).then(()=>{this.nb()}),K}pb(pe){return pe.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(be=>this.qb(pe,be))).then(()=>{})}async qb(pe,be){if(this.isActivated(be.identifier))return;const ge=!this.f.remote.isRemote&&!!this.f.remote.authority,ae={logService:this.s,folders:pe.map(Z=>Z.uri),forceUsingSearch:ge||!this.c.fsExists,exists:Z=>this.c.fsExists(Z.fsPath),checkExists:(Z,fe,le)=>this.y.$checkExists(Z,fe,le)},K=await(0,I.$zwb)(ae,be);if(K)return this.bb(be.identifier,{startup:!0,extensionId:be.identifier,activationEvent:K.activationEvent}).then(void 0,Z=>this.s.error(Z))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(pe){throw console.error(pe),pe}}async sb(){const{extensionDevelopmentLocationURI:pe,extensionTestsLocationURI:be}=this.f.environment;if(!pe||!be)throw new Error(y.localize(0,null));const ge=await this.xb(null,be,new w.$Vlc(!1));if(!ge||typeof ge.run!="function")throw new Error(y.localize(1,null,be.toString()));return new Promise((ae,K)=>{const Z=(Me,ve)=>{Me?(F.$n&&this.s.error("Test runner called back with error",Me),K(Me)):(F.$n&&(ve?this.s.info(`Test runner called back with ${ve} failures.`):this.s.info("Test runner called back with successful outcome.")),ae(typeof ve=="number"&&ve>0?1:0))},fe=(0,O.$Xg)(be),le=ge.run(fe,Z);le&&le.then&&le.then(()=>{F.$n&&this.s.info("Test runner finished successfully."),ae(0)}).catch(Me=>{F.$n&&this.s.error("Test runner finished with error",Me),K(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,N.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(pe,be){return this.S[pe]=be,(0,p.$Tc)(()=>{delete this.S[pe]})}async getRemoteExecServer(pe){const{resolver:be}=await this.ub(pe);return be?.resolveExecServer?.(pe,{resolveAttempt:0})}async ub(pe){const be=pe.indexOf("+");if(be===-1)throw new t.$fN("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ge=pe.substr(0,be);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ge}`,!1),{authorityPrefix:ge,resolver:this.S[ge]}}async $resolveAuthority(pe,be){const ge=R.$ae.create(!1),ae=()=>`[resolveAuthority(${(0,d.$Ll)(pe)},${be})][${ge.elapsed()}ms] `,K=_=>this.s.info(`${ae()}${_}`),Z=_=>this.s.warn(`${ae()}${_}`),fe=(_,oe=void 0)=>this.s.error(`${ae()}${_}`,oe),le=_=>{if(_ instanceof t.$fN)return{type:"error",error:{code:_._code,message:_._message,detail:_._detail}};throw _},Me=async _=>{K(`activating resolver for ${_}...`);const{resolver:oe,authorityPrefix:Ne}=await this.ub(_);if(!oe)throw fe(`no resolver for ${Ne}`),new t.$fN(`No remote extension installed to resolve ${Ne}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:oe,authorityPrefix:Ne,remoteAuthority:_}},ve=pe.split(/@|%40/g).reverse();K(`activating remote resolvers ${ve.join(" -> ")}`);let Re;try{Re=await Promise.all(ve.map(Me)).catch(async _=>{if(!(_ instanceof t.$fN)||_._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw _;return Z(`resolving nested authorities failed: ${_.message}`),[await Me(pe)]})}catch(_){return le(_)}const Oe=new N.$Hh;Oe.cancelAndSet(()=>K("waiting..."),1e3);let Ue,j;for(const[_,{authorityPrefix:oe,resolver:Ne,remoteAuthority:Ve}]of Re.entries())try{if(_===Re.length-1)K("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${oe}`),Ue=await Ne.resolve(Ve,{resolveAttempt:be,execServer:j}),C.mark(`code/extHost/didResolveAuthorityOK/${oe}`),K("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Ne,t.$eN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(K(`invoking resolveExecServer() for ${Ve}`),C.mark(`code/extHost/willResolveExecServer/${oe}`),j=await Ne.resolveExecServer?.(Ve,{resolveAttempt:be,execServer:j}),!j)throw new t.$fN(`Exec server was not available for ${Ve}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${oe}`)}}catch(Ke){return C.mark(`code/extHost/didResolveAuthorityError/${oe}`),fe("returned an error",Ke),Oe.dispose(),le(Ke)}Oe.dispose();const V={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},W={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};K(`returned ${t.$eN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let q;if(t.$eN.isManagedResolvedAuthority(Ue)){const _=be;this.Y.setFactory(_,Ue.makeConnection),q={authority:pe,connectTo:new d.$Il(_),connectionToken:Ue.connectionToken}}else q={authority:pe,connectTo:new d.$Jl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:q,options:W,tunnelInformation:V}}}async $getCanonicalURI(pe,be){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$Ll)(pe)})`);const{resolver:ge}=await this.ub(pe);if(!ge)return null;const ae=E.URI.revive(be);if(typeof ge.getCanonicalURI>"u")return ae;const K=await(0,N.$oh)(()=>ge.getCanonicalURI(ae));return K||ae}async $startExtensionHost(pe){pe.toAdd.forEach(Z=>Z.extensionLocation=E.URI.revive(Z.extensionLocation));const{globalRegistry:be,myExtensions:ge}=$e(this.I,this.L,this.J,pe),ae=await this.db(ge);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(be.getAllExtensionDescriptions()),this.J.set(ge),F.$n&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(pe,be){return be===1?this.D.wait().then(ge=>this.ab(pe,!1)):this.G.wait().then(ge=>this.ab(pe,!1))}async $activate(pe,be){return await this.G.wait(),this.J.getExtensionDescription(pe)?(await this.bb(pe,be),!0):!1}async $deltaExtensions(pe){pe.toAdd.forEach(Z=>Z.extensionLocation=E.URI.revive(Z.extensionLocation));const{globalRegistry:be,myExtensions:ge}=$e(this.I,this.L,this.J,pe),ae=await this.db(ge);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(be.getAllExtensionDescriptions()),this.J.set(ge),F.$n&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(pe){return pe}async $test_up(pe){return pe.byteLength}async $test_down(pe){const be=c.$Ge.alloc(pe),ge=Math.random()%256;for(let ae=0;ae<pe;ae++)be.writeUInt8(ge,ae);return be}async $updateRemoteConnectionData(pe){this.X=pe,this.a.fire()}};e.$gmc=de,e.$gmc=de=we=Qe([qe(0,o.$vi),qe(1,e.$fmc),qe(2,D.$xP),qe(3,r.$Dlc),qe(4,m.$Glc),qe(5,M.$3j),qe(6,f.$NP),qe(7,u.$Jlc),qe(8,v.$FDb),qe(9,b.$5lc),qe(10,L.$cmc),qe(11,T.$dmc),qe(12,P.$9lc)],de);function $e(Fe,pe,be,ge){Fe.addActivationEvents(ge.addActivationEvents);const ae=new s.$U_b(Fe,pe.getAllExtensionDescriptions());ae.deltaExtensions(ge.toAdd,ge.toRemove);const K=new i.$Tm(be.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of ge.myToRemove)K.delete(fe);for(const fe of ge.myToAdd)K.add(fe);const Z=re(ae,K);return{globalRegistry:ae,myExtensions:Z}}function ke(Fe,pe){return{id:Fe.identifier.value,name:Fe.name,extensionVersion:Fe.version,publisherDisplayName:Fe.publisher,activationEvents:Fe.activationEvents?Fe.activationEvents.join(","):null,isBuiltin:Fe.isBuiltin,reason:pe.activationEvent,reasonId:pe.extensionId.value}}function se(Fe){return Fe.getAllExtensionDescriptions().map(pe=>pe.identifier.value).join(",")}e.$hmc=(0,o.$wi)("IExtHostExtensionService");class Pe{constructor(pe,be,ge,ae,K){X.set(this,void 0),ne.set(this,void 0),me.set(this,void 0),_e(this,X,pe,"f"),_e(this,ne,be,"f"),_e(this,me,ge.identifier,"f"),this.id=ge.identifier.value,this.extensionUri=ge.extensionLocation,this.extensionPath=A.$ic((0,O.$Xg)(ge.extensionLocation)),this.packageJSON=ge,this.extensionKind=ae,this.isFromDifferentExtensionHost=K}get isActive(){return Be(this,X,"f").isActivated(Be(this,me,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,X,"f").getExtensionExports(Be(this,me,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,X,"f").activateByIdWithErrors(Be(this,me,"f"),{startup:!1,extensionId:Be(this,ne,"f"),activationEvent:"api"}),this.exports}}e.$imc=Pe,X=new WeakMap,ne=new WeakMap,me=new WeakMap;function re(Fe,pe){return Fe.getAllExtensionDescriptions().filter(be=>pe.has(be.identifier))}class H{constructor(pe){this.a=pe}setSearchTree(pe){this.a=pe}findSubstr(pe){return this.a.findSubstr(pe)}forEach(pe){return this.a.forEach(pe)}}e.$jmc=H;class he{constructor(pe){this.a=new i.$Um,this.addActivationEvents(pe)}readActivationEvents(pe){return this.a.get(pe.identifier)??[]}addActivationEvents(pe){for(const be of Object.keys(pe))this.a.set(be,pe[be])}}}),define(Ce[304],Ae([1,0,60,2,4,40,26,20,17,27,3,41,12,13]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let r=class{constructor(c,h,t,d,o,f,u){this.c=c,this.d=h,this.f=t,this.g=d,this.h=o,this.i=f,this.j=u,this.a=new Map,this.b=[]}async install(){this.k(),y.mark("code/extHost/willWaitForConfig");const c=await this.g.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const h=await this.h.getExtensionPathIndex();this.register(new s(this.c,h,this.d,c,this.j)),this.register(this.f.createInstance(a)),this.i.remote.isRemote&&this.register(this.f.createInstance(n,h,this.i.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$snc=r,e.$snc=r=Qe([qe(2,M.$vi),qe(3,O.$Glc),qe(4,S.$hmc),qe(5,E.$NP),qe(6,m.$3j)],r);let a=g=class{constructor(c){if(c.environment.appRoot&&g.a.size){const h=(0,w.$af)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${o}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,d,o]=h,f=g.a.get(d);if(f!==void 0)return console.warn(`${d} as been renamed to ${f}, please update your imports`),t+f+o}c(c){return c.replace(/\\/g,"/")}};a.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),a=g=Qe([qe(0,E.$NP)],a);class s{constructor(c,h,t,d,o){this.c=c,this.d=h,this.e=t,this.f=d,this.g=o,this.nodeModuleName="vscode",this.a=new p.$Um}load(c,h){const t=this.d.findSubstr(h);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((o,f)=>d+=`	${f} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${d}`),this.b=this.c(N.$JG,this.e,this.f)}return this.b}}let n=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(C.$0M.MainThreadTelemetry);const d=t.getProxy(C.$0M.MainThreadWindow);this.c=(o,f)=>{const u=A.URI.parse(o);return f?this.g(o,f):u.scheme==="http"||u.scheme==="https"?d.$openUri(u,o,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?d.$openUri(u,o,{}):this.g(o,f)}}load(c,h,t){const d=this.e.findSubstr(h);return d&&(this.a=d.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Qe([qe(2,$.$xP)],n)}),define(Ce[122],Ae([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0,e.$kmc=(0,N.$wi)("IExtHostVariableResolverProvider");class g extends m.$zQ{constructor(s,n,i,c,h,t,d){function o(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const u=c.tabGroups.all.find(D=>D.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof M.$XO||u.input instanceof M.$3O)return u.input.modified;if(u.input instanceof M.$WO||u.input instanceof M.$2O||u.input instanceof M.$ZO)return u.input.uri}}}super({getFolderUri:f=>{const u=t.folders.filter(D=>D.name===f);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(f,u)=>h.getConfiguration(void 0,f).get(u),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=o();if(f)return C.$ic(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const f=o();if(f){const u=n.getWorkspaceFolder(f);if(u)return C.$ic(u.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>s.getExtension(f)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(O.env))}}let r=class extends A.$Vc{constructor(s,n,i,c,h){super(),this.b=s,this.c=n,this.g=i,this.h=c,this.j=h,this.a=new y.$V(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,o,this.m())})}getResolver(){return this.a.value}m(){}};e.$lmc=r,e.$lmc=r=Qe([qe(0,E.$hmc),qe(1,S.$Dlc),qe(2,p.$IP),qe(3,w.$Glc),qe(4,$.$Slc)],r)}),define(Ce[123],Ae([1,0,9,5,2,20,3,4,67,41,17,7,39,226,228,40,122,6,36,32,8]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=e.$omc=e.$nmc=e.$mmc=void 0,e.$mmc=(0,N.$wi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,v,b,P,k,I,U){this.N=v,this.O=b,this.P=P,this.Q=k,this.R=I,this.S=U,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new A.$ee,this.o=new A.$ee,this.q=new A.$ee,this.w=new A.$ee,this.l=l.getProxy(p.$0M.MainThreadDebugService),this.A=new A.$ee,this.C=new A.$ee,this.y=new d(this.l),this.z=new Map,this.O.getExtensionRegistry().then(Q=>{Q.onDidChange(G=>{this.V(Q)}),this.V(Q)})}async $getVisualizerTreeItem(l,v){const b=this.W(v);if(!b)return;const P=await this.H.get(l)?.getTreeItem?.(b);return P?this.U(l,P):void 0}registerDebugVisualizationTree(l,v,b){const P=O.$Sm.toKey(l.identifier),k=this.jb(P,v);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.H.set(k,b),this.l.$registerDebugVisualizerTree(k,!!b.editItem),(0,s.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(v)})}async $getVisualizerTreeItemChildren(l,v){const b=this.J.get(v)?.item;return b?(await this.H.get(l)?.getChildren?.(b))?.map(k=>this.U(l,k))||[]:[]}async $editVisualizerTreeItem(l,v){const b=this.J.get(l);if(!b)return;const P=await this.H.get(b.provider)?.editItem?.(b.item,v);return this.U(b.provider,P||b.item)}$disposeVisualizedTree(l){const v=this.J.get(l);if(!v)return;const b=[v.children];for(const P of b)if(P)for(const k of P)b.push(this.J.get(k)?.children),this.J.delete(k)}U(l,v){let b=this.I.get(v);return b||(b=this.F++,this.I.set(v,b),this.J.set(b,{provider:l,item:v})),c.DebugTreeItem.from(v,b)}asDebugSourceUri(l,v){const b=l;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let P=`debug:${encodeURIComponent(b.path||"")}`,k="?";return v&&(P+=`${k}session=${encodeURIComponent(v.id)}`,k="&"),P+=`${k}ref=${b.sourceReference}`,C.URI.parse(P)}else{if(b.path)return C.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const v=[];for(const b of l.getAllExtensionDescriptions())if(b.contributes){const P=b.contributes.debuggers;if(P&&P.length>0)for(const k of P)(0,g.$tH)(k)&&v.push(k.type)}this.l.$registerDebugTypes(v)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(v=>l.push(v)),l}async $resolveDebugVisualizer(l,v){const b=this.L.get(l);if(!b)throw new Error(`No debug visualizer found with id '${l}'`);let{v:P,provider:k,extensionId:I}=b;if(P.visualization||(P=await k.resolveDebugVisualization?.(P,v)||P,b.v=P),!P.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(I,P.visualization)}async $executeDebugVisualizerCommand(l){const v=this.L.get(l);if(!v)throw new Error(`No debug visualizer found with id '${l}'`);const b=v.v.visualization;b&&"command"in b&&this.S.executeCommand(b.command,...b.arguments||[])}W(l){const v=this.m.get(l.sessionId);return v&&{session:v.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,v,b,P){const k=this.W(b),I=this.jb(l,v),U=this.G.get(I);if(!k||!U)return[];const Q=await U.provideDebugVisualization(k,P);return Q?Q.map(G=>{const L=++this.M;this.L.set(L,{v:G,provider:U,extensionId:l});const R=G.iconPath?this.lb(G.iconPath):void 0;return{id:L,name:G.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(l,G.visualization)}}):[]}$disposeDebugVisualizers(l){for(const v of l)this.L.delete(v)}registerDebugVisualizationProvider(l,v,b){if(!l.contributes?.debugVisualizers?.some(I=>I.id===v))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${v})`);const P=O.$Sm.toKey(l.identifier),k=this.jb(P,v);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.G.set(k,b),this.l.$registerDebugVisualizer(P,v),(0,s.$Tc)(()=>{this.l.$unregisterDebugVisualizer(P,v),this.G.delete(v)})}addBreakpoints(l){const v=l.filter(k=>{const I=k.id;return this.z.has(I)?!1:(this.z.set(I,k),!0)});this.gb(v,[],[]);const b=[],P=new Map;for(const k of v)if(k instanceof S.$bO){let I=P.get(k.location.uri.toString());I||(I={type:"sourceMulti",uri:k.location.uri,lines:[]},P.set(k.location.uri.toString(),I),b.push(I)),I.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof S.$cO&&b.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(b)}removeBreakpoints(l){const v=l.filter(I=>this.z.delete(I.id));this.gb([],v,[]);const b=v.filter(I=>I instanceof S.$bO).map(I=>I.id),P=v.filter(I=>I instanceof S.$cO).map(I=>I.id),k=v.filter(I=>I instanceof S.$dO).map(I=>I.id);return this.l.$unregisterBreakpoints(b,P,k)}startDebugging(l,v,b){return this.l.$startDebugging(l?l.uri:void 0,v,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,v,b){if(!v)return new S.$_M(()=>{});const P=this.d++;return this.f.push({type:l,handle:P,provider:v}),this.l.$registerDebugConfigurationProvider(l,b,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,P),new S.$_M(()=>{this.f=this.f.filter(k=>k.provider!==v),this.l.$unregisterDebugConfigurationProvider(P)})}registerDebugAdapterDescriptorFactory(l,v,b){if(!b)return new S.$_M(()=>{});if(!this.cb(l,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.$(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const P=this.g++;return this.h.push({type:v,handle:P,factory:b}),this.l.$registerDebugAdapterDescriptorFactory(v,P),new S.$_M(()=>{this.h=this.h.filter(k=>k.factory!==b),this.l.$unregisterDebugAdapterDescriptorFactory(P)})}registerDebugAdapterTrackerFactory(l,v){if(!v)return new S.$_M(()=>{});const b=this.j++;return this.k.push({type:l,handle:b,factory:v}),new S.$_M(()=>{this.k=this.k.filter(P=>P.factory!==v)})}async $runInTerminal(l,v){return Promise.resolve(void 0)}async $substituteVariables(l,v){let b;const P=await this.ib(l);return P&&(b={uri:P.uri,name:P.name,index:P.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(b,v)}X(l,v){if(l.type==="implementation")return new f(l.implementation)}Y(){}async $startDASession(l,v){const b=this,P=await this.hb(v);return this.eb(this.$(P.type),P).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${P.type}' (extension might have failed to activate)`);const I=this.Z(k),U=this.X(I,P);if(!U)throw new Error(`Couldn't create a debug adapter for type '${P.type}'.`);const Q=U;return this.D.set(l,Q),this.db(P).then(G=>(G&&this.E.set(l,G),Q.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const R=L,F={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const T=await this.K.sign(R.arguments.value);F.body={signature:T},Q.sendResponse(F)}else throw new Error("no signer")}catch(T){F.success=!1,F.message=T.message,Q.sendResponse(F)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(L),L=(0,g.$yH)(L,!0),b.l.$acceptDAMessage(l,L)}),Q.onError(L=>{G&&G.onError&&G.onError(L),this.l.$acceptDAError(l,L.name,L.message,L.stack)}),Q.onExit(L=>{G&&G.onExit&&G.onExit(L??void 0,void 0),this.l.$acceptDAExit(l,L??void 0,void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),Q.startSession()))})}$sendDAMessage(l,v){v=(0,g.$xH)(v,!1);const b=this.E.get(l);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(v),this.D.get(l)?.sendMessage(v)}$stopDASession(l){const v=this.E.get(l);this.E.delete(l),v&&v.onWillStopSession&&v.onWillStopSession();const b=this.D.get(l);return this.D.delete(l),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const v=[],b=[],P=[];if(l.added)for(const k of l.added){const I=k.id;if(I&&!this.z.has(I)){let U;if(k.type==="function")U=new S.$cO(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")U=new S.$dO(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const Q=C.URI.revive(k.uri);U=new S.$bO(new S.$lN(Q,new S.$aN(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,S.$_N)(U,I),this.z.set(I,U),v.push(U)}}if(l.removed)for(const k of l.removed){const I=this.z.get(k);I&&(this.z.delete(k),b.push(I))}if(l.changed){for(const k of l.changed)if(k.id){const I=this.z.get(k.id);if(I){if(I instanceof S.$cO&&k.type==="function"){const U=I;U.enabled=k.enabled,U.condition=k.condition,U.hitCondition=k.hitCondition,U.logMessage=k.logMessage,U.functionName=k.functionName}else if(I instanceof S.$bO&&k.type==="source"){const U=I;U.enabled=k.enabled,U.condition=k.condition,U.hitCondition=k.hitCondition,U.logMessage=k.logMessage,U.location=new S.$lN(C.URI.revive(k.uri),new S.$aN(k.line,k.character))}P.push(I)}}}this.gb(v,b,P)}async $acceptStackFrameFocus(l){let v;if(l){const b=await this.hb(l.sessionId);l.kind==="thread"?v=new S.$jO(b.api,l.threadId):v=new S.$iO(b.api,l.threadId,l.frameId)}this.B=v,this.C.fire(this.B)}$provideDebugConfigurations(l,v,b){return(0,y.$oh)(async()=>{const P=this.bb(l);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(v);return P.provideDebugConfigurations(k,b)}).then(P=>{if(!P)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return P})}$resolveDebugConfiguration(l,v,b,P){return(0,y.$oh)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.ib(v);return k.resolveDebugConfiguration(I,b,P)})}$resolveDebugConfigurationWithSubstitutedVariables(l,v,b,P){return(0,y.$oh)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.ib(v);return k.resolveDebugConfigurationWithSubstitutedVariables(I,b,P)})}async $provideDebugAdapter(l,v){const b=this.ab(l);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const P=await this.hb(v);return this.eb(b,P).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${P.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(l){const v=await this.hb(l);this.n.fire(v.api)}async $acceptDebugSessionTerminated(l){const v=await this.hb(l);v&&(this.o.fire(v.api),this.m.delete(v.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,v){(await this.hb(l))?._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(l,v){const P={session:(await this.hb(l)).api,event:v.event,body:v.body};this.w.fire(P)}Z(l){if(l instanceof S.$eO)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof S.$fO)return{type:"server",port:l.port,host:l.host};if(l instanceof S.$gO)return{type:"pipeServer",path:l.path};if(l instanceof S.$hO)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const v=this.h.filter(b=>b.type===l);if(v.length>0)return v[0].factory}ab(l){const v=this.h.filter(b=>b.handle===l);if(v.length>0)return v[0].factory}bb(l){const v=this.f.filter(b=>b.handle===l);if(v.length>0)return v[0].provider}cb(l,v){if(l.contributes){const b=l.contributes.debuggers;if(b&&b.length>0){for(const P of b)if(P.label&&P.type&&P.type===v)return!0}}return!1}db(l){const b=l.configuration.type,P=this.k.filter(k=>k.type===b||k.type==="*").map(k=>(0,y.$oh)(()=>k.factory.createDebugAdapterTracker(l.api)).then(I=>I,I=>null));return Promise.race([Promise.all(P).then(k=>{const I=k.filter(U=>!!U);if(I.length>0)return new o(I)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(l,v){const b=v.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new S.$fO(b));if(l){const k=await this.O.getExtensionRegistry();return(0,y.$oh)(()=>l.createDebugAdapterDescriptor(v.api,this.fb(v,k))).then(I=>{if(I)return I})}const P=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(v,P))}fb(l,v){}gb(l,v,b){(l.length>0||v.length>0||b.length>0)&&this.A.fire(Object.freeze({added:l,removed:v,changed:b}))}async hb(l){if(l)if(typeof l=="string"){const v=this.m.get(l);if(v)return v}else{let v=this.m.get(l.id);if(!v){const b=await this.ib(l.folderUri),P=l.parent?this.m.get(l.parent):void 0;v=new t(this.l,l.id,l.type,l.name,b,l.configuration,P?.api),this.m.set(v.id,v),this.l.$sessionCached(v.id)}return v}throw new Error("cannot find session")}ib(l){if(l){const v=C.URI.revive(l);return this.N.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}jb(l,v){return`${l}\0${v}`}kb(l,v){if(v){if("title"in v&&"command"in v)return{type:0};if("treeId"in v)return{type:1,id:`${l}\0${v.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const v=this.mb(l);let b,P;return"id"in v?P=n.ThemeIcon.asClassName(v):b=v,{iconPath:b,iconClass:P}}mb(l){if(l instanceof S.$9N)return{id:l.id};const v=typeof l=="object"&&"dark"in l?l.dark:l,b=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof v=="string"?C.URI.file(v):v,light:typeof b=="string"?C.URI.file(b):b}}};e.$nmc=h,e.$nmc=h=Qe([qe(0,M.$xP),qe(1,m.$Dlc),qe(2,E.$hmc),qe(3,r.$Glc),qe(4,$.$Slc),qe(5,a.$kmc),qe(6,i.$TP)],h);class t{constructor(l,v,b,P,k,I,U){this.f=l,this.g=v,this.h=b,this.j=P,this.k=k,this.l=I,this.m=U}get api(){const l=this;return this.d??(this.d=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(v){l.j=v,l.f.$setDebugSessionName(l.g,v)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(v,b){return l.f.$customDebugAdapterRequest(l.g,v,b)},getDebugProtocolBreakpoint(v){return l.f.$getDebugProtocolBreakpoint(l.g,v.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$omc=t;class d{constructor(l){this.value=Object.freeze({append(v){l.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.$pmc=d;class o{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(v=>v.onError?v.onError(l):void 0)}onExit(l,v){this.d.forEach(b=>b.onExit?b.onExit(l,v):void 0)}}class f extends w.$Vrb{constructor(l){super(),this.h=l,l.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(l,v,b,P,k,I,U){super(l,v,b,P,k,I,U)}};e.$qmc=u,e.$qmc=u=Qe([qe(0,M.$xP),qe(1,m.$Dlc),qe(2,E.$hmc),qe(3,r.$Glc),qe(4,$.$Slc),qe(5,a.$kmc),qe(6,i.$TP)],u)}),define(Ce[305],Ae([1,0,14,60,2,4,254,12,56,72,27,199,17,61,41,63]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0;class a{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get(p.$3j),t=i.get(m.$xP).getProxy(O.$0M.MainThreadErrors);y.setUnexpectedErrorHandler(d=>{c.error(d);const o=y.$3(d);t.$onUnexpectedError(o)})}static async installFullHandler(i){const c=i.get(p.$3j),h=i.get(m.$xP),t=i.get(g.$hmc),d=i.get(r.$RP),o=h.getProxy(O.$0M.MainThreadExtensionService),f=h.getProxy(O.$0M.MainThreadErrors),u=await t.getExtensionPathIndex(),D=new WeakMap;function l(P,k){if(D.has(P))return D.get(P).stack;let I="",U,Q;for(const L of k)I+=`
	at ${L.toString()}`,Q=L.getFileName(),!U&&Q&&(U=u.findSubstr(C.URI.file(Q)));const G=`${P.name||"Error"}: ${P.message||""}${I}`;return D.set(P,{extensionIdentifier:U?.identifier,stack:G}),G}const v=Symbol("prepareStackTrace wrapped");let b=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(P){if(P===l||!P||P[v]){b=P||l;return}b=function(k,I){return l(k,I),P.call(Error,k,I)},Object.assign(b,{[v]:!0})}}),y.setUnexpectedErrorHandler(P=>{c.error(P);const k=y.$3(P),I=D.get(P);if(!I?.extensionIdentifier){f.$onUnexpectedError(k);return}o.$onExtensionRuntimeError(I.extensionIdentifier,k);const U=d.onExtensionError(I.extensionIdentifier,P);c.trace("forwarded error to extension?",U,I)})}}e.$tnc=a;class s{constructor(i,c,h,t,d){this.a=h,this.b=new N.$3_b(i,null,t),c=s.e(c,this.b);const o=new E.$ui(...(0,$.$zs)());o.set(M.$NP,{_serviceBrand:void 0,...c,messagePorts:d}),o.set(m.$xP,new m.$yP(this.b)),o.set(w.$Alc,new w.$Blc(t)),o.set(g.$fmc,h);const f=new S.$dr(o,!0);f.invokeFunction(a.installEarlyHandler),this.d=f.invokeFunction(u=>u.get(p.$3j)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=f.invokeFunction(u=>u.get(g.$hmc)),this.c.initialize(),f.invokeFunction(a.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(O.$0M.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=C.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=C.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>C.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$unc=s}),define(Ce[306],Ae([1,0,18,9,24,44,16,19,23,2,47]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Fmc=e.$Emc=void 0,e.$Gmc=r;class S{constructor(n,i,c){this.d=n,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const c=this.g.folderQueries||[],h=new C.$pe(i);return new Promise((t,d)=>{this.a=new w(n);let o=!1;const f=(u,D)=>{if(!o&&!this.b){const l=this.h(u);r(u)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,o=!0,h.cancel(),u=this.j(u,this.g.maxResults-this.c));const v=this.h(u);this.c+=v,(v>0||!r(u))&&this.a.add(u,D)}};Promise.all(c.map((u,D)=>this.k(u,l=>f(l,D),h.token))).then(u=>{h.dispose(),this.a.flush();const D=u.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||D,messages:(0,y.$Rb)(u.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},u=>{h.dispose();const D=(0,O.$hj)(u);d(new Error(D))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,i),preview:{matches:h.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,c){const h=new M.$EL(this.g,n),t=[],d={report:u=>{if(!this.l(u))return;const D=n.folder.scheme===N.Schemas.file?(0,M.$FL)(()=>this.e.readdir($.$9g(u.uri))):void 0,l=$.$_g(n.folder,u.uri);if(l){const v=h.includedInQuery(l,p.$oc(l),D);(0,A.$ih)(v)?t.push(v.then(b=>{b&&i(u)})):v&&i(u)}}},o=this.n(n);let f;return this.d.query.type===3?f=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,o,d,c):f=await this.d.provider.provideTextSearchResults(m(this.d.query.contentPattern),o,d,c),t.length&&await Promise.all(t),f}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,M.$DL)(this.g.includePattern,n.includePattern),c=(0,M.$DL)(this.g.excludePattern,n.excludePattern),h={folder:E.URI.from(n.folder),excludes:c,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$Emc=S;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(g(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Fmc=w;function g(s){return r(s)?{preview:{matches:(0,y.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,y.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class a{constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Hmc=a,a.a=4e3,a.b=50}),define(Ce[124],Ae([1,0,6,4,3,301,17,61,12,2,306]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Imc=void 0,e.$Kmc=m,e.$Imc=(0,C.$wi)("IExtHostSearch");let S=class{constructor(r,a,s){this.n=r,this.o=a,this.q=s,this.c=this.n.getProxy(A.$0M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Dmc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,a){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,a),this.c.$registerTextSearchProvider(s,this.s(r)),(0,y.$Tc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,a){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,a),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,y.$Tc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,a){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,a),this.c.$registerFileSearchProvider(s,this.s(r)),(0,y.$Tc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,a,s,n){const i=m(s),c=this.j.get(r);if(c)return this.l.fileSearch(i,c,h=>{this.c.$handleFileMatch(r,a,h.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,a,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,a,s,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=m(s);return this.t(c,i).search(t=>this.c.$handleTextMatch(r,a,t),n)}$provideAITextSearchResults(r,a,s,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=m(s);return this.v(c,i).search(t=>this.c.$handleTextMatch(r,a,t),n)}$enableExtensionHostSearch(){}t(r,a){return new M.$Emc({query:r,provider:a},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,a){return new M.$Emc({query:r,provider:a},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$Jmc=S,e.$Jmc=S=Qe([qe(0,N.$xP),qe(1,p.$Alc),qe(2,$.$3j)],S);function m(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(w),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>E.URI.revive(r))}}function w(g){return{...g,folder:E.URI.revive(g.folder)}}}),define(Ce[307],Ae([1,0,24,14,5,6,16,33,2,158,146,147,96,20,38,12,58,59,213,4,257,285,80,86,262,263,264,243,232,32,265,40,266,123,112,267,245,258,268,269,68,67,259,41,271,65,272,46,27,286,287,246,273,90,274,81,82,248,300,276,219,277,288,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,289,290,260,291,292,88,8,7,251,61,252,64,293,294,111,39,227,79,26,120]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d,o,f,u,D,l,v,b,P,k,I,U,Q,G,L,R,F,T,X,ne,me,we,de,$e,ke,se,Pe,re,H,he,Fe,pe,be,ge,ae,K,Z,fe,le,Me,ve,Re,Oe,Ue,j,V,W,q,_,oe,Ne,Ve,Ke,Ye,tt,it,nt,st,ut,$t,je,ct,x,Y,ye,Ge,De,at,gt,Rt,Wt,Qt,_t,Xt,St,ei,ti,xe,hi){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=ni;function ni(ft){const wt=ft.get(se.$NP),Gt=ft.get(ke.$llc),Zt=ft.get(de.$Ilc),Lt=ft.get(me.$hmc),mt=ft.get(St.$Dlc),zt=ft.get(nt.$RP),qt=ft.get(P.$Glc),Ft=ft.get(gt.$Alc),Xe=ft.get(W.$xP),ci=ft.get(Ye.$2lc),Yt=ft.get(tt.$Jlc),Kt=ft.get(r.$4j),vt=ft.get(r.$3j),jt=ft.get(ye.$FDb),Bt=ft.get(t.$hlc),Ht=ft.get(Xt.$nnc),ri=ft.get(oe.$_lc),si=ft.get(X.$Slc),oi=ft.get(ge.$dmc),Mt=ft.get(d.$rlc),Pt=ft.get(Fe.$9lc);Xe.set(i.$$M.ExtHostFileSystemInfo,Gt),Xe.set(i.$$M.ExtHostLogLevelServiceShape,Kt),Xe.set(i.$$M.ExtHostWorkspace,mt),Xe.set(i.$$M.ExtHostConfiguration,qt),Xe.set(i.$$M.ExtHostExtensionService,Lt),Xe.set(i.$$M.ExtHostStorage,ci),Xe.set(i.$$M.ExtHostTunnelService,jt),Xe.set(i.$$M.ExtHostWindow,Ht),Xe.set(i.$$M.ExtHostSecretState,ri),Xe.set(i.$$M.ExtHostTelemetry,zt),Xe.set(i.$$M.ExtHostEditorTabs,si),Xe.set(i.$$M.ExtHostManagedSockets,oi),Xe.set(i.$$M.ExtHostAuthentication,Mt),Xe.set(i.$$M.ExtHostChatProvider,Pt);const Ot=Xe.set(i.$$M.ExtHostDecorations,ft.get(U.$smc)),It=Xe.set(i.$$M.ExtHostDocumentsAndEditors,ft.get(T.$IP)),pt=Xe.set(i.$$M.ExtHostCommands,ft.get(v.$TP)),Ct=Xe.set(i.$$M.ExtHostTerminalService,ft.get(st.$5lc)),ai=Xe.set(i.$$M.ExtHostTerminalShellIntegration,ft.get(ut.$_mc)),kt=Xe.set(i.$$M.ExtHostDebugService,ft.get(I.$mmc)),xt=Xe.set(i.$$M.ExtHostSearch,ft.get(_.$Imc)),ii=Xe.set(i.$$M.ExtHostTask,ft.get(it.$$mc)),yi=Xe.set(i.$$M.ExtHostOutputService,ft.get(Re.$Xmc)),di=Xe.set(i.$$M.ExtHostLocalization,ft.get(be.$cmc)),fi=Xe.set(i.$$M.ExtHostUrls,new Rt.$knc(Xe)),Nt=Xe.set(i.$$M.ExtHostDocuments,new F.$olc(Xe,It)),mi=Xe.set(i.$$M.ExtHostDocumentContentProviders,new L.$umc(Xe,It,vt)),Ei=Xe.set(i.$$M.ExtHostDocumentSaveParticipant,new R.$vmc(vt,Nt,Xe.getProxy(i.$0M.MainThreadBulkEdits))),Ee=Xe.set(i.$$M.ExtHostNotebook,new K.$Lmc(Xe,pt,It,Nt,Zt,xt)),Te=Xe.set(i.$$M.ExtHostNotebookDocuments,new fe.$Rmc(Ee)),ce=Xe.set(i.$$M.ExtHostNotebookEditors,new le.$Smc(vt,Ee)),J=Xe.set(i.$$M.ExtHostNotebookKernels,new Me.$Tmc(Xe,wt,Ee,pt,vt)),Ie=Xe.set(i.$$M.ExtHostNotebookRenderers,new ve.$Vmc(Xe,Ee)),We=Xe.set(i.$$M.ExtHostNotebookDocumentSaveParticipant,new Z.$Qmc(vt,Ee,Xe.getProxy(i.$0M.MainThreadBulkEdits))),Ze=Xe.set(i.$$M.ExtHostEditors,new je.$xlc(Xe,It)),He=Xe.set(i.$$M.ExtHostTreeViews,new Y.$inc(Xe.getProxy(i.$0M.MainThreadTreeViews),pt,vt)),ht=Xe.set(i.$$M.ExtHostEditorInsets,new l.$ylc(Xe.getProxy(i.$0M.MainThreadEditorInsets),Ze,wt.remote)),Dt=Xe.set(i.$$M.ExtHostDiagnostics,new Q.$nlc(Xe,vt,Gt,It)),Ut=Xe.set(i.$$M.ExtHostLanguages,new pe.$Omc(Xe,Nt,pt.converter,Ft)),lt=Xe.set(i.$$M.ExtHostLanguageFeatures,new he.$plc(Xe,Ft,Nt,pt,Dt,vt,Bt,zt)),Vt=Xe.set(i.$$M.ExtHostFileSystem,new we.$xmc(Xe,lt)),At=Xe.set(i.$$M.ExtHostFileSystemEventService,new $e.$ymc(Xe,vt,It)),wi=Xe.set(i.$$M.ExtHostQuickOpen,(0,V.$2mc)(Xe,mt,pt)),Pi=Xe.set(i.$$M.ExtHostSCM,new q.$4mc(Xe,pt,Nt,vt)),Li=Xe.set(i.$$M.ExtHostQuickDiff,new j.$1mc(Xe,Ft)),zi=Xe.set(i.$$M.ExtHostShare,new Ne.$5mc(Xe,Ft)),Ui=Xe.set(i.$$M.ExtHostComments,(0,b.$zlc)(Xe,pt,Nt)),Ii=Xe.set(i.$$M.ExtHostProgress,new Ue.$Zmc(Xe.getProxy(i.$0M.MainThreadProgress))),ji=Xe.set(i.$$M.ExtHostLabelService,new H.$Nmc(Xe)),Zi=Xe.set(i.$$M.ExtHostTheming,new ct.$fnc(Xe)),$n=Xe.set(i.$$M.ExtHostTimeline,new x.$hnc(Xe,pt)),Di=Xe.set(i.$$M.ExtHostWebviews,new Wt.$Nlc(Xe,wt.remote,mt,vt,Bt)),Ci=Xe.set(i.$$M.ExtHostWebviewPanels,new Qt.$Qlc(Xe,Di,mt)),Bi=Xe.set(i.$$M.ExtHostCustomEditors,new k.$Rlc(Xe,Nt,Yt,Di,Ci)),Vi=Xe.set(i.$$M.ExtHostWebviewViews,new _t.$lnc(Xe,Di)),vi=Xe.set(i.$$M.ExtHostTesting,new $t.$bnc(Xe,vt,pt,It)),Wi=Xe.set(i.$$M.ExtHostUriOpeners,new at.$jnc(Xe)),Yi=Xe.set(i.$$M.ExtHostProfileContentHandlers,new Oe.$Ymc(Xe));Xe.set(i.$$M.ExtHostInteractive,new re.$Mmc(Xe,Ee,It,pt,vt));const xi=Xe.set(i.$$M.ExtHostInlineChat,new Pe.$zmc(Xe,pt,Nt,vt)),qi=Xe.set(i.$$M.ExtHostChatAgents2,new f.$ulc(Xe,vt,pt)),_i=Xe.set(i.$$M.ExtHostChatVariables,new u.$vlc(Xe)),Ai=Xe.set(i.$$M.ExtHostAiRelatedInformation,new c.$glc(Xe)),Hi=Xe.set(i.$$M.ExtHostAiEmbeddingVector,new ne.$wmc(Xe)),Gi=Xe.set(i.$$M.ExtHostStatusBar,new Ke.$8mc(Xe,pt.converter)),en=Xe.set(i.$$M.ExtHostSpeech,new Ve.$6mc(Xe)),tn=Object.values(i.$$M);Xe.assertRegistered(tn);const nn=new o.$tlc(Xe,It),rn=new D.$wlc(Xe),Ri=new ae.$Pmc(Xe,vt),sn=new G.$tmc(Xe);return h.$qlc.register(pt),function(ze,ui,Ni){function rt(te){return(ue,Le,ot)=>{const Et=te(Tt=>{try{ue.call(Le,Tt)}catch(Ti){A.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Ti.toString()}`,{cause:Ti})),zt.onExtensionError(ze.identifier,Ti)}});return ot?.push(Et),Et}}const yt=function(){let te=!ze.isUnderDevelopment;function ue(){te||(vt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Le(ot){if(Array.isArray(ot))ot.forEach(Le);else if(typeof ot=="string")ue();else{const Et=ot;typeof Et.scheme>"u"&&ue(),typeof Et.exclusive=="boolean"&&(0,xe.$PG)(ze,"documentFiltersExclusive")}return ot}}(),on={getSession(te,ue,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,xe.$PG)(ze,"authLearnMore"),Mt.getSession(ze,te,ue,Le)},getSessions(te,ue){return(0,xe.$PG)(ze,"authGetSessions"),Mt.getSessions(ze,te,ue)},async hasSession(te,ue){return(0,xe.$PG)(ze,"authSession"),!!await Mt.getSession(ze,te,ue,{silent:!0})},get onDidChangeSessions(){return rt(Mt.onDidChangeSessions)},registerAuthenticationProvider(te,ue,Le,ot){return Mt.registerAuthenticationProvider(te,ue,Le,ot)}},pn={registerCommand(te,ue,Le){return pt.registerCommand(!0,te,ue,Le,void 0,ze)},registerTextEditorCommand(te,ue,Le){return pt.registerCommand(!0,te,(...ot)=>{const Et=Ze.getActiveTextEditor();if(!Et){vt.warn("Cannot execute "+te+" because there is no active text editor.");return}return Et.edit(Tt=>{ue.apply(Le,[Et,Tt,...ot])}).then(Tt=>{Tt||vt.warn("Edits from command "+te+" were not applied.")},Tt=>{vt.warn("An error occurred while running command "+te,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:(te,ue,Le)=>((0,xe.$PG)(ze,"diffCommand"),pt.registerCommand(!0,te,async(...ot)=>{const Et=It.activeEditor(!0);if(!Et){vt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Tt=await Ze.getDiffInformation(Et.id);ue.apply(Le,[Tt,...ot])},void 0,void 0,ze)),executeCommand(te,...ue){return pt.executeCommand(te,...ue)},getCommands(te=!1){return pt.getCommands(te)}},ki={get machineId(){return wt.telemetryInfo.machineId},get sessionId(){return wt.telemetryInfo.sessionId},get language(){return wt.environment.appLanguage},get appName(){return wt.environment.appName},get appRoot(){return wt.environment.appRoot?.fsPath??""},get appHost(){return wt.environment.appHost},get uriScheme(){return wt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return rt(Ct.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return rt(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$PG)(ze,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$PG)(ze,"telemetry"),rt(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$QP)(wt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ue){return nt.$PP.validateSender(te),zt.instantiateLogger(ze,te,ue)},openExternal(te,ue){return Ht.openUri(te,{allowTunneling:!!wt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===wt.environment.appUriScheme)return fi.createAppUri(te);try{return await Ht.asExternalUri(te,{allowTunneling:!!wt.remote.authority})}catch(ue){if((0,N.$Fg)(te,N.Schemas.http)||(0,N.$Fg)(te,N.Schemas.https))return te;throw ue}},get remoteName(){return(0,a.$Jm)(wt.remote.authority)},get remoteAuthority(){return(0,xe.$PG)(ze,"resolvers"),wt.remote.authority},get uiKind(){return wt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return rt(vt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$PG)(ze,"resolvers"),wt.quality},get appCommit(){return(0,xe.$PG)(ze,"resolvers"),wt.commit}};wt.environment.extensionTestsLocationURI||Object.freeze(ki);const an={createTestController(te,ue,Le){return vi.createTestController(ze,te,ue,Le)},createTestObserver(){return(0,xe.$PG)(ze,"testObserver"),vi.createTestObserver()},runTests(te){return(0,xe.$PG)(ze,"testObserver"),vi.runTests(te)},get onDidChangeTestResults(){return(0,xe.$PG)(ze,"testObserver"),rt(vi.onResultsChanged)},get testResults(){return(0,xe.$PG)(ze,"testObserver"),vi.results}},Si=wt.remote.isRemote?De.ExtensionKind.Workspace:De.ExtensionKind.UI,cn={getExtension(te,ue){(0,xe.$OG)(ze,"extensionsAny")||(ue=!1);const Le=ui.mine.getExtensionDescription(te);if(Le)return new me.$imc(Lt,ze.identifier,Le,Si,!1);if(ue){const ot=ui.all.getExtensionDescription(te);if(ot)return new me.$imc(Lt,ze.identifier,ot,Si,!0)}},get all(){const te=[];for(const ue of ui.mine.getAllExtensionDescriptions())te.push(new me.$imc(Lt,ze.identifier,ue,Si,!1));return te},get allAcrossExtensionHosts(){(0,xe.$PG)(ze,"extensionsAny");const te=new w.$Tm(ui.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),ue=[];for(const Le of ui.all.getAllExtensionDescriptions()){const ot=!te.has(Le.identifier);ue.push(new me.$imc(Lt,ze.identifier,Le,Si,ot))}return ue},get onDidChange(){return(0,xe.$OG)(ze,"extensionsAny")?rt(C.Event.any(ui.mine.onDidChange,ui.all.onDidChange)):rt(ui.mine.onDidChange)}},wn={createDiagnosticCollection(te){return Dt.createDiagnosticCollection(ze.identifier,te)},get onDidChangeDiagnostics(){return rt(Dt.onDidChangeDiagnostics)},getDiagnostics:te=>Dt.getDiagnostics(te),getLanguages(){return Ut.getLanguages()},setTextDocumentLanguage(te,ue){return Ut.changeLanguage(te.uri,ue)},match(te,ue){const Le=Ge.LanguageSelector.from(te);let ot;return(0,M.$Zt)(Le)&&(ot=Ee.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Tt=>Tt.document===ue))?.apiNotebook),(0,M.$Yt)(Le,ue.uri,ue.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(te,ue,Le){return lt.registerCodeActionProvider(ze,yt(te),ue,Le)},registerDocumentPasteEditProvider(te,ue,Le){return(0,xe.$PG)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,yt(te),ue,Le)},registerCodeLensProvider(te,ue){return lt.registerCodeLensProvider(ze,yt(te),ue)},registerDefinitionProvider(te,ue){return lt.registerDefinitionProvider(ze,yt(te),ue)},registerDeclarationProvider(te,ue){return lt.registerDeclarationProvider(ze,yt(te),ue)},registerImplementationProvider(te,ue){return lt.registerImplementationProvider(ze,yt(te),ue)},registerTypeDefinitionProvider(te,ue){return lt.registerTypeDefinitionProvider(ze,yt(te),ue)},registerHoverProvider(te,ue){return lt.registerHoverProvider(ze,yt(te),ue,ze.identifier)},registerEvaluatableExpressionProvider(te,ue){return lt.registerEvaluatableExpressionProvider(ze,yt(te),ue,ze.identifier)},registerInlineValuesProvider(te,ue){return lt.registerInlineValuesProvider(ze,yt(te),ue,ze.identifier)},registerDocumentHighlightProvider(te,ue){return lt.registerDocumentHighlightProvider(ze,yt(te),ue)},registerMultiDocumentHighlightProvider(te,ue){return lt.registerMultiDocumentHighlightProvider(ze,yt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return lt.registerLinkedEditingRangeProvider(ze,yt(te),ue)},registerReferenceProvider(te,ue){return lt.registerReferenceProvider(ze,yt(te),ue)},registerRenameProvider(te,ue){return lt.registerRenameProvider(ze,yt(te),ue)},registerNewSymbolNamesProvider(te,ue){return(0,xe.$PG)(ze,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(ze,yt(te),ue)},registerDocumentSymbolProvider(te,ue,Le){return lt.registerDocumentSymbolProvider(ze,yt(te),ue,Le)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(ze,te)},registerDocumentFormattingEditProvider(te,ue){return lt.registerDocumentFormattingEditProvider(ze,yt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return lt.registerDocumentRangeFormattingEditProvider(ze,yt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Le,...ot){return lt.registerOnTypeFormattingEditProvider(ze,yt(te),ue,[Le].concat(ot))},registerDocumentSemanticTokensProvider(te,ue,Le){return lt.registerDocumentSemanticTokensProvider(ze,yt(te),ue,Le)},registerDocumentRangeSemanticTokensProvider(te,ue,Le){return lt.registerDocumentRangeSemanticTokensProvider(ze,yt(te),ue,Le)},registerSignatureHelpProvider(te,ue,Le,...ot){return typeof Le=="object"?lt.registerSignatureHelpProvider(ze,yt(te),ue,Le):lt.registerSignatureHelpProvider(ze,yt(te),ue,typeof Le>"u"?[]:[Le,...ot])},registerCompletionItemProvider(te,ue,...Le){return lt.registerCompletionItemProvider(ze,yt(te),ue,Le)},registerInlineCompletionItemProvider(te,ue,Le){return ue.handleDidShowCompletionItem&&(0,xe.$PG)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,xe.$PG)(ze,"inlineCompletionsAdditions"),Le&&(0,xe.$PG)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,yt(te),ue,Le)},registerInlineEditProvider(te,ue){return(0,xe.$PG)(ze,"inlineEdit"),lt.registerInlineEditProvider(ze,yt(te),ue)},registerDocumentLinkProvider(te,ue){return lt.registerDocumentLinkProvider(ze,yt(te),ue)},registerColorProvider(te,ue){return lt.registerColorProvider(ze,yt(te),ue)},registerFoldingRangeProvider(te,ue){return lt.registerFoldingRangeProvider(ze,yt(te),ue)},registerSelectionRangeProvider(te,ue){return lt.registerSelectionRangeProvider(ze,te,ue)},registerCallHierarchyProvider(te,ue){return lt.registerCallHierarchyProvider(ze,te,ue)},registerTypeHierarchyProvider(te,ue){return lt.registerTypeHierarchyProvider(ze,te,ue)},setLanguageConfiguration:(te,ue)=>lt.setLanguageConfiguration(ze,te,ue),getTokenInformationAtPosition(te,ue){return(0,xe.$PG)(ze,"tokenInformation"),Ut.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return lt.registerInlayHintsProvider(ze,te,ue)},createLanguageStatusItem(te,ue){return Ut.createLanguageStatusItem(ze,te,ue)},registerDocumentDropEditProvider(te,ue,Le){return lt.registerDocumentOnDropEditProvider(ze,te,ue,(0,xe.$OG)(ze,"documentPaste")?Le:void 0)}},Ki={get activeTextEditor(){return Ze.getActiveTextEditor()},get visibleTextEditors(){return Ze.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(te,ue,Le){$.URI.isUri(te)&&te.scheme===N.Schemas.vscodeRemote&&!te.authority&&Bt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await($.URI.isUri(te)?Promise.resolve(Ji.openTextDocument(te)):Promise.resolve(te));return Ze.showTextDocument(ot,ue,Le)},createTextEditorDecorationType(te){return Ze.createTextEditorDecorationType(ze,te)},onDidChangeActiveTextEditor(te,ue,Le){return rt(Ze.onDidChangeActiveTextEditor)(te,ue,Le)},onDidChangeVisibleTextEditors(te,ue,Le){return rt(Ze.onDidChangeVisibleTextEditors)(te,ue,Le)},onDidChangeTextEditorSelection(te,ue,Le){return rt(Ze.onDidChangeTextEditorSelection)(te,ue,Le)},onDidChangeTextEditorOptions(te,ue,Le){return rt(Ze.onDidChangeTextEditorOptions)(te,ue,Le)},onDidChangeTextEditorVisibleRanges(te,ue,Le){return rt(Ze.onDidChangeTextEditorVisibleRanges)(te,ue,Le)},onDidChangeTextEditorViewColumn(te,ue,Le){return rt(Ze.onDidChangeTextEditorViewColumn)(te,ue,Le)},onDidCloseTerminal(te,ue,Le){return rt(Ct.onDidCloseTerminal)(te,ue,Le)},onDidOpenTerminal(te,ue,Le){return rt(Ct.onDidOpenTerminal)(te,ue,Le)},onDidChangeActiveTerminal(te,ue,Le){return rt(Ct.onDidChangeActiveTerminal)(te,ue,Le)},onDidChangeTerminalDimensions(te,ue,Le){return(0,xe.$PG)(ze,"terminalDimensions"),rt(Ct.onDidChangeTerminalDimensions)(te,ue,Le)},onDidChangeTerminalState(te,ue,Le){return rt(Ct.onDidChangeTerminalState)(te,ue,Le)},onDidWriteTerminalData(te,ue,Le){return(0,xe.$PG)(ze,"terminalDataWriteEvent"),rt(Ct.onDidWriteTerminalData)(te,ue,Le)},onDidExecuteTerminalCommand(te,ue,Le){return(0,xe.$PG)(ze,"terminalExecuteCommandEvent"),rt(Ct.onDidExecuteTerminalCommand)(te,ue,Le)},onDidChangeTerminalShellIntegration(te,ue,Le){return(0,xe.$PG)(ze,"terminalShellIntegration"),rt(ai.onDidChangeTerminalShellIntegration)(te,ue,Le)},onDidStartTerminalShellExecution(te,ue,Le){return(0,xe.$PG)(ze,"terminalShellIntegration"),rt(ai.onDidStartTerminalShellExecution)(te,ue,Le)},onDidEndTerminalShellExecution(te,ue,Le){return(0,xe.$PG)(ze,"terminalShellIntegration"),rt(ai.onDidEndTerminalShellExecution)(te,ue,Le)},get state(){return Ht.getState()},onDidChangeWindowState(te,ue,Le){return rt(Ht.onDidChangeWindowState)(te,ue,Le)},showInformationMessage(te,...ue){return Ri.showMessage(ze,p.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Ri.showMessage(ze,p.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Ri.showMessage(ze,p.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Le){return wi.showQuickPick(ze,te,ue,Le)},showWorkspaceFolderPick(te){return wi.showWorkspaceFolderPick(te)},showInputBox(te,ue){return wi.showInput(te,ue)},showOpenDialog(te){return sn.showOpenDialog(ze,te)},showSaveDialog(te){return sn.showSaveDialog(te)},createStatusBarItem(te,ue,Le){let ot,Et,Tt;return typeof te=="string"?(ot=te,Et=ue,Tt=Le):(Et=te,Tt=ue),Gi.createStatusBarEntry(ze,ot,Et,Tt)},setStatusBarMessage(te,ue){return Gi.setStatusBarMessage(te,ue)},withScmProgress(te){return Bt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ii.withProgress(ze,{location:De.ProgressLocation.SourceControl},(ue,Le)=>te({report(ot){}}))},withProgress(te,ue){return Ii.withProgress(ze,te,ue)},createOutputChannel(te,ue){return yi.createOutputChannel(te,ue,ze)},createWebviewPanel(te,ue,Le,ot){return Ci.createWebviewPanel(ze,te,ue,Le,ot)},createWebviewTextEditorInset(te,ue,Le,ot){return(0,xe.$PG)(ze,"editorInsets"),ht.createWebviewEditorInset(te,ue,Le,ot,ze)},createTerminal(te,ue,Le){return typeof te=="object"?"pty"in te?Ct.createExtensionTerminal(te):Ct.createTerminalFromOptions(te):Ct.createTerminal(te,ue,Le)},registerTerminalLinkProvider(te){return Ct.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return Ct.registerProfileProvider(ze,te,ue)},registerTerminalQuickFixProvider(te,ue){return(0,xe.$PG)(ze,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(te,ze.identifier.value,ue)},registerTreeDataProvider(te,ue){return He.registerTreeDataProvider(te,ue,ze)},createTreeView(te,ue){return He.createTreeView(te,ue,ze)},registerWebviewPanelSerializer:(te,ue)=>Ci.registerWebviewPanelSerializer(ze,te,ue),registerCustomEditorProvider:(te,ue,Le={})=>Bi.registerCustomEditorProvider(ze,te,ue,Le),registerFileDecorationProvider(te){return Ot.registerFileDecorationProvider(te,ze)},registerUriHandler(te){return fi.registerUriHandler(ze,te)},createQuickPick(){return wi.createQuickPick(ze)},createInputBox(){return wi.createInputBox(ze)},get activeColorTheme(){return Zi.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Le){return rt(Zi.onDidChangeActiveColorTheme)(te,ue,Le)},registerWebviewViewProvider(te,ue,Le){return Vi.registerWebviewViewProvider(ze,te,ue,Le?.webviewOptions)},get activeNotebookEditor(){return Ee.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Le){return rt(Ee.onDidChangeActiveNotebookEditor)(te,ue,Le)},get visibleNotebookEditors(){return Ee.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return rt(Ee.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ue,Le){return rt(ce.onDidChangeNotebookEditorSelection)(te,ue,Le)},onDidChangeNotebookEditorVisibleRanges(te,ue,Le){return rt(ce.onDidChangeNotebookEditorVisibleRanges)(te,ue,Le)},showNotebookDocument(te,ue){return Ee.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Le){return(0,xe.$PG)(ze,"externalUriOpener"),Wi.registerExternalUriOpener(ze.identifier,te,ue,Le)},registerProfileContentHandler(te,ue){return(0,xe.$PG)(ze,"profileContentHandlers"),Yi.registerProfileContentHandler(ze,te,ue)},registerQuickDiffProvider(te,ue,Le,ot){return(0,xe.$PG)(ze,"quickDiffProvider"),Li.registerQuickDiffProvider(yt(te),ue,Le,ot)},get tabGroups(){return si.tabGroups},registerShareProvider(te,ue){return(0,xe.$PG)(ze,"shareProvider"),zi.registerShareProvider(yt(te),ue)}},Ji={get rootPath(){return Bt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(te){throw new A.$9("rootPath")},getWorkspaceFolder(te){return mt.getWorkspaceFolder(te)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(te){throw new A.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(te){throw new A.$9("workspaceFile")},updateWorkspaceFolders:(te,ue,...Le)=>mt.updateWorkspaceFolders(ze,te,ue||0,...Le),onDidChangeWorkspaceFolders:function(te,ue,Le){return rt(mt.onDidChangeWorkspace)(te,ue,Le)},asRelativePath:(te,ue)=>mt.getRelativePath(te,ue),findFiles:(te,ue,Le,ot)=>mt.findFiles(te,ue,Le,ze.identifier,ot),findFiles2:(te,ue,Le)=>((0,xe.$PG)(ze,"findFiles2"),mt.findFiles2(te,ue,ze.identifier,Le)),findTextInFiles:(te,ue,Le,ot)=>{(0,xe.$PG)(ze,"findTextInFiles");let Et,Tt;return typeof ue=="object"?(Et=ue,Tt=Le):(Et={},Tt=ue,ot=Le),mt.findTextInFiles(te,Et||{},Tt,ze.identifier,ot)},save:te=>mt.save(te),saveAs:te=>mt.saveAs(te),saveAll:te=>mt.saveAll(te),applyEdit(te,ue){return nn.applyWorkspaceEdit(te,ze,ue)},createFileSystemWatcher:(te,ue,Le,ot)=>{let Et;return typeof ue=="boolean"?Et={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,xe.$PG)(ze,"createFileSystemWatcher"),Et={...ue,correlate:!0}),At.createFileSystemWatcher(mt,ze,te,Et)},get textDocuments(){return Nt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new A.$9("textDocuments")},openTextDocument(te){let ue;const Le=te;if(typeof te=="string")ue=Promise.resolve($.URI.file(te));else if($.URI.isUri(te))ue=Promise.resolve(te);else if(!Le||typeof Le=="object")ue=Nt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>(ot.scheme===N.Schemas.vscodeRemote&&!ot.authority&&Bt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(ot).then(Et=>Et.document)))},onDidOpenTextDocument:(te,ue,Le)=>rt(Nt.onDidAddDocument)(te,ue,Le),onDidCloseTextDocument:(te,ue,Le)=>rt(Nt.onDidRemoveDocument)(te,ue,Le),onDidChangeTextDocument:(te,ue,Le)=>rt(Nt.onDidChangeDocument)(te,ue,Le),onDidSaveTextDocument:(te,ue,Le)=>rt(Nt.onDidSaveDocument)(te,ue,Le),onWillSaveTextDocument:(te,ue,Le)=>rt(Ei.getOnWillSaveTextDocumentEvent(ze))(te,ue,Le),get notebookDocuments(){return Ee.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Le;if($.URI.isUri(te))Le=te,await Ee.openNotebookDocument(te);else if(typeof te=="string")Le=$.URI.revive(await Ee.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return Ee.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(te,ue,Le){return rt(Te.onDidSaveNotebookDocument)(te,ue,Le)},onDidChangeNotebookDocument(te,ue,Le){return rt(Te.onDidChangeNotebookDocument)(te,ue,Le)},onWillSaveNotebookDocument(te,ue,Le){return rt(We.getOnWillSaveNotebookDocumentEvent(ze))(te,ue,Le)},get onDidOpenNotebookDocument(){return rt(Ee.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return rt(Ee.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ue,Le,ot){return Ee.registerNotebookSerializer(ze,te,ue,Le,(0,xe.$OG)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(te,ue,Le)=>rt(Ni.onDidChangeConfiguration)(te,ue,Le),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,Ni.getConfiguration(te,ue,ze)},registerTextDocumentContentProvider(te,ue){return mi.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Bt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ii.registerTaskProvider(ze,te,ue)),registerFileSystemProvider(te,ue,Le){return(0,O.$Sc)(Vt.registerFileSystemProvider(ze,te,ue,Le),Zt.addFileSystemProvider(te,ue,Le))},get fs(){return Zt.value},registerFileSearchProvider:(te,ue)=>((0,xe.$PG)(ze,"fileSearchProvider"),xt.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,xe.$PG)(ze,"textSearchProvider"),xt.registerTextSearchProvider(te,ue)),registerAITextSearchProvider:(te,ue)=>((0,xe.$PG)(ze,"aiTextSearchProvider"),(0,xe.$PG)(ze,"textSearchProvider"),xt.registerAITextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,xe.$PG)(ze,"resolvers"),Lt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,xe.$PG)(ze,"resolvers"),ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,xe.$PG)(ze,"resolvers"),Lt.getRemoteExecServer(te)),onDidCreateFiles:(te,ue,Le)=>rt(At.onDidCreateFile)(te,ue,Le),onDidDeleteFiles:(te,ue,Le)=>rt(At.onDidDeleteFile)(te,ue,Le),onDidRenameFiles:(te,ue,Le)=>rt(At.onDidRenameFile)(te,ue,Le),onWillCreateFiles:(te,ue,Le)=>rt(At.getOnWillCreateFileEvent(ze))(te,ue,Le),onWillDeleteFiles:(te,ue,Le)=>rt(At.getOnWillDeleteFileEvent(ze))(te,ue,Le),onWillRenameFiles:(te,ue,Le)=>rt(At.getOnWillRenameFileEvent(ze))(te,ue,Le),openTunnel:te=>((0,xe.$PG)(ze,"tunnels"),jt.openTunnel(ze,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,xe.$PG)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(te,ue,Le)=>((0,xe.$PG)(ze,"tunnels"),rt(jt.onDidChangeTunnels)(te,ue,Le)),registerPortAttributesProvider:(te,ue)=>((0,xe.$PG)(ze,"portsAttributes"),jt.registerPortsAttributesProvider(te,ue)),registerTunnelProvider:(te,ue)=>((0,xe.$PG)(ze,"tunnelFactory"),jt.registerTunnelProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,xe.$PG)(ze,"timeline"),$n.registerTimelineProvider(te,ue,ze.identifier,pt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:te=>((0,xe.$PG)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Le)=>rt(mt.onDidGrantWorkspaceTrust)(te,ue,Le),registerEditSessionIdentityProvider:(te,ue)=>((0,xe.$PG)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(te,ue)),onWillCreateEditSessionIdentity:(te,ue,Le)=>((0,xe.$PG)(ze,"editSessionIdentityProvider"),rt(mt.getOnWillCreateEditSessionIdentityEvent(ze))(te,ue,Le)),registerCanonicalUriProvider:(te,ue)=>((0,xe.$PG)(ze,"canonicalUriProvider"),mt.registerCanonicalUriProvider(te,ue)),getCanonicalUri:(te,ue,Le)=>((0,xe.$PG)(ze,"canonicalUriProvider"),mt.provideCanonicalUri(te,ue,Le))},$i={get inputBox(){return Bt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Pi.getLastInputBox(ze)},createSourceControl(te,ue,Le){return Pi.createSourceControl(ze,te,ue,Le)}},Mi={createCommentController(te,ue){return Ui.createCommentController(ze,te,ue)}},vn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,xe.$OG)(ze,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(te,ue){return(0,xe.$PG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,te,ue)},registerDebugVisualizationTreeProvider(te,ue){return(0,xe.$PG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,te,ue)},onDidStartDebugSession(te,ue,Le){return rt(kt.onDidStartDebugSession)(te,ue,Le)},onDidTerminateDebugSession(te,ue,Le){return rt(kt.onDidTerminateDebugSession)(te,ue,Le)},onDidChangeActiveDebugSession(te,ue,Le){return rt(kt.onDidChangeActiveDebugSession)(te,ue,Le)},onDidReceiveDebugSessionCustomEvent(te,ue,Le){return rt(kt.onDidReceiveDebugSessionCustomEvent)(te,ue,Le)},onDidChangeBreakpoints(te,ue,Le){return rt(kt.onDidChangeBreakpoints)(te,ue,Le)},onDidChangeActiveStackItem(te,ue,Le){return(0,xe.$PG)(ze,"debugFocus"),rt(kt.onDidChangeActiveStackItem)(te,ue,Le)},registerDebugConfigurationProvider(te,ue,Le){return kt.registerDebugConfigurationProvider(te,ue,Le||ei.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return kt.registerDebugAdapterDescriptorFactory(ze,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return kt.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(te,ue,{parentSession:Le}):kt.startDebugging(te,ue,Le||{})},stopDebugging(te){return kt.stopDebugging(te)},addBreakpoints(te){return kt.addBreakpoints(te)},removeBreakpoints(te){return kt.removeBreakpoints(te)},asDebugSourceUri(te,ue){return kt.asDebugSourceUri(te,ue)}},un={registerTaskProvider:(te,ue)=>ii.registerTaskProvider(ze,te,ue),fetchTasks:te=>ii.fetchTasks(te),executeTask:te=>ii.executeTask(ze,te),get taskExecutions(){return ii.taskExecutions},onDidStartTask:(te,ue,Le)=>rt(ii.onDidStartTask)(te,ue,Le),onDidEndTask:(te,ue,Le)=>rt(ii.onDidEndTask)(te,ue,Le),onDidStartTaskProcess:(te,ue,Le)=>rt(ii.onDidStartTaskProcess)(te,ue,Le),onDidEndTaskProcess:(te,ue,Le)=>rt(ii.onDidEndTaskProcess)(te,ue,Le)},Oi={createNotebookController(te,ue,Le,ot,Et){return J.createNotebookController(ze,te,ue,Le,ot,(0,xe.$OG)(ze,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>Ee.registerNotebookCellStatusBarItemProvider(ze,te,ue),createRendererMessaging(te){return Ie.createRendererMessaging(ze,te)},createNotebookControllerDetectionTask(te){return(0,xe.$PG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,te)},registerKernelSourceActionProvider(te,ue){return(0,xe.$PG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,te,ue)},onDidChangeNotebookCellExecutionState(te,ue,Le){return(0,xe.$PG)(ze,"notebookCellExecutionState"),rt(J.onDidChangeNotebookCellExecutionState)(te,ue,Le)}},ln={t(...te){if(typeof te[0]=="string"){const ue=te.shift(),Le=!te||typeof te[0]!="object"?te:te[0];return di.getMessage(ze.identifier.value,{message:ue,args:Le})}return di.getMessage(ze.identifier.value,te[0])},get bundle(){return di.getBundle(ze.identifier.value)},get uri(){return di.getBundleUri(ze.identifier.value)}},hn={_version:1,registerInteractiveEditorSessionProvider(te,ue){return(0,xe.$PG)(ze,"interactive"),xi.registerProvider(ze,te,ue)},transferActiveChat(te){return(0,xe.$PG)(ze,"interactive"),qi.transferActiveChat(te)}},dn={getRelatedInformation(te,ue){return(0,xe.$PG)(ze,"aiRelatedInformation"),Ai.getRelatedInformation(ze,te,ue)},registerRelatedInformationProvider(te,ue){return(0,xe.$PG)(ze,"aiRelatedInformation"),Ai.registerRelatedInformationProvider(ze,te,ue)},registerEmbeddingVectorProvider(te,ue){return(0,xe.$PG)(ze,"aiRelatedInformation"),Hi.registerEmbeddingVectorProvider(ze,te,ue)}},fn={registerChatResponseProvider(te,ue,Le){return(0,xe.$PG)(ze,"chatProvider"),Pt.registerLanguageModel(ze,te,ue,Le)},registerChatVariableResolver(te,ue,Le){return(0,xe.$PG)(ze,"chatVariableResolver"),_i.registerVariableResolver(ze,te,ue,Le)},registerMappedEditsProvider(te,ue){return(0,xe.$PG)(ze,"mappedEditsProvider"),lt.registerMappedEditsProvider(ze,te,ue)},createChatParticipant(te,ue){return(0,xe.$PG)(ze,"chatParticipant"),qi.createChatAgent(ze,te,ue)},createDynamicChatParticipant(te,ue,Le,ot){return(0,xe.$PG)(ze,"chatParticipantAdditions"),qi.createDynamicChatAgent(ze,te,ue,Le,ot)}},bn={get languageModels(){return(0,xe.$PG)(ze,"languageModels"),Pt.getLanguageModelIds()},onDidChangeLanguageModels:(te,ue,Le)=>((0,xe.$PG)(ze,"languageModels"),Pt.onDidChangeProviders(te,ue,Le)),sendChatRequest(te,ue,Le,ot){return(0,xe.$PG)(ze,"languageModels"),Pt.sendChatRequest(ze,te,ue,Le,ot)},computeTokenLength(te,ue,Le){return(0,xe.$PG)(ze,"languageModels"),Le??(Le=y.CancellationToken.None),Pt.computeTokenLength(te,ue,Le)},getLanguageModelInformation(te){return(0,xe.$PG)(ze,"languageModels"),Pt.getLanguageModelInfo(te)}},gn={registerSpeechProvider(te,ue){return(0,xe.$PG)(ze,"speech"),en.registerProvider(ze.identifier,te,ue)}};return{version:wt.version,ai:dn,authentication:on,commands:pn,comments:Mi,chat:fn,debug:vn,env:ki,extensions:cn,interactive:hn,l10n:ln,languages:wn,lm:bn,notebooks:Oi,scm:$i,speech:gn,tasks:un,tests:an,window:Ki,workspace:Ji,Breakpoint:De.$aO,TerminalOutputAnchor:De.TerminalOutputAnchor,ChatResultFeedbackKind:De.ChatResultFeedbackKind,ChatVariableLevel:De.ChatVariableLevel,ChatCompletionItem:De.$8O,CallHierarchyIncomingCall:De.$yN,CallHierarchyItem:De.$xN,CallHierarchyOutgoingCall:De.$zN,CancellationError:A.$5,CancellationTokenSource:y.$pe,CandidatePortSource:i.CandidatePortSource,CodeAction:De.$uN,CodeActionKind:De.$vN,CodeActionTriggerKind:De.CodeActionTriggerKind,CodeLens:De.$AN,Color:De.$NN,ColorInformation:De.$ON,ColorPresentation:De.$PN,ColorThemeKind:De.ColorThemeKind,CommentMode:De.CommentMode,CommentState:De.CommentState,CommentThreadCollapsibleState:De.CommentThreadCollapsibleState,CommentThreadState:De.CommentThreadState,CommentThreadApplicability:De.CommentThreadApplicability,CompletionItem:De.$HN,CompletionItemKind:De.CompletionItemKind,CompletionItemTag:De.CompletionItemTag,CompletionList:De.$IN,CompletionTriggerKind:De.CompletionTriggerKind,ConfigurationTarget:De.ConfigurationTarget,CustomExecution:De.$XN,DebugAdapterExecutable:De.$eO,DebugAdapterInlineImplementation:De.$hO,DebugAdapterNamedPipeServer:De.$gO,DebugAdapterServer:De.$fO,DebugConfigurationProviderTriggerKind:ei.DebugConfigurationProviderTriggerKind,DebugConsoleMode:De.DebugConsoleMode,DebugVisualization:De.$xO,DecorationRangeBehavior:De.DecorationRangeBehavior,Diagnostic:De.$nN,DiagnosticRelatedInformation:De.$mN,DiagnosticSeverity:De.DiagnosticSeverity,DiagnosticTag:De.DiagnosticTag,Disposable:De.$_M,DocumentHighlight:De.$qN,DocumentHighlightKind:De.DocumentHighlightKind,MultiDocumentHighlight:De.$rN,DocumentLink:De.$MN,DocumentSymbol:De.$tN,EndOfLine:De.EndOfLine,EnvironmentVariableMutatorType:De.EnvironmentVariableMutatorType,EvaluatableExpression:De.$kO,InlineValueText:De.$lO,InlineValueVariableLookup:De.$mO,InlineValueEvaluatableExpression:De.$nO,InlineCompletionTriggerKind:De.InlineCompletionTriggerKind,EventEmitter:C.$ee,ExtensionKind:De.ExtensionKind,ExtensionMode:De.ExtensionMode,ExternalUriOpenerPriority:De.ExternalUriOpenerPriority,FileChangeType:De.FileChangeType,FileDecoration:De.$zO,FileDecoration2:De.$zO,FileSystemError:De.$qO,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:De.$rO,FoldingRangeKind:De.FoldingRangeKind,FunctionBreakpoint:De.$cO,InlineCompletionItem:De.$JN,InlineCompletionList:De.$KN,Hover:De.$oN,VerboseHover:De.$pN,HoverVerbosityAction:De.HoverVerbosityAction,IndentAction:S.IndentAction,Location:De.$lN,MarkdownString:De.$BN,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:De.$CN,PortAutoForwardAction:De.PortAutoForwardAction,Position:De.$aN,ProcessExecution:De.$VN,ProgressLocation:De.ProgressLocation,QuickInputButtons:De.$yO,Range:De.$bN,RelativePattern:De.$$N,Selection:De.$cN,SelectionRange:De.$wN,SemanticTokens:De.$uO,SemanticTokensBuilder:De.$tO,SemanticTokensEdit:De.$vO,SemanticTokensEdits:De.$wO,SemanticTokensLegend:De.$sO,ShellExecution:De.$WN,ShellQuoting:De.ShellQuoting,SignatureHelp:De.$EN,SignatureHelpTriggerKind:De.SignatureHelpTriggerKind,SignatureInformation:De.$DN,SnippetString:De.$kN,SourceBreakpoint:De.$bO,StandardTokenType:De.StandardTokenType,StatusBarAlignment:De.StatusBarAlignment,SymbolInformation:De.$sN,SymbolKind:De.SymbolKind,SymbolTag:De.SymbolTag,Task:De.$YN,TaskGroup:De.$UN,TaskPanelKind:De.TaskPanelKind,TaskRevealKind:De.TaskRevealKind,TaskScope:De.TaskScope,TerminalLink:De.$QN,TerminalQuickFixTerminalCommand:De.$SN,TerminalQuickFixOpener:De.$RN,TerminalLocation:De.TerminalLocation,TerminalProfile:De.$TN,TerminalExitReason:De.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:De.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:De.TextDocumentSaveReason,TextEdit:De.$gN,SnippetTextEdit:De.$iN,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:De.TextEditorLineNumbersStyle,TextEditorRevealType:De.TextEditorRevealType,TextEditorSelectionChangeKind:De.TextEditorSelectionChangeKind,SyntaxTokenType:De.SyntaxTokenType,TextDocumentChangeReason:De.TextDocumentChangeReason,ThemeColor:De.$0N,ThemeIcon:De.$9N,TreeItem:De.$ZN,TreeItemCheckboxState:De.TreeItemCheckboxState,TreeItemCollapsibleState:De.TreeItemCollapsibleState,TypeHierarchyItem:De.$VO,UIKind:ti.UIKind,Uri:$.URI,ViewColumn:De.ViewColumn,WorkspaceEdit:De.$jN,DocumentPasteTriggerKind:De.DocumentPasteTriggerKind,DocumentDropEdit:De.$6N,DocumentDropOrPasteEditKind:De.$7N,DocumentPasteEdit:De.$8N,InlayHint:De.$GN,InlayHintLabelPart:De.$FN,InlayHintKind:De.InlayHintKind,RemoteAuthorityResolverError:De.$fN,ResolvedAuthority:De.$dN,ManagedResolvedAuthority:De.$eN,SourceControlInputBoxValidationType:De.SourceControlInputBoxValidationType,ExtensionRuntime:De.ExtensionRuntime,TimelineItem:De.$JO,NotebookRange:De.$BO,NotebookCellKind:De.NotebookCellKind,NotebookCellExecutionState:De.NotebookCellExecutionState,NotebookCellData:De.$CO,NotebookData:De.$DO,NotebookRendererScript:De.$HO,NotebookCellStatusBarAlignment:De.NotebookCellStatusBarAlignment,NotebookEditorRevealType:De.NotebookEditorRevealType,NotebookCellOutput:De.$FO,NotebookCellOutputItem:De.$EO,NotebookCellStatusBarItem:De.$GO,NotebookControllerAffinity:De.NotebookControllerAffinity,NotebookControllerAffinity2:De.NotebookControllerAffinity2,NotebookEdit:De.$hN,NotebookKernelSourceAction:De.$IO,NotebookVariablesRequestKind:De.NotebookVariablesRequestKind,PortAttributes:De.$LO,LinkedEditingRanges:De.$KO,TestResultState:De.TestResultState,TestRunRequest:De.$MO,TestRunRequest2:De.$MO,TestMessage:De.$NO,TestTag:De.$OO,TestRunProfileKind:De.TestRunProfileKind,TextSearchCompleteMessageType:hi.TextSearchCompleteMessageType,DataTransfer:De.$5N,DataTransferItem:De.$1N,TestCoverageCount:De.$PO,FileCoverage:De.$RO,StatementCoverage:De.$SO,BranchCoverage:De.$TO,DeclarationCoverage:De.$UO,WorkspaceTrustState:De.WorkspaceTrustState,LanguageStatusSeverity:De.LanguageStatusSeverity,QuickPickItemKind:De.QuickPickItemKind,InputBoxValidationSeverity:De.InputBoxValidationSeverity,TabInputText:De.$WO,TabInputTextDiff:De.$XO,TabInputTextMerge:De.$YO,TabInputCustom:De.$ZO,TabInputNotebook:De.$2O,TabInputNotebookDiff:De.$3O,TabInputWebview:De.$1O,TabInputTerminal:De.$4O,TabInputInteractiveWindow:De.$5O,TabInputChat:De.$6O,TabInputTextMultiDiff:De.$7O,TelemetryTrustedValue:s.$gp,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:De.InteractiveSessionVoteDirection,ChatCopyKind:De.ChatCopyKind,InteractiveEditorResponseFeedbackKind:De.InteractiveEditorResponseFeedbackKind,DebugStackFrame:De.$iO,DebugThread:De.$jO,RelatedInformationType:De.RelatedInformationType,SpeechToTextStatus:De.SpeechToTextStatus,PartialAcceptTriggerKind:De.PartialAcceptTriggerKind,KeywordRecognitionStatus:De.KeywordRecognitionStatus,ChatResponseMarkdownPart:De.$9O,ChatResponseFileTreePart:De.$_O,ChatResponseAnchorPart:De.$aP,ChatResponseProgressPart:De.$bP,ChatResponseReferencePart:De.$dP,ChatResponseTextEditPart:De.$eP,ChatResponseMarkdownWithVulnerabilitiesPart:De.$0O,ChatResponseCommandButtonPart:De.$cP,ChatResponseDetectedParticipantPart:De.$$O,ChatRequestTurn:De.$fP,ChatResponseTurn:De.$gP,ChatLocation:De.ChatLocation,LanguageModelChatSystemMessage:De.$hP,LanguageModelChatUserMessage:De.$iP,LanguageModelChatAssistantMessage:De.$jP,LanguageModelSystemMessage:De.$hP,LanguageModelUserMessage:De.$iP,LanguageModelAssistantMessage:De.$jP,LanguageModelError:De.$kP,NewSymbolName:De.$pO,NewSymbolNameTag:De.NewSymbolNameTag,NewSymbolNameTriggerKind:De.NewSymbolNameTriggerKind,InlineEdit:De.$lP,InlineEditTriggerKind:De.InlineEditTriggerKind}}}}),define(Ce[308],Ae([1,0,56,118,39,112,40,32,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(ee,e,y,A,C,O,N,p,$,E,M,S,m,w,g,r,a,s,n,i,c,h,t,d,o,f,u,D,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$ys)(f.$cmc,f.$bmc,1),(0,y.$ys)(d.$4j,t.$pnc,1),(0,y.$ys)(r.$hlc,r.$ilc,1),(0,y.$ys)(p.$TP,p.$SP,0),(0,y.$ys)(D.$rlc,D.$slc,0),(0,y.$ys)(l.$9lc,l.$0lc,0),(0,y.$ys)(N.$Glc,N.$Elc,0),(0,y.$ys)(s.$Ilc,s.$Hlc,0),(0,y.$ys)(S.$mmc,S.$qmc,0),(0,y.$ys)(O.$smc,O.$rmc,0),(0,y.$ys)($.$IP,$.$HP,0),(0,y.$ys)(u.$dmc,u.$emc,0),(0,y.$ys)(n.$llc,n.$klc,0),(0,y.$ys)(A.$Xmc,A.$Wmc,1),(0,y.$ys)(m.$Imc,m.$Jmc,0),(0,y.$ys)(w.$2lc,w.$1lc,0),(0,y.$ys)(M.$$mc,M.$0mc,0),(0,y.$ys)(E.$5lc,E.$8lc,0),(0,y.$ys)(v.$_mc,v.$anc,0),(0,y.$ys)(g.$FDb,g.$GDb,0),(0,y.$ys)(a.$nnc,a.$mnc,0),(0,y.$ys)(C.$Dlc,C.$Clc,0),(0,y.$ys)(i.$_lc,i.$$lc,0),(0,y.$ys)(c.$RP,c.$OP,0),(0,y.$ys)(h.$Slc,h.$Tlc,0),(0,y.$ys)(o.$kmc,o.$lmc,0)}),define(Ce[309],Ae([1,0,307,41,2,304,7,9,253]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0;class E extends O.$snc{k(){}getModule(w,g){for(const r of this.b){const a=r(w);if(a){w=a;break}}if(this.a.has(w))return this.a.get(w).load(w,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends A.$gmc{constructor(){super(...arguments),this.extensionRuntime=N.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$ypc);const w=this.h.invokeFunction(y.$onc);this.r=this.h.createInstance(E,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,g,r){g=g.with({path:S(g.path,".js")});const a=w?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const s=C.URI.revive(await this.C.$asBrowserUri(g)),n=await fetch(s.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),c=`${g.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch(u){throw console.error(a?`Loading code for extension ${a} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${g.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}w&&await this.w.initializeLocalizedMessages(w);const d={},o={exports:d},f=u=>{const D=this.r.getModule(u,g);if(D===void 0)throw new Error(`Cannot load module '${u}'`);return D};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(o,d,f),o.exports!==d?o.exports:d}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+w;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,p.$xh)(10)}}e.$zpc=M;function S(m,w){return m.endsWith(w)?m:m+w}}),define(Ce[310],Ae([1,0,71,56,12,41,217,87,309]),function(ee,e,y,A,C,O,N,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,A.$ys)(C.$3j,new y.$ti(N.$rnc,[!0],!0)),(0,A.$ys)(O.$hmc,$.$zpc,0),(0,A.$ys)(p.$Jlc,p.$Klc,0)}),define(Ce[316],Ae([1,0,21,5,79,305,255,19,60,16,2,308,310]),function(ee,e,y,A,C,O,N,p,$,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(d,o){return d instanceof Request||w(String(d))&&(d=(await t(M.URI.parse(String(d)))).toString(!0)),g(d,o)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,o,f,u,D){(async()=>(w(o.toString())&&(o=(await t(M.URI.parse(o.toString()))).toString(!0)),super.open(d,o,f??!0,u,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,o){if(/^file:/i.test(d.toString()))d=E.$Qg.uriToBrowserUri(M.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(b){function P(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const k=fetch.bind(self);self.fetch=function(U,Q){return U instanceof Request?k(U,Q):k(P(U),Q)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,Q,G,L,R){return super.open(U,P(Q),G??!0,L,R)}};const I=importScripts.bind(self);self.importScripts=(...U)=>{I(...U.map(P))},I(b)}.toString()}('${d}'))`;o=o||{},o.name=`${name} -> ${o.name||p.$oc(d.toString())}`;const D=new Blob([u],{type:"application/javascript"}),l=URL.createObjectURL(D);return new t(l,o)}}else self.Worker=class extends N.$Apc{constructor(t,d){super(m,t,{name:p.$oc(t.toString()),...d})}};const a=new class{constructor(){this.pid=void 0}exit(t){S()}};class s{constructor(){const d=new MessageChannel,o=new A.$ee;let f=!1;m(d.port2,[d.port2]),d.port1.onmessage=u=>{const{data:D}=u;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const l=y.$Ge.wrap(new Uint8Array(D,0,D.byteLength));if((0,C.$2m)(l,2)){f=!0,i("received terminate message from renderer");return}o.fire(l)},this.protocol={onMessage:o.event,send:u=>{if(!f){const D=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);d.port1.postMessage(D,[D])}}}}}function n(t){return new Promise(d=>{const o=t.onMessage(f=>{o.dispose();const u=JSON.parse(f.toString());t.send((0,C.$1m)(0)),d({protocol:t,initData:u})});t.send((0,C.$1m)(1))})}let i=t=>S();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){$.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(d){c(d)&&n(t.protocol).then(o=>{$.mark("code/extHost/didWaitForInitData");const f=new O.$unc(o.protocol,o.initData,a,null,d.data);r(u=>f.asBrowserUri(u)),i=u=>f.terminate(u)})}}}})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
